// SPDX-FileCopyrightText: 2021-2023 deroad <wargio@libero.it>
// SPDX-License-Identifier: LGPL-3.0-only

#include "minunit.h"

mu_demangle_tests(msvc,
	mu_demangle_test(".?AV?$_CancellationTokenCallback@Vlambda_1@?1??_RegisterCancellation@_Task_impl_base@details@Concurrency@@QEAAXV?$weak_ptr@U_Task_impl_base@details@Concurrency@@@std@@@Z@@details@Concurrency@@", "class Concurrency::details::_CancellationTokenCallback<class `public: void __cdecl Concurrency::details::_Task_impl_base::_RegisterCancellation(class std::weak_ptr<struct Concurrency::details::_Task_impl_base>) __ptr64'::`2'::lambda_1>"),
	mu_demangle_test(".?AV?$FunctionT@P6AXPAX@Z@ns@@", "class ns::FunctionT<void (__cdecl *)(void *)>"),
	mu_demangle_test(".?AV?$GHI@$00VPQR@MNO@JKL@@@DEF@ABC@@", "class ABC::DEF::GHI<1, class JKL::MNO::PQR>"),
	mu_demangle_test(".?AV?$GHI@$FB@C@VPQR@MNO@JKL@@@DEF@ABC@@", "class ABC::DEF::GHI<{1, 2}, class JKL::MNO::PQR>"),
	mu_demangle_test(".?AV?$GHI@$GB@C@D@VPQR@MNO@JKL@@@DEF@ABC@@", "class ABC::DEF::GHI<{1, 2, 3}, class JKL::MNO::PQR>"),
	mu_demangle_test(".?AV?$GHI@$H0VPQR@MNO@JKL@@@DEF@ABC@@", "class ABC::DEF::GHI<1, class JKL::MNO::PQR>"),
	mu_demangle_test(".?AV?$GHI@$IB@C@VPQR@MNO@JKL@@@DEF@ABC@@", "class ABC::DEF::GHI<{1, 2}, class JKL::MNO::PQR>"),
	mu_demangle_test(".?AV?$GHI@$JB@C@D@VPQR@MNO@JKL@@@DEF@ABC@@", "class ABC::DEF::GHI<{1, 2, 3}, class JKL::MNO::PQR>"),
	mu_demangle_test(".?AV?$Template@UUnnamedStruct@@$1?StructName1@@3UStructType1@@B$1?StructName2@@3U3@B$00$0A@VChildClass@Class@@@Class@@", "class Class::Template<struct UnnamedStruct, &struct StructType1 const StructName1, &struct StructType1 const StructName2, 1, 0, class Class::ChildClass>"),
	mu_demangle_test(".?AVClassInInnerNamespace@InnerNamespace@OuterNamespace@@", "class OuterNamespace::InnerNamespace::ClassInInnerNamespace"),
	mu_demangle_test("??$?RD@ABC@@QEBAXQEBD@Z", "public: void __cdecl ABC::operator()<char>(char const * const __ptr64)const __ptr64"),
	mu_demangle_test("??$invoke@P6AXPEAX@ZAEAPEAX@wistd@@YAX$$REAP6AXPEAX@ZAEAPEAX@Z", "void __cdecl wistd::invoke<void (__cdecl *)(void * __ptr64), void * __ptr64 & __ptr64>(void (__cdecl *)(void * __ptr64) && volatile __ptr64, void * __ptr64 & __ptr64)"),
	mu_demangle_test("??$MyTemplateFunction@VClass1@@@Class1@@QAEXPAV0@@Z", "public: void __thiscall Class1::MyTemplateFunction<class Class1>(class Class1 *)"),
	mu_demangle_test("??0Delegate@Platform@@QE$AAA@XZ", "public: void __cdecl Platform::Delegate::constructor(void) __ptr64"),
	mu_demangle_test("??0PoolingFwdFP16x2Shader@cask@@QEAA@PEBVKernelInfo@1@Q6A?AV?$SafeEnum@UErrorEnum@cask@@@1@AEAUpoolingDescription@PoolingOperation@1@PEBXPEAXPEAUCUstream_st@@AEAW4cudaError@@@Z@Z", "public: void __cdecl cask::PoolingFwdFP16x2Shader::constructor(class cask::KernelInfo const * __ptr64, class cask::SafeEnum<struct cask::ErrorEnum> (__cdecl * const)(struct cask::PoolingOperation::poolingDescription & __ptr64, void const * __ptr64, void * __ptr64, struct CUstream_st * __ptr64, enum cudaError & __ptr64)) __ptr64"),
	mu_demangle_test("??0TEST_CLASS@@QEAA@AEBV0@@Z", "public: void __cdecl TEST_CLASS::constructor(class TEST_CLASS const & __ptr64) __ptr64"),
	mu_demangle_test("??0TEST_CLASS@@QEAA@H@Z", "public: void __cdecl TEST_CLASS::constructor(int) __ptr64"),
	mu_demangle_test("??1?$_Func_class@XW4LaunchUriStatus@System@Windows@@U_Nil@std@@U45@@std@@QEAA@XZ", "public: void __cdecl std::_Func_class<void, enum Windows::System::LaunchUriStatus, struct std::_Nil, struct std::_Nil>::~destructor(void) __ptr64"),
	mu_demangle_test("??1TEST_CLASS@@QEAA@XZ", "public: void __cdecl TEST_CLASS::~destructor(void) __ptr64"),
	mu_demangle_test("??4TEST_CLASS@@QEAAAEAV0@AEBV0@@Z ", "public: class TEST_CLASS & __ptr64 __cdecl TEST_CLASS::operator=(class TEST_CLASS const & __ptr64) __ptr64"),
	mu_demangle_test("??_7?$_Func_impl@U?$_Callable_obj@Vlambda@@$0A@@std@@V?$allocator@V?$_Func_class@XU_Nil@std@@U12@@std@@@2@XU_Nil@2@U42@@std@@6B@", "const std::_Func_impl<struct std::_Callable_obj<class lambda, 0>, class std::allocator<class std::_Func_class<void, struct std::_Nil, struct std::_Nil>>, void, struct std::_Nil, struct std::_Nil>::vftable"),
	mu_demangle_test("??_7NetworkUXViewProviderImpl@@6BIWeakReferenceSource@@@", "const NetworkUXViewProviderImpl::vftable{for `IWeakReferenceSource'}"),
	mu_demangle_test("??_7OOBEMainPage@NetworkUX@@6B__abi_IUnknown@@IWeakReferenceSource@Details@Platform@@@", "const NetworkUX::OOBEMainPage::vftable{for `__abi_IUnknown's `Platform::Details::IWeakReferenceSource'}"),
	mu_demangle_test("??_G?$__func@Vlambda@@$$A6AJPEBVExtensionRegistration@Details@PlatformExtensions@Internal@Windows@@_NPEA_N@Z@__function@wistd@@UEAAPEAXI@Z", "public virtual: void * __ptr64 __cdecl wistd::__function::__func<class lambda, long int (__cdecl *)(class Windows::Internal::PlatformExtensions::Details::ExtensionRegistration const * __ptr64, bool, bool * __ptr64)>::scalar_dtor(unsigned int) __ptr64"),
	mu_demangle_test("??_G?$impl@V?$binder2@V?$io_op@V?$basic_stream_socket@Vtcp@ip@asio@boost@@V?$any_executor@U?$context_as_t@AEAVexecution_context@asio@boost@@@execution@asio@boost@@U?$never_t@$0A@@blocking@detail@234@U?$prefer_only@U?$possibly_t@$0A@@blocking@detail@execution@asio@boost@@@234@U?$prefer_only@U?$tracked_t@$0A@@outstanding_work@detail@execution@asio@boost@@@234@U?$prefer_only@U?$untracked_t@$0A@@outstanding_work@detail@execution@asio@boost@@@234@U?$prefer_only@U?$fork_t@$0A@@relationship@detail@execution@asio@boost@@@234@U?$prefer_only@U?$continuation_t@$0A@@relationship@detail@execution@asio@boost@@@234@@execution@34@@asio@boost@@V?$read_op@Vmutable_buffers_1@asio@boost@@@detail@ssl@23@V?$read_op@V?$stream@V?$basic_stream_socket@Vtcp@ip@asio@boost@@V?$any_executor@U?$context_as_t@AEAVexecution_context@asio@boost@@@execution@asio@boost@@U?$never_t@$0A@@blocking@detail@234@U?$prefer_only@U?$possibly_t@$0A@@blocking@detail@execution@asio@boost@@@234@U?$prefer_only@U?$tracked_t@$0A@@outstanding_work@detail@execution@asio@boost@@@234@U?$prefer_only@U?$untracked_t@$0A@@outstanding_work@detail@execution@asio@boost@@@234@U?$prefer_only@U?$fork_t@$0A@@relationship@detail@execution@asio@boost@@@234@U?$prefer_only@U?$continuation_t@$0A@@relationship@detail@execution@asio@boost@@@234@@execution@34@@asio@boost@@@ssl@asio@boost@@Vmutable_buffers_1@34@PEBVmutable_buffer@34@Vtransfer_at_least_t@detail@34@V?$wrapped_handler@Vstrand@io_context@asio@boost@@V?$custom_alloc_handler@V?$_Binder@U_Unforced@std@@P8?$connection@Utransport_config@asio_tls@config@websocketpp@@@asio@transport@websocketpp@@EAAXV?$function@$$A6AXAEBVerror_code@std@@_K@Z@2@AEBVerror_code@system@boost@@_K@ZV?$shared_ptr@V?$connection@Utransport_config@asio_tls@config@websocketpp@@@asio@transport@websocketpp@@@2@AEAV72@AEBU?$_Ph@$00@2@AEBU?$_Ph@$01@2@@std@@@3transport@websocketpp@@Uis_continuation_if_running@detail@34@@834@@523@@detail@ssl@asio@boost@@Verror_code@system@5@_K@detail@asio@boost@@V?$allocator@X@std@@@executor_function@detail@asio@boost@@QEAAPEAXI@Z", "public: void * __ptr64 __cdecl boost::asio::detail::executor_function::impl<class boost::asio::detail::binder2<class boost::asio::ssl::detail::io_op<class boost::asio::basic_stream_socket<class boost::asio::ip::tcp, class boost::asio::execution::any_executor<struct boost::asio::execution::context_as_t<class boost::asio::execution_context & __ptr64>, struct boost::asio::execution::detail::blocking::never_t<0>, struct boost::asio::execution::prefer_only<struct boost::asio::execution::detail::blocking::possibly_t<0>>, struct boost::asio::execution::prefer_only<struct boost::asio::execution::detail::outstanding_work::tracked_t<0>>, struct boost::asio::execution::prefer_only<struct boost::asio::execution::detail::outstanding_work::untracked_t<0>>, struct boost::asio::execution::prefer_only<struct boost::asio::execution::detail::relationship::fork_t<0>>, struct boost::asio::execution::prefer_only<struct boost::asio::execution::detail::relationship::continuation_t<0>>>>, class boost::asio::ssl::detail::read_op<class boost::asio::mutable_buffers_1>, class boost::asio::detail::read_op<class boost::asio::ssl::stream<class boost::asio::basic_stream_socket<class boost::asio::ip::tcp, class boost::asio::execution::any_executor<struct boost::asio::execution::context_as_t<class boost::asio::execution_context & __ptr64>, struct boost::asio::execution::detail::blocking::never_t<0>, struct boost::asio::execution::prefer_only<struct boost::asio::execution::detail::blocking::possibly_t<0>>, struct boost::asio::execution::prefer_only<struct boost::asio::execution::detail::outstanding_work::tracked_t<0>>, struct boost::asio::execution::prefer_only<struct boost::asio::execution::detail::outstanding_work::untracked_t<0>>, struct boost::asio::execution::prefer_only<struct boost::asio::execution::detail::relationship::fork_t<0>>, struct boost::asio::execution::prefer_only<struct boost::asio::execution::detail::relationship::continuation_t<0>>>>>, class boost::asio::mutable_buffers_1, class boost::asio::mutable_buffer const * __ptr64, class boost::asio::detail::transfer_at_least_t, class boost::asio::detail::wrapped_handler<class boost::asio::io_context::strand, class websocketpp::transport::asio::custom_alloc_handler<class std::_Binder<struct std::_Unforced, void (__cdecl websocketpp::transport::asio::connection<struct websocketpp::config::asio_tls::transport_config>::*)(class std::function<void (__cdecl *)(class std::error_code const & __ptr64, unsigned __int64)>, class boost::system::error_code const & __ptr64, unsigned __int64) __ptr64, class std::shared_ptr<class websocketpp::transport::asio::connection<struct websocketpp::config::asio_tls::transport_config>>, class std::function<void (__cdecl *)(class std::error_code const & __ptr64, unsigned __int64)> & __ptr64, struct std::_Ph<1> const & __ptr64, struct std::_Ph<2> const & __ptr64>>, struct boost::asio::detail::is_continuation_if_running>>>, class boost::system::error_code, unsigned __int64>, class std::allocator<void>>::scalar_dtor(unsigned int) __ptr64"),
	mu_demangle_test("??_R0?AVResultException@wil@@@8", "class wil::ResultException `RTTI Type Descriptor'"),
	mu_demangle_test("??B?$ABC@DUDEF@@@@QEBA_NXZ", "public: bool __cdecl ABC<char, struct DEF>::operator bool(void)const __ptr64"),
	mu_demangle_test("??B?$unique_any_t@V?$semaphore_t@V?$unique_storage@U?$resource_policy@PEAXP6AXPEAX@Z$1?CloseHandle@details@wil@@YAX0@ZU?$integral_constant@_K$0A@@wistd@@PEAXPEAX$0A@$$T@details@wil@@@details@wil@@Uerr_returncode_policy@3@@wil@@@wil@@QEBA_NXZ", "public: bool __cdecl wil::unique_any_t<class wil::semaphore_t<class wil::details::unique_storage<struct wil::details::resource_policy<void * __ptr64, void (__cdecl *)(void * __ptr64), &void __cdecl wil::details::CloseHandle(void * __ptr64), struct wistd::integral_constant<unsigned __int64, 0>, void * __ptr64, void * __ptr64, 0, std::nullptr_t>>, struct wil::err_returncode_policy>>::operator bool(void)const __ptr64"),
	mu_demangle_test("??HTEST_CLASS@@QEAA?AV0@AEBV0@@Z ", "public: class TEST_CLASS __cdecl TEST_CLASS::operator+(class TEST_CLASS const & __ptr64) __ptr64"),
	mu_demangle_test("?__abi_Release@?QObject@Platform@@__CFEWiFiWCNComboActivationFactory@View@NetworkUX@@W7E$AAAKXZ", "[thunk]:public virtual: unsigned long int __cdecl NetworkUX::View::__CFEWiFiWCNComboActivationFactory::[Platform::Object]::__abi_Release`adjustor{8}'(void) __ptr64"),
	mu_demangle_test("?_tlgEvent@?M@??ReportStopActivity@?$ActivityBase@VNetworkFlyoutLogging@@$00$0A@$04$0A@U_TlgReflectorTag_Param0IsProviderType@@@wil@@AEAAXJ@Z@4Uunnamed-type-_tlgEvent@?M@??123@AEAAXJ@Z@B", "struct `private: void __cdecl wil::ActivityBase<class NetworkFlyoutLogging, 1, 0, 5, 0, struct _TlgReflectorTag_Param0IsProviderType>::ReportStopActivity(long int) __ptr64'::`12'::unnamed-type-_tlgEvent const `private: void __cdecl wil::ActivityBase<class NetworkFlyoutLogging, 1, 0, 5, 0, struct _TlgReflectorTag_Param0IsProviderType>::ReportStopActivity(long int) __ptr64'::`12'::_tlgEvent"),
	mu_demangle_test("?AbbreviationOfRepeteadNames@@YAPEAVTEST_CLASS@@PEAV1@00AEAV1@@Z", "class TEST_CLASS * __ptr64 __cdecl AbbreviationOfRepeteadNames(class TEST_CLASS * __ptr64, class TEST_CLASS * __ptr64, class TEST_CLASS * __ptr64, class TEST_CLASS & __ptr64)"),
	mu_demangle_test("?AbbreviationOfRepeteadTypes@@YA_NPEAHHH0_N1PEA_N@Z", "bool __cdecl AbbreviationOfRepeteadTypes(int * __ptr64, int, int, int * __ptr64, bool, bool, bool * __ptr64)"),
	mu_demangle_test("?arr2@@3PAY07HA", "int (*)[8] arr2"),
	mu_demangle_test("?arr3@@3PAY1BA@4HA", "int (*)[16][5] arr3"),
	mu_demangle_test("?arr@@3PAHA", "int * arr"),
	mu_demangle_test("?Delegate@Platform@@YAPE$AAVString@Platform@@_NPE$AAVObject@3@@Z", "class Platform::String ^ __ptr64 __cdecl Platform::Delegate(bool, class Platform::Object ^ __ptr64)"),
	mu_demangle_test("?f1@@YAXTUNION_TEST@1@0@Z", "void __cdecl f1(union UNION_TEST::UNION_TEST, union UNION_TEST::UNION_TEST)"),
	mu_demangle_test("?f2@@YAXTUNION_TEST@1@VTEST@2@0@Z", "void __cdecl f2(union UNION_TEST::UNION_TEST, class TEST::TEST, union UNION_TEST::UNION_TEST)"),
	mu_demangle_test("?f3@@YAXTUNION_TEST_NEW@@@Z", "void __cdecl f3(union UNION_TEST_NEW)"),
	mu_demangle_test("?f4@@YAXTUNION_NAMESPACE_2@NAMESPACE_2@NAMESPACE_1@@VTEST@4@TUNION_TEST@5@@Z", "void __cdecl f4(union NAMESPACE_1::NAMESPACE_2::UNION_NAMESPACE_2, class TEST::TEST, union UNION_TEST::UNION_TEST)"),
	mu_demangle_test("?f5@@YAXTUNION_TEST@1NAMESPACE_1@@VTEST@3@T11@@Z", "void __cdecl f5(union NAMESPACE_1::UNION_TEST::UNION_TEST, class TEST::TEST, union UNION_TEST::UNION_TEST)"),
	mu_demangle_test("?func_with_arg_class_from_namespace@@YAXVTEST@1@@Z", "void __cdecl func_with_arg_class_from_namespace(class TEST::TEST)"),
	mu_demangle_test("?func_with_arg_union_from_namespace@@YAXTUNION_TEST@1@@Z", "void __cdecl func_with_arg_union_from_namespace(union UNION_TEST::UNION_TEST)"),
	mu_demangle_test("?Fx_i@@YAHP6AHH@Z@Z", "int __cdecl Fx_i(int (__cdecl *)(int))"),
	mu_demangle_test("?Fxix_i@@YAHP6AHH@ZH0@Z", "int __cdecl Fxix_i(int (__cdecl *)(int), int, int (__cdecl *)(int))"),
	mu_demangle_test("?Fxyxy_i@@YAHP6AHH@ZP6AHF@Z01@Z", "int __cdecl Fxyxy_i(int (__cdecl *)(int), int (__cdecl *)(short int), int (__cdecl *)(int), int (__cdecl *)(short int))"),
	mu_demangle_test("?Fxyxy_i_x64@@YAHP6AHPEAH0H@ZP6AH0H0@ZP6AHH@ZP6AHF@Z@Z", "int __cdecl Fxyxy_i_x64(int (__cdecl *)(int * __ptr64, int * __ptr64, int), int (__cdecl *)(int * __ptr64, int, int * __ptr64), int (__cdecl *)(int), int (__cdecl *)(short int))"),
	mu_demangle_test("?instance_@?$StaticStorage@VInProcModule@Details@Platform@@$0A@H@Details@WRL@Microsoft@@0V1234@A", "private: static class Microsoft::WRL::Details::StaticStorage<class Platform::Details::InProcModule, 0, int> Microsoft::WRL::Details::StaticStorage<class Platform::Details::InProcModule, 0, int>::instance_"),
	mu_demangle_test("?private_func@TEST_CLASS@@AEAAXXZ", "private: void __cdecl TEST_CLASS::private_func(void) __ptr64"),
	mu_demangle_test("?public_func@TEST_CLASS@@QEAAHXZ", "public: int __cdecl TEST_CLASS::public_func(void) __ptr64"),
	mu_demangle_test("?SomeFunction@@YAPAVClass1@@PAV1@PAVClass2@@1AAV2@@Z", "class Class1 * __cdecl SomeFunction(class Class1 *, class Class2 *, class Class2 *, class Class2 &)"),
	mu_demangle_test("?static_func@TEST_CLASS@@SAXH@Z", "public: static void __cdecl TEST_CLASS::static_func(int)"),
	mu_demangle_test("?test@@$$FYMHPE$AA__ZUV@@@Z", "int __clrcall test(struct V ^ __ptr64)"),
	mu_demangle_test("?test@@$$FYMHPE$CA__ZUV@@@Z", "int __clrcall test(struct V % __ptr64)"),
	mu_demangle_test("?test@@YMHAE$CAPEAUV@@@Z", "int __clrcall test(struct V * __ptr64 % __ptr64)"),
	mu_demangle_test("?var__m128@@3T__m128@@A", "__m128 var__m128"),
	mu_demangle_test("?var__m128d@@3U__m128d@@A", "__m128d var__m128d"),
	mu_demangle_test("?var__m128i@@3T__m128i@@A", "__m128i var__m128i"),
	mu_demangle_test("?var__m256@@3T__m256@@A", "__m256 var__m256"),
	mu_demangle_test("?var__m256d@@3U__m256d@@A", "__m256d var__m256d"),
	mu_demangle_test("?var__m256i@@3T__m256i@@A", "__m256i var__m256i"),
	mu_demangle_test("?var__m64@@3T__m64@@A", "__m64 var__m64"),
	mu_demangle_test("?var_bool@@3_NA", "bool var_bool"),
	mu_demangle_test("?var_char@@3DA", "char var_char"),
	mu_demangle_test("?var_class@@3VCLASS_TEST@@A", "class CLASS_TEST var_class"),
	mu_demangle_test("?var_class_with_namespace@TEST_NAMESPACE@@3VCLASS_TEST@@A", "class CLASS_TEST TEST_NAMESPACE::var_class_with_namespace"),
	mu_demangle_test("?var_const_int_ptr@@3PEBHEB", "int const * __ptr64 const __ptr64 var_const_int_ptr"),
	mu_demangle_test("?var_const_volatile_int_ptr@@3PEDHED", "int const volatile * __ptr64 const volatile __ptr64 var_const_volatile_int_ptr"),
	mu_demangle_test("?var_double@@3NA", "double var_double"),
	mu_demangle_test("?var_enum@@3W4ENUM_TEST@@A", "enum ENUM_TEST var_enum"),
	mu_demangle_test("?var_enum_with_namespace@TEST_NAMESPACE@@3W4ENUM_TEST@@A", "enum ENUM_TEST TEST_NAMESPACE::var_enum_with_namespace"),
	mu_demangle_test("?var_float@@3MA", "float var_float"),
	mu_demangle_test("?var_int@@3HA", "int var_int"),
	mu_demangle_test("?var_int_ptr@@3PEAHA", "int * __ptr64 var_int_ptr"),
	mu_demangle_test("?var_int_ptr_volatile@@3REAHEA", "int * volatile __ptr64 __ptr64 var_int_ptr_volatile"),
	mu_demangle_test("?var_long_double@@3OA", "long double var_long_double"),
	mu_demangle_test("?var_long_int@@3JA", "long int var_long_int"),
	mu_demangle_test("?var_long_long@@3_JA", "__int64 var_long_long"),
	mu_demangle_test("?var_ptr_with_namespace@TEST_NAMESPACE@@3PEAUSTRUCT_TEST@@EA", "struct STRUCT_TEST * __ptr64 __ptr64 TEST_NAMESPACE::var_ptr_with_namespace"),
	mu_demangle_test("?var_short_int@@3FA", "short int var_short_int"),
	mu_demangle_test("?var_signed_char@@3CA", "signed char var_signed_char"),
	mu_demangle_test("?var_union@@3TUNION_TEST@@A", "union UNION_TEST var_union"),
	mu_demangle_test("?var_union_with_namespace@TEST_NAMESPACE@@3TUNION_TEST@@A", "union UNION_TEST TEST_NAMESPACE::var_union_with_namespace"),
	mu_demangle_test("?var_unsigned_char@@3EA", "unsigned char var_unsigned_char"),
	mu_demangle_test("?var_unsigned_int@@3IA", "unsigned int var_unsigned_int"),
	mu_demangle_test("?var_unsigned_long_int@@3KA", "unsigned long int var_unsigned_long_int"),
	mu_demangle_test("?var_unsigned_long_long@@3_KA", "unsigned __int64 var_unsigned_long_long"),
	mu_demangle_test("?var_voidptr@@3PEAXA", "void * __ptr64 var_voidptr"),
	mu_demangle_test("?var_volatile_int_ptr@@3PECHEC", "int volatile * __ptr64 volatile __ptr64 var_volatile_int_ptr"),
	mu_demangle_test("?var_wchar_t@@3_WA", "wchar_t var_wchar_t"),
	mu_demangle_test("?x@@QEFGHIBAHXZ", "public: int __cdecl x(void)const __unaligned __ptr64 __restrict& &&"),
	mu_demangle_test("?xyz@?$abc@V?$def@H@@PAX@@YAXXZ", "void __cdecl abc<class def<int>, void *>::xyz(void)"),
	mu_demangle_test("?nested@??func@@YAXXZ@4HA", "int `void __cdecl func(void)'::nested"),
	mu_demangle_test("?CONST@?1??main@@9@4HB", "int const `main'::`2'::CONST"),
	mu_demangle_test("??_7Ftable@?A0x123??Test@@6A@base@@6B@", "const base::` Test'::`291'::Ftable::vftable"),
	mu_demangle_test("??_7VFtable@?2?3?@base@@6B@", "const base::`0'::`4'::`3'::VFtable::vftable"),
	mu_demangle_test("??_R1A@?0A@EA@DayPeriodRulesDataSink@icu_64@@8", "icu_64::DayPeriodRulesDataSink::`RTTI Base Class Descriptor at (0,-1,0,64)'"),
	mu_demangle_test("??_R4ObjectLocator@Test123@@6B@", "const Test123::ObjectLocator::`RTTI Complete Object Locator'"),
	mu_demangle_test("??__FNullSlot@?1??GetSlotAt@?$TSlotlessChildren@VSWidget@@@@EEBAAEBVFSlotBase@@H@Z@YAXXZ", "void __cdecl `private virtual: class FSlotBase const & __ptr64 __cdecl TSlotlessChildren<class SWidget>::GetSlotAt(int)const __ptr64'::`2'::`dynamic atexit destructor for 'NullSlot''(void)"),
	mu_demangle_test("?in@?$codecvt@DDU_Mbstatet@@@std@@QEBAHAEAU_Mbstatet@@PEBD1AEAPEBDPEAD3AEAPEAD@Z", "public: int __cdecl std::codecvt<char, char, struct _Mbstatet>::in(struct _Mbstatet & __ptr64, char const * __ptr64, char const * __ptr64, char const * __ptr64 & __ptr64, char * __ptr64, char * __ptr64, char * __ptr64 & __ptr64)const __ptr64"),
	mu_demangle_test("??$Add@$$BY09UFVector4@@@FDraw@@QEAAXVFParameter@@AEAY09$$CBUFVector4@@@Z", "public: void __cdecl FDraw::Add<struct FVector4 [10]>(class FParameter, struct FVector4 const (& __ptr64)[10]) __ptr64"),
	mu_demangle_test("??$CreateSP@VSThrobber@@H@?$TBaseDelegate@UFVector2D@@$$V@@SA?AV0@PEAVSThrobber@@P81@EBA?AUFVector2D@@H@ZH@Z", "public: static class TBaseDelegate<struct FVector2D> __cdecl TBaseDelegate<struct FVector2D>::CreateSP<class SThrobber, int>(class SThrobber * __ptr64, struct FVector2D (__cdecl SThrobber::*)(int) const __ptr64, int)"),
	mu_demangle_test("??_C@_1CK@EOPGIILJ@?$AAi?$AAn?$AAv?$AAa?$AAl?$AAi?$AAd?$AA?5?$AAn?$AAu?$AAl?$AAl?$AA?5?$AAp?$AAo?$AAi?$AAn?$AAt?$AAe?$AAr?$AA?$AA@", "`string'::1324779705::\"invalid null pointer\""),
	mu_demangle_test("??_C@_0CK@EOPGIILJ@invalid?5null?5pointer?$AA@", "`string'::1324779705::\"invalid null pointer\""),
	mu_demangle_test("??_C@_1BK@FIHMCKAM@?$AAa@", "`string'::1484532236::\"a\""),
	mu_demangle_test("??_C@_0BK@FIHMCKAM@a@", "`string'::1484532236::\"a\""),
	mu_demangle_test("??_C@_0BK@OFCNNNKO@?$GAgeneric?9class?9parameter?9@", "`string'::3844988334::\"\6generic-class-parameter-\""),
	mu_demangle_test("??_C@_0CL@CODINPLA@Failed?5to?5get?5the?5string?5from?5t@NNGAKEGL@", "`string'::775479216::\"Failed to get the string from t\"::3714098283"),
	mu_demangle_test("?", NULL),
	mu_demangle_test(".?", NULL),
	mu_demangle_test("..?", NULL),
	mu_demangle_test("??", NULL),
	mu_demangle_test("??_R0", NULL),
	mu_demangle_test("??A", "operator[]"),
	mu_demangle_test("???1", NULL),
	mu_demangle_test("??$?$@R9", "<><>"),
	mu_demangle_test("??_C@_10", "`string'::\"\""),
	mu_demangle_test("??_C@_10@$A", "`string'::0::\"⑁\""),
	mu_demangle_test("??_C@_10@$?A", NULL),
	mu_demangle_test("?a@?$", NULL),
	mu_demangle_test("?a@?$a@?$", NULL),
	mu_demangle_test("?a@?$a@W4", NULL),
	mu_demangle_test("?a@?$a@AE$", "private virtual: a<>::a"),
	mu_demangle_test("?a@@Y", "a"),
	mu_demangle_test("?a@@YA", NULL),
	mu_demangle_test("?a@@YAE", NULL),
	mu_demangle_test(".?AV?$a@a@P6", "class a::a<>"),
	mu_demangle_test(".?AV?$a@@", "class a<>"),
	mu_demangle_test("??J?6J?J", "const operator->*{for `operator->*'}"),
	mu_demangle_test("??QQSSQ6", NULL),
	mu_demangle_test("?A@7B?5", "const A{for `operator>>'}"),
	// end
);

mu_main2(msvc);