// SPDX-FileCopyrightText: 2021 Rot127 <unisono@quyllur.org>
// SPDX-License-Identifier: LGPL-3.0-only

// LLVM commit: c2b89fc9e45d325282b8eb6536f6145282dc3fdf
// LLVM commit date: 2024-12-23 13:36:28 -0600 (ISO 8601 format)
// Date of code generation: 2025-02-22 07:05:24-05:00
//========================================
// The following code is generated.
// Do not edit. Repository of code generator:
// https://github.com/rizinorg/rz-hexagon

#include <rz_il/rz_il_opbuilder_begin.h>
#include "../hexagon_il.h"
#include <hexagon/hexagon.h>
#include <rz_il/rz_il_opcodes.h>

// Rx += add(Rs,Rt)
RzILOpEffect *hex_il_op_m2_acci(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = Rx + Rs + Rt;
	RzILOpPure *op_ADD_2 = ADD(READ_REG(pkt, Rx_op, false), Rs);
	RzILOpPure *op_ADD_4 = ADD(op_ADD_2, Rt);
	RzILOpEffect *op_ASSIGN_5 = WRITE_REG(bundle, Rx_op, op_ADD_4);

	RzILOpEffect *instruction_sequence = op_ASSIGN_5;
	return instruction_sequence;
}

// Rx += add(Rs,Ii)
RzILOpEffect *hex_il_op_m2_accii(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	RzILOpPure *s = SN(32, (st32)ISA2IMM(hi, 's'));
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);

	// s = s;
	RzILOpEffect *imm_assign_0 = SETL("s", s);

	// Rx = Rx + Rs + s;
	RzILOpPure *op_ADD_4 = ADD(READ_REG(pkt, Rx_op, false), Rs);
	RzILOpPure *op_ADD_5 = ADD(op_ADD_4, VARL("s"));
	RzILOpEffect *op_ASSIGN_6 = WRITE_REG(bundle, Rx_op, op_ADD_5);

	RzILOpEffect *instruction_sequence = SEQN(2, imm_assign_0, op_ASSIGN_6);
	return instruction_sequence;
}

// Rxx += cmpyi(Rs,Rt)
RzILOpEffect *hex_il_op_m2_cmaci_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = Rxx + ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) + ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_ADD_21 = ADD(READ_REG(pkt, Rxx_op, false), CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)));
	RzILOpPure *op_RSHIFT_25 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_27 = LOGAND(op_RSHIFT_25, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_33 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_35 = LOGAND(op_RSHIFT_33, SN(32, 0xffff));
	RzILOpPure *op_MUL_38 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_27), DUP(op_AND_27))), CAST(16, MSB(DUP(op_AND_27)), DUP(op_AND_27))), CAST(32, MSB(CAST(16, MSB(op_AND_35), DUP(op_AND_35))), CAST(16, MSB(DUP(op_AND_35)), DUP(op_AND_35))));
	RzILOpPure *op_ADD_40 = ADD(op_ADD_21, CAST(64, MSB(op_MUL_38), DUP(op_MUL_38)));
	RzILOpEffect *op_ASSIGN_41 = WRITE_REG(bundle, Rxx_op, op_ADD_40);

	RzILOpEffect *instruction_sequence = op_ASSIGN_41;
	return instruction_sequence;
}

// Rxx += cmpyr(Rs,Rt)
RzILOpEffect *hex_il_op_m2_cmacr_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = Rxx + ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) - ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_ADD_21 = ADD(READ_REG(pkt, Rxx_op, false), CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)));
	RzILOpPure *op_RSHIFT_25 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_27 = LOGAND(op_RSHIFT_25, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_33 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_35 = LOGAND(op_RSHIFT_33, SN(32, 0xffff));
	RzILOpPure *op_MUL_38 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_27), DUP(op_AND_27))), CAST(16, MSB(DUP(op_AND_27)), DUP(op_AND_27))), CAST(32, MSB(CAST(16, MSB(op_AND_35), DUP(op_AND_35))), CAST(16, MSB(DUP(op_AND_35)), DUP(op_AND_35))));
	RzILOpPure *op_SUB_40 = SUB(op_ADD_21, CAST(64, MSB(op_MUL_38), DUP(op_MUL_38)));
	RzILOpEffect *op_ASSIGN_41 = WRITE_REG(bundle, Rxx_op, op_SUB_40);

	RzILOpEffect *instruction_sequence = op_ASSIGN_41;
	return instruction_sequence;
}

// Rxx += cmpy(Rs,Rt):sat
RzILOpEffect *hex_il_op_m2_cmacs_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_171 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_25 = LOGAND(op_RSHIFT_23, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_32 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_34 = LOGAND(op_RSHIFT_32, SN(32, 0xffff));
	RzILOpPure *op_MUL_37 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_25), DUP(op_AND_25))), CAST(16, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(CAST(16, MSB(op_AND_34), DUP(op_AND_34))), CAST(16, MSB(DUP(op_AND_34)), DUP(op_AND_34))));
	RzILOpPure *op_LSHIFT_40 = SHIFTL0(CAST(64, MSB(op_MUL_37), DUP(op_MUL_37)), SN(32, 0));
	RzILOpPure *op_ADD_41 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_LSHIFT_40);
	RzILOpPure *op_RSHIFT_45 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_47 = LOGAND(op_RSHIFT_45, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_53 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_55 = LOGAND(op_RSHIFT_53, SN(32, 0xffff));
	RzILOpPure *op_MUL_58 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_47), DUP(op_AND_47))), CAST(16, MSB(DUP(op_AND_47)), DUP(op_AND_47))), CAST(32, MSB(CAST(16, MSB(op_AND_55), DUP(op_AND_55))), CAST(16, MSB(DUP(op_AND_55)), DUP(op_AND_55))));
	RzILOpPure *op_LSHIFT_61 = SHIFTL0(CAST(64, MSB(op_MUL_58), DUP(op_MUL_58)), SN(32, 0));
	RzILOpPure *op_ADD_62 = ADD(op_ADD_41, op_LSHIFT_61);
	RzILOpPure *op_RSHIFT_71 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_73 = LOGAND(op_RSHIFT_71, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_79 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_81 = LOGAND(op_RSHIFT_79, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_87 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_89 = LOGAND(op_RSHIFT_87, SN(32, 0xffff));
	RzILOpPure *op_MUL_92 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_81), DUP(op_AND_81))), CAST(16, MSB(DUP(op_AND_81)), DUP(op_AND_81))), CAST(32, MSB(CAST(16, MSB(op_AND_89), DUP(op_AND_89))), CAST(16, MSB(DUP(op_AND_89)), DUP(op_AND_89))));
	RzILOpPure *op_LSHIFT_95 = SHIFTL0(CAST(64, MSB(op_MUL_92), DUP(op_MUL_92)), SN(32, 0));
	RzILOpPure *op_ADD_96 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_73), DUP(op_AND_73))), CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73))), op_LSHIFT_95);
	RzILOpPure *op_RSHIFT_100 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_102 = LOGAND(op_RSHIFT_100, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_108 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_110 = LOGAND(op_RSHIFT_108, SN(32, 0xffff));
	RzILOpPure *op_MUL_113 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_102), DUP(op_AND_102))), CAST(16, MSB(DUP(op_AND_102)), DUP(op_AND_102))), CAST(32, MSB(CAST(16, MSB(op_AND_110), DUP(op_AND_110))), CAST(16, MSB(DUP(op_AND_110)), DUP(op_AND_110))));
	RzILOpPure *op_LSHIFT_116 = SHIFTL0(CAST(64, MSB(op_MUL_113), DUP(op_MUL_113)), SN(32, 0));
	RzILOpPure *op_ADD_117 = ADD(op_ADD_96, op_LSHIFT_116);
	RzILOpPure *op_EQ_118 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_62), SN(32, 0), SN(32, 0x20)), op_ADD_117);
	RzILOpPure *op_RSHIFT_175 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_177 = LOGAND(op_RSHIFT_175, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_183 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_185 = LOGAND(op_RSHIFT_183, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_191 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_193 = LOGAND(op_RSHIFT_191, SN(32, 0xffff));
	RzILOpPure *op_MUL_196 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_185), DUP(op_AND_185))), CAST(16, MSB(DUP(op_AND_185)), DUP(op_AND_185))), CAST(32, MSB(CAST(16, MSB(op_AND_193), DUP(op_AND_193))), CAST(16, MSB(DUP(op_AND_193)), DUP(op_AND_193))));
	RzILOpPure *op_LSHIFT_199 = SHIFTL0(CAST(64, MSB(op_MUL_196), DUP(op_MUL_196)), SN(32, 0));
	RzILOpPure *op_ADD_200 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_177), DUP(op_AND_177))), CAST(32, MSB(DUP(op_AND_177)), DUP(op_AND_177))), op_LSHIFT_199);
	RzILOpPure *op_RSHIFT_204 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_206 = LOGAND(op_RSHIFT_204, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_212 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_214 = LOGAND(op_RSHIFT_212, SN(32, 0xffff));
	RzILOpPure *op_MUL_217 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_206), DUP(op_AND_206))), CAST(16, MSB(DUP(op_AND_206)), DUP(op_AND_206))), CAST(32, MSB(CAST(16, MSB(op_AND_214), DUP(op_AND_214))), CAST(16, MSB(DUP(op_AND_214)), DUP(op_AND_214))));
	RzILOpPure *op_LSHIFT_220 = SHIFTL0(CAST(64, MSB(op_MUL_217), DUP(op_MUL_217)), SN(32, 0));
	RzILOpPure *op_ADD_221 = ADD(op_ADD_200, op_LSHIFT_220);
	RzILOpPure *op_LT_224 = SLT(op_ADD_221, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_229 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_230 = NEG(op_LSHIFT_229);
	RzILOpPure *op_LSHIFT_235 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_238 = SUB(op_LSHIFT_235, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_239 = ITE(op_LT_224, op_NEG_230, op_SUB_238);
	RzILOpEffect *gcc_expr_240 = BRANCH(op_EQ_118, EMPTY(), set_usr_field_call_171);

	// h_tmp232 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_242 = SETL("h_tmp232", cond_239);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_243 = SEQN(2, gcc_expr_240, op_ASSIGN_hybrid_tmp_242);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) : h_tmp232) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_122 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_124 = LOGAND(op_RSHIFT_122, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_130 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_132 = LOGAND(op_RSHIFT_130, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_138 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_140 = LOGAND(op_RSHIFT_138, SN(32, 0xffff));
	RzILOpPure *op_MUL_143 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_132), DUP(op_AND_132))), CAST(16, MSB(DUP(op_AND_132)), DUP(op_AND_132))), CAST(32, MSB(CAST(16, MSB(op_AND_140), DUP(op_AND_140))), CAST(16, MSB(DUP(op_AND_140)), DUP(op_AND_140))));
	RzILOpPure *op_LSHIFT_146 = SHIFTL0(CAST(64, MSB(op_MUL_143), DUP(op_MUL_143)), SN(32, 0));
	RzILOpPure *op_ADD_147 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_124), DUP(op_AND_124))), CAST(32, MSB(DUP(op_AND_124)), DUP(op_AND_124))), op_LSHIFT_146);
	RzILOpPure *op_RSHIFT_151 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_153 = LOGAND(op_RSHIFT_151, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_159 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_161 = LOGAND(op_RSHIFT_159, SN(32, 0xffff));
	RzILOpPure *op_MUL_164 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_153), DUP(op_AND_153))), CAST(16, MSB(DUP(op_AND_153)), DUP(op_AND_153))), CAST(32, MSB(CAST(16, MSB(op_AND_161), DUP(op_AND_161))), CAST(16, MSB(DUP(op_AND_161)), DUP(op_AND_161))));
	RzILOpPure *op_LSHIFT_167 = SHIFTL0(CAST(64, MSB(op_MUL_164), DUP(op_MUL_164)), SN(32, 0));
	RzILOpPure *op_ADD_168 = ADD(op_ADD_147, op_LSHIFT_167);
	RzILOpPure *cond_244 = ITE(DUP(op_EQ_118), op_ADD_168, VARL("h_tmp232"));
	RzILOpPure *op_AND_246 = LOGAND(cond_244, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_250 = SHIFTL0(op_AND_246, SN(32, 0x20));
	RzILOpPure *op_OR_251 = LOGOR(op_AND_7, op_LSHIFT_250);
	RzILOpEffect *op_ASSIGN_252 = WRITE_REG(bundle, Rxx_op, op_OR_251);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_253 = SEQN(2, seq_243, op_ASSIGN_252);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_423 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_268 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_270 = LOGAND(op_RSHIFT_268, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_276 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_278 = LOGAND(op_RSHIFT_276, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_284 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_286 = LOGAND(op_RSHIFT_284, SN(32, 0xffff));
	RzILOpPure *op_MUL_289 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_278), DUP(op_AND_278))), CAST(16, MSB(DUP(op_AND_278)), DUP(op_AND_278))), CAST(32, MSB(CAST(16, MSB(op_AND_286), DUP(op_AND_286))), CAST(16, MSB(DUP(op_AND_286)), DUP(op_AND_286))));
	RzILOpPure *op_LSHIFT_292 = SHIFTL0(CAST(64, MSB(op_MUL_289), DUP(op_MUL_289)), SN(32, 0));
	RzILOpPure *op_ADD_293 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_270), DUP(op_AND_270))), CAST(32, MSB(DUP(op_AND_270)), DUP(op_AND_270))), op_LSHIFT_292);
	RzILOpPure *op_RSHIFT_297 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_299 = LOGAND(op_RSHIFT_297, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_305 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_307 = LOGAND(op_RSHIFT_305, SN(32, 0xffff));
	RzILOpPure *op_MUL_310 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_299), DUP(op_AND_299))), CAST(16, MSB(DUP(op_AND_299)), DUP(op_AND_299))), CAST(32, MSB(CAST(16, MSB(op_AND_307), DUP(op_AND_307))), CAST(16, MSB(DUP(op_AND_307)), DUP(op_AND_307))));
	RzILOpPure *op_LSHIFT_313 = SHIFTL0(CAST(64, MSB(op_MUL_310), DUP(op_MUL_310)), SN(32, 0));
	RzILOpPure *op_SUB_314 = SUB(op_ADD_293, op_LSHIFT_313);
	RzILOpPure *op_RSHIFT_323 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_325 = LOGAND(op_RSHIFT_323, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_331 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_333 = LOGAND(op_RSHIFT_331, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_339 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_341 = LOGAND(op_RSHIFT_339, SN(32, 0xffff));
	RzILOpPure *op_MUL_344 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_333), DUP(op_AND_333))), CAST(16, MSB(DUP(op_AND_333)), DUP(op_AND_333))), CAST(32, MSB(CAST(16, MSB(op_AND_341), DUP(op_AND_341))), CAST(16, MSB(DUP(op_AND_341)), DUP(op_AND_341))));
	RzILOpPure *op_LSHIFT_347 = SHIFTL0(CAST(64, MSB(op_MUL_344), DUP(op_MUL_344)), SN(32, 0));
	RzILOpPure *op_ADD_348 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_325), DUP(op_AND_325))), CAST(32, MSB(DUP(op_AND_325)), DUP(op_AND_325))), op_LSHIFT_347);
	RzILOpPure *op_RSHIFT_352 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_354 = LOGAND(op_RSHIFT_352, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_360 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_362 = LOGAND(op_RSHIFT_360, SN(32, 0xffff));
	RzILOpPure *op_MUL_365 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_354), DUP(op_AND_354))), CAST(16, MSB(DUP(op_AND_354)), DUP(op_AND_354))), CAST(32, MSB(CAST(16, MSB(op_AND_362), DUP(op_AND_362))), CAST(16, MSB(DUP(op_AND_362)), DUP(op_AND_362))));
	RzILOpPure *op_LSHIFT_368 = SHIFTL0(CAST(64, MSB(op_MUL_365), DUP(op_MUL_365)), SN(32, 0));
	RzILOpPure *op_SUB_369 = SUB(op_ADD_348, op_LSHIFT_368);
	RzILOpPure *op_EQ_370 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_SUB_314), SN(32, 0), SN(32, 0x20)), op_SUB_369);
	RzILOpPure *op_RSHIFT_427 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_429 = LOGAND(op_RSHIFT_427, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_435 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_437 = LOGAND(op_RSHIFT_435, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_443 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_445 = LOGAND(op_RSHIFT_443, SN(32, 0xffff));
	RzILOpPure *op_MUL_448 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_437), DUP(op_AND_437))), CAST(16, MSB(DUP(op_AND_437)), DUP(op_AND_437))), CAST(32, MSB(CAST(16, MSB(op_AND_445), DUP(op_AND_445))), CAST(16, MSB(DUP(op_AND_445)), DUP(op_AND_445))));
	RzILOpPure *op_LSHIFT_451 = SHIFTL0(CAST(64, MSB(op_MUL_448), DUP(op_MUL_448)), SN(32, 0));
	RzILOpPure *op_ADD_452 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_429), DUP(op_AND_429))), CAST(32, MSB(DUP(op_AND_429)), DUP(op_AND_429))), op_LSHIFT_451);
	RzILOpPure *op_RSHIFT_456 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_458 = LOGAND(op_RSHIFT_456, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_464 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_466 = LOGAND(op_RSHIFT_464, SN(32, 0xffff));
	RzILOpPure *op_MUL_469 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_458), DUP(op_AND_458))), CAST(16, MSB(DUP(op_AND_458)), DUP(op_AND_458))), CAST(32, MSB(CAST(16, MSB(op_AND_466), DUP(op_AND_466))), CAST(16, MSB(DUP(op_AND_466)), DUP(op_AND_466))));
	RzILOpPure *op_LSHIFT_472 = SHIFTL0(CAST(64, MSB(op_MUL_469), DUP(op_MUL_469)), SN(32, 0));
	RzILOpPure *op_SUB_473 = SUB(op_ADD_452, op_LSHIFT_472);
	RzILOpPure *op_LT_476 = SLT(op_SUB_473, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_481 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_482 = NEG(op_LSHIFT_481);
	RzILOpPure *op_LSHIFT_487 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_490 = SUB(op_LSHIFT_487, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_491 = ITE(op_LT_476, op_NEG_482, op_SUB_490);
	RzILOpEffect *gcc_expr_492 = BRANCH(op_EQ_370, EMPTY(), set_usr_field_call_423);

	// h_tmp233 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_494 = SETL("h_tmp233", cond_491);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_495 = SEQN(2, gcc_expr_492, op_ASSIGN_hybrid_tmp_494);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) : h_tmp233) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_259 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_260 = LOGNOT(op_LSHIFT_259);
	RzILOpPure *op_AND_261 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_260);
	RzILOpPure *op_RSHIFT_374 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_376 = LOGAND(op_RSHIFT_374, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_382 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_384 = LOGAND(op_RSHIFT_382, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_390 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_392 = LOGAND(op_RSHIFT_390, SN(32, 0xffff));
	RzILOpPure *op_MUL_395 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_384), DUP(op_AND_384))), CAST(16, MSB(DUP(op_AND_384)), DUP(op_AND_384))), CAST(32, MSB(CAST(16, MSB(op_AND_392), DUP(op_AND_392))), CAST(16, MSB(DUP(op_AND_392)), DUP(op_AND_392))));
	RzILOpPure *op_LSHIFT_398 = SHIFTL0(CAST(64, MSB(op_MUL_395), DUP(op_MUL_395)), SN(32, 0));
	RzILOpPure *op_ADD_399 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_376), DUP(op_AND_376))), CAST(32, MSB(DUP(op_AND_376)), DUP(op_AND_376))), op_LSHIFT_398);
	RzILOpPure *op_RSHIFT_403 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_405 = LOGAND(op_RSHIFT_403, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_411 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_413 = LOGAND(op_RSHIFT_411, SN(32, 0xffff));
	RzILOpPure *op_MUL_416 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_405), DUP(op_AND_405))), CAST(16, MSB(DUP(op_AND_405)), DUP(op_AND_405))), CAST(32, MSB(CAST(16, MSB(op_AND_413), DUP(op_AND_413))), CAST(16, MSB(DUP(op_AND_413)), DUP(op_AND_413))));
	RzILOpPure *op_LSHIFT_419 = SHIFTL0(CAST(64, MSB(op_MUL_416), DUP(op_MUL_416)), SN(32, 0));
	RzILOpPure *op_SUB_420 = SUB(op_ADD_399, op_LSHIFT_419);
	RzILOpPure *cond_496 = ITE(DUP(op_EQ_370), op_SUB_420, VARL("h_tmp233"));
	RzILOpPure *op_AND_498 = LOGAND(cond_496, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_502 = SHIFTL0(op_AND_498, SN(32, 0));
	RzILOpPure *op_OR_503 = LOGOR(op_AND_261, op_LSHIFT_502);
	RzILOpEffect *op_ASSIGN_504 = WRITE_REG(bundle, Rxx_op, op_OR_503);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_505 = SEQN(2, seq_495, op_ASSIGN_504);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_253, seq_505);
	return instruction_sequence;
}

// Rxx += cmpy(Rs,Rt):<<1:sat
RzILOpEffect *hex_il_op_m2_cmacs_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_171 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_25 = LOGAND(op_RSHIFT_23, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_32 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_34 = LOGAND(op_RSHIFT_32, SN(32, 0xffff));
	RzILOpPure *op_MUL_37 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_25), DUP(op_AND_25))), CAST(16, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(CAST(16, MSB(op_AND_34), DUP(op_AND_34))), CAST(16, MSB(DUP(op_AND_34)), DUP(op_AND_34))));
	RzILOpPure *op_LSHIFT_40 = SHIFTL0(CAST(64, MSB(op_MUL_37), DUP(op_MUL_37)), SN(32, 1));
	RzILOpPure *op_ADD_41 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_LSHIFT_40);
	RzILOpPure *op_RSHIFT_45 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_47 = LOGAND(op_RSHIFT_45, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_53 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_55 = LOGAND(op_RSHIFT_53, SN(32, 0xffff));
	RzILOpPure *op_MUL_58 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_47), DUP(op_AND_47))), CAST(16, MSB(DUP(op_AND_47)), DUP(op_AND_47))), CAST(32, MSB(CAST(16, MSB(op_AND_55), DUP(op_AND_55))), CAST(16, MSB(DUP(op_AND_55)), DUP(op_AND_55))));
	RzILOpPure *op_LSHIFT_61 = SHIFTL0(CAST(64, MSB(op_MUL_58), DUP(op_MUL_58)), SN(32, 1));
	RzILOpPure *op_ADD_62 = ADD(op_ADD_41, op_LSHIFT_61);
	RzILOpPure *op_RSHIFT_71 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_73 = LOGAND(op_RSHIFT_71, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_79 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_81 = LOGAND(op_RSHIFT_79, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_87 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_89 = LOGAND(op_RSHIFT_87, SN(32, 0xffff));
	RzILOpPure *op_MUL_92 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_81), DUP(op_AND_81))), CAST(16, MSB(DUP(op_AND_81)), DUP(op_AND_81))), CAST(32, MSB(CAST(16, MSB(op_AND_89), DUP(op_AND_89))), CAST(16, MSB(DUP(op_AND_89)), DUP(op_AND_89))));
	RzILOpPure *op_LSHIFT_95 = SHIFTL0(CAST(64, MSB(op_MUL_92), DUP(op_MUL_92)), SN(32, 1));
	RzILOpPure *op_ADD_96 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_73), DUP(op_AND_73))), CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73))), op_LSHIFT_95);
	RzILOpPure *op_RSHIFT_100 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_102 = LOGAND(op_RSHIFT_100, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_108 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_110 = LOGAND(op_RSHIFT_108, SN(32, 0xffff));
	RzILOpPure *op_MUL_113 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_102), DUP(op_AND_102))), CAST(16, MSB(DUP(op_AND_102)), DUP(op_AND_102))), CAST(32, MSB(CAST(16, MSB(op_AND_110), DUP(op_AND_110))), CAST(16, MSB(DUP(op_AND_110)), DUP(op_AND_110))));
	RzILOpPure *op_LSHIFT_116 = SHIFTL0(CAST(64, MSB(op_MUL_113), DUP(op_MUL_113)), SN(32, 1));
	RzILOpPure *op_ADD_117 = ADD(op_ADD_96, op_LSHIFT_116);
	RzILOpPure *op_EQ_118 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_62), SN(32, 0), SN(32, 0x20)), op_ADD_117);
	RzILOpPure *op_RSHIFT_175 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_177 = LOGAND(op_RSHIFT_175, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_183 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_185 = LOGAND(op_RSHIFT_183, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_191 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_193 = LOGAND(op_RSHIFT_191, SN(32, 0xffff));
	RzILOpPure *op_MUL_196 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_185), DUP(op_AND_185))), CAST(16, MSB(DUP(op_AND_185)), DUP(op_AND_185))), CAST(32, MSB(CAST(16, MSB(op_AND_193), DUP(op_AND_193))), CAST(16, MSB(DUP(op_AND_193)), DUP(op_AND_193))));
	RzILOpPure *op_LSHIFT_199 = SHIFTL0(CAST(64, MSB(op_MUL_196), DUP(op_MUL_196)), SN(32, 1));
	RzILOpPure *op_ADD_200 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_177), DUP(op_AND_177))), CAST(32, MSB(DUP(op_AND_177)), DUP(op_AND_177))), op_LSHIFT_199);
	RzILOpPure *op_RSHIFT_204 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_206 = LOGAND(op_RSHIFT_204, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_212 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_214 = LOGAND(op_RSHIFT_212, SN(32, 0xffff));
	RzILOpPure *op_MUL_217 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_206), DUP(op_AND_206))), CAST(16, MSB(DUP(op_AND_206)), DUP(op_AND_206))), CAST(32, MSB(CAST(16, MSB(op_AND_214), DUP(op_AND_214))), CAST(16, MSB(DUP(op_AND_214)), DUP(op_AND_214))));
	RzILOpPure *op_LSHIFT_220 = SHIFTL0(CAST(64, MSB(op_MUL_217), DUP(op_MUL_217)), SN(32, 1));
	RzILOpPure *op_ADD_221 = ADD(op_ADD_200, op_LSHIFT_220);
	RzILOpPure *op_LT_224 = SLT(op_ADD_221, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_229 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_230 = NEG(op_LSHIFT_229);
	RzILOpPure *op_LSHIFT_235 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_238 = SUB(op_LSHIFT_235, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_239 = ITE(op_LT_224, op_NEG_230, op_SUB_238);
	RzILOpEffect *gcc_expr_240 = BRANCH(op_EQ_118, EMPTY(), set_usr_field_call_171);

	// h_tmp234 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_242 = SETL("h_tmp234", cond_239);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_243 = SEQN(2, gcc_expr_240, op_ASSIGN_hybrid_tmp_242);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) : h_tmp234) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_122 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_124 = LOGAND(op_RSHIFT_122, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_130 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_132 = LOGAND(op_RSHIFT_130, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_138 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_140 = LOGAND(op_RSHIFT_138, SN(32, 0xffff));
	RzILOpPure *op_MUL_143 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_132), DUP(op_AND_132))), CAST(16, MSB(DUP(op_AND_132)), DUP(op_AND_132))), CAST(32, MSB(CAST(16, MSB(op_AND_140), DUP(op_AND_140))), CAST(16, MSB(DUP(op_AND_140)), DUP(op_AND_140))));
	RzILOpPure *op_LSHIFT_146 = SHIFTL0(CAST(64, MSB(op_MUL_143), DUP(op_MUL_143)), SN(32, 1));
	RzILOpPure *op_ADD_147 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_124), DUP(op_AND_124))), CAST(32, MSB(DUP(op_AND_124)), DUP(op_AND_124))), op_LSHIFT_146);
	RzILOpPure *op_RSHIFT_151 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_153 = LOGAND(op_RSHIFT_151, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_159 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_161 = LOGAND(op_RSHIFT_159, SN(32, 0xffff));
	RzILOpPure *op_MUL_164 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_153), DUP(op_AND_153))), CAST(16, MSB(DUP(op_AND_153)), DUP(op_AND_153))), CAST(32, MSB(CAST(16, MSB(op_AND_161), DUP(op_AND_161))), CAST(16, MSB(DUP(op_AND_161)), DUP(op_AND_161))));
	RzILOpPure *op_LSHIFT_167 = SHIFTL0(CAST(64, MSB(op_MUL_164), DUP(op_MUL_164)), SN(32, 1));
	RzILOpPure *op_ADD_168 = ADD(op_ADD_147, op_LSHIFT_167);
	RzILOpPure *cond_244 = ITE(DUP(op_EQ_118), op_ADD_168, VARL("h_tmp234"));
	RzILOpPure *op_AND_246 = LOGAND(cond_244, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_250 = SHIFTL0(op_AND_246, SN(32, 0x20));
	RzILOpPure *op_OR_251 = LOGOR(op_AND_7, op_LSHIFT_250);
	RzILOpEffect *op_ASSIGN_252 = WRITE_REG(bundle, Rxx_op, op_OR_251);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_253 = SEQN(2, seq_243, op_ASSIGN_252);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_423 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_268 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_270 = LOGAND(op_RSHIFT_268, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_276 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_278 = LOGAND(op_RSHIFT_276, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_284 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_286 = LOGAND(op_RSHIFT_284, SN(32, 0xffff));
	RzILOpPure *op_MUL_289 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_278), DUP(op_AND_278))), CAST(16, MSB(DUP(op_AND_278)), DUP(op_AND_278))), CAST(32, MSB(CAST(16, MSB(op_AND_286), DUP(op_AND_286))), CAST(16, MSB(DUP(op_AND_286)), DUP(op_AND_286))));
	RzILOpPure *op_LSHIFT_292 = SHIFTL0(CAST(64, MSB(op_MUL_289), DUP(op_MUL_289)), SN(32, 1));
	RzILOpPure *op_ADD_293 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_270), DUP(op_AND_270))), CAST(32, MSB(DUP(op_AND_270)), DUP(op_AND_270))), op_LSHIFT_292);
	RzILOpPure *op_RSHIFT_297 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_299 = LOGAND(op_RSHIFT_297, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_305 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_307 = LOGAND(op_RSHIFT_305, SN(32, 0xffff));
	RzILOpPure *op_MUL_310 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_299), DUP(op_AND_299))), CAST(16, MSB(DUP(op_AND_299)), DUP(op_AND_299))), CAST(32, MSB(CAST(16, MSB(op_AND_307), DUP(op_AND_307))), CAST(16, MSB(DUP(op_AND_307)), DUP(op_AND_307))));
	RzILOpPure *op_LSHIFT_313 = SHIFTL0(CAST(64, MSB(op_MUL_310), DUP(op_MUL_310)), SN(32, 1));
	RzILOpPure *op_SUB_314 = SUB(op_ADD_293, op_LSHIFT_313);
	RzILOpPure *op_RSHIFT_323 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_325 = LOGAND(op_RSHIFT_323, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_331 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_333 = LOGAND(op_RSHIFT_331, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_339 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_341 = LOGAND(op_RSHIFT_339, SN(32, 0xffff));
	RzILOpPure *op_MUL_344 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_333), DUP(op_AND_333))), CAST(16, MSB(DUP(op_AND_333)), DUP(op_AND_333))), CAST(32, MSB(CAST(16, MSB(op_AND_341), DUP(op_AND_341))), CAST(16, MSB(DUP(op_AND_341)), DUP(op_AND_341))));
	RzILOpPure *op_LSHIFT_347 = SHIFTL0(CAST(64, MSB(op_MUL_344), DUP(op_MUL_344)), SN(32, 1));
	RzILOpPure *op_ADD_348 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_325), DUP(op_AND_325))), CAST(32, MSB(DUP(op_AND_325)), DUP(op_AND_325))), op_LSHIFT_347);
	RzILOpPure *op_RSHIFT_352 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_354 = LOGAND(op_RSHIFT_352, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_360 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_362 = LOGAND(op_RSHIFT_360, SN(32, 0xffff));
	RzILOpPure *op_MUL_365 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_354), DUP(op_AND_354))), CAST(16, MSB(DUP(op_AND_354)), DUP(op_AND_354))), CAST(32, MSB(CAST(16, MSB(op_AND_362), DUP(op_AND_362))), CAST(16, MSB(DUP(op_AND_362)), DUP(op_AND_362))));
	RzILOpPure *op_LSHIFT_368 = SHIFTL0(CAST(64, MSB(op_MUL_365), DUP(op_MUL_365)), SN(32, 1));
	RzILOpPure *op_SUB_369 = SUB(op_ADD_348, op_LSHIFT_368);
	RzILOpPure *op_EQ_370 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_SUB_314), SN(32, 0), SN(32, 0x20)), op_SUB_369);
	RzILOpPure *op_RSHIFT_427 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_429 = LOGAND(op_RSHIFT_427, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_435 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_437 = LOGAND(op_RSHIFT_435, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_443 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_445 = LOGAND(op_RSHIFT_443, SN(32, 0xffff));
	RzILOpPure *op_MUL_448 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_437), DUP(op_AND_437))), CAST(16, MSB(DUP(op_AND_437)), DUP(op_AND_437))), CAST(32, MSB(CAST(16, MSB(op_AND_445), DUP(op_AND_445))), CAST(16, MSB(DUP(op_AND_445)), DUP(op_AND_445))));
	RzILOpPure *op_LSHIFT_451 = SHIFTL0(CAST(64, MSB(op_MUL_448), DUP(op_MUL_448)), SN(32, 1));
	RzILOpPure *op_ADD_452 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_429), DUP(op_AND_429))), CAST(32, MSB(DUP(op_AND_429)), DUP(op_AND_429))), op_LSHIFT_451);
	RzILOpPure *op_RSHIFT_456 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_458 = LOGAND(op_RSHIFT_456, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_464 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_466 = LOGAND(op_RSHIFT_464, SN(32, 0xffff));
	RzILOpPure *op_MUL_469 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_458), DUP(op_AND_458))), CAST(16, MSB(DUP(op_AND_458)), DUP(op_AND_458))), CAST(32, MSB(CAST(16, MSB(op_AND_466), DUP(op_AND_466))), CAST(16, MSB(DUP(op_AND_466)), DUP(op_AND_466))));
	RzILOpPure *op_LSHIFT_472 = SHIFTL0(CAST(64, MSB(op_MUL_469), DUP(op_MUL_469)), SN(32, 1));
	RzILOpPure *op_SUB_473 = SUB(op_ADD_452, op_LSHIFT_472);
	RzILOpPure *op_LT_476 = SLT(op_SUB_473, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_481 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_482 = NEG(op_LSHIFT_481);
	RzILOpPure *op_LSHIFT_487 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_490 = SUB(op_LSHIFT_487, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_491 = ITE(op_LT_476, op_NEG_482, op_SUB_490);
	RzILOpEffect *gcc_expr_492 = BRANCH(op_EQ_370, EMPTY(), set_usr_field_call_423);

	// h_tmp235 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_494 = SETL("h_tmp235", cond_491);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_495 = SEQN(2, gcc_expr_492, op_ASSIGN_hybrid_tmp_494);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) : h_tmp235) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_259 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_260 = LOGNOT(op_LSHIFT_259);
	RzILOpPure *op_AND_261 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_260);
	RzILOpPure *op_RSHIFT_374 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_376 = LOGAND(op_RSHIFT_374, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_382 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_384 = LOGAND(op_RSHIFT_382, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_390 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_392 = LOGAND(op_RSHIFT_390, SN(32, 0xffff));
	RzILOpPure *op_MUL_395 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_384), DUP(op_AND_384))), CAST(16, MSB(DUP(op_AND_384)), DUP(op_AND_384))), CAST(32, MSB(CAST(16, MSB(op_AND_392), DUP(op_AND_392))), CAST(16, MSB(DUP(op_AND_392)), DUP(op_AND_392))));
	RzILOpPure *op_LSHIFT_398 = SHIFTL0(CAST(64, MSB(op_MUL_395), DUP(op_MUL_395)), SN(32, 1));
	RzILOpPure *op_ADD_399 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_376), DUP(op_AND_376))), CAST(32, MSB(DUP(op_AND_376)), DUP(op_AND_376))), op_LSHIFT_398);
	RzILOpPure *op_RSHIFT_403 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_405 = LOGAND(op_RSHIFT_403, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_411 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_413 = LOGAND(op_RSHIFT_411, SN(32, 0xffff));
	RzILOpPure *op_MUL_416 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_405), DUP(op_AND_405))), CAST(16, MSB(DUP(op_AND_405)), DUP(op_AND_405))), CAST(32, MSB(CAST(16, MSB(op_AND_413), DUP(op_AND_413))), CAST(16, MSB(DUP(op_AND_413)), DUP(op_AND_413))));
	RzILOpPure *op_LSHIFT_419 = SHIFTL0(CAST(64, MSB(op_MUL_416), DUP(op_MUL_416)), SN(32, 1));
	RzILOpPure *op_SUB_420 = SUB(op_ADD_399, op_LSHIFT_419);
	RzILOpPure *cond_496 = ITE(DUP(op_EQ_370), op_SUB_420, VARL("h_tmp235"));
	RzILOpPure *op_AND_498 = LOGAND(cond_496, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_502 = SHIFTL0(op_AND_498, SN(32, 0));
	RzILOpPure *op_OR_503 = LOGOR(op_AND_261, op_LSHIFT_502);
	RzILOpEffect *op_ASSIGN_504 = WRITE_REG(bundle, Rxx_op, op_OR_503);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_505 = SEQN(2, seq_495, op_ASSIGN_504);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_253, seq_505);
	return instruction_sequence;
}

// Rxx += cmpy(Rs,Rt*):sat
RzILOpEffect *hex_il_op_m2_cmacsc_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_171 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_25 = LOGAND(op_RSHIFT_23, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_32 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_34 = LOGAND(op_RSHIFT_32, SN(32, 0xffff));
	RzILOpPure *op_MUL_37 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_25), DUP(op_AND_25))), CAST(16, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(CAST(16, MSB(op_AND_34), DUP(op_AND_34))), CAST(16, MSB(DUP(op_AND_34)), DUP(op_AND_34))));
	RzILOpPure *op_LSHIFT_40 = SHIFTL0(CAST(64, MSB(op_MUL_37), DUP(op_MUL_37)), SN(32, 0));
	RzILOpPure *op_ADD_41 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_LSHIFT_40);
	RzILOpPure *op_RSHIFT_45 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_47 = LOGAND(op_RSHIFT_45, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_53 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_55 = LOGAND(op_RSHIFT_53, SN(32, 0xffff));
	RzILOpPure *op_MUL_58 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_47), DUP(op_AND_47))), CAST(16, MSB(DUP(op_AND_47)), DUP(op_AND_47))), CAST(32, MSB(CAST(16, MSB(op_AND_55), DUP(op_AND_55))), CAST(16, MSB(DUP(op_AND_55)), DUP(op_AND_55))));
	RzILOpPure *op_LSHIFT_61 = SHIFTL0(CAST(64, MSB(op_MUL_58), DUP(op_MUL_58)), SN(32, 0));
	RzILOpPure *op_SUB_62 = SUB(op_ADD_41, op_LSHIFT_61);
	RzILOpPure *op_RSHIFT_71 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_73 = LOGAND(op_RSHIFT_71, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_79 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_81 = LOGAND(op_RSHIFT_79, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_87 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_89 = LOGAND(op_RSHIFT_87, SN(32, 0xffff));
	RzILOpPure *op_MUL_92 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_81), DUP(op_AND_81))), CAST(16, MSB(DUP(op_AND_81)), DUP(op_AND_81))), CAST(32, MSB(CAST(16, MSB(op_AND_89), DUP(op_AND_89))), CAST(16, MSB(DUP(op_AND_89)), DUP(op_AND_89))));
	RzILOpPure *op_LSHIFT_95 = SHIFTL0(CAST(64, MSB(op_MUL_92), DUP(op_MUL_92)), SN(32, 0));
	RzILOpPure *op_ADD_96 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_73), DUP(op_AND_73))), CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73))), op_LSHIFT_95);
	RzILOpPure *op_RSHIFT_100 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_102 = LOGAND(op_RSHIFT_100, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_108 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_110 = LOGAND(op_RSHIFT_108, SN(32, 0xffff));
	RzILOpPure *op_MUL_113 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_102), DUP(op_AND_102))), CAST(16, MSB(DUP(op_AND_102)), DUP(op_AND_102))), CAST(32, MSB(CAST(16, MSB(op_AND_110), DUP(op_AND_110))), CAST(16, MSB(DUP(op_AND_110)), DUP(op_AND_110))));
	RzILOpPure *op_LSHIFT_116 = SHIFTL0(CAST(64, MSB(op_MUL_113), DUP(op_MUL_113)), SN(32, 0));
	RzILOpPure *op_SUB_117 = SUB(op_ADD_96, op_LSHIFT_116);
	RzILOpPure *op_EQ_118 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_SUB_62), SN(32, 0), SN(32, 0x20)), op_SUB_117);
	RzILOpPure *op_RSHIFT_175 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_177 = LOGAND(op_RSHIFT_175, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_183 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_185 = LOGAND(op_RSHIFT_183, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_191 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_193 = LOGAND(op_RSHIFT_191, SN(32, 0xffff));
	RzILOpPure *op_MUL_196 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_185), DUP(op_AND_185))), CAST(16, MSB(DUP(op_AND_185)), DUP(op_AND_185))), CAST(32, MSB(CAST(16, MSB(op_AND_193), DUP(op_AND_193))), CAST(16, MSB(DUP(op_AND_193)), DUP(op_AND_193))));
	RzILOpPure *op_LSHIFT_199 = SHIFTL0(CAST(64, MSB(op_MUL_196), DUP(op_MUL_196)), SN(32, 0));
	RzILOpPure *op_ADD_200 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_177), DUP(op_AND_177))), CAST(32, MSB(DUP(op_AND_177)), DUP(op_AND_177))), op_LSHIFT_199);
	RzILOpPure *op_RSHIFT_204 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_206 = LOGAND(op_RSHIFT_204, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_212 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_214 = LOGAND(op_RSHIFT_212, SN(32, 0xffff));
	RzILOpPure *op_MUL_217 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_206), DUP(op_AND_206))), CAST(16, MSB(DUP(op_AND_206)), DUP(op_AND_206))), CAST(32, MSB(CAST(16, MSB(op_AND_214), DUP(op_AND_214))), CAST(16, MSB(DUP(op_AND_214)), DUP(op_AND_214))));
	RzILOpPure *op_LSHIFT_220 = SHIFTL0(CAST(64, MSB(op_MUL_217), DUP(op_MUL_217)), SN(32, 0));
	RzILOpPure *op_SUB_221 = SUB(op_ADD_200, op_LSHIFT_220);
	RzILOpPure *op_LT_224 = SLT(op_SUB_221, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_229 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_230 = NEG(op_LSHIFT_229);
	RzILOpPure *op_LSHIFT_235 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_238 = SUB(op_LSHIFT_235, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_239 = ITE(op_LT_224, op_NEG_230, op_SUB_238);
	RzILOpEffect *gcc_expr_240 = BRANCH(op_EQ_118, EMPTY(), set_usr_field_call_171);

	// h_tmp236 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_242 = SETL("h_tmp236", cond_239);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_243 = SEQN(2, gcc_expr_240, op_ASSIGN_hybrid_tmp_242);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) : h_tmp236) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_122 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_124 = LOGAND(op_RSHIFT_122, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_130 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_132 = LOGAND(op_RSHIFT_130, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_138 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_140 = LOGAND(op_RSHIFT_138, SN(32, 0xffff));
	RzILOpPure *op_MUL_143 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_132), DUP(op_AND_132))), CAST(16, MSB(DUP(op_AND_132)), DUP(op_AND_132))), CAST(32, MSB(CAST(16, MSB(op_AND_140), DUP(op_AND_140))), CAST(16, MSB(DUP(op_AND_140)), DUP(op_AND_140))));
	RzILOpPure *op_LSHIFT_146 = SHIFTL0(CAST(64, MSB(op_MUL_143), DUP(op_MUL_143)), SN(32, 0));
	RzILOpPure *op_ADD_147 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_124), DUP(op_AND_124))), CAST(32, MSB(DUP(op_AND_124)), DUP(op_AND_124))), op_LSHIFT_146);
	RzILOpPure *op_RSHIFT_151 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_153 = LOGAND(op_RSHIFT_151, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_159 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_161 = LOGAND(op_RSHIFT_159, SN(32, 0xffff));
	RzILOpPure *op_MUL_164 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_153), DUP(op_AND_153))), CAST(16, MSB(DUP(op_AND_153)), DUP(op_AND_153))), CAST(32, MSB(CAST(16, MSB(op_AND_161), DUP(op_AND_161))), CAST(16, MSB(DUP(op_AND_161)), DUP(op_AND_161))));
	RzILOpPure *op_LSHIFT_167 = SHIFTL0(CAST(64, MSB(op_MUL_164), DUP(op_MUL_164)), SN(32, 0));
	RzILOpPure *op_SUB_168 = SUB(op_ADD_147, op_LSHIFT_167);
	RzILOpPure *cond_244 = ITE(DUP(op_EQ_118), op_SUB_168, VARL("h_tmp236"));
	RzILOpPure *op_AND_246 = LOGAND(cond_244, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_250 = SHIFTL0(op_AND_246, SN(32, 0x20));
	RzILOpPure *op_OR_251 = LOGOR(op_AND_7, op_LSHIFT_250);
	RzILOpEffect *op_ASSIGN_252 = WRITE_REG(bundle, Rxx_op, op_OR_251);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_253 = SEQN(2, seq_243, op_ASSIGN_252);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_423 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_268 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_270 = LOGAND(op_RSHIFT_268, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_276 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_278 = LOGAND(op_RSHIFT_276, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_284 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_286 = LOGAND(op_RSHIFT_284, SN(32, 0xffff));
	RzILOpPure *op_MUL_289 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_278), DUP(op_AND_278))), CAST(16, MSB(DUP(op_AND_278)), DUP(op_AND_278))), CAST(32, MSB(CAST(16, MSB(op_AND_286), DUP(op_AND_286))), CAST(16, MSB(DUP(op_AND_286)), DUP(op_AND_286))));
	RzILOpPure *op_LSHIFT_292 = SHIFTL0(CAST(64, MSB(op_MUL_289), DUP(op_MUL_289)), SN(32, 0));
	RzILOpPure *op_ADD_293 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_270), DUP(op_AND_270))), CAST(32, MSB(DUP(op_AND_270)), DUP(op_AND_270))), op_LSHIFT_292);
	RzILOpPure *op_RSHIFT_297 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_299 = LOGAND(op_RSHIFT_297, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_305 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_307 = LOGAND(op_RSHIFT_305, SN(32, 0xffff));
	RzILOpPure *op_MUL_310 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_299), DUP(op_AND_299))), CAST(16, MSB(DUP(op_AND_299)), DUP(op_AND_299))), CAST(32, MSB(CAST(16, MSB(op_AND_307), DUP(op_AND_307))), CAST(16, MSB(DUP(op_AND_307)), DUP(op_AND_307))));
	RzILOpPure *op_LSHIFT_313 = SHIFTL0(CAST(64, MSB(op_MUL_310), DUP(op_MUL_310)), SN(32, 0));
	RzILOpPure *op_ADD_314 = ADD(op_ADD_293, op_LSHIFT_313);
	RzILOpPure *op_RSHIFT_323 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_325 = LOGAND(op_RSHIFT_323, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_331 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_333 = LOGAND(op_RSHIFT_331, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_339 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_341 = LOGAND(op_RSHIFT_339, SN(32, 0xffff));
	RzILOpPure *op_MUL_344 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_333), DUP(op_AND_333))), CAST(16, MSB(DUP(op_AND_333)), DUP(op_AND_333))), CAST(32, MSB(CAST(16, MSB(op_AND_341), DUP(op_AND_341))), CAST(16, MSB(DUP(op_AND_341)), DUP(op_AND_341))));
	RzILOpPure *op_LSHIFT_347 = SHIFTL0(CAST(64, MSB(op_MUL_344), DUP(op_MUL_344)), SN(32, 0));
	RzILOpPure *op_ADD_348 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_325), DUP(op_AND_325))), CAST(32, MSB(DUP(op_AND_325)), DUP(op_AND_325))), op_LSHIFT_347);
	RzILOpPure *op_RSHIFT_352 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_354 = LOGAND(op_RSHIFT_352, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_360 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_362 = LOGAND(op_RSHIFT_360, SN(32, 0xffff));
	RzILOpPure *op_MUL_365 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_354), DUP(op_AND_354))), CAST(16, MSB(DUP(op_AND_354)), DUP(op_AND_354))), CAST(32, MSB(CAST(16, MSB(op_AND_362), DUP(op_AND_362))), CAST(16, MSB(DUP(op_AND_362)), DUP(op_AND_362))));
	RzILOpPure *op_LSHIFT_368 = SHIFTL0(CAST(64, MSB(op_MUL_365), DUP(op_MUL_365)), SN(32, 0));
	RzILOpPure *op_ADD_369 = ADD(op_ADD_348, op_LSHIFT_368);
	RzILOpPure *op_EQ_370 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_314), SN(32, 0), SN(32, 0x20)), op_ADD_369);
	RzILOpPure *op_RSHIFT_427 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_429 = LOGAND(op_RSHIFT_427, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_435 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_437 = LOGAND(op_RSHIFT_435, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_443 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_445 = LOGAND(op_RSHIFT_443, SN(32, 0xffff));
	RzILOpPure *op_MUL_448 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_437), DUP(op_AND_437))), CAST(16, MSB(DUP(op_AND_437)), DUP(op_AND_437))), CAST(32, MSB(CAST(16, MSB(op_AND_445), DUP(op_AND_445))), CAST(16, MSB(DUP(op_AND_445)), DUP(op_AND_445))));
	RzILOpPure *op_LSHIFT_451 = SHIFTL0(CAST(64, MSB(op_MUL_448), DUP(op_MUL_448)), SN(32, 0));
	RzILOpPure *op_ADD_452 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_429), DUP(op_AND_429))), CAST(32, MSB(DUP(op_AND_429)), DUP(op_AND_429))), op_LSHIFT_451);
	RzILOpPure *op_RSHIFT_456 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_458 = LOGAND(op_RSHIFT_456, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_464 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_466 = LOGAND(op_RSHIFT_464, SN(32, 0xffff));
	RzILOpPure *op_MUL_469 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_458), DUP(op_AND_458))), CAST(16, MSB(DUP(op_AND_458)), DUP(op_AND_458))), CAST(32, MSB(CAST(16, MSB(op_AND_466), DUP(op_AND_466))), CAST(16, MSB(DUP(op_AND_466)), DUP(op_AND_466))));
	RzILOpPure *op_LSHIFT_472 = SHIFTL0(CAST(64, MSB(op_MUL_469), DUP(op_MUL_469)), SN(32, 0));
	RzILOpPure *op_ADD_473 = ADD(op_ADD_452, op_LSHIFT_472);
	RzILOpPure *op_LT_476 = SLT(op_ADD_473, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_481 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_482 = NEG(op_LSHIFT_481);
	RzILOpPure *op_LSHIFT_487 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_490 = SUB(op_LSHIFT_487, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_491 = ITE(op_LT_476, op_NEG_482, op_SUB_490);
	RzILOpEffect *gcc_expr_492 = BRANCH(op_EQ_370, EMPTY(), set_usr_field_call_423);

	// h_tmp237 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_494 = SETL("h_tmp237", cond_491);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_495 = SEQN(2, gcc_expr_492, op_ASSIGN_hybrid_tmp_494);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) : h_tmp237) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_259 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_260 = LOGNOT(op_LSHIFT_259);
	RzILOpPure *op_AND_261 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_260);
	RzILOpPure *op_RSHIFT_374 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_376 = LOGAND(op_RSHIFT_374, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_382 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_384 = LOGAND(op_RSHIFT_382, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_390 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_392 = LOGAND(op_RSHIFT_390, SN(32, 0xffff));
	RzILOpPure *op_MUL_395 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_384), DUP(op_AND_384))), CAST(16, MSB(DUP(op_AND_384)), DUP(op_AND_384))), CAST(32, MSB(CAST(16, MSB(op_AND_392), DUP(op_AND_392))), CAST(16, MSB(DUP(op_AND_392)), DUP(op_AND_392))));
	RzILOpPure *op_LSHIFT_398 = SHIFTL0(CAST(64, MSB(op_MUL_395), DUP(op_MUL_395)), SN(32, 0));
	RzILOpPure *op_ADD_399 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_376), DUP(op_AND_376))), CAST(32, MSB(DUP(op_AND_376)), DUP(op_AND_376))), op_LSHIFT_398);
	RzILOpPure *op_RSHIFT_403 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_405 = LOGAND(op_RSHIFT_403, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_411 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_413 = LOGAND(op_RSHIFT_411, SN(32, 0xffff));
	RzILOpPure *op_MUL_416 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_405), DUP(op_AND_405))), CAST(16, MSB(DUP(op_AND_405)), DUP(op_AND_405))), CAST(32, MSB(CAST(16, MSB(op_AND_413), DUP(op_AND_413))), CAST(16, MSB(DUP(op_AND_413)), DUP(op_AND_413))));
	RzILOpPure *op_LSHIFT_419 = SHIFTL0(CAST(64, MSB(op_MUL_416), DUP(op_MUL_416)), SN(32, 0));
	RzILOpPure *op_ADD_420 = ADD(op_ADD_399, op_LSHIFT_419);
	RzILOpPure *cond_496 = ITE(DUP(op_EQ_370), op_ADD_420, VARL("h_tmp237"));
	RzILOpPure *op_AND_498 = LOGAND(cond_496, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_502 = SHIFTL0(op_AND_498, SN(32, 0));
	RzILOpPure *op_OR_503 = LOGOR(op_AND_261, op_LSHIFT_502);
	RzILOpEffect *op_ASSIGN_504 = WRITE_REG(bundle, Rxx_op, op_OR_503);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_505 = SEQN(2, seq_495, op_ASSIGN_504);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_253, seq_505);
	return instruction_sequence;
}

// Rxx += cmpy(Rs,Rt*):<<1:sat
RzILOpEffect *hex_il_op_m2_cmacsc_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_171 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_25 = LOGAND(op_RSHIFT_23, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_32 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_34 = LOGAND(op_RSHIFT_32, SN(32, 0xffff));
	RzILOpPure *op_MUL_37 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_25), DUP(op_AND_25))), CAST(16, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(CAST(16, MSB(op_AND_34), DUP(op_AND_34))), CAST(16, MSB(DUP(op_AND_34)), DUP(op_AND_34))));
	RzILOpPure *op_LSHIFT_40 = SHIFTL0(CAST(64, MSB(op_MUL_37), DUP(op_MUL_37)), SN(32, 1));
	RzILOpPure *op_ADD_41 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_LSHIFT_40);
	RzILOpPure *op_RSHIFT_45 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_47 = LOGAND(op_RSHIFT_45, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_53 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_55 = LOGAND(op_RSHIFT_53, SN(32, 0xffff));
	RzILOpPure *op_MUL_58 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_47), DUP(op_AND_47))), CAST(16, MSB(DUP(op_AND_47)), DUP(op_AND_47))), CAST(32, MSB(CAST(16, MSB(op_AND_55), DUP(op_AND_55))), CAST(16, MSB(DUP(op_AND_55)), DUP(op_AND_55))));
	RzILOpPure *op_LSHIFT_61 = SHIFTL0(CAST(64, MSB(op_MUL_58), DUP(op_MUL_58)), SN(32, 1));
	RzILOpPure *op_SUB_62 = SUB(op_ADD_41, op_LSHIFT_61);
	RzILOpPure *op_RSHIFT_71 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_73 = LOGAND(op_RSHIFT_71, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_79 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_81 = LOGAND(op_RSHIFT_79, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_87 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_89 = LOGAND(op_RSHIFT_87, SN(32, 0xffff));
	RzILOpPure *op_MUL_92 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_81), DUP(op_AND_81))), CAST(16, MSB(DUP(op_AND_81)), DUP(op_AND_81))), CAST(32, MSB(CAST(16, MSB(op_AND_89), DUP(op_AND_89))), CAST(16, MSB(DUP(op_AND_89)), DUP(op_AND_89))));
	RzILOpPure *op_LSHIFT_95 = SHIFTL0(CAST(64, MSB(op_MUL_92), DUP(op_MUL_92)), SN(32, 1));
	RzILOpPure *op_ADD_96 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_73), DUP(op_AND_73))), CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73))), op_LSHIFT_95);
	RzILOpPure *op_RSHIFT_100 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_102 = LOGAND(op_RSHIFT_100, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_108 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_110 = LOGAND(op_RSHIFT_108, SN(32, 0xffff));
	RzILOpPure *op_MUL_113 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_102), DUP(op_AND_102))), CAST(16, MSB(DUP(op_AND_102)), DUP(op_AND_102))), CAST(32, MSB(CAST(16, MSB(op_AND_110), DUP(op_AND_110))), CAST(16, MSB(DUP(op_AND_110)), DUP(op_AND_110))));
	RzILOpPure *op_LSHIFT_116 = SHIFTL0(CAST(64, MSB(op_MUL_113), DUP(op_MUL_113)), SN(32, 1));
	RzILOpPure *op_SUB_117 = SUB(op_ADD_96, op_LSHIFT_116);
	RzILOpPure *op_EQ_118 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_SUB_62), SN(32, 0), SN(32, 0x20)), op_SUB_117);
	RzILOpPure *op_RSHIFT_175 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_177 = LOGAND(op_RSHIFT_175, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_183 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_185 = LOGAND(op_RSHIFT_183, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_191 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_193 = LOGAND(op_RSHIFT_191, SN(32, 0xffff));
	RzILOpPure *op_MUL_196 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_185), DUP(op_AND_185))), CAST(16, MSB(DUP(op_AND_185)), DUP(op_AND_185))), CAST(32, MSB(CAST(16, MSB(op_AND_193), DUP(op_AND_193))), CAST(16, MSB(DUP(op_AND_193)), DUP(op_AND_193))));
	RzILOpPure *op_LSHIFT_199 = SHIFTL0(CAST(64, MSB(op_MUL_196), DUP(op_MUL_196)), SN(32, 1));
	RzILOpPure *op_ADD_200 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_177), DUP(op_AND_177))), CAST(32, MSB(DUP(op_AND_177)), DUP(op_AND_177))), op_LSHIFT_199);
	RzILOpPure *op_RSHIFT_204 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_206 = LOGAND(op_RSHIFT_204, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_212 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_214 = LOGAND(op_RSHIFT_212, SN(32, 0xffff));
	RzILOpPure *op_MUL_217 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_206), DUP(op_AND_206))), CAST(16, MSB(DUP(op_AND_206)), DUP(op_AND_206))), CAST(32, MSB(CAST(16, MSB(op_AND_214), DUP(op_AND_214))), CAST(16, MSB(DUP(op_AND_214)), DUP(op_AND_214))));
	RzILOpPure *op_LSHIFT_220 = SHIFTL0(CAST(64, MSB(op_MUL_217), DUP(op_MUL_217)), SN(32, 1));
	RzILOpPure *op_SUB_221 = SUB(op_ADD_200, op_LSHIFT_220);
	RzILOpPure *op_LT_224 = SLT(op_SUB_221, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_229 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_230 = NEG(op_LSHIFT_229);
	RzILOpPure *op_LSHIFT_235 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_238 = SUB(op_LSHIFT_235, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_239 = ITE(op_LT_224, op_NEG_230, op_SUB_238);
	RzILOpEffect *gcc_expr_240 = BRANCH(op_EQ_118, EMPTY(), set_usr_field_call_171);

	// h_tmp238 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_242 = SETL("h_tmp238", cond_239);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_243 = SEQN(2, gcc_expr_240, op_ASSIGN_hybrid_tmp_242);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) : h_tmp238) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_122 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_124 = LOGAND(op_RSHIFT_122, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_130 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_132 = LOGAND(op_RSHIFT_130, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_138 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_140 = LOGAND(op_RSHIFT_138, SN(32, 0xffff));
	RzILOpPure *op_MUL_143 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_132), DUP(op_AND_132))), CAST(16, MSB(DUP(op_AND_132)), DUP(op_AND_132))), CAST(32, MSB(CAST(16, MSB(op_AND_140), DUP(op_AND_140))), CAST(16, MSB(DUP(op_AND_140)), DUP(op_AND_140))));
	RzILOpPure *op_LSHIFT_146 = SHIFTL0(CAST(64, MSB(op_MUL_143), DUP(op_MUL_143)), SN(32, 1));
	RzILOpPure *op_ADD_147 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_124), DUP(op_AND_124))), CAST(32, MSB(DUP(op_AND_124)), DUP(op_AND_124))), op_LSHIFT_146);
	RzILOpPure *op_RSHIFT_151 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_153 = LOGAND(op_RSHIFT_151, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_159 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_161 = LOGAND(op_RSHIFT_159, SN(32, 0xffff));
	RzILOpPure *op_MUL_164 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_153), DUP(op_AND_153))), CAST(16, MSB(DUP(op_AND_153)), DUP(op_AND_153))), CAST(32, MSB(CAST(16, MSB(op_AND_161), DUP(op_AND_161))), CAST(16, MSB(DUP(op_AND_161)), DUP(op_AND_161))));
	RzILOpPure *op_LSHIFT_167 = SHIFTL0(CAST(64, MSB(op_MUL_164), DUP(op_MUL_164)), SN(32, 1));
	RzILOpPure *op_SUB_168 = SUB(op_ADD_147, op_LSHIFT_167);
	RzILOpPure *cond_244 = ITE(DUP(op_EQ_118), op_SUB_168, VARL("h_tmp238"));
	RzILOpPure *op_AND_246 = LOGAND(cond_244, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_250 = SHIFTL0(op_AND_246, SN(32, 0x20));
	RzILOpPure *op_OR_251 = LOGOR(op_AND_7, op_LSHIFT_250);
	RzILOpEffect *op_ASSIGN_252 = WRITE_REG(bundle, Rxx_op, op_OR_251);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_253 = SEQN(2, seq_243, op_ASSIGN_252);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_423 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_268 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_270 = LOGAND(op_RSHIFT_268, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_276 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_278 = LOGAND(op_RSHIFT_276, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_284 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_286 = LOGAND(op_RSHIFT_284, SN(32, 0xffff));
	RzILOpPure *op_MUL_289 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_278), DUP(op_AND_278))), CAST(16, MSB(DUP(op_AND_278)), DUP(op_AND_278))), CAST(32, MSB(CAST(16, MSB(op_AND_286), DUP(op_AND_286))), CAST(16, MSB(DUP(op_AND_286)), DUP(op_AND_286))));
	RzILOpPure *op_LSHIFT_292 = SHIFTL0(CAST(64, MSB(op_MUL_289), DUP(op_MUL_289)), SN(32, 1));
	RzILOpPure *op_ADD_293 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_270), DUP(op_AND_270))), CAST(32, MSB(DUP(op_AND_270)), DUP(op_AND_270))), op_LSHIFT_292);
	RzILOpPure *op_RSHIFT_297 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_299 = LOGAND(op_RSHIFT_297, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_305 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_307 = LOGAND(op_RSHIFT_305, SN(32, 0xffff));
	RzILOpPure *op_MUL_310 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_299), DUP(op_AND_299))), CAST(16, MSB(DUP(op_AND_299)), DUP(op_AND_299))), CAST(32, MSB(CAST(16, MSB(op_AND_307), DUP(op_AND_307))), CAST(16, MSB(DUP(op_AND_307)), DUP(op_AND_307))));
	RzILOpPure *op_LSHIFT_313 = SHIFTL0(CAST(64, MSB(op_MUL_310), DUP(op_MUL_310)), SN(32, 1));
	RzILOpPure *op_ADD_314 = ADD(op_ADD_293, op_LSHIFT_313);
	RzILOpPure *op_RSHIFT_323 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_325 = LOGAND(op_RSHIFT_323, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_331 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_333 = LOGAND(op_RSHIFT_331, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_339 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_341 = LOGAND(op_RSHIFT_339, SN(32, 0xffff));
	RzILOpPure *op_MUL_344 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_333), DUP(op_AND_333))), CAST(16, MSB(DUP(op_AND_333)), DUP(op_AND_333))), CAST(32, MSB(CAST(16, MSB(op_AND_341), DUP(op_AND_341))), CAST(16, MSB(DUP(op_AND_341)), DUP(op_AND_341))));
	RzILOpPure *op_LSHIFT_347 = SHIFTL0(CAST(64, MSB(op_MUL_344), DUP(op_MUL_344)), SN(32, 1));
	RzILOpPure *op_ADD_348 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_325), DUP(op_AND_325))), CAST(32, MSB(DUP(op_AND_325)), DUP(op_AND_325))), op_LSHIFT_347);
	RzILOpPure *op_RSHIFT_352 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_354 = LOGAND(op_RSHIFT_352, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_360 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_362 = LOGAND(op_RSHIFT_360, SN(32, 0xffff));
	RzILOpPure *op_MUL_365 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_354), DUP(op_AND_354))), CAST(16, MSB(DUP(op_AND_354)), DUP(op_AND_354))), CAST(32, MSB(CAST(16, MSB(op_AND_362), DUP(op_AND_362))), CAST(16, MSB(DUP(op_AND_362)), DUP(op_AND_362))));
	RzILOpPure *op_LSHIFT_368 = SHIFTL0(CAST(64, MSB(op_MUL_365), DUP(op_MUL_365)), SN(32, 1));
	RzILOpPure *op_ADD_369 = ADD(op_ADD_348, op_LSHIFT_368);
	RzILOpPure *op_EQ_370 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_314), SN(32, 0), SN(32, 0x20)), op_ADD_369);
	RzILOpPure *op_RSHIFT_427 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_429 = LOGAND(op_RSHIFT_427, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_435 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_437 = LOGAND(op_RSHIFT_435, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_443 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_445 = LOGAND(op_RSHIFT_443, SN(32, 0xffff));
	RzILOpPure *op_MUL_448 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_437), DUP(op_AND_437))), CAST(16, MSB(DUP(op_AND_437)), DUP(op_AND_437))), CAST(32, MSB(CAST(16, MSB(op_AND_445), DUP(op_AND_445))), CAST(16, MSB(DUP(op_AND_445)), DUP(op_AND_445))));
	RzILOpPure *op_LSHIFT_451 = SHIFTL0(CAST(64, MSB(op_MUL_448), DUP(op_MUL_448)), SN(32, 1));
	RzILOpPure *op_ADD_452 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_429), DUP(op_AND_429))), CAST(32, MSB(DUP(op_AND_429)), DUP(op_AND_429))), op_LSHIFT_451);
	RzILOpPure *op_RSHIFT_456 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_458 = LOGAND(op_RSHIFT_456, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_464 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_466 = LOGAND(op_RSHIFT_464, SN(32, 0xffff));
	RzILOpPure *op_MUL_469 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_458), DUP(op_AND_458))), CAST(16, MSB(DUP(op_AND_458)), DUP(op_AND_458))), CAST(32, MSB(CAST(16, MSB(op_AND_466), DUP(op_AND_466))), CAST(16, MSB(DUP(op_AND_466)), DUP(op_AND_466))));
	RzILOpPure *op_LSHIFT_472 = SHIFTL0(CAST(64, MSB(op_MUL_469), DUP(op_MUL_469)), SN(32, 1));
	RzILOpPure *op_ADD_473 = ADD(op_ADD_452, op_LSHIFT_472);
	RzILOpPure *op_LT_476 = SLT(op_ADD_473, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_481 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_482 = NEG(op_LSHIFT_481);
	RzILOpPure *op_LSHIFT_487 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_490 = SUB(op_LSHIFT_487, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_491 = ITE(op_LT_476, op_NEG_482, op_SUB_490);
	RzILOpEffect *gcc_expr_492 = BRANCH(op_EQ_370, EMPTY(), set_usr_field_call_423);

	// h_tmp239 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_494 = SETL("h_tmp239", cond_491);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_495 = SEQN(2, gcc_expr_492, op_ASSIGN_hybrid_tmp_494);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) : h_tmp239) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_259 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_260 = LOGNOT(op_LSHIFT_259);
	RzILOpPure *op_AND_261 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_260);
	RzILOpPure *op_RSHIFT_374 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_376 = LOGAND(op_RSHIFT_374, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_382 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_384 = LOGAND(op_RSHIFT_382, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_390 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_392 = LOGAND(op_RSHIFT_390, SN(32, 0xffff));
	RzILOpPure *op_MUL_395 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_384), DUP(op_AND_384))), CAST(16, MSB(DUP(op_AND_384)), DUP(op_AND_384))), CAST(32, MSB(CAST(16, MSB(op_AND_392), DUP(op_AND_392))), CAST(16, MSB(DUP(op_AND_392)), DUP(op_AND_392))));
	RzILOpPure *op_LSHIFT_398 = SHIFTL0(CAST(64, MSB(op_MUL_395), DUP(op_MUL_395)), SN(32, 1));
	RzILOpPure *op_ADD_399 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_376), DUP(op_AND_376))), CAST(32, MSB(DUP(op_AND_376)), DUP(op_AND_376))), op_LSHIFT_398);
	RzILOpPure *op_RSHIFT_403 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_405 = LOGAND(op_RSHIFT_403, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_411 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_413 = LOGAND(op_RSHIFT_411, SN(32, 0xffff));
	RzILOpPure *op_MUL_416 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_405), DUP(op_AND_405))), CAST(16, MSB(DUP(op_AND_405)), DUP(op_AND_405))), CAST(32, MSB(CAST(16, MSB(op_AND_413), DUP(op_AND_413))), CAST(16, MSB(DUP(op_AND_413)), DUP(op_AND_413))));
	RzILOpPure *op_LSHIFT_419 = SHIFTL0(CAST(64, MSB(op_MUL_416), DUP(op_MUL_416)), SN(32, 1));
	RzILOpPure *op_ADD_420 = ADD(op_ADD_399, op_LSHIFT_419);
	RzILOpPure *cond_496 = ITE(DUP(op_EQ_370), op_ADD_420, VARL("h_tmp239"));
	RzILOpPure *op_AND_498 = LOGAND(cond_496, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_502 = SHIFTL0(op_AND_498, SN(32, 0));
	RzILOpPure *op_OR_503 = LOGOR(op_AND_261, op_LSHIFT_502);
	RzILOpEffect *op_ASSIGN_504 = WRITE_REG(bundle, Rxx_op, op_OR_503);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_505 = SEQN(2, seq_495, op_ASSIGN_504);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_253, seq_505);
	return instruction_sequence;
}

// Rdd = cmpyi(Rs,Rt)
RzILOpEffect *hex_il_op_m2_cmpyi_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rdd = ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) + ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_RSHIFT_24 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_26 = LOGAND(op_RSHIFT_24, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_32 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_34 = LOGAND(op_RSHIFT_32, SN(32, 0xffff));
	RzILOpPure *op_MUL_37 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_26), DUP(op_AND_26))), CAST(16, MSB(DUP(op_AND_26)), DUP(op_AND_26))), CAST(32, MSB(CAST(16, MSB(op_AND_34), DUP(op_AND_34))), CAST(16, MSB(DUP(op_AND_34)), DUP(op_AND_34))));
	RzILOpPure *op_ADD_39 = ADD(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), CAST(64, MSB(op_MUL_37), DUP(op_MUL_37)));
	RzILOpEffect *op_ASSIGN_40 = WRITE_REG(bundle, Rdd_op, op_ADD_39);

	RzILOpEffect *instruction_sequence = op_ASSIGN_40;
	return instruction_sequence;
}

// Rdd = cmpyr(Rs,Rt)
RzILOpEffect *hex_il_op_m2_cmpyr_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rdd = ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) - ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_RSHIFT_24 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_26 = LOGAND(op_RSHIFT_24, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_32 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_34 = LOGAND(op_RSHIFT_32, SN(32, 0xffff));
	RzILOpPure *op_MUL_37 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_26), DUP(op_AND_26))), CAST(16, MSB(DUP(op_AND_26)), DUP(op_AND_26))), CAST(32, MSB(CAST(16, MSB(op_AND_34), DUP(op_AND_34))), CAST(16, MSB(DUP(op_AND_34)), DUP(op_AND_34))));
	RzILOpPure *op_SUB_39 = SUB(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), CAST(64, MSB(op_MUL_37), DUP(op_MUL_37)));
	RzILOpEffect *op_ASSIGN_40 = WRITE_REG(bundle, Rdd_op, op_SUB_39);

	RzILOpEffect *instruction_sequence = op_ASSIGN_40;
	return instruction_sequence;
}

// Rd = cmpy(Rs,Rt):rnd:sat
RzILOpEffect *hex_il_op_m2_cmpyrs_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_154 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_16 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_18 = LOGAND(op_RSHIFT_16, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_25 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_27 = LOGAND(op_RSHIFT_25, SN(32, 0xffff));
	RzILOpPure *op_MUL_30 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_18), DUP(op_AND_18))), CAST(16, MSB(DUP(op_AND_18)), DUP(op_AND_18))), CAST(32, MSB(CAST(16, MSB(op_AND_27), DUP(op_AND_27))), CAST(16, MSB(DUP(op_AND_27)), DUP(op_AND_27))));
	RzILOpPure *op_LSHIFT_33 = SHIFTL0(CAST(64, MSB(op_MUL_30), DUP(op_MUL_30)), SN(32, 0));
	RzILOpPure *op_RSHIFT_37 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_39 = LOGAND(op_RSHIFT_37, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_45 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_47 = LOGAND(op_RSHIFT_45, SN(32, 0xffff));
	RzILOpPure *op_MUL_50 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_39), DUP(op_AND_39))), CAST(16, MSB(DUP(op_AND_39)), DUP(op_AND_39))), CAST(32, MSB(CAST(16, MSB(op_AND_47), DUP(op_AND_47))), CAST(16, MSB(DUP(op_AND_47)), DUP(op_AND_47))));
	RzILOpPure *op_LSHIFT_53 = SHIFTL0(CAST(64, MSB(op_MUL_50), DUP(op_MUL_50)), SN(32, 0));
	RzILOpPure *op_ADD_54 = ADD(op_LSHIFT_33, op_LSHIFT_53);
	RzILOpPure *op_ADD_57 = ADD(op_ADD_54, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_66 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_68 = LOGAND(op_RSHIFT_66, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_74 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_76 = LOGAND(op_RSHIFT_74, SN(32, 0xffff));
	RzILOpPure *op_MUL_79 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_68), DUP(op_AND_68))), CAST(16, MSB(DUP(op_AND_68)), DUP(op_AND_68))), CAST(32, MSB(CAST(16, MSB(op_AND_76), DUP(op_AND_76))), CAST(16, MSB(DUP(op_AND_76)), DUP(op_AND_76))));
	RzILOpPure *op_LSHIFT_82 = SHIFTL0(CAST(64, MSB(op_MUL_79), DUP(op_MUL_79)), SN(32, 0));
	RzILOpPure *op_RSHIFT_86 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_88 = LOGAND(op_RSHIFT_86, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_94 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_96 = LOGAND(op_RSHIFT_94, SN(32, 0xffff));
	RzILOpPure *op_MUL_99 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_88), DUP(op_AND_88))), CAST(16, MSB(DUP(op_AND_88)), DUP(op_AND_88))), CAST(32, MSB(CAST(16, MSB(op_AND_96), DUP(op_AND_96))), CAST(16, MSB(DUP(op_AND_96)), DUP(op_AND_96))));
	RzILOpPure *op_LSHIFT_102 = SHIFTL0(CAST(64, MSB(op_MUL_99), DUP(op_MUL_99)), SN(32, 0));
	RzILOpPure *op_ADD_103 = ADD(op_LSHIFT_82, op_LSHIFT_102);
	RzILOpPure *op_ADD_106 = ADD(op_ADD_103, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_EQ_107 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_57), SN(32, 0), SN(32, 0x20)), op_ADD_106);
	RzILOpPure *op_RSHIFT_158 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_160 = LOGAND(op_RSHIFT_158, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_166 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_168 = LOGAND(op_RSHIFT_166, SN(32, 0xffff));
	RzILOpPure *op_MUL_171 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_160), DUP(op_AND_160))), CAST(16, MSB(DUP(op_AND_160)), DUP(op_AND_160))), CAST(32, MSB(CAST(16, MSB(op_AND_168), DUP(op_AND_168))), CAST(16, MSB(DUP(op_AND_168)), DUP(op_AND_168))));
	RzILOpPure *op_LSHIFT_174 = SHIFTL0(CAST(64, MSB(op_MUL_171), DUP(op_MUL_171)), SN(32, 0));
	RzILOpPure *op_RSHIFT_178 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_180 = LOGAND(op_RSHIFT_178, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_186 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_188 = LOGAND(op_RSHIFT_186, SN(32, 0xffff));
	RzILOpPure *op_MUL_191 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_180), DUP(op_AND_180))), CAST(16, MSB(DUP(op_AND_180)), DUP(op_AND_180))), CAST(32, MSB(CAST(16, MSB(op_AND_188), DUP(op_AND_188))), CAST(16, MSB(DUP(op_AND_188)), DUP(op_AND_188))));
	RzILOpPure *op_LSHIFT_194 = SHIFTL0(CAST(64, MSB(op_MUL_191), DUP(op_MUL_191)), SN(32, 0));
	RzILOpPure *op_ADD_195 = ADD(op_LSHIFT_174, op_LSHIFT_194);
	RzILOpPure *op_ADD_198 = ADD(op_ADD_195, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_LT_201 = SLT(op_ADD_198, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_206 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_207 = NEG(op_LSHIFT_206);
	RzILOpPure *op_LSHIFT_212 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_215 = SUB(op_LSHIFT_212, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_216 = ITE(op_LT_201, op_NEG_207, op_SUB_215);
	RzILOpEffect *gcc_expr_217 = BRANCH(op_EQ_107, EMPTY(), set_usr_field_call_154);

	// h_tmp240 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_219 = SETL("h_tmp240", cond_216);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_220 = SEQN(2, gcc_expr_217, op_ASSIGN_hybrid_tmp_219);

	// Rd = ((st32) (((ut64) (((st64) Rd) & (~(0xffff << 0x10)))) | (((ut64) (((st32) ((st16) ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000)) ? (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000) : h_tmp240) >> 0x10) & ((st64) 0xffff)))) & 0xffff)) << 0x10)));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffff), SN(32, 16));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_8 = LOGAND(CAST(64, MSB(READ_REG(pkt, Rd_op, true)), READ_REG(pkt, Rd_op, true)), op_NOT_6);
	RzILOpPure *op_RSHIFT_111 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_113 = LOGAND(op_RSHIFT_111, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_119 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_121 = LOGAND(op_RSHIFT_119, SN(32, 0xffff));
	RzILOpPure *op_MUL_124 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_113), DUP(op_AND_113))), CAST(16, MSB(DUP(op_AND_113)), DUP(op_AND_113))), CAST(32, MSB(CAST(16, MSB(op_AND_121), DUP(op_AND_121))), CAST(16, MSB(DUP(op_AND_121)), DUP(op_AND_121))));
	RzILOpPure *op_LSHIFT_127 = SHIFTL0(CAST(64, MSB(op_MUL_124), DUP(op_MUL_124)), SN(32, 0));
	RzILOpPure *op_RSHIFT_131 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_133 = LOGAND(op_RSHIFT_131, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_139 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_141 = LOGAND(op_RSHIFT_139, SN(32, 0xffff));
	RzILOpPure *op_MUL_144 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_133), DUP(op_AND_133))), CAST(16, MSB(DUP(op_AND_133)), DUP(op_AND_133))), CAST(32, MSB(CAST(16, MSB(op_AND_141), DUP(op_AND_141))), CAST(16, MSB(DUP(op_AND_141)), DUP(op_AND_141))));
	RzILOpPure *op_LSHIFT_147 = SHIFTL0(CAST(64, MSB(op_MUL_144), DUP(op_MUL_144)), SN(32, 0));
	RzILOpPure *op_ADD_148 = ADD(op_LSHIFT_127, op_LSHIFT_147);
	RzILOpPure *op_ADD_151 = ADD(op_ADD_148, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *cond_221 = ITE(DUP(op_EQ_107), op_ADD_151, VARL("h_tmp240"));
	RzILOpPure *op_RSHIFT_225 = SHIFTRA(cond_221, SN(32, 16));
	RzILOpPure *op_AND_228 = LOGAND(op_RSHIFT_225, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_AND_232 = LOGAND(CAST(32, MSB(CAST(16, MSB(op_AND_228), DUP(op_AND_228))), CAST(16, MSB(DUP(op_AND_228)), DUP(op_AND_228))), SN(32, 0xffff));
	RzILOpPure *op_LSHIFT_237 = SHIFTL0(CAST(64, IL_FALSE, op_AND_232), SN(32, 16));
	RzILOpPure *op_OR_239 = LOGOR(CAST(64, IL_FALSE, op_AND_8), op_LSHIFT_237);
	RzILOpEffect *op_ASSIGN_241 = WRITE_REG(bundle, Rd_op, CAST(32, IL_FALSE, op_OR_239));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_242 = SEQN(2, seq_220, op_ASSIGN_241);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_395 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_258 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_260 = LOGAND(op_RSHIFT_258, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_266 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_268 = LOGAND(op_RSHIFT_266, SN(32, 0xffff));
	RzILOpPure *op_MUL_271 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_260), DUP(op_AND_260))), CAST(16, MSB(DUP(op_AND_260)), DUP(op_AND_260))), CAST(32, MSB(CAST(16, MSB(op_AND_268), DUP(op_AND_268))), CAST(16, MSB(DUP(op_AND_268)), DUP(op_AND_268))));
	RzILOpPure *op_LSHIFT_274 = SHIFTL0(CAST(64, MSB(op_MUL_271), DUP(op_MUL_271)), SN(32, 0));
	RzILOpPure *op_RSHIFT_278 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_280 = LOGAND(op_RSHIFT_278, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_286 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_288 = LOGAND(op_RSHIFT_286, SN(32, 0xffff));
	RzILOpPure *op_MUL_291 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_280), DUP(op_AND_280))), CAST(16, MSB(DUP(op_AND_280)), DUP(op_AND_280))), CAST(32, MSB(CAST(16, MSB(op_AND_288), DUP(op_AND_288))), CAST(16, MSB(DUP(op_AND_288)), DUP(op_AND_288))));
	RzILOpPure *op_LSHIFT_294 = SHIFTL0(CAST(64, MSB(op_MUL_291), DUP(op_MUL_291)), SN(32, 0));
	RzILOpPure *op_SUB_295 = SUB(op_LSHIFT_274, op_LSHIFT_294);
	RzILOpPure *op_ADD_298 = ADD(op_SUB_295, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_307 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_309 = LOGAND(op_RSHIFT_307, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_315 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_317 = LOGAND(op_RSHIFT_315, SN(32, 0xffff));
	RzILOpPure *op_MUL_320 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_309), DUP(op_AND_309))), CAST(16, MSB(DUP(op_AND_309)), DUP(op_AND_309))), CAST(32, MSB(CAST(16, MSB(op_AND_317), DUP(op_AND_317))), CAST(16, MSB(DUP(op_AND_317)), DUP(op_AND_317))));
	RzILOpPure *op_LSHIFT_323 = SHIFTL0(CAST(64, MSB(op_MUL_320), DUP(op_MUL_320)), SN(32, 0));
	RzILOpPure *op_RSHIFT_327 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_329 = LOGAND(op_RSHIFT_327, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_335 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_337 = LOGAND(op_RSHIFT_335, SN(32, 0xffff));
	RzILOpPure *op_MUL_340 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_329), DUP(op_AND_329))), CAST(16, MSB(DUP(op_AND_329)), DUP(op_AND_329))), CAST(32, MSB(CAST(16, MSB(op_AND_337), DUP(op_AND_337))), CAST(16, MSB(DUP(op_AND_337)), DUP(op_AND_337))));
	RzILOpPure *op_LSHIFT_343 = SHIFTL0(CAST(64, MSB(op_MUL_340), DUP(op_MUL_340)), SN(32, 0));
	RzILOpPure *op_SUB_344 = SUB(op_LSHIFT_323, op_LSHIFT_343);
	RzILOpPure *op_ADD_347 = ADD(op_SUB_344, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_EQ_348 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_298), SN(32, 0), SN(32, 0x20)), op_ADD_347);
	RzILOpPure *op_RSHIFT_399 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_401 = LOGAND(op_RSHIFT_399, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_407 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_409 = LOGAND(op_RSHIFT_407, SN(32, 0xffff));
	RzILOpPure *op_MUL_412 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_401), DUP(op_AND_401))), CAST(16, MSB(DUP(op_AND_401)), DUP(op_AND_401))), CAST(32, MSB(CAST(16, MSB(op_AND_409), DUP(op_AND_409))), CAST(16, MSB(DUP(op_AND_409)), DUP(op_AND_409))));
	RzILOpPure *op_LSHIFT_415 = SHIFTL0(CAST(64, MSB(op_MUL_412), DUP(op_MUL_412)), SN(32, 0));
	RzILOpPure *op_RSHIFT_419 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_421 = LOGAND(op_RSHIFT_419, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_427 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_429 = LOGAND(op_RSHIFT_427, SN(32, 0xffff));
	RzILOpPure *op_MUL_432 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_421), DUP(op_AND_421))), CAST(16, MSB(DUP(op_AND_421)), DUP(op_AND_421))), CAST(32, MSB(CAST(16, MSB(op_AND_429), DUP(op_AND_429))), CAST(16, MSB(DUP(op_AND_429)), DUP(op_AND_429))));
	RzILOpPure *op_LSHIFT_435 = SHIFTL0(CAST(64, MSB(op_MUL_432), DUP(op_MUL_432)), SN(32, 0));
	RzILOpPure *op_SUB_436 = SUB(op_LSHIFT_415, op_LSHIFT_435);
	RzILOpPure *op_ADD_439 = ADD(op_SUB_436, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_LT_442 = SLT(op_ADD_439, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_447 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_448 = NEG(op_LSHIFT_447);
	RzILOpPure *op_LSHIFT_453 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_456 = SUB(op_LSHIFT_453, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_457 = ITE(op_LT_442, op_NEG_448, op_SUB_456);
	RzILOpEffect *gcc_expr_458 = BRANCH(op_EQ_348, EMPTY(), set_usr_field_call_395);

	// h_tmp241 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_460 = SETL("h_tmp241", cond_457);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_461 = SEQN(2, gcc_expr_458, op_ASSIGN_hybrid_tmp_460);

	// Rd = ((st32) (((ut64) (((st64) Rd) & (~(0xffff << 0x0)))) | (((ut64) (((st32) ((st16) ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000)) ? (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000) : h_tmp241) >> 0x10) & ((st64) 0xffff)))) & 0xffff)) << 0x0)));
	RzILOpPure *op_LSHIFT_248 = SHIFTL0(SN(64, 0xffff), SN(32, 0));
	RzILOpPure *op_NOT_249 = LOGNOT(op_LSHIFT_248);
	RzILOpPure *op_AND_251 = LOGAND(CAST(64, MSB(READ_REG(pkt, Rd_op, true)), READ_REG(pkt, Rd_op, true)), op_NOT_249);
	RzILOpPure *op_RSHIFT_352 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_354 = LOGAND(op_RSHIFT_352, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_360 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_362 = LOGAND(op_RSHIFT_360, SN(32, 0xffff));
	RzILOpPure *op_MUL_365 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_354), DUP(op_AND_354))), CAST(16, MSB(DUP(op_AND_354)), DUP(op_AND_354))), CAST(32, MSB(CAST(16, MSB(op_AND_362), DUP(op_AND_362))), CAST(16, MSB(DUP(op_AND_362)), DUP(op_AND_362))));
	RzILOpPure *op_LSHIFT_368 = SHIFTL0(CAST(64, MSB(op_MUL_365), DUP(op_MUL_365)), SN(32, 0));
	RzILOpPure *op_RSHIFT_372 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_374 = LOGAND(op_RSHIFT_372, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_380 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_382 = LOGAND(op_RSHIFT_380, SN(32, 0xffff));
	RzILOpPure *op_MUL_385 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_374), DUP(op_AND_374))), CAST(16, MSB(DUP(op_AND_374)), DUP(op_AND_374))), CAST(32, MSB(CAST(16, MSB(op_AND_382), DUP(op_AND_382))), CAST(16, MSB(DUP(op_AND_382)), DUP(op_AND_382))));
	RzILOpPure *op_LSHIFT_388 = SHIFTL0(CAST(64, MSB(op_MUL_385), DUP(op_MUL_385)), SN(32, 0));
	RzILOpPure *op_SUB_389 = SUB(op_LSHIFT_368, op_LSHIFT_388);
	RzILOpPure *op_ADD_392 = ADD(op_SUB_389, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *cond_462 = ITE(DUP(op_EQ_348), op_ADD_392, VARL("h_tmp241"));
	RzILOpPure *op_RSHIFT_466 = SHIFTRA(cond_462, SN(32, 16));
	RzILOpPure *op_AND_469 = LOGAND(op_RSHIFT_466, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_AND_473 = LOGAND(CAST(32, MSB(CAST(16, MSB(op_AND_469), DUP(op_AND_469))), CAST(16, MSB(DUP(op_AND_469)), DUP(op_AND_469))), SN(32, 0xffff));
	RzILOpPure *op_LSHIFT_478 = SHIFTL0(CAST(64, IL_FALSE, op_AND_473), SN(32, 0));
	RzILOpPure *op_OR_480 = LOGOR(CAST(64, IL_FALSE, op_AND_251), op_LSHIFT_478);
	RzILOpEffect *op_ASSIGN_482 = WRITE_REG(bundle, Rd_op, CAST(32, IL_FALSE, op_OR_480));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_483 = SEQN(2, seq_461, op_ASSIGN_482);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_242, seq_483);
	return instruction_sequence;
}

// Rd = cmpy(Rs,Rt):<<1:rnd:sat
RzILOpEffect *hex_il_op_m2_cmpyrs_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_154 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_16 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_18 = LOGAND(op_RSHIFT_16, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_25 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_27 = LOGAND(op_RSHIFT_25, SN(32, 0xffff));
	RzILOpPure *op_MUL_30 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_18), DUP(op_AND_18))), CAST(16, MSB(DUP(op_AND_18)), DUP(op_AND_18))), CAST(32, MSB(CAST(16, MSB(op_AND_27), DUP(op_AND_27))), CAST(16, MSB(DUP(op_AND_27)), DUP(op_AND_27))));
	RzILOpPure *op_LSHIFT_33 = SHIFTL0(CAST(64, MSB(op_MUL_30), DUP(op_MUL_30)), SN(32, 1));
	RzILOpPure *op_RSHIFT_37 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_39 = LOGAND(op_RSHIFT_37, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_45 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_47 = LOGAND(op_RSHIFT_45, SN(32, 0xffff));
	RzILOpPure *op_MUL_50 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_39), DUP(op_AND_39))), CAST(16, MSB(DUP(op_AND_39)), DUP(op_AND_39))), CAST(32, MSB(CAST(16, MSB(op_AND_47), DUP(op_AND_47))), CAST(16, MSB(DUP(op_AND_47)), DUP(op_AND_47))));
	RzILOpPure *op_LSHIFT_53 = SHIFTL0(CAST(64, MSB(op_MUL_50), DUP(op_MUL_50)), SN(32, 1));
	RzILOpPure *op_ADD_54 = ADD(op_LSHIFT_33, op_LSHIFT_53);
	RzILOpPure *op_ADD_57 = ADD(op_ADD_54, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_66 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_68 = LOGAND(op_RSHIFT_66, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_74 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_76 = LOGAND(op_RSHIFT_74, SN(32, 0xffff));
	RzILOpPure *op_MUL_79 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_68), DUP(op_AND_68))), CAST(16, MSB(DUP(op_AND_68)), DUP(op_AND_68))), CAST(32, MSB(CAST(16, MSB(op_AND_76), DUP(op_AND_76))), CAST(16, MSB(DUP(op_AND_76)), DUP(op_AND_76))));
	RzILOpPure *op_LSHIFT_82 = SHIFTL0(CAST(64, MSB(op_MUL_79), DUP(op_MUL_79)), SN(32, 1));
	RzILOpPure *op_RSHIFT_86 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_88 = LOGAND(op_RSHIFT_86, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_94 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_96 = LOGAND(op_RSHIFT_94, SN(32, 0xffff));
	RzILOpPure *op_MUL_99 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_88), DUP(op_AND_88))), CAST(16, MSB(DUP(op_AND_88)), DUP(op_AND_88))), CAST(32, MSB(CAST(16, MSB(op_AND_96), DUP(op_AND_96))), CAST(16, MSB(DUP(op_AND_96)), DUP(op_AND_96))));
	RzILOpPure *op_LSHIFT_102 = SHIFTL0(CAST(64, MSB(op_MUL_99), DUP(op_MUL_99)), SN(32, 1));
	RzILOpPure *op_ADD_103 = ADD(op_LSHIFT_82, op_LSHIFT_102);
	RzILOpPure *op_ADD_106 = ADD(op_ADD_103, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_EQ_107 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_57), SN(32, 0), SN(32, 0x20)), op_ADD_106);
	RzILOpPure *op_RSHIFT_158 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_160 = LOGAND(op_RSHIFT_158, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_166 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_168 = LOGAND(op_RSHIFT_166, SN(32, 0xffff));
	RzILOpPure *op_MUL_171 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_160), DUP(op_AND_160))), CAST(16, MSB(DUP(op_AND_160)), DUP(op_AND_160))), CAST(32, MSB(CAST(16, MSB(op_AND_168), DUP(op_AND_168))), CAST(16, MSB(DUP(op_AND_168)), DUP(op_AND_168))));
	RzILOpPure *op_LSHIFT_174 = SHIFTL0(CAST(64, MSB(op_MUL_171), DUP(op_MUL_171)), SN(32, 1));
	RzILOpPure *op_RSHIFT_178 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_180 = LOGAND(op_RSHIFT_178, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_186 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_188 = LOGAND(op_RSHIFT_186, SN(32, 0xffff));
	RzILOpPure *op_MUL_191 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_180), DUP(op_AND_180))), CAST(16, MSB(DUP(op_AND_180)), DUP(op_AND_180))), CAST(32, MSB(CAST(16, MSB(op_AND_188), DUP(op_AND_188))), CAST(16, MSB(DUP(op_AND_188)), DUP(op_AND_188))));
	RzILOpPure *op_LSHIFT_194 = SHIFTL0(CAST(64, MSB(op_MUL_191), DUP(op_MUL_191)), SN(32, 1));
	RzILOpPure *op_ADD_195 = ADD(op_LSHIFT_174, op_LSHIFT_194);
	RzILOpPure *op_ADD_198 = ADD(op_ADD_195, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_LT_201 = SLT(op_ADD_198, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_206 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_207 = NEG(op_LSHIFT_206);
	RzILOpPure *op_LSHIFT_212 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_215 = SUB(op_LSHIFT_212, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_216 = ITE(op_LT_201, op_NEG_207, op_SUB_215);
	RzILOpEffect *gcc_expr_217 = BRANCH(op_EQ_107, EMPTY(), set_usr_field_call_154);

	// h_tmp242 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_219 = SETL("h_tmp242", cond_216);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_220 = SEQN(2, gcc_expr_217, op_ASSIGN_hybrid_tmp_219);

	// Rd = ((st32) (((ut64) (((st64) Rd) & (~(0xffff << 0x10)))) | (((ut64) (((st32) ((st16) ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000)) ? (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000) : h_tmp242) >> 0x10) & ((st64) 0xffff)))) & 0xffff)) << 0x10)));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffff), SN(32, 16));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_8 = LOGAND(CAST(64, MSB(READ_REG(pkt, Rd_op, true)), READ_REG(pkt, Rd_op, true)), op_NOT_6);
	RzILOpPure *op_RSHIFT_111 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_113 = LOGAND(op_RSHIFT_111, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_119 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_121 = LOGAND(op_RSHIFT_119, SN(32, 0xffff));
	RzILOpPure *op_MUL_124 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_113), DUP(op_AND_113))), CAST(16, MSB(DUP(op_AND_113)), DUP(op_AND_113))), CAST(32, MSB(CAST(16, MSB(op_AND_121), DUP(op_AND_121))), CAST(16, MSB(DUP(op_AND_121)), DUP(op_AND_121))));
	RzILOpPure *op_LSHIFT_127 = SHIFTL0(CAST(64, MSB(op_MUL_124), DUP(op_MUL_124)), SN(32, 1));
	RzILOpPure *op_RSHIFT_131 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_133 = LOGAND(op_RSHIFT_131, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_139 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_141 = LOGAND(op_RSHIFT_139, SN(32, 0xffff));
	RzILOpPure *op_MUL_144 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_133), DUP(op_AND_133))), CAST(16, MSB(DUP(op_AND_133)), DUP(op_AND_133))), CAST(32, MSB(CAST(16, MSB(op_AND_141), DUP(op_AND_141))), CAST(16, MSB(DUP(op_AND_141)), DUP(op_AND_141))));
	RzILOpPure *op_LSHIFT_147 = SHIFTL0(CAST(64, MSB(op_MUL_144), DUP(op_MUL_144)), SN(32, 1));
	RzILOpPure *op_ADD_148 = ADD(op_LSHIFT_127, op_LSHIFT_147);
	RzILOpPure *op_ADD_151 = ADD(op_ADD_148, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *cond_221 = ITE(DUP(op_EQ_107), op_ADD_151, VARL("h_tmp242"));
	RzILOpPure *op_RSHIFT_225 = SHIFTRA(cond_221, SN(32, 16));
	RzILOpPure *op_AND_228 = LOGAND(op_RSHIFT_225, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_AND_232 = LOGAND(CAST(32, MSB(CAST(16, MSB(op_AND_228), DUP(op_AND_228))), CAST(16, MSB(DUP(op_AND_228)), DUP(op_AND_228))), SN(32, 0xffff));
	RzILOpPure *op_LSHIFT_237 = SHIFTL0(CAST(64, IL_FALSE, op_AND_232), SN(32, 16));
	RzILOpPure *op_OR_239 = LOGOR(CAST(64, IL_FALSE, op_AND_8), op_LSHIFT_237);
	RzILOpEffect *op_ASSIGN_241 = WRITE_REG(bundle, Rd_op, CAST(32, IL_FALSE, op_OR_239));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_242 = SEQN(2, seq_220, op_ASSIGN_241);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_395 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_258 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_260 = LOGAND(op_RSHIFT_258, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_266 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_268 = LOGAND(op_RSHIFT_266, SN(32, 0xffff));
	RzILOpPure *op_MUL_271 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_260), DUP(op_AND_260))), CAST(16, MSB(DUP(op_AND_260)), DUP(op_AND_260))), CAST(32, MSB(CAST(16, MSB(op_AND_268), DUP(op_AND_268))), CAST(16, MSB(DUP(op_AND_268)), DUP(op_AND_268))));
	RzILOpPure *op_LSHIFT_274 = SHIFTL0(CAST(64, MSB(op_MUL_271), DUP(op_MUL_271)), SN(32, 1));
	RzILOpPure *op_RSHIFT_278 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_280 = LOGAND(op_RSHIFT_278, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_286 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_288 = LOGAND(op_RSHIFT_286, SN(32, 0xffff));
	RzILOpPure *op_MUL_291 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_280), DUP(op_AND_280))), CAST(16, MSB(DUP(op_AND_280)), DUP(op_AND_280))), CAST(32, MSB(CAST(16, MSB(op_AND_288), DUP(op_AND_288))), CAST(16, MSB(DUP(op_AND_288)), DUP(op_AND_288))));
	RzILOpPure *op_LSHIFT_294 = SHIFTL0(CAST(64, MSB(op_MUL_291), DUP(op_MUL_291)), SN(32, 1));
	RzILOpPure *op_SUB_295 = SUB(op_LSHIFT_274, op_LSHIFT_294);
	RzILOpPure *op_ADD_298 = ADD(op_SUB_295, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_307 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_309 = LOGAND(op_RSHIFT_307, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_315 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_317 = LOGAND(op_RSHIFT_315, SN(32, 0xffff));
	RzILOpPure *op_MUL_320 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_309), DUP(op_AND_309))), CAST(16, MSB(DUP(op_AND_309)), DUP(op_AND_309))), CAST(32, MSB(CAST(16, MSB(op_AND_317), DUP(op_AND_317))), CAST(16, MSB(DUP(op_AND_317)), DUP(op_AND_317))));
	RzILOpPure *op_LSHIFT_323 = SHIFTL0(CAST(64, MSB(op_MUL_320), DUP(op_MUL_320)), SN(32, 1));
	RzILOpPure *op_RSHIFT_327 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_329 = LOGAND(op_RSHIFT_327, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_335 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_337 = LOGAND(op_RSHIFT_335, SN(32, 0xffff));
	RzILOpPure *op_MUL_340 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_329), DUP(op_AND_329))), CAST(16, MSB(DUP(op_AND_329)), DUP(op_AND_329))), CAST(32, MSB(CAST(16, MSB(op_AND_337), DUP(op_AND_337))), CAST(16, MSB(DUP(op_AND_337)), DUP(op_AND_337))));
	RzILOpPure *op_LSHIFT_343 = SHIFTL0(CAST(64, MSB(op_MUL_340), DUP(op_MUL_340)), SN(32, 1));
	RzILOpPure *op_SUB_344 = SUB(op_LSHIFT_323, op_LSHIFT_343);
	RzILOpPure *op_ADD_347 = ADD(op_SUB_344, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_EQ_348 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_298), SN(32, 0), SN(32, 0x20)), op_ADD_347);
	RzILOpPure *op_RSHIFT_399 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_401 = LOGAND(op_RSHIFT_399, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_407 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_409 = LOGAND(op_RSHIFT_407, SN(32, 0xffff));
	RzILOpPure *op_MUL_412 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_401), DUP(op_AND_401))), CAST(16, MSB(DUP(op_AND_401)), DUP(op_AND_401))), CAST(32, MSB(CAST(16, MSB(op_AND_409), DUP(op_AND_409))), CAST(16, MSB(DUP(op_AND_409)), DUP(op_AND_409))));
	RzILOpPure *op_LSHIFT_415 = SHIFTL0(CAST(64, MSB(op_MUL_412), DUP(op_MUL_412)), SN(32, 1));
	RzILOpPure *op_RSHIFT_419 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_421 = LOGAND(op_RSHIFT_419, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_427 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_429 = LOGAND(op_RSHIFT_427, SN(32, 0xffff));
	RzILOpPure *op_MUL_432 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_421), DUP(op_AND_421))), CAST(16, MSB(DUP(op_AND_421)), DUP(op_AND_421))), CAST(32, MSB(CAST(16, MSB(op_AND_429), DUP(op_AND_429))), CAST(16, MSB(DUP(op_AND_429)), DUP(op_AND_429))));
	RzILOpPure *op_LSHIFT_435 = SHIFTL0(CAST(64, MSB(op_MUL_432), DUP(op_MUL_432)), SN(32, 1));
	RzILOpPure *op_SUB_436 = SUB(op_LSHIFT_415, op_LSHIFT_435);
	RzILOpPure *op_ADD_439 = ADD(op_SUB_436, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_LT_442 = SLT(op_ADD_439, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_447 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_448 = NEG(op_LSHIFT_447);
	RzILOpPure *op_LSHIFT_453 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_456 = SUB(op_LSHIFT_453, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_457 = ITE(op_LT_442, op_NEG_448, op_SUB_456);
	RzILOpEffect *gcc_expr_458 = BRANCH(op_EQ_348, EMPTY(), set_usr_field_call_395);

	// h_tmp243 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_460 = SETL("h_tmp243", cond_457);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_461 = SEQN(2, gcc_expr_458, op_ASSIGN_hybrid_tmp_460);

	// Rd = ((st32) (((ut64) (((st64) Rd) & (~(0xffff << 0x0)))) | (((ut64) (((st32) ((st16) ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000)) ? (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000) : h_tmp243) >> 0x10) & ((st64) 0xffff)))) & 0xffff)) << 0x0)));
	RzILOpPure *op_LSHIFT_248 = SHIFTL0(SN(64, 0xffff), SN(32, 0));
	RzILOpPure *op_NOT_249 = LOGNOT(op_LSHIFT_248);
	RzILOpPure *op_AND_251 = LOGAND(CAST(64, MSB(READ_REG(pkt, Rd_op, true)), READ_REG(pkt, Rd_op, true)), op_NOT_249);
	RzILOpPure *op_RSHIFT_352 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_354 = LOGAND(op_RSHIFT_352, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_360 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_362 = LOGAND(op_RSHIFT_360, SN(32, 0xffff));
	RzILOpPure *op_MUL_365 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_354), DUP(op_AND_354))), CAST(16, MSB(DUP(op_AND_354)), DUP(op_AND_354))), CAST(32, MSB(CAST(16, MSB(op_AND_362), DUP(op_AND_362))), CAST(16, MSB(DUP(op_AND_362)), DUP(op_AND_362))));
	RzILOpPure *op_LSHIFT_368 = SHIFTL0(CAST(64, MSB(op_MUL_365), DUP(op_MUL_365)), SN(32, 1));
	RzILOpPure *op_RSHIFT_372 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_374 = LOGAND(op_RSHIFT_372, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_380 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_382 = LOGAND(op_RSHIFT_380, SN(32, 0xffff));
	RzILOpPure *op_MUL_385 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_374), DUP(op_AND_374))), CAST(16, MSB(DUP(op_AND_374)), DUP(op_AND_374))), CAST(32, MSB(CAST(16, MSB(op_AND_382), DUP(op_AND_382))), CAST(16, MSB(DUP(op_AND_382)), DUP(op_AND_382))));
	RzILOpPure *op_LSHIFT_388 = SHIFTL0(CAST(64, MSB(op_MUL_385), DUP(op_MUL_385)), SN(32, 1));
	RzILOpPure *op_SUB_389 = SUB(op_LSHIFT_368, op_LSHIFT_388);
	RzILOpPure *op_ADD_392 = ADD(op_SUB_389, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *cond_462 = ITE(DUP(op_EQ_348), op_ADD_392, VARL("h_tmp243"));
	RzILOpPure *op_RSHIFT_466 = SHIFTRA(cond_462, SN(32, 16));
	RzILOpPure *op_AND_469 = LOGAND(op_RSHIFT_466, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_AND_473 = LOGAND(CAST(32, MSB(CAST(16, MSB(op_AND_469), DUP(op_AND_469))), CAST(16, MSB(DUP(op_AND_469)), DUP(op_AND_469))), SN(32, 0xffff));
	RzILOpPure *op_LSHIFT_478 = SHIFTL0(CAST(64, IL_FALSE, op_AND_473), SN(32, 0));
	RzILOpPure *op_OR_480 = LOGOR(CAST(64, IL_FALSE, op_AND_251), op_LSHIFT_478);
	RzILOpEffect *op_ASSIGN_482 = WRITE_REG(bundle, Rd_op, CAST(32, IL_FALSE, op_OR_480));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_483 = SEQN(2, seq_461, op_ASSIGN_482);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_242, seq_483);
	return instruction_sequence;
}

// Rd = cmpy(Rs,Rt*):rnd:sat
RzILOpEffect *hex_il_op_m2_cmpyrsc_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_154 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_16 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_18 = LOGAND(op_RSHIFT_16, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_25 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_27 = LOGAND(op_RSHIFT_25, SN(32, 0xffff));
	RzILOpPure *op_MUL_30 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_18), DUP(op_AND_18))), CAST(16, MSB(DUP(op_AND_18)), DUP(op_AND_18))), CAST(32, MSB(CAST(16, MSB(op_AND_27), DUP(op_AND_27))), CAST(16, MSB(DUP(op_AND_27)), DUP(op_AND_27))));
	RzILOpPure *op_LSHIFT_33 = SHIFTL0(CAST(64, MSB(op_MUL_30), DUP(op_MUL_30)), SN(32, 0));
	RzILOpPure *op_RSHIFT_37 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_39 = LOGAND(op_RSHIFT_37, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_45 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_47 = LOGAND(op_RSHIFT_45, SN(32, 0xffff));
	RzILOpPure *op_MUL_50 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_39), DUP(op_AND_39))), CAST(16, MSB(DUP(op_AND_39)), DUP(op_AND_39))), CAST(32, MSB(CAST(16, MSB(op_AND_47), DUP(op_AND_47))), CAST(16, MSB(DUP(op_AND_47)), DUP(op_AND_47))));
	RzILOpPure *op_LSHIFT_53 = SHIFTL0(CAST(64, MSB(op_MUL_50), DUP(op_MUL_50)), SN(32, 0));
	RzILOpPure *op_SUB_54 = SUB(op_LSHIFT_33, op_LSHIFT_53);
	RzILOpPure *op_ADD_57 = ADD(op_SUB_54, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_66 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_68 = LOGAND(op_RSHIFT_66, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_74 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_76 = LOGAND(op_RSHIFT_74, SN(32, 0xffff));
	RzILOpPure *op_MUL_79 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_68), DUP(op_AND_68))), CAST(16, MSB(DUP(op_AND_68)), DUP(op_AND_68))), CAST(32, MSB(CAST(16, MSB(op_AND_76), DUP(op_AND_76))), CAST(16, MSB(DUP(op_AND_76)), DUP(op_AND_76))));
	RzILOpPure *op_LSHIFT_82 = SHIFTL0(CAST(64, MSB(op_MUL_79), DUP(op_MUL_79)), SN(32, 0));
	RzILOpPure *op_RSHIFT_86 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_88 = LOGAND(op_RSHIFT_86, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_94 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_96 = LOGAND(op_RSHIFT_94, SN(32, 0xffff));
	RzILOpPure *op_MUL_99 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_88), DUP(op_AND_88))), CAST(16, MSB(DUP(op_AND_88)), DUP(op_AND_88))), CAST(32, MSB(CAST(16, MSB(op_AND_96), DUP(op_AND_96))), CAST(16, MSB(DUP(op_AND_96)), DUP(op_AND_96))));
	RzILOpPure *op_LSHIFT_102 = SHIFTL0(CAST(64, MSB(op_MUL_99), DUP(op_MUL_99)), SN(32, 0));
	RzILOpPure *op_SUB_103 = SUB(op_LSHIFT_82, op_LSHIFT_102);
	RzILOpPure *op_ADD_106 = ADD(op_SUB_103, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_EQ_107 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_57), SN(32, 0), SN(32, 0x20)), op_ADD_106);
	RzILOpPure *op_RSHIFT_158 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_160 = LOGAND(op_RSHIFT_158, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_166 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_168 = LOGAND(op_RSHIFT_166, SN(32, 0xffff));
	RzILOpPure *op_MUL_171 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_160), DUP(op_AND_160))), CAST(16, MSB(DUP(op_AND_160)), DUP(op_AND_160))), CAST(32, MSB(CAST(16, MSB(op_AND_168), DUP(op_AND_168))), CAST(16, MSB(DUP(op_AND_168)), DUP(op_AND_168))));
	RzILOpPure *op_LSHIFT_174 = SHIFTL0(CAST(64, MSB(op_MUL_171), DUP(op_MUL_171)), SN(32, 0));
	RzILOpPure *op_RSHIFT_178 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_180 = LOGAND(op_RSHIFT_178, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_186 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_188 = LOGAND(op_RSHIFT_186, SN(32, 0xffff));
	RzILOpPure *op_MUL_191 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_180), DUP(op_AND_180))), CAST(16, MSB(DUP(op_AND_180)), DUP(op_AND_180))), CAST(32, MSB(CAST(16, MSB(op_AND_188), DUP(op_AND_188))), CAST(16, MSB(DUP(op_AND_188)), DUP(op_AND_188))));
	RzILOpPure *op_LSHIFT_194 = SHIFTL0(CAST(64, MSB(op_MUL_191), DUP(op_MUL_191)), SN(32, 0));
	RzILOpPure *op_SUB_195 = SUB(op_LSHIFT_174, op_LSHIFT_194);
	RzILOpPure *op_ADD_198 = ADD(op_SUB_195, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_LT_201 = SLT(op_ADD_198, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_206 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_207 = NEG(op_LSHIFT_206);
	RzILOpPure *op_LSHIFT_212 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_215 = SUB(op_LSHIFT_212, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_216 = ITE(op_LT_201, op_NEG_207, op_SUB_215);
	RzILOpEffect *gcc_expr_217 = BRANCH(op_EQ_107, EMPTY(), set_usr_field_call_154);

	// h_tmp244 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_219 = SETL("h_tmp244", cond_216);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_220 = SEQN(2, gcc_expr_217, op_ASSIGN_hybrid_tmp_219);

	// Rd = ((st32) (((ut64) (((st64) Rd) & (~(0xffff << 0x10)))) | (((ut64) (((st32) ((st16) ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000)) ? (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000) : h_tmp244) >> 0x10) & ((st64) 0xffff)))) & 0xffff)) << 0x10)));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffff), SN(32, 16));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_8 = LOGAND(CAST(64, MSB(READ_REG(pkt, Rd_op, true)), READ_REG(pkt, Rd_op, true)), op_NOT_6);
	RzILOpPure *op_RSHIFT_111 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_113 = LOGAND(op_RSHIFT_111, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_119 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_121 = LOGAND(op_RSHIFT_119, SN(32, 0xffff));
	RzILOpPure *op_MUL_124 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_113), DUP(op_AND_113))), CAST(16, MSB(DUP(op_AND_113)), DUP(op_AND_113))), CAST(32, MSB(CAST(16, MSB(op_AND_121), DUP(op_AND_121))), CAST(16, MSB(DUP(op_AND_121)), DUP(op_AND_121))));
	RzILOpPure *op_LSHIFT_127 = SHIFTL0(CAST(64, MSB(op_MUL_124), DUP(op_MUL_124)), SN(32, 0));
	RzILOpPure *op_RSHIFT_131 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_133 = LOGAND(op_RSHIFT_131, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_139 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_141 = LOGAND(op_RSHIFT_139, SN(32, 0xffff));
	RzILOpPure *op_MUL_144 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_133), DUP(op_AND_133))), CAST(16, MSB(DUP(op_AND_133)), DUP(op_AND_133))), CAST(32, MSB(CAST(16, MSB(op_AND_141), DUP(op_AND_141))), CAST(16, MSB(DUP(op_AND_141)), DUP(op_AND_141))));
	RzILOpPure *op_LSHIFT_147 = SHIFTL0(CAST(64, MSB(op_MUL_144), DUP(op_MUL_144)), SN(32, 0));
	RzILOpPure *op_SUB_148 = SUB(op_LSHIFT_127, op_LSHIFT_147);
	RzILOpPure *op_ADD_151 = ADD(op_SUB_148, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *cond_221 = ITE(DUP(op_EQ_107), op_ADD_151, VARL("h_tmp244"));
	RzILOpPure *op_RSHIFT_225 = SHIFTRA(cond_221, SN(32, 16));
	RzILOpPure *op_AND_228 = LOGAND(op_RSHIFT_225, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_AND_232 = LOGAND(CAST(32, MSB(CAST(16, MSB(op_AND_228), DUP(op_AND_228))), CAST(16, MSB(DUP(op_AND_228)), DUP(op_AND_228))), SN(32, 0xffff));
	RzILOpPure *op_LSHIFT_237 = SHIFTL0(CAST(64, IL_FALSE, op_AND_232), SN(32, 16));
	RzILOpPure *op_OR_239 = LOGOR(CAST(64, IL_FALSE, op_AND_8), op_LSHIFT_237);
	RzILOpEffect *op_ASSIGN_241 = WRITE_REG(bundle, Rd_op, CAST(32, IL_FALSE, op_OR_239));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_242 = SEQN(2, seq_220, op_ASSIGN_241);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_395 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_258 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_260 = LOGAND(op_RSHIFT_258, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_266 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_268 = LOGAND(op_RSHIFT_266, SN(32, 0xffff));
	RzILOpPure *op_MUL_271 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_260), DUP(op_AND_260))), CAST(16, MSB(DUP(op_AND_260)), DUP(op_AND_260))), CAST(32, MSB(CAST(16, MSB(op_AND_268), DUP(op_AND_268))), CAST(16, MSB(DUP(op_AND_268)), DUP(op_AND_268))));
	RzILOpPure *op_LSHIFT_274 = SHIFTL0(CAST(64, MSB(op_MUL_271), DUP(op_MUL_271)), SN(32, 0));
	RzILOpPure *op_RSHIFT_278 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_280 = LOGAND(op_RSHIFT_278, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_286 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_288 = LOGAND(op_RSHIFT_286, SN(32, 0xffff));
	RzILOpPure *op_MUL_291 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_280), DUP(op_AND_280))), CAST(16, MSB(DUP(op_AND_280)), DUP(op_AND_280))), CAST(32, MSB(CAST(16, MSB(op_AND_288), DUP(op_AND_288))), CAST(16, MSB(DUP(op_AND_288)), DUP(op_AND_288))));
	RzILOpPure *op_LSHIFT_294 = SHIFTL0(CAST(64, MSB(op_MUL_291), DUP(op_MUL_291)), SN(32, 0));
	RzILOpPure *op_ADD_295 = ADD(op_LSHIFT_274, op_LSHIFT_294);
	RzILOpPure *op_ADD_298 = ADD(op_ADD_295, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_307 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_309 = LOGAND(op_RSHIFT_307, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_315 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_317 = LOGAND(op_RSHIFT_315, SN(32, 0xffff));
	RzILOpPure *op_MUL_320 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_309), DUP(op_AND_309))), CAST(16, MSB(DUP(op_AND_309)), DUP(op_AND_309))), CAST(32, MSB(CAST(16, MSB(op_AND_317), DUP(op_AND_317))), CAST(16, MSB(DUP(op_AND_317)), DUP(op_AND_317))));
	RzILOpPure *op_LSHIFT_323 = SHIFTL0(CAST(64, MSB(op_MUL_320), DUP(op_MUL_320)), SN(32, 0));
	RzILOpPure *op_RSHIFT_327 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_329 = LOGAND(op_RSHIFT_327, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_335 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_337 = LOGAND(op_RSHIFT_335, SN(32, 0xffff));
	RzILOpPure *op_MUL_340 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_329), DUP(op_AND_329))), CAST(16, MSB(DUP(op_AND_329)), DUP(op_AND_329))), CAST(32, MSB(CAST(16, MSB(op_AND_337), DUP(op_AND_337))), CAST(16, MSB(DUP(op_AND_337)), DUP(op_AND_337))));
	RzILOpPure *op_LSHIFT_343 = SHIFTL0(CAST(64, MSB(op_MUL_340), DUP(op_MUL_340)), SN(32, 0));
	RzILOpPure *op_ADD_344 = ADD(op_LSHIFT_323, op_LSHIFT_343);
	RzILOpPure *op_ADD_347 = ADD(op_ADD_344, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_EQ_348 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_298), SN(32, 0), SN(32, 0x20)), op_ADD_347);
	RzILOpPure *op_RSHIFT_399 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_401 = LOGAND(op_RSHIFT_399, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_407 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_409 = LOGAND(op_RSHIFT_407, SN(32, 0xffff));
	RzILOpPure *op_MUL_412 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_401), DUP(op_AND_401))), CAST(16, MSB(DUP(op_AND_401)), DUP(op_AND_401))), CAST(32, MSB(CAST(16, MSB(op_AND_409), DUP(op_AND_409))), CAST(16, MSB(DUP(op_AND_409)), DUP(op_AND_409))));
	RzILOpPure *op_LSHIFT_415 = SHIFTL0(CAST(64, MSB(op_MUL_412), DUP(op_MUL_412)), SN(32, 0));
	RzILOpPure *op_RSHIFT_419 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_421 = LOGAND(op_RSHIFT_419, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_427 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_429 = LOGAND(op_RSHIFT_427, SN(32, 0xffff));
	RzILOpPure *op_MUL_432 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_421), DUP(op_AND_421))), CAST(16, MSB(DUP(op_AND_421)), DUP(op_AND_421))), CAST(32, MSB(CAST(16, MSB(op_AND_429), DUP(op_AND_429))), CAST(16, MSB(DUP(op_AND_429)), DUP(op_AND_429))));
	RzILOpPure *op_LSHIFT_435 = SHIFTL0(CAST(64, MSB(op_MUL_432), DUP(op_MUL_432)), SN(32, 0));
	RzILOpPure *op_ADD_436 = ADD(op_LSHIFT_415, op_LSHIFT_435);
	RzILOpPure *op_ADD_439 = ADD(op_ADD_436, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_LT_442 = SLT(op_ADD_439, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_447 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_448 = NEG(op_LSHIFT_447);
	RzILOpPure *op_LSHIFT_453 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_456 = SUB(op_LSHIFT_453, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_457 = ITE(op_LT_442, op_NEG_448, op_SUB_456);
	RzILOpEffect *gcc_expr_458 = BRANCH(op_EQ_348, EMPTY(), set_usr_field_call_395);

	// h_tmp245 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_460 = SETL("h_tmp245", cond_457);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_461 = SEQN(2, gcc_expr_458, op_ASSIGN_hybrid_tmp_460);

	// Rd = ((st32) (((ut64) (((st64) Rd) & (~(0xffff << 0x0)))) | (((ut64) (((st32) ((st16) ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000)) ? (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000) : h_tmp245) >> 0x10) & ((st64) 0xffff)))) & 0xffff)) << 0x0)));
	RzILOpPure *op_LSHIFT_248 = SHIFTL0(SN(64, 0xffff), SN(32, 0));
	RzILOpPure *op_NOT_249 = LOGNOT(op_LSHIFT_248);
	RzILOpPure *op_AND_251 = LOGAND(CAST(64, MSB(READ_REG(pkt, Rd_op, true)), READ_REG(pkt, Rd_op, true)), op_NOT_249);
	RzILOpPure *op_RSHIFT_352 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_354 = LOGAND(op_RSHIFT_352, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_360 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_362 = LOGAND(op_RSHIFT_360, SN(32, 0xffff));
	RzILOpPure *op_MUL_365 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_354), DUP(op_AND_354))), CAST(16, MSB(DUP(op_AND_354)), DUP(op_AND_354))), CAST(32, MSB(CAST(16, MSB(op_AND_362), DUP(op_AND_362))), CAST(16, MSB(DUP(op_AND_362)), DUP(op_AND_362))));
	RzILOpPure *op_LSHIFT_368 = SHIFTL0(CAST(64, MSB(op_MUL_365), DUP(op_MUL_365)), SN(32, 0));
	RzILOpPure *op_RSHIFT_372 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_374 = LOGAND(op_RSHIFT_372, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_380 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_382 = LOGAND(op_RSHIFT_380, SN(32, 0xffff));
	RzILOpPure *op_MUL_385 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_374), DUP(op_AND_374))), CAST(16, MSB(DUP(op_AND_374)), DUP(op_AND_374))), CAST(32, MSB(CAST(16, MSB(op_AND_382), DUP(op_AND_382))), CAST(16, MSB(DUP(op_AND_382)), DUP(op_AND_382))));
	RzILOpPure *op_LSHIFT_388 = SHIFTL0(CAST(64, MSB(op_MUL_385), DUP(op_MUL_385)), SN(32, 0));
	RzILOpPure *op_ADD_389 = ADD(op_LSHIFT_368, op_LSHIFT_388);
	RzILOpPure *op_ADD_392 = ADD(op_ADD_389, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *cond_462 = ITE(DUP(op_EQ_348), op_ADD_392, VARL("h_tmp245"));
	RzILOpPure *op_RSHIFT_466 = SHIFTRA(cond_462, SN(32, 16));
	RzILOpPure *op_AND_469 = LOGAND(op_RSHIFT_466, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_AND_473 = LOGAND(CAST(32, MSB(CAST(16, MSB(op_AND_469), DUP(op_AND_469))), CAST(16, MSB(DUP(op_AND_469)), DUP(op_AND_469))), SN(32, 0xffff));
	RzILOpPure *op_LSHIFT_478 = SHIFTL0(CAST(64, IL_FALSE, op_AND_473), SN(32, 0));
	RzILOpPure *op_OR_480 = LOGOR(CAST(64, IL_FALSE, op_AND_251), op_LSHIFT_478);
	RzILOpEffect *op_ASSIGN_482 = WRITE_REG(bundle, Rd_op, CAST(32, IL_FALSE, op_OR_480));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_483 = SEQN(2, seq_461, op_ASSIGN_482);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_242, seq_483);
	return instruction_sequence;
}

// Rd = cmpy(Rs,Rt*):<<1:rnd:sat
RzILOpEffect *hex_il_op_m2_cmpyrsc_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_154 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_16 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_18 = LOGAND(op_RSHIFT_16, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_25 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_27 = LOGAND(op_RSHIFT_25, SN(32, 0xffff));
	RzILOpPure *op_MUL_30 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_18), DUP(op_AND_18))), CAST(16, MSB(DUP(op_AND_18)), DUP(op_AND_18))), CAST(32, MSB(CAST(16, MSB(op_AND_27), DUP(op_AND_27))), CAST(16, MSB(DUP(op_AND_27)), DUP(op_AND_27))));
	RzILOpPure *op_LSHIFT_33 = SHIFTL0(CAST(64, MSB(op_MUL_30), DUP(op_MUL_30)), SN(32, 1));
	RzILOpPure *op_RSHIFT_37 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_39 = LOGAND(op_RSHIFT_37, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_45 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_47 = LOGAND(op_RSHIFT_45, SN(32, 0xffff));
	RzILOpPure *op_MUL_50 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_39), DUP(op_AND_39))), CAST(16, MSB(DUP(op_AND_39)), DUP(op_AND_39))), CAST(32, MSB(CAST(16, MSB(op_AND_47), DUP(op_AND_47))), CAST(16, MSB(DUP(op_AND_47)), DUP(op_AND_47))));
	RzILOpPure *op_LSHIFT_53 = SHIFTL0(CAST(64, MSB(op_MUL_50), DUP(op_MUL_50)), SN(32, 1));
	RzILOpPure *op_SUB_54 = SUB(op_LSHIFT_33, op_LSHIFT_53);
	RzILOpPure *op_ADD_57 = ADD(op_SUB_54, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_66 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_68 = LOGAND(op_RSHIFT_66, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_74 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_76 = LOGAND(op_RSHIFT_74, SN(32, 0xffff));
	RzILOpPure *op_MUL_79 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_68), DUP(op_AND_68))), CAST(16, MSB(DUP(op_AND_68)), DUP(op_AND_68))), CAST(32, MSB(CAST(16, MSB(op_AND_76), DUP(op_AND_76))), CAST(16, MSB(DUP(op_AND_76)), DUP(op_AND_76))));
	RzILOpPure *op_LSHIFT_82 = SHIFTL0(CAST(64, MSB(op_MUL_79), DUP(op_MUL_79)), SN(32, 1));
	RzILOpPure *op_RSHIFT_86 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_88 = LOGAND(op_RSHIFT_86, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_94 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_96 = LOGAND(op_RSHIFT_94, SN(32, 0xffff));
	RzILOpPure *op_MUL_99 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_88), DUP(op_AND_88))), CAST(16, MSB(DUP(op_AND_88)), DUP(op_AND_88))), CAST(32, MSB(CAST(16, MSB(op_AND_96), DUP(op_AND_96))), CAST(16, MSB(DUP(op_AND_96)), DUP(op_AND_96))));
	RzILOpPure *op_LSHIFT_102 = SHIFTL0(CAST(64, MSB(op_MUL_99), DUP(op_MUL_99)), SN(32, 1));
	RzILOpPure *op_SUB_103 = SUB(op_LSHIFT_82, op_LSHIFT_102);
	RzILOpPure *op_ADD_106 = ADD(op_SUB_103, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_EQ_107 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_57), SN(32, 0), SN(32, 0x20)), op_ADD_106);
	RzILOpPure *op_RSHIFT_158 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_160 = LOGAND(op_RSHIFT_158, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_166 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_168 = LOGAND(op_RSHIFT_166, SN(32, 0xffff));
	RzILOpPure *op_MUL_171 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_160), DUP(op_AND_160))), CAST(16, MSB(DUP(op_AND_160)), DUP(op_AND_160))), CAST(32, MSB(CAST(16, MSB(op_AND_168), DUP(op_AND_168))), CAST(16, MSB(DUP(op_AND_168)), DUP(op_AND_168))));
	RzILOpPure *op_LSHIFT_174 = SHIFTL0(CAST(64, MSB(op_MUL_171), DUP(op_MUL_171)), SN(32, 1));
	RzILOpPure *op_RSHIFT_178 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_180 = LOGAND(op_RSHIFT_178, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_186 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_188 = LOGAND(op_RSHIFT_186, SN(32, 0xffff));
	RzILOpPure *op_MUL_191 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_180), DUP(op_AND_180))), CAST(16, MSB(DUP(op_AND_180)), DUP(op_AND_180))), CAST(32, MSB(CAST(16, MSB(op_AND_188), DUP(op_AND_188))), CAST(16, MSB(DUP(op_AND_188)), DUP(op_AND_188))));
	RzILOpPure *op_LSHIFT_194 = SHIFTL0(CAST(64, MSB(op_MUL_191), DUP(op_MUL_191)), SN(32, 1));
	RzILOpPure *op_SUB_195 = SUB(op_LSHIFT_174, op_LSHIFT_194);
	RzILOpPure *op_ADD_198 = ADD(op_SUB_195, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_LT_201 = SLT(op_ADD_198, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_206 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_207 = NEG(op_LSHIFT_206);
	RzILOpPure *op_LSHIFT_212 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_215 = SUB(op_LSHIFT_212, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_216 = ITE(op_LT_201, op_NEG_207, op_SUB_215);
	RzILOpEffect *gcc_expr_217 = BRANCH(op_EQ_107, EMPTY(), set_usr_field_call_154);

	// h_tmp246 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_219 = SETL("h_tmp246", cond_216);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_220 = SEQN(2, gcc_expr_217, op_ASSIGN_hybrid_tmp_219);

	// Rd = ((st32) (((ut64) (((st64) Rd) & (~(0xffff << 0x10)))) | (((ut64) (((st32) ((st16) ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000)) ? (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000) : h_tmp246) >> 0x10) & ((st64) 0xffff)))) & 0xffff)) << 0x10)));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffff), SN(32, 16));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_8 = LOGAND(CAST(64, MSB(READ_REG(pkt, Rd_op, true)), READ_REG(pkt, Rd_op, true)), op_NOT_6);
	RzILOpPure *op_RSHIFT_111 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_113 = LOGAND(op_RSHIFT_111, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_119 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_121 = LOGAND(op_RSHIFT_119, SN(32, 0xffff));
	RzILOpPure *op_MUL_124 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_113), DUP(op_AND_113))), CAST(16, MSB(DUP(op_AND_113)), DUP(op_AND_113))), CAST(32, MSB(CAST(16, MSB(op_AND_121), DUP(op_AND_121))), CAST(16, MSB(DUP(op_AND_121)), DUP(op_AND_121))));
	RzILOpPure *op_LSHIFT_127 = SHIFTL0(CAST(64, MSB(op_MUL_124), DUP(op_MUL_124)), SN(32, 1));
	RzILOpPure *op_RSHIFT_131 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_133 = LOGAND(op_RSHIFT_131, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_139 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_141 = LOGAND(op_RSHIFT_139, SN(32, 0xffff));
	RzILOpPure *op_MUL_144 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_133), DUP(op_AND_133))), CAST(16, MSB(DUP(op_AND_133)), DUP(op_AND_133))), CAST(32, MSB(CAST(16, MSB(op_AND_141), DUP(op_AND_141))), CAST(16, MSB(DUP(op_AND_141)), DUP(op_AND_141))));
	RzILOpPure *op_LSHIFT_147 = SHIFTL0(CAST(64, MSB(op_MUL_144), DUP(op_MUL_144)), SN(32, 1));
	RzILOpPure *op_SUB_148 = SUB(op_LSHIFT_127, op_LSHIFT_147);
	RzILOpPure *op_ADD_151 = ADD(op_SUB_148, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *cond_221 = ITE(DUP(op_EQ_107), op_ADD_151, VARL("h_tmp246"));
	RzILOpPure *op_RSHIFT_225 = SHIFTRA(cond_221, SN(32, 16));
	RzILOpPure *op_AND_228 = LOGAND(op_RSHIFT_225, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_AND_232 = LOGAND(CAST(32, MSB(CAST(16, MSB(op_AND_228), DUP(op_AND_228))), CAST(16, MSB(DUP(op_AND_228)), DUP(op_AND_228))), SN(32, 0xffff));
	RzILOpPure *op_LSHIFT_237 = SHIFTL0(CAST(64, IL_FALSE, op_AND_232), SN(32, 16));
	RzILOpPure *op_OR_239 = LOGOR(CAST(64, IL_FALSE, op_AND_8), op_LSHIFT_237);
	RzILOpEffect *op_ASSIGN_241 = WRITE_REG(bundle, Rd_op, CAST(32, IL_FALSE, op_OR_239));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_242 = SEQN(2, seq_220, op_ASSIGN_241);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_395 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_258 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_260 = LOGAND(op_RSHIFT_258, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_266 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_268 = LOGAND(op_RSHIFT_266, SN(32, 0xffff));
	RzILOpPure *op_MUL_271 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_260), DUP(op_AND_260))), CAST(16, MSB(DUP(op_AND_260)), DUP(op_AND_260))), CAST(32, MSB(CAST(16, MSB(op_AND_268), DUP(op_AND_268))), CAST(16, MSB(DUP(op_AND_268)), DUP(op_AND_268))));
	RzILOpPure *op_LSHIFT_274 = SHIFTL0(CAST(64, MSB(op_MUL_271), DUP(op_MUL_271)), SN(32, 1));
	RzILOpPure *op_RSHIFT_278 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_280 = LOGAND(op_RSHIFT_278, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_286 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_288 = LOGAND(op_RSHIFT_286, SN(32, 0xffff));
	RzILOpPure *op_MUL_291 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_280), DUP(op_AND_280))), CAST(16, MSB(DUP(op_AND_280)), DUP(op_AND_280))), CAST(32, MSB(CAST(16, MSB(op_AND_288), DUP(op_AND_288))), CAST(16, MSB(DUP(op_AND_288)), DUP(op_AND_288))));
	RzILOpPure *op_LSHIFT_294 = SHIFTL0(CAST(64, MSB(op_MUL_291), DUP(op_MUL_291)), SN(32, 1));
	RzILOpPure *op_ADD_295 = ADD(op_LSHIFT_274, op_LSHIFT_294);
	RzILOpPure *op_ADD_298 = ADD(op_ADD_295, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_307 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_309 = LOGAND(op_RSHIFT_307, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_315 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_317 = LOGAND(op_RSHIFT_315, SN(32, 0xffff));
	RzILOpPure *op_MUL_320 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_309), DUP(op_AND_309))), CAST(16, MSB(DUP(op_AND_309)), DUP(op_AND_309))), CAST(32, MSB(CAST(16, MSB(op_AND_317), DUP(op_AND_317))), CAST(16, MSB(DUP(op_AND_317)), DUP(op_AND_317))));
	RzILOpPure *op_LSHIFT_323 = SHIFTL0(CAST(64, MSB(op_MUL_320), DUP(op_MUL_320)), SN(32, 1));
	RzILOpPure *op_RSHIFT_327 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_329 = LOGAND(op_RSHIFT_327, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_335 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_337 = LOGAND(op_RSHIFT_335, SN(32, 0xffff));
	RzILOpPure *op_MUL_340 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_329), DUP(op_AND_329))), CAST(16, MSB(DUP(op_AND_329)), DUP(op_AND_329))), CAST(32, MSB(CAST(16, MSB(op_AND_337), DUP(op_AND_337))), CAST(16, MSB(DUP(op_AND_337)), DUP(op_AND_337))));
	RzILOpPure *op_LSHIFT_343 = SHIFTL0(CAST(64, MSB(op_MUL_340), DUP(op_MUL_340)), SN(32, 1));
	RzILOpPure *op_ADD_344 = ADD(op_LSHIFT_323, op_LSHIFT_343);
	RzILOpPure *op_ADD_347 = ADD(op_ADD_344, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_EQ_348 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_298), SN(32, 0), SN(32, 0x20)), op_ADD_347);
	RzILOpPure *op_RSHIFT_399 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_401 = LOGAND(op_RSHIFT_399, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_407 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_409 = LOGAND(op_RSHIFT_407, SN(32, 0xffff));
	RzILOpPure *op_MUL_412 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_401), DUP(op_AND_401))), CAST(16, MSB(DUP(op_AND_401)), DUP(op_AND_401))), CAST(32, MSB(CAST(16, MSB(op_AND_409), DUP(op_AND_409))), CAST(16, MSB(DUP(op_AND_409)), DUP(op_AND_409))));
	RzILOpPure *op_LSHIFT_415 = SHIFTL0(CAST(64, MSB(op_MUL_412), DUP(op_MUL_412)), SN(32, 1));
	RzILOpPure *op_RSHIFT_419 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_421 = LOGAND(op_RSHIFT_419, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_427 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_429 = LOGAND(op_RSHIFT_427, SN(32, 0xffff));
	RzILOpPure *op_MUL_432 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_421), DUP(op_AND_421))), CAST(16, MSB(DUP(op_AND_421)), DUP(op_AND_421))), CAST(32, MSB(CAST(16, MSB(op_AND_429), DUP(op_AND_429))), CAST(16, MSB(DUP(op_AND_429)), DUP(op_AND_429))));
	RzILOpPure *op_LSHIFT_435 = SHIFTL0(CAST(64, MSB(op_MUL_432), DUP(op_MUL_432)), SN(32, 1));
	RzILOpPure *op_ADD_436 = ADD(op_LSHIFT_415, op_LSHIFT_435);
	RzILOpPure *op_ADD_439 = ADD(op_ADD_436, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_LT_442 = SLT(op_ADD_439, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_447 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_448 = NEG(op_LSHIFT_447);
	RzILOpPure *op_LSHIFT_453 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_456 = SUB(op_LSHIFT_453, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_457 = ITE(op_LT_442, op_NEG_448, op_SUB_456);
	RzILOpEffect *gcc_expr_458 = BRANCH(op_EQ_348, EMPTY(), set_usr_field_call_395);

	// h_tmp247 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_460 = SETL("h_tmp247", cond_457);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_461 = SEQN(2, gcc_expr_458, op_ASSIGN_hybrid_tmp_460);

	// Rd = ((st32) (((ut64) (((st64) Rd) & (~(0xffff << 0x0)))) | (((ut64) (((st32) ((st16) ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000)) ? (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000) : h_tmp247) >> 0x10) & ((st64) 0xffff)))) & 0xffff)) << 0x0)));
	RzILOpPure *op_LSHIFT_248 = SHIFTL0(SN(64, 0xffff), SN(32, 0));
	RzILOpPure *op_NOT_249 = LOGNOT(op_LSHIFT_248);
	RzILOpPure *op_AND_251 = LOGAND(CAST(64, MSB(READ_REG(pkt, Rd_op, true)), READ_REG(pkt, Rd_op, true)), op_NOT_249);
	RzILOpPure *op_RSHIFT_352 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_354 = LOGAND(op_RSHIFT_352, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_360 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_362 = LOGAND(op_RSHIFT_360, SN(32, 0xffff));
	RzILOpPure *op_MUL_365 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_354), DUP(op_AND_354))), CAST(16, MSB(DUP(op_AND_354)), DUP(op_AND_354))), CAST(32, MSB(CAST(16, MSB(op_AND_362), DUP(op_AND_362))), CAST(16, MSB(DUP(op_AND_362)), DUP(op_AND_362))));
	RzILOpPure *op_LSHIFT_368 = SHIFTL0(CAST(64, MSB(op_MUL_365), DUP(op_MUL_365)), SN(32, 1));
	RzILOpPure *op_RSHIFT_372 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_374 = LOGAND(op_RSHIFT_372, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_380 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_382 = LOGAND(op_RSHIFT_380, SN(32, 0xffff));
	RzILOpPure *op_MUL_385 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_374), DUP(op_AND_374))), CAST(16, MSB(DUP(op_AND_374)), DUP(op_AND_374))), CAST(32, MSB(CAST(16, MSB(op_AND_382), DUP(op_AND_382))), CAST(16, MSB(DUP(op_AND_382)), DUP(op_AND_382))));
	RzILOpPure *op_LSHIFT_388 = SHIFTL0(CAST(64, MSB(op_MUL_385), DUP(op_MUL_385)), SN(32, 1));
	RzILOpPure *op_ADD_389 = ADD(op_LSHIFT_368, op_LSHIFT_388);
	RzILOpPure *op_ADD_392 = ADD(op_ADD_389, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *cond_462 = ITE(DUP(op_EQ_348), op_ADD_392, VARL("h_tmp247"));
	RzILOpPure *op_RSHIFT_466 = SHIFTRA(cond_462, SN(32, 16));
	RzILOpPure *op_AND_469 = LOGAND(op_RSHIFT_466, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_AND_473 = LOGAND(CAST(32, MSB(CAST(16, MSB(op_AND_469), DUP(op_AND_469))), CAST(16, MSB(DUP(op_AND_469)), DUP(op_AND_469))), SN(32, 0xffff));
	RzILOpPure *op_LSHIFT_478 = SHIFTL0(CAST(64, IL_FALSE, op_AND_473), SN(32, 0));
	RzILOpPure *op_OR_480 = LOGOR(CAST(64, IL_FALSE, op_AND_251), op_LSHIFT_478);
	RzILOpEffect *op_ASSIGN_482 = WRITE_REG(bundle, Rd_op, CAST(32, IL_FALSE, op_OR_480));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_483 = SEQN(2, seq_461, op_ASSIGN_482);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_242, seq_483);
	return instruction_sequence;
}

// Rdd = cmpy(Rs,Rt):sat
RzILOpEffect *hex_il_op_m2_cmpys_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_144 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_17 = LOGAND(op_RSHIFT_15, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_24 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_26 = LOGAND(op_RSHIFT_24, SN(32, 0xffff));
	RzILOpPure *op_MUL_29 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_17), DUP(op_AND_17))), CAST(16, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(CAST(16, MSB(op_AND_26), DUP(op_AND_26))), CAST(16, MSB(DUP(op_AND_26)), DUP(op_AND_26))));
	RzILOpPure *op_LSHIFT_32 = SHIFTL0(CAST(64, MSB(op_MUL_29), DUP(op_MUL_29)), SN(32, 0));
	RzILOpPure *op_RSHIFT_36 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_38 = LOGAND(op_RSHIFT_36, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_44 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_46 = LOGAND(op_RSHIFT_44, SN(32, 0xffff));
	RzILOpPure *op_MUL_49 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_38), DUP(op_AND_38))), CAST(16, MSB(DUP(op_AND_38)), DUP(op_AND_38))), CAST(32, MSB(CAST(16, MSB(op_AND_46), DUP(op_AND_46))), CAST(16, MSB(DUP(op_AND_46)), DUP(op_AND_46))));
	RzILOpPure *op_LSHIFT_52 = SHIFTL0(CAST(64, MSB(op_MUL_49), DUP(op_MUL_49)), SN(32, 0));
	RzILOpPure *op_ADD_53 = ADD(op_LSHIFT_32, op_LSHIFT_52);
	RzILOpPure *op_RSHIFT_62 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_64 = LOGAND(op_RSHIFT_62, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_70 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_72 = LOGAND(op_RSHIFT_70, SN(32, 0xffff));
	RzILOpPure *op_MUL_75 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_64), DUP(op_AND_64))), CAST(16, MSB(DUP(op_AND_64)), DUP(op_AND_64))), CAST(32, MSB(CAST(16, MSB(op_AND_72), DUP(op_AND_72))), CAST(16, MSB(DUP(op_AND_72)), DUP(op_AND_72))));
	RzILOpPure *op_LSHIFT_78 = SHIFTL0(CAST(64, MSB(op_MUL_75), DUP(op_MUL_75)), SN(32, 0));
	RzILOpPure *op_RSHIFT_82 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_84 = LOGAND(op_RSHIFT_82, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_90 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_92 = LOGAND(op_RSHIFT_90, SN(32, 0xffff));
	RzILOpPure *op_MUL_95 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_84), DUP(op_AND_84))), CAST(16, MSB(DUP(op_AND_84)), DUP(op_AND_84))), CAST(32, MSB(CAST(16, MSB(op_AND_92), DUP(op_AND_92))), CAST(16, MSB(DUP(op_AND_92)), DUP(op_AND_92))));
	RzILOpPure *op_LSHIFT_98 = SHIFTL0(CAST(64, MSB(op_MUL_95), DUP(op_MUL_95)), SN(32, 0));
	RzILOpPure *op_ADD_99 = ADD(op_LSHIFT_78, op_LSHIFT_98);
	RzILOpPure *op_EQ_100 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_53), SN(32, 0), SN(32, 0x20)), op_ADD_99);
	RzILOpPure *op_RSHIFT_148 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_150 = LOGAND(op_RSHIFT_148, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_156 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_158 = LOGAND(op_RSHIFT_156, SN(32, 0xffff));
	RzILOpPure *op_MUL_161 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_150), DUP(op_AND_150))), CAST(16, MSB(DUP(op_AND_150)), DUP(op_AND_150))), CAST(32, MSB(CAST(16, MSB(op_AND_158), DUP(op_AND_158))), CAST(16, MSB(DUP(op_AND_158)), DUP(op_AND_158))));
	RzILOpPure *op_LSHIFT_164 = SHIFTL0(CAST(64, MSB(op_MUL_161), DUP(op_MUL_161)), SN(32, 0));
	RzILOpPure *op_RSHIFT_168 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_170 = LOGAND(op_RSHIFT_168, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_176 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_178 = LOGAND(op_RSHIFT_176, SN(32, 0xffff));
	RzILOpPure *op_MUL_181 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_170), DUP(op_AND_170))), CAST(16, MSB(DUP(op_AND_170)), DUP(op_AND_170))), CAST(32, MSB(CAST(16, MSB(op_AND_178), DUP(op_AND_178))), CAST(16, MSB(DUP(op_AND_178)), DUP(op_AND_178))));
	RzILOpPure *op_LSHIFT_184 = SHIFTL0(CAST(64, MSB(op_MUL_181), DUP(op_MUL_181)), SN(32, 0));
	RzILOpPure *op_ADD_185 = ADD(op_LSHIFT_164, op_LSHIFT_184);
	RzILOpPure *op_LT_188 = SLT(op_ADD_185, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_193 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_194 = NEG(op_LSHIFT_193);
	RzILOpPure *op_LSHIFT_199 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_202 = SUB(op_LSHIFT_199, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_203 = ITE(op_LT_188, op_NEG_194, op_SUB_202);
	RzILOpEffect *gcc_expr_204 = BRANCH(op_EQ_100, EMPTY(), set_usr_field_call_144);

	// h_tmp248 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_206 = SETL("h_tmp248", cond_203);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_207 = SEQN(2, gcc_expr_204, op_ASSIGN_hybrid_tmp_206);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)) ? (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) : h_tmp248) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_104 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_106 = LOGAND(op_RSHIFT_104, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_112 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_114 = LOGAND(op_RSHIFT_112, SN(32, 0xffff));
	RzILOpPure *op_MUL_117 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_106), DUP(op_AND_106))), CAST(16, MSB(DUP(op_AND_106)), DUP(op_AND_106))), CAST(32, MSB(CAST(16, MSB(op_AND_114), DUP(op_AND_114))), CAST(16, MSB(DUP(op_AND_114)), DUP(op_AND_114))));
	RzILOpPure *op_LSHIFT_120 = SHIFTL0(CAST(64, MSB(op_MUL_117), DUP(op_MUL_117)), SN(32, 0));
	RzILOpPure *op_RSHIFT_124 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_126 = LOGAND(op_RSHIFT_124, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_132 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_134 = LOGAND(op_RSHIFT_132, SN(32, 0xffff));
	RzILOpPure *op_MUL_137 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_126), DUP(op_AND_126))), CAST(16, MSB(DUP(op_AND_126)), DUP(op_AND_126))), CAST(32, MSB(CAST(16, MSB(op_AND_134), DUP(op_AND_134))), CAST(16, MSB(DUP(op_AND_134)), DUP(op_AND_134))));
	RzILOpPure *op_LSHIFT_140 = SHIFTL0(CAST(64, MSB(op_MUL_137), DUP(op_MUL_137)), SN(32, 0));
	RzILOpPure *op_ADD_141 = ADD(op_LSHIFT_120, op_LSHIFT_140);
	RzILOpPure *cond_208 = ITE(DUP(op_EQ_100), op_ADD_141, VARL("h_tmp248"));
	RzILOpPure *op_AND_210 = LOGAND(cond_208, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_214 = SHIFTL0(op_AND_210, SN(32, 0x20));
	RzILOpPure *op_OR_215 = LOGOR(op_AND_7, op_LSHIFT_214);
	RzILOpEffect *op_ASSIGN_216 = WRITE_REG(bundle, Rdd_op, op_OR_215);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_217 = SEQN(2, seq_207, op_ASSIGN_216);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_360 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_232 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_234 = LOGAND(op_RSHIFT_232, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_240 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_242 = LOGAND(op_RSHIFT_240, SN(32, 0xffff));
	RzILOpPure *op_MUL_245 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_234), DUP(op_AND_234))), CAST(16, MSB(DUP(op_AND_234)), DUP(op_AND_234))), CAST(32, MSB(CAST(16, MSB(op_AND_242), DUP(op_AND_242))), CAST(16, MSB(DUP(op_AND_242)), DUP(op_AND_242))));
	RzILOpPure *op_LSHIFT_248 = SHIFTL0(CAST(64, MSB(op_MUL_245), DUP(op_MUL_245)), SN(32, 0));
	RzILOpPure *op_RSHIFT_252 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_254 = LOGAND(op_RSHIFT_252, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_260 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_262 = LOGAND(op_RSHIFT_260, SN(32, 0xffff));
	RzILOpPure *op_MUL_265 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_254), DUP(op_AND_254))), CAST(16, MSB(DUP(op_AND_254)), DUP(op_AND_254))), CAST(32, MSB(CAST(16, MSB(op_AND_262), DUP(op_AND_262))), CAST(16, MSB(DUP(op_AND_262)), DUP(op_AND_262))));
	RzILOpPure *op_LSHIFT_268 = SHIFTL0(CAST(64, MSB(op_MUL_265), DUP(op_MUL_265)), SN(32, 0));
	RzILOpPure *op_SUB_269 = SUB(op_LSHIFT_248, op_LSHIFT_268);
	RzILOpPure *op_RSHIFT_278 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_280 = LOGAND(op_RSHIFT_278, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_286 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_288 = LOGAND(op_RSHIFT_286, SN(32, 0xffff));
	RzILOpPure *op_MUL_291 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_280), DUP(op_AND_280))), CAST(16, MSB(DUP(op_AND_280)), DUP(op_AND_280))), CAST(32, MSB(CAST(16, MSB(op_AND_288), DUP(op_AND_288))), CAST(16, MSB(DUP(op_AND_288)), DUP(op_AND_288))));
	RzILOpPure *op_LSHIFT_294 = SHIFTL0(CAST(64, MSB(op_MUL_291), DUP(op_MUL_291)), SN(32, 0));
	RzILOpPure *op_RSHIFT_298 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_300 = LOGAND(op_RSHIFT_298, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_306 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_308 = LOGAND(op_RSHIFT_306, SN(32, 0xffff));
	RzILOpPure *op_MUL_311 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_300), DUP(op_AND_300))), CAST(16, MSB(DUP(op_AND_300)), DUP(op_AND_300))), CAST(32, MSB(CAST(16, MSB(op_AND_308), DUP(op_AND_308))), CAST(16, MSB(DUP(op_AND_308)), DUP(op_AND_308))));
	RzILOpPure *op_LSHIFT_314 = SHIFTL0(CAST(64, MSB(op_MUL_311), DUP(op_MUL_311)), SN(32, 0));
	RzILOpPure *op_SUB_315 = SUB(op_LSHIFT_294, op_LSHIFT_314);
	RzILOpPure *op_EQ_316 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_SUB_269), SN(32, 0), SN(32, 0x20)), op_SUB_315);
	RzILOpPure *op_RSHIFT_364 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_366 = LOGAND(op_RSHIFT_364, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_372 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_374 = LOGAND(op_RSHIFT_372, SN(32, 0xffff));
	RzILOpPure *op_MUL_377 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_366), DUP(op_AND_366))), CAST(16, MSB(DUP(op_AND_366)), DUP(op_AND_366))), CAST(32, MSB(CAST(16, MSB(op_AND_374), DUP(op_AND_374))), CAST(16, MSB(DUP(op_AND_374)), DUP(op_AND_374))));
	RzILOpPure *op_LSHIFT_380 = SHIFTL0(CAST(64, MSB(op_MUL_377), DUP(op_MUL_377)), SN(32, 0));
	RzILOpPure *op_RSHIFT_384 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_386 = LOGAND(op_RSHIFT_384, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_392 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_394 = LOGAND(op_RSHIFT_392, SN(32, 0xffff));
	RzILOpPure *op_MUL_397 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_386), DUP(op_AND_386))), CAST(16, MSB(DUP(op_AND_386)), DUP(op_AND_386))), CAST(32, MSB(CAST(16, MSB(op_AND_394), DUP(op_AND_394))), CAST(16, MSB(DUP(op_AND_394)), DUP(op_AND_394))));
	RzILOpPure *op_LSHIFT_400 = SHIFTL0(CAST(64, MSB(op_MUL_397), DUP(op_MUL_397)), SN(32, 0));
	RzILOpPure *op_SUB_401 = SUB(op_LSHIFT_380, op_LSHIFT_400);
	RzILOpPure *op_LT_404 = SLT(op_SUB_401, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_409 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_410 = NEG(op_LSHIFT_409);
	RzILOpPure *op_LSHIFT_415 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_418 = SUB(op_LSHIFT_415, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_419 = ITE(op_LT_404, op_NEG_410, op_SUB_418);
	RzILOpEffect *gcc_expr_420 = BRANCH(op_EQ_316, EMPTY(), set_usr_field_call_360);

	// h_tmp249 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_422 = SETL("h_tmp249", cond_419);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_423 = SEQN(2, gcc_expr_420, op_ASSIGN_hybrid_tmp_422);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)) ? (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) : h_tmp249) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_223 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_224 = LOGNOT(op_LSHIFT_223);
	RzILOpPure *op_AND_225 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_224);
	RzILOpPure *op_RSHIFT_320 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_322 = LOGAND(op_RSHIFT_320, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_328 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_330 = LOGAND(op_RSHIFT_328, SN(32, 0xffff));
	RzILOpPure *op_MUL_333 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_322), DUP(op_AND_322))), CAST(16, MSB(DUP(op_AND_322)), DUP(op_AND_322))), CAST(32, MSB(CAST(16, MSB(op_AND_330), DUP(op_AND_330))), CAST(16, MSB(DUP(op_AND_330)), DUP(op_AND_330))));
	RzILOpPure *op_LSHIFT_336 = SHIFTL0(CAST(64, MSB(op_MUL_333), DUP(op_MUL_333)), SN(32, 0));
	RzILOpPure *op_RSHIFT_340 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_342 = LOGAND(op_RSHIFT_340, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_348 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_350 = LOGAND(op_RSHIFT_348, SN(32, 0xffff));
	RzILOpPure *op_MUL_353 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_342), DUP(op_AND_342))), CAST(16, MSB(DUP(op_AND_342)), DUP(op_AND_342))), CAST(32, MSB(CAST(16, MSB(op_AND_350), DUP(op_AND_350))), CAST(16, MSB(DUP(op_AND_350)), DUP(op_AND_350))));
	RzILOpPure *op_LSHIFT_356 = SHIFTL0(CAST(64, MSB(op_MUL_353), DUP(op_MUL_353)), SN(32, 0));
	RzILOpPure *op_SUB_357 = SUB(op_LSHIFT_336, op_LSHIFT_356);
	RzILOpPure *cond_424 = ITE(DUP(op_EQ_316), op_SUB_357, VARL("h_tmp249"));
	RzILOpPure *op_AND_426 = LOGAND(cond_424, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_430 = SHIFTL0(op_AND_426, SN(32, 0));
	RzILOpPure *op_OR_431 = LOGOR(op_AND_225, op_LSHIFT_430);
	RzILOpEffect *op_ASSIGN_432 = WRITE_REG(bundle, Rdd_op, op_OR_431);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_433 = SEQN(2, seq_423, op_ASSIGN_432);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_217, seq_433);
	return instruction_sequence;
}

// Rdd = cmpy(Rs,Rt):<<1:sat
RzILOpEffect *hex_il_op_m2_cmpys_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_144 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_17 = LOGAND(op_RSHIFT_15, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_24 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_26 = LOGAND(op_RSHIFT_24, SN(32, 0xffff));
	RzILOpPure *op_MUL_29 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_17), DUP(op_AND_17))), CAST(16, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(CAST(16, MSB(op_AND_26), DUP(op_AND_26))), CAST(16, MSB(DUP(op_AND_26)), DUP(op_AND_26))));
	RzILOpPure *op_LSHIFT_32 = SHIFTL0(CAST(64, MSB(op_MUL_29), DUP(op_MUL_29)), SN(32, 1));
	RzILOpPure *op_RSHIFT_36 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_38 = LOGAND(op_RSHIFT_36, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_44 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_46 = LOGAND(op_RSHIFT_44, SN(32, 0xffff));
	RzILOpPure *op_MUL_49 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_38), DUP(op_AND_38))), CAST(16, MSB(DUP(op_AND_38)), DUP(op_AND_38))), CAST(32, MSB(CAST(16, MSB(op_AND_46), DUP(op_AND_46))), CAST(16, MSB(DUP(op_AND_46)), DUP(op_AND_46))));
	RzILOpPure *op_LSHIFT_52 = SHIFTL0(CAST(64, MSB(op_MUL_49), DUP(op_MUL_49)), SN(32, 1));
	RzILOpPure *op_ADD_53 = ADD(op_LSHIFT_32, op_LSHIFT_52);
	RzILOpPure *op_RSHIFT_62 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_64 = LOGAND(op_RSHIFT_62, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_70 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_72 = LOGAND(op_RSHIFT_70, SN(32, 0xffff));
	RzILOpPure *op_MUL_75 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_64), DUP(op_AND_64))), CAST(16, MSB(DUP(op_AND_64)), DUP(op_AND_64))), CAST(32, MSB(CAST(16, MSB(op_AND_72), DUP(op_AND_72))), CAST(16, MSB(DUP(op_AND_72)), DUP(op_AND_72))));
	RzILOpPure *op_LSHIFT_78 = SHIFTL0(CAST(64, MSB(op_MUL_75), DUP(op_MUL_75)), SN(32, 1));
	RzILOpPure *op_RSHIFT_82 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_84 = LOGAND(op_RSHIFT_82, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_90 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_92 = LOGAND(op_RSHIFT_90, SN(32, 0xffff));
	RzILOpPure *op_MUL_95 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_84), DUP(op_AND_84))), CAST(16, MSB(DUP(op_AND_84)), DUP(op_AND_84))), CAST(32, MSB(CAST(16, MSB(op_AND_92), DUP(op_AND_92))), CAST(16, MSB(DUP(op_AND_92)), DUP(op_AND_92))));
	RzILOpPure *op_LSHIFT_98 = SHIFTL0(CAST(64, MSB(op_MUL_95), DUP(op_MUL_95)), SN(32, 1));
	RzILOpPure *op_ADD_99 = ADD(op_LSHIFT_78, op_LSHIFT_98);
	RzILOpPure *op_EQ_100 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_53), SN(32, 0), SN(32, 0x20)), op_ADD_99);
	RzILOpPure *op_RSHIFT_148 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_150 = LOGAND(op_RSHIFT_148, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_156 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_158 = LOGAND(op_RSHIFT_156, SN(32, 0xffff));
	RzILOpPure *op_MUL_161 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_150), DUP(op_AND_150))), CAST(16, MSB(DUP(op_AND_150)), DUP(op_AND_150))), CAST(32, MSB(CAST(16, MSB(op_AND_158), DUP(op_AND_158))), CAST(16, MSB(DUP(op_AND_158)), DUP(op_AND_158))));
	RzILOpPure *op_LSHIFT_164 = SHIFTL0(CAST(64, MSB(op_MUL_161), DUP(op_MUL_161)), SN(32, 1));
	RzILOpPure *op_RSHIFT_168 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_170 = LOGAND(op_RSHIFT_168, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_176 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_178 = LOGAND(op_RSHIFT_176, SN(32, 0xffff));
	RzILOpPure *op_MUL_181 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_170), DUP(op_AND_170))), CAST(16, MSB(DUP(op_AND_170)), DUP(op_AND_170))), CAST(32, MSB(CAST(16, MSB(op_AND_178), DUP(op_AND_178))), CAST(16, MSB(DUP(op_AND_178)), DUP(op_AND_178))));
	RzILOpPure *op_LSHIFT_184 = SHIFTL0(CAST(64, MSB(op_MUL_181), DUP(op_MUL_181)), SN(32, 1));
	RzILOpPure *op_ADD_185 = ADD(op_LSHIFT_164, op_LSHIFT_184);
	RzILOpPure *op_LT_188 = SLT(op_ADD_185, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_193 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_194 = NEG(op_LSHIFT_193);
	RzILOpPure *op_LSHIFT_199 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_202 = SUB(op_LSHIFT_199, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_203 = ITE(op_LT_188, op_NEG_194, op_SUB_202);
	RzILOpEffect *gcc_expr_204 = BRANCH(op_EQ_100, EMPTY(), set_usr_field_call_144);

	// h_tmp250 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_206 = SETL("h_tmp250", cond_203);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_207 = SEQN(2, gcc_expr_204, op_ASSIGN_hybrid_tmp_206);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)) ? (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) : h_tmp250) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_104 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_106 = LOGAND(op_RSHIFT_104, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_112 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_114 = LOGAND(op_RSHIFT_112, SN(32, 0xffff));
	RzILOpPure *op_MUL_117 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_106), DUP(op_AND_106))), CAST(16, MSB(DUP(op_AND_106)), DUP(op_AND_106))), CAST(32, MSB(CAST(16, MSB(op_AND_114), DUP(op_AND_114))), CAST(16, MSB(DUP(op_AND_114)), DUP(op_AND_114))));
	RzILOpPure *op_LSHIFT_120 = SHIFTL0(CAST(64, MSB(op_MUL_117), DUP(op_MUL_117)), SN(32, 1));
	RzILOpPure *op_RSHIFT_124 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_126 = LOGAND(op_RSHIFT_124, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_132 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_134 = LOGAND(op_RSHIFT_132, SN(32, 0xffff));
	RzILOpPure *op_MUL_137 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_126), DUP(op_AND_126))), CAST(16, MSB(DUP(op_AND_126)), DUP(op_AND_126))), CAST(32, MSB(CAST(16, MSB(op_AND_134), DUP(op_AND_134))), CAST(16, MSB(DUP(op_AND_134)), DUP(op_AND_134))));
	RzILOpPure *op_LSHIFT_140 = SHIFTL0(CAST(64, MSB(op_MUL_137), DUP(op_MUL_137)), SN(32, 1));
	RzILOpPure *op_ADD_141 = ADD(op_LSHIFT_120, op_LSHIFT_140);
	RzILOpPure *cond_208 = ITE(DUP(op_EQ_100), op_ADD_141, VARL("h_tmp250"));
	RzILOpPure *op_AND_210 = LOGAND(cond_208, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_214 = SHIFTL0(op_AND_210, SN(32, 0x20));
	RzILOpPure *op_OR_215 = LOGOR(op_AND_7, op_LSHIFT_214);
	RzILOpEffect *op_ASSIGN_216 = WRITE_REG(bundle, Rdd_op, op_OR_215);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_217 = SEQN(2, seq_207, op_ASSIGN_216);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_360 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_232 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_234 = LOGAND(op_RSHIFT_232, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_240 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_242 = LOGAND(op_RSHIFT_240, SN(32, 0xffff));
	RzILOpPure *op_MUL_245 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_234), DUP(op_AND_234))), CAST(16, MSB(DUP(op_AND_234)), DUP(op_AND_234))), CAST(32, MSB(CAST(16, MSB(op_AND_242), DUP(op_AND_242))), CAST(16, MSB(DUP(op_AND_242)), DUP(op_AND_242))));
	RzILOpPure *op_LSHIFT_248 = SHIFTL0(CAST(64, MSB(op_MUL_245), DUP(op_MUL_245)), SN(32, 1));
	RzILOpPure *op_RSHIFT_252 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_254 = LOGAND(op_RSHIFT_252, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_260 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_262 = LOGAND(op_RSHIFT_260, SN(32, 0xffff));
	RzILOpPure *op_MUL_265 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_254), DUP(op_AND_254))), CAST(16, MSB(DUP(op_AND_254)), DUP(op_AND_254))), CAST(32, MSB(CAST(16, MSB(op_AND_262), DUP(op_AND_262))), CAST(16, MSB(DUP(op_AND_262)), DUP(op_AND_262))));
	RzILOpPure *op_LSHIFT_268 = SHIFTL0(CAST(64, MSB(op_MUL_265), DUP(op_MUL_265)), SN(32, 1));
	RzILOpPure *op_SUB_269 = SUB(op_LSHIFT_248, op_LSHIFT_268);
	RzILOpPure *op_RSHIFT_278 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_280 = LOGAND(op_RSHIFT_278, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_286 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_288 = LOGAND(op_RSHIFT_286, SN(32, 0xffff));
	RzILOpPure *op_MUL_291 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_280), DUP(op_AND_280))), CAST(16, MSB(DUP(op_AND_280)), DUP(op_AND_280))), CAST(32, MSB(CAST(16, MSB(op_AND_288), DUP(op_AND_288))), CAST(16, MSB(DUP(op_AND_288)), DUP(op_AND_288))));
	RzILOpPure *op_LSHIFT_294 = SHIFTL0(CAST(64, MSB(op_MUL_291), DUP(op_MUL_291)), SN(32, 1));
	RzILOpPure *op_RSHIFT_298 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_300 = LOGAND(op_RSHIFT_298, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_306 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_308 = LOGAND(op_RSHIFT_306, SN(32, 0xffff));
	RzILOpPure *op_MUL_311 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_300), DUP(op_AND_300))), CAST(16, MSB(DUP(op_AND_300)), DUP(op_AND_300))), CAST(32, MSB(CAST(16, MSB(op_AND_308), DUP(op_AND_308))), CAST(16, MSB(DUP(op_AND_308)), DUP(op_AND_308))));
	RzILOpPure *op_LSHIFT_314 = SHIFTL0(CAST(64, MSB(op_MUL_311), DUP(op_MUL_311)), SN(32, 1));
	RzILOpPure *op_SUB_315 = SUB(op_LSHIFT_294, op_LSHIFT_314);
	RzILOpPure *op_EQ_316 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_SUB_269), SN(32, 0), SN(32, 0x20)), op_SUB_315);
	RzILOpPure *op_RSHIFT_364 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_366 = LOGAND(op_RSHIFT_364, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_372 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_374 = LOGAND(op_RSHIFT_372, SN(32, 0xffff));
	RzILOpPure *op_MUL_377 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_366), DUP(op_AND_366))), CAST(16, MSB(DUP(op_AND_366)), DUP(op_AND_366))), CAST(32, MSB(CAST(16, MSB(op_AND_374), DUP(op_AND_374))), CAST(16, MSB(DUP(op_AND_374)), DUP(op_AND_374))));
	RzILOpPure *op_LSHIFT_380 = SHIFTL0(CAST(64, MSB(op_MUL_377), DUP(op_MUL_377)), SN(32, 1));
	RzILOpPure *op_RSHIFT_384 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_386 = LOGAND(op_RSHIFT_384, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_392 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_394 = LOGAND(op_RSHIFT_392, SN(32, 0xffff));
	RzILOpPure *op_MUL_397 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_386), DUP(op_AND_386))), CAST(16, MSB(DUP(op_AND_386)), DUP(op_AND_386))), CAST(32, MSB(CAST(16, MSB(op_AND_394), DUP(op_AND_394))), CAST(16, MSB(DUP(op_AND_394)), DUP(op_AND_394))));
	RzILOpPure *op_LSHIFT_400 = SHIFTL0(CAST(64, MSB(op_MUL_397), DUP(op_MUL_397)), SN(32, 1));
	RzILOpPure *op_SUB_401 = SUB(op_LSHIFT_380, op_LSHIFT_400);
	RzILOpPure *op_LT_404 = SLT(op_SUB_401, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_409 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_410 = NEG(op_LSHIFT_409);
	RzILOpPure *op_LSHIFT_415 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_418 = SUB(op_LSHIFT_415, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_419 = ITE(op_LT_404, op_NEG_410, op_SUB_418);
	RzILOpEffect *gcc_expr_420 = BRANCH(op_EQ_316, EMPTY(), set_usr_field_call_360);

	// h_tmp251 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_422 = SETL("h_tmp251", cond_419);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_423 = SEQN(2, gcc_expr_420, op_ASSIGN_hybrid_tmp_422);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)) ? (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) : h_tmp251) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_223 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_224 = LOGNOT(op_LSHIFT_223);
	RzILOpPure *op_AND_225 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_224);
	RzILOpPure *op_RSHIFT_320 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_322 = LOGAND(op_RSHIFT_320, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_328 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_330 = LOGAND(op_RSHIFT_328, SN(32, 0xffff));
	RzILOpPure *op_MUL_333 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_322), DUP(op_AND_322))), CAST(16, MSB(DUP(op_AND_322)), DUP(op_AND_322))), CAST(32, MSB(CAST(16, MSB(op_AND_330), DUP(op_AND_330))), CAST(16, MSB(DUP(op_AND_330)), DUP(op_AND_330))));
	RzILOpPure *op_LSHIFT_336 = SHIFTL0(CAST(64, MSB(op_MUL_333), DUP(op_MUL_333)), SN(32, 1));
	RzILOpPure *op_RSHIFT_340 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_342 = LOGAND(op_RSHIFT_340, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_348 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_350 = LOGAND(op_RSHIFT_348, SN(32, 0xffff));
	RzILOpPure *op_MUL_353 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_342), DUP(op_AND_342))), CAST(16, MSB(DUP(op_AND_342)), DUP(op_AND_342))), CAST(32, MSB(CAST(16, MSB(op_AND_350), DUP(op_AND_350))), CAST(16, MSB(DUP(op_AND_350)), DUP(op_AND_350))));
	RzILOpPure *op_LSHIFT_356 = SHIFTL0(CAST(64, MSB(op_MUL_353), DUP(op_MUL_353)), SN(32, 1));
	RzILOpPure *op_SUB_357 = SUB(op_LSHIFT_336, op_LSHIFT_356);
	RzILOpPure *cond_424 = ITE(DUP(op_EQ_316), op_SUB_357, VARL("h_tmp251"));
	RzILOpPure *op_AND_426 = LOGAND(cond_424, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_430 = SHIFTL0(op_AND_426, SN(32, 0));
	RzILOpPure *op_OR_431 = LOGOR(op_AND_225, op_LSHIFT_430);
	RzILOpEffect *op_ASSIGN_432 = WRITE_REG(bundle, Rdd_op, op_OR_431);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_433 = SEQN(2, seq_423, op_ASSIGN_432);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_217, seq_433);
	return instruction_sequence;
}

// Rdd = cmpy(Rs,Rt*):sat
RzILOpEffect *hex_il_op_m2_cmpysc_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_144 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_17 = LOGAND(op_RSHIFT_15, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_24 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_26 = LOGAND(op_RSHIFT_24, SN(32, 0xffff));
	RzILOpPure *op_MUL_29 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_17), DUP(op_AND_17))), CAST(16, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(CAST(16, MSB(op_AND_26), DUP(op_AND_26))), CAST(16, MSB(DUP(op_AND_26)), DUP(op_AND_26))));
	RzILOpPure *op_LSHIFT_32 = SHIFTL0(CAST(64, MSB(op_MUL_29), DUP(op_MUL_29)), SN(32, 0));
	RzILOpPure *op_RSHIFT_36 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_38 = LOGAND(op_RSHIFT_36, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_44 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_46 = LOGAND(op_RSHIFT_44, SN(32, 0xffff));
	RzILOpPure *op_MUL_49 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_38), DUP(op_AND_38))), CAST(16, MSB(DUP(op_AND_38)), DUP(op_AND_38))), CAST(32, MSB(CAST(16, MSB(op_AND_46), DUP(op_AND_46))), CAST(16, MSB(DUP(op_AND_46)), DUP(op_AND_46))));
	RzILOpPure *op_LSHIFT_52 = SHIFTL0(CAST(64, MSB(op_MUL_49), DUP(op_MUL_49)), SN(32, 0));
	RzILOpPure *op_SUB_53 = SUB(op_LSHIFT_32, op_LSHIFT_52);
	RzILOpPure *op_RSHIFT_62 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_64 = LOGAND(op_RSHIFT_62, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_70 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_72 = LOGAND(op_RSHIFT_70, SN(32, 0xffff));
	RzILOpPure *op_MUL_75 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_64), DUP(op_AND_64))), CAST(16, MSB(DUP(op_AND_64)), DUP(op_AND_64))), CAST(32, MSB(CAST(16, MSB(op_AND_72), DUP(op_AND_72))), CAST(16, MSB(DUP(op_AND_72)), DUP(op_AND_72))));
	RzILOpPure *op_LSHIFT_78 = SHIFTL0(CAST(64, MSB(op_MUL_75), DUP(op_MUL_75)), SN(32, 0));
	RzILOpPure *op_RSHIFT_82 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_84 = LOGAND(op_RSHIFT_82, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_90 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_92 = LOGAND(op_RSHIFT_90, SN(32, 0xffff));
	RzILOpPure *op_MUL_95 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_84), DUP(op_AND_84))), CAST(16, MSB(DUP(op_AND_84)), DUP(op_AND_84))), CAST(32, MSB(CAST(16, MSB(op_AND_92), DUP(op_AND_92))), CAST(16, MSB(DUP(op_AND_92)), DUP(op_AND_92))));
	RzILOpPure *op_LSHIFT_98 = SHIFTL0(CAST(64, MSB(op_MUL_95), DUP(op_MUL_95)), SN(32, 0));
	RzILOpPure *op_SUB_99 = SUB(op_LSHIFT_78, op_LSHIFT_98);
	RzILOpPure *op_EQ_100 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_SUB_53), SN(32, 0), SN(32, 0x20)), op_SUB_99);
	RzILOpPure *op_RSHIFT_148 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_150 = LOGAND(op_RSHIFT_148, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_156 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_158 = LOGAND(op_RSHIFT_156, SN(32, 0xffff));
	RzILOpPure *op_MUL_161 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_150), DUP(op_AND_150))), CAST(16, MSB(DUP(op_AND_150)), DUP(op_AND_150))), CAST(32, MSB(CAST(16, MSB(op_AND_158), DUP(op_AND_158))), CAST(16, MSB(DUP(op_AND_158)), DUP(op_AND_158))));
	RzILOpPure *op_LSHIFT_164 = SHIFTL0(CAST(64, MSB(op_MUL_161), DUP(op_MUL_161)), SN(32, 0));
	RzILOpPure *op_RSHIFT_168 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_170 = LOGAND(op_RSHIFT_168, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_176 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_178 = LOGAND(op_RSHIFT_176, SN(32, 0xffff));
	RzILOpPure *op_MUL_181 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_170), DUP(op_AND_170))), CAST(16, MSB(DUP(op_AND_170)), DUP(op_AND_170))), CAST(32, MSB(CAST(16, MSB(op_AND_178), DUP(op_AND_178))), CAST(16, MSB(DUP(op_AND_178)), DUP(op_AND_178))));
	RzILOpPure *op_LSHIFT_184 = SHIFTL0(CAST(64, MSB(op_MUL_181), DUP(op_MUL_181)), SN(32, 0));
	RzILOpPure *op_SUB_185 = SUB(op_LSHIFT_164, op_LSHIFT_184);
	RzILOpPure *op_LT_188 = SLT(op_SUB_185, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_193 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_194 = NEG(op_LSHIFT_193);
	RzILOpPure *op_LSHIFT_199 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_202 = SUB(op_LSHIFT_199, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_203 = ITE(op_LT_188, op_NEG_194, op_SUB_202);
	RzILOpEffect *gcc_expr_204 = BRANCH(op_EQ_100, EMPTY(), set_usr_field_call_144);

	// h_tmp252 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_206 = SETL("h_tmp252", cond_203);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_207 = SEQN(2, gcc_expr_204, op_ASSIGN_hybrid_tmp_206);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)) ? (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) : h_tmp252) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_104 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_106 = LOGAND(op_RSHIFT_104, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_112 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_114 = LOGAND(op_RSHIFT_112, SN(32, 0xffff));
	RzILOpPure *op_MUL_117 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_106), DUP(op_AND_106))), CAST(16, MSB(DUP(op_AND_106)), DUP(op_AND_106))), CAST(32, MSB(CAST(16, MSB(op_AND_114), DUP(op_AND_114))), CAST(16, MSB(DUP(op_AND_114)), DUP(op_AND_114))));
	RzILOpPure *op_LSHIFT_120 = SHIFTL0(CAST(64, MSB(op_MUL_117), DUP(op_MUL_117)), SN(32, 0));
	RzILOpPure *op_RSHIFT_124 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_126 = LOGAND(op_RSHIFT_124, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_132 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_134 = LOGAND(op_RSHIFT_132, SN(32, 0xffff));
	RzILOpPure *op_MUL_137 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_126), DUP(op_AND_126))), CAST(16, MSB(DUP(op_AND_126)), DUP(op_AND_126))), CAST(32, MSB(CAST(16, MSB(op_AND_134), DUP(op_AND_134))), CAST(16, MSB(DUP(op_AND_134)), DUP(op_AND_134))));
	RzILOpPure *op_LSHIFT_140 = SHIFTL0(CAST(64, MSB(op_MUL_137), DUP(op_MUL_137)), SN(32, 0));
	RzILOpPure *op_SUB_141 = SUB(op_LSHIFT_120, op_LSHIFT_140);
	RzILOpPure *cond_208 = ITE(DUP(op_EQ_100), op_SUB_141, VARL("h_tmp252"));
	RzILOpPure *op_AND_210 = LOGAND(cond_208, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_214 = SHIFTL0(op_AND_210, SN(32, 0x20));
	RzILOpPure *op_OR_215 = LOGOR(op_AND_7, op_LSHIFT_214);
	RzILOpEffect *op_ASSIGN_216 = WRITE_REG(bundle, Rdd_op, op_OR_215);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_217 = SEQN(2, seq_207, op_ASSIGN_216);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_360 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_232 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_234 = LOGAND(op_RSHIFT_232, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_240 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_242 = LOGAND(op_RSHIFT_240, SN(32, 0xffff));
	RzILOpPure *op_MUL_245 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_234), DUP(op_AND_234))), CAST(16, MSB(DUP(op_AND_234)), DUP(op_AND_234))), CAST(32, MSB(CAST(16, MSB(op_AND_242), DUP(op_AND_242))), CAST(16, MSB(DUP(op_AND_242)), DUP(op_AND_242))));
	RzILOpPure *op_LSHIFT_248 = SHIFTL0(CAST(64, MSB(op_MUL_245), DUP(op_MUL_245)), SN(32, 0));
	RzILOpPure *op_RSHIFT_252 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_254 = LOGAND(op_RSHIFT_252, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_260 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_262 = LOGAND(op_RSHIFT_260, SN(32, 0xffff));
	RzILOpPure *op_MUL_265 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_254), DUP(op_AND_254))), CAST(16, MSB(DUP(op_AND_254)), DUP(op_AND_254))), CAST(32, MSB(CAST(16, MSB(op_AND_262), DUP(op_AND_262))), CAST(16, MSB(DUP(op_AND_262)), DUP(op_AND_262))));
	RzILOpPure *op_LSHIFT_268 = SHIFTL0(CAST(64, MSB(op_MUL_265), DUP(op_MUL_265)), SN(32, 0));
	RzILOpPure *op_ADD_269 = ADD(op_LSHIFT_248, op_LSHIFT_268);
	RzILOpPure *op_RSHIFT_278 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_280 = LOGAND(op_RSHIFT_278, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_286 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_288 = LOGAND(op_RSHIFT_286, SN(32, 0xffff));
	RzILOpPure *op_MUL_291 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_280), DUP(op_AND_280))), CAST(16, MSB(DUP(op_AND_280)), DUP(op_AND_280))), CAST(32, MSB(CAST(16, MSB(op_AND_288), DUP(op_AND_288))), CAST(16, MSB(DUP(op_AND_288)), DUP(op_AND_288))));
	RzILOpPure *op_LSHIFT_294 = SHIFTL0(CAST(64, MSB(op_MUL_291), DUP(op_MUL_291)), SN(32, 0));
	RzILOpPure *op_RSHIFT_298 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_300 = LOGAND(op_RSHIFT_298, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_306 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_308 = LOGAND(op_RSHIFT_306, SN(32, 0xffff));
	RzILOpPure *op_MUL_311 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_300), DUP(op_AND_300))), CAST(16, MSB(DUP(op_AND_300)), DUP(op_AND_300))), CAST(32, MSB(CAST(16, MSB(op_AND_308), DUP(op_AND_308))), CAST(16, MSB(DUP(op_AND_308)), DUP(op_AND_308))));
	RzILOpPure *op_LSHIFT_314 = SHIFTL0(CAST(64, MSB(op_MUL_311), DUP(op_MUL_311)), SN(32, 0));
	RzILOpPure *op_ADD_315 = ADD(op_LSHIFT_294, op_LSHIFT_314);
	RzILOpPure *op_EQ_316 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_269), SN(32, 0), SN(32, 0x20)), op_ADD_315);
	RzILOpPure *op_RSHIFT_364 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_366 = LOGAND(op_RSHIFT_364, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_372 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_374 = LOGAND(op_RSHIFT_372, SN(32, 0xffff));
	RzILOpPure *op_MUL_377 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_366), DUP(op_AND_366))), CAST(16, MSB(DUP(op_AND_366)), DUP(op_AND_366))), CAST(32, MSB(CAST(16, MSB(op_AND_374), DUP(op_AND_374))), CAST(16, MSB(DUP(op_AND_374)), DUP(op_AND_374))));
	RzILOpPure *op_LSHIFT_380 = SHIFTL0(CAST(64, MSB(op_MUL_377), DUP(op_MUL_377)), SN(32, 0));
	RzILOpPure *op_RSHIFT_384 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_386 = LOGAND(op_RSHIFT_384, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_392 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_394 = LOGAND(op_RSHIFT_392, SN(32, 0xffff));
	RzILOpPure *op_MUL_397 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_386), DUP(op_AND_386))), CAST(16, MSB(DUP(op_AND_386)), DUP(op_AND_386))), CAST(32, MSB(CAST(16, MSB(op_AND_394), DUP(op_AND_394))), CAST(16, MSB(DUP(op_AND_394)), DUP(op_AND_394))));
	RzILOpPure *op_LSHIFT_400 = SHIFTL0(CAST(64, MSB(op_MUL_397), DUP(op_MUL_397)), SN(32, 0));
	RzILOpPure *op_ADD_401 = ADD(op_LSHIFT_380, op_LSHIFT_400);
	RzILOpPure *op_LT_404 = SLT(op_ADD_401, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_409 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_410 = NEG(op_LSHIFT_409);
	RzILOpPure *op_LSHIFT_415 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_418 = SUB(op_LSHIFT_415, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_419 = ITE(op_LT_404, op_NEG_410, op_SUB_418);
	RzILOpEffect *gcc_expr_420 = BRANCH(op_EQ_316, EMPTY(), set_usr_field_call_360);

	// h_tmp253 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_422 = SETL("h_tmp253", cond_419);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_423 = SEQN(2, gcc_expr_420, op_ASSIGN_hybrid_tmp_422);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)) ? (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) : h_tmp253) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_223 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_224 = LOGNOT(op_LSHIFT_223);
	RzILOpPure *op_AND_225 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_224);
	RzILOpPure *op_RSHIFT_320 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_322 = LOGAND(op_RSHIFT_320, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_328 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_330 = LOGAND(op_RSHIFT_328, SN(32, 0xffff));
	RzILOpPure *op_MUL_333 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_322), DUP(op_AND_322))), CAST(16, MSB(DUP(op_AND_322)), DUP(op_AND_322))), CAST(32, MSB(CAST(16, MSB(op_AND_330), DUP(op_AND_330))), CAST(16, MSB(DUP(op_AND_330)), DUP(op_AND_330))));
	RzILOpPure *op_LSHIFT_336 = SHIFTL0(CAST(64, MSB(op_MUL_333), DUP(op_MUL_333)), SN(32, 0));
	RzILOpPure *op_RSHIFT_340 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_342 = LOGAND(op_RSHIFT_340, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_348 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_350 = LOGAND(op_RSHIFT_348, SN(32, 0xffff));
	RzILOpPure *op_MUL_353 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_342), DUP(op_AND_342))), CAST(16, MSB(DUP(op_AND_342)), DUP(op_AND_342))), CAST(32, MSB(CAST(16, MSB(op_AND_350), DUP(op_AND_350))), CAST(16, MSB(DUP(op_AND_350)), DUP(op_AND_350))));
	RzILOpPure *op_LSHIFT_356 = SHIFTL0(CAST(64, MSB(op_MUL_353), DUP(op_MUL_353)), SN(32, 0));
	RzILOpPure *op_ADD_357 = ADD(op_LSHIFT_336, op_LSHIFT_356);
	RzILOpPure *cond_424 = ITE(DUP(op_EQ_316), op_ADD_357, VARL("h_tmp253"));
	RzILOpPure *op_AND_426 = LOGAND(cond_424, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_430 = SHIFTL0(op_AND_426, SN(32, 0));
	RzILOpPure *op_OR_431 = LOGOR(op_AND_225, op_LSHIFT_430);
	RzILOpEffect *op_ASSIGN_432 = WRITE_REG(bundle, Rdd_op, op_OR_431);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_433 = SEQN(2, seq_423, op_ASSIGN_432);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_217, seq_433);
	return instruction_sequence;
}

// Rdd = cmpy(Rs,Rt*):<<1:sat
RzILOpEffect *hex_il_op_m2_cmpysc_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_144 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_17 = LOGAND(op_RSHIFT_15, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_24 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_26 = LOGAND(op_RSHIFT_24, SN(32, 0xffff));
	RzILOpPure *op_MUL_29 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_17), DUP(op_AND_17))), CAST(16, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(CAST(16, MSB(op_AND_26), DUP(op_AND_26))), CAST(16, MSB(DUP(op_AND_26)), DUP(op_AND_26))));
	RzILOpPure *op_LSHIFT_32 = SHIFTL0(CAST(64, MSB(op_MUL_29), DUP(op_MUL_29)), SN(32, 1));
	RzILOpPure *op_RSHIFT_36 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_38 = LOGAND(op_RSHIFT_36, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_44 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_46 = LOGAND(op_RSHIFT_44, SN(32, 0xffff));
	RzILOpPure *op_MUL_49 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_38), DUP(op_AND_38))), CAST(16, MSB(DUP(op_AND_38)), DUP(op_AND_38))), CAST(32, MSB(CAST(16, MSB(op_AND_46), DUP(op_AND_46))), CAST(16, MSB(DUP(op_AND_46)), DUP(op_AND_46))));
	RzILOpPure *op_LSHIFT_52 = SHIFTL0(CAST(64, MSB(op_MUL_49), DUP(op_MUL_49)), SN(32, 1));
	RzILOpPure *op_SUB_53 = SUB(op_LSHIFT_32, op_LSHIFT_52);
	RzILOpPure *op_RSHIFT_62 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_64 = LOGAND(op_RSHIFT_62, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_70 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_72 = LOGAND(op_RSHIFT_70, SN(32, 0xffff));
	RzILOpPure *op_MUL_75 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_64), DUP(op_AND_64))), CAST(16, MSB(DUP(op_AND_64)), DUP(op_AND_64))), CAST(32, MSB(CAST(16, MSB(op_AND_72), DUP(op_AND_72))), CAST(16, MSB(DUP(op_AND_72)), DUP(op_AND_72))));
	RzILOpPure *op_LSHIFT_78 = SHIFTL0(CAST(64, MSB(op_MUL_75), DUP(op_MUL_75)), SN(32, 1));
	RzILOpPure *op_RSHIFT_82 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_84 = LOGAND(op_RSHIFT_82, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_90 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_92 = LOGAND(op_RSHIFT_90, SN(32, 0xffff));
	RzILOpPure *op_MUL_95 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_84), DUP(op_AND_84))), CAST(16, MSB(DUP(op_AND_84)), DUP(op_AND_84))), CAST(32, MSB(CAST(16, MSB(op_AND_92), DUP(op_AND_92))), CAST(16, MSB(DUP(op_AND_92)), DUP(op_AND_92))));
	RzILOpPure *op_LSHIFT_98 = SHIFTL0(CAST(64, MSB(op_MUL_95), DUP(op_MUL_95)), SN(32, 1));
	RzILOpPure *op_SUB_99 = SUB(op_LSHIFT_78, op_LSHIFT_98);
	RzILOpPure *op_EQ_100 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_SUB_53), SN(32, 0), SN(32, 0x20)), op_SUB_99);
	RzILOpPure *op_RSHIFT_148 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_150 = LOGAND(op_RSHIFT_148, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_156 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_158 = LOGAND(op_RSHIFT_156, SN(32, 0xffff));
	RzILOpPure *op_MUL_161 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_150), DUP(op_AND_150))), CAST(16, MSB(DUP(op_AND_150)), DUP(op_AND_150))), CAST(32, MSB(CAST(16, MSB(op_AND_158), DUP(op_AND_158))), CAST(16, MSB(DUP(op_AND_158)), DUP(op_AND_158))));
	RzILOpPure *op_LSHIFT_164 = SHIFTL0(CAST(64, MSB(op_MUL_161), DUP(op_MUL_161)), SN(32, 1));
	RzILOpPure *op_RSHIFT_168 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_170 = LOGAND(op_RSHIFT_168, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_176 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_178 = LOGAND(op_RSHIFT_176, SN(32, 0xffff));
	RzILOpPure *op_MUL_181 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_170), DUP(op_AND_170))), CAST(16, MSB(DUP(op_AND_170)), DUP(op_AND_170))), CAST(32, MSB(CAST(16, MSB(op_AND_178), DUP(op_AND_178))), CAST(16, MSB(DUP(op_AND_178)), DUP(op_AND_178))));
	RzILOpPure *op_LSHIFT_184 = SHIFTL0(CAST(64, MSB(op_MUL_181), DUP(op_MUL_181)), SN(32, 1));
	RzILOpPure *op_SUB_185 = SUB(op_LSHIFT_164, op_LSHIFT_184);
	RzILOpPure *op_LT_188 = SLT(op_SUB_185, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_193 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_194 = NEG(op_LSHIFT_193);
	RzILOpPure *op_LSHIFT_199 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_202 = SUB(op_LSHIFT_199, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_203 = ITE(op_LT_188, op_NEG_194, op_SUB_202);
	RzILOpEffect *gcc_expr_204 = BRANCH(op_EQ_100, EMPTY(), set_usr_field_call_144);

	// h_tmp254 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_206 = SETL("h_tmp254", cond_203);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_207 = SEQN(2, gcc_expr_204, op_ASSIGN_hybrid_tmp_206);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)) ? (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) : h_tmp254) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_104 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_106 = LOGAND(op_RSHIFT_104, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_112 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_114 = LOGAND(op_RSHIFT_112, SN(32, 0xffff));
	RzILOpPure *op_MUL_117 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_106), DUP(op_AND_106))), CAST(16, MSB(DUP(op_AND_106)), DUP(op_AND_106))), CAST(32, MSB(CAST(16, MSB(op_AND_114), DUP(op_AND_114))), CAST(16, MSB(DUP(op_AND_114)), DUP(op_AND_114))));
	RzILOpPure *op_LSHIFT_120 = SHIFTL0(CAST(64, MSB(op_MUL_117), DUP(op_MUL_117)), SN(32, 1));
	RzILOpPure *op_RSHIFT_124 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_126 = LOGAND(op_RSHIFT_124, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_132 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_134 = LOGAND(op_RSHIFT_132, SN(32, 0xffff));
	RzILOpPure *op_MUL_137 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_126), DUP(op_AND_126))), CAST(16, MSB(DUP(op_AND_126)), DUP(op_AND_126))), CAST(32, MSB(CAST(16, MSB(op_AND_134), DUP(op_AND_134))), CAST(16, MSB(DUP(op_AND_134)), DUP(op_AND_134))));
	RzILOpPure *op_LSHIFT_140 = SHIFTL0(CAST(64, MSB(op_MUL_137), DUP(op_MUL_137)), SN(32, 1));
	RzILOpPure *op_SUB_141 = SUB(op_LSHIFT_120, op_LSHIFT_140);
	RzILOpPure *cond_208 = ITE(DUP(op_EQ_100), op_SUB_141, VARL("h_tmp254"));
	RzILOpPure *op_AND_210 = LOGAND(cond_208, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_214 = SHIFTL0(op_AND_210, SN(32, 0x20));
	RzILOpPure *op_OR_215 = LOGOR(op_AND_7, op_LSHIFT_214);
	RzILOpEffect *op_ASSIGN_216 = WRITE_REG(bundle, Rdd_op, op_OR_215);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_217 = SEQN(2, seq_207, op_ASSIGN_216);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_360 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_232 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_234 = LOGAND(op_RSHIFT_232, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_240 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_242 = LOGAND(op_RSHIFT_240, SN(32, 0xffff));
	RzILOpPure *op_MUL_245 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_234), DUP(op_AND_234))), CAST(16, MSB(DUP(op_AND_234)), DUP(op_AND_234))), CAST(32, MSB(CAST(16, MSB(op_AND_242), DUP(op_AND_242))), CAST(16, MSB(DUP(op_AND_242)), DUP(op_AND_242))));
	RzILOpPure *op_LSHIFT_248 = SHIFTL0(CAST(64, MSB(op_MUL_245), DUP(op_MUL_245)), SN(32, 1));
	RzILOpPure *op_RSHIFT_252 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_254 = LOGAND(op_RSHIFT_252, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_260 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_262 = LOGAND(op_RSHIFT_260, SN(32, 0xffff));
	RzILOpPure *op_MUL_265 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_254), DUP(op_AND_254))), CAST(16, MSB(DUP(op_AND_254)), DUP(op_AND_254))), CAST(32, MSB(CAST(16, MSB(op_AND_262), DUP(op_AND_262))), CAST(16, MSB(DUP(op_AND_262)), DUP(op_AND_262))));
	RzILOpPure *op_LSHIFT_268 = SHIFTL0(CAST(64, MSB(op_MUL_265), DUP(op_MUL_265)), SN(32, 1));
	RzILOpPure *op_ADD_269 = ADD(op_LSHIFT_248, op_LSHIFT_268);
	RzILOpPure *op_RSHIFT_278 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_280 = LOGAND(op_RSHIFT_278, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_286 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_288 = LOGAND(op_RSHIFT_286, SN(32, 0xffff));
	RzILOpPure *op_MUL_291 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_280), DUP(op_AND_280))), CAST(16, MSB(DUP(op_AND_280)), DUP(op_AND_280))), CAST(32, MSB(CAST(16, MSB(op_AND_288), DUP(op_AND_288))), CAST(16, MSB(DUP(op_AND_288)), DUP(op_AND_288))));
	RzILOpPure *op_LSHIFT_294 = SHIFTL0(CAST(64, MSB(op_MUL_291), DUP(op_MUL_291)), SN(32, 1));
	RzILOpPure *op_RSHIFT_298 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_300 = LOGAND(op_RSHIFT_298, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_306 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_308 = LOGAND(op_RSHIFT_306, SN(32, 0xffff));
	RzILOpPure *op_MUL_311 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_300), DUP(op_AND_300))), CAST(16, MSB(DUP(op_AND_300)), DUP(op_AND_300))), CAST(32, MSB(CAST(16, MSB(op_AND_308), DUP(op_AND_308))), CAST(16, MSB(DUP(op_AND_308)), DUP(op_AND_308))));
	RzILOpPure *op_LSHIFT_314 = SHIFTL0(CAST(64, MSB(op_MUL_311), DUP(op_MUL_311)), SN(32, 1));
	RzILOpPure *op_ADD_315 = ADD(op_LSHIFT_294, op_LSHIFT_314);
	RzILOpPure *op_EQ_316 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_269), SN(32, 0), SN(32, 0x20)), op_ADD_315);
	RzILOpPure *op_RSHIFT_364 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_366 = LOGAND(op_RSHIFT_364, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_372 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_374 = LOGAND(op_RSHIFT_372, SN(32, 0xffff));
	RzILOpPure *op_MUL_377 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_366), DUP(op_AND_366))), CAST(16, MSB(DUP(op_AND_366)), DUP(op_AND_366))), CAST(32, MSB(CAST(16, MSB(op_AND_374), DUP(op_AND_374))), CAST(16, MSB(DUP(op_AND_374)), DUP(op_AND_374))));
	RzILOpPure *op_LSHIFT_380 = SHIFTL0(CAST(64, MSB(op_MUL_377), DUP(op_MUL_377)), SN(32, 1));
	RzILOpPure *op_RSHIFT_384 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_386 = LOGAND(op_RSHIFT_384, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_392 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_394 = LOGAND(op_RSHIFT_392, SN(32, 0xffff));
	RzILOpPure *op_MUL_397 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_386), DUP(op_AND_386))), CAST(16, MSB(DUP(op_AND_386)), DUP(op_AND_386))), CAST(32, MSB(CAST(16, MSB(op_AND_394), DUP(op_AND_394))), CAST(16, MSB(DUP(op_AND_394)), DUP(op_AND_394))));
	RzILOpPure *op_LSHIFT_400 = SHIFTL0(CAST(64, MSB(op_MUL_397), DUP(op_MUL_397)), SN(32, 1));
	RzILOpPure *op_ADD_401 = ADD(op_LSHIFT_380, op_LSHIFT_400);
	RzILOpPure *op_LT_404 = SLT(op_ADD_401, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_409 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_410 = NEG(op_LSHIFT_409);
	RzILOpPure *op_LSHIFT_415 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_418 = SUB(op_LSHIFT_415, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_419 = ITE(op_LT_404, op_NEG_410, op_SUB_418);
	RzILOpEffect *gcc_expr_420 = BRANCH(op_EQ_316, EMPTY(), set_usr_field_call_360);

	// h_tmp255 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_422 = SETL("h_tmp255", cond_419);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_423 = SEQN(2, gcc_expr_420, op_ASSIGN_hybrid_tmp_422);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)) ? (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) : h_tmp255) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_223 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_224 = LOGNOT(op_LSHIFT_223);
	RzILOpPure *op_AND_225 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_224);
	RzILOpPure *op_RSHIFT_320 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_322 = LOGAND(op_RSHIFT_320, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_328 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_330 = LOGAND(op_RSHIFT_328, SN(32, 0xffff));
	RzILOpPure *op_MUL_333 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_322), DUP(op_AND_322))), CAST(16, MSB(DUP(op_AND_322)), DUP(op_AND_322))), CAST(32, MSB(CAST(16, MSB(op_AND_330), DUP(op_AND_330))), CAST(16, MSB(DUP(op_AND_330)), DUP(op_AND_330))));
	RzILOpPure *op_LSHIFT_336 = SHIFTL0(CAST(64, MSB(op_MUL_333), DUP(op_MUL_333)), SN(32, 1));
	RzILOpPure *op_RSHIFT_340 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_342 = LOGAND(op_RSHIFT_340, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_348 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_350 = LOGAND(op_RSHIFT_348, SN(32, 0xffff));
	RzILOpPure *op_MUL_353 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_342), DUP(op_AND_342))), CAST(16, MSB(DUP(op_AND_342)), DUP(op_AND_342))), CAST(32, MSB(CAST(16, MSB(op_AND_350), DUP(op_AND_350))), CAST(16, MSB(DUP(op_AND_350)), DUP(op_AND_350))));
	RzILOpPure *op_LSHIFT_356 = SHIFTL0(CAST(64, MSB(op_MUL_353), DUP(op_MUL_353)), SN(32, 1));
	RzILOpPure *op_ADD_357 = ADD(op_LSHIFT_336, op_LSHIFT_356);
	RzILOpPure *cond_424 = ITE(DUP(op_EQ_316), op_ADD_357, VARL("h_tmp255"));
	RzILOpPure *op_AND_426 = LOGAND(cond_424, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_430 = SHIFTL0(op_AND_426, SN(32, 0));
	RzILOpPure *op_OR_431 = LOGOR(op_AND_225, op_LSHIFT_430);
	RzILOpEffect *op_ASSIGN_432 = WRITE_REG(bundle, Rdd_op, op_OR_431);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_433 = SEQN(2, seq_423, op_ASSIGN_432);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_217, seq_433);
	return instruction_sequence;
}

// Rxx -= cmpy(Rs,Rt):sat
RzILOpEffect *hex_il_op_m2_cnacs_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_171 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_25 = LOGAND(op_RSHIFT_23, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_32 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_34 = LOGAND(op_RSHIFT_32, SN(32, 0xffff));
	RzILOpPure *op_MUL_37 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_25), DUP(op_AND_25))), CAST(16, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(CAST(16, MSB(op_AND_34), DUP(op_AND_34))), CAST(16, MSB(DUP(op_AND_34)), DUP(op_AND_34))));
	RzILOpPure *op_LSHIFT_40 = SHIFTL0(CAST(64, MSB(op_MUL_37), DUP(op_MUL_37)), SN(32, 0));
	RzILOpPure *op_RSHIFT_44 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_46 = LOGAND(op_RSHIFT_44, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_52 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_54 = LOGAND(op_RSHIFT_52, SN(32, 0xffff));
	RzILOpPure *op_MUL_57 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_46), DUP(op_AND_46))), CAST(16, MSB(DUP(op_AND_46)), DUP(op_AND_46))), CAST(32, MSB(CAST(16, MSB(op_AND_54), DUP(op_AND_54))), CAST(16, MSB(DUP(op_AND_54)), DUP(op_AND_54))));
	RzILOpPure *op_LSHIFT_60 = SHIFTL0(CAST(64, MSB(op_MUL_57), DUP(op_MUL_57)), SN(32, 0));
	RzILOpPure *op_ADD_61 = ADD(op_LSHIFT_40, op_LSHIFT_60);
	RzILOpPure *op_SUB_62 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_ADD_61);
	RzILOpPure *op_RSHIFT_71 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_73 = LOGAND(op_RSHIFT_71, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_79 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_81 = LOGAND(op_RSHIFT_79, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_87 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_89 = LOGAND(op_RSHIFT_87, SN(32, 0xffff));
	RzILOpPure *op_MUL_92 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_81), DUP(op_AND_81))), CAST(16, MSB(DUP(op_AND_81)), DUP(op_AND_81))), CAST(32, MSB(CAST(16, MSB(op_AND_89), DUP(op_AND_89))), CAST(16, MSB(DUP(op_AND_89)), DUP(op_AND_89))));
	RzILOpPure *op_LSHIFT_95 = SHIFTL0(CAST(64, MSB(op_MUL_92), DUP(op_MUL_92)), SN(32, 0));
	RzILOpPure *op_RSHIFT_99 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_101 = LOGAND(op_RSHIFT_99, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_107 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_109 = LOGAND(op_RSHIFT_107, SN(32, 0xffff));
	RzILOpPure *op_MUL_112 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_101), DUP(op_AND_101))), CAST(16, MSB(DUP(op_AND_101)), DUP(op_AND_101))), CAST(32, MSB(CAST(16, MSB(op_AND_109), DUP(op_AND_109))), CAST(16, MSB(DUP(op_AND_109)), DUP(op_AND_109))));
	RzILOpPure *op_LSHIFT_115 = SHIFTL0(CAST(64, MSB(op_MUL_112), DUP(op_MUL_112)), SN(32, 0));
	RzILOpPure *op_ADD_116 = ADD(op_LSHIFT_95, op_LSHIFT_115);
	RzILOpPure *op_SUB_117 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_73), DUP(op_AND_73))), CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73))), op_ADD_116);
	RzILOpPure *op_EQ_118 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_SUB_62), SN(32, 0), SN(32, 0x20)), op_SUB_117);
	RzILOpPure *op_RSHIFT_175 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_177 = LOGAND(op_RSHIFT_175, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_183 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_185 = LOGAND(op_RSHIFT_183, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_191 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_193 = LOGAND(op_RSHIFT_191, SN(32, 0xffff));
	RzILOpPure *op_MUL_196 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_185), DUP(op_AND_185))), CAST(16, MSB(DUP(op_AND_185)), DUP(op_AND_185))), CAST(32, MSB(CAST(16, MSB(op_AND_193), DUP(op_AND_193))), CAST(16, MSB(DUP(op_AND_193)), DUP(op_AND_193))));
	RzILOpPure *op_LSHIFT_199 = SHIFTL0(CAST(64, MSB(op_MUL_196), DUP(op_MUL_196)), SN(32, 0));
	RzILOpPure *op_RSHIFT_203 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_205 = LOGAND(op_RSHIFT_203, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_211 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_213 = LOGAND(op_RSHIFT_211, SN(32, 0xffff));
	RzILOpPure *op_MUL_216 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_205), DUP(op_AND_205))), CAST(16, MSB(DUP(op_AND_205)), DUP(op_AND_205))), CAST(32, MSB(CAST(16, MSB(op_AND_213), DUP(op_AND_213))), CAST(16, MSB(DUP(op_AND_213)), DUP(op_AND_213))));
	RzILOpPure *op_LSHIFT_219 = SHIFTL0(CAST(64, MSB(op_MUL_216), DUP(op_MUL_216)), SN(32, 0));
	RzILOpPure *op_ADD_220 = ADD(op_LSHIFT_199, op_LSHIFT_219);
	RzILOpPure *op_SUB_221 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_177), DUP(op_AND_177))), CAST(32, MSB(DUP(op_AND_177)), DUP(op_AND_177))), op_ADD_220);
	RzILOpPure *op_LT_224 = SLT(op_SUB_221, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_229 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_230 = NEG(op_LSHIFT_229);
	RzILOpPure *op_LSHIFT_235 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_238 = SUB(op_LSHIFT_235, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_239 = ITE(op_LT_224, op_NEG_230, op_SUB_238);
	RzILOpEffect *gcc_expr_240 = BRANCH(op_EQ_118, EMPTY(), set_usr_field_call_171);

	// h_tmp256 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_242 = SETL("h_tmp256", cond_239);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_243 = SEQN(2, gcc_expr_240, op_ASSIGN_hybrid_tmp_242);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) : h_tmp256) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_122 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_124 = LOGAND(op_RSHIFT_122, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_130 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_132 = LOGAND(op_RSHIFT_130, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_138 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_140 = LOGAND(op_RSHIFT_138, SN(32, 0xffff));
	RzILOpPure *op_MUL_143 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_132), DUP(op_AND_132))), CAST(16, MSB(DUP(op_AND_132)), DUP(op_AND_132))), CAST(32, MSB(CAST(16, MSB(op_AND_140), DUP(op_AND_140))), CAST(16, MSB(DUP(op_AND_140)), DUP(op_AND_140))));
	RzILOpPure *op_LSHIFT_146 = SHIFTL0(CAST(64, MSB(op_MUL_143), DUP(op_MUL_143)), SN(32, 0));
	RzILOpPure *op_RSHIFT_150 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_152 = LOGAND(op_RSHIFT_150, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_158 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_160 = LOGAND(op_RSHIFT_158, SN(32, 0xffff));
	RzILOpPure *op_MUL_163 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_152), DUP(op_AND_152))), CAST(16, MSB(DUP(op_AND_152)), DUP(op_AND_152))), CAST(32, MSB(CAST(16, MSB(op_AND_160), DUP(op_AND_160))), CAST(16, MSB(DUP(op_AND_160)), DUP(op_AND_160))));
	RzILOpPure *op_LSHIFT_166 = SHIFTL0(CAST(64, MSB(op_MUL_163), DUP(op_MUL_163)), SN(32, 0));
	RzILOpPure *op_ADD_167 = ADD(op_LSHIFT_146, op_LSHIFT_166);
	RzILOpPure *op_SUB_168 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_124), DUP(op_AND_124))), CAST(32, MSB(DUP(op_AND_124)), DUP(op_AND_124))), op_ADD_167);
	RzILOpPure *cond_244 = ITE(DUP(op_EQ_118), op_SUB_168, VARL("h_tmp256"));
	RzILOpPure *op_AND_246 = LOGAND(cond_244, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_250 = SHIFTL0(op_AND_246, SN(32, 0x20));
	RzILOpPure *op_OR_251 = LOGOR(op_AND_7, op_LSHIFT_250);
	RzILOpEffect *op_ASSIGN_252 = WRITE_REG(bundle, Rxx_op, op_OR_251);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_253 = SEQN(2, seq_243, op_ASSIGN_252);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_423 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_268 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_270 = LOGAND(op_RSHIFT_268, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_276 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_278 = LOGAND(op_RSHIFT_276, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_284 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_286 = LOGAND(op_RSHIFT_284, SN(32, 0xffff));
	RzILOpPure *op_MUL_289 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_278), DUP(op_AND_278))), CAST(16, MSB(DUP(op_AND_278)), DUP(op_AND_278))), CAST(32, MSB(CAST(16, MSB(op_AND_286), DUP(op_AND_286))), CAST(16, MSB(DUP(op_AND_286)), DUP(op_AND_286))));
	RzILOpPure *op_LSHIFT_292 = SHIFTL0(CAST(64, MSB(op_MUL_289), DUP(op_MUL_289)), SN(32, 0));
	RzILOpPure *op_RSHIFT_296 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_298 = LOGAND(op_RSHIFT_296, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_304 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_306 = LOGAND(op_RSHIFT_304, SN(32, 0xffff));
	RzILOpPure *op_MUL_309 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_298), DUP(op_AND_298))), CAST(16, MSB(DUP(op_AND_298)), DUP(op_AND_298))), CAST(32, MSB(CAST(16, MSB(op_AND_306), DUP(op_AND_306))), CAST(16, MSB(DUP(op_AND_306)), DUP(op_AND_306))));
	RzILOpPure *op_LSHIFT_312 = SHIFTL0(CAST(64, MSB(op_MUL_309), DUP(op_MUL_309)), SN(32, 0));
	RzILOpPure *op_SUB_313 = SUB(op_LSHIFT_292, op_LSHIFT_312);
	RzILOpPure *op_SUB_314 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_270), DUP(op_AND_270))), CAST(32, MSB(DUP(op_AND_270)), DUP(op_AND_270))), op_SUB_313);
	RzILOpPure *op_RSHIFT_323 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_325 = LOGAND(op_RSHIFT_323, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_331 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_333 = LOGAND(op_RSHIFT_331, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_339 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_341 = LOGAND(op_RSHIFT_339, SN(32, 0xffff));
	RzILOpPure *op_MUL_344 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_333), DUP(op_AND_333))), CAST(16, MSB(DUP(op_AND_333)), DUP(op_AND_333))), CAST(32, MSB(CAST(16, MSB(op_AND_341), DUP(op_AND_341))), CAST(16, MSB(DUP(op_AND_341)), DUP(op_AND_341))));
	RzILOpPure *op_LSHIFT_347 = SHIFTL0(CAST(64, MSB(op_MUL_344), DUP(op_MUL_344)), SN(32, 0));
	RzILOpPure *op_RSHIFT_351 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_353 = LOGAND(op_RSHIFT_351, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_359 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_361 = LOGAND(op_RSHIFT_359, SN(32, 0xffff));
	RzILOpPure *op_MUL_364 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_353), DUP(op_AND_353))), CAST(16, MSB(DUP(op_AND_353)), DUP(op_AND_353))), CAST(32, MSB(CAST(16, MSB(op_AND_361), DUP(op_AND_361))), CAST(16, MSB(DUP(op_AND_361)), DUP(op_AND_361))));
	RzILOpPure *op_LSHIFT_367 = SHIFTL0(CAST(64, MSB(op_MUL_364), DUP(op_MUL_364)), SN(32, 0));
	RzILOpPure *op_SUB_368 = SUB(op_LSHIFT_347, op_LSHIFT_367);
	RzILOpPure *op_SUB_369 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_325), DUP(op_AND_325))), CAST(32, MSB(DUP(op_AND_325)), DUP(op_AND_325))), op_SUB_368);
	RzILOpPure *op_EQ_370 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_SUB_314), SN(32, 0), SN(32, 0x20)), op_SUB_369);
	RzILOpPure *op_RSHIFT_427 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_429 = LOGAND(op_RSHIFT_427, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_435 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_437 = LOGAND(op_RSHIFT_435, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_443 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_445 = LOGAND(op_RSHIFT_443, SN(32, 0xffff));
	RzILOpPure *op_MUL_448 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_437), DUP(op_AND_437))), CAST(16, MSB(DUP(op_AND_437)), DUP(op_AND_437))), CAST(32, MSB(CAST(16, MSB(op_AND_445), DUP(op_AND_445))), CAST(16, MSB(DUP(op_AND_445)), DUP(op_AND_445))));
	RzILOpPure *op_LSHIFT_451 = SHIFTL0(CAST(64, MSB(op_MUL_448), DUP(op_MUL_448)), SN(32, 0));
	RzILOpPure *op_RSHIFT_455 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_457 = LOGAND(op_RSHIFT_455, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_463 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_465 = LOGAND(op_RSHIFT_463, SN(32, 0xffff));
	RzILOpPure *op_MUL_468 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_457), DUP(op_AND_457))), CAST(16, MSB(DUP(op_AND_457)), DUP(op_AND_457))), CAST(32, MSB(CAST(16, MSB(op_AND_465), DUP(op_AND_465))), CAST(16, MSB(DUP(op_AND_465)), DUP(op_AND_465))));
	RzILOpPure *op_LSHIFT_471 = SHIFTL0(CAST(64, MSB(op_MUL_468), DUP(op_MUL_468)), SN(32, 0));
	RzILOpPure *op_SUB_472 = SUB(op_LSHIFT_451, op_LSHIFT_471);
	RzILOpPure *op_SUB_473 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_429), DUP(op_AND_429))), CAST(32, MSB(DUP(op_AND_429)), DUP(op_AND_429))), op_SUB_472);
	RzILOpPure *op_LT_476 = SLT(op_SUB_473, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_481 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_482 = NEG(op_LSHIFT_481);
	RzILOpPure *op_LSHIFT_487 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_490 = SUB(op_LSHIFT_487, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_491 = ITE(op_LT_476, op_NEG_482, op_SUB_490);
	RzILOpEffect *gcc_expr_492 = BRANCH(op_EQ_370, EMPTY(), set_usr_field_call_423);

	// h_tmp257 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_494 = SETL("h_tmp257", cond_491);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_495 = SEQN(2, gcc_expr_492, op_ASSIGN_hybrid_tmp_494);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) : h_tmp257) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_259 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_260 = LOGNOT(op_LSHIFT_259);
	RzILOpPure *op_AND_261 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_260);
	RzILOpPure *op_RSHIFT_374 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_376 = LOGAND(op_RSHIFT_374, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_382 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_384 = LOGAND(op_RSHIFT_382, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_390 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_392 = LOGAND(op_RSHIFT_390, SN(32, 0xffff));
	RzILOpPure *op_MUL_395 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_384), DUP(op_AND_384))), CAST(16, MSB(DUP(op_AND_384)), DUP(op_AND_384))), CAST(32, MSB(CAST(16, MSB(op_AND_392), DUP(op_AND_392))), CAST(16, MSB(DUP(op_AND_392)), DUP(op_AND_392))));
	RzILOpPure *op_LSHIFT_398 = SHIFTL0(CAST(64, MSB(op_MUL_395), DUP(op_MUL_395)), SN(32, 0));
	RzILOpPure *op_RSHIFT_402 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_404 = LOGAND(op_RSHIFT_402, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_410 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_412 = LOGAND(op_RSHIFT_410, SN(32, 0xffff));
	RzILOpPure *op_MUL_415 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_404), DUP(op_AND_404))), CAST(16, MSB(DUP(op_AND_404)), DUP(op_AND_404))), CAST(32, MSB(CAST(16, MSB(op_AND_412), DUP(op_AND_412))), CAST(16, MSB(DUP(op_AND_412)), DUP(op_AND_412))));
	RzILOpPure *op_LSHIFT_418 = SHIFTL0(CAST(64, MSB(op_MUL_415), DUP(op_MUL_415)), SN(32, 0));
	RzILOpPure *op_SUB_419 = SUB(op_LSHIFT_398, op_LSHIFT_418);
	RzILOpPure *op_SUB_420 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_376), DUP(op_AND_376))), CAST(32, MSB(DUP(op_AND_376)), DUP(op_AND_376))), op_SUB_419);
	RzILOpPure *cond_496 = ITE(DUP(op_EQ_370), op_SUB_420, VARL("h_tmp257"));
	RzILOpPure *op_AND_498 = LOGAND(cond_496, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_502 = SHIFTL0(op_AND_498, SN(32, 0));
	RzILOpPure *op_OR_503 = LOGOR(op_AND_261, op_LSHIFT_502);
	RzILOpEffect *op_ASSIGN_504 = WRITE_REG(bundle, Rxx_op, op_OR_503);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_505 = SEQN(2, seq_495, op_ASSIGN_504);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_253, seq_505);
	return instruction_sequence;
}

// Rxx -= cmpy(Rs,Rt):<<1:sat
RzILOpEffect *hex_il_op_m2_cnacs_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_171 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_25 = LOGAND(op_RSHIFT_23, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_32 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_34 = LOGAND(op_RSHIFT_32, SN(32, 0xffff));
	RzILOpPure *op_MUL_37 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_25), DUP(op_AND_25))), CAST(16, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(CAST(16, MSB(op_AND_34), DUP(op_AND_34))), CAST(16, MSB(DUP(op_AND_34)), DUP(op_AND_34))));
	RzILOpPure *op_LSHIFT_40 = SHIFTL0(CAST(64, MSB(op_MUL_37), DUP(op_MUL_37)), SN(32, 1));
	RzILOpPure *op_RSHIFT_44 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_46 = LOGAND(op_RSHIFT_44, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_52 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_54 = LOGAND(op_RSHIFT_52, SN(32, 0xffff));
	RzILOpPure *op_MUL_57 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_46), DUP(op_AND_46))), CAST(16, MSB(DUP(op_AND_46)), DUP(op_AND_46))), CAST(32, MSB(CAST(16, MSB(op_AND_54), DUP(op_AND_54))), CAST(16, MSB(DUP(op_AND_54)), DUP(op_AND_54))));
	RzILOpPure *op_LSHIFT_60 = SHIFTL0(CAST(64, MSB(op_MUL_57), DUP(op_MUL_57)), SN(32, 1));
	RzILOpPure *op_ADD_61 = ADD(op_LSHIFT_40, op_LSHIFT_60);
	RzILOpPure *op_SUB_62 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_ADD_61);
	RzILOpPure *op_RSHIFT_71 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_73 = LOGAND(op_RSHIFT_71, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_79 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_81 = LOGAND(op_RSHIFT_79, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_87 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_89 = LOGAND(op_RSHIFT_87, SN(32, 0xffff));
	RzILOpPure *op_MUL_92 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_81), DUP(op_AND_81))), CAST(16, MSB(DUP(op_AND_81)), DUP(op_AND_81))), CAST(32, MSB(CAST(16, MSB(op_AND_89), DUP(op_AND_89))), CAST(16, MSB(DUP(op_AND_89)), DUP(op_AND_89))));
	RzILOpPure *op_LSHIFT_95 = SHIFTL0(CAST(64, MSB(op_MUL_92), DUP(op_MUL_92)), SN(32, 1));
	RzILOpPure *op_RSHIFT_99 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_101 = LOGAND(op_RSHIFT_99, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_107 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_109 = LOGAND(op_RSHIFT_107, SN(32, 0xffff));
	RzILOpPure *op_MUL_112 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_101), DUP(op_AND_101))), CAST(16, MSB(DUP(op_AND_101)), DUP(op_AND_101))), CAST(32, MSB(CAST(16, MSB(op_AND_109), DUP(op_AND_109))), CAST(16, MSB(DUP(op_AND_109)), DUP(op_AND_109))));
	RzILOpPure *op_LSHIFT_115 = SHIFTL0(CAST(64, MSB(op_MUL_112), DUP(op_MUL_112)), SN(32, 1));
	RzILOpPure *op_ADD_116 = ADD(op_LSHIFT_95, op_LSHIFT_115);
	RzILOpPure *op_SUB_117 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_73), DUP(op_AND_73))), CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73))), op_ADD_116);
	RzILOpPure *op_EQ_118 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_SUB_62), SN(32, 0), SN(32, 0x20)), op_SUB_117);
	RzILOpPure *op_RSHIFT_175 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_177 = LOGAND(op_RSHIFT_175, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_183 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_185 = LOGAND(op_RSHIFT_183, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_191 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_193 = LOGAND(op_RSHIFT_191, SN(32, 0xffff));
	RzILOpPure *op_MUL_196 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_185), DUP(op_AND_185))), CAST(16, MSB(DUP(op_AND_185)), DUP(op_AND_185))), CAST(32, MSB(CAST(16, MSB(op_AND_193), DUP(op_AND_193))), CAST(16, MSB(DUP(op_AND_193)), DUP(op_AND_193))));
	RzILOpPure *op_LSHIFT_199 = SHIFTL0(CAST(64, MSB(op_MUL_196), DUP(op_MUL_196)), SN(32, 1));
	RzILOpPure *op_RSHIFT_203 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_205 = LOGAND(op_RSHIFT_203, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_211 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_213 = LOGAND(op_RSHIFT_211, SN(32, 0xffff));
	RzILOpPure *op_MUL_216 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_205), DUP(op_AND_205))), CAST(16, MSB(DUP(op_AND_205)), DUP(op_AND_205))), CAST(32, MSB(CAST(16, MSB(op_AND_213), DUP(op_AND_213))), CAST(16, MSB(DUP(op_AND_213)), DUP(op_AND_213))));
	RzILOpPure *op_LSHIFT_219 = SHIFTL0(CAST(64, MSB(op_MUL_216), DUP(op_MUL_216)), SN(32, 1));
	RzILOpPure *op_ADD_220 = ADD(op_LSHIFT_199, op_LSHIFT_219);
	RzILOpPure *op_SUB_221 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_177), DUP(op_AND_177))), CAST(32, MSB(DUP(op_AND_177)), DUP(op_AND_177))), op_ADD_220);
	RzILOpPure *op_LT_224 = SLT(op_SUB_221, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_229 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_230 = NEG(op_LSHIFT_229);
	RzILOpPure *op_LSHIFT_235 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_238 = SUB(op_LSHIFT_235, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_239 = ITE(op_LT_224, op_NEG_230, op_SUB_238);
	RzILOpEffect *gcc_expr_240 = BRANCH(op_EQ_118, EMPTY(), set_usr_field_call_171);

	// h_tmp258 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_242 = SETL("h_tmp258", cond_239);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_243 = SEQN(2, gcc_expr_240, op_ASSIGN_hybrid_tmp_242);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) : h_tmp258) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_122 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_124 = LOGAND(op_RSHIFT_122, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_130 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_132 = LOGAND(op_RSHIFT_130, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_138 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_140 = LOGAND(op_RSHIFT_138, SN(32, 0xffff));
	RzILOpPure *op_MUL_143 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_132), DUP(op_AND_132))), CAST(16, MSB(DUP(op_AND_132)), DUP(op_AND_132))), CAST(32, MSB(CAST(16, MSB(op_AND_140), DUP(op_AND_140))), CAST(16, MSB(DUP(op_AND_140)), DUP(op_AND_140))));
	RzILOpPure *op_LSHIFT_146 = SHIFTL0(CAST(64, MSB(op_MUL_143), DUP(op_MUL_143)), SN(32, 1));
	RzILOpPure *op_RSHIFT_150 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_152 = LOGAND(op_RSHIFT_150, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_158 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_160 = LOGAND(op_RSHIFT_158, SN(32, 0xffff));
	RzILOpPure *op_MUL_163 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_152), DUP(op_AND_152))), CAST(16, MSB(DUP(op_AND_152)), DUP(op_AND_152))), CAST(32, MSB(CAST(16, MSB(op_AND_160), DUP(op_AND_160))), CAST(16, MSB(DUP(op_AND_160)), DUP(op_AND_160))));
	RzILOpPure *op_LSHIFT_166 = SHIFTL0(CAST(64, MSB(op_MUL_163), DUP(op_MUL_163)), SN(32, 1));
	RzILOpPure *op_ADD_167 = ADD(op_LSHIFT_146, op_LSHIFT_166);
	RzILOpPure *op_SUB_168 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_124), DUP(op_AND_124))), CAST(32, MSB(DUP(op_AND_124)), DUP(op_AND_124))), op_ADD_167);
	RzILOpPure *cond_244 = ITE(DUP(op_EQ_118), op_SUB_168, VARL("h_tmp258"));
	RzILOpPure *op_AND_246 = LOGAND(cond_244, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_250 = SHIFTL0(op_AND_246, SN(32, 0x20));
	RzILOpPure *op_OR_251 = LOGOR(op_AND_7, op_LSHIFT_250);
	RzILOpEffect *op_ASSIGN_252 = WRITE_REG(bundle, Rxx_op, op_OR_251);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_253 = SEQN(2, seq_243, op_ASSIGN_252);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_423 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_268 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_270 = LOGAND(op_RSHIFT_268, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_276 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_278 = LOGAND(op_RSHIFT_276, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_284 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_286 = LOGAND(op_RSHIFT_284, SN(32, 0xffff));
	RzILOpPure *op_MUL_289 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_278), DUP(op_AND_278))), CAST(16, MSB(DUP(op_AND_278)), DUP(op_AND_278))), CAST(32, MSB(CAST(16, MSB(op_AND_286), DUP(op_AND_286))), CAST(16, MSB(DUP(op_AND_286)), DUP(op_AND_286))));
	RzILOpPure *op_LSHIFT_292 = SHIFTL0(CAST(64, MSB(op_MUL_289), DUP(op_MUL_289)), SN(32, 1));
	RzILOpPure *op_RSHIFT_296 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_298 = LOGAND(op_RSHIFT_296, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_304 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_306 = LOGAND(op_RSHIFT_304, SN(32, 0xffff));
	RzILOpPure *op_MUL_309 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_298), DUP(op_AND_298))), CAST(16, MSB(DUP(op_AND_298)), DUP(op_AND_298))), CAST(32, MSB(CAST(16, MSB(op_AND_306), DUP(op_AND_306))), CAST(16, MSB(DUP(op_AND_306)), DUP(op_AND_306))));
	RzILOpPure *op_LSHIFT_312 = SHIFTL0(CAST(64, MSB(op_MUL_309), DUP(op_MUL_309)), SN(32, 1));
	RzILOpPure *op_SUB_313 = SUB(op_LSHIFT_292, op_LSHIFT_312);
	RzILOpPure *op_SUB_314 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_270), DUP(op_AND_270))), CAST(32, MSB(DUP(op_AND_270)), DUP(op_AND_270))), op_SUB_313);
	RzILOpPure *op_RSHIFT_323 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_325 = LOGAND(op_RSHIFT_323, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_331 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_333 = LOGAND(op_RSHIFT_331, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_339 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_341 = LOGAND(op_RSHIFT_339, SN(32, 0xffff));
	RzILOpPure *op_MUL_344 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_333), DUP(op_AND_333))), CAST(16, MSB(DUP(op_AND_333)), DUP(op_AND_333))), CAST(32, MSB(CAST(16, MSB(op_AND_341), DUP(op_AND_341))), CAST(16, MSB(DUP(op_AND_341)), DUP(op_AND_341))));
	RzILOpPure *op_LSHIFT_347 = SHIFTL0(CAST(64, MSB(op_MUL_344), DUP(op_MUL_344)), SN(32, 1));
	RzILOpPure *op_RSHIFT_351 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_353 = LOGAND(op_RSHIFT_351, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_359 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_361 = LOGAND(op_RSHIFT_359, SN(32, 0xffff));
	RzILOpPure *op_MUL_364 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_353), DUP(op_AND_353))), CAST(16, MSB(DUP(op_AND_353)), DUP(op_AND_353))), CAST(32, MSB(CAST(16, MSB(op_AND_361), DUP(op_AND_361))), CAST(16, MSB(DUP(op_AND_361)), DUP(op_AND_361))));
	RzILOpPure *op_LSHIFT_367 = SHIFTL0(CAST(64, MSB(op_MUL_364), DUP(op_MUL_364)), SN(32, 1));
	RzILOpPure *op_SUB_368 = SUB(op_LSHIFT_347, op_LSHIFT_367);
	RzILOpPure *op_SUB_369 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_325), DUP(op_AND_325))), CAST(32, MSB(DUP(op_AND_325)), DUP(op_AND_325))), op_SUB_368);
	RzILOpPure *op_EQ_370 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_SUB_314), SN(32, 0), SN(32, 0x20)), op_SUB_369);
	RzILOpPure *op_RSHIFT_427 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_429 = LOGAND(op_RSHIFT_427, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_435 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_437 = LOGAND(op_RSHIFT_435, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_443 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_445 = LOGAND(op_RSHIFT_443, SN(32, 0xffff));
	RzILOpPure *op_MUL_448 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_437), DUP(op_AND_437))), CAST(16, MSB(DUP(op_AND_437)), DUP(op_AND_437))), CAST(32, MSB(CAST(16, MSB(op_AND_445), DUP(op_AND_445))), CAST(16, MSB(DUP(op_AND_445)), DUP(op_AND_445))));
	RzILOpPure *op_LSHIFT_451 = SHIFTL0(CAST(64, MSB(op_MUL_448), DUP(op_MUL_448)), SN(32, 1));
	RzILOpPure *op_RSHIFT_455 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_457 = LOGAND(op_RSHIFT_455, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_463 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_465 = LOGAND(op_RSHIFT_463, SN(32, 0xffff));
	RzILOpPure *op_MUL_468 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_457), DUP(op_AND_457))), CAST(16, MSB(DUP(op_AND_457)), DUP(op_AND_457))), CAST(32, MSB(CAST(16, MSB(op_AND_465), DUP(op_AND_465))), CAST(16, MSB(DUP(op_AND_465)), DUP(op_AND_465))));
	RzILOpPure *op_LSHIFT_471 = SHIFTL0(CAST(64, MSB(op_MUL_468), DUP(op_MUL_468)), SN(32, 1));
	RzILOpPure *op_SUB_472 = SUB(op_LSHIFT_451, op_LSHIFT_471);
	RzILOpPure *op_SUB_473 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_429), DUP(op_AND_429))), CAST(32, MSB(DUP(op_AND_429)), DUP(op_AND_429))), op_SUB_472);
	RzILOpPure *op_LT_476 = SLT(op_SUB_473, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_481 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_482 = NEG(op_LSHIFT_481);
	RzILOpPure *op_LSHIFT_487 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_490 = SUB(op_LSHIFT_487, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_491 = ITE(op_LT_476, op_NEG_482, op_SUB_490);
	RzILOpEffect *gcc_expr_492 = BRANCH(op_EQ_370, EMPTY(), set_usr_field_call_423);

	// h_tmp259 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_494 = SETL("h_tmp259", cond_491);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_495 = SEQN(2, gcc_expr_492, op_ASSIGN_hybrid_tmp_494);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) : h_tmp259) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_259 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_260 = LOGNOT(op_LSHIFT_259);
	RzILOpPure *op_AND_261 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_260);
	RzILOpPure *op_RSHIFT_374 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_376 = LOGAND(op_RSHIFT_374, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_382 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_384 = LOGAND(op_RSHIFT_382, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_390 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_392 = LOGAND(op_RSHIFT_390, SN(32, 0xffff));
	RzILOpPure *op_MUL_395 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_384), DUP(op_AND_384))), CAST(16, MSB(DUP(op_AND_384)), DUP(op_AND_384))), CAST(32, MSB(CAST(16, MSB(op_AND_392), DUP(op_AND_392))), CAST(16, MSB(DUP(op_AND_392)), DUP(op_AND_392))));
	RzILOpPure *op_LSHIFT_398 = SHIFTL0(CAST(64, MSB(op_MUL_395), DUP(op_MUL_395)), SN(32, 1));
	RzILOpPure *op_RSHIFT_402 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_404 = LOGAND(op_RSHIFT_402, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_410 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_412 = LOGAND(op_RSHIFT_410, SN(32, 0xffff));
	RzILOpPure *op_MUL_415 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_404), DUP(op_AND_404))), CAST(16, MSB(DUP(op_AND_404)), DUP(op_AND_404))), CAST(32, MSB(CAST(16, MSB(op_AND_412), DUP(op_AND_412))), CAST(16, MSB(DUP(op_AND_412)), DUP(op_AND_412))));
	RzILOpPure *op_LSHIFT_418 = SHIFTL0(CAST(64, MSB(op_MUL_415), DUP(op_MUL_415)), SN(32, 1));
	RzILOpPure *op_SUB_419 = SUB(op_LSHIFT_398, op_LSHIFT_418);
	RzILOpPure *op_SUB_420 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_376), DUP(op_AND_376))), CAST(32, MSB(DUP(op_AND_376)), DUP(op_AND_376))), op_SUB_419);
	RzILOpPure *cond_496 = ITE(DUP(op_EQ_370), op_SUB_420, VARL("h_tmp259"));
	RzILOpPure *op_AND_498 = LOGAND(cond_496, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_502 = SHIFTL0(op_AND_498, SN(32, 0));
	RzILOpPure *op_OR_503 = LOGOR(op_AND_261, op_LSHIFT_502);
	RzILOpEffect *op_ASSIGN_504 = WRITE_REG(bundle, Rxx_op, op_OR_503);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_505 = SEQN(2, seq_495, op_ASSIGN_504);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_253, seq_505);
	return instruction_sequence;
}

// Rxx -= cmpy(Rs,Rt*):sat
RzILOpEffect *hex_il_op_m2_cnacsc_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_171 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_25 = LOGAND(op_RSHIFT_23, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_32 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_34 = LOGAND(op_RSHIFT_32, SN(32, 0xffff));
	RzILOpPure *op_MUL_37 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_25), DUP(op_AND_25))), CAST(16, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(CAST(16, MSB(op_AND_34), DUP(op_AND_34))), CAST(16, MSB(DUP(op_AND_34)), DUP(op_AND_34))));
	RzILOpPure *op_LSHIFT_40 = SHIFTL0(CAST(64, MSB(op_MUL_37), DUP(op_MUL_37)), SN(32, 0));
	RzILOpPure *op_RSHIFT_44 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_46 = LOGAND(op_RSHIFT_44, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_52 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_54 = LOGAND(op_RSHIFT_52, SN(32, 0xffff));
	RzILOpPure *op_MUL_57 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_46), DUP(op_AND_46))), CAST(16, MSB(DUP(op_AND_46)), DUP(op_AND_46))), CAST(32, MSB(CAST(16, MSB(op_AND_54), DUP(op_AND_54))), CAST(16, MSB(DUP(op_AND_54)), DUP(op_AND_54))));
	RzILOpPure *op_LSHIFT_60 = SHIFTL0(CAST(64, MSB(op_MUL_57), DUP(op_MUL_57)), SN(32, 0));
	RzILOpPure *op_SUB_61 = SUB(op_LSHIFT_40, op_LSHIFT_60);
	RzILOpPure *op_SUB_62 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_SUB_61);
	RzILOpPure *op_RSHIFT_71 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_73 = LOGAND(op_RSHIFT_71, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_79 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_81 = LOGAND(op_RSHIFT_79, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_87 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_89 = LOGAND(op_RSHIFT_87, SN(32, 0xffff));
	RzILOpPure *op_MUL_92 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_81), DUP(op_AND_81))), CAST(16, MSB(DUP(op_AND_81)), DUP(op_AND_81))), CAST(32, MSB(CAST(16, MSB(op_AND_89), DUP(op_AND_89))), CAST(16, MSB(DUP(op_AND_89)), DUP(op_AND_89))));
	RzILOpPure *op_LSHIFT_95 = SHIFTL0(CAST(64, MSB(op_MUL_92), DUP(op_MUL_92)), SN(32, 0));
	RzILOpPure *op_RSHIFT_99 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_101 = LOGAND(op_RSHIFT_99, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_107 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_109 = LOGAND(op_RSHIFT_107, SN(32, 0xffff));
	RzILOpPure *op_MUL_112 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_101), DUP(op_AND_101))), CAST(16, MSB(DUP(op_AND_101)), DUP(op_AND_101))), CAST(32, MSB(CAST(16, MSB(op_AND_109), DUP(op_AND_109))), CAST(16, MSB(DUP(op_AND_109)), DUP(op_AND_109))));
	RzILOpPure *op_LSHIFT_115 = SHIFTL0(CAST(64, MSB(op_MUL_112), DUP(op_MUL_112)), SN(32, 0));
	RzILOpPure *op_SUB_116 = SUB(op_LSHIFT_95, op_LSHIFT_115);
	RzILOpPure *op_SUB_117 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_73), DUP(op_AND_73))), CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73))), op_SUB_116);
	RzILOpPure *op_EQ_118 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_SUB_62), SN(32, 0), SN(32, 0x20)), op_SUB_117);
	RzILOpPure *op_RSHIFT_175 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_177 = LOGAND(op_RSHIFT_175, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_183 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_185 = LOGAND(op_RSHIFT_183, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_191 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_193 = LOGAND(op_RSHIFT_191, SN(32, 0xffff));
	RzILOpPure *op_MUL_196 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_185), DUP(op_AND_185))), CAST(16, MSB(DUP(op_AND_185)), DUP(op_AND_185))), CAST(32, MSB(CAST(16, MSB(op_AND_193), DUP(op_AND_193))), CAST(16, MSB(DUP(op_AND_193)), DUP(op_AND_193))));
	RzILOpPure *op_LSHIFT_199 = SHIFTL0(CAST(64, MSB(op_MUL_196), DUP(op_MUL_196)), SN(32, 0));
	RzILOpPure *op_RSHIFT_203 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_205 = LOGAND(op_RSHIFT_203, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_211 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_213 = LOGAND(op_RSHIFT_211, SN(32, 0xffff));
	RzILOpPure *op_MUL_216 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_205), DUP(op_AND_205))), CAST(16, MSB(DUP(op_AND_205)), DUP(op_AND_205))), CAST(32, MSB(CAST(16, MSB(op_AND_213), DUP(op_AND_213))), CAST(16, MSB(DUP(op_AND_213)), DUP(op_AND_213))));
	RzILOpPure *op_LSHIFT_219 = SHIFTL0(CAST(64, MSB(op_MUL_216), DUP(op_MUL_216)), SN(32, 0));
	RzILOpPure *op_SUB_220 = SUB(op_LSHIFT_199, op_LSHIFT_219);
	RzILOpPure *op_SUB_221 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_177), DUP(op_AND_177))), CAST(32, MSB(DUP(op_AND_177)), DUP(op_AND_177))), op_SUB_220);
	RzILOpPure *op_LT_224 = SLT(op_SUB_221, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_229 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_230 = NEG(op_LSHIFT_229);
	RzILOpPure *op_LSHIFT_235 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_238 = SUB(op_LSHIFT_235, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_239 = ITE(op_LT_224, op_NEG_230, op_SUB_238);
	RzILOpEffect *gcc_expr_240 = BRANCH(op_EQ_118, EMPTY(), set_usr_field_call_171);

	// h_tmp260 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_242 = SETL("h_tmp260", cond_239);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_243 = SEQN(2, gcc_expr_240, op_ASSIGN_hybrid_tmp_242);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) : h_tmp260) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_122 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_124 = LOGAND(op_RSHIFT_122, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_130 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_132 = LOGAND(op_RSHIFT_130, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_138 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_140 = LOGAND(op_RSHIFT_138, SN(32, 0xffff));
	RzILOpPure *op_MUL_143 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_132), DUP(op_AND_132))), CAST(16, MSB(DUP(op_AND_132)), DUP(op_AND_132))), CAST(32, MSB(CAST(16, MSB(op_AND_140), DUP(op_AND_140))), CAST(16, MSB(DUP(op_AND_140)), DUP(op_AND_140))));
	RzILOpPure *op_LSHIFT_146 = SHIFTL0(CAST(64, MSB(op_MUL_143), DUP(op_MUL_143)), SN(32, 0));
	RzILOpPure *op_RSHIFT_150 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_152 = LOGAND(op_RSHIFT_150, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_158 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_160 = LOGAND(op_RSHIFT_158, SN(32, 0xffff));
	RzILOpPure *op_MUL_163 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_152), DUP(op_AND_152))), CAST(16, MSB(DUP(op_AND_152)), DUP(op_AND_152))), CAST(32, MSB(CAST(16, MSB(op_AND_160), DUP(op_AND_160))), CAST(16, MSB(DUP(op_AND_160)), DUP(op_AND_160))));
	RzILOpPure *op_LSHIFT_166 = SHIFTL0(CAST(64, MSB(op_MUL_163), DUP(op_MUL_163)), SN(32, 0));
	RzILOpPure *op_SUB_167 = SUB(op_LSHIFT_146, op_LSHIFT_166);
	RzILOpPure *op_SUB_168 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_124), DUP(op_AND_124))), CAST(32, MSB(DUP(op_AND_124)), DUP(op_AND_124))), op_SUB_167);
	RzILOpPure *cond_244 = ITE(DUP(op_EQ_118), op_SUB_168, VARL("h_tmp260"));
	RzILOpPure *op_AND_246 = LOGAND(cond_244, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_250 = SHIFTL0(op_AND_246, SN(32, 0x20));
	RzILOpPure *op_OR_251 = LOGOR(op_AND_7, op_LSHIFT_250);
	RzILOpEffect *op_ASSIGN_252 = WRITE_REG(bundle, Rxx_op, op_OR_251);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_253 = SEQN(2, seq_243, op_ASSIGN_252);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_423 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_268 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_270 = LOGAND(op_RSHIFT_268, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_276 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_278 = LOGAND(op_RSHIFT_276, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_284 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_286 = LOGAND(op_RSHIFT_284, SN(32, 0xffff));
	RzILOpPure *op_MUL_289 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_278), DUP(op_AND_278))), CAST(16, MSB(DUP(op_AND_278)), DUP(op_AND_278))), CAST(32, MSB(CAST(16, MSB(op_AND_286), DUP(op_AND_286))), CAST(16, MSB(DUP(op_AND_286)), DUP(op_AND_286))));
	RzILOpPure *op_LSHIFT_292 = SHIFTL0(CAST(64, MSB(op_MUL_289), DUP(op_MUL_289)), SN(32, 0));
	RzILOpPure *op_RSHIFT_296 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_298 = LOGAND(op_RSHIFT_296, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_304 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_306 = LOGAND(op_RSHIFT_304, SN(32, 0xffff));
	RzILOpPure *op_MUL_309 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_298), DUP(op_AND_298))), CAST(16, MSB(DUP(op_AND_298)), DUP(op_AND_298))), CAST(32, MSB(CAST(16, MSB(op_AND_306), DUP(op_AND_306))), CAST(16, MSB(DUP(op_AND_306)), DUP(op_AND_306))));
	RzILOpPure *op_LSHIFT_312 = SHIFTL0(CAST(64, MSB(op_MUL_309), DUP(op_MUL_309)), SN(32, 0));
	RzILOpPure *op_ADD_313 = ADD(op_LSHIFT_292, op_LSHIFT_312);
	RzILOpPure *op_SUB_314 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_270), DUP(op_AND_270))), CAST(32, MSB(DUP(op_AND_270)), DUP(op_AND_270))), op_ADD_313);
	RzILOpPure *op_RSHIFT_323 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_325 = LOGAND(op_RSHIFT_323, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_331 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_333 = LOGAND(op_RSHIFT_331, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_339 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_341 = LOGAND(op_RSHIFT_339, SN(32, 0xffff));
	RzILOpPure *op_MUL_344 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_333), DUP(op_AND_333))), CAST(16, MSB(DUP(op_AND_333)), DUP(op_AND_333))), CAST(32, MSB(CAST(16, MSB(op_AND_341), DUP(op_AND_341))), CAST(16, MSB(DUP(op_AND_341)), DUP(op_AND_341))));
	RzILOpPure *op_LSHIFT_347 = SHIFTL0(CAST(64, MSB(op_MUL_344), DUP(op_MUL_344)), SN(32, 0));
	RzILOpPure *op_RSHIFT_351 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_353 = LOGAND(op_RSHIFT_351, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_359 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_361 = LOGAND(op_RSHIFT_359, SN(32, 0xffff));
	RzILOpPure *op_MUL_364 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_353), DUP(op_AND_353))), CAST(16, MSB(DUP(op_AND_353)), DUP(op_AND_353))), CAST(32, MSB(CAST(16, MSB(op_AND_361), DUP(op_AND_361))), CAST(16, MSB(DUP(op_AND_361)), DUP(op_AND_361))));
	RzILOpPure *op_LSHIFT_367 = SHIFTL0(CAST(64, MSB(op_MUL_364), DUP(op_MUL_364)), SN(32, 0));
	RzILOpPure *op_ADD_368 = ADD(op_LSHIFT_347, op_LSHIFT_367);
	RzILOpPure *op_SUB_369 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_325), DUP(op_AND_325))), CAST(32, MSB(DUP(op_AND_325)), DUP(op_AND_325))), op_ADD_368);
	RzILOpPure *op_EQ_370 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_SUB_314), SN(32, 0), SN(32, 0x20)), op_SUB_369);
	RzILOpPure *op_RSHIFT_427 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_429 = LOGAND(op_RSHIFT_427, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_435 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_437 = LOGAND(op_RSHIFT_435, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_443 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_445 = LOGAND(op_RSHIFT_443, SN(32, 0xffff));
	RzILOpPure *op_MUL_448 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_437), DUP(op_AND_437))), CAST(16, MSB(DUP(op_AND_437)), DUP(op_AND_437))), CAST(32, MSB(CAST(16, MSB(op_AND_445), DUP(op_AND_445))), CAST(16, MSB(DUP(op_AND_445)), DUP(op_AND_445))));
	RzILOpPure *op_LSHIFT_451 = SHIFTL0(CAST(64, MSB(op_MUL_448), DUP(op_MUL_448)), SN(32, 0));
	RzILOpPure *op_RSHIFT_455 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_457 = LOGAND(op_RSHIFT_455, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_463 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_465 = LOGAND(op_RSHIFT_463, SN(32, 0xffff));
	RzILOpPure *op_MUL_468 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_457), DUP(op_AND_457))), CAST(16, MSB(DUP(op_AND_457)), DUP(op_AND_457))), CAST(32, MSB(CAST(16, MSB(op_AND_465), DUP(op_AND_465))), CAST(16, MSB(DUP(op_AND_465)), DUP(op_AND_465))));
	RzILOpPure *op_LSHIFT_471 = SHIFTL0(CAST(64, MSB(op_MUL_468), DUP(op_MUL_468)), SN(32, 0));
	RzILOpPure *op_ADD_472 = ADD(op_LSHIFT_451, op_LSHIFT_471);
	RzILOpPure *op_SUB_473 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_429), DUP(op_AND_429))), CAST(32, MSB(DUP(op_AND_429)), DUP(op_AND_429))), op_ADD_472);
	RzILOpPure *op_LT_476 = SLT(op_SUB_473, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_481 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_482 = NEG(op_LSHIFT_481);
	RzILOpPure *op_LSHIFT_487 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_490 = SUB(op_LSHIFT_487, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_491 = ITE(op_LT_476, op_NEG_482, op_SUB_490);
	RzILOpEffect *gcc_expr_492 = BRANCH(op_EQ_370, EMPTY(), set_usr_field_call_423);

	// h_tmp261 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_494 = SETL("h_tmp261", cond_491);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_495 = SEQN(2, gcc_expr_492, op_ASSIGN_hybrid_tmp_494);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) : h_tmp261) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_259 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_260 = LOGNOT(op_LSHIFT_259);
	RzILOpPure *op_AND_261 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_260);
	RzILOpPure *op_RSHIFT_374 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_376 = LOGAND(op_RSHIFT_374, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_382 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_384 = LOGAND(op_RSHIFT_382, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_390 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_392 = LOGAND(op_RSHIFT_390, SN(32, 0xffff));
	RzILOpPure *op_MUL_395 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_384), DUP(op_AND_384))), CAST(16, MSB(DUP(op_AND_384)), DUP(op_AND_384))), CAST(32, MSB(CAST(16, MSB(op_AND_392), DUP(op_AND_392))), CAST(16, MSB(DUP(op_AND_392)), DUP(op_AND_392))));
	RzILOpPure *op_LSHIFT_398 = SHIFTL0(CAST(64, MSB(op_MUL_395), DUP(op_MUL_395)), SN(32, 0));
	RzILOpPure *op_RSHIFT_402 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_404 = LOGAND(op_RSHIFT_402, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_410 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_412 = LOGAND(op_RSHIFT_410, SN(32, 0xffff));
	RzILOpPure *op_MUL_415 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_404), DUP(op_AND_404))), CAST(16, MSB(DUP(op_AND_404)), DUP(op_AND_404))), CAST(32, MSB(CAST(16, MSB(op_AND_412), DUP(op_AND_412))), CAST(16, MSB(DUP(op_AND_412)), DUP(op_AND_412))));
	RzILOpPure *op_LSHIFT_418 = SHIFTL0(CAST(64, MSB(op_MUL_415), DUP(op_MUL_415)), SN(32, 0));
	RzILOpPure *op_ADD_419 = ADD(op_LSHIFT_398, op_LSHIFT_418);
	RzILOpPure *op_SUB_420 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_376), DUP(op_AND_376))), CAST(32, MSB(DUP(op_AND_376)), DUP(op_AND_376))), op_ADD_419);
	RzILOpPure *cond_496 = ITE(DUP(op_EQ_370), op_SUB_420, VARL("h_tmp261"));
	RzILOpPure *op_AND_498 = LOGAND(cond_496, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_502 = SHIFTL0(op_AND_498, SN(32, 0));
	RzILOpPure *op_OR_503 = LOGOR(op_AND_261, op_LSHIFT_502);
	RzILOpEffect *op_ASSIGN_504 = WRITE_REG(bundle, Rxx_op, op_OR_503);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_505 = SEQN(2, seq_495, op_ASSIGN_504);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_253, seq_505);
	return instruction_sequence;
}

// Rxx -= cmpy(Rs,Rt*):<<1:sat
RzILOpEffect *hex_il_op_m2_cnacsc_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_171 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_25 = LOGAND(op_RSHIFT_23, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_32 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_34 = LOGAND(op_RSHIFT_32, SN(32, 0xffff));
	RzILOpPure *op_MUL_37 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_25), DUP(op_AND_25))), CAST(16, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(CAST(16, MSB(op_AND_34), DUP(op_AND_34))), CAST(16, MSB(DUP(op_AND_34)), DUP(op_AND_34))));
	RzILOpPure *op_LSHIFT_40 = SHIFTL0(CAST(64, MSB(op_MUL_37), DUP(op_MUL_37)), SN(32, 1));
	RzILOpPure *op_RSHIFT_44 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_46 = LOGAND(op_RSHIFT_44, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_52 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_54 = LOGAND(op_RSHIFT_52, SN(32, 0xffff));
	RzILOpPure *op_MUL_57 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_46), DUP(op_AND_46))), CAST(16, MSB(DUP(op_AND_46)), DUP(op_AND_46))), CAST(32, MSB(CAST(16, MSB(op_AND_54), DUP(op_AND_54))), CAST(16, MSB(DUP(op_AND_54)), DUP(op_AND_54))));
	RzILOpPure *op_LSHIFT_60 = SHIFTL0(CAST(64, MSB(op_MUL_57), DUP(op_MUL_57)), SN(32, 1));
	RzILOpPure *op_SUB_61 = SUB(op_LSHIFT_40, op_LSHIFT_60);
	RzILOpPure *op_SUB_62 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_SUB_61);
	RzILOpPure *op_RSHIFT_71 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_73 = LOGAND(op_RSHIFT_71, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_79 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_81 = LOGAND(op_RSHIFT_79, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_87 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_89 = LOGAND(op_RSHIFT_87, SN(32, 0xffff));
	RzILOpPure *op_MUL_92 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_81), DUP(op_AND_81))), CAST(16, MSB(DUP(op_AND_81)), DUP(op_AND_81))), CAST(32, MSB(CAST(16, MSB(op_AND_89), DUP(op_AND_89))), CAST(16, MSB(DUP(op_AND_89)), DUP(op_AND_89))));
	RzILOpPure *op_LSHIFT_95 = SHIFTL0(CAST(64, MSB(op_MUL_92), DUP(op_MUL_92)), SN(32, 1));
	RzILOpPure *op_RSHIFT_99 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_101 = LOGAND(op_RSHIFT_99, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_107 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_109 = LOGAND(op_RSHIFT_107, SN(32, 0xffff));
	RzILOpPure *op_MUL_112 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_101), DUP(op_AND_101))), CAST(16, MSB(DUP(op_AND_101)), DUP(op_AND_101))), CAST(32, MSB(CAST(16, MSB(op_AND_109), DUP(op_AND_109))), CAST(16, MSB(DUP(op_AND_109)), DUP(op_AND_109))));
	RzILOpPure *op_LSHIFT_115 = SHIFTL0(CAST(64, MSB(op_MUL_112), DUP(op_MUL_112)), SN(32, 1));
	RzILOpPure *op_SUB_116 = SUB(op_LSHIFT_95, op_LSHIFT_115);
	RzILOpPure *op_SUB_117 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_73), DUP(op_AND_73))), CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73))), op_SUB_116);
	RzILOpPure *op_EQ_118 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_SUB_62), SN(32, 0), SN(32, 0x20)), op_SUB_117);
	RzILOpPure *op_RSHIFT_175 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_177 = LOGAND(op_RSHIFT_175, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_183 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_185 = LOGAND(op_RSHIFT_183, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_191 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_193 = LOGAND(op_RSHIFT_191, SN(32, 0xffff));
	RzILOpPure *op_MUL_196 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_185), DUP(op_AND_185))), CAST(16, MSB(DUP(op_AND_185)), DUP(op_AND_185))), CAST(32, MSB(CAST(16, MSB(op_AND_193), DUP(op_AND_193))), CAST(16, MSB(DUP(op_AND_193)), DUP(op_AND_193))));
	RzILOpPure *op_LSHIFT_199 = SHIFTL0(CAST(64, MSB(op_MUL_196), DUP(op_MUL_196)), SN(32, 1));
	RzILOpPure *op_RSHIFT_203 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_205 = LOGAND(op_RSHIFT_203, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_211 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_213 = LOGAND(op_RSHIFT_211, SN(32, 0xffff));
	RzILOpPure *op_MUL_216 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_205), DUP(op_AND_205))), CAST(16, MSB(DUP(op_AND_205)), DUP(op_AND_205))), CAST(32, MSB(CAST(16, MSB(op_AND_213), DUP(op_AND_213))), CAST(16, MSB(DUP(op_AND_213)), DUP(op_AND_213))));
	RzILOpPure *op_LSHIFT_219 = SHIFTL0(CAST(64, MSB(op_MUL_216), DUP(op_MUL_216)), SN(32, 1));
	RzILOpPure *op_SUB_220 = SUB(op_LSHIFT_199, op_LSHIFT_219);
	RzILOpPure *op_SUB_221 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_177), DUP(op_AND_177))), CAST(32, MSB(DUP(op_AND_177)), DUP(op_AND_177))), op_SUB_220);
	RzILOpPure *op_LT_224 = SLT(op_SUB_221, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_229 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_230 = NEG(op_LSHIFT_229);
	RzILOpPure *op_LSHIFT_235 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_238 = SUB(op_LSHIFT_235, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_239 = ITE(op_LT_224, op_NEG_230, op_SUB_238);
	RzILOpEffect *gcc_expr_240 = BRANCH(op_EQ_118, EMPTY(), set_usr_field_call_171);

	// h_tmp262 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_242 = SETL("h_tmp262", cond_239);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_243 = SEQN(2, gcc_expr_240, op_ASSIGN_hybrid_tmp_242);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) : h_tmp262) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_122 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_124 = LOGAND(op_RSHIFT_122, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_130 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_132 = LOGAND(op_RSHIFT_130, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_138 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_140 = LOGAND(op_RSHIFT_138, SN(32, 0xffff));
	RzILOpPure *op_MUL_143 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_132), DUP(op_AND_132))), CAST(16, MSB(DUP(op_AND_132)), DUP(op_AND_132))), CAST(32, MSB(CAST(16, MSB(op_AND_140), DUP(op_AND_140))), CAST(16, MSB(DUP(op_AND_140)), DUP(op_AND_140))));
	RzILOpPure *op_LSHIFT_146 = SHIFTL0(CAST(64, MSB(op_MUL_143), DUP(op_MUL_143)), SN(32, 1));
	RzILOpPure *op_RSHIFT_150 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_152 = LOGAND(op_RSHIFT_150, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_158 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_160 = LOGAND(op_RSHIFT_158, SN(32, 0xffff));
	RzILOpPure *op_MUL_163 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_152), DUP(op_AND_152))), CAST(16, MSB(DUP(op_AND_152)), DUP(op_AND_152))), CAST(32, MSB(CAST(16, MSB(op_AND_160), DUP(op_AND_160))), CAST(16, MSB(DUP(op_AND_160)), DUP(op_AND_160))));
	RzILOpPure *op_LSHIFT_166 = SHIFTL0(CAST(64, MSB(op_MUL_163), DUP(op_MUL_163)), SN(32, 1));
	RzILOpPure *op_SUB_167 = SUB(op_LSHIFT_146, op_LSHIFT_166);
	RzILOpPure *op_SUB_168 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_124), DUP(op_AND_124))), CAST(32, MSB(DUP(op_AND_124)), DUP(op_AND_124))), op_SUB_167);
	RzILOpPure *cond_244 = ITE(DUP(op_EQ_118), op_SUB_168, VARL("h_tmp262"));
	RzILOpPure *op_AND_246 = LOGAND(cond_244, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_250 = SHIFTL0(op_AND_246, SN(32, 0x20));
	RzILOpPure *op_OR_251 = LOGOR(op_AND_7, op_LSHIFT_250);
	RzILOpEffect *op_ASSIGN_252 = WRITE_REG(bundle, Rxx_op, op_OR_251);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_253 = SEQN(2, seq_243, op_ASSIGN_252);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_423 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_268 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_270 = LOGAND(op_RSHIFT_268, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_276 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_278 = LOGAND(op_RSHIFT_276, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_284 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_286 = LOGAND(op_RSHIFT_284, SN(32, 0xffff));
	RzILOpPure *op_MUL_289 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_278), DUP(op_AND_278))), CAST(16, MSB(DUP(op_AND_278)), DUP(op_AND_278))), CAST(32, MSB(CAST(16, MSB(op_AND_286), DUP(op_AND_286))), CAST(16, MSB(DUP(op_AND_286)), DUP(op_AND_286))));
	RzILOpPure *op_LSHIFT_292 = SHIFTL0(CAST(64, MSB(op_MUL_289), DUP(op_MUL_289)), SN(32, 1));
	RzILOpPure *op_RSHIFT_296 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_298 = LOGAND(op_RSHIFT_296, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_304 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_306 = LOGAND(op_RSHIFT_304, SN(32, 0xffff));
	RzILOpPure *op_MUL_309 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_298), DUP(op_AND_298))), CAST(16, MSB(DUP(op_AND_298)), DUP(op_AND_298))), CAST(32, MSB(CAST(16, MSB(op_AND_306), DUP(op_AND_306))), CAST(16, MSB(DUP(op_AND_306)), DUP(op_AND_306))));
	RzILOpPure *op_LSHIFT_312 = SHIFTL0(CAST(64, MSB(op_MUL_309), DUP(op_MUL_309)), SN(32, 1));
	RzILOpPure *op_ADD_313 = ADD(op_LSHIFT_292, op_LSHIFT_312);
	RzILOpPure *op_SUB_314 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_270), DUP(op_AND_270))), CAST(32, MSB(DUP(op_AND_270)), DUP(op_AND_270))), op_ADD_313);
	RzILOpPure *op_RSHIFT_323 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_325 = LOGAND(op_RSHIFT_323, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_331 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_333 = LOGAND(op_RSHIFT_331, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_339 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_341 = LOGAND(op_RSHIFT_339, SN(32, 0xffff));
	RzILOpPure *op_MUL_344 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_333), DUP(op_AND_333))), CAST(16, MSB(DUP(op_AND_333)), DUP(op_AND_333))), CAST(32, MSB(CAST(16, MSB(op_AND_341), DUP(op_AND_341))), CAST(16, MSB(DUP(op_AND_341)), DUP(op_AND_341))));
	RzILOpPure *op_LSHIFT_347 = SHIFTL0(CAST(64, MSB(op_MUL_344), DUP(op_MUL_344)), SN(32, 1));
	RzILOpPure *op_RSHIFT_351 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_353 = LOGAND(op_RSHIFT_351, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_359 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_361 = LOGAND(op_RSHIFT_359, SN(32, 0xffff));
	RzILOpPure *op_MUL_364 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_353), DUP(op_AND_353))), CAST(16, MSB(DUP(op_AND_353)), DUP(op_AND_353))), CAST(32, MSB(CAST(16, MSB(op_AND_361), DUP(op_AND_361))), CAST(16, MSB(DUP(op_AND_361)), DUP(op_AND_361))));
	RzILOpPure *op_LSHIFT_367 = SHIFTL0(CAST(64, MSB(op_MUL_364), DUP(op_MUL_364)), SN(32, 1));
	RzILOpPure *op_ADD_368 = ADD(op_LSHIFT_347, op_LSHIFT_367);
	RzILOpPure *op_SUB_369 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_325), DUP(op_AND_325))), CAST(32, MSB(DUP(op_AND_325)), DUP(op_AND_325))), op_ADD_368);
	RzILOpPure *op_EQ_370 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_SUB_314), SN(32, 0), SN(32, 0x20)), op_SUB_369);
	RzILOpPure *op_RSHIFT_427 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_429 = LOGAND(op_RSHIFT_427, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_435 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_437 = LOGAND(op_RSHIFT_435, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_443 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_445 = LOGAND(op_RSHIFT_443, SN(32, 0xffff));
	RzILOpPure *op_MUL_448 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_437), DUP(op_AND_437))), CAST(16, MSB(DUP(op_AND_437)), DUP(op_AND_437))), CAST(32, MSB(CAST(16, MSB(op_AND_445), DUP(op_AND_445))), CAST(16, MSB(DUP(op_AND_445)), DUP(op_AND_445))));
	RzILOpPure *op_LSHIFT_451 = SHIFTL0(CAST(64, MSB(op_MUL_448), DUP(op_MUL_448)), SN(32, 1));
	RzILOpPure *op_RSHIFT_455 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_457 = LOGAND(op_RSHIFT_455, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_463 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_465 = LOGAND(op_RSHIFT_463, SN(32, 0xffff));
	RzILOpPure *op_MUL_468 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_457), DUP(op_AND_457))), CAST(16, MSB(DUP(op_AND_457)), DUP(op_AND_457))), CAST(32, MSB(CAST(16, MSB(op_AND_465), DUP(op_AND_465))), CAST(16, MSB(DUP(op_AND_465)), DUP(op_AND_465))));
	RzILOpPure *op_LSHIFT_471 = SHIFTL0(CAST(64, MSB(op_MUL_468), DUP(op_MUL_468)), SN(32, 1));
	RzILOpPure *op_ADD_472 = ADD(op_LSHIFT_451, op_LSHIFT_471);
	RzILOpPure *op_SUB_473 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_429), DUP(op_AND_429))), CAST(32, MSB(DUP(op_AND_429)), DUP(op_AND_429))), op_ADD_472);
	RzILOpPure *op_LT_476 = SLT(op_SUB_473, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_481 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_482 = NEG(op_LSHIFT_481);
	RzILOpPure *op_LSHIFT_487 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_490 = SUB(op_LSHIFT_487, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_491 = ITE(op_LT_476, op_NEG_482, op_SUB_490);
	RzILOpEffect *gcc_expr_492 = BRANCH(op_EQ_370, EMPTY(), set_usr_field_call_423);

	// h_tmp263 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_494 = SETL("h_tmp263", cond_491);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_495 = SEQN(2, gcc_expr_492, op_ASSIGN_hybrid_tmp_494);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) : h_tmp263) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_259 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_260 = LOGNOT(op_LSHIFT_259);
	RzILOpPure *op_AND_261 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_260);
	RzILOpPure *op_RSHIFT_374 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_376 = LOGAND(op_RSHIFT_374, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_382 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_384 = LOGAND(op_RSHIFT_382, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_390 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_392 = LOGAND(op_RSHIFT_390, SN(32, 0xffff));
	RzILOpPure *op_MUL_395 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_384), DUP(op_AND_384))), CAST(16, MSB(DUP(op_AND_384)), DUP(op_AND_384))), CAST(32, MSB(CAST(16, MSB(op_AND_392), DUP(op_AND_392))), CAST(16, MSB(DUP(op_AND_392)), DUP(op_AND_392))));
	RzILOpPure *op_LSHIFT_398 = SHIFTL0(CAST(64, MSB(op_MUL_395), DUP(op_MUL_395)), SN(32, 1));
	RzILOpPure *op_RSHIFT_402 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_404 = LOGAND(op_RSHIFT_402, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_410 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_412 = LOGAND(op_RSHIFT_410, SN(32, 0xffff));
	RzILOpPure *op_MUL_415 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_404), DUP(op_AND_404))), CAST(16, MSB(DUP(op_AND_404)), DUP(op_AND_404))), CAST(32, MSB(CAST(16, MSB(op_AND_412), DUP(op_AND_412))), CAST(16, MSB(DUP(op_AND_412)), DUP(op_AND_412))));
	RzILOpPure *op_LSHIFT_418 = SHIFTL0(CAST(64, MSB(op_MUL_415), DUP(op_MUL_415)), SN(32, 1));
	RzILOpPure *op_ADD_419 = ADD(op_LSHIFT_398, op_LSHIFT_418);
	RzILOpPure *op_SUB_420 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_376), DUP(op_AND_376))), CAST(32, MSB(DUP(op_AND_376)), DUP(op_AND_376))), op_ADD_419);
	RzILOpPure *cond_496 = ITE(DUP(op_EQ_370), op_SUB_420, VARL("h_tmp263"));
	RzILOpPure *op_AND_498 = LOGAND(cond_496, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_502 = SHIFTL0(op_AND_498, SN(32, 0));
	RzILOpPure *op_OR_503 = LOGOR(op_AND_261, op_LSHIFT_502);
	RzILOpEffect *op_ASSIGN_504 = WRITE_REG(bundle, Rxx_op, op_OR_503);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_505 = SEQN(2, seq_495, op_ASSIGN_504);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_253, seq_505);
	return instruction_sequence;
}

// Rxx += mpy(Rs,Rt)
RzILOpEffect *hex_il_op_m2_dpmpyss_acc_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = Rxx + ((st64) Rs) * ((st64) Rt);
	RzILOpPure *op_MUL_5 = MUL(CAST(64, MSB(Rs), DUP(Rs)), CAST(64, MSB(Rt), DUP(Rt)));
	RzILOpPure *op_ADD_6 = ADD(READ_REG(pkt, Rxx_op, false), op_MUL_5);
	RzILOpEffect *op_ASSIGN_7 = WRITE_REG(bundle, Rxx_op, op_ADD_6);

	RzILOpEffect *instruction_sequence = op_ASSIGN_7;
	return instruction_sequence;
}

// Rxx -= mpy(Rs,Rt)
RzILOpEffect *hex_il_op_m2_dpmpyss_nac_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = Rxx - ((st64) Rs) * ((st64) Rt);
	RzILOpPure *op_MUL_5 = MUL(CAST(64, MSB(Rs), DUP(Rs)), CAST(64, MSB(Rt), DUP(Rt)));
	RzILOpPure *op_SUB_6 = SUB(READ_REG(pkt, Rxx_op, false), op_MUL_5);
	RzILOpEffect *op_ASSIGN_7 = WRITE_REG(bundle, Rxx_op, op_SUB_6);

	RzILOpEffect *instruction_sequence = op_ASSIGN_7;
	return instruction_sequence;
}

// Rd = mpy(Rs,Rt):rnd
RzILOpEffect *hex_il_op_m2_dpmpyss_rnd_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = ((st32) (((st64) Rs) * ((st64) Rt) + 0x80000000 >> 0x20));
	RzILOpPure *op_MUL_5 = MUL(CAST(64, MSB(Rs), DUP(Rs)), CAST(64, MSB(Rt), DUP(Rt)));
	RzILOpPure *op_ADD_7 = ADD(op_MUL_5, SN(64, 0x80000000));
	RzILOpPure *op_RSHIFT_9 = SHIFTRA(op_ADD_7, SN(32, 0x20));
	RzILOpEffect *op_ASSIGN_11 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(op_RSHIFT_9), DUP(op_RSHIFT_9)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_11;
	return instruction_sequence;
}

// Rdd = mpy(Rs,Rt)
RzILOpEffect *hex_il_op_m2_dpmpyss_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rdd = ((st64) Rs) * ((st64) Rt);
	RzILOpPure *op_MUL_5 = MUL(CAST(64, MSB(Rs), DUP(Rs)), CAST(64, MSB(Rt), DUP(Rt)));
	RzILOpEffect *op_ASSIGN_6 = WRITE_REG(bundle, Rdd_op, op_MUL_5);

	RzILOpEffect *instruction_sequence = op_ASSIGN_6;
	return instruction_sequence;
}

// Rxx += mpyu(Rs,Rt)
RzILOpEffect *hex_il_op_m2_dpmpyuu_acc_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = ((st64) ((ut64) Rxx) + ((ut64) ((ut32) Rs)) * ((ut64) ((ut32) Rt)));
	RzILOpPure *op_MUL_7 = MUL(CAST(64, IL_FALSE, CAST(32, IL_FALSE, Rs)), CAST(64, IL_FALSE, CAST(32, IL_FALSE, Rt)));
	RzILOpPure *op_ADD_9 = ADD(CAST(64, IL_FALSE, READ_REG(pkt, Rxx_op, false)), op_MUL_7);
	RzILOpEffect *op_ASSIGN_11 = WRITE_REG(bundle, Rxx_op, CAST(64, IL_FALSE, op_ADD_9));

	RzILOpEffect *instruction_sequence = op_ASSIGN_11;
	return instruction_sequence;
}

// Rxx -= mpyu(Rs,Rt)
RzILOpEffect *hex_il_op_m2_dpmpyuu_nac_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = ((st64) ((ut64) Rxx) - ((ut64) ((ut32) Rs)) * ((ut64) ((ut32) Rt)));
	RzILOpPure *op_MUL_7 = MUL(CAST(64, IL_FALSE, CAST(32, IL_FALSE, Rs)), CAST(64, IL_FALSE, CAST(32, IL_FALSE, Rt)));
	RzILOpPure *op_SUB_9 = SUB(CAST(64, IL_FALSE, READ_REG(pkt, Rxx_op, false)), op_MUL_7);
	RzILOpEffect *op_ASSIGN_11 = WRITE_REG(bundle, Rxx_op, CAST(64, IL_FALSE, op_SUB_9));

	RzILOpEffect *instruction_sequence = op_ASSIGN_11;
	return instruction_sequence;
}

// Rdd = mpyu(Rs,Rt)
RzILOpEffect *hex_il_op_m2_dpmpyuu_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rdd = ((st64) ((ut64) ((ut32) Rs)) * ((ut64) ((ut32) Rt)));
	RzILOpPure *op_MUL_7 = MUL(CAST(64, IL_FALSE, CAST(32, IL_FALSE, Rs)), CAST(64, IL_FALSE, CAST(32, IL_FALSE, Rt)));
	RzILOpEffect *op_ASSIGN_9 = WRITE_REG(bundle, Rdd_op, CAST(64, IL_FALSE, op_MUL_7));

	RzILOpEffect *instruction_sequence = op_ASSIGN_9;
	return instruction_sequence;
}

// Rd = mpy(Rs,Rt.h):<<1:rnd:sat
RzILOpEffect *hex_il_op_m2_hmmpyh_rs1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_86 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x10) & 0xffff))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x10) & 0xffff))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x10) & 0xffff))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_13 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_15 = LOGAND(op_RSHIFT_13, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(64, MSB(Rs), DUP(Rs)), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_15), DUP(op_AND_15))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_24 = SHIFTL0(op_MUL_22, SN(32, 1));
	RzILOpPure *op_ADD_27 = ADD(op_LSHIFT_24, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_29 = SHIFTRA(op_ADD_27, SN(32, 16));
	RzILOpPure *op_RSHIFT_42 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_44 = LOGAND(op_RSHIFT_42, SN(32, 0xffff));
	RzILOpPure *op_MUL_51 = MUL(CAST(64, MSB(DUP(Rs)), DUP(Rs)), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_44), DUP(op_AND_44))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_53 = SHIFTL0(op_MUL_51, SN(32, 1));
	RzILOpPure *op_ADD_56 = ADD(op_LSHIFT_53, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_58 = SHIFTRA(op_ADD_56, SN(32, 16));
	RzILOpPure *op_EQ_59 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_29), SN(32, 0), SN(32, 0x20)), op_RSHIFT_58);
	RzILOpPure *op_RSHIFT_94 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_96 = LOGAND(op_RSHIFT_94, SN(32, 0xffff));
	RzILOpPure *op_MUL_103 = MUL(CAST(64, MSB(DUP(Rs)), DUP(Rs)), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_96), DUP(op_AND_96))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_105 = SHIFTL0(op_MUL_103, SN(32, 1));
	RzILOpPure *op_ADD_108 = ADD(op_LSHIFT_105, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_110 = SHIFTRA(op_ADD_108, SN(32, 16));
	RzILOpPure *op_LT_113 = SLT(op_RSHIFT_110, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_118 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_119 = NEG(op_LSHIFT_118);
	RzILOpPure *op_LSHIFT_124 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_127 = SUB(op_LSHIFT_124, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_128 = ITE(op_LT_113, op_NEG_119, op_SUB_127);
	RzILOpEffect *gcc_expr_129 = BRANCH(op_EQ_59, EMPTY(), set_usr_field_call_86);

	// h_tmp264 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x10) & 0xffff))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x10) & 0xffff))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x10) & 0xffff))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_131 = SETL("h_tmp264", cond_128);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) Rs) * sextrac ...;
	RzILOpEffect *seq_132 = SEQN(2, gcc_expr_129, op_ASSIGN_hybrid_tmp_131);

	// Rd = ((st32) ((sextract64(((ut64) ((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x10) & 0xffff))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x10) & 0xffff))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)) ? ((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x10) & 0xffff))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) : h_tmp264));
	RzILOpPure *op_RSHIFT_67 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_69 = LOGAND(op_RSHIFT_67, SN(32, 0xffff));
	RzILOpPure *op_MUL_76 = MUL(CAST(64, MSB(DUP(Rs)), DUP(Rs)), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_69), DUP(op_AND_69))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_78 = SHIFTL0(op_MUL_76, SN(32, 1));
	RzILOpPure *op_ADD_81 = ADD(op_LSHIFT_78, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_83 = SHIFTRA(op_ADD_81, SN(32, 16));
	RzILOpPure *cond_133 = ITE(DUP(op_EQ_59), op_RSHIFT_83, VARL("h_tmp264"));
	RzILOpEffect *op_ASSIGN_135 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(cond_133), DUP(cond_133)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) Rs) * sex ...;
	RzILOpEffect *seq_136 = SEQN(2, seq_132, op_ASSIGN_135);

	RzILOpEffect *instruction_sequence = seq_136;
	return instruction_sequence;
}

// Rd = mpy(Rs,Rt.h):<<1:sat
RzILOpEffect *hex_il_op_m2_hmmpyh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_77 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x10) & 0xffff))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x10) & 0xffff))), 0x0, 0x10) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x10) & 0xffff))), 0x0, 0x10) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_13 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_15 = LOGAND(op_RSHIFT_13, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(64, MSB(Rs), DUP(Rs)), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_15), DUP(op_AND_15))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_24 = SHIFTL0(op_MUL_22, SN(32, 1));
	RzILOpPure *op_RSHIFT_26 = SHIFTRA(op_LSHIFT_24, SN(32, 16));
	RzILOpPure *op_RSHIFT_39 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_41 = LOGAND(op_RSHIFT_39, SN(32, 0xffff));
	RzILOpPure *op_MUL_48 = MUL(CAST(64, MSB(DUP(Rs)), DUP(Rs)), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_41), DUP(op_AND_41))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_50 = SHIFTL0(op_MUL_48, SN(32, 1));
	RzILOpPure *op_RSHIFT_52 = SHIFTRA(op_LSHIFT_50, SN(32, 16));
	RzILOpPure *op_EQ_53 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_26), SN(32, 0), SN(32, 0x20)), op_RSHIFT_52);
	RzILOpPure *op_RSHIFT_85 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_87 = LOGAND(op_RSHIFT_85, SN(32, 0xffff));
	RzILOpPure *op_MUL_94 = MUL(CAST(64, MSB(DUP(Rs)), DUP(Rs)), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_87), DUP(op_AND_87))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_96 = SHIFTL0(op_MUL_94, SN(32, 1));
	RzILOpPure *op_RSHIFT_98 = SHIFTRA(op_LSHIFT_96, SN(32, 16));
	RzILOpPure *op_LT_101 = SLT(op_RSHIFT_98, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_106 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_107 = NEG(op_LSHIFT_106);
	RzILOpPure *op_LSHIFT_112 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_115 = SUB(op_LSHIFT_112, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_116 = ITE(op_LT_101, op_NEG_107, op_SUB_115);
	RzILOpEffect *gcc_expr_117 = BRANCH(op_EQ_53, EMPTY(), set_usr_field_call_77);

	// h_tmp265 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x10) & 0xffff))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x10) & 0xffff))), 0x0, 0x10) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x10) & 0xffff))), 0x0, 0x10) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_119 = SETL("h_tmp265", cond_116);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) Rs) * sextrac ...;
	RzILOpEffect *seq_120 = SEQN(2, gcc_expr_117, op_ASSIGN_hybrid_tmp_119);

	// Rd = ((st32) ((sextract64(((ut64) ((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x10) & 0xffff))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x10) & 0xffff))), 0x0, 0x10) << 0x1) >> 0x10)) ? ((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x10) & 0xffff))), 0x0, 0x10) << 0x1) >> 0x10) : h_tmp265));
	RzILOpPure *op_RSHIFT_61 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_63 = LOGAND(op_RSHIFT_61, SN(32, 0xffff));
	RzILOpPure *op_MUL_70 = MUL(CAST(64, MSB(DUP(Rs)), DUP(Rs)), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_63), DUP(op_AND_63))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_72 = SHIFTL0(op_MUL_70, SN(32, 1));
	RzILOpPure *op_RSHIFT_74 = SHIFTRA(op_LSHIFT_72, SN(32, 16));
	RzILOpPure *cond_121 = ITE(DUP(op_EQ_53), op_RSHIFT_74, VARL("h_tmp265"));
	RzILOpEffect *op_ASSIGN_123 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(cond_121), DUP(cond_121)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) Rs) * sex ...;
	RzILOpEffect *seq_124 = SEQN(2, seq_120, op_ASSIGN_123);

	RzILOpEffect *instruction_sequence = seq_124;
	return instruction_sequence;
}

// Rd = mpy(Rs,Rt.l):<<1:rnd:sat
RzILOpEffect *hex_il_op_m2_hmmpyl_rs1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_86 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x0) & 0xffff))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x0) & 0xffff))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x0) & 0xffff))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_13 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_15 = LOGAND(op_RSHIFT_13, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(64, MSB(Rs), DUP(Rs)), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_15), DUP(op_AND_15))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_24 = SHIFTL0(op_MUL_22, SN(32, 1));
	RzILOpPure *op_ADD_27 = ADD(op_LSHIFT_24, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_29 = SHIFTRA(op_ADD_27, SN(32, 16));
	RzILOpPure *op_RSHIFT_42 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_44 = LOGAND(op_RSHIFT_42, SN(32, 0xffff));
	RzILOpPure *op_MUL_51 = MUL(CAST(64, MSB(DUP(Rs)), DUP(Rs)), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_44), DUP(op_AND_44))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_53 = SHIFTL0(op_MUL_51, SN(32, 1));
	RzILOpPure *op_ADD_56 = ADD(op_LSHIFT_53, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_58 = SHIFTRA(op_ADD_56, SN(32, 16));
	RzILOpPure *op_EQ_59 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_29), SN(32, 0), SN(32, 0x20)), op_RSHIFT_58);
	RzILOpPure *op_RSHIFT_94 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_96 = LOGAND(op_RSHIFT_94, SN(32, 0xffff));
	RzILOpPure *op_MUL_103 = MUL(CAST(64, MSB(DUP(Rs)), DUP(Rs)), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_96), DUP(op_AND_96))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_105 = SHIFTL0(op_MUL_103, SN(32, 1));
	RzILOpPure *op_ADD_108 = ADD(op_LSHIFT_105, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_110 = SHIFTRA(op_ADD_108, SN(32, 16));
	RzILOpPure *op_LT_113 = SLT(op_RSHIFT_110, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_118 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_119 = NEG(op_LSHIFT_118);
	RzILOpPure *op_LSHIFT_124 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_127 = SUB(op_LSHIFT_124, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_128 = ITE(op_LT_113, op_NEG_119, op_SUB_127);
	RzILOpEffect *gcc_expr_129 = BRANCH(op_EQ_59, EMPTY(), set_usr_field_call_86);

	// h_tmp266 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x0) & 0xffff))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x0) & 0xffff))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x0) & 0xffff))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_131 = SETL("h_tmp266", cond_128);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) Rs) * sextrac ...;
	RzILOpEffect *seq_132 = SEQN(2, gcc_expr_129, op_ASSIGN_hybrid_tmp_131);

	// Rd = ((st32) ((sextract64(((ut64) ((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x0) & 0xffff))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x0) & 0xffff))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)) ? ((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x0) & 0xffff))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) : h_tmp266));
	RzILOpPure *op_RSHIFT_67 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_69 = LOGAND(op_RSHIFT_67, SN(32, 0xffff));
	RzILOpPure *op_MUL_76 = MUL(CAST(64, MSB(DUP(Rs)), DUP(Rs)), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_69), DUP(op_AND_69))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_78 = SHIFTL0(op_MUL_76, SN(32, 1));
	RzILOpPure *op_ADD_81 = ADD(op_LSHIFT_78, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_83 = SHIFTRA(op_ADD_81, SN(32, 16));
	RzILOpPure *cond_133 = ITE(DUP(op_EQ_59), op_RSHIFT_83, VARL("h_tmp266"));
	RzILOpEffect *op_ASSIGN_135 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(cond_133), DUP(cond_133)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) Rs) * sex ...;
	RzILOpEffect *seq_136 = SEQN(2, seq_132, op_ASSIGN_135);

	RzILOpEffect *instruction_sequence = seq_136;
	return instruction_sequence;
}

// Rd = mpy(Rs,Rt.l):<<1:sat
RzILOpEffect *hex_il_op_m2_hmmpyl_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_77 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x0) & 0xffff))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x0) & 0xffff))), 0x0, 0x10) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x0) & 0xffff))), 0x0, 0x10) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_13 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_15 = LOGAND(op_RSHIFT_13, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(64, MSB(Rs), DUP(Rs)), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_15), DUP(op_AND_15))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_24 = SHIFTL0(op_MUL_22, SN(32, 1));
	RzILOpPure *op_RSHIFT_26 = SHIFTRA(op_LSHIFT_24, SN(32, 16));
	RzILOpPure *op_RSHIFT_39 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_41 = LOGAND(op_RSHIFT_39, SN(32, 0xffff));
	RzILOpPure *op_MUL_48 = MUL(CAST(64, MSB(DUP(Rs)), DUP(Rs)), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_41), DUP(op_AND_41))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_50 = SHIFTL0(op_MUL_48, SN(32, 1));
	RzILOpPure *op_RSHIFT_52 = SHIFTRA(op_LSHIFT_50, SN(32, 16));
	RzILOpPure *op_EQ_53 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_26), SN(32, 0), SN(32, 0x20)), op_RSHIFT_52);
	RzILOpPure *op_RSHIFT_85 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_87 = LOGAND(op_RSHIFT_85, SN(32, 0xffff));
	RzILOpPure *op_MUL_94 = MUL(CAST(64, MSB(DUP(Rs)), DUP(Rs)), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_87), DUP(op_AND_87))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_96 = SHIFTL0(op_MUL_94, SN(32, 1));
	RzILOpPure *op_RSHIFT_98 = SHIFTRA(op_LSHIFT_96, SN(32, 16));
	RzILOpPure *op_LT_101 = SLT(op_RSHIFT_98, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_106 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_107 = NEG(op_LSHIFT_106);
	RzILOpPure *op_LSHIFT_112 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_115 = SUB(op_LSHIFT_112, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_116 = ITE(op_LT_101, op_NEG_107, op_SUB_115);
	RzILOpEffect *gcc_expr_117 = BRANCH(op_EQ_53, EMPTY(), set_usr_field_call_77);

	// h_tmp267 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x0) & 0xffff))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x0) & 0xffff))), 0x0, 0x10) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x0) & 0xffff))), 0x0, 0x10) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_119 = SETL("h_tmp267", cond_116);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) Rs) * sextrac ...;
	RzILOpEffect *seq_120 = SEQN(2, gcc_expr_117, op_ASSIGN_hybrid_tmp_119);

	// Rd = ((st32) ((sextract64(((ut64) ((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x0) & 0xffff))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x0) & 0xffff))), 0x0, 0x10) << 0x1) >> 0x10)) ? ((((st64) Rs) * sextract64(((ut64) ((st16) ((Rt >> 0x0) & 0xffff))), 0x0, 0x10) << 0x1) >> 0x10) : h_tmp267));
	RzILOpPure *op_RSHIFT_61 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_63 = LOGAND(op_RSHIFT_61, SN(32, 0xffff));
	RzILOpPure *op_MUL_70 = MUL(CAST(64, MSB(DUP(Rs)), DUP(Rs)), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_63), DUP(op_AND_63))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_72 = SHIFTL0(op_MUL_70, SN(32, 1));
	RzILOpPure *op_RSHIFT_74 = SHIFTRA(op_LSHIFT_72, SN(32, 16));
	RzILOpPure *cond_121 = ITE(DUP(op_EQ_53), op_RSHIFT_74, VARL("h_tmp267"));
	RzILOpEffect *op_ASSIGN_123 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(cond_121), DUP(cond_121)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) Rs) * sex ...;
	RzILOpEffect *seq_124 = SEQN(2, seq_120, op_ASSIGN_123);

	RzILOpEffect *instruction_sequence = seq_124;
	return instruction_sequence;
}

// Rx += mpyi(Rs,Rt)
RzILOpEffect *hex_il_op_m2_maci(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = Rx + Rs * Rt;
	RzILOpPure *op_MUL_3 = MUL(Rs, Rt);
	RzILOpPure *op_ADD_4 = ADD(READ_REG(pkt, Rx_op, false), op_MUL_3);
	RzILOpEffect *op_ASSIGN_5 = WRITE_REG(bundle, Rx_op, op_ADD_4);

	RzILOpEffect *instruction_sequence = op_ASSIGN_5;
	return instruction_sequence;
}

// Rx -= mpyi(Rs,Ii)
RzILOpEffect *hex_il_op_m2_macsin(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	RzILOpPure *u = UN(32, (ut32)ISA2IMM(hi, 'u'));
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);

	// u = u;
	RzILOpEffect *imm_assign_0 = SETL("u", u);

	// Rx = ((st32) ((ut32) Rx) - ((ut32) Rs) * u);
	RzILOpPure *op_MUL_5 = MUL(CAST(32, IL_FALSE, Rs), VARL("u"));
	RzILOpPure *op_SUB_7 = SUB(CAST(32, IL_FALSE, READ_REG(pkt, Rx_op, false)), op_MUL_5);
	RzILOpEffect *op_ASSIGN_9 = WRITE_REG(bundle, Rx_op, CAST(32, IL_FALSE, op_SUB_7));

	RzILOpEffect *instruction_sequence = SEQN(2, imm_assign_0, op_ASSIGN_9);
	return instruction_sequence;
}

// Rx += mpyi(Rs,Ii)
RzILOpEffect *hex_il_op_m2_macsip(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	RzILOpPure *u = UN(32, (ut32)ISA2IMM(hi, 'u'));
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);

	// u = u;
	RzILOpEffect *imm_assign_0 = SETL("u", u);

	// Rx = ((st32) ((ut32) Rx) + ((ut32) Rs) * u);
	RzILOpPure *op_MUL_5 = MUL(CAST(32, IL_FALSE, Rs), VARL("u"));
	RzILOpPure *op_ADD_7 = ADD(CAST(32, IL_FALSE, READ_REG(pkt, Rx_op, false)), op_MUL_5);
	RzILOpEffect *op_ASSIGN_9 = WRITE_REG(bundle, Rx_op, CAST(32, IL_FALSE, op_ADD_7));

	RzILOpEffect *instruction_sequence = SEQN(2, imm_assign_0, op_ASSIGN_9);
	return instruction_sequence;
}

// Rxx += vmpywoh(Rss,Rtt):rnd:sat
RzILOpEffect *hex_il_op_m2_mmachs_rs0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_150 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_25 = LOGAND(op_RSHIFT_23, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_37 = SHIFTRA(Rtt, SN(32, 0x30));
	RzILOpPure *op_AND_40 = LOGAND(op_RSHIFT_37, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_47 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_25), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_40), DUP(op_AND_40))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_49 = SHIFTL0(op_MUL_47, SN(32, 0));
	RzILOpPure *op_ADD_52 = ADD(op_LSHIFT_49, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_54 = SHIFTRA(op_ADD_52, SN(32, 16));
	RzILOpPure *op_ADD_55 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_RSHIFT_54);
	RzILOpPure *op_RSHIFT_64 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_66 = LOGAND(op_RSHIFT_64, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_72 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_74 = LOGAND(op_RSHIFT_72, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_85 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_88 = LOGAND(op_RSHIFT_85, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_95 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_74), DUP(op_AND_74))), CAST(32, MSB(DUP(op_AND_74)), DUP(op_AND_74)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_74)), DUP(op_AND_74))), CAST(32, MSB(DUP(op_AND_74)), DUP(op_AND_74))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_74)), DUP(op_AND_74))), CAST(32, MSB(DUP(op_AND_74)), DUP(op_AND_74)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_74)), DUP(op_AND_74))), CAST(32, MSB(DUP(op_AND_74)), DUP(op_AND_74))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_88), DUP(op_AND_88))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_97 = SHIFTL0(op_MUL_95, SN(32, 0));
	RzILOpPure *op_ADD_100 = ADD(op_LSHIFT_97, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_102 = SHIFTRA(op_ADD_100, SN(32, 16));
	RzILOpPure *op_ADD_103 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_66), DUP(op_AND_66))), CAST(32, MSB(DUP(op_AND_66)), DUP(op_AND_66))), op_RSHIFT_102);
	RzILOpPure *op_EQ_104 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_55), SN(32, 0), SN(32, 0x20)), op_ADD_103);
	RzILOpPure *op_RSHIFT_154 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_156 = LOGAND(op_RSHIFT_154, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_162 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_164 = LOGAND(op_RSHIFT_162, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_175 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_178 = LOGAND(op_RSHIFT_175, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_185 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_164), DUP(op_AND_164))), CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164))), CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164))), CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164))), CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_178), DUP(op_AND_178))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_187 = SHIFTL0(op_MUL_185, SN(32, 0));
	RzILOpPure *op_ADD_190 = ADD(op_LSHIFT_187, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_192 = SHIFTRA(op_ADD_190, SN(32, 16));
	RzILOpPure *op_ADD_193 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_156), DUP(op_AND_156))), CAST(32, MSB(DUP(op_AND_156)), DUP(op_AND_156))), op_RSHIFT_192);
	RzILOpPure *op_LT_196 = SLT(op_ADD_193, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_201 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_202 = NEG(op_LSHIFT_201);
	RzILOpPure *op_LSHIFT_207 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_210 = SUB(op_LSHIFT_207, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_211 = ITE(op_LT_196, op_NEG_202, op_SUB_210);
	RzILOpEffect *gcc_expr_212 = BRANCH(op_EQ_104, EMPTY(), set_usr_field_call_150);

	// h_tmp268 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_214 = SETL("h_tmp268", cond_211);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_215 = SEQN(2, gcc_expr_212, op_ASSIGN_hybrid_tmp_214);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10) : h_tmp268) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_108 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_110 = LOGAND(op_RSHIFT_108, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_116 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_118 = LOGAND(op_RSHIFT_116, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_129 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_132 = LOGAND(op_RSHIFT_129, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_139 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_118), DUP(op_AND_118))), CAST(32, MSB(DUP(op_AND_118)), DUP(op_AND_118)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_118)), DUP(op_AND_118))), CAST(32, MSB(DUP(op_AND_118)), DUP(op_AND_118))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_118)), DUP(op_AND_118))), CAST(32, MSB(DUP(op_AND_118)), DUP(op_AND_118)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_118)), DUP(op_AND_118))), CAST(32, MSB(DUP(op_AND_118)), DUP(op_AND_118))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_132), DUP(op_AND_132))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_141 = SHIFTL0(op_MUL_139, SN(32, 0));
	RzILOpPure *op_ADD_144 = ADD(op_LSHIFT_141, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_146 = SHIFTRA(op_ADD_144, SN(32, 16));
	RzILOpPure *op_ADD_147 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_110), DUP(op_AND_110))), CAST(32, MSB(DUP(op_AND_110)), DUP(op_AND_110))), op_RSHIFT_146);
	RzILOpPure *cond_216 = ITE(DUP(op_EQ_104), op_ADD_147, VARL("h_tmp268"));
	RzILOpPure *op_AND_218 = LOGAND(cond_216, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_222 = SHIFTL0(op_AND_218, SN(32, 0x20));
	RzILOpPure *op_OR_223 = LOGOR(op_AND_7, op_LSHIFT_222);
	RzILOpEffect *op_ASSIGN_224 = WRITE_REG(bundle, Rxx_op, op_OR_223);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_225 = SEQN(2, seq_215, op_ASSIGN_224);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_374 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_240 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_242 = LOGAND(op_RSHIFT_240, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_248 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_250 = LOGAND(op_RSHIFT_248, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_261 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_264 = LOGAND(op_RSHIFT_261, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_271 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_250), DUP(op_AND_250))), CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250))), CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250))), CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250))), CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_264), DUP(op_AND_264))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_273 = SHIFTL0(op_MUL_271, SN(32, 0));
	RzILOpPure *op_ADD_276 = ADD(op_LSHIFT_273, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_278 = SHIFTRA(op_ADD_276, SN(32, 16));
	RzILOpPure *op_ADD_279 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_242), DUP(op_AND_242))), CAST(32, MSB(DUP(op_AND_242)), DUP(op_AND_242))), op_RSHIFT_278);
	RzILOpPure *op_RSHIFT_288 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_290 = LOGAND(op_RSHIFT_288, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_296 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_298 = LOGAND(op_RSHIFT_296, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_309 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_312 = LOGAND(op_RSHIFT_309, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_319 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_298), DUP(op_AND_298))), CAST(32, MSB(DUP(op_AND_298)), DUP(op_AND_298)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_298)), DUP(op_AND_298))), CAST(32, MSB(DUP(op_AND_298)), DUP(op_AND_298))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_298)), DUP(op_AND_298))), CAST(32, MSB(DUP(op_AND_298)), DUP(op_AND_298)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_298)), DUP(op_AND_298))), CAST(32, MSB(DUP(op_AND_298)), DUP(op_AND_298))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_312), DUP(op_AND_312))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_321 = SHIFTL0(op_MUL_319, SN(32, 0));
	RzILOpPure *op_ADD_324 = ADD(op_LSHIFT_321, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_326 = SHIFTRA(op_ADD_324, SN(32, 16));
	RzILOpPure *op_ADD_327 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_290), DUP(op_AND_290))), CAST(32, MSB(DUP(op_AND_290)), DUP(op_AND_290))), op_RSHIFT_326);
	RzILOpPure *op_EQ_328 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_279), SN(32, 0), SN(32, 0x20)), op_ADD_327);
	RzILOpPure *op_RSHIFT_378 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_380 = LOGAND(op_RSHIFT_378, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_386 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_388 = LOGAND(op_RSHIFT_386, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_399 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_402 = LOGAND(op_RSHIFT_399, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_409 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_388), DUP(op_AND_388))), CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388))), CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388))), CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388))), CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_402), DUP(op_AND_402))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_411 = SHIFTL0(op_MUL_409, SN(32, 0));
	RzILOpPure *op_ADD_414 = ADD(op_LSHIFT_411, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_416 = SHIFTRA(op_ADD_414, SN(32, 16));
	RzILOpPure *op_ADD_417 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_380), DUP(op_AND_380))), CAST(32, MSB(DUP(op_AND_380)), DUP(op_AND_380))), op_RSHIFT_416);
	RzILOpPure *op_LT_420 = SLT(op_ADD_417, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_425 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_426 = NEG(op_LSHIFT_425);
	RzILOpPure *op_LSHIFT_431 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_434 = SUB(op_LSHIFT_431, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_435 = ITE(op_LT_420, op_NEG_426, op_SUB_434);
	RzILOpEffect *gcc_expr_436 = BRANCH(op_EQ_328, EMPTY(), set_usr_field_call_374);

	// h_tmp269 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_438 = SETL("h_tmp269", cond_435);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_439 = SEQN(2, gcc_expr_436, op_ASSIGN_hybrid_tmp_438);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10) : h_tmp269) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_231 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_232 = LOGNOT(op_LSHIFT_231);
	RzILOpPure *op_AND_233 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_232);
	RzILOpPure *op_RSHIFT_332 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_334 = LOGAND(op_RSHIFT_332, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_340 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_342 = LOGAND(op_RSHIFT_340, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_353 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_356 = LOGAND(op_RSHIFT_353, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_363 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_342), DUP(op_AND_342))), CAST(32, MSB(DUP(op_AND_342)), DUP(op_AND_342)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_342)), DUP(op_AND_342))), CAST(32, MSB(DUP(op_AND_342)), DUP(op_AND_342))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_342)), DUP(op_AND_342))), CAST(32, MSB(DUP(op_AND_342)), DUP(op_AND_342)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_342)), DUP(op_AND_342))), CAST(32, MSB(DUP(op_AND_342)), DUP(op_AND_342))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_356), DUP(op_AND_356))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_365 = SHIFTL0(op_MUL_363, SN(32, 0));
	RzILOpPure *op_ADD_368 = ADD(op_LSHIFT_365, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_370 = SHIFTRA(op_ADD_368, SN(32, 16));
	RzILOpPure *op_ADD_371 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_334), DUP(op_AND_334))), CAST(32, MSB(DUP(op_AND_334)), DUP(op_AND_334))), op_RSHIFT_370);
	RzILOpPure *cond_440 = ITE(DUP(op_EQ_328), op_ADD_371, VARL("h_tmp269"));
	RzILOpPure *op_AND_442 = LOGAND(cond_440, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_446 = SHIFTL0(op_AND_442, SN(32, 0));
	RzILOpPure *op_OR_447 = LOGOR(op_AND_233, op_LSHIFT_446);
	RzILOpEffect *op_ASSIGN_448 = WRITE_REG(bundle, Rxx_op, op_OR_447);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_449 = SEQN(2, seq_439, op_ASSIGN_448);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_225, seq_449);
	return instruction_sequence;
}

// Rxx += vmpywoh(Rss,Rtt):<<1:rnd:sat
RzILOpEffect *hex_il_op_m2_mmachs_rs1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_150 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_25 = LOGAND(op_RSHIFT_23, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_37 = SHIFTRA(Rtt, SN(32, 0x30));
	RzILOpPure *op_AND_40 = LOGAND(op_RSHIFT_37, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_47 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_25), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_40), DUP(op_AND_40))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_49 = SHIFTL0(op_MUL_47, SN(32, 1));
	RzILOpPure *op_ADD_52 = ADD(op_LSHIFT_49, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_54 = SHIFTRA(op_ADD_52, SN(32, 16));
	RzILOpPure *op_ADD_55 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_RSHIFT_54);
	RzILOpPure *op_RSHIFT_64 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_66 = LOGAND(op_RSHIFT_64, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_72 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_74 = LOGAND(op_RSHIFT_72, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_85 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_88 = LOGAND(op_RSHIFT_85, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_95 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_74), DUP(op_AND_74))), CAST(32, MSB(DUP(op_AND_74)), DUP(op_AND_74)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_74)), DUP(op_AND_74))), CAST(32, MSB(DUP(op_AND_74)), DUP(op_AND_74))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_74)), DUP(op_AND_74))), CAST(32, MSB(DUP(op_AND_74)), DUP(op_AND_74)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_74)), DUP(op_AND_74))), CAST(32, MSB(DUP(op_AND_74)), DUP(op_AND_74))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_88), DUP(op_AND_88))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_97 = SHIFTL0(op_MUL_95, SN(32, 1));
	RzILOpPure *op_ADD_100 = ADD(op_LSHIFT_97, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_102 = SHIFTRA(op_ADD_100, SN(32, 16));
	RzILOpPure *op_ADD_103 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_66), DUP(op_AND_66))), CAST(32, MSB(DUP(op_AND_66)), DUP(op_AND_66))), op_RSHIFT_102);
	RzILOpPure *op_EQ_104 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_55), SN(32, 0), SN(32, 0x20)), op_ADD_103);
	RzILOpPure *op_RSHIFT_154 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_156 = LOGAND(op_RSHIFT_154, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_162 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_164 = LOGAND(op_RSHIFT_162, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_175 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_178 = LOGAND(op_RSHIFT_175, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_185 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_164), DUP(op_AND_164))), CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164))), CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164))), CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164))), CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_178), DUP(op_AND_178))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_187 = SHIFTL0(op_MUL_185, SN(32, 1));
	RzILOpPure *op_ADD_190 = ADD(op_LSHIFT_187, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_192 = SHIFTRA(op_ADD_190, SN(32, 16));
	RzILOpPure *op_ADD_193 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_156), DUP(op_AND_156))), CAST(32, MSB(DUP(op_AND_156)), DUP(op_AND_156))), op_RSHIFT_192);
	RzILOpPure *op_LT_196 = SLT(op_ADD_193, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_201 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_202 = NEG(op_LSHIFT_201);
	RzILOpPure *op_LSHIFT_207 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_210 = SUB(op_LSHIFT_207, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_211 = ITE(op_LT_196, op_NEG_202, op_SUB_210);
	RzILOpEffect *gcc_expr_212 = BRANCH(op_EQ_104, EMPTY(), set_usr_field_call_150);

	// h_tmp270 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_214 = SETL("h_tmp270", cond_211);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_215 = SEQN(2, gcc_expr_212, op_ASSIGN_hybrid_tmp_214);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) : h_tmp270) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_108 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_110 = LOGAND(op_RSHIFT_108, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_116 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_118 = LOGAND(op_RSHIFT_116, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_129 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_132 = LOGAND(op_RSHIFT_129, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_139 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_118), DUP(op_AND_118))), CAST(32, MSB(DUP(op_AND_118)), DUP(op_AND_118)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_118)), DUP(op_AND_118))), CAST(32, MSB(DUP(op_AND_118)), DUP(op_AND_118))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_118)), DUP(op_AND_118))), CAST(32, MSB(DUP(op_AND_118)), DUP(op_AND_118)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_118)), DUP(op_AND_118))), CAST(32, MSB(DUP(op_AND_118)), DUP(op_AND_118))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_132), DUP(op_AND_132))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_141 = SHIFTL0(op_MUL_139, SN(32, 1));
	RzILOpPure *op_ADD_144 = ADD(op_LSHIFT_141, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_146 = SHIFTRA(op_ADD_144, SN(32, 16));
	RzILOpPure *op_ADD_147 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_110), DUP(op_AND_110))), CAST(32, MSB(DUP(op_AND_110)), DUP(op_AND_110))), op_RSHIFT_146);
	RzILOpPure *cond_216 = ITE(DUP(op_EQ_104), op_ADD_147, VARL("h_tmp270"));
	RzILOpPure *op_AND_218 = LOGAND(cond_216, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_222 = SHIFTL0(op_AND_218, SN(32, 0x20));
	RzILOpPure *op_OR_223 = LOGOR(op_AND_7, op_LSHIFT_222);
	RzILOpEffect *op_ASSIGN_224 = WRITE_REG(bundle, Rxx_op, op_OR_223);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_225 = SEQN(2, seq_215, op_ASSIGN_224);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_374 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_240 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_242 = LOGAND(op_RSHIFT_240, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_248 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_250 = LOGAND(op_RSHIFT_248, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_261 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_264 = LOGAND(op_RSHIFT_261, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_271 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_250), DUP(op_AND_250))), CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250))), CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250))), CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250))), CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_264), DUP(op_AND_264))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_273 = SHIFTL0(op_MUL_271, SN(32, 1));
	RzILOpPure *op_ADD_276 = ADD(op_LSHIFT_273, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_278 = SHIFTRA(op_ADD_276, SN(32, 16));
	RzILOpPure *op_ADD_279 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_242), DUP(op_AND_242))), CAST(32, MSB(DUP(op_AND_242)), DUP(op_AND_242))), op_RSHIFT_278);
	RzILOpPure *op_RSHIFT_288 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_290 = LOGAND(op_RSHIFT_288, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_296 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_298 = LOGAND(op_RSHIFT_296, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_309 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_312 = LOGAND(op_RSHIFT_309, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_319 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_298), DUP(op_AND_298))), CAST(32, MSB(DUP(op_AND_298)), DUP(op_AND_298)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_298)), DUP(op_AND_298))), CAST(32, MSB(DUP(op_AND_298)), DUP(op_AND_298))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_298)), DUP(op_AND_298))), CAST(32, MSB(DUP(op_AND_298)), DUP(op_AND_298)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_298)), DUP(op_AND_298))), CAST(32, MSB(DUP(op_AND_298)), DUP(op_AND_298))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_312), DUP(op_AND_312))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_321 = SHIFTL0(op_MUL_319, SN(32, 1));
	RzILOpPure *op_ADD_324 = ADD(op_LSHIFT_321, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_326 = SHIFTRA(op_ADD_324, SN(32, 16));
	RzILOpPure *op_ADD_327 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_290), DUP(op_AND_290))), CAST(32, MSB(DUP(op_AND_290)), DUP(op_AND_290))), op_RSHIFT_326);
	RzILOpPure *op_EQ_328 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_279), SN(32, 0), SN(32, 0x20)), op_ADD_327);
	RzILOpPure *op_RSHIFT_378 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_380 = LOGAND(op_RSHIFT_378, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_386 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_388 = LOGAND(op_RSHIFT_386, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_399 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_402 = LOGAND(op_RSHIFT_399, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_409 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_388), DUP(op_AND_388))), CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388))), CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388))), CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388))), CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_402), DUP(op_AND_402))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_411 = SHIFTL0(op_MUL_409, SN(32, 1));
	RzILOpPure *op_ADD_414 = ADD(op_LSHIFT_411, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_416 = SHIFTRA(op_ADD_414, SN(32, 16));
	RzILOpPure *op_ADD_417 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_380), DUP(op_AND_380))), CAST(32, MSB(DUP(op_AND_380)), DUP(op_AND_380))), op_RSHIFT_416);
	RzILOpPure *op_LT_420 = SLT(op_ADD_417, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_425 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_426 = NEG(op_LSHIFT_425);
	RzILOpPure *op_LSHIFT_431 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_434 = SUB(op_LSHIFT_431, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_435 = ITE(op_LT_420, op_NEG_426, op_SUB_434);
	RzILOpEffect *gcc_expr_436 = BRANCH(op_EQ_328, EMPTY(), set_usr_field_call_374);

	// h_tmp271 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_438 = SETL("h_tmp271", cond_435);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_439 = SEQN(2, gcc_expr_436, op_ASSIGN_hybrid_tmp_438);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) : h_tmp271) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_231 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_232 = LOGNOT(op_LSHIFT_231);
	RzILOpPure *op_AND_233 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_232);
	RzILOpPure *op_RSHIFT_332 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_334 = LOGAND(op_RSHIFT_332, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_340 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_342 = LOGAND(op_RSHIFT_340, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_353 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_356 = LOGAND(op_RSHIFT_353, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_363 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_342), DUP(op_AND_342))), CAST(32, MSB(DUP(op_AND_342)), DUP(op_AND_342)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_342)), DUP(op_AND_342))), CAST(32, MSB(DUP(op_AND_342)), DUP(op_AND_342))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_342)), DUP(op_AND_342))), CAST(32, MSB(DUP(op_AND_342)), DUP(op_AND_342)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_342)), DUP(op_AND_342))), CAST(32, MSB(DUP(op_AND_342)), DUP(op_AND_342))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_356), DUP(op_AND_356))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_365 = SHIFTL0(op_MUL_363, SN(32, 1));
	RzILOpPure *op_ADD_368 = ADD(op_LSHIFT_365, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_370 = SHIFTRA(op_ADD_368, SN(32, 16));
	RzILOpPure *op_ADD_371 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_334), DUP(op_AND_334))), CAST(32, MSB(DUP(op_AND_334)), DUP(op_AND_334))), op_RSHIFT_370);
	RzILOpPure *cond_440 = ITE(DUP(op_EQ_328), op_ADD_371, VARL("h_tmp271"));
	RzILOpPure *op_AND_442 = LOGAND(cond_440, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_446 = SHIFTL0(op_AND_442, SN(32, 0));
	RzILOpPure *op_OR_447 = LOGOR(op_AND_233, op_LSHIFT_446);
	RzILOpEffect *op_ASSIGN_448 = WRITE_REG(bundle, Rxx_op, op_OR_447);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_449 = SEQN(2, seq_439, op_ASSIGN_448);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_225, seq_449);
	return instruction_sequence;
}

// Rxx += vmpywoh(Rss,Rtt):sat
RzILOpEffect *hex_il_op_m2_mmachs_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_141 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_25 = LOGAND(op_RSHIFT_23, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_37 = SHIFTRA(Rtt, SN(32, 0x30));
	RzILOpPure *op_AND_40 = LOGAND(op_RSHIFT_37, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_47 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_25), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_40), DUP(op_AND_40))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_49 = SHIFTL0(op_MUL_47, SN(32, 0));
	RzILOpPure *op_RSHIFT_51 = SHIFTRA(op_LSHIFT_49, SN(32, 16));
	RzILOpPure *op_ADD_52 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_RSHIFT_51);
	RzILOpPure *op_RSHIFT_61 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_63 = LOGAND(op_RSHIFT_61, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_69 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_71 = LOGAND(op_RSHIFT_69, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_82 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_85 = LOGAND(op_RSHIFT_82, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_92 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_71), DUP(op_AND_71))), CAST(32, MSB(DUP(op_AND_71)), DUP(op_AND_71)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_71)), DUP(op_AND_71))), CAST(32, MSB(DUP(op_AND_71)), DUP(op_AND_71))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_71)), DUP(op_AND_71))), CAST(32, MSB(DUP(op_AND_71)), DUP(op_AND_71)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_71)), DUP(op_AND_71))), CAST(32, MSB(DUP(op_AND_71)), DUP(op_AND_71))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_85), DUP(op_AND_85))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_94 = SHIFTL0(op_MUL_92, SN(32, 0));
	RzILOpPure *op_RSHIFT_96 = SHIFTRA(op_LSHIFT_94, SN(32, 16));
	RzILOpPure *op_ADD_97 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_63), DUP(op_AND_63))), CAST(32, MSB(DUP(op_AND_63)), DUP(op_AND_63))), op_RSHIFT_96);
	RzILOpPure *op_EQ_98 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_52), SN(32, 0), SN(32, 0x20)), op_ADD_97);
	RzILOpPure *op_RSHIFT_145 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_147 = LOGAND(op_RSHIFT_145, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_153 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_155 = LOGAND(op_RSHIFT_153, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_166 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_169 = LOGAND(op_RSHIFT_166, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_176 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_155), DUP(op_AND_155))), CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155))), CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155))), CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155))), CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_169), DUP(op_AND_169))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_178 = SHIFTL0(op_MUL_176, SN(32, 0));
	RzILOpPure *op_RSHIFT_180 = SHIFTRA(op_LSHIFT_178, SN(32, 16));
	RzILOpPure *op_ADD_181 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_147), DUP(op_AND_147))), CAST(32, MSB(DUP(op_AND_147)), DUP(op_AND_147))), op_RSHIFT_180);
	RzILOpPure *op_LT_184 = SLT(op_ADD_181, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_189 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_190 = NEG(op_LSHIFT_189);
	RzILOpPure *op_LSHIFT_195 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_198 = SUB(op_LSHIFT_195, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_199 = ITE(op_LT_184, op_NEG_190, op_SUB_198);
	RzILOpEffect *gcc_expr_200 = BRANCH(op_EQ_98, EMPTY(), set_usr_field_call_141);

	// h_tmp272 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_202 = SETL("h_tmp272", cond_199);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_203 = SEQN(2, gcc_expr_200, op_ASSIGN_hybrid_tmp_202);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10) : h_tmp272) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_102 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_104 = LOGAND(op_RSHIFT_102, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_110 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_112 = LOGAND(op_RSHIFT_110, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_123 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_126 = LOGAND(op_RSHIFT_123, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_133 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_112), DUP(op_AND_112))), CAST(32, MSB(DUP(op_AND_112)), DUP(op_AND_112)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_112)), DUP(op_AND_112))), CAST(32, MSB(DUP(op_AND_112)), DUP(op_AND_112))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_112)), DUP(op_AND_112))), CAST(32, MSB(DUP(op_AND_112)), DUP(op_AND_112)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_112)), DUP(op_AND_112))), CAST(32, MSB(DUP(op_AND_112)), DUP(op_AND_112))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_126), DUP(op_AND_126))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_135 = SHIFTL0(op_MUL_133, SN(32, 0));
	RzILOpPure *op_RSHIFT_137 = SHIFTRA(op_LSHIFT_135, SN(32, 16));
	RzILOpPure *op_ADD_138 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_104), DUP(op_AND_104))), CAST(32, MSB(DUP(op_AND_104)), DUP(op_AND_104))), op_RSHIFT_137);
	RzILOpPure *cond_204 = ITE(DUP(op_EQ_98), op_ADD_138, VARL("h_tmp272"));
	RzILOpPure *op_AND_206 = LOGAND(cond_204, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_210 = SHIFTL0(op_AND_206, SN(32, 0x20));
	RzILOpPure *op_OR_211 = LOGOR(op_AND_7, op_LSHIFT_210);
	RzILOpEffect *op_ASSIGN_212 = WRITE_REG(bundle, Rxx_op, op_OR_211);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_213 = SEQN(2, seq_203, op_ASSIGN_212);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_353 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_228 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_230 = LOGAND(op_RSHIFT_228, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_236 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_238 = LOGAND(op_RSHIFT_236, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_249 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_252 = LOGAND(op_RSHIFT_249, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_259 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_238), DUP(op_AND_238))), CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238))), CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238))), CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238))), CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_252), DUP(op_AND_252))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_261 = SHIFTL0(op_MUL_259, SN(32, 0));
	RzILOpPure *op_RSHIFT_263 = SHIFTRA(op_LSHIFT_261, SN(32, 16));
	RzILOpPure *op_ADD_264 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_230), DUP(op_AND_230))), CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230))), op_RSHIFT_263);
	RzILOpPure *op_RSHIFT_273 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_275 = LOGAND(op_RSHIFT_273, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_281 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_283 = LOGAND(op_RSHIFT_281, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_294 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_297 = LOGAND(op_RSHIFT_294, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_304 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_283), DUP(op_AND_283))), CAST(32, MSB(DUP(op_AND_283)), DUP(op_AND_283)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_283)), DUP(op_AND_283))), CAST(32, MSB(DUP(op_AND_283)), DUP(op_AND_283))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_283)), DUP(op_AND_283))), CAST(32, MSB(DUP(op_AND_283)), DUP(op_AND_283)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_283)), DUP(op_AND_283))), CAST(32, MSB(DUP(op_AND_283)), DUP(op_AND_283))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_297), DUP(op_AND_297))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_306 = SHIFTL0(op_MUL_304, SN(32, 0));
	RzILOpPure *op_RSHIFT_308 = SHIFTRA(op_LSHIFT_306, SN(32, 16));
	RzILOpPure *op_ADD_309 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_275), DUP(op_AND_275))), CAST(32, MSB(DUP(op_AND_275)), DUP(op_AND_275))), op_RSHIFT_308);
	RzILOpPure *op_EQ_310 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_264), SN(32, 0), SN(32, 0x20)), op_ADD_309);
	RzILOpPure *op_RSHIFT_357 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_359 = LOGAND(op_RSHIFT_357, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_365 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_367 = LOGAND(op_RSHIFT_365, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_378 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_381 = LOGAND(op_RSHIFT_378, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_388 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_367), DUP(op_AND_367))), CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367))), CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367))), CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367))), CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_381), DUP(op_AND_381))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_390 = SHIFTL0(op_MUL_388, SN(32, 0));
	RzILOpPure *op_RSHIFT_392 = SHIFTRA(op_LSHIFT_390, SN(32, 16));
	RzILOpPure *op_ADD_393 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_359), DUP(op_AND_359))), CAST(32, MSB(DUP(op_AND_359)), DUP(op_AND_359))), op_RSHIFT_392);
	RzILOpPure *op_LT_396 = SLT(op_ADD_393, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_401 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_402 = NEG(op_LSHIFT_401);
	RzILOpPure *op_LSHIFT_407 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_410 = SUB(op_LSHIFT_407, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_411 = ITE(op_LT_396, op_NEG_402, op_SUB_410);
	RzILOpEffect *gcc_expr_412 = BRANCH(op_EQ_310, EMPTY(), set_usr_field_call_353);

	// h_tmp273 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_414 = SETL("h_tmp273", cond_411);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_415 = SEQN(2, gcc_expr_412, op_ASSIGN_hybrid_tmp_414);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10) : h_tmp273) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_219 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_220 = LOGNOT(op_LSHIFT_219);
	RzILOpPure *op_AND_221 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_220);
	RzILOpPure *op_RSHIFT_314 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_316 = LOGAND(op_RSHIFT_314, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_322 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_324 = LOGAND(op_RSHIFT_322, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_335 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_338 = LOGAND(op_RSHIFT_335, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_345 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_324), DUP(op_AND_324))), CAST(32, MSB(DUP(op_AND_324)), DUP(op_AND_324)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_324)), DUP(op_AND_324))), CAST(32, MSB(DUP(op_AND_324)), DUP(op_AND_324))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_324)), DUP(op_AND_324))), CAST(32, MSB(DUP(op_AND_324)), DUP(op_AND_324)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_324)), DUP(op_AND_324))), CAST(32, MSB(DUP(op_AND_324)), DUP(op_AND_324))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_338), DUP(op_AND_338))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_347 = SHIFTL0(op_MUL_345, SN(32, 0));
	RzILOpPure *op_RSHIFT_349 = SHIFTRA(op_LSHIFT_347, SN(32, 16));
	RzILOpPure *op_ADD_350 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_316), DUP(op_AND_316))), CAST(32, MSB(DUP(op_AND_316)), DUP(op_AND_316))), op_RSHIFT_349);
	RzILOpPure *cond_416 = ITE(DUP(op_EQ_310), op_ADD_350, VARL("h_tmp273"));
	RzILOpPure *op_AND_418 = LOGAND(cond_416, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_422 = SHIFTL0(op_AND_418, SN(32, 0));
	RzILOpPure *op_OR_423 = LOGOR(op_AND_221, op_LSHIFT_422);
	RzILOpEffect *op_ASSIGN_424 = WRITE_REG(bundle, Rxx_op, op_OR_423);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_425 = SEQN(2, seq_415, op_ASSIGN_424);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_213, seq_425);
	return instruction_sequence;
}

// Rxx += vmpywoh(Rss,Rtt):<<1:sat
RzILOpEffect *hex_il_op_m2_mmachs_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_141 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_25 = LOGAND(op_RSHIFT_23, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_37 = SHIFTRA(Rtt, SN(32, 0x30));
	RzILOpPure *op_AND_40 = LOGAND(op_RSHIFT_37, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_47 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_25), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_40), DUP(op_AND_40))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_49 = SHIFTL0(op_MUL_47, SN(32, 1));
	RzILOpPure *op_RSHIFT_51 = SHIFTRA(op_LSHIFT_49, SN(32, 16));
	RzILOpPure *op_ADD_52 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_RSHIFT_51);
	RzILOpPure *op_RSHIFT_61 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_63 = LOGAND(op_RSHIFT_61, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_69 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_71 = LOGAND(op_RSHIFT_69, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_82 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_85 = LOGAND(op_RSHIFT_82, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_92 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_71), DUP(op_AND_71))), CAST(32, MSB(DUP(op_AND_71)), DUP(op_AND_71)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_71)), DUP(op_AND_71))), CAST(32, MSB(DUP(op_AND_71)), DUP(op_AND_71))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_71)), DUP(op_AND_71))), CAST(32, MSB(DUP(op_AND_71)), DUP(op_AND_71)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_71)), DUP(op_AND_71))), CAST(32, MSB(DUP(op_AND_71)), DUP(op_AND_71))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_85), DUP(op_AND_85))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_94 = SHIFTL0(op_MUL_92, SN(32, 1));
	RzILOpPure *op_RSHIFT_96 = SHIFTRA(op_LSHIFT_94, SN(32, 16));
	RzILOpPure *op_ADD_97 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_63), DUP(op_AND_63))), CAST(32, MSB(DUP(op_AND_63)), DUP(op_AND_63))), op_RSHIFT_96);
	RzILOpPure *op_EQ_98 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_52), SN(32, 0), SN(32, 0x20)), op_ADD_97);
	RzILOpPure *op_RSHIFT_145 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_147 = LOGAND(op_RSHIFT_145, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_153 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_155 = LOGAND(op_RSHIFT_153, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_166 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_169 = LOGAND(op_RSHIFT_166, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_176 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_155), DUP(op_AND_155))), CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155))), CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155))), CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155))), CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_169), DUP(op_AND_169))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_178 = SHIFTL0(op_MUL_176, SN(32, 1));
	RzILOpPure *op_RSHIFT_180 = SHIFTRA(op_LSHIFT_178, SN(32, 16));
	RzILOpPure *op_ADD_181 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_147), DUP(op_AND_147))), CAST(32, MSB(DUP(op_AND_147)), DUP(op_AND_147))), op_RSHIFT_180);
	RzILOpPure *op_LT_184 = SLT(op_ADD_181, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_189 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_190 = NEG(op_LSHIFT_189);
	RzILOpPure *op_LSHIFT_195 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_198 = SUB(op_LSHIFT_195, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_199 = ITE(op_LT_184, op_NEG_190, op_SUB_198);
	RzILOpEffect *gcc_expr_200 = BRANCH(op_EQ_98, EMPTY(), set_usr_field_call_141);

	// h_tmp274 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_202 = SETL("h_tmp274", cond_199);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_203 = SEQN(2, gcc_expr_200, op_ASSIGN_hybrid_tmp_202);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10) : h_tmp274) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_102 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_104 = LOGAND(op_RSHIFT_102, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_110 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_112 = LOGAND(op_RSHIFT_110, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_123 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_126 = LOGAND(op_RSHIFT_123, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_133 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_112), DUP(op_AND_112))), CAST(32, MSB(DUP(op_AND_112)), DUP(op_AND_112)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_112)), DUP(op_AND_112))), CAST(32, MSB(DUP(op_AND_112)), DUP(op_AND_112))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_112)), DUP(op_AND_112))), CAST(32, MSB(DUP(op_AND_112)), DUP(op_AND_112)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_112)), DUP(op_AND_112))), CAST(32, MSB(DUP(op_AND_112)), DUP(op_AND_112))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_126), DUP(op_AND_126))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_135 = SHIFTL0(op_MUL_133, SN(32, 1));
	RzILOpPure *op_RSHIFT_137 = SHIFTRA(op_LSHIFT_135, SN(32, 16));
	RzILOpPure *op_ADD_138 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_104), DUP(op_AND_104))), CAST(32, MSB(DUP(op_AND_104)), DUP(op_AND_104))), op_RSHIFT_137);
	RzILOpPure *cond_204 = ITE(DUP(op_EQ_98), op_ADD_138, VARL("h_tmp274"));
	RzILOpPure *op_AND_206 = LOGAND(cond_204, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_210 = SHIFTL0(op_AND_206, SN(32, 0x20));
	RzILOpPure *op_OR_211 = LOGOR(op_AND_7, op_LSHIFT_210);
	RzILOpEffect *op_ASSIGN_212 = WRITE_REG(bundle, Rxx_op, op_OR_211);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_213 = SEQN(2, seq_203, op_ASSIGN_212);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_353 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_228 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_230 = LOGAND(op_RSHIFT_228, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_236 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_238 = LOGAND(op_RSHIFT_236, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_249 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_252 = LOGAND(op_RSHIFT_249, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_259 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_238), DUP(op_AND_238))), CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238))), CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238))), CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238))), CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_252), DUP(op_AND_252))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_261 = SHIFTL0(op_MUL_259, SN(32, 1));
	RzILOpPure *op_RSHIFT_263 = SHIFTRA(op_LSHIFT_261, SN(32, 16));
	RzILOpPure *op_ADD_264 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_230), DUP(op_AND_230))), CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230))), op_RSHIFT_263);
	RzILOpPure *op_RSHIFT_273 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_275 = LOGAND(op_RSHIFT_273, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_281 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_283 = LOGAND(op_RSHIFT_281, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_294 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_297 = LOGAND(op_RSHIFT_294, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_304 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_283), DUP(op_AND_283))), CAST(32, MSB(DUP(op_AND_283)), DUP(op_AND_283)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_283)), DUP(op_AND_283))), CAST(32, MSB(DUP(op_AND_283)), DUP(op_AND_283))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_283)), DUP(op_AND_283))), CAST(32, MSB(DUP(op_AND_283)), DUP(op_AND_283)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_283)), DUP(op_AND_283))), CAST(32, MSB(DUP(op_AND_283)), DUP(op_AND_283))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_297), DUP(op_AND_297))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_306 = SHIFTL0(op_MUL_304, SN(32, 1));
	RzILOpPure *op_RSHIFT_308 = SHIFTRA(op_LSHIFT_306, SN(32, 16));
	RzILOpPure *op_ADD_309 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_275), DUP(op_AND_275))), CAST(32, MSB(DUP(op_AND_275)), DUP(op_AND_275))), op_RSHIFT_308);
	RzILOpPure *op_EQ_310 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_264), SN(32, 0), SN(32, 0x20)), op_ADD_309);
	RzILOpPure *op_RSHIFT_357 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_359 = LOGAND(op_RSHIFT_357, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_365 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_367 = LOGAND(op_RSHIFT_365, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_378 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_381 = LOGAND(op_RSHIFT_378, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_388 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_367), DUP(op_AND_367))), CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367))), CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367))), CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367))), CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_381), DUP(op_AND_381))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_390 = SHIFTL0(op_MUL_388, SN(32, 1));
	RzILOpPure *op_RSHIFT_392 = SHIFTRA(op_LSHIFT_390, SN(32, 16));
	RzILOpPure *op_ADD_393 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_359), DUP(op_AND_359))), CAST(32, MSB(DUP(op_AND_359)), DUP(op_AND_359))), op_RSHIFT_392);
	RzILOpPure *op_LT_396 = SLT(op_ADD_393, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_401 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_402 = NEG(op_LSHIFT_401);
	RzILOpPure *op_LSHIFT_407 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_410 = SUB(op_LSHIFT_407, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_411 = ITE(op_LT_396, op_NEG_402, op_SUB_410);
	RzILOpEffect *gcc_expr_412 = BRANCH(op_EQ_310, EMPTY(), set_usr_field_call_353);

	// h_tmp275 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_414 = SETL("h_tmp275", cond_411);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_415 = SEQN(2, gcc_expr_412, op_ASSIGN_hybrid_tmp_414);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10) : h_tmp275) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_219 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_220 = LOGNOT(op_LSHIFT_219);
	RzILOpPure *op_AND_221 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_220);
	RzILOpPure *op_RSHIFT_314 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_316 = LOGAND(op_RSHIFT_314, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_322 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_324 = LOGAND(op_RSHIFT_322, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_335 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_338 = LOGAND(op_RSHIFT_335, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_345 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_324), DUP(op_AND_324))), CAST(32, MSB(DUP(op_AND_324)), DUP(op_AND_324)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_324)), DUP(op_AND_324))), CAST(32, MSB(DUP(op_AND_324)), DUP(op_AND_324))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_324)), DUP(op_AND_324))), CAST(32, MSB(DUP(op_AND_324)), DUP(op_AND_324)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_324)), DUP(op_AND_324))), CAST(32, MSB(DUP(op_AND_324)), DUP(op_AND_324))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_338), DUP(op_AND_338))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_347 = SHIFTL0(op_MUL_345, SN(32, 1));
	RzILOpPure *op_RSHIFT_349 = SHIFTRA(op_LSHIFT_347, SN(32, 16));
	RzILOpPure *op_ADD_350 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_316), DUP(op_AND_316))), CAST(32, MSB(DUP(op_AND_316)), DUP(op_AND_316))), op_RSHIFT_349);
	RzILOpPure *cond_416 = ITE(DUP(op_EQ_310), op_ADD_350, VARL("h_tmp275"));
	RzILOpPure *op_AND_418 = LOGAND(cond_416, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_422 = SHIFTL0(op_AND_418, SN(32, 0));
	RzILOpPure *op_OR_423 = LOGOR(op_AND_221, op_LSHIFT_422);
	RzILOpEffect *op_ASSIGN_424 = WRITE_REG(bundle, Rxx_op, op_OR_423);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_425 = SEQN(2, seq_415, op_ASSIGN_424);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_213, seq_425);
	return instruction_sequence;
}

// Rxx += vmpyweh(Rss,Rtt):rnd:sat
RzILOpEffect *hex_il_op_m2_mmacls_rs0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_150 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_25 = LOGAND(op_RSHIFT_23, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_37 = SHIFTRA(Rtt, SN(32, 0x20));
	RzILOpPure *op_AND_40 = LOGAND(op_RSHIFT_37, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_47 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_25), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_40), DUP(op_AND_40))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_49 = SHIFTL0(op_MUL_47, SN(32, 0));
	RzILOpPure *op_ADD_52 = ADD(op_LSHIFT_49, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_54 = SHIFTRA(op_ADD_52, SN(32, 16));
	RzILOpPure *op_ADD_55 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_RSHIFT_54);
	RzILOpPure *op_RSHIFT_64 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_66 = LOGAND(op_RSHIFT_64, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_72 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_74 = LOGAND(op_RSHIFT_72, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_85 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_88 = LOGAND(op_RSHIFT_85, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_95 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_74), DUP(op_AND_74))), CAST(32, MSB(DUP(op_AND_74)), DUP(op_AND_74)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_74)), DUP(op_AND_74))), CAST(32, MSB(DUP(op_AND_74)), DUP(op_AND_74))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_74)), DUP(op_AND_74))), CAST(32, MSB(DUP(op_AND_74)), DUP(op_AND_74)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_74)), DUP(op_AND_74))), CAST(32, MSB(DUP(op_AND_74)), DUP(op_AND_74))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_88), DUP(op_AND_88))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_97 = SHIFTL0(op_MUL_95, SN(32, 0));
	RzILOpPure *op_ADD_100 = ADD(op_LSHIFT_97, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_102 = SHIFTRA(op_ADD_100, SN(32, 16));
	RzILOpPure *op_ADD_103 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_66), DUP(op_AND_66))), CAST(32, MSB(DUP(op_AND_66)), DUP(op_AND_66))), op_RSHIFT_102);
	RzILOpPure *op_EQ_104 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_55), SN(32, 0), SN(32, 0x20)), op_ADD_103);
	RzILOpPure *op_RSHIFT_154 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_156 = LOGAND(op_RSHIFT_154, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_162 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_164 = LOGAND(op_RSHIFT_162, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_175 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_178 = LOGAND(op_RSHIFT_175, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_185 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_164), DUP(op_AND_164))), CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164))), CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164))), CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164))), CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_178), DUP(op_AND_178))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_187 = SHIFTL0(op_MUL_185, SN(32, 0));
	RzILOpPure *op_ADD_190 = ADD(op_LSHIFT_187, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_192 = SHIFTRA(op_ADD_190, SN(32, 16));
	RzILOpPure *op_ADD_193 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_156), DUP(op_AND_156))), CAST(32, MSB(DUP(op_AND_156)), DUP(op_AND_156))), op_RSHIFT_192);
	RzILOpPure *op_LT_196 = SLT(op_ADD_193, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_201 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_202 = NEG(op_LSHIFT_201);
	RzILOpPure *op_LSHIFT_207 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_210 = SUB(op_LSHIFT_207, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_211 = ITE(op_LT_196, op_NEG_202, op_SUB_210);
	RzILOpEffect *gcc_expr_212 = BRANCH(op_EQ_104, EMPTY(), set_usr_field_call_150);

	// h_tmp276 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_214 = SETL("h_tmp276", cond_211);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_215 = SEQN(2, gcc_expr_212, op_ASSIGN_hybrid_tmp_214);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10) : h_tmp276) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_108 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_110 = LOGAND(op_RSHIFT_108, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_116 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_118 = LOGAND(op_RSHIFT_116, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_129 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_132 = LOGAND(op_RSHIFT_129, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_139 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_118), DUP(op_AND_118))), CAST(32, MSB(DUP(op_AND_118)), DUP(op_AND_118)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_118)), DUP(op_AND_118))), CAST(32, MSB(DUP(op_AND_118)), DUP(op_AND_118))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_118)), DUP(op_AND_118))), CAST(32, MSB(DUP(op_AND_118)), DUP(op_AND_118)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_118)), DUP(op_AND_118))), CAST(32, MSB(DUP(op_AND_118)), DUP(op_AND_118))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_132), DUP(op_AND_132))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_141 = SHIFTL0(op_MUL_139, SN(32, 0));
	RzILOpPure *op_ADD_144 = ADD(op_LSHIFT_141, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_146 = SHIFTRA(op_ADD_144, SN(32, 16));
	RzILOpPure *op_ADD_147 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_110), DUP(op_AND_110))), CAST(32, MSB(DUP(op_AND_110)), DUP(op_AND_110))), op_RSHIFT_146);
	RzILOpPure *cond_216 = ITE(DUP(op_EQ_104), op_ADD_147, VARL("h_tmp276"));
	RzILOpPure *op_AND_218 = LOGAND(cond_216, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_222 = SHIFTL0(op_AND_218, SN(32, 0x20));
	RzILOpPure *op_OR_223 = LOGOR(op_AND_7, op_LSHIFT_222);
	RzILOpEffect *op_ASSIGN_224 = WRITE_REG(bundle, Rxx_op, op_OR_223);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_225 = SEQN(2, seq_215, op_ASSIGN_224);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_374 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_240 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_242 = LOGAND(op_RSHIFT_240, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_248 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_250 = LOGAND(op_RSHIFT_248, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_261 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_264 = LOGAND(op_RSHIFT_261, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_271 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_250), DUP(op_AND_250))), CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250))), CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250))), CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250))), CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_264), DUP(op_AND_264))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_273 = SHIFTL0(op_MUL_271, SN(32, 0));
	RzILOpPure *op_ADD_276 = ADD(op_LSHIFT_273, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_278 = SHIFTRA(op_ADD_276, SN(32, 16));
	RzILOpPure *op_ADD_279 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_242), DUP(op_AND_242))), CAST(32, MSB(DUP(op_AND_242)), DUP(op_AND_242))), op_RSHIFT_278);
	RzILOpPure *op_RSHIFT_288 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_290 = LOGAND(op_RSHIFT_288, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_296 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_298 = LOGAND(op_RSHIFT_296, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_309 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_312 = LOGAND(op_RSHIFT_309, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_319 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_298), DUP(op_AND_298))), CAST(32, MSB(DUP(op_AND_298)), DUP(op_AND_298)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_298)), DUP(op_AND_298))), CAST(32, MSB(DUP(op_AND_298)), DUP(op_AND_298))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_298)), DUP(op_AND_298))), CAST(32, MSB(DUP(op_AND_298)), DUP(op_AND_298)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_298)), DUP(op_AND_298))), CAST(32, MSB(DUP(op_AND_298)), DUP(op_AND_298))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_312), DUP(op_AND_312))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_321 = SHIFTL0(op_MUL_319, SN(32, 0));
	RzILOpPure *op_ADD_324 = ADD(op_LSHIFT_321, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_326 = SHIFTRA(op_ADD_324, SN(32, 16));
	RzILOpPure *op_ADD_327 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_290), DUP(op_AND_290))), CAST(32, MSB(DUP(op_AND_290)), DUP(op_AND_290))), op_RSHIFT_326);
	RzILOpPure *op_EQ_328 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_279), SN(32, 0), SN(32, 0x20)), op_ADD_327);
	RzILOpPure *op_RSHIFT_378 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_380 = LOGAND(op_RSHIFT_378, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_386 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_388 = LOGAND(op_RSHIFT_386, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_399 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_402 = LOGAND(op_RSHIFT_399, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_409 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_388), DUP(op_AND_388))), CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388))), CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388))), CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388))), CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_402), DUP(op_AND_402))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_411 = SHIFTL0(op_MUL_409, SN(32, 0));
	RzILOpPure *op_ADD_414 = ADD(op_LSHIFT_411, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_416 = SHIFTRA(op_ADD_414, SN(32, 16));
	RzILOpPure *op_ADD_417 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_380), DUP(op_AND_380))), CAST(32, MSB(DUP(op_AND_380)), DUP(op_AND_380))), op_RSHIFT_416);
	RzILOpPure *op_LT_420 = SLT(op_ADD_417, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_425 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_426 = NEG(op_LSHIFT_425);
	RzILOpPure *op_LSHIFT_431 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_434 = SUB(op_LSHIFT_431, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_435 = ITE(op_LT_420, op_NEG_426, op_SUB_434);
	RzILOpEffect *gcc_expr_436 = BRANCH(op_EQ_328, EMPTY(), set_usr_field_call_374);

	// h_tmp277 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_438 = SETL("h_tmp277", cond_435);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_439 = SEQN(2, gcc_expr_436, op_ASSIGN_hybrid_tmp_438);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10) : h_tmp277) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_231 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_232 = LOGNOT(op_LSHIFT_231);
	RzILOpPure *op_AND_233 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_232);
	RzILOpPure *op_RSHIFT_332 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_334 = LOGAND(op_RSHIFT_332, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_340 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_342 = LOGAND(op_RSHIFT_340, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_353 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_356 = LOGAND(op_RSHIFT_353, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_363 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_342), DUP(op_AND_342))), CAST(32, MSB(DUP(op_AND_342)), DUP(op_AND_342)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_342)), DUP(op_AND_342))), CAST(32, MSB(DUP(op_AND_342)), DUP(op_AND_342))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_342)), DUP(op_AND_342))), CAST(32, MSB(DUP(op_AND_342)), DUP(op_AND_342)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_342)), DUP(op_AND_342))), CAST(32, MSB(DUP(op_AND_342)), DUP(op_AND_342))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_356), DUP(op_AND_356))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_365 = SHIFTL0(op_MUL_363, SN(32, 0));
	RzILOpPure *op_ADD_368 = ADD(op_LSHIFT_365, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_370 = SHIFTRA(op_ADD_368, SN(32, 16));
	RzILOpPure *op_ADD_371 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_334), DUP(op_AND_334))), CAST(32, MSB(DUP(op_AND_334)), DUP(op_AND_334))), op_RSHIFT_370);
	RzILOpPure *cond_440 = ITE(DUP(op_EQ_328), op_ADD_371, VARL("h_tmp277"));
	RzILOpPure *op_AND_442 = LOGAND(cond_440, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_446 = SHIFTL0(op_AND_442, SN(32, 0));
	RzILOpPure *op_OR_447 = LOGOR(op_AND_233, op_LSHIFT_446);
	RzILOpEffect *op_ASSIGN_448 = WRITE_REG(bundle, Rxx_op, op_OR_447);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_449 = SEQN(2, seq_439, op_ASSIGN_448);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_225, seq_449);
	return instruction_sequence;
}

// Rxx += vmpyweh(Rss,Rtt):<<1:rnd:sat
RzILOpEffect *hex_il_op_m2_mmacls_rs1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_150 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_25 = LOGAND(op_RSHIFT_23, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_37 = SHIFTRA(Rtt, SN(32, 0x20));
	RzILOpPure *op_AND_40 = LOGAND(op_RSHIFT_37, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_47 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_25), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_40), DUP(op_AND_40))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_49 = SHIFTL0(op_MUL_47, SN(32, 1));
	RzILOpPure *op_ADD_52 = ADD(op_LSHIFT_49, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_54 = SHIFTRA(op_ADD_52, SN(32, 16));
	RzILOpPure *op_ADD_55 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_RSHIFT_54);
	RzILOpPure *op_RSHIFT_64 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_66 = LOGAND(op_RSHIFT_64, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_72 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_74 = LOGAND(op_RSHIFT_72, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_85 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_88 = LOGAND(op_RSHIFT_85, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_95 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_74), DUP(op_AND_74))), CAST(32, MSB(DUP(op_AND_74)), DUP(op_AND_74)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_74)), DUP(op_AND_74))), CAST(32, MSB(DUP(op_AND_74)), DUP(op_AND_74))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_74)), DUP(op_AND_74))), CAST(32, MSB(DUP(op_AND_74)), DUP(op_AND_74)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_74)), DUP(op_AND_74))), CAST(32, MSB(DUP(op_AND_74)), DUP(op_AND_74))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_88), DUP(op_AND_88))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_97 = SHIFTL0(op_MUL_95, SN(32, 1));
	RzILOpPure *op_ADD_100 = ADD(op_LSHIFT_97, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_102 = SHIFTRA(op_ADD_100, SN(32, 16));
	RzILOpPure *op_ADD_103 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_66), DUP(op_AND_66))), CAST(32, MSB(DUP(op_AND_66)), DUP(op_AND_66))), op_RSHIFT_102);
	RzILOpPure *op_EQ_104 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_55), SN(32, 0), SN(32, 0x20)), op_ADD_103);
	RzILOpPure *op_RSHIFT_154 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_156 = LOGAND(op_RSHIFT_154, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_162 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_164 = LOGAND(op_RSHIFT_162, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_175 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_178 = LOGAND(op_RSHIFT_175, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_185 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_164), DUP(op_AND_164))), CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164))), CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164))), CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164))), CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_178), DUP(op_AND_178))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_187 = SHIFTL0(op_MUL_185, SN(32, 1));
	RzILOpPure *op_ADD_190 = ADD(op_LSHIFT_187, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_192 = SHIFTRA(op_ADD_190, SN(32, 16));
	RzILOpPure *op_ADD_193 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_156), DUP(op_AND_156))), CAST(32, MSB(DUP(op_AND_156)), DUP(op_AND_156))), op_RSHIFT_192);
	RzILOpPure *op_LT_196 = SLT(op_ADD_193, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_201 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_202 = NEG(op_LSHIFT_201);
	RzILOpPure *op_LSHIFT_207 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_210 = SUB(op_LSHIFT_207, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_211 = ITE(op_LT_196, op_NEG_202, op_SUB_210);
	RzILOpEffect *gcc_expr_212 = BRANCH(op_EQ_104, EMPTY(), set_usr_field_call_150);

	// h_tmp278 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_214 = SETL("h_tmp278", cond_211);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_215 = SEQN(2, gcc_expr_212, op_ASSIGN_hybrid_tmp_214);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) : h_tmp278) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_108 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_110 = LOGAND(op_RSHIFT_108, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_116 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_118 = LOGAND(op_RSHIFT_116, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_129 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_132 = LOGAND(op_RSHIFT_129, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_139 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_118), DUP(op_AND_118))), CAST(32, MSB(DUP(op_AND_118)), DUP(op_AND_118)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_118)), DUP(op_AND_118))), CAST(32, MSB(DUP(op_AND_118)), DUP(op_AND_118))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_118)), DUP(op_AND_118))), CAST(32, MSB(DUP(op_AND_118)), DUP(op_AND_118)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_118)), DUP(op_AND_118))), CAST(32, MSB(DUP(op_AND_118)), DUP(op_AND_118))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_132), DUP(op_AND_132))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_141 = SHIFTL0(op_MUL_139, SN(32, 1));
	RzILOpPure *op_ADD_144 = ADD(op_LSHIFT_141, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_146 = SHIFTRA(op_ADD_144, SN(32, 16));
	RzILOpPure *op_ADD_147 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_110), DUP(op_AND_110))), CAST(32, MSB(DUP(op_AND_110)), DUP(op_AND_110))), op_RSHIFT_146);
	RzILOpPure *cond_216 = ITE(DUP(op_EQ_104), op_ADD_147, VARL("h_tmp278"));
	RzILOpPure *op_AND_218 = LOGAND(cond_216, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_222 = SHIFTL0(op_AND_218, SN(32, 0x20));
	RzILOpPure *op_OR_223 = LOGOR(op_AND_7, op_LSHIFT_222);
	RzILOpEffect *op_ASSIGN_224 = WRITE_REG(bundle, Rxx_op, op_OR_223);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_225 = SEQN(2, seq_215, op_ASSIGN_224);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_374 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_240 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_242 = LOGAND(op_RSHIFT_240, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_248 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_250 = LOGAND(op_RSHIFT_248, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_261 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_264 = LOGAND(op_RSHIFT_261, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_271 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_250), DUP(op_AND_250))), CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250))), CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250))), CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250))), CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_264), DUP(op_AND_264))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_273 = SHIFTL0(op_MUL_271, SN(32, 1));
	RzILOpPure *op_ADD_276 = ADD(op_LSHIFT_273, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_278 = SHIFTRA(op_ADD_276, SN(32, 16));
	RzILOpPure *op_ADD_279 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_242), DUP(op_AND_242))), CAST(32, MSB(DUP(op_AND_242)), DUP(op_AND_242))), op_RSHIFT_278);
	RzILOpPure *op_RSHIFT_288 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_290 = LOGAND(op_RSHIFT_288, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_296 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_298 = LOGAND(op_RSHIFT_296, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_309 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_312 = LOGAND(op_RSHIFT_309, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_319 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_298), DUP(op_AND_298))), CAST(32, MSB(DUP(op_AND_298)), DUP(op_AND_298)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_298)), DUP(op_AND_298))), CAST(32, MSB(DUP(op_AND_298)), DUP(op_AND_298))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_298)), DUP(op_AND_298))), CAST(32, MSB(DUP(op_AND_298)), DUP(op_AND_298)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_298)), DUP(op_AND_298))), CAST(32, MSB(DUP(op_AND_298)), DUP(op_AND_298))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_312), DUP(op_AND_312))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_321 = SHIFTL0(op_MUL_319, SN(32, 1));
	RzILOpPure *op_ADD_324 = ADD(op_LSHIFT_321, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_326 = SHIFTRA(op_ADD_324, SN(32, 16));
	RzILOpPure *op_ADD_327 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_290), DUP(op_AND_290))), CAST(32, MSB(DUP(op_AND_290)), DUP(op_AND_290))), op_RSHIFT_326);
	RzILOpPure *op_EQ_328 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_279), SN(32, 0), SN(32, 0x20)), op_ADD_327);
	RzILOpPure *op_RSHIFT_378 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_380 = LOGAND(op_RSHIFT_378, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_386 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_388 = LOGAND(op_RSHIFT_386, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_399 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_402 = LOGAND(op_RSHIFT_399, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_409 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_388), DUP(op_AND_388))), CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388))), CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388))), CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388))), CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_402), DUP(op_AND_402))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_411 = SHIFTL0(op_MUL_409, SN(32, 1));
	RzILOpPure *op_ADD_414 = ADD(op_LSHIFT_411, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_416 = SHIFTRA(op_ADD_414, SN(32, 16));
	RzILOpPure *op_ADD_417 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_380), DUP(op_AND_380))), CAST(32, MSB(DUP(op_AND_380)), DUP(op_AND_380))), op_RSHIFT_416);
	RzILOpPure *op_LT_420 = SLT(op_ADD_417, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_425 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_426 = NEG(op_LSHIFT_425);
	RzILOpPure *op_LSHIFT_431 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_434 = SUB(op_LSHIFT_431, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_435 = ITE(op_LT_420, op_NEG_426, op_SUB_434);
	RzILOpEffect *gcc_expr_436 = BRANCH(op_EQ_328, EMPTY(), set_usr_field_call_374);

	// h_tmp279 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_438 = SETL("h_tmp279", cond_435);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_439 = SEQN(2, gcc_expr_436, op_ASSIGN_hybrid_tmp_438);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) : h_tmp279) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_231 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_232 = LOGNOT(op_LSHIFT_231);
	RzILOpPure *op_AND_233 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_232);
	RzILOpPure *op_RSHIFT_332 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_334 = LOGAND(op_RSHIFT_332, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_340 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_342 = LOGAND(op_RSHIFT_340, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_353 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_356 = LOGAND(op_RSHIFT_353, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_363 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_342), DUP(op_AND_342))), CAST(32, MSB(DUP(op_AND_342)), DUP(op_AND_342)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_342)), DUP(op_AND_342))), CAST(32, MSB(DUP(op_AND_342)), DUP(op_AND_342))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_342)), DUP(op_AND_342))), CAST(32, MSB(DUP(op_AND_342)), DUP(op_AND_342)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_342)), DUP(op_AND_342))), CAST(32, MSB(DUP(op_AND_342)), DUP(op_AND_342))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_356), DUP(op_AND_356))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_365 = SHIFTL0(op_MUL_363, SN(32, 1));
	RzILOpPure *op_ADD_368 = ADD(op_LSHIFT_365, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_370 = SHIFTRA(op_ADD_368, SN(32, 16));
	RzILOpPure *op_ADD_371 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_334), DUP(op_AND_334))), CAST(32, MSB(DUP(op_AND_334)), DUP(op_AND_334))), op_RSHIFT_370);
	RzILOpPure *cond_440 = ITE(DUP(op_EQ_328), op_ADD_371, VARL("h_tmp279"));
	RzILOpPure *op_AND_442 = LOGAND(cond_440, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_446 = SHIFTL0(op_AND_442, SN(32, 0));
	RzILOpPure *op_OR_447 = LOGOR(op_AND_233, op_LSHIFT_446);
	RzILOpEffect *op_ASSIGN_448 = WRITE_REG(bundle, Rxx_op, op_OR_447);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_449 = SEQN(2, seq_439, op_ASSIGN_448);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_225, seq_449);
	return instruction_sequence;
}

// Rxx += vmpyweh(Rss,Rtt):sat
RzILOpEffect *hex_il_op_m2_mmacls_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_141 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_25 = LOGAND(op_RSHIFT_23, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_37 = SHIFTRA(Rtt, SN(32, 0x20));
	RzILOpPure *op_AND_40 = LOGAND(op_RSHIFT_37, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_47 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_25), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_40), DUP(op_AND_40))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_49 = SHIFTL0(op_MUL_47, SN(32, 0));
	RzILOpPure *op_RSHIFT_51 = SHIFTRA(op_LSHIFT_49, SN(32, 16));
	RzILOpPure *op_ADD_52 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_RSHIFT_51);
	RzILOpPure *op_RSHIFT_61 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_63 = LOGAND(op_RSHIFT_61, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_69 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_71 = LOGAND(op_RSHIFT_69, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_82 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_85 = LOGAND(op_RSHIFT_82, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_92 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_71), DUP(op_AND_71))), CAST(32, MSB(DUP(op_AND_71)), DUP(op_AND_71)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_71)), DUP(op_AND_71))), CAST(32, MSB(DUP(op_AND_71)), DUP(op_AND_71))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_71)), DUP(op_AND_71))), CAST(32, MSB(DUP(op_AND_71)), DUP(op_AND_71)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_71)), DUP(op_AND_71))), CAST(32, MSB(DUP(op_AND_71)), DUP(op_AND_71))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_85), DUP(op_AND_85))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_94 = SHIFTL0(op_MUL_92, SN(32, 0));
	RzILOpPure *op_RSHIFT_96 = SHIFTRA(op_LSHIFT_94, SN(32, 16));
	RzILOpPure *op_ADD_97 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_63), DUP(op_AND_63))), CAST(32, MSB(DUP(op_AND_63)), DUP(op_AND_63))), op_RSHIFT_96);
	RzILOpPure *op_EQ_98 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_52), SN(32, 0), SN(32, 0x20)), op_ADD_97);
	RzILOpPure *op_RSHIFT_145 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_147 = LOGAND(op_RSHIFT_145, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_153 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_155 = LOGAND(op_RSHIFT_153, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_166 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_169 = LOGAND(op_RSHIFT_166, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_176 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_155), DUP(op_AND_155))), CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155))), CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155))), CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155))), CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_169), DUP(op_AND_169))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_178 = SHIFTL0(op_MUL_176, SN(32, 0));
	RzILOpPure *op_RSHIFT_180 = SHIFTRA(op_LSHIFT_178, SN(32, 16));
	RzILOpPure *op_ADD_181 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_147), DUP(op_AND_147))), CAST(32, MSB(DUP(op_AND_147)), DUP(op_AND_147))), op_RSHIFT_180);
	RzILOpPure *op_LT_184 = SLT(op_ADD_181, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_189 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_190 = NEG(op_LSHIFT_189);
	RzILOpPure *op_LSHIFT_195 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_198 = SUB(op_LSHIFT_195, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_199 = ITE(op_LT_184, op_NEG_190, op_SUB_198);
	RzILOpEffect *gcc_expr_200 = BRANCH(op_EQ_98, EMPTY(), set_usr_field_call_141);

	// h_tmp280 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_202 = SETL("h_tmp280", cond_199);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_203 = SEQN(2, gcc_expr_200, op_ASSIGN_hybrid_tmp_202);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10) : h_tmp280) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_102 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_104 = LOGAND(op_RSHIFT_102, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_110 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_112 = LOGAND(op_RSHIFT_110, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_123 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_126 = LOGAND(op_RSHIFT_123, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_133 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_112), DUP(op_AND_112))), CAST(32, MSB(DUP(op_AND_112)), DUP(op_AND_112)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_112)), DUP(op_AND_112))), CAST(32, MSB(DUP(op_AND_112)), DUP(op_AND_112))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_112)), DUP(op_AND_112))), CAST(32, MSB(DUP(op_AND_112)), DUP(op_AND_112)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_112)), DUP(op_AND_112))), CAST(32, MSB(DUP(op_AND_112)), DUP(op_AND_112))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_126), DUP(op_AND_126))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_135 = SHIFTL0(op_MUL_133, SN(32, 0));
	RzILOpPure *op_RSHIFT_137 = SHIFTRA(op_LSHIFT_135, SN(32, 16));
	RzILOpPure *op_ADD_138 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_104), DUP(op_AND_104))), CAST(32, MSB(DUP(op_AND_104)), DUP(op_AND_104))), op_RSHIFT_137);
	RzILOpPure *cond_204 = ITE(DUP(op_EQ_98), op_ADD_138, VARL("h_tmp280"));
	RzILOpPure *op_AND_206 = LOGAND(cond_204, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_210 = SHIFTL0(op_AND_206, SN(32, 0x20));
	RzILOpPure *op_OR_211 = LOGOR(op_AND_7, op_LSHIFT_210);
	RzILOpEffect *op_ASSIGN_212 = WRITE_REG(bundle, Rxx_op, op_OR_211);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_213 = SEQN(2, seq_203, op_ASSIGN_212);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_353 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_228 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_230 = LOGAND(op_RSHIFT_228, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_236 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_238 = LOGAND(op_RSHIFT_236, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_249 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_252 = LOGAND(op_RSHIFT_249, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_259 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_238), DUP(op_AND_238))), CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238))), CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238))), CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238))), CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_252), DUP(op_AND_252))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_261 = SHIFTL0(op_MUL_259, SN(32, 0));
	RzILOpPure *op_RSHIFT_263 = SHIFTRA(op_LSHIFT_261, SN(32, 16));
	RzILOpPure *op_ADD_264 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_230), DUP(op_AND_230))), CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230))), op_RSHIFT_263);
	RzILOpPure *op_RSHIFT_273 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_275 = LOGAND(op_RSHIFT_273, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_281 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_283 = LOGAND(op_RSHIFT_281, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_294 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_297 = LOGAND(op_RSHIFT_294, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_304 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_283), DUP(op_AND_283))), CAST(32, MSB(DUP(op_AND_283)), DUP(op_AND_283)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_283)), DUP(op_AND_283))), CAST(32, MSB(DUP(op_AND_283)), DUP(op_AND_283))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_283)), DUP(op_AND_283))), CAST(32, MSB(DUP(op_AND_283)), DUP(op_AND_283)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_283)), DUP(op_AND_283))), CAST(32, MSB(DUP(op_AND_283)), DUP(op_AND_283))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_297), DUP(op_AND_297))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_306 = SHIFTL0(op_MUL_304, SN(32, 0));
	RzILOpPure *op_RSHIFT_308 = SHIFTRA(op_LSHIFT_306, SN(32, 16));
	RzILOpPure *op_ADD_309 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_275), DUP(op_AND_275))), CAST(32, MSB(DUP(op_AND_275)), DUP(op_AND_275))), op_RSHIFT_308);
	RzILOpPure *op_EQ_310 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_264), SN(32, 0), SN(32, 0x20)), op_ADD_309);
	RzILOpPure *op_RSHIFT_357 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_359 = LOGAND(op_RSHIFT_357, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_365 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_367 = LOGAND(op_RSHIFT_365, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_378 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_381 = LOGAND(op_RSHIFT_378, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_388 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_367), DUP(op_AND_367))), CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367))), CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367))), CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367))), CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_381), DUP(op_AND_381))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_390 = SHIFTL0(op_MUL_388, SN(32, 0));
	RzILOpPure *op_RSHIFT_392 = SHIFTRA(op_LSHIFT_390, SN(32, 16));
	RzILOpPure *op_ADD_393 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_359), DUP(op_AND_359))), CAST(32, MSB(DUP(op_AND_359)), DUP(op_AND_359))), op_RSHIFT_392);
	RzILOpPure *op_LT_396 = SLT(op_ADD_393, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_401 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_402 = NEG(op_LSHIFT_401);
	RzILOpPure *op_LSHIFT_407 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_410 = SUB(op_LSHIFT_407, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_411 = ITE(op_LT_396, op_NEG_402, op_SUB_410);
	RzILOpEffect *gcc_expr_412 = BRANCH(op_EQ_310, EMPTY(), set_usr_field_call_353);

	// h_tmp281 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_414 = SETL("h_tmp281", cond_411);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_415 = SEQN(2, gcc_expr_412, op_ASSIGN_hybrid_tmp_414);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10) : h_tmp281) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_219 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_220 = LOGNOT(op_LSHIFT_219);
	RzILOpPure *op_AND_221 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_220);
	RzILOpPure *op_RSHIFT_314 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_316 = LOGAND(op_RSHIFT_314, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_322 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_324 = LOGAND(op_RSHIFT_322, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_335 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_338 = LOGAND(op_RSHIFT_335, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_345 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_324), DUP(op_AND_324))), CAST(32, MSB(DUP(op_AND_324)), DUP(op_AND_324)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_324)), DUP(op_AND_324))), CAST(32, MSB(DUP(op_AND_324)), DUP(op_AND_324))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_324)), DUP(op_AND_324))), CAST(32, MSB(DUP(op_AND_324)), DUP(op_AND_324)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_324)), DUP(op_AND_324))), CAST(32, MSB(DUP(op_AND_324)), DUP(op_AND_324))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_338), DUP(op_AND_338))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_347 = SHIFTL0(op_MUL_345, SN(32, 0));
	RzILOpPure *op_RSHIFT_349 = SHIFTRA(op_LSHIFT_347, SN(32, 16));
	RzILOpPure *op_ADD_350 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_316), DUP(op_AND_316))), CAST(32, MSB(DUP(op_AND_316)), DUP(op_AND_316))), op_RSHIFT_349);
	RzILOpPure *cond_416 = ITE(DUP(op_EQ_310), op_ADD_350, VARL("h_tmp281"));
	RzILOpPure *op_AND_418 = LOGAND(cond_416, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_422 = SHIFTL0(op_AND_418, SN(32, 0));
	RzILOpPure *op_OR_423 = LOGOR(op_AND_221, op_LSHIFT_422);
	RzILOpEffect *op_ASSIGN_424 = WRITE_REG(bundle, Rxx_op, op_OR_423);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_425 = SEQN(2, seq_415, op_ASSIGN_424);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_213, seq_425);
	return instruction_sequence;
}

// Rxx += vmpyweh(Rss,Rtt):<<1:sat
RzILOpEffect *hex_il_op_m2_mmacls_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_141 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_25 = LOGAND(op_RSHIFT_23, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_37 = SHIFTRA(Rtt, SN(32, 0x20));
	RzILOpPure *op_AND_40 = LOGAND(op_RSHIFT_37, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_47 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_25), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_40), DUP(op_AND_40))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_49 = SHIFTL0(op_MUL_47, SN(32, 1));
	RzILOpPure *op_RSHIFT_51 = SHIFTRA(op_LSHIFT_49, SN(32, 16));
	RzILOpPure *op_ADD_52 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_RSHIFT_51);
	RzILOpPure *op_RSHIFT_61 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_63 = LOGAND(op_RSHIFT_61, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_69 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_71 = LOGAND(op_RSHIFT_69, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_82 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_85 = LOGAND(op_RSHIFT_82, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_92 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_71), DUP(op_AND_71))), CAST(32, MSB(DUP(op_AND_71)), DUP(op_AND_71)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_71)), DUP(op_AND_71))), CAST(32, MSB(DUP(op_AND_71)), DUP(op_AND_71))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_71)), DUP(op_AND_71))), CAST(32, MSB(DUP(op_AND_71)), DUP(op_AND_71)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_71)), DUP(op_AND_71))), CAST(32, MSB(DUP(op_AND_71)), DUP(op_AND_71))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_85), DUP(op_AND_85))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_94 = SHIFTL0(op_MUL_92, SN(32, 1));
	RzILOpPure *op_RSHIFT_96 = SHIFTRA(op_LSHIFT_94, SN(32, 16));
	RzILOpPure *op_ADD_97 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_63), DUP(op_AND_63))), CAST(32, MSB(DUP(op_AND_63)), DUP(op_AND_63))), op_RSHIFT_96);
	RzILOpPure *op_EQ_98 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_52), SN(32, 0), SN(32, 0x20)), op_ADD_97);
	RzILOpPure *op_RSHIFT_145 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_147 = LOGAND(op_RSHIFT_145, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_153 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_155 = LOGAND(op_RSHIFT_153, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_166 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_169 = LOGAND(op_RSHIFT_166, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_176 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_155), DUP(op_AND_155))), CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155))), CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155))), CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155))), CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_169), DUP(op_AND_169))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_178 = SHIFTL0(op_MUL_176, SN(32, 1));
	RzILOpPure *op_RSHIFT_180 = SHIFTRA(op_LSHIFT_178, SN(32, 16));
	RzILOpPure *op_ADD_181 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_147), DUP(op_AND_147))), CAST(32, MSB(DUP(op_AND_147)), DUP(op_AND_147))), op_RSHIFT_180);
	RzILOpPure *op_LT_184 = SLT(op_ADD_181, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_189 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_190 = NEG(op_LSHIFT_189);
	RzILOpPure *op_LSHIFT_195 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_198 = SUB(op_LSHIFT_195, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_199 = ITE(op_LT_184, op_NEG_190, op_SUB_198);
	RzILOpEffect *gcc_expr_200 = BRANCH(op_EQ_98, EMPTY(), set_usr_field_call_141);

	// h_tmp282 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_202 = SETL("h_tmp282", cond_199);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_203 = SEQN(2, gcc_expr_200, op_ASSIGN_hybrid_tmp_202);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10) : h_tmp282) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_102 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_104 = LOGAND(op_RSHIFT_102, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_110 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_112 = LOGAND(op_RSHIFT_110, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_123 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_126 = LOGAND(op_RSHIFT_123, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_133 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_112), DUP(op_AND_112))), CAST(32, MSB(DUP(op_AND_112)), DUP(op_AND_112)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_112)), DUP(op_AND_112))), CAST(32, MSB(DUP(op_AND_112)), DUP(op_AND_112))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_112)), DUP(op_AND_112))), CAST(32, MSB(DUP(op_AND_112)), DUP(op_AND_112)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_112)), DUP(op_AND_112))), CAST(32, MSB(DUP(op_AND_112)), DUP(op_AND_112))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_126), DUP(op_AND_126))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_135 = SHIFTL0(op_MUL_133, SN(32, 1));
	RzILOpPure *op_RSHIFT_137 = SHIFTRA(op_LSHIFT_135, SN(32, 16));
	RzILOpPure *op_ADD_138 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_104), DUP(op_AND_104))), CAST(32, MSB(DUP(op_AND_104)), DUP(op_AND_104))), op_RSHIFT_137);
	RzILOpPure *cond_204 = ITE(DUP(op_EQ_98), op_ADD_138, VARL("h_tmp282"));
	RzILOpPure *op_AND_206 = LOGAND(cond_204, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_210 = SHIFTL0(op_AND_206, SN(32, 0x20));
	RzILOpPure *op_OR_211 = LOGOR(op_AND_7, op_LSHIFT_210);
	RzILOpEffect *op_ASSIGN_212 = WRITE_REG(bundle, Rxx_op, op_OR_211);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_213 = SEQN(2, seq_203, op_ASSIGN_212);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_353 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_228 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_230 = LOGAND(op_RSHIFT_228, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_236 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_238 = LOGAND(op_RSHIFT_236, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_249 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_252 = LOGAND(op_RSHIFT_249, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_259 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_238), DUP(op_AND_238))), CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238))), CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238))), CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238))), CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_252), DUP(op_AND_252))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_261 = SHIFTL0(op_MUL_259, SN(32, 1));
	RzILOpPure *op_RSHIFT_263 = SHIFTRA(op_LSHIFT_261, SN(32, 16));
	RzILOpPure *op_ADD_264 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_230), DUP(op_AND_230))), CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230))), op_RSHIFT_263);
	RzILOpPure *op_RSHIFT_273 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_275 = LOGAND(op_RSHIFT_273, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_281 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_283 = LOGAND(op_RSHIFT_281, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_294 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_297 = LOGAND(op_RSHIFT_294, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_304 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_283), DUP(op_AND_283))), CAST(32, MSB(DUP(op_AND_283)), DUP(op_AND_283)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_283)), DUP(op_AND_283))), CAST(32, MSB(DUP(op_AND_283)), DUP(op_AND_283))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_283)), DUP(op_AND_283))), CAST(32, MSB(DUP(op_AND_283)), DUP(op_AND_283)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_283)), DUP(op_AND_283))), CAST(32, MSB(DUP(op_AND_283)), DUP(op_AND_283))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_297), DUP(op_AND_297))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_306 = SHIFTL0(op_MUL_304, SN(32, 1));
	RzILOpPure *op_RSHIFT_308 = SHIFTRA(op_LSHIFT_306, SN(32, 16));
	RzILOpPure *op_ADD_309 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_275), DUP(op_AND_275))), CAST(32, MSB(DUP(op_AND_275)), DUP(op_AND_275))), op_RSHIFT_308);
	RzILOpPure *op_EQ_310 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_264), SN(32, 0), SN(32, 0x20)), op_ADD_309);
	RzILOpPure *op_RSHIFT_357 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_359 = LOGAND(op_RSHIFT_357, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_365 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_367 = LOGAND(op_RSHIFT_365, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_378 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_381 = LOGAND(op_RSHIFT_378, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_388 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_367), DUP(op_AND_367))), CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367))), CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367))), CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367))), CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_381), DUP(op_AND_381))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_390 = SHIFTL0(op_MUL_388, SN(32, 1));
	RzILOpPure *op_RSHIFT_392 = SHIFTRA(op_LSHIFT_390, SN(32, 16));
	RzILOpPure *op_ADD_393 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_359), DUP(op_AND_359))), CAST(32, MSB(DUP(op_AND_359)), DUP(op_AND_359))), op_RSHIFT_392);
	RzILOpPure *op_LT_396 = SLT(op_ADD_393, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_401 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_402 = NEG(op_LSHIFT_401);
	RzILOpPure *op_LSHIFT_407 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_410 = SUB(op_LSHIFT_407, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_411 = ITE(op_LT_396, op_NEG_402, op_SUB_410);
	RzILOpEffect *gcc_expr_412 = BRANCH(op_EQ_310, EMPTY(), set_usr_field_call_353);

	// h_tmp283 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_414 = SETL("h_tmp283", cond_411);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_415 = SEQN(2, gcc_expr_412, op_ASSIGN_hybrid_tmp_414);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10) : h_tmp283) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_219 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_220 = LOGNOT(op_LSHIFT_219);
	RzILOpPure *op_AND_221 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_220);
	RzILOpPure *op_RSHIFT_314 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_316 = LOGAND(op_RSHIFT_314, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_322 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_324 = LOGAND(op_RSHIFT_322, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_335 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_338 = LOGAND(op_RSHIFT_335, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_345 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_324), DUP(op_AND_324))), CAST(32, MSB(DUP(op_AND_324)), DUP(op_AND_324)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_324)), DUP(op_AND_324))), CAST(32, MSB(DUP(op_AND_324)), DUP(op_AND_324))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_324)), DUP(op_AND_324))), CAST(32, MSB(DUP(op_AND_324)), DUP(op_AND_324)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_324)), DUP(op_AND_324))), CAST(32, MSB(DUP(op_AND_324)), DUP(op_AND_324))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_338), DUP(op_AND_338))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_347 = SHIFTL0(op_MUL_345, SN(32, 1));
	RzILOpPure *op_RSHIFT_349 = SHIFTRA(op_LSHIFT_347, SN(32, 16));
	RzILOpPure *op_ADD_350 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_316), DUP(op_AND_316))), CAST(32, MSB(DUP(op_AND_316)), DUP(op_AND_316))), op_RSHIFT_349);
	RzILOpPure *cond_416 = ITE(DUP(op_EQ_310), op_ADD_350, VARL("h_tmp283"));
	RzILOpPure *op_AND_418 = LOGAND(cond_416, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_422 = SHIFTL0(op_AND_418, SN(32, 0));
	RzILOpPure *op_OR_423 = LOGOR(op_AND_221, op_LSHIFT_422);
	RzILOpEffect *op_ASSIGN_424 = WRITE_REG(bundle, Rxx_op, op_OR_423);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_425 = SEQN(2, seq_415, op_ASSIGN_424);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_213, seq_425);
	return instruction_sequence;
}

// Rxx += vmpywouh(Rss,Rtt):rnd:sat
RzILOpEffect *hex_il_op_m2_mmacuhs_rs0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_156 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_25 = LOGAND(op_RSHIFT_23, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_37 = SHIFTRA(Rtt, SN(32, 0x30));
	RzILOpPure *op_AND_40 = LOGAND(op_RSHIFT_37, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_48 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_25), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_40)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_51 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_48), SN(32, 0));
	RzILOpPure *op_ADD_54 = ADD(op_LSHIFT_51, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_56 = SHIFTRA(op_ADD_54, SN(32, 16));
	RzILOpPure *op_ADD_57 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_RSHIFT_56);
	RzILOpPure *op_RSHIFT_66 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_68 = LOGAND(op_RSHIFT_66, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_74 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_76 = LOGAND(op_RSHIFT_74, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_87 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_90 = LOGAND(op_RSHIFT_87, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_98 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_76), DUP(op_AND_76))), CAST(32, MSB(DUP(op_AND_76)), DUP(op_AND_76)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_76)), DUP(op_AND_76))), CAST(32, MSB(DUP(op_AND_76)), DUP(op_AND_76))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_76)), DUP(op_AND_76))), CAST(32, MSB(DUP(op_AND_76)), DUP(op_AND_76)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_76)), DUP(op_AND_76))), CAST(32, MSB(DUP(op_AND_76)), DUP(op_AND_76)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_90)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_101 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_98), SN(32, 0));
	RzILOpPure *op_ADD_104 = ADD(op_LSHIFT_101, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_106 = SHIFTRA(op_ADD_104, SN(32, 16));
	RzILOpPure *op_ADD_107 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_68), DUP(op_AND_68))), CAST(32, MSB(DUP(op_AND_68)), DUP(op_AND_68))), op_RSHIFT_106);
	RzILOpPure *op_EQ_108 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_57), SN(32, 0), SN(32, 0x20)), op_ADD_107);
	RzILOpPure *op_RSHIFT_160 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_162 = LOGAND(op_RSHIFT_160, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_168 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_170 = LOGAND(op_RSHIFT_168, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_181 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_184 = LOGAND(op_RSHIFT_181, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_192 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_170), DUP(op_AND_170))), CAST(32, MSB(DUP(op_AND_170)), DUP(op_AND_170)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_170)), DUP(op_AND_170))), CAST(32, MSB(DUP(op_AND_170)), DUP(op_AND_170))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_170)), DUP(op_AND_170))), CAST(32, MSB(DUP(op_AND_170)), DUP(op_AND_170)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_170)), DUP(op_AND_170))), CAST(32, MSB(DUP(op_AND_170)), DUP(op_AND_170)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_184)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_195 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_192), SN(32, 0));
	RzILOpPure *op_ADD_198 = ADD(op_LSHIFT_195, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_200 = SHIFTRA(op_ADD_198, SN(32, 16));
	RzILOpPure *op_ADD_201 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_162), DUP(op_AND_162))), CAST(32, MSB(DUP(op_AND_162)), DUP(op_AND_162))), op_RSHIFT_200);
	RzILOpPure *op_LT_204 = SLT(op_ADD_201, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_209 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_210 = NEG(op_LSHIFT_209);
	RzILOpPure *op_LSHIFT_215 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_218 = SUB(op_LSHIFT_215, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_219 = ITE(op_LT_204, op_NEG_210, op_SUB_218);
	RzILOpEffect *gcc_expr_220 = BRANCH(op_EQ_108, EMPTY(), set_usr_field_call_156);

	// h_tmp284 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_222 = SETL("h_tmp284", cond_219);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_223 = SEQN(2, gcc_expr_220, op_ASSIGN_hybrid_tmp_222);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10) : h_tmp284) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_112 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_114 = LOGAND(op_RSHIFT_112, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_120 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_122 = LOGAND(op_RSHIFT_120, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_133 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_136 = LOGAND(op_RSHIFT_133, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_144 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_122), DUP(op_AND_122))), CAST(32, MSB(DUP(op_AND_122)), DUP(op_AND_122)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_122)), DUP(op_AND_122))), CAST(32, MSB(DUP(op_AND_122)), DUP(op_AND_122))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_122)), DUP(op_AND_122))), CAST(32, MSB(DUP(op_AND_122)), DUP(op_AND_122)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_122)), DUP(op_AND_122))), CAST(32, MSB(DUP(op_AND_122)), DUP(op_AND_122)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_136)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_147 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_144), SN(32, 0));
	RzILOpPure *op_ADD_150 = ADD(op_LSHIFT_147, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_152 = SHIFTRA(op_ADD_150, SN(32, 16));
	RzILOpPure *op_ADD_153 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_114), DUP(op_AND_114))), CAST(32, MSB(DUP(op_AND_114)), DUP(op_AND_114))), op_RSHIFT_152);
	RzILOpPure *cond_224 = ITE(DUP(op_EQ_108), op_ADD_153, VARL("h_tmp284"));
	RzILOpPure *op_AND_226 = LOGAND(cond_224, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_230 = SHIFTL0(op_AND_226, SN(32, 0x20));
	RzILOpPure *op_OR_231 = LOGOR(op_AND_7, op_LSHIFT_230);
	RzILOpEffect *op_ASSIGN_232 = WRITE_REG(bundle, Rxx_op, op_OR_231);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_233 = SEQN(2, seq_223, op_ASSIGN_232);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_388 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_248 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_250 = LOGAND(op_RSHIFT_248, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_256 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_258 = LOGAND(op_RSHIFT_256, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_269 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_272 = LOGAND(op_RSHIFT_269, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_280 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_258), DUP(op_AND_258))), CAST(32, MSB(DUP(op_AND_258)), DUP(op_AND_258)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_258)), DUP(op_AND_258))), CAST(32, MSB(DUP(op_AND_258)), DUP(op_AND_258))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_258)), DUP(op_AND_258))), CAST(32, MSB(DUP(op_AND_258)), DUP(op_AND_258)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_258)), DUP(op_AND_258))), CAST(32, MSB(DUP(op_AND_258)), DUP(op_AND_258)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_272)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_283 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_280), SN(32, 0));
	RzILOpPure *op_ADD_286 = ADD(op_LSHIFT_283, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_288 = SHIFTRA(op_ADD_286, SN(32, 16));
	RzILOpPure *op_ADD_289 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_250), DUP(op_AND_250))), CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250))), op_RSHIFT_288);
	RzILOpPure *op_RSHIFT_298 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_300 = LOGAND(op_RSHIFT_298, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_306 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_308 = LOGAND(op_RSHIFT_306, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_319 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_322 = LOGAND(op_RSHIFT_319, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_330 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_308), DUP(op_AND_308))), CAST(32, MSB(DUP(op_AND_308)), DUP(op_AND_308)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_308)), DUP(op_AND_308))), CAST(32, MSB(DUP(op_AND_308)), DUP(op_AND_308))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_308)), DUP(op_AND_308))), CAST(32, MSB(DUP(op_AND_308)), DUP(op_AND_308)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_308)), DUP(op_AND_308))), CAST(32, MSB(DUP(op_AND_308)), DUP(op_AND_308)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_322)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_333 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_330), SN(32, 0));
	RzILOpPure *op_ADD_336 = ADD(op_LSHIFT_333, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_338 = SHIFTRA(op_ADD_336, SN(32, 16));
	RzILOpPure *op_ADD_339 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_300), DUP(op_AND_300))), CAST(32, MSB(DUP(op_AND_300)), DUP(op_AND_300))), op_RSHIFT_338);
	RzILOpPure *op_EQ_340 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_289), SN(32, 0), SN(32, 0x20)), op_ADD_339);
	RzILOpPure *op_RSHIFT_392 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_394 = LOGAND(op_RSHIFT_392, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_400 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_402 = LOGAND(op_RSHIFT_400, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_413 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_416 = LOGAND(op_RSHIFT_413, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_424 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_402), DUP(op_AND_402))), CAST(32, MSB(DUP(op_AND_402)), DUP(op_AND_402)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_402)), DUP(op_AND_402))), CAST(32, MSB(DUP(op_AND_402)), DUP(op_AND_402))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_402)), DUP(op_AND_402))), CAST(32, MSB(DUP(op_AND_402)), DUP(op_AND_402)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_402)), DUP(op_AND_402))), CAST(32, MSB(DUP(op_AND_402)), DUP(op_AND_402)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_416)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_427 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_424), SN(32, 0));
	RzILOpPure *op_ADD_430 = ADD(op_LSHIFT_427, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_432 = SHIFTRA(op_ADD_430, SN(32, 16));
	RzILOpPure *op_ADD_433 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_394), DUP(op_AND_394))), CAST(32, MSB(DUP(op_AND_394)), DUP(op_AND_394))), op_RSHIFT_432);
	RzILOpPure *op_LT_436 = SLT(op_ADD_433, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_441 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_442 = NEG(op_LSHIFT_441);
	RzILOpPure *op_LSHIFT_447 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_450 = SUB(op_LSHIFT_447, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_451 = ITE(op_LT_436, op_NEG_442, op_SUB_450);
	RzILOpEffect *gcc_expr_452 = BRANCH(op_EQ_340, EMPTY(), set_usr_field_call_388);

	// h_tmp285 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_454 = SETL("h_tmp285", cond_451);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_455 = SEQN(2, gcc_expr_452, op_ASSIGN_hybrid_tmp_454);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10) : h_tmp285) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_239 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_240 = LOGNOT(op_LSHIFT_239);
	RzILOpPure *op_AND_241 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_240);
	RzILOpPure *op_RSHIFT_344 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_346 = LOGAND(op_RSHIFT_344, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_352 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_354 = LOGAND(op_RSHIFT_352, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_365 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_368 = LOGAND(op_RSHIFT_365, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_376 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_354), DUP(op_AND_354))), CAST(32, MSB(DUP(op_AND_354)), DUP(op_AND_354)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_354)), DUP(op_AND_354))), CAST(32, MSB(DUP(op_AND_354)), DUP(op_AND_354))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_354)), DUP(op_AND_354))), CAST(32, MSB(DUP(op_AND_354)), DUP(op_AND_354)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_354)), DUP(op_AND_354))), CAST(32, MSB(DUP(op_AND_354)), DUP(op_AND_354)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_368)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_379 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_376), SN(32, 0));
	RzILOpPure *op_ADD_382 = ADD(op_LSHIFT_379, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_384 = SHIFTRA(op_ADD_382, SN(32, 16));
	RzILOpPure *op_ADD_385 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_346), DUP(op_AND_346))), CAST(32, MSB(DUP(op_AND_346)), DUP(op_AND_346))), op_RSHIFT_384);
	RzILOpPure *cond_456 = ITE(DUP(op_EQ_340), op_ADD_385, VARL("h_tmp285"));
	RzILOpPure *op_AND_458 = LOGAND(cond_456, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_462 = SHIFTL0(op_AND_458, SN(32, 0));
	RzILOpPure *op_OR_463 = LOGOR(op_AND_241, op_LSHIFT_462);
	RzILOpEffect *op_ASSIGN_464 = WRITE_REG(bundle, Rxx_op, op_OR_463);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_465 = SEQN(2, seq_455, op_ASSIGN_464);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_233, seq_465);
	return instruction_sequence;
}

// Rxx += vmpywouh(Rss,Rtt):<<1:rnd:sat
RzILOpEffect *hex_il_op_m2_mmacuhs_rs1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_156 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_25 = LOGAND(op_RSHIFT_23, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_37 = SHIFTRA(Rtt, SN(32, 0x30));
	RzILOpPure *op_AND_40 = LOGAND(op_RSHIFT_37, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_48 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_25), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_40)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_51 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_48), SN(32, 1));
	RzILOpPure *op_ADD_54 = ADD(op_LSHIFT_51, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_56 = SHIFTRA(op_ADD_54, SN(32, 16));
	RzILOpPure *op_ADD_57 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_RSHIFT_56);
	RzILOpPure *op_RSHIFT_66 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_68 = LOGAND(op_RSHIFT_66, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_74 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_76 = LOGAND(op_RSHIFT_74, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_87 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_90 = LOGAND(op_RSHIFT_87, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_98 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_76), DUP(op_AND_76))), CAST(32, MSB(DUP(op_AND_76)), DUP(op_AND_76)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_76)), DUP(op_AND_76))), CAST(32, MSB(DUP(op_AND_76)), DUP(op_AND_76))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_76)), DUP(op_AND_76))), CAST(32, MSB(DUP(op_AND_76)), DUP(op_AND_76)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_76)), DUP(op_AND_76))), CAST(32, MSB(DUP(op_AND_76)), DUP(op_AND_76)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_90)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_101 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_98), SN(32, 1));
	RzILOpPure *op_ADD_104 = ADD(op_LSHIFT_101, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_106 = SHIFTRA(op_ADD_104, SN(32, 16));
	RzILOpPure *op_ADD_107 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_68), DUP(op_AND_68))), CAST(32, MSB(DUP(op_AND_68)), DUP(op_AND_68))), op_RSHIFT_106);
	RzILOpPure *op_EQ_108 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_57), SN(32, 0), SN(32, 0x20)), op_ADD_107);
	RzILOpPure *op_RSHIFT_160 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_162 = LOGAND(op_RSHIFT_160, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_168 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_170 = LOGAND(op_RSHIFT_168, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_181 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_184 = LOGAND(op_RSHIFT_181, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_192 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_170), DUP(op_AND_170))), CAST(32, MSB(DUP(op_AND_170)), DUP(op_AND_170)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_170)), DUP(op_AND_170))), CAST(32, MSB(DUP(op_AND_170)), DUP(op_AND_170))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_170)), DUP(op_AND_170))), CAST(32, MSB(DUP(op_AND_170)), DUP(op_AND_170)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_170)), DUP(op_AND_170))), CAST(32, MSB(DUP(op_AND_170)), DUP(op_AND_170)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_184)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_195 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_192), SN(32, 1));
	RzILOpPure *op_ADD_198 = ADD(op_LSHIFT_195, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_200 = SHIFTRA(op_ADD_198, SN(32, 16));
	RzILOpPure *op_ADD_201 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_162), DUP(op_AND_162))), CAST(32, MSB(DUP(op_AND_162)), DUP(op_AND_162))), op_RSHIFT_200);
	RzILOpPure *op_LT_204 = SLT(op_ADD_201, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_209 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_210 = NEG(op_LSHIFT_209);
	RzILOpPure *op_LSHIFT_215 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_218 = SUB(op_LSHIFT_215, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_219 = ITE(op_LT_204, op_NEG_210, op_SUB_218);
	RzILOpEffect *gcc_expr_220 = BRANCH(op_EQ_108, EMPTY(), set_usr_field_call_156);

	// h_tmp286 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_222 = SETL("h_tmp286", cond_219);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_223 = SEQN(2, gcc_expr_220, op_ASSIGN_hybrid_tmp_222);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10) : h_tmp286) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_112 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_114 = LOGAND(op_RSHIFT_112, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_120 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_122 = LOGAND(op_RSHIFT_120, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_133 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_136 = LOGAND(op_RSHIFT_133, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_144 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_122), DUP(op_AND_122))), CAST(32, MSB(DUP(op_AND_122)), DUP(op_AND_122)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_122)), DUP(op_AND_122))), CAST(32, MSB(DUP(op_AND_122)), DUP(op_AND_122))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_122)), DUP(op_AND_122))), CAST(32, MSB(DUP(op_AND_122)), DUP(op_AND_122)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_122)), DUP(op_AND_122))), CAST(32, MSB(DUP(op_AND_122)), DUP(op_AND_122)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_136)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_147 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_144), SN(32, 1));
	RzILOpPure *op_ADD_150 = ADD(op_LSHIFT_147, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_152 = SHIFTRA(op_ADD_150, SN(32, 16));
	RzILOpPure *op_ADD_153 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_114), DUP(op_AND_114))), CAST(32, MSB(DUP(op_AND_114)), DUP(op_AND_114))), op_RSHIFT_152);
	RzILOpPure *cond_224 = ITE(DUP(op_EQ_108), op_ADD_153, VARL("h_tmp286"));
	RzILOpPure *op_AND_226 = LOGAND(cond_224, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_230 = SHIFTL0(op_AND_226, SN(32, 0x20));
	RzILOpPure *op_OR_231 = LOGOR(op_AND_7, op_LSHIFT_230);
	RzILOpEffect *op_ASSIGN_232 = WRITE_REG(bundle, Rxx_op, op_OR_231);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_233 = SEQN(2, seq_223, op_ASSIGN_232);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_388 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_248 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_250 = LOGAND(op_RSHIFT_248, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_256 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_258 = LOGAND(op_RSHIFT_256, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_269 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_272 = LOGAND(op_RSHIFT_269, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_280 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_258), DUP(op_AND_258))), CAST(32, MSB(DUP(op_AND_258)), DUP(op_AND_258)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_258)), DUP(op_AND_258))), CAST(32, MSB(DUP(op_AND_258)), DUP(op_AND_258))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_258)), DUP(op_AND_258))), CAST(32, MSB(DUP(op_AND_258)), DUP(op_AND_258)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_258)), DUP(op_AND_258))), CAST(32, MSB(DUP(op_AND_258)), DUP(op_AND_258)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_272)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_283 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_280), SN(32, 1));
	RzILOpPure *op_ADD_286 = ADD(op_LSHIFT_283, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_288 = SHIFTRA(op_ADD_286, SN(32, 16));
	RzILOpPure *op_ADD_289 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_250), DUP(op_AND_250))), CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250))), op_RSHIFT_288);
	RzILOpPure *op_RSHIFT_298 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_300 = LOGAND(op_RSHIFT_298, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_306 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_308 = LOGAND(op_RSHIFT_306, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_319 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_322 = LOGAND(op_RSHIFT_319, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_330 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_308), DUP(op_AND_308))), CAST(32, MSB(DUP(op_AND_308)), DUP(op_AND_308)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_308)), DUP(op_AND_308))), CAST(32, MSB(DUP(op_AND_308)), DUP(op_AND_308))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_308)), DUP(op_AND_308))), CAST(32, MSB(DUP(op_AND_308)), DUP(op_AND_308)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_308)), DUP(op_AND_308))), CAST(32, MSB(DUP(op_AND_308)), DUP(op_AND_308)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_322)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_333 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_330), SN(32, 1));
	RzILOpPure *op_ADD_336 = ADD(op_LSHIFT_333, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_338 = SHIFTRA(op_ADD_336, SN(32, 16));
	RzILOpPure *op_ADD_339 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_300), DUP(op_AND_300))), CAST(32, MSB(DUP(op_AND_300)), DUP(op_AND_300))), op_RSHIFT_338);
	RzILOpPure *op_EQ_340 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_289), SN(32, 0), SN(32, 0x20)), op_ADD_339);
	RzILOpPure *op_RSHIFT_392 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_394 = LOGAND(op_RSHIFT_392, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_400 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_402 = LOGAND(op_RSHIFT_400, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_413 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_416 = LOGAND(op_RSHIFT_413, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_424 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_402), DUP(op_AND_402))), CAST(32, MSB(DUP(op_AND_402)), DUP(op_AND_402)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_402)), DUP(op_AND_402))), CAST(32, MSB(DUP(op_AND_402)), DUP(op_AND_402))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_402)), DUP(op_AND_402))), CAST(32, MSB(DUP(op_AND_402)), DUP(op_AND_402)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_402)), DUP(op_AND_402))), CAST(32, MSB(DUP(op_AND_402)), DUP(op_AND_402)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_416)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_427 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_424), SN(32, 1));
	RzILOpPure *op_ADD_430 = ADD(op_LSHIFT_427, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_432 = SHIFTRA(op_ADD_430, SN(32, 16));
	RzILOpPure *op_ADD_433 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_394), DUP(op_AND_394))), CAST(32, MSB(DUP(op_AND_394)), DUP(op_AND_394))), op_RSHIFT_432);
	RzILOpPure *op_LT_436 = SLT(op_ADD_433, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_441 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_442 = NEG(op_LSHIFT_441);
	RzILOpPure *op_LSHIFT_447 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_450 = SUB(op_LSHIFT_447, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_451 = ITE(op_LT_436, op_NEG_442, op_SUB_450);
	RzILOpEffect *gcc_expr_452 = BRANCH(op_EQ_340, EMPTY(), set_usr_field_call_388);

	// h_tmp287 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_454 = SETL("h_tmp287", cond_451);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_455 = SEQN(2, gcc_expr_452, op_ASSIGN_hybrid_tmp_454);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10) : h_tmp287) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_239 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_240 = LOGNOT(op_LSHIFT_239);
	RzILOpPure *op_AND_241 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_240);
	RzILOpPure *op_RSHIFT_344 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_346 = LOGAND(op_RSHIFT_344, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_352 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_354 = LOGAND(op_RSHIFT_352, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_365 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_368 = LOGAND(op_RSHIFT_365, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_376 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_354), DUP(op_AND_354))), CAST(32, MSB(DUP(op_AND_354)), DUP(op_AND_354)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_354)), DUP(op_AND_354))), CAST(32, MSB(DUP(op_AND_354)), DUP(op_AND_354))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_354)), DUP(op_AND_354))), CAST(32, MSB(DUP(op_AND_354)), DUP(op_AND_354)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_354)), DUP(op_AND_354))), CAST(32, MSB(DUP(op_AND_354)), DUP(op_AND_354)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_368)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_379 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_376), SN(32, 1));
	RzILOpPure *op_ADD_382 = ADD(op_LSHIFT_379, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_384 = SHIFTRA(op_ADD_382, SN(32, 16));
	RzILOpPure *op_ADD_385 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_346), DUP(op_AND_346))), CAST(32, MSB(DUP(op_AND_346)), DUP(op_AND_346))), op_RSHIFT_384);
	RzILOpPure *cond_456 = ITE(DUP(op_EQ_340), op_ADD_385, VARL("h_tmp287"));
	RzILOpPure *op_AND_458 = LOGAND(cond_456, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_462 = SHIFTL0(op_AND_458, SN(32, 0));
	RzILOpPure *op_OR_463 = LOGOR(op_AND_241, op_LSHIFT_462);
	RzILOpEffect *op_ASSIGN_464 = WRITE_REG(bundle, Rxx_op, op_OR_463);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_465 = SEQN(2, seq_455, op_ASSIGN_464);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_233, seq_465);
	return instruction_sequence;
}

// Rxx += vmpywouh(Rss,Rtt):sat
RzILOpEffect *hex_il_op_m2_mmacuhs_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_147 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_25 = LOGAND(op_RSHIFT_23, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_37 = SHIFTRA(Rtt, SN(32, 0x30));
	RzILOpPure *op_AND_40 = LOGAND(op_RSHIFT_37, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_48 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_25), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_40)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_51 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_48), SN(32, 0));
	RzILOpPure *op_RSHIFT_53 = SHIFTRA(op_LSHIFT_51, SN(32, 16));
	RzILOpPure *op_ADD_54 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_RSHIFT_53);
	RzILOpPure *op_RSHIFT_63 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_65 = LOGAND(op_RSHIFT_63, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_71 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_73 = LOGAND(op_RSHIFT_71, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_84 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_87 = LOGAND(op_RSHIFT_84, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_95 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_73), DUP(op_AND_73))), CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73))), CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73))), CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73))), CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_87)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_98 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_95), SN(32, 0));
	RzILOpPure *op_RSHIFT_100 = SHIFTRA(op_LSHIFT_98, SN(32, 16));
	RzILOpPure *op_ADD_101 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_65), DUP(op_AND_65))), CAST(32, MSB(DUP(op_AND_65)), DUP(op_AND_65))), op_RSHIFT_100);
	RzILOpPure *op_EQ_102 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_54), SN(32, 0), SN(32, 0x20)), op_ADD_101);
	RzILOpPure *op_RSHIFT_151 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_153 = LOGAND(op_RSHIFT_151, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_159 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_161 = LOGAND(op_RSHIFT_159, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_172 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_175 = LOGAND(op_RSHIFT_172, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_183 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_161), DUP(op_AND_161))), CAST(32, MSB(DUP(op_AND_161)), DUP(op_AND_161)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_161)), DUP(op_AND_161))), CAST(32, MSB(DUP(op_AND_161)), DUP(op_AND_161))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_161)), DUP(op_AND_161))), CAST(32, MSB(DUP(op_AND_161)), DUP(op_AND_161)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_161)), DUP(op_AND_161))), CAST(32, MSB(DUP(op_AND_161)), DUP(op_AND_161)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_175)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_186 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_183), SN(32, 0));
	RzILOpPure *op_RSHIFT_188 = SHIFTRA(op_LSHIFT_186, SN(32, 16));
	RzILOpPure *op_ADD_189 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_153), DUP(op_AND_153))), CAST(32, MSB(DUP(op_AND_153)), DUP(op_AND_153))), op_RSHIFT_188);
	RzILOpPure *op_LT_192 = SLT(op_ADD_189, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_197 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_198 = NEG(op_LSHIFT_197);
	RzILOpPure *op_LSHIFT_203 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_206 = SUB(op_LSHIFT_203, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_207 = ITE(op_LT_192, op_NEG_198, op_SUB_206);
	RzILOpEffect *gcc_expr_208 = BRANCH(op_EQ_102, EMPTY(), set_usr_field_call_147);

	// h_tmp288 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_210 = SETL("h_tmp288", cond_207);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_211 = SEQN(2, gcc_expr_208, op_ASSIGN_hybrid_tmp_210);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10) : h_tmp288) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_106 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_108 = LOGAND(op_RSHIFT_106, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_114 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_116 = LOGAND(op_RSHIFT_114, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_127 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_130 = LOGAND(op_RSHIFT_127, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_138 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_116), DUP(op_AND_116))), CAST(32, MSB(DUP(op_AND_116)), DUP(op_AND_116)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_116)), DUP(op_AND_116))), CAST(32, MSB(DUP(op_AND_116)), DUP(op_AND_116))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_116)), DUP(op_AND_116))), CAST(32, MSB(DUP(op_AND_116)), DUP(op_AND_116)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_116)), DUP(op_AND_116))), CAST(32, MSB(DUP(op_AND_116)), DUP(op_AND_116)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_130)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_141 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_138), SN(32, 0));
	RzILOpPure *op_RSHIFT_143 = SHIFTRA(op_LSHIFT_141, SN(32, 16));
	RzILOpPure *op_ADD_144 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_108), DUP(op_AND_108))), CAST(32, MSB(DUP(op_AND_108)), DUP(op_AND_108))), op_RSHIFT_143);
	RzILOpPure *cond_212 = ITE(DUP(op_EQ_102), op_ADD_144, VARL("h_tmp288"));
	RzILOpPure *op_AND_214 = LOGAND(cond_212, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_218 = SHIFTL0(op_AND_214, SN(32, 0x20));
	RzILOpPure *op_OR_219 = LOGOR(op_AND_7, op_LSHIFT_218);
	RzILOpEffect *op_ASSIGN_220 = WRITE_REG(bundle, Rxx_op, op_OR_219);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_221 = SEQN(2, seq_211, op_ASSIGN_220);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_367 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_236 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_238 = LOGAND(op_RSHIFT_236, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_244 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_246 = LOGAND(op_RSHIFT_244, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_257 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_260 = LOGAND(op_RSHIFT_257, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_268 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_246), DUP(op_AND_246))), CAST(32, MSB(DUP(op_AND_246)), DUP(op_AND_246)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_246)), DUP(op_AND_246))), CAST(32, MSB(DUP(op_AND_246)), DUP(op_AND_246))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_246)), DUP(op_AND_246))), CAST(32, MSB(DUP(op_AND_246)), DUP(op_AND_246)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_246)), DUP(op_AND_246))), CAST(32, MSB(DUP(op_AND_246)), DUP(op_AND_246)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_260)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_271 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_268), SN(32, 0));
	RzILOpPure *op_RSHIFT_273 = SHIFTRA(op_LSHIFT_271, SN(32, 16));
	RzILOpPure *op_ADD_274 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_238), DUP(op_AND_238))), CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238))), op_RSHIFT_273);
	RzILOpPure *op_RSHIFT_283 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_285 = LOGAND(op_RSHIFT_283, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_291 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_293 = LOGAND(op_RSHIFT_291, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_304 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_307 = LOGAND(op_RSHIFT_304, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_315 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_293), DUP(op_AND_293))), CAST(32, MSB(DUP(op_AND_293)), DUP(op_AND_293)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_293)), DUP(op_AND_293))), CAST(32, MSB(DUP(op_AND_293)), DUP(op_AND_293))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_293)), DUP(op_AND_293))), CAST(32, MSB(DUP(op_AND_293)), DUP(op_AND_293)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_293)), DUP(op_AND_293))), CAST(32, MSB(DUP(op_AND_293)), DUP(op_AND_293)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_307)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_318 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_315), SN(32, 0));
	RzILOpPure *op_RSHIFT_320 = SHIFTRA(op_LSHIFT_318, SN(32, 16));
	RzILOpPure *op_ADD_321 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_285), DUP(op_AND_285))), CAST(32, MSB(DUP(op_AND_285)), DUP(op_AND_285))), op_RSHIFT_320);
	RzILOpPure *op_EQ_322 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_274), SN(32, 0), SN(32, 0x20)), op_ADD_321);
	RzILOpPure *op_RSHIFT_371 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_373 = LOGAND(op_RSHIFT_371, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_379 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_381 = LOGAND(op_RSHIFT_379, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_392 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_395 = LOGAND(op_RSHIFT_392, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_403 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_381), DUP(op_AND_381))), CAST(32, MSB(DUP(op_AND_381)), DUP(op_AND_381)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_381)), DUP(op_AND_381))), CAST(32, MSB(DUP(op_AND_381)), DUP(op_AND_381))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_381)), DUP(op_AND_381))), CAST(32, MSB(DUP(op_AND_381)), DUP(op_AND_381)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_381)), DUP(op_AND_381))), CAST(32, MSB(DUP(op_AND_381)), DUP(op_AND_381)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_395)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_406 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_403), SN(32, 0));
	RzILOpPure *op_RSHIFT_408 = SHIFTRA(op_LSHIFT_406, SN(32, 16));
	RzILOpPure *op_ADD_409 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_373), DUP(op_AND_373))), CAST(32, MSB(DUP(op_AND_373)), DUP(op_AND_373))), op_RSHIFT_408);
	RzILOpPure *op_LT_412 = SLT(op_ADD_409, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_417 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_418 = NEG(op_LSHIFT_417);
	RzILOpPure *op_LSHIFT_423 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_426 = SUB(op_LSHIFT_423, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_427 = ITE(op_LT_412, op_NEG_418, op_SUB_426);
	RzILOpEffect *gcc_expr_428 = BRANCH(op_EQ_322, EMPTY(), set_usr_field_call_367);

	// h_tmp289 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_430 = SETL("h_tmp289", cond_427);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_431 = SEQN(2, gcc_expr_428, op_ASSIGN_hybrid_tmp_430);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10) : h_tmp289) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_227 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_228 = LOGNOT(op_LSHIFT_227);
	RzILOpPure *op_AND_229 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_228);
	RzILOpPure *op_RSHIFT_326 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_328 = LOGAND(op_RSHIFT_326, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_334 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_336 = LOGAND(op_RSHIFT_334, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_347 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_350 = LOGAND(op_RSHIFT_347, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_358 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_336), DUP(op_AND_336))), CAST(32, MSB(DUP(op_AND_336)), DUP(op_AND_336)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_336)), DUP(op_AND_336))), CAST(32, MSB(DUP(op_AND_336)), DUP(op_AND_336))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_336)), DUP(op_AND_336))), CAST(32, MSB(DUP(op_AND_336)), DUP(op_AND_336)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_336)), DUP(op_AND_336))), CAST(32, MSB(DUP(op_AND_336)), DUP(op_AND_336)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_350)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_361 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_358), SN(32, 0));
	RzILOpPure *op_RSHIFT_363 = SHIFTRA(op_LSHIFT_361, SN(32, 16));
	RzILOpPure *op_ADD_364 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_328), DUP(op_AND_328))), CAST(32, MSB(DUP(op_AND_328)), DUP(op_AND_328))), op_RSHIFT_363);
	RzILOpPure *cond_432 = ITE(DUP(op_EQ_322), op_ADD_364, VARL("h_tmp289"));
	RzILOpPure *op_AND_434 = LOGAND(cond_432, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_438 = SHIFTL0(op_AND_434, SN(32, 0));
	RzILOpPure *op_OR_439 = LOGOR(op_AND_229, op_LSHIFT_438);
	RzILOpEffect *op_ASSIGN_440 = WRITE_REG(bundle, Rxx_op, op_OR_439);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_441 = SEQN(2, seq_431, op_ASSIGN_440);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_221, seq_441);
	return instruction_sequence;
}

// Rxx += vmpywouh(Rss,Rtt):<<1:sat
RzILOpEffect *hex_il_op_m2_mmacuhs_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_147 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_25 = LOGAND(op_RSHIFT_23, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_37 = SHIFTRA(Rtt, SN(32, 0x30));
	RzILOpPure *op_AND_40 = LOGAND(op_RSHIFT_37, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_48 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_25), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_40)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_51 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_48), SN(32, 1));
	RzILOpPure *op_RSHIFT_53 = SHIFTRA(op_LSHIFT_51, SN(32, 16));
	RzILOpPure *op_ADD_54 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_RSHIFT_53);
	RzILOpPure *op_RSHIFT_63 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_65 = LOGAND(op_RSHIFT_63, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_71 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_73 = LOGAND(op_RSHIFT_71, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_84 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_87 = LOGAND(op_RSHIFT_84, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_95 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_73), DUP(op_AND_73))), CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73))), CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73))), CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73))), CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_87)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_98 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_95), SN(32, 1));
	RzILOpPure *op_RSHIFT_100 = SHIFTRA(op_LSHIFT_98, SN(32, 16));
	RzILOpPure *op_ADD_101 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_65), DUP(op_AND_65))), CAST(32, MSB(DUP(op_AND_65)), DUP(op_AND_65))), op_RSHIFT_100);
	RzILOpPure *op_EQ_102 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_54), SN(32, 0), SN(32, 0x20)), op_ADD_101);
	RzILOpPure *op_RSHIFT_151 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_153 = LOGAND(op_RSHIFT_151, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_159 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_161 = LOGAND(op_RSHIFT_159, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_172 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_175 = LOGAND(op_RSHIFT_172, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_183 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_161), DUP(op_AND_161))), CAST(32, MSB(DUP(op_AND_161)), DUP(op_AND_161)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_161)), DUP(op_AND_161))), CAST(32, MSB(DUP(op_AND_161)), DUP(op_AND_161))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_161)), DUP(op_AND_161))), CAST(32, MSB(DUP(op_AND_161)), DUP(op_AND_161)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_161)), DUP(op_AND_161))), CAST(32, MSB(DUP(op_AND_161)), DUP(op_AND_161)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_175)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_186 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_183), SN(32, 1));
	RzILOpPure *op_RSHIFT_188 = SHIFTRA(op_LSHIFT_186, SN(32, 16));
	RzILOpPure *op_ADD_189 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_153), DUP(op_AND_153))), CAST(32, MSB(DUP(op_AND_153)), DUP(op_AND_153))), op_RSHIFT_188);
	RzILOpPure *op_LT_192 = SLT(op_ADD_189, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_197 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_198 = NEG(op_LSHIFT_197);
	RzILOpPure *op_LSHIFT_203 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_206 = SUB(op_LSHIFT_203, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_207 = ITE(op_LT_192, op_NEG_198, op_SUB_206);
	RzILOpEffect *gcc_expr_208 = BRANCH(op_EQ_102, EMPTY(), set_usr_field_call_147);

	// h_tmp290 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_210 = SETL("h_tmp290", cond_207);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_211 = SEQN(2, gcc_expr_208, op_ASSIGN_hybrid_tmp_210);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10) : h_tmp290) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_106 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_108 = LOGAND(op_RSHIFT_106, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_114 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_116 = LOGAND(op_RSHIFT_114, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_127 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_130 = LOGAND(op_RSHIFT_127, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_138 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_116), DUP(op_AND_116))), CAST(32, MSB(DUP(op_AND_116)), DUP(op_AND_116)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_116)), DUP(op_AND_116))), CAST(32, MSB(DUP(op_AND_116)), DUP(op_AND_116))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_116)), DUP(op_AND_116))), CAST(32, MSB(DUP(op_AND_116)), DUP(op_AND_116)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_116)), DUP(op_AND_116))), CAST(32, MSB(DUP(op_AND_116)), DUP(op_AND_116)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_130)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_141 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_138), SN(32, 1));
	RzILOpPure *op_RSHIFT_143 = SHIFTRA(op_LSHIFT_141, SN(32, 16));
	RzILOpPure *op_ADD_144 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_108), DUP(op_AND_108))), CAST(32, MSB(DUP(op_AND_108)), DUP(op_AND_108))), op_RSHIFT_143);
	RzILOpPure *cond_212 = ITE(DUP(op_EQ_102), op_ADD_144, VARL("h_tmp290"));
	RzILOpPure *op_AND_214 = LOGAND(cond_212, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_218 = SHIFTL0(op_AND_214, SN(32, 0x20));
	RzILOpPure *op_OR_219 = LOGOR(op_AND_7, op_LSHIFT_218);
	RzILOpEffect *op_ASSIGN_220 = WRITE_REG(bundle, Rxx_op, op_OR_219);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_221 = SEQN(2, seq_211, op_ASSIGN_220);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_367 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_236 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_238 = LOGAND(op_RSHIFT_236, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_244 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_246 = LOGAND(op_RSHIFT_244, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_257 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_260 = LOGAND(op_RSHIFT_257, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_268 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_246), DUP(op_AND_246))), CAST(32, MSB(DUP(op_AND_246)), DUP(op_AND_246)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_246)), DUP(op_AND_246))), CAST(32, MSB(DUP(op_AND_246)), DUP(op_AND_246))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_246)), DUP(op_AND_246))), CAST(32, MSB(DUP(op_AND_246)), DUP(op_AND_246)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_246)), DUP(op_AND_246))), CAST(32, MSB(DUP(op_AND_246)), DUP(op_AND_246)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_260)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_271 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_268), SN(32, 1));
	RzILOpPure *op_RSHIFT_273 = SHIFTRA(op_LSHIFT_271, SN(32, 16));
	RzILOpPure *op_ADD_274 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_238), DUP(op_AND_238))), CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238))), op_RSHIFT_273);
	RzILOpPure *op_RSHIFT_283 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_285 = LOGAND(op_RSHIFT_283, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_291 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_293 = LOGAND(op_RSHIFT_291, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_304 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_307 = LOGAND(op_RSHIFT_304, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_315 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_293), DUP(op_AND_293))), CAST(32, MSB(DUP(op_AND_293)), DUP(op_AND_293)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_293)), DUP(op_AND_293))), CAST(32, MSB(DUP(op_AND_293)), DUP(op_AND_293))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_293)), DUP(op_AND_293))), CAST(32, MSB(DUP(op_AND_293)), DUP(op_AND_293)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_293)), DUP(op_AND_293))), CAST(32, MSB(DUP(op_AND_293)), DUP(op_AND_293)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_307)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_318 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_315), SN(32, 1));
	RzILOpPure *op_RSHIFT_320 = SHIFTRA(op_LSHIFT_318, SN(32, 16));
	RzILOpPure *op_ADD_321 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_285), DUP(op_AND_285))), CAST(32, MSB(DUP(op_AND_285)), DUP(op_AND_285))), op_RSHIFT_320);
	RzILOpPure *op_EQ_322 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_274), SN(32, 0), SN(32, 0x20)), op_ADD_321);
	RzILOpPure *op_RSHIFT_371 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_373 = LOGAND(op_RSHIFT_371, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_379 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_381 = LOGAND(op_RSHIFT_379, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_392 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_395 = LOGAND(op_RSHIFT_392, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_403 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_381), DUP(op_AND_381))), CAST(32, MSB(DUP(op_AND_381)), DUP(op_AND_381)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_381)), DUP(op_AND_381))), CAST(32, MSB(DUP(op_AND_381)), DUP(op_AND_381))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_381)), DUP(op_AND_381))), CAST(32, MSB(DUP(op_AND_381)), DUP(op_AND_381)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_381)), DUP(op_AND_381))), CAST(32, MSB(DUP(op_AND_381)), DUP(op_AND_381)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_395)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_406 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_403), SN(32, 1));
	RzILOpPure *op_RSHIFT_408 = SHIFTRA(op_LSHIFT_406, SN(32, 16));
	RzILOpPure *op_ADD_409 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_373), DUP(op_AND_373))), CAST(32, MSB(DUP(op_AND_373)), DUP(op_AND_373))), op_RSHIFT_408);
	RzILOpPure *op_LT_412 = SLT(op_ADD_409, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_417 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_418 = NEG(op_LSHIFT_417);
	RzILOpPure *op_LSHIFT_423 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_426 = SUB(op_LSHIFT_423, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_427 = ITE(op_LT_412, op_NEG_418, op_SUB_426);
	RzILOpEffect *gcc_expr_428 = BRANCH(op_EQ_322, EMPTY(), set_usr_field_call_367);

	// h_tmp291 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_430 = SETL("h_tmp291", cond_427);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_431 = SEQN(2, gcc_expr_428, op_ASSIGN_hybrid_tmp_430);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10) : h_tmp291) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_227 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_228 = LOGNOT(op_LSHIFT_227);
	RzILOpPure *op_AND_229 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_228);
	RzILOpPure *op_RSHIFT_326 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_328 = LOGAND(op_RSHIFT_326, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_334 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_336 = LOGAND(op_RSHIFT_334, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_347 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_350 = LOGAND(op_RSHIFT_347, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_358 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_336), DUP(op_AND_336))), CAST(32, MSB(DUP(op_AND_336)), DUP(op_AND_336)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_336)), DUP(op_AND_336))), CAST(32, MSB(DUP(op_AND_336)), DUP(op_AND_336))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_336)), DUP(op_AND_336))), CAST(32, MSB(DUP(op_AND_336)), DUP(op_AND_336)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_336)), DUP(op_AND_336))), CAST(32, MSB(DUP(op_AND_336)), DUP(op_AND_336)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_350)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_361 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_358), SN(32, 1));
	RzILOpPure *op_RSHIFT_363 = SHIFTRA(op_LSHIFT_361, SN(32, 16));
	RzILOpPure *op_ADD_364 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_328), DUP(op_AND_328))), CAST(32, MSB(DUP(op_AND_328)), DUP(op_AND_328))), op_RSHIFT_363);
	RzILOpPure *cond_432 = ITE(DUP(op_EQ_322), op_ADD_364, VARL("h_tmp291"));
	RzILOpPure *op_AND_434 = LOGAND(cond_432, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_438 = SHIFTL0(op_AND_434, SN(32, 0));
	RzILOpPure *op_OR_439 = LOGOR(op_AND_229, op_LSHIFT_438);
	RzILOpEffect *op_ASSIGN_440 = WRITE_REG(bundle, Rxx_op, op_OR_439);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_441 = SEQN(2, seq_431, op_ASSIGN_440);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_221, seq_441);
	return instruction_sequence;
}

// Rxx += vmpyweuh(Rss,Rtt):rnd:sat
RzILOpEffect *hex_il_op_m2_mmaculs_rs0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_156 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_25 = LOGAND(op_RSHIFT_23, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_37 = SHIFTRA(Rtt, SN(32, 0x20));
	RzILOpPure *op_AND_40 = LOGAND(op_RSHIFT_37, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_48 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_25), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_40)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_51 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_48), SN(32, 0));
	RzILOpPure *op_ADD_54 = ADD(op_LSHIFT_51, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_56 = SHIFTRA(op_ADD_54, SN(32, 16));
	RzILOpPure *op_ADD_57 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_RSHIFT_56);
	RzILOpPure *op_RSHIFT_66 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_68 = LOGAND(op_RSHIFT_66, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_74 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_76 = LOGAND(op_RSHIFT_74, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_87 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_90 = LOGAND(op_RSHIFT_87, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_98 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_76), DUP(op_AND_76))), CAST(32, MSB(DUP(op_AND_76)), DUP(op_AND_76)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_76)), DUP(op_AND_76))), CAST(32, MSB(DUP(op_AND_76)), DUP(op_AND_76))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_76)), DUP(op_AND_76))), CAST(32, MSB(DUP(op_AND_76)), DUP(op_AND_76)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_76)), DUP(op_AND_76))), CAST(32, MSB(DUP(op_AND_76)), DUP(op_AND_76)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_90)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_101 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_98), SN(32, 0));
	RzILOpPure *op_ADD_104 = ADD(op_LSHIFT_101, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_106 = SHIFTRA(op_ADD_104, SN(32, 16));
	RzILOpPure *op_ADD_107 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_68), DUP(op_AND_68))), CAST(32, MSB(DUP(op_AND_68)), DUP(op_AND_68))), op_RSHIFT_106);
	RzILOpPure *op_EQ_108 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_57), SN(32, 0), SN(32, 0x20)), op_ADD_107);
	RzILOpPure *op_RSHIFT_160 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_162 = LOGAND(op_RSHIFT_160, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_168 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_170 = LOGAND(op_RSHIFT_168, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_181 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_184 = LOGAND(op_RSHIFT_181, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_192 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_170), DUP(op_AND_170))), CAST(32, MSB(DUP(op_AND_170)), DUP(op_AND_170)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_170)), DUP(op_AND_170))), CAST(32, MSB(DUP(op_AND_170)), DUP(op_AND_170))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_170)), DUP(op_AND_170))), CAST(32, MSB(DUP(op_AND_170)), DUP(op_AND_170)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_170)), DUP(op_AND_170))), CAST(32, MSB(DUP(op_AND_170)), DUP(op_AND_170)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_184)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_195 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_192), SN(32, 0));
	RzILOpPure *op_ADD_198 = ADD(op_LSHIFT_195, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_200 = SHIFTRA(op_ADD_198, SN(32, 16));
	RzILOpPure *op_ADD_201 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_162), DUP(op_AND_162))), CAST(32, MSB(DUP(op_AND_162)), DUP(op_AND_162))), op_RSHIFT_200);
	RzILOpPure *op_LT_204 = SLT(op_ADD_201, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_209 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_210 = NEG(op_LSHIFT_209);
	RzILOpPure *op_LSHIFT_215 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_218 = SUB(op_LSHIFT_215, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_219 = ITE(op_LT_204, op_NEG_210, op_SUB_218);
	RzILOpEffect *gcc_expr_220 = BRANCH(op_EQ_108, EMPTY(), set_usr_field_call_156);

	// h_tmp292 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_222 = SETL("h_tmp292", cond_219);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_223 = SEQN(2, gcc_expr_220, op_ASSIGN_hybrid_tmp_222);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10) : h_tmp292) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_112 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_114 = LOGAND(op_RSHIFT_112, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_120 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_122 = LOGAND(op_RSHIFT_120, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_133 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_136 = LOGAND(op_RSHIFT_133, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_144 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_122), DUP(op_AND_122))), CAST(32, MSB(DUP(op_AND_122)), DUP(op_AND_122)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_122)), DUP(op_AND_122))), CAST(32, MSB(DUP(op_AND_122)), DUP(op_AND_122))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_122)), DUP(op_AND_122))), CAST(32, MSB(DUP(op_AND_122)), DUP(op_AND_122)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_122)), DUP(op_AND_122))), CAST(32, MSB(DUP(op_AND_122)), DUP(op_AND_122)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_136)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_147 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_144), SN(32, 0));
	RzILOpPure *op_ADD_150 = ADD(op_LSHIFT_147, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_152 = SHIFTRA(op_ADD_150, SN(32, 16));
	RzILOpPure *op_ADD_153 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_114), DUP(op_AND_114))), CAST(32, MSB(DUP(op_AND_114)), DUP(op_AND_114))), op_RSHIFT_152);
	RzILOpPure *cond_224 = ITE(DUP(op_EQ_108), op_ADD_153, VARL("h_tmp292"));
	RzILOpPure *op_AND_226 = LOGAND(cond_224, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_230 = SHIFTL0(op_AND_226, SN(32, 0x20));
	RzILOpPure *op_OR_231 = LOGOR(op_AND_7, op_LSHIFT_230);
	RzILOpEffect *op_ASSIGN_232 = WRITE_REG(bundle, Rxx_op, op_OR_231);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_233 = SEQN(2, seq_223, op_ASSIGN_232);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_388 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_248 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_250 = LOGAND(op_RSHIFT_248, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_256 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_258 = LOGAND(op_RSHIFT_256, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_269 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_272 = LOGAND(op_RSHIFT_269, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_280 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_258), DUP(op_AND_258))), CAST(32, MSB(DUP(op_AND_258)), DUP(op_AND_258)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_258)), DUP(op_AND_258))), CAST(32, MSB(DUP(op_AND_258)), DUP(op_AND_258))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_258)), DUP(op_AND_258))), CAST(32, MSB(DUP(op_AND_258)), DUP(op_AND_258)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_258)), DUP(op_AND_258))), CAST(32, MSB(DUP(op_AND_258)), DUP(op_AND_258)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_272)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_283 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_280), SN(32, 0));
	RzILOpPure *op_ADD_286 = ADD(op_LSHIFT_283, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_288 = SHIFTRA(op_ADD_286, SN(32, 16));
	RzILOpPure *op_ADD_289 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_250), DUP(op_AND_250))), CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250))), op_RSHIFT_288);
	RzILOpPure *op_RSHIFT_298 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_300 = LOGAND(op_RSHIFT_298, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_306 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_308 = LOGAND(op_RSHIFT_306, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_319 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_322 = LOGAND(op_RSHIFT_319, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_330 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_308), DUP(op_AND_308))), CAST(32, MSB(DUP(op_AND_308)), DUP(op_AND_308)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_308)), DUP(op_AND_308))), CAST(32, MSB(DUP(op_AND_308)), DUP(op_AND_308))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_308)), DUP(op_AND_308))), CAST(32, MSB(DUP(op_AND_308)), DUP(op_AND_308)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_308)), DUP(op_AND_308))), CAST(32, MSB(DUP(op_AND_308)), DUP(op_AND_308)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_322)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_333 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_330), SN(32, 0));
	RzILOpPure *op_ADD_336 = ADD(op_LSHIFT_333, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_338 = SHIFTRA(op_ADD_336, SN(32, 16));
	RzILOpPure *op_ADD_339 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_300), DUP(op_AND_300))), CAST(32, MSB(DUP(op_AND_300)), DUP(op_AND_300))), op_RSHIFT_338);
	RzILOpPure *op_EQ_340 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_289), SN(32, 0), SN(32, 0x20)), op_ADD_339);
	RzILOpPure *op_RSHIFT_392 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_394 = LOGAND(op_RSHIFT_392, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_400 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_402 = LOGAND(op_RSHIFT_400, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_413 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_416 = LOGAND(op_RSHIFT_413, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_424 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_402), DUP(op_AND_402))), CAST(32, MSB(DUP(op_AND_402)), DUP(op_AND_402)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_402)), DUP(op_AND_402))), CAST(32, MSB(DUP(op_AND_402)), DUP(op_AND_402))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_402)), DUP(op_AND_402))), CAST(32, MSB(DUP(op_AND_402)), DUP(op_AND_402)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_402)), DUP(op_AND_402))), CAST(32, MSB(DUP(op_AND_402)), DUP(op_AND_402)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_416)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_427 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_424), SN(32, 0));
	RzILOpPure *op_ADD_430 = ADD(op_LSHIFT_427, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_432 = SHIFTRA(op_ADD_430, SN(32, 16));
	RzILOpPure *op_ADD_433 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_394), DUP(op_AND_394))), CAST(32, MSB(DUP(op_AND_394)), DUP(op_AND_394))), op_RSHIFT_432);
	RzILOpPure *op_LT_436 = SLT(op_ADD_433, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_441 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_442 = NEG(op_LSHIFT_441);
	RzILOpPure *op_LSHIFT_447 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_450 = SUB(op_LSHIFT_447, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_451 = ITE(op_LT_436, op_NEG_442, op_SUB_450);
	RzILOpEffect *gcc_expr_452 = BRANCH(op_EQ_340, EMPTY(), set_usr_field_call_388);

	// h_tmp293 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_454 = SETL("h_tmp293", cond_451);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_455 = SEQN(2, gcc_expr_452, op_ASSIGN_hybrid_tmp_454);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10) : h_tmp293) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_239 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_240 = LOGNOT(op_LSHIFT_239);
	RzILOpPure *op_AND_241 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_240);
	RzILOpPure *op_RSHIFT_344 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_346 = LOGAND(op_RSHIFT_344, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_352 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_354 = LOGAND(op_RSHIFT_352, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_365 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_368 = LOGAND(op_RSHIFT_365, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_376 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_354), DUP(op_AND_354))), CAST(32, MSB(DUP(op_AND_354)), DUP(op_AND_354)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_354)), DUP(op_AND_354))), CAST(32, MSB(DUP(op_AND_354)), DUP(op_AND_354))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_354)), DUP(op_AND_354))), CAST(32, MSB(DUP(op_AND_354)), DUP(op_AND_354)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_354)), DUP(op_AND_354))), CAST(32, MSB(DUP(op_AND_354)), DUP(op_AND_354)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_368)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_379 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_376), SN(32, 0));
	RzILOpPure *op_ADD_382 = ADD(op_LSHIFT_379, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_384 = SHIFTRA(op_ADD_382, SN(32, 16));
	RzILOpPure *op_ADD_385 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_346), DUP(op_AND_346))), CAST(32, MSB(DUP(op_AND_346)), DUP(op_AND_346))), op_RSHIFT_384);
	RzILOpPure *cond_456 = ITE(DUP(op_EQ_340), op_ADD_385, VARL("h_tmp293"));
	RzILOpPure *op_AND_458 = LOGAND(cond_456, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_462 = SHIFTL0(op_AND_458, SN(32, 0));
	RzILOpPure *op_OR_463 = LOGOR(op_AND_241, op_LSHIFT_462);
	RzILOpEffect *op_ASSIGN_464 = WRITE_REG(bundle, Rxx_op, op_OR_463);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_465 = SEQN(2, seq_455, op_ASSIGN_464);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_233, seq_465);
	return instruction_sequence;
}

// Rxx += vmpyweuh(Rss,Rtt):<<1:rnd:sat
RzILOpEffect *hex_il_op_m2_mmaculs_rs1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_156 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_25 = LOGAND(op_RSHIFT_23, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_37 = SHIFTRA(Rtt, SN(32, 0x20));
	RzILOpPure *op_AND_40 = LOGAND(op_RSHIFT_37, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_48 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_25), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_40)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_51 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_48), SN(32, 1));
	RzILOpPure *op_ADD_54 = ADD(op_LSHIFT_51, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_56 = SHIFTRA(op_ADD_54, SN(32, 16));
	RzILOpPure *op_ADD_57 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_RSHIFT_56);
	RzILOpPure *op_RSHIFT_66 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_68 = LOGAND(op_RSHIFT_66, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_74 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_76 = LOGAND(op_RSHIFT_74, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_87 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_90 = LOGAND(op_RSHIFT_87, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_98 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_76), DUP(op_AND_76))), CAST(32, MSB(DUP(op_AND_76)), DUP(op_AND_76)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_76)), DUP(op_AND_76))), CAST(32, MSB(DUP(op_AND_76)), DUP(op_AND_76))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_76)), DUP(op_AND_76))), CAST(32, MSB(DUP(op_AND_76)), DUP(op_AND_76)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_76)), DUP(op_AND_76))), CAST(32, MSB(DUP(op_AND_76)), DUP(op_AND_76)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_90)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_101 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_98), SN(32, 1));
	RzILOpPure *op_ADD_104 = ADD(op_LSHIFT_101, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_106 = SHIFTRA(op_ADD_104, SN(32, 16));
	RzILOpPure *op_ADD_107 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_68), DUP(op_AND_68))), CAST(32, MSB(DUP(op_AND_68)), DUP(op_AND_68))), op_RSHIFT_106);
	RzILOpPure *op_EQ_108 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_57), SN(32, 0), SN(32, 0x20)), op_ADD_107);
	RzILOpPure *op_RSHIFT_160 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_162 = LOGAND(op_RSHIFT_160, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_168 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_170 = LOGAND(op_RSHIFT_168, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_181 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_184 = LOGAND(op_RSHIFT_181, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_192 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_170), DUP(op_AND_170))), CAST(32, MSB(DUP(op_AND_170)), DUP(op_AND_170)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_170)), DUP(op_AND_170))), CAST(32, MSB(DUP(op_AND_170)), DUP(op_AND_170))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_170)), DUP(op_AND_170))), CAST(32, MSB(DUP(op_AND_170)), DUP(op_AND_170)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_170)), DUP(op_AND_170))), CAST(32, MSB(DUP(op_AND_170)), DUP(op_AND_170)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_184)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_195 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_192), SN(32, 1));
	RzILOpPure *op_ADD_198 = ADD(op_LSHIFT_195, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_200 = SHIFTRA(op_ADD_198, SN(32, 16));
	RzILOpPure *op_ADD_201 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_162), DUP(op_AND_162))), CAST(32, MSB(DUP(op_AND_162)), DUP(op_AND_162))), op_RSHIFT_200);
	RzILOpPure *op_LT_204 = SLT(op_ADD_201, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_209 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_210 = NEG(op_LSHIFT_209);
	RzILOpPure *op_LSHIFT_215 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_218 = SUB(op_LSHIFT_215, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_219 = ITE(op_LT_204, op_NEG_210, op_SUB_218);
	RzILOpEffect *gcc_expr_220 = BRANCH(op_EQ_108, EMPTY(), set_usr_field_call_156);

	// h_tmp294 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_222 = SETL("h_tmp294", cond_219);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_223 = SEQN(2, gcc_expr_220, op_ASSIGN_hybrid_tmp_222);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10) : h_tmp294) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_112 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_114 = LOGAND(op_RSHIFT_112, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_120 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_122 = LOGAND(op_RSHIFT_120, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_133 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_136 = LOGAND(op_RSHIFT_133, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_144 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_122), DUP(op_AND_122))), CAST(32, MSB(DUP(op_AND_122)), DUP(op_AND_122)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_122)), DUP(op_AND_122))), CAST(32, MSB(DUP(op_AND_122)), DUP(op_AND_122))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_122)), DUP(op_AND_122))), CAST(32, MSB(DUP(op_AND_122)), DUP(op_AND_122)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_122)), DUP(op_AND_122))), CAST(32, MSB(DUP(op_AND_122)), DUP(op_AND_122)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_136)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_147 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_144), SN(32, 1));
	RzILOpPure *op_ADD_150 = ADD(op_LSHIFT_147, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_152 = SHIFTRA(op_ADD_150, SN(32, 16));
	RzILOpPure *op_ADD_153 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_114), DUP(op_AND_114))), CAST(32, MSB(DUP(op_AND_114)), DUP(op_AND_114))), op_RSHIFT_152);
	RzILOpPure *cond_224 = ITE(DUP(op_EQ_108), op_ADD_153, VARL("h_tmp294"));
	RzILOpPure *op_AND_226 = LOGAND(cond_224, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_230 = SHIFTL0(op_AND_226, SN(32, 0x20));
	RzILOpPure *op_OR_231 = LOGOR(op_AND_7, op_LSHIFT_230);
	RzILOpEffect *op_ASSIGN_232 = WRITE_REG(bundle, Rxx_op, op_OR_231);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_233 = SEQN(2, seq_223, op_ASSIGN_232);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_388 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_248 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_250 = LOGAND(op_RSHIFT_248, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_256 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_258 = LOGAND(op_RSHIFT_256, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_269 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_272 = LOGAND(op_RSHIFT_269, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_280 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_258), DUP(op_AND_258))), CAST(32, MSB(DUP(op_AND_258)), DUP(op_AND_258)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_258)), DUP(op_AND_258))), CAST(32, MSB(DUP(op_AND_258)), DUP(op_AND_258))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_258)), DUP(op_AND_258))), CAST(32, MSB(DUP(op_AND_258)), DUP(op_AND_258)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_258)), DUP(op_AND_258))), CAST(32, MSB(DUP(op_AND_258)), DUP(op_AND_258)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_272)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_283 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_280), SN(32, 1));
	RzILOpPure *op_ADD_286 = ADD(op_LSHIFT_283, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_288 = SHIFTRA(op_ADD_286, SN(32, 16));
	RzILOpPure *op_ADD_289 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_250), DUP(op_AND_250))), CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250))), op_RSHIFT_288);
	RzILOpPure *op_RSHIFT_298 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_300 = LOGAND(op_RSHIFT_298, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_306 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_308 = LOGAND(op_RSHIFT_306, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_319 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_322 = LOGAND(op_RSHIFT_319, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_330 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_308), DUP(op_AND_308))), CAST(32, MSB(DUP(op_AND_308)), DUP(op_AND_308)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_308)), DUP(op_AND_308))), CAST(32, MSB(DUP(op_AND_308)), DUP(op_AND_308))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_308)), DUP(op_AND_308))), CAST(32, MSB(DUP(op_AND_308)), DUP(op_AND_308)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_308)), DUP(op_AND_308))), CAST(32, MSB(DUP(op_AND_308)), DUP(op_AND_308)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_322)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_333 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_330), SN(32, 1));
	RzILOpPure *op_ADD_336 = ADD(op_LSHIFT_333, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_338 = SHIFTRA(op_ADD_336, SN(32, 16));
	RzILOpPure *op_ADD_339 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_300), DUP(op_AND_300))), CAST(32, MSB(DUP(op_AND_300)), DUP(op_AND_300))), op_RSHIFT_338);
	RzILOpPure *op_EQ_340 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_289), SN(32, 0), SN(32, 0x20)), op_ADD_339);
	RzILOpPure *op_RSHIFT_392 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_394 = LOGAND(op_RSHIFT_392, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_400 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_402 = LOGAND(op_RSHIFT_400, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_413 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_416 = LOGAND(op_RSHIFT_413, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_424 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_402), DUP(op_AND_402))), CAST(32, MSB(DUP(op_AND_402)), DUP(op_AND_402)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_402)), DUP(op_AND_402))), CAST(32, MSB(DUP(op_AND_402)), DUP(op_AND_402))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_402)), DUP(op_AND_402))), CAST(32, MSB(DUP(op_AND_402)), DUP(op_AND_402)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_402)), DUP(op_AND_402))), CAST(32, MSB(DUP(op_AND_402)), DUP(op_AND_402)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_416)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_427 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_424), SN(32, 1));
	RzILOpPure *op_ADD_430 = ADD(op_LSHIFT_427, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_432 = SHIFTRA(op_ADD_430, SN(32, 16));
	RzILOpPure *op_ADD_433 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_394), DUP(op_AND_394))), CAST(32, MSB(DUP(op_AND_394)), DUP(op_AND_394))), op_RSHIFT_432);
	RzILOpPure *op_LT_436 = SLT(op_ADD_433, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_441 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_442 = NEG(op_LSHIFT_441);
	RzILOpPure *op_LSHIFT_447 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_450 = SUB(op_LSHIFT_447, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_451 = ITE(op_LT_436, op_NEG_442, op_SUB_450);
	RzILOpEffect *gcc_expr_452 = BRANCH(op_EQ_340, EMPTY(), set_usr_field_call_388);

	// h_tmp295 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_454 = SETL("h_tmp295", cond_451);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_455 = SEQN(2, gcc_expr_452, op_ASSIGN_hybrid_tmp_454);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10) : h_tmp295) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_239 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_240 = LOGNOT(op_LSHIFT_239);
	RzILOpPure *op_AND_241 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_240);
	RzILOpPure *op_RSHIFT_344 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_346 = LOGAND(op_RSHIFT_344, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_352 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_354 = LOGAND(op_RSHIFT_352, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_365 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_368 = LOGAND(op_RSHIFT_365, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_376 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_354), DUP(op_AND_354))), CAST(32, MSB(DUP(op_AND_354)), DUP(op_AND_354)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_354)), DUP(op_AND_354))), CAST(32, MSB(DUP(op_AND_354)), DUP(op_AND_354))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_354)), DUP(op_AND_354))), CAST(32, MSB(DUP(op_AND_354)), DUP(op_AND_354)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_354)), DUP(op_AND_354))), CAST(32, MSB(DUP(op_AND_354)), DUP(op_AND_354)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_368)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_379 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_376), SN(32, 1));
	RzILOpPure *op_ADD_382 = ADD(op_LSHIFT_379, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_384 = SHIFTRA(op_ADD_382, SN(32, 16));
	RzILOpPure *op_ADD_385 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_346), DUP(op_AND_346))), CAST(32, MSB(DUP(op_AND_346)), DUP(op_AND_346))), op_RSHIFT_384);
	RzILOpPure *cond_456 = ITE(DUP(op_EQ_340), op_ADD_385, VARL("h_tmp295"));
	RzILOpPure *op_AND_458 = LOGAND(cond_456, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_462 = SHIFTL0(op_AND_458, SN(32, 0));
	RzILOpPure *op_OR_463 = LOGOR(op_AND_241, op_LSHIFT_462);
	RzILOpEffect *op_ASSIGN_464 = WRITE_REG(bundle, Rxx_op, op_OR_463);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_465 = SEQN(2, seq_455, op_ASSIGN_464);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_233, seq_465);
	return instruction_sequence;
}

// Rxx += vmpyweuh(Rss,Rtt):sat
RzILOpEffect *hex_il_op_m2_mmaculs_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_147 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_25 = LOGAND(op_RSHIFT_23, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_37 = SHIFTRA(Rtt, SN(32, 0x20));
	RzILOpPure *op_AND_40 = LOGAND(op_RSHIFT_37, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_48 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_25), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_40)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_51 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_48), SN(32, 0));
	RzILOpPure *op_RSHIFT_53 = SHIFTRA(op_LSHIFT_51, SN(32, 16));
	RzILOpPure *op_ADD_54 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_RSHIFT_53);
	RzILOpPure *op_RSHIFT_63 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_65 = LOGAND(op_RSHIFT_63, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_71 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_73 = LOGAND(op_RSHIFT_71, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_84 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_87 = LOGAND(op_RSHIFT_84, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_95 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_73), DUP(op_AND_73))), CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73))), CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73))), CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73))), CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_87)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_98 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_95), SN(32, 0));
	RzILOpPure *op_RSHIFT_100 = SHIFTRA(op_LSHIFT_98, SN(32, 16));
	RzILOpPure *op_ADD_101 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_65), DUP(op_AND_65))), CAST(32, MSB(DUP(op_AND_65)), DUP(op_AND_65))), op_RSHIFT_100);
	RzILOpPure *op_EQ_102 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_54), SN(32, 0), SN(32, 0x20)), op_ADD_101);
	RzILOpPure *op_RSHIFT_151 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_153 = LOGAND(op_RSHIFT_151, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_159 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_161 = LOGAND(op_RSHIFT_159, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_172 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_175 = LOGAND(op_RSHIFT_172, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_183 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_161), DUP(op_AND_161))), CAST(32, MSB(DUP(op_AND_161)), DUP(op_AND_161)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_161)), DUP(op_AND_161))), CAST(32, MSB(DUP(op_AND_161)), DUP(op_AND_161))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_161)), DUP(op_AND_161))), CAST(32, MSB(DUP(op_AND_161)), DUP(op_AND_161)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_161)), DUP(op_AND_161))), CAST(32, MSB(DUP(op_AND_161)), DUP(op_AND_161)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_175)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_186 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_183), SN(32, 0));
	RzILOpPure *op_RSHIFT_188 = SHIFTRA(op_LSHIFT_186, SN(32, 16));
	RzILOpPure *op_ADD_189 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_153), DUP(op_AND_153))), CAST(32, MSB(DUP(op_AND_153)), DUP(op_AND_153))), op_RSHIFT_188);
	RzILOpPure *op_LT_192 = SLT(op_ADD_189, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_197 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_198 = NEG(op_LSHIFT_197);
	RzILOpPure *op_LSHIFT_203 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_206 = SUB(op_LSHIFT_203, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_207 = ITE(op_LT_192, op_NEG_198, op_SUB_206);
	RzILOpEffect *gcc_expr_208 = BRANCH(op_EQ_102, EMPTY(), set_usr_field_call_147);

	// h_tmp296 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_210 = SETL("h_tmp296", cond_207);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_211 = SEQN(2, gcc_expr_208, op_ASSIGN_hybrid_tmp_210);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10) : h_tmp296) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_106 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_108 = LOGAND(op_RSHIFT_106, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_114 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_116 = LOGAND(op_RSHIFT_114, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_127 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_130 = LOGAND(op_RSHIFT_127, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_138 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_116), DUP(op_AND_116))), CAST(32, MSB(DUP(op_AND_116)), DUP(op_AND_116)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_116)), DUP(op_AND_116))), CAST(32, MSB(DUP(op_AND_116)), DUP(op_AND_116))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_116)), DUP(op_AND_116))), CAST(32, MSB(DUP(op_AND_116)), DUP(op_AND_116)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_116)), DUP(op_AND_116))), CAST(32, MSB(DUP(op_AND_116)), DUP(op_AND_116)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_130)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_141 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_138), SN(32, 0));
	RzILOpPure *op_RSHIFT_143 = SHIFTRA(op_LSHIFT_141, SN(32, 16));
	RzILOpPure *op_ADD_144 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_108), DUP(op_AND_108))), CAST(32, MSB(DUP(op_AND_108)), DUP(op_AND_108))), op_RSHIFT_143);
	RzILOpPure *cond_212 = ITE(DUP(op_EQ_102), op_ADD_144, VARL("h_tmp296"));
	RzILOpPure *op_AND_214 = LOGAND(cond_212, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_218 = SHIFTL0(op_AND_214, SN(32, 0x20));
	RzILOpPure *op_OR_219 = LOGOR(op_AND_7, op_LSHIFT_218);
	RzILOpEffect *op_ASSIGN_220 = WRITE_REG(bundle, Rxx_op, op_OR_219);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_221 = SEQN(2, seq_211, op_ASSIGN_220);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_367 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_236 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_238 = LOGAND(op_RSHIFT_236, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_244 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_246 = LOGAND(op_RSHIFT_244, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_257 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_260 = LOGAND(op_RSHIFT_257, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_268 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_246), DUP(op_AND_246))), CAST(32, MSB(DUP(op_AND_246)), DUP(op_AND_246)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_246)), DUP(op_AND_246))), CAST(32, MSB(DUP(op_AND_246)), DUP(op_AND_246))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_246)), DUP(op_AND_246))), CAST(32, MSB(DUP(op_AND_246)), DUP(op_AND_246)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_246)), DUP(op_AND_246))), CAST(32, MSB(DUP(op_AND_246)), DUP(op_AND_246)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_260)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_271 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_268), SN(32, 0));
	RzILOpPure *op_RSHIFT_273 = SHIFTRA(op_LSHIFT_271, SN(32, 16));
	RzILOpPure *op_ADD_274 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_238), DUP(op_AND_238))), CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238))), op_RSHIFT_273);
	RzILOpPure *op_RSHIFT_283 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_285 = LOGAND(op_RSHIFT_283, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_291 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_293 = LOGAND(op_RSHIFT_291, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_304 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_307 = LOGAND(op_RSHIFT_304, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_315 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_293), DUP(op_AND_293))), CAST(32, MSB(DUP(op_AND_293)), DUP(op_AND_293)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_293)), DUP(op_AND_293))), CAST(32, MSB(DUP(op_AND_293)), DUP(op_AND_293))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_293)), DUP(op_AND_293))), CAST(32, MSB(DUP(op_AND_293)), DUP(op_AND_293)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_293)), DUP(op_AND_293))), CAST(32, MSB(DUP(op_AND_293)), DUP(op_AND_293)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_307)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_318 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_315), SN(32, 0));
	RzILOpPure *op_RSHIFT_320 = SHIFTRA(op_LSHIFT_318, SN(32, 16));
	RzILOpPure *op_ADD_321 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_285), DUP(op_AND_285))), CAST(32, MSB(DUP(op_AND_285)), DUP(op_AND_285))), op_RSHIFT_320);
	RzILOpPure *op_EQ_322 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_274), SN(32, 0), SN(32, 0x20)), op_ADD_321);
	RzILOpPure *op_RSHIFT_371 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_373 = LOGAND(op_RSHIFT_371, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_379 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_381 = LOGAND(op_RSHIFT_379, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_392 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_395 = LOGAND(op_RSHIFT_392, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_403 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_381), DUP(op_AND_381))), CAST(32, MSB(DUP(op_AND_381)), DUP(op_AND_381)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_381)), DUP(op_AND_381))), CAST(32, MSB(DUP(op_AND_381)), DUP(op_AND_381))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_381)), DUP(op_AND_381))), CAST(32, MSB(DUP(op_AND_381)), DUP(op_AND_381)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_381)), DUP(op_AND_381))), CAST(32, MSB(DUP(op_AND_381)), DUP(op_AND_381)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_395)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_406 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_403), SN(32, 0));
	RzILOpPure *op_RSHIFT_408 = SHIFTRA(op_LSHIFT_406, SN(32, 16));
	RzILOpPure *op_ADD_409 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_373), DUP(op_AND_373))), CAST(32, MSB(DUP(op_AND_373)), DUP(op_AND_373))), op_RSHIFT_408);
	RzILOpPure *op_LT_412 = SLT(op_ADD_409, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_417 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_418 = NEG(op_LSHIFT_417);
	RzILOpPure *op_LSHIFT_423 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_426 = SUB(op_LSHIFT_423, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_427 = ITE(op_LT_412, op_NEG_418, op_SUB_426);
	RzILOpEffect *gcc_expr_428 = BRANCH(op_EQ_322, EMPTY(), set_usr_field_call_367);

	// h_tmp297 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_430 = SETL("h_tmp297", cond_427);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_431 = SEQN(2, gcc_expr_428, op_ASSIGN_hybrid_tmp_430);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10) : h_tmp297) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_227 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_228 = LOGNOT(op_LSHIFT_227);
	RzILOpPure *op_AND_229 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_228);
	RzILOpPure *op_RSHIFT_326 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_328 = LOGAND(op_RSHIFT_326, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_334 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_336 = LOGAND(op_RSHIFT_334, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_347 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_350 = LOGAND(op_RSHIFT_347, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_358 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_336), DUP(op_AND_336))), CAST(32, MSB(DUP(op_AND_336)), DUP(op_AND_336)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_336)), DUP(op_AND_336))), CAST(32, MSB(DUP(op_AND_336)), DUP(op_AND_336))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_336)), DUP(op_AND_336))), CAST(32, MSB(DUP(op_AND_336)), DUP(op_AND_336)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_336)), DUP(op_AND_336))), CAST(32, MSB(DUP(op_AND_336)), DUP(op_AND_336)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_350)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_361 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_358), SN(32, 0));
	RzILOpPure *op_RSHIFT_363 = SHIFTRA(op_LSHIFT_361, SN(32, 16));
	RzILOpPure *op_ADD_364 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_328), DUP(op_AND_328))), CAST(32, MSB(DUP(op_AND_328)), DUP(op_AND_328))), op_RSHIFT_363);
	RzILOpPure *cond_432 = ITE(DUP(op_EQ_322), op_ADD_364, VARL("h_tmp297"));
	RzILOpPure *op_AND_434 = LOGAND(cond_432, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_438 = SHIFTL0(op_AND_434, SN(32, 0));
	RzILOpPure *op_OR_439 = LOGOR(op_AND_229, op_LSHIFT_438);
	RzILOpEffect *op_ASSIGN_440 = WRITE_REG(bundle, Rxx_op, op_OR_439);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_441 = SEQN(2, seq_431, op_ASSIGN_440);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_221, seq_441);
	return instruction_sequence;
}

// Rxx += vmpyweuh(Rss,Rtt):<<1:sat
RzILOpEffect *hex_il_op_m2_mmaculs_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_147 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_25 = LOGAND(op_RSHIFT_23, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_37 = SHIFTRA(Rtt, SN(32, 0x20));
	RzILOpPure *op_AND_40 = LOGAND(op_RSHIFT_37, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_48 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_25), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(DUP(op_AND_25)), DUP(op_AND_25)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_40)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_51 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_48), SN(32, 1));
	RzILOpPure *op_RSHIFT_53 = SHIFTRA(op_LSHIFT_51, SN(32, 16));
	RzILOpPure *op_ADD_54 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_RSHIFT_53);
	RzILOpPure *op_RSHIFT_63 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_65 = LOGAND(op_RSHIFT_63, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_71 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_73 = LOGAND(op_RSHIFT_71, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_84 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_87 = LOGAND(op_RSHIFT_84, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_95 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_73), DUP(op_AND_73))), CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73))), CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73))), CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73))), CAST(32, MSB(DUP(op_AND_73)), DUP(op_AND_73)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_87)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_98 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_95), SN(32, 1));
	RzILOpPure *op_RSHIFT_100 = SHIFTRA(op_LSHIFT_98, SN(32, 16));
	RzILOpPure *op_ADD_101 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_65), DUP(op_AND_65))), CAST(32, MSB(DUP(op_AND_65)), DUP(op_AND_65))), op_RSHIFT_100);
	RzILOpPure *op_EQ_102 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_54), SN(32, 0), SN(32, 0x20)), op_ADD_101);
	RzILOpPure *op_RSHIFT_151 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_153 = LOGAND(op_RSHIFT_151, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_159 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_161 = LOGAND(op_RSHIFT_159, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_172 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_175 = LOGAND(op_RSHIFT_172, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_183 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_161), DUP(op_AND_161))), CAST(32, MSB(DUP(op_AND_161)), DUP(op_AND_161)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_161)), DUP(op_AND_161))), CAST(32, MSB(DUP(op_AND_161)), DUP(op_AND_161))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_161)), DUP(op_AND_161))), CAST(32, MSB(DUP(op_AND_161)), DUP(op_AND_161)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_161)), DUP(op_AND_161))), CAST(32, MSB(DUP(op_AND_161)), DUP(op_AND_161)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_175)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_186 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_183), SN(32, 1));
	RzILOpPure *op_RSHIFT_188 = SHIFTRA(op_LSHIFT_186, SN(32, 16));
	RzILOpPure *op_ADD_189 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_153), DUP(op_AND_153))), CAST(32, MSB(DUP(op_AND_153)), DUP(op_AND_153))), op_RSHIFT_188);
	RzILOpPure *op_LT_192 = SLT(op_ADD_189, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_197 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_198 = NEG(op_LSHIFT_197);
	RzILOpPure *op_LSHIFT_203 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_206 = SUB(op_LSHIFT_203, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_207 = ITE(op_LT_192, op_NEG_198, op_SUB_206);
	RzILOpEffect *gcc_expr_208 = BRANCH(op_EQ_102, EMPTY(), set_usr_field_call_147);

	// h_tmp298 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_210 = SETL("h_tmp298", cond_207);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_211 = SEQN(2, gcc_expr_208, op_ASSIGN_hybrid_tmp_210);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10) : h_tmp298) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_106 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_108 = LOGAND(op_RSHIFT_106, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_114 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_116 = LOGAND(op_RSHIFT_114, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_127 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_130 = LOGAND(op_RSHIFT_127, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_138 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_116), DUP(op_AND_116))), CAST(32, MSB(DUP(op_AND_116)), DUP(op_AND_116)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_116)), DUP(op_AND_116))), CAST(32, MSB(DUP(op_AND_116)), DUP(op_AND_116))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_116)), DUP(op_AND_116))), CAST(32, MSB(DUP(op_AND_116)), DUP(op_AND_116)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_116)), DUP(op_AND_116))), CAST(32, MSB(DUP(op_AND_116)), DUP(op_AND_116)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_130)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_141 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_138), SN(32, 1));
	RzILOpPure *op_RSHIFT_143 = SHIFTRA(op_LSHIFT_141, SN(32, 16));
	RzILOpPure *op_ADD_144 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_108), DUP(op_AND_108))), CAST(32, MSB(DUP(op_AND_108)), DUP(op_AND_108))), op_RSHIFT_143);
	RzILOpPure *cond_212 = ITE(DUP(op_EQ_102), op_ADD_144, VARL("h_tmp298"));
	RzILOpPure *op_AND_214 = LOGAND(cond_212, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_218 = SHIFTL0(op_AND_214, SN(32, 0x20));
	RzILOpPure *op_OR_219 = LOGOR(op_AND_7, op_LSHIFT_218);
	RzILOpEffect *op_ASSIGN_220 = WRITE_REG(bundle, Rxx_op, op_OR_219);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_221 = SEQN(2, seq_211, op_ASSIGN_220);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_367 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_236 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_238 = LOGAND(op_RSHIFT_236, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_244 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_246 = LOGAND(op_RSHIFT_244, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_257 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_260 = LOGAND(op_RSHIFT_257, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_268 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_246), DUP(op_AND_246))), CAST(32, MSB(DUP(op_AND_246)), DUP(op_AND_246)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_246)), DUP(op_AND_246))), CAST(32, MSB(DUP(op_AND_246)), DUP(op_AND_246))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_246)), DUP(op_AND_246))), CAST(32, MSB(DUP(op_AND_246)), DUP(op_AND_246)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_246)), DUP(op_AND_246))), CAST(32, MSB(DUP(op_AND_246)), DUP(op_AND_246)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_260)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_271 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_268), SN(32, 1));
	RzILOpPure *op_RSHIFT_273 = SHIFTRA(op_LSHIFT_271, SN(32, 16));
	RzILOpPure *op_ADD_274 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_238), DUP(op_AND_238))), CAST(32, MSB(DUP(op_AND_238)), DUP(op_AND_238))), op_RSHIFT_273);
	RzILOpPure *op_RSHIFT_283 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_285 = LOGAND(op_RSHIFT_283, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_291 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_293 = LOGAND(op_RSHIFT_291, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_304 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_307 = LOGAND(op_RSHIFT_304, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_315 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_293), DUP(op_AND_293))), CAST(32, MSB(DUP(op_AND_293)), DUP(op_AND_293)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_293)), DUP(op_AND_293))), CAST(32, MSB(DUP(op_AND_293)), DUP(op_AND_293))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_293)), DUP(op_AND_293))), CAST(32, MSB(DUP(op_AND_293)), DUP(op_AND_293)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_293)), DUP(op_AND_293))), CAST(32, MSB(DUP(op_AND_293)), DUP(op_AND_293)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_307)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_318 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_315), SN(32, 1));
	RzILOpPure *op_RSHIFT_320 = SHIFTRA(op_LSHIFT_318, SN(32, 16));
	RzILOpPure *op_ADD_321 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_285), DUP(op_AND_285))), CAST(32, MSB(DUP(op_AND_285)), DUP(op_AND_285))), op_RSHIFT_320);
	RzILOpPure *op_EQ_322 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_274), SN(32, 0), SN(32, 0x20)), op_ADD_321);
	RzILOpPure *op_RSHIFT_371 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_373 = LOGAND(op_RSHIFT_371, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_379 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_381 = LOGAND(op_RSHIFT_379, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_392 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_395 = LOGAND(op_RSHIFT_392, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_403 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_381), DUP(op_AND_381))), CAST(32, MSB(DUP(op_AND_381)), DUP(op_AND_381)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_381)), DUP(op_AND_381))), CAST(32, MSB(DUP(op_AND_381)), DUP(op_AND_381))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_381)), DUP(op_AND_381))), CAST(32, MSB(DUP(op_AND_381)), DUP(op_AND_381)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_381)), DUP(op_AND_381))), CAST(32, MSB(DUP(op_AND_381)), DUP(op_AND_381)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_395)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_406 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_403), SN(32, 1));
	RzILOpPure *op_RSHIFT_408 = SHIFTRA(op_LSHIFT_406, SN(32, 16));
	RzILOpPure *op_ADD_409 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_373), DUP(op_AND_373))), CAST(32, MSB(DUP(op_AND_373)), DUP(op_AND_373))), op_RSHIFT_408);
	RzILOpPure *op_LT_412 = SLT(op_ADD_409, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_417 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_418 = NEG(op_LSHIFT_417);
	RzILOpPure *op_LSHIFT_423 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_426 = SUB(op_LSHIFT_423, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_427 = ITE(op_LT_412, op_NEG_418, op_SUB_426);
	RzILOpEffect *gcc_expr_428 = BRANCH(op_EQ_322, EMPTY(), set_usr_field_call_367);

	// h_tmp299 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_430 = SETL("h_tmp299", cond_427);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_431 = SEQN(2, gcc_expr_428, op_ASSIGN_hybrid_tmp_430);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10) : h_tmp299) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_227 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_228 = LOGNOT(op_LSHIFT_227);
	RzILOpPure *op_AND_229 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_228);
	RzILOpPure *op_RSHIFT_326 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_328 = LOGAND(op_RSHIFT_326, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_334 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_336 = LOGAND(op_RSHIFT_334, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_347 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_350 = LOGAND(op_RSHIFT_347, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_358 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_336), DUP(op_AND_336))), CAST(32, MSB(DUP(op_AND_336)), DUP(op_AND_336)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_336)), DUP(op_AND_336))), CAST(32, MSB(DUP(op_AND_336)), DUP(op_AND_336))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_336)), DUP(op_AND_336))), CAST(32, MSB(DUP(op_AND_336)), DUP(op_AND_336)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_336)), DUP(op_AND_336))), CAST(32, MSB(DUP(op_AND_336)), DUP(op_AND_336)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_350)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_361 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_358), SN(32, 1));
	RzILOpPure *op_RSHIFT_363 = SHIFTRA(op_LSHIFT_361, SN(32, 16));
	RzILOpPure *op_ADD_364 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_328), DUP(op_AND_328))), CAST(32, MSB(DUP(op_AND_328)), DUP(op_AND_328))), op_RSHIFT_363);
	RzILOpPure *cond_432 = ITE(DUP(op_EQ_322), op_ADD_364, VARL("h_tmp299"));
	RzILOpPure *op_AND_434 = LOGAND(cond_432, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_438 = SHIFTL0(op_AND_434, SN(32, 0));
	RzILOpPure *op_OR_439 = LOGOR(op_AND_229, op_LSHIFT_438);
	RzILOpEffect *op_ASSIGN_440 = WRITE_REG(bundle, Rxx_op, op_OR_439);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_441 = SEQN(2, seq_431, op_ASSIGN_440);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_221, seq_441);
	return instruction_sequence;
}

// Rdd = vmpywoh(Rss,Rtt):rnd:sat
RzILOpEffect *hex_il_op_m2_mmpyh_rs0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_123 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_17 = LOGAND(op_RSHIFT_15, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_29 = SHIFTRA(Rtt, SN(32, 0x30));
	RzILOpPure *op_AND_32 = LOGAND(op_RSHIFT_29, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_39 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_17), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_32), DUP(op_AND_32))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_41 = SHIFTL0(op_MUL_39, SN(32, 0));
	RzILOpPure *op_ADD_44 = ADD(op_LSHIFT_41, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_46 = SHIFTRA(op_ADD_44, SN(32, 16));
	RzILOpPure *op_RSHIFT_55 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_57 = LOGAND(op_RSHIFT_55, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_68 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_71 = LOGAND(op_RSHIFT_68, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_78 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_57), DUP(op_AND_57))), CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57))), CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57))), CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57))), CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_71), DUP(op_AND_71))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_80 = SHIFTL0(op_MUL_78, SN(32, 0));
	RzILOpPure *op_ADD_83 = ADD(op_LSHIFT_80, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_85 = SHIFTRA(op_ADD_83, SN(32, 16));
	RzILOpPure *op_EQ_86 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_46), SN(32, 0), SN(32, 0x20)), op_RSHIFT_85);
	RzILOpPure *op_RSHIFT_127 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_129 = LOGAND(op_RSHIFT_127, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_140 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_143 = LOGAND(op_RSHIFT_140, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_150 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_129), DUP(op_AND_129))), CAST(32, MSB(DUP(op_AND_129)), DUP(op_AND_129)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_129)), DUP(op_AND_129))), CAST(32, MSB(DUP(op_AND_129)), DUP(op_AND_129))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_129)), DUP(op_AND_129))), CAST(32, MSB(DUP(op_AND_129)), DUP(op_AND_129)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_129)), DUP(op_AND_129))), CAST(32, MSB(DUP(op_AND_129)), DUP(op_AND_129))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_143), DUP(op_AND_143))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_152 = SHIFTL0(op_MUL_150, SN(32, 0));
	RzILOpPure *op_ADD_155 = ADD(op_LSHIFT_152, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_157 = SHIFTRA(op_ADD_155, SN(32, 16));
	RzILOpPure *op_LT_160 = SLT(op_RSHIFT_157, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_165 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_166 = NEG(op_LSHIFT_165);
	RzILOpPure *op_LSHIFT_171 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_174 = SUB(op_LSHIFT_171, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_175 = ITE(op_LT_160, op_NEG_166, op_SUB_174);
	RzILOpEffect *gcc_expr_176 = BRANCH(op_EQ_86, EMPTY(), set_usr_field_call_123);

	// h_tmp300 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_178 = SETL("h_tmp300", cond_175);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st6 ...;
	RzILOpEffect *seq_179 = SEQN(2, gcc_expr_176, op_ASSIGN_hybrid_tmp_178);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)) ? ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10) : h_tmp300) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_90 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_92 = LOGAND(op_RSHIFT_90, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_103 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_106 = LOGAND(op_RSHIFT_103, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_113 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_92), DUP(op_AND_92))), CAST(32, MSB(DUP(op_AND_92)), DUP(op_AND_92)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_92)), DUP(op_AND_92))), CAST(32, MSB(DUP(op_AND_92)), DUP(op_AND_92))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_92)), DUP(op_AND_92))), CAST(32, MSB(DUP(op_AND_92)), DUP(op_AND_92)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_92)), DUP(op_AND_92))), CAST(32, MSB(DUP(op_AND_92)), DUP(op_AND_92))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_106), DUP(op_AND_106))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_115 = SHIFTL0(op_MUL_113, SN(32, 0));
	RzILOpPure *op_ADD_118 = ADD(op_LSHIFT_115, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_120 = SHIFTRA(op_ADD_118, SN(32, 16));
	RzILOpPure *cond_180 = ITE(DUP(op_EQ_86), op_RSHIFT_120, VARL("h_tmp300"));
	RzILOpPure *op_AND_182 = LOGAND(cond_180, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_186 = SHIFTL0(op_AND_182, SN(32, 0x20));
	RzILOpPure *op_OR_187 = LOGOR(op_AND_7, op_LSHIFT_186);
	RzILOpEffect *op_ASSIGN_188 = WRITE_REG(bundle, Rdd_op, op_OR_187);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ( ...;
	RzILOpEffect *seq_189 = SEQN(2, seq_179, op_ASSIGN_188);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_311 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_204 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_206 = LOGAND(op_RSHIFT_204, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_217 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_220 = LOGAND(op_RSHIFT_217, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_227 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_206), DUP(op_AND_206))), CAST(32, MSB(DUP(op_AND_206)), DUP(op_AND_206)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_206)), DUP(op_AND_206))), CAST(32, MSB(DUP(op_AND_206)), DUP(op_AND_206))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_206)), DUP(op_AND_206))), CAST(32, MSB(DUP(op_AND_206)), DUP(op_AND_206)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_206)), DUP(op_AND_206))), CAST(32, MSB(DUP(op_AND_206)), DUP(op_AND_206))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_220), DUP(op_AND_220))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_229 = SHIFTL0(op_MUL_227, SN(32, 0));
	RzILOpPure *op_ADD_232 = ADD(op_LSHIFT_229, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_234 = SHIFTRA(op_ADD_232, SN(32, 16));
	RzILOpPure *op_RSHIFT_243 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_245 = LOGAND(op_RSHIFT_243, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_256 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_259 = LOGAND(op_RSHIFT_256, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_266 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_245), DUP(op_AND_245))), CAST(32, MSB(DUP(op_AND_245)), DUP(op_AND_245)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_245)), DUP(op_AND_245))), CAST(32, MSB(DUP(op_AND_245)), DUP(op_AND_245))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_245)), DUP(op_AND_245))), CAST(32, MSB(DUP(op_AND_245)), DUP(op_AND_245)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_245)), DUP(op_AND_245))), CAST(32, MSB(DUP(op_AND_245)), DUP(op_AND_245))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_259), DUP(op_AND_259))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_268 = SHIFTL0(op_MUL_266, SN(32, 0));
	RzILOpPure *op_ADD_271 = ADD(op_LSHIFT_268, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_273 = SHIFTRA(op_ADD_271, SN(32, 16));
	RzILOpPure *op_EQ_274 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_234), SN(32, 0), SN(32, 0x20)), op_RSHIFT_273);
	RzILOpPure *op_RSHIFT_315 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_317 = LOGAND(op_RSHIFT_315, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_328 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_331 = LOGAND(op_RSHIFT_328, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_338 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_317), DUP(op_AND_317))), CAST(32, MSB(DUP(op_AND_317)), DUP(op_AND_317)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_317)), DUP(op_AND_317))), CAST(32, MSB(DUP(op_AND_317)), DUP(op_AND_317))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_317)), DUP(op_AND_317))), CAST(32, MSB(DUP(op_AND_317)), DUP(op_AND_317)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_317)), DUP(op_AND_317))), CAST(32, MSB(DUP(op_AND_317)), DUP(op_AND_317))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_331), DUP(op_AND_331))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_340 = SHIFTL0(op_MUL_338, SN(32, 0));
	RzILOpPure *op_ADD_343 = ADD(op_LSHIFT_340, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_345 = SHIFTRA(op_ADD_343, SN(32, 16));
	RzILOpPure *op_LT_348 = SLT(op_RSHIFT_345, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_353 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_354 = NEG(op_LSHIFT_353);
	RzILOpPure *op_LSHIFT_359 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_362 = SUB(op_LSHIFT_359, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_363 = ITE(op_LT_348, op_NEG_354, op_SUB_362);
	RzILOpEffect *gcc_expr_364 = BRANCH(op_EQ_274, EMPTY(), set_usr_field_call_311);

	// h_tmp301 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_366 = SETL("h_tmp301", cond_363);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st6 ...;
	RzILOpEffect *seq_367 = SEQN(2, gcc_expr_364, op_ASSIGN_hybrid_tmp_366);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)) ? ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10) : h_tmp301) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_195 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_196 = LOGNOT(op_LSHIFT_195);
	RzILOpPure *op_AND_197 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_196);
	RzILOpPure *op_RSHIFT_278 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_280 = LOGAND(op_RSHIFT_278, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_291 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_294 = LOGAND(op_RSHIFT_291, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_301 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_280), DUP(op_AND_280))), CAST(32, MSB(DUP(op_AND_280)), DUP(op_AND_280)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_280)), DUP(op_AND_280))), CAST(32, MSB(DUP(op_AND_280)), DUP(op_AND_280))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_280)), DUP(op_AND_280))), CAST(32, MSB(DUP(op_AND_280)), DUP(op_AND_280)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_280)), DUP(op_AND_280))), CAST(32, MSB(DUP(op_AND_280)), DUP(op_AND_280))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_294), DUP(op_AND_294))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_303 = SHIFTL0(op_MUL_301, SN(32, 0));
	RzILOpPure *op_ADD_306 = ADD(op_LSHIFT_303, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_308 = SHIFTRA(op_ADD_306, SN(32, 16));
	RzILOpPure *cond_368 = ITE(DUP(op_EQ_274), op_RSHIFT_308, VARL("h_tmp301"));
	RzILOpPure *op_AND_370 = LOGAND(cond_368, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_374 = SHIFTL0(op_AND_370, SN(32, 0));
	RzILOpPure *op_OR_375 = LOGOR(op_AND_197, op_LSHIFT_374);
	RzILOpEffect *op_ASSIGN_376 = WRITE_REG(bundle, Rdd_op, op_OR_375);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ( ...;
	RzILOpEffect *seq_377 = SEQN(2, seq_367, op_ASSIGN_376);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_189, seq_377);
	return instruction_sequence;
}

// Rdd = vmpywoh(Rss,Rtt):<<1:rnd:sat
RzILOpEffect *hex_il_op_m2_mmpyh_rs1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_123 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_17 = LOGAND(op_RSHIFT_15, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_29 = SHIFTRA(Rtt, SN(32, 0x30));
	RzILOpPure *op_AND_32 = LOGAND(op_RSHIFT_29, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_39 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_17), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_32), DUP(op_AND_32))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_41 = SHIFTL0(op_MUL_39, SN(32, 1));
	RzILOpPure *op_ADD_44 = ADD(op_LSHIFT_41, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_46 = SHIFTRA(op_ADD_44, SN(32, 16));
	RzILOpPure *op_RSHIFT_55 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_57 = LOGAND(op_RSHIFT_55, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_68 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_71 = LOGAND(op_RSHIFT_68, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_78 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_57), DUP(op_AND_57))), CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57))), CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57))), CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57))), CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_71), DUP(op_AND_71))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_80 = SHIFTL0(op_MUL_78, SN(32, 1));
	RzILOpPure *op_ADD_83 = ADD(op_LSHIFT_80, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_85 = SHIFTRA(op_ADD_83, SN(32, 16));
	RzILOpPure *op_EQ_86 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_46), SN(32, 0), SN(32, 0x20)), op_RSHIFT_85);
	RzILOpPure *op_RSHIFT_127 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_129 = LOGAND(op_RSHIFT_127, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_140 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_143 = LOGAND(op_RSHIFT_140, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_150 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_129), DUP(op_AND_129))), CAST(32, MSB(DUP(op_AND_129)), DUP(op_AND_129)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_129)), DUP(op_AND_129))), CAST(32, MSB(DUP(op_AND_129)), DUP(op_AND_129))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_129)), DUP(op_AND_129))), CAST(32, MSB(DUP(op_AND_129)), DUP(op_AND_129)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_129)), DUP(op_AND_129))), CAST(32, MSB(DUP(op_AND_129)), DUP(op_AND_129))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_143), DUP(op_AND_143))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_152 = SHIFTL0(op_MUL_150, SN(32, 1));
	RzILOpPure *op_ADD_155 = ADD(op_LSHIFT_152, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_157 = SHIFTRA(op_ADD_155, SN(32, 16));
	RzILOpPure *op_LT_160 = SLT(op_RSHIFT_157, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_165 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_166 = NEG(op_LSHIFT_165);
	RzILOpPure *op_LSHIFT_171 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_174 = SUB(op_LSHIFT_171, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_175 = ITE(op_LT_160, op_NEG_166, op_SUB_174);
	RzILOpEffect *gcc_expr_176 = BRANCH(op_EQ_86, EMPTY(), set_usr_field_call_123);

	// h_tmp302 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_178 = SETL("h_tmp302", cond_175);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st6 ...;
	RzILOpEffect *seq_179 = SEQN(2, gcc_expr_176, op_ASSIGN_hybrid_tmp_178);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)) ? ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) : h_tmp302) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_90 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_92 = LOGAND(op_RSHIFT_90, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_103 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_106 = LOGAND(op_RSHIFT_103, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_113 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_92), DUP(op_AND_92))), CAST(32, MSB(DUP(op_AND_92)), DUP(op_AND_92)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_92)), DUP(op_AND_92))), CAST(32, MSB(DUP(op_AND_92)), DUP(op_AND_92))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_92)), DUP(op_AND_92))), CAST(32, MSB(DUP(op_AND_92)), DUP(op_AND_92)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_92)), DUP(op_AND_92))), CAST(32, MSB(DUP(op_AND_92)), DUP(op_AND_92))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_106), DUP(op_AND_106))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_115 = SHIFTL0(op_MUL_113, SN(32, 1));
	RzILOpPure *op_ADD_118 = ADD(op_LSHIFT_115, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_120 = SHIFTRA(op_ADD_118, SN(32, 16));
	RzILOpPure *cond_180 = ITE(DUP(op_EQ_86), op_RSHIFT_120, VARL("h_tmp302"));
	RzILOpPure *op_AND_182 = LOGAND(cond_180, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_186 = SHIFTL0(op_AND_182, SN(32, 0x20));
	RzILOpPure *op_OR_187 = LOGOR(op_AND_7, op_LSHIFT_186);
	RzILOpEffect *op_ASSIGN_188 = WRITE_REG(bundle, Rdd_op, op_OR_187);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ( ...;
	RzILOpEffect *seq_189 = SEQN(2, seq_179, op_ASSIGN_188);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_311 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_204 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_206 = LOGAND(op_RSHIFT_204, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_217 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_220 = LOGAND(op_RSHIFT_217, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_227 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_206), DUP(op_AND_206))), CAST(32, MSB(DUP(op_AND_206)), DUP(op_AND_206)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_206)), DUP(op_AND_206))), CAST(32, MSB(DUP(op_AND_206)), DUP(op_AND_206))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_206)), DUP(op_AND_206))), CAST(32, MSB(DUP(op_AND_206)), DUP(op_AND_206)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_206)), DUP(op_AND_206))), CAST(32, MSB(DUP(op_AND_206)), DUP(op_AND_206))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_220), DUP(op_AND_220))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_229 = SHIFTL0(op_MUL_227, SN(32, 1));
	RzILOpPure *op_ADD_232 = ADD(op_LSHIFT_229, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_234 = SHIFTRA(op_ADD_232, SN(32, 16));
	RzILOpPure *op_RSHIFT_243 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_245 = LOGAND(op_RSHIFT_243, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_256 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_259 = LOGAND(op_RSHIFT_256, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_266 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_245), DUP(op_AND_245))), CAST(32, MSB(DUP(op_AND_245)), DUP(op_AND_245)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_245)), DUP(op_AND_245))), CAST(32, MSB(DUP(op_AND_245)), DUP(op_AND_245))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_245)), DUP(op_AND_245))), CAST(32, MSB(DUP(op_AND_245)), DUP(op_AND_245)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_245)), DUP(op_AND_245))), CAST(32, MSB(DUP(op_AND_245)), DUP(op_AND_245))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_259), DUP(op_AND_259))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_268 = SHIFTL0(op_MUL_266, SN(32, 1));
	RzILOpPure *op_ADD_271 = ADD(op_LSHIFT_268, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_273 = SHIFTRA(op_ADD_271, SN(32, 16));
	RzILOpPure *op_EQ_274 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_234), SN(32, 0), SN(32, 0x20)), op_RSHIFT_273);
	RzILOpPure *op_RSHIFT_315 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_317 = LOGAND(op_RSHIFT_315, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_328 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_331 = LOGAND(op_RSHIFT_328, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_338 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_317), DUP(op_AND_317))), CAST(32, MSB(DUP(op_AND_317)), DUP(op_AND_317)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_317)), DUP(op_AND_317))), CAST(32, MSB(DUP(op_AND_317)), DUP(op_AND_317))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_317)), DUP(op_AND_317))), CAST(32, MSB(DUP(op_AND_317)), DUP(op_AND_317)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_317)), DUP(op_AND_317))), CAST(32, MSB(DUP(op_AND_317)), DUP(op_AND_317))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_331), DUP(op_AND_331))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_340 = SHIFTL0(op_MUL_338, SN(32, 1));
	RzILOpPure *op_ADD_343 = ADD(op_LSHIFT_340, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_345 = SHIFTRA(op_ADD_343, SN(32, 16));
	RzILOpPure *op_LT_348 = SLT(op_RSHIFT_345, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_353 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_354 = NEG(op_LSHIFT_353);
	RzILOpPure *op_LSHIFT_359 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_362 = SUB(op_LSHIFT_359, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_363 = ITE(op_LT_348, op_NEG_354, op_SUB_362);
	RzILOpEffect *gcc_expr_364 = BRANCH(op_EQ_274, EMPTY(), set_usr_field_call_311);

	// h_tmp303 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_366 = SETL("h_tmp303", cond_363);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st6 ...;
	RzILOpEffect *seq_367 = SEQN(2, gcc_expr_364, op_ASSIGN_hybrid_tmp_366);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)) ? ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) : h_tmp303) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_195 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_196 = LOGNOT(op_LSHIFT_195);
	RzILOpPure *op_AND_197 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_196);
	RzILOpPure *op_RSHIFT_278 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_280 = LOGAND(op_RSHIFT_278, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_291 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_294 = LOGAND(op_RSHIFT_291, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_301 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_280), DUP(op_AND_280))), CAST(32, MSB(DUP(op_AND_280)), DUP(op_AND_280)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_280)), DUP(op_AND_280))), CAST(32, MSB(DUP(op_AND_280)), DUP(op_AND_280))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_280)), DUP(op_AND_280))), CAST(32, MSB(DUP(op_AND_280)), DUP(op_AND_280)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_280)), DUP(op_AND_280))), CAST(32, MSB(DUP(op_AND_280)), DUP(op_AND_280))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_294), DUP(op_AND_294))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_303 = SHIFTL0(op_MUL_301, SN(32, 1));
	RzILOpPure *op_ADD_306 = ADD(op_LSHIFT_303, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_308 = SHIFTRA(op_ADD_306, SN(32, 16));
	RzILOpPure *cond_368 = ITE(DUP(op_EQ_274), op_RSHIFT_308, VARL("h_tmp303"));
	RzILOpPure *op_AND_370 = LOGAND(cond_368, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_374 = SHIFTL0(op_AND_370, SN(32, 0));
	RzILOpPure *op_OR_375 = LOGOR(op_AND_197, op_LSHIFT_374);
	RzILOpEffect *op_ASSIGN_376 = WRITE_REG(bundle, Rdd_op, op_OR_375);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ( ...;
	RzILOpEffect *seq_377 = SEQN(2, seq_367, op_ASSIGN_376);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_189, seq_377);
	return instruction_sequence;
}

// Rdd = vmpywoh(Rss,Rtt):sat
RzILOpEffect *hex_il_op_m2_mmpyh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_114 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_17 = LOGAND(op_RSHIFT_15, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_29 = SHIFTRA(Rtt, SN(32, 0x30));
	RzILOpPure *op_AND_32 = LOGAND(op_RSHIFT_29, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_39 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_17), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_32), DUP(op_AND_32))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_41 = SHIFTL0(op_MUL_39, SN(32, 0));
	RzILOpPure *op_RSHIFT_43 = SHIFTRA(op_LSHIFT_41, SN(32, 16));
	RzILOpPure *op_RSHIFT_52 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_54 = LOGAND(op_RSHIFT_52, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_65 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_68 = LOGAND(op_RSHIFT_65, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_75 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_54), DUP(op_AND_54))), CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54))), CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54))), CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54))), CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_68), DUP(op_AND_68))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_77 = SHIFTL0(op_MUL_75, SN(32, 0));
	RzILOpPure *op_RSHIFT_79 = SHIFTRA(op_LSHIFT_77, SN(32, 16));
	RzILOpPure *op_EQ_80 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_43), SN(32, 0), SN(32, 0x20)), op_RSHIFT_79);
	RzILOpPure *op_RSHIFT_118 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_120 = LOGAND(op_RSHIFT_118, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_131 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_134 = LOGAND(op_RSHIFT_131, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_141 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_120), DUP(op_AND_120))), CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120))), CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120))), CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120))), CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_134), DUP(op_AND_134))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_143 = SHIFTL0(op_MUL_141, SN(32, 0));
	RzILOpPure *op_RSHIFT_145 = SHIFTRA(op_LSHIFT_143, SN(32, 16));
	RzILOpPure *op_LT_148 = SLT(op_RSHIFT_145, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_153 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_154 = NEG(op_LSHIFT_153);
	RzILOpPure *op_LSHIFT_159 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_162 = SUB(op_LSHIFT_159, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_163 = ITE(op_LT_148, op_NEG_154, op_SUB_162);
	RzILOpEffect *gcc_expr_164 = BRANCH(op_EQ_80, EMPTY(), set_usr_field_call_114);

	// h_tmp304 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_166 = SETL("h_tmp304", cond_163);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st6 ...;
	RzILOpEffect *seq_167 = SEQN(2, gcc_expr_164, op_ASSIGN_hybrid_tmp_166);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)) ? ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10) : h_tmp304) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_84 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_86 = LOGAND(op_RSHIFT_84, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_97 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_100 = LOGAND(op_RSHIFT_97, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_107 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_86), DUP(op_AND_86))), CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86))), CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86))), CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86))), CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_100), DUP(op_AND_100))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_109 = SHIFTL0(op_MUL_107, SN(32, 0));
	RzILOpPure *op_RSHIFT_111 = SHIFTRA(op_LSHIFT_109, SN(32, 16));
	RzILOpPure *cond_168 = ITE(DUP(op_EQ_80), op_RSHIFT_111, VARL("h_tmp304"));
	RzILOpPure *op_AND_170 = LOGAND(cond_168, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_174 = SHIFTL0(op_AND_170, SN(32, 0x20));
	RzILOpPure *op_OR_175 = LOGOR(op_AND_7, op_LSHIFT_174);
	RzILOpEffect *op_ASSIGN_176 = WRITE_REG(bundle, Rdd_op, op_OR_175);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ( ...;
	RzILOpEffect *seq_177 = SEQN(2, seq_167, op_ASSIGN_176);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_290 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_192 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_194 = LOGAND(op_RSHIFT_192, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_205 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_208 = LOGAND(op_RSHIFT_205, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_215 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_194), DUP(op_AND_194))), CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194))), CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194))), CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194))), CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_208), DUP(op_AND_208))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_217 = SHIFTL0(op_MUL_215, SN(32, 0));
	RzILOpPure *op_RSHIFT_219 = SHIFTRA(op_LSHIFT_217, SN(32, 16));
	RzILOpPure *op_RSHIFT_228 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_230 = LOGAND(op_RSHIFT_228, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_241 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_244 = LOGAND(op_RSHIFT_241, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_251 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_230), DUP(op_AND_230))), CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230))), CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230))), CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230))), CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_244), DUP(op_AND_244))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_253 = SHIFTL0(op_MUL_251, SN(32, 0));
	RzILOpPure *op_RSHIFT_255 = SHIFTRA(op_LSHIFT_253, SN(32, 16));
	RzILOpPure *op_EQ_256 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_219), SN(32, 0), SN(32, 0x20)), op_RSHIFT_255);
	RzILOpPure *op_RSHIFT_294 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_296 = LOGAND(op_RSHIFT_294, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_307 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_310 = LOGAND(op_RSHIFT_307, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_317 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_296), DUP(op_AND_296))), CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296))), CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296))), CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296))), CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_310), DUP(op_AND_310))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_319 = SHIFTL0(op_MUL_317, SN(32, 0));
	RzILOpPure *op_RSHIFT_321 = SHIFTRA(op_LSHIFT_319, SN(32, 16));
	RzILOpPure *op_LT_324 = SLT(op_RSHIFT_321, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_329 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_330 = NEG(op_LSHIFT_329);
	RzILOpPure *op_LSHIFT_335 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_338 = SUB(op_LSHIFT_335, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_339 = ITE(op_LT_324, op_NEG_330, op_SUB_338);
	RzILOpEffect *gcc_expr_340 = BRANCH(op_EQ_256, EMPTY(), set_usr_field_call_290);

	// h_tmp305 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_342 = SETL("h_tmp305", cond_339);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st6 ...;
	RzILOpEffect *seq_343 = SEQN(2, gcc_expr_340, op_ASSIGN_hybrid_tmp_342);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)) ? ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10) : h_tmp305) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_183 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_184 = LOGNOT(op_LSHIFT_183);
	RzILOpPure *op_AND_185 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_184);
	RzILOpPure *op_RSHIFT_260 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_262 = LOGAND(op_RSHIFT_260, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_273 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_276 = LOGAND(op_RSHIFT_273, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_283 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_262), DUP(op_AND_262))), CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262))), CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262))), CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262))), CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_276), DUP(op_AND_276))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_285 = SHIFTL0(op_MUL_283, SN(32, 0));
	RzILOpPure *op_RSHIFT_287 = SHIFTRA(op_LSHIFT_285, SN(32, 16));
	RzILOpPure *cond_344 = ITE(DUP(op_EQ_256), op_RSHIFT_287, VARL("h_tmp305"));
	RzILOpPure *op_AND_346 = LOGAND(cond_344, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_350 = SHIFTL0(op_AND_346, SN(32, 0));
	RzILOpPure *op_OR_351 = LOGOR(op_AND_185, op_LSHIFT_350);
	RzILOpEffect *op_ASSIGN_352 = WRITE_REG(bundle, Rdd_op, op_OR_351);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ( ...;
	RzILOpEffect *seq_353 = SEQN(2, seq_343, op_ASSIGN_352);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_177, seq_353);
	return instruction_sequence;
}

// Rdd = vmpywoh(Rss,Rtt):<<1:sat
RzILOpEffect *hex_il_op_m2_mmpyh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_114 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_17 = LOGAND(op_RSHIFT_15, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_29 = SHIFTRA(Rtt, SN(32, 0x30));
	RzILOpPure *op_AND_32 = LOGAND(op_RSHIFT_29, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_39 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_17), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_32), DUP(op_AND_32))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_41 = SHIFTL0(op_MUL_39, SN(32, 1));
	RzILOpPure *op_RSHIFT_43 = SHIFTRA(op_LSHIFT_41, SN(32, 16));
	RzILOpPure *op_RSHIFT_52 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_54 = LOGAND(op_RSHIFT_52, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_65 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_68 = LOGAND(op_RSHIFT_65, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_75 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_54), DUP(op_AND_54))), CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54))), CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54))), CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54))), CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_68), DUP(op_AND_68))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_77 = SHIFTL0(op_MUL_75, SN(32, 1));
	RzILOpPure *op_RSHIFT_79 = SHIFTRA(op_LSHIFT_77, SN(32, 16));
	RzILOpPure *op_EQ_80 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_43), SN(32, 0), SN(32, 0x20)), op_RSHIFT_79);
	RzILOpPure *op_RSHIFT_118 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_120 = LOGAND(op_RSHIFT_118, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_131 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_134 = LOGAND(op_RSHIFT_131, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_141 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_120), DUP(op_AND_120))), CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120))), CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120))), CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120))), CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_134), DUP(op_AND_134))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_143 = SHIFTL0(op_MUL_141, SN(32, 1));
	RzILOpPure *op_RSHIFT_145 = SHIFTRA(op_LSHIFT_143, SN(32, 16));
	RzILOpPure *op_LT_148 = SLT(op_RSHIFT_145, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_153 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_154 = NEG(op_LSHIFT_153);
	RzILOpPure *op_LSHIFT_159 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_162 = SUB(op_LSHIFT_159, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_163 = ITE(op_LT_148, op_NEG_154, op_SUB_162);
	RzILOpEffect *gcc_expr_164 = BRANCH(op_EQ_80, EMPTY(), set_usr_field_call_114);

	// h_tmp306 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_166 = SETL("h_tmp306", cond_163);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st6 ...;
	RzILOpEffect *seq_167 = SEQN(2, gcc_expr_164, op_ASSIGN_hybrid_tmp_166);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)) ? ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10) : h_tmp306) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_84 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_86 = LOGAND(op_RSHIFT_84, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_97 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_100 = LOGAND(op_RSHIFT_97, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_107 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_86), DUP(op_AND_86))), CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86))), CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86))), CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86))), CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_100), DUP(op_AND_100))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_109 = SHIFTL0(op_MUL_107, SN(32, 1));
	RzILOpPure *op_RSHIFT_111 = SHIFTRA(op_LSHIFT_109, SN(32, 16));
	RzILOpPure *cond_168 = ITE(DUP(op_EQ_80), op_RSHIFT_111, VARL("h_tmp306"));
	RzILOpPure *op_AND_170 = LOGAND(cond_168, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_174 = SHIFTL0(op_AND_170, SN(32, 0x20));
	RzILOpPure *op_OR_175 = LOGOR(op_AND_7, op_LSHIFT_174);
	RzILOpEffect *op_ASSIGN_176 = WRITE_REG(bundle, Rdd_op, op_OR_175);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ( ...;
	RzILOpEffect *seq_177 = SEQN(2, seq_167, op_ASSIGN_176);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_290 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_192 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_194 = LOGAND(op_RSHIFT_192, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_205 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_208 = LOGAND(op_RSHIFT_205, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_215 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_194), DUP(op_AND_194))), CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194))), CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194))), CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194))), CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_208), DUP(op_AND_208))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_217 = SHIFTL0(op_MUL_215, SN(32, 1));
	RzILOpPure *op_RSHIFT_219 = SHIFTRA(op_LSHIFT_217, SN(32, 16));
	RzILOpPure *op_RSHIFT_228 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_230 = LOGAND(op_RSHIFT_228, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_241 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_244 = LOGAND(op_RSHIFT_241, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_251 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_230), DUP(op_AND_230))), CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230))), CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230))), CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230))), CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_244), DUP(op_AND_244))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_253 = SHIFTL0(op_MUL_251, SN(32, 1));
	RzILOpPure *op_RSHIFT_255 = SHIFTRA(op_LSHIFT_253, SN(32, 16));
	RzILOpPure *op_EQ_256 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_219), SN(32, 0), SN(32, 0x20)), op_RSHIFT_255);
	RzILOpPure *op_RSHIFT_294 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_296 = LOGAND(op_RSHIFT_294, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_307 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_310 = LOGAND(op_RSHIFT_307, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_317 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_296), DUP(op_AND_296))), CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296))), CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296))), CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296))), CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_310), DUP(op_AND_310))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_319 = SHIFTL0(op_MUL_317, SN(32, 1));
	RzILOpPure *op_RSHIFT_321 = SHIFTRA(op_LSHIFT_319, SN(32, 16));
	RzILOpPure *op_LT_324 = SLT(op_RSHIFT_321, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_329 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_330 = NEG(op_LSHIFT_329);
	RzILOpPure *op_LSHIFT_335 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_338 = SUB(op_LSHIFT_335, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_339 = ITE(op_LT_324, op_NEG_330, op_SUB_338);
	RzILOpEffect *gcc_expr_340 = BRANCH(op_EQ_256, EMPTY(), set_usr_field_call_290);

	// h_tmp307 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_342 = SETL("h_tmp307", cond_339);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st6 ...;
	RzILOpEffect *seq_343 = SEQN(2, gcc_expr_340, op_ASSIGN_hybrid_tmp_342);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)) ? ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10) : h_tmp307) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_183 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_184 = LOGNOT(op_LSHIFT_183);
	RzILOpPure *op_AND_185 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_184);
	RzILOpPure *op_RSHIFT_260 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_262 = LOGAND(op_RSHIFT_260, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_273 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_276 = LOGAND(op_RSHIFT_273, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_283 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_262), DUP(op_AND_262))), CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262))), CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262))), CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262))), CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_276), DUP(op_AND_276))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_285 = SHIFTL0(op_MUL_283, SN(32, 1));
	RzILOpPure *op_RSHIFT_287 = SHIFTRA(op_LSHIFT_285, SN(32, 16));
	RzILOpPure *cond_344 = ITE(DUP(op_EQ_256), op_RSHIFT_287, VARL("h_tmp307"));
	RzILOpPure *op_AND_346 = LOGAND(cond_344, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_350 = SHIFTL0(op_AND_346, SN(32, 0));
	RzILOpPure *op_OR_351 = LOGOR(op_AND_185, op_LSHIFT_350);
	RzILOpEffect *op_ASSIGN_352 = WRITE_REG(bundle, Rdd_op, op_OR_351);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ( ...;
	RzILOpEffect *seq_353 = SEQN(2, seq_343, op_ASSIGN_352);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_177, seq_353);
	return instruction_sequence;
}

// Rdd = vmpyweh(Rss,Rtt):rnd:sat
RzILOpEffect *hex_il_op_m2_mmpyl_rs0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_123 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_17 = LOGAND(op_RSHIFT_15, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_29 = SHIFTRA(Rtt, SN(32, 0x20));
	RzILOpPure *op_AND_32 = LOGAND(op_RSHIFT_29, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_39 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_17), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_32), DUP(op_AND_32))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_41 = SHIFTL0(op_MUL_39, SN(32, 0));
	RzILOpPure *op_ADD_44 = ADD(op_LSHIFT_41, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_46 = SHIFTRA(op_ADD_44, SN(32, 16));
	RzILOpPure *op_RSHIFT_55 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_57 = LOGAND(op_RSHIFT_55, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_68 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_71 = LOGAND(op_RSHIFT_68, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_78 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_57), DUP(op_AND_57))), CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57))), CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57))), CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57))), CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_71), DUP(op_AND_71))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_80 = SHIFTL0(op_MUL_78, SN(32, 0));
	RzILOpPure *op_ADD_83 = ADD(op_LSHIFT_80, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_85 = SHIFTRA(op_ADD_83, SN(32, 16));
	RzILOpPure *op_EQ_86 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_46), SN(32, 0), SN(32, 0x20)), op_RSHIFT_85);
	RzILOpPure *op_RSHIFT_127 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_129 = LOGAND(op_RSHIFT_127, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_140 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_143 = LOGAND(op_RSHIFT_140, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_150 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_129), DUP(op_AND_129))), CAST(32, MSB(DUP(op_AND_129)), DUP(op_AND_129)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_129)), DUP(op_AND_129))), CAST(32, MSB(DUP(op_AND_129)), DUP(op_AND_129))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_129)), DUP(op_AND_129))), CAST(32, MSB(DUP(op_AND_129)), DUP(op_AND_129)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_129)), DUP(op_AND_129))), CAST(32, MSB(DUP(op_AND_129)), DUP(op_AND_129))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_143), DUP(op_AND_143))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_152 = SHIFTL0(op_MUL_150, SN(32, 0));
	RzILOpPure *op_ADD_155 = ADD(op_LSHIFT_152, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_157 = SHIFTRA(op_ADD_155, SN(32, 16));
	RzILOpPure *op_LT_160 = SLT(op_RSHIFT_157, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_165 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_166 = NEG(op_LSHIFT_165);
	RzILOpPure *op_LSHIFT_171 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_174 = SUB(op_LSHIFT_171, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_175 = ITE(op_LT_160, op_NEG_166, op_SUB_174);
	RzILOpEffect *gcc_expr_176 = BRANCH(op_EQ_86, EMPTY(), set_usr_field_call_123);

	// h_tmp308 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_178 = SETL("h_tmp308", cond_175);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st6 ...;
	RzILOpEffect *seq_179 = SEQN(2, gcc_expr_176, op_ASSIGN_hybrid_tmp_178);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)) ? ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10) : h_tmp308) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_90 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_92 = LOGAND(op_RSHIFT_90, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_103 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_106 = LOGAND(op_RSHIFT_103, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_113 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_92), DUP(op_AND_92))), CAST(32, MSB(DUP(op_AND_92)), DUP(op_AND_92)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_92)), DUP(op_AND_92))), CAST(32, MSB(DUP(op_AND_92)), DUP(op_AND_92))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_92)), DUP(op_AND_92))), CAST(32, MSB(DUP(op_AND_92)), DUP(op_AND_92)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_92)), DUP(op_AND_92))), CAST(32, MSB(DUP(op_AND_92)), DUP(op_AND_92))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_106), DUP(op_AND_106))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_115 = SHIFTL0(op_MUL_113, SN(32, 0));
	RzILOpPure *op_ADD_118 = ADD(op_LSHIFT_115, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_120 = SHIFTRA(op_ADD_118, SN(32, 16));
	RzILOpPure *cond_180 = ITE(DUP(op_EQ_86), op_RSHIFT_120, VARL("h_tmp308"));
	RzILOpPure *op_AND_182 = LOGAND(cond_180, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_186 = SHIFTL0(op_AND_182, SN(32, 0x20));
	RzILOpPure *op_OR_187 = LOGOR(op_AND_7, op_LSHIFT_186);
	RzILOpEffect *op_ASSIGN_188 = WRITE_REG(bundle, Rdd_op, op_OR_187);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ( ...;
	RzILOpEffect *seq_189 = SEQN(2, seq_179, op_ASSIGN_188);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_311 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_204 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_206 = LOGAND(op_RSHIFT_204, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_217 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_220 = LOGAND(op_RSHIFT_217, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_227 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_206), DUP(op_AND_206))), CAST(32, MSB(DUP(op_AND_206)), DUP(op_AND_206)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_206)), DUP(op_AND_206))), CAST(32, MSB(DUP(op_AND_206)), DUP(op_AND_206))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_206)), DUP(op_AND_206))), CAST(32, MSB(DUP(op_AND_206)), DUP(op_AND_206)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_206)), DUP(op_AND_206))), CAST(32, MSB(DUP(op_AND_206)), DUP(op_AND_206))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_220), DUP(op_AND_220))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_229 = SHIFTL0(op_MUL_227, SN(32, 0));
	RzILOpPure *op_ADD_232 = ADD(op_LSHIFT_229, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_234 = SHIFTRA(op_ADD_232, SN(32, 16));
	RzILOpPure *op_RSHIFT_243 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_245 = LOGAND(op_RSHIFT_243, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_256 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_259 = LOGAND(op_RSHIFT_256, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_266 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_245), DUP(op_AND_245))), CAST(32, MSB(DUP(op_AND_245)), DUP(op_AND_245)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_245)), DUP(op_AND_245))), CAST(32, MSB(DUP(op_AND_245)), DUP(op_AND_245))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_245)), DUP(op_AND_245))), CAST(32, MSB(DUP(op_AND_245)), DUP(op_AND_245)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_245)), DUP(op_AND_245))), CAST(32, MSB(DUP(op_AND_245)), DUP(op_AND_245))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_259), DUP(op_AND_259))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_268 = SHIFTL0(op_MUL_266, SN(32, 0));
	RzILOpPure *op_ADD_271 = ADD(op_LSHIFT_268, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_273 = SHIFTRA(op_ADD_271, SN(32, 16));
	RzILOpPure *op_EQ_274 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_234), SN(32, 0), SN(32, 0x20)), op_RSHIFT_273);
	RzILOpPure *op_RSHIFT_315 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_317 = LOGAND(op_RSHIFT_315, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_328 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_331 = LOGAND(op_RSHIFT_328, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_338 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_317), DUP(op_AND_317))), CAST(32, MSB(DUP(op_AND_317)), DUP(op_AND_317)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_317)), DUP(op_AND_317))), CAST(32, MSB(DUP(op_AND_317)), DUP(op_AND_317))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_317)), DUP(op_AND_317))), CAST(32, MSB(DUP(op_AND_317)), DUP(op_AND_317)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_317)), DUP(op_AND_317))), CAST(32, MSB(DUP(op_AND_317)), DUP(op_AND_317))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_331), DUP(op_AND_331))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_340 = SHIFTL0(op_MUL_338, SN(32, 0));
	RzILOpPure *op_ADD_343 = ADD(op_LSHIFT_340, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_345 = SHIFTRA(op_ADD_343, SN(32, 16));
	RzILOpPure *op_LT_348 = SLT(op_RSHIFT_345, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_353 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_354 = NEG(op_LSHIFT_353);
	RzILOpPure *op_LSHIFT_359 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_362 = SUB(op_LSHIFT_359, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_363 = ITE(op_LT_348, op_NEG_354, op_SUB_362);
	RzILOpEffect *gcc_expr_364 = BRANCH(op_EQ_274, EMPTY(), set_usr_field_call_311);

	// h_tmp309 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_366 = SETL("h_tmp309", cond_363);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st6 ...;
	RzILOpEffect *seq_367 = SEQN(2, gcc_expr_364, op_ASSIGN_hybrid_tmp_366);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10)) ? ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) + ((st64) 0x8000) >> 0x10) : h_tmp309) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_195 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_196 = LOGNOT(op_LSHIFT_195);
	RzILOpPure *op_AND_197 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_196);
	RzILOpPure *op_RSHIFT_278 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_280 = LOGAND(op_RSHIFT_278, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_291 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_294 = LOGAND(op_RSHIFT_291, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_301 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_280), DUP(op_AND_280))), CAST(32, MSB(DUP(op_AND_280)), DUP(op_AND_280)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_280)), DUP(op_AND_280))), CAST(32, MSB(DUP(op_AND_280)), DUP(op_AND_280))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_280)), DUP(op_AND_280))), CAST(32, MSB(DUP(op_AND_280)), DUP(op_AND_280)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_280)), DUP(op_AND_280))), CAST(32, MSB(DUP(op_AND_280)), DUP(op_AND_280))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_294), DUP(op_AND_294))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_303 = SHIFTL0(op_MUL_301, SN(32, 0));
	RzILOpPure *op_ADD_306 = ADD(op_LSHIFT_303, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_308 = SHIFTRA(op_ADD_306, SN(32, 16));
	RzILOpPure *cond_368 = ITE(DUP(op_EQ_274), op_RSHIFT_308, VARL("h_tmp309"));
	RzILOpPure *op_AND_370 = LOGAND(cond_368, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_374 = SHIFTL0(op_AND_370, SN(32, 0));
	RzILOpPure *op_OR_375 = LOGOR(op_AND_197, op_LSHIFT_374);
	RzILOpEffect *op_ASSIGN_376 = WRITE_REG(bundle, Rdd_op, op_OR_375);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ( ...;
	RzILOpEffect *seq_377 = SEQN(2, seq_367, op_ASSIGN_376);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_189, seq_377);
	return instruction_sequence;
}

// Rdd = vmpyweh(Rss,Rtt):<<1:rnd:sat
RzILOpEffect *hex_il_op_m2_mmpyl_rs1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_123 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_17 = LOGAND(op_RSHIFT_15, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_29 = SHIFTRA(Rtt, SN(32, 0x20));
	RzILOpPure *op_AND_32 = LOGAND(op_RSHIFT_29, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_39 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_17), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_32), DUP(op_AND_32))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_41 = SHIFTL0(op_MUL_39, SN(32, 1));
	RzILOpPure *op_ADD_44 = ADD(op_LSHIFT_41, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_46 = SHIFTRA(op_ADD_44, SN(32, 16));
	RzILOpPure *op_RSHIFT_55 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_57 = LOGAND(op_RSHIFT_55, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_68 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_71 = LOGAND(op_RSHIFT_68, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_78 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_57), DUP(op_AND_57))), CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57))), CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57))), CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57))), CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_71), DUP(op_AND_71))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_80 = SHIFTL0(op_MUL_78, SN(32, 1));
	RzILOpPure *op_ADD_83 = ADD(op_LSHIFT_80, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_85 = SHIFTRA(op_ADD_83, SN(32, 16));
	RzILOpPure *op_EQ_86 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_46), SN(32, 0), SN(32, 0x20)), op_RSHIFT_85);
	RzILOpPure *op_RSHIFT_127 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_129 = LOGAND(op_RSHIFT_127, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_140 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_143 = LOGAND(op_RSHIFT_140, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_150 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_129), DUP(op_AND_129))), CAST(32, MSB(DUP(op_AND_129)), DUP(op_AND_129)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_129)), DUP(op_AND_129))), CAST(32, MSB(DUP(op_AND_129)), DUP(op_AND_129))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_129)), DUP(op_AND_129))), CAST(32, MSB(DUP(op_AND_129)), DUP(op_AND_129)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_129)), DUP(op_AND_129))), CAST(32, MSB(DUP(op_AND_129)), DUP(op_AND_129))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_143), DUP(op_AND_143))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_152 = SHIFTL0(op_MUL_150, SN(32, 1));
	RzILOpPure *op_ADD_155 = ADD(op_LSHIFT_152, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_157 = SHIFTRA(op_ADD_155, SN(32, 16));
	RzILOpPure *op_LT_160 = SLT(op_RSHIFT_157, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_165 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_166 = NEG(op_LSHIFT_165);
	RzILOpPure *op_LSHIFT_171 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_174 = SUB(op_LSHIFT_171, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_175 = ITE(op_LT_160, op_NEG_166, op_SUB_174);
	RzILOpEffect *gcc_expr_176 = BRANCH(op_EQ_86, EMPTY(), set_usr_field_call_123);

	// h_tmp310 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_178 = SETL("h_tmp310", cond_175);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st6 ...;
	RzILOpEffect *seq_179 = SEQN(2, gcc_expr_176, op_ASSIGN_hybrid_tmp_178);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)) ? ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) : h_tmp310) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_90 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_92 = LOGAND(op_RSHIFT_90, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_103 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_106 = LOGAND(op_RSHIFT_103, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_113 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_92), DUP(op_AND_92))), CAST(32, MSB(DUP(op_AND_92)), DUP(op_AND_92)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_92)), DUP(op_AND_92))), CAST(32, MSB(DUP(op_AND_92)), DUP(op_AND_92))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_92)), DUP(op_AND_92))), CAST(32, MSB(DUP(op_AND_92)), DUP(op_AND_92)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_92)), DUP(op_AND_92))), CAST(32, MSB(DUP(op_AND_92)), DUP(op_AND_92))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_106), DUP(op_AND_106))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_115 = SHIFTL0(op_MUL_113, SN(32, 1));
	RzILOpPure *op_ADD_118 = ADD(op_LSHIFT_115, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_120 = SHIFTRA(op_ADD_118, SN(32, 16));
	RzILOpPure *cond_180 = ITE(DUP(op_EQ_86), op_RSHIFT_120, VARL("h_tmp310"));
	RzILOpPure *op_AND_182 = LOGAND(cond_180, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_186 = SHIFTL0(op_AND_182, SN(32, 0x20));
	RzILOpPure *op_OR_187 = LOGOR(op_AND_7, op_LSHIFT_186);
	RzILOpEffect *op_ASSIGN_188 = WRITE_REG(bundle, Rdd_op, op_OR_187);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ( ...;
	RzILOpEffect *seq_189 = SEQN(2, seq_179, op_ASSIGN_188);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_311 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_204 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_206 = LOGAND(op_RSHIFT_204, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_217 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_220 = LOGAND(op_RSHIFT_217, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_227 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_206), DUP(op_AND_206))), CAST(32, MSB(DUP(op_AND_206)), DUP(op_AND_206)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_206)), DUP(op_AND_206))), CAST(32, MSB(DUP(op_AND_206)), DUP(op_AND_206))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_206)), DUP(op_AND_206))), CAST(32, MSB(DUP(op_AND_206)), DUP(op_AND_206)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_206)), DUP(op_AND_206))), CAST(32, MSB(DUP(op_AND_206)), DUP(op_AND_206))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_220), DUP(op_AND_220))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_229 = SHIFTL0(op_MUL_227, SN(32, 1));
	RzILOpPure *op_ADD_232 = ADD(op_LSHIFT_229, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_234 = SHIFTRA(op_ADD_232, SN(32, 16));
	RzILOpPure *op_RSHIFT_243 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_245 = LOGAND(op_RSHIFT_243, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_256 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_259 = LOGAND(op_RSHIFT_256, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_266 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_245), DUP(op_AND_245))), CAST(32, MSB(DUP(op_AND_245)), DUP(op_AND_245)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_245)), DUP(op_AND_245))), CAST(32, MSB(DUP(op_AND_245)), DUP(op_AND_245))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_245)), DUP(op_AND_245))), CAST(32, MSB(DUP(op_AND_245)), DUP(op_AND_245)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_245)), DUP(op_AND_245))), CAST(32, MSB(DUP(op_AND_245)), DUP(op_AND_245))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_259), DUP(op_AND_259))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_268 = SHIFTL0(op_MUL_266, SN(32, 1));
	RzILOpPure *op_ADD_271 = ADD(op_LSHIFT_268, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_273 = SHIFTRA(op_ADD_271, SN(32, 16));
	RzILOpPure *op_EQ_274 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_234), SN(32, 0), SN(32, 0x20)), op_RSHIFT_273);
	RzILOpPure *op_RSHIFT_315 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_317 = LOGAND(op_RSHIFT_315, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_328 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_331 = LOGAND(op_RSHIFT_328, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_338 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_317), DUP(op_AND_317))), CAST(32, MSB(DUP(op_AND_317)), DUP(op_AND_317)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_317)), DUP(op_AND_317))), CAST(32, MSB(DUP(op_AND_317)), DUP(op_AND_317))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_317)), DUP(op_AND_317))), CAST(32, MSB(DUP(op_AND_317)), DUP(op_AND_317)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_317)), DUP(op_AND_317))), CAST(32, MSB(DUP(op_AND_317)), DUP(op_AND_317))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_331), DUP(op_AND_331))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_340 = SHIFTL0(op_MUL_338, SN(32, 1));
	RzILOpPure *op_ADD_343 = ADD(op_LSHIFT_340, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_345 = SHIFTRA(op_ADD_343, SN(32, 16));
	RzILOpPure *op_LT_348 = SLT(op_RSHIFT_345, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_353 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_354 = NEG(op_LSHIFT_353);
	RzILOpPure *op_LSHIFT_359 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_362 = SUB(op_LSHIFT_359, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_363 = ITE(op_LT_348, op_NEG_354, op_SUB_362);
	RzILOpEffect *gcc_expr_364 = BRANCH(op_EQ_274, EMPTY(), set_usr_field_call_311);

	// h_tmp311 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_366 = SETL("h_tmp311", cond_363);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st6 ...;
	RzILOpEffect *seq_367 = SEQN(2, gcc_expr_364, op_ASSIGN_hybrid_tmp_366);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10)) ? ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) + ((st64) 0x8000) >> 0x10) : h_tmp311) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_195 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_196 = LOGNOT(op_LSHIFT_195);
	RzILOpPure *op_AND_197 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_196);
	RzILOpPure *op_RSHIFT_278 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_280 = LOGAND(op_RSHIFT_278, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_291 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_294 = LOGAND(op_RSHIFT_291, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_301 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_280), DUP(op_AND_280))), CAST(32, MSB(DUP(op_AND_280)), DUP(op_AND_280)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_280)), DUP(op_AND_280))), CAST(32, MSB(DUP(op_AND_280)), DUP(op_AND_280))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_280)), DUP(op_AND_280))), CAST(32, MSB(DUP(op_AND_280)), DUP(op_AND_280)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_280)), DUP(op_AND_280))), CAST(32, MSB(DUP(op_AND_280)), DUP(op_AND_280))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_294), DUP(op_AND_294))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_303 = SHIFTL0(op_MUL_301, SN(32, 1));
	RzILOpPure *op_ADD_306 = ADD(op_LSHIFT_303, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_308 = SHIFTRA(op_ADD_306, SN(32, 16));
	RzILOpPure *cond_368 = ITE(DUP(op_EQ_274), op_RSHIFT_308, VARL("h_tmp311"));
	RzILOpPure *op_AND_370 = LOGAND(cond_368, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_374 = SHIFTL0(op_AND_370, SN(32, 0));
	RzILOpPure *op_OR_375 = LOGOR(op_AND_197, op_LSHIFT_374);
	RzILOpEffect *op_ASSIGN_376 = WRITE_REG(bundle, Rdd_op, op_OR_375);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ( ...;
	RzILOpEffect *seq_377 = SEQN(2, seq_367, op_ASSIGN_376);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_189, seq_377);
	return instruction_sequence;
}

// Rdd = vmpyweh(Rss,Rtt):sat
RzILOpEffect *hex_il_op_m2_mmpyl_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_114 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_17 = LOGAND(op_RSHIFT_15, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_29 = SHIFTRA(Rtt, SN(32, 0x20));
	RzILOpPure *op_AND_32 = LOGAND(op_RSHIFT_29, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_39 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_17), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_32), DUP(op_AND_32))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_41 = SHIFTL0(op_MUL_39, SN(32, 0));
	RzILOpPure *op_RSHIFT_43 = SHIFTRA(op_LSHIFT_41, SN(32, 16));
	RzILOpPure *op_RSHIFT_52 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_54 = LOGAND(op_RSHIFT_52, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_65 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_68 = LOGAND(op_RSHIFT_65, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_75 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_54), DUP(op_AND_54))), CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54))), CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54))), CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54))), CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_68), DUP(op_AND_68))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_77 = SHIFTL0(op_MUL_75, SN(32, 0));
	RzILOpPure *op_RSHIFT_79 = SHIFTRA(op_LSHIFT_77, SN(32, 16));
	RzILOpPure *op_EQ_80 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_43), SN(32, 0), SN(32, 0x20)), op_RSHIFT_79);
	RzILOpPure *op_RSHIFT_118 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_120 = LOGAND(op_RSHIFT_118, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_131 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_134 = LOGAND(op_RSHIFT_131, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_141 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_120), DUP(op_AND_120))), CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120))), CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120))), CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120))), CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_134), DUP(op_AND_134))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_143 = SHIFTL0(op_MUL_141, SN(32, 0));
	RzILOpPure *op_RSHIFT_145 = SHIFTRA(op_LSHIFT_143, SN(32, 16));
	RzILOpPure *op_LT_148 = SLT(op_RSHIFT_145, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_153 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_154 = NEG(op_LSHIFT_153);
	RzILOpPure *op_LSHIFT_159 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_162 = SUB(op_LSHIFT_159, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_163 = ITE(op_LT_148, op_NEG_154, op_SUB_162);
	RzILOpEffect *gcc_expr_164 = BRANCH(op_EQ_80, EMPTY(), set_usr_field_call_114);

	// h_tmp312 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_166 = SETL("h_tmp312", cond_163);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st6 ...;
	RzILOpEffect *seq_167 = SEQN(2, gcc_expr_164, op_ASSIGN_hybrid_tmp_166);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)) ? ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10) : h_tmp312) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_84 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_86 = LOGAND(op_RSHIFT_84, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_97 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_100 = LOGAND(op_RSHIFT_97, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_107 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_86), DUP(op_AND_86))), CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86))), CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86))), CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86))), CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_100), DUP(op_AND_100))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_109 = SHIFTL0(op_MUL_107, SN(32, 0));
	RzILOpPure *op_RSHIFT_111 = SHIFTRA(op_LSHIFT_109, SN(32, 16));
	RzILOpPure *cond_168 = ITE(DUP(op_EQ_80), op_RSHIFT_111, VARL("h_tmp312"));
	RzILOpPure *op_AND_170 = LOGAND(cond_168, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_174 = SHIFTL0(op_AND_170, SN(32, 0x20));
	RzILOpPure *op_OR_175 = LOGOR(op_AND_7, op_LSHIFT_174);
	RzILOpEffect *op_ASSIGN_176 = WRITE_REG(bundle, Rdd_op, op_OR_175);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ( ...;
	RzILOpEffect *seq_177 = SEQN(2, seq_167, op_ASSIGN_176);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_290 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_192 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_194 = LOGAND(op_RSHIFT_192, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_205 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_208 = LOGAND(op_RSHIFT_205, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_215 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_194), DUP(op_AND_194))), CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194))), CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194))), CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194))), CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_208), DUP(op_AND_208))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_217 = SHIFTL0(op_MUL_215, SN(32, 0));
	RzILOpPure *op_RSHIFT_219 = SHIFTRA(op_LSHIFT_217, SN(32, 16));
	RzILOpPure *op_RSHIFT_228 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_230 = LOGAND(op_RSHIFT_228, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_241 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_244 = LOGAND(op_RSHIFT_241, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_251 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_230), DUP(op_AND_230))), CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230))), CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230))), CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230))), CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_244), DUP(op_AND_244))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_253 = SHIFTL0(op_MUL_251, SN(32, 0));
	RzILOpPure *op_RSHIFT_255 = SHIFTRA(op_LSHIFT_253, SN(32, 16));
	RzILOpPure *op_EQ_256 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_219), SN(32, 0), SN(32, 0x20)), op_RSHIFT_255);
	RzILOpPure *op_RSHIFT_294 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_296 = LOGAND(op_RSHIFT_294, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_307 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_310 = LOGAND(op_RSHIFT_307, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_317 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_296), DUP(op_AND_296))), CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296))), CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296))), CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296))), CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_310), DUP(op_AND_310))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_319 = SHIFTL0(op_MUL_317, SN(32, 0));
	RzILOpPure *op_RSHIFT_321 = SHIFTRA(op_LSHIFT_319, SN(32, 16));
	RzILOpPure *op_LT_324 = SLT(op_RSHIFT_321, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_329 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_330 = NEG(op_LSHIFT_329);
	RzILOpPure *op_LSHIFT_335 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_338 = SUB(op_LSHIFT_335, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_339 = ITE(op_LT_324, op_NEG_330, op_SUB_338);
	RzILOpEffect *gcc_expr_340 = BRANCH(op_EQ_256, EMPTY(), set_usr_field_call_290);

	// h_tmp313 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_342 = SETL("h_tmp313", cond_339);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st6 ...;
	RzILOpEffect *seq_343 = SEQN(2, gcc_expr_340, op_ASSIGN_hybrid_tmp_342);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10)) ? ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x0) >> 0x10) : h_tmp313) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_183 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_184 = LOGNOT(op_LSHIFT_183);
	RzILOpPure *op_AND_185 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_184);
	RzILOpPure *op_RSHIFT_260 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_262 = LOGAND(op_RSHIFT_260, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_273 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_276 = LOGAND(op_RSHIFT_273, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_283 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_262), DUP(op_AND_262))), CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262))), CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262))), CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262))), CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_276), DUP(op_AND_276))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_285 = SHIFTL0(op_MUL_283, SN(32, 0));
	RzILOpPure *op_RSHIFT_287 = SHIFTRA(op_LSHIFT_285, SN(32, 16));
	RzILOpPure *cond_344 = ITE(DUP(op_EQ_256), op_RSHIFT_287, VARL("h_tmp313"));
	RzILOpPure *op_AND_346 = LOGAND(cond_344, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_350 = SHIFTL0(op_AND_346, SN(32, 0));
	RzILOpPure *op_OR_351 = LOGOR(op_AND_185, op_LSHIFT_350);
	RzILOpEffect *op_ASSIGN_352 = WRITE_REG(bundle, Rdd_op, op_OR_351);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ( ...;
	RzILOpEffect *seq_353 = SEQN(2, seq_343, op_ASSIGN_352);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_177, seq_353);
	return instruction_sequence;
}

// Rdd = vmpyweh(Rss,Rtt):<<1:sat
RzILOpEffect *hex_il_op_m2_mmpyl_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_114 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_17 = LOGAND(op_RSHIFT_15, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_29 = SHIFTRA(Rtt, SN(32, 0x20));
	RzILOpPure *op_AND_32 = LOGAND(op_RSHIFT_29, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_39 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_17), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_32), DUP(op_AND_32))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_41 = SHIFTL0(op_MUL_39, SN(32, 1));
	RzILOpPure *op_RSHIFT_43 = SHIFTRA(op_LSHIFT_41, SN(32, 16));
	RzILOpPure *op_RSHIFT_52 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_54 = LOGAND(op_RSHIFT_52, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_65 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_68 = LOGAND(op_RSHIFT_65, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_75 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_54), DUP(op_AND_54))), CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54))), CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54))), CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54))), CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_68), DUP(op_AND_68))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_77 = SHIFTL0(op_MUL_75, SN(32, 1));
	RzILOpPure *op_RSHIFT_79 = SHIFTRA(op_LSHIFT_77, SN(32, 16));
	RzILOpPure *op_EQ_80 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_43), SN(32, 0), SN(32, 0x20)), op_RSHIFT_79);
	RzILOpPure *op_RSHIFT_118 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_120 = LOGAND(op_RSHIFT_118, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_131 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_134 = LOGAND(op_RSHIFT_131, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_141 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_120), DUP(op_AND_120))), CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120))), CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120))), CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120))), CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_134), DUP(op_AND_134))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_143 = SHIFTL0(op_MUL_141, SN(32, 1));
	RzILOpPure *op_RSHIFT_145 = SHIFTRA(op_LSHIFT_143, SN(32, 16));
	RzILOpPure *op_LT_148 = SLT(op_RSHIFT_145, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_153 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_154 = NEG(op_LSHIFT_153);
	RzILOpPure *op_LSHIFT_159 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_162 = SUB(op_LSHIFT_159, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_163 = ITE(op_LT_148, op_NEG_154, op_SUB_162);
	RzILOpEffect *gcc_expr_164 = BRANCH(op_EQ_80, EMPTY(), set_usr_field_call_114);

	// h_tmp314 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_166 = SETL("h_tmp314", cond_163);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st6 ...;
	RzILOpEffect *seq_167 = SEQN(2, gcc_expr_164, op_ASSIGN_hybrid_tmp_166);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)) ? ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10) : h_tmp314) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_84 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_86 = LOGAND(op_RSHIFT_84, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_97 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_100 = LOGAND(op_RSHIFT_97, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_107 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_86), DUP(op_AND_86))), CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86))), CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86))), CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86))), CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_100), DUP(op_AND_100))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_109 = SHIFTL0(op_MUL_107, SN(32, 1));
	RzILOpPure *op_RSHIFT_111 = SHIFTRA(op_LSHIFT_109, SN(32, 16));
	RzILOpPure *cond_168 = ITE(DUP(op_EQ_80), op_RSHIFT_111, VARL("h_tmp314"));
	RzILOpPure *op_AND_170 = LOGAND(cond_168, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_174 = SHIFTL0(op_AND_170, SN(32, 0x20));
	RzILOpPure *op_OR_175 = LOGOR(op_AND_7, op_LSHIFT_174);
	RzILOpEffect *op_ASSIGN_176 = WRITE_REG(bundle, Rdd_op, op_OR_175);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ( ...;
	RzILOpEffect *seq_177 = SEQN(2, seq_167, op_ASSIGN_176);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_290 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_192 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_194 = LOGAND(op_RSHIFT_192, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_205 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_208 = LOGAND(op_RSHIFT_205, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_215 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_194), DUP(op_AND_194))), CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194))), CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194))), CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194))), CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_208), DUP(op_AND_208))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_217 = SHIFTL0(op_MUL_215, SN(32, 1));
	RzILOpPure *op_RSHIFT_219 = SHIFTRA(op_LSHIFT_217, SN(32, 16));
	RzILOpPure *op_RSHIFT_228 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_230 = LOGAND(op_RSHIFT_228, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_241 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_244 = LOGAND(op_RSHIFT_241, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_251 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_230), DUP(op_AND_230))), CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230))), CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230))), CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230))), CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_244), DUP(op_AND_244))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_253 = SHIFTL0(op_MUL_251, SN(32, 1));
	RzILOpPure *op_RSHIFT_255 = SHIFTRA(op_LSHIFT_253, SN(32, 16));
	RzILOpPure *op_EQ_256 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_219), SN(32, 0), SN(32, 0x20)), op_RSHIFT_255);
	RzILOpPure *op_RSHIFT_294 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_296 = LOGAND(op_RSHIFT_294, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_307 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_310 = LOGAND(op_RSHIFT_307, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_317 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_296), DUP(op_AND_296))), CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296))), CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296))), CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296))), CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_310), DUP(op_AND_310))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_319 = SHIFTL0(op_MUL_317, SN(32, 1));
	RzILOpPure *op_RSHIFT_321 = SHIFTRA(op_LSHIFT_319, SN(32, 16));
	RzILOpPure *op_LT_324 = SLT(op_RSHIFT_321, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_329 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_330 = NEG(op_LSHIFT_329);
	RzILOpPure *op_LSHIFT_335 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_338 = SUB(op_LSHIFT_335, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_339 = ITE(op_LT_324, op_NEG_330, op_SUB_338);
	RzILOpEffect *gcc_expr_340 = BRANCH(op_EQ_256, EMPTY(), set_usr_field_call_290);

	// h_tmp315 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_342 = SETL("h_tmp315", cond_339);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ((st6 ...;
	RzILOpEffect *seq_343 = SEQN(2, gcc_expr_340, op_ASSIGN_hybrid_tmp_342);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10)) ? ((((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff))))) * sextract64(((ut64) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10) << 0x1) >> 0x10) : h_tmp315) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_183 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_184 = LOGNOT(op_LSHIFT_183);
	RzILOpPure *op_AND_185 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_184);
	RzILOpPure *op_RSHIFT_260 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_262 = LOGAND(op_RSHIFT_260, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_273 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_276 = LOGAND(op_RSHIFT_273, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_283 = MUL(CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_262), DUP(op_AND_262))), CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262))), CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262))), CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262))), CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262))))), SEXTRACT64(CAST(64, IL_FALSE, CAST(16, MSB(op_AND_276), DUP(op_AND_276))), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_285 = SHIFTL0(op_MUL_283, SN(32, 1));
	RzILOpPure *op_RSHIFT_287 = SHIFTRA(op_LSHIFT_285, SN(32, 16));
	RzILOpPure *cond_344 = ITE(DUP(op_EQ_256), op_RSHIFT_287, VARL("h_tmp315"));
	RzILOpPure *op_AND_346 = LOGAND(cond_344, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_350 = SHIFTL0(op_AND_346, SN(32, 0));
	RzILOpPure *op_OR_351 = LOGOR(op_AND_185, op_LSHIFT_350);
	RzILOpEffect *op_ASSIGN_352 = WRITE_REG(bundle, Rdd_op, op_OR_351);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((st32) ( ...;
	RzILOpEffect *seq_353 = SEQN(2, seq_343, op_ASSIGN_352);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_177, seq_353);
	return instruction_sequence;
}

// Rdd = vmpywouh(Rss,Rtt):rnd:sat
RzILOpEffect *hex_il_op_m2_mmpyuh_rs0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_129 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_17 = LOGAND(op_RSHIFT_15, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_29 = SHIFTRA(Rtt, SN(32, 0x30));
	RzILOpPure *op_AND_32 = LOGAND(op_RSHIFT_29, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_40 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_17), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_32)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_43 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_40), SN(32, 0));
	RzILOpPure *op_ADD_46 = ADD(op_LSHIFT_43, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_48 = SHIFTRA(op_ADD_46, SN(32, 16));
	RzILOpPure *op_RSHIFT_57 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_59 = LOGAND(op_RSHIFT_57, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_70 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_73 = LOGAND(op_RSHIFT_70, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_81 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_59), DUP(op_AND_59))), CAST(32, MSB(DUP(op_AND_59)), DUP(op_AND_59)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_59)), DUP(op_AND_59))), CAST(32, MSB(DUP(op_AND_59)), DUP(op_AND_59))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_59)), DUP(op_AND_59))), CAST(32, MSB(DUP(op_AND_59)), DUP(op_AND_59)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_59)), DUP(op_AND_59))), CAST(32, MSB(DUP(op_AND_59)), DUP(op_AND_59)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_73)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_84 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_81), SN(32, 0));
	RzILOpPure *op_ADD_87 = ADD(op_LSHIFT_84, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_89 = SHIFTRA(op_ADD_87, SN(32, 16));
	RzILOpPure *op_EQ_90 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_48), SN(32, 0), SN(32, 0x20)), op_RSHIFT_89);
	RzILOpPure *op_RSHIFT_133 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_135 = LOGAND(op_RSHIFT_133, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_146 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_149 = LOGAND(op_RSHIFT_146, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_157 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_135), DUP(op_AND_135))), CAST(32, MSB(DUP(op_AND_135)), DUP(op_AND_135)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_135)), DUP(op_AND_135))), CAST(32, MSB(DUP(op_AND_135)), DUP(op_AND_135))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_135)), DUP(op_AND_135))), CAST(32, MSB(DUP(op_AND_135)), DUP(op_AND_135)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_135)), DUP(op_AND_135))), CAST(32, MSB(DUP(op_AND_135)), DUP(op_AND_135)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_149)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_160 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_157), SN(32, 0));
	RzILOpPure *op_ADD_163 = ADD(op_LSHIFT_160, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_165 = SHIFTRA(op_ADD_163, SN(32, 16));
	RzILOpPure *op_LT_168 = SLT(op_RSHIFT_165, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_173 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_174 = NEG(op_LSHIFT_173);
	RzILOpPure *op_LSHIFT_179 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_182 = SUB(op_LSHIFT_179, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_183 = ITE(op_LT_168, op_NEG_174, op_SUB_182);
	RzILOpEffect *gcc_expr_184 = BRANCH(op_EQ_90, EMPTY(), set_usr_field_call_129);

	// h_tmp316 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_186 = SETL("h_tmp316", cond_183);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st6 ...;
	RzILOpEffect *seq_187 = SEQN(2, gcc_expr_184, op_ASSIGN_hybrid_tmp_186);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)) ? ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10) : h_tmp316) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_94 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_96 = LOGAND(op_RSHIFT_94, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_107 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_110 = LOGAND(op_RSHIFT_107, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_118 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_96), DUP(op_AND_96))), CAST(32, MSB(DUP(op_AND_96)), DUP(op_AND_96)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_96)), DUP(op_AND_96))), CAST(32, MSB(DUP(op_AND_96)), DUP(op_AND_96))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_96)), DUP(op_AND_96))), CAST(32, MSB(DUP(op_AND_96)), DUP(op_AND_96)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_96)), DUP(op_AND_96))), CAST(32, MSB(DUP(op_AND_96)), DUP(op_AND_96)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_110)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_121 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_118), SN(32, 0));
	RzILOpPure *op_ADD_124 = ADD(op_LSHIFT_121, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_126 = SHIFTRA(op_ADD_124, SN(32, 16));
	RzILOpPure *cond_188 = ITE(DUP(op_EQ_90), op_RSHIFT_126, VARL("h_tmp316"));
	RzILOpPure *op_AND_190 = LOGAND(cond_188, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_194 = SHIFTL0(op_AND_190, SN(32, 0x20));
	RzILOpPure *op_OR_195 = LOGOR(op_AND_7, op_LSHIFT_194);
	RzILOpEffect *op_ASSIGN_196 = WRITE_REG(bundle, Rdd_op, op_OR_195);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ( ...;
	RzILOpEffect *seq_197 = SEQN(2, seq_187, op_ASSIGN_196);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_325 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_212 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_214 = LOGAND(op_RSHIFT_212, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_225 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_228 = LOGAND(op_RSHIFT_225, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_236 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_214), DUP(op_AND_214))), CAST(32, MSB(DUP(op_AND_214)), DUP(op_AND_214)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_214)), DUP(op_AND_214))), CAST(32, MSB(DUP(op_AND_214)), DUP(op_AND_214))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_214)), DUP(op_AND_214))), CAST(32, MSB(DUP(op_AND_214)), DUP(op_AND_214)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_214)), DUP(op_AND_214))), CAST(32, MSB(DUP(op_AND_214)), DUP(op_AND_214)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_228)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_239 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_236), SN(32, 0));
	RzILOpPure *op_ADD_242 = ADD(op_LSHIFT_239, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_244 = SHIFTRA(op_ADD_242, SN(32, 16));
	RzILOpPure *op_RSHIFT_253 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_255 = LOGAND(op_RSHIFT_253, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_266 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_269 = LOGAND(op_RSHIFT_266, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_277 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_255), DUP(op_AND_255))), CAST(32, MSB(DUP(op_AND_255)), DUP(op_AND_255)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_255)), DUP(op_AND_255))), CAST(32, MSB(DUP(op_AND_255)), DUP(op_AND_255))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_255)), DUP(op_AND_255))), CAST(32, MSB(DUP(op_AND_255)), DUP(op_AND_255)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_255)), DUP(op_AND_255))), CAST(32, MSB(DUP(op_AND_255)), DUP(op_AND_255)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_269)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_280 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_277), SN(32, 0));
	RzILOpPure *op_ADD_283 = ADD(op_LSHIFT_280, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_285 = SHIFTRA(op_ADD_283, SN(32, 16));
	RzILOpPure *op_EQ_286 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_244), SN(32, 0), SN(32, 0x20)), op_RSHIFT_285);
	RzILOpPure *op_RSHIFT_329 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_331 = LOGAND(op_RSHIFT_329, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_342 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_345 = LOGAND(op_RSHIFT_342, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_353 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_331), DUP(op_AND_331))), CAST(32, MSB(DUP(op_AND_331)), DUP(op_AND_331)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_331)), DUP(op_AND_331))), CAST(32, MSB(DUP(op_AND_331)), DUP(op_AND_331))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_331)), DUP(op_AND_331))), CAST(32, MSB(DUP(op_AND_331)), DUP(op_AND_331)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_331)), DUP(op_AND_331))), CAST(32, MSB(DUP(op_AND_331)), DUP(op_AND_331)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_345)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_356 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_353), SN(32, 0));
	RzILOpPure *op_ADD_359 = ADD(op_LSHIFT_356, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_361 = SHIFTRA(op_ADD_359, SN(32, 16));
	RzILOpPure *op_LT_364 = SLT(op_RSHIFT_361, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_369 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_370 = NEG(op_LSHIFT_369);
	RzILOpPure *op_LSHIFT_375 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_378 = SUB(op_LSHIFT_375, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_379 = ITE(op_LT_364, op_NEG_370, op_SUB_378);
	RzILOpEffect *gcc_expr_380 = BRANCH(op_EQ_286, EMPTY(), set_usr_field_call_325);

	// h_tmp317 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_382 = SETL("h_tmp317", cond_379);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st6 ...;
	RzILOpEffect *seq_383 = SEQN(2, gcc_expr_380, op_ASSIGN_hybrid_tmp_382);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)) ? ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10) : h_tmp317) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_203 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_204 = LOGNOT(op_LSHIFT_203);
	RzILOpPure *op_AND_205 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_204);
	RzILOpPure *op_RSHIFT_290 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_292 = LOGAND(op_RSHIFT_290, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_303 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_306 = LOGAND(op_RSHIFT_303, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_314 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_292), DUP(op_AND_292))), CAST(32, MSB(DUP(op_AND_292)), DUP(op_AND_292)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_292)), DUP(op_AND_292))), CAST(32, MSB(DUP(op_AND_292)), DUP(op_AND_292))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_292)), DUP(op_AND_292))), CAST(32, MSB(DUP(op_AND_292)), DUP(op_AND_292)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_292)), DUP(op_AND_292))), CAST(32, MSB(DUP(op_AND_292)), DUP(op_AND_292)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_306)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_317 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_314), SN(32, 0));
	RzILOpPure *op_ADD_320 = ADD(op_LSHIFT_317, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_322 = SHIFTRA(op_ADD_320, SN(32, 16));
	RzILOpPure *cond_384 = ITE(DUP(op_EQ_286), op_RSHIFT_322, VARL("h_tmp317"));
	RzILOpPure *op_AND_386 = LOGAND(cond_384, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_390 = SHIFTL0(op_AND_386, SN(32, 0));
	RzILOpPure *op_OR_391 = LOGOR(op_AND_205, op_LSHIFT_390);
	RzILOpEffect *op_ASSIGN_392 = WRITE_REG(bundle, Rdd_op, op_OR_391);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ( ...;
	RzILOpEffect *seq_393 = SEQN(2, seq_383, op_ASSIGN_392);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_197, seq_393);
	return instruction_sequence;
}

// Rdd = vmpywouh(Rss,Rtt):<<1:rnd:sat
RzILOpEffect *hex_il_op_m2_mmpyuh_rs1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_129 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_17 = LOGAND(op_RSHIFT_15, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_29 = SHIFTRA(Rtt, SN(32, 0x30));
	RzILOpPure *op_AND_32 = LOGAND(op_RSHIFT_29, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_40 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_17), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_32)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_43 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_40), SN(32, 1));
	RzILOpPure *op_ADD_46 = ADD(op_LSHIFT_43, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_48 = SHIFTRA(op_ADD_46, SN(32, 16));
	RzILOpPure *op_RSHIFT_57 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_59 = LOGAND(op_RSHIFT_57, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_70 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_73 = LOGAND(op_RSHIFT_70, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_81 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_59), DUP(op_AND_59))), CAST(32, MSB(DUP(op_AND_59)), DUP(op_AND_59)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_59)), DUP(op_AND_59))), CAST(32, MSB(DUP(op_AND_59)), DUP(op_AND_59))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_59)), DUP(op_AND_59))), CAST(32, MSB(DUP(op_AND_59)), DUP(op_AND_59)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_59)), DUP(op_AND_59))), CAST(32, MSB(DUP(op_AND_59)), DUP(op_AND_59)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_73)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_84 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_81), SN(32, 1));
	RzILOpPure *op_ADD_87 = ADD(op_LSHIFT_84, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_89 = SHIFTRA(op_ADD_87, SN(32, 16));
	RzILOpPure *op_EQ_90 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_48), SN(32, 0), SN(32, 0x20)), op_RSHIFT_89);
	RzILOpPure *op_RSHIFT_133 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_135 = LOGAND(op_RSHIFT_133, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_146 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_149 = LOGAND(op_RSHIFT_146, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_157 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_135), DUP(op_AND_135))), CAST(32, MSB(DUP(op_AND_135)), DUP(op_AND_135)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_135)), DUP(op_AND_135))), CAST(32, MSB(DUP(op_AND_135)), DUP(op_AND_135))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_135)), DUP(op_AND_135))), CAST(32, MSB(DUP(op_AND_135)), DUP(op_AND_135)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_135)), DUP(op_AND_135))), CAST(32, MSB(DUP(op_AND_135)), DUP(op_AND_135)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_149)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_160 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_157), SN(32, 1));
	RzILOpPure *op_ADD_163 = ADD(op_LSHIFT_160, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_165 = SHIFTRA(op_ADD_163, SN(32, 16));
	RzILOpPure *op_LT_168 = SLT(op_RSHIFT_165, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_173 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_174 = NEG(op_LSHIFT_173);
	RzILOpPure *op_LSHIFT_179 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_182 = SUB(op_LSHIFT_179, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_183 = ITE(op_LT_168, op_NEG_174, op_SUB_182);
	RzILOpEffect *gcc_expr_184 = BRANCH(op_EQ_90, EMPTY(), set_usr_field_call_129);

	// h_tmp318 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_186 = SETL("h_tmp318", cond_183);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st6 ...;
	RzILOpEffect *seq_187 = SEQN(2, gcc_expr_184, op_ASSIGN_hybrid_tmp_186);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)) ? ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10) : h_tmp318) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_94 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_96 = LOGAND(op_RSHIFT_94, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_107 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_110 = LOGAND(op_RSHIFT_107, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_118 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_96), DUP(op_AND_96))), CAST(32, MSB(DUP(op_AND_96)), DUP(op_AND_96)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_96)), DUP(op_AND_96))), CAST(32, MSB(DUP(op_AND_96)), DUP(op_AND_96))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_96)), DUP(op_AND_96))), CAST(32, MSB(DUP(op_AND_96)), DUP(op_AND_96)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_96)), DUP(op_AND_96))), CAST(32, MSB(DUP(op_AND_96)), DUP(op_AND_96)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_110)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_121 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_118), SN(32, 1));
	RzILOpPure *op_ADD_124 = ADD(op_LSHIFT_121, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_126 = SHIFTRA(op_ADD_124, SN(32, 16));
	RzILOpPure *cond_188 = ITE(DUP(op_EQ_90), op_RSHIFT_126, VARL("h_tmp318"));
	RzILOpPure *op_AND_190 = LOGAND(cond_188, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_194 = SHIFTL0(op_AND_190, SN(32, 0x20));
	RzILOpPure *op_OR_195 = LOGOR(op_AND_7, op_LSHIFT_194);
	RzILOpEffect *op_ASSIGN_196 = WRITE_REG(bundle, Rdd_op, op_OR_195);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ( ...;
	RzILOpEffect *seq_197 = SEQN(2, seq_187, op_ASSIGN_196);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_325 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_212 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_214 = LOGAND(op_RSHIFT_212, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_225 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_228 = LOGAND(op_RSHIFT_225, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_236 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_214), DUP(op_AND_214))), CAST(32, MSB(DUP(op_AND_214)), DUP(op_AND_214)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_214)), DUP(op_AND_214))), CAST(32, MSB(DUP(op_AND_214)), DUP(op_AND_214))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_214)), DUP(op_AND_214))), CAST(32, MSB(DUP(op_AND_214)), DUP(op_AND_214)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_214)), DUP(op_AND_214))), CAST(32, MSB(DUP(op_AND_214)), DUP(op_AND_214)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_228)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_239 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_236), SN(32, 1));
	RzILOpPure *op_ADD_242 = ADD(op_LSHIFT_239, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_244 = SHIFTRA(op_ADD_242, SN(32, 16));
	RzILOpPure *op_RSHIFT_253 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_255 = LOGAND(op_RSHIFT_253, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_266 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_269 = LOGAND(op_RSHIFT_266, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_277 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_255), DUP(op_AND_255))), CAST(32, MSB(DUP(op_AND_255)), DUP(op_AND_255)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_255)), DUP(op_AND_255))), CAST(32, MSB(DUP(op_AND_255)), DUP(op_AND_255))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_255)), DUP(op_AND_255))), CAST(32, MSB(DUP(op_AND_255)), DUP(op_AND_255)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_255)), DUP(op_AND_255))), CAST(32, MSB(DUP(op_AND_255)), DUP(op_AND_255)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_269)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_280 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_277), SN(32, 1));
	RzILOpPure *op_ADD_283 = ADD(op_LSHIFT_280, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_285 = SHIFTRA(op_ADD_283, SN(32, 16));
	RzILOpPure *op_EQ_286 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_244), SN(32, 0), SN(32, 0x20)), op_RSHIFT_285);
	RzILOpPure *op_RSHIFT_329 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_331 = LOGAND(op_RSHIFT_329, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_342 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_345 = LOGAND(op_RSHIFT_342, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_353 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_331), DUP(op_AND_331))), CAST(32, MSB(DUP(op_AND_331)), DUP(op_AND_331)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_331)), DUP(op_AND_331))), CAST(32, MSB(DUP(op_AND_331)), DUP(op_AND_331))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_331)), DUP(op_AND_331))), CAST(32, MSB(DUP(op_AND_331)), DUP(op_AND_331)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_331)), DUP(op_AND_331))), CAST(32, MSB(DUP(op_AND_331)), DUP(op_AND_331)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_345)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_356 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_353), SN(32, 1));
	RzILOpPure *op_ADD_359 = ADD(op_LSHIFT_356, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_361 = SHIFTRA(op_ADD_359, SN(32, 16));
	RzILOpPure *op_LT_364 = SLT(op_RSHIFT_361, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_369 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_370 = NEG(op_LSHIFT_369);
	RzILOpPure *op_LSHIFT_375 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_378 = SUB(op_LSHIFT_375, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_379 = ITE(op_LT_364, op_NEG_370, op_SUB_378);
	RzILOpEffect *gcc_expr_380 = BRANCH(op_EQ_286, EMPTY(), set_usr_field_call_325);

	// h_tmp319 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_382 = SETL("h_tmp319", cond_379);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st6 ...;
	RzILOpEffect *seq_383 = SEQN(2, gcc_expr_380, op_ASSIGN_hybrid_tmp_382);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)) ? ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10) : h_tmp319) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_203 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_204 = LOGNOT(op_LSHIFT_203);
	RzILOpPure *op_AND_205 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_204);
	RzILOpPure *op_RSHIFT_290 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_292 = LOGAND(op_RSHIFT_290, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_303 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_306 = LOGAND(op_RSHIFT_303, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_314 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_292), DUP(op_AND_292))), CAST(32, MSB(DUP(op_AND_292)), DUP(op_AND_292)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_292)), DUP(op_AND_292))), CAST(32, MSB(DUP(op_AND_292)), DUP(op_AND_292))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_292)), DUP(op_AND_292))), CAST(32, MSB(DUP(op_AND_292)), DUP(op_AND_292)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_292)), DUP(op_AND_292))), CAST(32, MSB(DUP(op_AND_292)), DUP(op_AND_292)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_306)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_317 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_314), SN(32, 1));
	RzILOpPure *op_ADD_320 = ADD(op_LSHIFT_317, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_322 = SHIFTRA(op_ADD_320, SN(32, 16));
	RzILOpPure *cond_384 = ITE(DUP(op_EQ_286), op_RSHIFT_322, VARL("h_tmp319"));
	RzILOpPure *op_AND_386 = LOGAND(cond_384, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_390 = SHIFTL0(op_AND_386, SN(32, 0));
	RzILOpPure *op_OR_391 = LOGOR(op_AND_205, op_LSHIFT_390);
	RzILOpEffect *op_ASSIGN_392 = WRITE_REG(bundle, Rdd_op, op_OR_391);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ( ...;
	RzILOpEffect *seq_393 = SEQN(2, seq_383, op_ASSIGN_392);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_197, seq_393);
	return instruction_sequence;
}

// Rdd = vmpywouh(Rss,Rtt):sat
RzILOpEffect *hex_il_op_m2_mmpyuh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_120 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_17 = LOGAND(op_RSHIFT_15, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_29 = SHIFTRA(Rtt, SN(32, 0x30));
	RzILOpPure *op_AND_32 = LOGAND(op_RSHIFT_29, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_40 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_17), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_32)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_43 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_40), SN(32, 0));
	RzILOpPure *op_RSHIFT_45 = SHIFTRA(op_LSHIFT_43, SN(32, 16));
	RzILOpPure *op_RSHIFT_54 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_56 = LOGAND(op_RSHIFT_54, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_67 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_70 = LOGAND(op_RSHIFT_67, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_78 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_56), DUP(op_AND_56))), CAST(32, MSB(DUP(op_AND_56)), DUP(op_AND_56)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_56)), DUP(op_AND_56))), CAST(32, MSB(DUP(op_AND_56)), DUP(op_AND_56))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_56)), DUP(op_AND_56))), CAST(32, MSB(DUP(op_AND_56)), DUP(op_AND_56)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_56)), DUP(op_AND_56))), CAST(32, MSB(DUP(op_AND_56)), DUP(op_AND_56)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_70)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_81 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_78), SN(32, 0));
	RzILOpPure *op_RSHIFT_83 = SHIFTRA(op_LSHIFT_81, SN(32, 16));
	RzILOpPure *op_EQ_84 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_45), SN(32, 0), SN(32, 0x20)), op_RSHIFT_83);
	RzILOpPure *op_RSHIFT_124 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_126 = LOGAND(op_RSHIFT_124, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_137 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_140 = LOGAND(op_RSHIFT_137, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_148 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_126), DUP(op_AND_126))), CAST(32, MSB(DUP(op_AND_126)), DUP(op_AND_126)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_126)), DUP(op_AND_126))), CAST(32, MSB(DUP(op_AND_126)), DUP(op_AND_126))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_126)), DUP(op_AND_126))), CAST(32, MSB(DUP(op_AND_126)), DUP(op_AND_126)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_126)), DUP(op_AND_126))), CAST(32, MSB(DUP(op_AND_126)), DUP(op_AND_126)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_140)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_151 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_148), SN(32, 0));
	RzILOpPure *op_RSHIFT_153 = SHIFTRA(op_LSHIFT_151, SN(32, 16));
	RzILOpPure *op_LT_156 = SLT(op_RSHIFT_153, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_161 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_162 = NEG(op_LSHIFT_161);
	RzILOpPure *op_LSHIFT_167 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_170 = SUB(op_LSHIFT_167, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_171 = ITE(op_LT_156, op_NEG_162, op_SUB_170);
	RzILOpEffect *gcc_expr_172 = BRANCH(op_EQ_84, EMPTY(), set_usr_field_call_120);

	// h_tmp320 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_174 = SETL("h_tmp320", cond_171);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st6 ...;
	RzILOpEffect *seq_175 = SEQN(2, gcc_expr_172, op_ASSIGN_hybrid_tmp_174);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)) ? ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10) : h_tmp320) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_88 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_90 = LOGAND(op_RSHIFT_88, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_101 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_104 = LOGAND(op_RSHIFT_101, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_112 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_90), DUP(op_AND_90))), CAST(32, MSB(DUP(op_AND_90)), DUP(op_AND_90)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_90)), DUP(op_AND_90))), CAST(32, MSB(DUP(op_AND_90)), DUP(op_AND_90))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_90)), DUP(op_AND_90))), CAST(32, MSB(DUP(op_AND_90)), DUP(op_AND_90)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_90)), DUP(op_AND_90))), CAST(32, MSB(DUP(op_AND_90)), DUP(op_AND_90)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_104)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_115 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_112), SN(32, 0));
	RzILOpPure *op_RSHIFT_117 = SHIFTRA(op_LSHIFT_115, SN(32, 16));
	RzILOpPure *cond_176 = ITE(DUP(op_EQ_84), op_RSHIFT_117, VARL("h_tmp320"));
	RzILOpPure *op_AND_178 = LOGAND(cond_176, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_182 = SHIFTL0(op_AND_178, SN(32, 0x20));
	RzILOpPure *op_OR_183 = LOGOR(op_AND_7, op_LSHIFT_182);
	RzILOpEffect *op_ASSIGN_184 = WRITE_REG(bundle, Rdd_op, op_OR_183);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ( ...;
	RzILOpEffect *seq_185 = SEQN(2, seq_175, op_ASSIGN_184);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_304 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_200 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_202 = LOGAND(op_RSHIFT_200, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_213 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_216 = LOGAND(op_RSHIFT_213, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_224 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_202), DUP(op_AND_202))), CAST(32, MSB(DUP(op_AND_202)), DUP(op_AND_202)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_202)), DUP(op_AND_202))), CAST(32, MSB(DUP(op_AND_202)), DUP(op_AND_202))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_202)), DUP(op_AND_202))), CAST(32, MSB(DUP(op_AND_202)), DUP(op_AND_202)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_202)), DUP(op_AND_202))), CAST(32, MSB(DUP(op_AND_202)), DUP(op_AND_202)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_216)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_227 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_224), SN(32, 0));
	RzILOpPure *op_RSHIFT_229 = SHIFTRA(op_LSHIFT_227, SN(32, 16));
	RzILOpPure *op_RSHIFT_238 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_240 = LOGAND(op_RSHIFT_238, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_251 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_254 = LOGAND(op_RSHIFT_251, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_262 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_240), DUP(op_AND_240))), CAST(32, MSB(DUP(op_AND_240)), DUP(op_AND_240)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_240)), DUP(op_AND_240))), CAST(32, MSB(DUP(op_AND_240)), DUP(op_AND_240))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_240)), DUP(op_AND_240))), CAST(32, MSB(DUP(op_AND_240)), DUP(op_AND_240)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_240)), DUP(op_AND_240))), CAST(32, MSB(DUP(op_AND_240)), DUP(op_AND_240)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_254)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_265 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_262), SN(32, 0));
	RzILOpPure *op_RSHIFT_267 = SHIFTRA(op_LSHIFT_265, SN(32, 16));
	RzILOpPure *op_EQ_268 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_229), SN(32, 0), SN(32, 0x20)), op_RSHIFT_267);
	RzILOpPure *op_RSHIFT_308 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_310 = LOGAND(op_RSHIFT_308, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_321 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_324 = LOGAND(op_RSHIFT_321, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_332 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_310), DUP(op_AND_310))), CAST(32, MSB(DUP(op_AND_310)), DUP(op_AND_310)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_310)), DUP(op_AND_310))), CAST(32, MSB(DUP(op_AND_310)), DUP(op_AND_310))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_310)), DUP(op_AND_310))), CAST(32, MSB(DUP(op_AND_310)), DUP(op_AND_310)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_310)), DUP(op_AND_310))), CAST(32, MSB(DUP(op_AND_310)), DUP(op_AND_310)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_324)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_335 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_332), SN(32, 0));
	RzILOpPure *op_RSHIFT_337 = SHIFTRA(op_LSHIFT_335, SN(32, 16));
	RzILOpPure *op_LT_340 = SLT(op_RSHIFT_337, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_345 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_346 = NEG(op_LSHIFT_345);
	RzILOpPure *op_LSHIFT_351 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_354 = SUB(op_LSHIFT_351, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_355 = ITE(op_LT_340, op_NEG_346, op_SUB_354);
	RzILOpEffect *gcc_expr_356 = BRANCH(op_EQ_268, EMPTY(), set_usr_field_call_304);

	// h_tmp321 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_358 = SETL("h_tmp321", cond_355);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st6 ...;
	RzILOpEffect *seq_359 = SEQN(2, gcc_expr_356, op_ASSIGN_hybrid_tmp_358);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)) ? ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10) : h_tmp321) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_191 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_192 = LOGNOT(op_LSHIFT_191);
	RzILOpPure *op_AND_193 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_192);
	RzILOpPure *op_RSHIFT_272 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_274 = LOGAND(op_RSHIFT_272, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_285 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_288 = LOGAND(op_RSHIFT_285, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_296 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_274), DUP(op_AND_274))), CAST(32, MSB(DUP(op_AND_274)), DUP(op_AND_274)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_274)), DUP(op_AND_274))), CAST(32, MSB(DUP(op_AND_274)), DUP(op_AND_274))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_274)), DUP(op_AND_274))), CAST(32, MSB(DUP(op_AND_274)), DUP(op_AND_274)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_274)), DUP(op_AND_274))), CAST(32, MSB(DUP(op_AND_274)), DUP(op_AND_274)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_288)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_299 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_296), SN(32, 0));
	RzILOpPure *op_RSHIFT_301 = SHIFTRA(op_LSHIFT_299, SN(32, 16));
	RzILOpPure *cond_360 = ITE(DUP(op_EQ_268), op_RSHIFT_301, VARL("h_tmp321"));
	RzILOpPure *op_AND_362 = LOGAND(cond_360, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_366 = SHIFTL0(op_AND_362, SN(32, 0));
	RzILOpPure *op_OR_367 = LOGOR(op_AND_193, op_LSHIFT_366);
	RzILOpEffect *op_ASSIGN_368 = WRITE_REG(bundle, Rdd_op, op_OR_367);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ( ...;
	RzILOpEffect *seq_369 = SEQN(2, seq_359, op_ASSIGN_368);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_185, seq_369);
	return instruction_sequence;
}

// Rdd = vmpywouh(Rss,Rtt):<<1:sat
RzILOpEffect *hex_il_op_m2_mmpyuh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_120 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_17 = LOGAND(op_RSHIFT_15, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_29 = SHIFTRA(Rtt, SN(32, 0x30));
	RzILOpPure *op_AND_32 = LOGAND(op_RSHIFT_29, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_40 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_17), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_32)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_43 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_40), SN(32, 1));
	RzILOpPure *op_RSHIFT_45 = SHIFTRA(op_LSHIFT_43, SN(32, 16));
	RzILOpPure *op_RSHIFT_54 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_56 = LOGAND(op_RSHIFT_54, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_67 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_70 = LOGAND(op_RSHIFT_67, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_78 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_56), DUP(op_AND_56))), CAST(32, MSB(DUP(op_AND_56)), DUP(op_AND_56)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_56)), DUP(op_AND_56))), CAST(32, MSB(DUP(op_AND_56)), DUP(op_AND_56))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_56)), DUP(op_AND_56))), CAST(32, MSB(DUP(op_AND_56)), DUP(op_AND_56)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_56)), DUP(op_AND_56))), CAST(32, MSB(DUP(op_AND_56)), DUP(op_AND_56)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_70)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_81 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_78), SN(32, 1));
	RzILOpPure *op_RSHIFT_83 = SHIFTRA(op_LSHIFT_81, SN(32, 16));
	RzILOpPure *op_EQ_84 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_45), SN(32, 0), SN(32, 0x20)), op_RSHIFT_83);
	RzILOpPure *op_RSHIFT_124 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_126 = LOGAND(op_RSHIFT_124, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_137 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_140 = LOGAND(op_RSHIFT_137, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_148 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_126), DUP(op_AND_126))), CAST(32, MSB(DUP(op_AND_126)), DUP(op_AND_126)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_126)), DUP(op_AND_126))), CAST(32, MSB(DUP(op_AND_126)), DUP(op_AND_126))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_126)), DUP(op_AND_126))), CAST(32, MSB(DUP(op_AND_126)), DUP(op_AND_126)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_126)), DUP(op_AND_126))), CAST(32, MSB(DUP(op_AND_126)), DUP(op_AND_126)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_140)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_151 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_148), SN(32, 1));
	RzILOpPure *op_RSHIFT_153 = SHIFTRA(op_LSHIFT_151, SN(32, 16));
	RzILOpPure *op_LT_156 = SLT(op_RSHIFT_153, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_161 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_162 = NEG(op_LSHIFT_161);
	RzILOpPure *op_LSHIFT_167 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_170 = SUB(op_LSHIFT_167, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_171 = ITE(op_LT_156, op_NEG_162, op_SUB_170);
	RzILOpEffect *gcc_expr_172 = BRANCH(op_EQ_84, EMPTY(), set_usr_field_call_120);

	// h_tmp322 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_174 = SETL("h_tmp322", cond_171);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st6 ...;
	RzILOpEffect *seq_175 = SEQN(2, gcc_expr_172, op_ASSIGN_hybrid_tmp_174);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)) ? ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x30) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10) : h_tmp322) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_88 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_90 = LOGAND(op_RSHIFT_88, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_101 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_104 = LOGAND(op_RSHIFT_101, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_112 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_90), DUP(op_AND_90))), CAST(32, MSB(DUP(op_AND_90)), DUP(op_AND_90)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_90)), DUP(op_AND_90))), CAST(32, MSB(DUP(op_AND_90)), DUP(op_AND_90))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_90)), DUP(op_AND_90))), CAST(32, MSB(DUP(op_AND_90)), DUP(op_AND_90)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_90)), DUP(op_AND_90))), CAST(32, MSB(DUP(op_AND_90)), DUP(op_AND_90)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_104)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_115 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_112), SN(32, 1));
	RzILOpPure *op_RSHIFT_117 = SHIFTRA(op_LSHIFT_115, SN(32, 16));
	RzILOpPure *cond_176 = ITE(DUP(op_EQ_84), op_RSHIFT_117, VARL("h_tmp322"));
	RzILOpPure *op_AND_178 = LOGAND(cond_176, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_182 = SHIFTL0(op_AND_178, SN(32, 0x20));
	RzILOpPure *op_OR_183 = LOGOR(op_AND_7, op_LSHIFT_182);
	RzILOpEffect *op_ASSIGN_184 = WRITE_REG(bundle, Rdd_op, op_OR_183);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ( ...;
	RzILOpEffect *seq_185 = SEQN(2, seq_175, op_ASSIGN_184);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_304 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_200 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_202 = LOGAND(op_RSHIFT_200, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_213 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_216 = LOGAND(op_RSHIFT_213, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_224 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_202), DUP(op_AND_202))), CAST(32, MSB(DUP(op_AND_202)), DUP(op_AND_202)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_202)), DUP(op_AND_202))), CAST(32, MSB(DUP(op_AND_202)), DUP(op_AND_202))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_202)), DUP(op_AND_202))), CAST(32, MSB(DUP(op_AND_202)), DUP(op_AND_202)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_202)), DUP(op_AND_202))), CAST(32, MSB(DUP(op_AND_202)), DUP(op_AND_202)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_216)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_227 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_224), SN(32, 1));
	RzILOpPure *op_RSHIFT_229 = SHIFTRA(op_LSHIFT_227, SN(32, 16));
	RzILOpPure *op_RSHIFT_238 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_240 = LOGAND(op_RSHIFT_238, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_251 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_254 = LOGAND(op_RSHIFT_251, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_262 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_240), DUP(op_AND_240))), CAST(32, MSB(DUP(op_AND_240)), DUP(op_AND_240)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_240)), DUP(op_AND_240))), CAST(32, MSB(DUP(op_AND_240)), DUP(op_AND_240))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_240)), DUP(op_AND_240))), CAST(32, MSB(DUP(op_AND_240)), DUP(op_AND_240)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_240)), DUP(op_AND_240))), CAST(32, MSB(DUP(op_AND_240)), DUP(op_AND_240)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_254)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_265 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_262), SN(32, 1));
	RzILOpPure *op_RSHIFT_267 = SHIFTRA(op_LSHIFT_265, SN(32, 16));
	RzILOpPure *op_EQ_268 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_229), SN(32, 0), SN(32, 0x20)), op_RSHIFT_267);
	RzILOpPure *op_RSHIFT_308 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_310 = LOGAND(op_RSHIFT_308, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_321 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_324 = LOGAND(op_RSHIFT_321, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_332 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_310), DUP(op_AND_310))), CAST(32, MSB(DUP(op_AND_310)), DUP(op_AND_310)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_310)), DUP(op_AND_310))), CAST(32, MSB(DUP(op_AND_310)), DUP(op_AND_310))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_310)), DUP(op_AND_310))), CAST(32, MSB(DUP(op_AND_310)), DUP(op_AND_310)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_310)), DUP(op_AND_310))), CAST(32, MSB(DUP(op_AND_310)), DUP(op_AND_310)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_324)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_335 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_332), SN(32, 1));
	RzILOpPure *op_RSHIFT_337 = SHIFTRA(op_LSHIFT_335, SN(32, 16));
	RzILOpPure *op_LT_340 = SLT(op_RSHIFT_337, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_345 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_346 = NEG(op_LSHIFT_345);
	RzILOpPure *op_LSHIFT_351 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_354 = SUB(op_LSHIFT_351, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_355 = ITE(op_LT_340, op_NEG_346, op_SUB_354);
	RzILOpEffect *gcc_expr_356 = BRANCH(op_EQ_268, EMPTY(), set_usr_field_call_304);

	// h_tmp323 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_358 = SETL("h_tmp323", cond_355);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st6 ...;
	RzILOpEffect *seq_359 = SEQN(2, gcc_expr_356, op_ASSIGN_hybrid_tmp_358);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)) ? ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x10) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10) : h_tmp323) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_191 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_192 = LOGNOT(op_LSHIFT_191);
	RzILOpPure *op_AND_193 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_192);
	RzILOpPure *op_RSHIFT_272 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_274 = LOGAND(op_RSHIFT_272, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_285 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_288 = LOGAND(op_RSHIFT_285, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_296 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_274), DUP(op_AND_274))), CAST(32, MSB(DUP(op_AND_274)), DUP(op_AND_274)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_274)), DUP(op_AND_274))), CAST(32, MSB(DUP(op_AND_274)), DUP(op_AND_274))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_274)), DUP(op_AND_274))), CAST(32, MSB(DUP(op_AND_274)), DUP(op_AND_274)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_274)), DUP(op_AND_274))), CAST(32, MSB(DUP(op_AND_274)), DUP(op_AND_274)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_288)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_299 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_296), SN(32, 1));
	RzILOpPure *op_RSHIFT_301 = SHIFTRA(op_LSHIFT_299, SN(32, 16));
	RzILOpPure *cond_360 = ITE(DUP(op_EQ_268), op_RSHIFT_301, VARL("h_tmp323"));
	RzILOpPure *op_AND_362 = LOGAND(cond_360, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_366 = SHIFTL0(op_AND_362, SN(32, 0));
	RzILOpPure *op_OR_367 = LOGOR(op_AND_193, op_LSHIFT_366);
	RzILOpEffect *op_ASSIGN_368 = WRITE_REG(bundle, Rdd_op, op_OR_367);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ( ...;
	RzILOpEffect *seq_369 = SEQN(2, seq_359, op_ASSIGN_368);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_185, seq_369);
	return instruction_sequence;
}

// Rdd = vmpyweuh(Rss,Rtt):rnd:sat
RzILOpEffect *hex_il_op_m2_mmpyul_rs0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_129 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_17 = LOGAND(op_RSHIFT_15, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_29 = SHIFTRA(Rtt, SN(32, 0x20));
	RzILOpPure *op_AND_32 = LOGAND(op_RSHIFT_29, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_40 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_17), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_32)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_43 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_40), SN(32, 0));
	RzILOpPure *op_ADD_46 = ADD(op_LSHIFT_43, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_48 = SHIFTRA(op_ADD_46, SN(32, 16));
	RzILOpPure *op_RSHIFT_57 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_59 = LOGAND(op_RSHIFT_57, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_70 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_73 = LOGAND(op_RSHIFT_70, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_81 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_59), DUP(op_AND_59))), CAST(32, MSB(DUP(op_AND_59)), DUP(op_AND_59)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_59)), DUP(op_AND_59))), CAST(32, MSB(DUP(op_AND_59)), DUP(op_AND_59))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_59)), DUP(op_AND_59))), CAST(32, MSB(DUP(op_AND_59)), DUP(op_AND_59)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_59)), DUP(op_AND_59))), CAST(32, MSB(DUP(op_AND_59)), DUP(op_AND_59)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_73)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_84 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_81), SN(32, 0));
	RzILOpPure *op_ADD_87 = ADD(op_LSHIFT_84, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_89 = SHIFTRA(op_ADD_87, SN(32, 16));
	RzILOpPure *op_EQ_90 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_48), SN(32, 0), SN(32, 0x20)), op_RSHIFT_89);
	RzILOpPure *op_RSHIFT_133 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_135 = LOGAND(op_RSHIFT_133, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_146 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_149 = LOGAND(op_RSHIFT_146, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_157 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_135), DUP(op_AND_135))), CAST(32, MSB(DUP(op_AND_135)), DUP(op_AND_135)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_135)), DUP(op_AND_135))), CAST(32, MSB(DUP(op_AND_135)), DUP(op_AND_135))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_135)), DUP(op_AND_135))), CAST(32, MSB(DUP(op_AND_135)), DUP(op_AND_135)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_135)), DUP(op_AND_135))), CAST(32, MSB(DUP(op_AND_135)), DUP(op_AND_135)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_149)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_160 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_157), SN(32, 0));
	RzILOpPure *op_ADD_163 = ADD(op_LSHIFT_160, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_165 = SHIFTRA(op_ADD_163, SN(32, 16));
	RzILOpPure *op_LT_168 = SLT(op_RSHIFT_165, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_173 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_174 = NEG(op_LSHIFT_173);
	RzILOpPure *op_LSHIFT_179 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_182 = SUB(op_LSHIFT_179, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_183 = ITE(op_LT_168, op_NEG_174, op_SUB_182);
	RzILOpEffect *gcc_expr_184 = BRANCH(op_EQ_90, EMPTY(), set_usr_field_call_129);

	// h_tmp324 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_186 = SETL("h_tmp324", cond_183);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st6 ...;
	RzILOpEffect *seq_187 = SEQN(2, gcc_expr_184, op_ASSIGN_hybrid_tmp_186);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)) ? ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10) : h_tmp324) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_94 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_96 = LOGAND(op_RSHIFT_94, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_107 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_110 = LOGAND(op_RSHIFT_107, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_118 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_96), DUP(op_AND_96))), CAST(32, MSB(DUP(op_AND_96)), DUP(op_AND_96)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_96)), DUP(op_AND_96))), CAST(32, MSB(DUP(op_AND_96)), DUP(op_AND_96))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_96)), DUP(op_AND_96))), CAST(32, MSB(DUP(op_AND_96)), DUP(op_AND_96)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_96)), DUP(op_AND_96))), CAST(32, MSB(DUP(op_AND_96)), DUP(op_AND_96)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_110)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_121 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_118), SN(32, 0));
	RzILOpPure *op_ADD_124 = ADD(op_LSHIFT_121, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_126 = SHIFTRA(op_ADD_124, SN(32, 16));
	RzILOpPure *cond_188 = ITE(DUP(op_EQ_90), op_RSHIFT_126, VARL("h_tmp324"));
	RzILOpPure *op_AND_190 = LOGAND(cond_188, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_194 = SHIFTL0(op_AND_190, SN(32, 0x20));
	RzILOpPure *op_OR_195 = LOGOR(op_AND_7, op_LSHIFT_194);
	RzILOpEffect *op_ASSIGN_196 = WRITE_REG(bundle, Rdd_op, op_OR_195);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ( ...;
	RzILOpEffect *seq_197 = SEQN(2, seq_187, op_ASSIGN_196);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_325 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_212 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_214 = LOGAND(op_RSHIFT_212, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_225 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_228 = LOGAND(op_RSHIFT_225, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_236 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_214), DUP(op_AND_214))), CAST(32, MSB(DUP(op_AND_214)), DUP(op_AND_214)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_214)), DUP(op_AND_214))), CAST(32, MSB(DUP(op_AND_214)), DUP(op_AND_214))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_214)), DUP(op_AND_214))), CAST(32, MSB(DUP(op_AND_214)), DUP(op_AND_214)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_214)), DUP(op_AND_214))), CAST(32, MSB(DUP(op_AND_214)), DUP(op_AND_214)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_228)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_239 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_236), SN(32, 0));
	RzILOpPure *op_ADD_242 = ADD(op_LSHIFT_239, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_244 = SHIFTRA(op_ADD_242, SN(32, 16));
	RzILOpPure *op_RSHIFT_253 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_255 = LOGAND(op_RSHIFT_253, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_266 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_269 = LOGAND(op_RSHIFT_266, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_277 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_255), DUP(op_AND_255))), CAST(32, MSB(DUP(op_AND_255)), DUP(op_AND_255)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_255)), DUP(op_AND_255))), CAST(32, MSB(DUP(op_AND_255)), DUP(op_AND_255))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_255)), DUP(op_AND_255))), CAST(32, MSB(DUP(op_AND_255)), DUP(op_AND_255)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_255)), DUP(op_AND_255))), CAST(32, MSB(DUP(op_AND_255)), DUP(op_AND_255)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_269)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_280 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_277), SN(32, 0));
	RzILOpPure *op_ADD_283 = ADD(op_LSHIFT_280, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_285 = SHIFTRA(op_ADD_283, SN(32, 16));
	RzILOpPure *op_EQ_286 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_244), SN(32, 0), SN(32, 0x20)), op_RSHIFT_285);
	RzILOpPure *op_RSHIFT_329 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_331 = LOGAND(op_RSHIFT_329, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_342 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_345 = LOGAND(op_RSHIFT_342, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_353 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_331), DUP(op_AND_331))), CAST(32, MSB(DUP(op_AND_331)), DUP(op_AND_331)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_331)), DUP(op_AND_331))), CAST(32, MSB(DUP(op_AND_331)), DUP(op_AND_331))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_331)), DUP(op_AND_331))), CAST(32, MSB(DUP(op_AND_331)), DUP(op_AND_331)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_331)), DUP(op_AND_331))), CAST(32, MSB(DUP(op_AND_331)), DUP(op_AND_331)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_345)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_356 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_353), SN(32, 0));
	RzILOpPure *op_ADD_359 = ADD(op_LSHIFT_356, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_361 = SHIFTRA(op_ADD_359, SN(32, 16));
	RzILOpPure *op_LT_364 = SLT(op_RSHIFT_361, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_369 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_370 = NEG(op_LSHIFT_369);
	RzILOpPure *op_LSHIFT_375 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_378 = SUB(op_LSHIFT_375, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_379 = ITE(op_LT_364, op_NEG_370, op_SUB_378);
	RzILOpEffect *gcc_expr_380 = BRANCH(op_EQ_286, EMPTY(), set_usr_field_call_325);

	// h_tmp325 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_382 = SETL("h_tmp325", cond_379);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st6 ...;
	RzILOpEffect *seq_383 = SEQN(2, gcc_expr_380, op_ASSIGN_hybrid_tmp_382);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10)) ? ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) + ((st64) 0x8000) >> 0x10) : h_tmp325) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_203 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_204 = LOGNOT(op_LSHIFT_203);
	RzILOpPure *op_AND_205 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_204);
	RzILOpPure *op_RSHIFT_290 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_292 = LOGAND(op_RSHIFT_290, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_303 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_306 = LOGAND(op_RSHIFT_303, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_314 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_292), DUP(op_AND_292))), CAST(32, MSB(DUP(op_AND_292)), DUP(op_AND_292)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_292)), DUP(op_AND_292))), CAST(32, MSB(DUP(op_AND_292)), DUP(op_AND_292))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_292)), DUP(op_AND_292))), CAST(32, MSB(DUP(op_AND_292)), DUP(op_AND_292)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_292)), DUP(op_AND_292))), CAST(32, MSB(DUP(op_AND_292)), DUP(op_AND_292)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_306)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_317 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_314), SN(32, 0));
	RzILOpPure *op_ADD_320 = ADD(op_LSHIFT_317, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_322 = SHIFTRA(op_ADD_320, SN(32, 16));
	RzILOpPure *cond_384 = ITE(DUP(op_EQ_286), op_RSHIFT_322, VARL("h_tmp325"));
	RzILOpPure *op_AND_386 = LOGAND(cond_384, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_390 = SHIFTL0(op_AND_386, SN(32, 0));
	RzILOpPure *op_OR_391 = LOGOR(op_AND_205, op_LSHIFT_390);
	RzILOpEffect *op_ASSIGN_392 = WRITE_REG(bundle, Rdd_op, op_OR_391);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ( ...;
	RzILOpEffect *seq_393 = SEQN(2, seq_383, op_ASSIGN_392);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_197, seq_393);
	return instruction_sequence;
}

// Rdd = vmpyweuh(Rss,Rtt):<<1:rnd:sat
RzILOpEffect *hex_il_op_m2_mmpyul_rs1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_129 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_17 = LOGAND(op_RSHIFT_15, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_29 = SHIFTRA(Rtt, SN(32, 0x20));
	RzILOpPure *op_AND_32 = LOGAND(op_RSHIFT_29, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_40 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_17), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_32)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_43 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_40), SN(32, 1));
	RzILOpPure *op_ADD_46 = ADD(op_LSHIFT_43, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_48 = SHIFTRA(op_ADD_46, SN(32, 16));
	RzILOpPure *op_RSHIFT_57 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_59 = LOGAND(op_RSHIFT_57, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_70 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_73 = LOGAND(op_RSHIFT_70, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_81 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_59), DUP(op_AND_59))), CAST(32, MSB(DUP(op_AND_59)), DUP(op_AND_59)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_59)), DUP(op_AND_59))), CAST(32, MSB(DUP(op_AND_59)), DUP(op_AND_59))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_59)), DUP(op_AND_59))), CAST(32, MSB(DUP(op_AND_59)), DUP(op_AND_59)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_59)), DUP(op_AND_59))), CAST(32, MSB(DUP(op_AND_59)), DUP(op_AND_59)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_73)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_84 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_81), SN(32, 1));
	RzILOpPure *op_ADD_87 = ADD(op_LSHIFT_84, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_89 = SHIFTRA(op_ADD_87, SN(32, 16));
	RzILOpPure *op_EQ_90 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_48), SN(32, 0), SN(32, 0x20)), op_RSHIFT_89);
	RzILOpPure *op_RSHIFT_133 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_135 = LOGAND(op_RSHIFT_133, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_146 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_149 = LOGAND(op_RSHIFT_146, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_157 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_135), DUP(op_AND_135))), CAST(32, MSB(DUP(op_AND_135)), DUP(op_AND_135)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_135)), DUP(op_AND_135))), CAST(32, MSB(DUP(op_AND_135)), DUP(op_AND_135))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_135)), DUP(op_AND_135))), CAST(32, MSB(DUP(op_AND_135)), DUP(op_AND_135)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_135)), DUP(op_AND_135))), CAST(32, MSB(DUP(op_AND_135)), DUP(op_AND_135)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_149)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_160 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_157), SN(32, 1));
	RzILOpPure *op_ADD_163 = ADD(op_LSHIFT_160, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_165 = SHIFTRA(op_ADD_163, SN(32, 16));
	RzILOpPure *op_LT_168 = SLT(op_RSHIFT_165, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_173 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_174 = NEG(op_LSHIFT_173);
	RzILOpPure *op_LSHIFT_179 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_182 = SUB(op_LSHIFT_179, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_183 = ITE(op_LT_168, op_NEG_174, op_SUB_182);
	RzILOpEffect *gcc_expr_184 = BRANCH(op_EQ_90, EMPTY(), set_usr_field_call_129);

	// h_tmp326 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_186 = SETL("h_tmp326", cond_183);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st6 ...;
	RzILOpEffect *seq_187 = SEQN(2, gcc_expr_184, op_ASSIGN_hybrid_tmp_186);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)) ? ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10) : h_tmp326) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_94 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_96 = LOGAND(op_RSHIFT_94, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_107 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_110 = LOGAND(op_RSHIFT_107, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_118 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_96), DUP(op_AND_96))), CAST(32, MSB(DUP(op_AND_96)), DUP(op_AND_96)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_96)), DUP(op_AND_96))), CAST(32, MSB(DUP(op_AND_96)), DUP(op_AND_96))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_96)), DUP(op_AND_96))), CAST(32, MSB(DUP(op_AND_96)), DUP(op_AND_96)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_96)), DUP(op_AND_96))), CAST(32, MSB(DUP(op_AND_96)), DUP(op_AND_96)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_110)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_121 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_118), SN(32, 1));
	RzILOpPure *op_ADD_124 = ADD(op_LSHIFT_121, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_126 = SHIFTRA(op_ADD_124, SN(32, 16));
	RzILOpPure *cond_188 = ITE(DUP(op_EQ_90), op_RSHIFT_126, VARL("h_tmp326"));
	RzILOpPure *op_AND_190 = LOGAND(cond_188, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_194 = SHIFTL0(op_AND_190, SN(32, 0x20));
	RzILOpPure *op_OR_195 = LOGOR(op_AND_7, op_LSHIFT_194);
	RzILOpEffect *op_ASSIGN_196 = WRITE_REG(bundle, Rdd_op, op_OR_195);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ( ...;
	RzILOpEffect *seq_197 = SEQN(2, seq_187, op_ASSIGN_196);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_325 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_212 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_214 = LOGAND(op_RSHIFT_212, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_225 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_228 = LOGAND(op_RSHIFT_225, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_236 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_214), DUP(op_AND_214))), CAST(32, MSB(DUP(op_AND_214)), DUP(op_AND_214)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_214)), DUP(op_AND_214))), CAST(32, MSB(DUP(op_AND_214)), DUP(op_AND_214))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_214)), DUP(op_AND_214))), CAST(32, MSB(DUP(op_AND_214)), DUP(op_AND_214)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_214)), DUP(op_AND_214))), CAST(32, MSB(DUP(op_AND_214)), DUP(op_AND_214)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_228)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_239 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_236), SN(32, 1));
	RzILOpPure *op_ADD_242 = ADD(op_LSHIFT_239, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_244 = SHIFTRA(op_ADD_242, SN(32, 16));
	RzILOpPure *op_RSHIFT_253 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_255 = LOGAND(op_RSHIFT_253, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_266 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_269 = LOGAND(op_RSHIFT_266, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_277 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_255), DUP(op_AND_255))), CAST(32, MSB(DUP(op_AND_255)), DUP(op_AND_255)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_255)), DUP(op_AND_255))), CAST(32, MSB(DUP(op_AND_255)), DUP(op_AND_255))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_255)), DUP(op_AND_255))), CAST(32, MSB(DUP(op_AND_255)), DUP(op_AND_255)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_255)), DUP(op_AND_255))), CAST(32, MSB(DUP(op_AND_255)), DUP(op_AND_255)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_269)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_280 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_277), SN(32, 1));
	RzILOpPure *op_ADD_283 = ADD(op_LSHIFT_280, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_285 = SHIFTRA(op_ADD_283, SN(32, 16));
	RzILOpPure *op_EQ_286 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_244), SN(32, 0), SN(32, 0x20)), op_RSHIFT_285);
	RzILOpPure *op_RSHIFT_329 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_331 = LOGAND(op_RSHIFT_329, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_342 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_345 = LOGAND(op_RSHIFT_342, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_353 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_331), DUP(op_AND_331))), CAST(32, MSB(DUP(op_AND_331)), DUP(op_AND_331)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_331)), DUP(op_AND_331))), CAST(32, MSB(DUP(op_AND_331)), DUP(op_AND_331))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_331)), DUP(op_AND_331))), CAST(32, MSB(DUP(op_AND_331)), DUP(op_AND_331)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_331)), DUP(op_AND_331))), CAST(32, MSB(DUP(op_AND_331)), DUP(op_AND_331)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_345)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_356 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_353), SN(32, 1));
	RzILOpPure *op_ADD_359 = ADD(op_LSHIFT_356, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_361 = SHIFTRA(op_ADD_359, SN(32, 16));
	RzILOpPure *op_LT_364 = SLT(op_RSHIFT_361, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_369 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_370 = NEG(op_LSHIFT_369);
	RzILOpPure *op_LSHIFT_375 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_378 = SUB(op_LSHIFT_375, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_379 = ITE(op_LT_364, op_NEG_370, op_SUB_378);
	RzILOpEffect *gcc_expr_380 = BRANCH(op_EQ_286, EMPTY(), set_usr_field_call_325);

	// h_tmp327 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_382 = SETL("h_tmp327", cond_379);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st6 ...;
	RzILOpEffect *seq_383 = SEQN(2, gcc_expr_380, op_ASSIGN_hybrid_tmp_382);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10)) ? ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) + ((st64) 0x8000) >> 0x10) : h_tmp327) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_203 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_204 = LOGNOT(op_LSHIFT_203);
	RzILOpPure *op_AND_205 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_204);
	RzILOpPure *op_RSHIFT_290 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_292 = LOGAND(op_RSHIFT_290, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_303 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_306 = LOGAND(op_RSHIFT_303, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_314 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_292), DUP(op_AND_292))), CAST(32, MSB(DUP(op_AND_292)), DUP(op_AND_292)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_292)), DUP(op_AND_292))), CAST(32, MSB(DUP(op_AND_292)), DUP(op_AND_292))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_292)), DUP(op_AND_292))), CAST(32, MSB(DUP(op_AND_292)), DUP(op_AND_292)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_292)), DUP(op_AND_292))), CAST(32, MSB(DUP(op_AND_292)), DUP(op_AND_292)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_306)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_317 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_314), SN(32, 1));
	RzILOpPure *op_ADD_320 = ADD(op_LSHIFT_317, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_322 = SHIFTRA(op_ADD_320, SN(32, 16));
	RzILOpPure *cond_384 = ITE(DUP(op_EQ_286), op_RSHIFT_322, VARL("h_tmp327"));
	RzILOpPure *op_AND_386 = LOGAND(cond_384, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_390 = SHIFTL0(op_AND_386, SN(32, 0));
	RzILOpPure *op_OR_391 = LOGOR(op_AND_205, op_LSHIFT_390);
	RzILOpEffect *op_ASSIGN_392 = WRITE_REG(bundle, Rdd_op, op_OR_391);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ( ...;
	RzILOpEffect *seq_393 = SEQN(2, seq_383, op_ASSIGN_392);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_197, seq_393);
	return instruction_sequence;
}

// Rdd = vmpyweuh(Rss,Rtt):sat
RzILOpEffect *hex_il_op_m2_mmpyul_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_120 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_17 = LOGAND(op_RSHIFT_15, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_29 = SHIFTRA(Rtt, SN(32, 0x20));
	RzILOpPure *op_AND_32 = LOGAND(op_RSHIFT_29, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_40 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_17), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_32)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_43 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_40), SN(32, 0));
	RzILOpPure *op_RSHIFT_45 = SHIFTRA(op_LSHIFT_43, SN(32, 16));
	RzILOpPure *op_RSHIFT_54 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_56 = LOGAND(op_RSHIFT_54, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_67 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_70 = LOGAND(op_RSHIFT_67, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_78 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_56), DUP(op_AND_56))), CAST(32, MSB(DUP(op_AND_56)), DUP(op_AND_56)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_56)), DUP(op_AND_56))), CAST(32, MSB(DUP(op_AND_56)), DUP(op_AND_56))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_56)), DUP(op_AND_56))), CAST(32, MSB(DUP(op_AND_56)), DUP(op_AND_56)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_56)), DUP(op_AND_56))), CAST(32, MSB(DUP(op_AND_56)), DUP(op_AND_56)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_70)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_81 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_78), SN(32, 0));
	RzILOpPure *op_RSHIFT_83 = SHIFTRA(op_LSHIFT_81, SN(32, 16));
	RzILOpPure *op_EQ_84 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_45), SN(32, 0), SN(32, 0x20)), op_RSHIFT_83);
	RzILOpPure *op_RSHIFT_124 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_126 = LOGAND(op_RSHIFT_124, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_137 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_140 = LOGAND(op_RSHIFT_137, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_148 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_126), DUP(op_AND_126))), CAST(32, MSB(DUP(op_AND_126)), DUP(op_AND_126)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_126)), DUP(op_AND_126))), CAST(32, MSB(DUP(op_AND_126)), DUP(op_AND_126))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_126)), DUP(op_AND_126))), CAST(32, MSB(DUP(op_AND_126)), DUP(op_AND_126)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_126)), DUP(op_AND_126))), CAST(32, MSB(DUP(op_AND_126)), DUP(op_AND_126)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_140)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_151 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_148), SN(32, 0));
	RzILOpPure *op_RSHIFT_153 = SHIFTRA(op_LSHIFT_151, SN(32, 16));
	RzILOpPure *op_LT_156 = SLT(op_RSHIFT_153, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_161 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_162 = NEG(op_LSHIFT_161);
	RzILOpPure *op_LSHIFT_167 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_170 = SUB(op_LSHIFT_167, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_171 = ITE(op_LT_156, op_NEG_162, op_SUB_170);
	RzILOpEffect *gcc_expr_172 = BRANCH(op_EQ_84, EMPTY(), set_usr_field_call_120);

	// h_tmp328 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_174 = SETL("h_tmp328", cond_171);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st6 ...;
	RzILOpEffect *seq_175 = SEQN(2, gcc_expr_172, op_ASSIGN_hybrid_tmp_174);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)) ? ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10) : h_tmp328) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_88 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_90 = LOGAND(op_RSHIFT_88, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_101 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_104 = LOGAND(op_RSHIFT_101, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_112 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_90), DUP(op_AND_90))), CAST(32, MSB(DUP(op_AND_90)), DUP(op_AND_90)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_90)), DUP(op_AND_90))), CAST(32, MSB(DUP(op_AND_90)), DUP(op_AND_90))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_90)), DUP(op_AND_90))), CAST(32, MSB(DUP(op_AND_90)), DUP(op_AND_90)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_90)), DUP(op_AND_90))), CAST(32, MSB(DUP(op_AND_90)), DUP(op_AND_90)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_104)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_115 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_112), SN(32, 0));
	RzILOpPure *op_RSHIFT_117 = SHIFTRA(op_LSHIFT_115, SN(32, 16));
	RzILOpPure *cond_176 = ITE(DUP(op_EQ_84), op_RSHIFT_117, VARL("h_tmp328"));
	RzILOpPure *op_AND_178 = LOGAND(cond_176, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_182 = SHIFTL0(op_AND_178, SN(32, 0x20));
	RzILOpPure *op_OR_183 = LOGOR(op_AND_7, op_LSHIFT_182);
	RzILOpEffect *op_ASSIGN_184 = WRITE_REG(bundle, Rdd_op, op_OR_183);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ( ...;
	RzILOpEffect *seq_185 = SEQN(2, seq_175, op_ASSIGN_184);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_304 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_200 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_202 = LOGAND(op_RSHIFT_200, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_213 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_216 = LOGAND(op_RSHIFT_213, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_224 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_202), DUP(op_AND_202))), CAST(32, MSB(DUP(op_AND_202)), DUP(op_AND_202)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_202)), DUP(op_AND_202))), CAST(32, MSB(DUP(op_AND_202)), DUP(op_AND_202))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_202)), DUP(op_AND_202))), CAST(32, MSB(DUP(op_AND_202)), DUP(op_AND_202)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_202)), DUP(op_AND_202))), CAST(32, MSB(DUP(op_AND_202)), DUP(op_AND_202)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_216)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_227 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_224), SN(32, 0));
	RzILOpPure *op_RSHIFT_229 = SHIFTRA(op_LSHIFT_227, SN(32, 16));
	RzILOpPure *op_RSHIFT_238 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_240 = LOGAND(op_RSHIFT_238, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_251 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_254 = LOGAND(op_RSHIFT_251, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_262 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_240), DUP(op_AND_240))), CAST(32, MSB(DUP(op_AND_240)), DUP(op_AND_240)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_240)), DUP(op_AND_240))), CAST(32, MSB(DUP(op_AND_240)), DUP(op_AND_240))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_240)), DUP(op_AND_240))), CAST(32, MSB(DUP(op_AND_240)), DUP(op_AND_240)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_240)), DUP(op_AND_240))), CAST(32, MSB(DUP(op_AND_240)), DUP(op_AND_240)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_254)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_265 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_262), SN(32, 0));
	RzILOpPure *op_RSHIFT_267 = SHIFTRA(op_LSHIFT_265, SN(32, 16));
	RzILOpPure *op_EQ_268 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_229), SN(32, 0), SN(32, 0x20)), op_RSHIFT_267);
	RzILOpPure *op_RSHIFT_308 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_310 = LOGAND(op_RSHIFT_308, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_321 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_324 = LOGAND(op_RSHIFT_321, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_332 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_310), DUP(op_AND_310))), CAST(32, MSB(DUP(op_AND_310)), DUP(op_AND_310)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_310)), DUP(op_AND_310))), CAST(32, MSB(DUP(op_AND_310)), DUP(op_AND_310))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_310)), DUP(op_AND_310))), CAST(32, MSB(DUP(op_AND_310)), DUP(op_AND_310)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_310)), DUP(op_AND_310))), CAST(32, MSB(DUP(op_AND_310)), DUP(op_AND_310)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_324)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_335 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_332), SN(32, 0));
	RzILOpPure *op_RSHIFT_337 = SHIFTRA(op_LSHIFT_335, SN(32, 16));
	RzILOpPure *op_LT_340 = SLT(op_RSHIFT_337, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_345 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_346 = NEG(op_LSHIFT_345);
	RzILOpPure *op_LSHIFT_351 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_354 = SUB(op_LSHIFT_351, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_355 = ITE(op_LT_340, op_NEG_346, op_SUB_354);
	RzILOpEffect *gcc_expr_356 = BRANCH(op_EQ_268, EMPTY(), set_usr_field_call_304);

	// h_tmp329 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_358 = SETL("h_tmp329", cond_355);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st6 ...;
	RzILOpEffect *seq_359 = SEQN(2, gcc_expr_356, op_ASSIGN_hybrid_tmp_358);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10)) ? ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x0) >> 0x10) : h_tmp329) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_191 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_192 = LOGNOT(op_LSHIFT_191);
	RzILOpPure *op_AND_193 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_192);
	RzILOpPure *op_RSHIFT_272 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_274 = LOGAND(op_RSHIFT_272, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_285 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_288 = LOGAND(op_RSHIFT_285, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_296 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_274), DUP(op_AND_274))), CAST(32, MSB(DUP(op_AND_274)), DUP(op_AND_274)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_274)), DUP(op_AND_274))), CAST(32, MSB(DUP(op_AND_274)), DUP(op_AND_274))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_274)), DUP(op_AND_274))), CAST(32, MSB(DUP(op_AND_274)), DUP(op_AND_274)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_274)), DUP(op_AND_274))), CAST(32, MSB(DUP(op_AND_274)), DUP(op_AND_274)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_288)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_299 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_296), SN(32, 0));
	RzILOpPure *op_RSHIFT_301 = SHIFTRA(op_LSHIFT_299, SN(32, 16));
	RzILOpPure *cond_360 = ITE(DUP(op_EQ_268), op_RSHIFT_301, VARL("h_tmp329"));
	RzILOpPure *op_AND_362 = LOGAND(cond_360, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_366 = SHIFTL0(op_AND_362, SN(32, 0));
	RzILOpPure *op_OR_367 = LOGOR(op_AND_193, op_LSHIFT_366);
	RzILOpEffect *op_ASSIGN_368 = WRITE_REG(bundle, Rdd_op, op_OR_367);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ( ...;
	RzILOpEffect *seq_369 = SEQN(2, seq_359, op_ASSIGN_368);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_185, seq_369);
	return instruction_sequence;
}

// Rdd = vmpyweuh(Rss,Rtt):<<1:sat
RzILOpEffect *hex_il_op_m2_mmpyul_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_120 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rss, SN(32, 0x20));
	RzILOpPure *op_AND_17 = LOGAND(op_RSHIFT_15, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_29 = SHIFTRA(Rtt, SN(32, 0x20));
	RzILOpPure *op_AND_32 = LOGAND(op_RSHIFT_29, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_40 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_17), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(DUP(op_AND_17)), DUP(op_AND_17)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_32)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_43 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_40), SN(32, 1));
	RzILOpPure *op_RSHIFT_45 = SHIFTRA(op_LSHIFT_43, SN(32, 16));
	RzILOpPure *op_RSHIFT_54 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_56 = LOGAND(op_RSHIFT_54, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_67 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_70 = LOGAND(op_RSHIFT_67, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_78 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_56), DUP(op_AND_56))), CAST(32, MSB(DUP(op_AND_56)), DUP(op_AND_56)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_56)), DUP(op_AND_56))), CAST(32, MSB(DUP(op_AND_56)), DUP(op_AND_56))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_56)), DUP(op_AND_56))), CAST(32, MSB(DUP(op_AND_56)), DUP(op_AND_56)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_56)), DUP(op_AND_56))), CAST(32, MSB(DUP(op_AND_56)), DUP(op_AND_56)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_70)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_81 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_78), SN(32, 1));
	RzILOpPure *op_RSHIFT_83 = SHIFTRA(op_LSHIFT_81, SN(32, 16));
	RzILOpPure *op_EQ_84 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_45), SN(32, 0), SN(32, 0x20)), op_RSHIFT_83);
	RzILOpPure *op_RSHIFT_124 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_126 = LOGAND(op_RSHIFT_124, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_137 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_140 = LOGAND(op_RSHIFT_137, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_148 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_126), DUP(op_AND_126))), CAST(32, MSB(DUP(op_AND_126)), DUP(op_AND_126)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_126)), DUP(op_AND_126))), CAST(32, MSB(DUP(op_AND_126)), DUP(op_AND_126))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_126)), DUP(op_AND_126))), CAST(32, MSB(DUP(op_AND_126)), DUP(op_AND_126)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_126)), DUP(op_AND_126))), CAST(32, MSB(DUP(op_AND_126)), DUP(op_AND_126)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_140)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_151 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_148), SN(32, 1));
	RzILOpPure *op_RSHIFT_153 = SHIFTRA(op_LSHIFT_151, SN(32, 16));
	RzILOpPure *op_LT_156 = SLT(op_RSHIFT_153, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_161 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_162 = NEG(op_LSHIFT_161);
	RzILOpPure *op_LSHIFT_167 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_170 = SUB(op_LSHIFT_167, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_171 = ITE(op_LT_156, op_NEG_162, op_SUB_170);
	RzILOpEffect *gcc_expr_172 = BRANCH(op_EQ_84, EMPTY(), set_usr_field_call_120);

	// h_tmp330 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_174 = SETL("h_tmp330", cond_171);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st6 ...;
	RzILOpEffect *seq_175 = SEQN(2, gcc_expr_172, op_ASSIGN_hybrid_tmp_174);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)) ? ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x20) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x20) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10) : h_tmp330) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_88 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_90 = LOGAND(op_RSHIFT_88, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_101 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_104 = LOGAND(op_RSHIFT_101, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_112 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_90), DUP(op_AND_90))), CAST(32, MSB(DUP(op_AND_90)), DUP(op_AND_90)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_90)), DUP(op_AND_90))), CAST(32, MSB(DUP(op_AND_90)), DUP(op_AND_90))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_90)), DUP(op_AND_90))), CAST(32, MSB(DUP(op_AND_90)), DUP(op_AND_90)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_90)), DUP(op_AND_90))), CAST(32, MSB(DUP(op_AND_90)), DUP(op_AND_90)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_104)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_115 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_112), SN(32, 1));
	RzILOpPure *op_RSHIFT_117 = SHIFTRA(op_LSHIFT_115, SN(32, 16));
	RzILOpPure *cond_176 = ITE(DUP(op_EQ_84), op_RSHIFT_117, VARL("h_tmp330"));
	RzILOpPure *op_AND_178 = LOGAND(cond_176, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_182 = SHIFTL0(op_AND_178, SN(32, 0x20));
	RzILOpPure *op_OR_183 = LOGOR(op_AND_7, op_LSHIFT_182);
	RzILOpEffect *op_ASSIGN_184 = WRITE_REG(bundle, Rdd_op, op_OR_183);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ( ...;
	RzILOpEffect *seq_185 = SEQN(2, seq_175, op_ASSIGN_184);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_304 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_200 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_202 = LOGAND(op_RSHIFT_200, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_213 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_216 = LOGAND(op_RSHIFT_213, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_224 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_202), DUP(op_AND_202))), CAST(32, MSB(DUP(op_AND_202)), DUP(op_AND_202)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_202)), DUP(op_AND_202))), CAST(32, MSB(DUP(op_AND_202)), DUP(op_AND_202))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_202)), DUP(op_AND_202))), CAST(32, MSB(DUP(op_AND_202)), DUP(op_AND_202)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_202)), DUP(op_AND_202))), CAST(32, MSB(DUP(op_AND_202)), DUP(op_AND_202)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_216)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_227 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_224), SN(32, 1));
	RzILOpPure *op_RSHIFT_229 = SHIFTRA(op_LSHIFT_227, SN(32, 16));
	RzILOpPure *op_RSHIFT_238 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_240 = LOGAND(op_RSHIFT_238, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_251 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_254 = LOGAND(op_RSHIFT_251, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_262 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_240), DUP(op_AND_240))), CAST(32, MSB(DUP(op_AND_240)), DUP(op_AND_240)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_240)), DUP(op_AND_240))), CAST(32, MSB(DUP(op_AND_240)), DUP(op_AND_240))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_240)), DUP(op_AND_240))), CAST(32, MSB(DUP(op_AND_240)), DUP(op_AND_240)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_240)), DUP(op_AND_240))), CAST(32, MSB(DUP(op_AND_240)), DUP(op_AND_240)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_254)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_265 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_262), SN(32, 1));
	RzILOpPure *op_RSHIFT_267 = SHIFTRA(op_LSHIFT_265, SN(32, 16));
	RzILOpPure *op_EQ_268 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_229), SN(32, 0), SN(32, 0x20)), op_RSHIFT_267);
	RzILOpPure *op_RSHIFT_308 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_310 = LOGAND(op_RSHIFT_308, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_321 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_324 = LOGAND(op_RSHIFT_321, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_332 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_310), DUP(op_AND_310))), CAST(32, MSB(DUP(op_AND_310)), DUP(op_AND_310)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_310)), DUP(op_AND_310))), CAST(32, MSB(DUP(op_AND_310)), DUP(op_AND_310))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_310)), DUP(op_AND_310))), CAST(32, MSB(DUP(op_AND_310)), DUP(op_AND_310)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_310)), DUP(op_AND_310))), CAST(32, MSB(DUP(op_AND_310)), DUP(op_AND_310)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_324)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_335 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_332), SN(32, 1));
	RzILOpPure *op_RSHIFT_337 = SHIFTRA(op_LSHIFT_335, SN(32, 16));
	RzILOpPure *op_LT_340 = SLT(op_RSHIFT_337, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_345 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_346 = NEG(op_LSHIFT_345);
	RzILOpPure *op_LSHIFT_351 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_354 = SUB(op_LSHIFT_351, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_355 = ITE(op_LT_340, op_NEG_346, op_SUB_354);
	RzILOpEffect *gcc_expr_356 = BRANCH(op_EQ_268, EMPTY(), set_usr_field_call_304);

	// h_tmp331 = HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_358 = SETL("h_tmp331", cond_355);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ((st6 ...;
	RzILOpEffect *seq_359 = SEQN(2, gcc_expr_356, op_ASSIGN_hybrid_tmp_358);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)), 0x0, 0x20) == ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10)) ? ((((st64) ((ut64) ((st64) ((st32) ((st64) ((st32) ((Rss >> 0x0) & 0xffffffff)))))) * extract64(((ut64) ((ut16) ((Rtt >> 0x0) & ((st64) 0xffff)))), 0x0, 0x10)) << 0x1) >> 0x10) : h_tmp331) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_191 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_192 = LOGNOT(op_LSHIFT_191);
	RzILOpPure *op_AND_193 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_192);
	RzILOpPure *op_RSHIFT_272 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_274 = LOGAND(op_RSHIFT_272, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_285 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_288 = LOGAND(op_RSHIFT_285, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_296 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(op_AND_274), DUP(op_AND_274))), CAST(32, MSB(DUP(op_AND_274)), DUP(op_AND_274)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_274)), DUP(op_AND_274))), CAST(32, MSB(DUP(op_AND_274)), DUP(op_AND_274))))), CAST(32, MSB(CAST(64, MSB(CAST(32, MSB(DUP(op_AND_274)), DUP(op_AND_274))), CAST(32, MSB(DUP(op_AND_274)), DUP(op_AND_274)))), CAST(64, MSB(CAST(32, MSB(DUP(op_AND_274)), DUP(op_AND_274))), CAST(32, MSB(DUP(op_AND_274)), DUP(op_AND_274)))))), EXTRACT64(CAST(64, IL_FALSE, CAST(16, IL_FALSE, op_AND_288)), SN(32, 0), SN(32, 16)));
	RzILOpPure *op_LSHIFT_299 = SHIFTL0(CAST(64, IL_FALSE, op_MUL_296), SN(32, 1));
	RzILOpPure *op_RSHIFT_301 = SHIFTRA(op_LSHIFT_299, SN(32, 16));
	RzILOpPure *cond_360 = ITE(DUP(op_EQ_268), op_RSHIFT_301, VARL("h_tmp331"));
	RzILOpPure *op_AND_362 = LOGAND(cond_360, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_366 = SHIFTL0(op_AND_362, SN(32, 0));
	RzILOpPure *op_OR_367 = LOGOR(op_AND_193, op_LSHIFT_366);
	RzILOpEffect *op_ASSIGN_368 = WRITE_REG(bundle, Rdd_op, op_OR_367);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((((st64) ((ut64) ( ...;
	RzILOpEffect *seq_369 = SEQN(2, seq_359, op_ASSIGN_368);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_185, seq_369);
	return instruction_sequence;
}

// Rx -= mpyi(Rs,Rt)
RzILOpEffect *hex_il_op_m2_mnaci(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = Rx - Rs * Rt;
	RzILOpPure *op_MUL_3 = MUL(Rs, Rt);
	RzILOpPure *op_SUB_4 = SUB(READ_REG(pkt, Rx_op, false), op_MUL_3);
	RzILOpEffect *op_ASSIGN_5 = WRITE_REG(bundle, Rx_op, op_SUB_4);

	RzILOpEffect *instruction_sequence = op_ASSIGN_5;
	return instruction_sequence;
}

// Rx += mpy(Rs.h,Rt.h)
RzILOpEffect *hex_il_op_m2_mpy_acc_hh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_ADD_22 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(op_ADD_22), DUP(op_ADD_22)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rx += mpy(Rs.h,Rt.h):<<1
RzILOpEffect *hex_il_op_m2_mpy_acc_hh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpPure *op_ADD_24 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_22);
	RzILOpEffect *op_ASSIGN_26 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(op_ADD_24), DUP(op_ADD_24)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_26;
	return instruction_sequence;
}

// Rx += mpy(Rs.h,Rt.l)
RzILOpEffect *hex_il_op_m2_mpy_acc_hl_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_ADD_22 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(op_ADD_22), DUP(op_ADD_22)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rx += mpy(Rs.h,Rt.l):<<1
RzILOpEffect *hex_il_op_m2_mpy_acc_hl_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpPure *op_ADD_24 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_22);
	RzILOpEffect *op_ASSIGN_26 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(op_ADD_24), DUP(op_ADD_24)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_26;
	return instruction_sequence;
}

// Rx += mpy(Rs.l,Rt.h)
RzILOpEffect *hex_il_op_m2_mpy_acc_lh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_ADD_22 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(op_ADD_22), DUP(op_ADD_22)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rx += mpy(Rs.l,Rt.h):<<1
RzILOpEffect *hex_il_op_m2_mpy_acc_lh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpPure *op_ADD_24 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_22);
	RzILOpEffect *op_ASSIGN_26 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(op_ADD_24), DUP(op_ADD_24)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_26;
	return instruction_sequence;
}

// Rx += mpy(Rs.l,Rt.l)
RzILOpEffect *hex_il_op_m2_mpy_acc_ll_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_ADD_22 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(op_ADD_22), DUP(op_ADD_22)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rx += mpy(Rs.l,Rt.l):<<1
RzILOpEffect *hex_il_op_m2_mpy_acc_ll_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpPure *op_ADD_24 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_22);
	RzILOpEffect *op_ASSIGN_26 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(op_ADD_24), DUP(op_ADD_24)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_26;
	return instruction_sequence;
}

// Rx += mpy(Rs.h,Rt.h):sat
RzILOpEffect *hex_il_op_m2_mpy_acc_sat_hh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_74 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))))), 0x0, 0x20) == ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_ADD_25 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_22), DUP(op_MUL_22)));
	RzILOpPure *op_RSHIFT_34 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_36 = LOGAND(op_RSHIFT_34, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_42 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_44 = LOGAND(op_RSHIFT_42, SN(32, 0xffff));
	RzILOpPure *op_MUL_47 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_36), DUP(op_AND_36))), CAST(16, MSB(DUP(op_AND_36)), DUP(op_AND_36))), CAST(32, MSB(CAST(16, MSB(op_AND_44), DUP(op_AND_44))), CAST(16, MSB(DUP(op_AND_44)), DUP(op_AND_44))));
	RzILOpPure *op_ADD_50 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_47), DUP(op_MUL_47)));
	RzILOpPure *op_EQ_51 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_25), SN(32, 0), SN(32, 0x20)), op_ADD_50);
	RzILOpPure *op_RSHIFT_78 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_80 = LOGAND(op_RSHIFT_78, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_86 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_88 = LOGAND(op_RSHIFT_86, SN(32, 0xffff));
	RzILOpPure *op_MUL_91 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_80), DUP(op_AND_80))), CAST(16, MSB(DUP(op_AND_80)), DUP(op_AND_80))), CAST(32, MSB(CAST(16, MSB(op_AND_88), DUP(op_AND_88))), CAST(16, MSB(DUP(op_AND_88)), DUP(op_AND_88))));
	RzILOpPure *op_ADD_94 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_91), DUP(op_MUL_91)));
	RzILOpPure *op_LT_97 = SLT(op_ADD_94, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_102 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_103 = NEG(op_LSHIFT_102);
	RzILOpPure *op_LSHIFT_108 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_111 = SUB(op_LSHIFT_108, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_112 = ITE(op_LT_97, op_NEG_103, op_SUB_111);
	RzILOpEffect *gcc_expr_113 = BRANCH(op_EQ_51, EMPTY(), set_usr_field_call_74);

	// h_tmp332 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))))), 0x0, 0x20) == ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_115 = SETL("h_tmp332", cond_112);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + ((st64) ( ...;
	RzILOpEffect *seq_116 = SEQN(2, gcc_expr_113, op_ASSIGN_hybrid_tmp_115);

	// Rx = ((st32) ((sextract64(((ut64) ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))))), 0x0, 0x20) == ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))))) ? ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) : h_tmp332));
	RzILOpPure *op_RSHIFT_55 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_57 = LOGAND(op_RSHIFT_55, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_63 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_65 = LOGAND(op_RSHIFT_63, SN(32, 0xffff));
	RzILOpPure *op_MUL_68 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_57), DUP(op_AND_57))), CAST(16, MSB(DUP(op_AND_57)), DUP(op_AND_57))), CAST(32, MSB(CAST(16, MSB(op_AND_65), DUP(op_AND_65))), CAST(16, MSB(DUP(op_AND_65)), DUP(op_AND_65))));
	RzILOpPure *op_ADD_71 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_68), DUP(op_MUL_68)));
	RzILOpPure *cond_117 = ITE(DUP(op_EQ_51), op_ADD_71, VARL("h_tmp332"));
	RzILOpEffect *op_ASSIGN_119 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(cond_117), DUP(cond_117)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + ((st6 ...;
	RzILOpEffect *seq_120 = SEQN(2, seq_116, op_ASSIGN_119);

	RzILOpEffect *instruction_sequence = seq_120;
	return instruction_sequence;
}

// Rx += mpy(Rs.h,Rt.h):<<1:sat
RzILOpEffect *hex_il_op_m2_mpy_acc_sat_hh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_80 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_LSHIFT_25 = SHIFTL0(CAST(64, MSB(op_MUL_22), DUP(op_MUL_22)), SN(32, 1));
	RzILOpPure *op_ADD_27 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_25);
	RzILOpPure *op_RSHIFT_36 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_38 = LOGAND(op_RSHIFT_36, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_44 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_46 = LOGAND(op_RSHIFT_44, SN(32, 0xffff));
	RzILOpPure *op_MUL_49 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_38), DUP(op_AND_38))), CAST(16, MSB(DUP(op_AND_38)), DUP(op_AND_38))), CAST(32, MSB(CAST(16, MSB(op_AND_46), DUP(op_AND_46))), CAST(16, MSB(DUP(op_AND_46)), DUP(op_AND_46))));
	RzILOpPure *op_LSHIFT_52 = SHIFTL0(CAST(64, MSB(op_MUL_49), DUP(op_MUL_49)), SN(32, 1));
	RzILOpPure *op_ADD_54 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_52);
	RzILOpPure *op_EQ_55 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_27), SN(32, 0), SN(32, 0x20)), op_ADD_54);
	RzILOpPure *op_RSHIFT_84 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_86 = LOGAND(op_RSHIFT_84, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_92 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_94 = LOGAND(op_RSHIFT_92, SN(32, 0xffff));
	RzILOpPure *op_MUL_97 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_86), DUP(op_AND_86))), CAST(16, MSB(DUP(op_AND_86)), DUP(op_AND_86))), CAST(32, MSB(CAST(16, MSB(op_AND_94), DUP(op_AND_94))), CAST(16, MSB(DUP(op_AND_94)), DUP(op_AND_94))));
	RzILOpPure *op_LSHIFT_100 = SHIFTL0(CAST(64, MSB(op_MUL_97), DUP(op_MUL_97)), SN(32, 1));
	RzILOpPure *op_ADD_102 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_100);
	RzILOpPure *op_LT_105 = SLT(op_ADD_102, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_110 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_111 = NEG(op_LSHIFT_110);
	RzILOpPure *op_LSHIFT_116 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_119 = SUB(op_LSHIFT_116, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_120 = ITE(op_LT_105, op_NEG_111, op_SUB_119);
	RzILOpEffect *gcc_expr_121 = BRANCH(op_EQ_55, EMPTY(), set_usr_field_call_80);

	// h_tmp333 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_123 = SETL("h_tmp333", cond_120);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + (((st64)  ...;
	RzILOpEffect *seq_124 = SEQN(2, gcc_expr_121, op_ASSIGN_hybrid_tmp_123);

	// Rx = ((st32) ((sextract64(((ut64) ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)) ? ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) : h_tmp333));
	RzILOpPure *op_RSHIFT_59 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_61 = LOGAND(op_RSHIFT_59, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_67 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_69 = LOGAND(op_RSHIFT_67, SN(32, 0xffff));
	RzILOpPure *op_MUL_72 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_61), DUP(op_AND_61))), CAST(16, MSB(DUP(op_AND_61)), DUP(op_AND_61))), CAST(32, MSB(CAST(16, MSB(op_AND_69), DUP(op_AND_69))), CAST(16, MSB(DUP(op_AND_69)), DUP(op_AND_69))));
	RzILOpPure *op_LSHIFT_75 = SHIFTL0(CAST(64, MSB(op_MUL_72), DUP(op_MUL_72)), SN(32, 1));
	RzILOpPure *op_ADD_77 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_75);
	RzILOpPure *cond_125 = ITE(DUP(op_EQ_55), op_ADD_77, VARL("h_tmp333"));
	RzILOpEffect *op_ASSIGN_127 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(cond_125), DUP(cond_125)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + (((st ...;
	RzILOpEffect *seq_128 = SEQN(2, seq_124, op_ASSIGN_127);

	RzILOpEffect *instruction_sequence = seq_128;
	return instruction_sequence;
}

// Rx += mpy(Rs.h,Rt.l):sat
RzILOpEffect *hex_il_op_m2_mpy_acc_sat_hl_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_74 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))))), 0x0, 0x20) == ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_ADD_25 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_22), DUP(op_MUL_22)));
	RzILOpPure *op_RSHIFT_34 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_36 = LOGAND(op_RSHIFT_34, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_42 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_44 = LOGAND(op_RSHIFT_42, SN(32, 0xffff));
	RzILOpPure *op_MUL_47 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_36), DUP(op_AND_36))), CAST(16, MSB(DUP(op_AND_36)), DUP(op_AND_36))), CAST(32, MSB(CAST(16, MSB(op_AND_44), DUP(op_AND_44))), CAST(16, MSB(DUP(op_AND_44)), DUP(op_AND_44))));
	RzILOpPure *op_ADD_50 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_47), DUP(op_MUL_47)));
	RzILOpPure *op_EQ_51 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_25), SN(32, 0), SN(32, 0x20)), op_ADD_50);
	RzILOpPure *op_RSHIFT_78 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_80 = LOGAND(op_RSHIFT_78, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_86 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_88 = LOGAND(op_RSHIFT_86, SN(32, 0xffff));
	RzILOpPure *op_MUL_91 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_80), DUP(op_AND_80))), CAST(16, MSB(DUP(op_AND_80)), DUP(op_AND_80))), CAST(32, MSB(CAST(16, MSB(op_AND_88), DUP(op_AND_88))), CAST(16, MSB(DUP(op_AND_88)), DUP(op_AND_88))));
	RzILOpPure *op_ADD_94 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_91), DUP(op_MUL_91)));
	RzILOpPure *op_LT_97 = SLT(op_ADD_94, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_102 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_103 = NEG(op_LSHIFT_102);
	RzILOpPure *op_LSHIFT_108 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_111 = SUB(op_LSHIFT_108, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_112 = ITE(op_LT_97, op_NEG_103, op_SUB_111);
	RzILOpEffect *gcc_expr_113 = BRANCH(op_EQ_51, EMPTY(), set_usr_field_call_74);

	// h_tmp334 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))))), 0x0, 0x20) == ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_115 = SETL("h_tmp334", cond_112);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + ((st64) ( ...;
	RzILOpEffect *seq_116 = SEQN(2, gcc_expr_113, op_ASSIGN_hybrid_tmp_115);

	// Rx = ((st32) ((sextract64(((ut64) ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))))), 0x0, 0x20) == ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))))) ? ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) : h_tmp334));
	RzILOpPure *op_RSHIFT_55 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_57 = LOGAND(op_RSHIFT_55, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_63 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_65 = LOGAND(op_RSHIFT_63, SN(32, 0xffff));
	RzILOpPure *op_MUL_68 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_57), DUP(op_AND_57))), CAST(16, MSB(DUP(op_AND_57)), DUP(op_AND_57))), CAST(32, MSB(CAST(16, MSB(op_AND_65), DUP(op_AND_65))), CAST(16, MSB(DUP(op_AND_65)), DUP(op_AND_65))));
	RzILOpPure *op_ADD_71 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_68), DUP(op_MUL_68)));
	RzILOpPure *cond_117 = ITE(DUP(op_EQ_51), op_ADD_71, VARL("h_tmp334"));
	RzILOpEffect *op_ASSIGN_119 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(cond_117), DUP(cond_117)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + ((st6 ...;
	RzILOpEffect *seq_120 = SEQN(2, seq_116, op_ASSIGN_119);

	RzILOpEffect *instruction_sequence = seq_120;
	return instruction_sequence;
}

// Rx += mpy(Rs.h,Rt.l):<<1:sat
RzILOpEffect *hex_il_op_m2_mpy_acc_sat_hl_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_80 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_LSHIFT_25 = SHIFTL0(CAST(64, MSB(op_MUL_22), DUP(op_MUL_22)), SN(32, 1));
	RzILOpPure *op_ADD_27 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_25);
	RzILOpPure *op_RSHIFT_36 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_38 = LOGAND(op_RSHIFT_36, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_44 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_46 = LOGAND(op_RSHIFT_44, SN(32, 0xffff));
	RzILOpPure *op_MUL_49 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_38), DUP(op_AND_38))), CAST(16, MSB(DUP(op_AND_38)), DUP(op_AND_38))), CAST(32, MSB(CAST(16, MSB(op_AND_46), DUP(op_AND_46))), CAST(16, MSB(DUP(op_AND_46)), DUP(op_AND_46))));
	RzILOpPure *op_LSHIFT_52 = SHIFTL0(CAST(64, MSB(op_MUL_49), DUP(op_MUL_49)), SN(32, 1));
	RzILOpPure *op_ADD_54 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_52);
	RzILOpPure *op_EQ_55 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_27), SN(32, 0), SN(32, 0x20)), op_ADD_54);
	RzILOpPure *op_RSHIFT_84 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_86 = LOGAND(op_RSHIFT_84, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_92 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_94 = LOGAND(op_RSHIFT_92, SN(32, 0xffff));
	RzILOpPure *op_MUL_97 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_86), DUP(op_AND_86))), CAST(16, MSB(DUP(op_AND_86)), DUP(op_AND_86))), CAST(32, MSB(CAST(16, MSB(op_AND_94), DUP(op_AND_94))), CAST(16, MSB(DUP(op_AND_94)), DUP(op_AND_94))));
	RzILOpPure *op_LSHIFT_100 = SHIFTL0(CAST(64, MSB(op_MUL_97), DUP(op_MUL_97)), SN(32, 1));
	RzILOpPure *op_ADD_102 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_100);
	RzILOpPure *op_LT_105 = SLT(op_ADD_102, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_110 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_111 = NEG(op_LSHIFT_110);
	RzILOpPure *op_LSHIFT_116 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_119 = SUB(op_LSHIFT_116, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_120 = ITE(op_LT_105, op_NEG_111, op_SUB_119);
	RzILOpEffect *gcc_expr_121 = BRANCH(op_EQ_55, EMPTY(), set_usr_field_call_80);

	// h_tmp335 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_123 = SETL("h_tmp335", cond_120);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + (((st64)  ...;
	RzILOpEffect *seq_124 = SEQN(2, gcc_expr_121, op_ASSIGN_hybrid_tmp_123);

	// Rx = ((st32) ((sextract64(((ut64) ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)) ? ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) : h_tmp335));
	RzILOpPure *op_RSHIFT_59 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_61 = LOGAND(op_RSHIFT_59, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_67 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_69 = LOGAND(op_RSHIFT_67, SN(32, 0xffff));
	RzILOpPure *op_MUL_72 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_61), DUP(op_AND_61))), CAST(16, MSB(DUP(op_AND_61)), DUP(op_AND_61))), CAST(32, MSB(CAST(16, MSB(op_AND_69), DUP(op_AND_69))), CAST(16, MSB(DUP(op_AND_69)), DUP(op_AND_69))));
	RzILOpPure *op_LSHIFT_75 = SHIFTL0(CAST(64, MSB(op_MUL_72), DUP(op_MUL_72)), SN(32, 1));
	RzILOpPure *op_ADD_77 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_75);
	RzILOpPure *cond_125 = ITE(DUP(op_EQ_55), op_ADD_77, VARL("h_tmp335"));
	RzILOpEffect *op_ASSIGN_127 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(cond_125), DUP(cond_125)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + (((st ...;
	RzILOpEffect *seq_128 = SEQN(2, seq_124, op_ASSIGN_127);

	RzILOpEffect *instruction_sequence = seq_128;
	return instruction_sequence;
}

// Rx += mpy(Rs.l,Rt.h):sat
RzILOpEffect *hex_il_op_m2_mpy_acc_sat_lh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_74 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))))), 0x0, 0x20) == ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_ADD_25 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_22), DUP(op_MUL_22)));
	RzILOpPure *op_RSHIFT_34 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_36 = LOGAND(op_RSHIFT_34, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_42 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_44 = LOGAND(op_RSHIFT_42, SN(32, 0xffff));
	RzILOpPure *op_MUL_47 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_36), DUP(op_AND_36))), CAST(16, MSB(DUP(op_AND_36)), DUP(op_AND_36))), CAST(32, MSB(CAST(16, MSB(op_AND_44), DUP(op_AND_44))), CAST(16, MSB(DUP(op_AND_44)), DUP(op_AND_44))));
	RzILOpPure *op_ADD_50 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_47), DUP(op_MUL_47)));
	RzILOpPure *op_EQ_51 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_25), SN(32, 0), SN(32, 0x20)), op_ADD_50);
	RzILOpPure *op_RSHIFT_78 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_80 = LOGAND(op_RSHIFT_78, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_86 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_88 = LOGAND(op_RSHIFT_86, SN(32, 0xffff));
	RzILOpPure *op_MUL_91 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_80), DUP(op_AND_80))), CAST(16, MSB(DUP(op_AND_80)), DUP(op_AND_80))), CAST(32, MSB(CAST(16, MSB(op_AND_88), DUP(op_AND_88))), CAST(16, MSB(DUP(op_AND_88)), DUP(op_AND_88))));
	RzILOpPure *op_ADD_94 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_91), DUP(op_MUL_91)));
	RzILOpPure *op_LT_97 = SLT(op_ADD_94, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_102 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_103 = NEG(op_LSHIFT_102);
	RzILOpPure *op_LSHIFT_108 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_111 = SUB(op_LSHIFT_108, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_112 = ITE(op_LT_97, op_NEG_103, op_SUB_111);
	RzILOpEffect *gcc_expr_113 = BRANCH(op_EQ_51, EMPTY(), set_usr_field_call_74);

	// h_tmp336 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))))), 0x0, 0x20) == ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_115 = SETL("h_tmp336", cond_112);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + ((st64) ( ...;
	RzILOpEffect *seq_116 = SEQN(2, gcc_expr_113, op_ASSIGN_hybrid_tmp_115);

	// Rx = ((st32) ((sextract64(((ut64) ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))))), 0x0, 0x20) == ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))))) ? ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) : h_tmp336));
	RzILOpPure *op_RSHIFT_55 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_57 = LOGAND(op_RSHIFT_55, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_63 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_65 = LOGAND(op_RSHIFT_63, SN(32, 0xffff));
	RzILOpPure *op_MUL_68 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_57), DUP(op_AND_57))), CAST(16, MSB(DUP(op_AND_57)), DUP(op_AND_57))), CAST(32, MSB(CAST(16, MSB(op_AND_65), DUP(op_AND_65))), CAST(16, MSB(DUP(op_AND_65)), DUP(op_AND_65))));
	RzILOpPure *op_ADD_71 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_68), DUP(op_MUL_68)));
	RzILOpPure *cond_117 = ITE(DUP(op_EQ_51), op_ADD_71, VARL("h_tmp336"));
	RzILOpEffect *op_ASSIGN_119 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(cond_117), DUP(cond_117)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + ((st6 ...;
	RzILOpEffect *seq_120 = SEQN(2, seq_116, op_ASSIGN_119);

	RzILOpEffect *instruction_sequence = seq_120;
	return instruction_sequence;
}

// Rx += mpy(Rs.l,Rt.h):<<1:sat
RzILOpEffect *hex_il_op_m2_mpy_acc_sat_lh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_80 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_LSHIFT_25 = SHIFTL0(CAST(64, MSB(op_MUL_22), DUP(op_MUL_22)), SN(32, 1));
	RzILOpPure *op_ADD_27 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_25);
	RzILOpPure *op_RSHIFT_36 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_38 = LOGAND(op_RSHIFT_36, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_44 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_46 = LOGAND(op_RSHIFT_44, SN(32, 0xffff));
	RzILOpPure *op_MUL_49 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_38), DUP(op_AND_38))), CAST(16, MSB(DUP(op_AND_38)), DUP(op_AND_38))), CAST(32, MSB(CAST(16, MSB(op_AND_46), DUP(op_AND_46))), CAST(16, MSB(DUP(op_AND_46)), DUP(op_AND_46))));
	RzILOpPure *op_LSHIFT_52 = SHIFTL0(CAST(64, MSB(op_MUL_49), DUP(op_MUL_49)), SN(32, 1));
	RzILOpPure *op_ADD_54 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_52);
	RzILOpPure *op_EQ_55 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_27), SN(32, 0), SN(32, 0x20)), op_ADD_54);
	RzILOpPure *op_RSHIFT_84 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_86 = LOGAND(op_RSHIFT_84, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_92 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_94 = LOGAND(op_RSHIFT_92, SN(32, 0xffff));
	RzILOpPure *op_MUL_97 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_86), DUP(op_AND_86))), CAST(16, MSB(DUP(op_AND_86)), DUP(op_AND_86))), CAST(32, MSB(CAST(16, MSB(op_AND_94), DUP(op_AND_94))), CAST(16, MSB(DUP(op_AND_94)), DUP(op_AND_94))));
	RzILOpPure *op_LSHIFT_100 = SHIFTL0(CAST(64, MSB(op_MUL_97), DUP(op_MUL_97)), SN(32, 1));
	RzILOpPure *op_ADD_102 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_100);
	RzILOpPure *op_LT_105 = SLT(op_ADD_102, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_110 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_111 = NEG(op_LSHIFT_110);
	RzILOpPure *op_LSHIFT_116 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_119 = SUB(op_LSHIFT_116, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_120 = ITE(op_LT_105, op_NEG_111, op_SUB_119);
	RzILOpEffect *gcc_expr_121 = BRANCH(op_EQ_55, EMPTY(), set_usr_field_call_80);

	// h_tmp337 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_123 = SETL("h_tmp337", cond_120);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + (((st64)  ...;
	RzILOpEffect *seq_124 = SEQN(2, gcc_expr_121, op_ASSIGN_hybrid_tmp_123);

	// Rx = ((st32) ((sextract64(((ut64) ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)) ? ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) : h_tmp337));
	RzILOpPure *op_RSHIFT_59 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_61 = LOGAND(op_RSHIFT_59, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_67 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_69 = LOGAND(op_RSHIFT_67, SN(32, 0xffff));
	RzILOpPure *op_MUL_72 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_61), DUP(op_AND_61))), CAST(16, MSB(DUP(op_AND_61)), DUP(op_AND_61))), CAST(32, MSB(CAST(16, MSB(op_AND_69), DUP(op_AND_69))), CAST(16, MSB(DUP(op_AND_69)), DUP(op_AND_69))));
	RzILOpPure *op_LSHIFT_75 = SHIFTL0(CAST(64, MSB(op_MUL_72), DUP(op_MUL_72)), SN(32, 1));
	RzILOpPure *op_ADD_77 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_75);
	RzILOpPure *cond_125 = ITE(DUP(op_EQ_55), op_ADD_77, VARL("h_tmp337"));
	RzILOpEffect *op_ASSIGN_127 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(cond_125), DUP(cond_125)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + (((st ...;
	RzILOpEffect *seq_128 = SEQN(2, seq_124, op_ASSIGN_127);

	RzILOpEffect *instruction_sequence = seq_128;
	return instruction_sequence;
}

// Rx += mpy(Rs.l,Rt.l):sat
RzILOpEffect *hex_il_op_m2_mpy_acc_sat_ll_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_74 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))))), 0x0, 0x20) == ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_ADD_25 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_22), DUP(op_MUL_22)));
	RzILOpPure *op_RSHIFT_34 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_36 = LOGAND(op_RSHIFT_34, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_42 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_44 = LOGAND(op_RSHIFT_42, SN(32, 0xffff));
	RzILOpPure *op_MUL_47 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_36), DUP(op_AND_36))), CAST(16, MSB(DUP(op_AND_36)), DUP(op_AND_36))), CAST(32, MSB(CAST(16, MSB(op_AND_44), DUP(op_AND_44))), CAST(16, MSB(DUP(op_AND_44)), DUP(op_AND_44))));
	RzILOpPure *op_ADD_50 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_47), DUP(op_MUL_47)));
	RzILOpPure *op_EQ_51 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_25), SN(32, 0), SN(32, 0x20)), op_ADD_50);
	RzILOpPure *op_RSHIFT_78 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_80 = LOGAND(op_RSHIFT_78, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_86 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_88 = LOGAND(op_RSHIFT_86, SN(32, 0xffff));
	RzILOpPure *op_MUL_91 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_80), DUP(op_AND_80))), CAST(16, MSB(DUP(op_AND_80)), DUP(op_AND_80))), CAST(32, MSB(CAST(16, MSB(op_AND_88), DUP(op_AND_88))), CAST(16, MSB(DUP(op_AND_88)), DUP(op_AND_88))));
	RzILOpPure *op_ADD_94 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_91), DUP(op_MUL_91)));
	RzILOpPure *op_LT_97 = SLT(op_ADD_94, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_102 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_103 = NEG(op_LSHIFT_102);
	RzILOpPure *op_LSHIFT_108 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_111 = SUB(op_LSHIFT_108, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_112 = ITE(op_LT_97, op_NEG_103, op_SUB_111);
	RzILOpEffect *gcc_expr_113 = BRANCH(op_EQ_51, EMPTY(), set_usr_field_call_74);

	// h_tmp338 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))))), 0x0, 0x20) == ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_115 = SETL("h_tmp338", cond_112);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + ((st64) ( ...;
	RzILOpEffect *seq_116 = SEQN(2, gcc_expr_113, op_ASSIGN_hybrid_tmp_115);

	// Rx = ((st32) ((sextract64(((ut64) ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))))), 0x0, 0x20) == ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))))) ? ((st64) Rx) + ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) : h_tmp338));
	RzILOpPure *op_RSHIFT_55 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_57 = LOGAND(op_RSHIFT_55, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_63 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_65 = LOGAND(op_RSHIFT_63, SN(32, 0xffff));
	RzILOpPure *op_MUL_68 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_57), DUP(op_AND_57))), CAST(16, MSB(DUP(op_AND_57)), DUP(op_AND_57))), CAST(32, MSB(CAST(16, MSB(op_AND_65), DUP(op_AND_65))), CAST(16, MSB(DUP(op_AND_65)), DUP(op_AND_65))));
	RzILOpPure *op_ADD_71 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_68), DUP(op_MUL_68)));
	RzILOpPure *cond_117 = ITE(DUP(op_EQ_51), op_ADD_71, VARL("h_tmp338"));
	RzILOpEffect *op_ASSIGN_119 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(cond_117), DUP(cond_117)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + ((st6 ...;
	RzILOpEffect *seq_120 = SEQN(2, seq_116, op_ASSIGN_119);

	RzILOpEffect *instruction_sequence = seq_120;
	return instruction_sequence;
}

// Rx += mpy(Rs.l,Rt.l):<<1:sat
RzILOpEffect *hex_il_op_m2_mpy_acc_sat_ll_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_80 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_LSHIFT_25 = SHIFTL0(CAST(64, MSB(op_MUL_22), DUP(op_MUL_22)), SN(32, 1));
	RzILOpPure *op_ADD_27 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_25);
	RzILOpPure *op_RSHIFT_36 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_38 = LOGAND(op_RSHIFT_36, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_44 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_46 = LOGAND(op_RSHIFT_44, SN(32, 0xffff));
	RzILOpPure *op_MUL_49 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_38), DUP(op_AND_38))), CAST(16, MSB(DUP(op_AND_38)), DUP(op_AND_38))), CAST(32, MSB(CAST(16, MSB(op_AND_46), DUP(op_AND_46))), CAST(16, MSB(DUP(op_AND_46)), DUP(op_AND_46))));
	RzILOpPure *op_LSHIFT_52 = SHIFTL0(CAST(64, MSB(op_MUL_49), DUP(op_MUL_49)), SN(32, 1));
	RzILOpPure *op_ADD_54 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_52);
	RzILOpPure *op_EQ_55 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_27), SN(32, 0), SN(32, 0x20)), op_ADD_54);
	RzILOpPure *op_RSHIFT_84 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_86 = LOGAND(op_RSHIFT_84, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_92 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_94 = LOGAND(op_RSHIFT_92, SN(32, 0xffff));
	RzILOpPure *op_MUL_97 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_86), DUP(op_AND_86))), CAST(16, MSB(DUP(op_AND_86)), DUP(op_AND_86))), CAST(32, MSB(CAST(16, MSB(op_AND_94), DUP(op_AND_94))), CAST(16, MSB(DUP(op_AND_94)), DUP(op_AND_94))));
	RzILOpPure *op_LSHIFT_100 = SHIFTL0(CAST(64, MSB(op_MUL_97), DUP(op_MUL_97)), SN(32, 1));
	RzILOpPure *op_ADD_102 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_100);
	RzILOpPure *op_LT_105 = SLT(op_ADD_102, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_110 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_111 = NEG(op_LSHIFT_110);
	RzILOpPure *op_LSHIFT_116 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_119 = SUB(op_LSHIFT_116, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_120 = ITE(op_LT_105, op_NEG_111, op_SUB_119);
	RzILOpEffect *gcc_expr_121 = BRANCH(op_EQ_55, EMPTY(), set_usr_field_call_80);

	// h_tmp339 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_123 = SETL("h_tmp339", cond_120);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + (((st64)  ...;
	RzILOpEffect *seq_124 = SEQN(2, gcc_expr_121, op_ASSIGN_hybrid_tmp_123);

	// Rx = ((st32) ((sextract64(((ut64) ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)) ? ((st64) Rx) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) : h_tmp339));
	RzILOpPure *op_RSHIFT_59 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_61 = LOGAND(op_RSHIFT_59, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_67 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_69 = LOGAND(op_RSHIFT_67, SN(32, 0xffff));
	RzILOpPure *op_MUL_72 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_61), DUP(op_AND_61))), CAST(16, MSB(DUP(op_AND_61)), DUP(op_AND_61))), CAST(32, MSB(CAST(16, MSB(op_AND_69), DUP(op_AND_69))), CAST(16, MSB(DUP(op_AND_69)), DUP(op_AND_69))));
	RzILOpPure *op_LSHIFT_75 = SHIFTL0(CAST(64, MSB(op_MUL_72), DUP(op_MUL_72)), SN(32, 1));
	RzILOpPure *op_ADD_77 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_75);
	RzILOpPure *cond_125 = ITE(DUP(op_EQ_55), op_ADD_77, VARL("h_tmp339"));
	RzILOpEffect *op_ASSIGN_127 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(cond_125), DUP(cond_125)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) + (((st ...;
	RzILOpEffect *seq_128 = SEQN(2, seq_124, op_ASSIGN_127);

	RzILOpEffect *instruction_sequence = seq_128;
	return instruction_sequence;
}

// Rd = mpy(Rs.h,Rt.h)
RzILOpEffect *hex_il_op_m2_mpy_hh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = ((st32) ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpEffect *op_ASSIGN_22 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19))), CAST(64, MSB(DUP(op_MUL_19)), DUP(op_MUL_19))));

	RzILOpEffect *instruction_sequence = op_ASSIGN_22;
	return instruction_sequence;
}

// Rd = mpy(Rs.h,Rt.h):<<1
RzILOpEffect *hex_il_op_m2_mpy_hh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = ((st32) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(op_LSHIFT_22), DUP(op_LSHIFT_22)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rd = mpy(Rs.h,Rt.l)
RzILOpEffect *hex_il_op_m2_mpy_hl_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = ((st32) ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpEffect *op_ASSIGN_22 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19))), CAST(64, MSB(DUP(op_MUL_19)), DUP(op_MUL_19))));

	RzILOpEffect *instruction_sequence = op_ASSIGN_22;
	return instruction_sequence;
}

// Rd = mpy(Rs.h,Rt.l):<<1
RzILOpEffect *hex_il_op_m2_mpy_hl_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = ((st32) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(op_LSHIFT_22), DUP(op_LSHIFT_22)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rd = mpy(Rs.l,Rt.h)
RzILOpEffect *hex_il_op_m2_mpy_lh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = ((st32) ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpEffect *op_ASSIGN_22 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19))), CAST(64, MSB(DUP(op_MUL_19)), DUP(op_MUL_19))));

	RzILOpEffect *instruction_sequence = op_ASSIGN_22;
	return instruction_sequence;
}

// Rd = mpy(Rs.l,Rt.h):<<1
RzILOpEffect *hex_il_op_m2_mpy_lh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = ((st32) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(op_LSHIFT_22), DUP(op_LSHIFT_22)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rd = mpy(Rs.l,Rt.l)
RzILOpEffect *hex_il_op_m2_mpy_ll_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = ((st32) ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpEffect *op_ASSIGN_22 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19))), CAST(64, MSB(DUP(op_MUL_19)), DUP(op_MUL_19))));

	RzILOpEffect *instruction_sequence = op_ASSIGN_22;
	return instruction_sequence;
}

// Rd = mpy(Rs.l,Rt.l):<<1
RzILOpEffect *hex_il_op_m2_mpy_ll_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = ((st32) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(op_LSHIFT_22), DUP(op_LSHIFT_22)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rx -= mpy(Rs.h,Rt.h)
RzILOpEffect *hex_il_op_m2_mpy_nac_hh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_SUB_22 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(op_SUB_22), DUP(op_SUB_22)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rx -= mpy(Rs.h,Rt.h):<<1
RzILOpEffect *hex_il_op_m2_mpy_nac_hh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpPure *op_SUB_24 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_22);
	RzILOpEffect *op_ASSIGN_26 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(op_SUB_24), DUP(op_SUB_24)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_26;
	return instruction_sequence;
}

// Rx -= mpy(Rs.h,Rt.l)
RzILOpEffect *hex_il_op_m2_mpy_nac_hl_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_SUB_22 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(op_SUB_22), DUP(op_SUB_22)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rx -= mpy(Rs.h,Rt.l):<<1
RzILOpEffect *hex_il_op_m2_mpy_nac_hl_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpPure *op_SUB_24 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_22);
	RzILOpEffect *op_ASSIGN_26 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(op_SUB_24), DUP(op_SUB_24)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_26;
	return instruction_sequence;
}

// Rx -= mpy(Rs.l,Rt.h)
RzILOpEffect *hex_il_op_m2_mpy_nac_lh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_SUB_22 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(op_SUB_22), DUP(op_SUB_22)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rx -= mpy(Rs.l,Rt.h):<<1
RzILOpEffect *hex_il_op_m2_mpy_nac_lh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpPure *op_SUB_24 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_22);
	RzILOpEffect *op_ASSIGN_26 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(op_SUB_24), DUP(op_SUB_24)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_26;
	return instruction_sequence;
}

// Rx -= mpy(Rs.l,Rt.l)
RzILOpEffect *hex_il_op_m2_mpy_nac_ll_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_SUB_22 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(op_SUB_22), DUP(op_SUB_22)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rx -= mpy(Rs.l,Rt.l):<<1
RzILOpEffect *hex_il_op_m2_mpy_nac_ll_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpPure *op_SUB_24 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_22);
	RzILOpEffect *op_ASSIGN_26 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(op_SUB_24), DUP(op_SUB_24)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_26;
	return instruction_sequence;
}

// Rx -= mpy(Rs.h,Rt.h):sat
RzILOpEffect *hex_il_op_m2_mpy_nac_sat_hh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_74 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))))), 0x0, 0x20) == ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_SUB_25 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_22), DUP(op_MUL_22)));
	RzILOpPure *op_RSHIFT_34 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_36 = LOGAND(op_RSHIFT_34, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_42 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_44 = LOGAND(op_RSHIFT_42, SN(32, 0xffff));
	RzILOpPure *op_MUL_47 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_36), DUP(op_AND_36))), CAST(16, MSB(DUP(op_AND_36)), DUP(op_AND_36))), CAST(32, MSB(CAST(16, MSB(op_AND_44), DUP(op_AND_44))), CAST(16, MSB(DUP(op_AND_44)), DUP(op_AND_44))));
	RzILOpPure *op_SUB_50 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_47), DUP(op_MUL_47)));
	RzILOpPure *op_EQ_51 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_SUB_25), SN(32, 0), SN(32, 0x20)), op_SUB_50);
	RzILOpPure *op_RSHIFT_78 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_80 = LOGAND(op_RSHIFT_78, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_86 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_88 = LOGAND(op_RSHIFT_86, SN(32, 0xffff));
	RzILOpPure *op_MUL_91 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_80), DUP(op_AND_80))), CAST(16, MSB(DUP(op_AND_80)), DUP(op_AND_80))), CAST(32, MSB(CAST(16, MSB(op_AND_88), DUP(op_AND_88))), CAST(16, MSB(DUP(op_AND_88)), DUP(op_AND_88))));
	RzILOpPure *op_SUB_94 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_91), DUP(op_MUL_91)));
	RzILOpPure *op_LT_97 = SLT(op_SUB_94, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_102 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_103 = NEG(op_LSHIFT_102);
	RzILOpPure *op_LSHIFT_108 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_111 = SUB(op_LSHIFT_108, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_112 = ITE(op_LT_97, op_NEG_103, op_SUB_111);
	RzILOpEffect *gcc_expr_113 = BRANCH(op_EQ_51, EMPTY(), set_usr_field_call_74);

	// h_tmp340 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))))), 0x0, 0x20) == ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_115 = SETL("h_tmp340", cond_112);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - ((st64) ( ...;
	RzILOpEffect *seq_116 = SEQN(2, gcc_expr_113, op_ASSIGN_hybrid_tmp_115);

	// Rx = ((st32) ((sextract64(((ut64) ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))))), 0x0, 0x20) == ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))))) ? ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) : h_tmp340));
	RzILOpPure *op_RSHIFT_55 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_57 = LOGAND(op_RSHIFT_55, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_63 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_65 = LOGAND(op_RSHIFT_63, SN(32, 0xffff));
	RzILOpPure *op_MUL_68 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_57), DUP(op_AND_57))), CAST(16, MSB(DUP(op_AND_57)), DUP(op_AND_57))), CAST(32, MSB(CAST(16, MSB(op_AND_65), DUP(op_AND_65))), CAST(16, MSB(DUP(op_AND_65)), DUP(op_AND_65))));
	RzILOpPure *op_SUB_71 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_68), DUP(op_MUL_68)));
	RzILOpPure *cond_117 = ITE(DUP(op_EQ_51), op_SUB_71, VARL("h_tmp340"));
	RzILOpEffect *op_ASSIGN_119 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(cond_117), DUP(cond_117)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - ((st6 ...;
	RzILOpEffect *seq_120 = SEQN(2, seq_116, op_ASSIGN_119);

	RzILOpEffect *instruction_sequence = seq_120;
	return instruction_sequence;
}

// Rx -= mpy(Rs.h,Rt.h):<<1:sat
RzILOpEffect *hex_il_op_m2_mpy_nac_sat_hh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_80 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_LSHIFT_25 = SHIFTL0(CAST(64, MSB(op_MUL_22), DUP(op_MUL_22)), SN(32, 1));
	RzILOpPure *op_SUB_27 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_25);
	RzILOpPure *op_RSHIFT_36 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_38 = LOGAND(op_RSHIFT_36, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_44 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_46 = LOGAND(op_RSHIFT_44, SN(32, 0xffff));
	RzILOpPure *op_MUL_49 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_38), DUP(op_AND_38))), CAST(16, MSB(DUP(op_AND_38)), DUP(op_AND_38))), CAST(32, MSB(CAST(16, MSB(op_AND_46), DUP(op_AND_46))), CAST(16, MSB(DUP(op_AND_46)), DUP(op_AND_46))));
	RzILOpPure *op_LSHIFT_52 = SHIFTL0(CAST(64, MSB(op_MUL_49), DUP(op_MUL_49)), SN(32, 1));
	RzILOpPure *op_SUB_54 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_52);
	RzILOpPure *op_EQ_55 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_SUB_27), SN(32, 0), SN(32, 0x20)), op_SUB_54);
	RzILOpPure *op_RSHIFT_84 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_86 = LOGAND(op_RSHIFT_84, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_92 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_94 = LOGAND(op_RSHIFT_92, SN(32, 0xffff));
	RzILOpPure *op_MUL_97 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_86), DUP(op_AND_86))), CAST(16, MSB(DUP(op_AND_86)), DUP(op_AND_86))), CAST(32, MSB(CAST(16, MSB(op_AND_94), DUP(op_AND_94))), CAST(16, MSB(DUP(op_AND_94)), DUP(op_AND_94))));
	RzILOpPure *op_LSHIFT_100 = SHIFTL0(CAST(64, MSB(op_MUL_97), DUP(op_MUL_97)), SN(32, 1));
	RzILOpPure *op_SUB_102 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_100);
	RzILOpPure *op_LT_105 = SLT(op_SUB_102, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_110 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_111 = NEG(op_LSHIFT_110);
	RzILOpPure *op_LSHIFT_116 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_119 = SUB(op_LSHIFT_116, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_120 = ITE(op_LT_105, op_NEG_111, op_SUB_119);
	RzILOpEffect *gcc_expr_121 = BRANCH(op_EQ_55, EMPTY(), set_usr_field_call_80);

	// h_tmp341 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_123 = SETL("h_tmp341", cond_120);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - (((st64)  ...;
	RzILOpEffect *seq_124 = SEQN(2, gcc_expr_121, op_ASSIGN_hybrid_tmp_123);

	// Rx = ((st32) ((sextract64(((ut64) ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)) ? ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) : h_tmp341));
	RzILOpPure *op_RSHIFT_59 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_61 = LOGAND(op_RSHIFT_59, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_67 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_69 = LOGAND(op_RSHIFT_67, SN(32, 0xffff));
	RzILOpPure *op_MUL_72 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_61), DUP(op_AND_61))), CAST(16, MSB(DUP(op_AND_61)), DUP(op_AND_61))), CAST(32, MSB(CAST(16, MSB(op_AND_69), DUP(op_AND_69))), CAST(16, MSB(DUP(op_AND_69)), DUP(op_AND_69))));
	RzILOpPure *op_LSHIFT_75 = SHIFTL0(CAST(64, MSB(op_MUL_72), DUP(op_MUL_72)), SN(32, 1));
	RzILOpPure *op_SUB_77 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_75);
	RzILOpPure *cond_125 = ITE(DUP(op_EQ_55), op_SUB_77, VARL("h_tmp341"));
	RzILOpEffect *op_ASSIGN_127 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(cond_125), DUP(cond_125)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - (((st ...;
	RzILOpEffect *seq_128 = SEQN(2, seq_124, op_ASSIGN_127);

	RzILOpEffect *instruction_sequence = seq_128;
	return instruction_sequence;
}

// Rx -= mpy(Rs.h,Rt.l):sat
RzILOpEffect *hex_il_op_m2_mpy_nac_sat_hl_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_74 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))))), 0x0, 0x20) == ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_SUB_25 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_22), DUP(op_MUL_22)));
	RzILOpPure *op_RSHIFT_34 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_36 = LOGAND(op_RSHIFT_34, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_42 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_44 = LOGAND(op_RSHIFT_42, SN(32, 0xffff));
	RzILOpPure *op_MUL_47 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_36), DUP(op_AND_36))), CAST(16, MSB(DUP(op_AND_36)), DUP(op_AND_36))), CAST(32, MSB(CAST(16, MSB(op_AND_44), DUP(op_AND_44))), CAST(16, MSB(DUP(op_AND_44)), DUP(op_AND_44))));
	RzILOpPure *op_SUB_50 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_47), DUP(op_MUL_47)));
	RzILOpPure *op_EQ_51 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_SUB_25), SN(32, 0), SN(32, 0x20)), op_SUB_50);
	RzILOpPure *op_RSHIFT_78 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_80 = LOGAND(op_RSHIFT_78, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_86 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_88 = LOGAND(op_RSHIFT_86, SN(32, 0xffff));
	RzILOpPure *op_MUL_91 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_80), DUP(op_AND_80))), CAST(16, MSB(DUP(op_AND_80)), DUP(op_AND_80))), CAST(32, MSB(CAST(16, MSB(op_AND_88), DUP(op_AND_88))), CAST(16, MSB(DUP(op_AND_88)), DUP(op_AND_88))));
	RzILOpPure *op_SUB_94 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_91), DUP(op_MUL_91)));
	RzILOpPure *op_LT_97 = SLT(op_SUB_94, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_102 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_103 = NEG(op_LSHIFT_102);
	RzILOpPure *op_LSHIFT_108 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_111 = SUB(op_LSHIFT_108, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_112 = ITE(op_LT_97, op_NEG_103, op_SUB_111);
	RzILOpEffect *gcc_expr_113 = BRANCH(op_EQ_51, EMPTY(), set_usr_field_call_74);

	// h_tmp342 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))))), 0x0, 0x20) == ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_115 = SETL("h_tmp342", cond_112);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - ((st64) ( ...;
	RzILOpEffect *seq_116 = SEQN(2, gcc_expr_113, op_ASSIGN_hybrid_tmp_115);

	// Rx = ((st32) ((sextract64(((ut64) ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))))), 0x0, 0x20) == ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))))) ? ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) : h_tmp342));
	RzILOpPure *op_RSHIFT_55 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_57 = LOGAND(op_RSHIFT_55, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_63 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_65 = LOGAND(op_RSHIFT_63, SN(32, 0xffff));
	RzILOpPure *op_MUL_68 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_57), DUP(op_AND_57))), CAST(16, MSB(DUP(op_AND_57)), DUP(op_AND_57))), CAST(32, MSB(CAST(16, MSB(op_AND_65), DUP(op_AND_65))), CAST(16, MSB(DUP(op_AND_65)), DUP(op_AND_65))));
	RzILOpPure *op_SUB_71 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_68), DUP(op_MUL_68)));
	RzILOpPure *cond_117 = ITE(DUP(op_EQ_51), op_SUB_71, VARL("h_tmp342"));
	RzILOpEffect *op_ASSIGN_119 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(cond_117), DUP(cond_117)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - ((st6 ...;
	RzILOpEffect *seq_120 = SEQN(2, seq_116, op_ASSIGN_119);

	RzILOpEffect *instruction_sequence = seq_120;
	return instruction_sequence;
}

// Rx -= mpy(Rs.h,Rt.l):<<1:sat
RzILOpEffect *hex_il_op_m2_mpy_nac_sat_hl_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_80 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_LSHIFT_25 = SHIFTL0(CAST(64, MSB(op_MUL_22), DUP(op_MUL_22)), SN(32, 1));
	RzILOpPure *op_SUB_27 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_25);
	RzILOpPure *op_RSHIFT_36 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_38 = LOGAND(op_RSHIFT_36, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_44 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_46 = LOGAND(op_RSHIFT_44, SN(32, 0xffff));
	RzILOpPure *op_MUL_49 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_38), DUP(op_AND_38))), CAST(16, MSB(DUP(op_AND_38)), DUP(op_AND_38))), CAST(32, MSB(CAST(16, MSB(op_AND_46), DUP(op_AND_46))), CAST(16, MSB(DUP(op_AND_46)), DUP(op_AND_46))));
	RzILOpPure *op_LSHIFT_52 = SHIFTL0(CAST(64, MSB(op_MUL_49), DUP(op_MUL_49)), SN(32, 1));
	RzILOpPure *op_SUB_54 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_52);
	RzILOpPure *op_EQ_55 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_SUB_27), SN(32, 0), SN(32, 0x20)), op_SUB_54);
	RzILOpPure *op_RSHIFT_84 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_86 = LOGAND(op_RSHIFT_84, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_92 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_94 = LOGAND(op_RSHIFT_92, SN(32, 0xffff));
	RzILOpPure *op_MUL_97 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_86), DUP(op_AND_86))), CAST(16, MSB(DUP(op_AND_86)), DUP(op_AND_86))), CAST(32, MSB(CAST(16, MSB(op_AND_94), DUP(op_AND_94))), CAST(16, MSB(DUP(op_AND_94)), DUP(op_AND_94))));
	RzILOpPure *op_LSHIFT_100 = SHIFTL0(CAST(64, MSB(op_MUL_97), DUP(op_MUL_97)), SN(32, 1));
	RzILOpPure *op_SUB_102 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_100);
	RzILOpPure *op_LT_105 = SLT(op_SUB_102, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_110 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_111 = NEG(op_LSHIFT_110);
	RzILOpPure *op_LSHIFT_116 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_119 = SUB(op_LSHIFT_116, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_120 = ITE(op_LT_105, op_NEG_111, op_SUB_119);
	RzILOpEffect *gcc_expr_121 = BRANCH(op_EQ_55, EMPTY(), set_usr_field_call_80);

	// h_tmp343 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_123 = SETL("h_tmp343", cond_120);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - (((st64)  ...;
	RzILOpEffect *seq_124 = SEQN(2, gcc_expr_121, op_ASSIGN_hybrid_tmp_123);

	// Rx = ((st32) ((sextract64(((ut64) ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)) ? ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) : h_tmp343));
	RzILOpPure *op_RSHIFT_59 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_61 = LOGAND(op_RSHIFT_59, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_67 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_69 = LOGAND(op_RSHIFT_67, SN(32, 0xffff));
	RzILOpPure *op_MUL_72 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_61), DUP(op_AND_61))), CAST(16, MSB(DUP(op_AND_61)), DUP(op_AND_61))), CAST(32, MSB(CAST(16, MSB(op_AND_69), DUP(op_AND_69))), CAST(16, MSB(DUP(op_AND_69)), DUP(op_AND_69))));
	RzILOpPure *op_LSHIFT_75 = SHIFTL0(CAST(64, MSB(op_MUL_72), DUP(op_MUL_72)), SN(32, 1));
	RzILOpPure *op_SUB_77 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_75);
	RzILOpPure *cond_125 = ITE(DUP(op_EQ_55), op_SUB_77, VARL("h_tmp343"));
	RzILOpEffect *op_ASSIGN_127 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(cond_125), DUP(cond_125)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - (((st ...;
	RzILOpEffect *seq_128 = SEQN(2, seq_124, op_ASSIGN_127);

	RzILOpEffect *instruction_sequence = seq_128;
	return instruction_sequence;
}

// Rx -= mpy(Rs.l,Rt.h):sat
RzILOpEffect *hex_il_op_m2_mpy_nac_sat_lh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_74 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))))), 0x0, 0x20) == ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_SUB_25 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_22), DUP(op_MUL_22)));
	RzILOpPure *op_RSHIFT_34 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_36 = LOGAND(op_RSHIFT_34, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_42 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_44 = LOGAND(op_RSHIFT_42, SN(32, 0xffff));
	RzILOpPure *op_MUL_47 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_36), DUP(op_AND_36))), CAST(16, MSB(DUP(op_AND_36)), DUP(op_AND_36))), CAST(32, MSB(CAST(16, MSB(op_AND_44), DUP(op_AND_44))), CAST(16, MSB(DUP(op_AND_44)), DUP(op_AND_44))));
	RzILOpPure *op_SUB_50 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_47), DUP(op_MUL_47)));
	RzILOpPure *op_EQ_51 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_SUB_25), SN(32, 0), SN(32, 0x20)), op_SUB_50);
	RzILOpPure *op_RSHIFT_78 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_80 = LOGAND(op_RSHIFT_78, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_86 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_88 = LOGAND(op_RSHIFT_86, SN(32, 0xffff));
	RzILOpPure *op_MUL_91 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_80), DUP(op_AND_80))), CAST(16, MSB(DUP(op_AND_80)), DUP(op_AND_80))), CAST(32, MSB(CAST(16, MSB(op_AND_88), DUP(op_AND_88))), CAST(16, MSB(DUP(op_AND_88)), DUP(op_AND_88))));
	RzILOpPure *op_SUB_94 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_91), DUP(op_MUL_91)));
	RzILOpPure *op_LT_97 = SLT(op_SUB_94, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_102 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_103 = NEG(op_LSHIFT_102);
	RzILOpPure *op_LSHIFT_108 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_111 = SUB(op_LSHIFT_108, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_112 = ITE(op_LT_97, op_NEG_103, op_SUB_111);
	RzILOpEffect *gcc_expr_113 = BRANCH(op_EQ_51, EMPTY(), set_usr_field_call_74);

	// h_tmp344 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))))), 0x0, 0x20) == ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_115 = SETL("h_tmp344", cond_112);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - ((st64) ( ...;
	RzILOpEffect *seq_116 = SEQN(2, gcc_expr_113, op_ASSIGN_hybrid_tmp_115);

	// Rx = ((st32) ((sextract64(((ut64) ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))))), 0x0, 0x20) == ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))))) ? ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) : h_tmp344));
	RzILOpPure *op_RSHIFT_55 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_57 = LOGAND(op_RSHIFT_55, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_63 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_65 = LOGAND(op_RSHIFT_63, SN(32, 0xffff));
	RzILOpPure *op_MUL_68 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_57), DUP(op_AND_57))), CAST(16, MSB(DUP(op_AND_57)), DUP(op_AND_57))), CAST(32, MSB(CAST(16, MSB(op_AND_65), DUP(op_AND_65))), CAST(16, MSB(DUP(op_AND_65)), DUP(op_AND_65))));
	RzILOpPure *op_SUB_71 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_68), DUP(op_MUL_68)));
	RzILOpPure *cond_117 = ITE(DUP(op_EQ_51), op_SUB_71, VARL("h_tmp344"));
	RzILOpEffect *op_ASSIGN_119 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(cond_117), DUP(cond_117)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - ((st6 ...;
	RzILOpEffect *seq_120 = SEQN(2, seq_116, op_ASSIGN_119);

	RzILOpEffect *instruction_sequence = seq_120;
	return instruction_sequence;
}

// Rx -= mpy(Rs.l,Rt.h):<<1:sat
RzILOpEffect *hex_il_op_m2_mpy_nac_sat_lh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_80 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_LSHIFT_25 = SHIFTL0(CAST(64, MSB(op_MUL_22), DUP(op_MUL_22)), SN(32, 1));
	RzILOpPure *op_SUB_27 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_25);
	RzILOpPure *op_RSHIFT_36 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_38 = LOGAND(op_RSHIFT_36, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_44 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_46 = LOGAND(op_RSHIFT_44, SN(32, 0xffff));
	RzILOpPure *op_MUL_49 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_38), DUP(op_AND_38))), CAST(16, MSB(DUP(op_AND_38)), DUP(op_AND_38))), CAST(32, MSB(CAST(16, MSB(op_AND_46), DUP(op_AND_46))), CAST(16, MSB(DUP(op_AND_46)), DUP(op_AND_46))));
	RzILOpPure *op_LSHIFT_52 = SHIFTL0(CAST(64, MSB(op_MUL_49), DUP(op_MUL_49)), SN(32, 1));
	RzILOpPure *op_SUB_54 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_52);
	RzILOpPure *op_EQ_55 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_SUB_27), SN(32, 0), SN(32, 0x20)), op_SUB_54);
	RzILOpPure *op_RSHIFT_84 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_86 = LOGAND(op_RSHIFT_84, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_92 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_94 = LOGAND(op_RSHIFT_92, SN(32, 0xffff));
	RzILOpPure *op_MUL_97 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_86), DUP(op_AND_86))), CAST(16, MSB(DUP(op_AND_86)), DUP(op_AND_86))), CAST(32, MSB(CAST(16, MSB(op_AND_94), DUP(op_AND_94))), CAST(16, MSB(DUP(op_AND_94)), DUP(op_AND_94))));
	RzILOpPure *op_LSHIFT_100 = SHIFTL0(CAST(64, MSB(op_MUL_97), DUP(op_MUL_97)), SN(32, 1));
	RzILOpPure *op_SUB_102 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_100);
	RzILOpPure *op_LT_105 = SLT(op_SUB_102, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_110 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_111 = NEG(op_LSHIFT_110);
	RzILOpPure *op_LSHIFT_116 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_119 = SUB(op_LSHIFT_116, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_120 = ITE(op_LT_105, op_NEG_111, op_SUB_119);
	RzILOpEffect *gcc_expr_121 = BRANCH(op_EQ_55, EMPTY(), set_usr_field_call_80);

	// h_tmp345 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_123 = SETL("h_tmp345", cond_120);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - (((st64)  ...;
	RzILOpEffect *seq_124 = SEQN(2, gcc_expr_121, op_ASSIGN_hybrid_tmp_123);

	// Rx = ((st32) ((sextract64(((ut64) ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)) ? ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) : h_tmp345));
	RzILOpPure *op_RSHIFT_59 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_61 = LOGAND(op_RSHIFT_59, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_67 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_69 = LOGAND(op_RSHIFT_67, SN(32, 0xffff));
	RzILOpPure *op_MUL_72 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_61), DUP(op_AND_61))), CAST(16, MSB(DUP(op_AND_61)), DUP(op_AND_61))), CAST(32, MSB(CAST(16, MSB(op_AND_69), DUP(op_AND_69))), CAST(16, MSB(DUP(op_AND_69)), DUP(op_AND_69))));
	RzILOpPure *op_LSHIFT_75 = SHIFTL0(CAST(64, MSB(op_MUL_72), DUP(op_MUL_72)), SN(32, 1));
	RzILOpPure *op_SUB_77 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_75);
	RzILOpPure *cond_125 = ITE(DUP(op_EQ_55), op_SUB_77, VARL("h_tmp345"));
	RzILOpEffect *op_ASSIGN_127 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(cond_125), DUP(cond_125)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - (((st ...;
	RzILOpEffect *seq_128 = SEQN(2, seq_124, op_ASSIGN_127);

	RzILOpEffect *instruction_sequence = seq_128;
	return instruction_sequence;
}

// Rx -= mpy(Rs.l,Rt.l):sat
RzILOpEffect *hex_il_op_m2_mpy_nac_sat_ll_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_74 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))))), 0x0, 0x20) == ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_SUB_25 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_22), DUP(op_MUL_22)));
	RzILOpPure *op_RSHIFT_34 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_36 = LOGAND(op_RSHIFT_34, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_42 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_44 = LOGAND(op_RSHIFT_42, SN(32, 0xffff));
	RzILOpPure *op_MUL_47 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_36), DUP(op_AND_36))), CAST(16, MSB(DUP(op_AND_36)), DUP(op_AND_36))), CAST(32, MSB(CAST(16, MSB(op_AND_44), DUP(op_AND_44))), CAST(16, MSB(DUP(op_AND_44)), DUP(op_AND_44))));
	RzILOpPure *op_SUB_50 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_47), DUP(op_MUL_47)));
	RzILOpPure *op_EQ_51 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_SUB_25), SN(32, 0), SN(32, 0x20)), op_SUB_50);
	RzILOpPure *op_RSHIFT_78 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_80 = LOGAND(op_RSHIFT_78, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_86 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_88 = LOGAND(op_RSHIFT_86, SN(32, 0xffff));
	RzILOpPure *op_MUL_91 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_80), DUP(op_AND_80))), CAST(16, MSB(DUP(op_AND_80)), DUP(op_AND_80))), CAST(32, MSB(CAST(16, MSB(op_AND_88), DUP(op_AND_88))), CAST(16, MSB(DUP(op_AND_88)), DUP(op_AND_88))));
	RzILOpPure *op_SUB_94 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_91), DUP(op_MUL_91)));
	RzILOpPure *op_LT_97 = SLT(op_SUB_94, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_102 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_103 = NEG(op_LSHIFT_102);
	RzILOpPure *op_LSHIFT_108 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_111 = SUB(op_LSHIFT_108, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_112 = ITE(op_LT_97, op_NEG_103, op_SUB_111);
	RzILOpEffect *gcc_expr_113 = BRANCH(op_EQ_51, EMPTY(), set_usr_field_call_74);

	// h_tmp346 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))))), 0x0, 0x20) == ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_115 = SETL("h_tmp346", cond_112);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - ((st64) ( ...;
	RzILOpEffect *seq_116 = SEQN(2, gcc_expr_113, op_ASSIGN_hybrid_tmp_115);

	// Rx = ((st32) ((sextract64(((ut64) ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))))), 0x0, 0x20) == ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))))) ? ((st64) Rx) - ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) : h_tmp346));
	RzILOpPure *op_RSHIFT_55 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_57 = LOGAND(op_RSHIFT_55, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_63 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_65 = LOGAND(op_RSHIFT_63, SN(32, 0xffff));
	RzILOpPure *op_MUL_68 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_57), DUP(op_AND_57))), CAST(16, MSB(DUP(op_AND_57)), DUP(op_AND_57))), CAST(32, MSB(CAST(16, MSB(op_AND_65), DUP(op_AND_65))), CAST(16, MSB(DUP(op_AND_65)), DUP(op_AND_65))));
	RzILOpPure *op_SUB_71 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), CAST(64, MSB(op_MUL_68), DUP(op_MUL_68)));
	RzILOpPure *cond_117 = ITE(DUP(op_EQ_51), op_SUB_71, VARL("h_tmp346"));
	RzILOpEffect *op_ASSIGN_119 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(cond_117), DUP(cond_117)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - ((st6 ...;
	RzILOpEffect *seq_120 = SEQN(2, seq_116, op_ASSIGN_119);

	RzILOpEffect *instruction_sequence = seq_120;
	return instruction_sequence;
}

// Rx -= mpy(Rs.l,Rt.l):<<1:sat
RzILOpEffect *hex_il_op_m2_mpy_nac_sat_ll_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_80 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_LSHIFT_25 = SHIFTL0(CAST(64, MSB(op_MUL_22), DUP(op_MUL_22)), SN(32, 1));
	RzILOpPure *op_SUB_27 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_25);
	RzILOpPure *op_RSHIFT_36 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_38 = LOGAND(op_RSHIFT_36, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_44 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_46 = LOGAND(op_RSHIFT_44, SN(32, 0xffff));
	RzILOpPure *op_MUL_49 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_38), DUP(op_AND_38))), CAST(16, MSB(DUP(op_AND_38)), DUP(op_AND_38))), CAST(32, MSB(CAST(16, MSB(op_AND_46), DUP(op_AND_46))), CAST(16, MSB(DUP(op_AND_46)), DUP(op_AND_46))));
	RzILOpPure *op_LSHIFT_52 = SHIFTL0(CAST(64, MSB(op_MUL_49), DUP(op_MUL_49)), SN(32, 1));
	RzILOpPure *op_SUB_54 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_52);
	RzILOpPure *op_EQ_55 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_SUB_27), SN(32, 0), SN(32, 0x20)), op_SUB_54);
	RzILOpPure *op_RSHIFT_84 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_86 = LOGAND(op_RSHIFT_84, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_92 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_94 = LOGAND(op_RSHIFT_92, SN(32, 0xffff));
	RzILOpPure *op_MUL_97 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_86), DUP(op_AND_86))), CAST(16, MSB(DUP(op_AND_86)), DUP(op_AND_86))), CAST(32, MSB(CAST(16, MSB(op_AND_94), DUP(op_AND_94))), CAST(16, MSB(DUP(op_AND_94)), DUP(op_AND_94))));
	RzILOpPure *op_LSHIFT_100 = SHIFTL0(CAST(64, MSB(op_MUL_97), DUP(op_MUL_97)), SN(32, 1));
	RzILOpPure *op_SUB_102 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_100);
	RzILOpPure *op_LT_105 = SLT(op_SUB_102, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_110 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_111 = NEG(op_LSHIFT_110);
	RzILOpPure *op_LSHIFT_116 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_119 = SUB(op_LSHIFT_116, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_120 = ITE(op_LT_105, op_NEG_111, op_SUB_119);
	RzILOpEffect *gcc_expr_121 = BRANCH(op_EQ_55, EMPTY(), set_usr_field_call_80);

	// h_tmp347 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_123 = SETL("h_tmp347", cond_120);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - (((st64)  ...;
	RzILOpEffect *seq_124 = SEQN(2, gcc_expr_121, op_ASSIGN_hybrid_tmp_123);

	// Rx = ((st32) ((sextract64(((ut64) ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)) ? ((st64) Rx) - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) : h_tmp347));
	RzILOpPure *op_RSHIFT_59 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_61 = LOGAND(op_RSHIFT_59, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_67 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_69 = LOGAND(op_RSHIFT_67, SN(32, 0xffff));
	RzILOpPure *op_MUL_72 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_61), DUP(op_AND_61))), CAST(16, MSB(DUP(op_AND_61)), DUP(op_AND_61))), CAST(32, MSB(CAST(16, MSB(op_AND_69), DUP(op_AND_69))), CAST(16, MSB(DUP(op_AND_69)), DUP(op_AND_69))));
	RzILOpPure *op_LSHIFT_75 = SHIFTL0(CAST(64, MSB(op_MUL_72), DUP(op_MUL_72)), SN(32, 1));
	RzILOpPure *op_SUB_77 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_75);
	RzILOpPure *cond_125 = ITE(DUP(op_EQ_55), op_SUB_77, VARL("h_tmp347"));
	RzILOpEffect *op_ASSIGN_127 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(cond_125), DUP(cond_125)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) Rx) - (((st ...;
	RzILOpEffect *seq_128 = SEQN(2, seq_124, op_ASSIGN_127);

	RzILOpEffect *instruction_sequence = seq_128;
	return instruction_sequence;
}

// Rd = mpy(Rs.h,Rt.h):rnd
RzILOpEffect *hex_il_op_m2_mpy_rnd_hh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = ((st32) ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) + ((st64) 0x8000));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_ADD_23 = ADD(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpEffect *op_ASSIGN_25 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(op_ADD_23), DUP(op_ADD_23)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_25;
	return instruction_sequence;
}

// Rd = mpy(Rs.h,Rt.h):<<1:rnd
RzILOpEffect *hex_il_op_m2_mpy_rnd_hh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = ((st32) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpPure *op_ADD_25 = ADD(op_LSHIFT_22, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpEffect *op_ASSIGN_27 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(op_ADD_25), DUP(op_ADD_25)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_27;
	return instruction_sequence;
}

// Rd = mpy(Rs.h,Rt.l):rnd
RzILOpEffect *hex_il_op_m2_mpy_rnd_hl_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = ((st32) ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) + ((st64) 0x8000));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_ADD_23 = ADD(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpEffect *op_ASSIGN_25 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(op_ADD_23), DUP(op_ADD_23)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_25;
	return instruction_sequence;
}

// Rd = mpy(Rs.h,Rt.l):<<1:rnd
RzILOpEffect *hex_il_op_m2_mpy_rnd_hl_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = ((st32) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpPure *op_ADD_25 = ADD(op_LSHIFT_22, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpEffect *op_ASSIGN_27 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(op_ADD_25), DUP(op_ADD_25)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_27;
	return instruction_sequence;
}

// Rd = mpy(Rs.l,Rt.h):rnd
RzILOpEffect *hex_il_op_m2_mpy_rnd_lh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = ((st32) ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) + ((st64) 0x8000));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_ADD_23 = ADD(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpEffect *op_ASSIGN_25 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(op_ADD_23), DUP(op_ADD_23)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_25;
	return instruction_sequence;
}

// Rd = mpy(Rs.l,Rt.h):<<1:rnd
RzILOpEffect *hex_il_op_m2_mpy_rnd_lh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = ((st32) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpPure *op_ADD_25 = ADD(op_LSHIFT_22, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpEffect *op_ASSIGN_27 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(op_ADD_25), DUP(op_ADD_25)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_27;
	return instruction_sequence;
}

// Rd = mpy(Rs.l,Rt.l):rnd
RzILOpEffect *hex_il_op_m2_mpy_rnd_ll_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = ((st32) ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) + ((st64) 0x8000));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_ADD_23 = ADD(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpEffect *op_ASSIGN_25 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(op_ADD_23), DUP(op_ADD_23)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_25;
	return instruction_sequence;
}

// Rd = mpy(Rs.l,Rt.l):<<1:rnd
RzILOpEffect *hex_il_op_m2_mpy_rnd_ll_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = ((st32) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpPure *op_ADD_25 = ADD(op_LSHIFT_22, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpEffect *op_ASSIGN_27 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(op_ADD_25), DUP(op_ADD_25)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_27;
	return instruction_sequence;
}

// Rd = mpy(Rs.h,Rt.h):sat
RzILOpEffect *hex_il_op_m2_mpy_sat_hh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_68 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))))), 0x0, 0x20) == ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_RSHIFT_32 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_34 = LOGAND(op_RSHIFT_32, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_40 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_42 = LOGAND(op_RSHIFT_40, SN(32, 0xffff));
	RzILOpPure *op_MUL_45 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_34), DUP(op_AND_34))), CAST(16, MSB(DUP(op_AND_34)), DUP(op_AND_34))), CAST(32, MSB(CAST(16, MSB(op_AND_42), DUP(op_AND_42))), CAST(16, MSB(DUP(op_AND_42)), DUP(op_AND_42))));
	RzILOpPure *op_EQ_47 = EQ(SEXTRACT64(CAST(64, IL_FALSE, CAST(64, MSB(op_MUL_22), DUP(op_MUL_22))), SN(32, 0), SN(32, 0x20)), CAST(64, MSB(op_MUL_45), DUP(op_MUL_45)));
	RzILOpPure *op_RSHIFT_72 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_74 = LOGAND(op_RSHIFT_72, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_80 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_82 = LOGAND(op_RSHIFT_80, SN(32, 0xffff));
	RzILOpPure *op_MUL_85 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_74), DUP(op_AND_74))), CAST(16, MSB(DUP(op_AND_74)), DUP(op_AND_74))), CAST(32, MSB(CAST(16, MSB(op_AND_82), DUP(op_AND_82))), CAST(16, MSB(DUP(op_AND_82)), DUP(op_AND_82))));
	RzILOpPure *op_LT_89 = SLT(CAST(64, MSB(op_MUL_85), DUP(op_MUL_85)), CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_94 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_95 = NEG(op_LSHIFT_94);
	RzILOpPure *op_LSHIFT_100 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_103 = SUB(op_LSHIFT_100, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_104 = ITE(op_LT_89, op_NEG_95, op_SUB_103);
	RzILOpEffect *gcc_expr_105 = BRANCH(op_EQ_47, EMPTY(), set_usr_field_call_68);

	// h_tmp348 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))))), 0x0, 0x20) == ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_107 = SETL("h_tmp348", cond_104);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((st16) ...;
	RzILOpEffect *seq_108 = SEQN(2, gcc_expr_105, op_ASSIGN_hybrid_tmp_107);

	// Rd = ((st32) ((sextract64(((ut64) ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))))), 0x0, 0x20) == ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))))) ? ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) : h_tmp348));
	RzILOpPure *op_RSHIFT_51 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_53 = LOGAND(op_RSHIFT_51, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_59 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_61 = LOGAND(op_RSHIFT_59, SN(32, 0xffff));
	RzILOpPure *op_MUL_64 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_53), DUP(op_AND_53))), CAST(16, MSB(DUP(op_AND_53)), DUP(op_AND_53))), CAST(32, MSB(CAST(16, MSB(op_AND_61), DUP(op_AND_61))), CAST(16, MSB(DUP(op_AND_61)), DUP(op_AND_61))));
	RzILOpPure *cond_109 = ITE(DUP(op_EQ_47), CAST(64, MSB(op_MUL_64), DUP(op_MUL_64)), VARL("h_tmp348"));
	RzILOpEffect *op_ASSIGN_111 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(cond_109), DUP(cond_109)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((s ...;
	RzILOpEffect *seq_112 = SEQN(2, seq_108, op_ASSIGN_111);

	RzILOpEffect *instruction_sequence = seq_112;
	return instruction_sequence;
}

// Rd = mpy(Rs.h,Rt.h):<<1:sat
RzILOpEffect *hex_il_op_m2_mpy_sat_hh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_74 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_LSHIFT_25 = SHIFTL0(CAST(64, MSB(op_MUL_22), DUP(op_MUL_22)), SN(32, 1));
	RzILOpPure *op_RSHIFT_34 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_36 = LOGAND(op_RSHIFT_34, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_42 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_44 = LOGAND(op_RSHIFT_42, SN(32, 0xffff));
	RzILOpPure *op_MUL_47 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_36), DUP(op_AND_36))), CAST(16, MSB(DUP(op_AND_36)), DUP(op_AND_36))), CAST(32, MSB(CAST(16, MSB(op_AND_44), DUP(op_AND_44))), CAST(16, MSB(DUP(op_AND_44)), DUP(op_AND_44))));
	RzILOpPure *op_LSHIFT_50 = SHIFTL0(CAST(64, MSB(op_MUL_47), DUP(op_MUL_47)), SN(32, 1));
	RzILOpPure *op_EQ_51 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_LSHIFT_25), SN(32, 0), SN(32, 0x20)), op_LSHIFT_50);
	RzILOpPure *op_RSHIFT_78 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_80 = LOGAND(op_RSHIFT_78, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_86 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_88 = LOGAND(op_RSHIFT_86, SN(32, 0xffff));
	RzILOpPure *op_MUL_91 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_80), DUP(op_AND_80))), CAST(16, MSB(DUP(op_AND_80)), DUP(op_AND_80))), CAST(32, MSB(CAST(16, MSB(op_AND_88), DUP(op_AND_88))), CAST(16, MSB(DUP(op_AND_88)), DUP(op_AND_88))));
	RzILOpPure *op_LSHIFT_94 = SHIFTL0(CAST(64, MSB(op_MUL_91), DUP(op_MUL_91)), SN(32, 1));
	RzILOpPure *op_LT_97 = SLT(op_LSHIFT_94, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_102 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_103 = NEG(op_LSHIFT_102);
	RzILOpPure *op_LSHIFT_108 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_111 = SUB(op_LSHIFT_108, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_112 = ITE(op_LT_97, op_NEG_103, op_SUB_111);
	RzILOpEffect *gcc_expr_113 = BRANCH(op_EQ_51, EMPTY(), set_usr_field_call_74);

	// h_tmp349 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_115 = SETL("h_tmp349", cond_112);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_116 = SEQN(2, gcc_expr_113, op_ASSIGN_hybrid_tmp_115);

	// Rd = ((st32) ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)) ? (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) : h_tmp349));
	RzILOpPure *op_RSHIFT_55 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_57 = LOGAND(op_RSHIFT_55, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_63 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_65 = LOGAND(op_RSHIFT_63, SN(32, 0xffff));
	RzILOpPure *op_MUL_68 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_57), DUP(op_AND_57))), CAST(16, MSB(DUP(op_AND_57)), DUP(op_AND_57))), CAST(32, MSB(CAST(16, MSB(op_AND_65), DUP(op_AND_65))), CAST(16, MSB(DUP(op_AND_65)), DUP(op_AND_65))));
	RzILOpPure *op_LSHIFT_71 = SHIFTL0(CAST(64, MSB(op_MUL_68), DUP(op_MUL_68)), SN(32, 1));
	RzILOpPure *cond_117 = ITE(DUP(op_EQ_51), op_LSHIFT_71, VARL("h_tmp349"));
	RzILOpEffect *op_ASSIGN_119 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(cond_117), DUP(cond_117)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_120 = SEQN(2, seq_116, op_ASSIGN_119);

	RzILOpEffect *instruction_sequence = seq_120;
	return instruction_sequence;
}

// Rd = mpy(Rs.h,Rt.l):sat
RzILOpEffect *hex_il_op_m2_mpy_sat_hl_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_68 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))))), 0x0, 0x20) == ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_RSHIFT_32 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_34 = LOGAND(op_RSHIFT_32, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_40 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_42 = LOGAND(op_RSHIFT_40, SN(32, 0xffff));
	RzILOpPure *op_MUL_45 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_34), DUP(op_AND_34))), CAST(16, MSB(DUP(op_AND_34)), DUP(op_AND_34))), CAST(32, MSB(CAST(16, MSB(op_AND_42), DUP(op_AND_42))), CAST(16, MSB(DUP(op_AND_42)), DUP(op_AND_42))));
	RzILOpPure *op_EQ_47 = EQ(SEXTRACT64(CAST(64, IL_FALSE, CAST(64, MSB(op_MUL_22), DUP(op_MUL_22))), SN(32, 0), SN(32, 0x20)), CAST(64, MSB(op_MUL_45), DUP(op_MUL_45)));
	RzILOpPure *op_RSHIFT_72 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_74 = LOGAND(op_RSHIFT_72, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_80 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_82 = LOGAND(op_RSHIFT_80, SN(32, 0xffff));
	RzILOpPure *op_MUL_85 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_74), DUP(op_AND_74))), CAST(16, MSB(DUP(op_AND_74)), DUP(op_AND_74))), CAST(32, MSB(CAST(16, MSB(op_AND_82), DUP(op_AND_82))), CAST(16, MSB(DUP(op_AND_82)), DUP(op_AND_82))));
	RzILOpPure *op_LT_89 = SLT(CAST(64, MSB(op_MUL_85), DUP(op_MUL_85)), CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_94 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_95 = NEG(op_LSHIFT_94);
	RzILOpPure *op_LSHIFT_100 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_103 = SUB(op_LSHIFT_100, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_104 = ITE(op_LT_89, op_NEG_95, op_SUB_103);
	RzILOpEffect *gcc_expr_105 = BRANCH(op_EQ_47, EMPTY(), set_usr_field_call_68);

	// h_tmp350 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))))), 0x0, 0x20) == ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_107 = SETL("h_tmp350", cond_104);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((st16) ...;
	RzILOpEffect *seq_108 = SEQN(2, gcc_expr_105, op_ASSIGN_hybrid_tmp_107);

	// Rd = ((st32) ((sextract64(((ut64) ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))))), 0x0, 0x20) == ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))))) ? ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) : h_tmp350));
	RzILOpPure *op_RSHIFT_51 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_53 = LOGAND(op_RSHIFT_51, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_59 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_61 = LOGAND(op_RSHIFT_59, SN(32, 0xffff));
	RzILOpPure *op_MUL_64 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_53), DUP(op_AND_53))), CAST(16, MSB(DUP(op_AND_53)), DUP(op_AND_53))), CAST(32, MSB(CAST(16, MSB(op_AND_61), DUP(op_AND_61))), CAST(16, MSB(DUP(op_AND_61)), DUP(op_AND_61))));
	RzILOpPure *cond_109 = ITE(DUP(op_EQ_47), CAST(64, MSB(op_MUL_64), DUP(op_MUL_64)), VARL("h_tmp350"));
	RzILOpEffect *op_ASSIGN_111 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(cond_109), DUP(cond_109)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((s ...;
	RzILOpEffect *seq_112 = SEQN(2, seq_108, op_ASSIGN_111);

	RzILOpEffect *instruction_sequence = seq_112;
	return instruction_sequence;
}

// Rd = mpy(Rs.h,Rt.l):<<1:sat
RzILOpEffect *hex_il_op_m2_mpy_sat_hl_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_74 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_LSHIFT_25 = SHIFTL0(CAST(64, MSB(op_MUL_22), DUP(op_MUL_22)), SN(32, 1));
	RzILOpPure *op_RSHIFT_34 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_36 = LOGAND(op_RSHIFT_34, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_42 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_44 = LOGAND(op_RSHIFT_42, SN(32, 0xffff));
	RzILOpPure *op_MUL_47 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_36), DUP(op_AND_36))), CAST(16, MSB(DUP(op_AND_36)), DUP(op_AND_36))), CAST(32, MSB(CAST(16, MSB(op_AND_44), DUP(op_AND_44))), CAST(16, MSB(DUP(op_AND_44)), DUP(op_AND_44))));
	RzILOpPure *op_LSHIFT_50 = SHIFTL0(CAST(64, MSB(op_MUL_47), DUP(op_MUL_47)), SN(32, 1));
	RzILOpPure *op_EQ_51 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_LSHIFT_25), SN(32, 0), SN(32, 0x20)), op_LSHIFT_50);
	RzILOpPure *op_RSHIFT_78 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_80 = LOGAND(op_RSHIFT_78, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_86 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_88 = LOGAND(op_RSHIFT_86, SN(32, 0xffff));
	RzILOpPure *op_MUL_91 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_80), DUP(op_AND_80))), CAST(16, MSB(DUP(op_AND_80)), DUP(op_AND_80))), CAST(32, MSB(CAST(16, MSB(op_AND_88), DUP(op_AND_88))), CAST(16, MSB(DUP(op_AND_88)), DUP(op_AND_88))));
	RzILOpPure *op_LSHIFT_94 = SHIFTL0(CAST(64, MSB(op_MUL_91), DUP(op_MUL_91)), SN(32, 1));
	RzILOpPure *op_LT_97 = SLT(op_LSHIFT_94, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_102 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_103 = NEG(op_LSHIFT_102);
	RzILOpPure *op_LSHIFT_108 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_111 = SUB(op_LSHIFT_108, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_112 = ITE(op_LT_97, op_NEG_103, op_SUB_111);
	RzILOpEffect *gcc_expr_113 = BRANCH(op_EQ_51, EMPTY(), set_usr_field_call_74);

	// h_tmp351 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_115 = SETL("h_tmp351", cond_112);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_116 = SEQN(2, gcc_expr_113, op_ASSIGN_hybrid_tmp_115);

	// Rd = ((st32) ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)) ? (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) : h_tmp351));
	RzILOpPure *op_RSHIFT_55 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_57 = LOGAND(op_RSHIFT_55, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_63 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_65 = LOGAND(op_RSHIFT_63, SN(32, 0xffff));
	RzILOpPure *op_MUL_68 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_57), DUP(op_AND_57))), CAST(16, MSB(DUP(op_AND_57)), DUP(op_AND_57))), CAST(32, MSB(CAST(16, MSB(op_AND_65), DUP(op_AND_65))), CAST(16, MSB(DUP(op_AND_65)), DUP(op_AND_65))));
	RzILOpPure *op_LSHIFT_71 = SHIFTL0(CAST(64, MSB(op_MUL_68), DUP(op_MUL_68)), SN(32, 1));
	RzILOpPure *cond_117 = ITE(DUP(op_EQ_51), op_LSHIFT_71, VARL("h_tmp351"));
	RzILOpEffect *op_ASSIGN_119 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(cond_117), DUP(cond_117)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_120 = SEQN(2, seq_116, op_ASSIGN_119);

	RzILOpEffect *instruction_sequence = seq_120;
	return instruction_sequence;
}

// Rd = mpy(Rs.l,Rt.h):sat
RzILOpEffect *hex_il_op_m2_mpy_sat_lh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_68 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))))), 0x0, 0x20) == ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_RSHIFT_32 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_34 = LOGAND(op_RSHIFT_32, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_40 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_42 = LOGAND(op_RSHIFT_40, SN(32, 0xffff));
	RzILOpPure *op_MUL_45 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_34), DUP(op_AND_34))), CAST(16, MSB(DUP(op_AND_34)), DUP(op_AND_34))), CAST(32, MSB(CAST(16, MSB(op_AND_42), DUP(op_AND_42))), CAST(16, MSB(DUP(op_AND_42)), DUP(op_AND_42))));
	RzILOpPure *op_EQ_47 = EQ(SEXTRACT64(CAST(64, IL_FALSE, CAST(64, MSB(op_MUL_22), DUP(op_MUL_22))), SN(32, 0), SN(32, 0x20)), CAST(64, MSB(op_MUL_45), DUP(op_MUL_45)));
	RzILOpPure *op_RSHIFT_72 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_74 = LOGAND(op_RSHIFT_72, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_80 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_82 = LOGAND(op_RSHIFT_80, SN(32, 0xffff));
	RzILOpPure *op_MUL_85 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_74), DUP(op_AND_74))), CAST(16, MSB(DUP(op_AND_74)), DUP(op_AND_74))), CAST(32, MSB(CAST(16, MSB(op_AND_82), DUP(op_AND_82))), CAST(16, MSB(DUP(op_AND_82)), DUP(op_AND_82))));
	RzILOpPure *op_LT_89 = SLT(CAST(64, MSB(op_MUL_85), DUP(op_MUL_85)), CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_94 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_95 = NEG(op_LSHIFT_94);
	RzILOpPure *op_LSHIFT_100 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_103 = SUB(op_LSHIFT_100, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_104 = ITE(op_LT_89, op_NEG_95, op_SUB_103);
	RzILOpEffect *gcc_expr_105 = BRANCH(op_EQ_47, EMPTY(), set_usr_field_call_68);

	// h_tmp352 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))))), 0x0, 0x20) == ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_107 = SETL("h_tmp352", cond_104);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((st16) ...;
	RzILOpEffect *seq_108 = SEQN(2, gcc_expr_105, op_ASSIGN_hybrid_tmp_107);

	// Rd = ((st32) ((sextract64(((ut64) ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))))), 0x0, 0x20) == ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))))) ? ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) : h_tmp352));
	RzILOpPure *op_RSHIFT_51 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_53 = LOGAND(op_RSHIFT_51, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_59 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_61 = LOGAND(op_RSHIFT_59, SN(32, 0xffff));
	RzILOpPure *op_MUL_64 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_53), DUP(op_AND_53))), CAST(16, MSB(DUP(op_AND_53)), DUP(op_AND_53))), CAST(32, MSB(CAST(16, MSB(op_AND_61), DUP(op_AND_61))), CAST(16, MSB(DUP(op_AND_61)), DUP(op_AND_61))));
	RzILOpPure *cond_109 = ITE(DUP(op_EQ_47), CAST(64, MSB(op_MUL_64), DUP(op_MUL_64)), VARL("h_tmp352"));
	RzILOpEffect *op_ASSIGN_111 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(cond_109), DUP(cond_109)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((s ...;
	RzILOpEffect *seq_112 = SEQN(2, seq_108, op_ASSIGN_111);

	RzILOpEffect *instruction_sequence = seq_112;
	return instruction_sequence;
}

// Rd = mpy(Rs.l,Rt.h):<<1:sat
RzILOpEffect *hex_il_op_m2_mpy_sat_lh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_74 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_LSHIFT_25 = SHIFTL0(CAST(64, MSB(op_MUL_22), DUP(op_MUL_22)), SN(32, 1));
	RzILOpPure *op_RSHIFT_34 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_36 = LOGAND(op_RSHIFT_34, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_42 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_44 = LOGAND(op_RSHIFT_42, SN(32, 0xffff));
	RzILOpPure *op_MUL_47 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_36), DUP(op_AND_36))), CAST(16, MSB(DUP(op_AND_36)), DUP(op_AND_36))), CAST(32, MSB(CAST(16, MSB(op_AND_44), DUP(op_AND_44))), CAST(16, MSB(DUP(op_AND_44)), DUP(op_AND_44))));
	RzILOpPure *op_LSHIFT_50 = SHIFTL0(CAST(64, MSB(op_MUL_47), DUP(op_MUL_47)), SN(32, 1));
	RzILOpPure *op_EQ_51 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_LSHIFT_25), SN(32, 0), SN(32, 0x20)), op_LSHIFT_50);
	RzILOpPure *op_RSHIFT_78 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_80 = LOGAND(op_RSHIFT_78, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_86 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_88 = LOGAND(op_RSHIFT_86, SN(32, 0xffff));
	RzILOpPure *op_MUL_91 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_80), DUP(op_AND_80))), CAST(16, MSB(DUP(op_AND_80)), DUP(op_AND_80))), CAST(32, MSB(CAST(16, MSB(op_AND_88), DUP(op_AND_88))), CAST(16, MSB(DUP(op_AND_88)), DUP(op_AND_88))));
	RzILOpPure *op_LSHIFT_94 = SHIFTL0(CAST(64, MSB(op_MUL_91), DUP(op_MUL_91)), SN(32, 1));
	RzILOpPure *op_LT_97 = SLT(op_LSHIFT_94, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_102 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_103 = NEG(op_LSHIFT_102);
	RzILOpPure *op_LSHIFT_108 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_111 = SUB(op_LSHIFT_108, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_112 = ITE(op_LT_97, op_NEG_103, op_SUB_111);
	RzILOpEffect *gcc_expr_113 = BRANCH(op_EQ_51, EMPTY(), set_usr_field_call_74);

	// h_tmp353 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_115 = SETL("h_tmp353", cond_112);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_116 = SEQN(2, gcc_expr_113, op_ASSIGN_hybrid_tmp_115);

	// Rd = ((st32) ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)) ? (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) : h_tmp353));
	RzILOpPure *op_RSHIFT_55 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_57 = LOGAND(op_RSHIFT_55, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_63 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_65 = LOGAND(op_RSHIFT_63, SN(32, 0xffff));
	RzILOpPure *op_MUL_68 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_57), DUP(op_AND_57))), CAST(16, MSB(DUP(op_AND_57)), DUP(op_AND_57))), CAST(32, MSB(CAST(16, MSB(op_AND_65), DUP(op_AND_65))), CAST(16, MSB(DUP(op_AND_65)), DUP(op_AND_65))));
	RzILOpPure *op_LSHIFT_71 = SHIFTL0(CAST(64, MSB(op_MUL_68), DUP(op_MUL_68)), SN(32, 1));
	RzILOpPure *cond_117 = ITE(DUP(op_EQ_51), op_LSHIFT_71, VARL("h_tmp353"));
	RzILOpEffect *op_ASSIGN_119 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(cond_117), DUP(cond_117)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_120 = SEQN(2, seq_116, op_ASSIGN_119);

	RzILOpEffect *instruction_sequence = seq_120;
	return instruction_sequence;
}

// Rd = mpy(Rs.l,Rt.l):sat
RzILOpEffect *hex_il_op_m2_mpy_sat_ll_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_68 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))))), 0x0, 0x20) == ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_RSHIFT_32 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_34 = LOGAND(op_RSHIFT_32, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_40 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_42 = LOGAND(op_RSHIFT_40, SN(32, 0xffff));
	RzILOpPure *op_MUL_45 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_34), DUP(op_AND_34))), CAST(16, MSB(DUP(op_AND_34)), DUP(op_AND_34))), CAST(32, MSB(CAST(16, MSB(op_AND_42), DUP(op_AND_42))), CAST(16, MSB(DUP(op_AND_42)), DUP(op_AND_42))));
	RzILOpPure *op_EQ_47 = EQ(SEXTRACT64(CAST(64, IL_FALSE, CAST(64, MSB(op_MUL_22), DUP(op_MUL_22))), SN(32, 0), SN(32, 0x20)), CAST(64, MSB(op_MUL_45), DUP(op_MUL_45)));
	RzILOpPure *op_RSHIFT_72 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_74 = LOGAND(op_RSHIFT_72, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_80 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_82 = LOGAND(op_RSHIFT_80, SN(32, 0xffff));
	RzILOpPure *op_MUL_85 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_74), DUP(op_AND_74))), CAST(16, MSB(DUP(op_AND_74)), DUP(op_AND_74))), CAST(32, MSB(CAST(16, MSB(op_AND_82), DUP(op_AND_82))), CAST(16, MSB(DUP(op_AND_82)), DUP(op_AND_82))));
	RzILOpPure *op_LT_89 = SLT(CAST(64, MSB(op_MUL_85), DUP(op_MUL_85)), CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_94 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_95 = NEG(op_LSHIFT_94);
	RzILOpPure *op_LSHIFT_100 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_103 = SUB(op_LSHIFT_100, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_104 = ITE(op_LT_89, op_NEG_95, op_SUB_103);
	RzILOpEffect *gcc_expr_105 = BRANCH(op_EQ_47, EMPTY(), set_usr_field_call_68);

	// h_tmp354 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))))), 0x0, 0x20) == ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_107 = SETL("h_tmp354", cond_104);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((st16) ...;
	RzILOpEffect *seq_108 = SEQN(2, gcc_expr_105, op_ASSIGN_hybrid_tmp_107);

	// Rd = ((st32) ((sextract64(((ut64) ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))))), 0x0, 0x20) == ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))))) ? ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) : h_tmp354));
	RzILOpPure *op_RSHIFT_51 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_53 = LOGAND(op_RSHIFT_51, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_59 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_61 = LOGAND(op_RSHIFT_59, SN(32, 0xffff));
	RzILOpPure *op_MUL_64 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_53), DUP(op_AND_53))), CAST(16, MSB(DUP(op_AND_53)), DUP(op_AND_53))), CAST(32, MSB(CAST(16, MSB(op_AND_61), DUP(op_AND_61))), CAST(16, MSB(DUP(op_AND_61)), DUP(op_AND_61))));
	RzILOpPure *cond_109 = ITE(DUP(op_EQ_47), CAST(64, MSB(op_MUL_64), DUP(op_MUL_64)), VARL("h_tmp354"));
	RzILOpEffect *op_ASSIGN_111 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(cond_109), DUP(cond_109)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((s ...;
	RzILOpEffect *seq_112 = SEQN(2, seq_108, op_ASSIGN_111);

	RzILOpEffect *instruction_sequence = seq_112;
	return instruction_sequence;
}

// Rd = mpy(Rs.l,Rt.l):<<1:sat
RzILOpEffect *hex_il_op_m2_mpy_sat_ll_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_74 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_LSHIFT_25 = SHIFTL0(CAST(64, MSB(op_MUL_22), DUP(op_MUL_22)), SN(32, 1));
	RzILOpPure *op_RSHIFT_34 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_36 = LOGAND(op_RSHIFT_34, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_42 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_44 = LOGAND(op_RSHIFT_42, SN(32, 0xffff));
	RzILOpPure *op_MUL_47 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_36), DUP(op_AND_36))), CAST(16, MSB(DUP(op_AND_36)), DUP(op_AND_36))), CAST(32, MSB(CAST(16, MSB(op_AND_44), DUP(op_AND_44))), CAST(16, MSB(DUP(op_AND_44)), DUP(op_AND_44))));
	RzILOpPure *op_LSHIFT_50 = SHIFTL0(CAST(64, MSB(op_MUL_47), DUP(op_MUL_47)), SN(32, 1));
	RzILOpPure *op_EQ_51 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_LSHIFT_25), SN(32, 0), SN(32, 0x20)), op_LSHIFT_50);
	RzILOpPure *op_RSHIFT_78 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_80 = LOGAND(op_RSHIFT_78, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_86 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_88 = LOGAND(op_RSHIFT_86, SN(32, 0xffff));
	RzILOpPure *op_MUL_91 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_80), DUP(op_AND_80))), CAST(16, MSB(DUP(op_AND_80)), DUP(op_AND_80))), CAST(32, MSB(CAST(16, MSB(op_AND_88), DUP(op_AND_88))), CAST(16, MSB(DUP(op_AND_88)), DUP(op_AND_88))));
	RzILOpPure *op_LSHIFT_94 = SHIFTL0(CAST(64, MSB(op_MUL_91), DUP(op_MUL_91)), SN(32, 1));
	RzILOpPure *op_LT_97 = SLT(op_LSHIFT_94, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_102 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_103 = NEG(op_LSHIFT_102);
	RzILOpPure *op_LSHIFT_108 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_111 = SUB(op_LSHIFT_108, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_112 = ITE(op_LT_97, op_NEG_103, op_SUB_111);
	RzILOpEffect *gcc_expr_113 = BRANCH(op_EQ_51, EMPTY(), set_usr_field_call_74);

	// h_tmp355 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_115 = SETL("h_tmp355", cond_112);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_116 = SEQN(2, gcc_expr_113, op_ASSIGN_hybrid_tmp_115);

	// Rd = ((st32) ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)) ? (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) : h_tmp355));
	RzILOpPure *op_RSHIFT_55 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_57 = LOGAND(op_RSHIFT_55, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_63 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_65 = LOGAND(op_RSHIFT_63, SN(32, 0xffff));
	RzILOpPure *op_MUL_68 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_57), DUP(op_AND_57))), CAST(16, MSB(DUP(op_AND_57)), DUP(op_AND_57))), CAST(32, MSB(CAST(16, MSB(op_AND_65), DUP(op_AND_65))), CAST(16, MSB(DUP(op_AND_65)), DUP(op_AND_65))));
	RzILOpPure *op_LSHIFT_71 = SHIFTL0(CAST(64, MSB(op_MUL_68), DUP(op_MUL_68)), SN(32, 1));
	RzILOpPure *cond_117 = ITE(DUP(op_EQ_51), op_LSHIFT_71, VARL("h_tmp355"));
	RzILOpEffect *op_ASSIGN_119 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(cond_117), DUP(cond_117)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_120 = SEQN(2, seq_116, op_ASSIGN_119);

	RzILOpEffect *instruction_sequence = seq_120;
	return instruction_sequence;
}

// Rd = mpy(Rs.h,Rt.h):rnd:sat
RzILOpEffect *hex_il_op_m2_mpy_sat_rnd_hh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_77 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) + ((st64) 0x8000)), 0x0, 0x20) == ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_ADD_26 = ADD(CAST(64, MSB(op_MUL_22), DUP(op_MUL_22)), CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_35 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_37 = LOGAND(op_RSHIFT_35, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_43 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_45 = LOGAND(op_RSHIFT_43, SN(32, 0xffff));
	RzILOpPure *op_MUL_48 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_37), DUP(op_AND_37))), CAST(16, MSB(DUP(op_AND_37)), DUP(op_AND_37))), CAST(32, MSB(CAST(16, MSB(op_AND_45), DUP(op_AND_45))), CAST(16, MSB(DUP(op_AND_45)), DUP(op_AND_45))));
	RzILOpPure *op_ADD_52 = ADD(CAST(64, MSB(op_MUL_48), DUP(op_MUL_48)), CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_EQ_53 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_26), SN(32, 0), SN(32, 0x20)), op_ADD_52);
	RzILOpPure *op_RSHIFT_81 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_83 = LOGAND(op_RSHIFT_81, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_89 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_91 = LOGAND(op_RSHIFT_89, SN(32, 0xffff));
	RzILOpPure *op_MUL_94 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_83), DUP(op_AND_83))), CAST(16, MSB(DUP(op_AND_83)), DUP(op_AND_83))), CAST(32, MSB(CAST(16, MSB(op_AND_91), DUP(op_AND_91))), CAST(16, MSB(DUP(op_AND_91)), DUP(op_AND_91))));
	RzILOpPure *op_ADD_98 = ADD(CAST(64, MSB(op_MUL_94), DUP(op_MUL_94)), CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_LT_101 = SLT(op_ADD_98, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_106 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_107 = NEG(op_LSHIFT_106);
	RzILOpPure *op_LSHIFT_112 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_115 = SUB(op_LSHIFT_112, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_116 = ITE(op_LT_101, op_NEG_107, op_SUB_115);
	RzILOpEffect *gcc_expr_117 = BRANCH(op_EQ_53, EMPTY(), set_usr_field_call_77);

	// h_tmp356 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) + ((st64) 0x8000)), 0x0, 0x20) == ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_119 = SETL("h_tmp356", cond_116);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((st16) ...;
	RzILOpEffect *seq_120 = SEQN(2, gcc_expr_117, op_ASSIGN_hybrid_tmp_119);

	// Rd = ((st32) ((sextract64(((ut64) ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) + ((st64) 0x8000)), 0x0, 0x20) == ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) + ((st64) 0x8000)) ? ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) + ((st64) 0x8000) : h_tmp356));
	RzILOpPure *op_RSHIFT_57 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_59 = LOGAND(op_RSHIFT_57, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_65 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_67 = LOGAND(op_RSHIFT_65, SN(32, 0xffff));
	RzILOpPure *op_MUL_70 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_59), DUP(op_AND_59))), CAST(16, MSB(DUP(op_AND_59)), DUP(op_AND_59))), CAST(32, MSB(CAST(16, MSB(op_AND_67), DUP(op_AND_67))), CAST(16, MSB(DUP(op_AND_67)), DUP(op_AND_67))));
	RzILOpPure *op_ADD_74 = ADD(CAST(64, MSB(op_MUL_70), DUP(op_MUL_70)), CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *cond_121 = ITE(DUP(op_EQ_53), op_ADD_74, VARL("h_tmp356"));
	RzILOpEffect *op_ASSIGN_123 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(cond_121), DUP(cond_121)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((s ...;
	RzILOpEffect *seq_124 = SEQN(2, seq_120, op_ASSIGN_123);

	RzILOpEffect *instruction_sequence = seq_124;
	return instruction_sequence;
}

// Rd = mpy(Rs.h,Rt.h):<<1:rnd:sat
RzILOpEffect *hex_il_op_m2_mpy_sat_rnd_hh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_83 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_LSHIFT_25 = SHIFTL0(CAST(64, MSB(op_MUL_22), DUP(op_MUL_22)), SN(32, 1));
	RzILOpPure *op_ADD_28 = ADD(op_LSHIFT_25, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_37 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_39 = LOGAND(op_RSHIFT_37, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_45 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_47 = LOGAND(op_RSHIFT_45, SN(32, 0xffff));
	RzILOpPure *op_MUL_50 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_39), DUP(op_AND_39))), CAST(16, MSB(DUP(op_AND_39)), DUP(op_AND_39))), CAST(32, MSB(CAST(16, MSB(op_AND_47), DUP(op_AND_47))), CAST(16, MSB(DUP(op_AND_47)), DUP(op_AND_47))));
	RzILOpPure *op_LSHIFT_53 = SHIFTL0(CAST(64, MSB(op_MUL_50), DUP(op_MUL_50)), SN(32, 1));
	RzILOpPure *op_ADD_56 = ADD(op_LSHIFT_53, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_EQ_57 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_28), SN(32, 0), SN(32, 0x20)), op_ADD_56);
	RzILOpPure *op_RSHIFT_87 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_89 = LOGAND(op_RSHIFT_87, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_95 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_97 = LOGAND(op_RSHIFT_95, SN(32, 0xffff));
	RzILOpPure *op_MUL_100 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_89), DUP(op_AND_89))), CAST(16, MSB(DUP(op_AND_89)), DUP(op_AND_89))), CAST(32, MSB(CAST(16, MSB(op_AND_97), DUP(op_AND_97))), CAST(16, MSB(DUP(op_AND_97)), DUP(op_AND_97))));
	RzILOpPure *op_LSHIFT_103 = SHIFTL0(CAST(64, MSB(op_MUL_100), DUP(op_MUL_100)), SN(32, 1));
	RzILOpPure *op_ADD_106 = ADD(op_LSHIFT_103, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_LT_109 = SLT(op_ADD_106, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_114 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_115 = NEG(op_LSHIFT_114);
	RzILOpPure *op_LSHIFT_120 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_123 = SUB(op_LSHIFT_120, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_124 = ITE(op_LT_109, op_NEG_115, op_SUB_123);
	RzILOpEffect *gcc_expr_125 = BRANCH(op_EQ_57, EMPTY(), set_usr_field_call_83);

	// h_tmp357 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_127 = SETL("h_tmp357", cond_124);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_128 = SEQN(2, gcc_expr_125, op_ASSIGN_hybrid_tmp_127);

	// Rd = ((st32) ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000)) ? (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000) : h_tmp357));
	RzILOpPure *op_RSHIFT_61 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_63 = LOGAND(op_RSHIFT_61, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_69 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_71 = LOGAND(op_RSHIFT_69, SN(32, 0xffff));
	RzILOpPure *op_MUL_74 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_63), DUP(op_AND_63))), CAST(16, MSB(DUP(op_AND_63)), DUP(op_AND_63))), CAST(32, MSB(CAST(16, MSB(op_AND_71), DUP(op_AND_71))), CAST(16, MSB(DUP(op_AND_71)), DUP(op_AND_71))));
	RzILOpPure *op_LSHIFT_77 = SHIFTL0(CAST(64, MSB(op_MUL_74), DUP(op_MUL_74)), SN(32, 1));
	RzILOpPure *op_ADD_80 = ADD(op_LSHIFT_77, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *cond_129 = ITE(DUP(op_EQ_57), op_ADD_80, VARL("h_tmp357"));
	RzILOpEffect *op_ASSIGN_131 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(cond_129), DUP(cond_129)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_132 = SEQN(2, seq_128, op_ASSIGN_131);

	RzILOpEffect *instruction_sequence = seq_132;
	return instruction_sequence;
}

// Rd = mpy(Rs.h,Rt.l):rnd:sat
RzILOpEffect *hex_il_op_m2_mpy_sat_rnd_hl_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_77 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) + ((st64) 0x8000)), 0x0, 0x20) == ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_ADD_26 = ADD(CAST(64, MSB(op_MUL_22), DUP(op_MUL_22)), CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_35 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_37 = LOGAND(op_RSHIFT_35, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_43 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_45 = LOGAND(op_RSHIFT_43, SN(32, 0xffff));
	RzILOpPure *op_MUL_48 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_37), DUP(op_AND_37))), CAST(16, MSB(DUP(op_AND_37)), DUP(op_AND_37))), CAST(32, MSB(CAST(16, MSB(op_AND_45), DUP(op_AND_45))), CAST(16, MSB(DUP(op_AND_45)), DUP(op_AND_45))));
	RzILOpPure *op_ADD_52 = ADD(CAST(64, MSB(op_MUL_48), DUP(op_MUL_48)), CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_EQ_53 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_26), SN(32, 0), SN(32, 0x20)), op_ADD_52);
	RzILOpPure *op_RSHIFT_81 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_83 = LOGAND(op_RSHIFT_81, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_89 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_91 = LOGAND(op_RSHIFT_89, SN(32, 0xffff));
	RzILOpPure *op_MUL_94 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_83), DUP(op_AND_83))), CAST(16, MSB(DUP(op_AND_83)), DUP(op_AND_83))), CAST(32, MSB(CAST(16, MSB(op_AND_91), DUP(op_AND_91))), CAST(16, MSB(DUP(op_AND_91)), DUP(op_AND_91))));
	RzILOpPure *op_ADD_98 = ADD(CAST(64, MSB(op_MUL_94), DUP(op_MUL_94)), CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_LT_101 = SLT(op_ADD_98, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_106 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_107 = NEG(op_LSHIFT_106);
	RzILOpPure *op_LSHIFT_112 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_115 = SUB(op_LSHIFT_112, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_116 = ITE(op_LT_101, op_NEG_107, op_SUB_115);
	RzILOpEffect *gcc_expr_117 = BRANCH(op_EQ_53, EMPTY(), set_usr_field_call_77);

	// h_tmp358 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) + ((st64) 0x8000)), 0x0, 0x20) == ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_119 = SETL("h_tmp358", cond_116);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((st16) ...;
	RzILOpEffect *seq_120 = SEQN(2, gcc_expr_117, op_ASSIGN_hybrid_tmp_119);

	// Rd = ((st32) ((sextract64(((ut64) ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) + ((st64) 0x8000)), 0x0, 0x20) == ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) + ((st64) 0x8000)) ? ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) + ((st64) 0x8000) : h_tmp358));
	RzILOpPure *op_RSHIFT_57 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_59 = LOGAND(op_RSHIFT_57, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_65 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_67 = LOGAND(op_RSHIFT_65, SN(32, 0xffff));
	RzILOpPure *op_MUL_70 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_59), DUP(op_AND_59))), CAST(16, MSB(DUP(op_AND_59)), DUP(op_AND_59))), CAST(32, MSB(CAST(16, MSB(op_AND_67), DUP(op_AND_67))), CAST(16, MSB(DUP(op_AND_67)), DUP(op_AND_67))));
	RzILOpPure *op_ADD_74 = ADD(CAST(64, MSB(op_MUL_70), DUP(op_MUL_70)), CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *cond_121 = ITE(DUP(op_EQ_53), op_ADD_74, VARL("h_tmp358"));
	RzILOpEffect *op_ASSIGN_123 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(cond_121), DUP(cond_121)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((s ...;
	RzILOpEffect *seq_124 = SEQN(2, seq_120, op_ASSIGN_123);

	RzILOpEffect *instruction_sequence = seq_124;
	return instruction_sequence;
}

// Rd = mpy(Rs.h,Rt.l):<<1:rnd:sat
RzILOpEffect *hex_il_op_m2_mpy_sat_rnd_hl_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_83 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_LSHIFT_25 = SHIFTL0(CAST(64, MSB(op_MUL_22), DUP(op_MUL_22)), SN(32, 1));
	RzILOpPure *op_ADD_28 = ADD(op_LSHIFT_25, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_37 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_39 = LOGAND(op_RSHIFT_37, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_45 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_47 = LOGAND(op_RSHIFT_45, SN(32, 0xffff));
	RzILOpPure *op_MUL_50 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_39), DUP(op_AND_39))), CAST(16, MSB(DUP(op_AND_39)), DUP(op_AND_39))), CAST(32, MSB(CAST(16, MSB(op_AND_47), DUP(op_AND_47))), CAST(16, MSB(DUP(op_AND_47)), DUP(op_AND_47))));
	RzILOpPure *op_LSHIFT_53 = SHIFTL0(CAST(64, MSB(op_MUL_50), DUP(op_MUL_50)), SN(32, 1));
	RzILOpPure *op_ADD_56 = ADD(op_LSHIFT_53, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_EQ_57 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_28), SN(32, 0), SN(32, 0x20)), op_ADD_56);
	RzILOpPure *op_RSHIFT_87 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_89 = LOGAND(op_RSHIFT_87, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_95 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_97 = LOGAND(op_RSHIFT_95, SN(32, 0xffff));
	RzILOpPure *op_MUL_100 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_89), DUP(op_AND_89))), CAST(16, MSB(DUP(op_AND_89)), DUP(op_AND_89))), CAST(32, MSB(CAST(16, MSB(op_AND_97), DUP(op_AND_97))), CAST(16, MSB(DUP(op_AND_97)), DUP(op_AND_97))));
	RzILOpPure *op_LSHIFT_103 = SHIFTL0(CAST(64, MSB(op_MUL_100), DUP(op_MUL_100)), SN(32, 1));
	RzILOpPure *op_ADD_106 = ADD(op_LSHIFT_103, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_LT_109 = SLT(op_ADD_106, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_114 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_115 = NEG(op_LSHIFT_114);
	RzILOpPure *op_LSHIFT_120 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_123 = SUB(op_LSHIFT_120, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_124 = ITE(op_LT_109, op_NEG_115, op_SUB_123);
	RzILOpEffect *gcc_expr_125 = BRANCH(op_EQ_57, EMPTY(), set_usr_field_call_83);

	// h_tmp359 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_127 = SETL("h_tmp359", cond_124);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_128 = SEQN(2, gcc_expr_125, op_ASSIGN_hybrid_tmp_127);

	// Rd = ((st32) ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000)) ? (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000) : h_tmp359));
	RzILOpPure *op_RSHIFT_61 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_63 = LOGAND(op_RSHIFT_61, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_69 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_71 = LOGAND(op_RSHIFT_69, SN(32, 0xffff));
	RzILOpPure *op_MUL_74 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_63), DUP(op_AND_63))), CAST(16, MSB(DUP(op_AND_63)), DUP(op_AND_63))), CAST(32, MSB(CAST(16, MSB(op_AND_71), DUP(op_AND_71))), CAST(16, MSB(DUP(op_AND_71)), DUP(op_AND_71))));
	RzILOpPure *op_LSHIFT_77 = SHIFTL0(CAST(64, MSB(op_MUL_74), DUP(op_MUL_74)), SN(32, 1));
	RzILOpPure *op_ADD_80 = ADD(op_LSHIFT_77, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *cond_129 = ITE(DUP(op_EQ_57), op_ADD_80, VARL("h_tmp359"));
	RzILOpEffect *op_ASSIGN_131 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(cond_129), DUP(cond_129)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_132 = SEQN(2, seq_128, op_ASSIGN_131);

	RzILOpEffect *instruction_sequence = seq_132;
	return instruction_sequence;
}

// Rd = mpy(Rs.l,Rt.h):rnd:sat
RzILOpEffect *hex_il_op_m2_mpy_sat_rnd_lh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_77 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) + ((st64) 0x8000)), 0x0, 0x20) == ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_ADD_26 = ADD(CAST(64, MSB(op_MUL_22), DUP(op_MUL_22)), CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_35 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_37 = LOGAND(op_RSHIFT_35, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_43 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_45 = LOGAND(op_RSHIFT_43, SN(32, 0xffff));
	RzILOpPure *op_MUL_48 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_37), DUP(op_AND_37))), CAST(16, MSB(DUP(op_AND_37)), DUP(op_AND_37))), CAST(32, MSB(CAST(16, MSB(op_AND_45), DUP(op_AND_45))), CAST(16, MSB(DUP(op_AND_45)), DUP(op_AND_45))));
	RzILOpPure *op_ADD_52 = ADD(CAST(64, MSB(op_MUL_48), DUP(op_MUL_48)), CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_EQ_53 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_26), SN(32, 0), SN(32, 0x20)), op_ADD_52);
	RzILOpPure *op_RSHIFT_81 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_83 = LOGAND(op_RSHIFT_81, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_89 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_91 = LOGAND(op_RSHIFT_89, SN(32, 0xffff));
	RzILOpPure *op_MUL_94 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_83), DUP(op_AND_83))), CAST(16, MSB(DUP(op_AND_83)), DUP(op_AND_83))), CAST(32, MSB(CAST(16, MSB(op_AND_91), DUP(op_AND_91))), CAST(16, MSB(DUP(op_AND_91)), DUP(op_AND_91))));
	RzILOpPure *op_ADD_98 = ADD(CAST(64, MSB(op_MUL_94), DUP(op_MUL_94)), CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_LT_101 = SLT(op_ADD_98, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_106 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_107 = NEG(op_LSHIFT_106);
	RzILOpPure *op_LSHIFT_112 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_115 = SUB(op_LSHIFT_112, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_116 = ITE(op_LT_101, op_NEG_107, op_SUB_115);
	RzILOpEffect *gcc_expr_117 = BRANCH(op_EQ_53, EMPTY(), set_usr_field_call_77);

	// h_tmp360 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) + ((st64) 0x8000)), 0x0, 0x20) == ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_119 = SETL("h_tmp360", cond_116);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((st16) ...;
	RzILOpEffect *seq_120 = SEQN(2, gcc_expr_117, op_ASSIGN_hybrid_tmp_119);

	// Rd = ((st32) ((sextract64(((ut64) ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) + ((st64) 0x8000)), 0x0, 0x20) == ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) + ((st64) 0x8000)) ? ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) + ((st64) 0x8000) : h_tmp360));
	RzILOpPure *op_RSHIFT_57 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_59 = LOGAND(op_RSHIFT_57, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_65 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_67 = LOGAND(op_RSHIFT_65, SN(32, 0xffff));
	RzILOpPure *op_MUL_70 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_59), DUP(op_AND_59))), CAST(16, MSB(DUP(op_AND_59)), DUP(op_AND_59))), CAST(32, MSB(CAST(16, MSB(op_AND_67), DUP(op_AND_67))), CAST(16, MSB(DUP(op_AND_67)), DUP(op_AND_67))));
	RzILOpPure *op_ADD_74 = ADD(CAST(64, MSB(op_MUL_70), DUP(op_MUL_70)), CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *cond_121 = ITE(DUP(op_EQ_53), op_ADD_74, VARL("h_tmp360"));
	RzILOpEffect *op_ASSIGN_123 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(cond_121), DUP(cond_121)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((s ...;
	RzILOpEffect *seq_124 = SEQN(2, seq_120, op_ASSIGN_123);

	RzILOpEffect *instruction_sequence = seq_124;
	return instruction_sequence;
}

// Rd = mpy(Rs.l,Rt.h):<<1:rnd:sat
RzILOpEffect *hex_il_op_m2_mpy_sat_rnd_lh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_83 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_LSHIFT_25 = SHIFTL0(CAST(64, MSB(op_MUL_22), DUP(op_MUL_22)), SN(32, 1));
	RzILOpPure *op_ADD_28 = ADD(op_LSHIFT_25, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_37 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_39 = LOGAND(op_RSHIFT_37, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_45 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_47 = LOGAND(op_RSHIFT_45, SN(32, 0xffff));
	RzILOpPure *op_MUL_50 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_39), DUP(op_AND_39))), CAST(16, MSB(DUP(op_AND_39)), DUP(op_AND_39))), CAST(32, MSB(CAST(16, MSB(op_AND_47), DUP(op_AND_47))), CAST(16, MSB(DUP(op_AND_47)), DUP(op_AND_47))));
	RzILOpPure *op_LSHIFT_53 = SHIFTL0(CAST(64, MSB(op_MUL_50), DUP(op_MUL_50)), SN(32, 1));
	RzILOpPure *op_ADD_56 = ADD(op_LSHIFT_53, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_EQ_57 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_28), SN(32, 0), SN(32, 0x20)), op_ADD_56);
	RzILOpPure *op_RSHIFT_87 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_89 = LOGAND(op_RSHIFT_87, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_95 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_97 = LOGAND(op_RSHIFT_95, SN(32, 0xffff));
	RzILOpPure *op_MUL_100 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_89), DUP(op_AND_89))), CAST(16, MSB(DUP(op_AND_89)), DUP(op_AND_89))), CAST(32, MSB(CAST(16, MSB(op_AND_97), DUP(op_AND_97))), CAST(16, MSB(DUP(op_AND_97)), DUP(op_AND_97))));
	RzILOpPure *op_LSHIFT_103 = SHIFTL0(CAST(64, MSB(op_MUL_100), DUP(op_MUL_100)), SN(32, 1));
	RzILOpPure *op_ADD_106 = ADD(op_LSHIFT_103, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_LT_109 = SLT(op_ADD_106, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_114 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_115 = NEG(op_LSHIFT_114);
	RzILOpPure *op_LSHIFT_120 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_123 = SUB(op_LSHIFT_120, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_124 = ITE(op_LT_109, op_NEG_115, op_SUB_123);
	RzILOpEffect *gcc_expr_125 = BRANCH(op_EQ_57, EMPTY(), set_usr_field_call_83);

	// h_tmp361 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_127 = SETL("h_tmp361", cond_124);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_128 = SEQN(2, gcc_expr_125, op_ASSIGN_hybrid_tmp_127);

	// Rd = ((st32) ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000)) ? (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000) : h_tmp361));
	RzILOpPure *op_RSHIFT_61 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_63 = LOGAND(op_RSHIFT_61, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_69 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_71 = LOGAND(op_RSHIFT_69, SN(32, 0xffff));
	RzILOpPure *op_MUL_74 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_63), DUP(op_AND_63))), CAST(16, MSB(DUP(op_AND_63)), DUP(op_AND_63))), CAST(32, MSB(CAST(16, MSB(op_AND_71), DUP(op_AND_71))), CAST(16, MSB(DUP(op_AND_71)), DUP(op_AND_71))));
	RzILOpPure *op_LSHIFT_77 = SHIFTL0(CAST(64, MSB(op_MUL_74), DUP(op_MUL_74)), SN(32, 1));
	RzILOpPure *op_ADD_80 = ADD(op_LSHIFT_77, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *cond_129 = ITE(DUP(op_EQ_57), op_ADD_80, VARL("h_tmp361"));
	RzILOpEffect *op_ASSIGN_131 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(cond_129), DUP(cond_129)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_132 = SEQN(2, seq_128, op_ASSIGN_131);

	RzILOpEffect *instruction_sequence = seq_132;
	return instruction_sequence;
}

// Rd = mpy(Rs.l,Rt.l):rnd:sat
RzILOpEffect *hex_il_op_m2_mpy_sat_rnd_ll_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_77 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) + ((st64) 0x8000)), 0x0, 0x20) == ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_ADD_26 = ADD(CAST(64, MSB(op_MUL_22), DUP(op_MUL_22)), CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_35 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_37 = LOGAND(op_RSHIFT_35, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_43 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_45 = LOGAND(op_RSHIFT_43, SN(32, 0xffff));
	RzILOpPure *op_MUL_48 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_37), DUP(op_AND_37))), CAST(16, MSB(DUP(op_AND_37)), DUP(op_AND_37))), CAST(32, MSB(CAST(16, MSB(op_AND_45), DUP(op_AND_45))), CAST(16, MSB(DUP(op_AND_45)), DUP(op_AND_45))));
	RzILOpPure *op_ADD_52 = ADD(CAST(64, MSB(op_MUL_48), DUP(op_MUL_48)), CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_EQ_53 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_26), SN(32, 0), SN(32, 0x20)), op_ADD_52);
	RzILOpPure *op_RSHIFT_81 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_83 = LOGAND(op_RSHIFT_81, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_89 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_91 = LOGAND(op_RSHIFT_89, SN(32, 0xffff));
	RzILOpPure *op_MUL_94 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_83), DUP(op_AND_83))), CAST(16, MSB(DUP(op_AND_83)), DUP(op_AND_83))), CAST(32, MSB(CAST(16, MSB(op_AND_91), DUP(op_AND_91))), CAST(16, MSB(DUP(op_AND_91)), DUP(op_AND_91))));
	RzILOpPure *op_ADD_98 = ADD(CAST(64, MSB(op_MUL_94), DUP(op_MUL_94)), CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_LT_101 = SLT(op_ADD_98, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_106 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_107 = NEG(op_LSHIFT_106);
	RzILOpPure *op_LSHIFT_112 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_115 = SUB(op_LSHIFT_112, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_116 = ITE(op_LT_101, op_NEG_107, op_SUB_115);
	RzILOpEffect *gcc_expr_117 = BRANCH(op_EQ_53, EMPTY(), set_usr_field_call_77);

	// h_tmp362 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) + ((st64) 0x8000)), 0x0, 0x20) == ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_119 = SETL("h_tmp362", cond_116);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((st16) ...;
	RzILOpEffect *seq_120 = SEQN(2, gcc_expr_117, op_ASSIGN_hybrid_tmp_119);

	// Rd = ((st32) ((sextract64(((ut64) ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) + ((st64) 0x8000)), 0x0, 0x20) == ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) + ((st64) 0x8000)) ? ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) + ((st64) 0x8000) : h_tmp362));
	RzILOpPure *op_RSHIFT_57 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_59 = LOGAND(op_RSHIFT_57, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_65 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_67 = LOGAND(op_RSHIFT_65, SN(32, 0xffff));
	RzILOpPure *op_MUL_70 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_59), DUP(op_AND_59))), CAST(16, MSB(DUP(op_AND_59)), DUP(op_AND_59))), CAST(32, MSB(CAST(16, MSB(op_AND_67), DUP(op_AND_67))), CAST(16, MSB(DUP(op_AND_67)), DUP(op_AND_67))));
	RzILOpPure *op_ADD_74 = ADD(CAST(64, MSB(op_MUL_70), DUP(op_MUL_70)), CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *cond_121 = ITE(DUP(op_EQ_53), op_ADD_74, VARL("h_tmp362"));
	RzILOpEffect *op_ASSIGN_123 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(cond_121), DUP(cond_121)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((s ...;
	RzILOpEffect *seq_124 = SEQN(2, seq_120, op_ASSIGN_123);

	RzILOpEffect *instruction_sequence = seq_124;
	return instruction_sequence;
}

// Rd = mpy(Rs.l,Rt.l):<<1:rnd:sat
RzILOpEffect *hex_il_op_m2_mpy_sat_rnd_ll_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_83 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_8 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_10 = LOGAND(op_RSHIFT_8, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_17 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_17, SN(32, 0xffff));
	RzILOpPure *op_MUL_22 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_10), DUP(op_AND_10))), CAST(16, MSB(DUP(op_AND_10)), DUP(op_AND_10))), CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))));
	RzILOpPure *op_LSHIFT_25 = SHIFTL0(CAST(64, MSB(op_MUL_22), DUP(op_MUL_22)), SN(32, 1));
	RzILOpPure *op_ADD_28 = ADD(op_LSHIFT_25, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_37 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_39 = LOGAND(op_RSHIFT_37, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_45 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_47 = LOGAND(op_RSHIFT_45, SN(32, 0xffff));
	RzILOpPure *op_MUL_50 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_39), DUP(op_AND_39))), CAST(16, MSB(DUP(op_AND_39)), DUP(op_AND_39))), CAST(32, MSB(CAST(16, MSB(op_AND_47), DUP(op_AND_47))), CAST(16, MSB(DUP(op_AND_47)), DUP(op_AND_47))));
	RzILOpPure *op_LSHIFT_53 = SHIFTL0(CAST(64, MSB(op_MUL_50), DUP(op_MUL_50)), SN(32, 1));
	RzILOpPure *op_ADD_56 = ADD(op_LSHIFT_53, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_EQ_57 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_28), SN(32, 0), SN(32, 0x20)), op_ADD_56);
	RzILOpPure *op_RSHIFT_87 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_89 = LOGAND(op_RSHIFT_87, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_95 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_97 = LOGAND(op_RSHIFT_95, SN(32, 0xffff));
	RzILOpPure *op_MUL_100 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_89), DUP(op_AND_89))), CAST(16, MSB(DUP(op_AND_89)), DUP(op_AND_89))), CAST(32, MSB(CAST(16, MSB(op_AND_97), DUP(op_AND_97))), CAST(16, MSB(DUP(op_AND_97)), DUP(op_AND_97))));
	RzILOpPure *op_LSHIFT_103 = SHIFTL0(CAST(64, MSB(op_MUL_100), DUP(op_MUL_100)), SN(32, 1));
	RzILOpPure *op_ADD_106 = ADD(op_LSHIFT_103, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_LT_109 = SLT(op_ADD_106, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_114 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_115 = NEG(op_LSHIFT_114);
	RzILOpPure *op_LSHIFT_120 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_123 = SUB(op_LSHIFT_120, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_124 = ITE(op_LT_109, op_NEG_115, op_SUB_123);
	RzILOpEffect *gcc_expr_125 = BRANCH(op_EQ_57, EMPTY(), set_usr_field_call_83);

	// h_tmp363 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_127 = SETL("h_tmp363", cond_124);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_128 = SEQN(2, gcc_expr_125, op_ASSIGN_hybrid_tmp_127);

	// Rd = ((st32) ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000)) ? (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000) : h_tmp363));
	RzILOpPure *op_RSHIFT_61 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_63 = LOGAND(op_RSHIFT_61, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_69 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_71 = LOGAND(op_RSHIFT_69, SN(32, 0xffff));
	RzILOpPure *op_MUL_74 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_63), DUP(op_AND_63))), CAST(16, MSB(DUP(op_AND_63)), DUP(op_AND_63))), CAST(32, MSB(CAST(16, MSB(op_AND_71), DUP(op_AND_71))), CAST(16, MSB(DUP(op_AND_71)), DUP(op_AND_71))));
	RzILOpPure *op_LSHIFT_77 = SHIFTL0(CAST(64, MSB(op_MUL_74), DUP(op_MUL_74)), SN(32, 1));
	RzILOpPure *op_ADD_80 = ADD(op_LSHIFT_77, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *cond_129 = ITE(DUP(op_EQ_57), op_ADD_80, VARL("h_tmp363"));
	RzILOpEffect *op_ASSIGN_131 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(cond_129), DUP(cond_129)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_132 = SEQN(2, seq_128, op_ASSIGN_131);

	RzILOpEffect *instruction_sequence = seq_132;
	return instruction_sequence;
}

// Rd = mpy(Rs,Rt)
RzILOpEffect *hex_il_op_m2_mpy_up(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = ((st32) (((st64) Rs) * ((st64) Rt) >> 0x20));
	RzILOpPure *op_MUL_5 = MUL(CAST(64, MSB(Rs), DUP(Rs)), CAST(64, MSB(Rt), DUP(Rt)));
	RzILOpPure *op_RSHIFT_7 = SHIFTRA(op_MUL_5, SN(32, 0x20));
	RzILOpEffect *op_ASSIGN_9 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(op_RSHIFT_7), DUP(op_RSHIFT_7)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_9;
	return instruction_sequence;
}

// Rd = mpy(Rs,Rt):<<1
RzILOpEffect *hex_il_op_m2_mpy_up_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = ((st32) (((st64) Rs) * ((st64) Rt) >> 0x1f));
	RzILOpPure *op_MUL_5 = MUL(CAST(64, MSB(Rs), DUP(Rs)), CAST(64, MSB(Rt), DUP(Rt)));
	RzILOpPure *op_RSHIFT_7 = SHIFTRA(op_MUL_5, SN(32, 31));
	RzILOpEffect *op_ASSIGN_9 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(op_RSHIFT_7), DUP(op_RSHIFT_7)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_9;
	return instruction_sequence;
}

// Rd = mpy(Rs,Rt):<<1:sat
RzILOpEffect *hex_il_op_m2_mpy_up_s1_sat(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_29 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) Rs) * ((st64) Rt) >> 0x1f)), 0x0, 0x20) == (((st64) Rs) * ((st64) Rt) >> 0x1f))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) Rs) * ((st64) Rt) >> 0x1f) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_MUL_8 = MUL(CAST(64, MSB(Rs), DUP(Rs)), CAST(64, MSB(Rt), DUP(Rt)));
	RzILOpPure *op_RSHIFT_10 = SHIFTRA(op_MUL_8, SN(32, 31));
	RzILOpPure *op_MUL_18 = MUL(CAST(64, MSB(DUP(Rs)), DUP(Rs)), CAST(64, MSB(DUP(Rt)), DUP(Rt)));
	RzILOpPure *op_RSHIFT_20 = SHIFTRA(op_MUL_18, SN(32, 31));
	RzILOpPure *op_EQ_21 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_RSHIFT_10), SN(32, 0), SN(32, 0x20)), op_RSHIFT_20);
	RzILOpPure *op_MUL_32 = MUL(CAST(64, MSB(DUP(Rs)), DUP(Rs)), CAST(64, MSB(DUP(Rt)), DUP(Rt)));
	RzILOpPure *op_RSHIFT_34 = SHIFTRA(op_MUL_32, SN(32, 31));
	RzILOpPure *op_LT_37 = SLT(op_RSHIFT_34, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_42 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_43 = NEG(op_LSHIFT_42);
	RzILOpPure *op_LSHIFT_48 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_51 = SUB(op_LSHIFT_48, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_52 = ITE(op_LT_37, op_NEG_43, op_SUB_51);
	RzILOpEffect *gcc_expr_53 = BRANCH(op_EQ_21, EMPTY(), set_usr_field_call_29);

	// h_tmp364 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) Rs) * ((st64) Rt) >> 0x1f)), 0x0, 0x20) == (((st64) Rs) * ((st64) Rt) >> 0x1f))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) Rs) * ((st64) Rt) >> 0x1f) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_55 = SETL("h_tmp364", cond_52);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) Rs) * ((st64)  ...;
	RzILOpEffect *seq_56 = SEQN(2, gcc_expr_53, op_ASSIGN_hybrid_tmp_55);

	// Rd = ((st32) ((sextract64(((ut64) (((st64) Rs) * ((st64) Rt) >> 0x1f)), 0x0, 0x20) == (((st64) Rs) * ((st64) Rt) >> 0x1f)) ? (((st64) Rs) * ((st64) Rt) >> 0x1f) : h_tmp364));
	RzILOpPure *op_MUL_24 = MUL(CAST(64, MSB(DUP(Rs)), DUP(Rs)), CAST(64, MSB(DUP(Rt)), DUP(Rt)));
	RzILOpPure *op_RSHIFT_26 = SHIFTRA(op_MUL_24, SN(32, 31));
	RzILOpPure *cond_57 = ITE(DUP(op_EQ_21), op_RSHIFT_26, VARL("h_tmp364"));
	RzILOpEffect *op_ASSIGN_59 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(cond_57), DUP(cond_57)));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) Rs) * ((st ...;
	RzILOpEffect *seq_60 = SEQN(2, seq_56, op_ASSIGN_59);

	RzILOpEffect *instruction_sequence = seq_60;
	return instruction_sequence;
}

// Rxx += mpy(Rs.h,Rt.h)
RzILOpEffect *hex_il_op_m2_mpyd_acc_hh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = Rxx + ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_ADD_21 = ADD(READ_REG(pkt, Rxx_op, false), CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)));
	RzILOpEffect *op_ASSIGN_22 = WRITE_REG(bundle, Rxx_op, op_ADD_21);

	RzILOpEffect *instruction_sequence = op_ASSIGN_22;
	return instruction_sequence;
}

// Rxx += mpy(Rs.h,Rt.h):<<1
RzILOpEffect *hex_il_op_m2_mpyd_acc_hh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = Rxx + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpPure *op_ADD_23 = ADD(READ_REG(pkt, Rxx_op, false), op_LSHIFT_22);
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rxx_op, op_ADD_23);

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rxx += mpy(Rs.h,Rt.l)
RzILOpEffect *hex_il_op_m2_mpyd_acc_hl_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = Rxx + ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_ADD_21 = ADD(READ_REG(pkt, Rxx_op, false), CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)));
	RzILOpEffect *op_ASSIGN_22 = WRITE_REG(bundle, Rxx_op, op_ADD_21);

	RzILOpEffect *instruction_sequence = op_ASSIGN_22;
	return instruction_sequence;
}

// Rxx += mpy(Rs.h,Rt.l):<<1
RzILOpEffect *hex_il_op_m2_mpyd_acc_hl_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = Rxx + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpPure *op_ADD_23 = ADD(READ_REG(pkt, Rxx_op, false), op_LSHIFT_22);
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rxx_op, op_ADD_23);

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rxx += mpy(Rs.l,Rt.h)
RzILOpEffect *hex_il_op_m2_mpyd_acc_lh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = Rxx + ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_ADD_21 = ADD(READ_REG(pkt, Rxx_op, false), CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)));
	RzILOpEffect *op_ASSIGN_22 = WRITE_REG(bundle, Rxx_op, op_ADD_21);

	RzILOpEffect *instruction_sequence = op_ASSIGN_22;
	return instruction_sequence;
}

// Rxx += mpy(Rs.l,Rt.h):<<1
RzILOpEffect *hex_il_op_m2_mpyd_acc_lh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = Rxx + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpPure *op_ADD_23 = ADD(READ_REG(pkt, Rxx_op, false), op_LSHIFT_22);
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rxx_op, op_ADD_23);

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rxx += mpy(Rs.l,Rt.l)
RzILOpEffect *hex_il_op_m2_mpyd_acc_ll_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = Rxx + ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_ADD_21 = ADD(READ_REG(pkt, Rxx_op, false), CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)));
	RzILOpEffect *op_ASSIGN_22 = WRITE_REG(bundle, Rxx_op, op_ADD_21);

	RzILOpEffect *instruction_sequence = op_ASSIGN_22;
	return instruction_sequence;
}

// Rxx += mpy(Rs.l,Rt.l):<<1
RzILOpEffect *hex_il_op_m2_mpyd_acc_ll_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = Rxx + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpPure *op_ADD_23 = ADD(READ_REG(pkt, Rxx_op, false), op_LSHIFT_22);
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rxx_op, op_ADD_23);

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rdd = mpy(Rs.h,Rt.h)
RzILOpEffect *hex_il_op_m2_mpyd_hh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rdd = ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpEffect *op_ASSIGN_21 = WRITE_REG(bundle, Rdd_op, CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_21;
	return instruction_sequence;
}

// Rdd = mpy(Rs.h,Rt.h):<<1
RzILOpEffect *hex_il_op_m2_mpyd_hh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rdd = (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpEffect *op_ASSIGN_23 = WRITE_REG(bundle, Rdd_op, op_LSHIFT_22);

	RzILOpEffect *instruction_sequence = op_ASSIGN_23;
	return instruction_sequence;
}

// Rdd = mpy(Rs.h,Rt.l)
RzILOpEffect *hex_il_op_m2_mpyd_hl_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rdd = ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpEffect *op_ASSIGN_21 = WRITE_REG(bundle, Rdd_op, CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_21;
	return instruction_sequence;
}

// Rdd = mpy(Rs.h,Rt.l):<<1
RzILOpEffect *hex_il_op_m2_mpyd_hl_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rdd = (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpEffect *op_ASSIGN_23 = WRITE_REG(bundle, Rdd_op, op_LSHIFT_22);

	RzILOpEffect *instruction_sequence = op_ASSIGN_23;
	return instruction_sequence;
}

// Rdd = mpy(Rs.l,Rt.h)
RzILOpEffect *hex_il_op_m2_mpyd_lh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rdd = ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpEffect *op_ASSIGN_21 = WRITE_REG(bundle, Rdd_op, CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_21;
	return instruction_sequence;
}

// Rdd = mpy(Rs.l,Rt.h):<<1
RzILOpEffect *hex_il_op_m2_mpyd_lh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rdd = (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpEffect *op_ASSIGN_23 = WRITE_REG(bundle, Rdd_op, op_LSHIFT_22);

	RzILOpEffect *instruction_sequence = op_ASSIGN_23;
	return instruction_sequence;
}

// Rdd = mpy(Rs.l,Rt.l)
RzILOpEffect *hex_il_op_m2_mpyd_ll_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rdd = ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpEffect *op_ASSIGN_21 = WRITE_REG(bundle, Rdd_op, CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_21;
	return instruction_sequence;
}

// Rdd = mpy(Rs.l,Rt.l):<<1
RzILOpEffect *hex_il_op_m2_mpyd_ll_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rdd = (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpEffect *op_ASSIGN_23 = WRITE_REG(bundle, Rdd_op, op_LSHIFT_22);

	RzILOpEffect *instruction_sequence = op_ASSIGN_23;
	return instruction_sequence;
}

// Rxx -= mpy(Rs.h,Rt.h)
RzILOpEffect *hex_il_op_m2_mpyd_nac_hh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = Rxx - ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_SUB_21 = SUB(READ_REG(pkt, Rxx_op, false), CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)));
	RzILOpEffect *op_ASSIGN_22 = WRITE_REG(bundle, Rxx_op, op_SUB_21);

	RzILOpEffect *instruction_sequence = op_ASSIGN_22;
	return instruction_sequence;
}

// Rxx -= mpy(Rs.h,Rt.h):<<1
RzILOpEffect *hex_il_op_m2_mpyd_nac_hh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = Rxx - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpPure *op_SUB_23 = SUB(READ_REG(pkt, Rxx_op, false), op_LSHIFT_22);
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rxx_op, op_SUB_23);

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rxx -= mpy(Rs.h,Rt.l)
RzILOpEffect *hex_il_op_m2_mpyd_nac_hl_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = Rxx - ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_SUB_21 = SUB(READ_REG(pkt, Rxx_op, false), CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)));
	RzILOpEffect *op_ASSIGN_22 = WRITE_REG(bundle, Rxx_op, op_SUB_21);

	RzILOpEffect *instruction_sequence = op_ASSIGN_22;
	return instruction_sequence;
}

// Rxx -= mpy(Rs.h,Rt.l):<<1
RzILOpEffect *hex_il_op_m2_mpyd_nac_hl_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = Rxx - (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpPure *op_SUB_23 = SUB(READ_REG(pkt, Rxx_op, false), op_LSHIFT_22);
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rxx_op, op_SUB_23);

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rxx -= mpy(Rs.l,Rt.h)
RzILOpEffect *hex_il_op_m2_mpyd_nac_lh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = Rxx - ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_SUB_21 = SUB(READ_REG(pkt, Rxx_op, false), CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)));
	RzILOpEffect *op_ASSIGN_22 = WRITE_REG(bundle, Rxx_op, op_SUB_21);

	RzILOpEffect *instruction_sequence = op_ASSIGN_22;
	return instruction_sequence;
}

// Rxx -= mpy(Rs.l,Rt.h):<<1
RzILOpEffect *hex_il_op_m2_mpyd_nac_lh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = Rxx - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpPure *op_SUB_23 = SUB(READ_REG(pkt, Rxx_op, false), op_LSHIFT_22);
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rxx_op, op_SUB_23);

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rxx -= mpy(Rs.l,Rt.l)
RzILOpEffect *hex_il_op_m2_mpyd_nac_ll_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = Rxx - ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_SUB_21 = SUB(READ_REG(pkt, Rxx_op, false), CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)));
	RzILOpEffect *op_ASSIGN_22 = WRITE_REG(bundle, Rxx_op, op_SUB_21);

	RzILOpEffect *instruction_sequence = op_ASSIGN_22;
	return instruction_sequence;
}

// Rxx -= mpy(Rs.l,Rt.l):<<1
RzILOpEffect *hex_il_op_m2_mpyd_nac_ll_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = Rxx - (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpPure *op_SUB_23 = SUB(READ_REG(pkt, Rxx_op, false), op_LSHIFT_22);
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rxx_op, op_SUB_23);

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rdd = mpy(Rs.h,Rt.h):rnd
RzILOpEffect *hex_il_op_m2_mpyd_rnd_hh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rdd = ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) + ((st64) 0x8000);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_ADD_23 = ADD(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rdd_op, op_ADD_23);

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rdd = mpy(Rs.h,Rt.h):<<1:rnd
RzILOpEffect *hex_il_op_m2_mpyd_rnd_hh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rdd = (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpPure *op_ADD_25 = ADD(op_LSHIFT_22, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpEffect *op_ASSIGN_26 = WRITE_REG(bundle, Rdd_op, op_ADD_25);

	RzILOpEffect *instruction_sequence = op_ASSIGN_26;
	return instruction_sequence;
}

// Rdd = mpy(Rs.h,Rt.l):rnd
RzILOpEffect *hex_il_op_m2_mpyd_rnd_hl_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rdd = ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) + ((st64) 0x8000);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_ADD_23 = ADD(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rdd_op, op_ADD_23);

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rdd = mpy(Rs.h,Rt.l):<<1:rnd
RzILOpEffect *hex_il_op_m2_mpyd_rnd_hl_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rdd = (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpPure *op_ADD_25 = ADD(op_LSHIFT_22, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpEffect *op_ASSIGN_26 = WRITE_REG(bundle, Rdd_op, op_ADD_25);

	RzILOpEffect *instruction_sequence = op_ASSIGN_26;
	return instruction_sequence;
}

// Rdd = mpy(Rs.l,Rt.h):rnd
RzILOpEffect *hex_il_op_m2_mpyd_rnd_lh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rdd = ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) + ((st64) 0x8000);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_ADD_23 = ADD(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rdd_op, op_ADD_23);

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rdd = mpy(Rs.l,Rt.h):<<1:rnd
RzILOpEffect *hex_il_op_m2_mpyd_rnd_lh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rdd = (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpPure *op_ADD_25 = ADD(op_LSHIFT_22, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpEffect *op_ASSIGN_26 = WRITE_REG(bundle, Rdd_op, op_ADD_25);

	RzILOpEffect *instruction_sequence = op_ASSIGN_26;
	return instruction_sequence;
}

// Rdd = mpy(Rs.l,Rt.l):rnd
RzILOpEffect *hex_il_op_m2_mpyd_rnd_ll_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rdd = ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) + ((st64) 0x8000);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_ADD_23 = ADD(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rdd_op, op_ADD_23);

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rdd = mpy(Rs.l,Rt.l):<<1:rnd
RzILOpEffect *hex_il_op_m2_mpyd_rnd_ll_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rdd = (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_7), DUP(op_AND_7))), CAST(16, MSB(DUP(op_AND_7)), DUP(op_AND_7))), CAST(32, MSB(CAST(16, MSB(op_AND_16), DUP(op_AND_16))), CAST(16, MSB(DUP(op_AND_16)), DUP(op_AND_16))));
	RzILOpPure *op_LSHIFT_22 = SHIFTL0(CAST(64, MSB(op_MUL_19), DUP(op_MUL_19)), SN(32, 1));
	RzILOpPure *op_ADD_25 = ADD(op_LSHIFT_22, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpEffect *op_ASSIGN_26 = WRITE_REG(bundle, Rdd_op, op_ADD_25);

	RzILOpEffect *instruction_sequence = op_ASSIGN_26;
	return instruction_sequence;
}

// Rd = mpyi(Rs,Rt)
RzILOpEffect *hex_il_op_m2_mpyi(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = Rs * Rt;
	RzILOpPure *op_MUL_3 = MUL(Rs, Rt);
	RzILOpEffect *op_ASSIGN_4 = WRITE_REG(bundle, Rd_op, op_MUL_3);

	RzILOpEffect *instruction_sequence = op_ASSIGN_4;
	return instruction_sequence;
}

// Rd = -mpyi(Rs,Ii)
RzILOpEffect *hex_il_op_m2_mpysin(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	RzILOpPure *u = UN(32, (ut32)ISA2IMM(hi, 'u'));

	// u = u;
	RzILOpEffect *imm_assign_2 = SETL("u", u);

	// Rd = ((st32) ((ut32) Rs) * (-u));
	RzILOpPure *op_NEG_4 = NEG(VARL("u"));
	RzILOpPure *op_MUL_6 = MUL(CAST(32, IL_FALSE, Rs), op_NEG_4);
	RzILOpEffect *op_ASSIGN_8 = WRITE_REG(bundle, Rd_op, CAST(32, IL_FALSE, op_MUL_6));

	RzILOpEffect *instruction_sequence = SEQN(2, imm_assign_2, op_ASSIGN_8);
	return instruction_sequence;
}

// Rd = +mpyi(Rs,Ii)
RzILOpEffect *hex_il_op_m2_mpysip(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	RzILOpPure *u = UN(32, (ut32)ISA2IMM(hi, 'u'));
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);

	// u = u;
	RzILOpEffect *imm_assign_0 = SETL("u", u);

	// Rd = ((st32) ((ut32) Rs) * u);
	RzILOpPure *op_MUL_5 = MUL(CAST(32, IL_FALSE, Rs), VARL("u"));
	RzILOpEffect *op_ASSIGN_7 = WRITE_REG(bundle, Rd_op, CAST(32, IL_FALSE, op_MUL_5));

	RzILOpEffect *instruction_sequence = SEQN(2, imm_assign_0, op_ASSIGN_7);
	return instruction_sequence;
}

// Rd = mpysu(Rs,Rt)
RzILOpEffect *hex_il_op_m2_mpysu_up(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = ((st32) (((ut64) ((st64) Rs)) * ((ut64) ((ut32) Rt)) >> 0x20));
	RzILOpPure *op_MUL_7 = MUL(CAST(64, IL_FALSE, CAST(64, MSB(Rs), DUP(Rs))), CAST(64, IL_FALSE, CAST(32, IL_FALSE, Rt)));
	RzILOpPure *op_RSHIFT_9 = SHIFTR0(op_MUL_7, SN(32, 0x20));
	RzILOpEffect *op_ASSIGN_11 = WRITE_REG(bundle, Rd_op, CAST(32, IL_FALSE, op_RSHIFT_9));

	RzILOpEffect *instruction_sequence = op_ASSIGN_11;
	return instruction_sequence;
}

// Rx += mpyu(Rs.h,Rt.h)
RzILOpEffect *hex_il_op_m2_mpyu_acc_hh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((ut64) Rx) + ((ut64) ((ut32) ((ut16) ((Rs >> 0x10) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_ADD_22 = ADD(CAST(64, IL_FALSE, READ_REG(pkt, Rx_op, false)), CAST(64, IL_FALSE, op_MUL_19));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rx_op, CAST(32, IL_FALSE, op_ADD_22));

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rx += mpyu(Rs.h,Rt.h):<<1
RzILOpEffect *hex_il_op_m2_mpyu_acc_hh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((st64) Rx) + (((st64) ((ut64) ((ut32) ((ut16) ((Rs >> 0x10) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_LSHIFT_23 = SHIFTL0(CAST(64, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)), SN(32, 1));
	RzILOpPure *op_ADD_25 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_23);
	RzILOpEffect *op_ASSIGN_27 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(op_ADD_25), DUP(op_ADD_25)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_27;
	return instruction_sequence;
}

// Rx += mpyu(Rs.h,Rt.l)
RzILOpEffect *hex_il_op_m2_mpyu_acc_hl_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((ut64) Rx) + ((ut64) ((ut32) ((ut16) ((Rs >> 0x10) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_ADD_22 = ADD(CAST(64, IL_FALSE, READ_REG(pkt, Rx_op, false)), CAST(64, IL_FALSE, op_MUL_19));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rx_op, CAST(32, IL_FALSE, op_ADD_22));

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rx += mpyu(Rs.h,Rt.l):<<1
RzILOpEffect *hex_il_op_m2_mpyu_acc_hl_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((st64) Rx) + (((st64) ((ut64) ((ut32) ((ut16) ((Rs >> 0x10) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_LSHIFT_23 = SHIFTL0(CAST(64, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)), SN(32, 1));
	RzILOpPure *op_ADD_25 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_23);
	RzILOpEffect *op_ASSIGN_27 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(op_ADD_25), DUP(op_ADD_25)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_27;
	return instruction_sequence;
}

// Rx += mpyu(Rs.l,Rt.h)
RzILOpEffect *hex_il_op_m2_mpyu_acc_lh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((ut64) Rx) + ((ut64) ((ut32) ((ut16) ((Rs >> 0x0) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_ADD_22 = ADD(CAST(64, IL_FALSE, READ_REG(pkt, Rx_op, false)), CAST(64, IL_FALSE, op_MUL_19));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rx_op, CAST(32, IL_FALSE, op_ADD_22));

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rx += mpyu(Rs.l,Rt.h):<<1
RzILOpEffect *hex_il_op_m2_mpyu_acc_lh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((st64) Rx) + (((st64) ((ut64) ((ut32) ((ut16) ((Rs >> 0x0) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_LSHIFT_23 = SHIFTL0(CAST(64, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)), SN(32, 1));
	RzILOpPure *op_ADD_25 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_23);
	RzILOpEffect *op_ASSIGN_27 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(op_ADD_25), DUP(op_ADD_25)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_27;
	return instruction_sequence;
}

// Rx += mpyu(Rs.l,Rt.l)
RzILOpEffect *hex_il_op_m2_mpyu_acc_ll_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((ut64) Rx) + ((ut64) ((ut32) ((ut16) ((Rs >> 0x0) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_ADD_22 = ADD(CAST(64, IL_FALSE, READ_REG(pkt, Rx_op, false)), CAST(64, IL_FALSE, op_MUL_19));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rx_op, CAST(32, IL_FALSE, op_ADD_22));

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rx += mpyu(Rs.l,Rt.l):<<1
RzILOpEffect *hex_il_op_m2_mpyu_acc_ll_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((st64) Rx) + (((st64) ((ut64) ((ut32) ((ut16) ((Rs >> 0x0) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_LSHIFT_23 = SHIFTL0(CAST(64, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)), SN(32, 1));
	RzILOpPure *op_ADD_25 = ADD(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_23);
	RzILOpEffect *op_ASSIGN_27 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(op_ADD_25), DUP(op_ADD_25)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_27;
	return instruction_sequence;
}

// Rd = mpyu(Rs.h,Rt.h)
RzILOpEffect *hex_il_op_m2_mpyu_hh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = ((st32) ((ut64) ((ut32) ((ut16) ((Rs >> 0x10) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpEffect *op_ASSIGN_22 = WRITE_REG(bundle, Rd_op, CAST(32, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_22;
	return instruction_sequence;
}

// Rd = mpyu(Rs.h,Rt.h):<<1
RzILOpEffect *hex_il_op_m2_mpyu_hh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = ((st32) (((st64) ((ut64) ((ut32) ((ut16) ((Rs >> 0x10) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_LSHIFT_23 = SHIFTL0(CAST(64, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)), SN(32, 1));
	RzILOpEffect *op_ASSIGN_25 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(op_LSHIFT_23), DUP(op_LSHIFT_23)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_25;
	return instruction_sequence;
}

// Rd = mpyu(Rs.h,Rt.l)
RzILOpEffect *hex_il_op_m2_mpyu_hl_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = ((st32) ((ut64) ((ut32) ((ut16) ((Rs >> 0x10) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpEffect *op_ASSIGN_22 = WRITE_REG(bundle, Rd_op, CAST(32, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_22;
	return instruction_sequence;
}

// Rd = mpyu(Rs.h,Rt.l):<<1
RzILOpEffect *hex_il_op_m2_mpyu_hl_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = ((st32) (((st64) ((ut64) ((ut32) ((ut16) ((Rs >> 0x10) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_LSHIFT_23 = SHIFTL0(CAST(64, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)), SN(32, 1));
	RzILOpEffect *op_ASSIGN_25 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(op_LSHIFT_23), DUP(op_LSHIFT_23)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_25;
	return instruction_sequence;
}

// Rd = mpyu(Rs.l,Rt.h)
RzILOpEffect *hex_il_op_m2_mpyu_lh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = ((st32) ((ut64) ((ut32) ((ut16) ((Rs >> 0x0) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpEffect *op_ASSIGN_22 = WRITE_REG(bundle, Rd_op, CAST(32, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_22;
	return instruction_sequence;
}

// Rd = mpyu(Rs.l,Rt.h):<<1
RzILOpEffect *hex_il_op_m2_mpyu_lh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = ((st32) (((st64) ((ut64) ((ut32) ((ut16) ((Rs >> 0x0) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_LSHIFT_23 = SHIFTL0(CAST(64, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)), SN(32, 1));
	RzILOpEffect *op_ASSIGN_25 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(op_LSHIFT_23), DUP(op_LSHIFT_23)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_25;
	return instruction_sequence;
}

// Rd = mpyu(Rs.l,Rt.l)
RzILOpEffect *hex_il_op_m2_mpyu_ll_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = ((st32) ((ut64) ((ut32) ((ut16) ((Rs >> 0x0) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpEffect *op_ASSIGN_22 = WRITE_REG(bundle, Rd_op, CAST(32, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_22;
	return instruction_sequence;
}

// Rd = mpyu(Rs.l,Rt.l):<<1
RzILOpEffect *hex_il_op_m2_mpyu_ll_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = ((st32) (((st64) ((ut64) ((ut32) ((ut16) ((Rs >> 0x0) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_LSHIFT_23 = SHIFTL0(CAST(64, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)), SN(32, 1));
	RzILOpEffect *op_ASSIGN_25 = WRITE_REG(bundle, Rd_op, CAST(32, MSB(op_LSHIFT_23), DUP(op_LSHIFT_23)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_25;
	return instruction_sequence;
}

// Rx -= mpyu(Rs.h,Rt.h)
RzILOpEffect *hex_il_op_m2_mpyu_nac_hh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((ut64) Rx) - ((ut64) ((ut32) ((ut16) ((Rs >> 0x10) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_SUB_22 = SUB(CAST(64, IL_FALSE, READ_REG(pkt, Rx_op, false)), CAST(64, IL_FALSE, op_MUL_19));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rx_op, CAST(32, IL_FALSE, op_SUB_22));

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rx -= mpyu(Rs.h,Rt.h):<<1
RzILOpEffect *hex_il_op_m2_mpyu_nac_hh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((st64) Rx) - (((st64) ((ut64) ((ut32) ((ut16) ((Rs >> 0x10) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_LSHIFT_23 = SHIFTL0(CAST(64, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)), SN(32, 1));
	RzILOpPure *op_SUB_25 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_23);
	RzILOpEffect *op_ASSIGN_27 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(op_SUB_25), DUP(op_SUB_25)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_27;
	return instruction_sequence;
}

// Rx -= mpyu(Rs.h,Rt.l)
RzILOpEffect *hex_il_op_m2_mpyu_nac_hl_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((ut64) Rx) - ((ut64) ((ut32) ((ut16) ((Rs >> 0x10) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_SUB_22 = SUB(CAST(64, IL_FALSE, READ_REG(pkt, Rx_op, false)), CAST(64, IL_FALSE, op_MUL_19));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rx_op, CAST(32, IL_FALSE, op_SUB_22));

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rx -= mpyu(Rs.h,Rt.l):<<1
RzILOpEffect *hex_il_op_m2_mpyu_nac_hl_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((st64) Rx) - (((st64) ((ut64) ((ut32) ((ut16) ((Rs >> 0x10) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_LSHIFT_23 = SHIFTL0(CAST(64, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)), SN(32, 1));
	RzILOpPure *op_SUB_25 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_23);
	RzILOpEffect *op_ASSIGN_27 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(op_SUB_25), DUP(op_SUB_25)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_27;
	return instruction_sequence;
}

// Rx -= mpyu(Rs.l,Rt.h)
RzILOpEffect *hex_il_op_m2_mpyu_nac_lh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((ut64) Rx) - ((ut64) ((ut32) ((ut16) ((Rs >> 0x0) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_SUB_22 = SUB(CAST(64, IL_FALSE, READ_REG(pkt, Rx_op, false)), CAST(64, IL_FALSE, op_MUL_19));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rx_op, CAST(32, IL_FALSE, op_SUB_22));

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rx -= mpyu(Rs.l,Rt.h):<<1
RzILOpEffect *hex_il_op_m2_mpyu_nac_lh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((st64) Rx) - (((st64) ((ut64) ((ut32) ((ut16) ((Rs >> 0x0) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_LSHIFT_23 = SHIFTL0(CAST(64, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)), SN(32, 1));
	RzILOpPure *op_SUB_25 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_23);
	RzILOpEffect *op_ASSIGN_27 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(op_SUB_25), DUP(op_SUB_25)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_27;
	return instruction_sequence;
}

// Rx -= mpyu(Rs.l,Rt.l)
RzILOpEffect *hex_il_op_m2_mpyu_nac_ll_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((ut64) Rx) - ((ut64) ((ut32) ((ut16) ((Rs >> 0x0) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_SUB_22 = SUB(CAST(64, IL_FALSE, READ_REG(pkt, Rx_op, false)), CAST(64, IL_FALSE, op_MUL_19));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rx_op, CAST(32, IL_FALSE, op_SUB_22));

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rx -= mpyu(Rs.l,Rt.l):<<1
RzILOpEffect *hex_il_op_m2_mpyu_nac_ll_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = ((st32) ((st64) Rx) - (((st64) ((ut64) ((ut32) ((ut16) ((Rs >> 0x0) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_LSHIFT_23 = SHIFTL0(CAST(64, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)), SN(32, 1));
	RzILOpPure *op_SUB_25 = SUB(CAST(64, MSB(READ_REG(pkt, Rx_op, false)), READ_REG(pkt, Rx_op, false)), op_LSHIFT_23);
	RzILOpEffect *op_ASSIGN_27 = WRITE_REG(bundle, Rx_op, CAST(32, MSB(op_SUB_25), DUP(op_SUB_25)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_27;
	return instruction_sequence;
}

// Rd = mpyu(Rs,Rt)
RzILOpEffect *hex_il_op_m2_mpyu_up(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rd = ((st32) (((ut64) ((ut32) Rs)) * ((ut64) ((ut32) Rt)) >> 0x20));
	RzILOpPure *op_MUL_7 = MUL(CAST(64, IL_FALSE, CAST(32, IL_FALSE, Rs)), CAST(64, IL_FALSE, CAST(32, IL_FALSE, Rt)));
	RzILOpPure *op_RSHIFT_9 = SHIFTR0(op_MUL_7, SN(32, 0x20));
	RzILOpEffect *op_ASSIGN_11 = WRITE_REG(bundle, Rd_op, CAST(32, IL_FALSE, op_RSHIFT_9));

	RzILOpEffect *instruction_sequence = op_ASSIGN_11;
	return instruction_sequence;
}

// Rxx += mpyu(Rs.h,Rt.h)
RzILOpEffect *hex_il_op_m2_mpyud_acc_hh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = ((st64) ((ut64) Rxx) + ((ut64) ((ut32) ((ut16) ((Rs >> 0x10) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_ADD_22 = ADD(CAST(64, IL_FALSE, READ_REG(pkt, Rxx_op, false)), CAST(64, IL_FALSE, op_MUL_19));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rxx_op, CAST(64, IL_FALSE, op_ADD_22));

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rxx += mpyu(Rs.h,Rt.h):<<1
RzILOpEffect *hex_il_op_m2_mpyud_acc_hh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = Rxx + (((st64) ((ut64) ((ut32) ((ut16) ((Rs >> 0x10) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_LSHIFT_23 = SHIFTL0(CAST(64, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)), SN(32, 1));
	RzILOpPure *op_ADD_24 = ADD(READ_REG(pkt, Rxx_op, false), op_LSHIFT_23);
	RzILOpEffect *op_ASSIGN_25 = WRITE_REG(bundle, Rxx_op, op_ADD_24);

	RzILOpEffect *instruction_sequence = op_ASSIGN_25;
	return instruction_sequence;
}

// Rxx += mpyu(Rs.h,Rt.l)
RzILOpEffect *hex_il_op_m2_mpyud_acc_hl_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = ((st64) ((ut64) Rxx) + ((ut64) ((ut32) ((ut16) ((Rs >> 0x10) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_ADD_22 = ADD(CAST(64, IL_FALSE, READ_REG(pkt, Rxx_op, false)), CAST(64, IL_FALSE, op_MUL_19));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rxx_op, CAST(64, IL_FALSE, op_ADD_22));

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rxx += mpyu(Rs.h,Rt.l):<<1
RzILOpEffect *hex_il_op_m2_mpyud_acc_hl_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = Rxx + (((st64) ((ut64) ((ut32) ((ut16) ((Rs >> 0x10) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_LSHIFT_23 = SHIFTL0(CAST(64, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)), SN(32, 1));
	RzILOpPure *op_ADD_24 = ADD(READ_REG(pkt, Rxx_op, false), op_LSHIFT_23);
	RzILOpEffect *op_ASSIGN_25 = WRITE_REG(bundle, Rxx_op, op_ADD_24);

	RzILOpEffect *instruction_sequence = op_ASSIGN_25;
	return instruction_sequence;
}

// Rxx += mpyu(Rs.l,Rt.h)
RzILOpEffect *hex_il_op_m2_mpyud_acc_lh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = ((st64) ((ut64) Rxx) + ((ut64) ((ut32) ((ut16) ((Rs >> 0x0) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_ADD_22 = ADD(CAST(64, IL_FALSE, READ_REG(pkt, Rxx_op, false)), CAST(64, IL_FALSE, op_MUL_19));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rxx_op, CAST(64, IL_FALSE, op_ADD_22));

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rxx += mpyu(Rs.l,Rt.h):<<1
RzILOpEffect *hex_il_op_m2_mpyud_acc_lh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = Rxx + (((st64) ((ut64) ((ut32) ((ut16) ((Rs >> 0x0) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_LSHIFT_23 = SHIFTL0(CAST(64, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)), SN(32, 1));
	RzILOpPure *op_ADD_24 = ADD(READ_REG(pkt, Rxx_op, false), op_LSHIFT_23);
	RzILOpEffect *op_ASSIGN_25 = WRITE_REG(bundle, Rxx_op, op_ADD_24);

	RzILOpEffect *instruction_sequence = op_ASSIGN_25;
	return instruction_sequence;
}

// Rxx += mpyu(Rs.l,Rt.l)
RzILOpEffect *hex_il_op_m2_mpyud_acc_ll_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = ((st64) ((ut64) Rxx) + ((ut64) ((ut32) ((ut16) ((Rs >> 0x0) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_ADD_22 = ADD(CAST(64, IL_FALSE, READ_REG(pkt, Rxx_op, false)), CAST(64, IL_FALSE, op_MUL_19));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rxx_op, CAST(64, IL_FALSE, op_ADD_22));

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rxx += mpyu(Rs.l,Rt.l):<<1
RzILOpEffect *hex_il_op_m2_mpyud_acc_ll_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = Rxx + (((st64) ((ut64) ((ut32) ((ut16) ((Rs >> 0x0) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_LSHIFT_23 = SHIFTL0(CAST(64, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)), SN(32, 1));
	RzILOpPure *op_ADD_24 = ADD(READ_REG(pkt, Rxx_op, false), op_LSHIFT_23);
	RzILOpEffect *op_ASSIGN_25 = WRITE_REG(bundle, Rxx_op, op_ADD_24);

	RzILOpEffect *instruction_sequence = op_ASSIGN_25;
	return instruction_sequence;
}

// Rdd = mpyu(Rs.h,Rt.h)
RzILOpEffect *hex_il_op_m2_mpyud_hh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rdd = ((st64) ((ut64) ((ut32) ((ut16) ((Rs >> 0x10) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpEffect *op_ASSIGN_22 = WRITE_REG(bundle, Rdd_op, CAST(64, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_22;
	return instruction_sequence;
}

// Rdd = mpyu(Rs.h,Rt.h):<<1
RzILOpEffect *hex_il_op_m2_mpyud_hh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rdd = (((st64) ((ut64) ((ut32) ((ut16) ((Rs >> 0x10) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_LSHIFT_23 = SHIFTL0(CAST(64, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)), SN(32, 1));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rdd_op, op_LSHIFT_23);

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rdd = mpyu(Rs.h,Rt.l)
RzILOpEffect *hex_il_op_m2_mpyud_hl_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rdd = ((st64) ((ut64) ((ut32) ((ut16) ((Rs >> 0x10) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpEffect *op_ASSIGN_22 = WRITE_REG(bundle, Rdd_op, CAST(64, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_22;
	return instruction_sequence;
}

// Rdd = mpyu(Rs.h,Rt.l):<<1
RzILOpEffect *hex_il_op_m2_mpyud_hl_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rdd = (((st64) ((ut64) ((ut32) ((ut16) ((Rs >> 0x10) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_LSHIFT_23 = SHIFTL0(CAST(64, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)), SN(32, 1));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rdd_op, op_LSHIFT_23);

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rdd = mpyu(Rs.l,Rt.h)
RzILOpEffect *hex_il_op_m2_mpyud_lh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rdd = ((st64) ((ut64) ((ut32) ((ut16) ((Rs >> 0x0) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpEffect *op_ASSIGN_22 = WRITE_REG(bundle, Rdd_op, CAST(64, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_22;
	return instruction_sequence;
}

// Rdd = mpyu(Rs.l,Rt.h):<<1
RzILOpEffect *hex_il_op_m2_mpyud_lh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rdd = (((st64) ((ut64) ((ut32) ((ut16) ((Rs >> 0x0) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_LSHIFT_23 = SHIFTL0(CAST(64, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)), SN(32, 1));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rdd_op, op_LSHIFT_23);

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rdd = mpyu(Rs.l,Rt.l)
RzILOpEffect *hex_il_op_m2_mpyud_ll_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rdd = ((st64) ((ut64) ((ut32) ((ut16) ((Rs >> 0x0) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpEffect *op_ASSIGN_22 = WRITE_REG(bundle, Rdd_op, CAST(64, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)));

	RzILOpEffect *instruction_sequence = op_ASSIGN_22;
	return instruction_sequence;
}

// Rdd = mpyu(Rs.l,Rt.l):<<1
RzILOpEffect *hex_il_op_m2_mpyud_ll_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rdd = (((st64) ((ut64) ((ut32) ((ut16) ((Rs >> 0x0) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_LSHIFT_23 = SHIFTL0(CAST(64, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)), SN(32, 1));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rdd_op, op_LSHIFT_23);

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rxx -= mpyu(Rs.h,Rt.h)
RzILOpEffect *hex_il_op_m2_mpyud_nac_hh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = ((st64) ((ut64) Rxx) - ((ut64) ((ut32) ((ut16) ((Rs >> 0x10) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_SUB_22 = SUB(CAST(64, IL_FALSE, READ_REG(pkt, Rxx_op, false)), CAST(64, IL_FALSE, op_MUL_19));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rxx_op, CAST(64, IL_FALSE, op_SUB_22));

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rxx -= mpyu(Rs.h,Rt.h):<<1
RzILOpEffect *hex_il_op_m2_mpyud_nac_hh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = Rxx - (((st64) ((ut64) ((ut32) ((ut16) ((Rs >> 0x10) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_LSHIFT_23 = SHIFTL0(CAST(64, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)), SN(32, 1));
	RzILOpPure *op_SUB_24 = SUB(READ_REG(pkt, Rxx_op, false), op_LSHIFT_23);
	RzILOpEffect *op_ASSIGN_25 = WRITE_REG(bundle, Rxx_op, op_SUB_24);

	RzILOpEffect *instruction_sequence = op_ASSIGN_25;
	return instruction_sequence;
}

// Rxx -= mpyu(Rs.h,Rt.l)
RzILOpEffect *hex_il_op_m2_mpyud_nac_hl_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = ((st64) ((ut64) Rxx) - ((ut64) ((ut32) ((ut16) ((Rs >> 0x10) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_SUB_22 = SUB(CAST(64, IL_FALSE, READ_REG(pkt, Rxx_op, false)), CAST(64, IL_FALSE, op_MUL_19));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rxx_op, CAST(64, IL_FALSE, op_SUB_22));

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rxx -= mpyu(Rs.h,Rt.l):<<1
RzILOpEffect *hex_il_op_m2_mpyud_nac_hl_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = Rxx - (((st64) ((ut64) ((ut32) ((ut16) ((Rs >> 0x10) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_LSHIFT_23 = SHIFTL0(CAST(64, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)), SN(32, 1));
	RzILOpPure *op_SUB_24 = SUB(READ_REG(pkt, Rxx_op, false), op_LSHIFT_23);
	RzILOpEffect *op_ASSIGN_25 = WRITE_REG(bundle, Rxx_op, op_SUB_24);

	RzILOpEffect *instruction_sequence = op_ASSIGN_25;
	return instruction_sequence;
}

// Rxx -= mpyu(Rs.l,Rt.h)
RzILOpEffect *hex_il_op_m2_mpyud_nac_lh_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = ((st64) ((ut64) Rxx) - ((ut64) ((ut32) ((ut16) ((Rs >> 0x0) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_SUB_22 = SUB(CAST(64, IL_FALSE, READ_REG(pkt, Rxx_op, false)), CAST(64, IL_FALSE, op_MUL_19));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rxx_op, CAST(64, IL_FALSE, op_SUB_22));

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rxx -= mpyu(Rs.l,Rt.h):<<1
RzILOpEffect *hex_il_op_m2_mpyud_nac_lh_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = Rxx - (((st64) ((ut64) ((ut32) ((ut16) ((Rs >> 0x0) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_LSHIFT_23 = SHIFTL0(CAST(64, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)), SN(32, 1));
	RzILOpPure *op_SUB_24 = SUB(READ_REG(pkt, Rxx_op, false), op_LSHIFT_23);
	RzILOpEffect *op_ASSIGN_25 = WRITE_REG(bundle, Rxx_op, op_SUB_24);

	RzILOpEffect *instruction_sequence = op_ASSIGN_25;
	return instruction_sequence;
}

// Rxx -= mpyu(Rs.l,Rt.l)
RzILOpEffect *hex_il_op_m2_mpyud_nac_ll_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = ((st64) ((ut64) Rxx) - ((ut64) ((ut32) ((ut16) ((Rs >> 0x0) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_SUB_22 = SUB(CAST(64, IL_FALSE, READ_REG(pkt, Rxx_op, false)), CAST(64, IL_FALSE, op_MUL_19));
	RzILOpEffect *op_ASSIGN_24 = WRITE_REG(bundle, Rxx_op, CAST(64, IL_FALSE, op_SUB_22));

	RzILOpEffect *instruction_sequence = op_ASSIGN_24;
	return instruction_sequence;
}

// Rxx -= mpyu(Rs.l,Rt.l):<<1
RzILOpEffect *hex_il_op_m2_mpyud_nac_ll_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = Rxx - (((st64) ((ut64) ((ut32) ((ut16) ((Rs >> 0x0) & 0xffff))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1);
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_7 = LOGAND(op_RSHIFT_5, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(32, 0xffff));
	RzILOpPure *op_MUL_19 = MUL(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_7)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_16)));
	RzILOpPure *op_LSHIFT_23 = SHIFTL0(CAST(64, IL_FALSE, CAST(64, IL_FALSE, op_MUL_19)), SN(32, 1));
	RzILOpPure *op_SUB_24 = SUB(READ_REG(pkt, Rxx_op, false), op_LSHIFT_23);
	RzILOpEffect *op_ASSIGN_25 = WRITE_REG(bundle, Rxx_op, op_SUB_24);

	RzILOpEffect *instruction_sequence = op_ASSIGN_25;
	return instruction_sequence;
}

// Rx -= add(Rs,Rt)
RzILOpEffect *hex_il_op_m2_nacci(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = Rx - Rs + Rt;
	RzILOpPure *op_ADD_3 = ADD(Rs, Rt);
	RzILOpPure *op_SUB_4 = SUB(READ_REG(pkt, Rx_op, false), op_ADD_3);
	RzILOpEffect *op_ASSIGN_5 = WRITE_REG(bundle, Rx_op, op_SUB_4);

	RzILOpEffect *instruction_sequence = op_ASSIGN_5;
	return instruction_sequence;
}

// Rx -= add(Rs,Ii)
RzILOpEffect *hex_il_op_m2_naccii(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	RzILOpPure *s = SN(32, (st32)ISA2IMM(hi, 's'));
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);

	// s = s;
	RzILOpEffect *imm_assign_0 = SETL("s", s);

	// Rx = Rx - Rs + s;
	RzILOpPure *op_ADD_4 = ADD(Rs, VARL("s"));
	RzILOpPure *op_SUB_5 = SUB(READ_REG(pkt, Rx_op, false), op_ADD_4);
	RzILOpEffect *op_ASSIGN_6 = WRITE_REG(bundle, Rx_op, op_SUB_5);

	RzILOpEffect *instruction_sequence = SEQN(2, imm_assign_0, op_ASSIGN_6);
	return instruction_sequence;
}

// Rx += sub(Rt,Rs)
RzILOpEffect *hex_il_op_m2_subacc(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);

	// Rx = Rx + Rt - Rs;
	RzILOpPure *op_ADD_2 = ADD(READ_REG(pkt, Rx_op, false), Rt);
	RzILOpPure *op_SUB_4 = SUB(op_ADD_2, Rs);
	RzILOpEffect *op_ASSIGN_5 = WRITE_REG(bundle, Rx_op, op_SUB_4);

	RzILOpEffect *instruction_sequence = op_ASSIGN_5;
	return instruction_sequence;
}

// Rdd = vabsdiffh(Rtt,Rss)
RzILOpEffect *hex_il_op_m2_vabsdiffh(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	// Declare: st32 i;
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);

	// i = 0x0;
	RzILOpEffect *op_ASSIGN_2 = SETL("i", SN(32, 0));

	// HYB(++i);
	RzILOpEffect *op_INC_5 = SETL("i", INC(VARL("i"), 32));

	// h_tmp365 = HYB(++i);
	RzILOpEffect *op_ASSIGN_hybrid_tmp_7 = SETL("h_tmp365", VARL("i"));

	// seq(h_tmp365 = HYB(++i); HYB(++i));
	RzILOpEffect *seq_8 = SEQN(2, op_ASSIGN_hybrid_tmp_7, op_INC_5);

	// Rdd = ((st64) (((ut64) (Rdd & (~(0xffff << i * 0x10)))) | (((ut64) (((((st32) ((st16) ((Rtt >> i * 0x10) & ((st64) 0xffff)))) - ((st32) ((st16) ((Rss >> i * 0x10) & ((st64) 0xffff)))) < 0x0) ? (-((st32) ((st16) ((Rtt >> i * 0x10) & ((st64) 0xffff)))) - ((st32) ((st16) ((Rss >> i * 0x10) & ((st64) 0xffff))))) : ((st32) ((st16) ((Rtt >> i * 0x10) & ((st64) 0xffff)))) - ((st32) ((st16) ((Rss >> i * 0x10) & ((st64) 0xffff))))) & 0xffff)) << i * 0x10)));
	RzILOpPure *op_MUL_12 = MUL(VARL("i"), SN(32, 16));
	RzILOpPure *op_LSHIFT_13 = SHIFTL0(SN(64, 0xffff), op_MUL_12);
	RzILOpPure *op_NOT_14 = LOGNOT(op_LSHIFT_13);
	RzILOpPure *op_AND_15 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_14);
	RzILOpPure *op_MUL_18 = MUL(VARL("i"), SN(32, 16));
	RzILOpPure *op_RSHIFT_19 = SHIFTRA(Rtt, op_MUL_18);
	RzILOpPure *op_AND_22 = LOGAND(op_RSHIFT_19, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_26 = MUL(VARL("i"), SN(32, 16));
	RzILOpPure *op_RSHIFT_27 = SHIFTRA(Rss, op_MUL_26);
	RzILOpPure *op_AND_30 = LOGAND(op_RSHIFT_27, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_SUB_34 = SUB(CAST(32, MSB(CAST(16, MSB(op_AND_22), DUP(op_AND_22))), CAST(16, MSB(DUP(op_AND_22)), DUP(op_AND_22))), CAST(32, MSB(CAST(16, MSB(op_AND_30), DUP(op_AND_30))), CAST(16, MSB(DUP(op_AND_30)), DUP(op_AND_30))));
	RzILOpPure *op_LT_36 = SLT(op_SUB_34, SN(32, 0));
	RzILOpPure *op_MUL_38 = MUL(VARL("i"), SN(32, 16));
	RzILOpPure *op_RSHIFT_39 = SHIFTRA(DUP(Rtt), op_MUL_38);
	RzILOpPure *op_AND_42 = LOGAND(op_RSHIFT_39, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_45 = MUL(VARL("i"), SN(32, 16));
	RzILOpPure *op_RSHIFT_46 = SHIFTRA(DUP(Rss), op_MUL_45);
	RzILOpPure *op_AND_49 = LOGAND(op_RSHIFT_46, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_SUB_53 = SUB(CAST(32, MSB(CAST(16, MSB(op_AND_42), DUP(op_AND_42))), CAST(16, MSB(DUP(op_AND_42)), DUP(op_AND_42))), CAST(32, MSB(CAST(16, MSB(op_AND_49), DUP(op_AND_49))), CAST(16, MSB(DUP(op_AND_49)), DUP(op_AND_49))));
	RzILOpPure *op_NEG_54 = NEG(op_SUB_53);
	RzILOpPure *op_MUL_56 = MUL(VARL("i"), SN(32, 16));
	RzILOpPure *op_RSHIFT_57 = SHIFTRA(DUP(Rtt), op_MUL_56);
	RzILOpPure *op_AND_60 = LOGAND(op_RSHIFT_57, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_63 = MUL(VARL("i"), SN(32, 16));
	RzILOpPure *op_RSHIFT_64 = SHIFTRA(DUP(Rss), op_MUL_63);
	RzILOpPure *op_AND_67 = LOGAND(op_RSHIFT_64, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_SUB_71 = SUB(CAST(32, MSB(CAST(16, MSB(op_AND_60), DUP(op_AND_60))), CAST(16, MSB(DUP(op_AND_60)), DUP(op_AND_60))), CAST(32, MSB(CAST(16, MSB(op_AND_67), DUP(op_AND_67))), CAST(16, MSB(DUP(op_AND_67)), DUP(op_AND_67))));
	RzILOpPure *cond_72 = ITE(op_LT_36, op_NEG_54, op_SUB_71);
	RzILOpPure *op_AND_74 = LOGAND(cond_72, SN(32, 0xffff));
	RzILOpPure *op_MUL_77 = MUL(VARL("i"), SN(32, 16));
	RzILOpPure *op_LSHIFT_78 = SHIFTL0(CAST(64, IL_FALSE, op_AND_74), op_MUL_77);
	RzILOpPure *op_OR_80 = LOGOR(CAST(64, IL_FALSE, op_AND_15), op_LSHIFT_78);
	RzILOpEffect *op_ASSIGN_82 = WRITE_REG(bundle, Rdd_op, CAST(64, IL_FALSE, op_OR_80));

	// seq(h_tmp365; Rdd = ((st64) (((ut64) (Rdd & (~(0xffff << i * 0x1 ...;
	RzILOpEffect *seq_84 = op_ASSIGN_82;

	// seq(seq(h_tmp365; Rdd = ((st64) (((ut64) (Rdd & (~(0xffff << i * ...;
	RzILOpEffect *seq_85 = SEQN(2, seq_84, seq_8);

	// while ((i < 0x4)) { seq(seq(h_tmp365; Rdd = ((st64) (((ut64) (Rdd & (~(0xffff << i * ... };
	RzILOpPure *op_LT_4 = SLT(VARL("i"), SN(32, 4));
	RzILOpEffect *for_86 = REPEAT(op_LT_4, seq_85);

	// seq(i = 0x0; while ((i < 0x4)) { seq(seq(h_tmp365; Rdd = ((st64) ...;
	RzILOpEffect *seq_87 = SEQN(2, op_ASSIGN_2, for_86);

	RzILOpEffect *instruction_sequence = seq_87;
	return instruction_sequence;
}

// Rdd = vabsdiffw(Rtt,Rss)
RzILOpEffect *hex_il_op_m2_vabsdiffw(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	// Declare: st32 i;
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);

	// i = 0x0;
	RzILOpEffect *op_ASSIGN_2 = SETL("i", SN(32, 0));

	// HYB(++i);
	RzILOpEffect *op_INC_5 = SETL("i", INC(VARL("i"), 32));

	// h_tmp366 = HYB(++i);
	RzILOpEffect *op_ASSIGN_hybrid_tmp_7 = SETL("h_tmp366", VARL("i"));

	// seq(h_tmp366 = HYB(++i); HYB(++i));
	RzILOpEffect *seq_8 = SEQN(2, op_ASSIGN_hybrid_tmp_7, op_INC_5);

	// Rdd = ((Rdd & (~(0xffffffff << i * 0x20))) | ((((((st64) ((st32) ((Rtt >> i * 0x20) & 0xffffffff))) - ((st64) ((st32) ((Rss >> i * 0x20) & 0xffffffff))) < ((st64) 0x0)) ? (-((st64) ((st32) ((Rtt >> i * 0x20) & 0xffffffff))) - ((st64) ((st32) ((Rss >> i * 0x20) & 0xffffffff)))) : ((st64) ((st32) ((Rtt >> i * 0x20) & 0xffffffff))) - ((st64) ((st32) ((Rss >> i * 0x20) & 0xffffffff)))) & 0xffffffff) << i * 0x20));
	RzILOpPure *op_MUL_12 = MUL(VARL("i"), SN(32, 0x20));
	RzILOpPure *op_LSHIFT_13 = SHIFTL0(SN(64, 0xffffffff), op_MUL_12);
	RzILOpPure *op_NOT_14 = LOGNOT(op_LSHIFT_13);
	RzILOpPure *op_AND_15 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_14);
	RzILOpPure *op_MUL_18 = MUL(VARL("i"), SN(32, 0x20));
	RzILOpPure *op_RSHIFT_19 = SHIFTRA(Rtt, op_MUL_18);
	RzILOpPure *op_AND_21 = LOGAND(op_RSHIFT_19, SN(64, 0xffffffff));
	RzILOpPure *op_MUL_26 = MUL(VARL("i"), SN(32, 0x20));
	RzILOpPure *op_RSHIFT_27 = SHIFTRA(Rss, op_MUL_26);
	RzILOpPure *op_AND_29 = LOGAND(op_RSHIFT_27, SN(64, 0xffffffff));
	RzILOpPure *op_SUB_32 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_21), DUP(op_AND_21))), CAST(32, MSB(DUP(op_AND_21)), DUP(op_AND_21))), CAST(64, MSB(CAST(32, MSB(op_AND_29), DUP(op_AND_29))), CAST(32, MSB(DUP(op_AND_29)), DUP(op_AND_29))));
	RzILOpPure *op_LT_35 = SLT(op_SUB_32, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_MUL_37 = MUL(VARL("i"), SN(32, 0x20));
	RzILOpPure *op_RSHIFT_38 = SHIFTRA(DUP(Rtt), op_MUL_37);
	RzILOpPure *op_AND_40 = LOGAND(op_RSHIFT_38, SN(64, 0xffffffff));
	RzILOpPure *op_MUL_44 = MUL(VARL("i"), SN(32, 0x20));
	RzILOpPure *op_RSHIFT_45 = SHIFTRA(DUP(Rss), op_MUL_44);
	RzILOpPure *op_AND_47 = LOGAND(op_RSHIFT_45, SN(64, 0xffffffff));
	RzILOpPure *op_SUB_50 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_40), DUP(op_AND_40))), CAST(32, MSB(DUP(op_AND_40)), DUP(op_AND_40))), CAST(64, MSB(CAST(32, MSB(op_AND_47), DUP(op_AND_47))), CAST(32, MSB(DUP(op_AND_47)), DUP(op_AND_47))));
	RzILOpPure *op_NEG_51 = NEG(op_SUB_50);
	RzILOpPure *op_MUL_53 = MUL(VARL("i"), SN(32, 0x20));
	RzILOpPure *op_RSHIFT_54 = SHIFTRA(DUP(Rtt), op_MUL_53);
	RzILOpPure *op_AND_56 = LOGAND(op_RSHIFT_54, SN(64, 0xffffffff));
	RzILOpPure *op_MUL_60 = MUL(VARL("i"), SN(32, 0x20));
	RzILOpPure *op_RSHIFT_61 = SHIFTRA(DUP(Rss), op_MUL_60);
	RzILOpPure *op_AND_63 = LOGAND(op_RSHIFT_61, SN(64, 0xffffffff));
	RzILOpPure *op_SUB_66 = SUB(CAST(64, MSB(CAST(32, MSB(op_AND_56), DUP(op_AND_56))), CAST(32, MSB(DUP(op_AND_56)), DUP(op_AND_56))), CAST(64, MSB(CAST(32, MSB(op_AND_63), DUP(op_AND_63))), CAST(32, MSB(DUP(op_AND_63)), DUP(op_AND_63))));
	RzILOpPure *cond_67 = ITE(op_LT_35, op_NEG_51, op_SUB_66);
	RzILOpPure *op_AND_69 = LOGAND(cond_67, SN(64, 0xffffffff));
	RzILOpPure *op_MUL_71 = MUL(VARL("i"), SN(32, 0x20));
	RzILOpPure *op_LSHIFT_72 = SHIFTL0(op_AND_69, op_MUL_71);
	RzILOpPure *op_OR_73 = LOGOR(op_AND_15, op_LSHIFT_72);
	RzILOpEffect *op_ASSIGN_74 = WRITE_REG(bundle, Rdd_op, op_OR_73);

	// seq(h_tmp366; Rdd = ((Rdd & (~(0xffffffff << i * 0x20))) | ((((( ...;
	RzILOpEffect *seq_76 = op_ASSIGN_74;

	// seq(seq(h_tmp366; Rdd = ((Rdd & (~(0xffffffff << i * 0x20))) | ( ...;
	RzILOpEffect *seq_77 = SEQN(2, seq_76, seq_8);

	// while ((i < 0x2)) { seq(seq(h_tmp366; Rdd = ((Rdd & (~(0xffffffff << i * 0x20))) | ( ... };
	RzILOpPure *op_LT_4 = SLT(VARL("i"), SN(32, 2));
	RzILOpEffect *for_78 = REPEAT(op_LT_4, seq_77);

	// seq(i = 0x0; while ((i < 0x2)) { seq(seq(h_tmp366; Rdd = ((Rdd & ...;
	RzILOpEffect *seq_79 = SEQN(2, op_ASSIGN_2, for_78);

	RzILOpEffect *instruction_sequence = seq_79;
	return instruction_sequence;
}

// Rxx += vcmpyi(Rss,Rtt):sat
RzILOpEffect *hex_il_op_m2_vcmac_s0_sat_i(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_177 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rss, SN(32, 16));
	RzILOpPure *op_AND_26 = LOGAND(op_RSHIFT_23, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_33 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_36 = LOGAND(op_RSHIFT_33, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_39 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_26), DUP(op_AND_26))), CAST(16, MSB(DUP(op_AND_26)), DUP(op_AND_26))), CAST(32, MSB(CAST(16, MSB(op_AND_36), DUP(op_AND_36))), CAST(16, MSB(DUP(op_AND_36)), DUP(op_AND_36))));
	RzILOpPure *op_RSHIFT_44 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_47 = LOGAND(op_RSHIFT_44, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_53 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_56 = LOGAND(op_RSHIFT_53, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_59 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_47), DUP(op_AND_47))), CAST(16, MSB(DUP(op_AND_47)), DUP(op_AND_47))), CAST(32, MSB(CAST(16, MSB(op_AND_56), DUP(op_AND_56))), CAST(16, MSB(DUP(op_AND_56)), DUP(op_AND_56))));
	RzILOpPure *op_ADD_61 = ADD(CAST(64, MSB(op_MUL_39), DUP(op_MUL_39)), CAST(64, MSB(op_MUL_59), DUP(op_MUL_59)));
	RzILOpPure *op_LSHIFT_63 = SHIFTL0(op_ADD_61, SN(32, 0));
	RzILOpPure *op_ADD_64 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_LSHIFT_63);
	RzILOpPure *op_RSHIFT_73 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_75 = LOGAND(op_RSHIFT_73, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_81 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_84 = LOGAND(op_RSHIFT_81, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_90 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_93 = LOGAND(op_RSHIFT_90, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_96 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_84), DUP(op_AND_84))), CAST(16, MSB(DUP(op_AND_84)), DUP(op_AND_84))), CAST(32, MSB(CAST(16, MSB(op_AND_93), DUP(op_AND_93))), CAST(16, MSB(DUP(op_AND_93)), DUP(op_AND_93))));
	RzILOpPure *op_RSHIFT_101 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_104 = LOGAND(op_RSHIFT_101, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_110 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_113 = LOGAND(op_RSHIFT_110, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_116 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_104), DUP(op_AND_104))), CAST(16, MSB(DUP(op_AND_104)), DUP(op_AND_104))), CAST(32, MSB(CAST(16, MSB(op_AND_113), DUP(op_AND_113))), CAST(16, MSB(DUP(op_AND_113)), DUP(op_AND_113))));
	RzILOpPure *op_ADD_118 = ADD(CAST(64, MSB(op_MUL_96), DUP(op_MUL_96)), CAST(64, MSB(op_MUL_116), DUP(op_MUL_116)));
	RzILOpPure *op_LSHIFT_120 = SHIFTL0(op_ADD_118, SN(32, 0));
	RzILOpPure *op_ADD_121 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_75), DUP(op_AND_75))), CAST(32, MSB(DUP(op_AND_75)), DUP(op_AND_75))), op_LSHIFT_120);
	RzILOpPure *op_EQ_122 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_64), SN(32, 0), SN(32, 0x20)), op_ADD_121);
	RzILOpPure *op_RSHIFT_181 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_183 = LOGAND(op_RSHIFT_181, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_189 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_192 = LOGAND(op_RSHIFT_189, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_198 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_201 = LOGAND(op_RSHIFT_198, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_204 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_192), DUP(op_AND_192))), CAST(16, MSB(DUP(op_AND_192)), DUP(op_AND_192))), CAST(32, MSB(CAST(16, MSB(op_AND_201), DUP(op_AND_201))), CAST(16, MSB(DUP(op_AND_201)), DUP(op_AND_201))));
	RzILOpPure *op_RSHIFT_209 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_212 = LOGAND(op_RSHIFT_209, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_218 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_221 = LOGAND(op_RSHIFT_218, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_224 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_212), DUP(op_AND_212))), CAST(16, MSB(DUP(op_AND_212)), DUP(op_AND_212))), CAST(32, MSB(CAST(16, MSB(op_AND_221), DUP(op_AND_221))), CAST(16, MSB(DUP(op_AND_221)), DUP(op_AND_221))));
	RzILOpPure *op_ADD_226 = ADD(CAST(64, MSB(op_MUL_204), DUP(op_MUL_204)), CAST(64, MSB(op_MUL_224), DUP(op_MUL_224)));
	RzILOpPure *op_LSHIFT_228 = SHIFTL0(op_ADD_226, SN(32, 0));
	RzILOpPure *op_ADD_229 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_183), DUP(op_AND_183))), CAST(32, MSB(DUP(op_AND_183)), DUP(op_AND_183))), op_LSHIFT_228);
	RzILOpPure *op_LT_232 = SLT(op_ADD_229, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_237 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_238 = NEG(op_LSHIFT_237);
	RzILOpPure *op_LSHIFT_243 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_246 = SUB(op_LSHIFT_243, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_247 = ITE(op_LT_232, op_NEG_238, op_SUB_246);
	RzILOpEffect *gcc_expr_248 = BRANCH(op_EQ_122, EMPTY(), set_usr_field_call_177);

	// h_tmp367 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_250 = SETL("h_tmp367", cond_247);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_251 = SEQN(2, gcc_expr_248, op_ASSIGN_hybrid_tmp_250);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0) : h_tmp367) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_126 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_128 = LOGAND(op_RSHIFT_126, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_134 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_137 = LOGAND(op_RSHIFT_134, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_143 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_146 = LOGAND(op_RSHIFT_143, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_149 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_137), DUP(op_AND_137))), CAST(16, MSB(DUP(op_AND_137)), DUP(op_AND_137))), CAST(32, MSB(CAST(16, MSB(op_AND_146), DUP(op_AND_146))), CAST(16, MSB(DUP(op_AND_146)), DUP(op_AND_146))));
	RzILOpPure *op_RSHIFT_154 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_157 = LOGAND(op_RSHIFT_154, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_163 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_166 = LOGAND(op_RSHIFT_163, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_169 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_157), DUP(op_AND_157))), CAST(16, MSB(DUP(op_AND_157)), DUP(op_AND_157))), CAST(32, MSB(CAST(16, MSB(op_AND_166), DUP(op_AND_166))), CAST(16, MSB(DUP(op_AND_166)), DUP(op_AND_166))));
	RzILOpPure *op_ADD_171 = ADD(CAST(64, MSB(op_MUL_149), DUP(op_MUL_149)), CAST(64, MSB(op_MUL_169), DUP(op_MUL_169)));
	RzILOpPure *op_LSHIFT_173 = SHIFTL0(op_ADD_171, SN(32, 0));
	RzILOpPure *op_ADD_174 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_128), DUP(op_AND_128))), CAST(32, MSB(DUP(op_AND_128)), DUP(op_AND_128))), op_LSHIFT_173);
	RzILOpPure *cond_252 = ITE(DUP(op_EQ_122), op_ADD_174, VARL("h_tmp367"));
	RzILOpPure *op_AND_254 = LOGAND(cond_252, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_258 = SHIFTL0(op_AND_254, SN(32, 0));
	RzILOpPure *op_OR_259 = LOGOR(op_AND_7, op_LSHIFT_258);
	RzILOpEffect *op_ASSIGN_260 = WRITE_REG(bundle, Rxx_op, op_OR_259);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_261 = SEQN(2, seq_251, op_ASSIGN_260);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_437 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_276 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_278 = LOGAND(op_RSHIFT_276, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_284 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_287 = LOGAND(op_RSHIFT_284, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_293 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_296 = LOGAND(op_RSHIFT_293, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_299 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_287), DUP(op_AND_287))), CAST(16, MSB(DUP(op_AND_287)), DUP(op_AND_287))), CAST(32, MSB(CAST(16, MSB(op_AND_296), DUP(op_AND_296))), CAST(16, MSB(DUP(op_AND_296)), DUP(op_AND_296))));
	RzILOpPure *op_RSHIFT_304 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_307 = LOGAND(op_RSHIFT_304, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_313 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_316 = LOGAND(op_RSHIFT_313, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_319 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_307), DUP(op_AND_307))), CAST(16, MSB(DUP(op_AND_307)), DUP(op_AND_307))), CAST(32, MSB(CAST(16, MSB(op_AND_316), DUP(op_AND_316))), CAST(16, MSB(DUP(op_AND_316)), DUP(op_AND_316))));
	RzILOpPure *op_ADD_321 = ADD(CAST(64, MSB(op_MUL_299), DUP(op_MUL_299)), CAST(64, MSB(op_MUL_319), DUP(op_MUL_319)));
	RzILOpPure *op_LSHIFT_323 = SHIFTL0(op_ADD_321, SN(32, 0));
	RzILOpPure *op_ADD_324 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_278), DUP(op_AND_278))), CAST(32, MSB(DUP(op_AND_278)), DUP(op_AND_278))), op_LSHIFT_323);
	RzILOpPure *op_RSHIFT_333 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_335 = LOGAND(op_RSHIFT_333, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_341 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_344 = LOGAND(op_RSHIFT_341, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_350 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_353 = LOGAND(op_RSHIFT_350, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_356 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_344), DUP(op_AND_344))), CAST(16, MSB(DUP(op_AND_344)), DUP(op_AND_344))), CAST(32, MSB(CAST(16, MSB(op_AND_353), DUP(op_AND_353))), CAST(16, MSB(DUP(op_AND_353)), DUP(op_AND_353))));
	RzILOpPure *op_RSHIFT_361 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_364 = LOGAND(op_RSHIFT_361, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_370 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_373 = LOGAND(op_RSHIFT_370, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_376 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_364), DUP(op_AND_364))), CAST(16, MSB(DUP(op_AND_364)), DUP(op_AND_364))), CAST(32, MSB(CAST(16, MSB(op_AND_373), DUP(op_AND_373))), CAST(16, MSB(DUP(op_AND_373)), DUP(op_AND_373))));
	RzILOpPure *op_ADD_378 = ADD(CAST(64, MSB(op_MUL_356), DUP(op_MUL_356)), CAST(64, MSB(op_MUL_376), DUP(op_MUL_376)));
	RzILOpPure *op_LSHIFT_380 = SHIFTL0(op_ADD_378, SN(32, 0));
	RzILOpPure *op_ADD_381 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_335), DUP(op_AND_335))), CAST(32, MSB(DUP(op_AND_335)), DUP(op_AND_335))), op_LSHIFT_380);
	RzILOpPure *op_EQ_382 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_324), SN(32, 0), SN(32, 0x20)), op_ADD_381);
	RzILOpPure *op_RSHIFT_441 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_443 = LOGAND(op_RSHIFT_441, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_449 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_452 = LOGAND(op_RSHIFT_449, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_458 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_461 = LOGAND(op_RSHIFT_458, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_464 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_452), DUP(op_AND_452))), CAST(16, MSB(DUP(op_AND_452)), DUP(op_AND_452))), CAST(32, MSB(CAST(16, MSB(op_AND_461), DUP(op_AND_461))), CAST(16, MSB(DUP(op_AND_461)), DUP(op_AND_461))));
	RzILOpPure *op_RSHIFT_469 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_472 = LOGAND(op_RSHIFT_469, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_478 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_481 = LOGAND(op_RSHIFT_478, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_484 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_472), DUP(op_AND_472))), CAST(16, MSB(DUP(op_AND_472)), DUP(op_AND_472))), CAST(32, MSB(CAST(16, MSB(op_AND_481), DUP(op_AND_481))), CAST(16, MSB(DUP(op_AND_481)), DUP(op_AND_481))));
	RzILOpPure *op_ADD_486 = ADD(CAST(64, MSB(op_MUL_464), DUP(op_MUL_464)), CAST(64, MSB(op_MUL_484), DUP(op_MUL_484)));
	RzILOpPure *op_LSHIFT_488 = SHIFTL0(op_ADD_486, SN(32, 0));
	RzILOpPure *op_ADD_489 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_443), DUP(op_AND_443))), CAST(32, MSB(DUP(op_AND_443)), DUP(op_AND_443))), op_LSHIFT_488);
	RzILOpPure *op_LT_492 = SLT(op_ADD_489, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_497 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_498 = NEG(op_LSHIFT_497);
	RzILOpPure *op_LSHIFT_503 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_506 = SUB(op_LSHIFT_503, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_507 = ITE(op_LT_492, op_NEG_498, op_SUB_506);
	RzILOpEffect *gcc_expr_508 = BRANCH(op_EQ_382, EMPTY(), set_usr_field_call_437);

	// h_tmp368 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_510 = SETL("h_tmp368", cond_507);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_511 = SEQN(2, gcc_expr_508, op_ASSIGN_hybrid_tmp_510);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0) : h_tmp368) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_267 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_268 = LOGNOT(op_LSHIFT_267);
	RzILOpPure *op_AND_269 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_268);
	RzILOpPure *op_RSHIFT_386 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_388 = LOGAND(op_RSHIFT_386, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_394 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_397 = LOGAND(op_RSHIFT_394, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_403 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_406 = LOGAND(op_RSHIFT_403, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_409 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_397), DUP(op_AND_397))), CAST(16, MSB(DUP(op_AND_397)), DUP(op_AND_397))), CAST(32, MSB(CAST(16, MSB(op_AND_406), DUP(op_AND_406))), CAST(16, MSB(DUP(op_AND_406)), DUP(op_AND_406))));
	RzILOpPure *op_RSHIFT_414 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_417 = LOGAND(op_RSHIFT_414, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_423 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_426 = LOGAND(op_RSHIFT_423, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_429 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_417), DUP(op_AND_417))), CAST(16, MSB(DUP(op_AND_417)), DUP(op_AND_417))), CAST(32, MSB(CAST(16, MSB(op_AND_426), DUP(op_AND_426))), CAST(16, MSB(DUP(op_AND_426)), DUP(op_AND_426))));
	RzILOpPure *op_ADD_431 = ADD(CAST(64, MSB(op_MUL_409), DUP(op_MUL_409)), CAST(64, MSB(op_MUL_429), DUP(op_MUL_429)));
	RzILOpPure *op_LSHIFT_433 = SHIFTL0(op_ADD_431, SN(32, 0));
	RzILOpPure *op_ADD_434 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_388), DUP(op_AND_388))), CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388))), op_LSHIFT_433);
	RzILOpPure *cond_512 = ITE(DUP(op_EQ_382), op_ADD_434, VARL("h_tmp368"));
	RzILOpPure *op_AND_514 = LOGAND(cond_512, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_518 = SHIFTL0(op_AND_514, SN(32, 0x20));
	RzILOpPure *op_OR_519 = LOGOR(op_AND_269, op_LSHIFT_518);
	RzILOpEffect *op_ASSIGN_520 = WRITE_REG(bundle, Rxx_op, op_OR_519);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_521 = SEQN(2, seq_511, op_ASSIGN_520);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_261, seq_521);
	return instruction_sequence;
}

// Rxx += vcmpyr(Rss,Rtt):sat
RzILOpEffect *hex_il_op_m2_vcmac_s0_sat_r(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_177 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rss, SN(32, 0));
	RzILOpPure *op_AND_26 = LOGAND(op_RSHIFT_23, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_33 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_36 = LOGAND(op_RSHIFT_33, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_39 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_26), DUP(op_AND_26))), CAST(16, MSB(DUP(op_AND_26)), DUP(op_AND_26))), CAST(32, MSB(CAST(16, MSB(op_AND_36), DUP(op_AND_36))), CAST(16, MSB(DUP(op_AND_36)), DUP(op_AND_36))));
	RzILOpPure *op_RSHIFT_44 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_47 = LOGAND(op_RSHIFT_44, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_53 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_56 = LOGAND(op_RSHIFT_53, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_59 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_47), DUP(op_AND_47))), CAST(16, MSB(DUP(op_AND_47)), DUP(op_AND_47))), CAST(32, MSB(CAST(16, MSB(op_AND_56), DUP(op_AND_56))), CAST(16, MSB(DUP(op_AND_56)), DUP(op_AND_56))));
	RzILOpPure *op_SUB_61 = SUB(CAST(64, MSB(op_MUL_39), DUP(op_MUL_39)), CAST(64, MSB(op_MUL_59), DUP(op_MUL_59)));
	RzILOpPure *op_LSHIFT_63 = SHIFTL0(op_SUB_61, SN(32, 0));
	RzILOpPure *op_ADD_64 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_LSHIFT_63);
	RzILOpPure *op_RSHIFT_73 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_75 = LOGAND(op_RSHIFT_73, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_81 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_84 = LOGAND(op_RSHIFT_81, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_90 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_93 = LOGAND(op_RSHIFT_90, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_96 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_84), DUP(op_AND_84))), CAST(16, MSB(DUP(op_AND_84)), DUP(op_AND_84))), CAST(32, MSB(CAST(16, MSB(op_AND_93), DUP(op_AND_93))), CAST(16, MSB(DUP(op_AND_93)), DUP(op_AND_93))));
	RzILOpPure *op_RSHIFT_101 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_104 = LOGAND(op_RSHIFT_101, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_110 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_113 = LOGAND(op_RSHIFT_110, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_116 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_104), DUP(op_AND_104))), CAST(16, MSB(DUP(op_AND_104)), DUP(op_AND_104))), CAST(32, MSB(CAST(16, MSB(op_AND_113), DUP(op_AND_113))), CAST(16, MSB(DUP(op_AND_113)), DUP(op_AND_113))));
	RzILOpPure *op_SUB_118 = SUB(CAST(64, MSB(op_MUL_96), DUP(op_MUL_96)), CAST(64, MSB(op_MUL_116), DUP(op_MUL_116)));
	RzILOpPure *op_LSHIFT_120 = SHIFTL0(op_SUB_118, SN(32, 0));
	RzILOpPure *op_ADD_121 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_75), DUP(op_AND_75))), CAST(32, MSB(DUP(op_AND_75)), DUP(op_AND_75))), op_LSHIFT_120);
	RzILOpPure *op_EQ_122 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_64), SN(32, 0), SN(32, 0x20)), op_ADD_121);
	RzILOpPure *op_RSHIFT_181 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_183 = LOGAND(op_RSHIFT_181, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_189 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_192 = LOGAND(op_RSHIFT_189, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_198 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_201 = LOGAND(op_RSHIFT_198, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_204 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_192), DUP(op_AND_192))), CAST(16, MSB(DUP(op_AND_192)), DUP(op_AND_192))), CAST(32, MSB(CAST(16, MSB(op_AND_201), DUP(op_AND_201))), CAST(16, MSB(DUP(op_AND_201)), DUP(op_AND_201))));
	RzILOpPure *op_RSHIFT_209 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_212 = LOGAND(op_RSHIFT_209, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_218 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_221 = LOGAND(op_RSHIFT_218, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_224 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_212), DUP(op_AND_212))), CAST(16, MSB(DUP(op_AND_212)), DUP(op_AND_212))), CAST(32, MSB(CAST(16, MSB(op_AND_221), DUP(op_AND_221))), CAST(16, MSB(DUP(op_AND_221)), DUP(op_AND_221))));
	RzILOpPure *op_SUB_226 = SUB(CAST(64, MSB(op_MUL_204), DUP(op_MUL_204)), CAST(64, MSB(op_MUL_224), DUP(op_MUL_224)));
	RzILOpPure *op_LSHIFT_228 = SHIFTL0(op_SUB_226, SN(32, 0));
	RzILOpPure *op_ADD_229 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_183), DUP(op_AND_183))), CAST(32, MSB(DUP(op_AND_183)), DUP(op_AND_183))), op_LSHIFT_228);
	RzILOpPure *op_LT_232 = SLT(op_ADD_229, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_237 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_238 = NEG(op_LSHIFT_237);
	RzILOpPure *op_LSHIFT_243 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_246 = SUB(op_LSHIFT_243, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_247 = ITE(op_LT_232, op_NEG_238, op_SUB_246);
	RzILOpEffect *gcc_expr_248 = BRANCH(op_EQ_122, EMPTY(), set_usr_field_call_177);

	// h_tmp369 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_250 = SETL("h_tmp369", cond_247);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_251 = SEQN(2, gcc_expr_248, op_ASSIGN_hybrid_tmp_250);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0) : h_tmp369) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_126 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_128 = LOGAND(op_RSHIFT_126, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_134 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_137 = LOGAND(op_RSHIFT_134, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_143 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_146 = LOGAND(op_RSHIFT_143, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_149 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_137), DUP(op_AND_137))), CAST(16, MSB(DUP(op_AND_137)), DUP(op_AND_137))), CAST(32, MSB(CAST(16, MSB(op_AND_146), DUP(op_AND_146))), CAST(16, MSB(DUP(op_AND_146)), DUP(op_AND_146))));
	RzILOpPure *op_RSHIFT_154 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_157 = LOGAND(op_RSHIFT_154, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_163 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_166 = LOGAND(op_RSHIFT_163, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_169 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_157), DUP(op_AND_157))), CAST(16, MSB(DUP(op_AND_157)), DUP(op_AND_157))), CAST(32, MSB(CAST(16, MSB(op_AND_166), DUP(op_AND_166))), CAST(16, MSB(DUP(op_AND_166)), DUP(op_AND_166))));
	RzILOpPure *op_SUB_171 = SUB(CAST(64, MSB(op_MUL_149), DUP(op_MUL_149)), CAST(64, MSB(op_MUL_169), DUP(op_MUL_169)));
	RzILOpPure *op_LSHIFT_173 = SHIFTL0(op_SUB_171, SN(32, 0));
	RzILOpPure *op_ADD_174 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_128), DUP(op_AND_128))), CAST(32, MSB(DUP(op_AND_128)), DUP(op_AND_128))), op_LSHIFT_173);
	RzILOpPure *cond_252 = ITE(DUP(op_EQ_122), op_ADD_174, VARL("h_tmp369"));
	RzILOpPure *op_AND_254 = LOGAND(cond_252, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_258 = SHIFTL0(op_AND_254, SN(32, 0));
	RzILOpPure *op_OR_259 = LOGOR(op_AND_7, op_LSHIFT_258);
	RzILOpEffect *op_ASSIGN_260 = WRITE_REG(bundle, Rxx_op, op_OR_259);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_261 = SEQN(2, seq_251, op_ASSIGN_260);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_437 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_276 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_278 = LOGAND(op_RSHIFT_276, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_284 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_287 = LOGAND(op_RSHIFT_284, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_293 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_296 = LOGAND(op_RSHIFT_293, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_299 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_287), DUP(op_AND_287))), CAST(16, MSB(DUP(op_AND_287)), DUP(op_AND_287))), CAST(32, MSB(CAST(16, MSB(op_AND_296), DUP(op_AND_296))), CAST(16, MSB(DUP(op_AND_296)), DUP(op_AND_296))));
	RzILOpPure *op_RSHIFT_304 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_307 = LOGAND(op_RSHIFT_304, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_313 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_316 = LOGAND(op_RSHIFT_313, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_319 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_307), DUP(op_AND_307))), CAST(16, MSB(DUP(op_AND_307)), DUP(op_AND_307))), CAST(32, MSB(CAST(16, MSB(op_AND_316), DUP(op_AND_316))), CAST(16, MSB(DUP(op_AND_316)), DUP(op_AND_316))));
	RzILOpPure *op_SUB_321 = SUB(CAST(64, MSB(op_MUL_299), DUP(op_MUL_299)), CAST(64, MSB(op_MUL_319), DUP(op_MUL_319)));
	RzILOpPure *op_LSHIFT_323 = SHIFTL0(op_SUB_321, SN(32, 0));
	RzILOpPure *op_ADD_324 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_278), DUP(op_AND_278))), CAST(32, MSB(DUP(op_AND_278)), DUP(op_AND_278))), op_LSHIFT_323);
	RzILOpPure *op_RSHIFT_333 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_335 = LOGAND(op_RSHIFT_333, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_341 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_344 = LOGAND(op_RSHIFT_341, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_350 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_353 = LOGAND(op_RSHIFT_350, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_356 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_344), DUP(op_AND_344))), CAST(16, MSB(DUP(op_AND_344)), DUP(op_AND_344))), CAST(32, MSB(CAST(16, MSB(op_AND_353), DUP(op_AND_353))), CAST(16, MSB(DUP(op_AND_353)), DUP(op_AND_353))));
	RzILOpPure *op_RSHIFT_361 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_364 = LOGAND(op_RSHIFT_361, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_370 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_373 = LOGAND(op_RSHIFT_370, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_376 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_364), DUP(op_AND_364))), CAST(16, MSB(DUP(op_AND_364)), DUP(op_AND_364))), CAST(32, MSB(CAST(16, MSB(op_AND_373), DUP(op_AND_373))), CAST(16, MSB(DUP(op_AND_373)), DUP(op_AND_373))));
	RzILOpPure *op_SUB_378 = SUB(CAST(64, MSB(op_MUL_356), DUP(op_MUL_356)), CAST(64, MSB(op_MUL_376), DUP(op_MUL_376)));
	RzILOpPure *op_LSHIFT_380 = SHIFTL0(op_SUB_378, SN(32, 0));
	RzILOpPure *op_ADD_381 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_335), DUP(op_AND_335))), CAST(32, MSB(DUP(op_AND_335)), DUP(op_AND_335))), op_LSHIFT_380);
	RzILOpPure *op_EQ_382 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_324), SN(32, 0), SN(32, 0x20)), op_ADD_381);
	RzILOpPure *op_RSHIFT_441 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_443 = LOGAND(op_RSHIFT_441, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_449 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_452 = LOGAND(op_RSHIFT_449, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_458 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_461 = LOGAND(op_RSHIFT_458, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_464 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_452), DUP(op_AND_452))), CAST(16, MSB(DUP(op_AND_452)), DUP(op_AND_452))), CAST(32, MSB(CAST(16, MSB(op_AND_461), DUP(op_AND_461))), CAST(16, MSB(DUP(op_AND_461)), DUP(op_AND_461))));
	RzILOpPure *op_RSHIFT_469 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_472 = LOGAND(op_RSHIFT_469, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_478 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_481 = LOGAND(op_RSHIFT_478, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_484 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_472), DUP(op_AND_472))), CAST(16, MSB(DUP(op_AND_472)), DUP(op_AND_472))), CAST(32, MSB(CAST(16, MSB(op_AND_481), DUP(op_AND_481))), CAST(16, MSB(DUP(op_AND_481)), DUP(op_AND_481))));
	RzILOpPure *op_SUB_486 = SUB(CAST(64, MSB(op_MUL_464), DUP(op_MUL_464)), CAST(64, MSB(op_MUL_484), DUP(op_MUL_484)));
	RzILOpPure *op_LSHIFT_488 = SHIFTL0(op_SUB_486, SN(32, 0));
	RzILOpPure *op_ADD_489 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_443), DUP(op_AND_443))), CAST(32, MSB(DUP(op_AND_443)), DUP(op_AND_443))), op_LSHIFT_488);
	RzILOpPure *op_LT_492 = SLT(op_ADD_489, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_497 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_498 = NEG(op_LSHIFT_497);
	RzILOpPure *op_LSHIFT_503 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_506 = SUB(op_LSHIFT_503, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_507 = ITE(op_LT_492, op_NEG_498, op_SUB_506);
	RzILOpEffect *gcc_expr_508 = BRANCH(op_EQ_382, EMPTY(), set_usr_field_call_437);

	// h_tmp370 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_510 = SETL("h_tmp370", cond_507);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_511 = SEQN(2, gcc_expr_508, op_ASSIGN_hybrid_tmp_510);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0) : h_tmp370) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_267 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_268 = LOGNOT(op_LSHIFT_267);
	RzILOpPure *op_AND_269 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_268);
	RzILOpPure *op_RSHIFT_386 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_388 = LOGAND(op_RSHIFT_386, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_394 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_397 = LOGAND(op_RSHIFT_394, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_403 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_406 = LOGAND(op_RSHIFT_403, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_409 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_397), DUP(op_AND_397))), CAST(16, MSB(DUP(op_AND_397)), DUP(op_AND_397))), CAST(32, MSB(CAST(16, MSB(op_AND_406), DUP(op_AND_406))), CAST(16, MSB(DUP(op_AND_406)), DUP(op_AND_406))));
	RzILOpPure *op_RSHIFT_414 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_417 = LOGAND(op_RSHIFT_414, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_423 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_426 = LOGAND(op_RSHIFT_423, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_429 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_417), DUP(op_AND_417))), CAST(16, MSB(DUP(op_AND_417)), DUP(op_AND_417))), CAST(32, MSB(CAST(16, MSB(op_AND_426), DUP(op_AND_426))), CAST(16, MSB(DUP(op_AND_426)), DUP(op_AND_426))));
	RzILOpPure *op_SUB_431 = SUB(CAST(64, MSB(op_MUL_409), DUP(op_MUL_409)), CAST(64, MSB(op_MUL_429), DUP(op_MUL_429)));
	RzILOpPure *op_LSHIFT_433 = SHIFTL0(op_SUB_431, SN(32, 0));
	RzILOpPure *op_ADD_434 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_388), DUP(op_AND_388))), CAST(32, MSB(DUP(op_AND_388)), DUP(op_AND_388))), op_LSHIFT_433);
	RzILOpPure *cond_512 = ITE(DUP(op_EQ_382), op_ADD_434, VARL("h_tmp370"));
	RzILOpPure *op_AND_514 = LOGAND(cond_512, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_518 = SHIFTL0(op_AND_514, SN(32, 0x20));
	RzILOpPure *op_OR_519 = LOGOR(op_AND_269, op_LSHIFT_518);
	RzILOpEffect *op_ASSIGN_520 = WRITE_REG(bundle, Rxx_op, op_OR_519);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_521 = SEQN(2, seq_511, op_ASSIGN_520);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_261, seq_521);
	return instruction_sequence;
}

// Rdd = vcmpyi(Rss,Rtt):sat
RzILOpEffect *hex_il_op_m2_vcmpy_s0_sat_i(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_150 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rss, SN(32, 16));
	RzILOpPure *op_AND_18 = LOGAND(op_RSHIFT_15, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_25 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_28 = LOGAND(op_RSHIFT_25, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_31 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_18), DUP(op_AND_18))), CAST(16, MSB(DUP(op_AND_18)), DUP(op_AND_18))), CAST(32, MSB(CAST(16, MSB(op_AND_28), DUP(op_AND_28))), CAST(16, MSB(DUP(op_AND_28)), DUP(op_AND_28))));
	RzILOpPure *op_RSHIFT_36 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_39 = LOGAND(op_RSHIFT_36, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_45 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_48 = LOGAND(op_RSHIFT_45, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_51 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_39), DUP(op_AND_39))), CAST(16, MSB(DUP(op_AND_39)), DUP(op_AND_39))), CAST(32, MSB(CAST(16, MSB(op_AND_48), DUP(op_AND_48))), CAST(16, MSB(DUP(op_AND_48)), DUP(op_AND_48))));
	RzILOpPure *op_ADD_53 = ADD(CAST(64, MSB(op_MUL_31), DUP(op_MUL_31)), CAST(64, MSB(op_MUL_51), DUP(op_MUL_51)));
	RzILOpPure *op_LSHIFT_55 = SHIFTL0(op_ADD_53, SN(32, 0));
	RzILOpPure *op_RSHIFT_64 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_67 = LOGAND(op_RSHIFT_64, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_73 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_76 = LOGAND(op_RSHIFT_73, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_79 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_67), DUP(op_AND_67))), CAST(16, MSB(DUP(op_AND_67)), DUP(op_AND_67))), CAST(32, MSB(CAST(16, MSB(op_AND_76), DUP(op_AND_76))), CAST(16, MSB(DUP(op_AND_76)), DUP(op_AND_76))));
	RzILOpPure *op_RSHIFT_84 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_87 = LOGAND(op_RSHIFT_84, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_93 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_96 = LOGAND(op_RSHIFT_93, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_99 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_87), DUP(op_AND_87))), CAST(16, MSB(DUP(op_AND_87)), DUP(op_AND_87))), CAST(32, MSB(CAST(16, MSB(op_AND_96), DUP(op_AND_96))), CAST(16, MSB(DUP(op_AND_96)), DUP(op_AND_96))));
	RzILOpPure *op_ADD_101 = ADD(CAST(64, MSB(op_MUL_79), DUP(op_MUL_79)), CAST(64, MSB(op_MUL_99), DUP(op_MUL_99)));
	RzILOpPure *op_LSHIFT_103 = SHIFTL0(op_ADD_101, SN(32, 0));
	RzILOpPure *op_EQ_104 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_LSHIFT_55), SN(32, 0), SN(32, 0x20)), op_LSHIFT_103);
	RzILOpPure *op_RSHIFT_154 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_157 = LOGAND(op_RSHIFT_154, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_163 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_166 = LOGAND(op_RSHIFT_163, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_169 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_157), DUP(op_AND_157))), CAST(16, MSB(DUP(op_AND_157)), DUP(op_AND_157))), CAST(32, MSB(CAST(16, MSB(op_AND_166), DUP(op_AND_166))), CAST(16, MSB(DUP(op_AND_166)), DUP(op_AND_166))));
	RzILOpPure *op_RSHIFT_174 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_177 = LOGAND(op_RSHIFT_174, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_183 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_186 = LOGAND(op_RSHIFT_183, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_189 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_177), DUP(op_AND_177))), CAST(16, MSB(DUP(op_AND_177)), DUP(op_AND_177))), CAST(32, MSB(CAST(16, MSB(op_AND_186), DUP(op_AND_186))), CAST(16, MSB(DUP(op_AND_186)), DUP(op_AND_186))));
	RzILOpPure *op_ADD_191 = ADD(CAST(64, MSB(op_MUL_169), DUP(op_MUL_169)), CAST(64, MSB(op_MUL_189), DUP(op_MUL_189)));
	RzILOpPure *op_LSHIFT_193 = SHIFTL0(op_ADD_191, SN(32, 0));
	RzILOpPure *op_LT_196 = SLT(op_LSHIFT_193, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_201 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_202 = NEG(op_LSHIFT_201);
	RzILOpPure *op_LSHIFT_207 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_210 = SUB(op_LSHIFT_207, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_211 = ITE(op_LT_196, op_NEG_202, op_SUB_210);
	RzILOpEffect *gcc_expr_212 = BRANCH(op_EQ_104, EMPTY(), set_usr_field_call_150);

	// h_tmp371 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_214 = SETL("h_tmp371", cond_211);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_215 = SEQN(2, gcc_expr_212, op_ASSIGN_hybrid_tmp_214);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0)) ? (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0) : h_tmp371) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_108 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_111 = LOGAND(op_RSHIFT_108, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_117 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_120 = LOGAND(op_RSHIFT_117, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_123 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_111), DUP(op_AND_111))), CAST(16, MSB(DUP(op_AND_111)), DUP(op_AND_111))), CAST(32, MSB(CAST(16, MSB(op_AND_120), DUP(op_AND_120))), CAST(16, MSB(DUP(op_AND_120)), DUP(op_AND_120))));
	RzILOpPure *op_RSHIFT_128 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_131 = LOGAND(op_RSHIFT_128, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_137 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_140 = LOGAND(op_RSHIFT_137, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_143 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_131), DUP(op_AND_131))), CAST(16, MSB(DUP(op_AND_131)), DUP(op_AND_131))), CAST(32, MSB(CAST(16, MSB(op_AND_140), DUP(op_AND_140))), CAST(16, MSB(DUP(op_AND_140)), DUP(op_AND_140))));
	RzILOpPure *op_ADD_145 = ADD(CAST(64, MSB(op_MUL_123), DUP(op_MUL_123)), CAST(64, MSB(op_MUL_143), DUP(op_MUL_143)));
	RzILOpPure *op_LSHIFT_147 = SHIFTL0(op_ADD_145, SN(32, 0));
	RzILOpPure *cond_216 = ITE(DUP(op_EQ_104), op_LSHIFT_147, VARL("h_tmp371"));
	RzILOpPure *op_AND_218 = LOGAND(cond_216, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_222 = SHIFTL0(op_AND_218, SN(32, 0));
	RzILOpPure *op_OR_223 = LOGOR(op_AND_7, op_LSHIFT_222);
	RzILOpEffect *op_ASSIGN_224 = WRITE_REG(bundle, Rdd_op, op_OR_223);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_225 = SEQN(2, seq_215, op_ASSIGN_224);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_374 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_240 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_243 = LOGAND(op_RSHIFT_240, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_249 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_252 = LOGAND(op_RSHIFT_249, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_255 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_243), DUP(op_AND_243))), CAST(16, MSB(DUP(op_AND_243)), DUP(op_AND_243))), CAST(32, MSB(CAST(16, MSB(op_AND_252), DUP(op_AND_252))), CAST(16, MSB(DUP(op_AND_252)), DUP(op_AND_252))));
	RzILOpPure *op_RSHIFT_260 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_263 = LOGAND(op_RSHIFT_260, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_269 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_272 = LOGAND(op_RSHIFT_269, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_275 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_263), DUP(op_AND_263))), CAST(16, MSB(DUP(op_AND_263)), DUP(op_AND_263))), CAST(32, MSB(CAST(16, MSB(op_AND_272), DUP(op_AND_272))), CAST(16, MSB(DUP(op_AND_272)), DUP(op_AND_272))));
	RzILOpPure *op_ADD_277 = ADD(CAST(64, MSB(op_MUL_255), DUP(op_MUL_255)), CAST(64, MSB(op_MUL_275), DUP(op_MUL_275)));
	RzILOpPure *op_LSHIFT_279 = SHIFTL0(op_ADD_277, SN(32, 0));
	RzILOpPure *op_RSHIFT_288 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_291 = LOGAND(op_RSHIFT_288, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_297 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_300 = LOGAND(op_RSHIFT_297, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_303 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_291), DUP(op_AND_291))), CAST(16, MSB(DUP(op_AND_291)), DUP(op_AND_291))), CAST(32, MSB(CAST(16, MSB(op_AND_300), DUP(op_AND_300))), CAST(16, MSB(DUP(op_AND_300)), DUP(op_AND_300))));
	RzILOpPure *op_RSHIFT_308 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_311 = LOGAND(op_RSHIFT_308, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_317 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_320 = LOGAND(op_RSHIFT_317, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_323 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_311), DUP(op_AND_311))), CAST(16, MSB(DUP(op_AND_311)), DUP(op_AND_311))), CAST(32, MSB(CAST(16, MSB(op_AND_320), DUP(op_AND_320))), CAST(16, MSB(DUP(op_AND_320)), DUP(op_AND_320))));
	RzILOpPure *op_ADD_325 = ADD(CAST(64, MSB(op_MUL_303), DUP(op_MUL_303)), CAST(64, MSB(op_MUL_323), DUP(op_MUL_323)));
	RzILOpPure *op_LSHIFT_327 = SHIFTL0(op_ADD_325, SN(32, 0));
	RzILOpPure *op_EQ_328 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_LSHIFT_279), SN(32, 0), SN(32, 0x20)), op_LSHIFT_327);
	RzILOpPure *op_RSHIFT_378 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_381 = LOGAND(op_RSHIFT_378, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_387 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_390 = LOGAND(op_RSHIFT_387, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_393 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_381), DUP(op_AND_381))), CAST(16, MSB(DUP(op_AND_381)), DUP(op_AND_381))), CAST(32, MSB(CAST(16, MSB(op_AND_390), DUP(op_AND_390))), CAST(16, MSB(DUP(op_AND_390)), DUP(op_AND_390))));
	RzILOpPure *op_RSHIFT_398 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_401 = LOGAND(op_RSHIFT_398, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_407 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_410 = LOGAND(op_RSHIFT_407, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_413 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_401), DUP(op_AND_401))), CAST(16, MSB(DUP(op_AND_401)), DUP(op_AND_401))), CAST(32, MSB(CAST(16, MSB(op_AND_410), DUP(op_AND_410))), CAST(16, MSB(DUP(op_AND_410)), DUP(op_AND_410))));
	RzILOpPure *op_ADD_415 = ADD(CAST(64, MSB(op_MUL_393), DUP(op_MUL_393)), CAST(64, MSB(op_MUL_413), DUP(op_MUL_413)));
	RzILOpPure *op_LSHIFT_417 = SHIFTL0(op_ADD_415, SN(32, 0));
	RzILOpPure *op_LT_420 = SLT(op_LSHIFT_417, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_425 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_426 = NEG(op_LSHIFT_425);
	RzILOpPure *op_LSHIFT_431 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_434 = SUB(op_LSHIFT_431, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_435 = ITE(op_LT_420, op_NEG_426, op_SUB_434);
	RzILOpEffect *gcc_expr_436 = BRANCH(op_EQ_328, EMPTY(), set_usr_field_call_374);

	// h_tmp372 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_438 = SETL("h_tmp372", cond_435);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_439 = SEQN(2, gcc_expr_436, op_ASSIGN_hybrid_tmp_438);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0)) ? (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0) : h_tmp372) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_231 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_232 = LOGNOT(op_LSHIFT_231);
	RzILOpPure *op_AND_233 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_232);
	RzILOpPure *op_RSHIFT_332 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_335 = LOGAND(op_RSHIFT_332, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_341 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_344 = LOGAND(op_RSHIFT_341, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_347 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_335), DUP(op_AND_335))), CAST(16, MSB(DUP(op_AND_335)), DUP(op_AND_335))), CAST(32, MSB(CAST(16, MSB(op_AND_344), DUP(op_AND_344))), CAST(16, MSB(DUP(op_AND_344)), DUP(op_AND_344))));
	RzILOpPure *op_RSHIFT_352 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_355 = LOGAND(op_RSHIFT_352, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_361 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_364 = LOGAND(op_RSHIFT_361, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_367 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_355), DUP(op_AND_355))), CAST(16, MSB(DUP(op_AND_355)), DUP(op_AND_355))), CAST(32, MSB(CAST(16, MSB(op_AND_364), DUP(op_AND_364))), CAST(16, MSB(DUP(op_AND_364)), DUP(op_AND_364))));
	RzILOpPure *op_ADD_369 = ADD(CAST(64, MSB(op_MUL_347), DUP(op_MUL_347)), CAST(64, MSB(op_MUL_367), DUP(op_MUL_367)));
	RzILOpPure *op_LSHIFT_371 = SHIFTL0(op_ADD_369, SN(32, 0));
	RzILOpPure *cond_440 = ITE(DUP(op_EQ_328), op_LSHIFT_371, VARL("h_tmp372"));
	RzILOpPure *op_AND_442 = LOGAND(cond_440, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_446 = SHIFTL0(op_AND_442, SN(32, 0x20));
	RzILOpPure *op_OR_447 = LOGOR(op_AND_233, op_LSHIFT_446);
	RzILOpEffect *op_ASSIGN_448 = WRITE_REG(bundle, Rdd_op, op_OR_447);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_449 = SEQN(2, seq_439, op_ASSIGN_448);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_225, seq_449);
	return instruction_sequence;
}

// Rdd = vcmpyr(Rss,Rtt):sat
RzILOpEffect *hex_il_op_m2_vcmpy_s0_sat_r(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_150 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rss, SN(32, 0));
	RzILOpPure *op_AND_18 = LOGAND(op_RSHIFT_15, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_25 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_28 = LOGAND(op_RSHIFT_25, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_31 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_18), DUP(op_AND_18))), CAST(16, MSB(DUP(op_AND_18)), DUP(op_AND_18))), CAST(32, MSB(CAST(16, MSB(op_AND_28), DUP(op_AND_28))), CAST(16, MSB(DUP(op_AND_28)), DUP(op_AND_28))));
	RzILOpPure *op_RSHIFT_36 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_39 = LOGAND(op_RSHIFT_36, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_45 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_48 = LOGAND(op_RSHIFT_45, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_51 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_39), DUP(op_AND_39))), CAST(16, MSB(DUP(op_AND_39)), DUP(op_AND_39))), CAST(32, MSB(CAST(16, MSB(op_AND_48), DUP(op_AND_48))), CAST(16, MSB(DUP(op_AND_48)), DUP(op_AND_48))));
	RzILOpPure *op_SUB_53 = SUB(CAST(64, MSB(op_MUL_31), DUP(op_MUL_31)), CAST(64, MSB(op_MUL_51), DUP(op_MUL_51)));
	RzILOpPure *op_LSHIFT_55 = SHIFTL0(op_SUB_53, SN(32, 0));
	RzILOpPure *op_RSHIFT_64 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_67 = LOGAND(op_RSHIFT_64, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_73 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_76 = LOGAND(op_RSHIFT_73, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_79 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_67), DUP(op_AND_67))), CAST(16, MSB(DUP(op_AND_67)), DUP(op_AND_67))), CAST(32, MSB(CAST(16, MSB(op_AND_76), DUP(op_AND_76))), CAST(16, MSB(DUP(op_AND_76)), DUP(op_AND_76))));
	RzILOpPure *op_RSHIFT_84 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_87 = LOGAND(op_RSHIFT_84, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_93 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_96 = LOGAND(op_RSHIFT_93, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_99 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_87), DUP(op_AND_87))), CAST(16, MSB(DUP(op_AND_87)), DUP(op_AND_87))), CAST(32, MSB(CAST(16, MSB(op_AND_96), DUP(op_AND_96))), CAST(16, MSB(DUP(op_AND_96)), DUP(op_AND_96))));
	RzILOpPure *op_SUB_101 = SUB(CAST(64, MSB(op_MUL_79), DUP(op_MUL_79)), CAST(64, MSB(op_MUL_99), DUP(op_MUL_99)));
	RzILOpPure *op_LSHIFT_103 = SHIFTL0(op_SUB_101, SN(32, 0));
	RzILOpPure *op_EQ_104 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_LSHIFT_55), SN(32, 0), SN(32, 0x20)), op_LSHIFT_103);
	RzILOpPure *op_RSHIFT_154 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_157 = LOGAND(op_RSHIFT_154, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_163 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_166 = LOGAND(op_RSHIFT_163, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_169 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_157), DUP(op_AND_157))), CAST(16, MSB(DUP(op_AND_157)), DUP(op_AND_157))), CAST(32, MSB(CAST(16, MSB(op_AND_166), DUP(op_AND_166))), CAST(16, MSB(DUP(op_AND_166)), DUP(op_AND_166))));
	RzILOpPure *op_RSHIFT_174 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_177 = LOGAND(op_RSHIFT_174, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_183 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_186 = LOGAND(op_RSHIFT_183, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_189 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_177), DUP(op_AND_177))), CAST(16, MSB(DUP(op_AND_177)), DUP(op_AND_177))), CAST(32, MSB(CAST(16, MSB(op_AND_186), DUP(op_AND_186))), CAST(16, MSB(DUP(op_AND_186)), DUP(op_AND_186))));
	RzILOpPure *op_SUB_191 = SUB(CAST(64, MSB(op_MUL_169), DUP(op_MUL_169)), CAST(64, MSB(op_MUL_189), DUP(op_MUL_189)));
	RzILOpPure *op_LSHIFT_193 = SHIFTL0(op_SUB_191, SN(32, 0));
	RzILOpPure *op_LT_196 = SLT(op_LSHIFT_193, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_201 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_202 = NEG(op_LSHIFT_201);
	RzILOpPure *op_LSHIFT_207 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_210 = SUB(op_LSHIFT_207, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_211 = ITE(op_LT_196, op_NEG_202, op_SUB_210);
	RzILOpEffect *gcc_expr_212 = BRANCH(op_EQ_104, EMPTY(), set_usr_field_call_150);

	// h_tmp373 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_214 = SETL("h_tmp373", cond_211);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_215 = SEQN(2, gcc_expr_212, op_ASSIGN_hybrid_tmp_214);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0)) ? (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0) : h_tmp373) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_108 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_111 = LOGAND(op_RSHIFT_108, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_117 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_120 = LOGAND(op_RSHIFT_117, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_123 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_111), DUP(op_AND_111))), CAST(16, MSB(DUP(op_AND_111)), DUP(op_AND_111))), CAST(32, MSB(CAST(16, MSB(op_AND_120), DUP(op_AND_120))), CAST(16, MSB(DUP(op_AND_120)), DUP(op_AND_120))));
	RzILOpPure *op_RSHIFT_128 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_131 = LOGAND(op_RSHIFT_128, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_137 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_140 = LOGAND(op_RSHIFT_137, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_143 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_131), DUP(op_AND_131))), CAST(16, MSB(DUP(op_AND_131)), DUP(op_AND_131))), CAST(32, MSB(CAST(16, MSB(op_AND_140), DUP(op_AND_140))), CAST(16, MSB(DUP(op_AND_140)), DUP(op_AND_140))));
	RzILOpPure *op_SUB_145 = SUB(CAST(64, MSB(op_MUL_123), DUP(op_MUL_123)), CAST(64, MSB(op_MUL_143), DUP(op_MUL_143)));
	RzILOpPure *op_LSHIFT_147 = SHIFTL0(op_SUB_145, SN(32, 0));
	RzILOpPure *cond_216 = ITE(DUP(op_EQ_104), op_LSHIFT_147, VARL("h_tmp373"));
	RzILOpPure *op_AND_218 = LOGAND(cond_216, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_222 = SHIFTL0(op_AND_218, SN(32, 0));
	RzILOpPure *op_OR_223 = LOGOR(op_AND_7, op_LSHIFT_222);
	RzILOpEffect *op_ASSIGN_224 = WRITE_REG(bundle, Rdd_op, op_OR_223);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_225 = SEQN(2, seq_215, op_ASSIGN_224);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_374 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_240 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_243 = LOGAND(op_RSHIFT_240, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_249 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_252 = LOGAND(op_RSHIFT_249, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_255 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_243), DUP(op_AND_243))), CAST(16, MSB(DUP(op_AND_243)), DUP(op_AND_243))), CAST(32, MSB(CAST(16, MSB(op_AND_252), DUP(op_AND_252))), CAST(16, MSB(DUP(op_AND_252)), DUP(op_AND_252))));
	RzILOpPure *op_RSHIFT_260 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_263 = LOGAND(op_RSHIFT_260, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_269 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_272 = LOGAND(op_RSHIFT_269, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_275 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_263), DUP(op_AND_263))), CAST(16, MSB(DUP(op_AND_263)), DUP(op_AND_263))), CAST(32, MSB(CAST(16, MSB(op_AND_272), DUP(op_AND_272))), CAST(16, MSB(DUP(op_AND_272)), DUP(op_AND_272))));
	RzILOpPure *op_SUB_277 = SUB(CAST(64, MSB(op_MUL_255), DUP(op_MUL_255)), CAST(64, MSB(op_MUL_275), DUP(op_MUL_275)));
	RzILOpPure *op_LSHIFT_279 = SHIFTL0(op_SUB_277, SN(32, 0));
	RzILOpPure *op_RSHIFT_288 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_291 = LOGAND(op_RSHIFT_288, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_297 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_300 = LOGAND(op_RSHIFT_297, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_303 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_291), DUP(op_AND_291))), CAST(16, MSB(DUP(op_AND_291)), DUP(op_AND_291))), CAST(32, MSB(CAST(16, MSB(op_AND_300), DUP(op_AND_300))), CAST(16, MSB(DUP(op_AND_300)), DUP(op_AND_300))));
	RzILOpPure *op_RSHIFT_308 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_311 = LOGAND(op_RSHIFT_308, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_317 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_320 = LOGAND(op_RSHIFT_317, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_323 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_311), DUP(op_AND_311))), CAST(16, MSB(DUP(op_AND_311)), DUP(op_AND_311))), CAST(32, MSB(CAST(16, MSB(op_AND_320), DUP(op_AND_320))), CAST(16, MSB(DUP(op_AND_320)), DUP(op_AND_320))));
	RzILOpPure *op_SUB_325 = SUB(CAST(64, MSB(op_MUL_303), DUP(op_MUL_303)), CAST(64, MSB(op_MUL_323), DUP(op_MUL_323)));
	RzILOpPure *op_LSHIFT_327 = SHIFTL0(op_SUB_325, SN(32, 0));
	RzILOpPure *op_EQ_328 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_LSHIFT_279), SN(32, 0), SN(32, 0x20)), op_LSHIFT_327);
	RzILOpPure *op_RSHIFT_378 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_381 = LOGAND(op_RSHIFT_378, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_387 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_390 = LOGAND(op_RSHIFT_387, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_393 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_381), DUP(op_AND_381))), CAST(16, MSB(DUP(op_AND_381)), DUP(op_AND_381))), CAST(32, MSB(CAST(16, MSB(op_AND_390), DUP(op_AND_390))), CAST(16, MSB(DUP(op_AND_390)), DUP(op_AND_390))));
	RzILOpPure *op_RSHIFT_398 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_401 = LOGAND(op_RSHIFT_398, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_407 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_410 = LOGAND(op_RSHIFT_407, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_413 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_401), DUP(op_AND_401))), CAST(16, MSB(DUP(op_AND_401)), DUP(op_AND_401))), CAST(32, MSB(CAST(16, MSB(op_AND_410), DUP(op_AND_410))), CAST(16, MSB(DUP(op_AND_410)), DUP(op_AND_410))));
	RzILOpPure *op_SUB_415 = SUB(CAST(64, MSB(op_MUL_393), DUP(op_MUL_393)), CAST(64, MSB(op_MUL_413), DUP(op_MUL_413)));
	RzILOpPure *op_LSHIFT_417 = SHIFTL0(op_SUB_415, SN(32, 0));
	RzILOpPure *op_LT_420 = SLT(op_LSHIFT_417, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_425 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_426 = NEG(op_LSHIFT_425);
	RzILOpPure *op_LSHIFT_431 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_434 = SUB(op_LSHIFT_431, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_435 = ITE(op_LT_420, op_NEG_426, op_SUB_434);
	RzILOpEffect *gcc_expr_436 = BRANCH(op_EQ_328, EMPTY(), set_usr_field_call_374);

	// h_tmp374 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_438 = SETL("h_tmp374", cond_435);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_439 = SEQN(2, gcc_expr_436, op_ASSIGN_hybrid_tmp_438);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0)) ? (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0) : h_tmp374) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_231 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_232 = LOGNOT(op_LSHIFT_231);
	RzILOpPure *op_AND_233 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_232);
	RzILOpPure *op_RSHIFT_332 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_335 = LOGAND(op_RSHIFT_332, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_341 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_344 = LOGAND(op_RSHIFT_341, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_347 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_335), DUP(op_AND_335))), CAST(16, MSB(DUP(op_AND_335)), DUP(op_AND_335))), CAST(32, MSB(CAST(16, MSB(op_AND_344), DUP(op_AND_344))), CAST(16, MSB(DUP(op_AND_344)), DUP(op_AND_344))));
	RzILOpPure *op_RSHIFT_352 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_355 = LOGAND(op_RSHIFT_352, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_361 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_364 = LOGAND(op_RSHIFT_361, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_367 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_355), DUP(op_AND_355))), CAST(16, MSB(DUP(op_AND_355)), DUP(op_AND_355))), CAST(32, MSB(CAST(16, MSB(op_AND_364), DUP(op_AND_364))), CAST(16, MSB(DUP(op_AND_364)), DUP(op_AND_364))));
	RzILOpPure *op_SUB_369 = SUB(CAST(64, MSB(op_MUL_347), DUP(op_MUL_347)), CAST(64, MSB(op_MUL_367), DUP(op_MUL_367)));
	RzILOpPure *op_LSHIFT_371 = SHIFTL0(op_SUB_369, SN(32, 0));
	RzILOpPure *cond_440 = ITE(DUP(op_EQ_328), op_LSHIFT_371, VARL("h_tmp374"));
	RzILOpPure *op_AND_442 = LOGAND(cond_440, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_446 = SHIFTL0(op_AND_442, SN(32, 0x20));
	RzILOpPure *op_OR_447 = LOGOR(op_AND_233, op_LSHIFT_446);
	RzILOpEffect *op_ASSIGN_448 = WRITE_REG(bundle, Rdd_op, op_OR_447);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_449 = SEQN(2, seq_439, op_ASSIGN_448);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_225, seq_449);
	return instruction_sequence;
}

// Rdd = vcmpyi(Rss,Rtt):<<1:sat
RzILOpEffect *hex_il_op_m2_vcmpy_s1_sat_i(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_150 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rss, SN(32, 16));
	RzILOpPure *op_AND_18 = LOGAND(op_RSHIFT_15, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_25 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_28 = LOGAND(op_RSHIFT_25, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_31 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_18), DUP(op_AND_18))), CAST(16, MSB(DUP(op_AND_18)), DUP(op_AND_18))), CAST(32, MSB(CAST(16, MSB(op_AND_28), DUP(op_AND_28))), CAST(16, MSB(DUP(op_AND_28)), DUP(op_AND_28))));
	RzILOpPure *op_RSHIFT_36 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_39 = LOGAND(op_RSHIFT_36, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_45 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_48 = LOGAND(op_RSHIFT_45, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_51 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_39), DUP(op_AND_39))), CAST(16, MSB(DUP(op_AND_39)), DUP(op_AND_39))), CAST(32, MSB(CAST(16, MSB(op_AND_48), DUP(op_AND_48))), CAST(16, MSB(DUP(op_AND_48)), DUP(op_AND_48))));
	RzILOpPure *op_ADD_53 = ADD(CAST(64, MSB(op_MUL_31), DUP(op_MUL_31)), CAST(64, MSB(op_MUL_51), DUP(op_MUL_51)));
	RzILOpPure *op_LSHIFT_55 = SHIFTL0(op_ADD_53, SN(32, 1));
	RzILOpPure *op_RSHIFT_64 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_67 = LOGAND(op_RSHIFT_64, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_73 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_76 = LOGAND(op_RSHIFT_73, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_79 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_67), DUP(op_AND_67))), CAST(16, MSB(DUP(op_AND_67)), DUP(op_AND_67))), CAST(32, MSB(CAST(16, MSB(op_AND_76), DUP(op_AND_76))), CAST(16, MSB(DUP(op_AND_76)), DUP(op_AND_76))));
	RzILOpPure *op_RSHIFT_84 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_87 = LOGAND(op_RSHIFT_84, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_93 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_96 = LOGAND(op_RSHIFT_93, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_99 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_87), DUP(op_AND_87))), CAST(16, MSB(DUP(op_AND_87)), DUP(op_AND_87))), CAST(32, MSB(CAST(16, MSB(op_AND_96), DUP(op_AND_96))), CAST(16, MSB(DUP(op_AND_96)), DUP(op_AND_96))));
	RzILOpPure *op_ADD_101 = ADD(CAST(64, MSB(op_MUL_79), DUP(op_MUL_79)), CAST(64, MSB(op_MUL_99), DUP(op_MUL_99)));
	RzILOpPure *op_LSHIFT_103 = SHIFTL0(op_ADD_101, SN(32, 1));
	RzILOpPure *op_EQ_104 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_LSHIFT_55), SN(32, 0), SN(32, 0x20)), op_LSHIFT_103);
	RzILOpPure *op_RSHIFT_154 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_157 = LOGAND(op_RSHIFT_154, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_163 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_166 = LOGAND(op_RSHIFT_163, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_169 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_157), DUP(op_AND_157))), CAST(16, MSB(DUP(op_AND_157)), DUP(op_AND_157))), CAST(32, MSB(CAST(16, MSB(op_AND_166), DUP(op_AND_166))), CAST(16, MSB(DUP(op_AND_166)), DUP(op_AND_166))));
	RzILOpPure *op_RSHIFT_174 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_177 = LOGAND(op_RSHIFT_174, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_183 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_186 = LOGAND(op_RSHIFT_183, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_189 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_177), DUP(op_AND_177))), CAST(16, MSB(DUP(op_AND_177)), DUP(op_AND_177))), CAST(32, MSB(CAST(16, MSB(op_AND_186), DUP(op_AND_186))), CAST(16, MSB(DUP(op_AND_186)), DUP(op_AND_186))));
	RzILOpPure *op_ADD_191 = ADD(CAST(64, MSB(op_MUL_169), DUP(op_MUL_169)), CAST(64, MSB(op_MUL_189), DUP(op_MUL_189)));
	RzILOpPure *op_LSHIFT_193 = SHIFTL0(op_ADD_191, SN(32, 1));
	RzILOpPure *op_LT_196 = SLT(op_LSHIFT_193, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_201 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_202 = NEG(op_LSHIFT_201);
	RzILOpPure *op_LSHIFT_207 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_210 = SUB(op_LSHIFT_207, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_211 = ITE(op_LT_196, op_NEG_202, op_SUB_210);
	RzILOpEffect *gcc_expr_212 = BRANCH(op_EQ_104, EMPTY(), set_usr_field_call_150);

	// h_tmp375 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_214 = SETL("h_tmp375", cond_211);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_215 = SEQN(2, gcc_expr_212, op_ASSIGN_hybrid_tmp_214);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1)) ? (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1) : h_tmp375) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_108 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_111 = LOGAND(op_RSHIFT_108, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_117 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_120 = LOGAND(op_RSHIFT_117, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_123 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_111), DUP(op_AND_111))), CAST(16, MSB(DUP(op_AND_111)), DUP(op_AND_111))), CAST(32, MSB(CAST(16, MSB(op_AND_120), DUP(op_AND_120))), CAST(16, MSB(DUP(op_AND_120)), DUP(op_AND_120))));
	RzILOpPure *op_RSHIFT_128 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_131 = LOGAND(op_RSHIFT_128, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_137 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_140 = LOGAND(op_RSHIFT_137, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_143 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_131), DUP(op_AND_131))), CAST(16, MSB(DUP(op_AND_131)), DUP(op_AND_131))), CAST(32, MSB(CAST(16, MSB(op_AND_140), DUP(op_AND_140))), CAST(16, MSB(DUP(op_AND_140)), DUP(op_AND_140))));
	RzILOpPure *op_ADD_145 = ADD(CAST(64, MSB(op_MUL_123), DUP(op_MUL_123)), CAST(64, MSB(op_MUL_143), DUP(op_MUL_143)));
	RzILOpPure *op_LSHIFT_147 = SHIFTL0(op_ADD_145, SN(32, 1));
	RzILOpPure *cond_216 = ITE(DUP(op_EQ_104), op_LSHIFT_147, VARL("h_tmp375"));
	RzILOpPure *op_AND_218 = LOGAND(cond_216, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_222 = SHIFTL0(op_AND_218, SN(32, 0));
	RzILOpPure *op_OR_223 = LOGOR(op_AND_7, op_LSHIFT_222);
	RzILOpEffect *op_ASSIGN_224 = WRITE_REG(bundle, Rdd_op, op_OR_223);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_225 = SEQN(2, seq_215, op_ASSIGN_224);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_374 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_240 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_243 = LOGAND(op_RSHIFT_240, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_249 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_252 = LOGAND(op_RSHIFT_249, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_255 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_243), DUP(op_AND_243))), CAST(16, MSB(DUP(op_AND_243)), DUP(op_AND_243))), CAST(32, MSB(CAST(16, MSB(op_AND_252), DUP(op_AND_252))), CAST(16, MSB(DUP(op_AND_252)), DUP(op_AND_252))));
	RzILOpPure *op_RSHIFT_260 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_263 = LOGAND(op_RSHIFT_260, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_269 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_272 = LOGAND(op_RSHIFT_269, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_275 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_263), DUP(op_AND_263))), CAST(16, MSB(DUP(op_AND_263)), DUP(op_AND_263))), CAST(32, MSB(CAST(16, MSB(op_AND_272), DUP(op_AND_272))), CAST(16, MSB(DUP(op_AND_272)), DUP(op_AND_272))));
	RzILOpPure *op_ADD_277 = ADD(CAST(64, MSB(op_MUL_255), DUP(op_MUL_255)), CAST(64, MSB(op_MUL_275), DUP(op_MUL_275)));
	RzILOpPure *op_LSHIFT_279 = SHIFTL0(op_ADD_277, SN(32, 1));
	RzILOpPure *op_RSHIFT_288 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_291 = LOGAND(op_RSHIFT_288, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_297 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_300 = LOGAND(op_RSHIFT_297, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_303 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_291), DUP(op_AND_291))), CAST(16, MSB(DUP(op_AND_291)), DUP(op_AND_291))), CAST(32, MSB(CAST(16, MSB(op_AND_300), DUP(op_AND_300))), CAST(16, MSB(DUP(op_AND_300)), DUP(op_AND_300))));
	RzILOpPure *op_RSHIFT_308 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_311 = LOGAND(op_RSHIFT_308, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_317 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_320 = LOGAND(op_RSHIFT_317, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_323 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_311), DUP(op_AND_311))), CAST(16, MSB(DUP(op_AND_311)), DUP(op_AND_311))), CAST(32, MSB(CAST(16, MSB(op_AND_320), DUP(op_AND_320))), CAST(16, MSB(DUP(op_AND_320)), DUP(op_AND_320))));
	RzILOpPure *op_ADD_325 = ADD(CAST(64, MSB(op_MUL_303), DUP(op_MUL_303)), CAST(64, MSB(op_MUL_323), DUP(op_MUL_323)));
	RzILOpPure *op_LSHIFT_327 = SHIFTL0(op_ADD_325, SN(32, 1));
	RzILOpPure *op_EQ_328 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_LSHIFT_279), SN(32, 0), SN(32, 0x20)), op_LSHIFT_327);
	RzILOpPure *op_RSHIFT_378 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_381 = LOGAND(op_RSHIFT_378, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_387 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_390 = LOGAND(op_RSHIFT_387, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_393 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_381), DUP(op_AND_381))), CAST(16, MSB(DUP(op_AND_381)), DUP(op_AND_381))), CAST(32, MSB(CAST(16, MSB(op_AND_390), DUP(op_AND_390))), CAST(16, MSB(DUP(op_AND_390)), DUP(op_AND_390))));
	RzILOpPure *op_RSHIFT_398 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_401 = LOGAND(op_RSHIFT_398, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_407 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_410 = LOGAND(op_RSHIFT_407, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_413 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_401), DUP(op_AND_401))), CAST(16, MSB(DUP(op_AND_401)), DUP(op_AND_401))), CAST(32, MSB(CAST(16, MSB(op_AND_410), DUP(op_AND_410))), CAST(16, MSB(DUP(op_AND_410)), DUP(op_AND_410))));
	RzILOpPure *op_ADD_415 = ADD(CAST(64, MSB(op_MUL_393), DUP(op_MUL_393)), CAST(64, MSB(op_MUL_413), DUP(op_MUL_413)));
	RzILOpPure *op_LSHIFT_417 = SHIFTL0(op_ADD_415, SN(32, 1));
	RzILOpPure *op_LT_420 = SLT(op_LSHIFT_417, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_425 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_426 = NEG(op_LSHIFT_425);
	RzILOpPure *op_LSHIFT_431 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_434 = SUB(op_LSHIFT_431, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_435 = ITE(op_LT_420, op_NEG_426, op_SUB_434);
	RzILOpEffect *gcc_expr_436 = BRANCH(op_EQ_328, EMPTY(), set_usr_field_call_374);

	// h_tmp376 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_438 = SETL("h_tmp376", cond_435);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_439 = SEQN(2, gcc_expr_436, op_ASSIGN_hybrid_tmp_438);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1)) ? (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1) : h_tmp376) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_231 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_232 = LOGNOT(op_LSHIFT_231);
	RzILOpPure *op_AND_233 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_232);
	RzILOpPure *op_RSHIFT_332 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_335 = LOGAND(op_RSHIFT_332, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_341 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_344 = LOGAND(op_RSHIFT_341, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_347 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_335), DUP(op_AND_335))), CAST(16, MSB(DUP(op_AND_335)), DUP(op_AND_335))), CAST(32, MSB(CAST(16, MSB(op_AND_344), DUP(op_AND_344))), CAST(16, MSB(DUP(op_AND_344)), DUP(op_AND_344))));
	RzILOpPure *op_RSHIFT_352 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_355 = LOGAND(op_RSHIFT_352, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_361 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_364 = LOGAND(op_RSHIFT_361, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_367 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_355), DUP(op_AND_355))), CAST(16, MSB(DUP(op_AND_355)), DUP(op_AND_355))), CAST(32, MSB(CAST(16, MSB(op_AND_364), DUP(op_AND_364))), CAST(16, MSB(DUP(op_AND_364)), DUP(op_AND_364))));
	RzILOpPure *op_ADD_369 = ADD(CAST(64, MSB(op_MUL_347), DUP(op_MUL_347)), CAST(64, MSB(op_MUL_367), DUP(op_MUL_367)));
	RzILOpPure *op_LSHIFT_371 = SHIFTL0(op_ADD_369, SN(32, 1));
	RzILOpPure *cond_440 = ITE(DUP(op_EQ_328), op_LSHIFT_371, VARL("h_tmp376"));
	RzILOpPure *op_AND_442 = LOGAND(cond_440, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_446 = SHIFTL0(op_AND_442, SN(32, 0x20));
	RzILOpPure *op_OR_447 = LOGOR(op_AND_233, op_LSHIFT_446);
	RzILOpEffect *op_ASSIGN_448 = WRITE_REG(bundle, Rdd_op, op_OR_447);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_449 = SEQN(2, seq_439, op_ASSIGN_448);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_225, seq_449);
	return instruction_sequence;
}

// Rdd = vcmpyr(Rss,Rtt):<<1:sat
RzILOpEffect *hex_il_op_m2_vcmpy_s1_sat_r(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_150 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rss, SN(32, 0));
	RzILOpPure *op_AND_18 = LOGAND(op_RSHIFT_15, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_25 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_28 = LOGAND(op_RSHIFT_25, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_31 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_18), DUP(op_AND_18))), CAST(16, MSB(DUP(op_AND_18)), DUP(op_AND_18))), CAST(32, MSB(CAST(16, MSB(op_AND_28), DUP(op_AND_28))), CAST(16, MSB(DUP(op_AND_28)), DUP(op_AND_28))));
	RzILOpPure *op_RSHIFT_36 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_39 = LOGAND(op_RSHIFT_36, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_45 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_48 = LOGAND(op_RSHIFT_45, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_51 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_39), DUP(op_AND_39))), CAST(16, MSB(DUP(op_AND_39)), DUP(op_AND_39))), CAST(32, MSB(CAST(16, MSB(op_AND_48), DUP(op_AND_48))), CAST(16, MSB(DUP(op_AND_48)), DUP(op_AND_48))));
	RzILOpPure *op_SUB_53 = SUB(CAST(64, MSB(op_MUL_31), DUP(op_MUL_31)), CAST(64, MSB(op_MUL_51), DUP(op_MUL_51)));
	RzILOpPure *op_LSHIFT_55 = SHIFTL0(op_SUB_53, SN(32, 1));
	RzILOpPure *op_RSHIFT_64 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_67 = LOGAND(op_RSHIFT_64, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_73 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_76 = LOGAND(op_RSHIFT_73, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_79 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_67), DUP(op_AND_67))), CAST(16, MSB(DUP(op_AND_67)), DUP(op_AND_67))), CAST(32, MSB(CAST(16, MSB(op_AND_76), DUP(op_AND_76))), CAST(16, MSB(DUP(op_AND_76)), DUP(op_AND_76))));
	RzILOpPure *op_RSHIFT_84 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_87 = LOGAND(op_RSHIFT_84, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_93 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_96 = LOGAND(op_RSHIFT_93, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_99 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_87), DUP(op_AND_87))), CAST(16, MSB(DUP(op_AND_87)), DUP(op_AND_87))), CAST(32, MSB(CAST(16, MSB(op_AND_96), DUP(op_AND_96))), CAST(16, MSB(DUP(op_AND_96)), DUP(op_AND_96))));
	RzILOpPure *op_SUB_101 = SUB(CAST(64, MSB(op_MUL_79), DUP(op_MUL_79)), CAST(64, MSB(op_MUL_99), DUP(op_MUL_99)));
	RzILOpPure *op_LSHIFT_103 = SHIFTL0(op_SUB_101, SN(32, 1));
	RzILOpPure *op_EQ_104 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_LSHIFT_55), SN(32, 0), SN(32, 0x20)), op_LSHIFT_103);
	RzILOpPure *op_RSHIFT_154 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_157 = LOGAND(op_RSHIFT_154, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_163 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_166 = LOGAND(op_RSHIFT_163, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_169 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_157), DUP(op_AND_157))), CAST(16, MSB(DUP(op_AND_157)), DUP(op_AND_157))), CAST(32, MSB(CAST(16, MSB(op_AND_166), DUP(op_AND_166))), CAST(16, MSB(DUP(op_AND_166)), DUP(op_AND_166))));
	RzILOpPure *op_RSHIFT_174 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_177 = LOGAND(op_RSHIFT_174, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_183 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_186 = LOGAND(op_RSHIFT_183, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_189 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_177), DUP(op_AND_177))), CAST(16, MSB(DUP(op_AND_177)), DUP(op_AND_177))), CAST(32, MSB(CAST(16, MSB(op_AND_186), DUP(op_AND_186))), CAST(16, MSB(DUP(op_AND_186)), DUP(op_AND_186))));
	RzILOpPure *op_SUB_191 = SUB(CAST(64, MSB(op_MUL_169), DUP(op_MUL_169)), CAST(64, MSB(op_MUL_189), DUP(op_MUL_189)));
	RzILOpPure *op_LSHIFT_193 = SHIFTL0(op_SUB_191, SN(32, 1));
	RzILOpPure *op_LT_196 = SLT(op_LSHIFT_193, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_201 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_202 = NEG(op_LSHIFT_201);
	RzILOpPure *op_LSHIFT_207 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_210 = SUB(op_LSHIFT_207, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_211 = ITE(op_LT_196, op_NEG_202, op_SUB_210);
	RzILOpEffect *gcc_expr_212 = BRANCH(op_EQ_104, EMPTY(), set_usr_field_call_150);

	// h_tmp377 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_214 = SETL("h_tmp377", cond_211);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_215 = SEQN(2, gcc_expr_212, op_ASSIGN_hybrid_tmp_214);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1)) ? (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1) : h_tmp377) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_108 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_111 = LOGAND(op_RSHIFT_108, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_117 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_120 = LOGAND(op_RSHIFT_117, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_123 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_111), DUP(op_AND_111))), CAST(16, MSB(DUP(op_AND_111)), DUP(op_AND_111))), CAST(32, MSB(CAST(16, MSB(op_AND_120), DUP(op_AND_120))), CAST(16, MSB(DUP(op_AND_120)), DUP(op_AND_120))));
	RzILOpPure *op_RSHIFT_128 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_131 = LOGAND(op_RSHIFT_128, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_137 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_140 = LOGAND(op_RSHIFT_137, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_143 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_131), DUP(op_AND_131))), CAST(16, MSB(DUP(op_AND_131)), DUP(op_AND_131))), CAST(32, MSB(CAST(16, MSB(op_AND_140), DUP(op_AND_140))), CAST(16, MSB(DUP(op_AND_140)), DUP(op_AND_140))));
	RzILOpPure *op_SUB_145 = SUB(CAST(64, MSB(op_MUL_123), DUP(op_MUL_123)), CAST(64, MSB(op_MUL_143), DUP(op_MUL_143)));
	RzILOpPure *op_LSHIFT_147 = SHIFTL0(op_SUB_145, SN(32, 1));
	RzILOpPure *cond_216 = ITE(DUP(op_EQ_104), op_LSHIFT_147, VARL("h_tmp377"));
	RzILOpPure *op_AND_218 = LOGAND(cond_216, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_222 = SHIFTL0(op_AND_218, SN(32, 0));
	RzILOpPure *op_OR_223 = LOGOR(op_AND_7, op_LSHIFT_222);
	RzILOpEffect *op_ASSIGN_224 = WRITE_REG(bundle, Rdd_op, op_OR_223);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_225 = SEQN(2, seq_215, op_ASSIGN_224);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_374 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_240 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_243 = LOGAND(op_RSHIFT_240, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_249 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_252 = LOGAND(op_RSHIFT_249, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_255 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_243), DUP(op_AND_243))), CAST(16, MSB(DUP(op_AND_243)), DUP(op_AND_243))), CAST(32, MSB(CAST(16, MSB(op_AND_252), DUP(op_AND_252))), CAST(16, MSB(DUP(op_AND_252)), DUP(op_AND_252))));
	RzILOpPure *op_RSHIFT_260 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_263 = LOGAND(op_RSHIFT_260, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_269 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_272 = LOGAND(op_RSHIFT_269, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_275 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_263), DUP(op_AND_263))), CAST(16, MSB(DUP(op_AND_263)), DUP(op_AND_263))), CAST(32, MSB(CAST(16, MSB(op_AND_272), DUP(op_AND_272))), CAST(16, MSB(DUP(op_AND_272)), DUP(op_AND_272))));
	RzILOpPure *op_SUB_277 = SUB(CAST(64, MSB(op_MUL_255), DUP(op_MUL_255)), CAST(64, MSB(op_MUL_275), DUP(op_MUL_275)));
	RzILOpPure *op_LSHIFT_279 = SHIFTL0(op_SUB_277, SN(32, 1));
	RzILOpPure *op_RSHIFT_288 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_291 = LOGAND(op_RSHIFT_288, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_297 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_300 = LOGAND(op_RSHIFT_297, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_303 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_291), DUP(op_AND_291))), CAST(16, MSB(DUP(op_AND_291)), DUP(op_AND_291))), CAST(32, MSB(CAST(16, MSB(op_AND_300), DUP(op_AND_300))), CAST(16, MSB(DUP(op_AND_300)), DUP(op_AND_300))));
	RzILOpPure *op_RSHIFT_308 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_311 = LOGAND(op_RSHIFT_308, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_317 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_320 = LOGAND(op_RSHIFT_317, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_323 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_311), DUP(op_AND_311))), CAST(16, MSB(DUP(op_AND_311)), DUP(op_AND_311))), CAST(32, MSB(CAST(16, MSB(op_AND_320), DUP(op_AND_320))), CAST(16, MSB(DUP(op_AND_320)), DUP(op_AND_320))));
	RzILOpPure *op_SUB_325 = SUB(CAST(64, MSB(op_MUL_303), DUP(op_MUL_303)), CAST(64, MSB(op_MUL_323), DUP(op_MUL_323)));
	RzILOpPure *op_LSHIFT_327 = SHIFTL0(op_SUB_325, SN(32, 1));
	RzILOpPure *op_EQ_328 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_LSHIFT_279), SN(32, 0), SN(32, 0x20)), op_LSHIFT_327);
	RzILOpPure *op_RSHIFT_378 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_381 = LOGAND(op_RSHIFT_378, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_387 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_390 = LOGAND(op_RSHIFT_387, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_393 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_381), DUP(op_AND_381))), CAST(16, MSB(DUP(op_AND_381)), DUP(op_AND_381))), CAST(32, MSB(CAST(16, MSB(op_AND_390), DUP(op_AND_390))), CAST(16, MSB(DUP(op_AND_390)), DUP(op_AND_390))));
	RzILOpPure *op_RSHIFT_398 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_401 = LOGAND(op_RSHIFT_398, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_407 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_410 = LOGAND(op_RSHIFT_407, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_413 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_401), DUP(op_AND_401))), CAST(16, MSB(DUP(op_AND_401)), DUP(op_AND_401))), CAST(32, MSB(CAST(16, MSB(op_AND_410), DUP(op_AND_410))), CAST(16, MSB(DUP(op_AND_410)), DUP(op_AND_410))));
	RzILOpPure *op_SUB_415 = SUB(CAST(64, MSB(op_MUL_393), DUP(op_MUL_393)), CAST(64, MSB(op_MUL_413), DUP(op_MUL_413)));
	RzILOpPure *op_LSHIFT_417 = SHIFTL0(op_SUB_415, SN(32, 1));
	RzILOpPure *op_LT_420 = SLT(op_LSHIFT_417, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_425 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_426 = NEG(op_LSHIFT_425);
	RzILOpPure *op_LSHIFT_431 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_434 = SUB(op_LSHIFT_431, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_435 = ITE(op_LT_420, op_NEG_426, op_SUB_434);
	RzILOpEffect *gcc_expr_436 = BRANCH(op_EQ_328, EMPTY(), set_usr_field_call_374);

	// h_tmp378 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_438 = SETL("h_tmp378", cond_435);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_439 = SEQN(2, gcc_expr_436, op_ASSIGN_hybrid_tmp_438);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1)) ? (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1) : h_tmp378) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_231 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_232 = LOGNOT(op_LSHIFT_231);
	RzILOpPure *op_AND_233 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_232);
	RzILOpPure *op_RSHIFT_332 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_335 = LOGAND(op_RSHIFT_332, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_341 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_344 = LOGAND(op_RSHIFT_341, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_347 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_335), DUP(op_AND_335))), CAST(16, MSB(DUP(op_AND_335)), DUP(op_AND_335))), CAST(32, MSB(CAST(16, MSB(op_AND_344), DUP(op_AND_344))), CAST(16, MSB(DUP(op_AND_344)), DUP(op_AND_344))));
	RzILOpPure *op_RSHIFT_352 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_355 = LOGAND(op_RSHIFT_352, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_361 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_364 = LOGAND(op_RSHIFT_361, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_367 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_355), DUP(op_AND_355))), CAST(16, MSB(DUP(op_AND_355)), DUP(op_AND_355))), CAST(32, MSB(CAST(16, MSB(op_AND_364), DUP(op_AND_364))), CAST(16, MSB(DUP(op_AND_364)), DUP(op_AND_364))));
	RzILOpPure *op_SUB_369 = SUB(CAST(64, MSB(op_MUL_347), DUP(op_MUL_347)), CAST(64, MSB(op_MUL_367), DUP(op_MUL_367)));
	RzILOpPure *op_LSHIFT_371 = SHIFTL0(op_SUB_369, SN(32, 1));
	RzILOpPure *cond_440 = ITE(DUP(op_EQ_328), op_LSHIFT_371, VARL("h_tmp378"));
	RzILOpPure *op_AND_442 = LOGAND(cond_440, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_446 = SHIFTL0(op_AND_442, SN(32, 0x20));
	RzILOpPure *op_OR_447 = LOGOR(op_AND_233, op_LSHIFT_446);
	RzILOpEffect *op_ASSIGN_448 = WRITE_REG(bundle, Rdd_op, op_OR_447);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_449 = SEQN(2, seq_439, op_ASSIGN_448);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_225, seq_449);
	return instruction_sequence;
}

// Rxx += vdmpy(Rss,Rtt):sat
RzILOpEffect *hex_il_op_m2_vdmacs_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_183 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rss, SN(32, 0));
	RzILOpPure *op_AND_26 = LOGAND(op_RSHIFT_23, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_33 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_36 = LOGAND(op_RSHIFT_33, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_39 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_26), DUP(op_AND_26))), CAST(16, MSB(DUP(op_AND_26)), DUP(op_AND_26))), CAST(32, MSB(CAST(16, MSB(op_AND_36), DUP(op_AND_36))), CAST(16, MSB(DUP(op_AND_36)), DUP(op_AND_36))));
	RzILOpPure *op_LSHIFT_42 = SHIFTL0(CAST(64, MSB(op_MUL_39), DUP(op_MUL_39)), SN(32, 0));
	RzILOpPure *op_ADD_43 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_LSHIFT_42);
	RzILOpPure *op_RSHIFT_47 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_50 = LOGAND(op_RSHIFT_47, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_56 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_59 = LOGAND(op_RSHIFT_56, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_62 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_50), DUP(op_AND_50))), CAST(16, MSB(DUP(op_AND_50)), DUP(op_AND_50))), CAST(32, MSB(CAST(16, MSB(op_AND_59), DUP(op_AND_59))), CAST(16, MSB(DUP(op_AND_59)), DUP(op_AND_59))));
	RzILOpPure *op_LSHIFT_65 = SHIFTL0(CAST(64, MSB(op_MUL_62), DUP(op_MUL_62)), SN(32, 0));
	RzILOpPure *op_ADD_66 = ADD(op_ADD_43, op_LSHIFT_65);
	RzILOpPure *op_RSHIFT_75 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_77 = LOGAND(op_RSHIFT_75, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_83 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_86 = LOGAND(op_RSHIFT_83, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_92 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_95 = LOGAND(op_RSHIFT_92, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_98 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_86), DUP(op_AND_86))), CAST(16, MSB(DUP(op_AND_86)), DUP(op_AND_86))), CAST(32, MSB(CAST(16, MSB(op_AND_95), DUP(op_AND_95))), CAST(16, MSB(DUP(op_AND_95)), DUP(op_AND_95))));
	RzILOpPure *op_LSHIFT_101 = SHIFTL0(CAST(64, MSB(op_MUL_98), DUP(op_MUL_98)), SN(32, 0));
	RzILOpPure *op_ADD_102 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_77), DUP(op_AND_77))), CAST(32, MSB(DUP(op_AND_77)), DUP(op_AND_77))), op_LSHIFT_101);
	RzILOpPure *op_RSHIFT_106 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_109 = LOGAND(op_RSHIFT_106, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_115 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_118 = LOGAND(op_RSHIFT_115, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_121 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_109), DUP(op_AND_109))), CAST(16, MSB(DUP(op_AND_109)), DUP(op_AND_109))), CAST(32, MSB(CAST(16, MSB(op_AND_118), DUP(op_AND_118))), CAST(16, MSB(DUP(op_AND_118)), DUP(op_AND_118))));
	RzILOpPure *op_LSHIFT_124 = SHIFTL0(CAST(64, MSB(op_MUL_121), DUP(op_MUL_121)), SN(32, 0));
	RzILOpPure *op_ADD_125 = ADD(op_ADD_102, op_LSHIFT_124);
	RzILOpPure *op_EQ_126 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_66), SN(32, 0), SN(32, 0x20)), op_ADD_125);
	RzILOpPure *op_RSHIFT_187 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_189 = LOGAND(op_RSHIFT_187, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_195 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_198 = LOGAND(op_RSHIFT_195, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_204 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_207 = LOGAND(op_RSHIFT_204, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_210 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_198), DUP(op_AND_198))), CAST(16, MSB(DUP(op_AND_198)), DUP(op_AND_198))), CAST(32, MSB(CAST(16, MSB(op_AND_207), DUP(op_AND_207))), CAST(16, MSB(DUP(op_AND_207)), DUP(op_AND_207))));
	RzILOpPure *op_LSHIFT_213 = SHIFTL0(CAST(64, MSB(op_MUL_210), DUP(op_MUL_210)), SN(32, 0));
	RzILOpPure *op_ADD_214 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_189), DUP(op_AND_189))), CAST(32, MSB(DUP(op_AND_189)), DUP(op_AND_189))), op_LSHIFT_213);
	RzILOpPure *op_RSHIFT_218 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_221 = LOGAND(op_RSHIFT_218, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_227 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_230 = LOGAND(op_RSHIFT_227, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_233 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_221), DUP(op_AND_221))), CAST(16, MSB(DUP(op_AND_221)), DUP(op_AND_221))), CAST(32, MSB(CAST(16, MSB(op_AND_230), DUP(op_AND_230))), CAST(16, MSB(DUP(op_AND_230)), DUP(op_AND_230))));
	RzILOpPure *op_LSHIFT_236 = SHIFTL0(CAST(64, MSB(op_MUL_233), DUP(op_MUL_233)), SN(32, 0));
	RzILOpPure *op_ADD_237 = ADD(op_ADD_214, op_LSHIFT_236);
	RzILOpPure *op_LT_240 = SLT(op_ADD_237, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_245 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_246 = NEG(op_LSHIFT_245);
	RzILOpPure *op_LSHIFT_251 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_254 = SUB(op_LSHIFT_251, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_255 = ITE(op_LT_240, op_NEG_246, op_SUB_254);
	RzILOpEffect *gcc_expr_256 = BRANCH(op_EQ_126, EMPTY(), set_usr_field_call_183);

	// h_tmp379 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_258 = SETL("h_tmp379", cond_255);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_259 = SEQN(2, gcc_expr_256, op_ASSIGN_hybrid_tmp_258);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0) : h_tmp379) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_130 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_132 = LOGAND(op_RSHIFT_130, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_138 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_141 = LOGAND(op_RSHIFT_138, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_147 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_150 = LOGAND(op_RSHIFT_147, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_153 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_141), DUP(op_AND_141))), CAST(16, MSB(DUP(op_AND_141)), DUP(op_AND_141))), CAST(32, MSB(CAST(16, MSB(op_AND_150), DUP(op_AND_150))), CAST(16, MSB(DUP(op_AND_150)), DUP(op_AND_150))));
	RzILOpPure *op_LSHIFT_156 = SHIFTL0(CAST(64, MSB(op_MUL_153), DUP(op_MUL_153)), SN(32, 0));
	RzILOpPure *op_ADD_157 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_132), DUP(op_AND_132))), CAST(32, MSB(DUP(op_AND_132)), DUP(op_AND_132))), op_LSHIFT_156);
	RzILOpPure *op_RSHIFT_161 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_164 = LOGAND(op_RSHIFT_161, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_170 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_173 = LOGAND(op_RSHIFT_170, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_176 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_164), DUP(op_AND_164))), CAST(16, MSB(DUP(op_AND_164)), DUP(op_AND_164))), CAST(32, MSB(CAST(16, MSB(op_AND_173), DUP(op_AND_173))), CAST(16, MSB(DUP(op_AND_173)), DUP(op_AND_173))));
	RzILOpPure *op_LSHIFT_179 = SHIFTL0(CAST(64, MSB(op_MUL_176), DUP(op_MUL_176)), SN(32, 0));
	RzILOpPure *op_ADD_180 = ADD(op_ADD_157, op_LSHIFT_179);
	RzILOpPure *cond_260 = ITE(DUP(op_EQ_126), op_ADD_180, VARL("h_tmp379"));
	RzILOpPure *op_AND_262 = LOGAND(cond_260, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_266 = SHIFTL0(op_AND_262, SN(32, 0));
	RzILOpPure *op_OR_267 = LOGOR(op_AND_7, op_LSHIFT_266);
	RzILOpEffect *op_ASSIGN_268 = WRITE_REG(bundle, Rxx_op, op_OR_267);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_269 = SEQN(2, seq_259, op_ASSIGN_268);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_451 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_284 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_286 = LOGAND(op_RSHIFT_284, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_292 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_295 = LOGAND(op_RSHIFT_292, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_301 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_304 = LOGAND(op_RSHIFT_301, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_307 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_295), DUP(op_AND_295))), CAST(16, MSB(DUP(op_AND_295)), DUP(op_AND_295))), CAST(32, MSB(CAST(16, MSB(op_AND_304), DUP(op_AND_304))), CAST(16, MSB(DUP(op_AND_304)), DUP(op_AND_304))));
	RzILOpPure *op_LSHIFT_310 = SHIFTL0(CAST(64, MSB(op_MUL_307), DUP(op_MUL_307)), SN(32, 0));
	RzILOpPure *op_ADD_311 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_286), DUP(op_AND_286))), CAST(32, MSB(DUP(op_AND_286)), DUP(op_AND_286))), op_LSHIFT_310);
	RzILOpPure *op_RSHIFT_315 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_318 = LOGAND(op_RSHIFT_315, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_324 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_327 = LOGAND(op_RSHIFT_324, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_330 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_318), DUP(op_AND_318))), CAST(16, MSB(DUP(op_AND_318)), DUP(op_AND_318))), CAST(32, MSB(CAST(16, MSB(op_AND_327), DUP(op_AND_327))), CAST(16, MSB(DUP(op_AND_327)), DUP(op_AND_327))));
	RzILOpPure *op_LSHIFT_333 = SHIFTL0(CAST(64, MSB(op_MUL_330), DUP(op_MUL_330)), SN(32, 0));
	RzILOpPure *op_ADD_334 = ADD(op_ADD_311, op_LSHIFT_333);
	RzILOpPure *op_RSHIFT_343 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_345 = LOGAND(op_RSHIFT_343, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_351 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_354 = LOGAND(op_RSHIFT_351, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_360 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_363 = LOGAND(op_RSHIFT_360, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_366 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_354), DUP(op_AND_354))), CAST(16, MSB(DUP(op_AND_354)), DUP(op_AND_354))), CAST(32, MSB(CAST(16, MSB(op_AND_363), DUP(op_AND_363))), CAST(16, MSB(DUP(op_AND_363)), DUP(op_AND_363))));
	RzILOpPure *op_LSHIFT_369 = SHIFTL0(CAST(64, MSB(op_MUL_366), DUP(op_MUL_366)), SN(32, 0));
	RzILOpPure *op_ADD_370 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_345), DUP(op_AND_345))), CAST(32, MSB(DUP(op_AND_345)), DUP(op_AND_345))), op_LSHIFT_369);
	RzILOpPure *op_RSHIFT_374 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_377 = LOGAND(op_RSHIFT_374, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_383 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_386 = LOGAND(op_RSHIFT_383, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_389 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_377), DUP(op_AND_377))), CAST(16, MSB(DUP(op_AND_377)), DUP(op_AND_377))), CAST(32, MSB(CAST(16, MSB(op_AND_386), DUP(op_AND_386))), CAST(16, MSB(DUP(op_AND_386)), DUP(op_AND_386))));
	RzILOpPure *op_LSHIFT_392 = SHIFTL0(CAST(64, MSB(op_MUL_389), DUP(op_MUL_389)), SN(32, 0));
	RzILOpPure *op_ADD_393 = ADD(op_ADD_370, op_LSHIFT_392);
	RzILOpPure *op_EQ_394 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_334), SN(32, 0), SN(32, 0x20)), op_ADD_393);
	RzILOpPure *op_RSHIFT_455 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_457 = LOGAND(op_RSHIFT_455, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_463 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_466 = LOGAND(op_RSHIFT_463, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_472 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_475 = LOGAND(op_RSHIFT_472, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_478 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_466), DUP(op_AND_466))), CAST(16, MSB(DUP(op_AND_466)), DUP(op_AND_466))), CAST(32, MSB(CAST(16, MSB(op_AND_475), DUP(op_AND_475))), CAST(16, MSB(DUP(op_AND_475)), DUP(op_AND_475))));
	RzILOpPure *op_LSHIFT_481 = SHIFTL0(CAST(64, MSB(op_MUL_478), DUP(op_MUL_478)), SN(32, 0));
	RzILOpPure *op_ADD_482 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_457), DUP(op_AND_457))), CAST(32, MSB(DUP(op_AND_457)), DUP(op_AND_457))), op_LSHIFT_481);
	RzILOpPure *op_RSHIFT_486 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_489 = LOGAND(op_RSHIFT_486, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_495 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_498 = LOGAND(op_RSHIFT_495, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_501 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_489), DUP(op_AND_489))), CAST(16, MSB(DUP(op_AND_489)), DUP(op_AND_489))), CAST(32, MSB(CAST(16, MSB(op_AND_498), DUP(op_AND_498))), CAST(16, MSB(DUP(op_AND_498)), DUP(op_AND_498))));
	RzILOpPure *op_LSHIFT_504 = SHIFTL0(CAST(64, MSB(op_MUL_501), DUP(op_MUL_501)), SN(32, 0));
	RzILOpPure *op_ADD_505 = ADD(op_ADD_482, op_LSHIFT_504);
	RzILOpPure *op_LT_508 = SLT(op_ADD_505, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_513 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_514 = NEG(op_LSHIFT_513);
	RzILOpPure *op_LSHIFT_519 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_522 = SUB(op_LSHIFT_519, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_523 = ITE(op_LT_508, op_NEG_514, op_SUB_522);
	RzILOpEffect *gcc_expr_524 = BRANCH(op_EQ_394, EMPTY(), set_usr_field_call_451);

	// h_tmp380 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_526 = SETL("h_tmp380", cond_523);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_527 = SEQN(2, gcc_expr_524, op_ASSIGN_hybrid_tmp_526);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0) : h_tmp380) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_275 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_276 = LOGNOT(op_LSHIFT_275);
	RzILOpPure *op_AND_277 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_276);
	RzILOpPure *op_RSHIFT_398 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_400 = LOGAND(op_RSHIFT_398, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_406 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_409 = LOGAND(op_RSHIFT_406, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_415 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_418 = LOGAND(op_RSHIFT_415, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_421 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_409), DUP(op_AND_409))), CAST(16, MSB(DUP(op_AND_409)), DUP(op_AND_409))), CAST(32, MSB(CAST(16, MSB(op_AND_418), DUP(op_AND_418))), CAST(16, MSB(DUP(op_AND_418)), DUP(op_AND_418))));
	RzILOpPure *op_LSHIFT_424 = SHIFTL0(CAST(64, MSB(op_MUL_421), DUP(op_MUL_421)), SN(32, 0));
	RzILOpPure *op_ADD_425 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_400), DUP(op_AND_400))), CAST(32, MSB(DUP(op_AND_400)), DUP(op_AND_400))), op_LSHIFT_424);
	RzILOpPure *op_RSHIFT_429 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_432 = LOGAND(op_RSHIFT_429, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_438 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_441 = LOGAND(op_RSHIFT_438, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_444 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_432), DUP(op_AND_432))), CAST(16, MSB(DUP(op_AND_432)), DUP(op_AND_432))), CAST(32, MSB(CAST(16, MSB(op_AND_441), DUP(op_AND_441))), CAST(16, MSB(DUP(op_AND_441)), DUP(op_AND_441))));
	RzILOpPure *op_LSHIFT_447 = SHIFTL0(CAST(64, MSB(op_MUL_444), DUP(op_MUL_444)), SN(32, 0));
	RzILOpPure *op_ADD_448 = ADD(op_ADD_425, op_LSHIFT_447);
	RzILOpPure *cond_528 = ITE(DUP(op_EQ_394), op_ADD_448, VARL("h_tmp380"));
	RzILOpPure *op_AND_530 = LOGAND(cond_528, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_534 = SHIFTL0(op_AND_530, SN(32, 0x20));
	RzILOpPure *op_OR_535 = LOGOR(op_AND_277, op_LSHIFT_534);
	RzILOpEffect *op_ASSIGN_536 = WRITE_REG(bundle, Rxx_op, op_OR_535);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_537 = SEQN(2, seq_527, op_ASSIGN_536);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_269, seq_537);
	return instruction_sequence;
}

// Rxx += vdmpy(Rss,Rtt):<<1:sat
RzILOpEffect *hex_il_op_m2_vdmacs_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_183 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rss, SN(32, 0));
	RzILOpPure *op_AND_26 = LOGAND(op_RSHIFT_23, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_33 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_36 = LOGAND(op_RSHIFT_33, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_39 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_26), DUP(op_AND_26))), CAST(16, MSB(DUP(op_AND_26)), DUP(op_AND_26))), CAST(32, MSB(CAST(16, MSB(op_AND_36), DUP(op_AND_36))), CAST(16, MSB(DUP(op_AND_36)), DUP(op_AND_36))));
	RzILOpPure *op_LSHIFT_42 = SHIFTL0(CAST(64, MSB(op_MUL_39), DUP(op_MUL_39)), SN(32, 1));
	RzILOpPure *op_ADD_43 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_LSHIFT_42);
	RzILOpPure *op_RSHIFT_47 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_50 = LOGAND(op_RSHIFT_47, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_56 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_59 = LOGAND(op_RSHIFT_56, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_62 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_50), DUP(op_AND_50))), CAST(16, MSB(DUP(op_AND_50)), DUP(op_AND_50))), CAST(32, MSB(CAST(16, MSB(op_AND_59), DUP(op_AND_59))), CAST(16, MSB(DUP(op_AND_59)), DUP(op_AND_59))));
	RzILOpPure *op_LSHIFT_65 = SHIFTL0(CAST(64, MSB(op_MUL_62), DUP(op_MUL_62)), SN(32, 1));
	RzILOpPure *op_ADD_66 = ADD(op_ADD_43, op_LSHIFT_65);
	RzILOpPure *op_RSHIFT_75 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_77 = LOGAND(op_RSHIFT_75, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_83 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_86 = LOGAND(op_RSHIFT_83, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_92 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_95 = LOGAND(op_RSHIFT_92, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_98 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_86), DUP(op_AND_86))), CAST(16, MSB(DUP(op_AND_86)), DUP(op_AND_86))), CAST(32, MSB(CAST(16, MSB(op_AND_95), DUP(op_AND_95))), CAST(16, MSB(DUP(op_AND_95)), DUP(op_AND_95))));
	RzILOpPure *op_LSHIFT_101 = SHIFTL0(CAST(64, MSB(op_MUL_98), DUP(op_MUL_98)), SN(32, 1));
	RzILOpPure *op_ADD_102 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_77), DUP(op_AND_77))), CAST(32, MSB(DUP(op_AND_77)), DUP(op_AND_77))), op_LSHIFT_101);
	RzILOpPure *op_RSHIFT_106 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_109 = LOGAND(op_RSHIFT_106, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_115 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_118 = LOGAND(op_RSHIFT_115, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_121 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_109), DUP(op_AND_109))), CAST(16, MSB(DUP(op_AND_109)), DUP(op_AND_109))), CAST(32, MSB(CAST(16, MSB(op_AND_118), DUP(op_AND_118))), CAST(16, MSB(DUP(op_AND_118)), DUP(op_AND_118))));
	RzILOpPure *op_LSHIFT_124 = SHIFTL0(CAST(64, MSB(op_MUL_121), DUP(op_MUL_121)), SN(32, 1));
	RzILOpPure *op_ADD_125 = ADD(op_ADD_102, op_LSHIFT_124);
	RzILOpPure *op_EQ_126 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_66), SN(32, 0), SN(32, 0x20)), op_ADD_125);
	RzILOpPure *op_RSHIFT_187 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_189 = LOGAND(op_RSHIFT_187, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_195 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_198 = LOGAND(op_RSHIFT_195, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_204 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_207 = LOGAND(op_RSHIFT_204, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_210 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_198), DUP(op_AND_198))), CAST(16, MSB(DUP(op_AND_198)), DUP(op_AND_198))), CAST(32, MSB(CAST(16, MSB(op_AND_207), DUP(op_AND_207))), CAST(16, MSB(DUP(op_AND_207)), DUP(op_AND_207))));
	RzILOpPure *op_LSHIFT_213 = SHIFTL0(CAST(64, MSB(op_MUL_210), DUP(op_MUL_210)), SN(32, 1));
	RzILOpPure *op_ADD_214 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_189), DUP(op_AND_189))), CAST(32, MSB(DUP(op_AND_189)), DUP(op_AND_189))), op_LSHIFT_213);
	RzILOpPure *op_RSHIFT_218 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_221 = LOGAND(op_RSHIFT_218, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_227 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_230 = LOGAND(op_RSHIFT_227, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_233 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_221), DUP(op_AND_221))), CAST(16, MSB(DUP(op_AND_221)), DUP(op_AND_221))), CAST(32, MSB(CAST(16, MSB(op_AND_230), DUP(op_AND_230))), CAST(16, MSB(DUP(op_AND_230)), DUP(op_AND_230))));
	RzILOpPure *op_LSHIFT_236 = SHIFTL0(CAST(64, MSB(op_MUL_233), DUP(op_MUL_233)), SN(32, 1));
	RzILOpPure *op_ADD_237 = ADD(op_ADD_214, op_LSHIFT_236);
	RzILOpPure *op_LT_240 = SLT(op_ADD_237, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_245 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_246 = NEG(op_LSHIFT_245);
	RzILOpPure *op_LSHIFT_251 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_254 = SUB(op_LSHIFT_251, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_255 = ITE(op_LT_240, op_NEG_246, op_SUB_254);
	RzILOpEffect *gcc_expr_256 = BRANCH(op_EQ_126, EMPTY(), set_usr_field_call_183);

	// h_tmp381 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_258 = SETL("h_tmp381", cond_255);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_259 = SEQN(2, gcc_expr_256, op_ASSIGN_hybrid_tmp_258);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1) : h_tmp381) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_130 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_132 = LOGAND(op_RSHIFT_130, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_138 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_141 = LOGAND(op_RSHIFT_138, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_147 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_150 = LOGAND(op_RSHIFT_147, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_153 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_141), DUP(op_AND_141))), CAST(16, MSB(DUP(op_AND_141)), DUP(op_AND_141))), CAST(32, MSB(CAST(16, MSB(op_AND_150), DUP(op_AND_150))), CAST(16, MSB(DUP(op_AND_150)), DUP(op_AND_150))));
	RzILOpPure *op_LSHIFT_156 = SHIFTL0(CAST(64, MSB(op_MUL_153), DUP(op_MUL_153)), SN(32, 1));
	RzILOpPure *op_ADD_157 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_132), DUP(op_AND_132))), CAST(32, MSB(DUP(op_AND_132)), DUP(op_AND_132))), op_LSHIFT_156);
	RzILOpPure *op_RSHIFT_161 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_164 = LOGAND(op_RSHIFT_161, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_170 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_173 = LOGAND(op_RSHIFT_170, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_176 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_164), DUP(op_AND_164))), CAST(16, MSB(DUP(op_AND_164)), DUP(op_AND_164))), CAST(32, MSB(CAST(16, MSB(op_AND_173), DUP(op_AND_173))), CAST(16, MSB(DUP(op_AND_173)), DUP(op_AND_173))));
	RzILOpPure *op_LSHIFT_179 = SHIFTL0(CAST(64, MSB(op_MUL_176), DUP(op_MUL_176)), SN(32, 1));
	RzILOpPure *op_ADD_180 = ADD(op_ADD_157, op_LSHIFT_179);
	RzILOpPure *cond_260 = ITE(DUP(op_EQ_126), op_ADD_180, VARL("h_tmp381"));
	RzILOpPure *op_AND_262 = LOGAND(cond_260, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_266 = SHIFTL0(op_AND_262, SN(32, 0));
	RzILOpPure *op_OR_267 = LOGOR(op_AND_7, op_LSHIFT_266);
	RzILOpEffect *op_ASSIGN_268 = WRITE_REG(bundle, Rxx_op, op_OR_267);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_269 = SEQN(2, seq_259, op_ASSIGN_268);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_451 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_284 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_286 = LOGAND(op_RSHIFT_284, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_292 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_295 = LOGAND(op_RSHIFT_292, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_301 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_304 = LOGAND(op_RSHIFT_301, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_307 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_295), DUP(op_AND_295))), CAST(16, MSB(DUP(op_AND_295)), DUP(op_AND_295))), CAST(32, MSB(CAST(16, MSB(op_AND_304), DUP(op_AND_304))), CAST(16, MSB(DUP(op_AND_304)), DUP(op_AND_304))));
	RzILOpPure *op_LSHIFT_310 = SHIFTL0(CAST(64, MSB(op_MUL_307), DUP(op_MUL_307)), SN(32, 1));
	RzILOpPure *op_ADD_311 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_286), DUP(op_AND_286))), CAST(32, MSB(DUP(op_AND_286)), DUP(op_AND_286))), op_LSHIFT_310);
	RzILOpPure *op_RSHIFT_315 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_318 = LOGAND(op_RSHIFT_315, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_324 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_327 = LOGAND(op_RSHIFT_324, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_330 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_318), DUP(op_AND_318))), CAST(16, MSB(DUP(op_AND_318)), DUP(op_AND_318))), CAST(32, MSB(CAST(16, MSB(op_AND_327), DUP(op_AND_327))), CAST(16, MSB(DUP(op_AND_327)), DUP(op_AND_327))));
	RzILOpPure *op_LSHIFT_333 = SHIFTL0(CAST(64, MSB(op_MUL_330), DUP(op_MUL_330)), SN(32, 1));
	RzILOpPure *op_ADD_334 = ADD(op_ADD_311, op_LSHIFT_333);
	RzILOpPure *op_RSHIFT_343 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_345 = LOGAND(op_RSHIFT_343, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_351 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_354 = LOGAND(op_RSHIFT_351, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_360 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_363 = LOGAND(op_RSHIFT_360, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_366 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_354), DUP(op_AND_354))), CAST(16, MSB(DUP(op_AND_354)), DUP(op_AND_354))), CAST(32, MSB(CAST(16, MSB(op_AND_363), DUP(op_AND_363))), CAST(16, MSB(DUP(op_AND_363)), DUP(op_AND_363))));
	RzILOpPure *op_LSHIFT_369 = SHIFTL0(CAST(64, MSB(op_MUL_366), DUP(op_MUL_366)), SN(32, 1));
	RzILOpPure *op_ADD_370 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_345), DUP(op_AND_345))), CAST(32, MSB(DUP(op_AND_345)), DUP(op_AND_345))), op_LSHIFT_369);
	RzILOpPure *op_RSHIFT_374 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_377 = LOGAND(op_RSHIFT_374, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_383 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_386 = LOGAND(op_RSHIFT_383, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_389 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_377), DUP(op_AND_377))), CAST(16, MSB(DUP(op_AND_377)), DUP(op_AND_377))), CAST(32, MSB(CAST(16, MSB(op_AND_386), DUP(op_AND_386))), CAST(16, MSB(DUP(op_AND_386)), DUP(op_AND_386))));
	RzILOpPure *op_LSHIFT_392 = SHIFTL0(CAST(64, MSB(op_MUL_389), DUP(op_MUL_389)), SN(32, 1));
	RzILOpPure *op_ADD_393 = ADD(op_ADD_370, op_LSHIFT_392);
	RzILOpPure *op_EQ_394 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_334), SN(32, 0), SN(32, 0x20)), op_ADD_393);
	RzILOpPure *op_RSHIFT_455 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_457 = LOGAND(op_RSHIFT_455, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_463 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_466 = LOGAND(op_RSHIFT_463, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_472 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_475 = LOGAND(op_RSHIFT_472, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_478 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_466), DUP(op_AND_466))), CAST(16, MSB(DUP(op_AND_466)), DUP(op_AND_466))), CAST(32, MSB(CAST(16, MSB(op_AND_475), DUP(op_AND_475))), CAST(16, MSB(DUP(op_AND_475)), DUP(op_AND_475))));
	RzILOpPure *op_LSHIFT_481 = SHIFTL0(CAST(64, MSB(op_MUL_478), DUP(op_MUL_478)), SN(32, 1));
	RzILOpPure *op_ADD_482 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_457), DUP(op_AND_457))), CAST(32, MSB(DUP(op_AND_457)), DUP(op_AND_457))), op_LSHIFT_481);
	RzILOpPure *op_RSHIFT_486 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_489 = LOGAND(op_RSHIFT_486, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_495 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_498 = LOGAND(op_RSHIFT_495, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_501 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_489), DUP(op_AND_489))), CAST(16, MSB(DUP(op_AND_489)), DUP(op_AND_489))), CAST(32, MSB(CAST(16, MSB(op_AND_498), DUP(op_AND_498))), CAST(16, MSB(DUP(op_AND_498)), DUP(op_AND_498))));
	RzILOpPure *op_LSHIFT_504 = SHIFTL0(CAST(64, MSB(op_MUL_501), DUP(op_MUL_501)), SN(32, 1));
	RzILOpPure *op_ADD_505 = ADD(op_ADD_482, op_LSHIFT_504);
	RzILOpPure *op_LT_508 = SLT(op_ADD_505, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_513 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_514 = NEG(op_LSHIFT_513);
	RzILOpPure *op_LSHIFT_519 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_522 = SUB(op_LSHIFT_519, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_523 = ITE(op_LT_508, op_NEG_514, op_SUB_522);
	RzILOpEffect *gcc_expr_524 = BRANCH(op_EQ_394, EMPTY(), set_usr_field_call_451);

	// h_tmp382 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_526 = SETL("h_tmp382", cond_523);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_527 = SEQN(2, gcc_expr_524, op_ASSIGN_hybrid_tmp_526);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1) : h_tmp382) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_275 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_276 = LOGNOT(op_LSHIFT_275);
	RzILOpPure *op_AND_277 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_276);
	RzILOpPure *op_RSHIFT_398 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_400 = LOGAND(op_RSHIFT_398, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_406 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_409 = LOGAND(op_RSHIFT_406, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_415 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_418 = LOGAND(op_RSHIFT_415, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_421 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_409), DUP(op_AND_409))), CAST(16, MSB(DUP(op_AND_409)), DUP(op_AND_409))), CAST(32, MSB(CAST(16, MSB(op_AND_418), DUP(op_AND_418))), CAST(16, MSB(DUP(op_AND_418)), DUP(op_AND_418))));
	RzILOpPure *op_LSHIFT_424 = SHIFTL0(CAST(64, MSB(op_MUL_421), DUP(op_MUL_421)), SN(32, 1));
	RzILOpPure *op_ADD_425 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_400), DUP(op_AND_400))), CAST(32, MSB(DUP(op_AND_400)), DUP(op_AND_400))), op_LSHIFT_424);
	RzILOpPure *op_RSHIFT_429 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_432 = LOGAND(op_RSHIFT_429, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_438 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_441 = LOGAND(op_RSHIFT_438, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_444 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_432), DUP(op_AND_432))), CAST(16, MSB(DUP(op_AND_432)), DUP(op_AND_432))), CAST(32, MSB(CAST(16, MSB(op_AND_441), DUP(op_AND_441))), CAST(16, MSB(DUP(op_AND_441)), DUP(op_AND_441))));
	RzILOpPure *op_LSHIFT_447 = SHIFTL0(CAST(64, MSB(op_MUL_444), DUP(op_MUL_444)), SN(32, 1));
	RzILOpPure *op_ADD_448 = ADD(op_ADD_425, op_LSHIFT_447);
	RzILOpPure *cond_528 = ITE(DUP(op_EQ_394), op_ADD_448, VARL("h_tmp382"));
	RzILOpPure *op_AND_530 = LOGAND(cond_528, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_534 = SHIFTL0(op_AND_530, SN(32, 0x20));
	RzILOpPure *op_OR_535 = LOGOR(op_AND_277, op_LSHIFT_534);
	RzILOpEffect *op_ASSIGN_536 = WRITE_REG(bundle, Rxx_op, op_OR_535);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_537 = SEQN(2, seq_527, op_ASSIGN_536);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_269, seq_537);
	return instruction_sequence;
}

// Rd = vdmpy(Rss,Rtt):rnd:sat
RzILOpEffect *hex_il_op_m2_vdmpyrs_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_166 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_16 = SHIFTRA(Rss, SN(32, 0));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_16, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_26 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_29 = LOGAND(op_RSHIFT_26, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_32 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))), CAST(32, MSB(CAST(16, MSB(op_AND_29), DUP(op_AND_29))), CAST(16, MSB(DUP(op_AND_29)), DUP(op_AND_29))));
	RzILOpPure *op_LSHIFT_35 = SHIFTL0(CAST(64, MSB(op_MUL_32), DUP(op_MUL_32)), SN(32, 0));
	RzILOpPure *op_RSHIFT_39 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_42 = LOGAND(op_RSHIFT_39, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_48 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_51 = LOGAND(op_RSHIFT_48, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_54 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_42), DUP(op_AND_42))), CAST(16, MSB(DUP(op_AND_42)), DUP(op_AND_42))), CAST(32, MSB(CAST(16, MSB(op_AND_51), DUP(op_AND_51))), CAST(16, MSB(DUP(op_AND_51)), DUP(op_AND_51))));
	RzILOpPure *op_LSHIFT_57 = SHIFTL0(CAST(64, MSB(op_MUL_54), DUP(op_MUL_54)), SN(32, 0));
	RzILOpPure *op_ADD_58 = ADD(op_LSHIFT_35, op_LSHIFT_57);
	RzILOpPure *op_ADD_61 = ADD(op_ADD_58, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_70 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_73 = LOGAND(op_RSHIFT_70, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_79 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_82 = LOGAND(op_RSHIFT_79, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_85 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_73), DUP(op_AND_73))), CAST(16, MSB(DUP(op_AND_73)), DUP(op_AND_73))), CAST(32, MSB(CAST(16, MSB(op_AND_82), DUP(op_AND_82))), CAST(16, MSB(DUP(op_AND_82)), DUP(op_AND_82))));
	RzILOpPure *op_LSHIFT_88 = SHIFTL0(CAST(64, MSB(op_MUL_85), DUP(op_MUL_85)), SN(32, 0));
	RzILOpPure *op_RSHIFT_92 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_95 = LOGAND(op_RSHIFT_92, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_101 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_104 = LOGAND(op_RSHIFT_101, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_107 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_95), DUP(op_AND_95))), CAST(16, MSB(DUP(op_AND_95)), DUP(op_AND_95))), CAST(32, MSB(CAST(16, MSB(op_AND_104), DUP(op_AND_104))), CAST(16, MSB(DUP(op_AND_104)), DUP(op_AND_104))));
	RzILOpPure *op_LSHIFT_110 = SHIFTL0(CAST(64, MSB(op_MUL_107), DUP(op_MUL_107)), SN(32, 0));
	RzILOpPure *op_ADD_111 = ADD(op_LSHIFT_88, op_LSHIFT_110);
	RzILOpPure *op_ADD_114 = ADD(op_ADD_111, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_EQ_115 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_61), SN(32, 0), SN(32, 0x20)), op_ADD_114);
	RzILOpPure *op_RSHIFT_170 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_173 = LOGAND(op_RSHIFT_170, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_179 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_182 = LOGAND(op_RSHIFT_179, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_185 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_173), DUP(op_AND_173))), CAST(16, MSB(DUP(op_AND_173)), DUP(op_AND_173))), CAST(32, MSB(CAST(16, MSB(op_AND_182), DUP(op_AND_182))), CAST(16, MSB(DUP(op_AND_182)), DUP(op_AND_182))));
	RzILOpPure *op_LSHIFT_188 = SHIFTL0(CAST(64, MSB(op_MUL_185), DUP(op_MUL_185)), SN(32, 0));
	RzILOpPure *op_RSHIFT_192 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_195 = LOGAND(op_RSHIFT_192, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_201 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_204 = LOGAND(op_RSHIFT_201, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_207 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_195), DUP(op_AND_195))), CAST(16, MSB(DUP(op_AND_195)), DUP(op_AND_195))), CAST(32, MSB(CAST(16, MSB(op_AND_204), DUP(op_AND_204))), CAST(16, MSB(DUP(op_AND_204)), DUP(op_AND_204))));
	RzILOpPure *op_LSHIFT_210 = SHIFTL0(CAST(64, MSB(op_MUL_207), DUP(op_MUL_207)), SN(32, 0));
	RzILOpPure *op_ADD_211 = ADD(op_LSHIFT_188, op_LSHIFT_210);
	RzILOpPure *op_ADD_214 = ADD(op_ADD_211, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_LT_217 = SLT(op_ADD_214, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_222 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_223 = NEG(op_LSHIFT_222);
	RzILOpPure *op_LSHIFT_228 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_231 = SUB(op_LSHIFT_228, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_232 = ITE(op_LT_217, op_NEG_223, op_SUB_231);
	RzILOpEffect *gcc_expr_233 = BRANCH(op_EQ_115, EMPTY(), set_usr_field_call_166);

	// h_tmp383 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_235 = SETL("h_tmp383", cond_232);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_236 = SEQN(2, gcc_expr_233, op_ASSIGN_hybrid_tmp_235);

	// Rd = ((st32) (((ut64) (((st64) Rd) & (~(0xffff << 0x0)))) | (((ut64) (((st32) ((st16) ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0) + ((st64) 0x8000)) ? (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0) + ((st64) 0x8000) : h_tmp383) >> 0x10) & ((st64) 0xffff)))) & 0xffff)) << 0x0)));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffff), SN(32, 0));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_8 = LOGAND(CAST(64, MSB(READ_REG(pkt, Rd_op, true)), READ_REG(pkt, Rd_op, true)), op_NOT_6);
	RzILOpPure *op_RSHIFT_119 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_122 = LOGAND(op_RSHIFT_119, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_128 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_131 = LOGAND(op_RSHIFT_128, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_134 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_122), DUP(op_AND_122))), CAST(16, MSB(DUP(op_AND_122)), DUP(op_AND_122))), CAST(32, MSB(CAST(16, MSB(op_AND_131), DUP(op_AND_131))), CAST(16, MSB(DUP(op_AND_131)), DUP(op_AND_131))));
	RzILOpPure *op_LSHIFT_137 = SHIFTL0(CAST(64, MSB(op_MUL_134), DUP(op_MUL_134)), SN(32, 0));
	RzILOpPure *op_RSHIFT_141 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_144 = LOGAND(op_RSHIFT_141, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_150 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_153 = LOGAND(op_RSHIFT_150, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_156 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_144), DUP(op_AND_144))), CAST(16, MSB(DUP(op_AND_144)), DUP(op_AND_144))), CAST(32, MSB(CAST(16, MSB(op_AND_153), DUP(op_AND_153))), CAST(16, MSB(DUP(op_AND_153)), DUP(op_AND_153))));
	RzILOpPure *op_LSHIFT_159 = SHIFTL0(CAST(64, MSB(op_MUL_156), DUP(op_MUL_156)), SN(32, 0));
	RzILOpPure *op_ADD_160 = ADD(op_LSHIFT_137, op_LSHIFT_159);
	RzILOpPure *op_ADD_163 = ADD(op_ADD_160, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *cond_237 = ITE(DUP(op_EQ_115), op_ADD_163, VARL("h_tmp383"));
	RzILOpPure *op_RSHIFT_241 = SHIFTRA(cond_237, SN(32, 16));
	RzILOpPure *op_AND_244 = LOGAND(op_RSHIFT_241, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_AND_248 = LOGAND(CAST(32, MSB(CAST(16, MSB(op_AND_244), DUP(op_AND_244))), CAST(16, MSB(DUP(op_AND_244)), DUP(op_AND_244))), SN(32, 0xffff));
	RzILOpPure *op_LSHIFT_253 = SHIFTL0(CAST(64, IL_FALSE, op_AND_248), SN(32, 0));
	RzILOpPure *op_OR_255 = LOGOR(CAST(64, IL_FALSE, op_AND_8), op_LSHIFT_253);
	RzILOpEffect *op_ASSIGN_257 = WRITE_REG(bundle, Rd_op, CAST(32, IL_FALSE, op_OR_255));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_258 = SEQN(2, seq_236, op_ASSIGN_257);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_423 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_274 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_277 = LOGAND(op_RSHIFT_274, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_283 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_286 = LOGAND(op_RSHIFT_283, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_289 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_277), DUP(op_AND_277))), CAST(16, MSB(DUP(op_AND_277)), DUP(op_AND_277))), CAST(32, MSB(CAST(16, MSB(op_AND_286), DUP(op_AND_286))), CAST(16, MSB(DUP(op_AND_286)), DUP(op_AND_286))));
	RzILOpPure *op_LSHIFT_292 = SHIFTL0(CAST(64, MSB(op_MUL_289), DUP(op_MUL_289)), SN(32, 0));
	RzILOpPure *op_RSHIFT_296 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_299 = LOGAND(op_RSHIFT_296, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_305 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_308 = LOGAND(op_RSHIFT_305, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_311 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_299), DUP(op_AND_299))), CAST(16, MSB(DUP(op_AND_299)), DUP(op_AND_299))), CAST(32, MSB(CAST(16, MSB(op_AND_308), DUP(op_AND_308))), CAST(16, MSB(DUP(op_AND_308)), DUP(op_AND_308))));
	RzILOpPure *op_LSHIFT_314 = SHIFTL0(CAST(64, MSB(op_MUL_311), DUP(op_MUL_311)), SN(32, 0));
	RzILOpPure *op_ADD_315 = ADD(op_LSHIFT_292, op_LSHIFT_314);
	RzILOpPure *op_ADD_318 = ADD(op_ADD_315, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_327 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_330 = LOGAND(op_RSHIFT_327, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_336 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_339 = LOGAND(op_RSHIFT_336, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_342 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_330), DUP(op_AND_330))), CAST(16, MSB(DUP(op_AND_330)), DUP(op_AND_330))), CAST(32, MSB(CAST(16, MSB(op_AND_339), DUP(op_AND_339))), CAST(16, MSB(DUP(op_AND_339)), DUP(op_AND_339))));
	RzILOpPure *op_LSHIFT_345 = SHIFTL0(CAST(64, MSB(op_MUL_342), DUP(op_MUL_342)), SN(32, 0));
	RzILOpPure *op_RSHIFT_349 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_352 = LOGAND(op_RSHIFT_349, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_358 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_361 = LOGAND(op_RSHIFT_358, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_364 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_352), DUP(op_AND_352))), CAST(16, MSB(DUP(op_AND_352)), DUP(op_AND_352))), CAST(32, MSB(CAST(16, MSB(op_AND_361), DUP(op_AND_361))), CAST(16, MSB(DUP(op_AND_361)), DUP(op_AND_361))));
	RzILOpPure *op_LSHIFT_367 = SHIFTL0(CAST(64, MSB(op_MUL_364), DUP(op_MUL_364)), SN(32, 0));
	RzILOpPure *op_ADD_368 = ADD(op_LSHIFT_345, op_LSHIFT_367);
	RzILOpPure *op_ADD_371 = ADD(op_ADD_368, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_EQ_372 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_318), SN(32, 0), SN(32, 0x20)), op_ADD_371);
	RzILOpPure *op_RSHIFT_427 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_430 = LOGAND(op_RSHIFT_427, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_436 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_439 = LOGAND(op_RSHIFT_436, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_442 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_430), DUP(op_AND_430))), CAST(16, MSB(DUP(op_AND_430)), DUP(op_AND_430))), CAST(32, MSB(CAST(16, MSB(op_AND_439), DUP(op_AND_439))), CAST(16, MSB(DUP(op_AND_439)), DUP(op_AND_439))));
	RzILOpPure *op_LSHIFT_445 = SHIFTL0(CAST(64, MSB(op_MUL_442), DUP(op_MUL_442)), SN(32, 0));
	RzILOpPure *op_RSHIFT_449 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_452 = LOGAND(op_RSHIFT_449, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_458 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_461 = LOGAND(op_RSHIFT_458, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_464 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_452), DUP(op_AND_452))), CAST(16, MSB(DUP(op_AND_452)), DUP(op_AND_452))), CAST(32, MSB(CAST(16, MSB(op_AND_461), DUP(op_AND_461))), CAST(16, MSB(DUP(op_AND_461)), DUP(op_AND_461))));
	RzILOpPure *op_LSHIFT_467 = SHIFTL0(CAST(64, MSB(op_MUL_464), DUP(op_MUL_464)), SN(32, 0));
	RzILOpPure *op_ADD_468 = ADD(op_LSHIFT_445, op_LSHIFT_467);
	RzILOpPure *op_ADD_471 = ADD(op_ADD_468, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_LT_474 = SLT(op_ADD_471, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_479 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_480 = NEG(op_LSHIFT_479);
	RzILOpPure *op_LSHIFT_485 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_488 = SUB(op_LSHIFT_485, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_489 = ITE(op_LT_474, op_NEG_480, op_SUB_488);
	RzILOpEffect *gcc_expr_490 = BRANCH(op_EQ_372, EMPTY(), set_usr_field_call_423);

	// h_tmp384 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_492 = SETL("h_tmp384", cond_489);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_493 = SEQN(2, gcc_expr_490, op_ASSIGN_hybrid_tmp_492);

	// Rd = ((st32) (((ut64) (((st64) Rd) & (~(0xffff << 0x10)))) | (((ut64) (((st32) ((st16) ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0) + ((st64) 0x8000)) ? (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0) + ((st64) 0x8000) : h_tmp384) >> 0x10) & ((st64) 0xffff)))) & 0xffff)) << 0x10)));
	RzILOpPure *op_LSHIFT_264 = SHIFTL0(SN(64, 0xffff), SN(32, 16));
	RzILOpPure *op_NOT_265 = LOGNOT(op_LSHIFT_264);
	RzILOpPure *op_AND_267 = LOGAND(CAST(64, MSB(READ_REG(pkt, Rd_op, true)), READ_REG(pkt, Rd_op, true)), op_NOT_265);
	RzILOpPure *op_RSHIFT_376 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_379 = LOGAND(op_RSHIFT_376, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_385 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_388 = LOGAND(op_RSHIFT_385, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_391 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_379), DUP(op_AND_379))), CAST(16, MSB(DUP(op_AND_379)), DUP(op_AND_379))), CAST(32, MSB(CAST(16, MSB(op_AND_388), DUP(op_AND_388))), CAST(16, MSB(DUP(op_AND_388)), DUP(op_AND_388))));
	RzILOpPure *op_LSHIFT_394 = SHIFTL0(CAST(64, MSB(op_MUL_391), DUP(op_MUL_391)), SN(32, 0));
	RzILOpPure *op_RSHIFT_398 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_401 = LOGAND(op_RSHIFT_398, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_407 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_410 = LOGAND(op_RSHIFT_407, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_413 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_401), DUP(op_AND_401))), CAST(16, MSB(DUP(op_AND_401)), DUP(op_AND_401))), CAST(32, MSB(CAST(16, MSB(op_AND_410), DUP(op_AND_410))), CAST(16, MSB(DUP(op_AND_410)), DUP(op_AND_410))));
	RzILOpPure *op_LSHIFT_416 = SHIFTL0(CAST(64, MSB(op_MUL_413), DUP(op_MUL_413)), SN(32, 0));
	RzILOpPure *op_ADD_417 = ADD(op_LSHIFT_394, op_LSHIFT_416);
	RzILOpPure *op_ADD_420 = ADD(op_ADD_417, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *cond_494 = ITE(DUP(op_EQ_372), op_ADD_420, VARL("h_tmp384"));
	RzILOpPure *op_RSHIFT_498 = SHIFTRA(cond_494, SN(32, 16));
	RzILOpPure *op_AND_501 = LOGAND(op_RSHIFT_498, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_AND_505 = LOGAND(CAST(32, MSB(CAST(16, MSB(op_AND_501), DUP(op_AND_501))), CAST(16, MSB(DUP(op_AND_501)), DUP(op_AND_501))), SN(32, 0xffff));
	RzILOpPure *op_LSHIFT_510 = SHIFTL0(CAST(64, IL_FALSE, op_AND_505), SN(32, 16));
	RzILOpPure *op_OR_512 = LOGOR(CAST(64, IL_FALSE, op_AND_267), op_LSHIFT_510);
	RzILOpEffect *op_ASSIGN_514 = WRITE_REG(bundle, Rd_op, CAST(32, IL_FALSE, op_OR_512));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_515 = SEQN(2, seq_493, op_ASSIGN_514);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_258, seq_515);
	return instruction_sequence;
}

// Rd = vdmpy(Rss,Rtt):<<1:rnd:sat
RzILOpEffect *hex_il_op_m2_vdmpyrs_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_166 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_16 = SHIFTRA(Rss, SN(32, 0));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_16, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_26 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_29 = LOGAND(op_RSHIFT_26, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_32 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))), CAST(32, MSB(CAST(16, MSB(op_AND_29), DUP(op_AND_29))), CAST(16, MSB(DUP(op_AND_29)), DUP(op_AND_29))));
	RzILOpPure *op_LSHIFT_35 = SHIFTL0(CAST(64, MSB(op_MUL_32), DUP(op_MUL_32)), SN(32, 1));
	RzILOpPure *op_RSHIFT_39 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_42 = LOGAND(op_RSHIFT_39, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_48 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_51 = LOGAND(op_RSHIFT_48, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_54 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_42), DUP(op_AND_42))), CAST(16, MSB(DUP(op_AND_42)), DUP(op_AND_42))), CAST(32, MSB(CAST(16, MSB(op_AND_51), DUP(op_AND_51))), CAST(16, MSB(DUP(op_AND_51)), DUP(op_AND_51))));
	RzILOpPure *op_LSHIFT_57 = SHIFTL0(CAST(64, MSB(op_MUL_54), DUP(op_MUL_54)), SN(32, 1));
	RzILOpPure *op_ADD_58 = ADD(op_LSHIFT_35, op_LSHIFT_57);
	RzILOpPure *op_ADD_61 = ADD(op_ADD_58, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_70 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_73 = LOGAND(op_RSHIFT_70, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_79 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_82 = LOGAND(op_RSHIFT_79, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_85 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_73), DUP(op_AND_73))), CAST(16, MSB(DUP(op_AND_73)), DUP(op_AND_73))), CAST(32, MSB(CAST(16, MSB(op_AND_82), DUP(op_AND_82))), CAST(16, MSB(DUP(op_AND_82)), DUP(op_AND_82))));
	RzILOpPure *op_LSHIFT_88 = SHIFTL0(CAST(64, MSB(op_MUL_85), DUP(op_MUL_85)), SN(32, 1));
	RzILOpPure *op_RSHIFT_92 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_95 = LOGAND(op_RSHIFT_92, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_101 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_104 = LOGAND(op_RSHIFT_101, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_107 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_95), DUP(op_AND_95))), CAST(16, MSB(DUP(op_AND_95)), DUP(op_AND_95))), CAST(32, MSB(CAST(16, MSB(op_AND_104), DUP(op_AND_104))), CAST(16, MSB(DUP(op_AND_104)), DUP(op_AND_104))));
	RzILOpPure *op_LSHIFT_110 = SHIFTL0(CAST(64, MSB(op_MUL_107), DUP(op_MUL_107)), SN(32, 1));
	RzILOpPure *op_ADD_111 = ADD(op_LSHIFT_88, op_LSHIFT_110);
	RzILOpPure *op_ADD_114 = ADD(op_ADD_111, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_EQ_115 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_61), SN(32, 0), SN(32, 0x20)), op_ADD_114);
	RzILOpPure *op_RSHIFT_170 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_173 = LOGAND(op_RSHIFT_170, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_179 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_182 = LOGAND(op_RSHIFT_179, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_185 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_173), DUP(op_AND_173))), CAST(16, MSB(DUP(op_AND_173)), DUP(op_AND_173))), CAST(32, MSB(CAST(16, MSB(op_AND_182), DUP(op_AND_182))), CAST(16, MSB(DUP(op_AND_182)), DUP(op_AND_182))));
	RzILOpPure *op_LSHIFT_188 = SHIFTL0(CAST(64, MSB(op_MUL_185), DUP(op_MUL_185)), SN(32, 1));
	RzILOpPure *op_RSHIFT_192 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_195 = LOGAND(op_RSHIFT_192, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_201 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_204 = LOGAND(op_RSHIFT_201, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_207 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_195), DUP(op_AND_195))), CAST(16, MSB(DUP(op_AND_195)), DUP(op_AND_195))), CAST(32, MSB(CAST(16, MSB(op_AND_204), DUP(op_AND_204))), CAST(16, MSB(DUP(op_AND_204)), DUP(op_AND_204))));
	RzILOpPure *op_LSHIFT_210 = SHIFTL0(CAST(64, MSB(op_MUL_207), DUP(op_MUL_207)), SN(32, 1));
	RzILOpPure *op_ADD_211 = ADD(op_LSHIFT_188, op_LSHIFT_210);
	RzILOpPure *op_ADD_214 = ADD(op_ADD_211, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_LT_217 = SLT(op_ADD_214, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_222 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_223 = NEG(op_LSHIFT_222);
	RzILOpPure *op_LSHIFT_228 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_231 = SUB(op_LSHIFT_228, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_232 = ITE(op_LT_217, op_NEG_223, op_SUB_231);
	RzILOpEffect *gcc_expr_233 = BRANCH(op_EQ_115, EMPTY(), set_usr_field_call_166);

	// h_tmp385 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_235 = SETL("h_tmp385", cond_232);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_236 = SEQN(2, gcc_expr_233, op_ASSIGN_hybrid_tmp_235);

	// Rd = ((st32) (((ut64) (((st64) Rd) & (~(0xffff << 0x0)))) | (((ut64) (((st32) ((st16) ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000)) ? (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000) : h_tmp385) >> 0x10) & ((st64) 0xffff)))) & 0xffff)) << 0x0)));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffff), SN(32, 0));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_8 = LOGAND(CAST(64, MSB(READ_REG(pkt, Rd_op, true)), READ_REG(pkt, Rd_op, true)), op_NOT_6);
	RzILOpPure *op_RSHIFT_119 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_122 = LOGAND(op_RSHIFT_119, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_128 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_131 = LOGAND(op_RSHIFT_128, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_134 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_122), DUP(op_AND_122))), CAST(16, MSB(DUP(op_AND_122)), DUP(op_AND_122))), CAST(32, MSB(CAST(16, MSB(op_AND_131), DUP(op_AND_131))), CAST(16, MSB(DUP(op_AND_131)), DUP(op_AND_131))));
	RzILOpPure *op_LSHIFT_137 = SHIFTL0(CAST(64, MSB(op_MUL_134), DUP(op_MUL_134)), SN(32, 1));
	RzILOpPure *op_RSHIFT_141 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_144 = LOGAND(op_RSHIFT_141, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_150 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_153 = LOGAND(op_RSHIFT_150, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_156 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_144), DUP(op_AND_144))), CAST(16, MSB(DUP(op_AND_144)), DUP(op_AND_144))), CAST(32, MSB(CAST(16, MSB(op_AND_153), DUP(op_AND_153))), CAST(16, MSB(DUP(op_AND_153)), DUP(op_AND_153))));
	RzILOpPure *op_LSHIFT_159 = SHIFTL0(CAST(64, MSB(op_MUL_156), DUP(op_MUL_156)), SN(32, 1));
	RzILOpPure *op_ADD_160 = ADD(op_LSHIFT_137, op_LSHIFT_159);
	RzILOpPure *op_ADD_163 = ADD(op_ADD_160, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *cond_237 = ITE(DUP(op_EQ_115), op_ADD_163, VARL("h_tmp385"));
	RzILOpPure *op_RSHIFT_241 = SHIFTRA(cond_237, SN(32, 16));
	RzILOpPure *op_AND_244 = LOGAND(op_RSHIFT_241, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_AND_248 = LOGAND(CAST(32, MSB(CAST(16, MSB(op_AND_244), DUP(op_AND_244))), CAST(16, MSB(DUP(op_AND_244)), DUP(op_AND_244))), SN(32, 0xffff));
	RzILOpPure *op_LSHIFT_253 = SHIFTL0(CAST(64, IL_FALSE, op_AND_248), SN(32, 0));
	RzILOpPure *op_OR_255 = LOGOR(CAST(64, IL_FALSE, op_AND_8), op_LSHIFT_253);
	RzILOpEffect *op_ASSIGN_257 = WRITE_REG(bundle, Rd_op, CAST(32, IL_FALSE, op_OR_255));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_258 = SEQN(2, seq_236, op_ASSIGN_257);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_423 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_274 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_277 = LOGAND(op_RSHIFT_274, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_283 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_286 = LOGAND(op_RSHIFT_283, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_289 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_277), DUP(op_AND_277))), CAST(16, MSB(DUP(op_AND_277)), DUP(op_AND_277))), CAST(32, MSB(CAST(16, MSB(op_AND_286), DUP(op_AND_286))), CAST(16, MSB(DUP(op_AND_286)), DUP(op_AND_286))));
	RzILOpPure *op_LSHIFT_292 = SHIFTL0(CAST(64, MSB(op_MUL_289), DUP(op_MUL_289)), SN(32, 1));
	RzILOpPure *op_RSHIFT_296 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_299 = LOGAND(op_RSHIFT_296, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_305 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_308 = LOGAND(op_RSHIFT_305, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_311 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_299), DUP(op_AND_299))), CAST(16, MSB(DUP(op_AND_299)), DUP(op_AND_299))), CAST(32, MSB(CAST(16, MSB(op_AND_308), DUP(op_AND_308))), CAST(16, MSB(DUP(op_AND_308)), DUP(op_AND_308))));
	RzILOpPure *op_LSHIFT_314 = SHIFTL0(CAST(64, MSB(op_MUL_311), DUP(op_MUL_311)), SN(32, 1));
	RzILOpPure *op_ADD_315 = ADD(op_LSHIFT_292, op_LSHIFT_314);
	RzILOpPure *op_ADD_318 = ADD(op_ADD_315, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_327 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_330 = LOGAND(op_RSHIFT_327, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_336 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_339 = LOGAND(op_RSHIFT_336, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_342 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_330), DUP(op_AND_330))), CAST(16, MSB(DUP(op_AND_330)), DUP(op_AND_330))), CAST(32, MSB(CAST(16, MSB(op_AND_339), DUP(op_AND_339))), CAST(16, MSB(DUP(op_AND_339)), DUP(op_AND_339))));
	RzILOpPure *op_LSHIFT_345 = SHIFTL0(CAST(64, MSB(op_MUL_342), DUP(op_MUL_342)), SN(32, 1));
	RzILOpPure *op_RSHIFT_349 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_352 = LOGAND(op_RSHIFT_349, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_358 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_361 = LOGAND(op_RSHIFT_358, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_364 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_352), DUP(op_AND_352))), CAST(16, MSB(DUP(op_AND_352)), DUP(op_AND_352))), CAST(32, MSB(CAST(16, MSB(op_AND_361), DUP(op_AND_361))), CAST(16, MSB(DUP(op_AND_361)), DUP(op_AND_361))));
	RzILOpPure *op_LSHIFT_367 = SHIFTL0(CAST(64, MSB(op_MUL_364), DUP(op_MUL_364)), SN(32, 1));
	RzILOpPure *op_ADD_368 = ADD(op_LSHIFT_345, op_LSHIFT_367);
	RzILOpPure *op_ADD_371 = ADD(op_ADD_368, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_EQ_372 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_318), SN(32, 0), SN(32, 0x20)), op_ADD_371);
	RzILOpPure *op_RSHIFT_427 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_430 = LOGAND(op_RSHIFT_427, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_436 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_439 = LOGAND(op_RSHIFT_436, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_442 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_430), DUP(op_AND_430))), CAST(16, MSB(DUP(op_AND_430)), DUP(op_AND_430))), CAST(32, MSB(CAST(16, MSB(op_AND_439), DUP(op_AND_439))), CAST(16, MSB(DUP(op_AND_439)), DUP(op_AND_439))));
	RzILOpPure *op_LSHIFT_445 = SHIFTL0(CAST(64, MSB(op_MUL_442), DUP(op_MUL_442)), SN(32, 1));
	RzILOpPure *op_RSHIFT_449 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_452 = LOGAND(op_RSHIFT_449, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_458 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_461 = LOGAND(op_RSHIFT_458, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_464 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_452), DUP(op_AND_452))), CAST(16, MSB(DUP(op_AND_452)), DUP(op_AND_452))), CAST(32, MSB(CAST(16, MSB(op_AND_461), DUP(op_AND_461))), CAST(16, MSB(DUP(op_AND_461)), DUP(op_AND_461))));
	RzILOpPure *op_LSHIFT_467 = SHIFTL0(CAST(64, MSB(op_MUL_464), DUP(op_MUL_464)), SN(32, 1));
	RzILOpPure *op_ADD_468 = ADD(op_LSHIFT_445, op_LSHIFT_467);
	RzILOpPure *op_ADD_471 = ADD(op_ADD_468, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_LT_474 = SLT(op_ADD_471, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_479 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_480 = NEG(op_LSHIFT_479);
	RzILOpPure *op_LSHIFT_485 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_488 = SUB(op_LSHIFT_485, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_489 = ITE(op_LT_474, op_NEG_480, op_SUB_488);
	RzILOpEffect *gcc_expr_490 = BRANCH(op_EQ_372, EMPTY(), set_usr_field_call_423);

	// h_tmp386 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_492 = SETL("h_tmp386", cond_489);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_493 = SEQN(2, gcc_expr_490, op_ASSIGN_hybrid_tmp_492);

	// Rd = ((st32) (((ut64) (((st64) Rd) & (~(0xffff << 0x10)))) | (((ut64) (((st32) ((st16) ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000)) ? (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000) : h_tmp386) >> 0x10) & ((st64) 0xffff)))) & 0xffff)) << 0x10)));
	RzILOpPure *op_LSHIFT_264 = SHIFTL0(SN(64, 0xffff), SN(32, 16));
	RzILOpPure *op_NOT_265 = LOGNOT(op_LSHIFT_264);
	RzILOpPure *op_AND_267 = LOGAND(CAST(64, MSB(READ_REG(pkt, Rd_op, true)), READ_REG(pkt, Rd_op, true)), op_NOT_265);
	RzILOpPure *op_RSHIFT_376 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_379 = LOGAND(op_RSHIFT_376, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_385 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_388 = LOGAND(op_RSHIFT_385, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_391 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_379), DUP(op_AND_379))), CAST(16, MSB(DUP(op_AND_379)), DUP(op_AND_379))), CAST(32, MSB(CAST(16, MSB(op_AND_388), DUP(op_AND_388))), CAST(16, MSB(DUP(op_AND_388)), DUP(op_AND_388))));
	RzILOpPure *op_LSHIFT_394 = SHIFTL0(CAST(64, MSB(op_MUL_391), DUP(op_MUL_391)), SN(32, 1));
	RzILOpPure *op_RSHIFT_398 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_401 = LOGAND(op_RSHIFT_398, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_407 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_410 = LOGAND(op_RSHIFT_407, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_413 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_401), DUP(op_AND_401))), CAST(16, MSB(DUP(op_AND_401)), DUP(op_AND_401))), CAST(32, MSB(CAST(16, MSB(op_AND_410), DUP(op_AND_410))), CAST(16, MSB(DUP(op_AND_410)), DUP(op_AND_410))));
	RzILOpPure *op_LSHIFT_416 = SHIFTL0(CAST(64, MSB(op_MUL_413), DUP(op_MUL_413)), SN(32, 1));
	RzILOpPure *op_ADD_417 = ADD(op_LSHIFT_394, op_LSHIFT_416);
	RzILOpPure *op_ADD_420 = ADD(op_ADD_417, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *cond_494 = ITE(DUP(op_EQ_372), op_ADD_420, VARL("h_tmp386"));
	RzILOpPure *op_RSHIFT_498 = SHIFTRA(cond_494, SN(32, 16));
	RzILOpPure *op_AND_501 = LOGAND(op_RSHIFT_498, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_AND_505 = LOGAND(CAST(32, MSB(CAST(16, MSB(op_AND_501), DUP(op_AND_501))), CAST(16, MSB(DUP(op_AND_501)), DUP(op_AND_501))), SN(32, 0xffff));
	RzILOpPure *op_LSHIFT_510 = SHIFTL0(CAST(64, IL_FALSE, op_AND_505), SN(32, 16));
	RzILOpPure *op_OR_512 = LOGOR(CAST(64, IL_FALSE, op_AND_267), op_LSHIFT_510);
	RzILOpEffect *op_ASSIGN_514 = WRITE_REG(bundle, Rd_op, CAST(32, IL_FALSE, op_OR_512));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_515 = SEQN(2, seq_493, op_ASSIGN_514);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_258, seq_515);
	return instruction_sequence;
}

// Rdd = vdmpy(Rss,Rtt):sat
RzILOpEffect *hex_il_op_m2_vdmpys_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_156 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rss, SN(32, 0));
	RzILOpPure *op_AND_18 = LOGAND(op_RSHIFT_15, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_25 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_28 = LOGAND(op_RSHIFT_25, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_31 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_18), DUP(op_AND_18))), CAST(16, MSB(DUP(op_AND_18)), DUP(op_AND_18))), CAST(32, MSB(CAST(16, MSB(op_AND_28), DUP(op_AND_28))), CAST(16, MSB(DUP(op_AND_28)), DUP(op_AND_28))));
	RzILOpPure *op_LSHIFT_34 = SHIFTL0(CAST(64, MSB(op_MUL_31), DUP(op_MUL_31)), SN(32, 0));
	RzILOpPure *op_RSHIFT_38 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_41 = LOGAND(op_RSHIFT_38, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_47 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_50 = LOGAND(op_RSHIFT_47, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_53 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_41), DUP(op_AND_41))), CAST(16, MSB(DUP(op_AND_41)), DUP(op_AND_41))), CAST(32, MSB(CAST(16, MSB(op_AND_50), DUP(op_AND_50))), CAST(16, MSB(DUP(op_AND_50)), DUP(op_AND_50))));
	RzILOpPure *op_LSHIFT_56 = SHIFTL0(CAST(64, MSB(op_MUL_53), DUP(op_MUL_53)), SN(32, 0));
	RzILOpPure *op_ADD_57 = ADD(op_LSHIFT_34, op_LSHIFT_56);
	RzILOpPure *op_RSHIFT_66 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_69 = LOGAND(op_RSHIFT_66, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_75 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_78 = LOGAND(op_RSHIFT_75, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_81 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_69), DUP(op_AND_69))), CAST(16, MSB(DUP(op_AND_69)), DUP(op_AND_69))), CAST(32, MSB(CAST(16, MSB(op_AND_78), DUP(op_AND_78))), CAST(16, MSB(DUP(op_AND_78)), DUP(op_AND_78))));
	RzILOpPure *op_LSHIFT_84 = SHIFTL0(CAST(64, MSB(op_MUL_81), DUP(op_MUL_81)), SN(32, 0));
	RzILOpPure *op_RSHIFT_88 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_91 = LOGAND(op_RSHIFT_88, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_97 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_100 = LOGAND(op_RSHIFT_97, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_103 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_91), DUP(op_AND_91))), CAST(16, MSB(DUP(op_AND_91)), DUP(op_AND_91))), CAST(32, MSB(CAST(16, MSB(op_AND_100), DUP(op_AND_100))), CAST(16, MSB(DUP(op_AND_100)), DUP(op_AND_100))));
	RzILOpPure *op_LSHIFT_106 = SHIFTL0(CAST(64, MSB(op_MUL_103), DUP(op_MUL_103)), SN(32, 0));
	RzILOpPure *op_ADD_107 = ADD(op_LSHIFT_84, op_LSHIFT_106);
	RzILOpPure *op_EQ_108 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_57), SN(32, 0), SN(32, 0x20)), op_ADD_107);
	RzILOpPure *op_RSHIFT_160 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_163 = LOGAND(op_RSHIFT_160, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_169 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_172 = LOGAND(op_RSHIFT_169, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_175 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_163), DUP(op_AND_163))), CAST(16, MSB(DUP(op_AND_163)), DUP(op_AND_163))), CAST(32, MSB(CAST(16, MSB(op_AND_172), DUP(op_AND_172))), CAST(16, MSB(DUP(op_AND_172)), DUP(op_AND_172))));
	RzILOpPure *op_LSHIFT_178 = SHIFTL0(CAST(64, MSB(op_MUL_175), DUP(op_MUL_175)), SN(32, 0));
	RzILOpPure *op_RSHIFT_182 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_185 = LOGAND(op_RSHIFT_182, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_191 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_194 = LOGAND(op_RSHIFT_191, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_197 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_185), DUP(op_AND_185))), CAST(16, MSB(DUP(op_AND_185)), DUP(op_AND_185))), CAST(32, MSB(CAST(16, MSB(op_AND_194), DUP(op_AND_194))), CAST(16, MSB(DUP(op_AND_194)), DUP(op_AND_194))));
	RzILOpPure *op_LSHIFT_200 = SHIFTL0(CAST(64, MSB(op_MUL_197), DUP(op_MUL_197)), SN(32, 0));
	RzILOpPure *op_ADD_201 = ADD(op_LSHIFT_178, op_LSHIFT_200);
	RzILOpPure *op_LT_204 = SLT(op_ADD_201, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_209 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_210 = NEG(op_LSHIFT_209);
	RzILOpPure *op_LSHIFT_215 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_218 = SUB(op_LSHIFT_215, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_219 = ITE(op_LT_204, op_NEG_210, op_SUB_218);
	RzILOpEffect *gcc_expr_220 = BRANCH(op_EQ_108, EMPTY(), set_usr_field_call_156);

	// h_tmp387 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_222 = SETL("h_tmp387", cond_219);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_223 = SEQN(2, gcc_expr_220, op_ASSIGN_hybrid_tmp_222);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0)) ? (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x0) : h_tmp387) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_112 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_115 = LOGAND(op_RSHIFT_112, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_121 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_124 = LOGAND(op_RSHIFT_121, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_127 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_115), DUP(op_AND_115))), CAST(16, MSB(DUP(op_AND_115)), DUP(op_AND_115))), CAST(32, MSB(CAST(16, MSB(op_AND_124), DUP(op_AND_124))), CAST(16, MSB(DUP(op_AND_124)), DUP(op_AND_124))));
	RzILOpPure *op_LSHIFT_130 = SHIFTL0(CAST(64, MSB(op_MUL_127), DUP(op_MUL_127)), SN(32, 0));
	RzILOpPure *op_RSHIFT_134 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_137 = LOGAND(op_RSHIFT_134, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_143 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_146 = LOGAND(op_RSHIFT_143, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_149 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_137), DUP(op_AND_137))), CAST(16, MSB(DUP(op_AND_137)), DUP(op_AND_137))), CAST(32, MSB(CAST(16, MSB(op_AND_146), DUP(op_AND_146))), CAST(16, MSB(DUP(op_AND_146)), DUP(op_AND_146))));
	RzILOpPure *op_LSHIFT_152 = SHIFTL0(CAST(64, MSB(op_MUL_149), DUP(op_MUL_149)), SN(32, 0));
	RzILOpPure *op_ADD_153 = ADD(op_LSHIFT_130, op_LSHIFT_152);
	RzILOpPure *cond_224 = ITE(DUP(op_EQ_108), op_ADD_153, VARL("h_tmp387"));
	RzILOpPure *op_AND_226 = LOGAND(cond_224, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_230 = SHIFTL0(op_AND_226, SN(32, 0));
	RzILOpPure *op_OR_231 = LOGOR(op_AND_7, op_LSHIFT_230);
	RzILOpEffect *op_ASSIGN_232 = WRITE_REG(bundle, Rdd_op, op_OR_231);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_233 = SEQN(2, seq_223, op_ASSIGN_232);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_388 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_248 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_251 = LOGAND(op_RSHIFT_248, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_257 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_260 = LOGAND(op_RSHIFT_257, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_263 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_251), DUP(op_AND_251))), CAST(16, MSB(DUP(op_AND_251)), DUP(op_AND_251))), CAST(32, MSB(CAST(16, MSB(op_AND_260), DUP(op_AND_260))), CAST(16, MSB(DUP(op_AND_260)), DUP(op_AND_260))));
	RzILOpPure *op_LSHIFT_266 = SHIFTL0(CAST(64, MSB(op_MUL_263), DUP(op_MUL_263)), SN(32, 0));
	RzILOpPure *op_RSHIFT_270 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_273 = LOGAND(op_RSHIFT_270, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_279 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_282 = LOGAND(op_RSHIFT_279, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_285 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_273), DUP(op_AND_273))), CAST(16, MSB(DUP(op_AND_273)), DUP(op_AND_273))), CAST(32, MSB(CAST(16, MSB(op_AND_282), DUP(op_AND_282))), CAST(16, MSB(DUP(op_AND_282)), DUP(op_AND_282))));
	RzILOpPure *op_LSHIFT_288 = SHIFTL0(CAST(64, MSB(op_MUL_285), DUP(op_MUL_285)), SN(32, 0));
	RzILOpPure *op_ADD_289 = ADD(op_LSHIFT_266, op_LSHIFT_288);
	RzILOpPure *op_RSHIFT_298 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_301 = LOGAND(op_RSHIFT_298, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_307 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_310 = LOGAND(op_RSHIFT_307, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_313 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_301), DUP(op_AND_301))), CAST(16, MSB(DUP(op_AND_301)), DUP(op_AND_301))), CAST(32, MSB(CAST(16, MSB(op_AND_310), DUP(op_AND_310))), CAST(16, MSB(DUP(op_AND_310)), DUP(op_AND_310))));
	RzILOpPure *op_LSHIFT_316 = SHIFTL0(CAST(64, MSB(op_MUL_313), DUP(op_MUL_313)), SN(32, 0));
	RzILOpPure *op_RSHIFT_320 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_323 = LOGAND(op_RSHIFT_320, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_329 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_332 = LOGAND(op_RSHIFT_329, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_335 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_323), DUP(op_AND_323))), CAST(16, MSB(DUP(op_AND_323)), DUP(op_AND_323))), CAST(32, MSB(CAST(16, MSB(op_AND_332), DUP(op_AND_332))), CAST(16, MSB(DUP(op_AND_332)), DUP(op_AND_332))));
	RzILOpPure *op_LSHIFT_338 = SHIFTL0(CAST(64, MSB(op_MUL_335), DUP(op_MUL_335)), SN(32, 0));
	RzILOpPure *op_ADD_339 = ADD(op_LSHIFT_316, op_LSHIFT_338);
	RzILOpPure *op_EQ_340 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_289), SN(32, 0), SN(32, 0x20)), op_ADD_339);
	RzILOpPure *op_RSHIFT_392 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_395 = LOGAND(op_RSHIFT_392, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_401 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_404 = LOGAND(op_RSHIFT_401, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_407 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_395), DUP(op_AND_395))), CAST(16, MSB(DUP(op_AND_395)), DUP(op_AND_395))), CAST(32, MSB(CAST(16, MSB(op_AND_404), DUP(op_AND_404))), CAST(16, MSB(DUP(op_AND_404)), DUP(op_AND_404))));
	RzILOpPure *op_LSHIFT_410 = SHIFTL0(CAST(64, MSB(op_MUL_407), DUP(op_MUL_407)), SN(32, 0));
	RzILOpPure *op_RSHIFT_414 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_417 = LOGAND(op_RSHIFT_414, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_423 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_426 = LOGAND(op_RSHIFT_423, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_429 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_417), DUP(op_AND_417))), CAST(16, MSB(DUP(op_AND_417)), DUP(op_AND_417))), CAST(32, MSB(CAST(16, MSB(op_AND_426), DUP(op_AND_426))), CAST(16, MSB(DUP(op_AND_426)), DUP(op_AND_426))));
	RzILOpPure *op_LSHIFT_432 = SHIFTL0(CAST(64, MSB(op_MUL_429), DUP(op_MUL_429)), SN(32, 0));
	RzILOpPure *op_ADD_433 = ADD(op_LSHIFT_410, op_LSHIFT_432);
	RzILOpPure *op_LT_436 = SLT(op_ADD_433, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_441 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_442 = NEG(op_LSHIFT_441);
	RzILOpPure *op_LSHIFT_447 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_450 = SUB(op_LSHIFT_447, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_451 = ITE(op_LT_436, op_NEG_442, op_SUB_450);
	RzILOpEffect *gcc_expr_452 = BRANCH(op_EQ_340, EMPTY(), set_usr_field_call_388);

	// h_tmp388 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_454 = SETL("h_tmp388", cond_451);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_455 = SEQN(2, gcc_expr_452, op_ASSIGN_hybrid_tmp_454);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0)) ? (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x0) : h_tmp388) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_239 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_240 = LOGNOT(op_LSHIFT_239);
	RzILOpPure *op_AND_241 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_240);
	RzILOpPure *op_RSHIFT_344 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_347 = LOGAND(op_RSHIFT_344, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_353 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_356 = LOGAND(op_RSHIFT_353, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_359 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_347), DUP(op_AND_347))), CAST(16, MSB(DUP(op_AND_347)), DUP(op_AND_347))), CAST(32, MSB(CAST(16, MSB(op_AND_356), DUP(op_AND_356))), CAST(16, MSB(DUP(op_AND_356)), DUP(op_AND_356))));
	RzILOpPure *op_LSHIFT_362 = SHIFTL0(CAST(64, MSB(op_MUL_359), DUP(op_MUL_359)), SN(32, 0));
	RzILOpPure *op_RSHIFT_366 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_369 = LOGAND(op_RSHIFT_366, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_375 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_378 = LOGAND(op_RSHIFT_375, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_381 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_369), DUP(op_AND_369))), CAST(16, MSB(DUP(op_AND_369)), DUP(op_AND_369))), CAST(32, MSB(CAST(16, MSB(op_AND_378), DUP(op_AND_378))), CAST(16, MSB(DUP(op_AND_378)), DUP(op_AND_378))));
	RzILOpPure *op_LSHIFT_384 = SHIFTL0(CAST(64, MSB(op_MUL_381), DUP(op_MUL_381)), SN(32, 0));
	RzILOpPure *op_ADD_385 = ADD(op_LSHIFT_362, op_LSHIFT_384);
	RzILOpPure *cond_456 = ITE(DUP(op_EQ_340), op_ADD_385, VARL("h_tmp388"));
	RzILOpPure *op_AND_458 = LOGAND(cond_456, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_462 = SHIFTL0(op_AND_458, SN(32, 0x20));
	RzILOpPure *op_OR_463 = LOGOR(op_AND_241, op_LSHIFT_462);
	RzILOpEffect *op_ASSIGN_464 = WRITE_REG(bundle, Rdd_op, op_OR_463);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_465 = SEQN(2, seq_455, op_ASSIGN_464);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_233, seq_465);
	return instruction_sequence;
}

// Rdd = vdmpy(Rss,Rtt):<<1:sat
RzILOpEffect *hex_il_op_m2_vdmpys_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_156 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rss, SN(32, 0));
	RzILOpPure *op_AND_18 = LOGAND(op_RSHIFT_15, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_25 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_28 = LOGAND(op_RSHIFT_25, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_31 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_18), DUP(op_AND_18))), CAST(16, MSB(DUP(op_AND_18)), DUP(op_AND_18))), CAST(32, MSB(CAST(16, MSB(op_AND_28), DUP(op_AND_28))), CAST(16, MSB(DUP(op_AND_28)), DUP(op_AND_28))));
	RzILOpPure *op_LSHIFT_34 = SHIFTL0(CAST(64, MSB(op_MUL_31), DUP(op_MUL_31)), SN(32, 1));
	RzILOpPure *op_RSHIFT_38 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_41 = LOGAND(op_RSHIFT_38, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_47 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_50 = LOGAND(op_RSHIFT_47, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_53 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_41), DUP(op_AND_41))), CAST(16, MSB(DUP(op_AND_41)), DUP(op_AND_41))), CAST(32, MSB(CAST(16, MSB(op_AND_50), DUP(op_AND_50))), CAST(16, MSB(DUP(op_AND_50)), DUP(op_AND_50))));
	RzILOpPure *op_LSHIFT_56 = SHIFTL0(CAST(64, MSB(op_MUL_53), DUP(op_MUL_53)), SN(32, 1));
	RzILOpPure *op_ADD_57 = ADD(op_LSHIFT_34, op_LSHIFT_56);
	RzILOpPure *op_RSHIFT_66 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_69 = LOGAND(op_RSHIFT_66, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_75 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_78 = LOGAND(op_RSHIFT_75, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_81 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_69), DUP(op_AND_69))), CAST(16, MSB(DUP(op_AND_69)), DUP(op_AND_69))), CAST(32, MSB(CAST(16, MSB(op_AND_78), DUP(op_AND_78))), CAST(16, MSB(DUP(op_AND_78)), DUP(op_AND_78))));
	RzILOpPure *op_LSHIFT_84 = SHIFTL0(CAST(64, MSB(op_MUL_81), DUP(op_MUL_81)), SN(32, 1));
	RzILOpPure *op_RSHIFT_88 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_91 = LOGAND(op_RSHIFT_88, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_97 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_100 = LOGAND(op_RSHIFT_97, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_103 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_91), DUP(op_AND_91))), CAST(16, MSB(DUP(op_AND_91)), DUP(op_AND_91))), CAST(32, MSB(CAST(16, MSB(op_AND_100), DUP(op_AND_100))), CAST(16, MSB(DUP(op_AND_100)), DUP(op_AND_100))));
	RzILOpPure *op_LSHIFT_106 = SHIFTL0(CAST(64, MSB(op_MUL_103), DUP(op_MUL_103)), SN(32, 1));
	RzILOpPure *op_ADD_107 = ADD(op_LSHIFT_84, op_LSHIFT_106);
	RzILOpPure *op_EQ_108 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_57), SN(32, 0), SN(32, 0x20)), op_ADD_107);
	RzILOpPure *op_RSHIFT_160 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_163 = LOGAND(op_RSHIFT_160, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_169 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_172 = LOGAND(op_RSHIFT_169, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_175 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_163), DUP(op_AND_163))), CAST(16, MSB(DUP(op_AND_163)), DUP(op_AND_163))), CAST(32, MSB(CAST(16, MSB(op_AND_172), DUP(op_AND_172))), CAST(16, MSB(DUP(op_AND_172)), DUP(op_AND_172))));
	RzILOpPure *op_LSHIFT_178 = SHIFTL0(CAST(64, MSB(op_MUL_175), DUP(op_MUL_175)), SN(32, 1));
	RzILOpPure *op_RSHIFT_182 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_185 = LOGAND(op_RSHIFT_182, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_191 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_194 = LOGAND(op_RSHIFT_191, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_197 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_185), DUP(op_AND_185))), CAST(16, MSB(DUP(op_AND_185)), DUP(op_AND_185))), CAST(32, MSB(CAST(16, MSB(op_AND_194), DUP(op_AND_194))), CAST(16, MSB(DUP(op_AND_194)), DUP(op_AND_194))));
	RzILOpPure *op_LSHIFT_200 = SHIFTL0(CAST(64, MSB(op_MUL_197), DUP(op_MUL_197)), SN(32, 1));
	RzILOpPure *op_ADD_201 = ADD(op_LSHIFT_178, op_LSHIFT_200);
	RzILOpPure *op_LT_204 = SLT(op_ADD_201, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_209 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_210 = NEG(op_LSHIFT_209);
	RzILOpPure *op_LSHIFT_215 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_218 = SUB(op_LSHIFT_215, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_219 = ITE(op_LT_204, op_NEG_210, op_SUB_218);
	RzILOpEffect *gcc_expr_220 = BRANCH(op_EQ_108, EMPTY(), set_usr_field_call_156);

	// h_tmp389 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_222 = SETL("h_tmp389", cond_219);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_223 = SEQN(2, gcc_expr_220, op_ASSIGN_hybrid_tmp_222);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1)) ? (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) << 0x1) : h_tmp389) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_112 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_115 = LOGAND(op_RSHIFT_112, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_121 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_124 = LOGAND(op_RSHIFT_121, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_127 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_115), DUP(op_AND_115))), CAST(16, MSB(DUP(op_AND_115)), DUP(op_AND_115))), CAST(32, MSB(CAST(16, MSB(op_AND_124), DUP(op_AND_124))), CAST(16, MSB(DUP(op_AND_124)), DUP(op_AND_124))));
	RzILOpPure *op_LSHIFT_130 = SHIFTL0(CAST(64, MSB(op_MUL_127), DUP(op_MUL_127)), SN(32, 1));
	RzILOpPure *op_RSHIFT_134 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_137 = LOGAND(op_RSHIFT_134, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_143 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_146 = LOGAND(op_RSHIFT_143, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_149 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_137), DUP(op_AND_137))), CAST(16, MSB(DUP(op_AND_137)), DUP(op_AND_137))), CAST(32, MSB(CAST(16, MSB(op_AND_146), DUP(op_AND_146))), CAST(16, MSB(DUP(op_AND_146)), DUP(op_AND_146))));
	RzILOpPure *op_LSHIFT_152 = SHIFTL0(CAST(64, MSB(op_MUL_149), DUP(op_MUL_149)), SN(32, 1));
	RzILOpPure *op_ADD_153 = ADD(op_LSHIFT_130, op_LSHIFT_152);
	RzILOpPure *cond_224 = ITE(DUP(op_EQ_108), op_ADD_153, VARL("h_tmp389"));
	RzILOpPure *op_AND_226 = LOGAND(cond_224, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_230 = SHIFTL0(op_AND_226, SN(32, 0));
	RzILOpPure *op_OR_231 = LOGOR(op_AND_7, op_LSHIFT_230);
	RzILOpEffect *op_ASSIGN_232 = WRITE_REG(bundle, Rdd_op, op_OR_231);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_233 = SEQN(2, seq_223, op_ASSIGN_232);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_388 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_248 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_251 = LOGAND(op_RSHIFT_248, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_257 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_260 = LOGAND(op_RSHIFT_257, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_263 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_251), DUP(op_AND_251))), CAST(16, MSB(DUP(op_AND_251)), DUP(op_AND_251))), CAST(32, MSB(CAST(16, MSB(op_AND_260), DUP(op_AND_260))), CAST(16, MSB(DUP(op_AND_260)), DUP(op_AND_260))));
	RzILOpPure *op_LSHIFT_266 = SHIFTL0(CAST(64, MSB(op_MUL_263), DUP(op_MUL_263)), SN(32, 1));
	RzILOpPure *op_RSHIFT_270 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_273 = LOGAND(op_RSHIFT_270, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_279 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_282 = LOGAND(op_RSHIFT_279, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_285 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_273), DUP(op_AND_273))), CAST(16, MSB(DUP(op_AND_273)), DUP(op_AND_273))), CAST(32, MSB(CAST(16, MSB(op_AND_282), DUP(op_AND_282))), CAST(16, MSB(DUP(op_AND_282)), DUP(op_AND_282))));
	RzILOpPure *op_LSHIFT_288 = SHIFTL0(CAST(64, MSB(op_MUL_285), DUP(op_MUL_285)), SN(32, 1));
	RzILOpPure *op_ADD_289 = ADD(op_LSHIFT_266, op_LSHIFT_288);
	RzILOpPure *op_RSHIFT_298 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_301 = LOGAND(op_RSHIFT_298, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_307 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_310 = LOGAND(op_RSHIFT_307, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_313 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_301), DUP(op_AND_301))), CAST(16, MSB(DUP(op_AND_301)), DUP(op_AND_301))), CAST(32, MSB(CAST(16, MSB(op_AND_310), DUP(op_AND_310))), CAST(16, MSB(DUP(op_AND_310)), DUP(op_AND_310))));
	RzILOpPure *op_LSHIFT_316 = SHIFTL0(CAST(64, MSB(op_MUL_313), DUP(op_MUL_313)), SN(32, 1));
	RzILOpPure *op_RSHIFT_320 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_323 = LOGAND(op_RSHIFT_320, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_329 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_332 = LOGAND(op_RSHIFT_329, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_335 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_323), DUP(op_AND_323))), CAST(16, MSB(DUP(op_AND_323)), DUP(op_AND_323))), CAST(32, MSB(CAST(16, MSB(op_AND_332), DUP(op_AND_332))), CAST(16, MSB(DUP(op_AND_332)), DUP(op_AND_332))));
	RzILOpPure *op_LSHIFT_338 = SHIFTL0(CAST(64, MSB(op_MUL_335), DUP(op_MUL_335)), SN(32, 1));
	RzILOpPure *op_ADD_339 = ADD(op_LSHIFT_316, op_LSHIFT_338);
	RzILOpPure *op_EQ_340 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_289), SN(32, 0), SN(32, 0x20)), op_ADD_339);
	RzILOpPure *op_RSHIFT_392 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_395 = LOGAND(op_RSHIFT_392, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_401 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_404 = LOGAND(op_RSHIFT_401, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_407 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_395), DUP(op_AND_395))), CAST(16, MSB(DUP(op_AND_395)), DUP(op_AND_395))), CAST(32, MSB(CAST(16, MSB(op_AND_404), DUP(op_AND_404))), CAST(16, MSB(DUP(op_AND_404)), DUP(op_AND_404))));
	RzILOpPure *op_LSHIFT_410 = SHIFTL0(CAST(64, MSB(op_MUL_407), DUP(op_MUL_407)), SN(32, 1));
	RzILOpPure *op_RSHIFT_414 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_417 = LOGAND(op_RSHIFT_414, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_423 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_426 = LOGAND(op_RSHIFT_423, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_429 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_417), DUP(op_AND_417))), CAST(16, MSB(DUP(op_AND_417)), DUP(op_AND_417))), CAST(32, MSB(CAST(16, MSB(op_AND_426), DUP(op_AND_426))), CAST(16, MSB(DUP(op_AND_426)), DUP(op_AND_426))));
	RzILOpPure *op_LSHIFT_432 = SHIFTL0(CAST(64, MSB(op_MUL_429), DUP(op_MUL_429)), SN(32, 1));
	RzILOpPure *op_ADD_433 = ADD(op_LSHIFT_410, op_LSHIFT_432);
	RzILOpPure *op_LT_436 = SLT(op_ADD_433, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_441 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_442 = NEG(op_LSHIFT_441);
	RzILOpPure *op_LSHIFT_447 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_450 = SUB(op_LSHIFT_447, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_451 = ITE(op_LT_436, op_NEG_442, op_SUB_450);
	RzILOpEffect *gcc_expr_452 = BRANCH(op_EQ_340, EMPTY(), set_usr_field_call_388);

	// h_tmp390 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_454 = SETL("h_tmp390", cond_451);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_455 = SEQN(2, gcc_expr_452, op_ASSIGN_hybrid_tmp_454);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1)) ? (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff))))) << 0x1) : h_tmp390) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_239 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_240 = LOGNOT(op_LSHIFT_239);
	RzILOpPure *op_AND_241 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_240);
	RzILOpPure *op_RSHIFT_344 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_347 = LOGAND(op_RSHIFT_344, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_353 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_356 = LOGAND(op_RSHIFT_353, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_359 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_347), DUP(op_AND_347))), CAST(16, MSB(DUP(op_AND_347)), DUP(op_AND_347))), CAST(32, MSB(CAST(16, MSB(op_AND_356), DUP(op_AND_356))), CAST(16, MSB(DUP(op_AND_356)), DUP(op_AND_356))));
	RzILOpPure *op_LSHIFT_362 = SHIFTL0(CAST(64, MSB(op_MUL_359), DUP(op_MUL_359)), SN(32, 1));
	RzILOpPure *op_RSHIFT_366 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_369 = LOGAND(op_RSHIFT_366, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_375 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_378 = LOGAND(op_RSHIFT_375, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_381 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_369), DUP(op_AND_369))), CAST(16, MSB(DUP(op_AND_369)), DUP(op_AND_369))), CAST(32, MSB(CAST(16, MSB(op_AND_378), DUP(op_AND_378))), CAST(16, MSB(DUP(op_AND_378)), DUP(op_AND_378))));
	RzILOpPure *op_LSHIFT_384 = SHIFTL0(CAST(64, MSB(op_MUL_381), DUP(op_MUL_381)), SN(32, 1));
	RzILOpPure *op_ADD_385 = ADD(op_LSHIFT_362, op_LSHIFT_384);
	RzILOpPure *cond_456 = ITE(DUP(op_EQ_340), op_ADD_385, VARL("h_tmp390"));
	RzILOpPure *op_AND_458 = LOGAND(cond_456, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_462 = SHIFTL0(op_AND_458, SN(32, 0x20));
	RzILOpPure *op_OR_463 = LOGOR(op_AND_241, op_LSHIFT_462);
	RzILOpEffect *op_ASSIGN_464 = WRITE_REG(bundle, Rdd_op, op_OR_463);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_465 = SEQN(2, seq_455, op_ASSIGN_464);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_233, seq_465);
	return instruction_sequence;
}

// Rxx += vmpyh(Rs,Rt)
RzILOpEffect *hex_il_op_m2_vmac2(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_11 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_13 = LOGAND(op_RSHIFT_11, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_20 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_22 = LOGAND(op_RSHIFT_20, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_29 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_31 = LOGAND(op_RSHIFT_29, SN(32, 0xffff));
	RzILOpPure *op_MUL_34 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_22), DUP(op_AND_22))), CAST(16, MSB(DUP(op_AND_22)), DUP(op_AND_22))), CAST(32, MSB(CAST(16, MSB(op_AND_31), DUP(op_AND_31))), CAST(16, MSB(DUP(op_AND_31)), DUP(op_AND_31))));
	RzILOpPure *op_ADD_36 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_13), DUP(op_AND_13))), CAST(32, MSB(DUP(op_AND_13)), DUP(op_AND_13))), CAST(64, MSB(op_MUL_34), DUP(op_MUL_34)));
	RzILOpPure *op_AND_38 = LOGAND(op_ADD_36, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_42 = SHIFTL0(op_AND_38, SN(32, 0));
	RzILOpPure *op_OR_43 = LOGOR(op_AND_7, op_LSHIFT_42);
	RzILOpEffect *op_ASSIGN_44 = WRITE_REG(bundle, Rxx_op, op_OR_43);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_50 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_51 = LOGNOT(op_LSHIFT_50);
	RzILOpPure *op_AND_52 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_51);
	RzILOpPure *op_RSHIFT_56 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_58 = LOGAND(op_RSHIFT_56, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_64 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_66 = LOGAND(op_RSHIFT_64, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_72 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_74 = LOGAND(op_RSHIFT_72, SN(32, 0xffff));
	RzILOpPure *op_MUL_77 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_66), DUP(op_AND_66))), CAST(16, MSB(DUP(op_AND_66)), DUP(op_AND_66))), CAST(32, MSB(CAST(16, MSB(op_AND_74), DUP(op_AND_74))), CAST(16, MSB(DUP(op_AND_74)), DUP(op_AND_74))));
	RzILOpPure *op_ADD_79 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_58), DUP(op_AND_58))), CAST(32, MSB(DUP(op_AND_58)), DUP(op_AND_58))), CAST(64, MSB(op_MUL_77), DUP(op_MUL_77)));
	RzILOpPure *op_AND_81 = LOGAND(op_ADD_79, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_85 = SHIFTL0(op_AND_81, SN(32, 0x20));
	RzILOpPure *op_OR_86 = LOGOR(op_AND_52, op_LSHIFT_85);
	RzILOpEffect *op_ASSIGN_87 = WRITE_REG(bundle, Rxx_op, op_OR_86);

	RzILOpEffect *instruction_sequence = SEQN(2, op_ASSIGN_44, op_ASSIGN_87);
	return instruction_sequence;
}

// Rxx += vmpyeh(Rss,Rtt)
RzILOpEffect *hex_il_op_m2_vmac2es(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_11 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_13 = LOGAND(op_RSHIFT_11, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_20 = SHIFTRA(Rss, SN(32, 0));
	RzILOpPure *op_AND_23 = LOGAND(op_RSHIFT_20, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_30 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_33 = LOGAND(op_RSHIFT_30, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_36 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_23), DUP(op_AND_23))), CAST(16, MSB(DUP(op_AND_23)), DUP(op_AND_23))), CAST(32, MSB(CAST(16, MSB(op_AND_33), DUP(op_AND_33))), CAST(16, MSB(DUP(op_AND_33)), DUP(op_AND_33))));
	RzILOpPure *op_ADD_38 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_13), DUP(op_AND_13))), CAST(32, MSB(DUP(op_AND_13)), DUP(op_AND_13))), CAST(64, MSB(op_MUL_36), DUP(op_MUL_36)));
	RzILOpPure *op_AND_40 = LOGAND(op_ADD_38, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_44 = SHIFTL0(op_AND_40, SN(32, 0));
	RzILOpPure *op_OR_45 = LOGOR(op_AND_7, op_LSHIFT_44);
	RzILOpEffect *op_ASSIGN_46 = WRITE_REG(bundle, Rxx_op, op_OR_45);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_52 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_53 = LOGNOT(op_LSHIFT_52);
	RzILOpPure *op_AND_54 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_53);
	RzILOpPure *op_RSHIFT_58 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_60 = LOGAND(op_RSHIFT_58, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_66 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_69 = LOGAND(op_RSHIFT_66, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_75 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_78 = LOGAND(op_RSHIFT_75, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_81 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_69), DUP(op_AND_69))), CAST(16, MSB(DUP(op_AND_69)), DUP(op_AND_69))), CAST(32, MSB(CAST(16, MSB(op_AND_78), DUP(op_AND_78))), CAST(16, MSB(DUP(op_AND_78)), DUP(op_AND_78))));
	RzILOpPure *op_ADD_83 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_60), DUP(op_AND_60))), CAST(32, MSB(DUP(op_AND_60)), DUP(op_AND_60))), CAST(64, MSB(op_MUL_81), DUP(op_MUL_81)));
	RzILOpPure *op_AND_85 = LOGAND(op_ADD_83, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_89 = SHIFTL0(op_AND_85, SN(32, 0x20));
	RzILOpPure *op_OR_90 = LOGOR(op_AND_54, op_LSHIFT_89);
	RzILOpEffect *op_ASSIGN_91 = WRITE_REG(bundle, Rxx_op, op_OR_90);

	RzILOpEffect *instruction_sequence = SEQN(2, op_ASSIGN_46, op_ASSIGN_91);
	return instruction_sequence;
}

// Rxx += vmpyeh(Rss,Rtt):sat
RzILOpEffect *hex_il_op_m2_vmac2es_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_114 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rss, SN(32, 0));
	RzILOpPure *op_AND_26 = LOGAND(op_RSHIFT_23, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_33 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_36 = LOGAND(op_RSHIFT_33, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_39 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_26), DUP(op_AND_26))), CAST(16, MSB(DUP(op_AND_26)), DUP(op_AND_26))), CAST(32, MSB(CAST(16, MSB(op_AND_36), DUP(op_AND_36))), CAST(16, MSB(DUP(op_AND_36)), DUP(op_AND_36))));
	RzILOpPure *op_LSHIFT_42 = SHIFTL0(CAST(64, MSB(op_MUL_39), DUP(op_MUL_39)), SN(32, 0));
	RzILOpPure *op_ADD_43 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_LSHIFT_42);
	RzILOpPure *op_RSHIFT_52 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_54 = LOGAND(op_RSHIFT_52, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_60 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_63 = LOGAND(op_RSHIFT_60, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_69 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_72 = LOGAND(op_RSHIFT_69, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_75 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_63), DUP(op_AND_63))), CAST(16, MSB(DUP(op_AND_63)), DUP(op_AND_63))), CAST(32, MSB(CAST(16, MSB(op_AND_72), DUP(op_AND_72))), CAST(16, MSB(DUP(op_AND_72)), DUP(op_AND_72))));
	RzILOpPure *op_LSHIFT_78 = SHIFTL0(CAST(64, MSB(op_MUL_75), DUP(op_MUL_75)), SN(32, 0));
	RzILOpPure *op_ADD_79 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_54), DUP(op_AND_54))), CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54))), op_LSHIFT_78);
	RzILOpPure *op_EQ_80 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_43), SN(32, 0), SN(32, 0x20)), op_ADD_79);
	RzILOpPure *op_RSHIFT_118 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_120 = LOGAND(op_RSHIFT_118, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_126 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_129 = LOGAND(op_RSHIFT_126, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_135 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_138 = LOGAND(op_RSHIFT_135, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_141 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_129), DUP(op_AND_129))), CAST(16, MSB(DUP(op_AND_129)), DUP(op_AND_129))), CAST(32, MSB(CAST(16, MSB(op_AND_138), DUP(op_AND_138))), CAST(16, MSB(DUP(op_AND_138)), DUP(op_AND_138))));
	RzILOpPure *op_LSHIFT_144 = SHIFTL0(CAST(64, MSB(op_MUL_141), DUP(op_MUL_141)), SN(32, 0));
	RzILOpPure *op_ADD_145 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_120), DUP(op_AND_120))), CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120))), op_LSHIFT_144);
	RzILOpPure *op_LT_148 = SLT(op_ADD_145, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_153 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_154 = NEG(op_LSHIFT_153);
	RzILOpPure *op_LSHIFT_159 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_162 = SUB(op_LSHIFT_159, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_163 = ITE(op_LT_148, op_NEG_154, op_SUB_162);
	RzILOpEffect *gcc_expr_164 = BRANCH(op_EQ_80, EMPTY(), set_usr_field_call_114);

	// h_tmp391 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_166 = SETL("h_tmp391", cond_163);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_167 = SEQN(2, gcc_expr_164, op_ASSIGN_hybrid_tmp_166);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) : h_tmp391) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_84 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_86 = LOGAND(op_RSHIFT_84, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_92 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_95 = LOGAND(op_RSHIFT_92, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_101 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_104 = LOGAND(op_RSHIFT_101, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_107 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_95), DUP(op_AND_95))), CAST(16, MSB(DUP(op_AND_95)), DUP(op_AND_95))), CAST(32, MSB(CAST(16, MSB(op_AND_104), DUP(op_AND_104))), CAST(16, MSB(DUP(op_AND_104)), DUP(op_AND_104))));
	RzILOpPure *op_LSHIFT_110 = SHIFTL0(CAST(64, MSB(op_MUL_107), DUP(op_MUL_107)), SN(32, 0));
	RzILOpPure *op_ADD_111 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_86), DUP(op_AND_86))), CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86))), op_LSHIFT_110);
	RzILOpPure *cond_168 = ITE(DUP(op_EQ_80), op_ADD_111, VARL("h_tmp391"));
	RzILOpPure *op_AND_170 = LOGAND(cond_168, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_174 = SHIFTL0(op_AND_170, SN(32, 0));
	RzILOpPure *op_OR_175 = LOGOR(op_AND_7, op_LSHIFT_174);
	RzILOpEffect *op_ASSIGN_176 = WRITE_REG(bundle, Rxx_op, op_OR_175);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_177 = SEQN(2, seq_167, op_ASSIGN_176);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_290 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_192 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_194 = LOGAND(op_RSHIFT_192, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_200 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_203 = LOGAND(op_RSHIFT_200, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_209 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_212 = LOGAND(op_RSHIFT_209, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_215 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_203), DUP(op_AND_203))), CAST(16, MSB(DUP(op_AND_203)), DUP(op_AND_203))), CAST(32, MSB(CAST(16, MSB(op_AND_212), DUP(op_AND_212))), CAST(16, MSB(DUP(op_AND_212)), DUP(op_AND_212))));
	RzILOpPure *op_LSHIFT_218 = SHIFTL0(CAST(64, MSB(op_MUL_215), DUP(op_MUL_215)), SN(32, 0));
	RzILOpPure *op_ADD_219 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_194), DUP(op_AND_194))), CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194))), op_LSHIFT_218);
	RzILOpPure *op_RSHIFT_228 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_230 = LOGAND(op_RSHIFT_228, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_236 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_239 = LOGAND(op_RSHIFT_236, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_245 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_248 = LOGAND(op_RSHIFT_245, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_251 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_239), DUP(op_AND_239))), CAST(16, MSB(DUP(op_AND_239)), DUP(op_AND_239))), CAST(32, MSB(CAST(16, MSB(op_AND_248), DUP(op_AND_248))), CAST(16, MSB(DUP(op_AND_248)), DUP(op_AND_248))));
	RzILOpPure *op_LSHIFT_254 = SHIFTL0(CAST(64, MSB(op_MUL_251), DUP(op_MUL_251)), SN(32, 0));
	RzILOpPure *op_ADD_255 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_230), DUP(op_AND_230))), CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230))), op_LSHIFT_254);
	RzILOpPure *op_EQ_256 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_219), SN(32, 0), SN(32, 0x20)), op_ADD_255);
	RzILOpPure *op_RSHIFT_294 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_296 = LOGAND(op_RSHIFT_294, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_302 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_305 = LOGAND(op_RSHIFT_302, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_311 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_314 = LOGAND(op_RSHIFT_311, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_317 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_305), DUP(op_AND_305))), CAST(16, MSB(DUP(op_AND_305)), DUP(op_AND_305))), CAST(32, MSB(CAST(16, MSB(op_AND_314), DUP(op_AND_314))), CAST(16, MSB(DUP(op_AND_314)), DUP(op_AND_314))));
	RzILOpPure *op_LSHIFT_320 = SHIFTL0(CAST(64, MSB(op_MUL_317), DUP(op_MUL_317)), SN(32, 0));
	RzILOpPure *op_ADD_321 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_296), DUP(op_AND_296))), CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296))), op_LSHIFT_320);
	RzILOpPure *op_LT_324 = SLT(op_ADD_321, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_329 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_330 = NEG(op_LSHIFT_329);
	RzILOpPure *op_LSHIFT_335 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_338 = SUB(op_LSHIFT_335, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_339 = ITE(op_LT_324, op_NEG_330, op_SUB_338);
	RzILOpEffect *gcc_expr_340 = BRANCH(op_EQ_256, EMPTY(), set_usr_field_call_290);

	// h_tmp392 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_342 = SETL("h_tmp392", cond_339);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_343 = SEQN(2, gcc_expr_340, op_ASSIGN_hybrid_tmp_342);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) : h_tmp392) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_183 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_184 = LOGNOT(op_LSHIFT_183);
	RzILOpPure *op_AND_185 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_184);
	RzILOpPure *op_RSHIFT_260 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_262 = LOGAND(op_RSHIFT_260, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_268 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_271 = LOGAND(op_RSHIFT_268, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_277 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_280 = LOGAND(op_RSHIFT_277, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_283 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_271), DUP(op_AND_271))), CAST(16, MSB(DUP(op_AND_271)), DUP(op_AND_271))), CAST(32, MSB(CAST(16, MSB(op_AND_280), DUP(op_AND_280))), CAST(16, MSB(DUP(op_AND_280)), DUP(op_AND_280))));
	RzILOpPure *op_LSHIFT_286 = SHIFTL0(CAST(64, MSB(op_MUL_283), DUP(op_MUL_283)), SN(32, 0));
	RzILOpPure *op_ADD_287 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_262), DUP(op_AND_262))), CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262))), op_LSHIFT_286);
	RzILOpPure *cond_344 = ITE(DUP(op_EQ_256), op_ADD_287, VARL("h_tmp392"));
	RzILOpPure *op_AND_346 = LOGAND(cond_344, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_350 = SHIFTL0(op_AND_346, SN(32, 0x20));
	RzILOpPure *op_OR_351 = LOGOR(op_AND_185, op_LSHIFT_350);
	RzILOpEffect *op_ASSIGN_352 = WRITE_REG(bundle, Rxx_op, op_OR_351);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_353 = SEQN(2, seq_343, op_ASSIGN_352);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_177, seq_353);
	return instruction_sequence;
}

// Rxx += vmpyeh(Rss,Rtt):<<1:sat
RzILOpEffect *hex_il_op_m2_vmac2es_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_114 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rss, SN(32, 0));
	RzILOpPure *op_AND_26 = LOGAND(op_RSHIFT_23, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_33 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_36 = LOGAND(op_RSHIFT_33, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_39 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_26), DUP(op_AND_26))), CAST(16, MSB(DUP(op_AND_26)), DUP(op_AND_26))), CAST(32, MSB(CAST(16, MSB(op_AND_36), DUP(op_AND_36))), CAST(16, MSB(DUP(op_AND_36)), DUP(op_AND_36))));
	RzILOpPure *op_LSHIFT_42 = SHIFTL0(CAST(64, MSB(op_MUL_39), DUP(op_MUL_39)), SN(32, 1));
	RzILOpPure *op_ADD_43 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_LSHIFT_42);
	RzILOpPure *op_RSHIFT_52 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_54 = LOGAND(op_RSHIFT_52, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_60 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_63 = LOGAND(op_RSHIFT_60, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_69 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_72 = LOGAND(op_RSHIFT_69, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_75 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_63), DUP(op_AND_63))), CAST(16, MSB(DUP(op_AND_63)), DUP(op_AND_63))), CAST(32, MSB(CAST(16, MSB(op_AND_72), DUP(op_AND_72))), CAST(16, MSB(DUP(op_AND_72)), DUP(op_AND_72))));
	RzILOpPure *op_LSHIFT_78 = SHIFTL0(CAST(64, MSB(op_MUL_75), DUP(op_MUL_75)), SN(32, 1));
	RzILOpPure *op_ADD_79 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_54), DUP(op_AND_54))), CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54))), op_LSHIFT_78);
	RzILOpPure *op_EQ_80 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_43), SN(32, 0), SN(32, 0x20)), op_ADD_79);
	RzILOpPure *op_RSHIFT_118 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_120 = LOGAND(op_RSHIFT_118, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_126 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_129 = LOGAND(op_RSHIFT_126, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_135 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_138 = LOGAND(op_RSHIFT_135, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_141 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_129), DUP(op_AND_129))), CAST(16, MSB(DUP(op_AND_129)), DUP(op_AND_129))), CAST(32, MSB(CAST(16, MSB(op_AND_138), DUP(op_AND_138))), CAST(16, MSB(DUP(op_AND_138)), DUP(op_AND_138))));
	RzILOpPure *op_LSHIFT_144 = SHIFTL0(CAST(64, MSB(op_MUL_141), DUP(op_MUL_141)), SN(32, 1));
	RzILOpPure *op_ADD_145 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_120), DUP(op_AND_120))), CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120))), op_LSHIFT_144);
	RzILOpPure *op_LT_148 = SLT(op_ADD_145, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_153 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_154 = NEG(op_LSHIFT_153);
	RzILOpPure *op_LSHIFT_159 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_162 = SUB(op_LSHIFT_159, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_163 = ITE(op_LT_148, op_NEG_154, op_SUB_162);
	RzILOpEffect *gcc_expr_164 = BRANCH(op_EQ_80, EMPTY(), set_usr_field_call_114);

	// h_tmp393 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_166 = SETL("h_tmp393", cond_163);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_167 = SEQN(2, gcc_expr_164, op_ASSIGN_hybrid_tmp_166);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) : h_tmp393) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_84 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_86 = LOGAND(op_RSHIFT_84, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_92 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_95 = LOGAND(op_RSHIFT_92, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_101 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_104 = LOGAND(op_RSHIFT_101, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_107 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_95), DUP(op_AND_95))), CAST(16, MSB(DUP(op_AND_95)), DUP(op_AND_95))), CAST(32, MSB(CAST(16, MSB(op_AND_104), DUP(op_AND_104))), CAST(16, MSB(DUP(op_AND_104)), DUP(op_AND_104))));
	RzILOpPure *op_LSHIFT_110 = SHIFTL0(CAST(64, MSB(op_MUL_107), DUP(op_MUL_107)), SN(32, 1));
	RzILOpPure *op_ADD_111 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_86), DUP(op_AND_86))), CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86))), op_LSHIFT_110);
	RzILOpPure *cond_168 = ITE(DUP(op_EQ_80), op_ADD_111, VARL("h_tmp393"));
	RzILOpPure *op_AND_170 = LOGAND(cond_168, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_174 = SHIFTL0(op_AND_170, SN(32, 0));
	RzILOpPure *op_OR_175 = LOGOR(op_AND_7, op_LSHIFT_174);
	RzILOpEffect *op_ASSIGN_176 = WRITE_REG(bundle, Rxx_op, op_OR_175);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_177 = SEQN(2, seq_167, op_ASSIGN_176);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_290 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_192 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_194 = LOGAND(op_RSHIFT_192, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_200 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_203 = LOGAND(op_RSHIFT_200, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_209 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_212 = LOGAND(op_RSHIFT_209, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_215 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_203), DUP(op_AND_203))), CAST(16, MSB(DUP(op_AND_203)), DUP(op_AND_203))), CAST(32, MSB(CAST(16, MSB(op_AND_212), DUP(op_AND_212))), CAST(16, MSB(DUP(op_AND_212)), DUP(op_AND_212))));
	RzILOpPure *op_LSHIFT_218 = SHIFTL0(CAST(64, MSB(op_MUL_215), DUP(op_MUL_215)), SN(32, 1));
	RzILOpPure *op_ADD_219 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_194), DUP(op_AND_194))), CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194))), op_LSHIFT_218);
	RzILOpPure *op_RSHIFT_228 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_230 = LOGAND(op_RSHIFT_228, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_236 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_239 = LOGAND(op_RSHIFT_236, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_245 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_248 = LOGAND(op_RSHIFT_245, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_251 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_239), DUP(op_AND_239))), CAST(16, MSB(DUP(op_AND_239)), DUP(op_AND_239))), CAST(32, MSB(CAST(16, MSB(op_AND_248), DUP(op_AND_248))), CAST(16, MSB(DUP(op_AND_248)), DUP(op_AND_248))));
	RzILOpPure *op_LSHIFT_254 = SHIFTL0(CAST(64, MSB(op_MUL_251), DUP(op_MUL_251)), SN(32, 1));
	RzILOpPure *op_ADD_255 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_230), DUP(op_AND_230))), CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230))), op_LSHIFT_254);
	RzILOpPure *op_EQ_256 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_219), SN(32, 0), SN(32, 0x20)), op_ADD_255);
	RzILOpPure *op_RSHIFT_294 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_296 = LOGAND(op_RSHIFT_294, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_302 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_305 = LOGAND(op_RSHIFT_302, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_311 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_314 = LOGAND(op_RSHIFT_311, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_317 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_305), DUP(op_AND_305))), CAST(16, MSB(DUP(op_AND_305)), DUP(op_AND_305))), CAST(32, MSB(CAST(16, MSB(op_AND_314), DUP(op_AND_314))), CAST(16, MSB(DUP(op_AND_314)), DUP(op_AND_314))));
	RzILOpPure *op_LSHIFT_320 = SHIFTL0(CAST(64, MSB(op_MUL_317), DUP(op_MUL_317)), SN(32, 1));
	RzILOpPure *op_ADD_321 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_296), DUP(op_AND_296))), CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296))), op_LSHIFT_320);
	RzILOpPure *op_LT_324 = SLT(op_ADD_321, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_329 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_330 = NEG(op_LSHIFT_329);
	RzILOpPure *op_LSHIFT_335 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_338 = SUB(op_LSHIFT_335, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_339 = ITE(op_LT_324, op_NEG_330, op_SUB_338);
	RzILOpEffect *gcc_expr_340 = BRANCH(op_EQ_256, EMPTY(), set_usr_field_call_290);

	// h_tmp394 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_342 = SETL("h_tmp394", cond_339);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_343 = SEQN(2, gcc_expr_340, op_ASSIGN_hybrid_tmp_342);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) : h_tmp394) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_183 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_184 = LOGNOT(op_LSHIFT_183);
	RzILOpPure *op_AND_185 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_184);
	RzILOpPure *op_RSHIFT_260 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_262 = LOGAND(op_RSHIFT_260, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_268 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_271 = LOGAND(op_RSHIFT_268, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_277 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_280 = LOGAND(op_RSHIFT_277, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_283 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_271), DUP(op_AND_271))), CAST(16, MSB(DUP(op_AND_271)), DUP(op_AND_271))), CAST(32, MSB(CAST(16, MSB(op_AND_280), DUP(op_AND_280))), CAST(16, MSB(DUP(op_AND_280)), DUP(op_AND_280))));
	RzILOpPure *op_LSHIFT_286 = SHIFTL0(CAST(64, MSB(op_MUL_283), DUP(op_MUL_283)), SN(32, 1));
	RzILOpPure *op_ADD_287 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_262), DUP(op_AND_262))), CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262))), op_LSHIFT_286);
	RzILOpPure *cond_344 = ITE(DUP(op_EQ_256), op_ADD_287, VARL("h_tmp394"));
	RzILOpPure *op_AND_346 = LOGAND(cond_344, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_350 = SHIFTL0(op_AND_346, SN(32, 0x20));
	RzILOpPure *op_OR_351 = LOGOR(op_AND_185, op_LSHIFT_350);
	RzILOpEffect *op_ASSIGN_352 = WRITE_REG(bundle, Rxx_op, op_OR_351);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_353 = SEQN(2, seq_343, op_ASSIGN_352);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_177, seq_353);
	return instruction_sequence;
}

// Rxx += vmpyh(Rs,Rt):sat
RzILOpEffect *hex_il_op_m2_vmac2s_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_108 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_25 = LOGAND(op_RSHIFT_23, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_32 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_34 = LOGAND(op_RSHIFT_32, SN(32, 0xffff));
	RzILOpPure *op_MUL_37 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_25), DUP(op_AND_25))), CAST(16, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(CAST(16, MSB(op_AND_34), DUP(op_AND_34))), CAST(16, MSB(DUP(op_AND_34)), DUP(op_AND_34))));
	RzILOpPure *op_LSHIFT_40 = SHIFTL0(CAST(64, MSB(op_MUL_37), DUP(op_MUL_37)), SN(32, 0));
	RzILOpPure *op_ADD_41 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_LSHIFT_40);
	RzILOpPure *op_RSHIFT_50 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_52 = LOGAND(op_RSHIFT_50, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_58 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_60 = LOGAND(op_RSHIFT_58, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_66 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_68 = LOGAND(op_RSHIFT_66, SN(32, 0xffff));
	RzILOpPure *op_MUL_71 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_60), DUP(op_AND_60))), CAST(16, MSB(DUP(op_AND_60)), DUP(op_AND_60))), CAST(32, MSB(CAST(16, MSB(op_AND_68), DUP(op_AND_68))), CAST(16, MSB(DUP(op_AND_68)), DUP(op_AND_68))));
	RzILOpPure *op_LSHIFT_74 = SHIFTL0(CAST(64, MSB(op_MUL_71), DUP(op_MUL_71)), SN(32, 0));
	RzILOpPure *op_ADD_75 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_52), DUP(op_AND_52))), CAST(32, MSB(DUP(op_AND_52)), DUP(op_AND_52))), op_LSHIFT_74);
	RzILOpPure *op_EQ_76 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_41), SN(32, 0), SN(32, 0x20)), op_ADD_75);
	RzILOpPure *op_RSHIFT_112 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_114 = LOGAND(op_RSHIFT_112, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_120 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_122 = LOGAND(op_RSHIFT_120, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_128 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_130 = LOGAND(op_RSHIFT_128, SN(32, 0xffff));
	RzILOpPure *op_MUL_133 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_122), DUP(op_AND_122))), CAST(16, MSB(DUP(op_AND_122)), DUP(op_AND_122))), CAST(32, MSB(CAST(16, MSB(op_AND_130), DUP(op_AND_130))), CAST(16, MSB(DUP(op_AND_130)), DUP(op_AND_130))));
	RzILOpPure *op_LSHIFT_136 = SHIFTL0(CAST(64, MSB(op_MUL_133), DUP(op_MUL_133)), SN(32, 0));
	RzILOpPure *op_ADD_137 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_114), DUP(op_AND_114))), CAST(32, MSB(DUP(op_AND_114)), DUP(op_AND_114))), op_LSHIFT_136);
	RzILOpPure *op_LT_140 = SLT(op_ADD_137, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_145 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_146 = NEG(op_LSHIFT_145);
	RzILOpPure *op_LSHIFT_151 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_154 = SUB(op_LSHIFT_151, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_155 = ITE(op_LT_140, op_NEG_146, op_SUB_154);
	RzILOpEffect *gcc_expr_156 = BRANCH(op_EQ_76, EMPTY(), set_usr_field_call_108);

	// h_tmp395 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_158 = SETL("h_tmp395", cond_155);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_159 = SEQN(2, gcc_expr_156, op_ASSIGN_hybrid_tmp_158);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) : h_tmp395) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_80 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_82 = LOGAND(op_RSHIFT_80, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_88 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_90 = LOGAND(op_RSHIFT_88, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_96 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_98 = LOGAND(op_RSHIFT_96, SN(32, 0xffff));
	RzILOpPure *op_MUL_101 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_90), DUP(op_AND_90))), CAST(16, MSB(DUP(op_AND_90)), DUP(op_AND_90))), CAST(32, MSB(CAST(16, MSB(op_AND_98), DUP(op_AND_98))), CAST(16, MSB(DUP(op_AND_98)), DUP(op_AND_98))));
	RzILOpPure *op_LSHIFT_104 = SHIFTL0(CAST(64, MSB(op_MUL_101), DUP(op_MUL_101)), SN(32, 0));
	RzILOpPure *op_ADD_105 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_82), DUP(op_AND_82))), CAST(32, MSB(DUP(op_AND_82)), DUP(op_AND_82))), op_LSHIFT_104);
	RzILOpPure *cond_160 = ITE(DUP(op_EQ_76), op_ADD_105, VARL("h_tmp395"));
	RzILOpPure *op_AND_162 = LOGAND(cond_160, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_166 = SHIFTL0(op_AND_162, SN(32, 0));
	RzILOpPure *op_OR_167 = LOGOR(op_AND_7, op_LSHIFT_166);
	RzILOpEffect *op_ASSIGN_168 = WRITE_REG(bundle, Rxx_op, op_OR_167);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_169 = SEQN(2, seq_159, op_ASSIGN_168);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_276 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_184 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_186 = LOGAND(op_RSHIFT_184, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_192 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_194 = LOGAND(op_RSHIFT_192, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_200 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_202 = LOGAND(op_RSHIFT_200, SN(32, 0xffff));
	RzILOpPure *op_MUL_205 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_194), DUP(op_AND_194))), CAST(16, MSB(DUP(op_AND_194)), DUP(op_AND_194))), CAST(32, MSB(CAST(16, MSB(op_AND_202), DUP(op_AND_202))), CAST(16, MSB(DUP(op_AND_202)), DUP(op_AND_202))));
	RzILOpPure *op_LSHIFT_208 = SHIFTL0(CAST(64, MSB(op_MUL_205), DUP(op_MUL_205)), SN(32, 0));
	RzILOpPure *op_ADD_209 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_186), DUP(op_AND_186))), CAST(32, MSB(DUP(op_AND_186)), DUP(op_AND_186))), op_LSHIFT_208);
	RzILOpPure *op_RSHIFT_218 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_220 = LOGAND(op_RSHIFT_218, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_226 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_228 = LOGAND(op_RSHIFT_226, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_234 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_236 = LOGAND(op_RSHIFT_234, SN(32, 0xffff));
	RzILOpPure *op_MUL_239 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_228), DUP(op_AND_228))), CAST(16, MSB(DUP(op_AND_228)), DUP(op_AND_228))), CAST(32, MSB(CAST(16, MSB(op_AND_236), DUP(op_AND_236))), CAST(16, MSB(DUP(op_AND_236)), DUP(op_AND_236))));
	RzILOpPure *op_LSHIFT_242 = SHIFTL0(CAST(64, MSB(op_MUL_239), DUP(op_MUL_239)), SN(32, 0));
	RzILOpPure *op_ADD_243 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_220), DUP(op_AND_220))), CAST(32, MSB(DUP(op_AND_220)), DUP(op_AND_220))), op_LSHIFT_242);
	RzILOpPure *op_EQ_244 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_209), SN(32, 0), SN(32, 0x20)), op_ADD_243);
	RzILOpPure *op_RSHIFT_280 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_282 = LOGAND(op_RSHIFT_280, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_288 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_290 = LOGAND(op_RSHIFT_288, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_296 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_298 = LOGAND(op_RSHIFT_296, SN(32, 0xffff));
	RzILOpPure *op_MUL_301 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_290), DUP(op_AND_290))), CAST(16, MSB(DUP(op_AND_290)), DUP(op_AND_290))), CAST(32, MSB(CAST(16, MSB(op_AND_298), DUP(op_AND_298))), CAST(16, MSB(DUP(op_AND_298)), DUP(op_AND_298))));
	RzILOpPure *op_LSHIFT_304 = SHIFTL0(CAST(64, MSB(op_MUL_301), DUP(op_MUL_301)), SN(32, 0));
	RzILOpPure *op_ADD_305 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_282), DUP(op_AND_282))), CAST(32, MSB(DUP(op_AND_282)), DUP(op_AND_282))), op_LSHIFT_304);
	RzILOpPure *op_LT_308 = SLT(op_ADD_305, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_313 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_314 = NEG(op_LSHIFT_313);
	RzILOpPure *op_LSHIFT_319 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_322 = SUB(op_LSHIFT_319, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_323 = ITE(op_LT_308, op_NEG_314, op_SUB_322);
	RzILOpEffect *gcc_expr_324 = BRANCH(op_EQ_244, EMPTY(), set_usr_field_call_276);

	// h_tmp396 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_326 = SETL("h_tmp396", cond_323);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_327 = SEQN(2, gcc_expr_324, op_ASSIGN_hybrid_tmp_326);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) : h_tmp396) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_175 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_176 = LOGNOT(op_LSHIFT_175);
	RzILOpPure *op_AND_177 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_176);
	RzILOpPure *op_RSHIFT_248 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_250 = LOGAND(op_RSHIFT_248, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_256 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_258 = LOGAND(op_RSHIFT_256, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_264 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_266 = LOGAND(op_RSHIFT_264, SN(32, 0xffff));
	RzILOpPure *op_MUL_269 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_258), DUP(op_AND_258))), CAST(16, MSB(DUP(op_AND_258)), DUP(op_AND_258))), CAST(32, MSB(CAST(16, MSB(op_AND_266), DUP(op_AND_266))), CAST(16, MSB(DUP(op_AND_266)), DUP(op_AND_266))));
	RzILOpPure *op_LSHIFT_272 = SHIFTL0(CAST(64, MSB(op_MUL_269), DUP(op_MUL_269)), SN(32, 0));
	RzILOpPure *op_ADD_273 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_250), DUP(op_AND_250))), CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250))), op_LSHIFT_272);
	RzILOpPure *cond_328 = ITE(DUP(op_EQ_244), op_ADD_273, VARL("h_tmp396"));
	RzILOpPure *op_AND_330 = LOGAND(cond_328, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_334 = SHIFTL0(op_AND_330, SN(32, 0x20));
	RzILOpPure *op_OR_335 = LOGOR(op_AND_177, op_LSHIFT_334);
	RzILOpEffect *op_ASSIGN_336 = WRITE_REG(bundle, Rxx_op, op_OR_335);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_337 = SEQN(2, seq_327, op_ASSIGN_336);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_169, seq_337);
	return instruction_sequence;
}

// Rxx += vmpyh(Rs,Rt):<<1:sat
RzILOpEffect *hex_il_op_m2_vmac2s_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_108 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_25 = LOGAND(op_RSHIFT_23, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_32 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_34 = LOGAND(op_RSHIFT_32, SN(32, 0xffff));
	RzILOpPure *op_MUL_37 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_25), DUP(op_AND_25))), CAST(16, MSB(DUP(op_AND_25)), DUP(op_AND_25))), CAST(32, MSB(CAST(16, MSB(op_AND_34), DUP(op_AND_34))), CAST(16, MSB(DUP(op_AND_34)), DUP(op_AND_34))));
	RzILOpPure *op_LSHIFT_40 = SHIFTL0(CAST(64, MSB(op_MUL_37), DUP(op_MUL_37)), SN(32, 1));
	RzILOpPure *op_ADD_41 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_LSHIFT_40);
	RzILOpPure *op_RSHIFT_50 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_52 = LOGAND(op_RSHIFT_50, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_58 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_60 = LOGAND(op_RSHIFT_58, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_66 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_68 = LOGAND(op_RSHIFT_66, SN(32, 0xffff));
	RzILOpPure *op_MUL_71 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_60), DUP(op_AND_60))), CAST(16, MSB(DUP(op_AND_60)), DUP(op_AND_60))), CAST(32, MSB(CAST(16, MSB(op_AND_68), DUP(op_AND_68))), CAST(16, MSB(DUP(op_AND_68)), DUP(op_AND_68))));
	RzILOpPure *op_LSHIFT_74 = SHIFTL0(CAST(64, MSB(op_MUL_71), DUP(op_MUL_71)), SN(32, 1));
	RzILOpPure *op_ADD_75 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_52), DUP(op_AND_52))), CAST(32, MSB(DUP(op_AND_52)), DUP(op_AND_52))), op_LSHIFT_74);
	RzILOpPure *op_EQ_76 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_41), SN(32, 0), SN(32, 0x20)), op_ADD_75);
	RzILOpPure *op_RSHIFT_112 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_114 = LOGAND(op_RSHIFT_112, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_120 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_122 = LOGAND(op_RSHIFT_120, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_128 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_130 = LOGAND(op_RSHIFT_128, SN(32, 0xffff));
	RzILOpPure *op_MUL_133 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_122), DUP(op_AND_122))), CAST(16, MSB(DUP(op_AND_122)), DUP(op_AND_122))), CAST(32, MSB(CAST(16, MSB(op_AND_130), DUP(op_AND_130))), CAST(16, MSB(DUP(op_AND_130)), DUP(op_AND_130))));
	RzILOpPure *op_LSHIFT_136 = SHIFTL0(CAST(64, MSB(op_MUL_133), DUP(op_MUL_133)), SN(32, 1));
	RzILOpPure *op_ADD_137 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_114), DUP(op_AND_114))), CAST(32, MSB(DUP(op_AND_114)), DUP(op_AND_114))), op_LSHIFT_136);
	RzILOpPure *op_LT_140 = SLT(op_ADD_137, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_145 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_146 = NEG(op_LSHIFT_145);
	RzILOpPure *op_LSHIFT_151 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_154 = SUB(op_LSHIFT_151, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_155 = ITE(op_LT_140, op_NEG_146, op_SUB_154);
	RzILOpEffect *gcc_expr_156 = BRANCH(op_EQ_76, EMPTY(), set_usr_field_call_108);

	// h_tmp397 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_158 = SETL("h_tmp397", cond_155);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_159 = SEQN(2, gcc_expr_156, op_ASSIGN_hybrid_tmp_158);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) : h_tmp397) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_80 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_82 = LOGAND(op_RSHIFT_80, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_88 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_90 = LOGAND(op_RSHIFT_88, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_96 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_98 = LOGAND(op_RSHIFT_96, SN(32, 0xffff));
	RzILOpPure *op_MUL_101 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_90), DUP(op_AND_90))), CAST(16, MSB(DUP(op_AND_90)), DUP(op_AND_90))), CAST(32, MSB(CAST(16, MSB(op_AND_98), DUP(op_AND_98))), CAST(16, MSB(DUP(op_AND_98)), DUP(op_AND_98))));
	RzILOpPure *op_LSHIFT_104 = SHIFTL0(CAST(64, MSB(op_MUL_101), DUP(op_MUL_101)), SN(32, 1));
	RzILOpPure *op_ADD_105 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_82), DUP(op_AND_82))), CAST(32, MSB(DUP(op_AND_82)), DUP(op_AND_82))), op_LSHIFT_104);
	RzILOpPure *cond_160 = ITE(DUP(op_EQ_76), op_ADD_105, VARL("h_tmp397"));
	RzILOpPure *op_AND_162 = LOGAND(cond_160, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_166 = SHIFTL0(op_AND_162, SN(32, 0));
	RzILOpPure *op_OR_167 = LOGOR(op_AND_7, op_LSHIFT_166);
	RzILOpEffect *op_ASSIGN_168 = WRITE_REG(bundle, Rxx_op, op_OR_167);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_169 = SEQN(2, seq_159, op_ASSIGN_168);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_276 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_184 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_186 = LOGAND(op_RSHIFT_184, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_192 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_194 = LOGAND(op_RSHIFT_192, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_200 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_202 = LOGAND(op_RSHIFT_200, SN(32, 0xffff));
	RzILOpPure *op_MUL_205 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_194), DUP(op_AND_194))), CAST(16, MSB(DUP(op_AND_194)), DUP(op_AND_194))), CAST(32, MSB(CAST(16, MSB(op_AND_202), DUP(op_AND_202))), CAST(16, MSB(DUP(op_AND_202)), DUP(op_AND_202))));
	RzILOpPure *op_LSHIFT_208 = SHIFTL0(CAST(64, MSB(op_MUL_205), DUP(op_MUL_205)), SN(32, 1));
	RzILOpPure *op_ADD_209 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_186), DUP(op_AND_186))), CAST(32, MSB(DUP(op_AND_186)), DUP(op_AND_186))), op_LSHIFT_208);
	RzILOpPure *op_RSHIFT_218 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_220 = LOGAND(op_RSHIFT_218, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_226 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_228 = LOGAND(op_RSHIFT_226, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_234 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_236 = LOGAND(op_RSHIFT_234, SN(32, 0xffff));
	RzILOpPure *op_MUL_239 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_228), DUP(op_AND_228))), CAST(16, MSB(DUP(op_AND_228)), DUP(op_AND_228))), CAST(32, MSB(CAST(16, MSB(op_AND_236), DUP(op_AND_236))), CAST(16, MSB(DUP(op_AND_236)), DUP(op_AND_236))));
	RzILOpPure *op_LSHIFT_242 = SHIFTL0(CAST(64, MSB(op_MUL_239), DUP(op_MUL_239)), SN(32, 1));
	RzILOpPure *op_ADD_243 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_220), DUP(op_AND_220))), CAST(32, MSB(DUP(op_AND_220)), DUP(op_AND_220))), op_LSHIFT_242);
	RzILOpPure *op_EQ_244 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_209), SN(32, 0), SN(32, 0x20)), op_ADD_243);
	RzILOpPure *op_RSHIFT_280 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_282 = LOGAND(op_RSHIFT_280, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_288 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_290 = LOGAND(op_RSHIFT_288, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_296 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_298 = LOGAND(op_RSHIFT_296, SN(32, 0xffff));
	RzILOpPure *op_MUL_301 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_290), DUP(op_AND_290))), CAST(16, MSB(DUP(op_AND_290)), DUP(op_AND_290))), CAST(32, MSB(CAST(16, MSB(op_AND_298), DUP(op_AND_298))), CAST(16, MSB(DUP(op_AND_298)), DUP(op_AND_298))));
	RzILOpPure *op_LSHIFT_304 = SHIFTL0(CAST(64, MSB(op_MUL_301), DUP(op_MUL_301)), SN(32, 1));
	RzILOpPure *op_ADD_305 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_282), DUP(op_AND_282))), CAST(32, MSB(DUP(op_AND_282)), DUP(op_AND_282))), op_LSHIFT_304);
	RzILOpPure *op_LT_308 = SLT(op_ADD_305, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_313 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_314 = NEG(op_LSHIFT_313);
	RzILOpPure *op_LSHIFT_319 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_322 = SUB(op_LSHIFT_319, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_323 = ITE(op_LT_308, op_NEG_314, op_SUB_322);
	RzILOpEffect *gcc_expr_324 = BRANCH(op_EQ_244, EMPTY(), set_usr_field_call_276);

	// h_tmp398 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_326 = SETL("h_tmp398", cond_323);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_327 = SEQN(2, gcc_expr_324, op_ASSIGN_hybrid_tmp_326);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) : h_tmp398) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_175 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_176 = LOGNOT(op_LSHIFT_175);
	RzILOpPure *op_AND_177 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_176);
	RzILOpPure *op_RSHIFT_248 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_250 = LOGAND(op_RSHIFT_248, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_256 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_258 = LOGAND(op_RSHIFT_256, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_264 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_266 = LOGAND(op_RSHIFT_264, SN(32, 0xffff));
	RzILOpPure *op_MUL_269 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_258), DUP(op_AND_258))), CAST(16, MSB(DUP(op_AND_258)), DUP(op_AND_258))), CAST(32, MSB(CAST(16, MSB(op_AND_266), DUP(op_AND_266))), CAST(16, MSB(DUP(op_AND_266)), DUP(op_AND_266))));
	RzILOpPure *op_LSHIFT_272 = SHIFTL0(CAST(64, MSB(op_MUL_269), DUP(op_MUL_269)), SN(32, 1));
	RzILOpPure *op_ADD_273 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_250), DUP(op_AND_250))), CAST(32, MSB(DUP(op_AND_250)), DUP(op_AND_250))), op_LSHIFT_272);
	RzILOpPure *cond_328 = ITE(DUP(op_EQ_244), op_ADD_273, VARL("h_tmp398"));
	RzILOpPure *op_AND_330 = LOGAND(cond_328, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_334 = SHIFTL0(op_AND_330, SN(32, 0x20));
	RzILOpPure *op_OR_335 = LOGOR(op_AND_177, op_LSHIFT_334);
	RzILOpEffect *op_ASSIGN_336 = WRITE_REG(bundle, Rxx_op, op_OR_335);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_337 = SEQN(2, seq_327, op_ASSIGN_336);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_169, seq_337);
	return instruction_sequence;
}

// Rxx += vmpyhsu(Rs,Rt):sat
RzILOpEffect *hex_il_op_m2_vmac2su_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_114 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_25 = LOGAND(op_RSHIFT_23, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_32 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_34 = LOGAND(op_RSHIFT_32, SN(32, 0xffff));
	RzILOpPure *op_MUL_38 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_25), DUP(op_AND_25))), CAST(16, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_34)));
	RzILOpPure *op_LSHIFT_42 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_38)), CAST(32, IL_FALSE, DUP(op_MUL_38))), SN(32, 0));
	RzILOpPure *op_ADD_43 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_LSHIFT_42);
	RzILOpPure *op_RSHIFT_52 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_54 = LOGAND(op_RSHIFT_52, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_60 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_62 = LOGAND(op_RSHIFT_60, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_68 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_70 = LOGAND(op_RSHIFT_68, SN(32, 0xffff));
	RzILOpPure *op_MUL_74 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_62), DUP(op_AND_62))), CAST(16, MSB(DUP(op_AND_62)), DUP(op_AND_62)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_70)));
	RzILOpPure *op_LSHIFT_78 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_74)), CAST(32, IL_FALSE, DUP(op_MUL_74))), SN(32, 0));
	RzILOpPure *op_ADD_79 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_54), DUP(op_AND_54))), CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54))), op_LSHIFT_78);
	RzILOpPure *op_EQ_80 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_43), SN(32, 0), SN(32, 0x20)), op_ADD_79);
	RzILOpPure *op_RSHIFT_118 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_120 = LOGAND(op_RSHIFT_118, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_126 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_128 = LOGAND(op_RSHIFT_126, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_134 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_136 = LOGAND(op_RSHIFT_134, SN(32, 0xffff));
	RzILOpPure *op_MUL_140 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_128), DUP(op_AND_128))), CAST(16, MSB(DUP(op_AND_128)), DUP(op_AND_128)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_136)));
	RzILOpPure *op_LSHIFT_144 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_140)), CAST(32, IL_FALSE, DUP(op_MUL_140))), SN(32, 0));
	RzILOpPure *op_ADD_145 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_120), DUP(op_AND_120))), CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120))), op_LSHIFT_144);
	RzILOpPure *op_LT_148 = SLT(op_ADD_145, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_153 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_154 = NEG(op_LSHIFT_153);
	RzILOpPure *op_LSHIFT_159 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_162 = SUB(op_LSHIFT_159, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_163 = ITE(op_LT_148, op_NEG_154, op_SUB_162);
	RzILOpEffect *gcc_expr_164 = BRANCH(op_EQ_80, EMPTY(), set_usr_field_call_114);

	// h_tmp399 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_166 = SETL("h_tmp399", cond_163);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_167 = SEQN(2, gcc_expr_164, op_ASSIGN_hybrid_tmp_166);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x0)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x0) : h_tmp399) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_84 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_86 = LOGAND(op_RSHIFT_84, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_92 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_94 = LOGAND(op_RSHIFT_92, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_100 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_102 = LOGAND(op_RSHIFT_100, SN(32, 0xffff));
	RzILOpPure *op_MUL_106 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_94), DUP(op_AND_94))), CAST(16, MSB(DUP(op_AND_94)), DUP(op_AND_94)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_102)));
	RzILOpPure *op_LSHIFT_110 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_106)), CAST(32, IL_FALSE, DUP(op_MUL_106))), SN(32, 0));
	RzILOpPure *op_ADD_111 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_86), DUP(op_AND_86))), CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86))), op_LSHIFT_110);
	RzILOpPure *cond_168 = ITE(DUP(op_EQ_80), op_ADD_111, VARL("h_tmp399"));
	RzILOpPure *op_AND_170 = LOGAND(cond_168, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_174 = SHIFTL0(op_AND_170, SN(32, 0));
	RzILOpPure *op_OR_175 = LOGOR(op_AND_7, op_LSHIFT_174);
	RzILOpEffect *op_ASSIGN_176 = WRITE_REG(bundle, Rxx_op, op_OR_175);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_177 = SEQN(2, seq_167, op_ASSIGN_176);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_290 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_192 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_194 = LOGAND(op_RSHIFT_192, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_200 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_202 = LOGAND(op_RSHIFT_200, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_208 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_210 = LOGAND(op_RSHIFT_208, SN(32, 0xffff));
	RzILOpPure *op_MUL_214 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_202), DUP(op_AND_202))), CAST(16, MSB(DUP(op_AND_202)), DUP(op_AND_202)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_210)));
	RzILOpPure *op_LSHIFT_218 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_214)), CAST(32, IL_FALSE, DUP(op_MUL_214))), SN(32, 0));
	RzILOpPure *op_ADD_219 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_194), DUP(op_AND_194))), CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194))), op_LSHIFT_218);
	RzILOpPure *op_RSHIFT_228 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_230 = LOGAND(op_RSHIFT_228, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_236 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_238 = LOGAND(op_RSHIFT_236, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_244 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_246 = LOGAND(op_RSHIFT_244, SN(32, 0xffff));
	RzILOpPure *op_MUL_250 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_238), DUP(op_AND_238))), CAST(16, MSB(DUP(op_AND_238)), DUP(op_AND_238)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_246)));
	RzILOpPure *op_LSHIFT_254 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_250)), CAST(32, IL_FALSE, DUP(op_MUL_250))), SN(32, 0));
	RzILOpPure *op_ADD_255 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_230), DUP(op_AND_230))), CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230))), op_LSHIFT_254);
	RzILOpPure *op_EQ_256 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_219), SN(32, 0), SN(32, 0x20)), op_ADD_255);
	RzILOpPure *op_RSHIFT_294 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_296 = LOGAND(op_RSHIFT_294, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_302 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_304 = LOGAND(op_RSHIFT_302, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_310 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_312 = LOGAND(op_RSHIFT_310, SN(32, 0xffff));
	RzILOpPure *op_MUL_316 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_304), DUP(op_AND_304))), CAST(16, MSB(DUP(op_AND_304)), DUP(op_AND_304)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_312)));
	RzILOpPure *op_LSHIFT_320 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_316)), CAST(32, IL_FALSE, DUP(op_MUL_316))), SN(32, 0));
	RzILOpPure *op_ADD_321 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_296), DUP(op_AND_296))), CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296))), op_LSHIFT_320);
	RzILOpPure *op_LT_324 = SLT(op_ADD_321, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_329 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_330 = NEG(op_LSHIFT_329);
	RzILOpPure *op_LSHIFT_335 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_338 = SUB(op_LSHIFT_335, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_339 = ITE(op_LT_324, op_NEG_330, op_SUB_338);
	RzILOpEffect *gcc_expr_340 = BRANCH(op_EQ_256, EMPTY(), set_usr_field_call_290);

	// h_tmp400 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_342 = SETL("h_tmp400", cond_339);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_343 = SEQN(2, gcc_expr_340, op_ASSIGN_hybrid_tmp_342);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x0)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x0)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x0) : h_tmp400) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_183 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_184 = LOGNOT(op_LSHIFT_183);
	RzILOpPure *op_AND_185 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_184);
	RzILOpPure *op_RSHIFT_260 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_262 = LOGAND(op_RSHIFT_260, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_268 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_270 = LOGAND(op_RSHIFT_268, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_276 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_278 = LOGAND(op_RSHIFT_276, SN(32, 0xffff));
	RzILOpPure *op_MUL_282 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_270), DUP(op_AND_270))), CAST(16, MSB(DUP(op_AND_270)), DUP(op_AND_270)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_278)));
	RzILOpPure *op_LSHIFT_286 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_282)), CAST(32, IL_FALSE, DUP(op_MUL_282))), SN(32, 0));
	RzILOpPure *op_ADD_287 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_262), DUP(op_AND_262))), CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262))), op_LSHIFT_286);
	RzILOpPure *cond_344 = ITE(DUP(op_EQ_256), op_ADD_287, VARL("h_tmp400"));
	RzILOpPure *op_AND_346 = LOGAND(cond_344, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_350 = SHIFTL0(op_AND_346, SN(32, 0x20));
	RzILOpPure *op_OR_351 = LOGOR(op_AND_185, op_LSHIFT_350);
	RzILOpEffect *op_ASSIGN_352 = WRITE_REG(bundle, Rxx_op, op_OR_351);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_353 = SEQN(2, seq_343, op_ASSIGN_352);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_177, seq_353);
	return instruction_sequence;
}

// Rxx += vmpyhsu(Rs,Rt):<<1:sat
RzILOpEffect *hex_il_op_m2_vmac2su_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_114 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_25 = LOGAND(op_RSHIFT_23, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_32 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_34 = LOGAND(op_RSHIFT_32, SN(32, 0xffff));
	RzILOpPure *op_MUL_38 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_25), DUP(op_AND_25))), CAST(16, MSB(DUP(op_AND_25)), DUP(op_AND_25)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_34)));
	RzILOpPure *op_LSHIFT_42 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_38)), CAST(32, IL_FALSE, DUP(op_MUL_38))), SN(32, 1));
	RzILOpPure *op_ADD_43 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_LSHIFT_42);
	RzILOpPure *op_RSHIFT_52 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_54 = LOGAND(op_RSHIFT_52, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_60 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_62 = LOGAND(op_RSHIFT_60, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_68 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_70 = LOGAND(op_RSHIFT_68, SN(32, 0xffff));
	RzILOpPure *op_MUL_74 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_62), DUP(op_AND_62))), CAST(16, MSB(DUP(op_AND_62)), DUP(op_AND_62)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_70)));
	RzILOpPure *op_LSHIFT_78 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_74)), CAST(32, IL_FALSE, DUP(op_MUL_74))), SN(32, 1));
	RzILOpPure *op_ADD_79 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_54), DUP(op_AND_54))), CAST(32, MSB(DUP(op_AND_54)), DUP(op_AND_54))), op_LSHIFT_78);
	RzILOpPure *op_EQ_80 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_43), SN(32, 0), SN(32, 0x20)), op_ADD_79);
	RzILOpPure *op_RSHIFT_118 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_120 = LOGAND(op_RSHIFT_118, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_126 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_128 = LOGAND(op_RSHIFT_126, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_134 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_136 = LOGAND(op_RSHIFT_134, SN(32, 0xffff));
	RzILOpPure *op_MUL_140 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_128), DUP(op_AND_128))), CAST(16, MSB(DUP(op_AND_128)), DUP(op_AND_128)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_136)));
	RzILOpPure *op_LSHIFT_144 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_140)), CAST(32, IL_FALSE, DUP(op_MUL_140))), SN(32, 1));
	RzILOpPure *op_ADD_145 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_120), DUP(op_AND_120))), CAST(32, MSB(DUP(op_AND_120)), DUP(op_AND_120))), op_LSHIFT_144);
	RzILOpPure *op_LT_148 = SLT(op_ADD_145, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_153 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_154 = NEG(op_LSHIFT_153);
	RzILOpPure *op_LSHIFT_159 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_162 = SUB(op_LSHIFT_159, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_163 = ITE(op_LT_148, op_NEG_154, op_SUB_162);
	RzILOpEffect *gcc_expr_164 = BRANCH(op_EQ_80, EMPTY(), set_usr_field_call_114);

	// h_tmp401 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_166 = SETL("h_tmp401", cond_163);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_167 = SEQN(2, gcc_expr_164, op_ASSIGN_hybrid_tmp_166);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1) : h_tmp401) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_84 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_86 = LOGAND(op_RSHIFT_84, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_92 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_94 = LOGAND(op_RSHIFT_92, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_100 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_102 = LOGAND(op_RSHIFT_100, SN(32, 0xffff));
	RzILOpPure *op_MUL_106 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_94), DUP(op_AND_94))), CAST(16, MSB(DUP(op_AND_94)), DUP(op_AND_94)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_102)));
	RzILOpPure *op_LSHIFT_110 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_106)), CAST(32, IL_FALSE, DUP(op_MUL_106))), SN(32, 1));
	RzILOpPure *op_ADD_111 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_86), DUP(op_AND_86))), CAST(32, MSB(DUP(op_AND_86)), DUP(op_AND_86))), op_LSHIFT_110);
	RzILOpPure *cond_168 = ITE(DUP(op_EQ_80), op_ADD_111, VARL("h_tmp401"));
	RzILOpPure *op_AND_170 = LOGAND(cond_168, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_174 = SHIFTL0(op_AND_170, SN(32, 0));
	RzILOpPure *op_OR_175 = LOGOR(op_AND_7, op_LSHIFT_174);
	RzILOpEffect *op_ASSIGN_176 = WRITE_REG(bundle, Rxx_op, op_OR_175);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_177 = SEQN(2, seq_167, op_ASSIGN_176);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_290 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_192 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_194 = LOGAND(op_RSHIFT_192, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_200 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_202 = LOGAND(op_RSHIFT_200, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_208 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_210 = LOGAND(op_RSHIFT_208, SN(32, 0xffff));
	RzILOpPure *op_MUL_214 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_202), DUP(op_AND_202))), CAST(16, MSB(DUP(op_AND_202)), DUP(op_AND_202)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_210)));
	RzILOpPure *op_LSHIFT_218 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_214)), CAST(32, IL_FALSE, DUP(op_MUL_214))), SN(32, 1));
	RzILOpPure *op_ADD_219 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_194), DUP(op_AND_194))), CAST(32, MSB(DUP(op_AND_194)), DUP(op_AND_194))), op_LSHIFT_218);
	RzILOpPure *op_RSHIFT_228 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_230 = LOGAND(op_RSHIFT_228, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_236 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_238 = LOGAND(op_RSHIFT_236, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_244 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_246 = LOGAND(op_RSHIFT_244, SN(32, 0xffff));
	RzILOpPure *op_MUL_250 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_238), DUP(op_AND_238))), CAST(16, MSB(DUP(op_AND_238)), DUP(op_AND_238)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_246)));
	RzILOpPure *op_LSHIFT_254 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_250)), CAST(32, IL_FALSE, DUP(op_MUL_250))), SN(32, 1));
	RzILOpPure *op_ADD_255 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_230), DUP(op_AND_230))), CAST(32, MSB(DUP(op_AND_230)), DUP(op_AND_230))), op_LSHIFT_254);
	RzILOpPure *op_EQ_256 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_219), SN(32, 0), SN(32, 0x20)), op_ADD_255);
	RzILOpPure *op_RSHIFT_294 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_296 = LOGAND(op_RSHIFT_294, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_302 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_304 = LOGAND(op_RSHIFT_302, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_310 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_312 = LOGAND(op_RSHIFT_310, SN(32, 0xffff));
	RzILOpPure *op_MUL_316 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_304), DUP(op_AND_304))), CAST(16, MSB(DUP(op_AND_304)), DUP(op_AND_304)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_312)));
	RzILOpPure *op_LSHIFT_320 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_316)), CAST(32, IL_FALSE, DUP(op_MUL_316))), SN(32, 1));
	RzILOpPure *op_ADD_321 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_296), DUP(op_AND_296))), CAST(32, MSB(DUP(op_AND_296)), DUP(op_AND_296))), op_LSHIFT_320);
	RzILOpPure *op_LT_324 = SLT(op_ADD_321, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_329 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_330 = NEG(op_LSHIFT_329);
	RzILOpPure *op_LSHIFT_335 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_338 = SUB(op_LSHIFT_335, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_339 = ITE(op_LT_324, op_NEG_330, op_SUB_338);
	RzILOpEffect *gcc_expr_340 = BRANCH(op_EQ_256, EMPTY(), set_usr_field_call_290);

	// h_tmp402 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_342 = SETL("h_tmp402", cond_339);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_343 = SEQN(2, gcc_expr_340, op_ASSIGN_hybrid_tmp_342);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1) : h_tmp402) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_183 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_184 = LOGNOT(op_LSHIFT_183);
	RzILOpPure *op_AND_185 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_184);
	RzILOpPure *op_RSHIFT_260 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_262 = LOGAND(op_RSHIFT_260, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_268 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_270 = LOGAND(op_RSHIFT_268, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_276 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_278 = LOGAND(op_RSHIFT_276, SN(32, 0xffff));
	RzILOpPure *op_MUL_282 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_270), DUP(op_AND_270))), CAST(16, MSB(DUP(op_AND_270)), DUP(op_AND_270)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_278)));
	RzILOpPure *op_LSHIFT_286 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_282)), CAST(32, IL_FALSE, DUP(op_MUL_282))), SN(32, 1));
	RzILOpPure *op_ADD_287 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_262), DUP(op_AND_262))), CAST(32, MSB(DUP(op_AND_262)), DUP(op_AND_262))), op_LSHIFT_286);
	RzILOpPure *cond_344 = ITE(DUP(op_EQ_256), op_ADD_287, VARL("h_tmp402"));
	RzILOpPure *op_AND_346 = LOGAND(cond_344, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_350 = SHIFTL0(op_AND_346, SN(32, 0x20));
	RzILOpPure *op_OR_351 = LOGOR(op_AND_185, op_LSHIFT_350);
	RzILOpEffect *op_ASSIGN_352 = WRITE_REG(bundle, Rxx_op, op_OR_351);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_353 = SEQN(2, seq_343, op_ASSIGN_352);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_177, seq_353);
	return instruction_sequence;
}

// Rdd = vmpyeh(Rss,Rtt):sat
RzILOpEffect *hex_il_op_m2_vmpy2es_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_87 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rss, SN(32, 0));
	RzILOpPure *op_AND_18 = LOGAND(op_RSHIFT_15, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_25 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_28 = LOGAND(op_RSHIFT_25, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_31 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_18), DUP(op_AND_18))), CAST(16, MSB(DUP(op_AND_18)), DUP(op_AND_18))), CAST(32, MSB(CAST(16, MSB(op_AND_28), DUP(op_AND_28))), CAST(16, MSB(DUP(op_AND_28)), DUP(op_AND_28))));
	RzILOpPure *op_LSHIFT_34 = SHIFTL0(CAST(64, MSB(op_MUL_31), DUP(op_MUL_31)), SN(32, 0));
	RzILOpPure *op_RSHIFT_43 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_46 = LOGAND(op_RSHIFT_43, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_52 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_55 = LOGAND(op_RSHIFT_52, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_58 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_46), DUP(op_AND_46))), CAST(16, MSB(DUP(op_AND_46)), DUP(op_AND_46))), CAST(32, MSB(CAST(16, MSB(op_AND_55), DUP(op_AND_55))), CAST(16, MSB(DUP(op_AND_55)), DUP(op_AND_55))));
	RzILOpPure *op_LSHIFT_61 = SHIFTL0(CAST(64, MSB(op_MUL_58), DUP(op_MUL_58)), SN(32, 0));
	RzILOpPure *op_EQ_62 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_LSHIFT_34), SN(32, 0), SN(32, 0x20)), op_LSHIFT_61);
	RzILOpPure *op_RSHIFT_91 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_94 = LOGAND(op_RSHIFT_91, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_100 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_103 = LOGAND(op_RSHIFT_100, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_106 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_94), DUP(op_AND_94))), CAST(16, MSB(DUP(op_AND_94)), DUP(op_AND_94))), CAST(32, MSB(CAST(16, MSB(op_AND_103), DUP(op_AND_103))), CAST(16, MSB(DUP(op_AND_103)), DUP(op_AND_103))));
	RzILOpPure *op_LSHIFT_109 = SHIFTL0(CAST(64, MSB(op_MUL_106), DUP(op_MUL_106)), SN(32, 0));
	RzILOpPure *op_LT_112 = SLT(op_LSHIFT_109, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_117 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_118 = NEG(op_LSHIFT_117);
	RzILOpPure *op_LSHIFT_123 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_126 = SUB(op_LSHIFT_123, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_127 = ITE(op_LT_112, op_NEG_118, op_SUB_126);
	RzILOpEffect *gcc_expr_128 = BRANCH(op_EQ_62, EMPTY(), set_usr_field_call_87);

	// h_tmp403 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_130 = SETL("h_tmp403", cond_127);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_131 = SEQN(2, gcc_expr_128, op_ASSIGN_hybrid_tmp_130);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0)) ? (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x0) : h_tmp403) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_66 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_69 = LOGAND(op_RSHIFT_66, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_75 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_78 = LOGAND(op_RSHIFT_75, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_81 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_69), DUP(op_AND_69))), CAST(16, MSB(DUP(op_AND_69)), DUP(op_AND_69))), CAST(32, MSB(CAST(16, MSB(op_AND_78), DUP(op_AND_78))), CAST(16, MSB(DUP(op_AND_78)), DUP(op_AND_78))));
	RzILOpPure *op_LSHIFT_84 = SHIFTL0(CAST(64, MSB(op_MUL_81), DUP(op_MUL_81)), SN(32, 0));
	RzILOpPure *cond_132 = ITE(DUP(op_EQ_62), op_LSHIFT_84, VARL("h_tmp403"));
	RzILOpPure *op_AND_134 = LOGAND(cond_132, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_138 = SHIFTL0(op_AND_134, SN(32, 0));
	RzILOpPure *op_OR_139 = LOGOR(op_AND_7, op_LSHIFT_138);
	RzILOpEffect *op_ASSIGN_140 = WRITE_REG(bundle, Rdd_op, op_OR_139);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_141 = SEQN(2, seq_131, op_ASSIGN_140);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_227 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_156 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_159 = LOGAND(op_RSHIFT_156, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_165 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_168 = LOGAND(op_RSHIFT_165, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_171 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_159), DUP(op_AND_159))), CAST(16, MSB(DUP(op_AND_159)), DUP(op_AND_159))), CAST(32, MSB(CAST(16, MSB(op_AND_168), DUP(op_AND_168))), CAST(16, MSB(DUP(op_AND_168)), DUP(op_AND_168))));
	RzILOpPure *op_LSHIFT_174 = SHIFTL0(CAST(64, MSB(op_MUL_171), DUP(op_MUL_171)), SN(32, 0));
	RzILOpPure *op_RSHIFT_183 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_186 = LOGAND(op_RSHIFT_183, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_192 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_195 = LOGAND(op_RSHIFT_192, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_198 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_186), DUP(op_AND_186))), CAST(16, MSB(DUP(op_AND_186)), DUP(op_AND_186))), CAST(32, MSB(CAST(16, MSB(op_AND_195), DUP(op_AND_195))), CAST(16, MSB(DUP(op_AND_195)), DUP(op_AND_195))));
	RzILOpPure *op_LSHIFT_201 = SHIFTL0(CAST(64, MSB(op_MUL_198), DUP(op_MUL_198)), SN(32, 0));
	RzILOpPure *op_EQ_202 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_LSHIFT_174), SN(32, 0), SN(32, 0x20)), op_LSHIFT_201);
	RzILOpPure *op_RSHIFT_231 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_234 = LOGAND(op_RSHIFT_231, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_240 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_243 = LOGAND(op_RSHIFT_240, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_246 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_234), DUP(op_AND_234))), CAST(16, MSB(DUP(op_AND_234)), DUP(op_AND_234))), CAST(32, MSB(CAST(16, MSB(op_AND_243), DUP(op_AND_243))), CAST(16, MSB(DUP(op_AND_243)), DUP(op_AND_243))));
	RzILOpPure *op_LSHIFT_249 = SHIFTL0(CAST(64, MSB(op_MUL_246), DUP(op_MUL_246)), SN(32, 0));
	RzILOpPure *op_LT_252 = SLT(op_LSHIFT_249, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_257 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_258 = NEG(op_LSHIFT_257);
	RzILOpPure *op_LSHIFT_263 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_266 = SUB(op_LSHIFT_263, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_267 = ITE(op_LT_252, op_NEG_258, op_SUB_266);
	RzILOpEffect *gcc_expr_268 = BRANCH(op_EQ_202, EMPTY(), set_usr_field_call_227);

	// h_tmp404 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_270 = SETL("h_tmp404", cond_267);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_271 = SEQN(2, gcc_expr_268, op_ASSIGN_hybrid_tmp_270);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0)) ? (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x0) : h_tmp404) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_147 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_148 = LOGNOT(op_LSHIFT_147);
	RzILOpPure *op_AND_149 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_148);
	RzILOpPure *op_RSHIFT_206 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_209 = LOGAND(op_RSHIFT_206, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_215 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_218 = LOGAND(op_RSHIFT_215, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_221 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_209), DUP(op_AND_209))), CAST(16, MSB(DUP(op_AND_209)), DUP(op_AND_209))), CAST(32, MSB(CAST(16, MSB(op_AND_218), DUP(op_AND_218))), CAST(16, MSB(DUP(op_AND_218)), DUP(op_AND_218))));
	RzILOpPure *op_LSHIFT_224 = SHIFTL0(CAST(64, MSB(op_MUL_221), DUP(op_MUL_221)), SN(32, 0));
	RzILOpPure *cond_272 = ITE(DUP(op_EQ_202), op_LSHIFT_224, VARL("h_tmp404"));
	RzILOpPure *op_AND_274 = LOGAND(cond_272, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_278 = SHIFTL0(op_AND_274, SN(32, 0x20));
	RzILOpPure *op_OR_279 = LOGOR(op_AND_149, op_LSHIFT_278);
	RzILOpEffect *op_ASSIGN_280 = WRITE_REG(bundle, Rdd_op, op_OR_279);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_281 = SEQN(2, seq_271, op_ASSIGN_280);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_141, seq_281);
	return instruction_sequence;
}

// Rdd = vmpyeh(Rss,Rtt):<<1:sat
RzILOpEffect *hex_il_op_m2_vmpy2es_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_87 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rss, SN(32, 0));
	RzILOpPure *op_AND_18 = LOGAND(op_RSHIFT_15, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_25 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_28 = LOGAND(op_RSHIFT_25, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_31 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_18), DUP(op_AND_18))), CAST(16, MSB(DUP(op_AND_18)), DUP(op_AND_18))), CAST(32, MSB(CAST(16, MSB(op_AND_28), DUP(op_AND_28))), CAST(16, MSB(DUP(op_AND_28)), DUP(op_AND_28))));
	RzILOpPure *op_LSHIFT_34 = SHIFTL0(CAST(64, MSB(op_MUL_31), DUP(op_MUL_31)), SN(32, 1));
	RzILOpPure *op_RSHIFT_43 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_46 = LOGAND(op_RSHIFT_43, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_52 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_55 = LOGAND(op_RSHIFT_52, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_58 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_46), DUP(op_AND_46))), CAST(16, MSB(DUP(op_AND_46)), DUP(op_AND_46))), CAST(32, MSB(CAST(16, MSB(op_AND_55), DUP(op_AND_55))), CAST(16, MSB(DUP(op_AND_55)), DUP(op_AND_55))));
	RzILOpPure *op_LSHIFT_61 = SHIFTL0(CAST(64, MSB(op_MUL_58), DUP(op_MUL_58)), SN(32, 1));
	RzILOpPure *op_EQ_62 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_LSHIFT_34), SN(32, 0), SN(32, 0x20)), op_LSHIFT_61);
	RzILOpPure *op_RSHIFT_91 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_94 = LOGAND(op_RSHIFT_91, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_100 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_103 = LOGAND(op_RSHIFT_100, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_106 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_94), DUP(op_AND_94))), CAST(16, MSB(DUP(op_AND_94)), DUP(op_AND_94))), CAST(32, MSB(CAST(16, MSB(op_AND_103), DUP(op_AND_103))), CAST(16, MSB(DUP(op_AND_103)), DUP(op_AND_103))));
	RzILOpPure *op_LSHIFT_109 = SHIFTL0(CAST(64, MSB(op_MUL_106), DUP(op_MUL_106)), SN(32, 1));
	RzILOpPure *op_LT_112 = SLT(op_LSHIFT_109, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_117 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_118 = NEG(op_LSHIFT_117);
	RzILOpPure *op_LSHIFT_123 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_126 = SUB(op_LSHIFT_123, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_127 = ITE(op_LT_112, op_NEG_118, op_SUB_126);
	RzILOpEffect *gcc_expr_128 = BRANCH(op_EQ_62, EMPTY(), set_usr_field_call_87);

	// h_tmp405 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_130 = SETL("h_tmp405", cond_127);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_131 = SEQN(2, gcc_expr_128, op_ASSIGN_hybrid_tmp_130);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1)) ? (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) << 0x1) : h_tmp405) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_66 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_69 = LOGAND(op_RSHIFT_66, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_75 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_78 = LOGAND(op_RSHIFT_75, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_81 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_69), DUP(op_AND_69))), CAST(16, MSB(DUP(op_AND_69)), DUP(op_AND_69))), CAST(32, MSB(CAST(16, MSB(op_AND_78), DUP(op_AND_78))), CAST(16, MSB(DUP(op_AND_78)), DUP(op_AND_78))));
	RzILOpPure *op_LSHIFT_84 = SHIFTL0(CAST(64, MSB(op_MUL_81), DUP(op_MUL_81)), SN(32, 1));
	RzILOpPure *cond_132 = ITE(DUP(op_EQ_62), op_LSHIFT_84, VARL("h_tmp405"));
	RzILOpPure *op_AND_134 = LOGAND(cond_132, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_138 = SHIFTL0(op_AND_134, SN(32, 0));
	RzILOpPure *op_OR_139 = LOGOR(op_AND_7, op_LSHIFT_138);
	RzILOpEffect *op_ASSIGN_140 = WRITE_REG(bundle, Rdd_op, op_OR_139);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_141 = SEQN(2, seq_131, op_ASSIGN_140);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_227 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_156 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_159 = LOGAND(op_RSHIFT_156, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_165 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_168 = LOGAND(op_RSHIFT_165, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_171 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_159), DUP(op_AND_159))), CAST(16, MSB(DUP(op_AND_159)), DUP(op_AND_159))), CAST(32, MSB(CAST(16, MSB(op_AND_168), DUP(op_AND_168))), CAST(16, MSB(DUP(op_AND_168)), DUP(op_AND_168))));
	RzILOpPure *op_LSHIFT_174 = SHIFTL0(CAST(64, MSB(op_MUL_171), DUP(op_MUL_171)), SN(32, 1));
	RzILOpPure *op_RSHIFT_183 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_186 = LOGAND(op_RSHIFT_183, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_192 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_195 = LOGAND(op_RSHIFT_192, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_198 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_186), DUP(op_AND_186))), CAST(16, MSB(DUP(op_AND_186)), DUP(op_AND_186))), CAST(32, MSB(CAST(16, MSB(op_AND_195), DUP(op_AND_195))), CAST(16, MSB(DUP(op_AND_195)), DUP(op_AND_195))));
	RzILOpPure *op_LSHIFT_201 = SHIFTL0(CAST(64, MSB(op_MUL_198), DUP(op_MUL_198)), SN(32, 1));
	RzILOpPure *op_EQ_202 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_LSHIFT_174), SN(32, 0), SN(32, 0x20)), op_LSHIFT_201);
	RzILOpPure *op_RSHIFT_231 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_234 = LOGAND(op_RSHIFT_231, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_240 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_243 = LOGAND(op_RSHIFT_240, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_246 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_234), DUP(op_AND_234))), CAST(16, MSB(DUP(op_AND_234)), DUP(op_AND_234))), CAST(32, MSB(CAST(16, MSB(op_AND_243), DUP(op_AND_243))), CAST(16, MSB(DUP(op_AND_243)), DUP(op_AND_243))));
	RzILOpPure *op_LSHIFT_249 = SHIFTL0(CAST(64, MSB(op_MUL_246), DUP(op_MUL_246)), SN(32, 1));
	RzILOpPure *op_LT_252 = SLT(op_LSHIFT_249, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_257 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_258 = NEG(op_LSHIFT_257);
	RzILOpPure *op_LSHIFT_263 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_266 = SUB(op_LSHIFT_263, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_267 = ITE(op_LT_252, op_NEG_258, op_SUB_266);
	RzILOpEffect *gcc_expr_268 = BRANCH(op_EQ_202, EMPTY(), set_usr_field_call_227);

	// h_tmp406 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_270 = SETL("h_tmp406", cond_267);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_271 = SEQN(2, gcc_expr_268, op_ASSIGN_hybrid_tmp_270);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1)) ? (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) << 0x1) : h_tmp406) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_147 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_148 = LOGNOT(op_LSHIFT_147);
	RzILOpPure *op_AND_149 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_148);
	RzILOpPure *op_RSHIFT_206 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_209 = LOGAND(op_RSHIFT_206, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_215 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_218 = LOGAND(op_RSHIFT_215, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_221 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_209), DUP(op_AND_209))), CAST(16, MSB(DUP(op_AND_209)), DUP(op_AND_209))), CAST(32, MSB(CAST(16, MSB(op_AND_218), DUP(op_AND_218))), CAST(16, MSB(DUP(op_AND_218)), DUP(op_AND_218))));
	RzILOpPure *op_LSHIFT_224 = SHIFTL0(CAST(64, MSB(op_MUL_221), DUP(op_MUL_221)), SN(32, 1));
	RzILOpPure *cond_272 = ITE(DUP(op_EQ_202), op_LSHIFT_224, VARL("h_tmp406"));
	RzILOpPure *op_AND_274 = LOGAND(cond_272, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_278 = SHIFTL0(op_AND_274, SN(32, 0x20));
	RzILOpPure *op_OR_279 = LOGOR(op_AND_149, op_LSHIFT_278);
	RzILOpEffect *op_ASSIGN_280 = WRITE_REG(bundle, Rdd_op, op_OR_279);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_281 = SEQN(2, seq_271, op_ASSIGN_280);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_141, seq_281);
	return instruction_sequence;
}

// Rdd = vmpyh(Rs,Rt):sat
RzILOpEffect *hex_il_op_m2_vmpy2s_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_81 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_17 = LOGAND(op_RSHIFT_15, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_24 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_26 = LOGAND(op_RSHIFT_24, SN(32, 0xffff));
	RzILOpPure *op_MUL_29 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_17), DUP(op_AND_17))), CAST(16, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(CAST(16, MSB(op_AND_26), DUP(op_AND_26))), CAST(16, MSB(DUP(op_AND_26)), DUP(op_AND_26))));
	RzILOpPure *op_LSHIFT_32 = SHIFTL0(CAST(64, MSB(op_MUL_29), DUP(op_MUL_29)), SN(32, 0));
	RzILOpPure *op_RSHIFT_41 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_43 = LOGAND(op_RSHIFT_41, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_49 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_51 = LOGAND(op_RSHIFT_49, SN(32, 0xffff));
	RzILOpPure *op_MUL_54 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_43), DUP(op_AND_43))), CAST(16, MSB(DUP(op_AND_43)), DUP(op_AND_43))), CAST(32, MSB(CAST(16, MSB(op_AND_51), DUP(op_AND_51))), CAST(16, MSB(DUP(op_AND_51)), DUP(op_AND_51))));
	RzILOpPure *op_LSHIFT_57 = SHIFTL0(CAST(64, MSB(op_MUL_54), DUP(op_MUL_54)), SN(32, 0));
	RzILOpPure *op_EQ_58 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_LSHIFT_32), SN(32, 0), SN(32, 0x20)), op_LSHIFT_57);
	RzILOpPure *op_RSHIFT_85 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_87 = LOGAND(op_RSHIFT_85, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_93 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_95 = LOGAND(op_RSHIFT_93, SN(32, 0xffff));
	RzILOpPure *op_MUL_98 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_87), DUP(op_AND_87))), CAST(16, MSB(DUP(op_AND_87)), DUP(op_AND_87))), CAST(32, MSB(CAST(16, MSB(op_AND_95), DUP(op_AND_95))), CAST(16, MSB(DUP(op_AND_95)), DUP(op_AND_95))));
	RzILOpPure *op_LSHIFT_101 = SHIFTL0(CAST(64, MSB(op_MUL_98), DUP(op_MUL_98)), SN(32, 0));
	RzILOpPure *op_LT_104 = SLT(op_LSHIFT_101, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_109 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_110 = NEG(op_LSHIFT_109);
	RzILOpPure *op_LSHIFT_115 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_118 = SUB(op_LSHIFT_115, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_119 = ITE(op_LT_104, op_NEG_110, op_SUB_118);
	RzILOpEffect *gcc_expr_120 = BRANCH(op_EQ_58, EMPTY(), set_usr_field_call_81);

	// h_tmp407 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_122 = SETL("h_tmp407", cond_119);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_123 = SEQN(2, gcc_expr_120, op_ASSIGN_hybrid_tmp_122);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0)) ? (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) : h_tmp407) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_62 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_64 = LOGAND(op_RSHIFT_62, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_70 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_72 = LOGAND(op_RSHIFT_70, SN(32, 0xffff));
	RzILOpPure *op_MUL_75 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_64), DUP(op_AND_64))), CAST(16, MSB(DUP(op_AND_64)), DUP(op_AND_64))), CAST(32, MSB(CAST(16, MSB(op_AND_72), DUP(op_AND_72))), CAST(16, MSB(DUP(op_AND_72)), DUP(op_AND_72))));
	RzILOpPure *op_LSHIFT_78 = SHIFTL0(CAST(64, MSB(op_MUL_75), DUP(op_MUL_75)), SN(32, 0));
	RzILOpPure *cond_124 = ITE(DUP(op_EQ_58), op_LSHIFT_78, VARL("h_tmp407"));
	RzILOpPure *op_AND_126 = LOGAND(cond_124, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_130 = SHIFTL0(op_AND_126, SN(32, 0));
	RzILOpPure *op_OR_131 = LOGOR(op_AND_7, op_LSHIFT_130);
	RzILOpEffect *op_ASSIGN_132 = WRITE_REG(bundle, Rdd_op, op_OR_131);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_133 = SEQN(2, seq_123, op_ASSIGN_132);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_213 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_148 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_150 = LOGAND(op_RSHIFT_148, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_156 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_158 = LOGAND(op_RSHIFT_156, SN(32, 0xffff));
	RzILOpPure *op_MUL_161 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_150), DUP(op_AND_150))), CAST(16, MSB(DUP(op_AND_150)), DUP(op_AND_150))), CAST(32, MSB(CAST(16, MSB(op_AND_158), DUP(op_AND_158))), CAST(16, MSB(DUP(op_AND_158)), DUP(op_AND_158))));
	RzILOpPure *op_LSHIFT_164 = SHIFTL0(CAST(64, MSB(op_MUL_161), DUP(op_MUL_161)), SN(32, 0));
	RzILOpPure *op_RSHIFT_173 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_175 = LOGAND(op_RSHIFT_173, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_181 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_183 = LOGAND(op_RSHIFT_181, SN(32, 0xffff));
	RzILOpPure *op_MUL_186 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_175), DUP(op_AND_175))), CAST(16, MSB(DUP(op_AND_175)), DUP(op_AND_175))), CAST(32, MSB(CAST(16, MSB(op_AND_183), DUP(op_AND_183))), CAST(16, MSB(DUP(op_AND_183)), DUP(op_AND_183))));
	RzILOpPure *op_LSHIFT_189 = SHIFTL0(CAST(64, MSB(op_MUL_186), DUP(op_MUL_186)), SN(32, 0));
	RzILOpPure *op_EQ_190 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_LSHIFT_164), SN(32, 0), SN(32, 0x20)), op_LSHIFT_189);
	RzILOpPure *op_RSHIFT_217 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_219 = LOGAND(op_RSHIFT_217, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_225 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_227 = LOGAND(op_RSHIFT_225, SN(32, 0xffff));
	RzILOpPure *op_MUL_230 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_219), DUP(op_AND_219))), CAST(16, MSB(DUP(op_AND_219)), DUP(op_AND_219))), CAST(32, MSB(CAST(16, MSB(op_AND_227), DUP(op_AND_227))), CAST(16, MSB(DUP(op_AND_227)), DUP(op_AND_227))));
	RzILOpPure *op_LSHIFT_233 = SHIFTL0(CAST(64, MSB(op_MUL_230), DUP(op_MUL_230)), SN(32, 0));
	RzILOpPure *op_LT_236 = SLT(op_LSHIFT_233, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_241 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_242 = NEG(op_LSHIFT_241);
	RzILOpPure *op_LSHIFT_247 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_250 = SUB(op_LSHIFT_247, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_251 = ITE(op_LT_236, op_NEG_242, op_SUB_250);
	RzILOpEffect *gcc_expr_252 = BRANCH(op_EQ_190, EMPTY(), set_usr_field_call_213);

	// h_tmp408 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_254 = SETL("h_tmp408", cond_251);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_255 = SEQN(2, gcc_expr_252, op_ASSIGN_hybrid_tmp_254);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0)) ? (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) : h_tmp408) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_139 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_140 = LOGNOT(op_LSHIFT_139);
	RzILOpPure *op_AND_141 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_140);
	RzILOpPure *op_RSHIFT_194 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_196 = LOGAND(op_RSHIFT_194, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_202 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_204 = LOGAND(op_RSHIFT_202, SN(32, 0xffff));
	RzILOpPure *op_MUL_207 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_196), DUP(op_AND_196))), CAST(16, MSB(DUP(op_AND_196)), DUP(op_AND_196))), CAST(32, MSB(CAST(16, MSB(op_AND_204), DUP(op_AND_204))), CAST(16, MSB(DUP(op_AND_204)), DUP(op_AND_204))));
	RzILOpPure *op_LSHIFT_210 = SHIFTL0(CAST(64, MSB(op_MUL_207), DUP(op_MUL_207)), SN(32, 0));
	RzILOpPure *cond_256 = ITE(DUP(op_EQ_190), op_LSHIFT_210, VARL("h_tmp408"));
	RzILOpPure *op_AND_258 = LOGAND(cond_256, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_262 = SHIFTL0(op_AND_258, SN(32, 0x20));
	RzILOpPure *op_OR_263 = LOGOR(op_AND_141, op_LSHIFT_262);
	RzILOpEffect *op_ASSIGN_264 = WRITE_REG(bundle, Rdd_op, op_OR_263);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_265 = SEQN(2, seq_255, op_ASSIGN_264);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_133, seq_265);
	return instruction_sequence;
}

// Rd = vmpyh(Rs,Rt):rnd:sat
RzILOpEffect *hex_il_op_m2_vmpy2s_s0pack(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_91 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_16 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_18 = LOGAND(op_RSHIFT_16, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_25 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_27 = LOGAND(op_RSHIFT_25, SN(32, 0xffff));
	RzILOpPure *op_MUL_30 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_18), DUP(op_AND_18))), CAST(16, MSB(DUP(op_AND_18)), DUP(op_AND_18))), CAST(32, MSB(CAST(16, MSB(op_AND_27), DUP(op_AND_27))), CAST(16, MSB(DUP(op_AND_27)), DUP(op_AND_27))));
	RzILOpPure *op_LSHIFT_33 = SHIFTL0(CAST(64, MSB(op_MUL_30), DUP(op_MUL_30)), SN(32, 0));
	RzILOpPure *op_ADD_36 = ADD(op_LSHIFT_33, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_45 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_47 = LOGAND(op_RSHIFT_45, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_53 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_55 = LOGAND(op_RSHIFT_53, SN(32, 0xffff));
	RzILOpPure *op_MUL_58 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_47), DUP(op_AND_47))), CAST(16, MSB(DUP(op_AND_47)), DUP(op_AND_47))), CAST(32, MSB(CAST(16, MSB(op_AND_55), DUP(op_AND_55))), CAST(16, MSB(DUP(op_AND_55)), DUP(op_AND_55))));
	RzILOpPure *op_LSHIFT_61 = SHIFTL0(CAST(64, MSB(op_MUL_58), DUP(op_MUL_58)), SN(32, 0));
	RzILOpPure *op_ADD_64 = ADD(op_LSHIFT_61, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_EQ_65 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_36), SN(32, 0), SN(32, 0x20)), op_ADD_64);
	RzILOpPure *op_RSHIFT_95 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_97 = LOGAND(op_RSHIFT_95, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_103 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_105 = LOGAND(op_RSHIFT_103, SN(32, 0xffff));
	RzILOpPure *op_MUL_108 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_97), DUP(op_AND_97))), CAST(16, MSB(DUP(op_AND_97)), DUP(op_AND_97))), CAST(32, MSB(CAST(16, MSB(op_AND_105), DUP(op_AND_105))), CAST(16, MSB(DUP(op_AND_105)), DUP(op_AND_105))));
	RzILOpPure *op_LSHIFT_111 = SHIFTL0(CAST(64, MSB(op_MUL_108), DUP(op_MUL_108)), SN(32, 0));
	RzILOpPure *op_ADD_114 = ADD(op_LSHIFT_111, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_LT_117 = SLT(op_ADD_114, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_122 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_123 = NEG(op_LSHIFT_122);
	RzILOpPure *op_LSHIFT_128 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_131 = SUB(op_LSHIFT_128, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_132 = ITE(op_LT_117, op_NEG_123, op_SUB_131);
	RzILOpEffect *gcc_expr_133 = BRANCH(op_EQ_65, EMPTY(), set_usr_field_call_91);

	// h_tmp409 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_135 = SETL("h_tmp409", cond_132);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_136 = SEQN(2, gcc_expr_133, op_ASSIGN_hybrid_tmp_135);

	// Rd = ((st32) (((ut64) (((st64) Rd) & (~(0xffff << 0x10)))) | (((ut64) (((st32) ((st16) ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000)) ? (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x0) + ((st64) 0x8000) : h_tmp409) >> 0x10) & ((st64) 0xffff)))) & 0xffff)) << 0x10)));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffff), SN(32, 16));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_8 = LOGAND(CAST(64, MSB(READ_REG(pkt, Rd_op, true)), READ_REG(pkt, Rd_op, true)), op_NOT_6);
	RzILOpPure *op_RSHIFT_69 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_71 = LOGAND(op_RSHIFT_69, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_77 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_79 = LOGAND(op_RSHIFT_77, SN(32, 0xffff));
	RzILOpPure *op_MUL_82 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_71), DUP(op_AND_71))), CAST(16, MSB(DUP(op_AND_71)), DUP(op_AND_71))), CAST(32, MSB(CAST(16, MSB(op_AND_79), DUP(op_AND_79))), CAST(16, MSB(DUP(op_AND_79)), DUP(op_AND_79))));
	RzILOpPure *op_LSHIFT_85 = SHIFTL0(CAST(64, MSB(op_MUL_82), DUP(op_MUL_82)), SN(32, 0));
	RzILOpPure *op_ADD_88 = ADD(op_LSHIFT_85, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *cond_137 = ITE(DUP(op_EQ_65), op_ADD_88, VARL("h_tmp409"));
	RzILOpPure *op_RSHIFT_141 = SHIFTRA(cond_137, SN(32, 16));
	RzILOpPure *op_AND_144 = LOGAND(op_RSHIFT_141, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_AND_148 = LOGAND(CAST(32, MSB(CAST(16, MSB(op_AND_144), DUP(op_AND_144))), CAST(16, MSB(DUP(op_AND_144)), DUP(op_AND_144))), SN(32, 0xffff));
	RzILOpPure *op_LSHIFT_153 = SHIFTL0(CAST(64, IL_FALSE, op_AND_148), SN(32, 16));
	RzILOpPure *op_OR_155 = LOGOR(CAST(64, IL_FALSE, op_AND_8), op_LSHIFT_153);
	RzILOpEffect *op_ASSIGN_157 = WRITE_REG(bundle, Rd_op, CAST(32, IL_FALSE, op_OR_155));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_158 = SEQN(2, seq_136, op_ASSIGN_157);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_248 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_174 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_176 = LOGAND(op_RSHIFT_174, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_182 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_184 = LOGAND(op_RSHIFT_182, SN(32, 0xffff));
	RzILOpPure *op_MUL_187 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_176), DUP(op_AND_176))), CAST(16, MSB(DUP(op_AND_176)), DUP(op_AND_176))), CAST(32, MSB(CAST(16, MSB(op_AND_184), DUP(op_AND_184))), CAST(16, MSB(DUP(op_AND_184)), DUP(op_AND_184))));
	RzILOpPure *op_LSHIFT_190 = SHIFTL0(CAST(64, MSB(op_MUL_187), DUP(op_MUL_187)), SN(32, 0));
	RzILOpPure *op_ADD_193 = ADD(op_LSHIFT_190, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_202 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_204 = LOGAND(op_RSHIFT_202, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_210 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_212 = LOGAND(op_RSHIFT_210, SN(32, 0xffff));
	RzILOpPure *op_MUL_215 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_204), DUP(op_AND_204))), CAST(16, MSB(DUP(op_AND_204)), DUP(op_AND_204))), CAST(32, MSB(CAST(16, MSB(op_AND_212), DUP(op_AND_212))), CAST(16, MSB(DUP(op_AND_212)), DUP(op_AND_212))));
	RzILOpPure *op_LSHIFT_218 = SHIFTL0(CAST(64, MSB(op_MUL_215), DUP(op_MUL_215)), SN(32, 0));
	RzILOpPure *op_ADD_221 = ADD(op_LSHIFT_218, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_EQ_222 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_193), SN(32, 0), SN(32, 0x20)), op_ADD_221);
	RzILOpPure *op_RSHIFT_252 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_254 = LOGAND(op_RSHIFT_252, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_260 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_262 = LOGAND(op_RSHIFT_260, SN(32, 0xffff));
	RzILOpPure *op_MUL_265 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_254), DUP(op_AND_254))), CAST(16, MSB(DUP(op_AND_254)), DUP(op_AND_254))), CAST(32, MSB(CAST(16, MSB(op_AND_262), DUP(op_AND_262))), CAST(16, MSB(DUP(op_AND_262)), DUP(op_AND_262))));
	RzILOpPure *op_LSHIFT_268 = SHIFTL0(CAST(64, MSB(op_MUL_265), DUP(op_MUL_265)), SN(32, 0));
	RzILOpPure *op_ADD_271 = ADD(op_LSHIFT_268, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_LT_274 = SLT(op_ADD_271, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_279 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_280 = NEG(op_LSHIFT_279);
	RzILOpPure *op_LSHIFT_285 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_288 = SUB(op_LSHIFT_285, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_289 = ITE(op_LT_274, op_NEG_280, op_SUB_288);
	RzILOpEffect *gcc_expr_290 = BRANCH(op_EQ_222, EMPTY(), set_usr_field_call_248);

	// h_tmp410 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_292 = SETL("h_tmp410", cond_289);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_293 = SEQN(2, gcc_expr_290, op_ASSIGN_hybrid_tmp_292);

	// Rd = ((st32) (((ut64) (((st64) Rd) & (~(0xffff << 0x0)))) | (((ut64) (((st32) ((st16) ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + ((st64) 0x8000)) ? (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x0) + ((st64) 0x8000) : h_tmp410) >> 0x10) & ((st64) 0xffff)))) & 0xffff)) << 0x0)));
	RzILOpPure *op_LSHIFT_164 = SHIFTL0(SN(64, 0xffff), SN(32, 0));
	RzILOpPure *op_NOT_165 = LOGNOT(op_LSHIFT_164);
	RzILOpPure *op_AND_167 = LOGAND(CAST(64, MSB(READ_REG(pkt, Rd_op, true)), READ_REG(pkt, Rd_op, true)), op_NOT_165);
	RzILOpPure *op_RSHIFT_226 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_228 = LOGAND(op_RSHIFT_226, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_234 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_236 = LOGAND(op_RSHIFT_234, SN(32, 0xffff));
	RzILOpPure *op_MUL_239 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_228), DUP(op_AND_228))), CAST(16, MSB(DUP(op_AND_228)), DUP(op_AND_228))), CAST(32, MSB(CAST(16, MSB(op_AND_236), DUP(op_AND_236))), CAST(16, MSB(DUP(op_AND_236)), DUP(op_AND_236))));
	RzILOpPure *op_LSHIFT_242 = SHIFTL0(CAST(64, MSB(op_MUL_239), DUP(op_MUL_239)), SN(32, 0));
	RzILOpPure *op_ADD_245 = ADD(op_LSHIFT_242, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *cond_294 = ITE(DUP(op_EQ_222), op_ADD_245, VARL("h_tmp410"));
	RzILOpPure *op_RSHIFT_298 = SHIFTRA(cond_294, SN(32, 16));
	RzILOpPure *op_AND_301 = LOGAND(op_RSHIFT_298, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_AND_305 = LOGAND(CAST(32, MSB(CAST(16, MSB(op_AND_301), DUP(op_AND_301))), CAST(16, MSB(DUP(op_AND_301)), DUP(op_AND_301))), SN(32, 0xffff));
	RzILOpPure *op_LSHIFT_310 = SHIFTL0(CAST(64, IL_FALSE, op_AND_305), SN(32, 0));
	RzILOpPure *op_OR_312 = LOGOR(CAST(64, IL_FALSE, op_AND_167), op_LSHIFT_310);
	RzILOpEffect *op_ASSIGN_314 = WRITE_REG(bundle, Rd_op, CAST(32, IL_FALSE, op_OR_312));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_315 = SEQN(2, seq_293, op_ASSIGN_314);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_158, seq_315);
	return instruction_sequence;
}

// Rdd = vmpyh(Rs,Rt):<<1:sat
RzILOpEffect *hex_il_op_m2_vmpy2s_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_81 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_17 = LOGAND(op_RSHIFT_15, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_24 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_26 = LOGAND(op_RSHIFT_24, SN(32, 0xffff));
	RzILOpPure *op_MUL_29 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_17), DUP(op_AND_17))), CAST(16, MSB(DUP(op_AND_17)), DUP(op_AND_17))), CAST(32, MSB(CAST(16, MSB(op_AND_26), DUP(op_AND_26))), CAST(16, MSB(DUP(op_AND_26)), DUP(op_AND_26))));
	RzILOpPure *op_LSHIFT_32 = SHIFTL0(CAST(64, MSB(op_MUL_29), DUP(op_MUL_29)), SN(32, 1));
	RzILOpPure *op_RSHIFT_41 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_43 = LOGAND(op_RSHIFT_41, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_49 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_51 = LOGAND(op_RSHIFT_49, SN(32, 0xffff));
	RzILOpPure *op_MUL_54 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_43), DUP(op_AND_43))), CAST(16, MSB(DUP(op_AND_43)), DUP(op_AND_43))), CAST(32, MSB(CAST(16, MSB(op_AND_51), DUP(op_AND_51))), CAST(16, MSB(DUP(op_AND_51)), DUP(op_AND_51))));
	RzILOpPure *op_LSHIFT_57 = SHIFTL0(CAST(64, MSB(op_MUL_54), DUP(op_MUL_54)), SN(32, 1));
	RzILOpPure *op_EQ_58 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_LSHIFT_32), SN(32, 0), SN(32, 0x20)), op_LSHIFT_57);
	RzILOpPure *op_RSHIFT_85 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_87 = LOGAND(op_RSHIFT_85, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_93 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_95 = LOGAND(op_RSHIFT_93, SN(32, 0xffff));
	RzILOpPure *op_MUL_98 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_87), DUP(op_AND_87))), CAST(16, MSB(DUP(op_AND_87)), DUP(op_AND_87))), CAST(32, MSB(CAST(16, MSB(op_AND_95), DUP(op_AND_95))), CAST(16, MSB(DUP(op_AND_95)), DUP(op_AND_95))));
	RzILOpPure *op_LSHIFT_101 = SHIFTL0(CAST(64, MSB(op_MUL_98), DUP(op_MUL_98)), SN(32, 1));
	RzILOpPure *op_LT_104 = SLT(op_LSHIFT_101, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_109 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_110 = NEG(op_LSHIFT_109);
	RzILOpPure *op_LSHIFT_115 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_118 = SUB(op_LSHIFT_115, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_119 = ITE(op_LT_104, op_NEG_110, op_SUB_118);
	RzILOpEffect *gcc_expr_120 = BRANCH(op_EQ_58, EMPTY(), set_usr_field_call_81);

	// h_tmp411 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_122 = SETL("h_tmp411", cond_119);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_123 = SEQN(2, gcc_expr_120, op_ASSIGN_hybrid_tmp_122);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1)) ? (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) : h_tmp411) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_62 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_64 = LOGAND(op_RSHIFT_62, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_70 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_72 = LOGAND(op_RSHIFT_70, SN(32, 0xffff));
	RzILOpPure *op_MUL_75 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_64), DUP(op_AND_64))), CAST(16, MSB(DUP(op_AND_64)), DUP(op_AND_64))), CAST(32, MSB(CAST(16, MSB(op_AND_72), DUP(op_AND_72))), CAST(16, MSB(DUP(op_AND_72)), DUP(op_AND_72))));
	RzILOpPure *op_LSHIFT_78 = SHIFTL0(CAST(64, MSB(op_MUL_75), DUP(op_MUL_75)), SN(32, 1));
	RzILOpPure *cond_124 = ITE(DUP(op_EQ_58), op_LSHIFT_78, VARL("h_tmp411"));
	RzILOpPure *op_AND_126 = LOGAND(cond_124, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_130 = SHIFTL0(op_AND_126, SN(32, 0));
	RzILOpPure *op_OR_131 = LOGOR(op_AND_7, op_LSHIFT_130);
	RzILOpEffect *op_ASSIGN_132 = WRITE_REG(bundle, Rdd_op, op_OR_131);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_133 = SEQN(2, seq_123, op_ASSIGN_132);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_213 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_148 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_150 = LOGAND(op_RSHIFT_148, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_156 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_158 = LOGAND(op_RSHIFT_156, SN(32, 0xffff));
	RzILOpPure *op_MUL_161 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_150), DUP(op_AND_150))), CAST(16, MSB(DUP(op_AND_150)), DUP(op_AND_150))), CAST(32, MSB(CAST(16, MSB(op_AND_158), DUP(op_AND_158))), CAST(16, MSB(DUP(op_AND_158)), DUP(op_AND_158))));
	RzILOpPure *op_LSHIFT_164 = SHIFTL0(CAST(64, MSB(op_MUL_161), DUP(op_MUL_161)), SN(32, 1));
	RzILOpPure *op_RSHIFT_173 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_175 = LOGAND(op_RSHIFT_173, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_181 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_183 = LOGAND(op_RSHIFT_181, SN(32, 0xffff));
	RzILOpPure *op_MUL_186 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_175), DUP(op_AND_175))), CAST(16, MSB(DUP(op_AND_175)), DUP(op_AND_175))), CAST(32, MSB(CAST(16, MSB(op_AND_183), DUP(op_AND_183))), CAST(16, MSB(DUP(op_AND_183)), DUP(op_AND_183))));
	RzILOpPure *op_LSHIFT_189 = SHIFTL0(CAST(64, MSB(op_MUL_186), DUP(op_MUL_186)), SN(32, 1));
	RzILOpPure *op_EQ_190 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_LSHIFT_164), SN(32, 0), SN(32, 0x20)), op_LSHIFT_189);
	RzILOpPure *op_RSHIFT_217 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_219 = LOGAND(op_RSHIFT_217, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_225 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_227 = LOGAND(op_RSHIFT_225, SN(32, 0xffff));
	RzILOpPure *op_MUL_230 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_219), DUP(op_AND_219))), CAST(16, MSB(DUP(op_AND_219)), DUP(op_AND_219))), CAST(32, MSB(CAST(16, MSB(op_AND_227), DUP(op_AND_227))), CAST(16, MSB(DUP(op_AND_227)), DUP(op_AND_227))));
	RzILOpPure *op_LSHIFT_233 = SHIFTL0(CAST(64, MSB(op_MUL_230), DUP(op_MUL_230)), SN(32, 1));
	RzILOpPure *op_LT_236 = SLT(op_LSHIFT_233, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_241 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_242 = NEG(op_LSHIFT_241);
	RzILOpPure *op_LSHIFT_247 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_250 = SUB(op_LSHIFT_247, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_251 = ITE(op_LT_236, op_NEG_242, op_SUB_250);
	RzILOpEffect *gcc_expr_252 = BRANCH(op_EQ_190, EMPTY(), set_usr_field_call_213);

	// h_tmp412 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_254 = SETL("h_tmp412", cond_251);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_255 = SEQN(2, gcc_expr_252, op_ASSIGN_hybrid_tmp_254);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1)) ? (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) : h_tmp412) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_139 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_140 = LOGNOT(op_LSHIFT_139);
	RzILOpPure *op_AND_141 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_140);
	RzILOpPure *op_RSHIFT_194 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_196 = LOGAND(op_RSHIFT_194, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_202 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_204 = LOGAND(op_RSHIFT_202, SN(32, 0xffff));
	RzILOpPure *op_MUL_207 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_196), DUP(op_AND_196))), CAST(16, MSB(DUP(op_AND_196)), DUP(op_AND_196))), CAST(32, MSB(CAST(16, MSB(op_AND_204), DUP(op_AND_204))), CAST(16, MSB(DUP(op_AND_204)), DUP(op_AND_204))));
	RzILOpPure *op_LSHIFT_210 = SHIFTL0(CAST(64, MSB(op_MUL_207), DUP(op_MUL_207)), SN(32, 1));
	RzILOpPure *cond_256 = ITE(DUP(op_EQ_190), op_LSHIFT_210, VARL("h_tmp412"));
	RzILOpPure *op_AND_258 = LOGAND(cond_256, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_262 = SHIFTL0(op_AND_258, SN(32, 0x20));
	RzILOpPure *op_OR_263 = LOGOR(op_AND_141, op_LSHIFT_262);
	RzILOpEffect *op_ASSIGN_264 = WRITE_REG(bundle, Rdd_op, op_OR_263);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_265 = SEQN(2, seq_255, op_ASSIGN_264);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_133, seq_265);
	return instruction_sequence;
}

// Rd = vmpyh(Rs,Rt):<<1:rnd:sat
RzILOpEffect *hex_il_op_m2_vmpy2s_s1pack(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_91 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_16 = SHIFTRA(Rs, SN(32, 16));
	RzILOpPure *op_AND_18 = LOGAND(op_RSHIFT_16, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_25 = SHIFTRA(Rt, SN(32, 16));
	RzILOpPure *op_AND_27 = LOGAND(op_RSHIFT_25, SN(32, 0xffff));
	RzILOpPure *op_MUL_30 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_18), DUP(op_AND_18))), CAST(16, MSB(DUP(op_AND_18)), DUP(op_AND_18))), CAST(32, MSB(CAST(16, MSB(op_AND_27), DUP(op_AND_27))), CAST(16, MSB(DUP(op_AND_27)), DUP(op_AND_27))));
	RzILOpPure *op_LSHIFT_33 = SHIFTL0(CAST(64, MSB(op_MUL_30), DUP(op_MUL_30)), SN(32, 1));
	RzILOpPure *op_ADD_36 = ADD(op_LSHIFT_33, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_45 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_47 = LOGAND(op_RSHIFT_45, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_53 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_55 = LOGAND(op_RSHIFT_53, SN(32, 0xffff));
	RzILOpPure *op_MUL_58 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_47), DUP(op_AND_47))), CAST(16, MSB(DUP(op_AND_47)), DUP(op_AND_47))), CAST(32, MSB(CAST(16, MSB(op_AND_55), DUP(op_AND_55))), CAST(16, MSB(DUP(op_AND_55)), DUP(op_AND_55))));
	RzILOpPure *op_LSHIFT_61 = SHIFTL0(CAST(64, MSB(op_MUL_58), DUP(op_MUL_58)), SN(32, 1));
	RzILOpPure *op_ADD_64 = ADD(op_LSHIFT_61, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_EQ_65 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_36), SN(32, 0), SN(32, 0x20)), op_ADD_64);
	RzILOpPure *op_RSHIFT_95 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_97 = LOGAND(op_RSHIFT_95, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_103 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_105 = LOGAND(op_RSHIFT_103, SN(32, 0xffff));
	RzILOpPure *op_MUL_108 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_97), DUP(op_AND_97))), CAST(16, MSB(DUP(op_AND_97)), DUP(op_AND_97))), CAST(32, MSB(CAST(16, MSB(op_AND_105), DUP(op_AND_105))), CAST(16, MSB(DUP(op_AND_105)), DUP(op_AND_105))));
	RzILOpPure *op_LSHIFT_111 = SHIFTL0(CAST(64, MSB(op_MUL_108), DUP(op_MUL_108)), SN(32, 1));
	RzILOpPure *op_ADD_114 = ADD(op_LSHIFT_111, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_LT_117 = SLT(op_ADD_114, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_122 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_123 = NEG(op_LSHIFT_122);
	RzILOpPure *op_LSHIFT_128 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_131 = SUB(op_LSHIFT_128, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_132 = ITE(op_LT_117, op_NEG_123, op_SUB_131);
	RzILOpEffect *gcc_expr_133 = BRANCH(op_EQ_65, EMPTY(), set_usr_field_call_91);

	// h_tmp413 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_135 = SETL("h_tmp413", cond_132);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_136 = SEQN(2, gcc_expr_133, op_ASSIGN_hybrid_tmp_135);

	// Rd = ((st32) (((ut64) (((st64) Rd) & (~(0xffff << 0x10)))) | (((ut64) (((st32) ((st16) ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000)) ? (((st64) ((st32) ((st16) ((Rs >> 0x10) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x10) & 0xffff)))) << 0x1) + ((st64) 0x8000) : h_tmp413) >> 0x10) & ((st64) 0xffff)))) & 0xffff)) << 0x10)));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffff), SN(32, 16));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_8 = LOGAND(CAST(64, MSB(READ_REG(pkt, Rd_op, true)), READ_REG(pkt, Rd_op, true)), op_NOT_6);
	RzILOpPure *op_RSHIFT_69 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_71 = LOGAND(op_RSHIFT_69, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_77 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_79 = LOGAND(op_RSHIFT_77, SN(32, 0xffff));
	RzILOpPure *op_MUL_82 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_71), DUP(op_AND_71))), CAST(16, MSB(DUP(op_AND_71)), DUP(op_AND_71))), CAST(32, MSB(CAST(16, MSB(op_AND_79), DUP(op_AND_79))), CAST(16, MSB(DUP(op_AND_79)), DUP(op_AND_79))));
	RzILOpPure *op_LSHIFT_85 = SHIFTL0(CAST(64, MSB(op_MUL_82), DUP(op_MUL_82)), SN(32, 1));
	RzILOpPure *op_ADD_88 = ADD(op_LSHIFT_85, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *cond_137 = ITE(DUP(op_EQ_65), op_ADD_88, VARL("h_tmp413"));
	RzILOpPure *op_RSHIFT_141 = SHIFTRA(cond_137, SN(32, 16));
	RzILOpPure *op_AND_144 = LOGAND(op_RSHIFT_141, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_AND_148 = LOGAND(CAST(32, MSB(CAST(16, MSB(op_AND_144), DUP(op_AND_144))), CAST(16, MSB(DUP(op_AND_144)), DUP(op_AND_144))), SN(32, 0xffff));
	RzILOpPure *op_LSHIFT_153 = SHIFTL0(CAST(64, IL_FALSE, op_AND_148), SN(32, 16));
	RzILOpPure *op_OR_155 = LOGOR(CAST(64, IL_FALSE, op_AND_8), op_LSHIFT_153);
	RzILOpEffect *op_ASSIGN_157 = WRITE_REG(bundle, Rd_op, CAST(32, IL_FALSE, op_OR_155));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_158 = SEQN(2, seq_136, op_ASSIGN_157);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_248 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_174 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_176 = LOGAND(op_RSHIFT_174, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_182 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_184 = LOGAND(op_RSHIFT_182, SN(32, 0xffff));
	RzILOpPure *op_MUL_187 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_176), DUP(op_AND_176))), CAST(16, MSB(DUP(op_AND_176)), DUP(op_AND_176))), CAST(32, MSB(CAST(16, MSB(op_AND_184), DUP(op_AND_184))), CAST(16, MSB(DUP(op_AND_184)), DUP(op_AND_184))));
	RzILOpPure *op_LSHIFT_190 = SHIFTL0(CAST(64, MSB(op_MUL_187), DUP(op_MUL_187)), SN(32, 1));
	RzILOpPure *op_ADD_193 = ADD(op_LSHIFT_190, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_202 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_204 = LOGAND(op_RSHIFT_202, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_210 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_212 = LOGAND(op_RSHIFT_210, SN(32, 0xffff));
	RzILOpPure *op_MUL_215 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_204), DUP(op_AND_204))), CAST(16, MSB(DUP(op_AND_204)), DUP(op_AND_204))), CAST(32, MSB(CAST(16, MSB(op_AND_212), DUP(op_AND_212))), CAST(16, MSB(DUP(op_AND_212)), DUP(op_AND_212))));
	RzILOpPure *op_LSHIFT_218 = SHIFTL0(CAST(64, MSB(op_MUL_215), DUP(op_MUL_215)), SN(32, 1));
	RzILOpPure *op_ADD_221 = ADD(op_LSHIFT_218, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_EQ_222 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_193), SN(32, 0), SN(32, 0x20)), op_ADD_221);
	RzILOpPure *op_RSHIFT_252 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_254 = LOGAND(op_RSHIFT_252, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_260 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_262 = LOGAND(op_RSHIFT_260, SN(32, 0xffff));
	RzILOpPure *op_MUL_265 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_254), DUP(op_AND_254))), CAST(16, MSB(DUP(op_AND_254)), DUP(op_AND_254))), CAST(32, MSB(CAST(16, MSB(op_AND_262), DUP(op_AND_262))), CAST(16, MSB(DUP(op_AND_262)), DUP(op_AND_262))));
	RzILOpPure *op_LSHIFT_268 = SHIFTL0(CAST(64, MSB(op_MUL_265), DUP(op_MUL_265)), SN(32, 1));
	RzILOpPure *op_ADD_271 = ADD(op_LSHIFT_268, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_LT_274 = SLT(op_ADD_271, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_279 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_280 = NEG(op_LSHIFT_279);
	RzILOpPure *op_LSHIFT_285 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_288 = SUB(op_LSHIFT_285, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_289 = ITE(op_LT_274, op_NEG_280, op_SUB_288);
	RzILOpEffect *gcc_expr_290 = BRANCH(op_EQ_222, EMPTY(), set_usr_field_call_248);

	// h_tmp414 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_292 = SETL("h_tmp414", cond_289);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_293 = SEQN(2, gcc_expr_290, op_ASSIGN_hybrid_tmp_292);

	// Rd = ((st32) (((ut64) (((st64) Rd) & (~(0xffff << 0x0)))) | (((ut64) (((st32) ((st16) ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000)) ? (((st64) ((st32) ((st16) ((Rs >> 0x0) & 0xffff))) * ((st32) ((st16) ((Rt >> 0x0) & 0xffff)))) << 0x1) + ((st64) 0x8000) : h_tmp414) >> 0x10) & ((st64) 0xffff)))) & 0xffff)) << 0x0)));
	RzILOpPure *op_LSHIFT_164 = SHIFTL0(SN(64, 0xffff), SN(32, 0));
	RzILOpPure *op_NOT_165 = LOGNOT(op_LSHIFT_164);
	RzILOpPure *op_AND_167 = LOGAND(CAST(64, MSB(READ_REG(pkt, Rd_op, true)), READ_REG(pkt, Rd_op, true)), op_NOT_165);
	RzILOpPure *op_RSHIFT_226 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_228 = LOGAND(op_RSHIFT_226, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_234 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_236 = LOGAND(op_RSHIFT_234, SN(32, 0xffff));
	RzILOpPure *op_MUL_239 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_228), DUP(op_AND_228))), CAST(16, MSB(DUP(op_AND_228)), DUP(op_AND_228))), CAST(32, MSB(CAST(16, MSB(op_AND_236), DUP(op_AND_236))), CAST(16, MSB(DUP(op_AND_236)), DUP(op_AND_236))));
	RzILOpPure *op_LSHIFT_242 = SHIFTL0(CAST(64, MSB(op_MUL_239), DUP(op_MUL_239)), SN(32, 1));
	RzILOpPure *op_ADD_245 = ADD(op_LSHIFT_242, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *cond_294 = ITE(DUP(op_EQ_222), op_ADD_245, VARL("h_tmp414"));
	RzILOpPure *op_RSHIFT_298 = SHIFTRA(cond_294, SN(32, 16));
	RzILOpPure *op_AND_301 = LOGAND(op_RSHIFT_298, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_AND_305 = LOGAND(CAST(32, MSB(CAST(16, MSB(op_AND_301), DUP(op_AND_301))), CAST(16, MSB(DUP(op_AND_301)), DUP(op_AND_301))), SN(32, 0xffff));
	RzILOpPure *op_LSHIFT_310 = SHIFTL0(CAST(64, IL_FALSE, op_AND_305), SN(32, 0));
	RzILOpPure *op_OR_312 = LOGOR(CAST(64, IL_FALSE, op_AND_167), op_LSHIFT_310);
	RzILOpEffect *op_ASSIGN_314 = WRITE_REG(bundle, Rd_op, CAST(32, IL_FALSE, op_OR_312));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_315 = SEQN(2, seq_293, op_ASSIGN_314);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_158, seq_315);
	return instruction_sequence;
}

// Rdd = vmpyhsu(Rs,Rt):sat
RzILOpEffect *hex_il_op_m2_vmpy2su_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_87 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_17 = LOGAND(op_RSHIFT_15, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_24 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_26 = LOGAND(op_RSHIFT_24, SN(32, 0xffff));
	RzILOpPure *op_MUL_30 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_17), DUP(op_AND_17))), CAST(16, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_26)));
	RzILOpPure *op_LSHIFT_34 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_30)), CAST(32, IL_FALSE, DUP(op_MUL_30))), SN(32, 0));
	RzILOpPure *op_RSHIFT_43 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_45 = LOGAND(op_RSHIFT_43, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_51 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_53 = LOGAND(op_RSHIFT_51, SN(32, 0xffff));
	RzILOpPure *op_MUL_57 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_45), DUP(op_AND_45))), CAST(16, MSB(DUP(op_AND_45)), DUP(op_AND_45)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_53)));
	RzILOpPure *op_LSHIFT_61 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_57)), CAST(32, IL_FALSE, DUP(op_MUL_57))), SN(32, 0));
	RzILOpPure *op_EQ_62 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_LSHIFT_34), SN(32, 0), SN(32, 0x20)), op_LSHIFT_61);
	RzILOpPure *op_RSHIFT_91 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_93 = LOGAND(op_RSHIFT_91, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_99 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_101 = LOGAND(op_RSHIFT_99, SN(32, 0xffff));
	RzILOpPure *op_MUL_105 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_93), DUP(op_AND_93))), CAST(16, MSB(DUP(op_AND_93)), DUP(op_AND_93)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_101)));
	RzILOpPure *op_LSHIFT_109 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_105)), CAST(32, IL_FALSE, DUP(op_MUL_105))), SN(32, 0));
	RzILOpPure *op_LT_112 = SLT(op_LSHIFT_109, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_117 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_118 = NEG(op_LSHIFT_117);
	RzILOpPure *op_LSHIFT_123 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_126 = SUB(op_LSHIFT_123, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_127 = ITE(op_LT_112, op_NEG_118, op_SUB_126);
	RzILOpEffect *gcc_expr_128 = BRANCH(op_EQ_62, EMPTY(), set_usr_field_call_87);

	// h_tmp415 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_130 = SETL("h_tmp415", cond_127);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((ut32 ...;
	RzILOpEffect *seq_131 = SEQN(2, gcc_expr_128, op_ASSIGN_hybrid_tmp_130);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x0)) ? (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x0) : h_tmp415) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_66 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_68 = LOGAND(op_RSHIFT_66, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_74 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_76 = LOGAND(op_RSHIFT_74, SN(32, 0xffff));
	RzILOpPure *op_MUL_80 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_68), DUP(op_AND_68))), CAST(16, MSB(DUP(op_AND_68)), DUP(op_AND_68)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_76)));
	RzILOpPure *op_LSHIFT_84 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_80)), CAST(32, IL_FALSE, DUP(op_MUL_80))), SN(32, 0));
	RzILOpPure *cond_132 = ITE(DUP(op_EQ_62), op_LSHIFT_84, VARL("h_tmp415"));
	RzILOpPure *op_AND_134 = LOGAND(cond_132, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_138 = SHIFTL0(op_AND_134, SN(32, 0));
	RzILOpPure *op_OR_139 = LOGOR(op_AND_7, op_LSHIFT_138);
	RzILOpEffect *op_ASSIGN_140 = WRITE_REG(bundle, Rdd_op, op_OR_139);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_141 = SEQN(2, seq_131, op_ASSIGN_140);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_227 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_156 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_158 = LOGAND(op_RSHIFT_156, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_164 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_166 = LOGAND(op_RSHIFT_164, SN(32, 0xffff));
	RzILOpPure *op_MUL_170 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_158), DUP(op_AND_158))), CAST(16, MSB(DUP(op_AND_158)), DUP(op_AND_158)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_166)));
	RzILOpPure *op_LSHIFT_174 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_170)), CAST(32, IL_FALSE, DUP(op_MUL_170))), SN(32, 0));
	RzILOpPure *op_RSHIFT_183 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_185 = LOGAND(op_RSHIFT_183, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_191 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_193 = LOGAND(op_RSHIFT_191, SN(32, 0xffff));
	RzILOpPure *op_MUL_197 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_185), DUP(op_AND_185))), CAST(16, MSB(DUP(op_AND_185)), DUP(op_AND_185)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_193)));
	RzILOpPure *op_LSHIFT_201 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_197)), CAST(32, IL_FALSE, DUP(op_MUL_197))), SN(32, 0));
	RzILOpPure *op_EQ_202 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_LSHIFT_174), SN(32, 0), SN(32, 0x20)), op_LSHIFT_201);
	RzILOpPure *op_RSHIFT_231 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_233 = LOGAND(op_RSHIFT_231, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_239 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_241 = LOGAND(op_RSHIFT_239, SN(32, 0xffff));
	RzILOpPure *op_MUL_245 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_233), DUP(op_AND_233))), CAST(16, MSB(DUP(op_AND_233)), DUP(op_AND_233)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_241)));
	RzILOpPure *op_LSHIFT_249 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_245)), CAST(32, IL_FALSE, DUP(op_MUL_245))), SN(32, 0));
	RzILOpPure *op_LT_252 = SLT(op_LSHIFT_249, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_257 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_258 = NEG(op_LSHIFT_257);
	RzILOpPure *op_LSHIFT_263 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_266 = SUB(op_LSHIFT_263, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_267 = ITE(op_LT_252, op_NEG_258, op_SUB_266);
	RzILOpEffect *gcc_expr_268 = BRANCH(op_EQ_202, EMPTY(), set_usr_field_call_227);

	// h_tmp416 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x0))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x0) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_270 = SETL("h_tmp416", cond_267);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((ut32 ...;
	RzILOpEffect *seq_271 = SEQN(2, gcc_expr_268, op_ASSIGN_hybrid_tmp_270);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x0)), 0x0, 0x20) == (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x0)) ? (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x0) : h_tmp416) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_147 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_148 = LOGNOT(op_LSHIFT_147);
	RzILOpPure *op_AND_149 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_148);
	RzILOpPure *op_RSHIFT_206 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_208 = LOGAND(op_RSHIFT_206, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_214 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_216 = LOGAND(op_RSHIFT_214, SN(32, 0xffff));
	RzILOpPure *op_MUL_220 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_208), DUP(op_AND_208))), CAST(16, MSB(DUP(op_AND_208)), DUP(op_AND_208)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_216)));
	RzILOpPure *op_LSHIFT_224 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_220)), CAST(32, IL_FALSE, DUP(op_MUL_220))), SN(32, 0));
	RzILOpPure *cond_272 = ITE(DUP(op_EQ_202), op_LSHIFT_224, VARL("h_tmp416"));
	RzILOpPure *op_AND_274 = LOGAND(cond_272, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_278 = SHIFTL0(op_AND_274, SN(32, 0x20));
	RzILOpPure *op_OR_279 = LOGOR(op_AND_149, op_LSHIFT_278);
	RzILOpEffect *op_ASSIGN_280 = WRITE_REG(bundle, Rdd_op, op_OR_279);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_281 = SEQN(2, seq_271, op_ASSIGN_280);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_141, seq_281);
	return instruction_sequence;
}

// Rdd = vmpyhsu(Rs,Rt):<<1:sat
RzILOpEffect *hex_il_op_m2_vmpy2su_s1(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_87 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rs, SN(32, 0));
	RzILOpPure *op_AND_17 = LOGAND(op_RSHIFT_15, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_24 = SHIFTRA(Rt, SN(32, 0));
	RzILOpPure *op_AND_26 = LOGAND(op_RSHIFT_24, SN(32, 0xffff));
	RzILOpPure *op_MUL_30 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_17), DUP(op_AND_17))), CAST(16, MSB(DUP(op_AND_17)), DUP(op_AND_17)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_26)));
	RzILOpPure *op_LSHIFT_34 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_30)), CAST(32, IL_FALSE, DUP(op_MUL_30))), SN(32, 1));
	RzILOpPure *op_RSHIFT_43 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_45 = LOGAND(op_RSHIFT_43, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_51 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_53 = LOGAND(op_RSHIFT_51, SN(32, 0xffff));
	RzILOpPure *op_MUL_57 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_45), DUP(op_AND_45))), CAST(16, MSB(DUP(op_AND_45)), DUP(op_AND_45)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_53)));
	RzILOpPure *op_LSHIFT_61 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_57)), CAST(32, IL_FALSE, DUP(op_MUL_57))), SN(32, 1));
	RzILOpPure *op_EQ_62 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_LSHIFT_34), SN(32, 0), SN(32, 0x20)), op_LSHIFT_61);
	RzILOpPure *op_RSHIFT_91 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_93 = LOGAND(op_RSHIFT_91, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_99 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_101 = LOGAND(op_RSHIFT_99, SN(32, 0xffff));
	RzILOpPure *op_MUL_105 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_93), DUP(op_AND_93))), CAST(16, MSB(DUP(op_AND_93)), DUP(op_AND_93)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_101)));
	RzILOpPure *op_LSHIFT_109 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_105)), CAST(32, IL_FALSE, DUP(op_MUL_105))), SN(32, 1));
	RzILOpPure *op_LT_112 = SLT(op_LSHIFT_109, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_117 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_118 = NEG(op_LSHIFT_117);
	RzILOpPure *op_LSHIFT_123 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_126 = SUB(op_LSHIFT_123, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_127 = ITE(op_LT_112, op_NEG_118, op_SUB_126);
	RzILOpEffect *gcc_expr_128 = BRANCH(op_EQ_62, EMPTY(), set_usr_field_call_87);

	// h_tmp417 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_130 = SETL("h_tmp417", cond_127);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((ut32 ...;
	RzILOpEffect *seq_131 = SEQN(2, gcc_expr_128, op_ASSIGN_hybrid_tmp_130);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1)) ? (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x0) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x0) & 0xffff))))) << 0x1) : h_tmp417) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_66 = SHIFTRA(DUP(Rs), SN(32, 0));
	RzILOpPure *op_AND_68 = LOGAND(op_RSHIFT_66, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_74 = SHIFTRA(DUP(Rt), SN(32, 0));
	RzILOpPure *op_AND_76 = LOGAND(op_RSHIFT_74, SN(32, 0xffff));
	RzILOpPure *op_MUL_80 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_68), DUP(op_AND_68))), CAST(16, MSB(DUP(op_AND_68)), DUP(op_AND_68)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_76)));
	RzILOpPure *op_LSHIFT_84 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_80)), CAST(32, IL_FALSE, DUP(op_MUL_80))), SN(32, 1));
	RzILOpPure *cond_132 = ITE(DUP(op_EQ_62), op_LSHIFT_84, VARL("h_tmp417"));
	RzILOpPure *op_AND_134 = LOGAND(cond_132, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_138 = SHIFTL0(op_AND_134, SN(32, 0));
	RzILOpPure *op_OR_139 = LOGOR(op_AND_7, op_LSHIFT_138);
	RzILOpEffect *op_ASSIGN_140 = WRITE_REG(bundle, Rdd_op, op_OR_139);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_141 = SEQN(2, seq_131, op_ASSIGN_140);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_227 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_156 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_158 = LOGAND(op_RSHIFT_156, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_164 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_166 = LOGAND(op_RSHIFT_164, SN(32, 0xffff));
	RzILOpPure *op_MUL_170 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_158), DUP(op_AND_158))), CAST(16, MSB(DUP(op_AND_158)), DUP(op_AND_158)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_166)));
	RzILOpPure *op_LSHIFT_174 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_170)), CAST(32, IL_FALSE, DUP(op_MUL_170))), SN(32, 1));
	RzILOpPure *op_RSHIFT_183 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_185 = LOGAND(op_RSHIFT_183, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_191 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_193 = LOGAND(op_RSHIFT_191, SN(32, 0xffff));
	RzILOpPure *op_MUL_197 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_185), DUP(op_AND_185))), CAST(16, MSB(DUP(op_AND_185)), DUP(op_AND_185)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_193)));
	RzILOpPure *op_LSHIFT_201 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_197)), CAST(32, IL_FALSE, DUP(op_MUL_197))), SN(32, 1));
	RzILOpPure *op_EQ_202 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_LSHIFT_174), SN(32, 0), SN(32, 0x20)), op_LSHIFT_201);
	RzILOpPure *op_RSHIFT_231 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_233 = LOGAND(op_RSHIFT_231, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_239 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_241 = LOGAND(op_RSHIFT_239, SN(32, 0xffff));
	RzILOpPure *op_MUL_245 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_233), DUP(op_AND_233))), CAST(16, MSB(DUP(op_AND_233)), DUP(op_AND_233)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_241)));
	RzILOpPure *op_LSHIFT_249 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_245)), CAST(32, IL_FALSE, DUP(op_MUL_245))), SN(32, 1));
	RzILOpPure *op_LT_252 = SLT(op_LSHIFT_249, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_257 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_258 = NEG(op_LSHIFT_257);
	RzILOpPure *op_LSHIFT_263 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_266 = SUB(op_LSHIFT_263, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_267 = ITE(op_LT_252, op_NEG_258, op_SUB_266);
	RzILOpEffect *gcc_expr_268 = BRANCH(op_EQ_202, EMPTY(), set_usr_field_call_227);

	// h_tmp418 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_270 = SETL("h_tmp418", cond_267);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((ut32 ...;
	RzILOpEffect *seq_271 = SEQN(2, gcc_expr_268, op_ASSIGN_hybrid_tmp_270);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1)) ? (((st64) ((st32) ((ut32) ((st32) ((st16) ((Rs >> 0x10) & 0xffff)))) * ((ut32) ((ut16) ((Rt >> 0x10) & 0xffff))))) << 0x1) : h_tmp418) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_147 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_148 = LOGNOT(op_LSHIFT_147);
	RzILOpPure *op_AND_149 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_148);
	RzILOpPure *op_RSHIFT_206 = SHIFTRA(DUP(Rs), SN(32, 16));
	RzILOpPure *op_AND_208 = LOGAND(op_RSHIFT_206, SN(32, 0xffff));
	RzILOpPure *op_RSHIFT_214 = SHIFTRA(DUP(Rt), SN(32, 16));
	RzILOpPure *op_AND_216 = LOGAND(op_RSHIFT_214, SN(32, 0xffff));
	RzILOpPure *op_MUL_220 = MUL(CAST(32, IL_FALSE, CAST(32, MSB(CAST(16, MSB(op_AND_208), DUP(op_AND_208))), CAST(16, MSB(DUP(op_AND_208)), DUP(op_AND_208)))), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_216)));
	RzILOpPure *op_LSHIFT_224 = SHIFTL0(CAST(64, MSB(CAST(32, IL_FALSE, op_MUL_220)), CAST(32, IL_FALSE, DUP(op_MUL_220))), SN(32, 1));
	RzILOpPure *cond_272 = ITE(DUP(op_EQ_202), op_LSHIFT_224, VARL("h_tmp418"));
	RzILOpPure *op_AND_274 = LOGAND(cond_272, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_278 = SHIFTL0(op_AND_274, SN(32, 0x20));
	RzILOpPure *op_OR_279 = LOGOR(op_AND_149, op_LSHIFT_278);
	RzILOpEffect *op_ASSIGN_280 = WRITE_REG(bundle, Rdd_op, op_OR_279);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_281 = SEQN(2, seq_271, op_ASSIGN_280);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_141, seq_281);
	return instruction_sequence;
}

// Rd = vraddh(Rss,Rtt)
RzILOpEffect *hex_il_op_m2_vraddh(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	// Declare: st32 i;
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// Rd = 0x0;
	RzILOpEffect *op_ASSIGN_3 = WRITE_REG(bundle, Rd_op, SN(32, 0));

	// i = 0x0;
	RzILOpEffect *op_ASSIGN_5 = SETL("i", SN(32, 0));

	// HYB(++i);
	RzILOpEffect *op_INC_8 = SETL("i", INC(VARL("i"), 32));

	// h_tmp419 = HYB(++i);
	RzILOpEffect *op_ASSIGN_hybrid_tmp_10 = SETL("h_tmp419", VARL("i"));

	// seq(h_tmp419 = HYB(++i); HYB(++i));
	RzILOpEffect *seq_11 = SEQN(2, op_ASSIGN_hybrid_tmp_10, op_INC_8);

	// Rd = Rd + ((st32) ((st16) ((Rss >> i * 0x10) & ((st64) 0xffff)))) + ((st32) ((st16) ((Rtt >> i * 0x10) & ((st64) 0xffff))));
	RzILOpPure *op_MUL_14 = MUL(VARL("i"), SN(32, 16));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rss, op_MUL_14);
	RzILOpPure *op_AND_18 = LOGAND(op_RSHIFT_15, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_22 = MUL(VARL("i"), SN(32, 16));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rtt, op_MUL_22);
	RzILOpPure *op_AND_26 = LOGAND(op_RSHIFT_23, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_ADD_30 = ADD(CAST(32, MSB(CAST(16, MSB(op_AND_18), DUP(op_AND_18))), CAST(16, MSB(DUP(op_AND_18)), DUP(op_AND_18))), CAST(32, MSB(CAST(16, MSB(op_AND_26), DUP(op_AND_26))), CAST(16, MSB(DUP(op_AND_26)), DUP(op_AND_26))));
	RzILOpPure *op_ADD_31 = ADD(READ_REG(pkt, Rd_op, true), op_ADD_30);
	RzILOpEffect *op_ASSIGN_ADD_32 = WRITE_REG(bundle, Rd_op, op_ADD_31);

	// seq(h_tmp419; Rd = Rd + ((st32) ((st16) ((Rss >> i * 0x10) & ((s ...;
	RzILOpEffect *seq_33 = op_ASSIGN_ADD_32;

	// seq(seq(h_tmp419; Rd = Rd + ((st32) ((st16) ((Rss >> i * 0x10) & ...;
	RzILOpEffect *seq_34 = SEQN(2, seq_33, seq_11);

	// while ((i < 0x4)) { seq(seq(h_tmp419; Rd = Rd + ((st32) ((st16) ((Rss >> i * 0x10) & ... };
	RzILOpPure *op_LT_7 = SLT(VARL("i"), SN(32, 4));
	RzILOpEffect *for_35 = REPEAT(op_LT_7, seq_34);

	// seq(i = 0x0; while ((i < 0x4)) { seq(seq(h_tmp419; Rd = Rd + ((s ...;
	RzILOpEffect *seq_36 = SEQN(2, op_ASSIGN_5, for_35);

	RzILOpEffect *instruction_sequence = SEQN(2, op_ASSIGN_3, seq_36);
	return instruction_sequence;
}

// Rd = vradduh(Rss,Rtt)
RzILOpEffect *hex_il_op_m2_vradduh(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	// Declare: st32 i;
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// Rd = 0x0;
	RzILOpEffect *op_ASSIGN_3 = WRITE_REG(bundle, Rd_op, SN(32, 0));

	// i = 0x0;
	RzILOpEffect *op_ASSIGN_5 = SETL("i", SN(32, 0));

	// HYB(++i);
	RzILOpEffect *op_INC_8 = SETL("i", INC(VARL("i"), 32));

	// h_tmp420 = HYB(++i);
	RzILOpEffect *op_ASSIGN_hybrid_tmp_10 = SETL("h_tmp420", VARL("i"));

	// seq(h_tmp420 = HYB(++i); HYB(++i));
	RzILOpEffect *seq_11 = SEQN(2, op_ASSIGN_hybrid_tmp_10, op_INC_8);

	// Rd = Rd + ((st32) ((ut16) ((Rss >> i * 0x10) & ((st64) 0xffff)))) + ((st32) ((ut16) ((Rtt >> i * 0x10) & ((st64) 0xffff))));
	RzILOpPure *op_MUL_14 = MUL(VARL("i"), SN(32, 16));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rss, op_MUL_14);
	RzILOpPure *op_AND_18 = LOGAND(op_RSHIFT_15, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_22 = MUL(VARL("i"), SN(32, 16));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rtt, op_MUL_22);
	RzILOpPure *op_AND_26 = LOGAND(op_RSHIFT_23, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_ADD_30 = ADD(CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_18)), CAST(32, IL_FALSE, CAST(16, IL_FALSE, op_AND_26)));
	RzILOpPure *op_ADD_31 = ADD(READ_REG(pkt, Rd_op, true), op_ADD_30);
	RzILOpEffect *op_ASSIGN_ADD_32 = WRITE_REG(bundle, Rd_op, op_ADD_31);

	// seq(h_tmp420; Rd = Rd + ((st32) ((ut16) ((Rss >> i * 0x10) & ((s ...;
	RzILOpEffect *seq_33 = op_ASSIGN_ADD_32;

	// seq(seq(h_tmp420; Rd = Rd + ((st32) ((ut16) ((Rss >> i * 0x10) & ...;
	RzILOpEffect *seq_34 = SEQN(2, seq_33, seq_11);

	// while ((i < 0x4)) { seq(seq(h_tmp420; Rd = Rd + ((st32) ((ut16) ((Rss >> i * 0x10) & ... };
	RzILOpPure *op_LT_7 = SLT(VARL("i"), SN(32, 4));
	RzILOpEffect *for_35 = REPEAT(op_LT_7, seq_34);

	// seq(i = 0x0; while ((i < 0x4)) { seq(seq(h_tmp420; Rd = Rd + ((s ...;
	RzILOpEffect *seq_36 = SEQN(2, op_ASSIGN_5, for_35);

	RzILOpEffect *instruction_sequence = SEQN(2, op_ASSIGN_3, seq_36);
	return instruction_sequence;
}

// Rxx += vrcmpyi(Rss,Rtt)
RzILOpEffect *hex_il_op_m2_vrcmaci_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// Rxx = Rxx + ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rss, SN(32, 16));
	RzILOpPure *op_AND_8 = LOGAND(op_RSHIFT_5, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_18 = LOGAND(op_RSHIFT_15, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_21 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_8), DUP(op_AND_8))), CAST(16, MSB(DUP(op_AND_8)), DUP(op_AND_8))), CAST(32, MSB(CAST(16, MSB(op_AND_18), DUP(op_AND_18))), CAST(16, MSB(DUP(op_AND_18)), DUP(op_AND_18))));
	RzILOpPure *op_ADD_23 = ADD(READ_REG(pkt, Rxx_op, false), CAST(64, MSB(op_MUL_21), DUP(op_MUL_21)));
	RzILOpPure *op_RSHIFT_27 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_30 = LOGAND(op_RSHIFT_27, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_36 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_39 = LOGAND(op_RSHIFT_36, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_42 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_30), DUP(op_AND_30))), CAST(16, MSB(DUP(op_AND_30)), DUP(op_AND_30))), CAST(32, MSB(CAST(16, MSB(op_AND_39), DUP(op_AND_39))), CAST(16, MSB(DUP(op_AND_39)), DUP(op_AND_39))));
	RzILOpPure *op_ADD_44 = ADD(op_ADD_23, CAST(64, MSB(op_MUL_42), DUP(op_MUL_42)));
	RzILOpPure *op_RSHIFT_48 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_51 = LOGAND(op_RSHIFT_48, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_57 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_60 = LOGAND(op_RSHIFT_57, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_63 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_51), DUP(op_AND_51))), CAST(16, MSB(DUP(op_AND_51)), DUP(op_AND_51))), CAST(32, MSB(CAST(16, MSB(op_AND_60), DUP(op_AND_60))), CAST(16, MSB(DUP(op_AND_60)), DUP(op_AND_60))));
	RzILOpPure *op_ADD_65 = ADD(op_ADD_44, CAST(64, MSB(op_MUL_63), DUP(op_MUL_63)));
	RzILOpPure *op_RSHIFT_69 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_72 = LOGAND(op_RSHIFT_69, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_78 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_81 = LOGAND(op_RSHIFT_78, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_84 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_72), DUP(op_AND_72))), CAST(16, MSB(DUP(op_AND_72)), DUP(op_AND_72))), CAST(32, MSB(CAST(16, MSB(op_AND_81), DUP(op_AND_81))), CAST(16, MSB(DUP(op_AND_81)), DUP(op_AND_81))));
	RzILOpPure *op_ADD_86 = ADD(op_ADD_65, CAST(64, MSB(op_MUL_84), DUP(op_MUL_84)));
	RzILOpEffect *op_ASSIGN_87 = WRITE_REG(bundle, Rxx_op, op_ADD_86);

	RzILOpEffect *instruction_sequence = op_ASSIGN_87;
	return instruction_sequence;
}

// Rxx += vrcmpyi(Rss,Rtt*)
RzILOpEffect *hex_il_op_m2_vrcmaci_s0c(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// Rxx = Rxx + ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rss, SN(32, 16));
	RzILOpPure *op_AND_8 = LOGAND(op_RSHIFT_5, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_18 = LOGAND(op_RSHIFT_15, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_21 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_8), DUP(op_AND_8))), CAST(16, MSB(DUP(op_AND_8)), DUP(op_AND_8))), CAST(32, MSB(CAST(16, MSB(op_AND_18), DUP(op_AND_18))), CAST(16, MSB(DUP(op_AND_18)), DUP(op_AND_18))));
	RzILOpPure *op_ADD_23 = ADD(READ_REG(pkt, Rxx_op, false), CAST(64, MSB(op_MUL_21), DUP(op_MUL_21)));
	RzILOpPure *op_RSHIFT_27 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_30 = LOGAND(op_RSHIFT_27, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_36 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_39 = LOGAND(op_RSHIFT_36, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_42 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_30), DUP(op_AND_30))), CAST(16, MSB(DUP(op_AND_30)), DUP(op_AND_30))), CAST(32, MSB(CAST(16, MSB(op_AND_39), DUP(op_AND_39))), CAST(16, MSB(DUP(op_AND_39)), DUP(op_AND_39))));
	RzILOpPure *op_SUB_44 = SUB(op_ADD_23, CAST(64, MSB(op_MUL_42), DUP(op_MUL_42)));
	RzILOpPure *op_RSHIFT_48 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_51 = LOGAND(op_RSHIFT_48, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_57 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_60 = LOGAND(op_RSHIFT_57, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_63 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_51), DUP(op_AND_51))), CAST(16, MSB(DUP(op_AND_51)), DUP(op_AND_51))), CAST(32, MSB(CAST(16, MSB(op_AND_60), DUP(op_AND_60))), CAST(16, MSB(DUP(op_AND_60)), DUP(op_AND_60))));
	RzILOpPure *op_ADD_65 = ADD(op_SUB_44, CAST(64, MSB(op_MUL_63), DUP(op_MUL_63)));
	RzILOpPure *op_RSHIFT_69 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_72 = LOGAND(op_RSHIFT_69, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_78 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_81 = LOGAND(op_RSHIFT_78, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_84 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_72), DUP(op_AND_72))), CAST(16, MSB(DUP(op_AND_72)), DUP(op_AND_72))), CAST(32, MSB(CAST(16, MSB(op_AND_81), DUP(op_AND_81))), CAST(16, MSB(DUP(op_AND_81)), DUP(op_AND_81))));
	RzILOpPure *op_SUB_86 = SUB(op_ADD_65, CAST(64, MSB(op_MUL_84), DUP(op_MUL_84)));
	RzILOpEffect *op_ASSIGN_87 = WRITE_REG(bundle, Rxx_op, op_SUB_86);

	RzILOpEffect *instruction_sequence = op_ASSIGN_87;
	return instruction_sequence;
}

// Rxx += vrcmpyr(Rss,Rtt)
RzILOpEffect *hex_il_op_m2_vrcmacr_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// Rxx = Rxx + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rss, SN(32, 0));
	RzILOpPure *op_AND_8 = LOGAND(op_RSHIFT_5, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_18 = LOGAND(op_RSHIFT_15, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_21 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_8), DUP(op_AND_8))), CAST(16, MSB(DUP(op_AND_8)), DUP(op_AND_8))), CAST(32, MSB(CAST(16, MSB(op_AND_18), DUP(op_AND_18))), CAST(16, MSB(DUP(op_AND_18)), DUP(op_AND_18))));
	RzILOpPure *op_ADD_23 = ADD(READ_REG(pkt, Rxx_op, false), CAST(64, MSB(op_MUL_21), DUP(op_MUL_21)));
	RzILOpPure *op_RSHIFT_27 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_30 = LOGAND(op_RSHIFT_27, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_36 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_39 = LOGAND(op_RSHIFT_36, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_42 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_30), DUP(op_AND_30))), CAST(16, MSB(DUP(op_AND_30)), DUP(op_AND_30))), CAST(32, MSB(CAST(16, MSB(op_AND_39), DUP(op_AND_39))), CAST(16, MSB(DUP(op_AND_39)), DUP(op_AND_39))));
	RzILOpPure *op_SUB_44 = SUB(op_ADD_23, CAST(64, MSB(op_MUL_42), DUP(op_MUL_42)));
	RzILOpPure *op_RSHIFT_48 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_51 = LOGAND(op_RSHIFT_48, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_57 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_60 = LOGAND(op_RSHIFT_57, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_63 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_51), DUP(op_AND_51))), CAST(16, MSB(DUP(op_AND_51)), DUP(op_AND_51))), CAST(32, MSB(CAST(16, MSB(op_AND_60), DUP(op_AND_60))), CAST(16, MSB(DUP(op_AND_60)), DUP(op_AND_60))));
	RzILOpPure *op_ADD_65 = ADD(op_SUB_44, CAST(64, MSB(op_MUL_63), DUP(op_MUL_63)));
	RzILOpPure *op_RSHIFT_69 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_72 = LOGAND(op_RSHIFT_69, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_78 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_81 = LOGAND(op_RSHIFT_78, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_84 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_72), DUP(op_AND_72))), CAST(16, MSB(DUP(op_AND_72)), DUP(op_AND_72))), CAST(32, MSB(CAST(16, MSB(op_AND_81), DUP(op_AND_81))), CAST(16, MSB(DUP(op_AND_81)), DUP(op_AND_81))));
	RzILOpPure *op_SUB_86 = SUB(op_ADD_65, CAST(64, MSB(op_MUL_84), DUP(op_MUL_84)));
	RzILOpEffect *op_ASSIGN_87 = WRITE_REG(bundle, Rxx_op, op_SUB_86);

	RzILOpEffect *instruction_sequence = op_ASSIGN_87;
	return instruction_sequence;
}

// Rxx += vrcmpyr(Rss,Rtt*)
RzILOpEffect *hex_il_op_m2_vrcmacr_s0c(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// Rxx = Rxx + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rss, SN(32, 0));
	RzILOpPure *op_AND_8 = LOGAND(op_RSHIFT_5, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_18 = LOGAND(op_RSHIFT_15, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_21 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_8), DUP(op_AND_8))), CAST(16, MSB(DUP(op_AND_8)), DUP(op_AND_8))), CAST(32, MSB(CAST(16, MSB(op_AND_18), DUP(op_AND_18))), CAST(16, MSB(DUP(op_AND_18)), DUP(op_AND_18))));
	RzILOpPure *op_ADD_23 = ADD(READ_REG(pkt, Rxx_op, false), CAST(64, MSB(op_MUL_21), DUP(op_MUL_21)));
	RzILOpPure *op_RSHIFT_27 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_30 = LOGAND(op_RSHIFT_27, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_36 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_39 = LOGAND(op_RSHIFT_36, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_42 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_30), DUP(op_AND_30))), CAST(16, MSB(DUP(op_AND_30)), DUP(op_AND_30))), CAST(32, MSB(CAST(16, MSB(op_AND_39), DUP(op_AND_39))), CAST(16, MSB(DUP(op_AND_39)), DUP(op_AND_39))));
	RzILOpPure *op_ADD_44 = ADD(op_ADD_23, CAST(64, MSB(op_MUL_42), DUP(op_MUL_42)));
	RzILOpPure *op_RSHIFT_48 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_51 = LOGAND(op_RSHIFT_48, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_57 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_60 = LOGAND(op_RSHIFT_57, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_63 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_51), DUP(op_AND_51))), CAST(16, MSB(DUP(op_AND_51)), DUP(op_AND_51))), CAST(32, MSB(CAST(16, MSB(op_AND_60), DUP(op_AND_60))), CAST(16, MSB(DUP(op_AND_60)), DUP(op_AND_60))));
	RzILOpPure *op_ADD_65 = ADD(op_ADD_44, CAST(64, MSB(op_MUL_63), DUP(op_MUL_63)));
	RzILOpPure *op_RSHIFT_69 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_72 = LOGAND(op_RSHIFT_69, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_78 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_81 = LOGAND(op_RSHIFT_78, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_84 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_72), DUP(op_AND_72))), CAST(16, MSB(DUP(op_AND_72)), DUP(op_AND_72))), CAST(32, MSB(CAST(16, MSB(op_AND_81), DUP(op_AND_81))), CAST(16, MSB(DUP(op_AND_81)), DUP(op_AND_81))));
	RzILOpPure *op_ADD_86 = ADD(op_ADD_65, CAST(64, MSB(op_MUL_84), DUP(op_MUL_84)));
	RzILOpEffect *op_ASSIGN_87 = WRITE_REG(bundle, Rxx_op, op_ADD_86);

	RzILOpEffect *instruction_sequence = op_ASSIGN_87;
	return instruction_sequence;
}

// Rdd = vrcmpyi(Rss,Rtt)
RzILOpEffect *hex_il_op_m2_vrcmpyi_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// Rdd = ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rss, SN(32, 16));
	RzILOpPure *op_AND_8 = LOGAND(op_RSHIFT_5, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_18 = LOGAND(op_RSHIFT_15, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_21 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_8), DUP(op_AND_8))), CAST(16, MSB(DUP(op_AND_8)), DUP(op_AND_8))), CAST(32, MSB(CAST(16, MSB(op_AND_18), DUP(op_AND_18))), CAST(16, MSB(DUP(op_AND_18)), DUP(op_AND_18))));
	RzILOpPure *op_RSHIFT_26 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_29 = LOGAND(op_RSHIFT_26, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_35 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_38 = LOGAND(op_RSHIFT_35, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_41 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_29), DUP(op_AND_29))), CAST(16, MSB(DUP(op_AND_29)), DUP(op_AND_29))), CAST(32, MSB(CAST(16, MSB(op_AND_38), DUP(op_AND_38))), CAST(16, MSB(DUP(op_AND_38)), DUP(op_AND_38))));
	RzILOpPure *op_ADD_43 = ADD(CAST(64, MSB(op_MUL_21), DUP(op_MUL_21)), CAST(64, MSB(op_MUL_41), DUP(op_MUL_41)));
	RzILOpPure *op_RSHIFT_47 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_50 = LOGAND(op_RSHIFT_47, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_56 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_59 = LOGAND(op_RSHIFT_56, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_62 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_50), DUP(op_AND_50))), CAST(16, MSB(DUP(op_AND_50)), DUP(op_AND_50))), CAST(32, MSB(CAST(16, MSB(op_AND_59), DUP(op_AND_59))), CAST(16, MSB(DUP(op_AND_59)), DUP(op_AND_59))));
	RzILOpPure *op_ADD_64 = ADD(op_ADD_43, CAST(64, MSB(op_MUL_62), DUP(op_MUL_62)));
	RzILOpPure *op_RSHIFT_68 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_71 = LOGAND(op_RSHIFT_68, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_77 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_80 = LOGAND(op_RSHIFT_77, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_83 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_71), DUP(op_AND_71))), CAST(16, MSB(DUP(op_AND_71)), DUP(op_AND_71))), CAST(32, MSB(CAST(16, MSB(op_AND_80), DUP(op_AND_80))), CAST(16, MSB(DUP(op_AND_80)), DUP(op_AND_80))));
	RzILOpPure *op_ADD_85 = ADD(op_ADD_64, CAST(64, MSB(op_MUL_83), DUP(op_MUL_83)));
	RzILOpEffect *op_ASSIGN_86 = WRITE_REG(bundle, Rdd_op, op_ADD_85);

	RzILOpEffect *instruction_sequence = op_ASSIGN_86;
	return instruction_sequence;
}

// Rdd = vrcmpyi(Rss,Rtt*)
RzILOpEffect *hex_il_op_m2_vrcmpyi_s0c(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// Rdd = ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rss, SN(32, 16));
	RzILOpPure *op_AND_8 = LOGAND(op_RSHIFT_5, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_18 = LOGAND(op_RSHIFT_15, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_21 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_8), DUP(op_AND_8))), CAST(16, MSB(DUP(op_AND_8)), DUP(op_AND_8))), CAST(32, MSB(CAST(16, MSB(op_AND_18), DUP(op_AND_18))), CAST(16, MSB(DUP(op_AND_18)), DUP(op_AND_18))));
	RzILOpPure *op_RSHIFT_26 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_29 = LOGAND(op_RSHIFT_26, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_35 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_38 = LOGAND(op_RSHIFT_35, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_41 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_29), DUP(op_AND_29))), CAST(16, MSB(DUP(op_AND_29)), DUP(op_AND_29))), CAST(32, MSB(CAST(16, MSB(op_AND_38), DUP(op_AND_38))), CAST(16, MSB(DUP(op_AND_38)), DUP(op_AND_38))));
	RzILOpPure *op_SUB_43 = SUB(CAST(64, MSB(op_MUL_21), DUP(op_MUL_21)), CAST(64, MSB(op_MUL_41), DUP(op_MUL_41)));
	RzILOpPure *op_RSHIFT_47 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_50 = LOGAND(op_RSHIFT_47, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_56 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_59 = LOGAND(op_RSHIFT_56, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_62 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_50), DUP(op_AND_50))), CAST(16, MSB(DUP(op_AND_50)), DUP(op_AND_50))), CAST(32, MSB(CAST(16, MSB(op_AND_59), DUP(op_AND_59))), CAST(16, MSB(DUP(op_AND_59)), DUP(op_AND_59))));
	RzILOpPure *op_ADD_64 = ADD(op_SUB_43, CAST(64, MSB(op_MUL_62), DUP(op_MUL_62)));
	RzILOpPure *op_RSHIFT_68 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_71 = LOGAND(op_RSHIFT_68, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_77 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_80 = LOGAND(op_RSHIFT_77, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_83 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_71), DUP(op_AND_71))), CAST(16, MSB(DUP(op_AND_71)), DUP(op_AND_71))), CAST(32, MSB(CAST(16, MSB(op_AND_80), DUP(op_AND_80))), CAST(16, MSB(DUP(op_AND_80)), DUP(op_AND_80))));
	RzILOpPure *op_SUB_85 = SUB(op_ADD_64, CAST(64, MSB(op_MUL_83), DUP(op_MUL_83)));
	RzILOpEffect *op_ASSIGN_86 = WRITE_REG(bundle, Rdd_op, op_SUB_85);

	RzILOpEffect *instruction_sequence = op_ASSIGN_86;
	return instruction_sequence;
}

// Rdd = vrcmpyr(Rss,Rtt)
RzILOpEffect *hex_il_op_m2_vrcmpyr_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// Rdd = ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) - ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rss, SN(32, 0));
	RzILOpPure *op_AND_8 = LOGAND(op_RSHIFT_5, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_18 = LOGAND(op_RSHIFT_15, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_21 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_8), DUP(op_AND_8))), CAST(16, MSB(DUP(op_AND_8)), DUP(op_AND_8))), CAST(32, MSB(CAST(16, MSB(op_AND_18), DUP(op_AND_18))), CAST(16, MSB(DUP(op_AND_18)), DUP(op_AND_18))));
	RzILOpPure *op_RSHIFT_26 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_29 = LOGAND(op_RSHIFT_26, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_35 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_38 = LOGAND(op_RSHIFT_35, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_41 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_29), DUP(op_AND_29))), CAST(16, MSB(DUP(op_AND_29)), DUP(op_AND_29))), CAST(32, MSB(CAST(16, MSB(op_AND_38), DUP(op_AND_38))), CAST(16, MSB(DUP(op_AND_38)), DUP(op_AND_38))));
	RzILOpPure *op_SUB_43 = SUB(CAST(64, MSB(op_MUL_21), DUP(op_MUL_21)), CAST(64, MSB(op_MUL_41), DUP(op_MUL_41)));
	RzILOpPure *op_RSHIFT_47 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_50 = LOGAND(op_RSHIFT_47, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_56 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_59 = LOGAND(op_RSHIFT_56, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_62 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_50), DUP(op_AND_50))), CAST(16, MSB(DUP(op_AND_50)), DUP(op_AND_50))), CAST(32, MSB(CAST(16, MSB(op_AND_59), DUP(op_AND_59))), CAST(16, MSB(DUP(op_AND_59)), DUP(op_AND_59))));
	RzILOpPure *op_ADD_64 = ADD(op_SUB_43, CAST(64, MSB(op_MUL_62), DUP(op_MUL_62)));
	RzILOpPure *op_RSHIFT_68 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_71 = LOGAND(op_RSHIFT_68, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_77 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_80 = LOGAND(op_RSHIFT_77, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_83 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_71), DUP(op_AND_71))), CAST(16, MSB(DUP(op_AND_71)), DUP(op_AND_71))), CAST(32, MSB(CAST(16, MSB(op_AND_80), DUP(op_AND_80))), CAST(16, MSB(DUP(op_AND_80)), DUP(op_AND_80))));
	RzILOpPure *op_SUB_85 = SUB(op_ADD_64, CAST(64, MSB(op_MUL_83), DUP(op_MUL_83)));
	RzILOpEffect *op_ASSIGN_86 = WRITE_REG(bundle, Rdd_op, op_SUB_85);

	RzILOpEffect *instruction_sequence = op_ASSIGN_86;
	return instruction_sequence;
}

// Rdd = vrcmpyr(Rss,Rtt*)
RzILOpEffect *hex_il_op_m2_vrcmpyr_s0c(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// Rdd = ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rss, SN(32, 0));
	RzILOpPure *op_AND_8 = LOGAND(op_RSHIFT_5, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_18 = LOGAND(op_RSHIFT_15, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_21 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_8), DUP(op_AND_8))), CAST(16, MSB(DUP(op_AND_8)), DUP(op_AND_8))), CAST(32, MSB(CAST(16, MSB(op_AND_18), DUP(op_AND_18))), CAST(16, MSB(DUP(op_AND_18)), DUP(op_AND_18))));
	RzILOpPure *op_RSHIFT_26 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_29 = LOGAND(op_RSHIFT_26, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_35 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_38 = LOGAND(op_RSHIFT_35, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_41 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_29), DUP(op_AND_29))), CAST(16, MSB(DUP(op_AND_29)), DUP(op_AND_29))), CAST(32, MSB(CAST(16, MSB(op_AND_38), DUP(op_AND_38))), CAST(16, MSB(DUP(op_AND_38)), DUP(op_AND_38))));
	RzILOpPure *op_ADD_43 = ADD(CAST(64, MSB(op_MUL_21), DUP(op_MUL_21)), CAST(64, MSB(op_MUL_41), DUP(op_MUL_41)));
	RzILOpPure *op_RSHIFT_47 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_50 = LOGAND(op_RSHIFT_47, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_56 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_59 = LOGAND(op_RSHIFT_56, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_62 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_50), DUP(op_AND_50))), CAST(16, MSB(DUP(op_AND_50)), DUP(op_AND_50))), CAST(32, MSB(CAST(16, MSB(op_AND_59), DUP(op_AND_59))), CAST(16, MSB(DUP(op_AND_59)), DUP(op_AND_59))));
	RzILOpPure *op_ADD_64 = ADD(op_ADD_43, CAST(64, MSB(op_MUL_62), DUP(op_MUL_62)));
	RzILOpPure *op_RSHIFT_68 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_71 = LOGAND(op_RSHIFT_68, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_77 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_80 = LOGAND(op_RSHIFT_77, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_83 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_71), DUP(op_AND_71))), CAST(16, MSB(DUP(op_AND_71)), DUP(op_AND_71))), CAST(32, MSB(CAST(16, MSB(op_AND_80), DUP(op_AND_80))), CAST(16, MSB(DUP(op_AND_80)), DUP(op_AND_80))));
	RzILOpPure *op_ADD_85 = ADD(op_ADD_64, CAST(64, MSB(op_MUL_83), DUP(op_MUL_83)));
	RzILOpEffect *op_ASSIGN_86 = WRITE_REG(bundle, Rdd_op, op_ADD_85);

	RzILOpEffect *instruction_sequence = op_ASSIGN_86;
	return instruction_sequence;
}

// Rxx += vrcmpys(Rss,Rtt):<<1:sat:raw:hi
RzILOpEffect *hex_il_op_m2_vrcmpys_acc_s1_h(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_231 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rss, SN(32, 16));
	RzILOpPure *op_AND_26 = LOGAND(op_RSHIFT_23, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_33 = SHIFTRA(Rtt, SN(32, 0x20));
	RzILOpPure *op_AND_35 = LOGAND(op_RSHIFT_33, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_41 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_35), DUP(op_AND_35))), CAST(32, MSB(DUP(op_AND_35)), DUP(op_AND_35))), SN(32, 0));
	RzILOpPure *op_AND_44 = LOGAND(op_RSHIFT_41, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_47 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_26), DUP(op_AND_26))), CAST(16, MSB(DUP(op_AND_26)), DUP(op_AND_26))), CAST(32, MSB(CAST(16, MSB(op_AND_44), DUP(op_AND_44))), CAST(16, MSB(DUP(op_AND_44)), DUP(op_AND_44))));
	RzILOpPure *op_LSHIFT_50 = SHIFTL0(CAST(64, MSB(op_MUL_47), DUP(op_MUL_47)), SN(32, 1));
	RzILOpPure *op_ADD_51 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_LSHIFT_50);
	RzILOpPure *op_RSHIFT_55 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_58 = LOGAND(op_RSHIFT_55, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_64 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_66 = LOGAND(op_RSHIFT_64, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_72 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_66), DUP(op_AND_66))), CAST(32, MSB(DUP(op_AND_66)), DUP(op_AND_66))), SN(32, 16));
	RzILOpPure *op_AND_75 = LOGAND(op_RSHIFT_72, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_78 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_58), DUP(op_AND_58))), CAST(16, MSB(DUP(op_AND_58)), DUP(op_AND_58))), CAST(32, MSB(CAST(16, MSB(op_AND_75), DUP(op_AND_75))), CAST(16, MSB(DUP(op_AND_75)), DUP(op_AND_75))));
	RzILOpPure *op_LSHIFT_81 = SHIFTL0(CAST(64, MSB(op_MUL_78), DUP(op_MUL_78)), SN(32, 1));
	RzILOpPure *op_ADD_82 = ADD(op_ADD_51, op_LSHIFT_81);
	RzILOpPure *op_RSHIFT_91 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_93 = LOGAND(op_RSHIFT_91, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_99 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_102 = LOGAND(op_RSHIFT_99, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_108 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_110 = LOGAND(op_RSHIFT_108, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_116 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_110), DUP(op_AND_110))), CAST(32, MSB(DUP(op_AND_110)), DUP(op_AND_110))), SN(32, 0));
	RzILOpPure *op_AND_119 = LOGAND(op_RSHIFT_116, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_122 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_102), DUP(op_AND_102))), CAST(16, MSB(DUP(op_AND_102)), DUP(op_AND_102))), CAST(32, MSB(CAST(16, MSB(op_AND_119), DUP(op_AND_119))), CAST(16, MSB(DUP(op_AND_119)), DUP(op_AND_119))));
	RzILOpPure *op_LSHIFT_125 = SHIFTL0(CAST(64, MSB(op_MUL_122), DUP(op_MUL_122)), SN(32, 1));
	RzILOpPure *op_ADD_126 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_93), DUP(op_AND_93))), CAST(32, MSB(DUP(op_AND_93)), DUP(op_AND_93))), op_LSHIFT_125);
	RzILOpPure *op_RSHIFT_130 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_133 = LOGAND(op_RSHIFT_130, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_139 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_141 = LOGAND(op_RSHIFT_139, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_147 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_141), DUP(op_AND_141))), CAST(32, MSB(DUP(op_AND_141)), DUP(op_AND_141))), SN(32, 16));
	RzILOpPure *op_AND_150 = LOGAND(op_RSHIFT_147, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_153 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_133), DUP(op_AND_133))), CAST(16, MSB(DUP(op_AND_133)), DUP(op_AND_133))), CAST(32, MSB(CAST(16, MSB(op_AND_150), DUP(op_AND_150))), CAST(16, MSB(DUP(op_AND_150)), DUP(op_AND_150))));
	RzILOpPure *op_LSHIFT_156 = SHIFTL0(CAST(64, MSB(op_MUL_153), DUP(op_MUL_153)), SN(32, 1));
	RzILOpPure *op_ADD_157 = ADD(op_ADD_126, op_LSHIFT_156);
	RzILOpPure *op_EQ_158 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_82), SN(32, 0), SN(32, 0x20)), op_ADD_157);
	RzILOpPure *op_RSHIFT_235 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_237 = LOGAND(op_RSHIFT_235, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_243 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_246 = LOGAND(op_RSHIFT_243, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_252 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_254 = LOGAND(op_RSHIFT_252, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_260 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_254), DUP(op_AND_254))), CAST(32, MSB(DUP(op_AND_254)), DUP(op_AND_254))), SN(32, 0));
	RzILOpPure *op_AND_263 = LOGAND(op_RSHIFT_260, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_266 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_246), DUP(op_AND_246))), CAST(16, MSB(DUP(op_AND_246)), DUP(op_AND_246))), CAST(32, MSB(CAST(16, MSB(op_AND_263), DUP(op_AND_263))), CAST(16, MSB(DUP(op_AND_263)), DUP(op_AND_263))));
	RzILOpPure *op_LSHIFT_269 = SHIFTL0(CAST(64, MSB(op_MUL_266), DUP(op_MUL_266)), SN(32, 1));
	RzILOpPure *op_ADD_270 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_237), DUP(op_AND_237))), CAST(32, MSB(DUP(op_AND_237)), DUP(op_AND_237))), op_LSHIFT_269);
	RzILOpPure *op_RSHIFT_274 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_277 = LOGAND(op_RSHIFT_274, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_283 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_285 = LOGAND(op_RSHIFT_283, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_291 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_285), DUP(op_AND_285))), CAST(32, MSB(DUP(op_AND_285)), DUP(op_AND_285))), SN(32, 16));
	RzILOpPure *op_AND_294 = LOGAND(op_RSHIFT_291, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_297 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_277), DUP(op_AND_277))), CAST(16, MSB(DUP(op_AND_277)), DUP(op_AND_277))), CAST(32, MSB(CAST(16, MSB(op_AND_294), DUP(op_AND_294))), CAST(16, MSB(DUP(op_AND_294)), DUP(op_AND_294))));
	RzILOpPure *op_LSHIFT_300 = SHIFTL0(CAST(64, MSB(op_MUL_297), DUP(op_MUL_297)), SN(32, 1));
	RzILOpPure *op_ADD_301 = ADD(op_ADD_270, op_LSHIFT_300);
	RzILOpPure *op_LT_304 = SLT(op_ADD_301, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_309 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_310 = NEG(op_LSHIFT_309);
	RzILOpPure *op_LSHIFT_315 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_318 = SUB(op_LSHIFT_315, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_319 = ITE(op_LT_304, op_NEG_310, op_SUB_318);
	RzILOpEffect *gcc_expr_320 = BRANCH(op_EQ_158, EMPTY(), set_usr_field_call_231);

	// h_tmp421 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_322 = SETL("h_tmp421", cond_319);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_323 = SEQN(2, gcc_expr_320, op_ASSIGN_hybrid_tmp_322);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) : h_tmp421) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_162 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_164 = LOGAND(op_RSHIFT_162, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_170 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_173 = LOGAND(op_RSHIFT_170, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_179 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_181 = LOGAND(op_RSHIFT_179, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_187 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_181), DUP(op_AND_181))), CAST(32, MSB(DUP(op_AND_181)), DUP(op_AND_181))), SN(32, 0));
	RzILOpPure *op_AND_190 = LOGAND(op_RSHIFT_187, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_193 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_173), DUP(op_AND_173))), CAST(16, MSB(DUP(op_AND_173)), DUP(op_AND_173))), CAST(32, MSB(CAST(16, MSB(op_AND_190), DUP(op_AND_190))), CAST(16, MSB(DUP(op_AND_190)), DUP(op_AND_190))));
	RzILOpPure *op_LSHIFT_196 = SHIFTL0(CAST(64, MSB(op_MUL_193), DUP(op_MUL_193)), SN(32, 1));
	RzILOpPure *op_ADD_197 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_164), DUP(op_AND_164))), CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164))), op_LSHIFT_196);
	RzILOpPure *op_RSHIFT_201 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_204 = LOGAND(op_RSHIFT_201, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_210 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_212 = LOGAND(op_RSHIFT_210, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_218 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_212), DUP(op_AND_212))), CAST(32, MSB(DUP(op_AND_212)), DUP(op_AND_212))), SN(32, 16));
	RzILOpPure *op_AND_221 = LOGAND(op_RSHIFT_218, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_224 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_204), DUP(op_AND_204))), CAST(16, MSB(DUP(op_AND_204)), DUP(op_AND_204))), CAST(32, MSB(CAST(16, MSB(op_AND_221), DUP(op_AND_221))), CAST(16, MSB(DUP(op_AND_221)), DUP(op_AND_221))));
	RzILOpPure *op_LSHIFT_227 = SHIFTL0(CAST(64, MSB(op_MUL_224), DUP(op_MUL_224)), SN(32, 1));
	RzILOpPure *op_ADD_228 = ADD(op_ADD_197, op_LSHIFT_227);
	RzILOpPure *cond_324 = ITE(DUP(op_EQ_158), op_ADD_228, VARL("h_tmp421"));
	RzILOpPure *op_AND_326 = LOGAND(cond_324, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_330 = SHIFTL0(op_AND_326, SN(32, 0x20));
	RzILOpPure *op_OR_331 = LOGOR(op_AND_7, op_LSHIFT_330);
	RzILOpEffect *op_ASSIGN_332 = WRITE_REG(bundle, Rxx_op, op_OR_331);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_333 = SEQN(2, seq_323, op_ASSIGN_332);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_563 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_348 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_350 = LOGAND(op_RSHIFT_348, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_356 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_359 = LOGAND(op_RSHIFT_356, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_365 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_367 = LOGAND(op_RSHIFT_365, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_373 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_367), DUP(op_AND_367))), CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367))), SN(32, 0));
	RzILOpPure *op_AND_376 = LOGAND(op_RSHIFT_373, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_379 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_359), DUP(op_AND_359))), CAST(16, MSB(DUP(op_AND_359)), DUP(op_AND_359))), CAST(32, MSB(CAST(16, MSB(op_AND_376), DUP(op_AND_376))), CAST(16, MSB(DUP(op_AND_376)), DUP(op_AND_376))));
	RzILOpPure *op_LSHIFT_382 = SHIFTL0(CAST(64, MSB(op_MUL_379), DUP(op_MUL_379)), SN(32, 1));
	RzILOpPure *op_ADD_383 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_350), DUP(op_AND_350))), CAST(32, MSB(DUP(op_AND_350)), DUP(op_AND_350))), op_LSHIFT_382);
	RzILOpPure *op_RSHIFT_387 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_390 = LOGAND(op_RSHIFT_387, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_396 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_398 = LOGAND(op_RSHIFT_396, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_404 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_398), DUP(op_AND_398))), CAST(32, MSB(DUP(op_AND_398)), DUP(op_AND_398))), SN(32, 16));
	RzILOpPure *op_AND_407 = LOGAND(op_RSHIFT_404, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_410 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_390), DUP(op_AND_390))), CAST(16, MSB(DUP(op_AND_390)), DUP(op_AND_390))), CAST(32, MSB(CAST(16, MSB(op_AND_407), DUP(op_AND_407))), CAST(16, MSB(DUP(op_AND_407)), DUP(op_AND_407))));
	RzILOpPure *op_LSHIFT_413 = SHIFTL0(CAST(64, MSB(op_MUL_410), DUP(op_MUL_410)), SN(32, 1));
	RzILOpPure *op_ADD_414 = ADD(op_ADD_383, op_LSHIFT_413);
	RzILOpPure *op_RSHIFT_423 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_425 = LOGAND(op_RSHIFT_423, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_431 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_434 = LOGAND(op_RSHIFT_431, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_440 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_442 = LOGAND(op_RSHIFT_440, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_448 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_442), DUP(op_AND_442))), CAST(32, MSB(DUP(op_AND_442)), DUP(op_AND_442))), SN(32, 0));
	RzILOpPure *op_AND_451 = LOGAND(op_RSHIFT_448, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_454 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_434), DUP(op_AND_434))), CAST(16, MSB(DUP(op_AND_434)), DUP(op_AND_434))), CAST(32, MSB(CAST(16, MSB(op_AND_451), DUP(op_AND_451))), CAST(16, MSB(DUP(op_AND_451)), DUP(op_AND_451))));
	RzILOpPure *op_LSHIFT_457 = SHIFTL0(CAST(64, MSB(op_MUL_454), DUP(op_MUL_454)), SN(32, 1));
	RzILOpPure *op_ADD_458 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_425), DUP(op_AND_425))), CAST(32, MSB(DUP(op_AND_425)), DUP(op_AND_425))), op_LSHIFT_457);
	RzILOpPure *op_RSHIFT_462 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_465 = LOGAND(op_RSHIFT_462, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_471 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_473 = LOGAND(op_RSHIFT_471, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_479 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_473), DUP(op_AND_473))), CAST(32, MSB(DUP(op_AND_473)), DUP(op_AND_473))), SN(32, 16));
	RzILOpPure *op_AND_482 = LOGAND(op_RSHIFT_479, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_485 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_465), DUP(op_AND_465))), CAST(16, MSB(DUP(op_AND_465)), DUP(op_AND_465))), CAST(32, MSB(CAST(16, MSB(op_AND_482), DUP(op_AND_482))), CAST(16, MSB(DUP(op_AND_482)), DUP(op_AND_482))));
	RzILOpPure *op_LSHIFT_488 = SHIFTL0(CAST(64, MSB(op_MUL_485), DUP(op_MUL_485)), SN(32, 1));
	RzILOpPure *op_ADD_489 = ADD(op_ADD_458, op_LSHIFT_488);
	RzILOpPure *op_EQ_490 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_414), SN(32, 0), SN(32, 0x20)), op_ADD_489);
	RzILOpPure *op_RSHIFT_567 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_569 = LOGAND(op_RSHIFT_567, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_575 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_578 = LOGAND(op_RSHIFT_575, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_584 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_586 = LOGAND(op_RSHIFT_584, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_592 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_586), DUP(op_AND_586))), CAST(32, MSB(DUP(op_AND_586)), DUP(op_AND_586))), SN(32, 0));
	RzILOpPure *op_AND_595 = LOGAND(op_RSHIFT_592, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_598 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_578), DUP(op_AND_578))), CAST(16, MSB(DUP(op_AND_578)), DUP(op_AND_578))), CAST(32, MSB(CAST(16, MSB(op_AND_595), DUP(op_AND_595))), CAST(16, MSB(DUP(op_AND_595)), DUP(op_AND_595))));
	RzILOpPure *op_LSHIFT_601 = SHIFTL0(CAST(64, MSB(op_MUL_598), DUP(op_MUL_598)), SN(32, 1));
	RzILOpPure *op_ADD_602 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_569), DUP(op_AND_569))), CAST(32, MSB(DUP(op_AND_569)), DUP(op_AND_569))), op_LSHIFT_601);
	RzILOpPure *op_RSHIFT_606 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_609 = LOGAND(op_RSHIFT_606, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_615 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_617 = LOGAND(op_RSHIFT_615, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_623 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_617), DUP(op_AND_617))), CAST(32, MSB(DUP(op_AND_617)), DUP(op_AND_617))), SN(32, 16));
	RzILOpPure *op_AND_626 = LOGAND(op_RSHIFT_623, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_629 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_609), DUP(op_AND_609))), CAST(16, MSB(DUP(op_AND_609)), DUP(op_AND_609))), CAST(32, MSB(CAST(16, MSB(op_AND_626), DUP(op_AND_626))), CAST(16, MSB(DUP(op_AND_626)), DUP(op_AND_626))));
	RzILOpPure *op_LSHIFT_632 = SHIFTL0(CAST(64, MSB(op_MUL_629), DUP(op_MUL_629)), SN(32, 1));
	RzILOpPure *op_ADD_633 = ADD(op_ADD_602, op_LSHIFT_632);
	RzILOpPure *op_LT_636 = SLT(op_ADD_633, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_641 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_642 = NEG(op_LSHIFT_641);
	RzILOpPure *op_LSHIFT_647 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_650 = SUB(op_LSHIFT_647, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_651 = ITE(op_LT_636, op_NEG_642, op_SUB_650);
	RzILOpEffect *gcc_expr_652 = BRANCH(op_EQ_490, EMPTY(), set_usr_field_call_563);

	// h_tmp422 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_654 = SETL("h_tmp422", cond_651);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_655 = SEQN(2, gcc_expr_652, op_ASSIGN_hybrid_tmp_654);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) : h_tmp422) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_339 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_340 = LOGNOT(op_LSHIFT_339);
	RzILOpPure *op_AND_341 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_340);
	RzILOpPure *op_RSHIFT_494 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_496 = LOGAND(op_RSHIFT_494, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_502 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_505 = LOGAND(op_RSHIFT_502, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_511 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_513 = LOGAND(op_RSHIFT_511, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_519 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_513), DUP(op_AND_513))), CAST(32, MSB(DUP(op_AND_513)), DUP(op_AND_513))), SN(32, 0));
	RzILOpPure *op_AND_522 = LOGAND(op_RSHIFT_519, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_525 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_505), DUP(op_AND_505))), CAST(16, MSB(DUP(op_AND_505)), DUP(op_AND_505))), CAST(32, MSB(CAST(16, MSB(op_AND_522), DUP(op_AND_522))), CAST(16, MSB(DUP(op_AND_522)), DUP(op_AND_522))));
	RzILOpPure *op_LSHIFT_528 = SHIFTL0(CAST(64, MSB(op_MUL_525), DUP(op_MUL_525)), SN(32, 1));
	RzILOpPure *op_ADD_529 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_496), DUP(op_AND_496))), CAST(32, MSB(DUP(op_AND_496)), DUP(op_AND_496))), op_LSHIFT_528);
	RzILOpPure *op_RSHIFT_533 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_536 = LOGAND(op_RSHIFT_533, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_542 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_544 = LOGAND(op_RSHIFT_542, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_550 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_544), DUP(op_AND_544))), CAST(32, MSB(DUP(op_AND_544)), DUP(op_AND_544))), SN(32, 16));
	RzILOpPure *op_AND_553 = LOGAND(op_RSHIFT_550, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_556 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_536), DUP(op_AND_536))), CAST(16, MSB(DUP(op_AND_536)), DUP(op_AND_536))), CAST(32, MSB(CAST(16, MSB(op_AND_553), DUP(op_AND_553))), CAST(16, MSB(DUP(op_AND_553)), DUP(op_AND_553))));
	RzILOpPure *op_LSHIFT_559 = SHIFTL0(CAST(64, MSB(op_MUL_556), DUP(op_MUL_556)), SN(32, 1));
	RzILOpPure *op_ADD_560 = ADD(op_ADD_529, op_LSHIFT_559);
	RzILOpPure *cond_656 = ITE(DUP(op_EQ_490), op_ADD_560, VARL("h_tmp422"));
	RzILOpPure *op_AND_658 = LOGAND(cond_656, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_662 = SHIFTL0(op_AND_658, SN(32, 0));
	RzILOpPure *op_OR_663 = LOGOR(op_AND_341, op_LSHIFT_662);
	RzILOpEffect *op_ASSIGN_664 = WRITE_REG(bundle, Rxx_op, op_OR_663);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_665 = SEQN(2, seq_655, op_ASSIGN_664);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_333, seq_665);
	return instruction_sequence;
}

// Rxx += vrcmpys(Rss,Rtt):<<1:sat:raw:lo
RzILOpEffect *hex_il_op_m2_vrcmpys_acc_s1_l(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_231 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_14 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_16 = LOGAND(op_RSHIFT_14, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_23 = SHIFTRA(Rss, SN(32, 16));
	RzILOpPure *op_AND_26 = LOGAND(op_RSHIFT_23, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_33 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_35 = LOGAND(op_RSHIFT_33, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_41 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_35), DUP(op_AND_35))), CAST(32, MSB(DUP(op_AND_35)), DUP(op_AND_35))), SN(32, 0));
	RzILOpPure *op_AND_44 = LOGAND(op_RSHIFT_41, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_47 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_26), DUP(op_AND_26))), CAST(16, MSB(DUP(op_AND_26)), DUP(op_AND_26))), CAST(32, MSB(CAST(16, MSB(op_AND_44), DUP(op_AND_44))), CAST(16, MSB(DUP(op_AND_44)), DUP(op_AND_44))));
	RzILOpPure *op_LSHIFT_50 = SHIFTL0(CAST(64, MSB(op_MUL_47), DUP(op_MUL_47)), SN(32, 1));
	RzILOpPure *op_ADD_51 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_16), DUP(op_AND_16))), CAST(32, MSB(DUP(op_AND_16)), DUP(op_AND_16))), op_LSHIFT_50);
	RzILOpPure *op_RSHIFT_55 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_58 = LOGAND(op_RSHIFT_55, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_64 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_66 = LOGAND(op_RSHIFT_64, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_72 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_66), DUP(op_AND_66))), CAST(32, MSB(DUP(op_AND_66)), DUP(op_AND_66))), SN(32, 16));
	RzILOpPure *op_AND_75 = LOGAND(op_RSHIFT_72, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_78 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_58), DUP(op_AND_58))), CAST(16, MSB(DUP(op_AND_58)), DUP(op_AND_58))), CAST(32, MSB(CAST(16, MSB(op_AND_75), DUP(op_AND_75))), CAST(16, MSB(DUP(op_AND_75)), DUP(op_AND_75))));
	RzILOpPure *op_LSHIFT_81 = SHIFTL0(CAST(64, MSB(op_MUL_78), DUP(op_MUL_78)), SN(32, 1));
	RzILOpPure *op_ADD_82 = ADD(op_ADD_51, op_LSHIFT_81);
	RzILOpPure *op_RSHIFT_91 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_93 = LOGAND(op_RSHIFT_91, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_99 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_102 = LOGAND(op_RSHIFT_99, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_108 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_110 = LOGAND(op_RSHIFT_108, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_116 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_110), DUP(op_AND_110))), CAST(32, MSB(DUP(op_AND_110)), DUP(op_AND_110))), SN(32, 0));
	RzILOpPure *op_AND_119 = LOGAND(op_RSHIFT_116, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_122 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_102), DUP(op_AND_102))), CAST(16, MSB(DUP(op_AND_102)), DUP(op_AND_102))), CAST(32, MSB(CAST(16, MSB(op_AND_119), DUP(op_AND_119))), CAST(16, MSB(DUP(op_AND_119)), DUP(op_AND_119))));
	RzILOpPure *op_LSHIFT_125 = SHIFTL0(CAST(64, MSB(op_MUL_122), DUP(op_MUL_122)), SN(32, 1));
	RzILOpPure *op_ADD_126 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_93), DUP(op_AND_93))), CAST(32, MSB(DUP(op_AND_93)), DUP(op_AND_93))), op_LSHIFT_125);
	RzILOpPure *op_RSHIFT_130 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_133 = LOGAND(op_RSHIFT_130, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_139 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_141 = LOGAND(op_RSHIFT_139, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_147 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_141), DUP(op_AND_141))), CAST(32, MSB(DUP(op_AND_141)), DUP(op_AND_141))), SN(32, 16));
	RzILOpPure *op_AND_150 = LOGAND(op_RSHIFT_147, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_153 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_133), DUP(op_AND_133))), CAST(16, MSB(DUP(op_AND_133)), DUP(op_AND_133))), CAST(32, MSB(CAST(16, MSB(op_AND_150), DUP(op_AND_150))), CAST(16, MSB(DUP(op_AND_150)), DUP(op_AND_150))));
	RzILOpPure *op_LSHIFT_156 = SHIFTL0(CAST(64, MSB(op_MUL_153), DUP(op_MUL_153)), SN(32, 1));
	RzILOpPure *op_ADD_157 = ADD(op_ADD_126, op_LSHIFT_156);
	RzILOpPure *op_EQ_158 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_82), SN(32, 0), SN(32, 0x20)), op_ADD_157);
	RzILOpPure *op_RSHIFT_235 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_237 = LOGAND(op_RSHIFT_235, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_243 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_246 = LOGAND(op_RSHIFT_243, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_252 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_254 = LOGAND(op_RSHIFT_252, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_260 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_254), DUP(op_AND_254))), CAST(32, MSB(DUP(op_AND_254)), DUP(op_AND_254))), SN(32, 0));
	RzILOpPure *op_AND_263 = LOGAND(op_RSHIFT_260, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_266 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_246), DUP(op_AND_246))), CAST(16, MSB(DUP(op_AND_246)), DUP(op_AND_246))), CAST(32, MSB(CAST(16, MSB(op_AND_263), DUP(op_AND_263))), CAST(16, MSB(DUP(op_AND_263)), DUP(op_AND_263))));
	RzILOpPure *op_LSHIFT_269 = SHIFTL0(CAST(64, MSB(op_MUL_266), DUP(op_MUL_266)), SN(32, 1));
	RzILOpPure *op_ADD_270 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_237), DUP(op_AND_237))), CAST(32, MSB(DUP(op_AND_237)), DUP(op_AND_237))), op_LSHIFT_269);
	RzILOpPure *op_RSHIFT_274 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_277 = LOGAND(op_RSHIFT_274, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_283 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_285 = LOGAND(op_RSHIFT_283, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_291 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_285), DUP(op_AND_285))), CAST(32, MSB(DUP(op_AND_285)), DUP(op_AND_285))), SN(32, 16));
	RzILOpPure *op_AND_294 = LOGAND(op_RSHIFT_291, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_297 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_277), DUP(op_AND_277))), CAST(16, MSB(DUP(op_AND_277)), DUP(op_AND_277))), CAST(32, MSB(CAST(16, MSB(op_AND_294), DUP(op_AND_294))), CAST(16, MSB(DUP(op_AND_294)), DUP(op_AND_294))));
	RzILOpPure *op_LSHIFT_300 = SHIFTL0(CAST(64, MSB(op_MUL_297), DUP(op_MUL_297)), SN(32, 1));
	RzILOpPure *op_ADD_301 = ADD(op_ADD_270, op_LSHIFT_300);
	RzILOpPure *op_LT_304 = SLT(op_ADD_301, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_309 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_310 = NEG(op_LSHIFT_309);
	RzILOpPure *op_LSHIFT_315 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_318 = SUB(op_LSHIFT_315, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_319 = ITE(op_LT_304, op_NEG_310, op_SUB_318);
	RzILOpEffect *gcc_expr_320 = BRANCH(op_EQ_158, EMPTY(), set_usr_field_call_231);

	// h_tmp423 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_322 = SETL("h_tmp423", cond_319);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_323 = SEQN(2, gcc_expr_320, op_ASSIGN_hybrid_tmp_322);

	// Rxx = ((Rxx & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)) ? ((st64) ((st32) ((Rxx >> 0x20) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) : h_tmp423) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_6);
	RzILOpPure *op_RSHIFT_162 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0x20));
	RzILOpPure *op_AND_164 = LOGAND(op_RSHIFT_162, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_170 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_173 = LOGAND(op_RSHIFT_170, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_179 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_181 = LOGAND(op_RSHIFT_179, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_187 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_181), DUP(op_AND_181))), CAST(32, MSB(DUP(op_AND_181)), DUP(op_AND_181))), SN(32, 0));
	RzILOpPure *op_AND_190 = LOGAND(op_RSHIFT_187, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_193 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_173), DUP(op_AND_173))), CAST(16, MSB(DUP(op_AND_173)), DUP(op_AND_173))), CAST(32, MSB(CAST(16, MSB(op_AND_190), DUP(op_AND_190))), CAST(16, MSB(DUP(op_AND_190)), DUP(op_AND_190))));
	RzILOpPure *op_LSHIFT_196 = SHIFTL0(CAST(64, MSB(op_MUL_193), DUP(op_MUL_193)), SN(32, 1));
	RzILOpPure *op_ADD_197 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_164), DUP(op_AND_164))), CAST(32, MSB(DUP(op_AND_164)), DUP(op_AND_164))), op_LSHIFT_196);
	RzILOpPure *op_RSHIFT_201 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_204 = LOGAND(op_RSHIFT_201, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_210 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_212 = LOGAND(op_RSHIFT_210, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_218 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_212), DUP(op_AND_212))), CAST(32, MSB(DUP(op_AND_212)), DUP(op_AND_212))), SN(32, 16));
	RzILOpPure *op_AND_221 = LOGAND(op_RSHIFT_218, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_224 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_204), DUP(op_AND_204))), CAST(16, MSB(DUP(op_AND_204)), DUP(op_AND_204))), CAST(32, MSB(CAST(16, MSB(op_AND_221), DUP(op_AND_221))), CAST(16, MSB(DUP(op_AND_221)), DUP(op_AND_221))));
	RzILOpPure *op_LSHIFT_227 = SHIFTL0(CAST(64, MSB(op_MUL_224), DUP(op_MUL_224)), SN(32, 1));
	RzILOpPure *op_ADD_228 = ADD(op_ADD_197, op_LSHIFT_227);
	RzILOpPure *cond_324 = ITE(DUP(op_EQ_158), op_ADD_228, VARL("h_tmp423"));
	RzILOpPure *op_AND_326 = LOGAND(cond_324, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_330 = SHIFTL0(op_AND_326, SN(32, 0x20));
	RzILOpPure *op_OR_331 = LOGOR(op_AND_7, op_LSHIFT_330);
	RzILOpEffect *op_ASSIGN_332 = WRITE_REG(bundle, Rxx_op, op_OR_331);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_333 = SEQN(2, seq_323, op_ASSIGN_332);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_563 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_348 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_350 = LOGAND(op_RSHIFT_348, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_356 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_359 = LOGAND(op_RSHIFT_356, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_365 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_367 = LOGAND(op_RSHIFT_365, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_373 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_367), DUP(op_AND_367))), CAST(32, MSB(DUP(op_AND_367)), DUP(op_AND_367))), SN(32, 0));
	RzILOpPure *op_AND_376 = LOGAND(op_RSHIFT_373, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_379 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_359), DUP(op_AND_359))), CAST(16, MSB(DUP(op_AND_359)), DUP(op_AND_359))), CAST(32, MSB(CAST(16, MSB(op_AND_376), DUP(op_AND_376))), CAST(16, MSB(DUP(op_AND_376)), DUP(op_AND_376))));
	RzILOpPure *op_LSHIFT_382 = SHIFTL0(CAST(64, MSB(op_MUL_379), DUP(op_MUL_379)), SN(32, 1));
	RzILOpPure *op_ADD_383 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_350), DUP(op_AND_350))), CAST(32, MSB(DUP(op_AND_350)), DUP(op_AND_350))), op_LSHIFT_382);
	RzILOpPure *op_RSHIFT_387 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_390 = LOGAND(op_RSHIFT_387, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_396 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_398 = LOGAND(op_RSHIFT_396, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_404 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_398), DUP(op_AND_398))), CAST(32, MSB(DUP(op_AND_398)), DUP(op_AND_398))), SN(32, 16));
	RzILOpPure *op_AND_407 = LOGAND(op_RSHIFT_404, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_410 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_390), DUP(op_AND_390))), CAST(16, MSB(DUP(op_AND_390)), DUP(op_AND_390))), CAST(32, MSB(CAST(16, MSB(op_AND_407), DUP(op_AND_407))), CAST(16, MSB(DUP(op_AND_407)), DUP(op_AND_407))));
	RzILOpPure *op_LSHIFT_413 = SHIFTL0(CAST(64, MSB(op_MUL_410), DUP(op_MUL_410)), SN(32, 1));
	RzILOpPure *op_ADD_414 = ADD(op_ADD_383, op_LSHIFT_413);
	RzILOpPure *op_RSHIFT_423 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_425 = LOGAND(op_RSHIFT_423, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_431 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_434 = LOGAND(op_RSHIFT_431, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_440 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_442 = LOGAND(op_RSHIFT_440, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_448 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_442), DUP(op_AND_442))), CAST(32, MSB(DUP(op_AND_442)), DUP(op_AND_442))), SN(32, 0));
	RzILOpPure *op_AND_451 = LOGAND(op_RSHIFT_448, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_454 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_434), DUP(op_AND_434))), CAST(16, MSB(DUP(op_AND_434)), DUP(op_AND_434))), CAST(32, MSB(CAST(16, MSB(op_AND_451), DUP(op_AND_451))), CAST(16, MSB(DUP(op_AND_451)), DUP(op_AND_451))));
	RzILOpPure *op_LSHIFT_457 = SHIFTL0(CAST(64, MSB(op_MUL_454), DUP(op_MUL_454)), SN(32, 1));
	RzILOpPure *op_ADD_458 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_425), DUP(op_AND_425))), CAST(32, MSB(DUP(op_AND_425)), DUP(op_AND_425))), op_LSHIFT_457);
	RzILOpPure *op_RSHIFT_462 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_465 = LOGAND(op_RSHIFT_462, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_471 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_473 = LOGAND(op_RSHIFT_471, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_479 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_473), DUP(op_AND_473))), CAST(32, MSB(DUP(op_AND_473)), DUP(op_AND_473))), SN(32, 16));
	RzILOpPure *op_AND_482 = LOGAND(op_RSHIFT_479, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_485 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_465), DUP(op_AND_465))), CAST(16, MSB(DUP(op_AND_465)), DUP(op_AND_465))), CAST(32, MSB(CAST(16, MSB(op_AND_482), DUP(op_AND_482))), CAST(16, MSB(DUP(op_AND_482)), DUP(op_AND_482))));
	RzILOpPure *op_LSHIFT_488 = SHIFTL0(CAST(64, MSB(op_MUL_485), DUP(op_MUL_485)), SN(32, 1));
	RzILOpPure *op_ADD_489 = ADD(op_ADD_458, op_LSHIFT_488);
	RzILOpPure *op_EQ_490 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_414), SN(32, 0), SN(32, 0x20)), op_ADD_489);
	RzILOpPure *op_RSHIFT_567 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_569 = LOGAND(op_RSHIFT_567, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_575 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_578 = LOGAND(op_RSHIFT_575, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_584 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_586 = LOGAND(op_RSHIFT_584, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_592 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_586), DUP(op_AND_586))), CAST(32, MSB(DUP(op_AND_586)), DUP(op_AND_586))), SN(32, 0));
	RzILOpPure *op_AND_595 = LOGAND(op_RSHIFT_592, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_598 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_578), DUP(op_AND_578))), CAST(16, MSB(DUP(op_AND_578)), DUP(op_AND_578))), CAST(32, MSB(CAST(16, MSB(op_AND_595), DUP(op_AND_595))), CAST(16, MSB(DUP(op_AND_595)), DUP(op_AND_595))));
	RzILOpPure *op_LSHIFT_601 = SHIFTL0(CAST(64, MSB(op_MUL_598), DUP(op_MUL_598)), SN(32, 1));
	RzILOpPure *op_ADD_602 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_569), DUP(op_AND_569))), CAST(32, MSB(DUP(op_AND_569)), DUP(op_AND_569))), op_LSHIFT_601);
	RzILOpPure *op_RSHIFT_606 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_609 = LOGAND(op_RSHIFT_606, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_615 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_617 = LOGAND(op_RSHIFT_615, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_623 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_617), DUP(op_AND_617))), CAST(32, MSB(DUP(op_AND_617)), DUP(op_AND_617))), SN(32, 16));
	RzILOpPure *op_AND_626 = LOGAND(op_RSHIFT_623, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_629 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_609), DUP(op_AND_609))), CAST(16, MSB(DUP(op_AND_609)), DUP(op_AND_609))), CAST(32, MSB(CAST(16, MSB(op_AND_626), DUP(op_AND_626))), CAST(16, MSB(DUP(op_AND_626)), DUP(op_AND_626))));
	RzILOpPure *op_LSHIFT_632 = SHIFTL0(CAST(64, MSB(op_MUL_629), DUP(op_MUL_629)), SN(32, 1));
	RzILOpPure *op_ADD_633 = ADD(op_ADD_602, op_LSHIFT_632);
	RzILOpPure *op_LT_636 = SLT(op_ADD_633, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_641 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_642 = NEG(op_LSHIFT_641);
	RzILOpPure *op_LSHIFT_647 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_650 = SUB(op_LSHIFT_647, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_651 = ITE(op_LT_636, op_NEG_642, op_SUB_650);
	RzILOpEffect *gcc_expr_652 = BRANCH(op_EQ_490, EMPTY(), set_usr_field_call_563);

	// h_tmp424 = HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, ((((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_654 = SETL("h_tmp424", cond_651);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((Rxx > ...;
	RzILOpEffect *seq_655 = SEQN(2, gcc_expr_652, op_ASSIGN_hybrid_tmp_654);

	// Rxx = ((Rxx & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)) ? ((st64) ((st32) ((Rxx >> 0x0) & 0xffffffff))) + (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) : h_tmp424) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_339 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_340 = LOGNOT(op_LSHIFT_339);
	RzILOpPure *op_AND_341 = LOGAND(READ_REG(pkt, Rxx_op, false), op_NOT_340);
	RzILOpPure *op_RSHIFT_494 = SHIFTRA(READ_REG(pkt, Rxx_op, false), SN(32, 0));
	RzILOpPure *op_AND_496 = LOGAND(op_RSHIFT_494, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_502 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_505 = LOGAND(op_RSHIFT_502, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_511 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_513 = LOGAND(op_RSHIFT_511, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_519 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_513), DUP(op_AND_513))), CAST(32, MSB(DUP(op_AND_513)), DUP(op_AND_513))), SN(32, 0));
	RzILOpPure *op_AND_522 = LOGAND(op_RSHIFT_519, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_525 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_505), DUP(op_AND_505))), CAST(16, MSB(DUP(op_AND_505)), DUP(op_AND_505))), CAST(32, MSB(CAST(16, MSB(op_AND_522), DUP(op_AND_522))), CAST(16, MSB(DUP(op_AND_522)), DUP(op_AND_522))));
	RzILOpPure *op_LSHIFT_528 = SHIFTL0(CAST(64, MSB(op_MUL_525), DUP(op_MUL_525)), SN(32, 1));
	RzILOpPure *op_ADD_529 = ADD(CAST(64, MSB(CAST(32, MSB(op_AND_496), DUP(op_AND_496))), CAST(32, MSB(DUP(op_AND_496)), DUP(op_AND_496))), op_LSHIFT_528);
	RzILOpPure *op_RSHIFT_533 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_536 = LOGAND(op_RSHIFT_533, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_542 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_544 = LOGAND(op_RSHIFT_542, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_550 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_544), DUP(op_AND_544))), CAST(32, MSB(DUP(op_AND_544)), DUP(op_AND_544))), SN(32, 16));
	RzILOpPure *op_AND_553 = LOGAND(op_RSHIFT_550, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_556 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_536), DUP(op_AND_536))), CAST(16, MSB(DUP(op_AND_536)), DUP(op_AND_536))), CAST(32, MSB(CAST(16, MSB(op_AND_553), DUP(op_AND_553))), CAST(16, MSB(DUP(op_AND_553)), DUP(op_AND_553))));
	RzILOpPure *op_LSHIFT_559 = SHIFTL0(CAST(64, MSB(op_MUL_556), DUP(op_MUL_556)), SN(32, 1));
	RzILOpPure *op_ADD_560 = ADD(op_ADD_529, op_LSHIFT_559);
	RzILOpPure *cond_656 = ITE(DUP(op_EQ_490), op_ADD_560, VARL("h_tmp424"));
	RzILOpPure *op_AND_658 = LOGAND(cond_656, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_662 = SHIFTL0(op_AND_658, SN(32, 0));
	RzILOpPure *op_OR_663 = LOGOR(op_AND_341, op_LSHIFT_662);
	RzILOpEffect *op_ASSIGN_664 = WRITE_REG(bundle, Rxx_op, op_OR_663);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) ((st64) ((st32) ((R ...;
	RzILOpEffect *seq_665 = SEQN(2, seq_655, op_ASSIGN_664);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_333, seq_665);
	return instruction_sequence;
}

// Rdd = vrcmpys(Rss,Rtt):<<1:sat:raw:hi
RzILOpEffect *hex_il_op_m2_vrcmpys_s1_h(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_204 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rss, SN(32, 16));
	RzILOpPure *op_AND_18 = LOGAND(op_RSHIFT_15, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_25 = SHIFTRA(Rtt, SN(32, 0x20));
	RzILOpPure *op_AND_27 = LOGAND(op_RSHIFT_25, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_33 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_27), DUP(op_AND_27))), CAST(32, MSB(DUP(op_AND_27)), DUP(op_AND_27))), SN(32, 0));
	RzILOpPure *op_AND_36 = LOGAND(op_RSHIFT_33, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_39 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_18), DUP(op_AND_18))), CAST(16, MSB(DUP(op_AND_18)), DUP(op_AND_18))), CAST(32, MSB(CAST(16, MSB(op_AND_36), DUP(op_AND_36))), CAST(16, MSB(DUP(op_AND_36)), DUP(op_AND_36))));
	RzILOpPure *op_LSHIFT_42 = SHIFTL0(CAST(64, MSB(op_MUL_39), DUP(op_MUL_39)), SN(32, 1));
	RzILOpPure *op_RSHIFT_46 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_49 = LOGAND(op_RSHIFT_46, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_55 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_57 = LOGAND(op_RSHIFT_55, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_63 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_57), DUP(op_AND_57))), CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57))), SN(32, 16));
	RzILOpPure *op_AND_66 = LOGAND(op_RSHIFT_63, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_69 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_49), DUP(op_AND_49))), CAST(16, MSB(DUP(op_AND_49)), DUP(op_AND_49))), CAST(32, MSB(CAST(16, MSB(op_AND_66), DUP(op_AND_66))), CAST(16, MSB(DUP(op_AND_66)), DUP(op_AND_66))));
	RzILOpPure *op_LSHIFT_72 = SHIFTL0(CAST(64, MSB(op_MUL_69), DUP(op_MUL_69)), SN(32, 1));
	RzILOpPure *op_ADD_73 = ADD(op_LSHIFT_42, op_LSHIFT_72);
	RzILOpPure *op_RSHIFT_82 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_85 = LOGAND(op_RSHIFT_82, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_91 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_93 = LOGAND(op_RSHIFT_91, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_99 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_93), DUP(op_AND_93))), CAST(32, MSB(DUP(op_AND_93)), DUP(op_AND_93))), SN(32, 0));
	RzILOpPure *op_AND_102 = LOGAND(op_RSHIFT_99, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_105 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_85), DUP(op_AND_85))), CAST(16, MSB(DUP(op_AND_85)), DUP(op_AND_85))), CAST(32, MSB(CAST(16, MSB(op_AND_102), DUP(op_AND_102))), CAST(16, MSB(DUP(op_AND_102)), DUP(op_AND_102))));
	RzILOpPure *op_LSHIFT_108 = SHIFTL0(CAST(64, MSB(op_MUL_105), DUP(op_MUL_105)), SN(32, 1));
	RzILOpPure *op_RSHIFT_112 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_115 = LOGAND(op_RSHIFT_112, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_121 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_123 = LOGAND(op_RSHIFT_121, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_129 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_123), DUP(op_AND_123))), CAST(32, MSB(DUP(op_AND_123)), DUP(op_AND_123))), SN(32, 16));
	RzILOpPure *op_AND_132 = LOGAND(op_RSHIFT_129, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_135 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_115), DUP(op_AND_115))), CAST(16, MSB(DUP(op_AND_115)), DUP(op_AND_115))), CAST(32, MSB(CAST(16, MSB(op_AND_132), DUP(op_AND_132))), CAST(16, MSB(DUP(op_AND_132)), DUP(op_AND_132))));
	RzILOpPure *op_LSHIFT_138 = SHIFTL0(CAST(64, MSB(op_MUL_135), DUP(op_MUL_135)), SN(32, 1));
	RzILOpPure *op_ADD_139 = ADD(op_LSHIFT_108, op_LSHIFT_138);
	RzILOpPure *op_EQ_140 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_73), SN(32, 0), SN(32, 0x20)), op_ADD_139);
	RzILOpPure *op_RSHIFT_208 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_211 = LOGAND(op_RSHIFT_208, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_217 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_219 = LOGAND(op_RSHIFT_217, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_225 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_219), DUP(op_AND_219))), CAST(32, MSB(DUP(op_AND_219)), DUP(op_AND_219))), SN(32, 0));
	RzILOpPure *op_AND_228 = LOGAND(op_RSHIFT_225, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_231 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_211), DUP(op_AND_211))), CAST(16, MSB(DUP(op_AND_211)), DUP(op_AND_211))), CAST(32, MSB(CAST(16, MSB(op_AND_228), DUP(op_AND_228))), CAST(16, MSB(DUP(op_AND_228)), DUP(op_AND_228))));
	RzILOpPure *op_LSHIFT_234 = SHIFTL0(CAST(64, MSB(op_MUL_231), DUP(op_MUL_231)), SN(32, 1));
	RzILOpPure *op_RSHIFT_238 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_241 = LOGAND(op_RSHIFT_238, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_247 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_249 = LOGAND(op_RSHIFT_247, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_255 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_249), DUP(op_AND_249))), CAST(32, MSB(DUP(op_AND_249)), DUP(op_AND_249))), SN(32, 16));
	RzILOpPure *op_AND_258 = LOGAND(op_RSHIFT_255, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_261 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_241), DUP(op_AND_241))), CAST(16, MSB(DUP(op_AND_241)), DUP(op_AND_241))), CAST(32, MSB(CAST(16, MSB(op_AND_258), DUP(op_AND_258))), CAST(16, MSB(DUP(op_AND_258)), DUP(op_AND_258))));
	RzILOpPure *op_LSHIFT_264 = SHIFTL0(CAST(64, MSB(op_MUL_261), DUP(op_MUL_261)), SN(32, 1));
	RzILOpPure *op_ADD_265 = ADD(op_LSHIFT_234, op_LSHIFT_264);
	RzILOpPure *op_LT_268 = SLT(op_ADD_265, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_273 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_274 = NEG(op_LSHIFT_273);
	RzILOpPure *op_LSHIFT_279 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_282 = SUB(op_LSHIFT_279, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_283 = ITE(op_LT_268, op_NEG_274, op_SUB_282);
	RzILOpEffect *gcc_expr_284 = BRANCH(op_EQ_140, EMPTY(), set_usr_field_call_204);

	// h_tmp425 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_286 = SETL("h_tmp425", cond_283);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_287 = SEQN(2, gcc_expr_284, op_ASSIGN_hybrid_tmp_286);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)) ? (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) : h_tmp425) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_144 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_147 = LOGAND(op_RSHIFT_144, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_153 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_155 = LOGAND(op_RSHIFT_153, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_161 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_155), DUP(op_AND_155))), CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155))), SN(32, 0));
	RzILOpPure *op_AND_164 = LOGAND(op_RSHIFT_161, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_167 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_147), DUP(op_AND_147))), CAST(16, MSB(DUP(op_AND_147)), DUP(op_AND_147))), CAST(32, MSB(CAST(16, MSB(op_AND_164), DUP(op_AND_164))), CAST(16, MSB(DUP(op_AND_164)), DUP(op_AND_164))));
	RzILOpPure *op_LSHIFT_170 = SHIFTL0(CAST(64, MSB(op_MUL_167), DUP(op_MUL_167)), SN(32, 1));
	RzILOpPure *op_RSHIFT_174 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_177 = LOGAND(op_RSHIFT_174, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_183 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_185 = LOGAND(op_RSHIFT_183, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_191 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_185), DUP(op_AND_185))), CAST(32, MSB(DUP(op_AND_185)), DUP(op_AND_185))), SN(32, 16));
	RzILOpPure *op_AND_194 = LOGAND(op_RSHIFT_191, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_197 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_177), DUP(op_AND_177))), CAST(16, MSB(DUP(op_AND_177)), DUP(op_AND_177))), CAST(32, MSB(CAST(16, MSB(op_AND_194), DUP(op_AND_194))), CAST(16, MSB(DUP(op_AND_194)), DUP(op_AND_194))));
	RzILOpPure *op_LSHIFT_200 = SHIFTL0(CAST(64, MSB(op_MUL_197), DUP(op_MUL_197)), SN(32, 1));
	RzILOpPure *op_ADD_201 = ADD(op_LSHIFT_170, op_LSHIFT_200);
	RzILOpPure *cond_288 = ITE(DUP(op_EQ_140), op_ADD_201, VARL("h_tmp425"));
	RzILOpPure *op_AND_290 = LOGAND(cond_288, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_294 = SHIFTL0(op_AND_290, SN(32, 0x20));
	RzILOpPure *op_OR_295 = LOGOR(op_AND_7, op_LSHIFT_294);
	RzILOpEffect *op_ASSIGN_296 = WRITE_REG(bundle, Rdd_op, op_OR_295);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_297 = SEQN(2, seq_287, op_ASSIGN_296);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_500 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_312 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_315 = LOGAND(op_RSHIFT_312, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_321 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_323 = LOGAND(op_RSHIFT_321, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_329 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_323), DUP(op_AND_323))), CAST(32, MSB(DUP(op_AND_323)), DUP(op_AND_323))), SN(32, 0));
	RzILOpPure *op_AND_332 = LOGAND(op_RSHIFT_329, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_335 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_315), DUP(op_AND_315))), CAST(16, MSB(DUP(op_AND_315)), DUP(op_AND_315))), CAST(32, MSB(CAST(16, MSB(op_AND_332), DUP(op_AND_332))), CAST(16, MSB(DUP(op_AND_332)), DUP(op_AND_332))));
	RzILOpPure *op_LSHIFT_338 = SHIFTL0(CAST(64, MSB(op_MUL_335), DUP(op_MUL_335)), SN(32, 1));
	RzILOpPure *op_RSHIFT_342 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_345 = LOGAND(op_RSHIFT_342, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_351 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_353 = LOGAND(op_RSHIFT_351, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_359 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_353), DUP(op_AND_353))), CAST(32, MSB(DUP(op_AND_353)), DUP(op_AND_353))), SN(32, 16));
	RzILOpPure *op_AND_362 = LOGAND(op_RSHIFT_359, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_365 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_345), DUP(op_AND_345))), CAST(16, MSB(DUP(op_AND_345)), DUP(op_AND_345))), CAST(32, MSB(CAST(16, MSB(op_AND_362), DUP(op_AND_362))), CAST(16, MSB(DUP(op_AND_362)), DUP(op_AND_362))));
	RzILOpPure *op_LSHIFT_368 = SHIFTL0(CAST(64, MSB(op_MUL_365), DUP(op_MUL_365)), SN(32, 1));
	RzILOpPure *op_ADD_369 = ADD(op_LSHIFT_338, op_LSHIFT_368);
	RzILOpPure *op_RSHIFT_378 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_381 = LOGAND(op_RSHIFT_378, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_387 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_389 = LOGAND(op_RSHIFT_387, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_395 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_389), DUP(op_AND_389))), CAST(32, MSB(DUP(op_AND_389)), DUP(op_AND_389))), SN(32, 0));
	RzILOpPure *op_AND_398 = LOGAND(op_RSHIFT_395, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_401 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_381), DUP(op_AND_381))), CAST(16, MSB(DUP(op_AND_381)), DUP(op_AND_381))), CAST(32, MSB(CAST(16, MSB(op_AND_398), DUP(op_AND_398))), CAST(16, MSB(DUP(op_AND_398)), DUP(op_AND_398))));
	RzILOpPure *op_LSHIFT_404 = SHIFTL0(CAST(64, MSB(op_MUL_401), DUP(op_MUL_401)), SN(32, 1));
	RzILOpPure *op_RSHIFT_408 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_411 = LOGAND(op_RSHIFT_408, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_417 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_419 = LOGAND(op_RSHIFT_417, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_425 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_419), DUP(op_AND_419))), CAST(32, MSB(DUP(op_AND_419)), DUP(op_AND_419))), SN(32, 16));
	RzILOpPure *op_AND_428 = LOGAND(op_RSHIFT_425, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_431 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_411), DUP(op_AND_411))), CAST(16, MSB(DUP(op_AND_411)), DUP(op_AND_411))), CAST(32, MSB(CAST(16, MSB(op_AND_428), DUP(op_AND_428))), CAST(16, MSB(DUP(op_AND_428)), DUP(op_AND_428))));
	RzILOpPure *op_LSHIFT_434 = SHIFTL0(CAST(64, MSB(op_MUL_431), DUP(op_MUL_431)), SN(32, 1));
	RzILOpPure *op_ADD_435 = ADD(op_LSHIFT_404, op_LSHIFT_434);
	RzILOpPure *op_EQ_436 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_369), SN(32, 0), SN(32, 0x20)), op_ADD_435);
	RzILOpPure *op_RSHIFT_504 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_507 = LOGAND(op_RSHIFT_504, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_513 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_515 = LOGAND(op_RSHIFT_513, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_521 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_515), DUP(op_AND_515))), CAST(32, MSB(DUP(op_AND_515)), DUP(op_AND_515))), SN(32, 0));
	RzILOpPure *op_AND_524 = LOGAND(op_RSHIFT_521, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_527 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_507), DUP(op_AND_507))), CAST(16, MSB(DUP(op_AND_507)), DUP(op_AND_507))), CAST(32, MSB(CAST(16, MSB(op_AND_524), DUP(op_AND_524))), CAST(16, MSB(DUP(op_AND_524)), DUP(op_AND_524))));
	RzILOpPure *op_LSHIFT_530 = SHIFTL0(CAST(64, MSB(op_MUL_527), DUP(op_MUL_527)), SN(32, 1));
	RzILOpPure *op_RSHIFT_534 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_537 = LOGAND(op_RSHIFT_534, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_543 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_545 = LOGAND(op_RSHIFT_543, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_551 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_545), DUP(op_AND_545))), CAST(32, MSB(DUP(op_AND_545)), DUP(op_AND_545))), SN(32, 16));
	RzILOpPure *op_AND_554 = LOGAND(op_RSHIFT_551, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_557 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_537), DUP(op_AND_537))), CAST(16, MSB(DUP(op_AND_537)), DUP(op_AND_537))), CAST(32, MSB(CAST(16, MSB(op_AND_554), DUP(op_AND_554))), CAST(16, MSB(DUP(op_AND_554)), DUP(op_AND_554))));
	RzILOpPure *op_LSHIFT_560 = SHIFTL0(CAST(64, MSB(op_MUL_557), DUP(op_MUL_557)), SN(32, 1));
	RzILOpPure *op_ADD_561 = ADD(op_LSHIFT_530, op_LSHIFT_560);
	RzILOpPure *op_LT_564 = SLT(op_ADD_561, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_569 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_570 = NEG(op_LSHIFT_569);
	RzILOpPure *op_LSHIFT_575 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_578 = SUB(op_LSHIFT_575, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_579 = ITE(op_LT_564, op_NEG_570, op_SUB_578);
	RzILOpEffect *gcc_expr_580 = BRANCH(op_EQ_436, EMPTY(), set_usr_field_call_500);

	// h_tmp426 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_582 = SETL("h_tmp426", cond_579);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_583 = SEQN(2, gcc_expr_580, op_ASSIGN_hybrid_tmp_582);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)) ? (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) : h_tmp426) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_303 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_304 = LOGNOT(op_LSHIFT_303);
	RzILOpPure *op_AND_305 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_304);
	RzILOpPure *op_RSHIFT_440 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_443 = LOGAND(op_RSHIFT_440, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_449 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_451 = LOGAND(op_RSHIFT_449, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_457 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_451), DUP(op_AND_451))), CAST(32, MSB(DUP(op_AND_451)), DUP(op_AND_451))), SN(32, 0));
	RzILOpPure *op_AND_460 = LOGAND(op_RSHIFT_457, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_463 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_443), DUP(op_AND_443))), CAST(16, MSB(DUP(op_AND_443)), DUP(op_AND_443))), CAST(32, MSB(CAST(16, MSB(op_AND_460), DUP(op_AND_460))), CAST(16, MSB(DUP(op_AND_460)), DUP(op_AND_460))));
	RzILOpPure *op_LSHIFT_466 = SHIFTL0(CAST(64, MSB(op_MUL_463), DUP(op_MUL_463)), SN(32, 1));
	RzILOpPure *op_RSHIFT_470 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_473 = LOGAND(op_RSHIFT_470, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_479 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_481 = LOGAND(op_RSHIFT_479, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_487 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_481), DUP(op_AND_481))), CAST(32, MSB(DUP(op_AND_481)), DUP(op_AND_481))), SN(32, 16));
	RzILOpPure *op_AND_490 = LOGAND(op_RSHIFT_487, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_493 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_473), DUP(op_AND_473))), CAST(16, MSB(DUP(op_AND_473)), DUP(op_AND_473))), CAST(32, MSB(CAST(16, MSB(op_AND_490), DUP(op_AND_490))), CAST(16, MSB(DUP(op_AND_490)), DUP(op_AND_490))));
	RzILOpPure *op_LSHIFT_496 = SHIFTL0(CAST(64, MSB(op_MUL_493), DUP(op_MUL_493)), SN(32, 1));
	RzILOpPure *op_ADD_497 = ADD(op_LSHIFT_466, op_LSHIFT_496);
	RzILOpPure *cond_584 = ITE(DUP(op_EQ_436), op_ADD_497, VARL("h_tmp426"));
	RzILOpPure *op_AND_586 = LOGAND(cond_584, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_590 = SHIFTL0(op_AND_586, SN(32, 0));
	RzILOpPure *op_OR_591 = LOGOR(op_AND_305, op_LSHIFT_590);
	RzILOpEffect *op_ASSIGN_592 = WRITE_REG(bundle, Rdd_op, op_OR_591);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_593 = SEQN(2, seq_583, op_ASSIGN_592);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_297, seq_593);
	return instruction_sequence;
}

// Rdd = vrcmpys(Rss,Rtt):<<1:sat:raw:lo
RzILOpEffect *hex_il_op_m2_vrcmpys_s1_l(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_204 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rss, SN(32, 16));
	RzILOpPure *op_AND_18 = LOGAND(op_RSHIFT_15, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_25 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_27 = LOGAND(op_RSHIFT_25, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_33 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_27), DUP(op_AND_27))), CAST(32, MSB(DUP(op_AND_27)), DUP(op_AND_27))), SN(32, 0));
	RzILOpPure *op_AND_36 = LOGAND(op_RSHIFT_33, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_39 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_18), DUP(op_AND_18))), CAST(16, MSB(DUP(op_AND_18)), DUP(op_AND_18))), CAST(32, MSB(CAST(16, MSB(op_AND_36), DUP(op_AND_36))), CAST(16, MSB(DUP(op_AND_36)), DUP(op_AND_36))));
	RzILOpPure *op_LSHIFT_42 = SHIFTL0(CAST(64, MSB(op_MUL_39), DUP(op_MUL_39)), SN(32, 1));
	RzILOpPure *op_RSHIFT_46 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_49 = LOGAND(op_RSHIFT_46, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_55 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_57 = LOGAND(op_RSHIFT_55, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_63 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_57), DUP(op_AND_57))), CAST(32, MSB(DUP(op_AND_57)), DUP(op_AND_57))), SN(32, 16));
	RzILOpPure *op_AND_66 = LOGAND(op_RSHIFT_63, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_69 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_49), DUP(op_AND_49))), CAST(16, MSB(DUP(op_AND_49)), DUP(op_AND_49))), CAST(32, MSB(CAST(16, MSB(op_AND_66), DUP(op_AND_66))), CAST(16, MSB(DUP(op_AND_66)), DUP(op_AND_66))));
	RzILOpPure *op_LSHIFT_72 = SHIFTL0(CAST(64, MSB(op_MUL_69), DUP(op_MUL_69)), SN(32, 1));
	RzILOpPure *op_ADD_73 = ADD(op_LSHIFT_42, op_LSHIFT_72);
	RzILOpPure *op_RSHIFT_82 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_85 = LOGAND(op_RSHIFT_82, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_91 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_93 = LOGAND(op_RSHIFT_91, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_99 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_93), DUP(op_AND_93))), CAST(32, MSB(DUP(op_AND_93)), DUP(op_AND_93))), SN(32, 0));
	RzILOpPure *op_AND_102 = LOGAND(op_RSHIFT_99, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_105 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_85), DUP(op_AND_85))), CAST(16, MSB(DUP(op_AND_85)), DUP(op_AND_85))), CAST(32, MSB(CAST(16, MSB(op_AND_102), DUP(op_AND_102))), CAST(16, MSB(DUP(op_AND_102)), DUP(op_AND_102))));
	RzILOpPure *op_LSHIFT_108 = SHIFTL0(CAST(64, MSB(op_MUL_105), DUP(op_MUL_105)), SN(32, 1));
	RzILOpPure *op_RSHIFT_112 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_115 = LOGAND(op_RSHIFT_112, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_121 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_123 = LOGAND(op_RSHIFT_121, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_129 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_123), DUP(op_AND_123))), CAST(32, MSB(DUP(op_AND_123)), DUP(op_AND_123))), SN(32, 16));
	RzILOpPure *op_AND_132 = LOGAND(op_RSHIFT_129, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_135 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_115), DUP(op_AND_115))), CAST(16, MSB(DUP(op_AND_115)), DUP(op_AND_115))), CAST(32, MSB(CAST(16, MSB(op_AND_132), DUP(op_AND_132))), CAST(16, MSB(DUP(op_AND_132)), DUP(op_AND_132))));
	RzILOpPure *op_LSHIFT_138 = SHIFTL0(CAST(64, MSB(op_MUL_135), DUP(op_MUL_135)), SN(32, 1));
	RzILOpPure *op_ADD_139 = ADD(op_LSHIFT_108, op_LSHIFT_138);
	RzILOpPure *op_EQ_140 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_73), SN(32, 0), SN(32, 0x20)), op_ADD_139);
	RzILOpPure *op_RSHIFT_208 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_211 = LOGAND(op_RSHIFT_208, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_217 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_219 = LOGAND(op_RSHIFT_217, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_225 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_219), DUP(op_AND_219))), CAST(32, MSB(DUP(op_AND_219)), DUP(op_AND_219))), SN(32, 0));
	RzILOpPure *op_AND_228 = LOGAND(op_RSHIFT_225, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_231 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_211), DUP(op_AND_211))), CAST(16, MSB(DUP(op_AND_211)), DUP(op_AND_211))), CAST(32, MSB(CAST(16, MSB(op_AND_228), DUP(op_AND_228))), CAST(16, MSB(DUP(op_AND_228)), DUP(op_AND_228))));
	RzILOpPure *op_LSHIFT_234 = SHIFTL0(CAST(64, MSB(op_MUL_231), DUP(op_MUL_231)), SN(32, 1));
	RzILOpPure *op_RSHIFT_238 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_241 = LOGAND(op_RSHIFT_238, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_247 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_249 = LOGAND(op_RSHIFT_247, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_255 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_249), DUP(op_AND_249))), CAST(32, MSB(DUP(op_AND_249)), DUP(op_AND_249))), SN(32, 16));
	RzILOpPure *op_AND_258 = LOGAND(op_RSHIFT_255, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_261 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_241), DUP(op_AND_241))), CAST(16, MSB(DUP(op_AND_241)), DUP(op_AND_241))), CAST(32, MSB(CAST(16, MSB(op_AND_258), DUP(op_AND_258))), CAST(16, MSB(DUP(op_AND_258)), DUP(op_AND_258))));
	RzILOpPure *op_LSHIFT_264 = SHIFTL0(CAST(64, MSB(op_MUL_261), DUP(op_MUL_261)), SN(32, 1));
	RzILOpPure *op_ADD_265 = ADD(op_LSHIFT_234, op_LSHIFT_264);
	RzILOpPure *op_LT_268 = SLT(op_ADD_265, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_273 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_274 = NEG(op_LSHIFT_273);
	RzILOpPure *op_LSHIFT_279 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_282 = SUB(op_LSHIFT_279, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_283 = ITE(op_LT_268, op_NEG_274, op_SUB_282);
	RzILOpEffect *gcc_expr_284 = BRANCH(op_EQ_140, EMPTY(), set_usr_field_call_204);

	// h_tmp427 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_286 = SETL("h_tmp427", cond_283);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_287 = SEQN(2, gcc_expr_284, op_ASSIGN_hybrid_tmp_286);

	// Rdd = ((Rdd & (~(0xffffffff << 0x20))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)) ? (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) : h_tmp427) & 0xffffffff) << 0x20));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0x20));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_7 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_6);
	RzILOpPure *op_RSHIFT_144 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_147 = LOGAND(op_RSHIFT_144, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_153 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_155 = LOGAND(op_RSHIFT_153, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_161 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_155), DUP(op_AND_155))), CAST(32, MSB(DUP(op_AND_155)), DUP(op_AND_155))), SN(32, 0));
	RzILOpPure *op_AND_164 = LOGAND(op_RSHIFT_161, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_167 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_147), DUP(op_AND_147))), CAST(16, MSB(DUP(op_AND_147)), DUP(op_AND_147))), CAST(32, MSB(CAST(16, MSB(op_AND_164), DUP(op_AND_164))), CAST(16, MSB(DUP(op_AND_164)), DUP(op_AND_164))));
	RzILOpPure *op_LSHIFT_170 = SHIFTL0(CAST(64, MSB(op_MUL_167), DUP(op_MUL_167)), SN(32, 1));
	RzILOpPure *op_RSHIFT_174 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_177 = LOGAND(op_RSHIFT_174, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_183 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_185 = LOGAND(op_RSHIFT_183, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_191 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_185), DUP(op_AND_185))), CAST(32, MSB(DUP(op_AND_185)), DUP(op_AND_185))), SN(32, 16));
	RzILOpPure *op_AND_194 = LOGAND(op_RSHIFT_191, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_197 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_177), DUP(op_AND_177))), CAST(16, MSB(DUP(op_AND_177)), DUP(op_AND_177))), CAST(32, MSB(CAST(16, MSB(op_AND_194), DUP(op_AND_194))), CAST(16, MSB(DUP(op_AND_194)), DUP(op_AND_194))));
	RzILOpPure *op_LSHIFT_200 = SHIFTL0(CAST(64, MSB(op_MUL_197), DUP(op_MUL_197)), SN(32, 1));
	RzILOpPure *op_ADD_201 = ADD(op_LSHIFT_170, op_LSHIFT_200);
	RzILOpPure *cond_288 = ITE(DUP(op_EQ_140), op_ADD_201, VARL("h_tmp427"));
	RzILOpPure *op_AND_290 = LOGAND(cond_288, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_294 = SHIFTL0(op_AND_290, SN(32, 0x20));
	RzILOpPure *op_OR_295 = LOGOR(op_AND_7, op_LSHIFT_294);
	RzILOpEffect *op_ASSIGN_296 = WRITE_REG(bundle, Rdd_op, op_OR_295);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_297 = SEQN(2, seq_287, op_ASSIGN_296);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_500 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_312 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_315 = LOGAND(op_RSHIFT_312, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_321 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_323 = LOGAND(op_RSHIFT_321, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_329 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_323), DUP(op_AND_323))), CAST(32, MSB(DUP(op_AND_323)), DUP(op_AND_323))), SN(32, 0));
	RzILOpPure *op_AND_332 = LOGAND(op_RSHIFT_329, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_335 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_315), DUP(op_AND_315))), CAST(16, MSB(DUP(op_AND_315)), DUP(op_AND_315))), CAST(32, MSB(CAST(16, MSB(op_AND_332), DUP(op_AND_332))), CAST(16, MSB(DUP(op_AND_332)), DUP(op_AND_332))));
	RzILOpPure *op_LSHIFT_338 = SHIFTL0(CAST(64, MSB(op_MUL_335), DUP(op_MUL_335)), SN(32, 1));
	RzILOpPure *op_RSHIFT_342 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_345 = LOGAND(op_RSHIFT_342, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_351 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_353 = LOGAND(op_RSHIFT_351, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_359 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_353), DUP(op_AND_353))), CAST(32, MSB(DUP(op_AND_353)), DUP(op_AND_353))), SN(32, 16));
	RzILOpPure *op_AND_362 = LOGAND(op_RSHIFT_359, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_365 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_345), DUP(op_AND_345))), CAST(16, MSB(DUP(op_AND_345)), DUP(op_AND_345))), CAST(32, MSB(CAST(16, MSB(op_AND_362), DUP(op_AND_362))), CAST(16, MSB(DUP(op_AND_362)), DUP(op_AND_362))));
	RzILOpPure *op_LSHIFT_368 = SHIFTL0(CAST(64, MSB(op_MUL_365), DUP(op_MUL_365)), SN(32, 1));
	RzILOpPure *op_ADD_369 = ADD(op_LSHIFT_338, op_LSHIFT_368);
	RzILOpPure *op_RSHIFT_378 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_381 = LOGAND(op_RSHIFT_378, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_387 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_389 = LOGAND(op_RSHIFT_387, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_395 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_389), DUP(op_AND_389))), CAST(32, MSB(DUP(op_AND_389)), DUP(op_AND_389))), SN(32, 0));
	RzILOpPure *op_AND_398 = LOGAND(op_RSHIFT_395, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_401 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_381), DUP(op_AND_381))), CAST(16, MSB(DUP(op_AND_381)), DUP(op_AND_381))), CAST(32, MSB(CAST(16, MSB(op_AND_398), DUP(op_AND_398))), CAST(16, MSB(DUP(op_AND_398)), DUP(op_AND_398))));
	RzILOpPure *op_LSHIFT_404 = SHIFTL0(CAST(64, MSB(op_MUL_401), DUP(op_MUL_401)), SN(32, 1));
	RzILOpPure *op_RSHIFT_408 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_411 = LOGAND(op_RSHIFT_408, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_417 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_419 = LOGAND(op_RSHIFT_417, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_425 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_419), DUP(op_AND_419))), CAST(32, MSB(DUP(op_AND_419)), DUP(op_AND_419))), SN(32, 16));
	RzILOpPure *op_AND_428 = LOGAND(op_RSHIFT_425, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_431 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_411), DUP(op_AND_411))), CAST(16, MSB(DUP(op_AND_411)), DUP(op_AND_411))), CAST(32, MSB(CAST(16, MSB(op_AND_428), DUP(op_AND_428))), CAST(16, MSB(DUP(op_AND_428)), DUP(op_AND_428))));
	RzILOpPure *op_LSHIFT_434 = SHIFTL0(CAST(64, MSB(op_MUL_431), DUP(op_MUL_431)), SN(32, 1));
	RzILOpPure *op_ADD_435 = ADD(op_LSHIFT_404, op_LSHIFT_434);
	RzILOpPure *op_EQ_436 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_369), SN(32, 0), SN(32, 0x20)), op_ADD_435);
	RzILOpPure *op_RSHIFT_504 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_507 = LOGAND(op_RSHIFT_504, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_513 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_515 = LOGAND(op_RSHIFT_513, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_521 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_515), DUP(op_AND_515))), CAST(32, MSB(DUP(op_AND_515)), DUP(op_AND_515))), SN(32, 0));
	RzILOpPure *op_AND_524 = LOGAND(op_RSHIFT_521, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_527 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_507), DUP(op_AND_507))), CAST(16, MSB(DUP(op_AND_507)), DUP(op_AND_507))), CAST(32, MSB(CAST(16, MSB(op_AND_524), DUP(op_AND_524))), CAST(16, MSB(DUP(op_AND_524)), DUP(op_AND_524))));
	RzILOpPure *op_LSHIFT_530 = SHIFTL0(CAST(64, MSB(op_MUL_527), DUP(op_MUL_527)), SN(32, 1));
	RzILOpPure *op_RSHIFT_534 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_537 = LOGAND(op_RSHIFT_534, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_543 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_545 = LOGAND(op_RSHIFT_543, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_551 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_545), DUP(op_AND_545))), CAST(32, MSB(DUP(op_AND_545)), DUP(op_AND_545))), SN(32, 16));
	RzILOpPure *op_AND_554 = LOGAND(op_RSHIFT_551, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_557 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_537), DUP(op_AND_537))), CAST(16, MSB(DUP(op_AND_537)), DUP(op_AND_537))), CAST(32, MSB(CAST(16, MSB(op_AND_554), DUP(op_AND_554))), CAST(16, MSB(DUP(op_AND_554)), DUP(op_AND_554))));
	RzILOpPure *op_LSHIFT_560 = SHIFTL0(CAST(64, MSB(op_MUL_557), DUP(op_MUL_557)), SN(32, 1));
	RzILOpPure *op_ADD_561 = ADD(op_LSHIFT_530, op_LSHIFT_560);
	RzILOpPure *op_LT_564 = SLT(op_ADD_561, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_569 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_570 = NEG(op_LSHIFT_569);
	RzILOpPure *op_LSHIFT_575 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_578 = SUB(op_LSHIFT_575, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_579 = ITE(op_LT_564, op_NEG_570, op_SUB_578);
	RzILOpEffect *gcc_expr_580 = BRANCH(op_EQ_436, EMPTY(), set_usr_field_call_500);

	// h_tmp428 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_582 = SETL("h_tmp428", cond_579);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_583 = SEQN(2, gcc_expr_580, op_ASSIGN_hybrid_tmp_582);

	// Rdd = ((Rdd & (~(0xffffffff << 0x0))) | ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1)) ? (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) : h_tmp428) & 0xffffffff) << 0x0));
	RzILOpPure *op_LSHIFT_303 = SHIFTL0(SN(64, 0xffffffff), SN(32, 0));
	RzILOpPure *op_NOT_304 = LOGNOT(op_LSHIFT_303);
	RzILOpPure *op_AND_305 = LOGAND(READ_REG(pkt, Rdd_op, true), op_NOT_304);
	RzILOpPure *op_RSHIFT_440 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_443 = LOGAND(op_RSHIFT_440, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_449 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_451 = LOGAND(op_RSHIFT_449, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_457 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_451), DUP(op_AND_451))), CAST(32, MSB(DUP(op_AND_451)), DUP(op_AND_451))), SN(32, 0));
	RzILOpPure *op_AND_460 = LOGAND(op_RSHIFT_457, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_463 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_443), DUP(op_AND_443))), CAST(16, MSB(DUP(op_AND_443)), DUP(op_AND_443))), CAST(32, MSB(CAST(16, MSB(op_AND_460), DUP(op_AND_460))), CAST(16, MSB(DUP(op_AND_460)), DUP(op_AND_460))));
	RzILOpPure *op_LSHIFT_466 = SHIFTL0(CAST(64, MSB(op_MUL_463), DUP(op_MUL_463)), SN(32, 1));
	RzILOpPure *op_RSHIFT_470 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_473 = LOGAND(op_RSHIFT_470, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_479 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_481 = LOGAND(op_RSHIFT_479, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_487 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_481), DUP(op_AND_481))), CAST(32, MSB(DUP(op_AND_481)), DUP(op_AND_481))), SN(32, 16));
	RzILOpPure *op_AND_490 = LOGAND(op_RSHIFT_487, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_493 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_473), DUP(op_AND_473))), CAST(16, MSB(DUP(op_AND_473)), DUP(op_AND_473))), CAST(32, MSB(CAST(16, MSB(op_AND_490), DUP(op_AND_490))), CAST(16, MSB(DUP(op_AND_490)), DUP(op_AND_490))));
	RzILOpPure *op_LSHIFT_496 = SHIFTL0(CAST(64, MSB(op_MUL_493), DUP(op_MUL_493)), SN(32, 1));
	RzILOpPure *op_ADD_497 = ADD(op_LSHIFT_466, op_LSHIFT_496);
	RzILOpPure *cond_584 = ITE(DUP(op_EQ_436), op_ADD_497, VARL("h_tmp428"));
	RzILOpPure *op_AND_586 = LOGAND(cond_584, SN(64, 0xffffffff));
	RzILOpPure *op_LSHIFT_590 = SHIFTL0(op_AND_586, SN(32, 0));
	RzILOpPure *op_OR_591 = LOGOR(op_AND_305, op_LSHIFT_590);
	RzILOpEffect *op_ASSIGN_592 = WRITE_REG(bundle, Rdd_op, op_OR_591);

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_593 = SEQN(2, seq_583, op_ASSIGN_592);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_297, seq_593);
	return instruction_sequence;
}

// Rd = vrcmpys(Rss,Rtt):<<1:rnd:sat:raw:hi
RzILOpEffect *hex_il_op_m2_vrcmpys_s1rp_h(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_214 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_16 = SHIFTRA(Rss, SN(32, 16));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_16, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_26 = SHIFTRA(Rtt, SN(32, 0x20));
	RzILOpPure *op_AND_28 = LOGAND(op_RSHIFT_26, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_34 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_28), DUP(op_AND_28))), CAST(32, MSB(DUP(op_AND_28)), DUP(op_AND_28))), SN(32, 0));
	RzILOpPure *op_AND_37 = LOGAND(op_RSHIFT_34, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_40 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))), CAST(32, MSB(CAST(16, MSB(op_AND_37), DUP(op_AND_37))), CAST(16, MSB(DUP(op_AND_37)), DUP(op_AND_37))));
	RzILOpPure *op_LSHIFT_43 = SHIFTL0(CAST(64, MSB(op_MUL_40), DUP(op_MUL_40)), SN(32, 1));
	RzILOpPure *op_RSHIFT_47 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_50 = LOGAND(op_RSHIFT_47, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_56 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_58 = LOGAND(op_RSHIFT_56, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_64 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_58), DUP(op_AND_58))), CAST(32, MSB(DUP(op_AND_58)), DUP(op_AND_58))), SN(32, 16));
	RzILOpPure *op_AND_67 = LOGAND(op_RSHIFT_64, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_70 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_50), DUP(op_AND_50))), CAST(16, MSB(DUP(op_AND_50)), DUP(op_AND_50))), CAST(32, MSB(CAST(16, MSB(op_AND_67), DUP(op_AND_67))), CAST(16, MSB(DUP(op_AND_67)), DUP(op_AND_67))));
	RzILOpPure *op_LSHIFT_73 = SHIFTL0(CAST(64, MSB(op_MUL_70), DUP(op_MUL_70)), SN(32, 1));
	RzILOpPure *op_ADD_74 = ADD(op_LSHIFT_43, op_LSHIFT_73);
	RzILOpPure *op_ADD_77 = ADD(op_ADD_74, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_86 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_89 = LOGAND(op_RSHIFT_86, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_95 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_97 = LOGAND(op_RSHIFT_95, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_103 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_97), DUP(op_AND_97))), CAST(32, MSB(DUP(op_AND_97)), DUP(op_AND_97))), SN(32, 0));
	RzILOpPure *op_AND_106 = LOGAND(op_RSHIFT_103, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_109 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_89), DUP(op_AND_89))), CAST(16, MSB(DUP(op_AND_89)), DUP(op_AND_89))), CAST(32, MSB(CAST(16, MSB(op_AND_106), DUP(op_AND_106))), CAST(16, MSB(DUP(op_AND_106)), DUP(op_AND_106))));
	RzILOpPure *op_LSHIFT_112 = SHIFTL0(CAST(64, MSB(op_MUL_109), DUP(op_MUL_109)), SN(32, 1));
	RzILOpPure *op_RSHIFT_116 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_119 = LOGAND(op_RSHIFT_116, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_125 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_127 = LOGAND(op_RSHIFT_125, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_133 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_127), DUP(op_AND_127))), CAST(32, MSB(DUP(op_AND_127)), DUP(op_AND_127))), SN(32, 16));
	RzILOpPure *op_AND_136 = LOGAND(op_RSHIFT_133, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_139 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_119), DUP(op_AND_119))), CAST(16, MSB(DUP(op_AND_119)), DUP(op_AND_119))), CAST(32, MSB(CAST(16, MSB(op_AND_136), DUP(op_AND_136))), CAST(16, MSB(DUP(op_AND_136)), DUP(op_AND_136))));
	RzILOpPure *op_LSHIFT_142 = SHIFTL0(CAST(64, MSB(op_MUL_139), DUP(op_MUL_139)), SN(32, 1));
	RzILOpPure *op_ADD_143 = ADD(op_LSHIFT_112, op_LSHIFT_142);
	RzILOpPure *op_ADD_146 = ADD(op_ADD_143, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_EQ_147 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_77), SN(32, 0), SN(32, 0x20)), op_ADD_146);
	RzILOpPure *op_RSHIFT_218 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_221 = LOGAND(op_RSHIFT_218, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_227 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_229 = LOGAND(op_RSHIFT_227, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_235 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_229), DUP(op_AND_229))), CAST(32, MSB(DUP(op_AND_229)), DUP(op_AND_229))), SN(32, 0));
	RzILOpPure *op_AND_238 = LOGAND(op_RSHIFT_235, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_241 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_221), DUP(op_AND_221))), CAST(16, MSB(DUP(op_AND_221)), DUP(op_AND_221))), CAST(32, MSB(CAST(16, MSB(op_AND_238), DUP(op_AND_238))), CAST(16, MSB(DUP(op_AND_238)), DUP(op_AND_238))));
	RzILOpPure *op_LSHIFT_244 = SHIFTL0(CAST(64, MSB(op_MUL_241), DUP(op_MUL_241)), SN(32, 1));
	RzILOpPure *op_RSHIFT_248 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_251 = LOGAND(op_RSHIFT_248, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_257 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_259 = LOGAND(op_RSHIFT_257, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_265 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_259), DUP(op_AND_259))), CAST(32, MSB(DUP(op_AND_259)), DUP(op_AND_259))), SN(32, 16));
	RzILOpPure *op_AND_268 = LOGAND(op_RSHIFT_265, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_271 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_251), DUP(op_AND_251))), CAST(16, MSB(DUP(op_AND_251)), DUP(op_AND_251))), CAST(32, MSB(CAST(16, MSB(op_AND_268), DUP(op_AND_268))), CAST(16, MSB(DUP(op_AND_268)), DUP(op_AND_268))));
	RzILOpPure *op_LSHIFT_274 = SHIFTL0(CAST(64, MSB(op_MUL_271), DUP(op_MUL_271)), SN(32, 1));
	RzILOpPure *op_ADD_275 = ADD(op_LSHIFT_244, op_LSHIFT_274);
	RzILOpPure *op_ADD_278 = ADD(op_ADD_275, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_LT_281 = SLT(op_ADD_278, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_286 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_287 = NEG(op_LSHIFT_286);
	RzILOpPure *op_LSHIFT_292 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_295 = SUB(op_LSHIFT_292, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_296 = ITE(op_LT_281, op_NEG_287, op_SUB_295);
	RzILOpEffect *gcc_expr_297 = BRANCH(op_EQ_147, EMPTY(), set_usr_field_call_214);

	// h_tmp429 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_299 = SETL("h_tmp429", cond_296);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_300 = SEQN(2, gcc_expr_297, op_ASSIGN_hybrid_tmp_299);

	// Rd = ((st32) (((ut64) (((st64) Rd) & (~(0xffff << 0x10)))) | (((ut64) (((st32) ((st16) ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000)) ? (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000) : h_tmp429) >> 0x10) & ((st64) 0xffff)))) & 0xffff)) << 0x10)));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffff), SN(32, 16));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_8 = LOGAND(CAST(64, MSB(READ_REG(pkt, Rd_op, true)), READ_REG(pkt, Rd_op, true)), op_NOT_6);
	RzILOpPure *op_RSHIFT_151 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_154 = LOGAND(op_RSHIFT_151, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_160 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_162 = LOGAND(op_RSHIFT_160, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_168 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_162), DUP(op_AND_162))), CAST(32, MSB(DUP(op_AND_162)), DUP(op_AND_162))), SN(32, 0));
	RzILOpPure *op_AND_171 = LOGAND(op_RSHIFT_168, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_174 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_154), DUP(op_AND_154))), CAST(16, MSB(DUP(op_AND_154)), DUP(op_AND_154))), CAST(32, MSB(CAST(16, MSB(op_AND_171), DUP(op_AND_171))), CAST(16, MSB(DUP(op_AND_171)), DUP(op_AND_171))));
	RzILOpPure *op_LSHIFT_177 = SHIFTL0(CAST(64, MSB(op_MUL_174), DUP(op_MUL_174)), SN(32, 1));
	RzILOpPure *op_RSHIFT_181 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_184 = LOGAND(op_RSHIFT_181, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_190 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_192 = LOGAND(op_RSHIFT_190, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_198 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_192), DUP(op_AND_192))), CAST(32, MSB(DUP(op_AND_192)), DUP(op_AND_192))), SN(32, 16));
	RzILOpPure *op_AND_201 = LOGAND(op_RSHIFT_198, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_204 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_184), DUP(op_AND_184))), CAST(16, MSB(DUP(op_AND_184)), DUP(op_AND_184))), CAST(32, MSB(CAST(16, MSB(op_AND_201), DUP(op_AND_201))), CAST(16, MSB(DUP(op_AND_201)), DUP(op_AND_201))));
	RzILOpPure *op_LSHIFT_207 = SHIFTL0(CAST(64, MSB(op_MUL_204), DUP(op_MUL_204)), SN(32, 1));
	RzILOpPure *op_ADD_208 = ADD(op_LSHIFT_177, op_LSHIFT_207);
	RzILOpPure *op_ADD_211 = ADD(op_ADD_208, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *cond_301 = ITE(DUP(op_EQ_147), op_ADD_211, VARL("h_tmp429"));
	RzILOpPure *op_RSHIFT_305 = SHIFTRA(cond_301, SN(32, 16));
	RzILOpPure *op_AND_308 = LOGAND(op_RSHIFT_305, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_AND_312 = LOGAND(CAST(32, MSB(CAST(16, MSB(op_AND_308), DUP(op_AND_308))), CAST(16, MSB(DUP(op_AND_308)), DUP(op_AND_308))), SN(32, 0xffff));
	RzILOpPure *op_LSHIFT_317 = SHIFTL0(CAST(64, IL_FALSE, op_AND_312), SN(32, 16));
	RzILOpPure *op_OR_319 = LOGOR(CAST(64, IL_FALSE, op_AND_8), op_LSHIFT_317);
	RzILOpEffect *op_ASSIGN_321 = WRITE_REG(bundle, Rd_op, CAST(32, IL_FALSE, op_OR_319));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_322 = SEQN(2, seq_300, op_ASSIGN_321);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_535 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_338 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_341 = LOGAND(op_RSHIFT_338, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_347 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_349 = LOGAND(op_RSHIFT_347, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_355 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_349), DUP(op_AND_349))), CAST(32, MSB(DUP(op_AND_349)), DUP(op_AND_349))), SN(32, 0));
	RzILOpPure *op_AND_358 = LOGAND(op_RSHIFT_355, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_361 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_341), DUP(op_AND_341))), CAST(16, MSB(DUP(op_AND_341)), DUP(op_AND_341))), CAST(32, MSB(CAST(16, MSB(op_AND_358), DUP(op_AND_358))), CAST(16, MSB(DUP(op_AND_358)), DUP(op_AND_358))));
	RzILOpPure *op_LSHIFT_364 = SHIFTL0(CAST(64, MSB(op_MUL_361), DUP(op_MUL_361)), SN(32, 1));
	RzILOpPure *op_RSHIFT_368 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_371 = LOGAND(op_RSHIFT_368, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_377 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_379 = LOGAND(op_RSHIFT_377, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_385 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_379), DUP(op_AND_379))), CAST(32, MSB(DUP(op_AND_379)), DUP(op_AND_379))), SN(32, 16));
	RzILOpPure *op_AND_388 = LOGAND(op_RSHIFT_385, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_391 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_371), DUP(op_AND_371))), CAST(16, MSB(DUP(op_AND_371)), DUP(op_AND_371))), CAST(32, MSB(CAST(16, MSB(op_AND_388), DUP(op_AND_388))), CAST(16, MSB(DUP(op_AND_388)), DUP(op_AND_388))));
	RzILOpPure *op_LSHIFT_394 = SHIFTL0(CAST(64, MSB(op_MUL_391), DUP(op_MUL_391)), SN(32, 1));
	RzILOpPure *op_ADD_395 = ADD(op_LSHIFT_364, op_LSHIFT_394);
	RzILOpPure *op_ADD_398 = ADD(op_ADD_395, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_407 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_410 = LOGAND(op_RSHIFT_407, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_416 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_418 = LOGAND(op_RSHIFT_416, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_424 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_418), DUP(op_AND_418))), CAST(32, MSB(DUP(op_AND_418)), DUP(op_AND_418))), SN(32, 0));
	RzILOpPure *op_AND_427 = LOGAND(op_RSHIFT_424, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_430 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_410), DUP(op_AND_410))), CAST(16, MSB(DUP(op_AND_410)), DUP(op_AND_410))), CAST(32, MSB(CAST(16, MSB(op_AND_427), DUP(op_AND_427))), CAST(16, MSB(DUP(op_AND_427)), DUP(op_AND_427))));
	RzILOpPure *op_LSHIFT_433 = SHIFTL0(CAST(64, MSB(op_MUL_430), DUP(op_MUL_430)), SN(32, 1));
	RzILOpPure *op_RSHIFT_437 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_440 = LOGAND(op_RSHIFT_437, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_446 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_448 = LOGAND(op_RSHIFT_446, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_454 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_448), DUP(op_AND_448))), CAST(32, MSB(DUP(op_AND_448)), DUP(op_AND_448))), SN(32, 16));
	RzILOpPure *op_AND_457 = LOGAND(op_RSHIFT_454, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_460 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_440), DUP(op_AND_440))), CAST(16, MSB(DUP(op_AND_440)), DUP(op_AND_440))), CAST(32, MSB(CAST(16, MSB(op_AND_457), DUP(op_AND_457))), CAST(16, MSB(DUP(op_AND_457)), DUP(op_AND_457))));
	RzILOpPure *op_LSHIFT_463 = SHIFTL0(CAST(64, MSB(op_MUL_460), DUP(op_MUL_460)), SN(32, 1));
	RzILOpPure *op_ADD_464 = ADD(op_LSHIFT_433, op_LSHIFT_463);
	RzILOpPure *op_ADD_467 = ADD(op_ADD_464, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_EQ_468 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_398), SN(32, 0), SN(32, 0x20)), op_ADD_467);
	RzILOpPure *op_RSHIFT_539 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_542 = LOGAND(op_RSHIFT_539, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_548 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_550 = LOGAND(op_RSHIFT_548, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_556 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_550), DUP(op_AND_550))), CAST(32, MSB(DUP(op_AND_550)), DUP(op_AND_550))), SN(32, 0));
	RzILOpPure *op_AND_559 = LOGAND(op_RSHIFT_556, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_562 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_542), DUP(op_AND_542))), CAST(16, MSB(DUP(op_AND_542)), DUP(op_AND_542))), CAST(32, MSB(CAST(16, MSB(op_AND_559), DUP(op_AND_559))), CAST(16, MSB(DUP(op_AND_559)), DUP(op_AND_559))));
	RzILOpPure *op_LSHIFT_565 = SHIFTL0(CAST(64, MSB(op_MUL_562), DUP(op_MUL_562)), SN(32, 1));
	RzILOpPure *op_RSHIFT_569 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_572 = LOGAND(op_RSHIFT_569, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_578 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_580 = LOGAND(op_RSHIFT_578, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_586 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_580), DUP(op_AND_580))), CAST(32, MSB(DUP(op_AND_580)), DUP(op_AND_580))), SN(32, 16));
	RzILOpPure *op_AND_589 = LOGAND(op_RSHIFT_586, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_592 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_572), DUP(op_AND_572))), CAST(16, MSB(DUP(op_AND_572)), DUP(op_AND_572))), CAST(32, MSB(CAST(16, MSB(op_AND_589), DUP(op_AND_589))), CAST(16, MSB(DUP(op_AND_589)), DUP(op_AND_589))));
	RzILOpPure *op_LSHIFT_595 = SHIFTL0(CAST(64, MSB(op_MUL_592), DUP(op_MUL_592)), SN(32, 1));
	RzILOpPure *op_ADD_596 = ADD(op_LSHIFT_565, op_LSHIFT_595);
	RzILOpPure *op_ADD_599 = ADD(op_ADD_596, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_LT_602 = SLT(op_ADD_599, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_607 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_608 = NEG(op_LSHIFT_607);
	RzILOpPure *op_LSHIFT_613 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_616 = SUB(op_LSHIFT_613, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_617 = ITE(op_LT_602, op_NEG_608, op_SUB_616);
	RzILOpEffect *gcc_expr_618 = BRANCH(op_EQ_468, EMPTY(), set_usr_field_call_535);

	// h_tmp430 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_620 = SETL("h_tmp430", cond_617);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_621 = SEQN(2, gcc_expr_618, op_ASSIGN_hybrid_tmp_620);

	// Rd = ((st32) (((ut64) (((st64) Rd) & (~(0xffff << 0x0)))) | (((ut64) (((st32) ((st16) ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000)) ? (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x20) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000) : h_tmp430) >> 0x10) & ((st64) 0xffff)))) & 0xffff)) << 0x0)));
	RzILOpPure *op_LSHIFT_328 = SHIFTL0(SN(64, 0xffff), SN(32, 0));
	RzILOpPure *op_NOT_329 = LOGNOT(op_LSHIFT_328);
	RzILOpPure *op_AND_331 = LOGAND(CAST(64, MSB(READ_REG(pkt, Rd_op, true)), READ_REG(pkt, Rd_op, true)), op_NOT_329);
	RzILOpPure *op_RSHIFT_472 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_475 = LOGAND(op_RSHIFT_472, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_481 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_483 = LOGAND(op_RSHIFT_481, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_489 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_483), DUP(op_AND_483))), CAST(32, MSB(DUP(op_AND_483)), DUP(op_AND_483))), SN(32, 0));
	RzILOpPure *op_AND_492 = LOGAND(op_RSHIFT_489, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_495 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_475), DUP(op_AND_475))), CAST(16, MSB(DUP(op_AND_475)), DUP(op_AND_475))), CAST(32, MSB(CAST(16, MSB(op_AND_492), DUP(op_AND_492))), CAST(16, MSB(DUP(op_AND_492)), DUP(op_AND_492))));
	RzILOpPure *op_LSHIFT_498 = SHIFTL0(CAST(64, MSB(op_MUL_495), DUP(op_MUL_495)), SN(32, 1));
	RzILOpPure *op_RSHIFT_502 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_505 = LOGAND(op_RSHIFT_502, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_511 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_513 = LOGAND(op_RSHIFT_511, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_519 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_513), DUP(op_AND_513))), CAST(32, MSB(DUP(op_AND_513)), DUP(op_AND_513))), SN(32, 16));
	RzILOpPure *op_AND_522 = LOGAND(op_RSHIFT_519, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_525 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_505), DUP(op_AND_505))), CAST(16, MSB(DUP(op_AND_505)), DUP(op_AND_505))), CAST(32, MSB(CAST(16, MSB(op_AND_522), DUP(op_AND_522))), CAST(16, MSB(DUP(op_AND_522)), DUP(op_AND_522))));
	RzILOpPure *op_LSHIFT_528 = SHIFTL0(CAST(64, MSB(op_MUL_525), DUP(op_MUL_525)), SN(32, 1));
	RzILOpPure *op_ADD_529 = ADD(op_LSHIFT_498, op_LSHIFT_528);
	RzILOpPure *op_ADD_532 = ADD(op_ADD_529, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *cond_622 = ITE(DUP(op_EQ_468), op_ADD_532, VARL("h_tmp430"));
	RzILOpPure *op_RSHIFT_626 = SHIFTRA(cond_622, SN(32, 16));
	RzILOpPure *op_AND_629 = LOGAND(op_RSHIFT_626, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_AND_633 = LOGAND(CAST(32, MSB(CAST(16, MSB(op_AND_629), DUP(op_AND_629))), CAST(16, MSB(DUP(op_AND_629)), DUP(op_AND_629))), SN(32, 0xffff));
	RzILOpPure *op_LSHIFT_638 = SHIFTL0(CAST(64, IL_FALSE, op_AND_633), SN(32, 0));
	RzILOpPure *op_OR_640 = LOGOR(CAST(64, IL_FALSE, op_AND_331), op_LSHIFT_638);
	RzILOpEffect *op_ASSIGN_642 = WRITE_REG(bundle, Rd_op, CAST(32, IL_FALSE, op_OR_640));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_643 = SEQN(2, seq_621, op_ASSIGN_642);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_322, seq_643);
	return instruction_sequence;
}

// Rd = vrcmpys(Rss,Rtt):<<1:rnd:sat:raw:lo
RzILOpEffect *hex_il_op_m2_vrcmpys_s1rp_l(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_214 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_16 = SHIFTRA(Rss, SN(32, 16));
	RzILOpPure *op_AND_19 = LOGAND(op_RSHIFT_16, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_26 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_28 = LOGAND(op_RSHIFT_26, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_34 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_28), DUP(op_AND_28))), CAST(32, MSB(DUP(op_AND_28)), DUP(op_AND_28))), SN(32, 0));
	RzILOpPure *op_AND_37 = LOGAND(op_RSHIFT_34, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_40 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_19), DUP(op_AND_19))), CAST(16, MSB(DUP(op_AND_19)), DUP(op_AND_19))), CAST(32, MSB(CAST(16, MSB(op_AND_37), DUP(op_AND_37))), CAST(16, MSB(DUP(op_AND_37)), DUP(op_AND_37))));
	RzILOpPure *op_LSHIFT_43 = SHIFTL0(CAST(64, MSB(op_MUL_40), DUP(op_MUL_40)), SN(32, 1));
	RzILOpPure *op_RSHIFT_47 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_50 = LOGAND(op_RSHIFT_47, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_56 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_58 = LOGAND(op_RSHIFT_56, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_64 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_58), DUP(op_AND_58))), CAST(32, MSB(DUP(op_AND_58)), DUP(op_AND_58))), SN(32, 16));
	RzILOpPure *op_AND_67 = LOGAND(op_RSHIFT_64, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_70 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_50), DUP(op_AND_50))), CAST(16, MSB(DUP(op_AND_50)), DUP(op_AND_50))), CAST(32, MSB(CAST(16, MSB(op_AND_67), DUP(op_AND_67))), CAST(16, MSB(DUP(op_AND_67)), DUP(op_AND_67))));
	RzILOpPure *op_LSHIFT_73 = SHIFTL0(CAST(64, MSB(op_MUL_70), DUP(op_MUL_70)), SN(32, 1));
	RzILOpPure *op_ADD_74 = ADD(op_LSHIFT_43, op_LSHIFT_73);
	RzILOpPure *op_ADD_77 = ADD(op_ADD_74, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_86 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_89 = LOGAND(op_RSHIFT_86, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_95 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_97 = LOGAND(op_RSHIFT_95, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_103 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_97), DUP(op_AND_97))), CAST(32, MSB(DUP(op_AND_97)), DUP(op_AND_97))), SN(32, 0));
	RzILOpPure *op_AND_106 = LOGAND(op_RSHIFT_103, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_109 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_89), DUP(op_AND_89))), CAST(16, MSB(DUP(op_AND_89)), DUP(op_AND_89))), CAST(32, MSB(CAST(16, MSB(op_AND_106), DUP(op_AND_106))), CAST(16, MSB(DUP(op_AND_106)), DUP(op_AND_106))));
	RzILOpPure *op_LSHIFT_112 = SHIFTL0(CAST(64, MSB(op_MUL_109), DUP(op_MUL_109)), SN(32, 1));
	RzILOpPure *op_RSHIFT_116 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_119 = LOGAND(op_RSHIFT_116, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_125 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_127 = LOGAND(op_RSHIFT_125, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_133 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_127), DUP(op_AND_127))), CAST(32, MSB(DUP(op_AND_127)), DUP(op_AND_127))), SN(32, 16));
	RzILOpPure *op_AND_136 = LOGAND(op_RSHIFT_133, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_139 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_119), DUP(op_AND_119))), CAST(16, MSB(DUP(op_AND_119)), DUP(op_AND_119))), CAST(32, MSB(CAST(16, MSB(op_AND_136), DUP(op_AND_136))), CAST(16, MSB(DUP(op_AND_136)), DUP(op_AND_136))));
	RzILOpPure *op_LSHIFT_142 = SHIFTL0(CAST(64, MSB(op_MUL_139), DUP(op_MUL_139)), SN(32, 1));
	RzILOpPure *op_ADD_143 = ADD(op_LSHIFT_112, op_LSHIFT_142);
	RzILOpPure *op_ADD_146 = ADD(op_ADD_143, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_EQ_147 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_77), SN(32, 0), SN(32, 0x20)), op_ADD_146);
	RzILOpPure *op_RSHIFT_218 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_221 = LOGAND(op_RSHIFT_218, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_227 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_229 = LOGAND(op_RSHIFT_227, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_235 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_229), DUP(op_AND_229))), CAST(32, MSB(DUP(op_AND_229)), DUP(op_AND_229))), SN(32, 0));
	RzILOpPure *op_AND_238 = LOGAND(op_RSHIFT_235, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_241 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_221), DUP(op_AND_221))), CAST(16, MSB(DUP(op_AND_221)), DUP(op_AND_221))), CAST(32, MSB(CAST(16, MSB(op_AND_238), DUP(op_AND_238))), CAST(16, MSB(DUP(op_AND_238)), DUP(op_AND_238))));
	RzILOpPure *op_LSHIFT_244 = SHIFTL0(CAST(64, MSB(op_MUL_241), DUP(op_MUL_241)), SN(32, 1));
	RzILOpPure *op_RSHIFT_248 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_251 = LOGAND(op_RSHIFT_248, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_257 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_259 = LOGAND(op_RSHIFT_257, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_265 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_259), DUP(op_AND_259))), CAST(32, MSB(DUP(op_AND_259)), DUP(op_AND_259))), SN(32, 16));
	RzILOpPure *op_AND_268 = LOGAND(op_RSHIFT_265, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_271 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_251), DUP(op_AND_251))), CAST(16, MSB(DUP(op_AND_251)), DUP(op_AND_251))), CAST(32, MSB(CAST(16, MSB(op_AND_268), DUP(op_AND_268))), CAST(16, MSB(DUP(op_AND_268)), DUP(op_AND_268))));
	RzILOpPure *op_LSHIFT_274 = SHIFTL0(CAST(64, MSB(op_MUL_271), DUP(op_MUL_271)), SN(32, 1));
	RzILOpPure *op_ADD_275 = ADD(op_LSHIFT_244, op_LSHIFT_274);
	RzILOpPure *op_ADD_278 = ADD(op_ADD_275, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_LT_281 = SLT(op_ADD_278, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_286 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_287 = NEG(op_LSHIFT_286);
	RzILOpPure *op_LSHIFT_292 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_295 = SUB(op_LSHIFT_292, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_296 = ITE(op_LT_281, op_NEG_287, op_SUB_295);
	RzILOpEffect *gcc_expr_297 = BRANCH(op_EQ_147, EMPTY(), set_usr_field_call_214);

	// h_tmp431 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_299 = SETL("h_tmp431", cond_296);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_300 = SEQN(2, gcc_expr_297, op_ASSIGN_hybrid_tmp_299);

	// Rd = ((st32) (((ut64) (((st64) Rd) & (~(0xffff << 0x10)))) | (((ut64) (((st32) ((st16) ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000)) ? (((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000) : h_tmp431) >> 0x10) & ((st64) 0xffff)))) & 0xffff)) << 0x10)));
	RzILOpPure *op_LSHIFT_5 = SHIFTL0(SN(64, 0xffff), SN(32, 16));
	RzILOpPure *op_NOT_6 = LOGNOT(op_LSHIFT_5);
	RzILOpPure *op_AND_8 = LOGAND(CAST(64, MSB(READ_REG(pkt, Rd_op, true)), READ_REG(pkt, Rd_op, true)), op_NOT_6);
	RzILOpPure *op_RSHIFT_151 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_154 = LOGAND(op_RSHIFT_151, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_160 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_162 = LOGAND(op_RSHIFT_160, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_168 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_162), DUP(op_AND_162))), CAST(32, MSB(DUP(op_AND_162)), DUP(op_AND_162))), SN(32, 0));
	RzILOpPure *op_AND_171 = LOGAND(op_RSHIFT_168, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_174 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_154), DUP(op_AND_154))), CAST(16, MSB(DUP(op_AND_154)), DUP(op_AND_154))), CAST(32, MSB(CAST(16, MSB(op_AND_171), DUP(op_AND_171))), CAST(16, MSB(DUP(op_AND_171)), DUP(op_AND_171))));
	RzILOpPure *op_LSHIFT_177 = SHIFTL0(CAST(64, MSB(op_MUL_174), DUP(op_MUL_174)), SN(32, 1));
	RzILOpPure *op_RSHIFT_181 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_184 = LOGAND(op_RSHIFT_181, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_190 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_192 = LOGAND(op_RSHIFT_190, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_198 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_192), DUP(op_AND_192))), CAST(32, MSB(DUP(op_AND_192)), DUP(op_AND_192))), SN(32, 16));
	RzILOpPure *op_AND_201 = LOGAND(op_RSHIFT_198, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_204 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_184), DUP(op_AND_184))), CAST(16, MSB(DUP(op_AND_184)), DUP(op_AND_184))), CAST(32, MSB(CAST(16, MSB(op_AND_201), DUP(op_AND_201))), CAST(16, MSB(DUP(op_AND_201)), DUP(op_AND_201))));
	RzILOpPure *op_LSHIFT_207 = SHIFTL0(CAST(64, MSB(op_MUL_204), DUP(op_MUL_204)), SN(32, 1));
	RzILOpPure *op_ADD_208 = ADD(op_LSHIFT_177, op_LSHIFT_207);
	RzILOpPure *op_ADD_211 = ADD(op_ADD_208, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *cond_301 = ITE(DUP(op_EQ_147), op_ADD_211, VARL("h_tmp431"));
	RzILOpPure *op_RSHIFT_305 = SHIFTRA(cond_301, SN(32, 16));
	RzILOpPure *op_AND_308 = LOGAND(op_RSHIFT_305, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_AND_312 = LOGAND(CAST(32, MSB(CAST(16, MSB(op_AND_308), DUP(op_AND_308))), CAST(16, MSB(DUP(op_AND_308)), DUP(op_AND_308))), SN(32, 0xffff));
	RzILOpPure *op_LSHIFT_317 = SHIFTL0(CAST(64, IL_FALSE, op_AND_312), SN(32, 16));
	RzILOpPure *op_OR_319 = LOGOR(CAST(64, IL_FALSE, op_AND_8), op_LSHIFT_317);
	RzILOpEffect *op_ASSIGN_321 = WRITE_REG(bundle, Rd_op, CAST(32, IL_FALSE, op_OR_319));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_322 = SEQN(2, seq_300, op_ASSIGN_321);

	// set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1));
	RzILOpEffect *set_usr_field_call_535 = hex_set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, CAST(32, IL_FALSE, SN(32, 1)));

	// HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpPure *op_RSHIFT_338 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_341 = LOGAND(op_RSHIFT_338, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_347 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_349 = LOGAND(op_RSHIFT_347, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_355 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_349), DUP(op_AND_349))), CAST(32, MSB(DUP(op_AND_349)), DUP(op_AND_349))), SN(32, 0));
	RzILOpPure *op_AND_358 = LOGAND(op_RSHIFT_355, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_361 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_341), DUP(op_AND_341))), CAST(16, MSB(DUP(op_AND_341)), DUP(op_AND_341))), CAST(32, MSB(CAST(16, MSB(op_AND_358), DUP(op_AND_358))), CAST(16, MSB(DUP(op_AND_358)), DUP(op_AND_358))));
	RzILOpPure *op_LSHIFT_364 = SHIFTL0(CAST(64, MSB(op_MUL_361), DUP(op_MUL_361)), SN(32, 1));
	RzILOpPure *op_RSHIFT_368 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_371 = LOGAND(op_RSHIFT_368, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_377 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_379 = LOGAND(op_RSHIFT_377, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_385 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_379), DUP(op_AND_379))), CAST(32, MSB(DUP(op_AND_379)), DUP(op_AND_379))), SN(32, 16));
	RzILOpPure *op_AND_388 = LOGAND(op_RSHIFT_385, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_391 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_371), DUP(op_AND_371))), CAST(16, MSB(DUP(op_AND_371)), DUP(op_AND_371))), CAST(32, MSB(CAST(16, MSB(op_AND_388), DUP(op_AND_388))), CAST(16, MSB(DUP(op_AND_388)), DUP(op_AND_388))));
	RzILOpPure *op_LSHIFT_394 = SHIFTL0(CAST(64, MSB(op_MUL_391), DUP(op_MUL_391)), SN(32, 1));
	RzILOpPure *op_ADD_395 = ADD(op_LSHIFT_364, op_LSHIFT_394);
	RzILOpPure *op_ADD_398 = ADD(op_ADD_395, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_RSHIFT_407 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_410 = LOGAND(op_RSHIFT_407, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_416 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_418 = LOGAND(op_RSHIFT_416, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_424 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_418), DUP(op_AND_418))), CAST(32, MSB(DUP(op_AND_418)), DUP(op_AND_418))), SN(32, 0));
	RzILOpPure *op_AND_427 = LOGAND(op_RSHIFT_424, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_430 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_410), DUP(op_AND_410))), CAST(16, MSB(DUP(op_AND_410)), DUP(op_AND_410))), CAST(32, MSB(CAST(16, MSB(op_AND_427), DUP(op_AND_427))), CAST(16, MSB(DUP(op_AND_427)), DUP(op_AND_427))));
	RzILOpPure *op_LSHIFT_433 = SHIFTL0(CAST(64, MSB(op_MUL_430), DUP(op_MUL_430)), SN(32, 1));
	RzILOpPure *op_RSHIFT_437 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_440 = LOGAND(op_RSHIFT_437, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_446 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_448 = LOGAND(op_RSHIFT_446, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_454 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_448), DUP(op_AND_448))), CAST(32, MSB(DUP(op_AND_448)), DUP(op_AND_448))), SN(32, 16));
	RzILOpPure *op_AND_457 = LOGAND(op_RSHIFT_454, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_460 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_440), DUP(op_AND_440))), CAST(16, MSB(DUP(op_AND_440)), DUP(op_AND_440))), CAST(32, MSB(CAST(16, MSB(op_AND_457), DUP(op_AND_457))), CAST(16, MSB(DUP(op_AND_457)), DUP(op_AND_457))));
	RzILOpPure *op_LSHIFT_463 = SHIFTL0(CAST(64, MSB(op_MUL_460), DUP(op_MUL_460)), SN(32, 1));
	RzILOpPure *op_ADD_464 = ADD(op_LSHIFT_433, op_LSHIFT_463);
	RzILOpPure *op_ADD_467 = ADD(op_ADD_464, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_EQ_468 = EQ(SEXTRACT64(CAST(64, IL_FALSE, op_ADD_398), SN(32, 0), SN(32, 0x20)), op_ADD_467);
	RzILOpPure *op_RSHIFT_539 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_542 = LOGAND(op_RSHIFT_539, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_548 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_550 = LOGAND(op_RSHIFT_548, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_556 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_550), DUP(op_AND_550))), CAST(32, MSB(DUP(op_AND_550)), DUP(op_AND_550))), SN(32, 0));
	RzILOpPure *op_AND_559 = LOGAND(op_RSHIFT_556, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_562 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_542), DUP(op_AND_542))), CAST(16, MSB(DUP(op_AND_542)), DUP(op_AND_542))), CAST(32, MSB(CAST(16, MSB(op_AND_559), DUP(op_AND_559))), CAST(16, MSB(DUP(op_AND_559)), DUP(op_AND_559))));
	RzILOpPure *op_LSHIFT_565 = SHIFTL0(CAST(64, MSB(op_MUL_562), DUP(op_MUL_562)), SN(32, 1));
	RzILOpPure *op_RSHIFT_569 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_572 = LOGAND(op_RSHIFT_569, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_578 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_580 = LOGAND(op_RSHIFT_578, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_586 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_580), DUP(op_AND_580))), CAST(32, MSB(DUP(op_AND_580)), DUP(op_AND_580))), SN(32, 16));
	RzILOpPure *op_AND_589 = LOGAND(op_RSHIFT_586, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_592 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_572), DUP(op_AND_572))), CAST(16, MSB(DUP(op_AND_572)), DUP(op_AND_572))), CAST(32, MSB(CAST(16, MSB(op_AND_589), DUP(op_AND_589))), CAST(16, MSB(DUP(op_AND_589)), DUP(op_AND_589))));
	RzILOpPure *op_LSHIFT_595 = SHIFTL0(CAST(64, MSB(op_MUL_592), DUP(op_MUL_592)), SN(32, 1));
	RzILOpPure *op_ADD_596 = ADD(op_LSHIFT_565, op_LSHIFT_595);
	RzILOpPure *op_ADD_599 = ADD(op_ADD_596, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *op_LT_602 = SLT(op_ADD_599, CAST(64, MSB(SN(32, 0)), SN(32, 0)));
	RzILOpPure *op_LSHIFT_607 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_NEG_608 = NEG(op_LSHIFT_607);
	RzILOpPure *op_LSHIFT_613 = SHIFTL0(SN(64, 1), SN(32, 31));
	RzILOpPure *op_SUB_616 = SUB(op_LSHIFT_613, CAST(64, MSB(SN(32, 1)), SN(32, 1)));
	RzILOpPure *cond_617 = ITE(op_LT_602, op_NEG_608, op_SUB_616);
	RzILOpEffect *gcc_expr_618 = BRANCH(op_EQ_468, EMPTY(), set_usr_field_call_535);

	// h_tmp432 = HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000))) {{}} else {set_usr_field(bundle, HEX_REG_FIELD_USR_OVF, ((ut32) 0x1))}, (((((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000) < ((st64) 0x0)) ? (-(0x1 << 0x1f)) : (0x1 << 0x1f) - ((st64) 0x1)));
	RzILOpEffect *op_ASSIGN_hybrid_tmp_620 = SETL("h_tmp432", cond_617);

	// seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) ((st16 ...;
	RzILOpEffect *seq_621 = SEQN(2, gcc_expr_618, op_ASSIGN_hybrid_tmp_620);

	// Rd = ((st32) (((ut64) (((st64) Rd) & (~(0xffff << 0x0)))) | (((ut64) (((st32) ((st16) ((((sextract64(((ut64) (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000)), 0x0, 0x20) == (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000)) ? (((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x0) & ((st64) 0xffff))))) << 0x1) + (((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((((st64) ((st32) ((Rtt >> 0x0) & 0xffffffff))) >> 0x10) & ((st64) 0xffff))))) << 0x1) + ((st64) 0x8000) : h_tmp432) >> 0x10) & ((st64) 0xffff)))) & 0xffff)) << 0x0)));
	RzILOpPure *op_LSHIFT_328 = SHIFTL0(SN(64, 0xffff), SN(32, 0));
	RzILOpPure *op_NOT_329 = LOGNOT(op_LSHIFT_328);
	RzILOpPure *op_AND_331 = LOGAND(CAST(64, MSB(READ_REG(pkt, Rd_op, true)), READ_REG(pkt, Rd_op, true)), op_NOT_329);
	RzILOpPure *op_RSHIFT_472 = SHIFTRA(DUP(Rss), SN(32, 0));
	RzILOpPure *op_AND_475 = LOGAND(op_RSHIFT_472, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_481 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_483 = LOGAND(op_RSHIFT_481, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_489 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_483), DUP(op_AND_483))), CAST(32, MSB(DUP(op_AND_483)), DUP(op_AND_483))), SN(32, 0));
	RzILOpPure *op_AND_492 = LOGAND(op_RSHIFT_489, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_495 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_475), DUP(op_AND_475))), CAST(16, MSB(DUP(op_AND_475)), DUP(op_AND_475))), CAST(32, MSB(CAST(16, MSB(op_AND_492), DUP(op_AND_492))), CAST(16, MSB(DUP(op_AND_492)), DUP(op_AND_492))));
	RzILOpPure *op_LSHIFT_498 = SHIFTL0(CAST(64, MSB(op_MUL_495), DUP(op_MUL_495)), SN(32, 1));
	RzILOpPure *op_RSHIFT_502 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_505 = LOGAND(op_RSHIFT_502, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_511 = SHIFTRA(DUP(Rtt), SN(32, 0));
	RzILOpPure *op_AND_513 = LOGAND(op_RSHIFT_511, SN(64, 0xffffffff));
	RzILOpPure *op_RSHIFT_519 = SHIFTRA(CAST(64, MSB(CAST(32, MSB(op_AND_513), DUP(op_AND_513))), CAST(32, MSB(DUP(op_AND_513)), DUP(op_AND_513))), SN(32, 16));
	RzILOpPure *op_AND_522 = LOGAND(op_RSHIFT_519, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_525 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_505), DUP(op_AND_505))), CAST(16, MSB(DUP(op_AND_505)), DUP(op_AND_505))), CAST(32, MSB(CAST(16, MSB(op_AND_522), DUP(op_AND_522))), CAST(16, MSB(DUP(op_AND_522)), DUP(op_AND_522))));
	RzILOpPure *op_LSHIFT_528 = SHIFTL0(CAST(64, MSB(op_MUL_525), DUP(op_MUL_525)), SN(32, 1));
	RzILOpPure *op_ADD_529 = ADD(op_LSHIFT_498, op_LSHIFT_528);
	RzILOpPure *op_ADD_532 = ADD(op_ADD_529, CAST(64, MSB(SN(32, 0x8000)), SN(32, 0x8000)));
	RzILOpPure *cond_622 = ITE(DUP(op_EQ_468), op_ADD_532, VARL("h_tmp432"));
	RzILOpPure *op_RSHIFT_626 = SHIFTRA(cond_622, SN(32, 16));
	RzILOpPure *op_AND_629 = LOGAND(op_RSHIFT_626, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_AND_633 = LOGAND(CAST(32, MSB(CAST(16, MSB(op_AND_629), DUP(op_AND_629))), CAST(16, MSB(DUP(op_AND_629)), DUP(op_AND_629))), SN(32, 0xffff));
	RzILOpPure *op_LSHIFT_638 = SHIFTL0(CAST(64, IL_FALSE, op_AND_633), SN(32, 0));
	RzILOpPure *op_OR_640 = LOGOR(CAST(64, IL_FALSE, op_AND_331), op_LSHIFT_638);
	RzILOpEffect *op_ASSIGN_642 = WRITE_REG(bundle, Rd_op, CAST(32, IL_FALSE, op_OR_640));

	// seq(seq(HYB(gcc_expr_if ((sextract64(((ut64) (((st64) ((st32) (( ...;
	RzILOpEffect *seq_643 = SEQN(2, seq_621, op_ASSIGN_642);

	RzILOpEffect *instruction_sequence = SEQN(2, seq_322, seq_643);
	return instruction_sequence;
}

// Rxx += vrmpyh(Rss,Rtt)
RzILOpEffect *hex_il_op_m2_vrmac_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rxx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// Rxx = Rxx + ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rss, SN(32, 0));
	RzILOpPure *op_AND_8 = LOGAND(op_RSHIFT_5, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_18 = LOGAND(op_RSHIFT_15, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_21 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_8), DUP(op_AND_8))), CAST(16, MSB(DUP(op_AND_8)), DUP(op_AND_8))), CAST(32, MSB(CAST(16, MSB(op_AND_18), DUP(op_AND_18))), CAST(16, MSB(DUP(op_AND_18)), DUP(op_AND_18))));
	RzILOpPure *op_ADD_23 = ADD(READ_REG(pkt, Rxx_op, false), CAST(64, MSB(op_MUL_21), DUP(op_MUL_21)));
	RzILOpPure *op_RSHIFT_27 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_30 = LOGAND(op_RSHIFT_27, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_36 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_39 = LOGAND(op_RSHIFT_36, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_42 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_30), DUP(op_AND_30))), CAST(16, MSB(DUP(op_AND_30)), DUP(op_AND_30))), CAST(32, MSB(CAST(16, MSB(op_AND_39), DUP(op_AND_39))), CAST(16, MSB(DUP(op_AND_39)), DUP(op_AND_39))));
	RzILOpPure *op_ADD_44 = ADD(op_ADD_23, CAST(64, MSB(op_MUL_42), DUP(op_MUL_42)));
	RzILOpPure *op_RSHIFT_48 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_51 = LOGAND(op_RSHIFT_48, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_57 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_60 = LOGAND(op_RSHIFT_57, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_63 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_51), DUP(op_AND_51))), CAST(16, MSB(DUP(op_AND_51)), DUP(op_AND_51))), CAST(32, MSB(CAST(16, MSB(op_AND_60), DUP(op_AND_60))), CAST(16, MSB(DUP(op_AND_60)), DUP(op_AND_60))));
	RzILOpPure *op_ADD_65 = ADD(op_ADD_44, CAST(64, MSB(op_MUL_63), DUP(op_MUL_63)));
	RzILOpPure *op_RSHIFT_69 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_72 = LOGAND(op_RSHIFT_69, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_78 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_81 = LOGAND(op_RSHIFT_78, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_84 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_72), DUP(op_AND_72))), CAST(16, MSB(DUP(op_AND_72)), DUP(op_AND_72))), CAST(32, MSB(CAST(16, MSB(op_AND_81), DUP(op_AND_81))), CAST(16, MSB(DUP(op_AND_81)), DUP(op_AND_81))));
	RzILOpPure *op_ADD_86 = ADD(op_ADD_65, CAST(64, MSB(op_MUL_84), DUP(op_MUL_84)));
	RzILOpEffect *op_ASSIGN_87 = WRITE_REG(bundle, Rxx_op, op_ADD_86);

	RzILOpEffect *instruction_sequence = op_ASSIGN_87;
	return instruction_sequence;
}

// Rdd = vrmpyh(Rss,Rtt)
RzILOpEffect *hex_il_op_m2_vrmpy_s0(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rdd_op = ISA2REG(hi, 'd', false);
	const HexOp *Rss_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rss = READ_REG(pkt, Rss_op, false);
	const HexOp *Rtt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rtt = READ_REG(pkt, Rtt_op, false);

	// Rdd = ((st64) ((st32) ((st16) ((Rss >> 0x0) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x0) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x10) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x10) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x20) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x20) & ((st64) 0xffff))))) + ((st64) ((st32) ((st16) ((Rss >> 0x30) & ((st64) 0xffff)))) * ((st32) ((st16) ((Rtt >> 0x30) & ((st64) 0xffff)))));
	RzILOpPure *op_RSHIFT_5 = SHIFTRA(Rss, SN(32, 0));
	RzILOpPure *op_AND_8 = LOGAND(op_RSHIFT_5, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_15 = SHIFTRA(Rtt, SN(32, 0));
	RzILOpPure *op_AND_18 = LOGAND(op_RSHIFT_15, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_21 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_8), DUP(op_AND_8))), CAST(16, MSB(DUP(op_AND_8)), DUP(op_AND_8))), CAST(32, MSB(CAST(16, MSB(op_AND_18), DUP(op_AND_18))), CAST(16, MSB(DUP(op_AND_18)), DUP(op_AND_18))));
	RzILOpPure *op_RSHIFT_26 = SHIFTRA(DUP(Rss), SN(32, 16));
	RzILOpPure *op_AND_29 = LOGAND(op_RSHIFT_26, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_35 = SHIFTRA(DUP(Rtt), SN(32, 16));
	RzILOpPure *op_AND_38 = LOGAND(op_RSHIFT_35, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_41 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_29), DUP(op_AND_29))), CAST(16, MSB(DUP(op_AND_29)), DUP(op_AND_29))), CAST(32, MSB(CAST(16, MSB(op_AND_38), DUP(op_AND_38))), CAST(16, MSB(DUP(op_AND_38)), DUP(op_AND_38))));
	RzILOpPure *op_ADD_43 = ADD(CAST(64, MSB(op_MUL_21), DUP(op_MUL_21)), CAST(64, MSB(op_MUL_41), DUP(op_MUL_41)));
	RzILOpPure *op_RSHIFT_47 = SHIFTRA(DUP(Rss), SN(32, 0x20));
	RzILOpPure *op_AND_50 = LOGAND(op_RSHIFT_47, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_56 = SHIFTRA(DUP(Rtt), SN(32, 0x20));
	RzILOpPure *op_AND_59 = LOGAND(op_RSHIFT_56, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_62 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_50), DUP(op_AND_50))), CAST(16, MSB(DUP(op_AND_50)), DUP(op_AND_50))), CAST(32, MSB(CAST(16, MSB(op_AND_59), DUP(op_AND_59))), CAST(16, MSB(DUP(op_AND_59)), DUP(op_AND_59))));
	RzILOpPure *op_ADD_64 = ADD(op_ADD_43, CAST(64, MSB(op_MUL_62), DUP(op_MUL_62)));
	RzILOpPure *op_RSHIFT_68 = SHIFTRA(DUP(Rss), SN(32, 0x30));
	RzILOpPure *op_AND_71 = LOGAND(op_RSHIFT_68, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_RSHIFT_77 = SHIFTRA(DUP(Rtt), SN(32, 0x30));
	RzILOpPure *op_AND_80 = LOGAND(op_RSHIFT_77, CAST(64, MSB(SN(32, 0xffff)), SN(32, 0xffff)));
	RzILOpPure *op_MUL_83 = MUL(CAST(32, MSB(CAST(16, MSB(op_AND_71), DUP(op_AND_71))), CAST(16, MSB(DUP(op_AND_71)), DUP(op_AND_71))), CAST(32, MSB(CAST(16, MSB(op_AND_80), DUP(op_AND_80))), CAST(16, MSB(DUP(op_AND_80)), DUP(op_AND_80))));
	RzILOpPure *op_ADD_85 = ADD(op_ADD_64, CAST(64, MSB(op_MUL_83), DUP(op_MUL_83)));
	RzILOpEffect *op_ASSIGN_86 = WRITE_REG(bundle, Rdd_op, op_ADD_85);

	RzILOpEffect *instruction_sequence = op_ASSIGN_86;
	return instruction_sequence;
}

// Rx ^= xor(Rs,Rt)
RzILOpEffect *hex_il_op_m2_xor_xacc(HexInsnPktBundle *bundle) {
	const HexInsn *hi = bundle->insn;
	HexPkt *pkt = bundle->pkt;
	// READ
	const HexOp *Rx_op = ISA2REG(hi, 'x', false);

	const HexOp *Rs_op = ISA2REG(hi, 's', false);
	RzILOpPure *Rs = READ_REG(pkt, Rs_op, false);
	const HexOp *Rt_op = ISA2REG(hi, 't', false);
	RzILOpPure *Rt = READ_REG(pkt, Rt_op, false);

	// Rx = (Rx ^ (Rs ^ Rt));
	RzILOpPure *op_XOR_3 = LOGXOR(Rs, Rt);
	RzILOpPure *op_XOR_4 = LOGXOR(READ_REG(pkt, Rx_op, false), op_XOR_3);
	RzILOpEffect *op_ASSIGN_XOR_5 = WRITE_REG(bundle, Rx_op, op_XOR_4);

	RzILOpEffect *instruction_sequence = op_ASSIGN_XOR_5;
	return instruction_sequence;
}

#include <rz_il/rz_il_opbuilder_end.h>