// SPDX-FileCopyrightText: 2024 brightprogrammer <admin@brightprogrammer.in>
// SPDX-License-Identifier: LGPL-3.0-only

#include "minunit.h"

mu_demangle_tests(gpl,
	mu_demangle_test("_ZNSt6vectorIN4dyld13RegisteredDOFESaIS1_EE5eraseEN9__gnu_cxx17__normal_iteratorIPS1_S3_EE", "std::vector<dyld::RegisteredDOF, std::allocator<dyld::RegisteredDOF> >::erase(__gnu_cxx::__normal_iterator<dyld::RegisteredDOF*, std::vector<dyld::RegisteredDOF, std::allocator<dyld::RegisteredDOF> > >)"),
	mu_demangle_test("_ZNSt12_Vector_baseIPKcSaIS1_EED2Ev", "std::_Vector_base<char const*, std::allocator<char const*> >::~_Vector_base()"),
	mu_demangle_test("_ZNSt6vectorIPKcSaIS1_EED2Ev", "std::vector<char const*, std::allocator<char const*> >::~vector()"),
	mu_demangle_test("_ZNSt12_Vector_baseIN4dyld13RegisteredDOFESaIS1_EED2Ev", "std::_Vector_base<dyld::RegisteredDOF, std::allocator<dyld::RegisteredDOF> >::~_Vector_base()"),
	mu_demangle_test("_ZNSt6vectorIN4dyld13RegisteredDOFESaIS1_EED2Ev", "std::vector<dyld::RegisteredDOF, std::allocator<dyld::RegisteredDOF> >::~vector()"),
	mu_demangle_test("_ZNSt12_Vector_baseIP11ImageLoaderSaIS1_EED2Ev", "std::_Vector_base<ImageLoader*, std::allocator<ImageLoader*> >::~_Vector_base()"),
	mu_demangle_test("_ZNSt6vectorIP11ImageLoaderSaIS1_EED2Ev", "std::vector<ImageLoader*, std::allocator<ImageLoader*> >::~vector()"),
	mu_demangle_test("_ZN9__gnu_cxx13new_allocatorIPFPKc17dyld_image_statesjPK15dyld_image_infoEE8allocateEmPKv", "__gnu_cxx::new_allocator<char const* (*)(dyld_image_states, unsigned int, dyld_image_info const*)>::allocate(unsigned long, void const*)"),
	mu_demangle_test("_ZN9__gnu_cxx13new_allocatorIPFvPK11mach_headerlEE8allocateEmPKv", "__gnu_cxx::new_allocator<void (*)(mach_header const*, long)>::allocate(unsigned long, void const*)"),
	mu_demangle_test("_ZN9__gnu_cxx13new_allocatorIPKcE8allocateEmPKv", "__gnu_cxx::new_allocator<char const*>::allocate(unsigned long, void const*)"),
	mu_demangle_test("_ZN9__gnu_cxx13new_allocatorIP11ImageLoaderE8allocateEmPKv", "__gnu_cxx::new_allocator<ImageLoader*>::allocate(unsigned long, void const*)"),
	mu_demangle_test("_ZN9__gnu_cxx13new_allocatorIN4dyld13RegisteredDOFEE8allocateEmPKv", "__gnu_cxx::new_allocator<dyld::RegisteredDOF>::allocate(unsigned long, void const*)"),
	mu_demangle_test("_ZNSt6vectorIN4dyld13RegisteredDOFESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<dyld::RegisteredDOF, std::allocator<dyld::RegisteredDOF> >::_M_insert_aux(__gnu_cxx::__normal_iterator<dyld::RegisteredDOF*, std::vector<dyld::RegisteredDOF, std::allocator<dyld::RegisteredDOF> > >, dyld::RegisteredDOF const&)"),
	mu_demangle_test("_ZNSt6vectorIN4dyld13RegisteredDOFESaIS1_EE9push_backERKS1_", "std::vector<dyld::RegisteredDOF, std::allocator<dyld::RegisteredDOF> >::push_back(dyld::RegisteredDOF const&)"),
	mu_demangle_test("_ZNSt6vectorIPFPKc17dyld_image_statesjPK15dyld_image_infoESaIS7_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS7_S9_EERKS7_", "std::vector<char const* (*)(dyld_image_states, unsigned int, dyld_image_info const*), std::allocator<char const* (*)(dyld_image_states, unsigned int, dyld_image_info const*)> >::_M_insert_aux(__gnu_cxx::__normal_iterator<char const* (**)(dyld_image_states, unsigned int, dyld_image_info const*), std::vector<char const* (*)(dyld_image_states, unsigned int, dyld_image_info const*), std::allocator<char const* (*)(dyld_image_states, unsigned int, dyld_image_info const*)> > >, char const* (* const&)(dyld_image_states, unsigned int, dyld_image_info const*))"),
	mu_demangle_test("_ZNSt6vectorIPFPKc17dyld_image_statesjPK15dyld_image_infoESaIS7_EE6insertEN9__gnu_cxx17__normal_iteratorIPS7_S9_EERKS7_", "std::vector<char const* (*)(dyld_image_states, unsigned int, dyld_image_info const*), std::allocator<char const* (*)(dyld_image_states, unsigned int, dyld_image_info const*)> >::insert(__gnu_cxx::__normal_iterator<char const* (**)(dyld_image_states, unsigned int, dyld_image_info const*), std::vector<char const* (*)(dyld_image_states, unsigned int, dyld_image_info const*), std::allocator<char const* (*)(dyld_image_states, unsigned int, dyld_image_info const*)> > >, char const* (* const&)(dyld_image_states, unsigned int, dyld_image_info const*))"),
	mu_demangle_test("_ZNSt6vectorIPFvPK11mach_headerlESaIS4_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS4_S6_EERKS4_", "std::vector<void (*)(mach_header const*, long), std::allocator<void (*)(mach_header const*, long)> >::_M_insert_aux(__gnu_cxx::__normal_iterator<void (**)(mach_header const*, long), std::vector<void (*)(mach_header const*, long), std::allocator<void (*)(mach_header const*, long)> > >, void (* const&)(mach_header const*, long))"),
	mu_demangle_test("_ZNSt6vectorIPKcSaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<char const*, std::allocator<char const*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<char const**, std::vector<char const*, std::allocator<char const*> > >, char const* const&)"),
	mu_demangle_test("_ZNSt6vectorIPKcSaIS1_EE9push_backERKS1_", "std::vector<char const*, std::allocator<char const*> >::push_back(char const* const&)"),
	mu_demangle_test("_ZNSt6vectorIN4dyld13RegisteredDOFESaIS1_EE20_M_allocate_and_copyIPS1_EES5_mT_S6_", "dyld::RegisteredDOF* std::vector<dyld::RegisteredDOF, std::allocator<dyld::RegisteredDOF> >::_M_allocate_and_copy<dyld::RegisteredDOF*>(unsigned long, dyld::RegisteredDOF*, dyld::RegisteredDOF*)"),
	mu_demangle_test("_ZNSt6vectorIN4dyld13RegisteredDOFESaIS1_EE7reserveEm", "std::vector<dyld::RegisteredDOF, std::allocator<dyld::RegisteredDOF> >::reserve(unsigned long)"),
	mu_demangle_test("_ZNSt6vectorIP11ImageLoaderSaIS1_EE20_M_allocate_and_copyIPS1_EES5_mT_S6_", "ImageLoader** std::vector<ImageLoader*, std::allocator<ImageLoader*> >::_M_allocate_and_copy<ImageLoader**>(unsigned long, ImageLoader**, ImageLoader**)"),
	mu_demangle_test("_ZNSt6vectorIP11ImageLoaderSaIS1_EE7reserveEm", "std::vector<ImageLoader*, std::allocator<ImageLoader*> >::reserve(unsigned long)"),
	mu_demangle_test("_ZNSt6vectorIP11ImageLoaderSaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<ImageLoader*, std::allocator<ImageLoader*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<ImageLoader**, std::vector<ImageLoader*, std::allocator<ImageLoader*> > >, ImageLoader* const&)"),
	mu_demangle_test("_ZNSt6vectorIP11ImageLoaderSaIS1_EE9push_backERKS1_", "std::vector<ImageLoader*, std::allocator<ImageLoader*> >::push_back(ImageLoader* const&)"),
	mu_demangle_test("_ZNSt6vectorIP11ImageLoaderSaIS1_EE5eraseEN9__gnu_cxx17__normal_iteratorIPS1_S3_EE", "std::vector<ImageLoader*, std::allocator<ImageLoader*> >::erase(__gnu_cxx::__normal_iterator<ImageLoader**, std::vector<ImageLoader*, std::allocator<ImageLoader*> > >)"),
	mu_demangle_test("_ZNSt12_Vector_baseIP19__NSObjectFileImageSaIS1_EED2Ev", "std::_Vector_base<__NSObjectFileImage*, std::allocator<__NSObjectFileImage*> >::~_Vector_base()"),
	mu_demangle_test("_ZNSt6vectorIP19__NSObjectFileImageSaIS1_EED2Ev", "std::vector<__NSObjectFileImage*, std::allocator<__NSObjectFileImage*> >::~vector()"),
	mu_demangle_test("_ZN9__gnu_cxx13new_allocatorIP19__NSObjectFileImageE8allocateEmPKv", "__gnu_cxx::new_allocator<__NSObjectFileImage*>::allocate(unsigned long, void const*)"),
	mu_demangle_test("_ZNSt6vectorIP19__NSObjectFileImageSaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<__NSObjectFileImage*, std::allocator<__NSObjectFileImage*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<__NSObjectFileImage**, std::vector<__NSObjectFileImage*, std::allocator<__NSObjectFileImage*> > >, __NSObjectFileImage* const&)"),
	mu_demangle_test("_ZNSt6vectorIP19__NSObjectFileImageSaIS1_EE9push_backERKS1_", "std::vector<__NSObjectFileImage*, std::allocator<__NSObjectFileImage*> >::push_back(__NSObjectFileImage* const&)"),
	mu_demangle_test("_ZNSt6vectorIP19__NSObjectFileImageSaIS1_EE5eraseEN9__gnu_cxx17__normal_iteratorIPS1_S3_EE", "std::vector<__NSObjectFileImage*, std::allocator<__NSObjectFileImage*> >::erase(__gnu_cxx::__normal_iterator<__NSObjectFileImage**, std::vector<__NSObjectFileImage*, std::allocator<__NSObjectFileImage*> > >)"),
	mu_demangle_test("_ZNSt6vectorI15dyld_image_infoSaIS0_EE5eraseEN9__gnu_cxx17__normal_iteratorIPS0_S2_EE", "std::vector<dyld_image_info, std::allocator<dyld_image_info> >::erase(__gnu_cxx::__normal_iterator<dyld_image_info*, std::vector<dyld_image_info, std::allocator<dyld_image_info> > >)"),
	mu_demangle_test("_ZNSt12_Vector_baseI15dyld_image_infoSaIS0_EED2Ev", "std::_Vector_base<dyld_image_info, std::allocator<dyld_image_info> >::~_Vector_base()"),
	mu_demangle_test("_ZNSt6vectorI15dyld_image_infoSaIS0_EED2Ev", "std::vector<dyld_image_info, std::allocator<dyld_image_info> >::~vector()"),
	mu_demangle_test("_ZN9__gnu_cxx13new_allocatorI15dyld_image_infoE8allocateEmPKv", "__gnu_cxx::new_allocator<dyld_image_info>::allocate(unsigned long, void const*)"),
	mu_demangle_test("_ZNSt6vectorI15dyld_image_infoSaIS0_EE20_M_allocate_and_copyIPS0_EES4_mT_S5_", "dyld_image_info* std::vector<dyld_image_info, std::allocator<dyld_image_info> >::_M_allocate_and_copy<dyld_image_info*>(unsigned long, dyld_image_info*, dyld_image_info*)"),
	mu_demangle_test("_ZNSt6vectorI15dyld_image_infoSaIS0_EE7reserveEm", "std::vector<dyld_image_info, std::allocator<dyld_image_info> >::reserve(unsigned long)"),
	mu_demangle_test("_ZNSt6vectorI15dyld_image_infoSaIS0_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS0_S2_EERKS0_", "std::vector<dyld_image_info, std::allocator<dyld_image_info> >::_M_insert_aux(__gnu_cxx::__normal_iterator<dyld_image_info*, std::vector<dyld_image_info, std::allocator<dyld_image_info> > >, dyld_image_info const&)"),
	mu_demangle_test("_ZNSt6vectorI15dyld_image_infoSaIS0_EE9push_backERKS0_", "std::vector<dyld_image_info, std::allocator<dyld_image_info> >::push_back(dyld_image_info const&)"),
	mu_demangle_test("_ZN11ImageLoader23recursiveGetDOFSectionsERKNS_11LinkContextERSt6vectorINS_7DOFInfoESaIS4_EE", "ImageLoader::recursiveGetDOFSections(ImageLoader::LinkContext const&, std::vector<ImageLoader::DOFInfo, std::allocator<ImageLoader::DOFInfo> >&)"),
	mu_demangle_test("_ZNSt12_Vector_baseIN11ImageLoader7DOFInfoESaIS1_EED2Ev", "std::_Vector_base<ImageLoader::DOFInfo, std::allocator<ImageLoader::DOFInfo> >::~_Vector_base()"),
	mu_demangle_test("_ZNSt6vectorIN11ImageLoader7DOFInfoESaIS1_EED2Ev", "std::vector<ImageLoader::DOFInfo, std::allocator<ImageLoader::DOFInfo> >::~vector()"),
	mu_demangle_test("_ZNSt12_Vector_baseIN11ImageLoader14InterposeTupleESaIS1_EED2Ev", "std::_Vector_base<ImageLoader::InterposeTuple, std::allocator<ImageLoader::InterposeTuple> >::~_Vector_base()"),
	mu_demangle_test("_ZNSt6vectorIN11ImageLoader14InterposeTupleESaIS1_EED2Ev", "std::vector<ImageLoader::InterposeTuple, std::allocator<ImageLoader::InterposeTuple> >::~vector()"),
	mu_demangle_test("_ZNSt12_Vector_baseISt4pairIP11ImageLoaderS2_ESaIS3_EED2Ev", "std::_Vector_base<std::pair<ImageLoader*, ImageLoader*>, std::allocator<std::pair<ImageLoader*, ImageLoader*> > >::~_Vector_base()"),
	mu_demangle_test("_ZNSt6vectorISt4pairIP11ImageLoaderS2_ESaIS3_EED2Ev", "std::vector<std::pair<ImageLoader*, ImageLoader*>, std::allocator<std::pair<ImageLoader*, ImageLoader*> > >::~vector()"),
	mu_demangle_test("_ZN9__gnu_cxx13new_allocatorISt13_Rb_tree_nodeIPK11ImageLoaderEE8allocateEmPKv", "__gnu_cxx::new_allocator<std::_Rb_tree_node<ImageLoader const*> >::allocate(unsigned long, void const*)"),
	mu_demangle_test("_ZN9__gnu_cxx13new_allocatorISt4pairIP11ImageLoaderS3_EE8allocateEmPKv", "__gnu_cxx::new_allocator<std::pair<ImageLoader*, ImageLoader*> >::allocate(unsigned long, void const*)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIP11ImageLoaderS2_ESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<std::pair<ImageLoader*, ImageLoader*>, std::allocator<std::pair<ImageLoader*, ImageLoader*> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<ImageLoader*, ImageLoader*>*, std::vector<std::pair<ImageLoader*, ImageLoader*>, std::allocator<std::pair<ImageLoader*, ImageLoader*> > > >, std::pair<ImageLoader*, ImageLoader*> const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIP11ImageLoaderS2_ESaIS3_EE9push_backERKS3_", "std::vector<std::pair<ImageLoader*, ImageLoader*>, std::allocator<std::pair<ImageLoader*, ImageLoader*> > >::push_back(std::pair<ImageLoader*, ImageLoader*> const&)"),
	mu_demangle_test("_ZN16ImageLoaderMachO16doGetDOFSectionsERKN11ImageLoader11LinkContextERSt6vectorINS0_7DOFInfoESaIS5_EE", "ImageLoaderMachO::doGetDOFSections(ImageLoader::LinkContext const&, std::vector<ImageLoader::DOFInfo, std::allocator<ImageLoader::DOFInfo> >&)"),
	mu_demangle_test("_ZNK16ImageLoaderMachO9getRPathsERKN11ImageLoader11LinkContextERSt6vectorIPKcSaIS6_EE", "ImageLoaderMachO::getRPaths(ImageLoader::LinkContext const&, std::vector<char const*, std::allocator<char const*> >&) const"),
	mu_demangle_test("_ZN9__gnu_cxx13new_allocatorIN11ImageLoader7DOFInfoEE8allocateEmPKv", "__gnu_cxx::new_allocator<ImageLoader::DOFInfo>::allocate(unsigned long, void const*)"),
	mu_demangle_test("_ZN9__gnu_cxx13new_allocatorIN11ImageLoader14InterposeTupleEE8allocateEmPKv", "__gnu_cxx::new_allocator<ImageLoader::InterposeTuple>::allocate(unsigned long, void const*)"),
	mu_demangle_test("_ZNSt6vectorIN11ImageLoader7DOFInfoESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<ImageLoader::DOFInfo, std::allocator<ImageLoader::DOFInfo> >::_M_insert_aux(__gnu_cxx::__normal_iterator<ImageLoader::DOFInfo*, std::vector<ImageLoader::DOFInfo, std::allocator<ImageLoader::DOFInfo> > >, ImageLoader::DOFInfo const&)"),
	mu_demangle_test("_ZNSt6vectorIN11ImageLoader7DOFInfoESaIS1_EE9push_backERKS1_", "std::vector<ImageLoader::DOFInfo, std::allocator<ImageLoader::DOFInfo> >::push_back(ImageLoader::DOFInfo const&)"),
	mu_demangle_test("_ZNSt6vectorIN11ImageLoader14InterposeTupleESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<ImageLoader::InterposeTuple, std::allocator<ImageLoader::InterposeTuple> >::_M_insert_aux(__gnu_cxx::__normal_iterator<ImageLoader::InterposeTuple*, std::vector<ImageLoader::InterposeTuple, std::allocator<ImageLoader::InterposeTuple> > >, ImageLoader::InterposeTuple const&)"),
	mu_demangle_test("_ZNSt6vectorIN11ImageLoader14InterposeTupleESaIS1_EE9push_backERKS1_", "std::vector<ImageLoader::InterposeTuple, std::allocator<ImageLoader::InterposeTuple> >::push_back(ImageLoader::InterposeTuple const&)"),
	mu_demangle_test("_ZNSsC2ERKSs", "std::basic_string<char, std::char_traits<char>, std::allocator<char> >::basic_string(std::string const&)"),
	mu_demangle_test("_ZNSsC1ERKSs", "std::basic_string<char, std::char_traits<char>, std::allocator<char> >::basic_string(std::string const&)"),
	mu_demangle_test("_ZNSsC2EPKcRKSaIcE", "std::basic_string<char, std::char_traits<char>, std::allocator<char> >::basic_string(char const*, std::allocator<char> const&)"),
	mu_demangle_test("_ZNSsC1EPKcRKSaIcE", "std::basic_string<char, std::char_traits<char>, std::allocator<char> >::basic_string(char const*, std::allocator<char> const&)"),
	mu_demangle_test("_ZN9__gnu_cxx13new_allocatorIcE8allocateEmPKv", "__gnu_cxx::new_allocator<char>::allocate(unsigned long, void const*)"),
	mu_demangle_test("_ZNK9__gnu_cxx24__concurrence_lock_error4whatEv", "__gnu_cxx::__concurrence_lock_error::what() const"),
	mu_demangle_test("_ZNK9__gnu_cxx26__concurrence_unlock_error4whatEv", "__gnu_cxx::__concurrence_unlock_error::what() const"),
	mu_demangle_test("_ZN9__gnu_cxx32__throw_concurrence_unlock_errorEv", "__gnu_cxx::__throw_concurrence_unlock_error()"),
	mu_demangle_test("_ZN9__gnu_cxx30__throw_concurrence_lock_errorEv", "__gnu_cxx::__throw_concurrence_lock_error()"),
	mu_demangle_test("_ZN9__gnu_cxx7__mutex4lockEv", "__gnu_cxx::__mutex::lock()"),
	mu_demangle_test("_ZN9__gnu_cxx26__concurrence_unlock_errorD0Ev", "__gnu_cxx::__concurrence_unlock_error::~__concurrence_unlock_error()"),
	mu_demangle_test("_ZN9__gnu_cxx26__concurrence_unlock_errorD2Ev", "__gnu_cxx::__concurrence_unlock_error::~__concurrence_unlock_error()"),
	mu_demangle_test("_ZN9__gnu_cxx26__concurrence_unlock_errorD1Ev", "__gnu_cxx::__concurrence_unlock_error::~__concurrence_unlock_error()"),
	mu_demangle_test("_ZN9__gnu_cxx24__concurrence_lock_errorD0Ev", "__gnu_cxx::__concurrence_lock_error::~__concurrence_lock_error()"),
	mu_demangle_test("_ZN9__gnu_cxx24__concurrence_lock_errorD2Ev", "__gnu_cxx::__concurrence_lock_error::~__concurrence_lock_error()"),
	mu_demangle_test("_ZN9__gnu_cxx24__concurrence_lock_errorD1Ev", "__gnu_cxx::__concurrence_lock_error::~__concurrence_lock_error()"),
	mu_demangle_test("_ZN9__gnu_cxx7__mutex6unlockEv", "__gnu_cxx::__mutex::unlock()"),
	mu_demangle_test("_ZN9__gnu_cxx13__scoped_lockD2Ev", "__gnu_cxx::__scoped_lock::~__scoped_lock()"),
	mu_demangle_test("_ZTSN9__gnu_cxx24__concurrence_lock_errorE", "typeinfo name for __gnu_cxx::__concurrence_lock_error"),
	mu_demangle_test("_ZTSN9__gnu_cxx26__concurrence_unlock_errorE", "typeinfo name for __gnu_cxx::__concurrence_unlock_error"),
	mu_demangle_test("_ZTIN9__gnu_cxx24__concurrence_lock_errorE", "typeinfo for __gnu_cxx::__concurrence_lock_error"),
	mu_demangle_test("_ZTVN9__gnu_cxx24__concurrence_lock_errorE", "vtable for __gnu_cxx::__concurrence_lock_error"),
	mu_demangle_test("_ZTIN9__gnu_cxx26__concurrence_unlock_errorE", "typeinfo for __gnu_cxx::__concurrence_unlock_error"),
	mu_demangle_test("_ZTVN9__gnu_cxx26__concurrence_unlock_errorE", "vtable for __gnu_cxx::__concurrence_unlock_error"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm24PassRegistrationListenerESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::PassRegistrationListener*, std::allocator<llvm::PassRegistrationListener*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::PassRegistrationListener**, std::vector<llvm::PassRegistrationListener*, std::allocator<llvm::PassRegistrationListener*> > >, llvm::PassRegistrationListener* const&)"),
	mu_demangle_test("_ZNSt6vectorIS_ISsSaISsEESaIS1_EED2Ev", "std::vector<std::vector<std::string, std::allocator<std::string> >, std::allocator<std::vector<std::string, std::allocator<std::string> > > >::~vector()"),
	mu_demangle_test("_ZNSt6vectorISt4pairISsSsESaIS1_EED2Ev", "std::vector<std::pair<std::string, std::string>, std::allocator<std::pair<std::string, std::string> > >::~vector()"),
	mu_demangle_test("_ZNSt6vectorISsSaISsEEaSERKS1_", "std::vector<std::string, std::allocator<std::string> >::operator=(std::vector<std::string, std::allocator<std::string> > const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm9SourceMgr9SrcBufferESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::SourceMgr::SrcBuffer, std::allocator<llvm::SourceMgr::SrcBuffer> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::SourceMgr::SrcBuffer*, std::vector<llvm::SourceMgr::SrcBuffer, std::allocator<llvm::SourceMgr::SrcBuffer> > >, llvm::SourceMgr::SrcBuffer const&)"),
	mu_demangle_test("_Z17ExpandArgsFromBufPKcRN4llvm15SmallVectorImplIS0_EERSt3setISsSt4lessISsESaISsEE", "ExpandArgsFromBuf(char const*, llvm::SmallVectorImpl<char const*>&, std::set<std::string, std::less<std::string>, std::allocator<std::string> >&)"),
	mu_demangle_test("_ZN4llvm15SmallVectorImplIPKcE6insertIN9__gnu_cxx17__normal_iteratorIPS2_St6vectorIS2_SaIS2_EEEEEES7_S7_T_SC_", "char const** llvm::SmallVectorImpl<char const*>::insert<__gnu_cxx::__normal_iterator<char const**, std::vector<char const*, std::allocator<char const*> > > >(char const**, __gnu_cxx::__normal_iterator<char const**, std::vector<char const*, std::allocator<char const*> > >, __gnu_cxx::__normal_iterator<char const**, std::vector<char const*, std::allocator<char const*> > >)"),
	mu_demangle_test("_ZNSt6vectorIPKcSaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<char const*, std::allocator<char const*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<char const**, std::vector<char const*, std::allocator<char const*> > >, char const* const&)"),
	mu_demangle_test("_ZNSt5dequeISsSaISsEED2Ev", "std::deque<std::string, std::allocator<std::string> >::~deque()"),
	mu_demangle_test("_ZNSt5dequeISsSaISsEE19_M_destroy_data_auxESt15_Deque_iteratorISsRSsPSsES5_", "std::deque<std::string, std::allocator<std::string> >::_M_destroy_data_aux(std::_Deque_iterator<std::string, std::string&, std::string*>, std::_Deque_iterator<std::string, std::string&, std::string*>)"),
	mu_demangle_test("_ZNSt6vectorIN5clang15CharSourceRangeESaIS1_EEaSERKS3_", "std::vector<clang::CharSourceRange, std::allocator<clang::CharSourceRange> >::operator=(std::vector<clang::CharSourceRange, std::allocator<clang::CharSourceRange> > const&)"),
	mu_demangle_test("_ZNSt6vectorIN5clang9FixItHintESaIS1_EEaSERKS3_", "std::vector<clang::FixItHint, std::allocator<clang::FixItHint> >::operator=(std::vector<clang::FixItHint, std::allocator<clang::FixItHint> > const&)"),
	mu_demangle_test("_ZNSt6vectorIN5clang9FixItHintESaIS1_EEC2ERKS3_", "std::vector<clang::FixItHint, std::allocator<clang::FixItHint> >::vector(std::vector<clang::FixItHint, std::allocator<clang::FixItHint> > const&)"),
	mu_demangle_test("_ZNSt6vectorIN5clang15CharSourceRangeESaIS1_EEC2ERKS3_", "std::vector<clang::CharSourceRange, std::allocator<clang::CharSourceRange> >::vector(std::vector<clang::CharSourceRange, std::allocator<clang::CharSourceRange> > const&)"),
	mu_demangle_test("_ZNSt6vectorIPN5clang18PreprocessedEntityESaIS2_EE15_M_range_insertIN9__gnu_cxx17__normal_iteratorIPS2_S4_EEEEvS9_T_SA_St20forward_iterator_tag", "void std::vector<clang::PreprocessedEntity*, std::allocator<clang::PreprocessedEntity*> >::_M_range_insert<__gnu_cxx::__normal_iterator<clang::PreprocessedEntity**, std::vector<clang::PreprocessedEntity*, std::allocator<clang::PreprocessedEntity*> > > >(__gnu_cxx::__normal_iterator<clang::PreprocessedEntity**, std::vector<clang::PreprocessedEntity*, std::allocator<clang::PreprocessedEntity*> > >, __gnu_cxx::__normal_iterator<clang::PreprocessedEntity**, std::vector<clang::PreprocessedEntity*, std::allocator<clang::PreprocessedEntity*> > >, __gnu_cxx::__normal_iterator<clang::PreprocessedEntity**, std::vector<clang::PreprocessedEntity*, std::allocator<clang::PreprocessedEntity*> > >, std::forward_iterator_tag)"),
	mu_demangle_test("_ZNSt6vectorIPN5clang18PreprocessedEntityESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<clang::PreprocessedEntity*, std::allocator<clang::PreprocessedEntity*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::PreprocessedEntity**, std::vector<clang::PreprocessedEntity*, std::allocator<clang::PreprocessedEntity*> > >, clang::PreprocessedEntity* const&)"),
	mu_demangle_test("_ZNSt6vectorIPN5clang4DeclESaIS2_EE15_M_range_insertIN9__gnu_cxx17__normal_iteratorIPS2_S4_EEEEvS9_T_SA_St20forward_iterator_tag", "void std::vector<clang::Decl*, std::allocator<clang::Decl*> >::_M_range_insert<__gnu_cxx::__normal_iterator<clang::Decl**, std::vector<clang::Decl*, std::allocator<clang::Decl*> > > >(__gnu_cxx::__normal_iterator<clang::Decl**, std::vector<clang::Decl*, std::allocator<clang::Decl*> > >, __gnu_cxx::__normal_iterator<clang::Decl**, std::vector<clang::Decl*, std::allocator<clang::Decl*> > >, __gnu_cxx::__normal_iterator<clang::Decl**, std::vector<clang::Decl*, std::allocator<clang::Decl*> > >, std::forward_iterator_tag)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN5clang6FileIDESt4pairIKS1_St6vectorIPNS0_18PreprocessedEntityESaIS6_EEESt10_Select1stIS9_ESt4lessIS1_ESaIS9_EE8_M_eraseEPSt13_Rb_tree_nodeIS9_E", "std::_Rb_tree<clang::FileID, std::pair<clang::FileID const, std::vector<clang::PreprocessedEntity*, std::allocator<clang::PreprocessedEntity*> > >, std::_Select1st<std::pair<clang::FileID const, std::vector<clang::PreprocessedEntity*, std::allocator<clang::PreprocessedEntity*> > > >, std::less<clang::FileID>, std::allocator<std::pair<clang::FileID const, std::vector<clang::PreprocessedEntity*, std::allocator<clang::PreprocessedEntity*> > > > >::_M_erase(std::_Rb_tree_node<std::pair<clang::FileID const, std::vector<clang::PreprocessedEntity*, std::allocator<clang::PreprocessedEntity*> > > >*)"),
	mu_demangle_test("_ZNSt6vectorIN5clang7ASTUnit26CachedCodeCompletionResultESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<clang::ASTUnit::CachedCodeCompletionResult, std::allocator<clang::ASTUnit::CachedCodeCompletionResult> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::ASTUnit::CachedCodeCompletionResult*, std::vector<clang::ASTUnit::CachedCodeCompletionResult, std::allocator<clang::ASTUnit::CachedCodeCompletionResult> > >, clang::ASTUnit::CachedCodeCompletionResult const&)"),
	mu_demangle_test("_ZNSt6vectorIPN5clang4DeclESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<clang::Decl*, std::allocator<clang::Decl*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::Decl**, std::vector<clang::Decl*, std::allocator<clang::Decl*> > >, clang::Decl* const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairISsSsESaIS1_EE5clearEv", "std::vector<std::pair<std::string, std::string>, std::allocator<std::pair<std::string, std::string> > >::clear()"),
	mu_demangle_test("_ZNSt6vectorISt4pairISsPKN4llvm12MemoryBufferEESaIS5_EEC2ERKS7_", "std::vector<std::pair<std::string, llvm::MemoryBuffer const*>, std::allocator<std::pair<std::string, llvm::MemoryBuffer const*> > >::vector(std::vector<std::pair<std::string, llvm::MemoryBuffer const*>, std::allocator<std::pair<std::string, llvm::MemoryBuffer const*> > > const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairISsSsESaIS1_EEC2ERKS3_", "std::vector<std::pair<std::string, std::string>, std::allocator<std::pair<std::string, std::string> > >::vector(std::vector<std::pair<std::string, std::string>, std::allocator<std::pair<std::string, std::string> > > const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairISsbESaIS1_EEC2ERKS3_", "std::vector<std::pair<std::string, bool>, std::allocator<std::pair<std::string, bool> > >::vector(std::vector<std::pair<std::string, bool>, std::allocator<std::pair<std::string, bool> > > const&)"),
	mu_demangle_test("_ZNSt6vectorIN5clang19HeaderSearchOptions5EntryESaIS2_EEC2ERKS4_", "std::vector<clang::HeaderSearchOptions::Entry, std::allocator<clang::HeaderSearchOptions::Entry> >::vector(std::vector<clang::HeaderSearchOptions::Entry, std::allocator<clang::HeaderSearchOptions::Entry> > const&)"),
	mu_demangle_test("_ZNSt6vectorIS_ISsSaISsEESaIS1_EEC2ERKS3_", "std::vector<std::vector<std::string, std::allocator<std::string> >, std::allocator<std::vector<std::string, std::allocator<std::string> > > >::vector(std::vector<std::vector<std::string, std::allocator<std::string> >, std::allocator<std::vector<std::string, std::allocator<std::string> > > > const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN5clang9InputKindESsESaIS3_EEC2ERKS5_", "std::vector<std::pair<clang::InputKind, std::string>, std::allocator<std::pair<clang::InputKind, std::string> > >::vector(std::vector<std::pair<clang::InputKind, std::string>, std::allocator<std::pair<clang::InputKind, std::string> > > const&)"),
	mu_demangle_test("_ZNSt6vectorIN5clang8AnalysesESaIS1_EEC2ERKS3_", "std::vector<clang::Analyses, std::allocator<clang::Analyses> >::vector(std::vector<clang::Analyses, std::allocator<clang::Analyses> > const&)"),
	mu_demangle_test("_ZNSt6vectorIySaIyEE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPyS1_EERKy", "std::vector<uint64_t, std::allocator<uint64_t> >::_M_insert_aux(__gnu_cxx::__normal_iterator<uint64_t*, std::vector<uint64_t, std::allocator<uint64_t> > >, uint64_t const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairISsPKN4llvm12MemoryBufferEESaIS5_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS5_S7_EERKS5_", "std::vector<std::pair<std::string, llvm::MemoryBuffer const*>, std::allocator<std::pair<std::string, llvm::MemoryBuffer const*> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<std::string, llvm::MemoryBuffer const*>*, std::vector<std::pair<std::string, llvm::MemoryBuffer const*>, std::allocator<std::pair<std::string, llvm::MemoryBuffer const*> > > >, std::pair<std::string, llvm::MemoryBuffer const*> const&)"),
	mu_demangle_test("_ZNSt10_List_baseIN5clang16CompilerInstance10OutputFileESaIS2_EE8_M_clearEv", "std::_List_base<clang::CompilerInstance::OutputFile, std::allocator<clang::CompilerInstance::OutputFile> >::_M_clear()"),
	mu_demangle_test("_ZN5clang18CompilerInvocation6toArgsERSt6vectorISsSaISsEE", "clang::CompilerInvocation::toArgs(std::vector<std::string, std::allocator<std::string> >&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairISsSsESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<std::pair<std::string, std::string>, std::allocator<std::pair<std::string, std::string> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<std::string, std::string>*, std::vector<std::pair<std::string, std::string>, std::allocator<std::pair<std::string, std::string> > > >, std::pair<std::string, std::string> const&)"),
	mu_demangle_test("_ZNSt6vectorISsSaISsEE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPSsS1_EERKSs", "std::vector<std::string, std::allocator<std::string> >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::string*, std::vector<std::string, std::allocator<std::string> > >, std::string const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairISsbESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<std::pair<std::string, bool>, std::allocator<std::pair<std::string, bool> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<std::string, bool>*, std::vector<std::pair<std::string, bool>, std::allocator<std::pair<std::string, bool> > > >, std::pair<std::string, bool> const&)"),
	mu_demangle_test("_ZNSt6vectorIN5clang19HeaderSearchOptions5EntryESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<clang::HeaderSearchOptions::Entry, std::allocator<clang::HeaderSearchOptions::Entry> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::HeaderSearchOptions::Entry*, std::vector<clang::HeaderSearchOptions::Entry, std::allocator<clang::HeaderSearchOptions::Entry> > >, clang::HeaderSearchOptions::Entry const&)"),
	mu_demangle_test("_ZN5clang20ParsedSourceLocation10FromStringEN4llvm9StringRefE", "clang::ParsedSourceLocation::FromString(llvm::StringRef)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN5clang9InputKindESsESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<std::pair<clang::InputKind, std::string>, std::allocator<std::pair<clang::InputKind, std::string> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<clang::InputKind, std::string>*, std::vector<std::pair<clang::InputKind, std::string>, std::allocator<std::pair<clang::InputKind, std::string> > > >, std::pair<clang::InputKind, std::string> const&)"),
	mu_demangle_test("_ZNSt6vectorIS_ISsSaISsEESaIS1_EE15_M_erase_at_endEPS1_", "std::vector<std::vector<std::string, std::allocator<std::string> >, std::allocator<std::vector<std::string, std::allocator<std::string> > > >::_M_erase_at_end(std::vector<std::string, std::allocator<std::string> >*)"),
	mu_demangle_test("_ZNSt6vectorIS_ISsSaISsEESaIS1_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS1_S3_EEmRKS1_", "std::vector<std::vector<std::string, std::allocator<std::string> >, std::allocator<std::vector<std::string, std::allocator<std::string> > > >::_M_fill_insert(__gnu_cxx::__normal_iterator<std::vector<std::string, std::allocator<std::string> >*, std::vector<std::vector<std::string, std::allocator<std::string> >, std::allocator<std::vector<std::string, std::allocator<std::string> > > > >, unsigned long, std::vector<std::string, std::allocator<std::string> > const&)"),
	mu_demangle_test("_ZNSt6vectorISsSaISsEEC2ERKS1_", "std::vector<std::string, std::allocator<std::string> >::vector(std::vector<std::string, std::allocator<std::string> > const&)"),
	mu_demangle_test("_ZNSt6vectorIN5clang8AnalysesESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<clang::Analyses, std::allocator<clang::Analyses> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::Analyses*, std::vector<clang::Analyses, std::allocator<clang::Analyses> > >, clang::Analyses const&)"),
	mu_demangle_test("_ZNSt5dequeISsSaISsEE8pop_backEv", "std::deque<std::string, std::allocator<std::string> >::pop_back()"),
	mu_demangle_test("_ZNSt11_Deque_baseISsSaISsEE17_M_initialize_mapEm", "std::_Deque_base<std::string, std::allocator<std::string> >::_M_initialize_map(unsigned long)"),
	mu_demangle_test("_ZNSt5dequeISsSaISsEEC2ERKS1_", "std::deque<std::string, std::allocator<std::string> >::deque(std::deque<std::string, std::allocator<std::string> > const&)"),
	mu_demangle_test("_ZNSt6vectorIPN5clang11ASTConsumerESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<clang::ASTConsumer*, std::allocator<clang::ASTConsumer*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::ASTConsumer**, std::vector<clang::ASTConsumer*, std::allocator<clang::ASTConsumer*> > >, clang::ASTConsumer* const&)"),
	mu_demangle_test("_Z16RemoveDuplicatesRSt6vectorIN5clang15DirectoryLookupESaIS1_EEb", "RemoveDuplicates(std::vector<clang::DirectoryLookup, std::allocator<clang::DirectoryLookup> >&, bool)"),
	mu_demangle_test("_ZNSt6vectorIN5clang15DirectoryLookupESaIS1_EEaSERKS3_", "std::vector<clang::DirectoryLookup, std::allocator<clang::DirectoryLookup> >::operator=(std::vector<clang::DirectoryLookup, std::allocator<clang::DirectoryLookup> > const&)"),
	mu_demangle_test("_ZNSt6vectorIN5clang15DirectoryLookupESaIS1_EE15_M_range_insertIN9__gnu_cxx17__normal_iteratorIPS1_S3_EEEEvS8_T_S9_St20forward_iterator_tag", "void std::vector<clang::DirectoryLookup, std::allocator<clang::DirectoryLookup> >::_M_range_insert<__gnu_cxx::__normal_iterator<clang::DirectoryLookup*, std::vector<clang::DirectoryLookup, std::allocator<clang::DirectoryLookup> > > >(__gnu_cxx::__normal_iterator<clang::DirectoryLookup*, std::vector<clang::DirectoryLookup, std::allocator<clang::DirectoryLookup> > >, __gnu_cxx::__normal_iterator<clang::DirectoryLookup*, std::vector<clang::DirectoryLookup, std::allocator<clang::DirectoryLookup> > >, __gnu_cxx::__normal_iterator<clang::DirectoryLookup*, std::vector<clang::DirectoryLookup, std::allocator<clang::DirectoryLookup> > >, std::forward_iterator_tag)"),
	mu_demangle_test("_ZNSt6vectorIN5clang15DirectoryLookupESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<clang::DirectoryLookup, std::allocator<clang::DirectoryLookup> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::DirectoryLookup*, std::vector<clang::DirectoryLookup, std::allocator<clang::DirectoryLookup> > >, clang::DirectoryLookup const&)"),
	mu_demangle_test("_ZN5clang35MultiplexASTDeserializationListenerC1ERKSt6vectorIPNS_26ASTDeserializationListenerESaIS3_EE", "clang::MultiplexASTDeserializationListener::MultiplexASTDeserializationListener(std::vector<clang::ASTDeserializationListener*, std::allocator<clang::ASTDeserializationListener*> > const&)"),
	mu_demangle_test("_ZN5clang35MultiplexASTDeserializationListenerC2ERKSt6vectorIPNS_26ASTDeserializationListenerESaIS3_EE", "clang::MultiplexASTDeserializationListener::MultiplexASTDeserializationListener(std::vector<clang::ASTDeserializationListener*, std::allocator<clang::ASTDeserializationListener*> > const&)"),
	mu_demangle_test("_ZN5clang28MultiplexASTMutationListenerC1ERKSt6vectorIPNS_19ASTMutationListenerESaIS3_EE", "clang::MultiplexASTMutationListener::MultiplexASTMutationListener(std::vector<clang::ASTMutationListener*, std::allocator<clang::ASTMutationListener*> > const&)"),
	mu_demangle_test("_ZN5clang28MultiplexASTMutationListenerC2ERKSt6vectorIPNS_19ASTMutationListenerESaIS3_EE", "clang::MultiplexASTMutationListener::MultiplexASTMutationListener(std::vector<clang::ASTMutationListener*, std::allocator<clang::ASTMutationListener*> > const&)"),
	mu_demangle_test("_ZN5clang17MultiplexConsumerC1ERKSt6vectorIPNS_11ASTConsumerESaIS3_EE", "clang::MultiplexConsumer::MultiplexConsumer(std::vector<clang::ASTConsumer*, std::allocator<clang::ASTConsumer*> > const&)"),
	mu_demangle_test("_ZN5clang17MultiplexConsumerC2ERKSt6vectorIPNS_11ASTConsumerESaIS3_EE", "clang::MultiplexConsumer::MultiplexConsumer(std::vector<clang::ASTConsumer*, std::allocator<clang::ASTConsumer*> > const&)"),
	mu_demangle_test("_ZNSt6vectorIPN5clang26ASTDeserializationListenerESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<clang::ASTDeserializationListener*, std::allocator<clang::ASTDeserializationListener*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::ASTDeserializationListener**, std::vector<clang::ASTDeserializationListener*, std::allocator<clang::ASTDeserializationListener*> > >, clang::ASTDeserializationListener* const&)"),
	mu_demangle_test("_ZNSt6vectorIPN5clang19ASTMutationListenerESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<clang::ASTMutationListener*, std::allocator<clang::ASTMutationListener*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::ASTMutationListener**, std::vector<clang::ASTMutationListener*, std::allocator<clang::ASTMutationListener*> > >, clang::ASTMutationListener* const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN5clang14SourceLocationESsESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<std::pair<clang::SourceLocation, std::string>, std::allocator<std::pair<clang::SourceLocation, std::string> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<clang::SourceLocation, std::string>*, std::vector<std::pair<clang::SourceLocation, std::string>, std::allocator<std::pair<clang::SourceLocation, std::string> > > >, std::pair<clang::SourceLocation, std::string> const&)"),
	mu_demangle_test("_Z12PrintProblemRN5clang10DiagnosticEPNS_13SourceManagerEN9__gnu_cxx17__normal_iteratorIPKSt4pairINS_14SourceLocationESsESt6vectorIS8_SaIS8_EEEESE_PKcb", "PrintProblem(clang::Diagnostic&, clang::SourceManager*, __gnu_cxx::__normal_iterator<std::pair<clang::SourceLocation, std::string> const*, std::vector<std::pair<clang::SourceLocation, std::string>, std::allocator<std::pair<clang::SourceLocation, std::string> > > >, __gnu_cxx::__normal_iterator<std::pair<clang::SourceLocation, std::string> const*, std::vector<std::pair<clang::SourceLocation, std::string>, std::allocator<std::pair<clang::SourceLocation, std::string> > > >, char const*, bool)"),
	mu_demangle_test("_Z10CheckListsRN5clang10DiagnosticERNS_13SourceManagerEPKcRSt6vectorIPN12_GLOBAL__N_19DirectiveESaIS9_EEN9__gnu_cxx17__normal_iteratorIPKSt4pairINS_14SourceLocationESsES6_ISH_SaISH_EEEESM_", "CheckLists(clang::Diagnostic&, clang::SourceManager&, char const*, std::vector<(anonymous namespace)::Directive*, std::allocator<(anonymous namespace)::Directive*> >&, __gnu_cxx::__normal_iterator<std::pair<clang::SourceLocation, std::string> const*, std::vector<std::pair<clang::SourceLocation, std::string>, std::allocator<std::pair<clang::SourceLocation, std::string> > > >, __gnu_cxx::__normal_iterator<std::pair<clang::SourceLocation, std::string> const*, std::vector<std::pair<clang::SourceLocation, std::string>, std::allocator<std::pair<clang::SourceLocation, std::string> > > >)"),
	mu_demangle_test("_ZNSt6vectorIPN12_GLOBAL__N_19DirectiveESaIS2_EE9push_backERKS2_", "std::vector<(anonymous namespace)::Directive*, std::allocator<(anonymous namespace)::Directive*> >::push_back((anonymous namespace)::Directive* const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN5clang14SourceLocationESsESaIS3_EE19_M_range_initializeIN9__gnu_cxx17__normal_iteratorIPKS3_S5_EEEEvT_SC_St20forward_iterator_tag", "void std::vector<std::pair<clang::SourceLocation, std::string>, std::allocator<std::pair<clang::SourceLocation, std::string> > >::_M_range_initialize<__gnu_cxx::__normal_iterator<std::pair<clang::SourceLocation, std::string> const*, std::vector<std::pair<clang::SourceLocation, std::string>, std::allocator<std::pair<clang::SourceLocation, std::string> > > > >(__gnu_cxx::__normal_iterator<std::pair<clang::SourceLocation, std::string> const*, std::vector<std::pair<clang::SourceLocation, std::string>, std::allocator<std::pair<clang::SourceLocation, std::string> > > >, __gnu_cxx::__normal_iterator<std::pair<clang::SourceLocation, std::string> const*, std::vector<std::pair<clang::SourceLocation, std::string>, std::allocator<std::pair<clang::SourceLocation, std::string> > > >, std::forward_iterator_tag)"),
	mu_demangle_test("_ZNSt6vectorISsSaISsEE22_M_initialize_dispatchIPPKcEEvT_S6_St12__false_type", "void std::vector<std::string, std::allocator<std::string> >::_M_initialize_dispatch<char const**>(char const**, char const**, std::__false_type)"),
	mu_demangle_test("_ZNSt3mapISsSt6vectorISt4pairISsPKcESaIS4_EESt4lessISsESaIS1_IKSsS6_EEEixERS9_", "std::map<std::string, std::vector<std::pair<std::string, char const*>, std::allocator<std::pair<std::string, char const*> > >, std::less<std::string>, std::allocator<std::pair<std::string const, std::vector<std::pair<std::string, char const*>, std::allocator<std::pair<std::string, char const*> > > > > >::operator[](std::string const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairISsPKcESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<std::pair<std::string, char const*>, std::allocator<std::pair<std::string, char const*> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<std::string, char const*>*, std::vector<std::pair<std::string, char const*>, std::allocator<std::pair<std::string, char const*> > > >, std::pair<std::string, char const*> const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairISsPKcESaIS3_EEC2ERKS5_", "std::vector<std::pair<std::string, char const*>, std::allocator<std::pair<std::string, char const*> > >::vector(std::vector<std::pair<std::string, char const*>, std::allocator<std::pair<std::string, char const*> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsSt6vectorIS0_ISsPKcESaIS5_EEESt10_Select1stIS8_ESt4lessISsESaIS8_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS8_ERKS8_", "std::_Rb_tree<std::string, std::pair<std::string const, std::vector<std::pair<std::string, char const*>, std::allocator<std::pair<std::string, char const*> > > >, std::_Select1st<std::pair<std::string const, std::vector<std::pair<std::string, char const*>, std::allocator<std::pair<std::string, char const*> > > > >, std::less<std::string>, std::allocator<std::pair<std::string const, std::vector<std::pair<std::string, char const*>, std::allocator<std::pair<std::string, char const*> > > > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<std::string const, std::vector<std::pair<std::string, char const*>, std::allocator<std::pair<std::string, char const*> > > > >, std::pair<std::string const, std::vector<std::pair<std::string, char const*>, std::allocator<std::pair<std::string, char const*> > > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsSt6vectorIS0_ISsPKcESaIS5_EEESt10_Select1stIS8_ESt4lessISsESaIS8_EE9_M_insertEPSt18_Rb_tree_node_baseSG_RKS8_", "std::_Rb_tree<std::string, std::pair<std::string const, std::vector<std::pair<std::string, char const*>, std::allocator<std::pair<std::string, char const*> > > >, std::_Select1st<std::pair<std::string const, std::vector<std::pair<std::string, char const*>, std::allocator<std::pair<std::string, char const*> > > > >, std::less<std::string>, std::allocator<std::pair<std::string const, std::vector<std::pair<std::string, char const*>, std::allocator<std::pair<std::string, char const*> > > > > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<std::string const, std::vector<std::pair<std::string, char const*>, std::allocator<std::pair<std::string, char const*> > > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsSt6vectorIS0_ISsPKcESaIS5_EEESt10_Select1stIS8_ESt4lessISsESaIS8_EE16_M_insert_uniqueERKS8_", "std::_Rb_tree<std::string, std::pair<std::string const, std::vector<std::pair<std::string, char const*>, std::allocator<std::pair<std::string, char const*> > > >, std::_Select1st<std::pair<std::string const, std::vector<std::pair<std::string, char const*>, std::allocator<std::pair<std::string, char const*> > > > >, std::less<std::string>, std::allocator<std::pair<std::string const, std::vector<std::pair<std::string, char const*>, std::allocator<std::pair<std::string, char const*> > > > > >::_M_insert_unique(std::pair<std::string const, std::vector<std::pair<std::string, char const*>, std::allocator<std::pair<std::string, char const*> > > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsSt6vectorIS0_ISsPKcESaIS5_EEESt10_Select1stIS8_ESt4lessISsESaIS8_EE8_M_eraseEPSt13_Rb_tree_nodeIS8_E", "std::_Rb_tree<std::string, std::pair<std::string const, std::vector<std::pair<std::string, char const*>, std::allocator<std::pair<std::string, char const*> > > >, std::_Select1st<std::pair<std::string const, std::vector<std::pair<std::string, char const*>, std::allocator<std::pair<std::string, char const*> > > > >, std::less<std::string>, std::allocator<std::pair<std::string const, std::vector<std::pair<std::string, char const*>, std::allocator<std::pair<std::string, char const*> > > > > >::_M_erase(std::_Rb_tree_node<std::pair<std::string const, std::vector<std::pair<std::string, char const*>, std::allocator<std::pair<std::string, char const*> > > > >*)"),
	mu_demangle_test("_ZN9__gnu_cxx13new_allocatorISt4pairIKSsSt6vectorIS1_ISsPKcESaIS6_EEEE7destroyEPS9_", "__gnu_cxx::new_allocator<std::pair<std::string const, std::vector<std::pair<std::string, char const*>, std::allocator<std::pair<std::string, char const*> > > > >::destroy(std::pair<std::string const, std::vector<std::pair<std::string, char const*>, std::allocator<std::pair<std::string, char const*> > > >*)"),
	mu_demangle_test("_ZSt14set_differenceIPN4llvm9StringRefES2_St20back_insert_iteratorISt6vectorIS1_SaIS1_EEEET1_T_S9_T0_SA_S8_", "std::back_insert_iterator<std::vector<llvm::StringRef, std::allocator<llvm::StringRef> > > std::set_difference<llvm::StringRef*, llvm::StringRef*, std::back_insert_iterator<std::vector<llvm::StringRef, std::allocator<llvm::StringRef> > > >(llvm::StringRef*, llvm::StringRef*, llvm::StringRef*, llvm::StringRef*, std::back_insert_iterator<std::vector<llvm::StringRef, std::allocator<llvm::StringRef> > >)"),
	mu_demangle_test("_ZNSt6vectorIN5clang9LineEntryESaIS1_EE7reserveEm", "std::vector<clang::LineEntry, std::allocator<clang::LineEntry> >::reserve(unsigned long)"),
	mu_demangle_test("_ZN5clang13serialization10MakeTypeIDISt9binder1stISt16const_mem_fun1_tINS0_7TypeIdxENS_9ASTReaderENS_8QualTypeEEEEEjS6_T_", "unsigned int clang::serialization::MakeTypeID<std::binder1st<std::const_mem_fun1_t<clang::serialization::TypeIdx, clang::ASTReader, clang::QualType> > >(clang::QualType, std::binder1st<std::const_mem_fun1_t<clang::serialization::TypeIdx, clang::ASTReader, clang::QualType> >)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang8SelectorENS1_14SourceLocationENS_12DenseMapInfoIS2_EENS4_IS3_EEE6insertERKSt4pairIS2_S3_E", "llvm::DenseMap<clang::Selector, clang::SourceLocation, llvm::DenseMapInfo<clang::Selector>, llvm::DenseMapInfo<clang::SourceLocation> >::insert(std::pair<clang::Selector, clang::SourceLocation> const&)"),
	mu_demangle_test("_ZNSt5dequeISt4pairIPN5clang9ValueDeclENS1_14SourceLocationEESaIS5_EE9push_backERKS5_", "std::deque<std::pair<clang::ValueDecl*, clang::SourceLocation>, std::allocator<std::pair<clang::ValueDecl*, clang::SourceLocation> > >::push_back(std::pair<clang::ValueDecl*, clang::SourceLocation> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang14IdentifierInfoENS1_4Sema8WeakInfoENS_12DenseMapInfoIS3_EENS6_IS5_EEE6insertERKSt4pairIS3_S5_E", "llvm::DenseMap<clang::IdentifierInfo*, clang::Sema::WeakInfo, llvm::DenseMapInfo<clang::IdentifierInfo*>, llvm::DenseMapInfo<clang::Sema::WeakInfo> >::insert(std::pair<clang::IdentifierInfo*, clang::Sema::WeakInfo> const&)"),
	mu_demangle_test("_ZNSt5dequeIN5clang9ASTReader21PendingIdentifierInfoESaIS2_EED2Ev", "std::deque<clang::ASTReader::PendingIdentifierInfo, std::allocator<clang::ASTReader::PendingIdentifierInfo> >::~deque()"),
	mu_demangle_test("_ZNSt5dequeIN5clang9ASTReader21PendingIdentifierInfoESaIS2_EE19_M_destroy_data_auxESt15_Deque_iteratorIS2_RS2_PS2_ES8_", "std::deque<clang::ASTReader::PendingIdentifierInfo, std::allocator<clang::ASTReader::PendingIdentifierInfo> >::_M_destroy_data_aux(std::_Deque_iterator<clang::ASTReader::PendingIdentifierInfo, clang::ASTReader::PendingIdentifierInfo&, clang::ASTReader::PendingIdentifierInfo*>, std::_Deque_iterator<clang::ASTReader::PendingIdentifierInfo, clang::ASTReader::PendingIdentifierInfo&, clang::ASTReader::PendingIdentifierInfo*>)"),
	mu_demangle_test("_ZNSt11_Deque_baseIPN5clang4DeclESaIS2_EE17_M_initialize_mapEm", "std::_Deque_base<clang::Decl*, std::allocator<clang::Decl*> >::_M_initialize_map(unsigned long)"),
	mu_demangle_test("_ZNSt11_Deque_baseIN5clang9ASTReader21PendingIdentifierInfoESaIS2_EE17_M_initialize_mapEm", "std::_Deque_base<clang::ASTReader::PendingIdentifierInfo, std::allocator<clang::ASTReader::PendingIdentifierInfo> >::_M_initialize_map(unsigned long)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjPN5clang13AddrLabelExprEESt10_Select1stIS5_ESt4lessIjESaIS5_EE5eraseESt17_Rb_tree_iteratorIS5_ESD_", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, clang::AddrLabelExpr*>, std::_Select1st<std::pair<unsigned int const, clang::AddrLabelExpr*> >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, clang::AddrLabelExpr*> > >::erase(std::_Rb_tree_iterator<std::pair<unsigned int const, clang::AddrLabelExpr*> >, std::_Rb_tree_iterator<std::pair<unsigned int const, clang::AddrLabelExpr*> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjPN5clang13AddrLabelExprEESt10_Select1stIS5_ESt4lessIjESaIS5_EE8_M_eraseEPSt13_Rb_tree_nodeIS5_E", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, clang::AddrLabelExpr*>, std::_Select1st<std::pair<unsigned int const, clang::AddrLabelExpr*> >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, clang::AddrLabelExpr*> > >::_M_erase(std::_Rb_tree_node<std::pair<unsigned int const, clang::AddrLabelExpr*> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjPN5clang8GotoStmtEESt10_Select1stIS5_ESt4lessIjESaIS5_EE5eraseESt17_Rb_tree_iteratorIS5_ESD_", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, clang::GotoStmt*>, std::_Select1st<std::pair<unsigned int const, clang::GotoStmt*> >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, clang::GotoStmt*> > >::erase(std::_Rb_tree_iterator<std::pair<unsigned int const, clang::GotoStmt*> >, std::_Rb_tree_iterator<std::pair<unsigned int const, clang::GotoStmt*> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjPN5clang8GotoStmtEESt10_Select1stIS5_ESt4lessIjESaIS5_EE8_M_eraseEPSt13_Rb_tree_nodeIS5_E", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, clang::GotoStmt*>, std::_Select1st<std::pair<unsigned int const, clang::GotoStmt*> >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, clang::GotoStmt*> > >::_M_erase(std::_Rb_tree_node<std::pair<unsigned int const, clang::GotoStmt*> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjPN5clang9LabelStmtEESt10_Select1stIS5_ESt4lessIjESaIS5_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS5_ERKS5_", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, clang::LabelStmt*>, std::_Select1st<std::pair<unsigned int const, clang::LabelStmt*> >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, clang::LabelStmt*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<unsigned int const, clang::LabelStmt*> >, std::pair<unsigned int const, clang::LabelStmt*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjPN5clang9LabelStmtEESt10_Select1stIS5_ESt4lessIjESaIS5_EE16_M_insert_uniqueERKS5_", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, clang::LabelStmt*>, std::_Select1st<std::pair<unsigned int const, clang::LabelStmt*> >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, clang::LabelStmt*> > >::_M_insert_unique(std::pair<unsigned int const, clang::LabelStmt*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjPN5clang10SwitchCaseEESt10_Select1stIS5_ESt4lessIjESaIS5_EE8_M_eraseEPSt13_Rb_tree_nodeIS5_E", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, clang::SwitchCase*>, std::_Select1st<std::pair<unsigned int const, clang::SwitchCase*> >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, clang::SwitchCase*> > >::_M_erase(std::_Rb_tree_node<std::pair<unsigned int const, clang::SwitchCase*> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjPN5clang10SwitchCaseEESt10_Select1stIS5_ESt4lessIjESaIS5_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS5_ERKS5_", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, clang::SwitchCase*>, std::_Select1st<std::pair<unsigned int const, clang::SwitchCase*> >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, clang::SwitchCase*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<unsigned int const, clang::SwitchCase*> >, std::pair<unsigned int const, clang::SwitchCase*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjPN5clang10SwitchCaseEESt10_Select1stIS5_ESt4lessIjESaIS5_EE16_M_insert_uniqueERKS5_", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, clang::SwitchCase*>, std::_Select1st<std::pair<unsigned int const, clang::SwitchCase*> >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, clang::SwitchCase*> > >::_M_insert_unique(std::pair<unsigned int const, clang::SwitchCase*> const&)"),
	mu_demangle_test("_ZNSt5dequeIN5clang9ASTReader21PendingIdentifierInfoESaIS2_EE16_M_push_back_auxERKS2_", "std::deque<clang::ASTReader::PendingIdentifierInfo, std::allocator<clang::ASTReader::PendingIdentifierInfo> >::_M_push_back_aux(clang::ASTReader::PendingIdentifierInfo const&)"),
	mu_demangle_test("_ZNSt5dequeIN5clang9ASTReader21PendingIdentifierInfoESaIS2_EE17_M_reallocate_mapEmb", "std::deque<clang::ASTReader::PendingIdentifierInfo, std::allocator<clang::ASTReader::PendingIdentifierInfo> >::_M_reallocate_map(unsigned long, bool)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang13CXXRecordDeclEbNS_12DenseMapInfoIS3_EENS4_IbEEE16InsertIntoBucketERKS3_RKbPSt4pairIS3_bE", "llvm::DenseMap<clang::CXXRecordDecl*, bool, llvm::DenseMapInfo<clang::CXXRecordDecl*>, llvm::DenseMapInfo<bool> >::InsertIntoBucket(clang::CXXRecordDecl* const&, bool const&, std::pair<clang::CXXRecordDecl*, bool>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang13CXXRecordDeclEbNS_12DenseMapInfoIS3_EENS4_IbEEE4growEj", "llvm::DenseMap<clang::CXXRecordDecl*, bool, llvm::DenseMapInfo<clang::CXXRecordDecl*>, llvm::DenseMapInfo<bool> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang14IdentifierInfoENS1_4Sema8WeakInfoENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PSt4pairIS3_S5_E", "llvm::DenseMap<clang::IdentifierInfo*, clang::Sema::WeakInfo, llvm::DenseMapInfo<clang::IdentifierInfo*>, llvm::DenseMapInfo<clang::Sema::WeakInfo> >::InsertIntoBucket(clang::IdentifierInfo* const&, clang::Sema::WeakInfo const&, std::pair<clang::IdentifierInfo*, clang::Sema::WeakInfo>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang14IdentifierInfoENS1_4Sema8WeakInfoENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<clang::IdentifierInfo*, clang::Sema::WeakInfo, llvm::DenseMapInfo<clang::IdentifierInfo*>, llvm::DenseMapInfo<clang::Sema::WeakInfo> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt5dequeISt4pairIPN5clang9ValueDeclENS1_14SourceLocationEESaIS5_EE17_M_reallocate_mapEmb", "std::deque<std::pair<clang::ValueDecl*, clang::SourceLocation>, std::allocator<std::pair<clang::ValueDecl*, clang::SourceLocation> > >::_M_reallocate_map(unsigned long, bool)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang8SelectorENS1_14SourceLocationENS_12DenseMapInfoIS2_EENS4_IS3_EEE16InsertIntoBucketERKS2_RKS3_PSt4pairIS2_S3_E", "llvm::DenseMap<clang::Selector, clang::SourceLocation, llvm::DenseMapInfo<clang::Selector>, llvm::DenseMapInfo<clang::SourceLocation> >::InsertIntoBucket(clang::Selector const&, clang::SourceLocation const&, std::pair<clang::Selector, clang::SourceLocation>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang8SelectorENS1_14SourceLocationENS_12DenseMapInfoIS2_EENS4_IS3_EEE4growEj", "llvm::DenseMap<clang::Selector, clang::SourceLocation, llvm::DenseMapInfo<clang::Selector>, llvm::DenseMapInfo<clang::SourceLocation> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang15DeclarationNameEPNS1_9NamedDeclENS_12DenseMapInfoIS2_EENS5_IS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<clang::DeclarationName, clang::NamedDecl*, llvm::DenseMapInfo<clang::DeclarationName>, llvm::DenseMapInfo<clang::NamedDecl*> >::InsertIntoBucket(clang::DeclarationName const&, clang::NamedDecl* const&, std::pair<clang::DeclarationName, clang::NamedDecl*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang15DeclarationNameEPNS1_9NamedDeclENS_12DenseMapInfoIS2_EENS5_IS4_EEE4growEj", "llvm::DenseMap<clang::DeclarationName, clang::NamedDecl*, llvm::DenseMapInfo<clang::DeclarationName>, llvm::DenseMapInfo<clang::NamedDecl*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang8QualTypeENS1_13serialization7TypeIdxENS3_26UnsafeQualTypeDenseMapInfoENS_12DenseMapInfoIS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<clang::QualType, clang::serialization::TypeIdx, clang::serialization::UnsafeQualTypeDenseMapInfo, llvm::DenseMapInfo<clang::serialization::TypeIdx> >::InsertIntoBucket(clang::QualType const&, clang::serialization::TypeIdx const&, std::pair<clang::QualType, clang::serialization::TypeIdx>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang8QualTypeENS1_13serialization7TypeIdxENS3_26UnsafeQualTypeDenseMapInfoENS_12DenseMapInfoIS4_EEE4growEj", "llvm::DenseMap<clang::QualType, clang::serialization::TypeIdx, clang::serialization::UnsafeQualTypeDenseMapInfo, llvm::DenseMapInfo<clang::serialization::TypeIdx> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIPN5clang4DeclESaIS2_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS2_S4_EEmRKS2_", "std::vector<clang::Decl*, std::allocator<clang::Decl*> >::_M_fill_insert(__gnu_cxx::__normal_iterator<clang::Decl**, std::vector<clang::Decl*, std::allocator<clang::Decl*> > >, unsigned long, clang::Decl* const&)"),
	mu_demangle_test("_ZNSt6vectorIN5clang8QualTypeESaIS1_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS1_S3_EEmRKS1_", "std::vector<clang::QualType, std::allocator<clang::QualType> >::_M_fill_insert(__gnu_cxx::__normal_iterator<clang::QualType*, std::vector<clang::QualType, std::allocator<clang::QualType> > >, unsigned long, clang::QualType const&)"),
	mu_demangle_test("_ZNSt6vectorIPN5clang14IdentifierInfoESaIS2_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS2_S4_EEmRKS2_", "std::vector<clang::IdentifierInfo*, std::allocator<clang::IdentifierInfo*> >::_M_fill_insert(__gnu_cxx::__normal_iterator<clang::IdentifierInfo**, std::vector<clang::IdentifierInfo*, std::allocator<clang::IdentifierInfo*> > >, unsigned long, clang::IdentifierInfo* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjSt4pairIPN5clang9ASTReader11PerFileDataEyENS_12DenseMapInfoIjEENS7_IS6_EEE16InsertIntoBucketERKjRKS6_PS1_IjS6_E", "llvm::DenseMap<unsigned int, std::pair<clang::ASTReader::PerFileData*, uint64_t>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<std::pair<clang::ASTReader::PerFileData*, uint64_t> > >::InsertIntoBucket(unsigned int const&, std::pair<clang::ASTReader::PerFileData*, uint64_t> const&, std::pair<unsigned int, std::pair<clang::ASTReader::PerFileData*, uint64_t> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjSt4pairIPN5clang9ASTReader11PerFileDataEyENS_12DenseMapInfoIjEENS7_IS6_EEE4growEj", "llvm::DenseMap<unsigned int, std::pair<clang::ASTReader::PerFileData*, uint64_t>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<std::pair<clang::ASTReader::PerFileData*, uint64_t> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjNS_11SmallVectorISt4pairIPN5clang9ASTReader11PerFileDataEyELj2EEENS_12DenseMapInfoIjEENS9_IS8_EEE16FindAndConstructERKj", "llvm::DenseMap<unsigned int, llvm::SmallVector<std::pair<clang::ASTReader::PerFileData*, uint64_t>, 2u>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::SmallVector<std::pair<clang::ASTReader::PerFileData*, uint64_t>, 2u> > >::FindAndConstruct(unsigned int const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjNS_11SmallVectorISt4pairIPN5clang9ASTReader11PerFileDataEyELj2EEENS_12DenseMapInfoIjEENS9_IS8_EEE16InsertIntoBucketERKjRKS8_PS2_IjS8_E", "llvm::DenseMap<unsigned int, llvm::SmallVector<std::pair<clang::ASTReader::PerFileData*, uint64_t>, 2u>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::SmallVector<std::pair<clang::ASTReader::PerFileData*, uint64_t>, 2u> > >::InsertIntoBucket(unsigned int const&, llvm::SmallVector<std::pair<clang::ASTReader::PerFileData*, uint64_t>, 2u> const&, std::pair<unsigned int, llvm::SmallVector<std::pair<clang::ASTReader::PerFileData*, uint64_t>, 2u> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjNS_11SmallVectorISt4pairIPN5clang9ASTReader11PerFileDataEyELj2EEENS_12DenseMapInfoIjEENS9_IS8_EEE4growEj", "llvm::DenseMap<unsigned int, llvm::SmallVector<std::pair<clang::ASTReader::PerFileData*, uint64_t>, 2u>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::SmallVector<std::pair<clang::ASTReader::PerFileData*, uint64_t>, 2u> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm15SmallVectorImplISt4pairIPN5clang9ASTReader11PerFileDataEyEEaSERKS7_", "llvm::SmallVectorImpl<std::pair<clang::ASTReader::PerFileData*, uint64_t> >::operator=(llvm::SmallVectorImpl<std::pair<clang::ASTReader::PerFileData*, uint64_t> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjNS_11SmallVectorIPvLj1EEENS_12DenseMapInfoIjEENS4_IS3_EEE16FindAndConstructERKj", "llvm::DenseMap<unsigned int, llvm::SmallVector<void*, 1u>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::SmallVector<void*, 1u> > >::FindAndConstruct(unsigned int const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjNS_11SmallVectorIPvLj1EEENS_12DenseMapInfoIjEENS4_IS3_EEE16InsertIntoBucketERKjRKS3_PSt4pairIjS3_E", "llvm::DenseMap<unsigned int, llvm::SmallVector<void*, 1u>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::SmallVector<void*, 1u> > >::InsertIntoBucket(unsigned int const&, llvm::SmallVector<void*, 1u> const&, std::pair<unsigned int, llvm::SmallVector<void*, 1u> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjNS_11SmallVectorIPvLj1EEENS_12DenseMapInfoIjEENS4_IS3_EEE4growEj", "llvm::DenseMap<unsigned int, llvm::SmallVector<void*, 1u>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::SmallVector<void*, 1u> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang11DeclContextENS_11SmallVectorINS1_9ASTReader15DeclContextInfoELj1EEENS_12DenseMapInfoIS4_EENS9_IS8_EEE16FindAndConstructERKS4_", "llvm::DenseMap<clang::DeclContext const*, llvm::SmallVector<clang::ASTReader::DeclContextInfo, 1u>, llvm::DenseMapInfo<clang::DeclContext const*>, llvm::DenseMapInfo<llvm::SmallVector<clang::ASTReader::DeclContextInfo, 1u> > >::FindAndConstruct(clang::DeclContext const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang11DeclContextENS_11SmallVectorINS1_9ASTReader15DeclContextInfoELj1EEENS_12DenseMapInfoIS4_EENS9_IS8_EEE16InsertIntoBucketERKS4_RKS8_PSt4pairIS4_S8_E", "llvm::DenseMap<clang::DeclContext const*, llvm::SmallVector<clang::ASTReader::DeclContextInfo, 1u>, llvm::DenseMapInfo<clang::DeclContext const*>, llvm::DenseMapInfo<llvm::SmallVector<clang::ASTReader::DeclContextInfo, 1u> > >::InsertIntoBucket(clang::DeclContext const* const&, llvm::SmallVector<clang::ASTReader::DeclContextInfo, 1u> const&, std::pair<clang::DeclContext const*, llvm::SmallVector<clang::ASTReader::DeclContextInfo, 1u> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang11DeclContextENS_11SmallVectorINS1_9ASTReader15DeclContextInfoELj1EEENS_12DenseMapInfoIS4_EENS9_IS8_EEE4growEj", "llvm::DenseMap<clang::DeclContext const*, llvm::SmallVector<clang::ASTReader::DeclContextInfo, 1u>, llvm::DenseMapInfo<clang::DeclContext const*>, llvm::DenseMapInfo<llvm::SmallVector<clang::ASTReader::DeclContextInfo, 1u> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang14IdentifierInfoEyNS_12DenseMapInfoIS3_EENS4_IyEEE16InsertIntoBucketERKS3_RKyPSt4pairIS3_yE", "llvm::DenseMap<clang::IdentifierInfo*, uint64_t, llvm::DenseMapInfo<clang::IdentifierInfo*>, llvm::DenseMapInfo<uint64_t> >::InsertIntoBucket(clang::IdentifierInfo* const&, uint64_t const&, std::pair<clang::IdentifierInfo*, uint64_t>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang14IdentifierInfoEyNS_12DenseMapInfoIS3_EENS4_IyEEE4growEj", "llvm::DenseMap<clang::IdentifierInfo*, uint64_t, llvm::DenseMapInfo<clang::IdentifierInfo*>, llvm::DenseMapInfo<uint64_t> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt8_Rb_treeIiSt4pairIKiiESt10_Select1stIS2_ESt4lessIiESaIS2_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS2_ERKS2_", "std::_Rb_tree<int, std::pair<int const, int>, std::_Select1st<std::pair<int const, int> >, std::less<int>, std::allocator<std::pair<int const, int> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<int const, int> >, std::pair<int const, int> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIiSt4pairIKiiESt10_Select1stIS2_ESt4lessIiESaIS2_EE16_M_insert_uniqueERKS2_", "std::_Rb_tree<int, std::pair<int const, int>, std::_Select1st<std::pair<int const, int> >, std::less<int>, std::allocator<std::pair<int const, int> > >::_M_insert_unique(std::pair<int const, int> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjPN5clang9LabelStmtEESt10_Select1stIS5_ESt4lessIjESaIS5_EE8_M_eraseEPSt13_Rb_tree_nodeIS5_E", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, clang::LabelStmt*>, std::_Select1st<std::pair<unsigned int const, clang::LabelStmt*> >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, clang::LabelStmt*> > >::_M_erase(std::_Rb_tree_node<std::pair<unsigned int const, clang::LabelStmt*> >*)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIjSsESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<std::pair<unsigned int, std::string>, std::allocator<std::pair<unsigned int, std::string> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<unsigned int, std::string>*, std::vector<std::pair<unsigned int, std::string>, std::allocator<std::pair<unsigned int, std::string> > > >, std::pair<unsigned int, std::string> const&)"),
	mu_demangle_test("_ZN9__gnu_cxx13new_allocatorIN4llvm15BitstreamReader9BlockInfoEE9constructEPS3_RKS3_", "__gnu_cxx::new_allocator<llvm::BitstreamReader::BlockInfo>::construct(llvm::BitstreamReader::BlockInfo*, llvm::BitstreamReader::BlockInfo const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm15BitstreamReader9BlockInfoESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::BitstreamReader::BlockInfo, std::allocator<llvm::BitstreamReader::BlockInfo> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::BitstreamReader::BlockInfo*, std::vector<llvm::BitstreamReader::BlockInfo, std::allocator<llvm::BitstreamReader::BlockInfo> > >, llvm::BitstreamReader::BlockInfo const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm13BitCodeAbbrevESaIS2_EEaSERKS4_", "std::vector<llvm::BitCodeAbbrev*, std::allocator<llvm::BitCodeAbbrev*> >::operator=(std::vector<llvm::BitCodeAbbrev*, std::allocator<llvm::BitCodeAbbrev*> > const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIjSsESaIS1_EEaSERKS3_", "std::vector<std::pair<unsigned int, std::string>, std::allocator<std::pair<unsigned int, std::string> > >::operator=(std::vector<std::pair<unsigned int, std::string>, std::allocator<std::pair<unsigned int, std::string> > > const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIjSsESaIS1_EEC2ERKS3_", "std::vector<std::pair<unsigned int, std::string>, std::allocator<std::pair<unsigned int, std::string> > >::vector(std::vector<std::pair<unsigned int, std::string>, std::allocator<std::pair<unsigned int, std::string> > > const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm13BitCodeAbbrevESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::BitCodeAbbrev*, std::allocator<llvm::BitCodeAbbrev*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::BitCodeAbbrev**, std::vector<llvm::BitCodeAbbrev*, std::allocator<llvm::BitCodeAbbrev*> > >, llvm::BitCodeAbbrev* const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIiSt4pairIKiiESt10_Select1stIS2_ESt4lessIiESaIS2_EE8_M_eraseEPSt13_Rb_tree_nodeIS2_E", "std::_Rb_tree<int, std::pair<int const, int>, std::_Select1st<std::pair<int const, int> >, std::less<int>, std::allocator<std::pair<int const, int> > >::_M_erase(std::_Rb_tree_node<std::pair<int const, int> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclENS_11SmallVectorIPS2_Lj4EEENS_12DenseMapInfoIS4_EENS8_IS7_EEE16FindAndConstructERKS4_", "llvm::DenseMap<clang::CXXRecordDecl const*, llvm::SmallVector<clang::CXXRecordDecl*, 4u>, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<llvm::SmallVector<clang::CXXRecordDecl*, 4u> > >::FindAndConstruct(clang::CXXRecordDecl const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclENS_11SmallVectorIPS2_Lj4EEENS_12DenseMapInfoIS4_EENS8_IS7_EEE16InsertIntoBucketERKS4_RKS7_PSt4pairIS4_S7_E", "llvm::DenseMap<clang::CXXRecordDecl const*, llvm::SmallVector<clang::CXXRecordDecl*, 4u>, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<llvm::SmallVector<clang::CXXRecordDecl*, 4u> > >::InsertIntoBucket(clang::CXXRecordDecl const* const&, llvm::SmallVector<clang::CXXRecordDecl*, 4u> const&, std::pair<clang::CXXRecordDecl const*, llvm::SmallVector<clang::CXXRecordDecl*, 4u> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclENS_11SmallVectorIPS2_Lj4EEENS_12DenseMapInfoIS4_EENS8_IS7_EEE4growEj", "llvm::DenseMap<clang::CXXRecordDecl const*, llvm::SmallVector<clang::CXXRecordDecl*, 4u>, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<llvm::SmallVector<clang::CXXRecordDecl*, 4u> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN5clang13serialization10MakeTypeIDISt9binder1stISt10mem_fun1_tINS0_7TypeIdxENS_9ASTWriterENS_8QualTypeEEEEEjS6_T_", "unsigned int clang::serialization::MakeTypeID<std::binder1st<std::mem_fun1_t<clang::serialization::TypeIdx, clang::ASTWriter, clang::QualType> > >(clang::QualType, std::binder1st<std::mem_fun1_t<clang::serialization::TypeIdx, clang::ASTWriter, clang::QualType> >)"),
	mu_demangle_test("_ZN5clang13serialization10MakeTypeIDISt9binder1stISt16const_mem_fun1_tINS0_7TypeIdxENS_9ASTWriterENS_8QualTypeEEEEEjS6_T_", "unsigned int clang::serialization::MakeTypeID<std::binder1st<std::const_mem_fun1_t<clang::serialization::TypeIdx, clang::ASTWriter, clang::QualType> > >(clang::QualType, std::binder1st<std::const_mem_fun1_t<clang::serialization::TypeIdx, clang::ASTWriter, clang::QualType> >)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4DeclENS_11SmallVectorIyLj2EEENS_12DenseMapInfoIS4_EENS7_IS6_EEE16FindAndConstructERKS4_", "llvm::DenseMap<clang::Decl const*, llvm::SmallVector<uint64_t, 2u>, llvm::DenseMapInfo<clang::Decl const*>, llvm::DenseMapInfo<llvm::SmallVector<uint64_t, 2u> > >::FindAndConstruct(clang::Decl const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4DeclENS_11SmallVectorIyLj2EEENS_12DenseMapInfoIS4_EENS7_IS6_EEE16InsertIntoBucketERKS4_RKS6_PSt4pairIS4_S6_E", "llvm::DenseMap<clang::Decl const*, llvm::SmallVector<uint64_t, 2u>, llvm::DenseMapInfo<clang::Decl const*>, llvm::DenseMapInfo<llvm::SmallVector<uint64_t, 2u> > >::InsertIntoBucket(clang::Decl const* const&, llvm::SmallVector<uint64_t, 2u> const&, std::pair<clang::Decl const*, llvm::SmallVector<uint64_t, 2u> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4DeclENS_11SmallVectorIyLj2EEENS_12DenseMapInfoIS4_EENS7_IS6_EEE4growEj", "llvm::DenseMap<clang::Decl const*, llvm::SmallVector<uint64_t, 2u>, llvm::DenseMapInfo<clang::Decl const*>, llvm::DenseMapInfo<llvm::SmallVector<uint64_t, 2u> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang15MacroDefinitionEjNS_12DenseMapInfoIS4_EENS5_IjEEE16InsertIntoBucketERKS4_RKjPSt4pairIS4_jE", "llvm::DenseMap<clang::MacroDefinition const*, unsigned int, llvm::DenseMapInfo<clang::MacroDefinition const*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(clang::MacroDefinition const* const&, unsigned int const&, std::pair<clang::MacroDefinition const*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang15MacroDefinitionEjNS_12DenseMapInfoIS4_EENS5_IjEEE4growEj", "llvm::DenseMap<clang::MacroDefinition const*, unsigned int, llvm::DenseMapInfo<clang::MacroDefinition const*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt5dequeIN5clang9ASTWriter10DeclOrTypeESaIS2_EE9push_backERKS2_", "std::deque<clang::ASTWriter::DeclOrType, std::allocator<clang::ASTWriter::DeclOrType> >::push_back(clang::ASTWriter::DeclOrType const&)"),
	mu_demangle_test("_ZNSt5dequeIN5clang9ASTWriter10DeclOrTypeESaIS2_EE17_M_reallocate_mapEmb", "std::deque<clang::ASTWriter::DeclOrType, std::allocator<clang::ASTWriter::DeclOrType> >::_M_reallocate_map(unsigned long, bool)"),
	mu_demangle_test("_ZNSt11_Deque_baseIN5clang9ASTWriter10DeclOrTypeESaIS2_EE17_M_initialize_mapEm", "std::_Deque_base<clang::ASTWriter::DeclOrType, std::allocator<clang::ASTWriter::DeclOrType> >::_M_initialize_map(unsigned long)"),
	mu_demangle_test("_ZNSt5dequeIN5clang9ASTWriter10DeclOrTypeESaIS2_EEC2ERKS4_", "std::deque<clang::ASTWriter::DeclOrType, std::allocator<clang::ASTWriter::DeclOrType> >::deque(std::deque<clang::ASTWriter::DeclOrType, std::allocator<clang::ASTWriter::DeclOrType> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang8SelectorEjNS_12DenseMapInfoIS2_EENS3_IjEEE16InsertIntoBucketERKS2_RKjPSt4pairIS2_jE", "llvm::DenseMap<clang::Selector, unsigned int, llvm::DenseMapInfo<clang::Selector>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(clang::Selector const&, unsigned int const&, std::pair<clang::Selector, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang8SelectorEjNS_12DenseMapInfoIS2_EENS3_IjEEE4growEj", "llvm::DenseMap<clang::Selector, unsigned int, llvm::DenseMapInfo<clang::Selector>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIhSaIhEE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPhS1_EERKh", "std::vector<unsigned char, std::allocator<unsigned char> >::_M_insert_aux(__gnu_cxx::__normal_iterator<unsigned char*, std::vector<unsigned char, std::allocator<unsigned char> > >, unsigned char const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang14IdentifierInfoEyNS_12DenseMapInfoIS4_EENS5_IyEEE16InsertIntoBucketERKS4_RKyPSt4pairIS4_yE", "llvm::DenseMap<clang::IdentifierInfo const*, uint64_t, llvm::DenseMapInfo<clang::IdentifierInfo const*>, llvm::DenseMapInfo<uint64_t> >::InsertIntoBucket(clang::IdentifierInfo const* const&, uint64_t const&, std::pair<clang::IdentifierInfo const*, uint64_t>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang14IdentifierInfoEyNS_12DenseMapInfoIS4_EENS5_IyEEE4growEj", "llvm::DenseMap<clang::IdentifierInfo const*, uint64_t, llvm::DenseMapInfo<clang::IdentifierInfo const*>, llvm::DenseMapInfo<uint64_t> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm15BitstreamWriter5BlockESaIS2_EE9push_backERKS2_", "std::vector<llvm::BitstreamWriter::Block, std::allocator<llvm::BitstreamWriter::Block> >::push_back(llvm::BitstreamWriter::Block const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm15BitstreamWriter5BlockESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::BitstreamWriter::Block, std::allocator<llvm::BitstreamWriter::Block> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::BitstreamWriter::Block*, std::vector<llvm::BitstreamWriter::Block, std::allocator<llvm::BitstreamWriter::Block> > >, llvm::BitstreamWriter::Block const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN5clang9LabelStmtESt4pairIKS2_jESt10_Select1stIS5_ESt4lessIS2_ESaIS5_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS5_ERKS5_", "std::_Rb_tree<clang::LabelStmt*, std::pair<clang::LabelStmt* const, unsigned int>, std::_Select1st<std::pair<clang::LabelStmt* const, unsigned int> >, std::less<clang::LabelStmt*>, std::allocator<std::pair<clang::LabelStmt* const, unsigned int> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<clang::LabelStmt* const, unsigned int> >, std::pair<clang::LabelStmt* const, unsigned int> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN5clang9LabelStmtESt4pairIKS2_jESt10_Select1stIS5_ESt4lessIS2_ESaIS5_EE16_M_insert_uniqueERKS5_", "std::_Rb_tree<clang::LabelStmt*, std::pair<clang::LabelStmt* const, unsigned int>, std::_Select1st<std::pair<clang::LabelStmt* const, unsigned int> >, std::less<clang::LabelStmt*>, std::allocator<std::pair<clang::LabelStmt* const, unsigned int> > >::_M_insert_unique(std::pair<clang::LabelStmt* const, unsigned int> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN5clang10SwitchCaseESt4pairIKS2_jESt10_Select1stIS5_ESt4lessIS2_ESaIS5_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS5_ERKS5_", "std::_Rb_tree<clang::SwitchCase*, std::pair<clang::SwitchCase* const, unsigned int>, std::_Select1st<std::pair<clang::SwitchCase* const, unsigned int> >, std::less<clang::SwitchCase*>, std::allocator<std::pair<clang::SwitchCase* const, unsigned int> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<clang::SwitchCase* const, unsigned int> >, std::pair<clang::SwitchCase* const, unsigned int> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN5clang10SwitchCaseESt4pairIKS2_jESt10_Select1stIS5_ESt4lessIS2_ESaIS5_EE16_M_insert_uniqueERKS5_", "std::_Rb_tree<clang::SwitchCase*, std::pair<clang::SwitchCase* const, unsigned int>, std::_Select1st<std::pair<clang::SwitchCase* const, unsigned int> >, std::less<clang::SwitchCase*>, std::allocator<std::pair<clang::SwitchCase* const, unsigned int> > >::_M_insert_unique(std::pair<clang::SwitchCase* const, unsigned int> const&)"),
	mu_demangle_test("_ZN5clang7CodeGen15CodeGenFunction21GenerateBlockFunctionENS0_10GlobalDeclERKNS0_11CGBlockInfoEPKNS_4DeclERKN4llvm8DenseMapIS8_PNS9_5ValueENS9_12DenseMapInfoIS8_EENSD_ISC_EEEE", "clang::CodeGen::CodeGenFunction::GenerateBlockFunction(clang::CodeGen::GlobalDecl, clang::CodeGen::CGBlockInfo const&, clang::Decl const*, llvm::DenseMap<clang::Decl const*, llvm::Value*, llvm::DenseMapInfo<clang::Decl const*>, llvm::DenseMapInfo<llvm::Value*> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIyPNS_8ConstantENS_12DenseMapInfoIyEENS3_IS2_EEE16InsertIntoBucketERKyRKS2_PSt4pairIyS2_E", "llvm::DenseMap<uint64_t, llvm::Constant*, llvm::DenseMapInfo<uint64_t>, llvm::DenseMapInfo<llvm::Constant*> >::InsertIntoBucket(uint64_t const&, llvm::Constant* const&, std::pair<uint64_t, llvm::Constant*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIyPNS_8ConstantENS_12DenseMapInfoIyEENS3_IS2_EEE4growEj", "llvm::DenseMap<uint64_t, llvm::Constant*, llvm::DenseMapInfo<uint64_t>, llvm::DenseMapInfo<llvm::Constant*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang7VarDeclENS1_7CodeGen11CGBlockInfo7CaptureENS_12DenseMapInfoIS4_EENS8_IS7_EEE16InsertIntoBucketERKS4_RKS7_PSt4pairIS4_S7_E", "llvm::DenseMap<clang::VarDecl const*, clang::CodeGen::CGBlockInfo::Capture, llvm::DenseMapInfo<clang::VarDecl const*>, llvm::DenseMapInfo<clang::CodeGen::CGBlockInfo::Capture> >::InsertIntoBucket(clang::VarDecl const* const&, clang::CodeGen::CGBlockInfo::Capture const&, std::pair<clang::VarDecl const*, clang::CodeGen::CGBlockInfo::Capture>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang7VarDeclENS1_7CodeGen11CGBlockInfo7CaptureENS_12DenseMapInfoIS4_EENS8_IS7_EEE4growEj", "llvm::DenseMap<clang::VarDecl const*, clang::CodeGen::CGBlockInfo::Capture, llvm::DenseMapInfo<clang::VarDecl const*>, llvm::DenseMapInfo<clang::CodeGen::CGBlockInfo::Capture> >::grow(unsigned int)"),
	mu_demangle_test("_ZN5clang7CodeGen12CodeGenTypes15getFunctionInfoENS_7CanQualINS_4TypeEEERKN4llvm15SmallVectorImplIS4_EERKNS_12FunctionType7ExtInfoEb", "clang::CodeGen::CodeGenTypes::getFunctionInfo(clang::CanQual<clang::Type>, llvm::SmallVectorImpl<clang::CanQual<clang::Type> > const&, clang::FunctionType::ExtInfo const&, bool)"),
	mu_demangle_test("_Z15getFunctionInfoRN5clang7CodeGen12CodeGenTypesERN4llvm15SmallVectorImplINS_7CanQualINS_4TypeEEEEENS5_INS_17FunctionProtoTypeEEEb", "getFunctionInfo(clang::CodeGen::CodeGenTypes&, llvm::SmallVectorImpl<clang::CanQual<clang::Type> >&, clang::CanQual<clang::FunctionProtoType>, bool)"),
	mu_demangle_test("_ZN5clang7CodeGen12CodeGenTypes16GetExpandedTypesENS_8QualTypeERSt6vectorIPKN4llvm4TypeESaIS7_EEb", "clang::CodeGen::CodeGenTypes::GetExpandedTypes(clang::QualType, std::vector<llvm::Type const*, std::allocator<llvm::Type const*> >&, bool)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE18CreateConstGEP2_32EPNS_5ValueEjjRKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateConstGEP2_32(llvm::Value*, unsigned int, unsigned int, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE13CreateRetVoidEv", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateRetVoid()"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE9CreateRetEPNS_5ValueE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateRet(llvm::Value*)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE10CreateCallIPKPNS_5ValueEEEPNS_8CallInstES7_T_SC_RKNS_5TwineE", "llvm::CallInst* llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateCall<llvm::Value* const*>(llvm::Value*, llvm::Value* const*, llvm::Value* const*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE12CreateInvokeIPKPNS_5ValueEEEPNS_10InvokeInstES7_PNS_10BasicBlockESD_T_SE_RKNS_5TwineE", "llvm::InvokeInst* llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateInvoke<llvm::Value* const*>(llvm::Value*, llvm::BasicBlock*, llvm::BasicBlock*, llvm::Value* const*, llvm::Value* const*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE18CreateExtractValueEPNS_5ValueEjRKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateExtractValue(llvm::Value*, unsigned int, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE13CreateIntCastEPNS_5ValueEPKNS_4TypeEbRKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateIntCast(llvm::Value*, llvm::Type const*, bool, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE18CreateConstGEP1_64EPNS_5ValueEyRKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateConstGEP1_64(llvm::Value*, uint64_t, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE26CreateConstInBoundsGEP2_64EPNS_5ValueEyyRKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateConstInBoundsGEP2_64(llvm::Value*, uint64_t, uint64_t, llvm::Twine const&)"),
	mu_demangle_test("_ZN5clang7CodeGen11CGDebugInfo17EmitFunctionStartENS0_10GlobalDeclENS_8QualTypeEPN4llvm8FunctionERNS4_9IRBuilderILb0ENS4_14ConstantFolderENS4_24IRBuilderDefaultInserterILb0EEEEE", "clang::CodeGen::CGDebugInfo::EmitFunctionStart(clang::CodeGen::GlobalDecl, clang::QualType, llvm::Function*, llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >&)"),
	mu_demangle_test("_ZN5clang7CodeGen11CGDebugInfo13EmitStopPointERN4llvm9IRBuilderILb0ENS2_14ConstantFolderENS2_24IRBuilderDefaultInserterILb0EEEEE", "clang::CodeGen::CGDebugInfo::EmitStopPoint(llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >&)"),
	mu_demangle_test("_ZN5clang7CodeGen11CGDebugInfo25UpdateLineDirectiveRegionERN4llvm9IRBuilderILb0ENS2_14ConstantFolderENS2_24IRBuilderDefaultInserterILb0EEEEE", "clang::CodeGen::CGDebugInfo::UpdateLineDirectiveRegion(llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >&)"),
	mu_demangle_test("_ZN5clang7CodeGen11CGDebugInfo15EmitRegionStartERN4llvm9IRBuilderILb0ENS2_14ConstantFolderENS2_24IRBuilderDefaultInserterILb0EEEEE", "clang::CodeGen::CGDebugInfo::EmitRegionStart(llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >&)"),
	mu_demangle_test("_ZN5clang7CodeGen11CGDebugInfo13EmitRegionEndERN4llvm9IRBuilderILb0ENS2_14ConstantFolderENS2_24IRBuilderDefaultInserterILb0EEEEE", "clang::CodeGen::CGDebugInfo::EmitRegionEnd(llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >&)"),
	mu_demangle_test("_ZN5clang7CodeGen11CGDebugInfo15EmitFunctionEndERN4llvm9IRBuilderILb0ENS2_14ConstantFolderENS2_24IRBuilderDefaultInserterILb0EEEEE", "clang::CodeGen::CGDebugInfo::EmitFunctionEnd(llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >&)"),
	mu_demangle_test("_ZN5clang7CodeGen11CGDebugInfo11EmitDeclareEPKNS_7VarDeclEjPN4llvm5ValueERNS5_9IRBuilderILb0ENS5_14ConstantFolderENS5_24IRBuilderDefaultInserterILb0EEEEEb", "clang::CodeGen::CGDebugInfo::EmitDeclare(clang::VarDecl const*, unsigned int, llvm::Value*, llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >&, bool)"),
	mu_demangle_test("_ZN5clang7CodeGen11CGDebugInfo11EmitDeclareEPKNS_7VarDeclEjPN4llvm5ValueERNS5_9IRBuilderILb0ENS5_14ConstantFolderENS5_24IRBuilderDefaultInserterILb0EEEEERKNS0_11CGBlockInfoE", "clang::CodeGen::CGDebugInfo::EmitDeclare(clang::VarDecl const*, unsigned int, llvm::Value*, llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >&, clang::CodeGen::CGBlockInfo const&)"),
	mu_demangle_test("_ZN5clang7CodeGen11CGDebugInfo25EmitDeclareOfAutoVariableEPKNS_7VarDeclEPN4llvm5ValueERNS5_9IRBuilderILb0ENS5_14ConstantFolderENS5_24IRBuilderDefaultInserterILb0EEEEE", "clang::CodeGen::CGDebugInfo::EmitDeclareOfAutoVariable(clang::VarDecl const*, llvm::Value*, llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >&)"),
	mu_demangle_test("_ZN5clang7CodeGen11CGDebugInfo33EmitDeclareOfBlockDeclRefVariableEPKNS_7VarDeclEPN4llvm5ValueERNS5_9IRBuilderILb0ENS5_14ConstantFolderENS5_24IRBuilderDefaultInserterILb0EEEEERKNS0_11CGBlockInfoE", "clang::CodeGen::CGDebugInfo::EmitDeclareOfBlockDeclRefVariable(clang::VarDecl const*, llvm::Value*, llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >&, clang::CodeGen::CGBlockInfo const&)"),
	mu_demangle_test("_ZN5clang7CodeGen11CGDebugInfo24EmitDeclareOfArgVariableEPKNS_7VarDeclEPN4llvm5ValueERNS5_9IRBuilderILb0ENS5_14ConstantFolderENS5_24IRBuilderDefaultInserterILb0EEEEEb", "clang::CodeGen::CGDebugInfo::EmitDeclareOfArgVariable(clang::VarDecl const*, llvm::Value*, llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >&, bool)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13NamespaceDeclENS_6WeakVHENS_12DenseMapInfoIS4_EENS6_IS5_EEE16FindAndConstructERKS4_", "llvm::DenseMap<clang::NamespaceDecl const*, llvm::WeakVH, llvm::DenseMapInfo<clang::NamespaceDecl const*>, llvm::DenseMapInfo<llvm::WeakVH> >::FindAndConstruct(clang::NamespaceDecl const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13NamespaceDeclENS_6WeakVHENS_12DenseMapInfoIS4_EENS6_IS5_EEE16InsertIntoBucketERKS4_RKS5_PSt4pairIS4_S5_E", "llvm::DenseMap<clang::NamespaceDecl const*, llvm::WeakVH, llvm::DenseMapInfo<clang::NamespaceDecl const*>, llvm::DenseMapInfo<llvm::WeakVH> >::InsertIntoBucket(clang::NamespaceDecl const* const&, llvm::WeakVH const&, std::pair<clang::NamespaceDecl const*, llvm::WeakVH>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13NamespaceDeclENS_6WeakVHENS_12DenseMapInfoIS4_EENS6_IS5_EEE4growEj", "llvm::DenseMap<clang::NamespaceDecl const*, llvm::WeakVH, llvm::DenseMapInfo<clang::NamespaceDecl const*>, llvm::DenseMapInfo<llvm::WeakVH> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4DeclENS_6WeakVHENS_12DenseMapInfoIS4_EENS6_IS5_EEE16FindAndConstructERKS4_", "llvm::DenseMap<clang::Decl const*, llvm::WeakVH, llvm::DenseMapInfo<clang::Decl const*>, llvm::DenseMapInfo<llvm::WeakVH> >::FindAndConstruct(clang::Decl const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4DeclENS_6WeakVHENS_12DenseMapInfoIS4_EENS6_IS5_EEE16InsertIntoBucketERKS4_RKS5_PSt4pairIS4_S5_E", "llvm::DenseMap<clang::Decl const*, llvm::WeakVH, llvm::DenseMapInfo<clang::Decl const*>, llvm::DenseMapInfo<llvm::WeakVH> >::InsertIntoBucket(clang::Decl const* const&, llvm::WeakVH const&, std::pair<clang::Decl const*, llvm::WeakVH>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4DeclENS_6WeakVHENS_12DenseMapInfoIS4_EENS6_IS5_EEE4growEj", "llvm::DenseMap<clang::Decl const*, llvm::WeakVH, llvm::DenseMapInfo<clang::Decl const*>, llvm::DenseMapInfo<llvm::WeakVH> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm10TrackingVHINS0_6MDNodeEEESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<llvm::TrackingVH<llvm::MDNode>, std::allocator<llvm::TrackingVH<llvm::MDNode> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::TrackingVH<llvm::MDNode>*, std::vector<llvm::TrackingVH<llvm::MDNode>, std::allocator<llvm::TrackingVH<llvm::MDNode> > > >, llvm::TrackingVH<llvm::MDNode> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang12FunctionDeclENS_6WeakVHENS_12DenseMapInfoIS4_EENS6_IS5_EEE16FindAndConstructERKS4_", "llvm::DenseMap<clang::FunctionDecl const*, llvm::WeakVH, llvm::DenseMapInfo<clang::FunctionDecl const*>, llvm::DenseMapInfo<llvm::WeakVH> >::FindAndConstruct(clang::FunctionDecl const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang12FunctionDeclENS_6WeakVHENS_12DenseMapInfoIS4_EENS6_IS5_EEE16InsertIntoBucketERKS4_RKS5_PSt4pairIS4_S5_E", "llvm::DenseMap<clang::FunctionDecl const*, llvm::WeakVH, llvm::DenseMapInfo<clang::FunctionDecl const*>, llvm::DenseMapInfo<llvm::WeakVH> >::InsertIntoBucket(clang::FunctionDecl const* const&, llvm::WeakVH const&, std::pair<clang::FunctionDecl const*, llvm::WeakVH>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang12FunctionDeclENS_6WeakVHENS_12DenseMapInfoIS4_EENS6_IS5_EEE4growEj", "llvm::DenseMap<clang::FunctionDecl const*, llvm::WeakVH, llvm::DenseMapInfo<clang::FunctionDecl const*>, llvm::DenseMapInfo<llvm::WeakVH> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPvNS_6WeakVHENS_12DenseMapInfoIS1_EENS3_IS2_EEE16FindAndConstructERKS1_", "llvm::DenseMap<void*, llvm::WeakVH, llvm::DenseMapInfo<void*>, llvm::DenseMapInfo<llvm::WeakVH> >::FindAndConstruct(void* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPvNS_6WeakVHENS_12DenseMapInfoIS1_EENS3_IS2_EEE16InsertIntoBucketERKS1_RKS2_PSt4pairIS1_S2_E", "llvm::DenseMap<void*, llvm::WeakVH, llvm::DenseMapInfo<void*>, llvm::DenseMapInfo<llvm::WeakVH> >::InsertIntoBucket(void* const&, llvm::WeakVH const&, std::pair<void*, llvm::WeakVH>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPvNS_6WeakVHENS_12DenseMapInfoIS1_EENS3_IS2_EEE4growEj", "llvm::DenseMap<void*, llvm::WeakVH, llvm::DenseMapInfo<void*>, llvm::DenseMapInfo<llvm::WeakVH> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKcNS_6WeakVHENS_12DenseMapInfoIS2_EENS4_IS3_EEE16FindAndConstructERKS2_", "llvm::DenseMap<char const*, llvm::WeakVH, llvm::DenseMapInfo<char const*>, llvm::DenseMapInfo<llvm::WeakVH> >::FindAndConstruct(char const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKcNS_6WeakVHENS_12DenseMapInfoIS2_EENS4_IS3_EEE16InsertIntoBucketERKS2_RKS3_PSt4pairIS2_S3_E", "llvm::DenseMap<char const*, llvm::WeakVH, llvm::DenseMapInfo<char const*>, llvm::DenseMapInfo<llvm::WeakVH> >::InsertIntoBucket(char const* const&, llvm::WeakVH const&, std::pair<char const*, llvm::WeakVH>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKcNS_6WeakVHENS_12DenseMapInfoIS2_EENS4_IS3_EEE4growEj", "llvm::DenseMap<char const*, llvm::WeakVH, llvm::DenseMapInfo<char const*>, llvm::DenseMapInfo<llvm::WeakVH> >::grow(unsigned int)"),
	mu_demangle_test("_Z28emitStoresForInitAfterMemsetPN4llvm8ConstantEPNS_5ValueERNS_9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEEE", "emitStoresForInitAfterMemset(llvm::Constant*, llvm::Value*, llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang9ValueDeclESt4pairIPKNS_4TypeEjENS_12DenseMapInfoIS4_EENSA_IS9_EEE16InsertIntoBucketERKS4_RKS9_PS5_IS4_S9_E", "llvm::DenseMap<clang::ValueDecl const*, std::pair<llvm::Type const*, unsigned int>, llvm::DenseMapInfo<clang::ValueDecl const*>, llvm::DenseMapInfo<std::pair<llvm::Type const*, unsigned int> > >::InsertIntoBucket(clang::ValueDecl const* const&, std::pair<llvm::Type const*, unsigned int> const&, std::pair<clang::ValueDecl const*, std::pair<llvm::Type const*, unsigned int> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang9ValueDeclESt4pairIPKNS_4TypeEjENS_12DenseMapInfoIS4_EENSA_IS9_EEE4growEj", "llvm::DenseMap<clang::ValueDecl const*, std::pair<llvm::Type const*, unsigned int>, llvm::DenseMapInfo<clang::ValueDecl const*>, llvm::DenseMapInfo<std::pair<llvm::Type const*, unsigned int> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN5clang7CodeGen15CodeGenFunction25GenerateCXXGlobalDtorFuncEPN4llvm8FunctionERKSt6vectorISt4pairINS2_6WeakVHEPNS2_8ConstantEESaISA_EE", "clang::CodeGen::CodeGenFunction::GenerateCXXGlobalDtorFunc(llvm::Function*, std::vector<std::pair<llvm::WeakVH, llvm::Constant*>, std::allocator<std::pair<llvm::WeakVH, llvm::Constant*> > > const&)"),
	mu_demangle_test("_ZN4llvm25array_pod_sort_comparatorISt4pairIN5clang7CodeGen16OrderGlobalInitsEPNS_8FunctionEEEEiPKvS9_", "int llvm::array_pod_sort_comparator<std::pair<clang::CodeGen::OrderGlobalInits, llvm::Function*> >(void const*, void const*)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE10CreateCallEPNS_5ValueERKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateCall(llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN4llvm6WeakVHEPNS1_8ConstantEESaIS5_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS5_S7_EERKS5_", "std::vector<std::pair<llvm::WeakVH, llvm::Constant*>, std::allocator<std::pair<llvm::WeakVH, llvm::Constant*> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::WeakVH, llvm::Constant*>*, std::vector<std::pair<llvm::WeakVH, llvm::Constant*>, std::allocator<std::pair<llvm::WeakVH, llvm::Constant*> > > >, std::pair<llvm::WeakVH, llvm::Constant*> const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE12CreateInvokeEPNS_5ValueEPNS_10BasicBlockES8_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateInvoke(llvm::Value*, llvm::BasicBlock*, llvm::BasicBlock*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE13CreateInvoke3EPNS_5ValueEPNS_10BasicBlockES8_S6_S6_S6_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateInvoke3(llvm::Value*, llvm::BasicBlock*, llvm::BasicBlock*, llvm::Value*, llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5ValueEN5clang7CodeGen15CodeGenFunction10UnwindDestENS_12DenseMapInfoIS2_EENS7_IS6_EEE16InsertIntoBucketERKS2_RKS6_PSt4pairIS2_S6_E", "llvm::DenseMap<llvm::Value*, clang::CodeGen::CodeGenFunction::UnwindDest, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<clang::CodeGen::CodeGenFunction::UnwindDest> >::InsertIntoBucket(llvm::Value* const&, clang::CodeGen::CodeGenFunction::UnwindDest const&, std::pair<llvm::Value*, clang::CodeGen::CodeGenFunction::UnwindDest>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5ValueEN5clang7CodeGen15CodeGenFunction10UnwindDestENS_12DenseMapInfoIS2_EENS7_IS6_EEE4growEj", "llvm::DenseMap<llvm::Value*, clang::CodeGen::CodeGenFunction::UnwindDest, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<clang::CodeGen::CodeGenFunction::UnwindDest> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE17CreateInBoundsGEPIPPNS_5ValueEEES7_S7_T_S9_RKNS_5TwineE", "llvm::Value* llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateInBoundsGEP<llvm::Value**>(llvm::Value*, llvm::Value**, llvm::Value**, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4ExprENS1_7CodeGen6LValueENS_12DenseMapInfoIS4_EENS7_IS6_EEE16InsertIntoBucketERKS4_RKS6_PSt4pairIS4_S6_E", "llvm::DenseMap<clang::Expr const*, clang::CodeGen::LValue, llvm::DenseMapInfo<clang::Expr const*>, llvm::DenseMapInfo<clang::CodeGen::LValue> >::InsertIntoBucket(clang::Expr const* const&, clang::CodeGen::LValue const&, std::pair<clang::Expr const*, clang::CodeGen::LValue>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4ExprENS1_7CodeGen6LValueENS_12DenseMapInfoIS4_EENS7_IS6_EEE4growEj", "llvm::DenseMap<clang::Expr const*, clang::CodeGen::LValue, llvm::DenseMapInfo<clang::Expr const*>, llvm::DenseMapInfo<clang::CodeGen::LValue> >::grow(unsigned int)"),
	mu_demangle_test("_ZN5clang11StmtVisitorIN12_GLOBAL__N_118ComplexExprEmitterESt4pairIPN4llvm5ValueES6_EE5VisitEPNS_4StmtE", "clang::StmtVisitor<(anonymous namespace)::ComplexExprEmitter, std::pair<llvm::Value*, llvm::Value*> >::Visit(clang::Stmt*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4ExprESt4pairIPNS_5ValueES7_ENS_12DenseMapInfoIS4_EENS9_IS8_EEE16InsertIntoBucketERKS4_RKS8_PS5_IS4_S8_E", "llvm::DenseMap<clang::Expr const*, std::pair<llvm::Value*, llvm::Value*>, llvm::DenseMapInfo<clang::Expr const*>, llvm::DenseMapInfo<std::pair<llvm::Value*, llvm::Value*> > >::InsertIntoBucket(clang::Expr const* const&, std::pair<llvm::Value*, llvm::Value*> const&, std::pair<clang::Expr const*, std::pair<llvm::Value*, llvm::Value*> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4ExprESt4pairIPNS_5ValueES7_ENS_12DenseMapInfoIS4_EENS9_IS8_EEE4growEj", "llvm::DenseMap<clang::Expr const*, std::pair<llvm::Value*, llvm::Value*>, llvm::DenseMapInfo<clang::Expr const*>, llvm::DenseMapInfo<std::pair<llvm::Value*, llvm::Value*> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE10CreateFNegEPNS_5ValueERKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateFNeg(llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_Z28FillInNullDataMemberPointersRN5clang7CodeGen13CodeGenModuleENS_8QualTypeERSt6vectorIPN4llvm8ConstantESaIS7_EEy", "FillInNullDataMemberPointers(clang::CodeGen::CodeGenModule&, clang::QualType, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >&, uint64_t)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm8ConstantESaIS2_EEaSERKS4_", "std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >::operator=(std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4DeclEPNS_5ValueENS_12DenseMapInfoIS4_EENS7_IS6_EEE16InsertIntoBucketERKS4_RKS6_PSt4pairIS4_S6_E", "llvm::DenseMap<clang::Decl const*, llvm::Value*, llvm::DenseMapInfo<clang::Decl const*>, llvm::DenseMapInfo<llvm::Value*> >::InsertIntoBucket(clang::Decl const* const&, llvm::Value* const&, std::pair<clang::Decl const*, llvm::Value*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4DeclEPNS_5ValueENS_12DenseMapInfoIS4_EENS7_IS6_EEE4growEj", "llvm::DenseMap<clang::Decl const*, llvm::Value*, llvm::DenseMapInfo<clang::Decl const*>, llvm::DenseMapInfo<llvm::Value*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE9CreateXorEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateXor(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE10CreateLShrEPNS_5ValueES6_RKNS_5TwineEb", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateLShr(llvm::Value*, llvm::Value*, llvm::Twine const&, bool)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE9CreateShlEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateShl(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE10CreateFSubEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateFSub(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE9CreateNegEPNS_5ValueERKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateNeg(llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE10CreateSDivEPNS_5ValueES6_RKNS_5TwineEb", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateSDiv(llvm::Value*, llvm::Value*, llvm::Twine const&, bool)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE11CreateCall4EPNS_5ValueES6_S6_S6_S6_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateCall4(llvm::Value*, llvm::Value*, llvm::Value*, llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE10CreateFAddEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateFAdd(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE10CreateURemEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateURem(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE10CreateSRemEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateSRem(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE10CreateFDivEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateFDiv(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE10CreateUDivEPNS_5ValueES6_RKNS_5TwineEb", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateUDiv(llvm::Value*, llvm::Value*, llvm::Twine const&, bool)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE10CreateFCmpENS_7CmpInst9PredicateEPNS_5ValueES8_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateFCmp(llvm::CmpInst::Predicate, llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE12CreateNSWMulEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateNSWMul(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE10CreateFMulEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateFMul(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE19CreateInsertElementEPNS_5ValueES6_S6_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateInsertElement(llvm::Value*, llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE19CreateShuffleVectorEPNS_5ValueES6_S6_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateShuffleVector(llvm::Value*, llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE11CreateVAArgEPNS_5ValueEPKNS_4TypeERKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateVAArg(llvm::Value*, llvm::Type const*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE20CreateExtractElementEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateExtractElement(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE9CreateNotEPNS_5ValueERKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateNot(llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE19CreateZExtOrBitCastEPNS_5ValueEPKNS_4TypeERKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateZExtOrBitCast(llvm::Value*, llvm::Type const*, llvm::Twine const&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_19CGObjCGNU11GetSelectorERN4llvm9IRBuilderILb0ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb0EEEEEN5clang8SelectorEb", "(anonymous namespace)::CGObjCGNU::GetSelector(llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >&, clang::Selector, bool)"),
	mu_demangle_test("_ZN12_GLOBAL__N_19CGObjCGNU11GetSelectorERN4llvm9IRBuilderILb0ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb0EEEEEPKN5clang14ObjCMethodDeclE", "(anonymous namespace)::CGObjCGNU::GetSelector(llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >&, clang::ObjCMethodDecl const*)"),
	mu_demangle_test("_ZN12_GLOBAL__N_19CGObjCGNU19GenerateProtocolRefERN4llvm9IRBuilderILb0ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb0EEEEEPKN5clang16ObjCProtocolDeclE", "(anonymous namespace)::CGObjCGNU::GenerateProtocolRef(llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >&, clang::ObjCProtocolDecl const*)"),
	mu_demangle_test("_ZN12_GLOBAL__N_19CGObjCGNU8GetClassERN4llvm9IRBuilderILb0ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb0EEEEEPKN5clang17ObjCInterfaceDeclE", "(anonymous namespace)::CGObjCGNU::GetClass(llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >&, clang::ObjCInterfaceDecl const*)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE11CreateCall3EPNS_5ValueES6_S6_S6_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateCall3(llvm::Value*, llvm::Value*, llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE10CreateLoadEPNS_5ValueEbRKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateLoad(llvm::Value*, bool, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE11CreateCall2EPNS_5ValueES6_S6_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateCall2(llvm::Value*, llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE10CreateCallEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateCall(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE17CreateUnreachableEv", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateUnreachable()"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE12CreateInvokeIPPNS_5ValueEEEPNS_10InvokeInstES7_PNS_10BasicBlockESC_T_SD_RKNS_5TwineE", "llvm::InvokeInst* llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateInvoke<llvm::Value**>(llvm::Value*, llvm::BasicBlock*, llvm::BasicBlock*, llvm::Value**, llvm::Value**, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm15SmallVectorImplISt4pairIN5clang7CodeGen6RValueENS2_8QualTypeEEE6insertIPKS6_EEPS6_SB_T_SC_", "std::pair<clang::CodeGen::RValue, clang::QualType>* llvm::SmallVectorImpl<std::pair<clang::CodeGen::RValue, clang::QualType> >::insert<std::pair<clang::CodeGen::RValue, clang::QualType> const*>(std::pair<clang::CodeGen::RValue, clang::QualType>*, std::pair<clang::CodeGen::RValue, clang::QualType> const*, std::pair<clang::CodeGen::RValue, clang::QualType> const*)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE12CreateAllocaEPKNS_4TypeEPNS_5ValueERKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateAlloca(llvm::Type const*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE10CreateCallIPPNS_5ValueEEEPNS_8CallInstES7_T_SB_RKNS_5TwineE", "llvm::CallInst* llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateCall<llvm::Value**>(llvm::Value*, llvm::Value**, llvm::Value**, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE8CreateBrEPNS_10BasicBlockE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateBr(llvm::BasicBlock*)"),
	mu_demangle_test("_ZNSt3mapISt4pairISsSsEPN4llvm11GlobalAliasESt4lessIS1_ESaIS0_IKS1_S4_EEEixERS7_", "std::map<std::pair<std::string, std::string>, llvm::GlobalAlias*, std::less<std::pair<std::string, std::string> >, std::allocator<std::pair<std::pair<std::string, std::string> const, llvm::GlobalAlias*> > >::operator[](std::pair<std::string, std::string> const&)"),
	mu_demangle_test("_ZNKSt4lessISt4pairISsSsEEclERKS1_S4_", "std::less<std::pair<std::string, std::string> >::operator()(std::pair<std::string, std::string> const&, std::pair<std::string, std::string> const&) const"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairISsSsES0_IKS1_PN4llvm11GlobalAliasEESt10_Select1stIS6_ESt4lessIS1_ESaIS6_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS6_ERKS6_", "std::_Rb_tree<std::pair<std::string, std::string>, std::pair<std::pair<std::string, std::string> const, llvm::GlobalAlias*>, std::_Select1st<std::pair<std::pair<std::string, std::string> const, llvm::GlobalAlias*> >, std::less<std::pair<std::string, std::string> >, std::allocator<std::pair<std::pair<std::string, std::string> const, llvm::GlobalAlias*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<std::pair<std::string, std::string> const, llvm::GlobalAlias*> >, std::pair<std::pair<std::string, std::string> const, llvm::GlobalAlias*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairISsSsES0_IKS1_PN4llvm11GlobalAliasEESt10_Select1stIS6_ESt4lessIS1_ESaIS6_EE9_M_insertEPSt18_Rb_tree_node_baseSE_RKS6_", "std::_Rb_tree<std::pair<std::string, std::string>, std::pair<std::pair<std::string, std::string> const, llvm::GlobalAlias*>, std::_Select1st<std::pair<std::pair<std::string, std::string> const, llvm::GlobalAlias*> >, std::less<std::pair<std::string, std::string> >, std::allocator<std::pair<std::pair<std::string, std::string> const, llvm::GlobalAlias*> > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<std::pair<std::string, std::string> const, llvm::GlobalAlias*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairISsSsES0_IKS1_PN4llvm11GlobalAliasEESt10_Select1stIS6_ESt4lessIS1_ESaIS6_EE16_M_insert_uniqueERKS6_", "std::_Rb_tree<std::pair<std::string, std::string>, std::pair<std::pair<std::string, std::string> const, llvm::GlobalAlias*>, std::_Select1st<std::pair<std::pair<std::string, std::string> const, llvm::GlobalAlias*> >, std::less<std::pair<std::string, std::string> >, std::allocator<std::pair<std::pair<std::string, std::string> const, llvm::GlobalAlias*> > >::_M_insert_unique(std::pair<std::pair<std::string, std::string> const, llvm::GlobalAlias*> const&)"),
	mu_demangle_test("_ZN4llvm9StringMapIPNS_11GlobalAliasENS_15MallocAllocatorEE16GetOrCreateValueIS2_EERNS_14StringMapEntryIS2_EENS_9StringRefET_", "llvm::StringMapEntry<llvm::GlobalAlias*>& llvm::StringMap<llvm::GlobalAlias*, llvm::MallocAllocator>::GetOrCreateValue<llvm::GlobalAlias*>(llvm::StringRef, llvm::GlobalAlias*)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm8ConstantESaIS2_EE15_M_range_insertIN9__gnu_cxx17__normal_iteratorIPS2_S4_EEEEvS9_T_SA_St20forward_iterator_tag", "void std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >::_M_range_insert<__gnu_cxx::__normal_iterator<llvm::Constant**, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > >(__gnu_cxx::__normal_iterator<llvm::Constant**, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > >, __gnu_cxx::__normal_iterator<llvm::Constant**, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > >, __gnu_cxx::__normal_iterator<llvm::Constant**, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > >, std::forward_iterator_tag)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairISsSsES0_IKS1_PN4llvm11GlobalAliasEESt10_Select1stIS6_ESt4lessIS1_ESaIS6_EE8_M_eraseEPSt13_Rb_tree_nodeIS6_E", "std::_Rb_tree<std::pair<std::string, std::string>, std::pair<std::pair<std::string, std::string> const, llvm::GlobalAlias*>, std::_Select1st<std::pair<std::pair<std::string, std::string> const, llvm::GlobalAlias*> >, std::less<std::pair<std::string, std::string> >, std::allocator<std::pair<std::pair<std::string, std::string> const, llvm::GlobalAlias*> > >::_M_erase(std::_Rb_tree_node<std::pair<std::pair<std::string, std::string> const, llvm::GlobalAlias*> >*)"),
	mu_demangle_test("_ZN12_GLOBAL__N_122CGObjCNonFragileABIMac11GetSelectorERN4llvm9IRBuilderILb0ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb0EEEEEN5clang8SelectorEb", "(anonymous namespace)::CGObjCNonFragileABIMac::GetSelector(llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >&, clang::Selector, bool)"),
	mu_demangle_test("_ZN12_GLOBAL__N_122CGObjCNonFragileABIMac11GetSelectorERN4llvm9IRBuilderILb0ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb0EEEEEPKN5clang14ObjCMethodDeclE", "(anonymous namespace)::CGObjCNonFragileABIMac::GetSelector(llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >&, clang::ObjCMethodDecl const*)"),
	mu_demangle_test("_ZN12_GLOBAL__N_122CGObjCNonFragileABIMac19GenerateProtocolRefERN4llvm9IRBuilderILb0ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb0EEEEEPKN5clang16ObjCProtocolDeclE", "(anonymous namespace)::CGObjCNonFragileABIMac::GenerateProtocolRef(llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >&, clang::ObjCProtocolDecl const*)"),
	mu_demangle_test("_ZN12_GLOBAL__N_122CGObjCNonFragileABIMac8GetClassERN4llvm9IRBuilderILb0ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb0EEEEEPKN5clang17ObjCInterfaceDeclE", "(anonymous namespace)::CGObjCNonFragileABIMac::GetClass(llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >&, clang::ObjCInterfaceDecl const*)"),
	mu_demangle_test("_ZN12_GLOBAL__N_122CGObjCNonFragileABIMac14EmitMethodListEN4llvm5TwineEPKcRKSt6vectorIPNS1_8ConstantESaIS7_EE", "(anonymous namespace)::CGObjCNonFragileABIMac::EmitMethodList(llvm::Twine, char const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > const&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_115CGObjCCommonMac22PushProtocolPropertiesERN4llvm11SmallPtrSetIPKN5clang14IdentifierInfoELj16EEERSt6vectorIPNS1_8ConstantESaISB_EEPKNS3_4DeclEPKNS3_16ObjCProtocolDeclERKNS_21ObjCCommonTypesHelperE", "(anonymous namespace)::CGObjCCommonMac::PushProtocolProperties(llvm::SmallPtrSet<clang::IdentifierInfo const*, 16u>&, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >&, clang::Decl const*, clang::ObjCProtocolDecl const*, (anonymous namespace)::ObjCCommonTypesHelper const&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_122CGObjCNonFragileABIMac12EmitClassRefERN4llvm9IRBuilderILb0ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb0EEEEEPKN5clang17ObjCInterfaceDeclE", "(anonymous namespace)::CGObjCNonFragileABIMac::EmitClassRef(llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >&, clang::ObjCInterfaceDecl const*)"),
	mu_demangle_test("_ZN12_GLOBAL__N_122CGObjCNonFragileABIMac12EmitSelectorERN4llvm9IRBuilderILb0ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb0EEEEEN5clang8SelectorEb", "(anonymous namespace)::CGObjCNonFragileABIMac::EmitSelector(llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >&, clang::Selector, bool)"),
	mu_demangle_test("_ZN12_GLOBAL__N_122CGObjCNonFragileABIMac18AddModuleClassListERKSt6vectorIPN4llvm11GlobalValueESaIS4_EEPKcSA_", "(anonymous namespace)::CGObjCNonFragileABIMac::AddModuleClassList(std::vector<llvm::GlobalValue*, std::allocator<llvm::GlobalValue*> > const&, char const*, char const*)"),
	mu_demangle_test("_ZN12_GLOBAL__N_19CGObjCMac11GetSelectorERN4llvm9IRBuilderILb0ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb0EEEEEN5clang8SelectorEb", "(anonymous namespace)::CGObjCMac::GetSelector(llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >&, clang::Selector, bool)"),
	mu_demangle_test("_ZN12_GLOBAL__N_19CGObjCMac11GetSelectorERN4llvm9IRBuilderILb0ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb0EEEEEPKN5clang14ObjCMethodDeclE", "(anonymous namespace)::CGObjCMac::GetSelector(llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >&, clang::ObjCMethodDecl const*)"),
	mu_demangle_test("_ZN12_GLOBAL__N_19CGObjCMac19GenerateProtocolRefERN4llvm9IRBuilderILb0ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb0EEEEEPKN5clang16ObjCProtocolDeclE", "(anonymous namespace)::CGObjCMac::GenerateProtocolRef(llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >&, clang::ObjCProtocolDecl const*)"),
	mu_demangle_test("_ZN12_GLOBAL__N_19CGObjCMac8GetClassERN4llvm9IRBuilderILb0ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb0EEEEEPKN5clang17ObjCInterfaceDeclE", "(anonymous namespace)::CGObjCMac::GetClass(llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >&, clang::ObjCInterfaceDecl const*)"),
	mu_demangle_test("_ZN12_GLOBAL__N_19CGObjCMac18EmitMethodDescListEN4llvm5TwineEPKcRKSt6vectorIPNS1_8ConstantESaIS7_EE", "(anonymous namespace)::CGObjCMac::EmitMethodDescList(llvm::Twine, char const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > const&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_19CGObjCMac12EmitClassRefERN4llvm9IRBuilderILb0ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb0EEEEEPKN5clang17ObjCInterfaceDeclE", "(anonymous namespace)::CGObjCMac::EmitClassRef(llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >&, clang::ObjCInterfaceDecl const*)"),
	mu_demangle_test("_ZN12_GLOBAL__N_19CGObjCMac12EmitSelectorERN4llvm9IRBuilderILb0ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb0EEEEEN5clang8SelectorEb", "(anonymous namespace)::CGObjCMac::EmitSelector(llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >&, clang::Selector, bool)"),
	mu_demangle_test("_ZN12_GLOBAL__N_19CGObjCMac14EmitMethodListEN4llvm5TwineEPKcRKSt6vectorIPNS1_8ConstantESaIS7_EE", "(anonymous namespace)::CGObjCMac::EmitMethodList(llvm::Twine, char const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang14IdentifierInfoEPNS_14GlobalVariableENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PSt4pairIS3_S5_E", "llvm::DenseMap<clang::IdentifierInfo*, llvm::GlobalVariable*, llvm::DenseMapInfo<clang::IdentifierInfo*>, llvm::DenseMapInfo<llvm::GlobalVariable*> >::InsertIntoBucket(clang::IdentifierInfo* const&, llvm::GlobalVariable* const&, std::pair<clang::IdentifierInfo*, llvm::GlobalVariable*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang14IdentifierInfoEPNS_14GlobalVariableENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<clang::IdentifierInfo*, llvm::GlobalVariable*, llvm::DenseMapInfo<clang::IdentifierInfo*>, llvm::DenseMapInfo<llvm::GlobalVariable*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang8SelectorEPNS_14GlobalVariableENS_12DenseMapInfoIS2_EENS5_IS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<clang::Selector, llvm::GlobalVariable*, llvm::DenseMapInfo<clang::Selector>, llvm::DenseMapInfo<llvm::GlobalVariable*> >::InsertIntoBucket(clang::Selector const&, llvm::GlobalVariable* const&, std::pair<clang::Selector, llvm::GlobalVariable*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang8SelectorEPNS_14GlobalVariableENS_12DenseMapInfoIS2_EENS5_IS4_EEE4growEj", "llvm::DenseMap<clang::Selector, llvm::GlobalVariable*, llvm::DenseMapInfo<clang::Selector>, llvm::DenseMapInfo<llvm::GlobalVariable*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm15SmallVectorImplIPN5clang9FieldDeclEE6appendINS1_11DeclContext22specific_decl_iteratorIS2_EEEEvT_S9_", "void llvm::SmallVectorImpl<clang::FieldDecl*>::append<clang::DeclContext::specific_decl_iterator<clang::FieldDecl> >(clang::DeclContext::specific_decl_iterator<clang::FieldDecl>, clang::DeclContext::specific_decl_iterator<clang::FieldDecl>)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang14ObjCMethodDeclEPNS_8FunctionENS_12DenseMapInfoIS4_EENS7_IS6_EEE6insertERKSt4pairIS4_S6_E", "llvm::DenseMap<clang::ObjCMethodDecl const*, llvm::Function*, llvm::DenseMapInfo<clang::ObjCMethodDecl const*>, llvm::DenseMapInfo<llvm::Function*> >::insert(std::pair<clang::ObjCMethodDecl const*, llvm::Function*> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang14ObjCMethodDeclEPNS_8FunctionENS_12DenseMapInfoIS4_EENS7_IS6_EEE16InsertIntoBucketERKS4_RKS6_PSt4pairIS4_S6_E", "llvm::DenseMap<clang::ObjCMethodDecl const*, llvm::Function*, llvm::DenseMapInfo<clang::ObjCMethodDecl const*>, llvm::DenseMapInfo<llvm::Function*> >::InsertIntoBucket(clang::ObjCMethodDecl const* const&, llvm::Function* const&, std::pair<clang::ObjCMethodDecl const*, llvm::Function*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang14ObjCMethodDeclEPNS_8FunctionENS_12DenseMapInfoIS4_EENS7_IS6_EEE4growEj", "llvm::DenseMap<clang::ObjCMethodDecl const*, llvm::Function*, llvm::DenseMapInfo<clang::ObjCMethodDecl const*>, llvm::DenseMapInfo<llvm::Function*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang14IdentifierInfoEcNS_12DenseMapInfoIS3_EENS4_IcEEE6insertERKSt4pairIS3_cE", "llvm::DenseMap<clang::IdentifierInfo*, char, llvm::DenseMapInfo<clang::IdentifierInfo*>, llvm::DenseMapInfo<char> >::insert(std::pair<clang::IdentifierInfo*, char> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang14IdentifierInfoEcNS_12DenseMapInfoIS3_EENS4_IcEEE16InsertIntoBucketERKS3_RKcPSt4pairIS3_cE", "llvm::DenseMap<clang::IdentifierInfo*, char, llvm::DenseMapInfo<clang::IdentifierInfo*>, llvm::DenseMapInfo<char> >::InsertIntoBucket(clang::IdentifierInfo* const&, char const&, std::pair<clang::IdentifierInfo*, char>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang14IdentifierInfoEcNS_12DenseMapInfoIS3_EENS4_IcEEE4growEj", "llvm::DenseMap<clang::IdentifierInfo*, char, llvm::DenseMapInfo<clang::IdentifierInfo*>, llvm::DenseMapInfo<char> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm9SetVectorISsSt6vectorISsSaISsEENS_8SmallSetISsLj16EEEED2Ev", "llvm::SetVector<std::string, std::vector<std::string, std::allocator<std::string> >, llvm::SmallSet<std::string, 16u> >::~SetVector()"),
	mu_demangle_test("_ZNSt6vectorIPN5clang14IdentifierInfoESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<clang::IdentifierInfo*, std::allocator<clang::IdentifierInfo*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::IdentifierInfo**, std::vector<clang::IdentifierInfo*, std::allocator<clang::IdentifierInfo*> > >, clang::IdentifierInfo* const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE9CreateGEPIPPNS_5ValueEEES7_S7_T_S9_RKNS_5TwineE", "llvm::Value* llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateGEP<llvm::Value**>(llvm::Value*, llvm::Value**, llvm::Value**, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm25array_pod_sort_comparatorISt4pairIjPKN5clang7CodeGen14CGBitFieldInfoEEEEiPKvS9_", "int llvm::array_pod_sort_comparator<std::pair<unsigned int, clang::CodeGen::CGBitFieldInfo const*> >(void const*, void const*)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIjPKN5clang7CodeGen14CGBitFieldInfoEESaIS6_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS6_S8_EERKS6_", "std::vector<std::pair<unsigned int, clang::CodeGen::CGBitFieldInfo const*>, std::allocator<std::pair<unsigned int, clang::CodeGen::CGBitFieldInfo const*> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<unsigned int, clang::CodeGen::CGBitFieldInfo const*>*, std::vector<std::pair<unsigned int, clang::CodeGen::CGBitFieldInfo const*>, std::allocator<std::pair<unsigned int, clang::CodeGen::CGBitFieldInfo const*> > > >, std::pair<unsigned int, clang::CodeGen::CGBitFieldInfo const*> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang9FieldDeclENS1_7CodeGen14CGBitFieldInfoENS_12DenseMapInfoIS4_EENS7_IS6_EEE6insertERKSt4pairIS4_S6_E", "llvm::DenseMap<clang::FieldDecl const*, clang::CodeGen::CGBitFieldInfo, llvm::DenseMapInfo<clang::FieldDecl const*>, llvm::DenseMapInfo<clang::CodeGen::CGBitFieldInfo> >::insert(std::pair<clang::FieldDecl const*, clang::CodeGen::CGBitFieldInfo> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang9FieldDeclENS1_7CodeGen14CGBitFieldInfoENS_12DenseMapInfoIS4_EENS7_IS6_EEE16InsertIntoBucketERKS4_RKS6_PSt4pairIS4_S6_E", "llvm::DenseMap<clang::FieldDecl const*, clang::CodeGen::CGBitFieldInfo, llvm::DenseMapInfo<clang::FieldDecl const*>, llvm::DenseMapInfo<clang::CodeGen::CGBitFieldInfo> >::InsertIntoBucket(clang::FieldDecl const* const&, clang::CodeGen::CGBitFieldInfo const&, std::pair<clang::FieldDecl const*, clang::CodeGen::CGBitFieldInfo>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang9FieldDeclENS1_7CodeGen14CGBitFieldInfoENS_12DenseMapInfoIS4_EENS7_IS6_EEE4growEj", "llvm::DenseMap<clang::FieldDecl const*, clang::CodeGen::CGBitFieldInfo, llvm::DenseMapInfo<clang::FieldDecl const*>, llvm::DenseMapInfo<clang::CodeGen::CGBitFieldInfo> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang9FieldDeclEjNS_12DenseMapInfoIS4_EENS5_IjEEE6insertERKSt4pairIS4_jE", "llvm::DenseMap<clang::FieldDecl const*, unsigned int, llvm::DenseMapInfo<clang::FieldDecl const*>, llvm::DenseMapInfo<unsigned int> >::insert(std::pair<clang::FieldDecl const*, unsigned int> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang9FieldDeclEjNS_12DenseMapInfoIS4_EENS5_IjEEE16InsertIntoBucketERKS4_RKjPSt4pairIS4_jE", "llvm::DenseMap<clang::FieldDecl const*, unsigned int, llvm::DenseMapInfo<clang::FieldDecl const*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(clang::FieldDecl const* const&, unsigned int const&, std::pair<clang::FieldDecl const*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang9FieldDeclEjNS_12DenseMapInfoIS4_EENS5_IjEEE4growEj", "llvm::DenseMap<clang::FieldDecl const*, unsigned int, llvm::DenseMapInfo<clang::FieldDecl const*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclEjNS_12DenseMapInfoIS4_EENS5_IjEEE6insertERKSt4pairIS4_jE", "llvm::DenseMap<clang::CXXRecordDecl const*, unsigned int, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<unsigned int> >::insert(std::pair<clang::CXXRecordDecl const*, unsigned int> const&)"),
	mu_demangle_test("_ZNSt6vectorIPKN4llvm4TypeESaIS3_EEaSERKS5_", "std::vector<llvm::Type const*, std::allocator<llvm::Type const*> >::operator=(std::vector<llvm::Type const*, std::allocator<llvm::Type const*> > const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE12CreateSwitchEPNS_5ValueEPNS_10BasicBlockEj", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateSwitch(llvm::Value*, llvm::BasicBlock*, unsigned int)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE10CreateCallIN9__gnu_cxx17__normal_iteratorIPPNS_5ValueESt6vectorIS9_SaIS9_EEEEEEPNS_8CallInstES9_T_SH_RKNS_5TwineE", "llvm::CallInst* llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateCall<__gnu_cxx::__normal_iterator<llvm::Value**, std::vector<llvm::Value*, std::allocator<llvm::Value*> > > >(llvm::Value*, __gnu_cxx::__normal_iterator<llvm::Value**, std::vector<llvm::Value*, std::allocator<llvm::Value*> > >, __gnu_cxx::__normal_iterator<llvm::Value**, std::vector<llvm::Value*, std::allocator<llvm::Value*> > >, llvm::Twine const&)"),
	mu_demangle_test("_ZNSt6vectorIN5clang7CodeGen6LValueESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<clang::CodeGen::LValue, std::allocator<clang::CodeGen::LValue> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::CodeGen::LValue*, std::vector<clang::CodeGen::LValue, std::allocator<clang::CodeGen::LValue> > >, clang::CodeGen::LValue const&)"),
	mu_demangle_test("_ZNSt6vectorIN5clang8QualTypeESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<clang::QualType, std::allocator<clang::QualType> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::QualType*, std::vector<clang::QualType, std::allocator<clang::QualType> > >, clang::QualType const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang7VarDeclEPNS_5ValueENS_12DenseMapInfoIS4_EENS7_IS6_EEE16InsertIntoBucketERKS4_RKS6_PSt4pairIS4_S6_E", "llvm::DenseMap<clang::VarDecl const*, llvm::Value*, llvm::DenseMapInfo<clang::VarDecl const*>, llvm::DenseMapInfo<llvm::Value*> >::InsertIntoBucket(clang::VarDecl const* const&, llvm::Value* const&, std::pair<clang::VarDecl const*, llvm::Value*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang7VarDeclEPNS_5ValueENS_12DenseMapInfoIS4_EENS7_IS6_EEE4growEj", "llvm::DenseMap<clang::VarDecl const*, llvm::Value*, llvm::DenseMapInfo<clang::VarDecl const*>, llvm::DenseMapInfo<llvm::Value*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang9LabelStmtENS1_7CodeGen15CodeGenFunction8JumpDestENS_12DenseMapInfoIS4_EENS8_IS7_EEE16InsertIntoBucketERKS4_RKS7_PSt4pairIS4_S7_E", "llvm::DenseMap<clang::LabelStmt const*, clang::CodeGen::CodeGenFunction::JumpDest, llvm::DenseMapInfo<clang::LabelStmt const*>, llvm::DenseMapInfo<clang::CodeGen::CodeGenFunction::JumpDest> >::InsertIntoBucket(clang::LabelStmt const* const&, clang::CodeGen::CodeGenFunction::JumpDest const&, std::pair<clang::LabelStmt const*, clang::CodeGen::CodeGenFunction::JumpDest>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang9LabelStmtENS1_7CodeGen15CodeGenFunction8JumpDestENS_12DenseMapInfoIS4_EENS8_IS7_EEE4growEj", "llvm::DenseMap<clang::LabelStmt const*, clang::CodeGen::CodeGenFunction::JumpDest, llvm::DenseMapInfo<clang::LabelStmt const*>, llvm::DenseMapInfo<clang::CodeGen::CodeGenFunction::JumpDest> >::grow(unsigned int)"),
	mu_demangle_test("_ZN12_GLOBAL__N_110VTTBuilder16AddVTablePointerEN5clang7CodeGen13BaseSubobjectEPN4llvm8ConstantEPKNS1_13CXXRecordDeclERKNS4_8DenseMapIS3_yNS4_12DenseMapInfoIS3_EENSB_IyEEEE", "(anonymous namespace)::VTTBuilder::AddVTablePointer(clang::CodeGen::BaseSubobject, llvm::Constant*, clang::CXXRecordDecl const*, llvm::DenseMap<clang::CodeGen::BaseSubobject, uint64_t, llvm::DenseMapInfo<clang::CodeGen::BaseSubobject>, llvm::DenseMapInfo<uint64_t> > const&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_110VTTBuilder30LayoutSecondaryVirtualPointersEN5clang7CodeGen13BaseSubobjectEbPN4llvm8ConstantEPKNS1_13CXXRecordDeclERKNS4_8DenseMapIS3_yNS4_12DenseMapInfoIS3_EENSB_IyEEEERNS4_11SmallPtrSetIS9_Lj4EEE", "(anonymous namespace)::VTTBuilder::LayoutSecondaryVirtualPointers(clang::CodeGen::BaseSubobject, bool, llvm::Constant*, clang::CXXRecordDecl const*, llvm::DenseMap<clang::CodeGen::BaseSubobject, uint64_t, llvm::DenseMapInfo<clang::CodeGen::BaseSubobject>, llvm::DenseMapInfo<uint64_t> > const&, llvm::SmallPtrSet<clang::CXXRecordDecl const*, 4u>&)"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPKN5clang13CXXRecordDeclENS2_7CodeGen13BaseSubobjectEEyNS_12DenseMapInfoIS8_EENS9_IyEEE6insertERKS1_IS8_yE", "llvm::DenseMap<std::pair<clang::CXXRecordDecl const*, clang::CodeGen::BaseSubobject>, uint64_t, llvm::DenseMapInfo<std::pair<clang::CXXRecordDecl const*, clang::CodeGen::BaseSubobject> >, llvm::DenseMapInfo<uint64_t> >::insert(std::pair<std::pair<clang::CXXRecordDecl const*, clang::CodeGen::BaseSubobject>, uint64_t> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang7CodeGen13BaseSubobjectEyNS_12DenseMapInfoIS3_EENS4_IyEEE16FindAndConstructERKS3_", "llvm::DenseMap<clang::CodeGen::BaseSubobject, uint64_t, llvm::DenseMapInfo<clang::CodeGen::BaseSubobject>, llvm::DenseMapInfo<uint64_t> >::FindAndConstruct(clang::CodeGen::BaseSubobject const&)"),
	mu_demangle_test("_ZN5clang7CodeGen14CodeGenVTables26GenerateConstructionVTableEPKNS_13CXXRecordDeclERKNS0_13BaseSubobjectEbRN4llvm8DenseMapIS5_yNS8_12DenseMapInfoIS5_EENSA_IyEEEE", "clang::CodeGen::CodeGenVTables::GenerateConstructionVTable(clang::CXXRecordDecl const*, clang::CodeGen::BaseSubobject const&, bool, llvm::DenseMap<clang::CodeGen::BaseSubobject, uint64_t, llvm::DenseMapInfo<clang::CodeGen::BaseSubobject>, llvm::DenseMapInfo<uint64_t> >&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclEN12_GLOBAL__N_114VCallOffsetMapENS_12DenseMapInfoIS4_EENS7_IS6_EEEixERKS4_", "llvm::DenseMap<clang::CXXRecordDecl const*, (anonymous namespace)::VCallOffsetMap, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<(anonymous namespace)::VCallOffsetMap> >::operator[](clang::CXXRecordDecl const* const&)"),
	mu_demangle_test("_ZNK4llvm8DenseMapISt4pairIPKN5clang13CXXMethodDeclEyEN12_GLOBAL__N_115FinalOverriders13OverriderInfoENS_12DenseMapInfoIS6_EENSA_IS9_EEE15LookupBucketForERKS6_RPS1_IS6_S9_E", "llvm::DenseMap<std::pair<clang::CXXMethodDecl const*, uint64_t>, (anonymous namespace)::FinalOverriders::OverriderInfo, llvm::DenseMapInfo<std::pair<clang::CXXMethodDecl const*, uint64_t> >, llvm::DenseMapInfo<(anonymous namespace)::FinalOverriders::OverriderInfo> >::LookupBucketFor(std::pair<clang::CXXMethodDecl const*, uint64_t> const&, std::pair<std::pair<clang::CXXMethodDecl const*, uint64_t>, (anonymous namespace)::FinalOverriders::OverriderInfo>*&) const"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXMethodDeclEN12_GLOBAL__N_113VTableBuilder10MethodInfoENS_12DenseMapInfoIS4_EENS8_IS7_EEE6insertERKSt4pairIS4_S7_E", "llvm::DenseMap<clang::CXXMethodDecl const*, (anonymous namespace)::VTableBuilder::MethodInfo, llvm::DenseMapInfo<clang::CXXMethodDecl const*>, llvm::DenseMapInfo<(anonymous namespace)::VTableBuilder::MethodInfo> >::insert(std::pair<clang::CXXMethodDecl const*, (anonymous namespace)::VTableBuilder::MethodInfo> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXMethodDeclEN12_GLOBAL__N_113VTableBuilder10MethodInfoENS_12DenseMapInfoIS4_EENS8_IS7_EEE16InsertIntoBucketERKS4_RKS7_PSt4pairIS4_S7_E", "llvm::DenseMap<clang::CXXMethodDecl const*, (anonymous namespace)::VTableBuilder::MethodInfo, llvm::DenseMapInfo<clang::CXXMethodDecl const*>, llvm::DenseMapInfo<(anonymous namespace)::VTableBuilder::MethodInfo> >::InsertIntoBucket(clang::CXXMethodDecl const* const&, (anonymous namespace)::VTableBuilder::MethodInfo const&, std::pair<clang::CXXMethodDecl const*, (anonymous namespace)::VTableBuilder::MethodInfo>*)"),
	mu_demangle_test("_ZN12_GLOBAL__N_115FinalOverriders18ComputeBaseOffsetsEN5clang7CodeGen13BaseSubobjectEbyRN4llvm8DenseMapISt4pairIPKNS1_13CXXRecordDeclEjEyNS4_12DenseMapInfoISA_EENSB_IyEEEESF_RNS5_IS9_jNSB_IS9_EENSB_IjEEEE", "(anonymous namespace)::FinalOverriders::ComputeBaseOffsets(clang::CodeGen::BaseSubobject, bool, uint64_t, llvm::DenseMap<std::pair<clang::CXXRecordDecl const*, unsigned int>, uint64_t, llvm::DenseMapInfo<std::pair<clang::CXXRecordDecl const*, unsigned int> >, llvm::DenseMapInfo<uint64_t> >&, llvm::DenseMap<std::pair<clang::CXXRecordDecl const*, unsigned int>, uint64_t, llvm::DenseMapInfo<std::pair<clang::CXXRecordDecl const*, unsigned int> >, llvm::DenseMapInfo<uint64_t> >&, llvm::DenseMap<clang::CXXRecordDecl const*, unsigned int, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<unsigned int> >&)"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPKN5clang13CXXRecordDeclES5_ExNS_12DenseMapInfoIS6_EENS7_IxEEE6insertERKS1_IS6_xE", "llvm::DenseMap<std::pair<clang::CXXRecordDecl const*, clang::CXXRecordDecl const*>, int64_t, llvm::DenseMapInfo<std::pair<clang::CXXRecordDecl const*, clang::CXXRecordDecl const*> >, llvm::DenseMapInfo<int64_t> >::insert(std::pair<std::pair<clang::CXXRecordDecl const*, clang::CXXRecordDecl const*>, int64_t> const&)"),
	mu_demangle_test("_ZN4llvm15SmallVectorImplISt4pairIyN5clang9ThunkInfoEEE6appendINS_16DenseMapIteratorIyS3_NS_12DenseMapInfoIyEENS8_IS3_EELb1EEEEEvT_SC_", "void llvm::SmallVectorImpl<std::pair<uint64_t, clang::ThunkInfo> >::append<llvm::DenseMapIterator<uint64_t, clang::ThunkInfo, llvm::DenseMapInfo<uint64_t>, llvm::DenseMapInfo<clang::ThunkInfo>, true> >(llvm::DenseMapIterator<uint64_t, clang::ThunkInfo, llvm::DenseMapInfo<uint64_t>, llvm::DenseMapInfo<clang::ThunkInfo>, true>, llvm::DenseMapIterator<uint64_t, clang::ThunkInfo, llvm::DenseMapInfo<uint64_t>, llvm::DenseMapInfo<clang::ThunkInfo>, true>)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclEPNS_14GlobalVariableENS_12DenseMapInfoIS4_EENS7_IS6_EEE16InsertIntoBucketERKS4_RKS6_PSt4pairIS4_S6_E", "llvm::DenseMap<clang::CXXRecordDecl const*, llvm::GlobalVariable*, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<llvm::GlobalVariable*> >::InsertIntoBucket(clang::CXXRecordDecl const* const&, llvm::GlobalVariable* const&, std::pair<clang::CXXRecordDecl const*, llvm::GlobalVariable*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclEPNS_14GlobalVariableENS_12DenseMapInfoIS4_EENS7_IS6_EEE4growEj", "llvm::DenseMap<clang::CXXRecordDecl const*, llvm::GlobalVariable*, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<llvm::GlobalVariable*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang7CodeGen13BaseSubobjectEyNS_12DenseMapInfoIS3_EENS4_IyEEE6insertERKSt4pairIS3_yE", "llvm::DenseMap<clang::CodeGen::BaseSubobject, uint64_t, llvm::DenseMapInfo<clang::CodeGen::BaseSubobject>, llvm::DenseMapInfo<uint64_t> >::insert(std::pair<clang::CodeGen::BaseSubobject, uint64_t> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang7CodeGen13BaseSubobjectEyNS_12DenseMapInfoIS3_EENS4_IyEEE16InsertIntoBucketERKS3_RKyPSt4pairIS3_yE", "llvm::DenseMap<clang::CodeGen::BaseSubobject, uint64_t, llvm::DenseMapInfo<clang::CodeGen::BaseSubobject>, llvm::DenseMapInfo<uint64_t> >::InsertIntoBucket(clang::CodeGen::BaseSubobject const&, uint64_t const&, std::pair<clang::CodeGen::BaseSubobject, uint64_t>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang7CodeGen13BaseSubobjectEyNS_12DenseMapInfoIS3_EENS4_IyEEE4growEj", "llvm::DenseMap<clang::CodeGen::BaseSubobject, uint64_t, llvm::DenseMapInfo<clang::CodeGen::BaseSubobject>, llvm::DenseMapInfo<uint64_t> >::grow(unsigned int)"),
	mu_demangle_test("_ZNK4llvm8DenseMapISt4pairIPKN5clang13CXXRecordDeclES5_ExNS_12DenseMapInfoIS6_EENS7_IxEEE15LookupBucketForERKS6_RPS1_IS6_xE", "llvm::DenseMap<std::pair<clang::CXXRecordDecl const*, clang::CXXRecordDecl const*>, int64_t, llvm::DenseMapInfo<std::pair<clang::CXXRecordDecl const*, clang::CXXRecordDecl const*> >, llvm::DenseMapInfo<int64_t> >::LookupBucketFor(std::pair<clang::CXXRecordDecl const*, clang::CXXRecordDecl const*> const&, std::pair<std::pair<clang::CXXRecordDecl const*, clang::CXXRecordDecl const*>, int64_t>*&) const"),
	mu_demangle_test("_ZNK4llvm8DenseMapISt4pairIPKN5clang13CXXRecordDeclENS2_7CodeGen13BaseSubobjectEEyNS_12DenseMapInfoIS8_EENS9_IyEEE15LookupBucketForERKS8_RPS1_IS8_yE", "llvm::DenseMap<std::pair<clang::CXXRecordDecl const*, clang::CodeGen::BaseSubobject>, uint64_t, llvm::DenseMapInfo<std::pair<clang::CXXRecordDecl const*, clang::CodeGen::BaseSubobject> >, llvm::DenseMapInfo<uint64_t> >::LookupBucketFor(std::pair<clang::CXXRecordDecl const*, clang::CodeGen::BaseSubobject> const&, std::pair<std::pair<clang::CXXRecordDecl const*, clang::CodeGen::BaseSubobject>, uint64_t>*&) const"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPKN5clang13CXXRecordDeclENS2_7CodeGen13BaseSubobjectEEyNS_12DenseMapInfoIS8_EENS9_IyEEE16InsertIntoBucketERKS8_RKyPS1_IS8_yE", "llvm::DenseMap<std::pair<clang::CXXRecordDecl const*, clang::CodeGen::BaseSubobject>, uint64_t, llvm::DenseMapInfo<std::pair<clang::CXXRecordDecl const*, clang::CodeGen::BaseSubobject> >, llvm::DenseMapInfo<uint64_t> >::InsertIntoBucket(std::pair<clang::CXXRecordDecl const*, clang::CodeGen::BaseSubobject> const&, uint64_t const&, std::pair<std::pair<clang::CXXRecordDecl const*, clang::CodeGen::BaseSubobject>, uint64_t>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPKN5clang13CXXRecordDeclENS2_7CodeGen13BaseSubobjectEEyNS_12DenseMapInfoIS8_EENS9_IyEEE4growEj", "llvm::DenseMap<std::pair<clang::CXXRecordDecl const*, clang::CodeGen::BaseSubobject>, uint64_t, llvm::DenseMapInfo<std::pair<clang::CXXRecordDecl const*, clang::CodeGen::BaseSubobject> >, llvm::DenseMapInfo<uint64_t> >::grow(unsigned int)"),
	mu_demangle_test("_ZSt21__unguarded_partitionIPSt4pairIyN5clang9ThunkInfoEES3_ET_S5_S5_T0_", "std::pair<uint64_t, clang::ThunkInfo>* std::__unguarded_partition<std::pair<uint64_t, clang::ThunkInfo>*, std::pair<uint64_t, clang::ThunkInfo> >(std::pair<uint64_t, clang::ThunkInfo>*, std::pair<uint64_t, clang::ThunkInfo>*, std::pair<uint64_t, clang::ThunkInfo>)"),
	mu_demangle_test("_ZSt8__medianISt4pairIyN5clang9ThunkInfoEEERKT_S6_S6_S6_", "std::pair<uint64_t, clang::ThunkInfo> const& std::__median<std::pair<uint64_t, clang::ThunkInfo> >(std::pair<uint64_t, clang::ThunkInfo> const&, std::pair<uint64_t, clang::ThunkInfo> const&, std::pair<uint64_t, clang::ThunkInfo> const&)"),
	mu_demangle_test("_ZSt13__adjust_heapIPSt4pairIyN5clang9ThunkInfoEElS3_EvT_T0_S6_T1_", "void std::__adjust_heap<std::pair<uint64_t, clang::ThunkInfo>*, long, std::pair<uint64_t, clang::ThunkInfo> >(std::pair<uint64_t, clang::ThunkInfo>*, long, long, std::pair<uint64_t, clang::ThunkInfo>)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclENS_11SmallVectorISt4pairIyNS1_9ThunkInfoEELj1EEENS_12DenseMapInfoIS4_EENSA_IS9_EEE16FindAndConstructERKS4_", "llvm::DenseMap<clang::CXXRecordDecl const*, llvm::SmallVector<std::pair<uint64_t, clang::ThunkInfo>, 1u>, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<llvm::SmallVector<std::pair<uint64_t, clang::ThunkInfo>, 1u> > >::FindAndConstruct(clang::CXXRecordDecl const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclENS_11SmallVectorISt4pairIyNS1_9ThunkInfoEELj1EEENS_12DenseMapInfoIS4_EENSA_IS9_EEE16InsertIntoBucketERKS4_RKS9_PS6_IS4_S9_E", "llvm::DenseMap<clang::CXXRecordDecl const*, llvm::SmallVector<std::pair<uint64_t, clang::ThunkInfo>, 1u>, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<llvm::SmallVector<std::pair<uint64_t, clang::ThunkInfo>, 1u> > >::InsertIntoBucket(clang::CXXRecordDecl const* const&, llvm::SmallVector<std::pair<uint64_t, clang::ThunkInfo>, 1u> const&, std::pair<clang::CXXRecordDecl const*, llvm::SmallVector<std::pair<uint64_t, clang::ThunkInfo>, 1u> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclENS_11SmallVectorISt4pairIyNS1_9ThunkInfoEELj1EEENS_12DenseMapInfoIS4_EENSA_IS9_EEE4growEj", "llvm::DenseMap<clang::CXXRecordDecl const*, llvm::SmallVector<std::pair<uint64_t, clang::ThunkInfo>, 1u>, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<llvm::SmallVector<std::pair<uint64_t, clang::ThunkInfo>, 1u> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm15SmallVectorImplISt4pairIyN5clang9ThunkInfoEEEaSERKS5_", "llvm::SmallVectorImpl<std::pair<uint64_t, clang::ThunkInfo> >::operator=(llvm::SmallVectorImpl<std::pair<uint64_t, clang::ThunkInfo> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXMethodDeclENS_11SmallVectorINS1_9ThunkInfoELj1EEENS_12DenseMapInfoIS4_EENS8_IS7_EEE6insertERKSt4pairIS4_S7_E", "llvm::DenseMap<clang::CXXMethodDecl const*, llvm::SmallVector<clang::ThunkInfo, 1u>, llvm::DenseMapInfo<clang::CXXMethodDecl const*>, llvm::DenseMapInfo<llvm::SmallVector<clang::ThunkInfo, 1u> > >::insert(std::pair<clang::CXXMethodDecl const*, llvm::SmallVector<clang::ThunkInfo, 1u> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXMethodDeclENS_11SmallVectorINS1_9ThunkInfoELj1EEENS_12DenseMapInfoIS4_EENS8_IS7_EEE16InsertIntoBucketERKS4_RKS7_PSt4pairIS4_S7_E", "llvm::DenseMap<clang::CXXMethodDecl const*, llvm::SmallVector<clang::ThunkInfo, 1u>, llvm::DenseMapInfo<clang::CXXMethodDecl const*>, llvm::DenseMapInfo<llvm::SmallVector<clang::ThunkInfo, 1u> > >::InsertIntoBucket(clang::CXXMethodDecl const* const&, llvm::SmallVector<clang::ThunkInfo, 1u> const&, std::pair<clang::CXXMethodDecl const*, llvm::SmallVector<clang::ThunkInfo, 1u> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXMethodDeclENS_11SmallVectorINS1_9ThunkInfoELj1EEENS_12DenseMapInfoIS4_EENS8_IS7_EEE4growEj", "llvm::DenseMap<clang::CXXMethodDecl const*, llvm::SmallVector<clang::ThunkInfo, 1u>, llvm::DenseMapInfo<clang::CXXMethodDecl const*>, llvm::DenseMapInfo<llvm::SmallVector<clang::ThunkInfo, 1u> > >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIPKN5clang13CXXRecordDeclESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<clang::CXXRecordDecl const*, std::allocator<clang::CXXRecordDecl const*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::CXXRecordDecl const**, std::vector<clang::CXXRecordDecl const*, std::allocator<clang::CXXRecordDecl const*> > >, clang::CXXRecordDecl const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclENS_14PointerIntPairIPyLj1EbNS_21PointerLikeTypeTraitsIS6_EEEENS_12DenseMapInfoIS4_EENSA_IS9_EEE16InsertIntoBucketERKS4_RKS9_PSt4pairIS4_S9_E", "llvm::DenseMap<clang::CXXRecordDecl const*, llvm::PointerIntPair<uint64_t*, 1u, bool, llvm::PointerLikeTypeTraits<uint64_t*> >, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<llvm::PointerIntPair<uint64_t*, 1u, bool, llvm::PointerLikeTypeTraits<uint64_t*> > > >::InsertIntoBucket(clang::CXXRecordDecl const* const&, llvm::PointerIntPair<uint64_t*, 1u, bool, llvm::PointerLikeTypeTraits<uint64_t*> > const&, std::pair<clang::CXXRecordDecl const*, llvm::PointerIntPair<uint64_t*, 1u, bool, llvm::PointerLikeTypeTraits<uint64_t*> > >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclENS_14PointerIntPairIPyLj1EbNS_21PointerLikeTypeTraitsIS6_EEEENS_12DenseMapInfoIS4_EENSA_IS9_EEE4growEj", "llvm::DenseMap<clang::CXXRecordDecl const*, llvm::PointerIntPair<uint64_t*, 1u, bool, llvm::PointerLikeTypeTraits<uint64_t*> >, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<llvm::PointerIntPair<uint64_t*, 1u, bool, llvm::PointerLikeTypeTraits<uint64_t*> > > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPKN5clang13CXXRecordDeclES5_ExNS_12DenseMapInfoIS6_EENS7_IxEEE16InsertIntoBucketERKS6_RKxPS1_IS6_xE", "llvm::DenseMap<std::pair<clang::CXXRecordDecl const*, clang::CXXRecordDecl const*>, int64_t, llvm::DenseMapInfo<std::pair<clang::CXXRecordDecl const*, clang::CXXRecordDecl const*> >, llvm::DenseMapInfo<int64_t> >::InsertIntoBucket(std::pair<clang::CXXRecordDecl const*, clang::CXXRecordDecl const*> const&, int64_t const&, std::pair<std::pair<clang::CXXRecordDecl const*, clang::CXXRecordDecl const*>, int64_t>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPKN5clang13CXXRecordDeclES5_ExNS_12DenseMapInfoIS6_EENS7_IxEEE4growEj", "llvm::DenseMap<std::pair<clang::CXXRecordDecl const*, clang::CXXRecordDecl const*>, int64_t, llvm::DenseMapInfo<std::pair<clang::CXXRecordDecl const*, clang::CXXRecordDecl const*> >, llvm::DenseMapInfo<int64_t> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclEyNS_12DenseMapInfoIS4_EENS5_IyEEE16InsertIntoBucketERKS4_RKyPSt4pairIS4_yE", "llvm::DenseMap<clang::CXXRecordDecl const*, uint64_t, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<uint64_t> >::InsertIntoBucket(clang::CXXRecordDecl const* const&, uint64_t const&, std::pair<clang::CXXRecordDecl const*, uint64_t>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclEyNS_12DenseMapInfoIS4_EENS5_IyEEE4growEj", "llvm::DenseMap<clang::CXXRecordDecl const*, uint64_t, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<uint64_t> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang7CodeGen10GlobalDeclExNS_12DenseMapInfoIS3_EENS4_IxEEE16InsertIntoBucketERKS3_RKxPSt4pairIS3_xE", "llvm::DenseMap<clang::CodeGen::GlobalDecl, int64_t, llvm::DenseMapInfo<clang::CodeGen::GlobalDecl>, llvm::DenseMapInfo<int64_t> >::InsertIntoBucket(clang::CodeGen::GlobalDecl const&, int64_t const&, std::pair<clang::CodeGen::GlobalDecl, int64_t>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang7CodeGen10GlobalDeclExNS_12DenseMapInfoIS3_EENS4_IxEEE4growEj", "llvm::DenseMap<clang::CodeGen::GlobalDecl, int64_t, llvm::DenseMapInfo<clang::CodeGen::GlobalDecl>, llvm::DenseMapInfo<int64_t> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt8_Rb_treeIySt4pairIKyN5clang7CodeGen13BaseSubobjectEESt10_Select1stIS5_ESt4lessIyESaIS5_EE8_M_eraseEPSt13_Rb_tree_nodeIS5_E", "std::_Rb_tree<uint64_t, std::pair<uint64_t const, clang::CodeGen::BaseSubobject>, std::_Select1st<std::pair<uint64_t const, clang::CodeGen::BaseSubobject> >, std::less<uint64_t>, std::allocator<std::pair<uint64_t const, clang::CodeGen::BaseSubobject> > >::_M_erase(std::_Rb_tree_node<std::pair<uint64_t const, clang::CodeGen::BaseSubobject> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsPKN5clang13CXXMethodDeclEESt10_Select1stIS6_ESt4lessISsESaIS6_EE8_M_eraseEPSt13_Rb_tree_nodeIS6_E", "std::_Rb_tree<std::string, std::pair<std::string const, clang::CXXMethodDecl const*>, std::_Select1st<std::pair<std::string const, clang::CXXMethodDecl const*> >, std::less<std::string>, std::allocator<std::pair<std::string const, clang::CXXMethodDecl const*> > >::_M_erase(std::_Rb_tree_node<std::pair<std::string const, clang::CXXMethodDecl const*> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXMethodDeclENS_11SmallVectorINS1_9ThunkInfoELj1EEENS_12DenseMapInfoIS4_EENS8_IS7_EEE16FindAndConstructERKS4_", "llvm::DenseMap<clang::CXXMethodDecl const*, llvm::SmallVector<clang::ThunkInfo, 1u>, llvm::DenseMapInfo<clang::CXXMethodDecl const*>, llvm::DenseMapInfo<llvm::SmallVector<clang::ThunkInfo, 1u> > >::FindAndConstruct(clang::CXXMethodDecl const* const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsPKN5clang13CXXMethodDeclEESt10_Select1stIS6_ESt4lessISsESaIS6_EE16_M_insert_uniqueERKS6_", "std::_Rb_tree<std::string, std::pair<std::string const, clang::CXXMethodDecl const*>, std::_Select1st<std::pair<std::string const, clang::CXXMethodDecl const*> >, std::less<std::string>, std::allocator<std::pair<std::string const, clang::CXXMethodDecl const*> > >::_M_insert_unique(std::pair<std::string const, clang::CXXMethodDecl const*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsPKN5clang13CXXMethodDeclEESt10_Select1stIS6_ESt4lessISsESaIS6_EE9_M_insertEPSt18_Rb_tree_node_baseSE_RKS6_", "std::_Rb_tree<std::string, std::pair<std::string const, clang::CXXMethodDecl const*>, std::_Select1st<std::pair<std::string const, clang::CXXMethodDecl const*> >, std::less<std::string>, std::allocator<std::pair<std::string const, clang::CXXMethodDecl const*> > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<std::string const, clang::CXXMethodDecl const*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsxESt10_Select1stIS2_ESt4lessISsESaIS2_EE8_M_eraseEPSt13_Rb_tree_nodeIS2_E", "std::_Rb_tree<std::string, std::pair<std::string const, int64_t>, std::_Select1st<std::pair<std::string const, int64_t> >, std::less<std::string>, std::allocator<std::pair<std::string const, int64_t> > >::_M_erase(std::_Rb_tree_node<std::pair<std::string const, int64_t> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsxESt10_Select1stIS2_ESt4lessISsESaIS2_EE16_M_insert_uniqueERKS2_", "std::_Rb_tree<std::string, std::pair<std::string const, int64_t>, std::_Select1st<std::pair<std::string const, int64_t> >, std::less<std::string>, std::allocator<std::pair<std::string const, int64_t> > >::_M_insert_unique(std::pair<std::string const, int64_t> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsxESt10_Select1stIS2_ESt4lessISsESaIS2_EE9_M_insertEPSt18_Rb_tree_node_baseSA_RKS2_", "std::_Rb_tree<std::string, std::pair<std::string const, int64_t>, std::_Select1st<std::pair<std::string const, int64_t> >, std::less<std::string>, std::allocator<std::pair<std::string const, int64_t> > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<std::string const, int64_t> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIyN5clang9ThunkInfoENS_12DenseMapInfoIyEENS3_IS2_EEE16InsertIntoBucketERKyRKS2_PSt4pairIyS2_E", "llvm::DenseMap<uint64_t, clang::ThunkInfo, llvm::DenseMapInfo<uint64_t>, llvm::DenseMapInfo<clang::ThunkInfo> >::InsertIntoBucket(uint64_t const&, clang::ThunkInfo const&, std::pair<uint64_t, clang::ThunkInfo>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIyN5clang9ThunkInfoENS_12DenseMapInfoIyEENS3_IS2_EEE4growEj", "llvm::DenseMap<uint64_t, clang::ThunkInfo, llvm::DenseMapInfo<uint64_t>, llvm::DenseMapInfo<clang::ThunkInfo> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclExNS_12DenseMapInfoIS4_EENS5_IxEEE8CopyFromERKS8_", "llvm::DenseMap<clang::CXXRecordDecl const*, int64_t, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<int64_t> >::CopyFrom(llvm::DenseMap<clang::CXXRecordDecl const*, int64_t, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<int64_t> > const&)"),
	mu_demangle_test("_ZN4llvm15SmallVectorImplISt4pairIPKN5clang13CXXMethodDeclExEEaSERKS7_", "llvm::SmallVectorImpl<std::pair<clang::CXXMethodDecl const*, int64_t> >::operator=(llvm::SmallVectorImpl<std::pair<clang::CXXMethodDecl const*, int64_t> > const&)"),
	mu_demangle_test("_ZNK4llvm8DenseMapISt4pairIPKN5clang13CXXRecordDeclEjEyNS_12DenseMapInfoIS6_EENS7_IyEEE15LookupBucketForERKS6_RPS1_IS6_yE", "llvm::DenseMap<std::pair<clang::CXXRecordDecl const*, unsigned int>, uint64_t, llvm::DenseMapInfo<std::pair<clang::CXXRecordDecl const*, unsigned int> >, llvm::DenseMapInfo<uint64_t> >::LookupBucketFor(std::pair<clang::CXXRecordDecl const*, unsigned int> const&, std::pair<std::pair<clang::CXXRecordDecl const*, unsigned int>, uint64_t>*&) const"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPKN5clang13CXXRecordDeclEjEyNS_12DenseMapInfoIS6_EENS7_IyEEE16InsertIntoBucketERKS6_RKyPS1_IS6_yE", "llvm::DenseMap<std::pair<clang::CXXRecordDecl const*, unsigned int>, uint64_t, llvm::DenseMapInfo<std::pair<clang::CXXRecordDecl const*, unsigned int> >, llvm::DenseMapInfo<uint64_t> >::InsertIntoBucket(std::pair<clang::CXXRecordDecl const*, unsigned int> const&, uint64_t const&, std::pair<std::pair<clang::CXXRecordDecl const*, unsigned int>, uint64_t>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPKN5clang13CXXRecordDeclEjEyNS_12DenseMapInfoIS6_EENS7_IyEEE4growEj", "llvm::DenseMap<std::pair<clang::CXXRecordDecl const*, unsigned int>, uint64_t, llvm::DenseMapInfo<std::pair<clang::CXXRecordDecl const*, unsigned int> >, llvm::DenseMapInfo<uint64_t> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE26CreateConstInBoundsGEP1_64EPNS_5ValueEyRKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateConstInBoundsGEP1_64(llvm::Value*, uint64_t, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE17CreateInBoundsGEPEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateInBoundsGEP(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclExNS_12DenseMapInfoIS4_EENS5_IxEEE6insertERKSt4pairIS4_xE", "llvm::DenseMap<clang::CXXRecordDecl const*, int64_t, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<int64_t> >::insert(std::pair<clang::CXXRecordDecl const*, int64_t> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclExNS_12DenseMapInfoIS4_EENS5_IxEEE16InsertIntoBucketERKS4_RKxPSt4pairIS4_xE", "llvm::DenseMap<clang::CXXRecordDecl const*, int64_t, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<int64_t> >::InsertIntoBucket(clang::CXXRecordDecl const* const&, int64_t const&, std::pair<clang::CXXRecordDecl const*, int64_t>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclExNS_12DenseMapInfoIS4_EENS5_IxEEE4growEj", "llvm::DenseMap<clang::CXXRecordDecl const*, int64_t, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<int64_t> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE9CreateMulEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateMul(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4ExprEPNS_5ValueENS_12DenseMapInfoIS4_EENS7_IS6_EEE16InsertIntoBucketERKS4_RKS6_PSt4pairIS4_S6_E", "llvm::DenseMap<clang::Expr const*, llvm::Value*, llvm::DenseMapInfo<clang::Expr const*>, llvm::DenseMapInfo<llvm::Value*> >::InsertIntoBucket(clang::Expr const* const&, llvm::Value* const&, std::pair<clang::Expr const*, llvm::Value*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4ExprEPNS_5ValueENS_12DenseMapInfoIS4_EENS7_IS6_EEE4growEj", "llvm::DenseMap<clang::Expr const*, llvm::Value*, llvm::DenseMapInfo<clang::Expr const*>, llvm::DenseMapInfo<llvm::Value*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN5clang7CodeGen13CodeGenModule12EmitCtorListERKSt6vectorISt4pairIPN4llvm8ConstantEiESaIS7_EEPKc", "clang::CodeGen::CodeGenModule::EmitCtorList(std::vector<std::pair<llvm::Constant*, int>, std::allocator<std::pair<llvm::Constant*, int> > > const&, char const*)"),
	mu_demangle_test("_ZNSt6vectorIN5clang7CodeGen10GlobalDeclESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<clang::CodeGen::GlobalDecl, std::allocator<clang::CodeGen::GlobalDecl> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::CodeGen::GlobalDecl*, std::vector<clang::CodeGen::GlobalDecl, std::allocator<clang::CodeGen::GlobalDecl> > >, clang::CodeGen::GlobalDecl const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4DeclEjNS_12DenseMapInfoIS4_EENS5_IjEEE16InsertIntoBucketERKS4_RKjPSt4pairIS4_jE", "llvm::DenseMap<clang::Decl const*, unsigned int, llvm::DenseMapInfo<clang::Decl const*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(clang::Decl const* const&, unsigned int const&, std::pair<clang::Decl const*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4DeclEjNS_12DenseMapInfoIS4_EENS5_IjEEE4growEj", "llvm::DenseMap<clang::Decl const*, unsigned int, llvm::DenseMapInfo<clang::Decl const*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPN4llvm8ConstantEiESaIS4_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS4_S6_EERKS4_", "std::vector<std::pair<llvm::Constant*, int>, std::allocator<std::pair<llvm::Constant*, int> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::Constant*, int>*, std::vector<std::pair<llvm::Constant*, int>, std::allocator<std::pair<llvm::Constant*, int> > > >, std::pair<llvm::Constant*, int> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang7CodeGen10GlobalDeclENS_9StringRefENS_12DenseMapInfoIS3_EENS5_IS4_EEE16InsertIntoBucketERKS3_RKS4_PSt4pairIS3_S4_E", "llvm::DenseMap<clang::CodeGen::GlobalDecl, llvm::StringRef, llvm::DenseMapInfo<clang::CodeGen::GlobalDecl>, llvm::DenseMapInfo<llvm::StringRef> >::InsertIntoBucket(clang::CodeGen::GlobalDecl const&, llvm::StringRef const&, std::pair<clang::CodeGen::GlobalDecl, llvm::StringRef>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang7CodeGen10GlobalDeclENS_9StringRefENS_12DenseMapInfoIS3_EENS5_IS4_EEE4growEj", "llvm::DenseMap<clang::CodeGen::GlobalDecl, llvm::StringRef, llvm::DenseMapInfo<clang::CodeGen::GlobalDecl>, llvm::DenseMapInfo<llvm::StringRef> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4TypeEPNS_6MDNodeENS_12DenseMapInfoIS4_EENS7_IS6_EEE16InsertIntoBucketERKS4_RKS6_PSt4pairIS4_S6_E", "llvm::DenseMap<clang::Type const*, llvm::MDNode*, llvm::DenseMapInfo<clang::Type const*>, llvm::DenseMapInfo<llvm::MDNode*> >::InsertIntoBucket(clang::Type const* const&, llvm::MDNode* const&, std::pair<clang::Type const*, llvm::MDNode*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4TypeEPNS_6MDNodeENS_12DenseMapInfoIS4_EENS7_IS6_EEE4growEj", "llvm::DenseMap<clang::Type const*, llvm::MDNode*, llvm::DenseMapInfo<clang::Type const*>, llvm::DenseMapInfo<llvm::MDNode*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4TypeENS_12PATypeHolderENS_12DenseMapInfoIS4_EENS6_IS5_EEED1Ev", "llvm::DenseMap<clang::Type const*, llvm::PATypeHolder, llvm::DenseMapInfo<clang::Type const*>, llvm::DenseMapInfo<llvm::PATypeHolder> >::~DenseMap()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4TypeENS_12PATypeHolderENS_12DenseMapInfoIS4_EENS6_IS5_EEE6insertERKSt4pairIS4_S5_E", "llvm::DenseMap<clang::Type const*, llvm::PATypeHolder, llvm::DenseMapInfo<clang::Type const*>, llvm::DenseMapInfo<llvm::PATypeHolder> >::insert(std::pair<clang::Type const*, llvm::PATypeHolder> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4TypeEPNS1_7CodeGen14CGRecordLayoutENS_12DenseMapInfoIS4_EENS8_IS7_EEE16InsertIntoBucketERKS4_RKS7_PSt4pairIS4_S7_E", "llvm::DenseMap<clang::Type const*, clang::CodeGen::CGRecordLayout*, llvm::DenseMapInfo<clang::Type const*>, llvm::DenseMapInfo<clang::CodeGen::CGRecordLayout*> >::InsertIntoBucket(clang::Type const* const&, clang::CodeGen::CGRecordLayout* const&, std::pair<clang::Type const*, clang::CodeGen::CGRecordLayout*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4TypeEPNS1_7CodeGen14CGRecordLayoutENS_12DenseMapInfoIS4_EENS8_IS7_EEE4growEj", "llvm::DenseMap<clang::Type const*, clang::CodeGen::CGRecordLayout*, llvm::DenseMapInfo<clang::Type const*>, llvm::DenseMapInfo<clang::CodeGen::CGRecordLayout*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang17ObjCInterfaceTypeEPKNS_4TypeENS_12DenseMapInfoIS4_EENS8_IS7_EEE16InsertIntoBucketERKS4_RKS7_PSt4pairIS4_S7_E", "llvm::DenseMap<clang::ObjCInterfaceType const*, llvm::Type const*, llvm::DenseMapInfo<clang::ObjCInterfaceType const*>, llvm::DenseMapInfo<llvm::Type const*> >::InsertIntoBucket(clang::ObjCInterfaceType const* const&, llvm::Type const* const&, std::pair<clang::ObjCInterfaceType const*, llvm::Type const*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang17ObjCInterfaceTypeEPKNS_4TypeENS_12DenseMapInfoIS4_EENS8_IS7_EEE4growEj", "llvm::DenseMap<clang::ObjCInterfaceType const*, llvm::Type const*, llvm::DenseMapInfo<clang::ObjCInterfaceType const*>, llvm::DenseMapInfo<llvm::Type const*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4TypeENS_12PATypeHolderENS_12DenseMapInfoIS4_EENS6_IS5_EEE16InsertIntoBucketERKS4_RKS5_PSt4pairIS4_S5_E", "llvm::DenseMap<clang::Type const*, llvm::PATypeHolder, llvm::DenseMapInfo<clang::Type const*>, llvm::DenseMapInfo<llvm::PATypeHolder> >::InsertIntoBucket(clang::Type const* const&, llvm::PATypeHolder const&, std::pair<clang::Type const*, llvm::PATypeHolder>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4TypeENS_12PATypeHolderENS_12DenseMapInfoIS4_EENS6_IS5_EEE4growEj", "llvm::DenseMap<clang::Type const*, llvm::PATypeHolder, llvm::DenseMapInfo<clang::Type const*>, llvm::DenseMapInfo<llvm::PATypeHolder> >::grow(unsigned int)"),
	mu_demangle_test("_ZN12_GLOBAL__N_19ARMCXXABI25BuildConstructorSignatureEPKN5clang18CXXConstructorDeclENS1_11CXXCtorTypeERNS1_7CanQualINS1_4TypeEEERN4llvm15SmallVectorImplIS8_EE", "(anonymous namespace)::ARMCXXABI::BuildConstructorSignature(clang::CXXConstructorDecl const*, clang::CXXCtorType, clang::CanQual<clang::Type>&, llvm::SmallVectorImpl<clang::CanQual<clang::Type> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_19ARMCXXABI24BuildDestructorSignatureEPKN5clang17CXXDestructorDeclENS1_11CXXDtorTypeERNS1_7CanQualINS1_4TypeEEERN4llvm15SmallVectorImplIS8_EE", "(anonymous namespace)::ARMCXXABI::BuildDestructorSignature(clang::CXXDestructorDecl const*, clang::CXXDtorType, clang::CanQual<clang::Type>&, llvm::SmallVectorImpl<clang::CanQual<clang::Type> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_113ItaniumCXXABI24BuildDestructorSignatureEPKN5clang17CXXDestructorDeclENS1_11CXXDtorTypeERNS1_7CanQualINS1_4TypeEEERN4llvm15SmallVectorImplIS8_EE", "(anonymous namespace)::ItaniumCXXABI::BuildDestructorSignature(clang::CXXDestructorDecl const*, clang::CXXDtorType, clang::CanQual<clang::Type>&, llvm::SmallVectorImpl<clang::CanQual<clang::Type> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_113ItaniumCXXABI25BuildConstructorSignatureEPKN5clang18CXXConstructorDeclENS1_11CXXCtorTypeERNS1_7CanQualINS1_4TypeEEERN4llvm15SmallVectorImplIS8_EE", "(anonymous namespace)::ItaniumCXXABI::BuildConstructorSignature(clang::CXXConstructorDecl const*, clang::CXXCtorType, clang::CanQual<clang::Type>&, llvm::SmallVectorImpl<clang::CanQual<clang::Type> >&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE8CreateOrEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateOr(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE11CreateBinOpENS_11Instruction9BinaryOpsEPNS_5ValueES8_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateBinOp(llvm::Instruction::BinaryOps, llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE12CreateNSWSubEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateNSWSub(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE12CreateNSWAddEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateNSWAdd(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE12CreateSelectEPNS_5ValueES6_S6_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateSelect(llvm::Value*, llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE17CreateInsertValueEPNS_5ValueES6_jRKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateInsertValue(llvm::Value*, llvm::Value*, unsigned int, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE10CreateAShrEPNS_5ValueES6_RKNS_5TwineEb", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateAShr(llvm::Value*, llvm::Value*, llvm::Twine const&, bool)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE9CreateSubEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateSub(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_115MicrosoftCXXABI25BuildConstructorSignatureEPKN5clang18CXXConstructorDeclENS1_11CXXCtorTypeERNS1_7CanQualINS1_4TypeEEERN4llvm15SmallVectorImplIS8_EE", "(anonymous namespace)::MicrosoftCXXABI::BuildConstructorSignature(clang::CXXConstructorDecl const*, clang::CXXCtorType, clang::CanQual<clang::Type>&, llvm::SmallVectorImpl<clang::CanQual<clang::Type> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_115MicrosoftCXXABI24BuildDestructorSignatureEPKN5clang17CXXDestructorDeclENS1_11CXXDtorTypeERNS1_7CanQualINS1_4TypeEEERN4llvm15SmallVectorImplIS8_EE", "(anonymous namespace)::MicrosoftCXXABI::BuildDestructorSignature(clang::CXXDestructorDecl const*, clang::CXXDtorType, clang::CanQual<clang::Type>&, llvm::SmallVectorImpl<clang::CanQual<clang::Type> >&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE26CreateConstInBoundsGEP1_32EPNS_5ValueEjRKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateConstInBoundsGEP1_32(llvm::Value*, unsigned int, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE11CreateStoreEPNS_5ValueES6_b", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateStore(llvm::Value*, llvm::Value*, bool)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE10CreateLoadEPNS_5ValueEPKc", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateLoad(llvm::Value*, char const*)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE9CreateAndEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateAnd(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE12CreateCondBrEPNS_5ValueEPNS_10BasicBlockES8_", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateCondBr(llvm::Value*, llvm::BasicBlock*, llvm::BasicBlock*)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE9CreateGEPEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateGEP(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE10CreateLoadEPNS_5ValueERKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateLoad(llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE18CreateConstGEP1_32EPNS_5ValueEjRKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateConstGEP1_32(llvm::Value*, unsigned int, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE9CreateAddEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateAdd(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE9CreatePHIEPKNS_4TypeERKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreatePHI(llvm::Type const*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE10CreateCastENS_11Instruction7CastOpsEPNS_5ValueEPKNS_4TypeERKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateCast(llvm::Instruction::CastOps, llvm::Value*, llvm::Type const*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE10CreateICmpENS_7CmpInst9PredicateEPNS_5ValueES8_RKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateICmp(llvm::CmpInst::Predicate, llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb0ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb0EEEE26CreateConstInBoundsGEP2_32EPNS_5ValueEjjRKNS_5TwineE", "llvm::IRBuilder<false, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<false> >::CreateConstInBoundsGEP2_32(llvm::Value*, unsigned int, unsigned int, llvm::Twine const&)"),
	mu_demangle_test("_ZN5clang6Parser27ParseExceptionSpecificationERNS_14SourceLocationERN4llvm15SmallVectorImplINS_9OpaquePtrINS_8QualTypeEEEEERNS4_INS_11SourceRangeEEERb", "clang::Parser::ParseExceptionSpecification(clang::SourceLocation&, llvm::SmallVectorImpl<clang::OpaquePtr<clang::QualType> >&, llvm::SmallVectorImpl<clang::SourceRange>&, bool&)"),
	mu_demangle_test("_ZNSt5dequeIPN5clang6Parser12ParsingClassESaIS3_EE9push_backERKS3_", "std::deque<clang::Parser::ParsingClass*, std::allocator<clang::Parser::ParsingClass*> >::push_back(clang::Parser::ParsingClass* const&)"),
	mu_demangle_test("_ZNSt5dequeIPN5clang6Parser12ParsingClassESaIS3_EE17_M_reallocate_mapEmb", "std::deque<clang::Parser::ParsingClass*, std::allocator<clang::Parser::ParsingClass*> >::_M_reallocate_map(unsigned long, bool)"),
	mu_demangle_test("_ZNSt11_Deque_baseIPN5clang6Parser12ParsingClassESaIS3_EE17_M_initialize_mapEm", "std::_Deque_base<clang::Parser::ParsingClass*, std::allocator<clang::Parser::ParsingClass*> >::_M_initialize_map(unsigned long)"),
	mu_demangle_test("_ZNSt5dequeIPN5clang6Parser12ParsingClassESaIS3_EEC2ERKS5_", "std::deque<clang::Parser::ParsingClass*, std::allocator<clang::Parser::ParsingClass*> >::deque(std::deque<clang::Parser::ParsingClass*, std::allocator<clang::Parser::ParsingClass*> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang7VarDeclEPNS_11SmallVectorIPKNS1_4ExprELj2EEENS_12DenseMapInfoIS4_EENSB_ISA_EEE16InsertIntoBucketERKS4_RKSA_PSt4pairIS4_SA_E", "llvm::DenseMap<clang::VarDecl const*, llvm::SmallVector<clang::Expr const*, 2u>*, llvm::DenseMapInfo<clang::VarDecl const*>, llvm::DenseMapInfo<llvm::SmallVector<clang::Expr const*, 2u>*> >::InsertIntoBucket(clang::VarDecl const* const&, llvm::SmallVector<clang::Expr const*, 2u>* const&, std::pair<clang::VarDecl const*, llvm::SmallVector<clang::Expr const*, 2u>*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang7VarDeclEPNS_11SmallVectorIPKNS1_4ExprELj2EEENS_12DenseMapInfoIS4_EENSB_ISA_EEE4growEj", "llvm::DenseMap<clang::VarDecl const*, llvm::SmallVector<clang::Expr const*, 2u>*, llvm::DenseMapInfo<clang::VarDecl const*>, llvm::DenseMapInfo<llvm::SmallVector<clang::Expr const*, 2u>*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPN5clang9LabelStmtENS_12DenseMapInfoIjEENS4_IS3_EEE16InsertIntoBucketERKjRKS3_PSt4pairIjS3_E", "llvm::DenseMap<unsigned int, clang::LabelStmt*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<clang::LabelStmt*> >::InsertIntoBucket(unsigned int const&, clang::LabelStmt* const&, std::pair<unsigned int, clang::LabelStmt*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPN5clang9LabelStmtENS_12DenseMapInfoIjEENS4_IS3_EEE4growEj", "llvm::DenseMap<unsigned int, clang::LabelStmt*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<clang::LabelStmt*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPN5clang16IndirectGotoStmtENS_12DenseMapInfoIjEENS4_IS3_EEE16InsertIntoBucketERKjRKS3_PSt4pairIjS3_E", "llvm::DenseMap<unsigned int, clang::IndirectGotoStmt*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<clang::IndirectGotoStmt*> >::InsertIntoBucket(unsigned int const&, clang::IndirectGotoStmt* const&, std::pair<unsigned int, clang::IndirectGotoStmt*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPN5clang16IndirectGotoStmtENS_12DenseMapInfoIjEENS4_IS3_EEE4growEj", "llvm::DenseMap<unsigned int, clang::IndirectGotoStmt*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<clang::IndirectGotoStmt*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang4StmtEjNS_12DenseMapInfoIS3_EENS4_IjEEE16InsertIntoBucketERKS3_RKjPSt4pairIS3_jE", "llvm::DenseMap<clang::Stmt*, unsigned int, llvm::DenseMapInfo<clang::Stmt*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(clang::Stmt* const&, unsigned int const&, std::pair<clang::Stmt*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang4StmtEjNS_12DenseMapInfoIS3_EENS4_IjEEE4growEj", "llvm::DenseMap<clang::Stmt*, unsigned int, llvm::DenseMapInfo<clang::Stmt*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZSt9__find_ifIPPKN5clang14DeclaratorDeclESt9binder1stISt26pointer_to_binary_functionIPNS0_4SemaES3_bEEET_SB_SB_T0_St26random_access_iterator_tag", "clang::DeclaratorDecl const** std::__find_if<clang::DeclaratorDecl const**, std::binder1st<std::pointer_to_binary_function<clang::Sema*, clang::DeclaratorDecl const*, bool> > >(clang::DeclaratorDecl const**, clang::DeclaratorDecl const**, std::binder1st<std::pointer_to_binary_function<clang::Sema*, clang::DeclaratorDecl const*, bool> >, std::random_access_iterator_tag)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang4DeclENS_11SmallVectorISt4pairINS1_14SourceLocationENS1_17PartialDiagnosticEELj1EEENS_12DenseMapInfoIS3_EENSA_IS9_EEED2Ev", "llvm::DenseMap<clang::Decl*, llvm::SmallVector<std::pair<clang::SourceLocation, clang::PartialDiagnostic>, 1u>, llvm::DenseMapInfo<clang::Decl*>, llvm::DenseMapInfo<llvm::SmallVector<std::pair<clang::SourceLocation, clang::PartialDiagnostic>, 1u> > >::~DenseMap()"),
	mu_demangle_test("_ZNSt11_Deque_baseISt4pairIPN5clang9ValueDeclENS1_14SourceLocationEESaIS5_EE17_M_initialize_mapEm", "std::_Deque_base<std::pair<clang::ValueDecl*, clang::SourceLocation>, std::allocator<std::pair<clang::ValueDecl*, clang::SourceLocation> > >::_M_initialize_map(unsigned long)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang14IdentifierInfoEPNS1_9LabelStmtENS_12DenseMapInfoIS3_EENS6_IS5_EEE16shrink_and_clearEv", "llvm::DenseMap<clang::IdentifierInfo*, clang::LabelStmt*, llvm::DenseMapInfo<clang::IdentifierInfo*>, llvm::DenseMapInfo<clang::LabelStmt*> >::shrink_and_clear()"),
	mu_demangle_test("_ZNSt6vectorISt4pairIjN5clang14SourceLocationEESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<std::pair<unsigned int, clang::SourceLocation>, std::allocator<std::pair<unsigned int, clang::SourceLocation> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<unsigned int, clang::SourceLocation>*, std::vector<std::pair<unsigned int, clang::SourceLocation>, std::allocator<std::pair<unsigned int, clang::SourceLocation> > > >, std::pair<unsigned int, clang::SourceLocation> const&)"),
	mu_demangle_test("_Z24FindImplementableMethodsRN5clang10ASTContextEPNS_17ObjCContainerDeclEbNS_8QualTypeERN4llvm8DenseMapINS_8SelectorESt4pairIPNS_14ObjCMethodDeclEbENS5_12DenseMapInfoIS7_EENSC_ISB_EEEEb", "FindImplementableMethods(clang::ASTContext&, clang::ObjCContainerDecl*, bool, clang::QualType, llvm::DenseMap<clang::Selector, std::pair<clang::ObjCMethodDecl*, bool>, llvm::DenseMapInfo<clang::Selector>, llvm::DenseMapInfo<std::pair<clang::ObjCMethodDecl*, bool> > >&, bool)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN5clang13NamespaceDeclESt4pairIKS2_S2_ESt10_Select1stIS5_ESt4lessIS2_ESaIS5_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS5_ERKS5_", "std::_Rb_tree<clang::NamespaceDecl*, std::pair<clang::NamespaceDecl* const, clang::NamespaceDecl*>, std::_Select1st<std::pair<clang::NamespaceDecl* const, clang::NamespaceDecl*> >, std::less<clang::NamespaceDecl*>, std::allocator<std::pair<clang::NamespaceDecl* const, clang::NamespaceDecl*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<clang::NamespaceDecl* const, clang::NamespaceDecl*> >, std::pair<clang::NamespaceDecl* const, clang::NamespaceDecl*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN5clang13NamespaceDeclESt4pairIKS2_S2_ESt10_Select1stIS5_ESt4lessIS2_ESaIS5_EE16_M_insert_uniqueERKS5_", "std::_Rb_tree<clang::NamespaceDecl*, std::pair<clang::NamespaceDecl* const, clang::NamespaceDecl*>, std::_Select1st<std::pair<clang::NamespaceDecl* const, clang::NamespaceDecl*> >, std::less<clang::NamespaceDecl*>, std::allocator<std::pair<clang::NamespaceDecl* const, clang::NamespaceDecl*> > >::_M_insert_unique(std::pair<clang::NamespaceDecl* const, clang::NamespaceDecl*> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang8SelectorESt4pairIPNS1_14ObjCMethodDeclEbENS_12DenseMapInfoIS2_EENS7_IS6_EEE16InsertIntoBucketERKS2_RKS6_PS3_IS2_S6_E", "llvm::DenseMap<clang::Selector, std::pair<clang::ObjCMethodDecl*, bool>, llvm::DenseMapInfo<clang::Selector>, llvm::DenseMapInfo<std::pair<clang::ObjCMethodDecl*, bool> > >::InsertIntoBucket(clang::Selector const&, std::pair<clang::ObjCMethodDecl*, bool> const&, std::pair<clang::Selector, std::pair<clang::ObjCMethodDecl*, bool> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang8SelectorESt4pairIPNS1_14ObjCMethodDeclEbENS_12DenseMapInfoIS2_EENS7_IS6_EEE4growEj", "llvm::DenseMap<clang::Selector, std::pair<clang::ObjCMethodDecl*, bool>, llvm::DenseMapInfo<clang::Selector>, llvm::DenseMapInfo<std::pair<clang::ObjCMethodDecl*, bool> > >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIN5clang20CodeCompletionResultESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<clang::CodeCompletionResult, std::allocator<clang::CodeCompletionResult> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::CodeCompletionResult*, std::vector<clang::CodeCompletionResult, std::allocator<clang::CodeCompletionResult> > >, clang::CodeCompletionResult const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN5clang13NamespaceDeclESt4pairIKS2_S2_ESt10_Select1stIS5_ESt4lessIS2_ESaIS5_EE8_M_eraseEPSt13_Rb_tree_nodeIS5_E", "std::_Rb_tree<clang::NamespaceDecl*, std::pair<clang::NamespaceDecl* const, clang::NamespaceDecl*>, std::_Select1st<std::pair<clang::NamespaceDecl* const, clang::NamespaceDecl*> >, std::less<clang::NamespaceDecl*>, std::allocator<std::pair<clang::NamespaceDecl* const, clang::NamespaceDecl*> > >::_M_erase(std::_Rb_tree_node<std::pair<clang::NamespaceDecl* const, clang::NamespaceDecl*> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN5clang8QualTypeESt4pairIKS1_S2_IbjEESt10_Select1stIS5_ENS0_16QualTypeOrderingESaIS5_EE8_M_eraseEPSt13_Rb_tree_nodeIS5_E", "std::_Rb_tree<clang::QualType, std::pair<clang::QualType const, std::pair<bool, unsigned int> >, std::_Select1st<std::pair<clang::QualType const, std::pair<bool, unsigned int> > >, clang::QualTypeOrdering, std::allocator<std::pair<clang::QualType const, std::pair<bool, unsigned int> > > >::_M_erase(std::_Rb_tree_node<std::pair<clang::QualType const, std::pair<bool, unsigned int> > >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4TypeESt4pairINS1_7CanQualIS2_EEPNS1_18CXXConstructorDeclEENS_12DenseMapInfoIS4_EENSB_ISA_EEE6insertERKS5_IS4_SA_E", "llvm::DenseMap<clang::Type const*, std::pair<clang::CanQual<clang::Type>, clang::CXXConstructorDecl*>, llvm::DenseMapInfo<clang::Type const*>, llvm::DenseMapInfo<std::pair<clang::CanQual<clang::Type>, clang::CXXConstructorDecl*> > >::insert(std::pair<clang::Type const*, std::pair<clang::CanQual<clang::Type>, clang::CXXConstructorDecl*> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang13CXXRecordDeclEbNS_12DenseMapInfoIS3_EENS4_IbEEE6insertERKSt4pairIS3_bE", "llvm::DenseMap<clang::CXXRecordDecl*, bool, llvm::DenseMapInfo<clang::CXXRecordDecl*>, llvm::DenseMapInfo<bool> >::insert(std::pair<clang::CXXRecordDecl*, bool> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4TypeESt4pairINS1_7CanQualIS2_EEPNS1_18CXXConstructorDeclEENS_12DenseMapInfoIS4_EENSB_ISA_EEE16InsertIntoBucketERKS4_RKSA_PS5_IS4_SA_E", "llvm::DenseMap<clang::Type const*, std::pair<clang::CanQual<clang::Type>, clang::CXXConstructorDecl*>, llvm::DenseMapInfo<clang::Type const*>, llvm::DenseMapInfo<std::pair<clang::CanQual<clang::Type>, clang::CXXConstructorDecl*> > >::InsertIntoBucket(clang::Type const* const&, std::pair<clang::CanQual<clang::Type>, clang::CXXConstructorDecl*> const&, std::pair<clang::Type const*, std::pair<clang::CanQual<clang::Type>, clang::CXXConstructorDecl*> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4TypeESt4pairINS1_7CanQualIS2_EEPNS1_18CXXConstructorDeclEENS_12DenseMapInfoIS4_EENSB_ISA_EEE4growEj", "llvm::DenseMap<clang::Type const*, std::pair<clang::CanQual<clang::Type>, clang::CXXConstructorDecl*>, llvm::DenseMapInfo<clang::Type const*>, llvm::DenseMapInfo<std::pair<clang::CanQual<clang::Type>, clang::CXXConstructorDecl*> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPvPN5clang18CXXCtorInitializerENS_12DenseMapInfoIS1_EENS5_IS4_EEE16InsertIntoBucketERKS1_RKS4_PSt4pairIS1_S4_E", "llvm::DenseMap<void*, clang::CXXCtorInitializer*, llvm::DenseMapInfo<void*>, llvm::DenseMapInfo<clang::CXXCtorInitializer*> >::InsertIntoBucket(void* const&, clang::CXXCtorInitializer* const&, std::pair<void*, clang::CXXCtorInitializer*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPvPN5clang18CXXCtorInitializerENS_12DenseMapInfoIS1_EENS5_IS4_EEE4growEj", "llvm::DenseMap<void*, clang::CXXCtorInitializer*, llvm::DenseMapInfo<void*>, llvm::DenseMapInfo<clang::CXXCtorInitializer*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKvPN5clang18CXXCtorInitializerENS_12DenseMapInfoIS2_EENS6_IS5_EEE16InsertIntoBucketERKS2_RKS5_PSt4pairIS2_S5_E", "llvm::DenseMap<void const*, clang::CXXCtorInitializer*, llvm::DenseMapInfo<void const*>, llvm::DenseMapInfo<clang::CXXCtorInitializer*> >::InsertIntoBucket(void const* const&, clang::CXXCtorInitializer* const&, std::pair<void const*, clang::CXXCtorInitializer*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKvPN5clang18CXXCtorInitializerENS_12DenseMapInfoIS2_EENS6_IS5_EEE4growEj", "llvm::DenseMap<void const*, clang::CXXCtorInitializer*, llvm::DenseMapInfo<void const*>, llvm::DenseMapInfo<clang::CXXCtorInitializer*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN5clang8QualTypeESt4pairIKS1_PNS0_16CXXBaseSpecifierEESt10_Select1stIS6_ENS0_16QualTypeOrderingESaIS6_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS6_ERKS6_", "std::_Rb_tree<clang::QualType, std::pair<clang::QualType const, clang::CXXBaseSpecifier*>, std::_Select1st<std::pair<clang::QualType const, clang::CXXBaseSpecifier*> >, clang::QualTypeOrdering, std::allocator<std::pair<clang::QualType const, clang::CXXBaseSpecifier*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<clang::QualType const, clang::CXXBaseSpecifier*> >, std::pair<clang::QualType const, clang::CXXBaseSpecifier*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN5clang8QualTypeESt4pairIKS1_PNS0_16CXXBaseSpecifierEESt10_Select1stIS6_ENS0_16QualTypeOrderingESaIS6_EE16_M_insert_uniqueERKS6_", "std::_Rb_tree<clang::QualType, std::pair<clang::QualType const, clang::CXXBaseSpecifier*>, std::_Select1st<std::pair<clang::QualType const, clang::CXXBaseSpecifier*> >, clang::QualTypeOrdering, std::allocator<std::pair<clang::QualType const, clang::CXXBaseSpecifier*> > >::_M_insert_unique(std::pair<clang::QualType const, clang::CXXBaseSpecifier*> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang11ParmVarDeclENS1_14SourceLocationENS_12DenseMapInfoIS3_EENS5_IS4_EEE16InsertIntoBucketERKS3_RKS4_PSt4pairIS3_S4_E", "llvm::DenseMap<clang::ParmVarDecl*, clang::SourceLocation, llvm::DenseMapInfo<clang::ParmVarDecl*>, llvm::DenseMapInfo<clang::SourceLocation> >::InsertIntoBucket(clang::ParmVarDecl* const&, clang::SourceLocation const&, std::pair<clang::ParmVarDecl*, clang::SourceLocation>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang11ParmVarDeclENS1_14SourceLocationENS_12DenseMapInfoIS3_EENS5_IS4_EEE4growEj", "llvm::DenseMap<clang::ParmVarDecl*, clang::SourceLocation, llvm::DenseMapInfo<clang::ParmVarDecl*>, llvm::DenseMapInfo<clang::SourceLocation> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclEcNS_12DenseMapInfoIS4_EENS5_IcEEE6insertERKSt4pairIS4_cE", "llvm::DenseMap<clang::CXXRecordDecl const*, char, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<char> >::insert(std::pair<clang::CXXRecordDecl const*, char> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclEcNS_12DenseMapInfoIS4_EENS5_IcEEE16InsertIntoBucketERKS4_RKcPSt4pairIS4_cE", "llvm::DenseMap<clang::CXXRecordDecl const*, char, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<char> >::InsertIntoBucket(clang::CXXRecordDecl const* const&, char const&, std::pair<clang::CXXRecordDecl const*, char>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclEcNS_12DenseMapInfoIS4_EENS5_IcEEE4growEj", "llvm::DenseMap<clang::CXXRecordDecl const*, char, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<char> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang10RecordDeclESt4pairIPNS1_9NamedDeclEPNS1_18CXXCtorInitializerEENS_12DenseMapInfoIS3_EENSA_IS9_EEE16InsertIntoBucketERKS3_RKS9_PS4_IS3_S9_E", "llvm::DenseMap<clang::RecordDecl*, std::pair<clang::NamedDecl*, clang::CXXCtorInitializer*>, llvm::DenseMapInfo<clang::RecordDecl*>, llvm::DenseMapInfo<std::pair<clang::NamedDecl*, clang::CXXCtorInitializer*> > >::InsertIntoBucket(clang::RecordDecl* const&, std::pair<clang::NamedDecl*, clang::CXXCtorInitializer*> const&, std::pair<clang::RecordDecl*, std::pair<clang::NamedDecl*, clang::CXXCtorInitializer*> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang10RecordDeclESt4pairIPNS1_9NamedDeclEPNS1_18CXXCtorInitializerEENS_12DenseMapInfoIS3_EENSA_IS9_EEE4growEj", "llvm::DenseMap<clang::RecordDecl*, std::pair<clang::NamedDecl*, clang::CXXCtorInitializer*>, llvm::DenseMapInfo<clang::RecordDecl*>, llvm::DenseMapInfo<std::pair<clang::NamedDecl*, clang::CXXCtorInitializer*> > >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN5clang8QualTypeESt4pairIKS1_PNS0_16CXXBaseSpecifierEESt10_Select1stIS6_ENS0_16QualTypeOrderingESaIS6_EE8_M_eraseEPSt13_Rb_tree_nodeIS6_E", "std::_Rb_tree<clang::QualType, std::pair<clang::QualType const, clang::CXXBaseSpecifier*>, std::_Select1st<std::pair<clang::QualType const, clang::CXXBaseSpecifier*> >, clang::QualTypeOrdering, std::allocator<std::pair<clang::QualType const, clang::CXXBaseSpecifier*> > >::_M_erase(std::_Rb_tree_node<std::pair<clang::QualType const, clang::CXXBaseSpecifier*> >*)"),
	mu_demangle_test("_ZN5clang4Sema23CheckProtocolMethodDefsENS_14SourceLocationEPNS_16ObjCProtocolDeclERbRKN4llvm8DenseSetINS_8SelectorENS5_12DenseMapInfoIS7_EEEESC_PNS_17ObjCContainerDeclE", "clang::Sema::CheckProtocolMethodDefs(clang::SourceLocation, clang::ObjCProtocolDecl*, bool&, llvm::DenseSet<clang::Selector, llvm::DenseMapInfo<clang::Selector> > const&, llvm::DenseSet<clang::Selector, llvm::DenseMapInfo<clang::Selector> > const&, clang::ObjCContainerDecl*)"),
	mu_demangle_test("_ZN5clang4Sema26MatchAllMethodDeclarationsERKN4llvm8DenseSetINS_8SelectorENS1_12DenseMapInfoIS3_EEEES8_RS6_S9_PNS_12ObjCImplDeclEPNS_17ObjCContainerDeclERbb", "clang::Sema::MatchAllMethodDeclarations(llvm::DenseSet<clang::Selector, llvm::DenseMapInfo<clang::Selector> > const&, llvm::DenseSet<clang::Selector, llvm::DenseMapInfo<clang::Selector> > const&, llvm::DenseSet<clang::Selector, llvm::DenseMapInfo<clang::Selector> >&, llvm::DenseSet<clang::Selector, llvm::DenseMapInfo<clang::Selector> >&, clang::ObjCImplDecl*, clang::ObjCContainerDecl*, bool&, bool)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang8SelectorESt4pairINS1_14ObjCMethodListES4_ENS_12DenseMapInfoIS2_EENS6_IS5_EEE6insertERKS3_IS2_S5_E", "llvm::DenseMap<clang::Selector, std::pair<clang::ObjCMethodList, clang::ObjCMethodList>, llvm::DenseMapInfo<clang::Selector>, llvm::DenseMapInfo<std::pair<clang::ObjCMethodList, clang::ObjCMethodList> > >::insert(std::pair<clang::Selector, std::pair<clang::ObjCMethodList, clang::ObjCMethodList> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang8SelectorESt4pairINS1_14ObjCMethodListES4_ENS_12DenseMapInfoIS2_EENS6_IS5_EEE16InsertIntoBucketERKS2_RKS5_PS3_IS2_S5_E", "llvm::DenseMap<clang::Selector, std::pair<clang::ObjCMethodList, clang::ObjCMethodList>, llvm::DenseMapInfo<clang::Selector>, llvm::DenseMapInfo<std::pair<clang::ObjCMethodList, clang::ObjCMethodList> > >::InsertIntoBucket(clang::Selector const&, std::pair<clang::ObjCMethodList, clang::ObjCMethodList> const&, std::pair<clang::Selector, std::pair<clang::ObjCMethodList, clang::ObjCMethodList> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang8SelectorESt4pairINS1_14ObjCMethodListES4_ENS_12DenseMapInfoIS2_EENS6_IS5_EEE4growEj", "llvm::DenseMap<clang::Selector, std::pair<clang::ObjCMethodList, clang::ObjCMethodList>, llvm::DenseMapInfo<clang::Selector>, llvm::DenseMapInfo<std::pair<clang::ObjCMethodList, clang::ObjCMethodList> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang8SelectorEcNS_12DenseMapInfoIS2_EENS3_IcEEE6insertERKSt4pairIS2_cE", "llvm::DenseMap<clang::Selector, char, llvm::DenseMapInfo<clang::Selector>, llvm::DenseMapInfo<char> >::insert(std::pair<clang::Selector, char> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang8SelectorEcNS_12DenseMapInfoIS2_EENS3_IcEEE16InsertIntoBucketERKS2_RKcPSt4pairIS2_cE", "llvm::DenseMap<clang::Selector, char, llvm::DenseMapInfo<clang::Selector>, llvm::DenseMapInfo<char> >::InsertIntoBucket(clang::Selector const&, char const&, std::pair<clang::Selector, char>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang8SelectorEcNS_12DenseMapInfoIS2_EENS3_IcEEE4growEj", "llvm::DenseMap<clang::Selector, char, llvm::DenseMapInfo<clang::Selector>, llvm::DenseMapInfo<char> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang8SelectorEPKNS1_14ObjCMethodDeclENS_12DenseMapInfoIS2_EENS6_IS5_EEE16InsertIntoBucketERKS2_RKS5_PSt4pairIS2_S5_E", "llvm::DenseMap<clang::Selector, clang::ObjCMethodDecl const*, llvm::DenseMapInfo<clang::Selector>, llvm::DenseMapInfo<clang::ObjCMethodDecl const*> >::InsertIntoBucket(clang::Selector const&, clang::ObjCMethodDecl const* const&, std::pair<clang::Selector, clang::ObjCMethodDecl const*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang8SelectorEPKNS1_14ObjCMethodDeclENS_12DenseMapInfoIS2_EENS6_IS5_EEE4growEj", "llvm::DenseMap<clang::Selector, clang::ObjCMethodDecl const*, llvm::DenseMapInfo<clang::Selector>, llvm::DenseMapInfo<clang::ObjCMethodDecl const*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang14IdentifierInfoEPNS1_9LabelStmtENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PSt4pairIS3_S5_E", "llvm::DenseMap<clang::IdentifierInfo*, clang::LabelStmt*, llvm::DenseMapInfo<clang::IdentifierInfo*>, llvm::DenseMapInfo<clang::LabelStmt*> >::InsertIntoBucket(clang::IdentifierInfo* const&, clang::LabelStmt* const&, std::pair<clang::IdentifierInfo*, clang::LabelStmt*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang14IdentifierInfoEPNS1_9LabelStmtENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<clang::IdentifierInfo*, clang::LabelStmt*, llvm::DenseMapInfo<clang::IdentifierInfo*>, llvm::DenseMapInfo<clang::LabelStmt*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang7VarDeclEjNS_12DenseMapInfoIS3_EENS4_IjEEE16InsertIntoBucketERKS3_RKjPSt4pairIS3_jE", "llvm::DenseMap<clang::VarDecl*, unsigned int, llvm::DenseMapInfo<clang::VarDecl*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(clang::VarDecl* const&, unsigned int const&, std::pair<clang::VarDecl*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang7VarDeclEjNS_12DenseMapInfoIS3_EENS4_IjEEE4growEj", "llvm::DenseMap<clang::VarDecl*, unsigned int, llvm::DenseMapInfo<clang::VarDecl*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN5clang12InitListExprESt4pairIKS2_S2_ESt10_Select1stIS5_ESt4lessIS2_ESaIS5_EE8_M_eraseEPSt13_Rb_tree_nodeIS5_E", "std::_Rb_tree<clang::InitListExpr*, std::pair<clang::InitListExpr* const, clang::InitListExpr*>, std::_Select1st<std::pair<clang::InitListExpr* const, clang::InitListExpr*> >, std::less<clang::InitListExpr*>, std::allocator<std::pair<clang::InitListExpr* const, clang::InitListExpr*> > >::_M_erase(std::_Rb_tree_node<std::pair<clang::InitListExpr* const, clang::InitListExpr*> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN5clang12InitListExprESt4pairIKS2_S2_ESt10_Select1stIS5_ESt4lessIS2_ESaIS5_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS5_ERKS5_", "std::_Rb_tree<clang::InitListExpr*, std::pair<clang::InitListExpr* const, clang::InitListExpr*>, std::_Select1st<std::pair<clang::InitListExpr* const, clang::InitListExpr*> >, std::less<clang::InitListExpr*>, std::allocator<std::pair<clang::InitListExpr* const, clang::InitListExpr*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<clang::InitListExpr* const, clang::InitListExpr*> >, std::pair<clang::InitListExpr* const, clang::InitListExpr*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN5clang12InitListExprESt4pairIKS2_S2_ESt10_Select1stIS5_ESt4lessIS2_ESaIS5_EE16_M_insert_uniqueERKS5_", "std::_Rb_tree<clang::InitListExpr*, std::pair<clang::InitListExpr* const, clang::InitListExpr*>, std::_Select1st<std::pair<clang::InitListExpr* const, clang::InitListExpr*> >, std::less<clang::InitListExpr*>, std::allocator<std::pair<clang::InitListExpr* const, clang::InitListExpr*> > >::_M_insert_unique(std::pair<clang::InitListExpr* const, clang::InitListExpr*> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang14IdentifierInfoESt4pairINS_9StringRefEbENS_12DenseMapInfoIS3_EENS7_IS6_EEE16InsertIntoBucketERKS3_RKS6_PS4_IS3_S6_E", "llvm::DenseMap<clang::IdentifierInfo*, std::pair<llvm::StringRef, bool>, llvm::DenseMapInfo<clang::IdentifierInfo*>, llvm::DenseMapInfo<std::pair<llvm::StringRef, bool> > >::InsertIntoBucket(clang::IdentifierInfo* const&, std::pair<llvm::StringRef, bool> const&, std::pair<clang::IdentifierInfo*, std::pair<llvm::StringRef, bool> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang14IdentifierInfoESt4pairINS_9StringRefEbENS_12DenseMapInfoIS3_EENS7_IS6_EEE4growEj", "llvm::DenseMap<clang::IdentifierInfo*, std::pair<llvm::StringRef, bool>, llvm::DenseMapInfo<clang::IdentifierInfo*>, llvm::DenseMapInfo<std::pair<llvm::StringRef, bool> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang9NamedDeclES3_NS_12DenseMapInfoIS3_EES5_E16InsertIntoBucketERKS3_S8_PSt4pairIS3_S3_E", "llvm::DenseMap<clang::NamedDecl*, clang::NamedDecl*, llvm::DenseMapInfo<clang::NamedDecl*>, llvm::DenseMapInfo<clang::NamedDecl*> >::InsertIntoBucket(clang::NamedDecl* const&, clang::NamedDecl* const&, std::pair<clang::NamedDecl*, clang::NamedDecl*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang9NamedDeclES3_NS_12DenseMapInfoIS3_EES5_E4growEj", "llvm::DenseMap<clang::NamedDecl*, clang::NamedDecl*, llvm::DenseMapInfo<clang::NamedDecl*>, llvm::DenseMapInfo<clang::NamedDecl*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN5clang4DeclES2_St9_IdentityIS2_ESt4lessIS2_ESaIS2_EE16_M_insert_uniqueERKS2_", "std::_Rb_tree<clang::Decl*, clang::Decl*, std::_Identity<clang::Decl*>, std::less<clang::Decl*>, std::allocator<clang::Decl*> >::_M_insert_unique(clang::Decl* const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN5clang4DeclES2_St9_IdentityIS2_ESt4lessIS2_ESaIS2_EE8_M_eraseEPSt13_Rb_tree_nodeIS2_E", "std::_Rb_tree<clang::Decl*, clang::Decl*, std::_Identity<clang::Decl*>, std::less<clang::Decl*>, std::allocator<clang::Decl*> >::_M_erase(std::_Rb_tree_node<clang::Decl*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang11DeclContextEcNS_12DenseMapInfoIS3_EENS4_IcEEE6insertERKSt4pairIS3_cE", "llvm::DenseMap<clang::DeclContext*, char, llvm::DenseMapInfo<clang::DeclContext*>, llvm::DenseMapInfo<char> >::insert(std::pair<clang::DeclContext*, char> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang11DeclContextEcNS_12DenseMapInfoIS3_EENS4_IcEEE16InsertIntoBucketERKS3_RKcPSt4pairIS3_cE", "llvm::DenseMap<clang::DeclContext*, char, llvm::DenseMapInfo<clang::DeclContext*>, llvm::DenseMapInfo<char> >::InsertIntoBucket(clang::DeclContext* const&, char const&, std::pair<clang::DeclContext*, char>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang11DeclContextEcNS_12DenseMapInfoIS3_EENS4_IcEEE4growEj", "llvm::DenseMap<clang::DeclContext*, char, llvm::DenseMapInfo<clang::DeclContext*>, llvm::DenseMapInfo<char> >::grow(unsigned int)"),
	mu_demangle_test("_ZN5clang4Sema26CollectImmediatePropertiesEPNS_17ObjCContainerDeclERN4llvm8DenseMapIPNS_14IdentifierInfoEPNS_16ObjCPropertyDeclENS3_12DenseMapInfoIS6_EENS9_IS8_EEEESD_", "clang::Sema::CollectImmediateProperties(clang::ObjCContainerDecl*, llvm::DenseMap<clang::IdentifierInfo*, clang::ObjCPropertyDecl*, llvm::DenseMapInfo<clang::IdentifierInfo*>, llvm::DenseMapInfo<clang::ObjCPropertyDecl*> >&, llvm::DenseMap<clang::IdentifierInfo*, clang::ObjCPropertyDecl*, llvm::DenseMapInfo<clang::IdentifierInfo*>, llvm::DenseMapInfo<clang::ObjCPropertyDecl*> >&)"),
	mu_demangle_test("_Z35CollectClassPropertyImplementationsPN5clang17ObjCContainerDeclERN4llvm8DenseMapIPNS_14IdentifierInfoEPNS_16ObjCPropertyDeclENS2_12DenseMapInfoIS5_EENS8_IS7_EEEE", "CollectClassPropertyImplementations(clang::ObjCContainerDecl*, llvm::DenseMap<clang::IdentifierInfo*, clang::ObjCPropertyDecl*, llvm::DenseMapInfo<clang::IdentifierInfo*>, llvm::DenseMapInfo<clang::ObjCPropertyDecl*> >&)"),
	mu_demangle_test("_ZN5clang4Sema31DiagnoseUnimplementedPropertiesEPNS_5ScopeEPNS_12ObjCImplDeclEPNS_17ObjCContainerDeclERKN4llvm8DenseSetINS_8SelectorENS7_12DenseMapInfoIS9_EEEE", "clang::Sema::DiagnoseUnimplementedProperties(clang::Scope*, clang::ObjCImplDecl*, clang::ObjCContainerDecl*, llvm::DenseSet<clang::Selector, llvm::DenseMapInfo<clang::Selector> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang16ObjCPropertyDeclEcNS_12DenseMapInfoIS3_EENS4_IcEEE6insertERKSt4pairIS3_cE", "llvm::DenseMap<clang::ObjCPropertyDecl*, char, llvm::DenseMapInfo<clang::ObjCPropertyDecl*>, llvm::DenseMapInfo<char> >::insert(std::pair<clang::ObjCPropertyDecl*, char> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang16ObjCPropertyDeclEcNS_12DenseMapInfoIS3_EENS4_IcEEE16InsertIntoBucketERKS3_RKcPSt4pairIS3_cE", "llvm::DenseMap<clang::ObjCPropertyDecl*, char, llvm::DenseMapInfo<clang::ObjCPropertyDecl*>, llvm::DenseMapInfo<char> >::InsertIntoBucket(clang::ObjCPropertyDecl* const&, char const&, std::pair<clang::ObjCPropertyDecl*, char>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang16ObjCPropertyDeclEcNS_12DenseMapInfoIS3_EENS4_IcEEE4growEj", "llvm::DenseMap<clang::ObjCPropertyDecl*, char, llvm::DenseMapInfo<clang::ObjCPropertyDecl*>, llvm::DenseMapInfo<char> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang14IdentifierInfoEPNS1_16ObjCPropertyDeclENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PSt4pairIS3_S5_E", "llvm::DenseMap<clang::IdentifierInfo*, clang::ObjCPropertyDecl*, llvm::DenseMapInfo<clang::IdentifierInfo*>, llvm::DenseMapInfo<clang::ObjCPropertyDecl*> >::InsertIntoBucket(clang::IdentifierInfo* const&, clang::ObjCPropertyDecl* const&, std::pair<clang::IdentifierInfo*, clang::ObjCPropertyDecl*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang14IdentifierInfoEPNS1_16ObjCPropertyDeclENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<clang::IdentifierInfo*, clang::ObjCPropertyDecl*, llvm::DenseMapInfo<clang::IdentifierInfo*>, llvm::DenseMapInfo<clang::ObjCPropertyDecl*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNK4llvm8DenseMapISt4pairIN5clang7CanQualINS2_4TypeEEES5_EcNS_12DenseMapInfoIS6_EENS7_IcEEE15LookupBucketForERKS6_RPS1_IS6_cE", "llvm::DenseMap<std::pair<clang::CanQual<clang::Type>, clang::CanQual<clang::Type> >, char, llvm::DenseMapInfo<std::pair<clang::CanQual<clang::Type>, clang::CanQual<clang::Type> > >, llvm::DenseMapInfo<char> >::LookupBucketFor(std::pair<clang::CanQual<clang::Type>, clang::CanQual<clang::Type> > const&, std::pair<std::pair<clang::CanQual<clang::Type>, clang::CanQual<clang::Type> >, char>*&) const"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIN5clang7CanQualINS2_4TypeEEES5_EcNS_12DenseMapInfoIS6_EENS7_IcEEE6insertERKS1_IS6_cE", "llvm::DenseMap<std::pair<clang::CanQual<clang::Type>, clang::CanQual<clang::Type> >, char, llvm::DenseMapInfo<std::pair<clang::CanQual<clang::Type>, clang::CanQual<clang::Type> > >, llvm::DenseMapInfo<char> >::insert(std::pair<std::pair<clang::CanQual<clang::Type>, clang::CanQual<clang::Type> >, char> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIN5clang7CanQualINS2_4TypeEEES5_EcNS_12DenseMapInfoIS6_EENS7_IcEEE16InsertIntoBucketERKS6_RKcPS1_IS6_cE", "llvm::DenseMap<std::pair<clang::CanQual<clang::Type>, clang::CanQual<clang::Type> >, char, llvm::DenseMapInfo<std::pair<clang::CanQual<clang::Type>, clang::CanQual<clang::Type> > >, llvm::DenseMapInfo<char> >::InsertIntoBucket(std::pair<clang::CanQual<clang::Type>, clang::CanQual<clang::Type> > const&, char const&, std::pair<std::pair<clang::CanQual<clang::Type>, clang::CanQual<clang::Type> >, char>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIN5clang7CanQualINS2_4TypeEEES5_EcNS_12DenseMapInfoIS6_EENS7_IcEEE4growEj", "llvm::DenseMap<std::pair<clang::CanQual<clang::Type>, clang::CanQual<clang::Type> >, char, llvm::DenseMapInfo<std::pair<clang::CanQual<clang::Type>, clang::CanQual<clang::Type> > >, llvm::DenseMapInfo<char> >::grow(unsigned int)"),
	mu_demangle_test("_ZSt4swapISt4pairIN4llvm6APSIntEPN5clang16EnumConstantDeclEEEvRT_S8_", "void std::swap<std::pair<llvm::APSInt, clang::EnumConstantDecl*> >(std::pair<llvm::APSInt, clang::EnumConstantDecl*>&, std::pair<llvm::APSInt, clang::EnumConstantDecl*>&)"),
	mu_demangle_test("_ZNSt17_Temporary_bufferIPSt4pairIN4llvm6APSIntEPN5clang16EnumConstantDeclEES6_EC2ES7_S7_", "std::_Temporary_buffer<std::pair<llvm::APSInt, clang::EnumConstantDecl*>*, std::pair<llvm::APSInt, clang::EnumConstantDecl*> >::_Temporary_buffer(std::pair<llvm::APSInt, clang::EnumConstantDecl*>*, std::pair<llvm::APSInt, clang::EnumConstantDecl*>*)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm6APSIntESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<llvm::APSInt, std::allocator<llvm::APSInt> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::APSInt*, std::vector<llvm::APSInt, std::allocator<llvm::APSInt> > >, llvm::APSInt const&)"),
	mu_demangle_test("_ZSt21__inplace_stable_sortIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm6APSIntEPN5clang8CaseStmtEESt6vectorIS8_SaIS8_EEEEEvT_SE_", "void std::__inplace_stable_sort<__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > > >(__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >)"),
	mu_demangle_test("_ZSt22__stable_sort_adaptiveIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm6APSIntEPN5clang8CaseStmtEESt6vectorIS8_SaIS8_EEEES9_lEvT_SE_T0_T1_", "void std::__stable_sort_adaptive<__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, std::pair<llvm::APSInt, clang::CaseStmt*>*, long>(__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, std::pair<llvm::APSInt, clang::CaseStmt*>*, long)"),
	mu_demangle_test("_ZSt24__merge_sort_with_bufferIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm6APSIntEPN5clang8CaseStmtEESt6vectorIS8_SaIS8_EEEES9_EvT_SE_T0_", "void std::__merge_sort_with_buffer<__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, std::pair<llvm::APSInt, clang::CaseStmt*>*>(__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, std::pair<llvm::APSInt, clang::CaseStmt*>*)"),
	mu_demangle_test("_ZSt16__merge_adaptiveIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm6APSIntEPN5clang8CaseStmtEESt6vectorIS8_SaIS8_EEEElS9_EvT_SE_SE_T0_SF_T1_SF_", "void std::__merge_adaptive<__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, long, std::pair<llvm::APSInt, clang::CaseStmt*>*>(__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, long, long, std::pair<llvm::APSInt, clang::CaseStmt*>*, long)"),
	mu_demangle_test("_ZSt5mergeIPSt4pairIN4llvm6APSIntEPN5clang8CaseStmtEEN9__gnu_cxx17__normal_iteratorIS7_St6vectorIS6_SaIS6_EEEESD_ET1_T_SF_T0_SG_SE_", "__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > > std::merge<std::pair<llvm::APSInt, clang::CaseStmt*>*, __gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > > >(std::pair<llvm::APSInt, clang::CaseStmt*>*, std::pair<llvm::APSInt, clang::CaseStmt*>*, __gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >)"),
	mu_demangle_test("_ZSt16__merge_backwardIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm6APSIntEPN5clang8CaseStmtEESt6vectorIS8_SaIS8_EEEES9_SD_ET1_T_SF_T0_SG_SE_", "__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > > std::__merge_backward<__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, std::pair<llvm::APSInt, clang::CaseStmt*>*, __gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > > >(__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, std::pair<llvm::APSInt, clang::CaseStmt*>*, std::pair<llvm::APSInt, clang::CaseStmt*>*, __gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >)"),
	mu_demangle_test("_ZSt11lower_boundIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm6APSIntEPN5clang8CaseStmtEESt6vectorIS8_SaIS8_EEEES8_ET_SE_SE_RKT0_", "__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > > std::lower_bound<__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, std::pair<llvm::APSInt, clang::CaseStmt*> >(__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, std::pair<llvm::APSInt, clang::CaseStmt*> const&)"),
	mu_demangle_test("_ZSt11upper_boundIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm6APSIntEPN5clang8CaseStmtEESt6vectorIS8_SaIS8_EEEES8_ET_SE_SE_RKT0_", "__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > > std::upper_bound<__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, std::pair<llvm::APSInt, clang::CaseStmt*> >(__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, std::pair<llvm::APSInt, clang::CaseStmt*> const&)"),
	mu_demangle_test("_ZSt17__rotate_adaptiveIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm6APSIntEPN5clang8CaseStmtEESt6vectorIS8_SaIS8_EEEES9_lET_SE_SE_SE_T1_SF_T0_SF_", "__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > > std::__rotate_adaptive<__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, std::pair<llvm::APSInt, clang::CaseStmt*>*, long>(__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, long, long, std::pair<llvm::APSInt, clang::CaseStmt*>*, long)"),
	mu_demangle_test("_ZSt8__rotateIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm6APSIntEPN5clang8CaseStmtEESt6vectorIS8_SaIS8_EEEEEvT_SE_SE_St26random_access_iterator_tag", "void std::__rotate<__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > > >(__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, std::random_access_iterator_tag)"),
	mu_demangle_test("_ZSt4swapISt4pairIN4llvm6APSIntEPN5clang8CaseStmtEEEvRT_S8_", "void std::swap<std::pair<llvm::APSInt, clang::CaseStmt*> >(std::pair<llvm::APSInt, clang::CaseStmt*>&, std::pair<llvm::APSInt, clang::CaseStmt*>&)"),
	mu_demangle_test("_ZSt5mergeIPSt4pairIN4llvm6APSIntEPN5clang8CaseStmtEES7_N9__gnu_cxx17__normal_iteratorIS7_St6vectorIS6_SaIS6_EEEEET1_T_SF_T0_SG_SE_", "__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > > std::merge<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::pair<llvm::APSInt, clang::CaseStmt*>*, __gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > > >(std::pair<llvm::APSInt, clang::CaseStmt*>*, std::pair<llvm::APSInt, clang::CaseStmt*>*, std::pair<llvm::APSInt, clang::CaseStmt*>*, std::pair<llvm::APSInt, clang::CaseStmt*>*, __gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >)"),
	mu_demangle_test("_ZSt5mergeIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm6APSIntEPN5clang8CaseStmtEESt6vectorIS8_SaIS8_EEEESD_S9_ET1_T_SF_T0_SG_SE_", "std::pair<llvm::APSInt, clang::CaseStmt*>* std::merge<__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, std::pair<llvm::APSInt, clang::CaseStmt*>*>(__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, std::pair<llvm::APSInt, clang::CaseStmt*>*)"),
	mu_demangle_test("_ZSt16__insertion_sortIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm6APSIntEPN5clang8CaseStmtEESt6vectorIS8_SaIS8_EEEEEvT_SE_", "void std::__insertion_sort<__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > > >(__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >)"),
	mu_demangle_test("_ZSt25__unguarded_linear_insertIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm6APSIntEPN5clang8CaseStmtEESt6vectorIS8_SaIS8_EEEES8_EvT_T0_", "void std::__unguarded_linear_insert<__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, std::pair<llvm::APSInt, clang::CaseStmt*> >(__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, std::pair<llvm::APSInt, clang::CaseStmt*>)"),
	mu_demangle_test("_ZSt22__merge_without_bufferIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm6APSIntEPN5clang8CaseStmtEESt6vectorIS8_SaIS8_EEEElEvT_SE_SE_T0_SF_", "void std::__merge_without_buffer<__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, long>(__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, long, long)"),
	mu_demangle_test("_ZNSt17_Temporary_bufferIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm6APSIntEPN5clang8CaseStmtEESt6vectorIS8_SaIS8_EEEES8_EC2ESD_SD_", "std::_Temporary_buffer<__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, std::pair<llvm::APSInt, clang::CaseStmt*> >::_Temporary_buffer(__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >)"),
	mu_demangle_test("_ZNSt17_Temporary_bufferIPSt4pairIN4llvm6APSIntEPN5clang8CaseStmtEES6_EC2ES7_S7_", "std::_Temporary_buffer<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::pair<llvm::APSInt, clang::CaseStmt*> >::_Temporary_buffer(std::pair<llvm::APSInt, clang::CaseStmt*>*, std::pair<llvm::APSInt, clang::CaseStmt*>*)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN4llvm6APSIntEPN5clang8CaseStmtEESaIS6_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS6_S8_EERKS6_", "std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::APSInt, clang::CaseStmt*>*, std::vector<std::pair<llvm::APSInt, clang::CaseStmt*>, std::allocator<std::pair<llvm::APSInt, clang::CaseStmt*> > > >, std::pair<llvm::APSInt, clang::CaseStmt*> const&)"),
	mu_demangle_test("_ZN5clang13TreeTransformIN12_GLOBAL__N_129CurrentInstantiationRebuilderEE26TransformTemplateArgumentsINS_33TemplateArgumentLocInventIteratorIS2_PKNS_16TemplateArgumentEEEEEbT_SA_RNS_24TemplateArgumentListInfoE", "bool clang::TreeTransform<(anonymous namespace)::CurrentInstantiationRebuilder>::TransformTemplateArguments<clang::TemplateArgumentLocInventIterator<(anonymous namespace)::CurrentInstantiationRebuilder, clang::TemplateArgument const*> >(clang::TemplateArgumentLocInventIterator<(anonymous namespace)::CurrentInstantiationRebuilder, clang::TemplateArgument const*>, clang::TemplateArgumentLocInventIterator<(anonymous namespace)::CurrentInstantiationRebuilder, clang::TemplateArgument const*>, clang::TemplateArgumentListInfo&)"),
	mu_demangle_test("_Z28PrepareArgumentPackDeductionRN5clang4SemaERN4llvm15SmallVectorImplINS_23DeducedTemplateArgumentEEERKNS3_IjEES6_RNS3_INS2_11SmallVectorIS4_Lj4EEEEE", "PrepareArgumentPackDeduction(clang::Sema&, llvm::SmallVectorImpl<clang::DeducedTemplateArgument>&, llvm::SmallVectorImpl<unsigned int> const&, llvm::SmallVectorImpl<clang::DeducedTemplateArgument>&, llvm::SmallVectorImpl<llvm::SmallVector<clang::DeducedTemplateArgument, 4u> >&)"),
	mu_demangle_test("_Z27FinishArgumentPackDeductionRN5clang4SemaEPNS_21TemplateParameterListEbRN4llvm15SmallVectorImplINS_23DeducedTemplateArgumentEEERKNS5_IjEES8_RNS5_INS4_11SmallVectorIS6_Lj4EEEEERNS_4sema21TemplateDeductionInfoE", "FinishArgumentPackDeduction(clang::Sema&, clang::TemplateParameterList*, bool, llvm::SmallVectorImpl<clang::DeducedTemplateArgument>&, llvm::SmallVectorImpl<unsigned int> const&, llvm::SmallVectorImpl<clang::DeducedTemplateArgument>&, llvm::SmallVectorImpl<llvm::SmallVector<clang::DeducedTemplateArgument, 4u> >&, clang::sema::TemplateDeductionInfo&)"),
	mu_demangle_test("_ZN4llvm15SmallVectorImplISt4pairIN5clang14SourceLocationENS2_17PartialDiagnosticEEE6appendIPKS5_EEvT_SA_", "void llvm::SmallVectorImpl<std::pair<clang::SourceLocation, clang::PartialDiagnostic> >::append<std::pair<clang::SourceLocation, clang::PartialDiagnostic> const*>(std::pair<clang::SourceLocation, clang::PartialDiagnostic> const*, std::pair<clang::SourceLocation, clang::PartialDiagnostic> const*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang4DeclENS_11SmallVectorISt4pairINS1_14SourceLocationENS1_17PartialDiagnosticEELj1EEENS_12DenseMapInfoIS3_EENSA_IS9_EEE16FindAndConstructERKS3_", "llvm::DenseMap<clang::Decl*, llvm::SmallVector<std::pair<clang::SourceLocation, clang::PartialDiagnostic>, 1u>, llvm::DenseMapInfo<clang::Decl*>, llvm::DenseMapInfo<llvm::SmallVector<std::pair<clang::SourceLocation, clang::PartialDiagnostic>, 1u> > >::FindAndConstruct(clang::Decl* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang4DeclENS_11SmallVectorISt4pairINS1_14SourceLocationENS1_17PartialDiagnosticEELj1EEENS_12DenseMapInfoIS3_EENSA_IS9_EEE16InsertIntoBucketERKS3_RKS9_PS5_IS3_S9_E", "llvm::DenseMap<clang::Decl*, llvm::SmallVector<std::pair<clang::SourceLocation, clang::PartialDiagnostic>, 1u>, llvm::DenseMapInfo<clang::Decl*>, llvm::DenseMapInfo<llvm::SmallVector<std::pair<clang::SourceLocation, clang::PartialDiagnostic>, 1u> > >::InsertIntoBucket(clang::Decl* const&, llvm::SmallVector<std::pair<clang::SourceLocation, clang::PartialDiagnostic>, 1u> const&, std::pair<clang::Decl*, llvm::SmallVector<std::pair<clang::SourceLocation, clang::PartialDiagnostic>, 1u> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang4DeclENS_11SmallVectorISt4pairINS1_14SourceLocationENS1_17PartialDiagnosticEELj1EEENS_12DenseMapInfoIS3_EENSA_IS9_EEE4growEj", "llvm::DenseMap<clang::Decl*, llvm::SmallVector<std::pair<clang::SourceLocation, clang::PartialDiagnostic>, 1u>, llvm::DenseMapInfo<clang::Decl*>, llvm::DenseMapInfo<llvm::SmallVector<std::pair<clang::SourceLocation, clang::PartialDiagnostic>, 1u> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm15SmallVectorImplISt4pairIN5clang14SourceLocationENS2_17PartialDiagnosticEEEaSERKS6_", "llvm::SmallVectorImpl<std::pair<clang::SourceLocation, clang::PartialDiagnostic> >::operator=(llvm::SmallVectorImpl<std::pair<clang::SourceLocation, clang::PartialDiagnostic> > const&)"),
	mu_demangle_test("_ZN5clang13TreeTransformIN12_GLOBAL__N_120TemplateInstantiatorEE26TransformTemplateArgumentsINS_33TemplateArgumentLocInventIteratorIS2_PKNS_16TemplateArgumentEEEEEbT_SA_RNS_24TemplateArgumentListInfoE", "bool clang::TreeTransform<(anonymous namespace)::TemplateInstantiator>::TransformTemplateArguments<clang::TemplateArgumentLocInventIterator<(anonymous namespace)::TemplateInstantiator, clang::TemplateArgument const*> >(clang::TemplateArgumentLocInventIterator<(anonymous namespace)::TemplateInstantiator, clang::TemplateArgument const*>, clang::TemplateArgumentLocInventIterator<(anonymous namespace)::TemplateInstantiator, clang::TemplateArgument const*>, clang::TemplateArgumentListInfo&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4DeclENS_12PointerUnionIPS2_PNS_11SmallVectorIS6_Lj4EEEEENS_12DenseMapInfoIS4_EENSB_ISA_EEE16InsertIntoBucketERKS4_RKSA_PSt4pairIS4_SA_E", "llvm::DenseMap<clang::Decl const*, llvm::PointerUnion<clang::Decl*, llvm::SmallVector<clang::Decl*, 4u>*>, llvm::DenseMapInfo<clang::Decl const*>, llvm::DenseMapInfo<llvm::PointerUnion<clang::Decl*, llvm::SmallVector<clang::Decl*, 4u>*> > >::InsertIntoBucket(clang::Decl const* const&, llvm::PointerUnion<clang::Decl*, llvm::SmallVector<clang::Decl*, 4u>*> const&, std::pair<clang::Decl const*, llvm::PointerUnion<clang::Decl*, llvm::SmallVector<clang::Decl*, 4u>*> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4DeclENS_12PointerUnionIPS2_PNS_11SmallVectorIS6_Lj4EEEEENS_12DenseMapInfoIS4_EENSB_ISA_EEE4growEj", "llvm::DenseMap<clang::Decl const*, llvm::PointerUnion<clang::Decl*, llvm::SmallVector<clang::Decl*, 4u>*>, llvm::DenseMapInfo<clang::Decl const*>, llvm::DenseMapInfo<llvm::PointerUnion<clang::Decl*, llvm::SmallVector<clang::Decl*, 4u>*> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang11ParmVarDeclENS_11SmallVectorIS3_Lj1EEENS_12DenseMapInfoIS3_EENS6_IS5_EEE16FindAndConstructERKS3_", "llvm::DenseMap<clang::ParmVarDecl*, llvm::SmallVector<clang::ParmVarDecl*, 1u>, llvm::DenseMapInfo<clang::ParmVarDecl*>, llvm::DenseMapInfo<llvm::SmallVector<clang::ParmVarDecl*, 1u> > >::FindAndConstruct(clang::ParmVarDecl* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang11ParmVarDeclENS_11SmallVectorIS3_Lj1EEENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PSt4pairIS3_S5_E", "llvm::DenseMap<clang::ParmVarDecl*, llvm::SmallVector<clang::ParmVarDecl*, 1u>, llvm::DenseMapInfo<clang::ParmVarDecl*>, llvm::DenseMapInfo<llvm::SmallVector<clang::ParmVarDecl*, 1u> > >::InsertIntoBucket(clang::ParmVarDecl* const&, llvm::SmallVector<clang::ParmVarDecl*, 1u> const&, std::pair<clang::ParmVarDecl*, llvm::SmallVector<clang::ParmVarDecl*, 1u> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang11ParmVarDeclENS_11SmallVectorIS3_Lj1EEENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<clang::ParmVarDecl*, llvm::SmallVector<clang::ParmVarDecl*, 1u>, llvm::DenseMapInfo<clang::ParmVarDecl*>, llvm::DenseMapInfo<llvm::SmallVector<clang::ParmVarDecl*, 1u> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm15SmallVectorImplISt4pairIPN5clang13CXXRecordDeclENS2_14SourceLocationEEE4swapERS7_", "llvm::SmallVectorImpl<std::pair<clang::CXXRecordDecl*, clang::SourceLocation> >::swap(llvm::SmallVectorImpl<std::pair<clang::CXXRecordDecl*, clang::SourceLocation> >&)"),
	mu_demangle_test("_Z32DiagnoseUnexpandedParameterPacksRN5clang4SemaENS_14SourceLocationENS0_30UnexpandedParameterPackContextERKN4llvm15SmallVectorImplISt4pairINS4_12PointerUnionIPKNS_20TemplateTypeParmTypeEPNS_9NamedDeclEEES2_EEE", "DiagnoseUnexpandedParameterPacks(clang::Sema&, clang::SourceLocation, clang::Sema::UnexpandedParameterPackContext, llvm::SmallVectorImpl<std::pair<llvm::PointerUnion<clang::TemplateTypeParmType const*, clang::NamedDecl*>, clang::SourceLocation> > const&)"),
	mu_demangle_test("_ZN5clang4Sema31collectUnexpandedParameterPacksENS_16TemplateArgumentERN4llvm15SmallVectorImplISt4pairINS2_12PointerUnionIPKNS_20TemplateTypeParmTypeEPNS_9NamedDeclEEENS_14SourceLocationEEEE", "clang::Sema::collectUnexpandedParameterPacks(clang::TemplateArgument, llvm::SmallVectorImpl<std::pair<llvm::PointerUnion<clang::TemplateTypeParmType const*, clang::NamedDecl*>, clang::SourceLocation> >&)"),
	mu_demangle_test("_ZN5clang4Sema31collectUnexpandedParameterPacksENS_19TemplateArgumentLocERN4llvm15SmallVectorImplISt4pairINS2_12PointerUnionIPKNS_20TemplateTypeParmTypeEPNS_9NamedDeclEEENS_14SourceLocationEEEE", "clang::Sema::collectUnexpandedParameterPacks(clang::TemplateArgumentLoc, llvm::SmallVectorImpl<std::pair<llvm::PointerUnion<clang::TemplateTypeParmType const*, clang::NamedDecl*>, clang::SourceLocation> >&)"),
	mu_demangle_test("_ZN5clang4Sema31collectUnexpandedParameterPacksENS_8QualTypeERN4llvm15SmallVectorImplISt4pairINS2_12PointerUnionIPKNS_20TemplateTypeParmTypeEPNS_9NamedDeclEEENS_14SourceLocationEEEE", "clang::Sema::collectUnexpandedParameterPacks(clang::QualType, llvm::SmallVectorImpl<std::pair<llvm::PointerUnion<clang::TemplateTypeParmType const*, clang::NamedDecl*>, clang::SourceLocation> >&)"),
	mu_demangle_test("_ZN5clang4Sema31collectUnexpandedParameterPacksENS_7TypeLocERN4llvm15SmallVectorImplISt4pairINS2_12PointerUnionIPKNS_20TemplateTypeParmTypeEPNS_9NamedDeclEEENS_14SourceLocationEEEE", "clang::Sema::collectUnexpandedParameterPacks(clang::TypeLoc, llvm::SmallVectorImpl<std::pair<llvm::PointerUnion<clang::TemplateTypeParmType const*, clang::NamedDecl*>, clang::SourceLocation> >&)"),
	mu_demangle_test("_ZNSt6vectorIPFvRN12_GLOBAL__N_116AnalysisConsumerERN5clang4ento15AnalysisManagerEPNS3_4DeclEESaISA_EE9push_backERKSA_", "std::vector<void (*)((anonymous namespace)::AnalysisConsumer&, clang::ento::AnalysisManager&, clang::Decl*), std::allocator<void (*)((anonymous namespace)::AnalysisConsumer&, clang::ento::AnalysisManager&, clang::Decl*)> >::push_back(void (* const&)((anonymous namespace)::AnalysisConsumer&, clang::ento::AnalysisManager&, clang::Decl*))"),
	mu_demangle_test("_ZN12_GLOBAL__N_116AnalysisConsumer10HandleCodeEPN5clang4DeclERSt6vectorIPFvRS0_RNS1_4ento15AnalysisManagerES3_ESaISA_EE", "(anonymous namespace)::AnalysisConsumer::HandleCode(clang::Decl*, std::vector<void (*)((anonymous namespace)::AnalysisConsumer&, clang::ento::AnalysisManager&, clang::Decl*), std::allocator<void (*)((anonymous namespace)::AnalysisConsumer&, clang::ento::AnalysisManager&, clang::Decl*)> >&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_17ImutContainerInfoIPN5clang4ento7BugTypeEEEEC2Ev", "llvm::ImutAVLFactory<llvm::ImutContainerInfo<clang::ento::BugType*> >::ImutAVLFactory()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPvjNS_12DenseMapInfoIS1_EENS2_IjEEE16InsertIntoBucketERKS1_RKjPSt4pairIS1_jE", "llvm::DenseMap<void*, unsigned int, llvm::DenseMapInfo<void*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(void* const&, unsigned int const&, std::pair<void*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPvjNS_12DenseMapInfoIS1_EENS2_IjEEE4growEj", "llvm::DenseMap<void*, unsigned int, llvm::DenseMapInfo<void*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZN5clang4ento19GRStatePartialTraitIN4llvm12ImmutableMapIPKNS0_9MemRegionENS0_4SValENS2_16ImutKeyValueInfoIS6_S7_EEEEE13CreateContextERNS2_16BumpPtrAllocatorE", "clang::ento::GRStatePartialTrait<llvm::ImmutableMap<clang::ento::MemRegion const*, clang::ento::SVal, llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> > >::CreateContext(llvm::BumpPtrAllocator&)"),
	mu_demangle_test("_ZN5clang4ento19GRStatePartialTraitIN4llvm12ImmutableMapIPKNS0_9MemRegionENS0_4SValENS2_16ImutKeyValueInfoIS6_S7_EEEEE13DeleteContextEPv", "clang::ento::GRStatePartialTrait<llvm::ImmutableMap<clang::ento::MemRegion const*, clang::ento::SVal, llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> > >::DeleteContext(void*)"),
	mu_demangle_test("_ZN5clang4ento19GRStatePartialTraitIN4llvm12ImmutableMapIPKNS0_9MemRegionENS0_4SValENS2_16ImutKeyValueInfoIS6_S7_EEEEE3SetESA_S6_S7_RNSA_7FactoryE", "clang::ento::GRStatePartialTrait<llvm::ImmutableMap<clang::ento::MemRegion const*, clang::ento::SVal, llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> > >::Set(llvm::ImmutableMap<clang::ento::MemRegion const*, clang::ento::SVal, llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >, clang::ento::MemRegion const*, clang::ento::SVal, llvm::ImmutableMap<clang::ento::MemRegion const*, clang::ento::SVal, llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >::Factory&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang8SelectorEPNS1_14ObjCMethodDeclENS_12DenseMapInfoIS2_EENS5_IS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<clang::Selector, clang::ObjCMethodDecl*, llvm::DenseMapInfo<clang::Selector>, llvm::DenseMapInfo<clang::ObjCMethodDecl*> >::InsertIntoBucket(clang::Selector const&, clang::ObjCMethodDecl* const&, std::pair<clang::Selector, clang::ObjCMethodDecl*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang8SelectorEPNS1_14ObjCMethodDeclENS_12DenseMapInfoIS2_EENS5_IS4_EEE4growEj", "llvm::DenseMap<clang::Selector, clang::ObjCMethodDecl*, llvm::DenseMapInfo<clang::Selector>, llvm::DenseMapInfo<clang::ObjCMethodDecl*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPSt6vectorISt4pairIPvPN5clang4ento7CheckerEESaIS8_EENS_12DenseMapInfoIjEENSC_ISB_EEE16InsertIntoBucketERKjRKSB_PS2_IjSB_E", "llvm::DenseMap<unsigned int, std::vector<std::pair<void*, clang::ento::Checker*>, std::allocator<std::pair<void*, clang::ento::Checker*> > >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<std::vector<std::pair<void*, clang::ento::Checker*>, std::allocator<std::pair<void*, clang::ento::Checker*> > >*> >::InsertIntoBucket(unsigned int const&, std::vector<std::pair<void*, clang::ento::Checker*>, std::allocator<std::pair<void*, clang::ento::Checker*> > >* const&, std::pair<unsigned int, std::vector<std::pair<void*, clang::ento::Checker*>, std::allocator<std::pair<void*, clang::ento::Checker*> > >*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPSt6vectorISt4pairIPvPN5clang4ento7CheckerEESaIS8_EENS_12DenseMapInfoIjEENSC_ISB_EEE4growEj", "llvm::DenseMap<unsigned int, std::vector<std::pair<void*, clang::ento::Checker*>, std::allocator<std::pair<void*, clang::ento::Checker*> > >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<std::vector<std::pair<void*, clang::ento::Checker*>, std::allocator<std::pair<void*, clang::ento::Checker*> > >*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang14BinaryOperatorEN12_GLOBAL__N_126IdempotentOperationChecker18BinaryOperatorDataENS_12DenseMapInfoIS4_EENS8_IS7_EEEixERKS4_", "llvm::DenseMap<clang::BinaryOperator const*, (anonymous namespace)::IdempotentOperationChecker::BinaryOperatorData, llvm::DenseMapInfo<clang::BinaryOperator const*>, llvm::DenseMapInfo<(anonymous namespace)::IdempotentOperationChecker::BinaryOperatorData> >::operator[](clang::BinaryOperator const* const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPFvRN5clang4ento18BugReporterContextEPKvPKNS2_12ExplodedNodeEES6_ESaISC_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPSC_SE_EERKSC_", "std::vector<std::pair<void (*)(clang::ento::BugReporterContext&, void const*, clang::ento::ExplodedNode const*), void const*>, std::allocator<std::pair<void (*)(clang::ento::BugReporterContext&, void const*, clang::ento::ExplodedNode const*), void const*> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<void (*)(clang::ento::BugReporterContext&, void const*, clang::ento::ExplodedNode const*), void const*>*, std::vector<std::pair<void (*)(clang::ento::BugReporterContext&, void const*, clang::ento::ExplodedNode const*), void const*>, std::allocator<std::pair<void (*)(clang::ento::BugReporterContext&, void const*, clang::ento::ExplodedNode const*), void const*> > > >, std::pair<void (*)(clang::ento::BugReporterContext&, void const*, clang::ento::ExplodedNode const*), void const*> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjNS_8SmallSetIjLj32EEENS_12DenseMapInfoIjEENS3_IS2_EEE16FindAndConstructERKj", "llvm::DenseMap<unsigned int, llvm::SmallSet<unsigned int, 32u>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::SmallSet<unsigned int, 32u> > >::FindAndConstruct(unsigned int const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjNS_8SmallSetIjLj32EEENS_12DenseMapInfoIjEENS3_IS2_EEE16InsertIntoBucketERKjRKS2_PSt4pairIjS2_E", "llvm::DenseMap<unsigned int, llvm::SmallSet<unsigned int, 32u>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::SmallSet<unsigned int, 32u> > >::InsertIntoBucket(unsigned int const&, llvm::SmallSet<unsigned int, 32u> const&, std::pair<unsigned int, llvm::SmallSet<unsigned int, 32u> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjNS_8SmallSetIjLj32EEENS_12DenseMapInfoIjEENS3_IS2_EEE4growEj", "llvm::DenseMap<unsigned int, llvm::SmallSet<unsigned int, 32u>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::SmallSet<unsigned int, 32u> > >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt5dequeIPKN5clang8CFGBlockESaIS3_EE9push_backERKS3_", "std::deque<clang::CFGBlock const*, std::allocator<clang::CFGBlock const*> >::push_back(clang::CFGBlock const* const&)"),
	mu_demangle_test("_ZNSt5dequeIPKN5clang8CFGBlockESaIS3_EE17_M_reallocate_mapEmb", "std::deque<clang::CFGBlock const*, std::allocator<clang::CFGBlock const*> >::_M_reallocate_map(unsigned long, bool)"),
	mu_demangle_test("_ZNSt11_Deque_baseIPKN5clang8CFGBlockESaIS3_EE17_M_initialize_mapEm", "std::_Deque_base<clang::CFGBlock const*, std::allocator<clang::CFGBlock const*> >::_M_initialize_map(unsigned long)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjNS_8SmallSetIjLj32EEENS_12DenseMapInfoIjEENS3_IS2_EEED1Ev", "llvm::DenseMap<unsigned int, llvm::SmallSet<unsigned int, 32u>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::SmallSet<unsigned int, 32u> > >::~DenseMap()"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_18RefStateEEEE7destroyEv", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefState> >::destroy()"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_18RefStateEEEEENS_12DenseMapInfoIjEENSD_ISC_EEEixERKj", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefState> >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefState> >*> >::operator[](unsigned int const&)"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_18RefStateEEEE13computeDigestEv", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefState> >::computeDigest()"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm11ImutAVLTreeINS0_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_18RefStateEEEEESaISC_EE9push_backERKSC_", "std::vector<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefState> >*, std::allocator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefState> >*> >::push_back(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefState> >* const&)"),
	mu_demangle_test("_ZN4llvm26ImutAVLTreeInOrderIteratorINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_18RefStateEEEEppEv", "llvm::ImutAVLTreeInOrderIterator<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefState> >::operator++()"),
	mu_demangle_test("_ZN5clang4ento19GRStatePartialTraitIN4llvm12ImmutableMapIPKNS0_10SymbolDataEN12_GLOBAL__N_18RefStateENS2_16ImutKeyValueInfoIS6_S8_EEEEE13CreateContextERNS2_16BumpPtrAllocatorE", "clang::ento::GRStatePartialTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, (anonymous namespace)::RefState, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefState> > >::CreateContext(llvm::BumpPtrAllocator&)"),
	mu_demangle_test("_ZN5clang4ento19GRStatePartialTraitIN4llvm12ImmutableMapIPKNS0_10SymbolDataEN12_GLOBAL__N_18RefStateENS2_16ImutKeyValueInfoIS6_S8_EEEEE13DeleteContextEPv", "clang::ento::GRStatePartialTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, (anonymous namespace)::RefState, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefState> > >::DeleteContext(void*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_18RefStateEEEE16getCanonicalTreeEPNS_11ImutAVLTreeIS9_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefState> >::getCanonicalTree(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefState> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_18RefStateEEEE12add_internalERKSt4pairIS6_S8_EPNS_11ImutAVLTreeIS9_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefState> >::add_internal(std::pair<clang::ento::SymbolData const*, (anonymous namespace)::RefState> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefState> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_18RefStateEEEE13markImmutableEPNS_11ImutAVLTreeIS9_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefState> >::markImmutable(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefState> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_18RefStateEEEE10createNodeEPNS_11ImutAVLTreeIS9_EERKSt4pairIS6_S8_ESD_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefState> >::createNode(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefState> >*, std::pair<clang::ento::SymbolData const*, (anonymous namespace)::RefState> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefState> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_18RefStateEEEE11balanceTreeEPNS_11ImutAVLTreeIS9_EERKSt4pairIS6_S8_ESD_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefState> >::balanceTree(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefState> >*, std::pair<clang::ento::SymbolData const*, (anonymous namespace)::RefState> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefState> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_18RefStateEEEE15remove_internalERKS6_PNS_11ImutAVLTreeIS9_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefState> >::remove_internal(clang::ento::SymbolData const* const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefState> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_18RefStateEEEE16removeMinBindingEPNS_11ImutAVLTreeIS9_EERSD_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefState> >::removeMinBinding(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefState> >*, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefState> >*&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPvPN5clang4ento7CheckerEESaIS6_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS6_S8_EERKS6_", "std::vector<std::pair<void*, clang::ento::Checker*>, std::allocator<std::pair<void*, clang::ento::Checker*> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<void*, clang::ento::Checker*>*, std::vector<std::pair<void*, clang::ento::Checker*>, std::allocator<std::pair<void*, clang::ento::Checker*> > > >, std::pair<void*, clang::ento::Checker*> const&)"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEjEEE7destroyEv", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >::destroy()"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEjEEE13computeDigestEv", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >::computeDigest()"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm11ImutAVLTreeINS0_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEjEEEESaISA_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPSA_SC_EERKSA_", "std::vector<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >*, std::allocator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >**, std::vector<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >*, std::allocator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >*> > >, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEjEEEENS_12DenseMapInfoIjEENSB_ISA_EEE16InsertIntoBucketERKjRKSA_PSt4pairIjSA_E", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >*> >::InsertIntoBucket(unsigned int const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >* const&, std::pair<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEjEEEENS_12DenseMapInfoIjEENSB_ISA_EEE4growEj", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN5clang4ento14GRStateManager3setIN4llvm12ImmutableMapIPKNS0_10SymbolDataEjNS3_16ImutKeyValueInfoIS7_jEEEEEEPKNS0_7GRStateESD_NS0_12GRStateTraitIT_E8key_typeENSG_10value_typeENSG_12context_typeE", "clang::ento::GRState const* clang::ento::GRStateManager::set<llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > >(clang::ento::GRState const*, clang::ento::GRStateTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > >::key_type, clang::ento::GRStateTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > >::value_type, clang::ento::GRStateTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > >::context_type)"),
	mu_demangle_test("_ZN5clang4ento19GRStatePartialTraitIN4llvm12ImmutableMapIPKNS0_10SymbolDataEjNS2_16ImutKeyValueInfoIS6_jEEEEE13CreateContextERNS2_16BumpPtrAllocatorE", "clang::ento::GRStatePartialTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > >::CreateContext(llvm::BumpPtrAllocator&)"),
	mu_demangle_test("_ZN5clang4ento19GRStatePartialTraitIN4llvm12ImmutableMapIPKNS0_10SymbolDataEjNS2_16ImutKeyValueInfoIS6_jEEEEE13DeleteContextEPv", "clang::ento::GRStatePartialTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > >::DeleteContext(void*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEjEEED2Ev", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >::~ImutAVLFactory()"),
	mu_demangle_test("_ZN5clang4ento19GRStatePartialTraitIN4llvm12ImmutableMapIPKNS0_10SymbolDataEjNS2_16ImutKeyValueInfoIS6_jEEEEE3SetES9_S6_jRNS9_7FactoryE", "clang::ento::GRStatePartialTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > >::Set(llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >, clang::ento::SymbolData const*, unsigned int, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >::Factory&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEjEEE3addEPNS_11ImutAVLTreeIS7_EERKSt4pairIS6_jE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >::add(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >*, std::pair<clang::ento::SymbolData const*, unsigned int> const&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEjEEE16getCanonicalTreeEPNS_11ImutAVLTreeIS7_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >::getCanonicalTree(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEjEEE22compareTreeWithSectionEPNS_11ImutAVLTreeIS7_EERNS_26ImutAVLTreeInOrderIteratorIS7_EESE_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >::compareTreeWithSection(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >*, llvm::ImutAVLTreeInOrderIterator<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >&, llvm::ImutAVLTreeInOrderIterator<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >&)"),
	mu_demangle_test("_ZN4llvm26ImutAVLTreeGenericIteratorINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEjEEEppEv", "llvm::ImutAVLTreeGenericIterator<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >::operator++()"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEjEEE12add_internalERKSt4pairIS6_jEPNS_11ImutAVLTreeIS7_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >::add_internal(std::pair<clang::ento::SymbolData const*, unsigned int> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEjEEE13markImmutableEPNS_11ImutAVLTreeIS7_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >::markImmutable(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEjEEE10createNodeEPNS_11ImutAVLTreeIS7_EERKSt4pairIS6_jESB_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >::createNode(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >*, std::pair<clang::ento::SymbolData const*, unsigned int> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEjEEE11balanceTreeEPNS_11ImutAVLTreeIS7_EERKSt4pairIS6_jESB_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >::balanceTree(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >*, std::pair<clang::ento::SymbolData const*, unsigned int> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >*)"),
	mu_demangle_test("_Z4ScanRN4llvm8DenseMapIPKN5clang12ObjCIvarDeclE9IVarStateNS_12DenseMapInfoIS4_EENS6_IS5_EEEEPKNS1_17ObjCContainerDeclE", "Scan(llvm::DenseMap<clang::ObjCIvarDecl const*, IVarState, llvm::DenseMapInfo<clang::ObjCIvarDecl const*>, llvm::DenseMapInfo<IVarState> >&, clang::ObjCContainerDecl const*)"),
	mu_demangle_test("_Z4ScanRN4llvm8DenseMapIPKN5clang12ObjCIvarDeclE9IVarStateNS_12DenseMapInfoIS4_EENS6_IS5_EEEEPKNS1_4StmtE", "Scan(llvm::DenseMap<clang::ObjCIvarDecl const*, IVarState, llvm::DenseMapInfo<clang::ObjCIvarDecl const*>, llvm::DenseMapInfo<IVarState> >&, clang::Stmt const*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang12ObjCIvarDeclE9IVarStateNS_12DenseMapInfoIS4_EENS6_IS5_EEE16InsertIntoBucketERKS4_RKS5_PSt4pairIS4_S5_E", "llvm::DenseMap<clang::ObjCIvarDecl const*, IVarState, llvm::DenseMapInfo<clang::ObjCIvarDecl const*>, llvm::DenseMapInfo<IVarState> >::InsertIntoBucket(clang::ObjCIvarDecl const* const&, IVarState const&, std::pair<clang::ObjCIvarDecl const*, IVarState>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang12ObjCIvarDeclE9IVarStateNS_12DenseMapInfoIS4_EENS6_IS5_EEE4growEj", "llvm::DenseMap<clang::ObjCIvarDecl const*, IVarState, llvm::DenseMapInfo<clang::ObjCIvarDecl const*>, llvm::DenseMapInfo<IVarState> >::grow(unsigned int)"),
	mu_demangle_test("_ZN5clang4ento19GRStatePartialTraitIN4llvm12ImmutableSetIPKNS0_9MemRegionENS2_17ImutContainerInfoIS6_EEEEE13CreateContextERNS2_16BumpPtrAllocatorE", "clang::ento::GRStatePartialTrait<llvm::ImmutableSet<clang::ento::MemRegion const*, llvm::ImutContainerInfo<clang::ento::MemRegion const*> > >::CreateContext(llvm::BumpPtrAllocator&)"),
	mu_demangle_test("_ZN5clang4ento19GRStatePartialTraitIN4llvm12ImmutableSetIPKNS0_9MemRegionENS2_17ImutContainerInfoIS6_EEEEE13DeleteContextEPv", "clang::ento::GRStatePartialTrait<llvm::ImmutableSet<clang::ento::MemRegion const*, llvm::ImutContainerInfo<clang::ento::MemRegion const*> > >::DeleteContext(void*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_17ImutContainerInfoIPKN5clang4ento9MemRegionEEEE6removeEPNS_11ImutAVLTreeIS7_EES6_", "llvm::ImutAVLFactory<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >::remove(llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >*, clang::ento::MemRegion const*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_17ImutContainerInfoIPKN5clang4ento9MemRegionEEEE15remove_internalES6_PNS_11ImutAVLTreeIS7_EE", "llvm::ImutAVLFactory<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >::remove_internal(clang::ento::MemRegion const*, llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_17ImutContainerInfoIPKN5clang4ento9MemRegionEEEE16removeMinBindingEPNS_11ImutAVLTreeIS7_EERSB_", "llvm::ImutAVLFactory<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >::removeMinBinding(llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >*, llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >*&)"),
	mu_demangle_test("_ZN5clang4ento19GRStatePartialTraitIN4llvm12ImmutableMapIPKNS0_10SymbolDataEN12_GLOBAL__N_111StreamStateENS2_16ImutKeyValueInfoIS6_S8_EEEEE13CreateContextERNS2_16BumpPtrAllocatorE", "clang::ento::GRStatePartialTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, (anonymous namespace)::StreamState, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::StreamState> > >::CreateContext(llvm::BumpPtrAllocator&)"),
	mu_demangle_test("_ZN5clang4ento19GRStatePartialTraitIN4llvm12ImmutableMapIPKNS0_10SymbolDataEN12_GLOBAL__N_111StreamStateENS2_16ImutKeyValueInfoIS6_S8_EEEEE13DeleteContextEPv", "clang::ento::GRStatePartialTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, (anonymous namespace)::StreamState, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::StreamState> > >::DeleteContext(void*)"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_111StreamStateEEEE7destroyEv", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::StreamState> >::destroy()"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_111StreamStateEEEEENS_12DenseMapInfoIjEENSD_ISC_EEEixERKj", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::StreamState> >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::StreamState> >*> >::operator[](unsigned int const&)"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_111StreamStateEEEE13computeDigestEv", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::StreamState> >::computeDigest()"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm11ImutAVLTreeINS0_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_111StreamStateEEEEESaISC_EE9push_backERKSC_", "std::vector<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::StreamState> >*, std::allocator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::StreamState> >*> >::push_back(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::StreamState> >* const&)"),
	mu_demangle_test("_ZN4llvm26ImutAVLTreeInOrderIteratorINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_111StreamStateEEEEppEv", "llvm::ImutAVLTreeInOrderIterator<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::StreamState> >::operator++()"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_111StreamStateEEEE12add_internalERKSt4pairIS6_S8_EPNS_11ImutAVLTreeIS9_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::StreamState> >::add_internal(std::pair<clang::ento::SymbolData const*, (anonymous namespace)::StreamState> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::StreamState> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_111StreamStateEEEE13markImmutableEPNS_11ImutAVLTreeIS9_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::StreamState> >::markImmutable(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::StreamState> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_111StreamStateEEEE10createNodeEPNS_11ImutAVLTreeIS9_EERKSt4pairIS6_S8_ESD_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::StreamState> >::createNode(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::StreamState> >*, std::pair<clang::ento::SymbolData const*, (anonymous namespace)::StreamState> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::StreamState> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_111StreamStateEEEE11balanceTreeEPNS_11ImutAVLTreeIS9_EERKSt4pairIS6_S8_ESD_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::StreamState> >::balanceTree(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::StreamState> >*, std::pair<clang::ento::SymbolData const*, (anonymous namespace)::StreamState> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::StreamState> >*)"),
	mu_demangle_test("_ZN5clang4ento19GRStatePartialTraitIN4llvm12ImmutableMapIPKNS0_10SymbolDataEPKNS2_6APSIntENS2_16ImutKeyValueInfoIS6_S9_EEEEE13CreateContextERNS2_16BumpPtrAllocatorE", "clang::ento::GRStatePartialTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, llvm::APSInt const*, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> > >::CreateContext(llvm::BumpPtrAllocator&)"),
	mu_demangle_test("_ZN5clang4ento19GRStatePartialTraitIN4llvm12ImmutableMapIPKNS0_10SymbolDataEPKNS2_6APSIntENS2_16ImutKeyValueInfoIS6_S9_EEEEE13DeleteContextEPv", "clang::ento::GRStatePartialTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, llvm::APSInt const*, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> > >::DeleteContext(void*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEPKNS_6APSIntEEEED2Ev", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >::~ImutAVLFactory()"),
	mu_demangle_test("_ZN5clang4ento19GRStatePartialTraitIN4llvm12ImmutableMapIPKNS0_10SymbolDataEPKNS2_6APSIntENS2_16ImutKeyValueInfoIS6_S9_EEEEE3SetESC_S6_S9_RNSC_7FactoryE", "clang::ento::GRStatePartialTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, llvm::APSInt const*, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> > >::Set(llvm::ImmutableMap<clang::ento::SymbolData const*, llvm::APSInt const*, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >, clang::ento::SymbolData const*, llvm::APSInt const*, llvm::ImmutableMap<clang::ento::SymbolData const*, llvm::APSInt const*, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >::Factory&)"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEPKNS_6APSIntEEEE7destroyEv", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >::destroy()"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEPKNS_6APSIntEEEE13computeDigestEv", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >::computeDigest()"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm11ImutAVLTreeINS0_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEPKNS0_6APSIntEEEEESaISD_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPSD_SF_EERKSD_", "std::vector<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >*, std::allocator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >**, std::vector<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >*, std::allocator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >*> > >, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEPKNS_6APSIntEEEEENS_12DenseMapInfoIjEENSE_ISD_EEE16InsertIntoBucketERKjRKSD_PSt4pairIjSD_E", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >*> >::InsertIntoBucket(unsigned int const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >* const&, std::pair<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEPKNS_6APSIntEEEEENS_12DenseMapInfoIjEENSE_ISD_EEE4growEj", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEPKNS_6APSIntEEEE3addEPNS_11ImutAVLTreeISA_EERKSt4pairIS6_S9_E", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >::add(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >*, std::pair<clang::ento::SymbolData const*, llvm::APSInt const*> const&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEPKNS_6APSIntEEEE16getCanonicalTreeEPNS_11ImutAVLTreeISA_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >::getCanonicalTree(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEPKNS_6APSIntEEEE22compareTreeWithSectionEPNS_11ImutAVLTreeISA_EERNS_26ImutAVLTreeInOrderIteratorISA_EESH_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >::compareTreeWithSection(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >*, llvm::ImutAVLTreeInOrderIterator<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >&, llvm::ImutAVLTreeInOrderIterator<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >&)"),
	mu_demangle_test("_ZN4llvm26ImutAVLTreeGenericIteratorINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEPKNS_6APSIntEEEEppEv", "llvm::ImutAVLTreeGenericIterator<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >::operator++()"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEPKNS_6APSIntEEEE12add_internalERKSt4pairIS6_S9_EPNS_11ImutAVLTreeISA_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >::add_internal(std::pair<clang::ento::SymbolData const*, llvm::APSInt const*> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEPKNS_6APSIntEEEE13markImmutableEPNS_11ImutAVLTreeISA_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >::markImmutable(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEPKNS_6APSIntEEEE10createNodeEPNS_11ImutAVLTreeISA_EERKSt4pairIS6_S9_ESE_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >::createNode(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >*, std::pair<clang::ento::SymbolData const*, llvm::APSInt const*> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEPKNS_6APSIntEEEE11balanceTreeEPNS_11ImutAVLTreeISA_EERKSt4pairIS6_S9_ESE_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >::balanceTree(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >*, std::pair<clang::ento::SymbolData const*, llvm::APSInt const*> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >*)"),
	mu_demangle_test("_ZN5clang4ento19GRStatePartialTraitIN4llvm12ImmutableMapIPKNS0_10SymbolDataENS2_12ImmutableSetIPNS2_6APSIntENS2_17ImutContainerInfoIS9_EEEENS2_16ImutKeyValueInfoIS6_SC_EEEEE6LookupESF_S6_", "clang::ento::GRStatePartialTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> >, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > > >::Lookup(llvm::ImmutableMap<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> >, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >, clang::ento::SymbolData const*)"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS_12ImmutableSetIPNS_6APSIntENS_17ImutContainerInfoIS9_EEEEEEE7destroyEv", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >::destroy()"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS_12ImmutableSetIPNS_6APSIntENS_17ImutContainerInfoIS9_EEEEEEE13computeDigestEv", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >::computeDigest()"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm11ImutAVLTreeINS0_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS0_12ImmutableSetIPNS0_6APSIntENS0_17ImutContainerInfoISA_EEEEEEEESaISG_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPSG_SI_EERKSG_", "std::vector<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >*, std::allocator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >**, std::vector<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >*, std::allocator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >*> > >, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS_12ImmutableSetIPNS_6APSIntENS_17ImutContainerInfoISA_EEEEEEEENS_12DenseMapInfoIjEENSH_ISG_EEE16InsertIntoBucketERKjRKSG_PSt4pairIjSG_E", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >*> >::InsertIntoBucket(unsigned int const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >* const&, std::pair<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS_12ImmutableSetIPNS_6APSIntENS_17ImutContainerInfoISA_EEEEEEEENS_12DenseMapInfoIjEENSH_ISG_EEE4growEj", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN5clang4ento19GRStatePartialTraitIN4llvm12ImmutableMapIPKNS0_10SymbolDataENS2_12ImmutableSetIPNS2_6APSIntENS2_17ImutContainerInfoIS9_EEEENS2_16ImutKeyValueInfoIS6_SC_EEEEE13CreateContextERNS2_16BumpPtrAllocatorE", "clang::ento::GRStatePartialTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> >, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > > >::CreateContext(llvm::BumpPtrAllocator&)"),
	mu_demangle_test("_ZN5clang4ento19GRStatePartialTraitIN4llvm12ImmutableMapIPKNS0_10SymbolDataENS2_12ImmutableSetIPNS2_6APSIntENS2_17ImutContainerInfoIS9_EEEENS2_16ImutKeyValueInfoIS6_SC_EEEEE13DeleteContextEPv", "clang::ento::GRStatePartialTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> >, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > > >::DeleteContext(void*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS_12ImmutableSetIPNS_6APSIntENS_17ImutContainerInfoIS9_EEEEEEED2Ev", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >::~ImutAVLFactory()"),
	mu_demangle_test("_ZN4llvm12ImmutableMapIPKN5clang4ento10SymbolDataENS_12ImmutableSetIPNS_6APSIntENS_17ImutContainerInfoIS8_EEEENS_16ImutKeyValueInfoIS5_SB_EEE7Factory3addESE_RKS5_RKSB_", "llvm::ImmutableMap<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> >, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >::Factory::add(llvm::ImmutableMap<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> >, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >, clang::ento::SymbolData const* const&, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > const&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS_12ImmutableSetIPNS_6APSIntENS_17ImutContainerInfoIS9_EEEEEEE3addEPNS_11ImutAVLTreeISD_EERKSt4pairIS6_SC_E", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >::add(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >*, std::pair<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > const&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS_12ImmutableSetIPNS_6APSIntENS_17ImutContainerInfoIS9_EEEEEEE16getCanonicalTreeEPNS_11ImutAVLTreeISD_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >::getCanonicalTree(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS_12ImmutableSetIPNS_6APSIntENS_17ImutContainerInfoIS9_EEEEEEE22compareTreeWithSectionEPNS_11ImutAVLTreeISD_EERNS_26ImutAVLTreeInOrderIteratorISD_EESK_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >::compareTreeWithSection(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >*, llvm::ImutAVLTreeInOrderIterator<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >&, llvm::ImutAVLTreeInOrderIterator<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >&)"),
	mu_demangle_test("_ZN4llvm26ImutAVLTreeGenericIteratorINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS_12ImmutableSetIPNS_6APSIntENS_17ImutContainerInfoIS9_EEEEEEEppEv", "llvm::ImutAVLTreeGenericIterator<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >::operator++()"),
	mu_demangle_test("_ZNK4llvm11ImutAVLTreeINS_17ImutContainerInfoIPNS_6APSIntEEEE7isEqualERKS5_", "llvm::ImutAVLTree<llvm::ImutContainerInfo<llvm::APSInt*> >::isEqual(llvm::ImutAVLTree<llvm::ImutContainerInfo<llvm::APSInt*> > const&) const"),
	mu_demangle_test("_ZN4llvm26ImutAVLTreeGenericIteratorINS_17ImutContainerInfoIPNS_6APSIntEEEEppEv", "llvm::ImutAVLTreeGenericIterator<llvm::ImutContainerInfo<llvm::APSInt*> >::operator++()"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS_12ImmutableSetIPNS_6APSIntENS_17ImutContainerInfoIS9_EEEEEEE12add_internalERKSt4pairIS6_SC_EPNS_11ImutAVLTreeISD_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >::add_internal(std::pair<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS_12ImmutableSetIPNS_6APSIntENS_17ImutContainerInfoIS9_EEEEEEE13markImmutableEPNS_11ImutAVLTreeISD_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >::markImmutable(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS_12ImmutableSetIPNS_6APSIntENS_17ImutContainerInfoIS9_EEEEEEE10createNodeEPNS_11ImutAVLTreeISD_EERKSt4pairIS6_SC_ESH_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >::createNode(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >*, std::pair<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS_12ImmutableSetIPNS_6APSIntENS_17ImutContainerInfoIS9_EEEEEEE11balanceTreeEPNS_11ImutAVLTreeISD_EERKSt4pairIS6_SC_ESH_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >::balanceTree(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >*, std::pair<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >*)"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_17ImutContainerInfoIPNS_6APSIntEEEE7destroyEv", "llvm::ImutAVLTree<llvm::ImutContainerInfo<llvm::APSInt*> >::destroy()"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_17ImutContainerInfoIPNS_6APSIntEEEE13computeDigestEv", "llvm::ImutAVLTree<llvm::ImutContainerInfo<llvm::APSInt*> >::computeDigest()"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm11ImutAVLTreeINS0_17ImutContainerInfoIPNS0_6APSIntEEEEESaIS7_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS7_S9_EERKS7_", "std::vector<llvm::ImutAVLTree<llvm::ImutContainerInfo<llvm::APSInt*> >*, std::allocator<llvm::ImutAVLTree<llvm::ImutContainerInfo<llvm::APSInt*> >*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::ImutAVLTree<llvm::ImutContainerInfo<llvm::APSInt*> >**, std::vector<llvm::ImutAVLTree<llvm::ImutContainerInfo<llvm::APSInt*> >*, std::allocator<llvm::ImutAVLTree<llvm::ImutContainerInfo<llvm::APSInt*> >*> > >, llvm::ImutAVLTree<llvm::ImutContainerInfo<llvm::APSInt*> >* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_17ImutContainerInfoIPNS_6APSIntEEEEENS_12DenseMapInfoIjEENS8_IS7_EEE16InsertIntoBucketERKjRKS7_PSt4pairIjS7_E", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutContainerInfo<llvm::APSInt*> >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutContainerInfo<llvm::APSInt*> >*> >::InsertIntoBucket(unsigned int const&, llvm::ImutAVLTree<llvm::ImutContainerInfo<llvm::APSInt*> >* const&, std::pair<unsigned int, llvm::ImutAVLTree<llvm::ImutContainerInfo<llvm::APSInt*> >*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_17ImutContainerInfoIPNS_6APSIntEEEEENS_12DenseMapInfoIjEENS8_IS7_EEE4growEj", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutContainerInfo<llvm::APSInt*> >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutContainerInfo<llvm::APSInt*> >*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_17ImutContainerInfoIPNS_6APSIntEEEE3addEPNS_11ImutAVLTreeIS4_EEPKS2_", "llvm::ImutAVLFactory<llvm::ImutContainerInfo<llvm::APSInt*> >::add(llvm::ImutAVLTree<llvm::ImutContainerInfo<llvm::APSInt*> >*, llvm::APSInt const*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_17ImutContainerInfoIPNS_6APSIntEEEE16getCanonicalTreeEPNS_11ImutAVLTreeIS4_EE", "llvm::ImutAVLFactory<llvm::ImutContainerInfo<llvm::APSInt*> >::getCanonicalTree(llvm::ImutAVLTree<llvm::ImutContainerInfo<llvm::APSInt*> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_17ImutContainerInfoIPNS_6APSIntEEEE22compareTreeWithSectionEPNS_11ImutAVLTreeIS4_EERNS_26ImutAVLTreeInOrderIteratorIS4_EESB_", "llvm::ImutAVLFactory<llvm::ImutContainerInfo<llvm::APSInt*> >::compareTreeWithSection(llvm::ImutAVLTree<llvm::ImutContainerInfo<llvm::APSInt*> >*, llvm::ImutAVLTreeInOrderIterator<llvm::ImutContainerInfo<llvm::APSInt*> >&, llvm::ImutAVLTreeInOrderIterator<llvm::ImutContainerInfo<llvm::APSInt*> >&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_17ImutContainerInfoIPNS_6APSIntEEEE12add_internalEPKS2_PNS_11ImutAVLTreeIS4_EE", "llvm::ImutAVLFactory<llvm::ImutContainerInfo<llvm::APSInt*> >::add_internal(llvm::APSInt const*, llvm::ImutAVLTree<llvm::ImutContainerInfo<llvm::APSInt*> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_17ImutContainerInfoIPNS_6APSIntEEEE13markImmutableEPNS_11ImutAVLTreeIS4_EE", "llvm::ImutAVLFactory<llvm::ImutContainerInfo<llvm::APSInt*> >::markImmutable(llvm::ImutAVLTree<llvm::ImutContainerInfo<llvm::APSInt*> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_17ImutContainerInfoIPNS_6APSIntEEEE10createNodeEPNS_11ImutAVLTreeIS4_EEPKS2_S8_", "llvm::ImutAVLFactory<llvm::ImutContainerInfo<llvm::APSInt*> >::createNode(llvm::ImutAVLTree<llvm::ImutContainerInfo<llvm::APSInt*> >*, llvm::APSInt const*, llvm::ImutAVLTree<llvm::ImutContainerInfo<llvm::APSInt*> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_17ImutContainerInfoIPNS_6APSIntEEEE11balanceTreeEPNS_11ImutAVLTreeIS4_EEPKS2_S8_", "llvm::ImutAVLFactory<llvm::ImutContainerInfo<llvm::APSInt*> >::balanceTree(llvm::ImutAVLTree<llvm::ImutContainerInfo<llvm::APSInt*> >*, llvm::APSInt const*, llvm::ImutAVLTree<llvm::ImutContainerInfo<llvm::APSInt*> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS_12ImmutableSetIPNS_6APSIntENS_17ImutContainerInfoIS9_EEEEEEE6removeEPNS_11ImutAVLTreeISD_EERKS6_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >::remove(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >*, clang::ento::SymbolData const* const&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS_12ImmutableSetIPNS_6APSIntENS_17ImutContainerInfoIS9_EEEEEEE15remove_internalERKS6_PNS_11ImutAVLTreeISD_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >::remove_internal(clang::ento::SymbolData const* const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS_12ImmutableSetIPNS_6APSIntENS_17ImutContainerInfoIS9_EEEEEEE16removeMinBindingEPNS_11ImutAVLTreeISD_EERSH_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >::removeMinBinding(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >*, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableSet<llvm::APSInt*, llvm::ImutContainerInfo<llvm::APSInt*> > > >*&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEPKNS_6APSIntEEEE6removeEPNS_11ImutAVLTreeISA_EERKS6_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >::remove(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >*, clang::ento::SymbolData const* const&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEPKNS_6APSIntEEEE15remove_internalERKS6_PNS_11ImutAVLTreeISA_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >::remove_internal(clang::ento::SymbolData const* const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEPKNS_6APSIntEEEE16removeMinBindingEPNS_11ImutAVLTreeISA_EERSE_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >::removeMinBinding(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >*, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >*&)"),
	mu_demangle_test("_ZN5clang4ento19GRStatePartialTraitIN4llvm12ImmutableMapIPKNS0_10SymbolDataEPKNS2_6APSIntENS2_16ImutKeyValueInfoIS6_S9_EEEEE6LookupESC_S6_", "clang::ento::GRStatePartialTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, llvm::APSInt const*, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> > >::Lookup(llvm::ImmutableMap<clang::ento::SymbolData const*, llvm::APSInt const*, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::APSInt const*> >, clang::ento::SymbolData const*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_17ImutContainerInfoIPNS_6APSIntEEEED2Ev", "llvm::ImutAVLFactory<llvm::ImutContainerInfo<llvm::APSInt*> >::~ImutAVLFactory()"),
	mu_demangle_test("_ZN12_GLOBAL__N_117BasicStoreManager17InvalidateRegionsEPKvPKPKN5clang4ento9MemRegionES9_PKNS3_4ExprEjPN4llvm8DenseSetIPKNS4_10SymbolDataENSD_12DenseMapInfoISH_EEEEbPNSD_11SmallVectorIS7_Lj8EEE", "(anonymous namespace)::BasicStoreManager::InvalidateRegions(void const*, clang::ento::MemRegion const* const*, clang::ento::MemRegion const* const*, clang::Expr const*, unsigned int, llvm::DenseSet<clang::ento::SymbolData const*, llvm::DenseMapInfo<clang::ento::SymbolData const*> >*, bool, llvm::SmallVector<clang::ento::MemRegion const*, 8u>*)"),
	mu_demangle_test("_ZN12_GLOBAL__N_117BasicStoreManager16InvalidateRegionEPKvPKN5clang4ento9MemRegionEPKNS3_4ExprEjPN4llvm8DenseSetIPKNS4_10SymbolDataENSB_12DenseMapInfoISF_EEEE", "(anonymous namespace)::BasicStoreManager::InvalidateRegion(void const*, clang::ento::MemRegion const*, clang::Expr const*, unsigned int, llvm::DenseSet<clang::ento::SymbolData const*, llvm::DenseMapInfo<clang::ento::SymbolData const*> >*)"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS3_4SValEEEE7destroyEv", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >::destroy()"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm11ImutAVLTreeINS0_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS4_4SValEEEEESaISB_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPSB_SD_EERKSB_", "std::vector<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >*, std::allocator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >**, std::vector<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >*, std::allocator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >*> > >, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >* const&)"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS3_4SValEEEE13computeDigestEPS9_SA_RKSt4pairIS6_S7_E", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >::computeDigest(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >*, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >*, std::pair<clang::ento::MemRegion const*, clang::ento::SVal> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS4_4SValEEEEENS_12DenseMapInfoIjEENSC_ISB_EEE16InsertIntoBucketERKjRKSB_PSt4pairIjSB_E", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >*> >::InsertIntoBucket(unsigned int const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >* const&, std::pair<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS4_4SValEEEEENS_12DenseMapInfoIjEENSC_ISB_EEE4growEj", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm26ImutAVLTreeGenericIteratorINS_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS3_4SValEEEEppEv", "llvm::ImutAVLTreeGenericIterator<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >::operator++()"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS3_4SValEEEE6removeEPNS_11ImutAVLTreeIS8_EERKS6_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >::remove(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >*, clang::ento::MemRegion const* const&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS3_4SValEEEE16getCanonicalTreeEPNS_11ImutAVLTreeIS8_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >::getCanonicalTree(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS3_4SValEEEE22compareTreeWithSectionEPNS_11ImutAVLTreeIS8_EERNS_26ImutAVLTreeInOrderIteratorIS8_EESF_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >::compareTreeWithSection(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >*, llvm::ImutAVLTreeInOrderIterator<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >&, llvm::ImutAVLTreeInOrderIterator<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS3_4SValEEEE15remove_internalERKS6_PNS_11ImutAVLTreeIS8_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >::remove_internal(clang::ento::MemRegion const* const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS3_4SValEEEE13markImmutableEPNS_11ImutAVLTreeIS8_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >::markImmutable(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS3_4SValEEEE11balanceTreeEPNS_11ImutAVLTreeIS8_EERKSt4pairIS6_S7_ESC_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >::balanceTree(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >*, std::pair<clang::ento::MemRegion const*, clang::ento::SVal> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS3_4SValEEEE10createNodeEPNS_11ImutAVLTreeIS8_EERKSt4pairIS6_S7_ESC_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >::createNode(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >*, std::pair<clang::ento::MemRegion const*, clang::ento::SVal> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS3_4SValEEEE16removeMinBindingEPNS_11ImutAVLTreeIS8_EERSC_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >::removeMinBinding(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >*, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >*&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS3_4SValEEEE3addEPNS_11ImutAVLTreeIS8_EERKSt4pairIS6_S7_E", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >::add(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >*, std::pair<clang::ento::MemRegion const*, clang::ento::SVal> const&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS3_4SValEEEE12add_internalERKSt4pairIS6_S7_EPNS_11ImutAVLTreeIS8_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >::add_internal(std::pair<clang::ento::MemRegion const*, clang::ento::SVal> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS3_4SValEEEED2Ev", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, clang::ento::SVal> >::~ImutAVLFactory()"),
	mu_demangle_test("_ZN4llvm10FoldingSetINS_21FoldingSetNodeWrapperINS_6APSIntEEEED1Ev", "llvm::FoldingSet<llvm::FoldingSetNodeWrapper<llvm::APSInt> >::~FoldingSet()"),
	mu_demangle_test("_ZN4llvm21FoldingSetNodeWrapperISt4pairIN5clang4ento4SValES4_EED1Ev", "llvm::FoldingSetNodeWrapper<std::pair<clang::ento::SVal, clang::ento::SVal> >::~FoldingSetNodeWrapper()"),
	mu_demangle_test("_ZN4llvm21FoldingSetNodeWrapperISt4pairIN5clang4ento4SValES4_EED0Ev", "llvm::FoldingSetNodeWrapper<std::pair<clang::ento::SVal, clang::ento::SVal> >::~FoldingSetNodeWrapper()"),
	mu_demangle_test("_ZN4llvm10FoldingSetINS_21FoldingSetNodeWrapperISt4pairIN5clang4ento4SValES5_EEEED1Ev", "llvm::FoldingSet<llvm::FoldingSetNodeWrapper<std::pair<clang::ento::SVal, clang::ento::SVal> > >::~FoldingSet()"),
	mu_demangle_test("_ZN4llvm10FoldingSetINS_21FoldingSetNodeWrapperISt4pairIN5clang4ento4SValES5_EEEED0Ev", "llvm::FoldingSet<llvm::FoldingSetNodeWrapper<std::pair<clang::ento::SVal, clang::ento::SVal> > >::~FoldingSet()"),
	mu_demangle_test("_ZNK4llvm10FoldingSetINS_21FoldingSetNodeWrapperISt4pairIN5clang4ento4SValES5_EEEE14GetNodeProfileEPNS_14FoldingSetImpl4NodeERNS_16FoldingSetNodeIDE", "llvm::FoldingSet<llvm::FoldingSetNodeWrapper<std::pair<clang::ento::SVal, clang::ento::SVal> > >::GetNodeProfile(llvm::FoldingSetImpl::Node*, llvm::FoldingSetNodeID&) const"),
	mu_demangle_test("_ZNK4llvm10FoldingSetINS_21FoldingSetNodeWrapperISt4pairIN5clang4ento4SValES5_EEEE10NodeEqualsEPNS_14FoldingSetImpl4NodeERKNS_16FoldingSetNodeIDERSC_", "llvm::FoldingSet<llvm::FoldingSetNodeWrapper<std::pair<clang::ento::SVal, clang::ento::SVal> > >::NodeEquals(llvm::FoldingSetImpl::Node*, llvm::FoldingSetNodeID const&, llvm::FoldingSetNodeID&) const"),
	mu_demangle_test("_ZNK4llvm10FoldingSetINS_21FoldingSetNodeWrapperISt4pairIN5clang4ento4SValES5_EEEE15ComputeNodeHashEPNS_14FoldingSetImpl4NodeERNS_16FoldingSetNodeIDE", "llvm::FoldingSet<llvm::FoldingSetNodeWrapper<std::pair<clang::ento::SVal, clang::ento::SVal> > >::ComputeNodeHash(llvm::FoldingSetImpl::Node*, llvm::FoldingSetNodeID&) const"),
	mu_demangle_test("_ZN4llvm21FoldingSetNodeWrapperISt4pairIN5clang4ento4SValEmEED1Ev", "llvm::FoldingSetNodeWrapper<std::pair<clang::ento::SVal, unsigned long> >::~FoldingSetNodeWrapper()"),
	mu_demangle_test("_ZN4llvm21FoldingSetNodeWrapperISt4pairIN5clang4ento4SValEmEED0Ev", "llvm::FoldingSetNodeWrapper<std::pair<clang::ento::SVal, unsigned long> >::~FoldingSetNodeWrapper()"),
	mu_demangle_test("_ZN4llvm10FoldingSetINS_21FoldingSetNodeWrapperISt4pairIN5clang4ento4SValEmEEEED1Ev", "llvm::FoldingSet<llvm::FoldingSetNodeWrapper<std::pair<clang::ento::SVal, unsigned long> > >::~FoldingSet()"),
	mu_demangle_test("_ZN4llvm10FoldingSetINS_21FoldingSetNodeWrapperISt4pairIN5clang4ento4SValEmEEEED0Ev", "llvm::FoldingSet<llvm::FoldingSetNodeWrapper<std::pair<clang::ento::SVal, unsigned long> > >::~FoldingSet()"),
	mu_demangle_test("_ZNK4llvm10FoldingSetINS_21FoldingSetNodeWrapperISt4pairIN5clang4ento4SValEmEEEE14GetNodeProfileEPNS_14FoldingSetImpl4NodeERNS_16FoldingSetNodeIDE", "llvm::FoldingSet<llvm::FoldingSetNodeWrapper<std::pair<clang::ento::SVal, unsigned long> > >::GetNodeProfile(llvm::FoldingSetImpl::Node*, llvm::FoldingSetNodeID&) const"),
	mu_demangle_test("_ZNK4llvm10FoldingSetINS_21FoldingSetNodeWrapperISt4pairIN5clang4ento4SValEmEEEE10NodeEqualsEPNS_14FoldingSetImpl4NodeERKNS_16FoldingSetNodeIDERSC_", "llvm::FoldingSet<llvm::FoldingSetNodeWrapper<std::pair<clang::ento::SVal, unsigned long> > >::NodeEquals(llvm::FoldingSetImpl::Node*, llvm::FoldingSetNodeID const&, llvm::FoldingSetNodeID&) const"),
	mu_demangle_test("_ZNK4llvm10FoldingSetINS_21FoldingSetNodeWrapperISt4pairIN5clang4ento4SValEmEEEE15ComputeNodeHashEPNS_14FoldingSetImpl4NodeERNS_16FoldingSetNodeIDE", "llvm::FoldingSet<llvm::FoldingSetNodeWrapper<std::pair<clang::ento::SVal, unsigned long> > >::ComputeNodeHash(llvm::FoldingSetImpl::Node*, llvm::FoldingSetNodeID&) const"),
	mu_demangle_test("_ZN4llvm10FoldingSetINS_17ImmutableListImplIN5clang4ento4SValEEEED1Ev", "llvm::FoldingSet<llvm::ImmutableListImpl<clang::ento::SVal> >::~FoldingSet()"),
	mu_demangle_test("_ZN4llvm10FoldingSetINS_17ImmutableListImplIN5clang4ento4SValEEEED0Ev", "llvm::FoldingSet<llvm::ImmutableListImpl<clang::ento::SVal> >::~FoldingSet()"),
	mu_demangle_test("_ZNK4llvm10FoldingSetINS_17ImmutableListImplIN5clang4ento4SValEEEE14GetNodeProfileEPNS_14FoldingSetImpl4NodeERNS_16FoldingSetNodeIDE", "llvm::FoldingSet<llvm::ImmutableListImpl<clang::ento::SVal> >::GetNodeProfile(llvm::FoldingSetImpl::Node*, llvm::FoldingSetNodeID&) const"),
	mu_demangle_test("_ZNK4llvm10FoldingSetINS_17ImmutableListImplIN5clang4ento4SValEEEE10NodeEqualsEPNS_14FoldingSetImpl4NodeERKNS_16FoldingSetNodeIDERSA_", "llvm::FoldingSet<llvm::ImmutableListImpl<clang::ento::SVal> >::NodeEquals(llvm::FoldingSetImpl::Node*, llvm::FoldingSetNodeID const&, llvm::FoldingSetNodeID&) const"),
	mu_demangle_test("_ZNK4llvm10FoldingSetINS_17ImmutableListImplIN5clang4ento4SValEEEE15ComputeNodeHashEPNS_14FoldingSetImpl4NodeERNS_16FoldingSetNodeIDE", "llvm::FoldingSet<llvm::ImmutableListImpl<clang::ento::SVal> >::ComputeNodeHash(llvm::FoldingSetImpl::Node*, llvm::FoldingSetNodeID&) const"),
	mu_demangle_test("_ZN4llvm10FoldingSetINS_21FoldingSetNodeWrapperINS_6APSIntEEEED0Ev", "llvm::FoldingSet<llvm::FoldingSetNodeWrapper<llvm::APSInt> >::~FoldingSet()"),
	mu_demangle_test("_ZNK4llvm10FoldingSetINS_21FoldingSetNodeWrapperINS_6APSIntEEEE14GetNodeProfileEPNS_14FoldingSetImpl4NodeERNS_16FoldingSetNodeIDE", "llvm::FoldingSet<llvm::FoldingSetNodeWrapper<llvm::APSInt> >::GetNodeProfile(llvm::FoldingSetImpl::Node*, llvm::FoldingSetNodeID&) const"),
	mu_demangle_test("_ZNK4llvm10FoldingSetINS_21FoldingSetNodeWrapperINS_6APSIntEEEE10NodeEqualsEPNS_14FoldingSetImpl4NodeERKNS_16FoldingSetNodeIDERS8_", "llvm::FoldingSet<llvm::FoldingSetNodeWrapper<llvm::APSInt> >::NodeEquals(llvm::FoldingSetImpl::Node*, llvm::FoldingSetNodeID const&, llvm::FoldingSetNodeID&) const"),
	mu_demangle_test("_ZNK4llvm10FoldingSetINS_21FoldingSetNodeWrapperINS_6APSIntEEEE15ComputeNodeHashEPNS_14FoldingSetImpl4NodeERNS_16FoldingSetNodeIDE", "llvm::FoldingSet<llvm::FoldingSetNodeWrapper<llvm::APSInt> >::ComputeNodeHash(llvm::FoldingSetImpl::Node*, llvm::FoldingSetNodeID&) const"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIN12_GLOBAL__N_18CountKeyEjEEE13computeDigestEv", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::CountKey, unsigned int> >::computeDigest()"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_16ImutKeyValueInfoIN12_GLOBAL__N_18CountKeyEjEEEENS_12DenseMapInfoIjEENS8_IS7_EEEixERKj", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::CountKey, unsigned int> >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::CountKey, unsigned int> >*> >::operator[](unsigned int const&)"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIN12_GLOBAL__N_18CountKeyEjEEE7destroyEv", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::CountKey, unsigned int> >::destroy()"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm11ImutAVLTreeINS0_16ImutKeyValueInfoIN12_GLOBAL__N_18CountKeyEjEEEESaIS7_EE9push_backERKS7_", "std::vector<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::CountKey, unsigned int> >*, std::allocator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::CountKey, unsigned int> >*> >::push_back(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::CountKey, unsigned int> >* const&)"),
	mu_demangle_test("_ZN4llvm26ImutAVLTreeInOrderIteratorINS_16ImutKeyValueInfoIN12_GLOBAL__N_18CountKeyEjEEEppEv", "llvm::ImutAVLTreeInOrderIterator<llvm::ImutKeyValueInfo<(anonymous namespace)::CountKey, unsigned int> >::operator++()"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIN12_GLOBAL__N_18CountKeyEjEEE12add_internalERKSt4pairIS3_jEPNS_11ImutAVLTreeIS4_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<(anonymous namespace)::CountKey, unsigned int> >::add_internal(std::pair<(anonymous namespace)::CountKey, unsigned int> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::CountKey, unsigned int> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIN12_GLOBAL__N_18CountKeyEjEEE13markImmutableEPNS_11ImutAVLTreeIS4_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<(anonymous namespace)::CountKey, unsigned int> >::markImmutable(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::CountKey, unsigned int> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIN12_GLOBAL__N_18CountKeyEjEEE10createNodeEPNS_11ImutAVLTreeIS4_EERKSt4pairIS3_jES8_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<(anonymous namespace)::CountKey, unsigned int> >::createNode(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::CountKey, unsigned int> >*, std::pair<(anonymous namespace)::CountKey, unsigned int> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::CountKey, unsigned int> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIN12_GLOBAL__N_18CountKeyEjEEE11balanceTreeEPNS_11ImutAVLTreeIS4_EERKSt4pairIS3_jES8_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<(anonymous namespace)::CountKey, unsigned int> >::balanceTree(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::CountKey, unsigned int> >*, std::pair<(anonymous namespace)::CountKey, unsigned int> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::CountKey, unsigned int> >*)"),
	mu_demangle_test("_ZNSt6vectorIN12_GLOBAL__N_115ContextLocationESaIS1_EE9push_backERKS1_", "std::vector<(anonymous namespace)::ContextLocation, std::allocator<(anonymous namespace)::ContextLocation> >::push_back((anonymous namespace)::ContextLocation const&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_17ImutContainerInfoIPN5clang4ento7BugTypeEEEE3addEPNS_11ImutAVLTreeIS6_EEPKS4_", "llvm::ImutAVLFactory<llvm::ImutContainerInfo<clang::ento::BugType*> >::add(llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::BugType*> >*, clang::ento::BugType const*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_17ImutContainerInfoIPN5clang4ento7BugTypeEEEE16getCanonicalTreeEPNS_11ImutAVLTreeIS6_EE", "llvm::ImutAVLFactory<llvm::ImutContainerInfo<clang::ento::BugType*> >::getCanonicalTree(llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::BugType*> >*)"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_17ImutContainerInfoIPN5clang4ento7BugTypeEEEE13computeDigestEv", "llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::BugType*> >::computeDigest()"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_17ImutContainerInfoIPN5clang4ento7BugTypeEEEE22compareTreeWithSectionEPNS_11ImutAVLTreeIS6_EERNS_26ImutAVLTreeInOrderIteratorIS6_EESD_", "llvm::ImutAVLFactory<llvm::ImutContainerInfo<clang::ento::BugType*> >::compareTreeWithSection(llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::BugType*> >*, llvm::ImutAVLTreeInOrderIterator<llvm::ImutContainerInfo<clang::ento::BugType*> >&, llvm::ImutAVLTreeInOrderIterator<llvm::ImutContainerInfo<clang::ento::BugType*> >&)"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_17ImutContainerInfoIPN5clang4ento7BugTypeEEEE7destroyEv", "llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::BugType*> >::destroy()"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm11ImutAVLTreeINS0_17ImutContainerInfoIPN5clang4ento7BugTypeEEEEESaIS9_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS9_SB_EERKS9_", "std::vector<llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::BugType*> >*, std::allocator<llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::BugType*> >*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::BugType*> >**, std::vector<llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::BugType*> >*, std::allocator<llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::BugType*> >*> > >, llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::BugType*> >* const&)"),
	mu_demangle_test("_ZN4llvm26ImutAVLTreeGenericIteratorINS_17ImutContainerInfoIPN5clang4ento7BugTypeEEEEppEv", "llvm::ImutAVLTreeGenericIterator<llvm::ImutContainerInfo<clang::ento::BugType*> >::operator++()"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_17ImutContainerInfoIPN5clang4ento7BugTypeEEEEENS_12DenseMapInfoIjEENSA_IS9_EEE16InsertIntoBucketERKjRKS9_PSt4pairIjS9_E", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::BugType*> >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::BugType*> >*> >::InsertIntoBucket(unsigned int const&, llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::BugType*> >* const&, std::pair<unsigned int, llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::BugType*> >*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_17ImutContainerInfoIPN5clang4ento7BugTypeEEEEENS_12DenseMapInfoIjEENSA_IS9_EEE4growEj", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::BugType*> >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::BugType*> >*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_17ImutContainerInfoIPN5clang4ento7BugTypeEEEE12add_internalEPKS4_PNS_11ImutAVLTreeIS6_EE", "llvm::ImutAVLFactory<llvm::ImutContainerInfo<clang::ento::BugType*> >::add_internal(clang::ento::BugType const*, llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::BugType*> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_17ImutContainerInfoIPN5clang4ento7BugTypeEEEE13markImmutableEPNS_11ImutAVLTreeIS6_EE", "llvm::ImutAVLFactory<llvm::ImutContainerInfo<clang::ento::BugType*> >::markImmutable(llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::BugType*> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_17ImutContainerInfoIPN5clang4ento7BugTypeEEEE10createNodeEPNS_11ImutAVLTreeIS6_EEPKS4_SA_", "llvm::ImutAVLFactory<llvm::ImutContainerInfo<clang::ento::BugType*> >::createNode(llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::BugType*> >*, clang::ento::BugType const*, llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::BugType*> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_17ImutContainerInfoIPN5clang4ento7BugTypeEEEE11balanceTreeEPNS_11ImutAVLTreeIS6_EEPKS4_SA_", "llvm::ImutAVLFactory<llvm::ImutContainerInfo<clang::ento::BugType*> >::balanceTree(llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::BugType*> >*, clang::ento::BugType const*, llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::BugType*> >*)"),
	mu_demangle_test("_ZN4llvm10FoldingSetINS_17ImmutableListImplIPN5clang4ento18BugReporterVisitorEEEED1Ev", "llvm::FoldingSet<llvm::ImmutableListImpl<clang::ento::BugReporterVisitor*> >::~FoldingSet()"),
	mu_demangle_test("_ZN4llvm10FoldingSetINS_17ImmutableListImplIPN5clang4ento18BugReporterVisitorEEEED0Ev", "llvm::FoldingSet<llvm::ImmutableListImpl<clang::ento::BugReporterVisitor*> >::~FoldingSet()"),
	mu_demangle_test("_ZNK4llvm10FoldingSetINS_17ImmutableListImplIPN5clang4ento18BugReporterVisitorEEEE14GetNodeProfileEPNS_14FoldingSetImpl4NodeERNS_16FoldingSetNodeIDE", "llvm::FoldingSet<llvm::ImmutableListImpl<clang::ento::BugReporterVisitor*> >::GetNodeProfile(llvm::FoldingSetImpl::Node*, llvm::FoldingSetNodeID&) const"),
	mu_demangle_test("_ZNK4llvm10FoldingSetINS_17ImmutableListImplIPN5clang4ento18BugReporterVisitorEEEE10NodeEqualsEPNS_14FoldingSetImpl4NodeERKNS_16FoldingSetNodeIDERSB_", "llvm::FoldingSet<llvm::ImmutableListImpl<clang::ento::BugReporterVisitor*> >::NodeEquals(llvm::FoldingSetImpl::Node*, llvm::FoldingSetNodeID const&, llvm::FoldingSetNodeID&) const"),
	mu_demangle_test("_ZNK4llvm10FoldingSetINS_17ImmutableListImplIPN5clang4ento18BugReporterVisitorEEEE15ComputeNodeHashEPNS_14FoldingSetImpl4NodeERNS_16FoldingSetNodeIDE", "llvm::FoldingSet<llvm::ImmutableListImpl<clang::ento::BugReporterVisitor*> >::ComputeNodeHash(llvm::FoldingSetImpl::Node*, llvm::FoldingSetNodeID&) const"),
	mu_demangle_test("_ZNSt5dequeISsSaISsEE16_M_push_back_auxERKSs", "std::deque<std::string, std::allocator<std::string> >::_M_push_back_aux(std::string const&)"),
	mu_demangle_test("_ZNSt5dequeISsSaISsEE17_M_reallocate_mapEmb", "std::deque<std::string, std::allocator<std::string> >::_M_reallocate_map(unsigned long, bool)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4ento12ExplodedNodeEjNS_12DenseMapInfoIS5_EENS6_IjEEE16InsertIntoBucketERKS5_RKjPSt4pairIS5_jE", "llvm::DenseMap<clang::ento::ExplodedNode const*, unsigned int, llvm::DenseMapInfo<clang::ento::ExplodedNode const*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(clang::ento::ExplodedNode const* const&, unsigned int const&, std::pair<clang::ento::ExplodedNode const*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4ento12ExplodedNodeEjNS_12DenseMapInfoIS5_EENS6_IjEEE4growEj", "llvm::DenseMap<clang::ento::ExplodedNode const*, unsigned int, llvm::DenseMapInfo<clang::ento::ExplodedNode const*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPN5clang4ento24PathDiagnosticMacroPieceENS1_14SourceLocationEESaIS6_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS6_S8_EERKS6_", "std::vector<std::pair<clang::ento::PathDiagnosticMacroPiece*, clang::SourceLocation>, std::allocator<std::pair<clang::ento::PathDiagnosticMacroPiece*, clang::SourceLocation> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<clang::ento::PathDiagnosticMacroPiece*, clang::SourceLocation>*, std::vector<std::pair<clang::ento::PathDiagnosticMacroPiece*, clang::SourceLocation>, std::allocator<std::pair<clang::ento::PathDiagnosticMacroPiece*, clang::SourceLocation> > > >, std::pair<clang::ento::PathDiagnosticMacroPiece*, clang::SourceLocation> const&)"),
	mu_demangle_test("_ZNSt6vectorIPN5clang4ento19PathDiagnosticPieceESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<clang::ento::PathDiagnosticPiece*, std::allocator<clang::ento::PathDiagnosticPiece*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::ento::PathDiagnosticPiece**, std::vector<clang::ento::PathDiagnosticPiece*, std::allocator<clang::ento::PathDiagnosticPiece*> > >, clang::ento::PathDiagnosticPiece* const&)"),
	mu_demangle_test("_ZNSt6vectorIN5clang4ento26PathDiagnosticLocationPairESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<clang::ento::PathDiagnosticLocationPair, std::allocator<clang::ento::PathDiagnosticLocationPair> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::ento::PathDiagnosticLocationPair*, std::vector<clang::ento::PathDiagnosticLocationPair, std::allocator<clang::ento::PathDiagnosticLocationPair> > >, clang::ento::PathDiagnosticLocationPair const&)"),
	mu_demangle_test("_ZNSt5dequeIPN5clang4ento19PathDiagnosticPieceESaIS3_EE17_M_reallocate_mapEmb", "std::deque<clang::ento::PathDiagnosticPiece*, std::allocator<clang::ento::PathDiagnosticPiece*> >::_M_reallocate_map(unsigned long, bool)"),
	mu_demangle_test("_ZNSt5dequeIPN5clang4ento19PathDiagnosticPieceESaIS3_EE9push_backERKS3_", "std::deque<clang::ento::PathDiagnosticPiece*, std::allocator<clang::ento::PathDiagnosticPiece*> >::push_back(clang::ento::PathDiagnosticPiece* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4ento12ExplodedNodeES5_NS_12DenseMapInfoIS5_EES7_E16InsertIntoBucketERKS5_SA_PSt4pairIS5_S5_E", "llvm::DenseMap<clang::ento::ExplodedNode const*, clang::ento::ExplodedNode const*, llvm::DenseMapInfo<clang::ento::ExplodedNode const*>, llvm::DenseMapInfo<clang::ento::ExplodedNode const*> >::InsertIntoBucket(clang::ento::ExplodedNode const* const&, clang::ento::ExplodedNode const* const&, std::pair<clang::ento::ExplodedNode const*, clang::ento::ExplodedNode const*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4ento12ExplodedNodeES5_NS_12DenseMapInfoIS5_EES7_E4growEj", "llvm::DenseMap<clang::ento::ExplodedNode const*, clang::ento::ExplodedNode const*, llvm::DenseMapInfo<clang::ento::ExplodedNode const*>, llvm::DenseMapInfo<clang::ento::ExplodedNode const*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKvjNS_12DenseMapInfoIS2_EENS3_IjEEE16InsertIntoBucketERKS2_RKjPSt4pairIS2_jE", "llvm::DenseMap<void const*, unsigned int, llvm::DenseMapInfo<void const*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(void const* const&, unsigned int const&, std::pair<void const*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKvjNS_12DenseMapInfoIS2_EENS3_IjEEE4growEj", "llvm::DenseMap<void const*, unsigned int, llvm::DenseMapInfo<void const*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt5dequeIPKN5clang4ento12ExplodedNodeESaIS4_EE9push_backERKS4_", "std::deque<clang::ento::ExplodedNode const*, std::allocator<clang::ento::ExplodedNode const*> >::push_back(clang::ento::ExplodedNode const* const&)"),
	mu_demangle_test("_ZNSt5dequeIPKN5clang4ento12ExplodedNodeESaIS4_EE17_M_reallocate_mapEmb", "std::deque<clang::ento::ExplodedNode const*, std::allocator<clang::ento::ExplodedNode const*> >::_M_reallocate_map(unsigned long, bool)"),
	mu_demangle_test("_ZNSt11_Deque_baseIPKN5clang4ento12ExplodedNodeESaIS4_EE17_M_initialize_mapEm", "std::_Deque_base<clang::ento::ExplodedNode const*, std::allocator<clang::ento::ExplodedNode const*> >::_M_initialize_map(unsigned long)"),
	mu_demangle_test("_ZNSt5dequeIPKN5clang4ento12ExplodedNodeESaIS4_EEC2ERKS6_", "std::deque<clang::ento::ExplodedNode const*, std::allocator<clang::ento::ExplodedNode const*> >::deque(std::deque<clang::ento::ExplodedNode const*, std::allocator<clang::ento::ExplodedNode const*> > const&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_17ImutContainerInfoIPN5clang4ento7BugTypeEEEED2Ev", "llvm::ImutAVLFactory<llvm::ImutContainerInfo<clang::ento::BugType*> >::~ImutAVLFactory()"),
	mu_demangle_test("_ZNSt6vectorIN5clang11SourceRangeESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<clang::SourceRange, std::allocator<clang::SourceRange> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::SourceRange*, std::vector<clang::SourceRange, std::allocator<clang::SourceRange> > >, clang::SourceRange const&)"),
	mu_demangle_test("_ZNSt5dequeIPKN5clang4StmtESaIS3_EE9push_backERKS3_", "std::deque<clang::Stmt const*, std::allocator<clang::Stmt const*> >::push_back(clang::Stmt const* const&)"),
	mu_demangle_test("_ZNSt5dequeIPKN5clang4StmtESaIS3_EE17_M_reallocate_mapEmb", "std::deque<clang::Stmt const*, std::allocator<clang::Stmt const*> >::_M_reallocate_map(unsigned long, bool)"),
	mu_demangle_test("_ZNSt11_Deque_baseIPKN5clang4StmtESaIS3_EE17_M_initialize_mapEm", "std::_Deque_base<clang::Stmt const*, std::allocator<clang::Stmt const*> >::_M_initialize_map(unsigned long)"),
	mu_demangle_test("_ZN12_GLOBAL__N_110CFRefCount16RegisterPrintersERSt6vectorIPN5clang4ento7GRState7PrinterESaIS6_EE", "(anonymous namespace)::CFRefCount::RegisterPrinters(std::vector<clang::ento::GRState::Printer*, std::allocator<clang::ento::GRState::Printer*> >&)"),
	mu_demangle_test("_ZN4llvm12ImmutableMapIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_16RefValENS_16ImutKeyValueInfoIS5_S7_EEE7Factory6removeESA_RKS5_", "llvm::ImmutableMap<clang::ento::SymbolData const*, (anonymous namespace)::RefVal, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> >::Factory::remove(llvm::ImmutableMap<clang::ento::SymbolData const*, (anonymous namespace)::RefVal, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> >, clang::ento::SymbolData const* const&)"),
	mu_demangle_test("_ZNK5clang4ento7GRState3setIN4llvm12ImmutableMapIPKNS0_10SymbolDataEN12_GLOBAL__N_16RefValENS3_16ImutKeyValueInfoIS7_S9_EEEEEEPKS1_NS0_12GRStateTraitIT_E9data_typeE", "clang::ento::GRState const* clang::ento::GRState::set<llvm::ImmutableMap<clang::ento::SymbolData const*, (anonymous namespace)::RefVal, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> > >(clang::ento::GRStateTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, (anonymous namespace)::RefVal, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> > >::data_type) const"),
	mu_demangle_test("_ZN4llvm26ImutAVLTreeInOrderIteratorINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_16RefValEEEEppEv", "llvm::ImutAVLTreeInOrderIterator<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> >::operator++()"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_16RefValEEEE7destroyEv", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> >::destroy()"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_16RefValEEEEENS_12DenseMapInfoIjEENSD_ISC_EEEixERKj", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> >*> >::operator[](unsigned int const&)"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_16RefValEEEE13computeDigestEv", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> >::computeDigest()"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm11ImutAVLTreeINS0_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_16RefValEEEEESaISC_EE9push_backERKSC_", "std::vector<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> >*, std::allocator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> >*> >::push_back(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> >* const&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_16RefValEEEE16getCanonicalTreeEPNS_11ImutAVLTreeIS9_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> >::getCanonicalTree(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_16RefValEEEE15remove_internalERKS6_PNS_11ImutAVLTreeIS9_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> >::remove_internal(clang::ento::SymbolData const* const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_16RefValEEEE13markImmutableEPNS_11ImutAVLTreeIS9_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> >::markImmutable(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_16RefValEEEE11balanceTreeEPNS_11ImutAVLTreeIS9_EERKSt4pairIS6_S8_ESD_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> >::balanceTree(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> >*, std::pair<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_16RefValEEEE10createNodeEPNS_11ImutAVLTreeIS9_EERKSt4pairIS6_S8_ESD_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> >::createNode(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> >*, std::pair<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_16RefValEEEE16removeMinBindingEPNS_11ImutAVLTreeIS9_EERSD_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> >::removeMinBinding(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> >*, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> >*&)"),
	mu_demangle_test("_ZN5clang4ento19GRStatePartialTraitIN4llvm12ImmutableMapIPKNS0_10SymbolDataEN12_GLOBAL__N_16RefValENS2_16ImutKeyValueInfoIS6_S8_EEEEE13CreateContextERNS2_16BumpPtrAllocatorE", "clang::ento::GRStatePartialTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, (anonymous namespace)::RefVal, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> > >::CreateContext(llvm::BumpPtrAllocator&)"),
	mu_demangle_test("_ZN5clang4ento19GRStatePartialTraitIN4llvm12ImmutableMapIPKNS0_10SymbolDataEN12_GLOBAL__N_16RefValENS2_16ImutKeyValueInfoIS6_S8_EEEEE13DeleteContextEPv", "clang::ento::GRStatePartialTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, (anonymous namespace)::RefVal, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> > >::DeleteContext(void*)"),
	mu_demangle_test("_ZNK5clang4ento7GRState3setIN4llvm12ImmutableMapIPKNS0_10SymbolDataEN12_GLOBAL__N_16RefValENS3_16ImutKeyValueInfoIS7_S9_EEEEEEPKS1_NS0_12GRStateTraitIT_E8key_typeENSH_10value_typeE", "clang::ento::GRState const* clang::ento::GRState::set<llvm::ImmutableMap<clang::ento::SymbolData const*, (anonymous namespace)::RefVal, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> > >(clang::ento::GRStateTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, (anonymous namespace)::RefVal, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> > >::key_type, clang::ento::GRStateTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, (anonymous namespace)::RefVal, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> > >::value_type) const"),
	mu_demangle_test("_ZN4llvm8DenseMapIN12_GLOBAL__N_114ObjCSummaryKeyEPNS1_13RetainSummaryENS_12DenseMapInfoIS2_EENS5_IS4_EEEixERKS2_", "llvm::DenseMap<(anonymous namespace)::ObjCSummaryKey, (anonymous namespace)::RetainSummary*, llvm::DenseMapInfo<(anonymous namespace)::ObjCSummaryKey>, llvm::DenseMapInfo<(anonymous namespace)::RetainSummary*> >::operator[]((anonymous namespace)::ObjCSummaryKey const&)"),
	mu_demangle_test("_ZNK4llvm8DenseMapIN12_GLOBAL__N_114ObjCSummaryKeyEPNS1_13RetainSummaryENS_12DenseMapInfoIS2_EENS5_IS4_EEE15LookupBucketForERKS2_RPSt4pairIS2_S4_E", "llvm::DenseMap<(anonymous namespace)::ObjCSummaryKey, (anonymous namespace)::RetainSummary*, llvm::DenseMapInfo<(anonymous namespace)::ObjCSummaryKey>, llvm::DenseMapInfo<(anonymous namespace)::RetainSummary*> >::LookupBucketFor((anonymous namespace)::ObjCSummaryKey const&, std::pair<(anonymous namespace)::ObjCSummaryKey, (anonymous namespace)::RetainSummary*>*&) const"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_16RefValEEEE12add_internalERKSt4pairIS6_S8_EPNS_11ImutAVLTreeIS9_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> >::add_internal(std::pair<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> >*)"),
	mu_demangle_test("_ZNK5clang4ento7GRState6removeIN4llvm12ImmutableMapIPKNS0_10SymbolDataEN12_GLOBAL__N_16RefValENS3_16ImutKeyValueInfoIS7_S9_EEEEEEPKS1_NS0_12GRStateTraitIT_E8key_typeE", "clang::ento::GRState const* clang::ento::GRState::remove<llvm::ImmutableMap<clang::ento::SymbolData const*, (anonymous namespace)::RefVal, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> > >(clang::ento::GRStateTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, (anonymous namespace)::RefVal, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> > >::key_type) const"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIj9ArgEffectEEE7destroyEv", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >::destroy()"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIj9ArgEffectEEE13computeDigestEv", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >::computeDigest()"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm11ImutAVLTreeINS0_16ImutKeyValueInfoIj9ArgEffectEEEESaIS6_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS6_S8_EERKS6_", "std::vector<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >*, std::allocator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >**, std::vector<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >*, std::allocator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >*> > >, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_16ImutKeyValueInfoIj9ArgEffectEEEENS_12DenseMapInfoIjEENS7_IS6_EEE16InsertIntoBucketERKjRKS6_PSt4pairIjS6_E", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >*> >::InsertIntoBucket(unsigned int const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >* const&, std::pair<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_16ImutKeyValueInfoIj9ArgEffectEEEENS_12DenseMapInfoIjEENS7_IS6_EEE4growEj", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIj9ArgEffectEEE3addEPNS_11ImutAVLTreeIS3_EERKSt4pairIjS2_E", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >::add(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >*, std::pair<unsigned int, ArgEffect> const&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIj9ArgEffectEEE16getCanonicalTreeEPNS_11ImutAVLTreeIS3_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >::getCanonicalTree(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIj9ArgEffectEEE22compareTreeWithSectionEPNS_11ImutAVLTreeIS3_EERNS_26ImutAVLTreeInOrderIteratorIS3_EESA_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >::compareTreeWithSection(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >*, llvm::ImutAVLTreeInOrderIterator<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >&, llvm::ImutAVLTreeInOrderIterator<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >&)"),
	mu_demangle_test("_ZN4llvm26ImutAVLTreeGenericIteratorINS_16ImutKeyValueInfoIj9ArgEffectEEEppEv", "llvm::ImutAVLTreeGenericIterator<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >::operator++()"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIj9ArgEffectEEE12add_internalERKSt4pairIjS2_EPNS_11ImutAVLTreeIS3_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >::add_internal(std::pair<unsigned int, ArgEffect> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIj9ArgEffectEEE13markImmutableEPNS_11ImutAVLTreeIS3_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >::markImmutable(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIj9ArgEffectEEE10createNodeEPNS_11ImutAVLTreeIS3_EERKSt4pairIjS2_ES7_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >::createNode(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >*, std::pair<unsigned int, ArgEffect> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIj9ArgEffectEEE11balanceTreeEPNS_11ImutAVLTreeIS3_EERKSt4pairIjS2_ES7_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >::balanceTree(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >*, std::pair<unsigned int, ArgEffect> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >*)"),
	mu_demangle_test("_ZN5clang4ento19GRStatePartialTraitIN4llvm12ImmutableMapIPKNS0_10SymbolDataENS3_IS6_jNS2_16ImutKeyValueInfoIS6_jEEEENS7_IS6_S9_EEEEE13CreateContextERNS2_16BumpPtrAllocatorE", "clang::ento::GRStatePartialTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > > >::CreateContext(llvm::BumpPtrAllocator&)"),
	mu_demangle_test("_ZN5clang4ento19GRStatePartialTraitIN4llvm12ImmutableMapIPKNS0_10SymbolDataENS3_IS6_jNS2_16ImutKeyValueInfoIS6_jEEEENS7_IS6_S9_EEEEE13DeleteContextEPv", "clang::ento::GRStatePartialTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > > >::DeleteContext(void*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS_12ImmutableMapIS6_jNS1_IS6_jEEEEEEED2Ev", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >::~ImutAVLFactory()"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS_12ImmutableMapIS6_jNS1_IS6_jEEEEEEE7destroyEv", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >::destroy()"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS_12ImmutableMapIS6_jNS1_IS6_jEEEEEEE13computeDigestEv", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >::computeDigest()"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm11ImutAVLTreeINS0_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS0_12ImmutableMapIS7_jNS2_IS7_jEEEEEEEESaISD_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPSD_SF_EERKSD_", "std::vector<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >*, std::allocator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >**, std::vector<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >*, std::allocator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >*> > >, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS_12ImmutableMapIS7_jNS2_IS7_jEEEEEEEENS_12DenseMapInfoIjEENSE_ISD_EEE16InsertIntoBucketERKjRKSD_PSt4pairIjSD_E", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >*> >::InsertIntoBucket(unsigned int const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >* const&, std::pair<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS_12ImmutableMapIS7_jNS2_IS7_jEEEEEEEENS_12DenseMapInfoIjEENSE_ISD_EEE4growEj", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm12ImmutableMapIPKN5clang4ento10SymbolDataENS0_IS5_jNS_16ImutKeyValueInfoIS5_jEEEENS6_IS5_S8_EEE7Factory3addESA_RKS5_RKS8_", "llvm::ImmutableMap<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >::Factory::add(llvm::ImmutableMap<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >, clang::ento::SymbolData const* const&, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > const&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS_12ImmutableMapIS6_jNS1_IS6_jEEEEEEE3addEPNS_11ImutAVLTreeISA_EERKSt4pairIS6_S9_E", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >::add(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >*, std::pair<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > const&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS_12ImmutableMapIS6_jNS1_IS6_jEEEEEEE16getCanonicalTreeEPNS_11ImutAVLTreeISA_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >::getCanonicalTree(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS_12ImmutableMapIS6_jNS1_IS6_jEEEEEEE22compareTreeWithSectionEPNS_11ImutAVLTreeISA_EERNS_26ImutAVLTreeInOrderIteratorISA_EESH_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >::compareTreeWithSection(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >*, llvm::ImutAVLTreeInOrderIterator<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >&, llvm::ImutAVLTreeInOrderIterator<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >&)"),
	mu_demangle_test("_ZN4llvm26ImutAVLTreeGenericIteratorINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS_12ImmutableMapIS6_jNS1_IS6_jEEEEEEEppEv", "llvm::ImutAVLTreeGenericIterator<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >::operator++()"),
	mu_demangle_test("_ZNK4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEjEEE7isEqualERKS8_", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >::isEqual(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > const&) const"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS_12ImmutableMapIS6_jNS1_IS6_jEEEEEEE12add_internalERKSt4pairIS6_S9_EPNS_11ImutAVLTreeISA_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >::add_internal(std::pair<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS_12ImmutableMapIS6_jNS1_IS6_jEEEEEEE13markImmutableEPNS_11ImutAVLTreeISA_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >::markImmutable(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS_12ImmutableMapIS6_jNS1_IS6_jEEEEEEE10createNodeEPNS_11ImutAVLTreeISA_EERKSt4pairIS6_S9_ESE_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >::createNode(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >*, std::pair<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataENS_12ImmutableMapIS6_jNS1_IS6_jEEEEEEE11balanceTreeEPNS_11ImutAVLTreeISA_EERKSt4pairIS6_S9_ESE_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >::balanceTree(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >*, std::pair<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >*)"),
	mu_demangle_test("_ZN5clang4ento19GRStatePartialTraitIN4llvm12ImmutableMapIPKNS0_10SymbolDataENS3_IS6_jNS2_16ImutKeyValueInfoIS6_jEEEENS7_IS6_S9_EEEEE6LookupESB_S6_", "clang::ento::GRStatePartialTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > > >::Lookup(llvm::ImmutableMap<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > > >, clang::ento::SymbolData const*)"),
	mu_demangle_test("_ZN5clang4ento19GRStatePartialTraitIN4llvm13ImmutableListIPKNS0_10SymbolDataEEEE13CreateContextERNS2_16BumpPtrAllocatorE", "clang::ento::GRStatePartialTrait<llvm::ImmutableList<clang::ento::SymbolData const*> >::CreateContext(llvm::BumpPtrAllocator&)"),
	mu_demangle_test("_ZN5clang4ento19GRStatePartialTraitIN4llvm13ImmutableListIPKNS0_10SymbolDataEEEE13DeleteContextEPv", "clang::ento::GRStatePartialTrait<llvm::ImmutableList<clang::ento::SymbolData const*> >::DeleteContext(void*)"),
	mu_demangle_test("_ZN4llvm10FoldingSetINS_17ImmutableListImplIPKN5clang4ento10SymbolDataEEEED1Ev", "llvm::FoldingSet<llvm::ImmutableListImpl<clang::ento::SymbolData const*> >::~FoldingSet()"),
	mu_demangle_test("_ZN4llvm10FoldingSetINS_17ImmutableListImplIPKN5clang4ento10SymbolDataEEEED0Ev", "llvm::FoldingSet<llvm::ImmutableListImpl<clang::ento::SymbolData const*> >::~FoldingSet()"),
	mu_demangle_test("_ZNK4llvm10FoldingSetINS_17ImmutableListImplIPKN5clang4ento10SymbolDataEEEE14GetNodeProfileEPNS_14FoldingSetImpl4NodeERNS_16FoldingSetNodeIDE", "llvm::FoldingSet<llvm::ImmutableListImpl<clang::ento::SymbolData const*> >::GetNodeProfile(llvm::FoldingSetImpl::Node*, llvm::FoldingSetNodeID&) const"),
	mu_demangle_test("_ZNK4llvm10FoldingSetINS_17ImmutableListImplIPKN5clang4ento10SymbolDataEEEE10NodeEqualsEPNS_14FoldingSetImpl4NodeERKNS_16FoldingSetNodeIDERSC_", "llvm::FoldingSet<llvm::ImmutableListImpl<clang::ento::SymbolData const*> >::NodeEquals(llvm::FoldingSetImpl::Node*, llvm::FoldingSetNodeID const&, llvm::FoldingSetNodeID&) const"),
	mu_demangle_test("_ZNK4llvm10FoldingSetINS_17ImmutableListImplIPKN5clang4ento10SymbolDataEEEE15ComputeNodeHashEPNS_14FoldingSetImpl4NodeERNS_16FoldingSetNodeIDE", "llvm::FoldingSet<llvm::ImmutableListImpl<clang::ento::SymbolData const*> >::ComputeNodeHash(llvm::FoldingSetImpl::Node*, llvm::FoldingSetNodeID&) const"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4ento10SymbolDataEcNS_12DenseMapInfoIS5_EENS6_IcEEE6insertERKSt4pairIS5_cE", "llvm::DenseMap<clang::ento::SymbolData const*, char, llvm::DenseMapInfo<clang::ento::SymbolData const*>, llvm::DenseMapInfo<char> >::insert(std::pair<clang::ento::SymbolData const*, char> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4ento10SymbolDataEcNS_12DenseMapInfoIS5_EENS6_IcEEE16InsertIntoBucketERKS5_RKcPSt4pairIS5_cE", "llvm::DenseMap<clang::ento::SymbolData const*, char, llvm::DenseMapInfo<clang::ento::SymbolData const*>, llvm::DenseMapInfo<char> >::InsertIntoBucket(clang::ento::SymbolData const* const&, char const&, std::pair<clang::ento::SymbolData const*, char>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4ento10SymbolDataEcNS_12DenseMapInfoIS5_EENS6_IcEEE4growEj", "llvm::DenseMap<clang::ento::SymbolData const*, char, llvm::DenseMapInfo<clang::ento::SymbolData const*>, llvm::DenseMapInfo<char> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIPN5clang4ento7GRState7PrinterESaIS4_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS4_S6_EERKS4_", "std::vector<clang::ento::GRState::Printer*, std::allocator<clang::ento::GRState::Printer*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::ento::GRState::Printer**, std::vector<clang::ento::GRState::Printer*, std::allocator<clang::ento::GRState::Printer*> > >, clang::ento::GRState::Printer* const&)"),
	mu_demangle_test("_ZN5clang4ento13TransferFuncs16RegisterPrintersERSt6vectorIPNS0_7GRState7PrinterESaIS5_EE", "clang::ento::TransferFuncs::RegisterPrinters(std::vector<clang::ento::GRState::Printer*, std::allocator<clang::ento::GRState::Printer*> >&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIj9ArgEffectEEED2Ev", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<unsigned int, ArgEffect> >::~ImutAVLFactory()"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEjEEEC2Ev", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> >::ImutAVLFactory()"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN5clang9BlockEdgeEPKNS1_4ento12ExplodedNodeEESaIS7_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS7_S9_EERKS7_", "std::vector<std::pair<clang::BlockEdge, clang::ento::ExplodedNode const*>, std::allocator<std::pair<clang::BlockEdge, clang::ento::ExplodedNode const*> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<clang::BlockEdge, clang::ento::ExplodedNode const*>*, std::vector<std::pair<clang::BlockEdge, clang::ento::ExplodedNode const*>, std::allocator<std::pair<clang::BlockEdge, clang::ento::ExplodedNode const*> > > >, std::pair<clang::BlockEdge, clang::ento::ExplodedNode const*> const&)"),
	mu_demangle_test("_ZNSt5dequeIN5clang4ento12WorkListUnitESaIS2_EE17_M_reallocate_mapEmb", "std::deque<clang::ento::WorkListUnit, std::allocator<clang::ento::WorkListUnit> >::_M_reallocate_map(unsigned long, bool)"),
	mu_demangle_test("_ZNSt11_Deque_baseIN5clang4ento12WorkListUnitESaIS2_EE17_M_initialize_mapEm", "std::_Deque_base<clang::ento::WorkListUnit, std::allocator<clang::ento::WorkListUnit> >::_M_initialize_map(unsigned long)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4StmtENS2_4ento4SValEEEE3addEPNS_11ImutAVLTreeIS8_EERKSt4pairIS5_S7_E", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >::add(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >*, std::pair<clang::Stmt const*, clang::ento::SVal> const&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4StmtENS2_4ento4SValEEEE16getCanonicalTreeEPNS_11ImutAVLTreeIS8_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >::getCanonicalTree(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4StmtENS2_4ento4SValEEEE22compareTreeWithSectionEPNS_11ImutAVLTreeIS8_EERNS_26ImutAVLTreeInOrderIteratorIS8_EESF_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >::compareTreeWithSection(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >*, llvm::ImutAVLTreeInOrderIterator<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >&, llvm::ImutAVLTreeInOrderIterator<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4StmtENS2_4ento4SValEEEE12add_internalERKSt4pairIS5_S7_EPNS_11ImutAVLTreeIS8_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >::add_internal(std::pair<clang::Stmt const*, clang::ento::SVal> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4StmtENS2_4ento4SValEEEE13markImmutableEPNS_11ImutAVLTreeIS8_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >::markImmutable(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4StmtENS2_4ento4SValEEEE10createNodeEPNS_11ImutAVLTreeIS8_EERKSt4pairIS5_S7_ESC_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >::createNode(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >*, std::pair<clang::Stmt const*, clang::ento::SVal> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4StmtENS2_4ento4SValEEEE11balanceTreeEPNS_11ImutAVLTreeIS8_EERKSt4pairIS5_S7_ESC_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >::balanceTree(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >*, std::pair<clang::Stmt const*, clang::ento::SVal> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4StmtENS2_4ento4SValEEEE6removeEPNS_11ImutAVLTreeIS8_EERKS5_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >::remove(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >*, clang::Stmt const* const&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4StmtENS2_4ento4SValEEEE15remove_internalERKS5_PNS_11ImutAVLTreeIS8_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >::remove_internal(clang::Stmt const* const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4StmtENS2_4ento4SValEEEE16removeMinBindingEPNS_11ImutAVLTreeIS8_EERSC_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >::removeMinBinding(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >*, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >*&)"),
	mu_demangle_test("_ZNK5clang4ento13ExplodedGraph4TrimEPKPKNS0_12ExplodedNodeES6_PN4llvm8DenseMapIPKvSA_NS7_12DenseMapInfoISA_EESC_EE", "clang::ento::ExplodedGraph::Trim(clang::ento::ExplodedNode const* const*, clang::ento::ExplodedNode const* const*, llvm::DenseMap<void const*, void const*, llvm::DenseMapInfo<void const*>, llvm::DenseMapInfo<void const*> >*) const"),
	mu_demangle_test("_ZNK5clang4ento13ExplodedGraph12TrimInternalEPKPKNS0_12ExplodedNodeES6_PNS0_21InterExplodedGraphMapEPN4llvm8DenseMapIPKvSC_NS9_12DenseMapInfoISC_EESE_EE", "clang::ento::ExplodedGraph::TrimInternal(clang::ento::ExplodedNode const* const*, clang::ento::ExplodedNode const* const*, clang::ento::InterExplodedGraphMap*, llvm::DenseMap<void const*, void const*, llvm::DenseMapInfo<void const*>, llvm::DenseMapInfo<void const*> >*) const"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKvS2_NS_12DenseMapInfoIS2_EES4_E16InsertIntoBucketERKS2_S7_PSt4pairIS2_S2_E", "llvm::DenseMap<void const*, void const*, llvm::DenseMapInfo<void const*>, llvm::DenseMapInfo<void const*> >::InsertIntoBucket(void const* const&, void const* const&, std::pair<void const*, void const*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKvS2_NS_12DenseMapInfoIS2_EES4_E4growEj", "llvm::DenseMap<void const*, void const*, llvm::DenseMapInfo<void const*>, llvm::DenseMapInfo<void const*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4ento12ExplodedNodeEPS3_NS_12DenseMapInfoIS5_EENS7_IS6_EEE16InsertIntoBucketERKS5_RKS6_PSt4pairIS5_S6_E", "llvm::DenseMap<clang::ento::ExplodedNode const*, clang::ento::ExplodedNode*, llvm::DenseMapInfo<clang::ento::ExplodedNode const*>, llvm::DenseMapInfo<clang::ento::ExplodedNode*> >::InsertIntoBucket(clang::ento::ExplodedNode const* const&, clang::ento::ExplodedNode* const&, std::pair<clang::ento::ExplodedNode const*, clang::ento::ExplodedNode*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4ento12ExplodedNodeEPS3_NS_12DenseMapInfoIS5_EENS7_IS6_EEE4growEj", "llvm::DenseMap<clang::ento::ExplodedNode const*, clang::ento::ExplodedNode*, llvm::DenseMapInfo<clang::ento::ExplodedNode const*>, llvm::DenseMapInfo<clang::ento::ExplodedNode*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4ento12ExplodedNodeEcNS_12DenseMapInfoIS5_EENS6_IcEEE6insertERKSt4pairIS5_cE", "llvm::DenseMap<clang::ento::ExplodedNode const*, char, llvm::DenseMapInfo<clang::ento::ExplodedNode const*>, llvm::DenseMapInfo<char> >::insert(std::pair<clang::ento::ExplodedNode const*, char> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4ento12ExplodedNodeEcNS_12DenseMapInfoIS5_EENS6_IcEEE16InsertIntoBucketERKS5_RKcPSt4pairIS5_cE", "llvm::DenseMap<clang::ento::ExplodedNode const*, char, llvm::DenseMapInfo<clang::ento::ExplodedNode const*>, llvm::DenseMapInfo<char> >::InsertIntoBucket(clang::ento::ExplodedNode const* const&, char const&, std::pair<clang::ento::ExplodedNode const*, char>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4ento12ExplodedNodeEcNS_12DenseMapInfoIS5_EENS6_IcEEE4growEj", "llvm::DenseMap<clang::ento::ExplodedNode const*, char, llvm::DenseMapInfo<clang::ento::ExplodedNode const*>, llvm::DenseMapInfo<char> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIPN5clang4ento12ExplodedNodeESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<clang::ento::ExplodedNode*, std::allocator<clang::ento::ExplodedNode*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::ento::ExplodedNode**, std::vector<clang::ento::ExplodedNode*, std::allocator<clang::ento::ExplodedNode*> > >, clang::ento::ExplodedNode* const&)"),
	mu_demangle_test("_ZNK4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIPvS2_EEE7isEqualERKS4_", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<void*, void*> >::isEqual(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<void*, void*> > const&) const"),
	mu_demangle_test("_ZN4llvm26ImutAVLTreeGenericIteratorINS_16ImutKeyValueInfoIPvS2_EEEppEv", "llvm::ImutAVLTreeGenericIterator<llvm::ImutKeyValueInfo<void*, void*> >::operator++()"),
	mu_demangle_test("_ZN12_GLOBAL__N_116FlatStoreManager17InvalidateRegionsEPKvPKPKN5clang4ento9MemRegionES9_PKNS3_4ExprEjPN4llvm8DenseSetIPKNS4_10SymbolDataENSD_12DenseMapInfoISH_EEEEbPNSD_11SmallVectorIS7_Lj8EEE", "(anonymous namespace)::FlatStoreManager::InvalidateRegions(void const*, clang::ento::MemRegion const* const*, clang::ento::MemRegion const* const*, clang::Expr const*, unsigned int, llvm::DenseSet<clang::ento::SymbolData const*, llvm::DenseMapInfo<clang::ento::SymbolData const*> >*, bool, llvm::SmallVector<clang::ento::MemRegion const*, 8u>*)"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS_20ImmutableIntervalMapINS3_4SValEEEEEE7destroyEv", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >::destroy()"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS_20ImmutableIntervalMapINS3_4SValEEEEEE13computeDigestEv", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >::computeDigest()"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm11ImutAVLTreeINS0_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS0_20ImmutableIntervalMapINS4_4SValEEEEEEESaISD_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPSD_SF_EERKSD_", "std::vector<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >*, std::allocator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >**, std::vector<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >*, std::allocator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >*> > >, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS_20ImmutableIntervalMapINS4_4SValEEEEEEENS_12DenseMapInfoIjEENSE_ISD_EEE16InsertIntoBucketERKjRKSD_PSt4pairIjSD_E", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >*> >::InsertIntoBucket(unsigned int const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >* const&, std::pair<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS_20ImmutableIntervalMapINS4_4SValEEEEEEENS_12DenseMapInfoIjEENSE_ISD_EEE4growEj", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm12ImmutableMapIPKN5clang4ento9MemRegionENS_20ImmutableIntervalMapINS2_4SValEEENS_16ImutKeyValueInfoIS5_S8_EEE7Factory3addESB_RKS5_RKS8_", "llvm::ImmutableMap<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal>, llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >::Factory::add(llvm::ImmutableMap<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal>, llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >, clang::ento::MemRegion const* const&, llvm::ImmutableIntervalMap<clang::ento::SVal> const&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS_20ImmutableIntervalMapINS3_4SValEEEEEE3addEPNS_11ImutAVLTreeISA_EERKSt4pairIS6_S9_E", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >::add(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >*, std::pair<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > const&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS_20ImmutableIntervalMapINS3_4SValEEEEEE16getCanonicalTreeEPNS_11ImutAVLTreeISA_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >::getCanonicalTree(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS_20ImmutableIntervalMapINS3_4SValEEEEEE22compareTreeWithSectionEPNS_11ImutAVLTreeISA_EERNS_26ImutAVLTreeInOrderIteratorISA_EESH_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >::compareTreeWithSection(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >*, llvm::ImutAVLTreeInOrderIterator<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >&, llvm::ImutAVLTreeInOrderIterator<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >&)"),
	mu_demangle_test("_ZN4llvm26ImutAVLTreeGenericIteratorINS_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS_20ImmutableIntervalMapINS3_4SValEEEEEEppEv", "llvm::ImutAVLTreeGenericIterator<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >::operator++()"),
	mu_demangle_test("_ZNK4llvm11ImutAVLTreeINS_16ImutIntervalInfoIN5clang4ento4SValEEEE7isEqualERKS6_", "llvm::ImutAVLTree<llvm::ImutIntervalInfo<clang::ento::SVal> >::isEqual(llvm::ImutAVLTree<llvm::ImutIntervalInfo<clang::ento::SVal> > const&) const"),
	mu_demangle_test("_ZN4llvm26ImutAVLTreeGenericIteratorINS_16ImutIntervalInfoIN5clang4ento4SValEEEEppEv", "llvm::ImutAVLTreeGenericIterator<llvm::ImutIntervalInfo<clang::ento::SVal> >::operator++()"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS_20ImmutableIntervalMapINS3_4SValEEEEEE12add_internalERKSt4pairIS6_S9_EPNS_11ImutAVLTreeISA_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >::add_internal(std::pair<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS_20ImmutableIntervalMapINS3_4SValEEEEEE13markImmutableEPNS_11ImutAVLTreeISA_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >::markImmutable(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS_20ImmutableIntervalMapINS3_4SValEEEEEE10createNodeEPNS_11ImutAVLTreeISA_EERKSt4pairIS6_S9_ESE_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >::createNode(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >*, std::pair<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS_20ImmutableIntervalMapINS3_4SValEEEEEE11balanceTreeEPNS_11ImutAVLTreeISA_EERKSt4pairIS6_S9_ESE_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >::balanceTree(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >*, std::pair<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >*)"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutIntervalInfoIN5clang4ento4SValEEEE7destroyEv", "llvm::ImutAVLTree<llvm::ImutIntervalInfo<clang::ento::SVal> >::destroy()"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm11ImutAVLTreeINS0_16ImutIntervalInfoIN5clang4ento4SValEEEEESaIS8_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS8_SA_EERKS8_", "std::vector<llvm::ImutAVLTree<llvm::ImutIntervalInfo<clang::ento::SVal> >*, std::allocator<llvm::ImutAVLTree<llvm::ImutIntervalInfo<clang::ento::SVal> >*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::ImutAVLTree<llvm::ImutIntervalInfo<clang::ento::SVal> >**, std::vector<llvm::ImutAVLTree<llvm::ImutIntervalInfo<clang::ento::SVal> >*, std::allocator<llvm::ImutAVLTree<llvm::ImutIntervalInfo<clang::ento::SVal> >*> > >, llvm::ImutAVLTree<llvm::ImutIntervalInfo<clang::ento::SVal> >* const&)"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutIntervalInfoIN5clang4ento4SValEEEE13computeDigestEPS6_S7_RKSt4pairINS_8IntervalES4_E", "llvm::ImutAVLTree<llvm::ImutIntervalInfo<clang::ento::SVal> >::computeDigest(llvm::ImutAVLTree<llvm::ImutIntervalInfo<clang::ento::SVal> >*, llvm::ImutAVLTree<llvm::ImutIntervalInfo<clang::ento::SVal> >*, std::pair<llvm::Interval, clang::ento::SVal> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_16ImutIntervalInfoIN5clang4ento4SValEEEEENS_12DenseMapInfoIjEENS9_IS8_EEE16InsertIntoBucketERKjRKS8_PSt4pairIjS8_E", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutIntervalInfo<clang::ento::SVal> >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutIntervalInfo<clang::ento::SVal> >*> >::InsertIntoBucket(unsigned int const&, llvm::ImutAVLTree<llvm::ImutIntervalInfo<clang::ento::SVal> >* const&, std::pair<unsigned int, llvm::ImutAVLTree<llvm::ImutIntervalInfo<clang::ento::SVal> >*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_16ImutIntervalInfoIN5clang4ento4SValEEEEENS_12DenseMapInfoIjEENS9_IS8_EEE4growEj", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutIntervalInfo<clang::ento::SVal> >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutIntervalInfo<clang::ento::SVal> >*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutIntervalInfoIN5clang4ento4SValEEEE3addEPNS_11ImutAVLTreeIS5_EERKSt4pairINS_8IntervalES4_E", "llvm::ImutAVLFactory<llvm::ImutIntervalInfo<clang::ento::SVal> >::add(llvm::ImutAVLTree<llvm::ImutIntervalInfo<clang::ento::SVal> >*, std::pair<llvm::Interval, clang::ento::SVal> const&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutIntervalInfoIN5clang4ento4SValEEEE16getCanonicalTreeEPNS_11ImutAVLTreeIS5_EE", "llvm::ImutAVLFactory<llvm::ImutIntervalInfo<clang::ento::SVal> >::getCanonicalTree(llvm::ImutAVLTree<llvm::ImutIntervalInfo<clang::ento::SVal> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutIntervalInfoIN5clang4ento4SValEEEE22compareTreeWithSectionEPNS_11ImutAVLTreeIS5_EERNS_26ImutAVLTreeInOrderIteratorIS5_EESC_", "llvm::ImutAVLFactory<llvm::ImutIntervalInfo<clang::ento::SVal> >::compareTreeWithSection(llvm::ImutAVLTree<llvm::ImutIntervalInfo<clang::ento::SVal> >*, llvm::ImutAVLTreeInOrderIterator<llvm::ImutIntervalInfo<clang::ento::SVal> >&, llvm::ImutAVLTreeInOrderIterator<llvm::ImutIntervalInfo<clang::ento::SVal> >&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutIntervalInfoIN5clang4ento4SValEEEE12add_internalERKSt4pairINS_8IntervalES4_EPNS_11ImutAVLTreeIS5_EE", "llvm::ImutAVLFactory<llvm::ImutIntervalInfo<clang::ento::SVal> >::add_internal(std::pair<llvm::Interval, clang::ento::SVal> const&, llvm::ImutAVLTree<llvm::ImutIntervalInfo<clang::ento::SVal> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutIntervalInfoIN5clang4ento4SValEEEE13markImmutableEPNS_11ImutAVLTreeIS5_EE", "llvm::ImutAVLFactory<llvm::ImutIntervalInfo<clang::ento::SVal> >::markImmutable(llvm::ImutAVLTree<llvm::ImutIntervalInfo<clang::ento::SVal> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutIntervalInfoIN5clang4ento4SValEEEE10createNodeEPNS_11ImutAVLTreeIS5_EERKSt4pairINS_8IntervalES4_ES9_", "llvm::ImutAVLFactory<llvm::ImutIntervalInfo<clang::ento::SVal> >::createNode(llvm::ImutAVLTree<llvm::ImutIntervalInfo<clang::ento::SVal> >*, std::pair<llvm::Interval, clang::ento::SVal> const&, llvm::ImutAVLTree<llvm::ImutIntervalInfo<clang::ento::SVal> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutIntervalInfoIN5clang4ento4SValEEEE11balanceTreeEPNS_11ImutAVLTreeIS5_EERKSt4pairINS_8IntervalES4_ES9_", "llvm::ImutAVLFactory<llvm::ImutIntervalInfo<clang::ento::SVal> >::balanceTree(llvm::ImutAVLTree<llvm::ImutIntervalInfo<clang::ento::SVal> >*, std::pair<llvm::Interval, clang::ento::SVal> const&, llvm::ImutAVLTree<llvm::ImutIntervalInfo<clang::ento::SVal> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento9MemRegionENS_20ImmutableIntervalMapINS3_4SValEEEEEED2Ev", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::MemRegion const*, llvm::ImmutableIntervalMap<clang::ento::SVal> > >::~ImutAVLFactory()"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutIntervalInfoIN5clang4ento4SValEEEED2Ev", "llvm::ImutAVLFactory<llvm::ImutIntervalInfo<clang::ento::SVal> >::~ImutAVLFactory()"),
	mu_demangle_test("_ZNK5clang4ento7GRState17InvalidateRegionsEPKPKNS0_9MemRegionES6_PKNS_4ExprEjPN4llvm8DenseSetIPKNS0_10SymbolDataENSA_12DenseMapInfoISE_EEEEb", "clang::ento::GRState::InvalidateRegions(clang::ento::MemRegion const* const*, clang::ento::MemRegion const* const*, clang::Expr const*, unsigned int, llvm::DenseSet<clang::ento::SymbolData const*, llvm::DenseMapInfo<clang::ento::SymbolData const*> >*, bool) const"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPvS2_EEE6removeEPNS_11ImutAVLTreeIS3_EERKS2_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<void*, void*> >::remove(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<void*, void*> >*, void* const&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPvS2_EEE16getCanonicalTreeEPNS_11ImutAVLTreeIS3_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<void*, void*> >::getCanonicalTree(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<void*, void*> >*)"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIPvS2_EEE13computeDigestEv", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<void*, void*> >::computeDigest()"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPvS2_EEE22compareTreeWithSectionEPNS_11ImutAVLTreeIS3_EERNS_26ImutAVLTreeInOrderIteratorIS3_EESA_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<void*, void*> >::compareTreeWithSection(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<void*, void*> >*, llvm::ImutAVLTreeInOrderIterator<llvm::ImutKeyValueInfo<void*, void*> >&, llvm::ImutAVLTreeInOrderIterator<llvm::ImutKeyValueInfo<void*, void*> >&)"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIPvS2_EEE7destroyEv", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<void*, void*> >::destroy()"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm11ImutAVLTreeINS0_16ImutKeyValueInfoIPvS3_EEEESaIS6_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS6_S8_EERKS6_", "std::vector<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<void*, void*> >*, std::allocator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<void*, void*> >*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<void*, void*> >**, std::vector<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<void*, void*> >*, std::allocator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<void*, void*> >*> > >, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<void*, void*> >* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_16ImutKeyValueInfoIPvS3_EEEENS_12DenseMapInfoIjEENS7_IS6_EEE16InsertIntoBucketERKjRKS6_PSt4pairIjS6_E", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<void*, void*> >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<void*, void*> >*> >::InsertIntoBucket(unsigned int const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<void*, void*> >* const&, std::pair<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<void*, void*> >*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_16ImutKeyValueInfoIPvS3_EEEENS_12DenseMapInfoIjEENS7_IS6_EEE4growEj", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<void*, void*> >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<void*, void*> >*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPvS2_EEE15remove_internalERKS2_PNS_11ImutAVLTreeIS3_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<void*, void*> >::remove_internal(void* const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<void*, void*> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPvS2_EEE13markImmutableEPNS_11ImutAVLTreeIS3_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<void*, void*> >::markImmutable(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<void*, void*> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPvS2_EEE11balanceTreeEPNS_11ImutAVLTreeIS3_EERKSt4pairIS2_S2_ES7_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<void*, void*> >::balanceTree(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<void*, void*> >*, std::pair<void*, void*> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<void*, void*> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPvS2_EEE10createNodeEPNS_11ImutAVLTreeIS3_EERKSt4pairIS2_S2_ES7_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<void*, void*> >::createNode(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<void*, void*> >*, std::pair<void*, void*> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<void*, void*> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPvS2_EEE16removeMinBindingEPNS_11ImutAVLTreeIS3_EERS7_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<void*, void*> >::removeMinBinding(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<void*, void*> >*, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<void*, void*> >*&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPvS2_EEE3addEPNS_11ImutAVLTreeIS3_EERKSt4pairIS2_S2_E", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<void*, void*> >::add(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<void*, void*> >*, std::pair<void*, void*> const&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPvS2_EEE12add_internalERKSt4pairIS2_S2_EPNS_11ImutAVLTreeIS3_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<void*, void*> >::add_internal(std::pair<void*, void*> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<void*, void*> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPvSt4pairIS1_PFvS1_EENS_12DenseMapInfoIS1_EENS6_IS5_EEE16InsertIntoBucketERKS1_RKS5_PS2_IS1_S5_E", "llvm::DenseMap<void*, std::pair<void*, void (*)(void*)>, llvm::DenseMapInfo<void*>, llvm::DenseMapInfo<std::pair<void*, void (*)(void*)> > >::InsertIntoBucket(void* const&, std::pair<void*, void (*)(void*)> const&, std::pair<void*, std::pair<void*, void (*)(void*)> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPvSt4pairIS1_PFvS1_EENS_12DenseMapInfoIS1_EENS6_IS5_EEE4growEj", "llvm::DenseMap<void*, std::pair<void*, void (*)(void*)>, llvm::DenseMapInfo<void*>, llvm::DenseMapInfo<std::pair<void*, void (*)(void*)> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm26ImutAVLTreeGenericIteratorINS_16ImutKeyValueInfoIPKN5clang4StmtENS2_4ento4SValEEEEppEv", "llvm::ImutAVLTreeGenericIterator<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >::operator++()"),
	mu_demangle_test("_ZNSt6vectorIPN5clang4ento7GRStateESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<clang::ento::GRState*, std::allocator<clang::ento::GRState*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::ento::GRState**, std::vector<clang::ento::GRState*, std::allocator<clang::ento::GRState*> > >, clang::ento::GRState* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4ento9MemRegionEcNS_12DenseMapInfoIS5_EENS6_IcEEE6insertERKSt4pairIS5_cE", "llvm::DenseMap<clang::ento::MemRegion const*, char, llvm::DenseMapInfo<clang::ento::MemRegion const*>, llvm::DenseMapInfo<char> >::insert(std::pair<clang::ento::MemRegion const*, char> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4ento9MemRegionEcNS_12DenseMapInfoIS5_EENS6_IcEEE16InsertIntoBucketERKS5_RKcPSt4pairIS5_cE", "llvm::DenseMap<clang::ento::MemRegion const*, char, llvm::DenseMapInfo<clang::ento::MemRegion const*>, llvm::DenseMapInfo<char> >::InsertIntoBucket(clang::ento::MemRegion const* const&, char const&, std::pair<clang::ento::MemRegion const*, char>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4ento9MemRegionEcNS_12DenseMapInfoIS5_EENS6_IcEEE4growEj", "llvm::DenseMap<clang::ento::MemRegion const*, char, llvm::DenseMapInfo<clang::ento::MemRegion const*>, llvm::DenseMapInfo<char> >::grow(unsigned int)"),
	mu_demangle_test("_ZNK4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4StmtENS2_4ento4SValEEEE7isEqualERKS9_", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >::isEqual(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> > const&) const"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4StmtENS2_4ento4SValEEEE7destroyEv", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >::destroy()"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm11ImutAVLTreeINS0_16ImutKeyValueInfoIPKN5clang4StmtENS3_4ento4SValEEEEESaISB_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPSB_SD_EERKSB_", "std::vector<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >*, std::allocator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >**, std::vector<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >*, std::allocator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >*> > >, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >* const&)"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4StmtENS2_4ento4SValEEEE13computeDigestEPS9_SA_RKSt4pairIS5_S7_E", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >::computeDigest(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >*, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >*, std::pair<clang::Stmt const*, clang::ento::SVal> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4StmtENS3_4ento4SValEEEEENS_12DenseMapInfoIjEENSC_ISB_EEE16InsertIntoBucketERKjRKSB_PSt4pairIjSB_E", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >*> >::InsertIntoBucket(unsigned int const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >* const&, std::pair<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4StmtENS3_4ento4SValEEEEENS_12DenseMapInfoIjEENSC_ISB_EEE4growEj", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4StmtENS2_4ento4SValEEEED2Ev", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::Stmt const*, clang::ento::SVal> >::~ImutAVLFactory()"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPvS2_EEED2Ev", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<void*, void*> >::~ImutAVLFactory()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4ento14CodeTextRegionEPNS2_23StaticGlobalSpaceRegionENS_12DenseMapInfoIS5_EENS8_IS7_EEE16InsertIntoBucketERKS5_RKS7_PSt4pairIS5_S7_E", "llvm::DenseMap<clang::ento::CodeTextRegion const*, clang::ento::StaticGlobalSpaceRegion*, llvm::DenseMapInfo<clang::ento::CodeTextRegion const*>, llvm::DenseMapInfo<clang::ento::StaticGlobalSpaceRegion*> >::InsertIntoBucket(clang::ento::CodeTextRegion const* const&, clang::ento::StaticGlobalSpaceRegion* const&, std::pair<clang::ento::CodeTextRegion const*, clang::ento::StaticGlobalSpaceRegion*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4ento14CodeTextRegionEPNS2_23StaticGlobalSpaceRegionENS_12DenseMapInfoIS5_EENS8_IS7_EEE4growEj", "llvm::DenseMap<clang::ento::CodeTextRegion const*, clang::ento::StaticGlobalSpaceRegion*, llvm::DenseMapInfo<clang::ento::CodeTextRegion const*>, llvm::DenseMapInfo<clang::ento::StaticGlobalSpaceRegion*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang17StackFrameContextEPNS1_4ento25StackArgumentsSpaceRegionENS_12DenseMapInfoIS4_EENS8_IS7_EEE16InsertIntoBucketERKS4_RKS7_PSt4pairIS4_S7_E", "llvm::DenseMap<clang::StackFrameContext const*, clang::ento::StackArgumentsSpaceRegion*, llvm::DenseMapInfo<clang::StackFrameContext const*>, llvm::DenseMapInfo<clang::ento::StackArgumentsSpaceRegion*> >::InsertIntoBucket(clang::StackFrameContext const* const&, clang::ento::StackArgumentsSpaceRegion* const&, std::pair<clang::StackFrameContext const*, clang::ento::StackArgumentsSpaceRegion*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang17StackFrameContextEPNS1_4ento25StackArgumentsSpaceRegionENS_12DenseMapInfoIS4_EENS8_IS7_EEE4growEj", "llvm::DenseMap<clang::StackFrameContext const*, clang::ento::StackArgumentsSpaceRegion*, llvm::DenseMapInfo<clang::StackFrameContext const*>, llvm::DenseMapInfo<clang::ento::StackArgumentsSpaceRegion*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang17StackFrameContextEPNS1_4ento22StackLocalsSpaceRegionENS_12DenseMapInfoIS4_EENS8_IS7_EEE16InsertIntoBucketERKS4_RKS7_PSt4pairIS4_S7_E", "llvm::DenseMap<clang::StackFrameContext const*, clang::ento::StackLocalsSpaceRegion*, llvm::DenseMapInfo<clang::StackFrameContext const*>, llvm::DenseMapInfo<clang::ento::StackLocalsSpaceRegion*> >::InsertIntoBucket(clang::StackFrameContext const* const&, clang::ento::StackLocalsSpaceRegion* const&, std::pair<clang::StackFrameContext const*, clang::ento::StackLocalsSpaceRegion*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang17StackFrameContextEPNS1_4ento22StackLocalsSpaceRegionENS_12DenseMapInfoIS4_EENS8_IS7_EEE4growEj", "llvm::DenseMap<clang::StackFrameContext const*, clang::ento::StackLocalsSpaceRegion*, llvm::DenseMapInfo<clang::StackFrameContext const*>, llvm::DenseMapInfo<clang::ento::StackLocalsSpaceRegion*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt11_Deque_baseIPN5clang4ento19PathDiagnosticPieceESaIS3_EE17_M_initialize_mapEm", "std::_Deque_base<clang::ento::PathDiagnosticPiece*, std::allocator<clang::ento::PathDiagnosticPiece*> >::_M_initialize_map(unsigned long)"),
	mu_demangle_test("_Z6AddFIDRN4llvm8DenseMapIN5clang6FileIDEjNS_12DenseMapInfoIS2_EENS3_IjEEEERNS_15SmallVectorImplIS2_EEPKNS1_13SourceManagerENS1_14SourceLocationE", "AddFID(llvm::DenseMap<clang::FileID, unsigned int, llvm::DenseMapInfo<clang::FileID>, llvm::DenseMapInfo<unsigned int> >&, llvm::SmallVectorImpl<clang::FileID>&, clang::SourceManager const*, clang::SourceLocation)"),
	mu_demangle_test("_Z12EmitLocationRN4llvm11raw_ostreamERKN5clang13SourceManagerERKNS2_11LangOptionsENS2_14SourceLocationERKNS_8DenseMapINS2_6FileIDEjNS_12DenseMapInfoISB_EENSC_IjEEEEjb", "EmitLocation(llvm::raw_ostream&, clang::SourceManager const&, clang::LangOptions const&, clang::SourceLocation, llvm::DenseMap<clang::FileID, unsigned int, llvm::DenseMapInfo<clang::FileID>, llvm::DenseMapInfo<unsigned int> > const&, unsigned int, bool)"),
	mu_demangle_test("_Z11ReportEventRN4llvm11raw_ostreamERKN5clang4ento19PathDiagnosticPieceERKNS_8DenseMapINS2_6FileIDEjNS_12DenseMapInfoIS8_EENS9_IjEEEERKNS2_13SourceManagerERKNS2_11LangOptionsEj", "ReportEvent(llvm::raw_ostream&, clang::ento::PathDiagnosticPiece const&, llvm::DenseMap<clang::FileID, unsigned int, llvm::DenseMapInfo<clang::FileID>, llvm::DenseMapInfo<unsigned int> > const&, clang::SourceManager const&, clang::LangOptions const&, unsigned int)"),
	mu_demangle_test("_Z11ReportMacroRN4llvm11raw_ostreamERKN5clang4ento24PathDiagnosticMacroPieceERKNS_8DenseMapINS2_6FileIDEjNS_12DenseMapInfoIS8_EENS9_IjEEEERKNS2_13SourceManagerERKNS2_11LangOptionsEj", "ReportMacro(llvm::raw_ostream&, clang::ento::PathDiagnosticMacroPiece const&, llvm::DenseMap<clang::FileID, unsigned int, llvm::DenseMapInfo<clang::FileID>, llvm::DenseMapInfo<unsigned int> > const&, clang::SourceManager const&, clang::LangOptions const&, unsigned int)"),
	mu_demangle_test("_Z9EmitRangeRN4llvm11raw_ostreamERKN5clang13SourceManagerERKNS2_11LangOptionsENS2_4ento19PathDiagnosticRangeERKNS_8DenseMapINS2_6FileIDEjNS_12DenseMapInfoISC_EENSD_IjEEEEj", "EmitRange(llvm::raw_ostream&, clang::SourceManager const&, clang::LangOptions const&, clang::ento::PathDiagnosticRange, llvm::DenseMap<clang::FileID, unsigned int, llvm::DenseMapInfo<clang::FileID>, llvm::DenseMapInfo<unsigned int> > const&, unsigned int)"),
	mu_demangle_test("_ZSt16__introsort_loopIN9__gnu_cxx17__normal_iteratorIPPKN5clang4ento14PathDiagnosticESt6vectorIS6_SaIS6_EEEElN12_GLOBAL__N_118CompareDiagnosticsEEvT_SE_T0_T1_", "void std::__introsort_loop<__gnu_cxx::__normal_iterator<clang::ento::PathDiagnostic const**, std::vector<clang::ento::PathDiagnostic const*, std::allocator<clang::ento::PathDiagnostic const*> > >, long, (anonymous namespace)::CompareDiagnostics>(__gnu_cxx::__normal_iterator<clang::ento::PathDiagnostic const**, std::vector<clang::ento::PathDiagnostic const*, std::allocator<clang::ento::PathDiagnostic const*> > >, __gnu_cxx::__normal_iterator<clang::ento::PathDiagnostic const**, std::vector<clang::ento::PathDiagnostic const*, std::allocator<clang::ento::PathDiagnostic const*> > >, long, (anonymous namespace)::CompareDiagnostics)"),
	mu_demangle_test("_ZSt16__insertion_sortIN9__gnu_cxx17__normal_iteratorIPPKN5clang4ento14PathDiagnosticESt6vectorIS6_SaIS6_EEEEN12_GLOBAL__N_118CompareDiagnosticsEEvT_SE_T0_", "void std::__insertion_sort<__gnu_cxx::__normal_iterator<clang::ento::PathDiagnostic const**, std::vector<clang::ento::PathDiagnostic const*, std::allocator<clang::ento::PathDiagnostic const*> > >, (anonymous namespace)::CompareDiagnostics>(__gnu_cxx::__normal_iterator<clang::ento::PathDiagnostic const**, std::vector<clang::ento::PathDiagnostic const*, std::allocator<clang::ento::PathDiagnostic const*> > >, __gnu_cxx::__normal_iterator<clang::ento::PathDiagnostic const**, std::vector<clang::ento::PathDiagnostic const*, std::allocator<clang::ento::PathDiagnostic const*> > >, (anonymous namespace)::CompareDiagnostics)"),
	mu_demangle_test("_ZSt13__adjust_heapIN9__gnu_cxx17__normal_iteratorIPPKN5clang4ento14PathDiagnosticESt6vectorIS6_SaIS6_EEEElS6_N12_GLOBAL__N_118CompareDiagnosticsEEvT_T0_SF_T1_T2_", "void std::__adjust_heap<__gnu_cxx::__normal_iterator<clang::ento::PathDiagnostic const**, std::vector<clang::ento::PathDiagnostic const*, std::allocator<clang::ento::PathDiagnostic const*> > >, long, clang::ento::PathDiagnostic const*, (anonymous namespace)::CompareDiagnostics>(__gnu_cxx::__normal_iterator<clang::ento::PathDiagnostic const**, std::vector<clang::ento::PathDiagnostic const*, std::allocator<clang::ento::PathDiagnostic const*> > >, long, long, clang::ento::PathDiagnostic const*, (anonymous namespace)::CompareDiagnostics)"),
	mu_demangle_test("_ZNSt6vectorIPKN5clang4ento14PathDiagnosticESaIS4_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS4_S6_EERKS4_", "std::vector<clang::ento::PathDiagnostic const*, std::allocator<clang::ento::PathDiagnostic const*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::ento::PathDiagnostic const**, std::vector<clang::ento::PathDiagnostic const*, std::allocator<clang::ento::PathDiagnostic const*> > >, clang::ento::PathDiagnostic const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang6FileIDEjNS_12DenseMapInfoIS2_EENS3_IjEEE16InsertIntoBucketERKS2_RKjPSt4pairIS2_jE", "llvm::DenseMap<clang::FileID, unsigned int, llvm::DenseMapInfo<clang::FileID>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(clang::FileID const&, unsigned int const&, std::pair<clang::FileID, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang6FileIDEjNS_12DenseMapInfoIS2_EENS3_IjEEE4growEj", "llvm::DenseMap<clang::FileID, unsigned int, llvm::DenseMapInfo<clang::FileID>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZN5clang4ento19GRStatePartialTraitIN4llvm12ImmutableMapIPKNS0_10SymbolDataEN12_GLOBAL__N_18RangeSetENS2_16ImutKeyValueInfoIS6_S8_EEEEE13CreateContextERNS2_16BumpPtrAllocatorE", "clang::ento::GRStatePartialTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> > >::CreateContext(llvm::BumpPtrAllocator&)"),
	mu_demangle_test("_ZN5clang4ento19GRStatePartialTraitIN4llvm12ImmutableMapIPKNS0_10SymbolDataEN12_GLOBAL__N_18RangeSetENS2_16ImutKeyValueInfoIS6_S8_EEEEE13DeleteContextEPv", "clang::ento::GRStatePartialTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> > >::DeleteContext(void*)"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_18RangeSetEEEE7destroyEv", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> >::destroy()"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_18RangeSetEEEEENS_12DenseMapInfoIjEENSD_ISC_EEEixERKj", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> >*> >::operator[](unsigned int const&)"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_18RangeSetEEEE13computeDigestEv", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> >::computeDigest()"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm11ImutAVLTreeINS0_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_18RangeSetEEEEESaISC_EE9push_backERKSC_", "std::vector<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> >*, std::allocator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> >*> >::push_back(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> >* const&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_18RangeSetEEEE16getCanonicalTreeEPNS_11ImutAVLTreeIS9_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> >::getCanonicalTree(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> >*)"),
	mu_demangle_test("_ZN4llvm26ImutAVLTreeInOrderIteratorINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_18RangeSetEEEEppEv", "llvm::ImutAVLTreeInOrderIterator<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> >::operator++()"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_18RangeSetEEEE12add_internalERKSt4pairIS6_S8_EPNS_11ImutAVLTreeIS9_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> >::add_internal(std::pair<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_18RangeSetEEEE13markImmutableEPNS_11ImutAVLTreeIS9_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> >::markImmutable(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_18RangeSetEEEE10createNodeEPNS_11ImutAVLTreeIS9_EERKSt4pairIS6_S8_ESD_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> >::createNode(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> >*, std::pair<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_18RangeSetEEEE11balanceTreeEPNS_11ImutAVLTreeIS9_EERKSt4pairIS6_S8_ESD_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> >::balanceTree(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> >*, std::pair<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeIN12_GLOBAL__N_110RangeTraitEEENS_12DenseMapInfoIjEENS6_IS5_EEEixERKj", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<(anonymous namespace)::RangeTrait>*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<(anonymous namespace)::RangeTrait>*> >::operator[](unsigned int const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm11ImutAVLTreeIN12_GLOBAL__N_110RangeTraitEEESaIS5_EE9push_backERKS5_", "std::vector<llvm::ImutAVLTree<(anonymous namespace)::RangeTrait>*, std::allocator<llvm::ImutAVLTree<(anonymous namespace)::RangeTrait>*> >::push_back(llvm::ImutAVLTree<(anonymous namespace)::RangeTrait>* const&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_18RangeSetEEEE15remove_internalERKS6_PNS_11ImutAVLTreeIS9_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> >::remove_internal(clang::ento::SymbolData const* const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIPKN5clang4ento10SymbolDataEN12_GLOBAL__N_18RangeSetEEEE16removeMinBindingEPNS_11ImutAVLTreeIS9_EERSD_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> >::removeMinBinding(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> >*, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RangeSet> >*&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_118RegionStoreManager17InvalidateRegionsEPKvPKPKN5clang4ento9MemRegionES9_PKNS3_4ExprEjPN4llvm8DenseSetIPKNS4_10SymbolDataENSD_12DenseMapInfoISH_EEEEbPNSD_11SmallVectorIS7_Lj8EEE", "(anonymous namespace)::RegionStoreManager::InvalidateRegions(void const*, clang::ento::MemRegion const* const*, clang::ento::MemRegion const* const*, clang::Expr const*, unsigned int, llvm::DenseSet<clang::ento::SymbolData const*, llvm::DenseMapInfo<clang::ento::SymbolData const*> >*, bool, llvm::SmallVector<clang::ento::MemRegion const*, 8u>*)"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIN12_GLOBAL__N_110BindingKeyEN5clang4ento4SValEEEE7destroyEv", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >::destroy()"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_16ImutKeyValueInfoIN12_GLOBAL__N_110BindingKeyEN5clang4ento4SValEEEEENS_12DenseMapInfoIjEENSB_ISA_EEEixERKj", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >*> >::operator[](unsigned int const&)"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_16ImutKeyValueInfoIN12_GLOBAL__N_110BindingKeyEN5clang4ento4SValEEEE13computeDigestEv", "llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >::computeDigest()"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm11ImutAVLTreeINS0_16ImutKeyValueInfoIN12_GLOBAL__N_110BindingKeyEN5clang4ento4SValEEEEESaISA_EE9push_backERKSA_", "std::vector<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >*, std::allocator<llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >*> >::push_back(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >* const&)"),
	mu_demangle_test("_ZN4llvm26ImutAVLTreeInOrderIteratorINS_16ImutKeyValueInfoIN12_GLOBAL__N_110BindingKeyEN5clang4ento4SValEEEEppEv", "llvm::ImutAVLTreeInOrderIterator<llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >::operator++()"),
	mu_demangle_test("_ZN12_GLOBAL__N_118RegionStoreManager10addBindingEN4llvm12ImmutableMapINS_10BindingKeyEN5clang4ento4SValENS1_16ImutKeyValueInfoIS3_S6_EEEES3_S6_", "(anonymous namespace)::RegionStoreManager::addBinding(llvm::ImmutableMap<(anonymous namespace)::BindingKey, clang::ento::SVal, llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >, (anonymous namespace)::BindingKey, clang::ento::SVal)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIN12_GLOBAL__N_110BindingKeyEN5clang4ento4SValEEEE16getCanonicalTreeEPNS_11ImutAVLTreeIS7_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >::getCanonicalTree(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIN12_GLOBAL__N_110BindingKeyEN5clang4ento4SValEEEE12add_internalERKSt4pairIS3_S6_EPNS_11ImutAVLTreeIS7_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >::add_internal(std::pair<(anonymous namespace)::BindingKey, clang::ento::SVal> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIN12_GLOBAL__N_110BindingKeyEN5clang4ento4SValEEEE13markImmutableEPNS_11ImutAVLTreeIS7_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >::markImmutable(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIN12_GLOBAL__N_110BindingKeyEN5clang4ento4SValEEEE10createNodeEPNS_11ImutAVLTreeIS7_EERKSt4pairIS3_S6_ESB_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >::createNode(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >*, std::pair<(anonymous namespace)::BindingKey, clang::ento::SVal> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIN12_GLOBAL__N_110BindingKeyEN5clang4ento4SValEEEE11balanceTreeEPNS_11ImutAVLTreeIS7_EERKSt4pairIS3_S6_ESB_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >::balanceTree(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >*, std::pair<(anonymous namespace)::BindingKey, clang::ento::SVal> const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >*)"),
	mu_demangle_test("_ZN12_GLOBAL__N_118RegionStoreManager13removeBindingEN4llvm12ImmutableMapINS_10BindingKeyEN5clang4ento4SValENS1_16ImutKeyValueInfoIS3_S6_EEEES3_", "(anonymous namespace)::RegionStoreManager::removeBinding(llvm::ImmutableMap<(anonymous namespace)::BindingKey, clang::ento::SVal, llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >, (anonymous namespace)::BindingKey)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIN12_GLOBAL__N_110BindingKeyEN5clang4ento4SValEEEE15remove_internalERKS3_PNS_11ImutAVLTreeIS7_EE", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >::remove_internal((anonymous namespace)::BindingKey const&, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_16ImutKeyValueInfoIN12_GLOBAL__N_110BindingKeyEN5clang4ento4SValEEEE16removeMinBindingEPNS_11ImutAVLTreeIS7_EERSB_", "llvm::ImutAVLFactory<llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >::removeMinBinding(llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >*, llvm::ImutAVLTree<llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >*&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4ento9MemRegionEPNS1_10BumpVectorIN12_GLOBAL__N_110BindingKeyEEENS_12DenseMapInfoIS5_EENSB_ISA_EEEixERKS5_", "llvm::DenseMap<clang::ento::MemRegion const*, clang::BumpVector<(anonymous namespace)::BindingKey>*, llvm::DenseMapInfo<clang::ento::MemRegion const*>, llvm::DenseMapInfo<clang::BumpVector<(anonymous namespace)::BindingKey>*> >::operator[](clang::ento::MemRegion const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang10BumpVectorIN12_GLOBAL__N_110BindingKeyEEEjNS_12DenseMapInfoIS7_EENS8_IjEEEixERKS7_", "llvm::DenseMap<clang::BumpVector<(anonymous namespace)::BindingKey> const*, unsigned int, llvm::DenseMapInfo<clang::BumpVector<(anonymous namespace)::BindingKey> const*>, llvm::DenseMapInfo<unsigned int> >::operator[](clang::BumpVector<(anonymous namespace)::BindingKey> const* const&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_118RegionStoreManager23RemoveSubRegionBindingsERN4llvm12ImmutableMapINS_10BindingKeyEN5clang4ento4SValENS1_16ImutKeyValueInfoIS3_S6_EEEEPKNS5_9MemRegionERNS_23RegionStoreSubRegionMapE", "(anonymous namespace)::RegionStoreManager::RemoveSubRegionBindings(llvm::ImmutableMap<(anonymous namespace)::BindingKey, clang::ento::SVal, llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >&, clang::ento::MemRegion const*, (anonymous namespace)::RegionStoreSubRegionMap&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_118RegionStoreManager27RetrieveDerivedDefaultValueEN4llvm12ImmutableMapINS_10BindingKeyEN5clang4ento4SValENS1_16ImutKeyValueInfoIS3_S6_EEEEPKNS5_9MemRegionEPKNS5_11TypedRegionENS4_8QualTypeE", "(anonymous namespace)::RegionStoreManager::RetrieveDerivedDefaultValue(llvm::ImmutableMap<(anonymous namespace)::BindingKey, clang::ento::SVal, llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >, clang::ento::MemRegion const*, clang::ento::TypedRegion const*, clang::QualType)"),
	mu_demangle_test("_ZN12_GLOBAL__N_118RegionStoreManager17getDefaultBindingEN4llvm12ImmutableMapINS_10BindingKeyEN5clang4ento4SValENS1_16ImutKeyValueInfoIS3_S6_EEEEPKNS5_9MemRegionE", "(anonymous namespace)::RegionStoreManager::getDefaultBinding(llvm::ImmutableMap<(anonymous namespace)::BindingKey, clang::ento::SVal, llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >, clang::ento::MemRegion const*)"),
	mu_demangle_test("_ZN12_GLOBAL__N_118RegionStoreManager14GetLazyBindingEN4llvm12ImmutableMapINS_10BindingKeyEN5clang4ento4SValENS1_16ImutKeyValueInfoIS3_S6_EEEEPKNS5_9MemRegionE", "(anonymous namespace)::RegionStoreManager::GetLazyBinding(llvm::ImmutableMap<(anonymous namespace)::BindingKey, clang::ento::SVal, llvm::ImutKeyValueInfo<(anonymous namespace)::BindingKey, clang::ento::SVal> >, clang::ento::MemRegion const*)"),
	mu_demangle_test("_ZN4llvm26ImutAVLTreeGenericIteratorINS_17ImutContainerInfoIPKN5clang4ento9MemRegionEEEEppEv", "llvm::ImutAVLTreeGenericIterator<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >::operator++()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4ento9MemRegionENS_12ImmutableSetIS5_NS_17ImutContainerInfoIS5_EEEENS_12DenseMapInfoIS5_EENSA_IS9_EEE6insertERKSt4pairIS5_S9_E", "llvm::DenseMap<clang::ento::MemRegion const*, llvm::ImmutableSet<clang::ento::MemRegion const*, llvm::ImutContainerInfo<clang::ento::MemRegion const*> >, llvm::DenseMapInfo<clang::ento::MemRegion const*>, llvm::DenseMapInfo<llvm::ImmutableSet<clang::ento::MemRegion const*, llvm::ImutContainerInfo<clang::ento::MemRegion const*> > > >::insert(std::pair<clang::ento::MemRegion const*, llvm::ImmutableSet<clang::ento::MemRegion const*, llvm::ImutContainerInfo<clang::ento::MemRegion const*> > > const&)"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_17ImutContainerInfoIPKN5clang4ento9MemRegionEEEE7destroyEv", "llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >::destroy()"),
	mu_demangle_test("_ZN4llvm11ImutAVLTreeINS_17ImutContainerInfoIPKN5clang4ento9MemRegionEEEE13computeDigestEv", "llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >::computeDigest()"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm11ImutAVLTreeINS0_17ImutContainerInfoIPKN5clang4ento9MemRegionEEEEESaISA_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPSA_SC_EERKSA_", "std::vector<llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >*, std::allocator<llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >**, std::vector<llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >*, std::allocator<llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >*> > >, llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_17ImutContainerInfoIPKN5clang4ento9MemRegionEEEEENS_12DenseMapInfoIjEENSB_ISA_EEE16InsertIntoBucketERKjRKSA_PSt4pairIjSA_E", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >*> >::InsertIntoBucket(unsigned int const&, llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >* const&, std::pair<unsigned int, llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_11ImutAVLTreeINS_17ImutContainerInfoIPKN5clang4ento9MemRegionEEEEENS_12DenseMapInfoIjEENSB_ISA_EEE4growEj", "llvm::DenseMap<unsigned int, llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_17ImutContainerInfoIPKN5clang4ento9MemRegionEEEE3addEPNS_11ImutAVLTreeIS7_EES6_", "llvm::ImutAVLFactory<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >::add(llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >*, clang::ento::MemRegion const*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_17ImutContainerInfoIPKN5clang4ento9MemRegionEEEE16getCanonicalTreeEPNS_11ImutAVLTreeIS7_EE", "llvm::ImutAVLFactory<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >::getCanonicalTree(llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_17ImutContainerInfoIPKN5clang4ento9MemRegionEEEE22compareTreeWithSectionEPNS_11ImutAVLTreeIS7_EERNS_26ImutAVLTreeInOrderIteratorIS7_EESE_", "llvm::ImutAVLFactory<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >::compareTreeWithSection(llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >*, llvm::ImutAVLTreeInOrderIterator<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >&, llvm::ImutAVLTreeInOrderIterator<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >&)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_17ImutContainerInfoIPKN5clang4ento9MemRegionEEEE12add_internalES6_PNS_11ImutAVLTreeIS7_EE", "llvm::ImutAVLFactory<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >::add_internal(clang::ento::MemRegion const*, llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_17ImutContainerInfoIPKN5clang4ento9MemRegionEEEE13markImmutableEPNS_11ImutAVLTreeIS7_EE", "llvm::ImutAVLFactory<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >::markImmutable(llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_17ImutContainerInfoIPKN5clang4ento9MemRegionEEEE10createNodeEPNS_11ImutAVLTreeIS7_EES6_SB_", "llvm::ImutAVLFactory<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >::createNode(llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >*, clang::ento::MemRegion const*, llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >*)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_17ImutContainerInfoIPKN5clang4ento9MemRegionEEEE11balanceTreeEPNS_11ImutAVLTreeIS7_EES6_SB_", "llvm::ImutAVLFactory<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >::balanceTree(llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >*, clang::ento::MemRegion const*, llvm::ImutAVLTree<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4ento9MemRegionENS_12ImmutableSetIS5_NS_17ImutContainerInfoIS5_EEEENS_12DenseMapInfoIS5_EENSA_IS9_EEE16InsertIntoBucketERKS5_RKS9_PSt4pairIS5_S9_E", "llvm::DenseMap<clang::ento::MemRegion const*, llvm::ImmutableSet<clang::ento::MemRegion const*, llvm::ImutContainerInfo<clang::ento::MemRegion const*> >, llvm::DenseMapInfo<clang::ento::MemRegion const*>, llvm::DenseMapInfo<llvm::ImmutableSet<clang::ento::MemRegion const*, llvm::ImutContainerInfo<clang::ento::MemRegion const*> > > >::InsertIntoBucket(clang::ento::MemRegion const* const&, llvm::ImmutableSet<clang::ento::MemRegion const*, llvm::ImutContainerInfo<clang::ento::MemRegion const*> > const&, std::pair<clang::ento::MemRegion const*, llvm::ImmutableSet<clang::ento::MemRegion const*, llvm::ImutContainerInfo<clang::ento::MemRegion const*> > >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4ento9MemRegionENS_12ImmutableSetIS5_NS_17ImutContainerInfoIS5_EEEENS_12DenseMapInfoIS5_EENSA_IS9_EEE4growEj", "llvm::DenseMap<clang::ento::MemRegion const*, llvm::ImmutableSet<clang::ento::MemRegion const*, llvm::ImutContainerInfo<clang::ento::MemRegion const*> >, llvm::DenseMapInfo<clang::ento::MemRegion const*>, llvm::DenseMapInfo<llvm::ImmutableSet<clang::ento::MemRegion const*, llvm::ImutContainerInfo<clang::ento::MemRegion const*> > > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_17ImutContainerInfoIPKN5clang4ento9MemRegionEEEED2Ev", "llvm::ImutAVLFactory<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >::~ImutAVLFactory()"),
	mu_demangle_test("_ZN4llvm14ImutAVLFactoryINS_17ImutContainerInfoIPKN5clang4ento9MemRegionEEEEC2Ev", "llvm::ImutAVLFactory<llvm::ImutContainerInfo<clang::ento::MemRegion const*> >::ImutAVLFactory()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang9BlockDeclEPvNS_12DenseMapInfoIS4_EENS6_IS5_EEE16InsertIntoBucketERKS4_RKS5_PSt4pairIS4_S5_E", "llvm::DenseMap<clang::BlockDecl const*, void*, llvm::DenseMapInfo<clang::BlockDecl const*>, llvm::DenseMapInfo<void*> >::InsertIntoBucket(clang::BlockDecl const* const&, void* const&, std::pair<clang::BlockDecl const*, void*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang9BlockDeclEPvNS_12DenseMapInfoIS4_EENS6_IS5_EEE4growEj", "llvm::DenseMap<clang::BlockDecl const*, void*, llvm::DenseMapInfo<clang::BlockDecl const*>, llvm::DenseMapInfo<void*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4DeclEPNS1_15AnalysisContextENS_12DenseMapInfoIS4_EENS7_IS6_EEE16InsertIntoBucketERKS4_RKS6_PSt4pairIS4_S6_E", "llvm::DenseMap<clang::Decl const*, clang::AnalysisContext*, llvm::DenseMapInfo<clang::Decl const*>, llvm::DenseMapInfo<clang::AnalysisContext*> >::InsertIntoBucket(clang::Decl const* const&, clang::AnalysisContext* const&, std::pair<clang::Decl const*, clang::AnalysisContext*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4DeclEPNS1_15AnalysisContextENS_12DenseMapInfoIS4_EENS7_IS6_EEE4growEj", "llvm::DenseMap<clang::Decl const*, clang::AnalysisContext*, llvm::DenseMapInfo<clang::Decl const*>, llvm::DenseMapInfo<clang::AnalysisContext*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4DeclEPNS1_15AnalysisContextENS_12DenseMapInfoIS4_EENS7_IS6_EEE16shrink_and_clearEv", "llvm::DenseMap<clang::Decl const*, clang::AnalysisContext*, llvm::DenseMapInfo<clang::Decl const*>, llvm::DenseMapInfo<clang::AnalysisContext*> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang12ProgramPointENS1_23StmtDeclBitVector_Types5ValTyENS_12DenseMapInfoIS2_EENS5_IS4_EEED2Ev", "llvm::DenseMap<clang::ProgramPoint, clang::StmtDeclBitVector_Types::ValTy, llvm::DenseMapInfo<clang::ProgramPoint>, llvm::DenseMapInfo<clang::StmtDeclBitVector_Types::ValTy> >::~DenseMap()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang7VarDeclEjNS_12DenseMapInfoIS4_EENS5_IjEEE16InsertIntoBucketERKS4_RKjPSt4pairIS4_jE", "llvm::DenseMap<clang::VarDecl const*, unsigned int, llvm::DenseMapInfo<clang::VarDecl const*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(clang::VarDecl const* const&, unsigned int const&, std::pair<clang::VarDecl const*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang7VarDeclEjNS_12DenseMapInfoIS4_EENS5_IjEEE4growEj", "llvm::DenseMap<clang::VarDecl const*, unsigned int, llvm::DenseMapInfo<clang::VarDecl const*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang4DeclESt4pairIjjENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PS4_IS3_S5_E", "llvm::DenseMap<clang::Decl*, std::pair<unsigned int, unsigned int>, llvm::DenseMapInfo<clang::Decl*>, llvm::DenseMapInfo<std::pair<unsigned int, unsigned int> > >::InsertIntoBucket(clang::Decl* const&, std::pair<unsigned int, unsigned int> const&, std::pair<clang::Decl*, std::pair<unsigned int, unsigned int> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang4DeclESt4pairIjjENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<clang::Decl*, std::pair<unsigned int, unsigned int>, llvm::DenseMapInfo<clang::Decl*>, llvm::DenseMapInfo<std::pair<unsigned int, unsigned int> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang4StmtESt4pairIjjENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PS4_IS3_S5_E", "llvm::DenseMap<clang::Stmt*, std::pair<unsigned int, unsigned int>, llvm::DenseMapInfo<clang::Stmt*>, llvm::DenseMapInfo<std::pair<unsigned int, unsigned int> > >::InsertIntoBucket(clang::Stmt* const&, std::pair<unsigned int, unsigned int> const&, std::pair<clang::Stmt*, std::pair<unsigned int, unsigned int> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang4StmtESt4pairIjjENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<clang::Stmt*, std::pair<unsigned int, unsigned int>, llvm::DenseMapInfo<clang::Stmt*>, llvm::DenseMapInfo<std::pair<unsigned int, unsigned int> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4StmtEjNS_12DenseMapInfoIS4_EENS5_IjEEE16InsertIntoBucketERKS4_RKjPSt4pairIS4_jE", "llvm::DenseMap<clang::Stmt const*, unsigned int, llvm::DenseMapInfo<clang::Stmt const*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(clang::Stmt const* const&, unsigned int const&, std::pair<clang::Stmt const*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4StmtEjNS_12DenseMapInfoIS4_EENS5_IjEEE4growEj", "llvm::DenseMap<clang::Stmt const*, unsigned int, llvm::DenseMapInfo<clang::Stmt const*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang4StmtEPNS1_8CFGBlockENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PSt4pairIS3_S5_E", "llvm::DenseMap<clang::Stmt*, clang::CFGBlock*, llvm::DenseMapInfo<clang::Stmt*>, llvm::DenseMapInfo<clang::CFGBlock*> >::InsertIntoBucket(clang::Stmt* const&, clang::CFGBlock* const&, std::pair<clang::Stmt*, clang::CFGBlock*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang4StmtEPNS1_8CFGBlockENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<clang::Stmt*, clang::CFGBlock*, llvm::DenseMapInfo<clang::Stmt*>, llvm::DenseMapInfo<clang::CFGBlock*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN5clang14DataflowSolverINS_13LiveVariablesEN12_GLOBAL__N_113TransferFuncsENS_23StmtDeclBitVector_Types5UnionESt8equal_toINS4_5ValTyEEE12ProcessBlockEPKNS_8CFGBlockEbNS_8dataflow21backward_analysis_tagE", "clang::DataflowSolver<clang::LiveVariables, (anonymous namespace)::TransferFuncs, clang::StmtDeclBitVector_Types::Union, std::equal_to<clang::StmtDeclBitVector_Types::ValTy> >::ProcessBlock(clang::CFGBlock const*, bool, clang::dataflow::backward_analysis_tag)"),
	mu_demangle_test("_ZN5clang14DataflowSolverINS_19UninitializedValuesEN12_GLOBAL__N_113TransferFuncsENS_23StmtDeclBitVector_Types5UnionESt8equal_toINS4_5ValTyEEE12ProcessBlockEPKNS_8CFGBlockEbNS_8dataflow20forward_analysis_tagE", "clang::DataflowSolver<clang::UninitializedValues, (anonymous namespace)::TransferFuncs, clang::StmtDeclBitVector_Types::Union, std::equal_to<clang::StmtDeclBitVector_Types::ValTy> >::ProcessBlock(clang::CFGBlock const*, bool, clang::dataflow::forward_analysis_tag)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4StmtENS1_23StmtDeclBitVector_Types5ValTyENS_12DenseMapInfoIS4_EENS7_IS6_EEE16FindAndConstructERKS4_", "llvm::DenseMap<clang::Stmt const*, clang::StmtDeclBitVector_Types::ValTy, llvm::DenseMapInfo<clang::Stmt const*>, llvm::DenseMapInfo<clang::StmtDeclBitVector_Types::ValTy> >::FindAndConstruct(clang::Stmt const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4StmtENS1_23StmtDeclBitVector_Types5ValTyENS_12DenseMapInfoIS4_EENS7_IS6_EEE16InsertIntoBucketERKS4_RKS6_PSt4pairIS4_S6_E", "llvm::DenseMap<clang::Stmt const*, clang::StmtDeclBitVector_Types::ValTy, llvm::DenseMapInfo<clang::Stmt const*>, llvm::DenseMapInfo<clang::StmtDeclBitVector_Types::ValTy> >::InsertIntoBucket(clang::Stmt const* const&, clang::StmtDeclBitVector_Types::ValTy const&, std::pair<clang::Stmt const*, clang::StmtDeclBitVector_Types::ValTy>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4StmtENS1_23StmtDeclBitVector_Types5ValTyENS_12DenseMapInfoIS4_EENS7_IS6_EEE4growEj", "llvm::DenseMap<clang::Stmt const*, clang::StmtDeclBitVector_Types::ValTy, llvm::DenseMapInfo<clang::Stmt const*>, llvm::DenseMapInfo<clang::StmtDeclBitVector_Types::ValTy> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang12ProgramPointENS1_23StmtDeclBitVector_Types5ValTyENS_12DenseMapInfoIS2_EENS5_IS4_EEE4findERKS2_", "llvm::DenseMap<clang::ProgramPoint, clang::StmtDeclBitVector_Types::ValTy, llvm::DenseMapInfo<clang::ProgramPoint>, llvm::DenseMapInfo<clang::StmtDeclBitVector_Types::ValTy> >::find(clang::ProgramPoint const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang8CFGBlockEhNS_12DenseMapInfoIS4_EENS5_IhEEE16InsertIntoBucketERKS4_RKhPSt4pairIS4_hE", "llvm::DenseMap<clang::CFGBlock const*, unsigned char, llvm::DenseMapInfo<clang::CFGBlock const*>, llvm::DenseMapInfo<unsigned char> >::InsertIntoBucket(clang::CFGBlock const* const&, unsigned char const&, std::pair<clang::CFGBlock const*, unsigned char>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang8CFGBlockEhNS_12DenseMapInfoIS4_EENS5_IhEEE4growEj", "llvm::DenseMap<clang::CFGBlock const*, unsigned char, llvm::DenseMapInfo<clang::CFGBlock const*>, llvm::DenseMapInfo<unsigned char> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang12ProgramPointENS1_23StmtDeclBitVector_Types5ValTyENS_12DenseMapInfoIS2_EENS5_IS4_EEE16FindAndConstructERKS2_", "llvm::DenseMap<clang::ProgramPoint, clang::StmtDeclBitVector_Types::ValTy, llvm::DenseMapInfo<clang::ProgramPoint>, llvm::DenseMapInfo<clang::StmtDeclBitVector_Types::ValTy> >::FindAndConstruct(clang::ProgramPoint const&)"),
	mu_demangle_test("_ZNK4llvm8DenseMapIN5clang12ProgramPointENS1_23StmtDeclBitVector_Types5ValTyENS_12DenseMapInfoIS2_EENS5_IS4_EEE15LookupBucketForERKS2_RPSt4pairIS2_S4_E", "llvm::DenseMap<clang::ProgramPoint, clang::StmtDeclBitVector_Types::ValTy, llvm::DenseMapInfo<clang::ProgramPoint>, llvm::DenseMapInfo<clang::StmtDeclBitVector_Types::ValTy> >::LookupBucketFor(clang::ProgramPoint const&, std::pair<clang::ProgramPoint, clang::StmtDeclBitVector_Types::ValTy>*&) const"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang12ProgramPointENS1_23StmtDeclBitVector_Types5ValTyENS_12DenseMapInfoIS2_EENS5_IS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<clang::ProgramPoint, clang::StmtDeclBitVector_Types::ValTy, llvm::DenseMapInfo<clang::ProgramPoint>, llvm::DenseMapInfo<clang::StmtDeclBitVector_Types::ValTy> >::InsertIntoBucket(clang::ProgramPoint const&, clang::StmtDeclBitVector_Types::ValTy const&, std::pair<clang::ProgramPoint, clang::StmtDeclBitVector_Types::ValTy>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang12ProgramPointENS1_23StmtDeclBitVector_Types5ValTyENS_12DenseMapInfoIS2_EENS5_IS4_EEE4growEj", "llvm::DenseMap<clang::ProgramPoint, clang::StmtDeclBitVector_Types::ValTy, llvm::DenseMapInfo<clang::ProgramPoint>, llvm::DenseMapInfo<clang::StmtDeclBitVector_Types::ValTy> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang8CFGBlockENS1_23StmtDeclBitVector_Types5ValTyENS_12DenseMapInfoIS4_EENS7_IS6_EEE6insertERKSt4pairIS4_S6_E", "llvm::DenseMap<clang::CFGBlock const*, clang::StmtDeclBitVector_Types::ValTy, llvm::DenseMapInfo<clang::CFGBlock const*>, llvm::DenseMapInfo<clang::StmtDeclBitVector_Types::ValTy> >::insert(std::pair<clang::CFGBlock const*, clang::StmtDeclBitVector_Types::ValTy> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang8CFGBlockENS1_23StmtDeclBitVector_Types5ValTyENS_12DenseMapInfoIS4_EENS7_IS6_EEE16InsertIntoBucketERKS4_RKS6_PSt4pairIS4_S6_E", "llvm::DenseMap<clang::CFGBlock const*, clang::StmtDeclBitVector_Types::ValTy, llvm::DenseMapInfo<clang::CFGBlock const*>, llvm::DenseMapInfo<clang::StmtDeclBitVector_Types::ValTy> >::InsertIntoBucket(clang::CFGBlock const* const&, clang::StmtDeclBitVector_Types::ValTy const&, std::pair<clang::CFGBlock const*, clang::StmtDeclBitVector_Types::ValTy>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang8CFGBlockENS1_23StmtDeclBitVector_Types5ValTyENS_12DenseMapInfoIS4_EENS7_IS6_EEE4growEj", "llvm::DenseMap<clang::CFGBlock const*, clang::StmtDeclBitVector_Types::ValTy, llvm::DenseMapInfo<clang::CFGBlock const*>, llvm::DenseMapInfo<clang::StmtDeclBitVector_Types::ValTy> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt3mapIN5clang3idx14GlobalSelectorEN4llvm11SmallPtrSetIPNS1_15TranslationUnitELj4EEESt4lessIS2_ESaISt4pairIKS2_S7_EEEixERSB_", "std::map<clang::idx::GlobalSelector, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u>, std::less<clang::idx::GlobalSelector>, std::allocator<std::pair<clang::idx::GlobalSelector const, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u> > > >::operator[](clang::idx::GlobalSelector const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN5clang3idx14GlobalSelectorESt4pairIKS2_N4llvm11SmallPtrSetIPNS1_15TranslationUnitELj4EEEESt10_Select1stISA_ESt4lessIS2_ESaISA_EE16_M_insert_uniqueESt17_Rb_tree_iteratorISA_ERKSA_", "std::_Rb_tree<clang::idx::GlobalSelector, std::pair<clang::idx::GlobalSelector const, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u> >, std::_Select1st<std::pair<clang::idx::GlobalSelector const, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u> > >, std::less<clang::idx::GlobalSelector>, std::allocator<std::pair<clang::idx::GlobalSelector const, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u> > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<clang::idx::GlobalSelector const, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u> > >, std::pair<clang::idx::GlobalSelector const, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN5clang3idx14GlobalSelectorESt4pairIKS2_N4llvm11SmallPtrSetIPNS1_15TranslationUnitELj4EEEESt10_Select1stISA_ESt4lessIS2_ESaISA_EE16_M_insert_uniqueERKSA_", "std::_Rb_tree<clang::idx::GlobalSelector, std::pair<clang::idx::GlobalSelector const, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u> >, std::_Select1st<std::pair<clang::idx::GlobalSelector const, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u> > >, std::less<clang::idx::GlobalSelector>, std::allocator<std::pair<clang::idx::GlobalSelector const, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u> > > >::_M_insert_unique(std::pair<clang::idx::GlobalSelector const, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang10ASTContextEPNS1_3idx15TranslationUnitENS_12DenseMapInfoIS3_EENS7_IS6_EEE16InsertIntoBucketERKS3_RKS6_PSt4pairIS3_S6_E", "llvm::DenseMap<clang::ASTContext*, clang::idx::TranslationUnit*, llvm::DenseMapInfo<clang::ASTContext*>, llvm::DenseMapInfo<clang::idx::TranslationUnit*> >::InsertIntoBucket(clang::ASTContext* const&, clang::idx::TranslationUnit* const&, std::pair<clang::ASTContext*, clang::idx::TranslationUnit*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang10ASTContextEPNS1_3idx15TranslationUnitENS_12DenseMapInfoIS3_EENS7_IS6_EEE4growEj", "llvm::DenseMap<clang::ASTContext*, clang::idx::TranslationUnit*, llvm::DenseMapInfo<clang::ASTContext*>, llvm::DenseMapInfo<clang::idx::TranslationUnit*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN5clang3idx6EntityESt4pairIKS2_N4llvm11SmallPtrSetIPNS1_15TranslationUnitELj4EEEESt10_Select1stISA_ESt4lessIS2_ESaISA_EE8_M_eraseEPSt13_Rb_tree_nodeISA_E", "std::_Rb_tree<clang::idx::Entity, std::pair<clang::idx::Entity const, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u> >, std::_Select1st<std::pair<clang::idx::Entity const, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u> > >, std::less<clang::idx::Entity>, std::allocator<std::pair<clang::idx::Entity const, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u> > > >::_M_erase(std::_Rb_tree_node<std::pair<clang::idx::Entity const, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u> > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN5clang3idx6EntityESt4pairIKS2_S3_IPNS0_12FunctionDeclEPNS1_15TranslationUnitEEESt10_Select1stISA_ESt4lessIS2_ESaISA_EE8_M_eraseEPSt13_Rb_tree_nodeISA_E", "std::_Rb_tree<clang::idx::Entity, std::pair<clang::idx::Entity const, std::pair<clang::FunctionDecl*, clang::idx::TranslationUnit*> >, std::_Select1st<std::pair<clang::idx::Entity const, std::pair<clang::FunctionDecl*, clang::idx::TranslationUnit*> > >, std::less<clang::idx::Entity>, std::allocator<std::pair<clang::idx::Entity const, std::pair<clang::FunctionDecl*, clang::idx::TranslationUnit*> > > >::_M_erase(std::_Rb_tree_node<std::pair<clang::idx::Entity const, std::pair<clang::FunctionDecl*, clang::idx::TranslationUnit*> > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN5clang3idx14GlobalSelectorESt4pairIKS2_N4llvm11SmallPtrSetIPNS1_15TranslationUnitELj4EEEESt10_Select1stISA_ESt4lessIS2_ESaISA_EE8_M_eraseEPSt13_Rb_tree_nodeISA_E", "std::_Rb_tree<clang::idx::GlobalSelector, std::pair<clang::idx::GlobalSelector const, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u> >, std::_Select1st<std::pair<clang::idx::GlobalSelector const, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u> > >, std::less<clang::idx::GlobalSelector>, std::allocator<std::pair<clang::idx::GlobalSelector const, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u> > > >::_M_erase(std::_Rb_tree_node<std::pair<clang::idx::GlobalSelector const, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u> > >*)"),
	mu_demangle_test("_ZNSt3mapIN5clang3idx6EntityEN4llvm11SmallPtrSetIPNS1_15TranslationUnitELj4EEESt4lessIS2_ESaISt4pairIKS2_S7_EEEixERSB_", "std::map<clang::idx::Entity, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u>, std::less<clang::idx::Entity>, std::allocator<std::pair<clang::idx::Entity const, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u> > > >::operator[](clang::idx::Entity const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN5clang3idx6EntityESt4pairIKS2_S3_IPNS0_12FunctionDeclEPNS1_15TranslationUnitEEESt10_Select1stISA_ESt4lessIS2_ESaISA_EE16_M_insert_uniqueESt17_Rb_tree_iteratorISA_ERKSA_", "std::_Rb_tree<clang::idx::Entity, std::pair<clang::idx::Entity const, std::pair<clang::FunctionDecl*, clang::idx::TranslationUnit*> >, std::_Select1st<std::pair<clang::idx::Entity const, std::pair<clang::FunctionDecl*, clang::idx::TranslationUnit*> > >, std::less<clang::idx::Entity>, std::allocator<std::pair<clang::idx::Entity const, std::pair<clang::FunctionDecl*, clang::idx::TranslationUnit*> > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<clang::idx::Entity const, std::pair<clang::FunctionDecl*, clang::idx::TranslationUnit*> > >, std::pair<clang::idx::Entity const, std::pair<clang::FunctionDecl*, clang::idx::TranslationUnit*> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN5clang3idx6EntityESt4pairIKS2_S3_IPNS0_12FunctionDeclEPNS1_15TranslationUnitEEESt10_Select1stISA_ESt4lessIS2_ESaISA_EE16_M_insert_uniqueERKSA_", "std::_Rb_tree<clang::idx::Entity, std::pair<clang::idx::Entity const, std::pair<clang::FunctionDecl*, clang::idx::TranslationUnit*> >, std::_Select1st<std::pair<clang::idx::Entity const, std::pair<clang::FunctionDecl*, clang::idx::TranslationUnit*> > >, std::less<clang::idx::Entity>, std::allocator<std::pair<clang::idx::Entity const, std::pair<clang::FunctionDecl*, clang::idx::TranslationUnit*> > > >::_M_insert_unique(std::pair<clang::idx::Entity const, std::pair<clang::FunctionDecl*, clang::idx::TranslationUnit*> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN5clang3idx6EntityESt4pairIKS2_N4llvm11SmallPtrSetIPNS1_15TranslationUnitELj4EEEESt10_Select1stISA_ESt4lessIS2_ESaISA_EE16_M_insert_uniqueESt17_Rb_tree_iteratorISA_ERKSA_", "std::_Rb_tree<clang::idx::Entity, std::pair<clang::idx::Entity const, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u> >, std::_Select1st<std::pair<clang::idx::Entity const, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u> > >, std::less<clang::idx::Entity>, std::allocator<std::pair<clang::idx::Entity const, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u> > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<clang::idx::Entity const, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u> > >, std::pair<clang::idx::Entity const, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN5clang3idx6EntityESt4pairIKS2_N4llvm11SmallPtrSetIPNS1_15TranslationUnitELj4EEEESt10_Select1stISA_ESt4lessIS2_ESaISA_EE16_M_insert_uniqueERKSA_", "std::_Rb_tree<clang::idx::Entity, std::pair<clang::idx::Entity const, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u> >, std::_Select1st<std::pair<clang::idx::Entity const, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u> > >, std::less<clang::idx::Entity>, std::allocator<std::pair<clang::idx::Entity const, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u> > > >::_M_insert_unique(std::pair<clang::idx::Entity const, llvm::SmallPtrSet<clang::idx::TranslationUnit*, 4u> > const&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_111RewriteObjC26RewriteObjCMethodsMetaDataIN5clang11DeclContext22filtered_decl_iteratorINS2_14ObjCMethodDeclEXadL_ZNKS5_13isClassMethodEvEEEEEEvT_S7_bN4llvm9StringRefES9_RSs", "void (anonymous namespace)::RewriteObjC::RewriteObjCMethodsMetaData<clang::DeclContext::filtered_decl_iterator<clang::ObjCMethodDecl, &(clang::ObjCMethodDecl::isClassMethod() const)> >(clang::DeclContext::filtered_decl_iterator<clang::ObjCMethodDecl, &(clang::ObjCMethodDecl::isClassMethod() const)>, clang::DeclContext::filtered_decl_iterator<clang::ObjCMethodDecl, &(clang::ObjCMethodDecl::isClassMethod() const)>, bool, llvm::StringRef, llvm::StringRef, std::string&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang14ObjCMethodDeclESsNS_12DenseMapInfoIS3_EENS4_ISsEEE16FindAndConstructERKS3_", "llvm::DenseMap<clang::ObjCMethodDecl*, std::string, llvm::DenseMapInfo<clang::ObjCMethodDecl*>, llvm::DenseMapInfo<std::string> >::FindAndConstruct(clang::ObjCMethodDecl* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang14ObjCMethodDeclESsNS_12DenseMapInfoIS3_EENS4_ISsEEE16InsertIntoBucketERKS3_RKSsPSt4pairIS3_SsE", "llvm::DenseMap<clang::ObjCMethodDecl*, std::string, llvm::DenseMapInfo<clang::ObjCMethodDecl*>, llvm::DenseMapInfo<std::string> >::InsertIntoBucket(clang::ObjCMethodDecl* const&, std::string const&, std::pair<clang::ObjCMethodDecl*, std::string>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang14ObjCMethodDeclESsNS_12DenseMapInfoIS3_EENS4_ISsEEE4growEj", "llvm::DenseMap<clang::ObjCMethodDecl*, std::string, llvm::DenseMapInfo<clang::ObjCMethodDecl*>, llvm::DenseMapInfo<std::string> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm15SmallVectorImplIPN5clang14ObjCMethodDeclEE6appendINS1_11DeclContext22filtered_decl_iteratorIS2_XadL_ZNKS2_16isInstanceMethodEvEEEEEEvT_S9_", "void llvm::SmallVectorImpl<clang::ObjCMethodDecl*>::append<clang::DeclContext::filtered_decl_iterator<clang::ObjCMethodDecl, &(clang::ObjCMethodDecl::isInstanceMethod() const)> >(clang::DeclContext::filtered_decl_iterator<clang::ObjCMethodDecl, &(clang::ObjCMethodDecl::isInstanceMethod() const)>, clang::DeclContext::filtered_decl_iterator<clang::ObjCMethodDecl, &(clang::ObjCMethodDecl::isInstanceMethod() const)>)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang9BlockExprESsNS_12DenseMapInfoIS3_EENS4_ISsEEE5clearEv", "llvm::DenseMap<clang::BlockExpr*, std::string, llvm::DenseMapInfo<clang::BlockExpr*>, llvm::DenseMapInfo<std::string> >::clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang9BlockExprESsNS_12DenseMapInfoIS3_EENS4_ISsEEE16shrink_and_clearEv", "llvm::DenseMap<clang::BlockExpr*, std::string, llvm::DenseMapInfo<clang::BlockExpr*>, llvm::DenseMapInfo<std::string> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang9BlockExprESsNS_12DenseMapInfoIS3_EENS4_ISsEEE16FindAndConstructERKS3_", "llvm::DenseMap<clang::BlockExpr*, std::string, llvm::DenseMapInfo<clang::BlockExpr*>, llvm::DenseMapInfo<std::string> >::FindAndConstruct(clang::BlockExpr* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang9BlockExprESsNS_12DenseMapInfoIS3_EENS4_ISsEEE16InsertIntoBucketERKS3_RKSsPSt4pairIS3_SsE", "llvm::DenseMap<clang::BlockExpr*, std::string, llvm::DenseMapInfo<clang::BlockExpr*>, llvm::DenseMapInfo<std::string> >::InsertIntoBucket(clang::BlockExpr* const&, std::string const&, std::pair<clang::BlockExpr*, std::string>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang9BlockExprESsNS_12DenseMapInfoIS3_EENS4_ISsEEE4growEj", "llvm::DenseMap<clang::BlockExpr*, std::string, llvm::DenseMapInfo<clang::BlockExpr*>, llvm::DenseMapInfo<std::string> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang9ValueDeclEjNS_12DenseMapInfoIS3_EENS4_IjEEE16InsertIntoBucketERKS3_RKjPSt4pairIS3_jE", "llvm::DenseMap<clang::ValueDecl*, unsigned int, llvm::DenseMapInfo<clang::ValueDecl*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(clang::ValueDecl* const&, unsigned int const&, std::pair<clang::ValueDecl*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang9ValueDeclEjNS_12DenseMapInfoIS3_EENS4_IjEEE4growEj", "llvm::DenseMap<clang::ValueDecl*, unsigned int, llvm::DenseMapInfo<clang::ValueDecl*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIycNS_12DenseMapInfoIyEENS1_IcEEE6insertERKSt4pairIycE", "llvm::DenseMap<uint64_t, char, llvm::DenseMapInfo<uint64_t>, llvm::DenseMapInfo<char> >::insert(std::pair<uint64_t, char> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIycNS_12DenseMapInfoIyEENS1_IcEEE16InsertIntoBucketERKyRKcPSt4pairIycE", "llvm::DenseMap<uint64_t, char, llvm::DenseMapInfo<uint64_t>, llvm::DenseMapInfo<char> >::InsertIntoBucket(uint64_t const&, char const&, std::pair<uint64_t, char>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIycNS_12DenseMapInfoIyEENS1_IcEEE4growEj", "llvm::DenseMap<uint64_t, char, llvm::DenseMapInfo<uint64_t>, llvm::DenseMapInfo<char> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang4ExprEPNS1_4StmtENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PSt4pairIS3_S5_E", "llvm::DenseMap<clang::Expr*, clang::Stmt*, llvm::DenseMapInfo<clang::Expr*>, llvm::DenseMapInfo<clang::Stmt*> >::InsertIntoBucket(clang::Expr* const&, clang::Stmt* const&, std::pair<clang::Expr*, clang::Stmt*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang4ExprEPNS1_4StmtENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<clang::Expr*, clang::Stmt*, llvm::DenseMapInfo<clang::Expr*>, llvm::DenseMapInfo<clang::Stmt*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang4StmtES3_NS_12DenseMapInfoIS3_EES5_E16InsertIntoBucketERKS3_S8_PSt4pairIS3_S3_E", "llvm::DenseMap<clang::Stmt*, clang::Stmt*, llvm::DenseMapInfo<clang::Stmt*>, llvm::DenseMapInfo<clang::Stmt*> >::InsertIntoBucket(clang::Stmt* const&, clang::Stmt* const&, std::pair<clang::Stmt*, clang::Stmt*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang4StmtES3_NS_12DenseMapInfoIS3_EES5_E4growEj", "llvm::DenseMap<clang::Stmt*, clang::Stmt*, llvm::DenseMapInfo<clang::Stmt*>, llvm::DenseMapInfo<clang::Stmt*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang4ExprEPNS1_14BinaryOperatorENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PSt4pairIS3_S5_E", "llvm::DenseMap<clang::Expr*, clang::BinaryOperator*, llvm::DenseMapInfo<clang::Expr*>, llvm::DenseMapInfo<clang::BinaryOperator*> >::InsertIntoBucket(clang::Expr* const&, clang::BinaryOperator* const&, std::pair<clang::Expr*, clang::BinaryOperator*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang4ExprEPNS1_14BinaryOperatorENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<clang::Expr*, clang::BinaryOperator*, llvm::DenseMapInfo<clang::Expr*>, llvm::DenseMapInfo<clang::BinaryOperator*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN5clang6FileIDESt4pairIKS1_NS0_13RewriteBufferEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE8_M_eraseEPSt13_Rb_tree_nodeIS5_E", "std::_Rb_tree<clang::FileID, std::pair<clang::FileID const, clang::RewriteBuffer>, std::_Select1st<std::pair<clang::FileID const, clang::RewriteBuffer> >, std::less<clang::FileID>, std::allocator<std::pair<clang::FileID const, clang::RewriteBuffer> > >::_M_erase(std::_Rb_tree_node<std::pair<clang::FileID const, clang::RewriteBuffer> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN5clang6FileIDESt4pairIKS1_NS0_13RewriteBufferEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS5_ERKS5_", "std::_Rb_tree<clang::FileID, std::pair<clang::FileID const, clang::RewriteBuffer>, std::_Select1st<std::pair<clang::FileID const, clang::RewriteBuffer> >, std::less<clang::FileID>, std::allocator<std::pair<clang::FileID const, clang::RewriteBuffer> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<clang::FileID const, clang::RewriteBuffer> >, std::pair<clang::FileID const, clang::RewriteBuffer> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN5clang6FileIDESt4pairIKS1_NS0_13RewriteBufferEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE9_M_insertEPSt18_Rb_tree_node_baseSD_RKS5_", "std::_Rb_tree<clang::FileID, std::pair<clang::FileID const, clang::RewriteBuffer>, std::_Select1st<std::pair<clang::FileID const, clang::RewriteBuffer> >, std::less<clang::FileID>, std::allocator<std::pair<clang::FileID const, clang::RewriteBuffer> > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<clang::FileID const, clang::RewriteBuffer> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN5clang6FileIDESt4pairIKS1_NS0_13RewriteBufferEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE16_M_insert_uniqueERKS5_", "std::_Rb_tree<clang::FileID, std::pair<clang::FileID const, clang::RewriteBuffer>, std::_Select1st<std::pair<clang::FileID const, clang::RewriteBuffer> >, std::less<clang::FileID>, std::allocator<std::pair<clang::FileID const, clang::RewriteBuffer> > >::_M_insert_unique(std::pair<clang::FileID const, clang::RewriteBuffer> const&)"),
	mu_demangle_test("_ZN5clang13TokenRewriter8AddTokenERKNS_5TokenESt14_List_iteratorIS1_E", "clang::TokenRewriter::AddToken(clang::Token const&, std::_List_iterator<clang::Token>)"),
	mu_demangle_test("_ZN5clang13TokenRewriter13RemapIteratorESt20_List_const_iteratorINS_5TokenEE", "clang::TokenRewriter::RemapIterator(std::_List_const_iterator<clang::Token>)"),
	mu_demangle_test("_ZN5clang13TokenRewriter14AddTokenBeforeESt20_List_const_iteratorINS_5TokenEEPKc", "clang::TokenRewriter::AddTokenBefore(std::_List_const_iterator<clang::Token>, char const*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN5clang14SourceLocationESt4pairIKS1_St14_List_iteratorINS0_5TokenEEESt10_Select1stIS7_ESt4lessIS1_ESaIS7_EE16_M_insert_uniqueERKS7_", "std::_Rb_tree<clang::SourceLocation, std::pair<clang::SourceLocation const, std::_List_iterator<clang::Token> >, std::_Select1st<std::pair<clang::SourceLocation const, std::_List_iterator<clang::Token> > >, std::less<clang::SourceLocation>, std::allocator<std::pair<clang::SourceLocation const, std::_List_iterator<clang::Token> > > >::_M_insert_unique(std::pair<clang::SourceLocation const, std::_List_iterator<clang::Token> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN5clang14SourceLocationESt4pairIKS1_St14_List_iteratorINS0_5TokenEEESt10_Select1stIS7_ESt4lessIS1_ESaIS7_EE8_M_eraseEPSt13_Rb_tree_nodeIS7_E", "std::_Rb_tree<clang::SourceLocation, std::pair<clang::SourceLocation const, std::_List_iterator<clang::Token> >, std::_Select1st<std::pair<clang::SourceLocation const, std::_List_iterator<clang::Token> > >, std::less<clang::SourceLocation>, std::allocator<std::pair<clang::SourceLocation const, std::_List_iterator<clang::Token> > > >::_M_erase(std::_Rb_tree_node<std::pair<clang::SourceLocation const, std::_List_iterator<clang::Token> > >*)"),
	mu_demangle_test("_ZNSt6vectorIPN5clang17VariableArrayTypeESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<clang::VariableArrayType*, std::allocator<clang::VariableArrayType*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::VariableArrayType**, std::vector<clang::VariableArrayType*, std::allocator<clang::VariableArrayType*> > >, clang::VariableArrayType* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang7VarDeclEPNS1_4ExprENS_12DenseMapInfoIS4_EENS7_IS6_EEE16InsertIntoBucketERKS4_RKS6_PSt4pairIS4_S6_E", "llvm::DenseMap<clang::VarDecl const*, clang::Expr*, llvm::DenseMapInfo<clang::VarDecl const*>, llvm::DenseMapInfo<clang::Expr*> >::InsertIntoBucket(clang::VarDecl const* const&, clang::Expr* const&, std::pair<clang::VarDecl const*, clang::Expr*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang7VarDeclEPNS1_4ExprENS_12DenseMapInfoIS4_EENS7_IS6_EEE4growEj", "llvm::DenseMap<clang::VarDecl const*, clang::Expr*, llvm::DenseMapInfo<clang::VarDecl const*>, llvm::DenseMapInfo<clang::Expr*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang17ObjCContainerDeclEPNS1_12ObjCImplDeclENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PSt4pairIS3_S5_E", "llvm::DenseMap<clang::ObjCContainerDecl*, clang::ObjCImplDecl*, llvm::DenseMapInfo<clang::ObjCContainerDecl*>, llvm::DenseMapInfo<clang::ObjCImplDecl*> >::InsertIntoBucket(clang::ObjCContainerDecl* const&, clang::ObjCImplDecl* const&, std::pair<clang::ObjCContainerDecl*, clang::ObjCImplDecl*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang17ObjCContainerDeclEPNS1_12ObjCImplDeclENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<clang::ObjCContainerDecl*, clang::ObjCImplDecl*, llvm::DenseMapInfo<clang::ObjCContainerDecl*>, llvm::DenseMapInfo<clang::ObjCImplDecl*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIPKN5clang13CXXMethodDeclESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<clang::CXXMethodDecl const*, std::allocator<clang::CXXMethodDecl const*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::CXXMethodDecl const**, std::vector<clang::CXXMethodDecl const*, std::allocator<clang::CXXMethodDecl const*> > >, clang::CXXMethodDecl const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXMethodDeclENS1_20UsuallyTinyPtrVectorIS3_EENS_12DenseMapInfoIS4_EENS7_IS6_EEE16InsertIntoBucketERKS4_RKS6_PSt4pairIS4_S6_E", "llvm::DenseMap<clang::CXXMethodDecl const*, clang::UsuallyTinyPtrVector<clang::CXXMethodDecl const>, llvm::DenseMapInfo<clang::CXXMethodDecl const*>, llvm::DenseMapInfo<clang::UsuallyTinyPtrVector<clang::CXXMethodDecl const> > >::InsertIntoBucket(clang::CXXMethodDecl const* const&, clang::UsuallyTinyPtrVector<clang::CXXMethodDecl const> const&, std::pair<clang::CXXMethodDecl const*, clang::UsuallyTinyPtrVector<clang::CXXMethodDecl const> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXMethodDeclENS1_20UsuallyTinyPtrVectorIS3_EENS_12DenseMapInfoIS4_EENS7_IS6_EEE4growEj", "llvm::DenseMap<clang::CXXMethodDecl const*, clang::UsuallyTinyPtrVector<clang::CXXMethodDecl const>, llvm::DenseMapInfo<clang::CXXMethodDecl const*>, llvm::DenseMapInfo<clang::UsuallyTinyPtrVector<clang::CXXMethodDecl const> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang9FieldDeclES3_NS_12DenseMapInfoIS3_EES5_E16InsertIntoBucketERKS3_S8_PSt4pairIS3_S3_E", "llvm::DenseMap<clang::FieldDecl*, clang::FieldDecl*, llvm::DenseMapInfo<clang::FieldDecl*>, llvm::DenseMapInfo<clang::FieldDecl*> >::InsertIntoBucket(clang::FieldDecl* const&, clang::FieldDecl* const&, std::pair<clang::FieldDecl*, clang::FieldDecl*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang9FieldDeclES3_NS_12DenseMapInfoIS3_EES5_E4growEj", "llvm::DenseMap<clang::FieldDecl*, clang::FieldDecl*, llvm::DenseMapInfo<clang::FieldDecl*>, llvm::DenseMapInfo<clang::FieldDecl*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang15UsingShadowDeclES3_NS_12DenseMapInfoIS3_EES5_E16InsertIntoBucketERKS3_S8_PSt4pairIS3_S3_E", "llvm::DenseMap<clang::UsingShadowDecl*, clang::UsingShadowDecl*, llvm::DenseMapInfo<clang::UsingShadowDecl*>, llvm::DenseMapInfo<clang::UsingShadowDecl*> >::InsertIntoBucket(clang::UsingShadowDecl* const&, clang::UsingShadowDecl* const&, std::pair<clang::UsingShadowDecl*, clang::UsingShadowDecl*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang15UsingShadowDeclES3_NS_12DenseMapInfoIS3_EES5_E4growEj", "llvm::DenseMap<clang::UsingShadowDecl*, clang::UsingShadowDecl*, llvm::DenseMapInfo<clang::UsingShadowDecl*>, llvm::DenseMapInfo<clang::UsingShadowDecl*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang9UsingDeclEPNS1_9NamedDeclENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PSt4pairIS3_S5_E", "llvm::DenseMap<clang::UsingDecl*, clang::NamedDecl*, llvm::DenseMapInfo<clang::UsingDecl*>, llvm::DenseMapInfo<clang::NamedDecl*> >::InsertIntoBucket(clang::UsingDecl* const&, clang::NamedDecl* const&, std::pair<clang::UsingDecl*, clang::NamedDecl*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang9UsingDeclEPNS1_9NamedDeclENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<clang::UsingDecl*, clang::NamedDecl*, llvm::DenseMapInfo<clang::UsingDecl*>, llvm::DenseMapInfo<clang::NamedDecl*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang7VarDeclEPNS1_24MemberSpecializationInfoENS_12DenseMapInfoIS4_EENS7_IS6_EEE16InsertIntoBucketERKS4_RKS6_PSt4pairIS4_S6_E", "llvm::DenseMap<clang::VarDecl const*, clang::MemberSpecializationInfo*, llvm::DenseMapInfo<clang::VarDecl const*>, llvm::DenseMapInfo<clang::MemberSpecializationInfo*> >::InsertIntoBucket(clang::VarDecl const* const&, clang::MemberSpecializationInfo* const&, std::pair<clang::VarDecl const*, clang::MemberSpecializationInfo*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang7VarDeclEPNS1_24MemberSpecializationInfoENS_12DenseMapInfoIS4_EENS7_IS6_EEE4growEj", "llvm::DenseMap<clang::VarDecl const*, clang::MemberSpecializationInfo*, llvm::DenseMapInfo<clang::VarDecl const*>, llvm::DenseMapInfo<clang::MemberSpecializationInfo*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4DeclEPNS_11SmallVectorIPNS1_4AttrELj2EEENS_12DenseMapInfoIS4_EENSA_IS9_EEE16InsertIntoBucketERKS4_RKS9_PSt4pairIS4_S9_E", "llvm::DenseMap<clang::Decl const*, llvm::SmallVector<clang::Attr*, 2u>*, llvm::DenseMapInfo<clang::Decl const*>, llvm::DenseMapInfo<llvm::SmallVector<clang::Attr*, 2u>*> >::InsertIntoBucket(clang::Decl const* const&, llvm::SmallVector<clang::Attr*, 2u>* const&, std::pair<clang::Decl const*, llvm::SmallVector<clang::Attr*, 2u>*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4DeclEPNS_11SmallVectorIPNS1_4AttrELj2EEENS_12DenseMapInfoIS4_EENSA_IS9_EEE4growEj", "llvm::DenseMap<clang::Decl const*, llvm::SmallVector<clang::Attr*, 2u>*, llvm::DenseMapInfo<clang::Decl const*>, llvm::DenseMapInfo<llvm::SmallVector<clang::Attr*, 2u>*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIPN5clang4TypeESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<clang::Type*, std::allocator<clang::Type*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::Type**, std::vector<clang::Type*, std::allocator<clang::Type*> > >, clang::Type* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang6FileIDES2_NS_12DenseMapInfoIS2_EES4_E16InsertIntoBucketERKS2_S7_PSt4pairIS2_S2_E", "llvm::DenseMap<clang::FileID, clang::FileID, llvm::DenseMapInfo<clang::FileID>, llvm::DenseMapInfo<clang::FileID> >::InsertIntoBucket(clang::FileID const&, clang::FileID const&, std::pair<clang::FileID, clang::FileID>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang6FileIDES2_NS_12DenseMapInfoIS2_EES4_E4growEj", "llvm::DenseMap<clang::FileID, clang::FileID, llvm::DenseMapInfo<clang::FileID>, llvm::DenseMapInfo<clang::FileID> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPN5clang4DeclES4_EcNS_12DenseMapInfoIS5_EENS6_IcEEE6insertERKS1_IS5_cE", "llvm::DenseMap<std::pair<clang::Decl*, clang::Decl*>, char, llvm::DenseMapInfo<std::pair<clang::Decl*, clang::Decl*> >, llvm::DenseMapInfo<char> >::insert(std::pair<std::pair<clang::Decl*, clang::Decl*>, char> const&)"),
	mu_demangle_test("_ZNK4llvm8DenseMapISt4pairIPN5clang4DeclES4_EcNS_12DenseMapInfoIS5_EENS6_IcEEE15LookupBucketForERKS5_RPS1_IS5_cE", "llvm::DenseMap<std::pair<clang::Decl*, clang::Decl*>, char, llvm::DenseMapInfo<std::pair<clang::Decl*, clang::Decl*> >, llvm::DenseMapInfo<char> >::LookupBucketFor(std::pair<clang::Decl*, clang::Decl*> const&, std::pair<std::pair<clang::Decl*, clang::Decl*>, char>*&) const"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPN5clang4DeclES4_EcNS_12DenseMapInfoIS5_EENS6_IcEEE16InsertIntoBucketERKS5_RKcPS1_IS5_cE", "llvm::DenseMap<std::pair<clang::Decl*, clang::Decl*>, char, llvm::DenseMapInfo<std::pair<clang::Decl*, clang::Decl*> >, llvm::DenseMapInfo<char> >::InsertIntoBucket(std::pair<clang::Decl*, clang::Decl*> const&, char const&, std::pair<std::pair<clang::Decl*, clang::Decl*>, char>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPN5clang4DeclES4_EcNS_12DenseMapInfoIS5_EENS6_IcEEE4growEj", "llvm::DenseMap<std::pair<clang::Decl*, clang::Decl*>, char, llvm::DenseMapInfo<std::pair<clang::Decl*, clang::Decl*> >, llvm::DenseMapInfo<char> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt5dequeIPN5clang4DeclESaIS2_EE9push_backERKS2_", "std::deque<clang::Decl*, std::allocator<clang::Decl*> >::push_back(clang::Decl* const&)"),
	mu_demangle_test("_ZNSt5dequeIPN5clang4DeclESaIS2_EE17_M_reallocate_mapEmb", "std::deque<clang::Decl*, std::allocator<clang::Decl*> >::_M_reallocate_map(unsigned long, bool)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4TypeES4_NS_12DenseMapInfoIS4_EES6_E16InsertIntoBucketERKS4_S9_PSt4pairIS4_S4_E", "llvm::DenseMap<clang::Type const*, clang::Type const*, llvm::DenseMapInfo<clang::Type const*>, llvm::DenseMapInfo<clang::Type const*> >::InsertIntoBucket(clang::Type const* const&, clang::Type const* const&, std::pair<clang::Type const*, clang::Type const*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang4TypeES4_NS_12DenseMapInfoIS4_EES6_E4growEj", "llvm::DenseMap<clang::Type const*, clang::Type const*, llvm::DenseMapInfo<clang::Type const*>, llvm::DenseMapInfo<clang::Type const*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang4DeclES3_NS_12DenseMapInfoIS3_EES5_E16InsertIntoBucketERKS3_S8_PSt4pairIS3_S3_E", "llvm::DenseMap<clang::Decl*, clang::Decl*, llvm::DenseMapInfo<clang::Decl*>, llvm::DenseMapInfo<clang::Decl*> >::InsertIntoBucket(clang::Decl* const&, clang::Decl* const&, std::pair<clang::Decl*, clang::Decl*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang4DeclES3_NS_12DenseMapInfoIS3_EES5_E4growEj", "llvm::DenseMap<clang::Decl*, clang::Decl*, llvm::DenseMapInfo<clang::Decl*>, llvm::DenseMapInfo<clang::Decl*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjNS_11SmallVectorIN5clang19UniqueVirtualMethodELj4EEENS_12DenseMapInfoIjEENS5_IS4_EEE16FindAndConstructERKj", "llvm::DenseMap<unsigned int, llvm::SmallVector<clang::UniqueVirtualMethod, 4u>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::SmallVector<clang::UniqueVirtualMethod, 4u> > >::FindAndConstruct(unsigned int const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjNS_11SmallVectorIN5clang19UniqueVirtualMethodELj4EEENS_12DenseMapInfoIjEENS5_IS4_EEE16InsertIntoBucketERKjRKS4_PSt4pairIjS4_E", "llvm::DenseMap<unsigned int, llvm::SmallVector<clang::UniqueVirtualMethod, 4u>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::SmallVector<clang::UniqueVirtualMethod, 4u> > >::InsertIntoBucket(unsigned int const&, llvm::SmallVector<clang::UniqueVirtualMethod, 4u> const&, std::pair<unsigned int, llvm::SmallVector<clang::UniqueVirtualMethod, 4u> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjNS_11SmallVectorIN5clang19UniqueVirtualMethodELj4EEENS_12DenseMapInfoIjEENS5_IS4_EEE4growEj", "llvm::DenseMap<unsigned int, llvm::SmallVector<clang::UniqueVirtualMethod, 4u>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::SmallVector<clang::UniqueVirtualMethod, 4u> > >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN5clang8QualTypeESt4pairIKS1_S2_IbjEESt10_Select1stIS5_ENS0_16QualTypeOrderingESaIS5_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS5_ERKS5_", "std::_Rb_tree<clang::QualType, std::pair<clang::QualType const, std::pair<bool, unsigned int> >, std::_Select1st<std::pair<clang::QualType const, std::pair<bool, unsigned int> > >, clang::QualTypeOrdering, std::allocator<std::pair<clang::QualType const, std::pair<bool, unsigned int> > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<clang::QualType const, std::pair<bool, unsigned int> > >, std::pair<clang::QualType const, std::pair<bool, unsigned int> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN5clang8QualTypeESt4pairIKS1_S2_IbjEESt10_Select1stIS5_ENS0_16QualTypeOrderingESaIS5_EE16_M_insert_uniqueERKS5_", "std::_Rb_tree<clang::QualType, std::pair<clang::QualType const, std::pair<bool, unsigned int> >, std::_Select1st<std::pair<clang::QualType const, std::pair<bool, unsigned int> > >, clang::QualTypeOrdering, std::allocator<std::pair<clang::QualType const, std::pair<bool, unsigned int> > > >::_M_insert_unique(std::pair<clang::QualType const, std::pair<bool, unsigned int> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN5clang9NamedDeclES2_St9_IdentityIS2_ESt4lessIS2_ESaIS2_EE16_M_insert_uniqueERKS2_", "std::_Rb_tree<clang::NamedDecl*, clang::NamedDecl*, std::_Identity<clang::NamedDecl*>, std::less<clang::NamedDecl*>, std::allocator<clang::NamedDecl*> >::_M_insert_unique(clang::NamedDecl* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXMethodDeclENS1_17OverridingMethodsENS_12DenseMapInfoIS4_EENS6_IS5_EEE16FindAndConstructERKS4_", "llvm::DenseMap<clang::CXXMethodDecl const*, clang::OverridingMethods, llvm::DenseMapInfo<clang::CXXMethodDecl const*>, llvm::DenseMapInfo<clang::OverridingMethods> >::FindAndConstruct(clang::CXXMethodDecl const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXMethodDeclENS1_17OverridingMethodsENS_12DenseMapInfoIS4_EENS6_IS5_EEE16InsertIntoBucketERKS4_RKS5_PSt4pairIS4_S5_E", "llvm::DenseMap<clang::CXXMethodDecl const*, clang::OverridingMethods, llvm::DenseMapInfo<clang::CXXMethodDecl const*>, llvm::DenseMapInfo<clang::OverridingMethods> >::InsertIntoBucket(clang::CXXMethodDecl const* const&, clang::OverridingMethods const&, std::pair<clang::CXXMethodDecl const*, clang::OverridingMethods>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXMethodDeclENS1_17OverridingMethodsENS_12DenseMapInfoIS4_EENS6_IS5_EEE4growEj", "llvm::DenseMap<clang::CXXMethodDecl const*, clang::OverridingMethods, llvm::DenseMapInfo<clang::CXXMethodDecl const*>, llvm::DenseMapInfo<clang::OverridingMethods> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjNS_11SmallVectorIN5clang19UniqueVirtualMethodELj4EEENS_12DenseMapInfoIjEENS5_IS4_EEE8CopyFromERKS8_", "llvm::DenseMap<unsigned int, llvm::SmallVector<clang::UniqueVirtualMethod, 4u>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::SmallVector<clang::UniqueVirtualMethod, 4u> > >::CopyFrom(llvm::DenseMap<unsigned int, llvm::SmallVector<clang::UniqueVirtualMethod, 4u>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::SmallVector<clang::UniqueVirtualMethod, 4u> > > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclEPNS1_20CXXFinalOverriderMapENS_12DenseMapInfoIS4_EENS7_IS6_EEE16InsertIntoBucketERKS4_RKS6_PSt4pairIS4_S6_E", "llvm::DenseMap<clang::CXXRecordDecl const*, clang::CXXFinalOverriderMap*, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<clang::CXXFinalOverriderMap*> >::InsertIntoBucket(clang::CXXRecordDecl const* const&, clang::CXXFinalOverriderMap* const&, std::pair<clang::CXXRecordDecl const*, clang::CXXFinalOverriderMap*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclEPNS1_20CXXFinalOverriderMapENS_12DenseMapInfoIS4_EENS7_IS6_EEE4growEj", "llvm::DenseMap<clang::CXXRecordDecl const*, clang::CXXFinalOverriderMap*, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<clang::CXXFinalOverriderMap*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclEjNS_12DenseMapInfoIS4_EENS5_IjEEE16InsertIntoBucketERKS4_RKjPSt4pairIS4_jE", "llvm::DenseMap<clang::CXXRecordDecl const*, unsigned int, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(clang::CXXRecordDecl const* const&, unsigned int const&, std::pair<clang::CXXRecordDecl const*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclEjNS_12DenseMapInfoIS4_EENS5_IjEEE4growEj", "llvm::DenseMap<clang::CXXRecordDecl const*, unsigned int, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN5clang9NamedDeclES2_St9_IdentityIS2_ESt4lessIS2_ESaIS2_EE8_M_eraseEPSt13_Rb_tree_nodeIS2_E", "std::_Rb_tree<clang::NamedDecl*, clang::NamedDecl*, std::_Identity<clang::NamedDecl*>, std::less<clang::NamedDecl*>, std::allocator<clang::NamedDecl*> >::_M_erase(std::_Rb_tree_node<clang::NamedDecl*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang15DeclarationNameENS1_15StoredDeclsListENS_12DenseMapInfoIS2_EENS4_IS3_EEE16FindAndConstructERKS2_", "llvm::DenseMap<clang::DeclarationName, clang::StoredDeclsList, llvm::DenseMapInfo<clang::DeclarationName>, llvm::DenseMapInfo<clang::StoredDeclsList> >::FindAndConstruct(clang::DeclarationName const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang15DeclarationNameENS1_15StoredDeclsListENS_12DenseMapInfoIS2_EENS4_IS3_EEE16InsertIntoBucketERKS2_RKS3_PSt4pairIS2_S3_E", "llvm::DenseMap<clang::DeclarationName, clang::StoredDeclsList, llvm::DenseMapInfo<clang::DeclarationName>, llvm::DenseMapInfo<clang::StoredDeclsList> >::InsertIntoBucket(clang::DeclarationName const&, clang::StoredDeclsList const&, std::pair<clang::DeclarationName, clang::StoredDeclsList>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang15DeclarationNameENS1_15StoredDeclsListENS_12DenseMapInfoIS2_EENS4_IS3_EEE4growEj", "llvm::DenseMap<clang::DeclarationName, clang::StoredDeclsList, llvm::DenseMapInfo<clang::DeclarationName>, llvm::DenseMapInfo<clang::StoredDeclsList> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang15DeclarationNameENS1_15StoredDeclsListENS_12DenseMapInfoIS2_EENS4_IS3_EEED2Ev", "llvm::DenseMap<clang::DeclarationName, clang::StoredDeclsList, llvm::DenseMapInfo<clang::DeclarationName>, llvm::DenseMapInfo<clang::StoredDeclsList> >::~DenseMap()"),
	mu_demangle_test("_Z30GetBestOverloadCandidateSimpleRKN4llvm15SmallVectorImplISt4pairIPN5clang13CXXMethodDeclENS2_10QualifiersEEEE", "GetBestOverloadCandidateSimple(llvm::SmallVectorImpl<std::pair<clang::CXXMethodDecl*, clang::Qualifiers> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXMethodDeclENS1_17OverridingMethodsENS_12DenseMapInfoIS4_EENS6_IS5_EEED2Ev", "llvm::DenseMap<clang::CXXMethodDecl const*, clang::OverridingMethods, llvm::DenseMapInfo<clang::CXXMethodDecl const*>, llvm::DenseMapInfo<clang::OverridingMethods> >::~DenseMap()"),
	mu_demangle_test("_ZNSt8_Rb_treeIN5clang8QualTypeESt4pairIKS1_iESt10_Select1stIS4_ENS0_16QualTypeOrderingESaIS4_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS4_ERKS4_", "std::_Rb_tree<clang::QualType, std::pair<clang::QualType const, int>, std::_Select1st<std::pair<clang::QualType const, int> >, clang::QualTypeOrdering, std::allocator<std::pair<clang::QualType const, int> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<clang::QualType const, int> >, std::pair<clang::QualType const, int> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN5clang8QualTypeESt4pairIKS1_iESt10_Select1stIS4_ENS0_16QualTypeOrderingESaIS4_EE16_M_insert_uniqueERKS4_", "std::_Rb_tree<clang::QualType, std::pair<clang::QualType const, int>, std::_Select1st<std::pair<clang::QualType const, int> >, clang::QualTypeOrdering, std::allocator<std::pair<clang::QualType const, int> > >::_M_insert_unique(std::pair<clang::QualType const, int> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN5clang8QualTypeES1_St9_IdentityIS1_ENS0_16QualTypeOrderingESaIS1_EE16_M_insert_uniqueERKS1_", "std::_Rb_tree<clang::QualType, clang::QualType, std::_Identity<clang::QualType>, clang::QualTypeOrdering, std::allocator<clang::QualType> >::_M_insert_unique(clang::QualType const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN5clang8QualTypeESt4pairIKS1_iESt10_Select1stIS4_ENS0_16QualTypeOrderingESaIS4_EE8_M_eraseEPSt13_Rb_tree_nodeIS4_E", "std::_Rb_tree<clang::QualType, std::pair<clang::QualType const, int>, std::_Select1st<std::pair<clang::QualType const, int> >, clang::QualTypeOrdering, std::allocator<std::pair<clang::QualType const, int> > >::_M_erase(std::_Rb_tree_node<std::pair<clang::QualType const, int> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN5clang8QualTypeES1_St9_IdentityIS1_ENS0_16QualTypeOrderingESaIS1_EE8_M_eraseEPSt13_Rb_tree_nodeIS1_E", "std::_Rb_tree<clang::QualType, clang::QualType, std::_Identity<clang::QualType>, clang::QualTypeOrdering, std::allocator<clang::QualType> >::_M_erase(std::_Rb_tree_node<clang::QualType>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapImjNS_12DenseMapInfoImEENS1_IjEEE16InsertIntoBucketERKmRKjPSt4pairImjE", "llvm::DenseMap<unsigned long, unsigned int, llvm::DenseMapInfo<unsigned long>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(unsigned long const&, unsigned int const&, std::pair<unsigned long, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapImjNS_12DenseMapInfoImEENS1_IjEEE4growEj", "llvm::DenseMap<unsigned long, unsigned int, llvm::DenseMapInfo<unsigned long>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang7TagDeclEyNS_12DenseMapInfoIS4_EENS5_IyEEE6insertERKSt4pairIS4_yE", "llvm::DenseMap<clang::TagDecl const*, uint64_t, llvm::DenseMapInfo<clang::TagDecl const*>, llvm::DenseMapInfo<uint64_t> >::insert(std::pair<clang::TagDecl const*, uint64_t> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang7TagDeclEyNS_12DenseMapInfoIS4_EENS5_IyEEE16InsertIntoBucketERKS4_RKyPSt4pairIS4_yE", "llvm::DenseMap<clang::TagDecl const*, uint64_t, llvm::DenseMapInfo<clang::TagDecl const*>, llvm::DenseMapInfo<uint64_t> >::InsertIntoBucket(clang::TagDecl const* const&, uint64_t const&, std::pair<clang::TagDecl const*, uint64_t>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang7TagDeclEyNS_12DenseMapInfoIS4_EENS5_IyEEE4growEj", "llvm::DenseMap<clang::TagDecl const*, uint64_t, llvm::DenseMapInfo<clang::TagDecl const*>, llvm::DenseMapInfo<uint64_t> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang9NamedDeclEjNS_12DenseMapInfoIS4_EENS5_IjEEE16InsertIntoBucketERKS4_RKjPSt4pairIS4_jE", "llvm::DenseMap<clang::NamedDecl const*, unsigned int, llvm::DenseMapInfo<clang::NamedDecl const*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(clang::NamedDecl const* const&, unsigned int const&, std::pair<clang::NamedDecl const*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang9NamedDeclEjNS_12DenseMapInfoIS4_EENS5_IjEEE4growEj", "llvm::DenseMap<clang::NamedDecl const*, unsigned int, llvm::DenseMapInfo<clang::NamedDecl const*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang9BlockDeclEjNS_12DenseMapInfoIS4_EENS5_IjEEE16shrink_and_clearEv", "llvm::DenseMap<clang::BlockDecl const*, unsigned int, llvm::DenseMapInfo<clang::BlockDecl const*>, llvm::DenseMapInfo<unsigned int> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang9BlockDeclEjNS_12DenseMapInfoIS4_EENS5_IjEEE6insertERKSt4pairIS4_jE", "llvm::DenseMap<clang::BlockDecl const*, unsigned int, llvm::DenseMapInfo<clang::BlockDecl const*>, llvm::DenseMapInfo<unsigned int> >::insert(std::pair<clang::BlockDecl const*, unsigned int> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang9BlockDeclEjNS_12DenseMapInfoIS4_EENS5_IjEEE16InsertIntoBucketERKS4_RKjPSt4pairIS4_jE", "llvm::DenseMap<clang::BlockDecl const*, unsigned int, llvm::DenseMapInfo<clang::BlockDecl const*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(clang::BlockDecl const* const&, unsigned int const&, std::pair<clang::BlockDecl const*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang9BlockDeclEjNS_12DenseMapInfoIS4_EENS5_IjEEE4growEj", "llvm::DenseMap<clang::BlockDecl const*, unsigned int, llvm::DenseMapInfo<clang::BlockDecl const*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_Z14BuildParentMapRN4llvm8DenseMapIPN5clang4StmtES3_NS_12DenseMapInfoIS3_EES5_EES3_", "BuildParentMap(llvm::DenseMap<clang::Stmt*, clang::Stmt*, llvm::DenseMapInfo<clang::Stmt*>, llvm::DenseMapInfo<clang::Stmt*> >&, clang::Stmt*)"),
	mu_demangle_test("_ZN5clang15ASTRecordLayoutC1ERKNS_10ASTContextENS_9CharUnitsEjyPKyjS4_S4_S4_PKNS_13CXXRecordDeclEbRKN4llvm8DenseMapIS9_S4_NSA_12DenseMapInfoIS9_EENSC_IS4_EEEESH_", "clang::ASTRecordLayout::ASTRecordLayout(clang::ASTContext const&, clang::CharUnits, unsigned int, uint64_t, uint64_t const*, unsigned int, clang::CharUnits, clang::CharUnits, clang::CharUnits, clang::CXXRecordDecl const*, bool, llvm::DenseMap<clang::CXXRecordDecl const*, clang::CharUnits, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<clang::CharUnits> > const&, llvm::DenseMap<clang::CXXRecordDecl const*, clang::CharUnits, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<clang::CharUnits> > const&)"),
	mu_demangle_test("_ZN5clang15ASTRecordLayoutC2ERKNS_10ASTContextENS_9CharUnitsEjyPKyjS4_S4_S4_PKNS_13CXXRecordDeclEbRKN4llvm8DenseMapIS9_S4_NSA_12DenseMapInfoIS9_EENSC_IS4_EEEESH_", "clang::ASTRecordLayout::ASTRecordLayout(clang::ASTContext const&, clang::CharUnits, unsigned int, uint64_t, uint64_t const*, unsigned int, clang::CharUnits, clang::CharUnits, clang::CharUnits, clang::CXXRecordDecl const*, bool, llvm::DenseMap<clang::CXXRecordDecl const*, clang::CharUnits, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<clang::CharUnits> > const&, llvm::DenseMap<clang::CXXRecordDecl const*, clang::CharUnits, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<clang::CharUnits> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclENS1_9CharUnitsENS_12DenseMapInfoIS4_EENS6_IS5_EEE8CopyFromERKS9_", "llvm::DenseMap<clang::CXXRecordDecl const*, clang::CharUnits, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<clang::CharUnits> >::CopyFrom(llvm::DenseMap<clang::CXXRecordDecl const*, clang::CharUnits, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<clang::CharUnits> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclEPN12_GLOBAL__N_117BaseSubobjectInfoENS_12DenseMapInfoIS4_EENS8_IS7_EEE16InsertIntoBucketERKS4_RKS7_PSt4pairIS4_S7_E", "llvm::DenseMap<clang::CXXRecordDecl const*, (anonymous namespace)::BaseSubobjectInfo*, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<(anonymous namespace)::BaseSubobjectInfo*> >::InsertIntoBucket(clang::CXXRecordDecl const* const&, (anonymous namespace)::BaseSubobjectInfo* const&, std::pair<clang::CXXRecordDecl const*, (anonymous namespace)::BaseSubobjectInfo*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclEPKNS1_13CXXMethodDeclENS_12DenseMapInfoIS4_EENS8_IS7_EEE16InsertIntoBucketERKS4_RKS7_PSt4pairIS4_S7_E", "llvm::DenseMap<clang::CXXRecordDecl const*, clang::CXXMethodDecl const*, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<clang::CXXMethodDecl const*> >::InsertIntoBucket(clang::CXXRecordDecl const* const&, clang::CXXMethodDecl const* const&, std::pair<clang::CXXRecordDecl const*, clang::CXXMethodDecl const*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclEPKNS1_13CXXMethodDeclENS_12DenseMapInfoIS4_EENS8_IS7_EEE4growEj", "llvm::DenseMap<clang::CXXRecordDecl const*, clang::CXXMethodDecl const*, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<clang::CXXMethodDecl const*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang10RecordDeclEPKNS1_15ASTRecordLayoutENS_12DenseMapInfoIS4_EENS8_IS7_EEE16InsertIntoBucketERKS4_RKS7_PSt4pairIS4_S7_E", "llvm::DenseMap<clang::RecordDecl const*, clang::ASTRecordLayout const*, llvm::DenseMapInfo<clang::RecordDecl const*>, llvm::DenseMapInfo<clang::ASTRecordLayout const*> >::InsertIntoBucket(clang::RecordDecl const* const&, clang::ASTRecordLayout const* const&, std::pair<clang::RecordDecl const*, clang::ASTRecordLayout const*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang10RecordDeclEPKNS1_15ASTRecordLayoutENS_12DenseMapInfoIS4_EENS8_IS7_EEE4growEj", "llvm::DenseMap<clang::RecordDecl const*, clang::ASTRecordLayout const*, llvm::DenseMapInfo<clang::RecordDecl const*>, llvm::DenseMapInfo<clang::ASTRecordLayout const*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang17ObjCContainerDeclEPKNS1_15ASTRecordLayoutENS_12DenseMapInfoIS4_EENS8_IS7_EEE16InsertIntoBucketERKS4_RKS7_PSt4pairIS4_S7_E", "llvm::DenseMap<clang::ObjCContainerDecl const*, clang::ASTRecordLayout const*, llvm::DenseMapInfo<clang::ObjCContainerDecl const*>, llvm::DenseMapInfo<clang::ASTRecordLayout const*> >::InsertIntoBucket(clang::ObjCContainerDecl const* const&, clang::ASTRecordLayout const* const&, std::pair<clang::ObjCContainerDecl const*, clang::ASTRecordLayout const*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang17ObjCContainerDeclEPKNS1_15ASTRecordLayoutENS_12DenseMapInfoIS4_EENS8_IS7_EEE4growEj", "llvm::DenseMap<clang::ObjCContainerDecl const*, clang::ASTRecordLayout const*, llvm::DenseMapInfo<clang::ObjCContainerDecl const*>, llvm::DenseMapInfo<clang::ASTRecordLayout const*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclENS1_9CharUnitsENS_12DenseMapInfoIS4_EENS6_IS5_EEE16InsertIntoBucketERKS4_RKS5_PSt4pairIS4_S5_E", "llvm::DenseMap<clang::CXXRecordDecl const*, clang::CharUnits, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<clang::CharUnits> >::InsertIntoBucket(clang::CXXRecordDecl const* const&, clang::CharUnits const&, std::pair<clang::CXXRecordDecl const*, clang::CharUnits>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclENS1_9CharUnitsENS_12DenseMapInfoIS4_EENS6_IS5_EEE4growEj", "llvm::DenseMap<clang::CXXRecordDecl const*, clang::CharUnits, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<clang::CharUnits> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang9CharUnitsENS_11SmallVectorIPKNS1_13CXXRecordDeclELj1EEENS_12DenseMapInfoIS2_EENS8_IS7_EEE16FindAndConstructERKS2_", "llvm::DenseMap<clang::CharUnits, llvm::SmallVector<clang::CXXRecordDecl const*, 1u>, llvm::DenseMapInfo<clang::CharUnits>, llvm::DenseMapInfo<llvm::SmallVector<clang::CXXRecordDecl const*, 1u> > >::FindAndConstruct(clang::CharUnits const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang9CharUnitsENS_11SmallVectorIPKNS1_13CXXRecordDeclELj1EEENS_12DenseMapInfoIS2_EENS8_IS7_EEE16InsertIntoBucketERKS2_RKS7_PSt4pairIS2_S7_E", "llvm::DenseMap<clang::CharUnits, llvm::SmallVector<clang::CXXRecordDecl const*, 1u>, llvm::DenseMapInfo<clang::CharUnits>, llvm::DenseMapInfo<llvm::SmallVector<clang::CXXRecordDecl const*, 1u> > >::InsertIntoBucket(clang::CharUnits const&, llvm::SmallVector<clang::CXXRecordDecl const*, 1u> const&, std::pair<clang::CharUnits, llvm::SmallVector<clang::CXXRecordDecl const*, 1u> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN5clang9CharUnitsENS_11SmallVectorIPKNS1_13CXXRecordDeclELj1EEENS_12DenseMapInfoIS2_EENS8_IS7_EEE4growEj", "llvm::DenseMap<clang::CharUnits, llvm::SmallVector<clang::CXXRecordDecl const*, 1u>, llvm::DenseMapInfo<clang::CharUnits>, llvm::DenseMapInfo<llvm::SmallVector<clang::CXXRecordDecl const*, 1u> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang13CXXRecordDeclENS1_9CharUnitsENS_12DenseMapInfoIS4_EENS6_IS5_EEE6insertERKSt4pairIS4_S5_E", "llvm::DenseMap<clang::CXXRecordDecl const*, clang::CharUnits, llvm::DenseMapInfo<clang::CXXRecordDecl const*>, llvm::DenseMapInfo<clang::CharUnits> >::insert(std::pair<clang::CXXRecordDecl const*, clang::CharUnits> const&)"),
	mu_demangle_test("_ZNSt6vectorIN5clang14HeaderFileInfoESaIS1_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS1_S3_EEmRKS1_", "std::vector<clang::HeaderFileInfo, std::allocator<clang::HeaderFileInfo> >::_M_fill_insert(__gnu_cxx::__normal_iterator<clang::HeaderFileInfo*, std::vector<clang::HeaderFileInfo, std::allocator<clang::HeaderFileInfo> > >, unsigned long, clang::HeaderFileInfo const&)"),
	mu_demangle_test("_ZN4llvm9StringMapISt4pairIjjENS_15MallocAllocatorEE16GetOrCreateValueIS2_EERNS_14StringMapEntryIS2_EENS_9StringRefET_", "llvm::StringMapEntry<std::pair<unsigned int, unsigned int> >& llvm::StringMap<std::pair<unsigned int, unsigned int>, llvm::MallocAllocator>::GetOrCreateValue<std::pair<unsigned int, unsigned int> >(llvm::StringRef, std::pair<unsigned int, unsigned int>)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPKN5clang9FileEntryEPKNS1_9HeaderMapEESaIS8_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS8_SA_EERKS8_", "std::vector<std::pair<clang::FileEntry const*, clang::HeaderMap const*>, std::allocator<std::pair<clang::FileEntry const*, clang::HeaderMap const*> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<clang::FileEntry const*, clang::HeaderMap const*>*, std::vector<std::pair<clang::FileEntry const*, clang::HeaderMap const*>, std::allocator<std::pair<clang::FileEntry const*, clang::HeaderMap const*> > > >, std::pair<clang::FileEntry const*, clang::HeaderMap const*> const&)"),
	mu_demangle_test("_ZNSt6vectorIN5clang5TokenESaIS1_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS1_S3_EEmRKS1_", "std::vector<clang::Token, std::allocator<clang::Token> >::_M_fill_insert(__gnu_cxx::__normal_iterator<clang::Token*, std::vector<clang::Token, std::allocator<clang::Token> > >, unsigned long, clang::Token const&)"),
	mu_demangle_test("_ZNSt6vectorIN5clang5TokenESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<clang::Token, std::allocator<clang::Token> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::Token*, std::vector<clang::Token, std::allocator<clang::Token> > >, clang::Token const&)"),
	mu_demangle_test("_ZNSt6vectorIS_IN5clang5TokenESaIS1_EESaIS3_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS3_S5_EEmRKS3_", "std::vector<std::vector<clang::Token, std::allocator<clang::Token> >, std::allocator<std::vector<clang::Token, std::allocator<clang::Token> > > >::_M_fill_insert(__gnu_cxx::__normal_iterator<std::vector<clang::Token, std::allocator<clang::Token> >*, std::vector<std::vector<clang::Token, std::allocator<clang::Token> >, std::allocator<std::vector<clang::Token, std::allocator<clang::Token> > > > >, unsigned long, std::vector<clang::Token, std::allocator<clang::Token> > const&)"),
	mu_demangle_test("_ZNSt6vectorIN5clang5TokenESaIS1_EEaSERKS3_", "std::vector<clang::Token, std::allocator<clang::Token> >::operator=(std::vector<clang::Token, std::allocator<clang::Token> > const&)"),
	mu_demangle_test("_ZNSt6vectorIN5clang5TokenESaIS1_EEC2ERKS3_", "std::vector<clang::Token, std::allocator<clang::Token> >::vector(std::vector<clang::Token, std::allocator<clang::Token> > const&)"),
	mu_demangle_test("_ZNSt6vectorImSaImEE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPmS1_EERKm", "std::vector<unsigned long, std::allocator<unsigned long> >::_M_insert_aux(__gnu_cxx::__normal_iterator<unsigned long*, std::vector<unsigned long, std::allocator<unsigned long> > >, unsigned long const&)"),
	mu_demangle_test("_ZNSt6vectorIN5clang12Preprocessor16IncludeStackInfoESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<clang::Preprocessor::IncludeStackInfo, std::allocator<clang::Preprocessor::IncludeStackInfo> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::Preprocessor::IncludeStackInfo*, std::vector<clang::Preprocessor::IncludeStackInfo, std::allocator<clang::Preprocessor::IncludeStackInfo> > >, clang::Preprocessor::IncludeStackInfo const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang14IdentifierInfoEPNS1_9MacroInfoENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PSt4pairIS3_S5_E", "llvm::DenseMap<clang::IdentifierInfo*, clang::MacroInfo*, llvm::DenseMapInfo<clang::IdentifierInfo*>, llvm::DenseMapInfo<clang::MacroInfo*> >::InsertIntoBucket(clang::IdentifierInfo* const&, clang::MacroInfo* const&, std::pair<clang::IdentifierInfo*, clang::MacroInfo*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang14IdentifierInfoEPNS1_9MacroInfoENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<clang::IdentifierInfo*, clang::MacroInfo*, llvm::DenseMapInfo<clang::IdentifierInfo*>, llvm::DenseMapInfo<clang::MacroInfo*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIPN5clang9MacroInfoESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<clang::MacroInfo*, std::allocator<clang::MacroInfo*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::MacroInfo**, std::vector<clang::MacroInfo*, std::allocator<clang::MacroInfo*> > >, clang::MacroInfo* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang14IdentifierInfoESt6vectorIPNS1_9MacroInfoESaIS6_EENS_12DenseMapInfoIS3_EENS9_IS8_EEE16FindAndConstructERKS3_", "llvm::DenseMap<clang::IdentifierInfo*, std::vector<clang::MacroInfo*, std::allocator<clang::MacroInfo*> >, llvm::DenseMapInfo<clang::IdentifierInfo*>, llvm::DenseMapInfo<std::vector<clang::MacroInfo*, std::allocator<clang::MacroInfo*> > > >::FindAndConstruct(clang::IdentifierInfo* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang14IdentifierInfoESt6vectorIPNS1_9MacroInfoESaIS6_EENS_12DenseMapInfoIS3_EENS9_IS8_EEE16InsertIntoBucketERKS3_RKS8_PSt4pairIS3_S8_E", "llvm::DenseMap<clang::IdentifierInfo*, std::vector<clang::MacroInfo*, std::allocator<clang::MacroInfo*> >, llvm::DenseMapInfo<clang::IdentifierInfo*>, llvm::DenseMapInfo<std::vector<clang::MacroInfo*, std::allocator<clang::MacroInfo*> > > >::InsertIntoBucket(clang::IdentifierInfo* const&, std::vector<clang::MacroInfo*, std::allocator<clang::MacroInfo*> > const&, std::pair<clang::IdentifierInfo*, std::vector<clang::MacroInfo*, std::allocator<clang::MacroInfo*> > >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPN5clang14IdentifierInfoESt6vectorIPNS1_9MacroInfoESaIS6_EENS_12DenseMapInfoIS3_EENS9_IS8_EEE4growEj", "llvm::DenseMap<clang::IdentifierInfo*, std::vector<clang::MacroInfo*, std::allocator<clang::MacroInfo*> >, llvm::DenseMapInfo<clang::IdentifierInfo*>, llvm::DenseMapInfo<std::vector<clang::MacroInfo*, std::allocator<clang::MacroInfo*> > > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang9MacroInfoEPNS1_15MacroDefinitionENS_12DenseMapInfoIS4_EENS7_IS6_EEE16InsertIntoBucketERKS4_RKS6_PSt4pairIS4_S6_E", "llvm::DenseMap<clang::MacroInfo const*, clang::MacroDefinition*, llvm::DenseMapInfo<clang::MacroInfo const*>, llvm::DenseMapInfo<clang::MacroDefinition*> >::InsertIntoBucket(clang::MacroInfo const* const&, clang::MacroDefinition* const&, std::pair<clang::MacroInfo const*, clang::MacroDefinition*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang9MacroInfoEPNS1_15MacroDefinitionENS_12DenseMapInfoIS4_EENS7_IS6_EEE4growEj", "llvm::DenseMap<clang::MacroInfo const*, clang::MacroDefinition*, llvm::DenseMapInfo<clang::MacroInfo const*>, llvm::DenseMapInfo<clang::MacroDefinition*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIPN5clang18PreprocessedEntityESaIS2_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS2_S4_EEmRKS2_", "std::vector<clang::PreprocessedEntity*, std::allocator<clang::PreprocessedEntity*> >::_M_fill_insert(__gnu_cxx::__normal_iterator<clang::PreprocessedEntity**, std::vector<clang::PreprocessedEntity*, std::allocator<clang::PreprocessedEntity*> > >, unsigned long, clang::PreprocessedEntity* const&)"),
	mu_demangle_test("_ZSt6__findIN9__gnu_cxx17__normal_iteratorIPPN5clang14CommentHandlerESt6vectorIS4_SaIS4_EEEES4_ET_SA_SA_RKT0_St26random_access_iterator_tag", "__gnu_cxx::__normal_iterator<clang::CommentHandler**, std::vector<clang::CommentHandler*, std::allocator<clang::CommentHandler*> > > std::__find<__gnu_cxx::__normal_iterator<clang::CommentHandler**, std::vector<clang::CommentHandler*, std::allocator<clang::CommentHandler*> > >, clang::CommentHandler*>(__gnu_cxx::__normal_iterator<clang::CommentHandler**, std::vector<clang::CommentHandler*, std::allocator<clang::CommentHandler*> > >, __gnu_cxx::__normal_iterator<clang::CommentHandler**, std::vector<clang::CommentHandler*, std::allocator<clang::CommentHandler*> > >, clang::CommentHandler* const&, std::random_access_iterator_tag)"),
	mu_demangle_test("_ZNSt6vectorIPN5clang14CommentHandlerESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<clang::CommentHandler*, std::allocator<clang::CommentHandler*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::CommentHandler**, std::vector<clang::CommentHandler*, std::allocator<clang::CommentHandler*> > >, clang::CommentHandler* const&)"),
	mu_demangle_test("_ZNSt6vectorIN5clang15CharSourceRangeESaIS1_EE7reserveEm", "std::vector<clang::CharSourceRange, std::allocator<clang::CharSourceRange> >::reserve(unsigned long)"),
	mu_demangle_test("_ZNSt6vectorIN5clang9FixItHintESaIS1_EE7reserveEm", "std::vector<clang::FixItHint, std::allocator<clang::FixItHint> >::reserve(unsigned long)"),
	mu_demangle_test("_ZNSt6vectorIN5clang9FixItHintESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<clang::FixItHint, std::allocator<clang::FixItHint> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::FixItHint*, std::vector<clang::FixItHint, std::allocator<clang::FixItHint> > >, clang::FixItHint const&)"),
	mu_demangle_test("_ZNSt6vectorIN5clang15CharSourceRangeESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<clang::CharSourceRange, std::allocator<clang::CharSourceRange> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::CharSourceRange*, std::vector<clang::CharSourceRange, std::allocator<clang::CharSourceRange> > >, clang::CharSourceRange const&)"),
	mu_demangle_test("_ZNSt6vectorIN5clang10Diagnostic14DiagStatePointESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<clang::Diagnostic::DiagStatePoint, std::allocator<clang::Diagnostic::DiagStatePoint> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::Diagnostic::DiagStatePoint*, std::vector<clang::Diagnostic::DiagStatePoint, std::allocator<clang::Diagnostic::DiagStatePoint> > >, clang::Diagnostic::DiagStatePoint const&)"),
	mu_demangle_test("_ZNSt6vectorIPN5clang10Diagnostic9DiagStateESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<clang::Diagnostic::DiagState*, std::allocator<clang::Diagnostic::DiagState*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::Diagnostic::DiagState**, std::vector<clang::Diagnostic::DiagState*, std::allocator<clang::Diagnostic::DiagState*> > >, clang::Diagnostic::DiagState* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjjNS_12DenseMapInfoIjEES2_E8CopyFromERKS3_", "llvm::DenseMap<unsigned int, unsigned int, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<unsigned int> >::CopyFrom(llvm::DenseMap<unsigned int, unsigned int, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<unsigned int> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjjNS_12DenseMapInfoIjEES2_E16InsertIntoBucketERKjS5_PSt4pairIjjE", "llvm::DenseMap<unsigned int, unsigned int, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(unsigned int const&, unsigned int const&, std::pair<unsigned int, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjjNS_12DenseMapInfoIjEES2_E4growEj", "llvm::DenseMap<unsigned int, unsigned int, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN5clang13DiagnosticIDs5LevelESsESaIS4_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS4_S6_EERKS4_", "std::vector<std::pair<clang::DiagnosticIDs::Level, std::string>, std::allocator<std::pair<clang::DiagnosticIDs::Level, std::string> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<clang::DiagnosticIDs::Level, std::string>*, std::vector<std::pair<clang::DiagnosticIDs::Level, std::string>, std::allocator<std::pair<clang::DiagnosticIDs::Level, std::string> > > >, std::pair<clang::DiagnosticIDs::Level, std::string> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIN5clang13DiagnosticIDs5LevelESsES0_IKS4_jESt10_Select1stIS6_ESt4lessIS4_ESaIS6_EE16_M_insert_uniqueERKS6_", "std::_Rb_tree<std::pair<clang::DiagnosticIDs::Level, std::string>, std::pair<std::pair<clang::DiagnosticIDs::Level, std::string> const, unsigned int>, std::_Select1st<std::pair<std::pair<clang::DiagnosticIDs::Level, std::string> const, unsigned int> >, std::less<std::pair<clang::DiagnosticIDs::Level, std::string> >, std::allocator<std::pair<std::pair<clang::DiagnosticIDs::Level, std::string> const, unsigned int> > >::_M_insert_unique(std::pair<std::pair<clang::DiagnosticIDs::Level, std::string> const, unsigned int> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIN5clang13DiagnosticIDs5LevelESsES0_IKS4_jESt10_Select1stIS6_ESt4lessIS4_ESaIS6_EE9_M_insertEPSt18_Rb_tree_node_baseSE_RKS6_", "std::_Rb_tree<std::pair<clang::DiagnosticIDs::Level, std::string>, std::pair<std::pair<clang::DiagnosticIDs::Level, std::string> const, unsigned int>, std::_Select1st<std::pair<std::pair<clang::DiagnosticIDs::Level, std::string> const, unsigned int> >, std::less<std::pair<clang::DiagnosticIDs::Level, std::string> >, std::allocator<std::pair<std::pair<clang::DiagnosticIDs::Level, std::string> const, unsigned int> > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<std::pair<clang::DiagnosticIDs::Level, std::string> const, unsigned int> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIN5clang13DiagnosticIDs5LevelESsES0_IKS4_jESt10_Select1stIS6_ESt4lessIS4_ESaIS6_EE8_M_eraseEPSt13_Rb_tree_nodeIS6_E", "std::_Rb_tree<std::pair<clang::DiagnosticIDs::Level, std::string>, std::pair<std::pair<clang::DiagnosticIDs::Level, std::string> const, unsigned int>, std::_Select1st<std::pair<std::pair<clang::DiagnosticIDs::Level, std::string> const, unsigned int> >, std::less<std::pair<clang::DiagnosticIDs::Level, std::string> >, std::allocator<std::pair<std::pair<clang::DiagnosticIDs::Level, std::string> const, unsigned int> > >::_M_erase(std::_Rb_tree_node<std::pair<std::pair<clang::DiagnosticIDs::Level, std::string> const, unsigned int> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN5clang9FileEntryES1_St9_IdentityIS1_ESt4lessIS1_ESaIS1_EE16_M_insert_uniqueERKS1_", "std::_Rb_tree<clang::FileEntry, clang::FileEntry, std::_Identity<clang::FileEntry>, std::less<clang::FileEntry>, std::allocator<clang::FileEntry> >::_M_insert_unique(clang::FileEntry const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIiyES0_IKS1_N5clang14DirectoryEntryEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS5_ERKS5_", "std::_Rb_tree<std::pair<int, uint64_t>, std::pair<std::pair<int, uint64_t> const, clang::DirectoryEntry>, std::_Select1st<std::pair<std::pair<int, uint64_t> const, clang::DirectoryEntry> >, std::less<std::pair<int, uint64_t> >, std::allocator<std::pair<std::pair<int, uint64_t> const, clang::DirectoryEntry> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<std::pair<int, uint64_t> const, clang::DirectoryEntry> >, std::pair<std::pair<int, uint64_t> const, clang::DirectoryEntry> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIiyES0_IKS1_N5clang14DirectoryEntryEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE16_M_insert_uniqueERKS5_", "std::_Rb_tree<std::pair<int, uint64_t>, std::pair<std::pair<int, uint64_t> const, clang::DirectoryEntry>, std::_Select1st<std::pair<std::pair<int, uint64_t> const, clang::DirectoryEntry> >, std::less<std::pair<int, uint64_t> >, std::allocator<std::pair<std::pair<int, uint64_t> const, clang::DirectoryEntry> > >::_M_insert_unique(std::pair<std::pair<int, uint64_t> const, clang::DirectoryEntry> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN5clang9FileEntryES1_St9_IdentityIS1_ESt4lessIS1_ESaIS1_EE8_M_eraseEPSt13_Rb_tree_nodeIS1_E", "std::_Rb_tree<clang::FileEntry, clang::FileEntry, std::_Identity<clang::FileEntry>, std::less<clang::FileEntry>, std::allocator<clang::FileEntry> >::_M_erase(std::_Rb_tree_node<clang::FileEntry>*)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIiyES0_IKS1_N5clang14DirectoryEntryEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE8_M_eraseEPSt13_Rb_tree_nodeIS5_E", "std::_Rb_tree<std::pair<int, uint64_t>, std::pair<std::pair<int, uint64_t> const, clang::DirectoryEntry>, std::_Select1st<std::pair<std::pair<int, uint64_t> const, clang::DirectoryEntry> >, std::less<std::pair<int, uint64_t> >, std::allocator<std::pair<std::pair<int, uint64_t> const, clang::DirectoryEntry> > >::_M_erase(std::_Rb_tree_node<std::pair<std::pair<int, uint64_t> const, clang::DirectoryEntry> >*)"),
	mu_demangle_test("_ZN5clang13LineTableInfo8AddEntryEjRKSt6vectorINS_9LineEntryESaIS2_EE", "clang::LineTableInfo::AddEntry(unsigned int, std::vector<clang::LineEntry, std::allocator<clang::LineEntry> > const&)"),
	mu_demangle_test("_ZNSt6vectorIN5clang9LineEntryESaIS1_EEaSERKS3_", "std::vector<clang::LineEntry, std::allocator<clang::LineEntry> >::operator=(std::vector<clang::LineEntry, std::allocator<clang::LineEntry> > const&)"),
	mu_demangle_test("_ZNSt6vectorIbSaIbEE6resizeEmb", "std::vector<bool, std::allocator<bool> >::resize(unsigned long, bool)"),
	mu_demangle_test("_ZNSt6vectorIN5clang6SrcMgr9SLocEntryESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<clang::SrcMgr::SLocEntry, std::allocator<clang::SrcMgr::SLocEntry> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::SrcMgr::SLocEntry*, std::vector<clang::SrcMgr::SLocEntry, std::allocator<clang::SrcMgr::SLocEntry> > >, clang::SrcMgr::SLocEntry const&)"),
	mu_demangle_test("_ZNSt6vectorIN5clang6SrcMgr9SLocEntryESaIS2_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS2_S4_EEmRKS2_", "std::vector<clang::SrcMgr::SLocEntry, std::allocator<clang::SrcMgr::SLocEntry> >::_M_fill_insert(__gnu_cxx::__normal_iterator<clang::SrcMgr::SLocEntry*, std::vector<clang::SrcMgr::SLocEntry, std::allocator<clang::SrcMgr::SLocEntry> > >, unsigned long, clang::SrcMgr::SLocEntry const&)"),
	mu_demangle_test("_ZNSt6vectorIbSaIbEE14_M_fill_insertESt13_Bit_iteratormb", "std::vector<bool, std::allocator<bool> >::_M_fill_insert(std::_Bit_iterator, unsigned long, bool)"),
	mu_demangle_test("_ZNSt6vectorIPN5clang6SrcMgr12ContentCacheESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<clang::SrcMgr::ContentCache*, std::allocator<clang::SrcMgr::ContentCache*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::SrcMgr::ContentCache**, std::vector<clang::SrcMgr::ContentCache*, std::allocator<clang::SrcMgr::ContentCache*> > >, clang::SrcMgr::ContentCache* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang9FileEntryEPNS1_6SrcMgr12ContentCacheENS_12DenseMapInfoIS4_EENS8_IS7_EEE16InsertIntoBucketERKS4_RKS7_PSt4pairIS4_S7_E", "llvm::DenseMap<clang::FileEntry const*, clang::SrcMgr::ContentCache*, llvm::DenseMapInfo<clang::FileEntry const*>, llvm::DenseMapInfo<clang::SrcMgr::ContentCache*> >::InsertIntoBucket(clang::FileEntry const* const&, clang::SrcMgr::ContentCache* const&, std::pair<clang::FileEntry const*, clang::SrcMgr::ContentCache*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKN5clang9FileEntryEPNS1_6SrcMgr12ContentCacheENS_12DenseMapInfoIS4_EENS8_IS7_EEE4growEj", "llvm::DenseMap<clang::FileEntry const*, clang::SrcMgr::ContentCache*, llvm::DenseMapInfo<clang::FileEntry const*>, llvm::DenseMapInfo<clang::SrcMgr::ContentCache*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIN5clang9LineEntryESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<clang::LineEntry, std::allocator<clang::LineEntry> >::_M_insert_aux(__gnu_cxx::__normal_iterator<clang::LineEntry*, std::vector<clang::LineEntry, std::allocator<clang::LineEntry> > >, clang::LineEntry const&)"),
	mu_demangle_test("_ZNSt6vectorIN5clang9LineEntryESaIS1_EEC2ERKS3_", "std::vector<clang::LineEntry, std::allocator<clang::LineEntry> >::vector(std::vector<clang::LineEntry, std::allocator<clang::LineEntry> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjSt6vectorIN5clang9LineEntryESaIS4_EEESt10_Select1stIS7_ESt4lessIjESaIS7_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS7_ERKS7_", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, std::vector<clang::LineEntry, std::allocator<clang::LineEntry> > >, std::_Select1st<std::pair<unsigned int const, std::vector<clang::LineEntry, std::allocator<clang::LineEntry> > > >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, std::vector<clang::LineEntry, std::allocator<clang::LineEntry> > > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<unsigned int const, std::vector<clang::LineEntry, std::allocator<clang::LineEntry> > > >, std::pair<unsigned int const, std::vector<clang::LineEntry, std::allocator<clang::LineEntry> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjSt6vectorIN5clang9LineEntryESaIS4_EEESt10_Select1stIS7_ESt4lessIjESaIS7_EE16_M_insert_uniqueERKS7_", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, std::vector<clang::LineEntry, std::allocator<clang::LineEntry> > >, std::_Select1st<std::pair<unsigned int const, std::vector<clang::LineEntry, std::allocator<clang::LineEntry> > > >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, std::vector<clang::LineEntry, std::allocator<clang::LineEntry> > > > >::_M_insert_unique(std::pair<unsigned int const, std::vector<clang::LineEntry, std::allocator<clang::LineEntry> > > const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm14StringMapEntryIjEESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<llvm::StringMapEntry<unsigned int>*, std::allocator<llvm::StringMapEntry<unsigned int>*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::StringMapEntry<unsigned int>**, std::vector<llvm::StringMapEntry<unsigned int>*, std::allocator<llvm::StringMapEntry<unsigned int>*> > >, llvm::StringMapEntry<unsigned int>* const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjSt6vectorIN5clang9LineEntryESaIS4_EEESt10_Select1stIS7_ESt4lessIjESaIS7_EE8_M_eraseEPSt13_Rb_tree_nodeIS7_E", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, std::vector<clang::LineEntry, std::allocator<clang::LineEntry> > >, std::_Select1st<std::pair<unsigned int const, std::vector<clang::LineEntry, std::allocator<clang::LineEntry> > > >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, std::vector<clang::LineEntry, std::allocator<clang::LineEntry> > > > >::_M_erase(std::_Rb_tree_node<std::pair<unsigned int const, std::vector<clang::LineEntry, std::allocator<clang::LineEntry> > > >*)"),
	mu_demangle_test("_ZN12_GLOBAL__N_113X86TargetInfo20HandleTargetFeaturesERSt6vectorISsSaISsEE", "(anonymous namespace)::X86TargetInfo::HandleTargetFeatures(std::vector<std::string, std::allocator<std::string> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_117SparcV8TargetInfo20HandleTargetFeaturesERSt6vectorISsSaISsEE", "(anonymous namespace)::SparcV8TargetInfo::HandleTargetFeatures(std::vector<std::string, std::allocator<std::string> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_113ARMTargetInfo20HandleTargetFeaturesERSt6vectorISsSaISsEE", "(anonymous namespace)::ARMTargetInfo::HandleTargetFeatures(std::vector<std::string, std::allocator<std::string> >&)"),
	mu_demangle_test("_ZN5clang10TargetInfo20HandleTargetFeaturesERSt6vectorISsSaISsEE", "clang::TargetInfo::HandleTargetFeatures(std::vector<std::string, std::allocator<std::string> >&)"),
	mu_demangle_test("_ZSt6__findIN9__gnu_cxx17__normal_iteratorIPSsSt6vectorISsSaISsEEEEA16_cET_S8_S8_RKT0_St26random_access_iterator_tag", "__gnu_cxx::__normal_iterator<std::string*, std::vector<std::string, std::allocator<std::string> > > std::__find<__gnu_cxx::__normal_iterator<std::string*, std::vector<std::string, std::allocator<std::string> > >, char [16]>(__gnu_cxx::__normal_iterator<std::string*, std::vector<std::string, std::allocator<std::string> > >, __gnu_cxx::__normal_iterator<std::string*, std::vector<std::string, std::allocator<std::string> > >, char const (&) [16], std::random_access_iterator_tag)"),
	mu_demangle_test("_ZSt6__findIN9__gnu_cxx17__normal_iteratorIPSsSt6vectorISsSaISsEEEEA12_cET_S8_S8_RKT0_St26random_access_iterator_tag", "__gnu_cxx::__normal_iterator<std::string*, std::vector<std::string, std::allocator<std::string> > > std::__find<__gnu_cxx::__normal_iterator<std::string*, std::vector<std::string, std::allocator<std::string> > >, char [12]>(__gnu_cxx::__normal_iterator<std::string*, std::vector<std::string, std::allocator<std::string> > >, __gnu_cxx::__normal_iterator<std::string*, std::vector<std::string, std::allocator<std::string> > >, char const (&) [12], std::random_access_iterator_tag)"),
	mu_demangle_test("_Z15MarkIndicesSafeRKSt6vectorIySaIyEERSt3setIS1_St4lessIS1_ESaIS1_EE", "MarkIndicesSafe(std::vector<uint64_t, std::allocator<uint64_t> > const&, std::set<std::vector<uint64_t, std::allocator<uint64_t> >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::vector<uint64_t, std::allocator<uint64_t> > > >&)"),
	mu_demangle_test("_ZNSt3mapIPN4llvm8ArgumentESt3setISt6vectorIySaIyEESt4lessIS6_ESaIS6_EES7_IS2_ESaISt4pairIKS2_SA_EEEixERSD_", "std::map<llvm::Argument*, std::set<std::vector<uint64_t, std::allocator<uint64_t> >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::vector<uint64_t, std::allocator<uint64_t> > > >, std::less<llvm::Argument*>, std::allocator<std::pair<llvm::Argument* const, std::set<std::vector<uint64_t, std::allocator<uint64_t> >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::vector<uint64_t, std::allocator<uint64_t> > > > > > >::operator[](llvm::Argument* const&)"),
	mu_demangle_test("_ZNSt3mapISt6vectorIySaIyEEPN4llvm8LoadInstESt4lessIS2_ESaISt4pairIKS2_S5_EEEixERS9_", "std::map<std::vector<uint64_t, std::allocator<uint64_t> >, llvm::LoadInst*, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::pair<std::vector<uint64_t, std::allocator<uint64_t> > const, llvm::LoadInst*> > >::operator[](std::vector<uint64_t, std::allocator<uint64_t> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm8ArgumentESt4pairIKS2_St3setISt6vectorIySaIyEESt4lessIS8_ESaIS8_EEESt10_Select1stISD_ES9_IS2_ESaISD_EE8_M_eraseEPSt13_Rb_tree_nodeISD_E", "std::_Rb_tree<llvm::Argument*, std::pair<llvm::Argument* const, std::set<std::vector<uint64_t, std::allocator<uint64_t> >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::vector<uint64_t, std::allocator<uint64_t> > > > >, std::_Select1st<std::pair<llvm::Argument* const, std::set<std::vector<uint64_t, std::allocator<uint64_t> >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::vector<uint64_t, std::allocator<uint64_t> > > > > >, std::less<llvm::Argument*>, std::allocator<std::pair<llvm::Argument* const, std::set<std::vector<uint64_t, std::allocator<uint64_t> >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::vector<uint64_t, std::allocator<uint64_t> > > > > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::Argument* const, std::set<std::vector<uint64_t, std::allocator<uint64_t> >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::vector<uint64_t, std::allocator<uint64_t> > > > > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt6vectorIySaIyEES2_St9_IdentityIS2_ESt4lessIS2_ESaIS2_EE8_M_eraseEPSt13_Rb_tree_nodeIS2_E", "std::_Rb_tree<std::vector<uint64_t, std::allocator<uint64_t> >, std::vector<uint64_t, std::allocator<uint64_t> >, std::_Identity<std::vector<uint64_t, std::allocator<uint64_t> > >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::vector<uint64_t, std::allocator<uint64_t> > > >::_M_erase(std::_Rb_tree_node<std::vector<uint64_t, std::allocator<uint64_t> > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt6vectorIySaIyEESt4pairIKS2_PN4llvm8LoadInstEESt10_Select1stIS8_ESt4lessIS2_ESaIS8_EE8_M_eraseEPSt13_Rb_tree_nodeIS8_E", "std::_Rb_tree<std::vector<uint64_t, std::allocator<uint64_t> >, std::pair<std::vector<uint64_t, std::allocator<uint64_t> > const, llvm::LoadInst*>, std::_Select1st<std::pair<std::vector<uint64_t, std::allocator<uint64_t> > const, llvm::LoadInst*> >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::pair<std::vector<uint64_t, std::allocator<uint64_t> > const, llvm::LoadInst*> > >::_M_erase(std::_Rb_tree_node<std::pair<std::vector<uint64_t, std::allocator<uint64_t> > const, llvm::LoadInst*> >*)"),
	mu_demangle_test("_ZN4llvm17GetElementPtrInstC2IN9__gnu_cxx17__normal_iteratorIPPNS_5ValueESt6vectorIS5_SaIS5_EEEEEES5_T_SB_jRKNS_5TwineEPNS_11InstructionE", "llvm::GetElementPtrInst::GetElementPtrInst<__gnu_cxx::__normal_iterator<llvm::Value**, std::vector<llvm::Value*, std::allocator<llvm::Value*> > > >(llvm::Value*, __gnu_cxx::__normal_iterator<llvm::Value**, std::vector<llvm::Value*, std::allocator<llvm::Value*> > >, __gnu_cxx::__normal_iterator<llvm::Value**, std::vector<llvm::Value*, std::allocator<llvm::Value*> > >, unsigned int, llvm::Twine const&, llvm::Instruction*)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt6vectorIySaIyEESt4pairIKS2_PN4llvm8LoadInstEESt10_Select1stIS8_ESt4lessIS2_ESaIS8_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS8_ERKS8_", "std::_Rb_tree<std::vector<uint64_t, std::allocator<uint64_t> >, std::pair<std::vector<uint64_t, std::allocator<uint64_t> > const, llvm::LoadInst*>, std::_Select1st<std::pair<std::vector<uint64_t, std::allocator<uint64_t> > const, llvm::LoadInst*> >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::pair<std::vector<uint64_t, std::allocator<uint64_t> > const, llvm::LoadInst*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<std::vector<uint64_t, std::allocator<uint64_t> > const, llvm::LoadInst*> >, std::pair<std::vector<uint64_t, std::allocator<uint64_t> > const, llvm::LoadInst*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt6vectorIySaIyEESt4pairIKS2_PN4llvm8LoadInstEESt10_Select1stIS8_ESt4lessIS2_ESaIS8_EE16_M_insert_uniqueERKS8_", "std::_Rb_tree<std::vector<uint64_t, std::allocator<uint64_t> >, std::pair<std::vector<uint64_t, std::allocator<uint64_t> > const, llvm::LoadInst*>, std::_Select1st<std::pair<std::vector<uint64_t, std::allocator<uint64_t> > const, llvm::LoadInst*> >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::pair<std::vector<uint64_t, std::allocator<uint64_t> > const, llvm::LoadInst*> > >::_M_insert_unique(std::pair<std::vector<uint64_t, std::allocator<uint64_t> > const, llvm::LoadInst*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt6vectorIySaIyEESt4pairIKS2_PN4llvm8LoadInstEESt10_Select1stIS8_ESt4lessIS2_ESaIS8_EE14_M_create_nodeERKS8_", "std::_Rb_tree<std::vector<uint64_t, std::allocator<uint64_t> >, std::pair<std::vector<uint64_t, std::allocator<uint64_t> > const, llvm::LoadInst*>, std::_Select1st<std::pair<std::vector<uint64_t, std::allocator<uint64_t> > const, llvm::LoadInst*> >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::pair<std::vector<uint64_t, std::allocator<uint64_t> > const, llvm::LoadInst*> > >::_M_create_node(std::pair<std::vector<uint64_t, std::allocator<uint64_t> > const, llvm::LoadInst*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt6vectorIySaIyEES2_St9_IdentityIS2_ESt4lessIS2_ESaIS2_EE16_M_insert_uniqueERKS2_", "std::_Rb_tree<std::vector<uint64_t, std::allocator<uint64_t> >, std::vector<uint64_t, std::allocator<uint64_t> >, std::_Identity<std::vector<uint64_t, std::allocator<uint64_t> > >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::vector<uint64_t, std::allocator<uint64_t> > > >::_M_insert_unique(std::vector<uint64_t, std::allocator<uint64_t> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt6vectorIySaIyEES2_St9_IdentityIS2_ESt4lessIS2_ESaIS2_EE14_M_create_nodeERKS2_", "std::_Rb_tree<std::vector<uint64_t, std::allocator<uint64_t> >, std::vector<uint64_t, std::allocator<uint64_t> >, std::_Identity<std::vector<uint64_t, std::allocator<uint64_t> > >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::vector<uint64_t, std::allocator<uint64_t> > > >::_M_create_node(std::vector<uint64_t, std::allocator<uint64_t> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt6vectorIySaIyEES2_St9_IdentityIS2_ESt4lessIS2_ESaIS2_EE7_M_copyEPKSt13_Rb_tree_nodeIS2_EPSA_", "std::_Rb_tree<std::vector<uint64_t, std::allocator<uint64_t> >, std::vector<uint64_t, std::allocator<uint64_t> >, std::_Identity<std::vector<uint64_t, std::allocator<uint64_t> > >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::vector<uint64_t, std::allocator<uint64_t> > > >::_M_copy(std::_Rb_tree_node<std::vector<uint64_t, std::allocator<uint64_t> > > const*, std::_Rb_tree_node<std::vector<uint64_t, std::allocator<uint64_t> > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm8ArgumentESt4pairIKS2_St3setISt6vectorIySaIyEESt4lessIS8_ESaIS8_EEESt10_Select1stISD_ES9_IS2_ESaISD_EE16_M_insert_uniqueESt17_Rb_tree_iteratorISD_ERKSD_", "std::_Rb_tree<llvm::Argument*, std::pair<llvm::Argument* const, std::set<std::vector<uint64_t, std::allocator<uint64_t> >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::vector<uint64_t, std::allocator<uint64_t> > > > >, std::_Select1st<std::pair<llvm::Argument* const, std::set<std::vector<uint64_t, std::allocator<uint64_t> >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::vector<uint64_t, std::allocator<uint64_t> > > > > >, std::less<llvm::Argument*>, std::allocator<std::pair<llvm::Argument* const, std::set<std::vector<uint64_t, std::allocator<uint64_t> >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::vector<uint64_t, std::allocator<uint64_t> > > > > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::Argument* const, std::set<std::vector<uint64_t, std::allocator<uint64_t> >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::vector<uint64_t, std::allocator<uint64_t> > > > > >, std::pair<llvm::Argument* const, std::set<std::vector<uint64_t, std::allocator<uint64_t> >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::vector<uint64_t, std::allocator<uint64_t> > > > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm8ArgumentESt4pairIKS2_St3setISt6vectorIySaIyEESt4lessIS8_ESaIS8_EEESt10_Select1stISD_ES9_IS2_ESaISD_EE9_M_insertEPSt18_Rb_tree_node_baseSK_RKSD_", "std::_Rb_tree<llvm::Argument*, std::pair<llvm::Argument* const, std::set<std::vector<uint64_t, std::allocator<uint64_t> >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::vector<uint64_t, std::allocator<uint64_t> > > > >, std::_Select1st<std::pair<llvm::Argument* const, std::set<std::vector<uint64_t, std::allocator<uint64_t> >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::vector<uint64_t, std::allocator<uint64_t> > > > > >, std::less<llvm::Argument*>, std::allocator<std::pair<llvm::Argument* const, std::set<std::vector<uint64_t, std::allocator<uint64_t> >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::vector<uint64_t, std::allocator<uint64_t> > > > > > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<llvm::Argument* const, std::set<std::vector<uint64_t, std::allocator<uint64_t> >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::vector<uint64_t, std::allocator<uint64_t> > > > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm8ArgumentESt4pairIKS2_St3setISt6vectorIySaIyEESt4lessIS8_ESaIS8_EEESt10_Select1stISD_ES9_IS2_ESaISD_EE16_M_insert_uniqueERKSD_", "std::_Rb_tree<llvm::Argument*, std::pair<llvm::Argument* const, std::set<std::vector<uint64_t, std::allocator<uint64_t> >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::vector<uint64_t, std::allocator<uint64_t> > > > >, std::_Select1st<std::pair<llvm::Argument* const, std::set<std::vector<uint64_t, std::allocator<uint64_t> >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::vector<uint64_t, std::allocator<uint64_t> > > > > >, std::less<llvm::Argument*>, std::allocator<std::pair<llvm::Argument* const, std::set<std::vector<uint64_t, std::allocator<uint64_t> >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::vector<uint64_t, std::allocator<uint64_t> > > > > > >::_M_insert_unique(std::pair<llvm::Argument* const, std::set<std::vector<uint64_t, std::allocator<uint64_t> >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::vector<uint64_t, std::allocator<uint64_t> > > > > const&)"),
	mu_demangle_test("_ZN4llvm11df_iteratorINS_7InverseIPNS_10BasicBlockEEENS_11SmallPtrSetIS3_Lj16EEELb1ENS_11GraphTraitsIS4_EEE6toNextEv", "llvm::df_iterator<llvm::Inverse<llvm::BasicBlock*>, llvm::SmallPtrSet<llvm::BasicBlock*, 16u>, true, llvm::GraphTraits<llvm::Inverse<llvm::BasicBlock*> > >::toNext()"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN4llvm14PointerIntPairIPNS1_10BasicBlockELj1EjNS1_21PointerLikeTypeTraitsIS4_EEEENS1_12PredIteratorIS3_NS1_18value_use_iteratorINS1_4UserEEEEEESaISD_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPSD_SF_EERKSD_", "std::vector<std::pair<llvm::PointerIntPair<llvm::BasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::BasicBlock*> >, llvm::PredIterator<llvm::BasicBlock, llvm::value_use_iterator<llvm::User> > >, std::allocator<std::pair<llvm::PointerIntPair<llvm::BasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::BasicBlock*> >, llvm::PredIterator<llvm::BasicBlock, llvm::value_use_iterator<llvm::User> > > > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::PointerIntPair<llvm::BasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::BasicBlock*> >, llvm::PredIterator<llvm::BasicBlock, llvm::value_use_iterator<llvm::User> > >*, std::vector<std::pair<llvm::PointerIntPair<llvm::BasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::BasicBlock*> >, llvm::PredIterator<llvm::BasicBlock, llvm::value_use_iterator<llvm::User> > >, std::allocator<std::pair<llvm::PointerIntPair<llvm::BasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::BasicBlock*> >, llvm::PredIterator<llvm::BasicBlock, llvm::value_use_iterator<llvm::User> > > > > >, std::pair<llvm::PointerIntPair<llvm::BasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::BasicBlock*> >, llvm::PredIterator<llvm::BasicBlock, llvm::value_use_iterator<llvm::User> > > const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN4llvm14PointerIntPairIPNS1_10BasicBlockELj1EjNS1_21PointerLikeTypeTraitsIS4_EEEENS1_12PredIteratorIS3_NS1_18value_use_iteratorINS1_4UserEEEEEESaISD_EEC2ERKSF_", "std::vector<std::pair<llvm::PointerIntPair<llvm::BasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::BasicBlock*> >, llvm::PredIterator<llvm::BasicBlock, llvm::value_use_iterator<llvm::User> > >, std::allocator<std::pair<llvm::PointerIntPair<llvm::BasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::BasicBlock*> >, llvm::PredIterator<llvm::BasicBlock, llvm::value_use_iterator<llvm::User> > > > >::vector(std::vector<std::pair<llvm::PointerIntPair<llvm::BasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::BasicBlock*> >, llvm::PredIterator<llvm::BasicBlock, llvm::value_use_iterator<llvm::User> > >, std::allocator<std::pair<llvm::PointerIntPair<llvm::BasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::BasicBlock*> >, llvm::PredIterator<llvm::BasicBlock, llvm::value_use_iterator<llvm::User> > > > > const&)"),
	mu_demangle_test("_ZN4llvm11df_iteratorINS_7InverseIPNS_10BasicBlockEEENS_11SmallPtrSetIS3_Lj16EEELb1ENS_11GraphTraitsIS4_EEEC2ES3_RS6_", "llvm::df_iterator<llvm::Inverse<llvm::BasicBlock*>, llvm::SmallPtrSet<llvm::BasicBlock*, 16u>, true, llvm::GraphTraits<llvm::Inverse<llvm::BasicBlock*> > >::df_iterator(llvm::BasicBlock*, llvm::SmallPtrSet<llvm::BasicBlock*, 16u>&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt6vectorIySaIyEES2_St9_IdentityIS2_ESt4lessIS2_ESaIS2_EE4findERKS2_", "std::_Rb_tree<std::vector<uint64_t, std::allocator<uint64_t> >, std::vector<uint64_t, std::allocator<uint64_t> >, std::_Identity<std::vector<uint64_t, std::allocator<uint64_t> > >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::vector<uint64_t, std::allocator<uint64_t> > > >::find(std::vector<uint64_t, std::allocator<uint64_t> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt6vectorIySaIyEES2_St9_IdentityIS2_ESt4lessIS2_ESaIS2_EE16_M_insert_uniqueESt23_Rb_tree_const_iteratorIS2_ERKS2_", "std::_Rb_tree<std::vector<uint64_t, std::allocator<uint64_t> >, std::vector<uint64_t, std::allocator<uint64_t> >, std::_Identity<std::vector<uint64_t, std::allocator<uint64_t> > >, std::less<std::vector<uint64_t, std::allocator<uint64_t> > >, std::allocator<std::vector<uint64_t, std::allocator<uint64_t> > > >::_M_insert_unique(std::_Rb_tree_const_iterator<std::vector<uint64_t, std::allocator<uint64_t> > >, std::vector<uint64_t, std::allocator<uint64_t> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_8ConstantEPNS_14GlobalVariableENS_12DenseMapInfoIS2_EENS5_IS4_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::Constant*, llvm::GlobalVariable*, llvm::DenseMapInfo<llvm::Constant*>, llvm::DenseMapInfo<llvm::GlobalVariable*> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_8ConstantEPNS_14GlobalVariableENS_12DenseMapInfoIS2_EENS5_IS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<llvm::Constant*, llvm::GlobalVariable*, llvm::DenseMapInfo<llvm::Constant*>, llvm::DenseMapInfo<llvm::GlobalVariable*> >::InsertIntoBucket(llvm::Constant* const&, llvm::GlobalVariable* const&, std::pair<llvm::Constant*, llvm::GlobalVariable*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_8ConstantEPNS_14GlobalVariableENS_12DenseMapInfoIS2_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::Constant*, llvm::GlobalVariable*, llvm::DenseMapInfo<llvm::Constant*>, llvm::DenseMapInfo<llvm::GlobalVariable*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt3setIN12_GLOBAL__N_13DAE8RetOrArgESt4lessIS2_ESaIS2_EE5eraseERKS2_", "std::set<(anonymous namespace)::DAE::RetOrArg, std::less<(anonymous namespace)::DAE::RetOrArg>, std::allocator<(anonymous namespace)::DAE::RetOrArg> >::erase((anonymous namespace)::DAE::RetOrArg const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN12_GLOBAL__N_13DAE8RetOrArgES2_St9_IdentityIS2_ESt4lessIS2_ESaIS2_EE8_M_eraseEPSt13_Rb_tree_nodeIS2_E", "std::_Rb_tree<(anonymous namespace)::DAE::RetOrArg, (anonymous namespace)::DAE::RetOrArg, std::_Identity<(anonymous namespace)::DAE::RetOrArg>, std::less<(anonymous namespace)::DAE::RetOrArg>, std::allocator<(anonymous namespace)::DAE::RetOrArg> >::_M_erase(std::_Rb_tree_node<(anonymous namespace)::DAE::RetOrArg>*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN12_GLOBAL__N_13DAE8RetOrArgESt4pairIKS2_S2_ESt10_Select1stIS5_ESt4lessIS2_ESaIS5_EE8_M_eraseEPSt13_Rb_tree_nodeIS5_E", "std::_Rb_tree<(anonymous namespace)::DAE::RetOrArg, std::pair<(anonymous namespace)::DAE::RetOrArg const, (anonymous namespace)::DAE::RetOrArg>, std::_Select1st<std::pair<(anonymous namespace)::DAE::RetOrArg const, (anonymous namespace)::DAE::RetOrArg> >, std::less<(anonymous namespace)::DAE::RetOrArg>, std::allocator<std::pair<(anonymous namespace)::DAE::RetOrArg const, (anonymous namespace)::DAE::RetOrArg> > >::_M_erase(std::_Rb_tree_node<std::pair<(anonymous namespace)::DAE::RetOrArg const, (anonymous namespace)::DAE::RetOrArg> >*)"),
	mu_demangle_test("_ZN4llvm8CallInstC2IN9__gnu_cxx17__normal_iteratorIPPNS_5ValueESt6vectorIS5_SaIS5_EEEEEES5_T_SB_RKNS_5TwineEPNS_11InstructionE", "llvm::CallInst::CallInst<__gnu_cxx::__normal_iterator<llvm::Value**, std::vector<llvm::Value*, std::allocator<llvm::Value*> > > >(llvm::Value*, __gnu_cxx::__normal_iterator<llvm::Value**, std::vector<llvm::Value*, std::allocator<llvm::Value*> > >, __gnu_cxx::__normal_iterator<llvm::Value**, std::vector<llvm::Value*, std::allocator<llvm::Value*> > >, llvm::Twine const&, llvm::Instruction*)"),
	mu_demangle_test("_ZN4llvm10InvokeInstC2IN9__gnu_cxx17__normal_iteratorIPPNS_5ValueESt6vectorIS5_SaIS5_EEEEEES5_PNS_10BasicBlockESC_T_SD_jRKNS_5TwineEPNS_11InstructionE", "llvm::InvokeInst::InvokeInst<__gnu_cxx::__normal_iterator<llvm::Value**, std::vector<llvm::Value*, std::allocator<llvm::Value*> > > >(llvm::Value*, llvm::BasicBlock*, llvm::BasicBlock*, __gnu_cxx::__normal_iterator<llvm::Value**, std::vector<llvm::Value*, std::allocator<llvm::Value*> > >, __gnu_cxx::__normal_iterator<llvm::Value**, std::vector<llvm::Value*, std::allocator<llvm::Value*> > >, unsigned int, llvm::Twine const&, llvm::Instruction*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm8FunctionES3_St9_IdentityIS3_ESt4lessIS3_ESaIS3_EE16_M_insert_uniqueERKS3_", "std::_Rb_tree<llvm::Function const*, llvm::Function const*, std::_Identity<llvm::Function const*>, std::less<llvm::Function const*>, std::allocator<llvm::Function const*> >::_M_insert_unique(llvm::Function const* const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm5ValueESaIS2_EE13_M_assign_auxIPNS0_3UseEEEvT_S8_St20forward_iterator_tag", "void std::vector<llvm::Value*, std::allocator<llvm::Value*> >::_M_assign_aux<llvm::Use*>(llvm::Use*, llvm::Use*, std::forward_iterator_tag)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm8FunctionES3_St9_IdentityIS3_ESt4lessIS3_ESaIS3_EE8_M_eraseEPSt13_Rb_tree_nodeIS3_E", "std::_Rb_tree<llvm::Function const*, llvm::Function const*, std::_Identity<llvm::Function const*>, std::less<llvm::Function const*>, std::allocator<llvm::Function const*> >::_M_erase(std::_Rb_tree_node<llvm::Function const*>*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4TypeES3_St9_IdentityIS3_ESt4lessIS3_ESaIS3_EE8_M_eraseEPSt13_Rb_tree_nodeIS3_E", "std::_Rb_tree<llvm::Type const*, llvm::Type const*, std::_Identity<llvm::Type const*>, std::less<llvm::Type const*>, std::allocator<llvm::Type const*> >::_M_erase(std::_Rb_tree_node<llvm::Type const*>*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4TypeES3_St9_IdentityIS3_ESt4lessIS3_ESaIS3_EE5eraseESt17_Rb_tree_iteratorIS3_ESB_", "std::_Rb_tree<llvm::Type const*, llvm::Type const*, std::_Identity<llvm::Type const*>, std::less<llvm::Type const*>, std::allocator<llvm::Type const*> >::erase(std::_Rb_tree_iterator<llvm::Type const*>, std::_Rb_tree_iterator<llvm::Type const*>)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4TypeES3_St9_IdentityIS3_ESt4lessIS3_ESaIS3_EE7_M_copyEPKSt13_Rb_tree_nodeIS3_EPSB_", "std::_Rb_tree<llvm::Type const*, llvm::Type const*, std::_Identity<llvm::Type const*>, std::less<llvm::Type const*>, std::allocator<llvm::Type const*> >::_M_copy(std::_Rb_tree_node<llvm::Type const*> const*, std::_Rb_tree_node<llvm::Type const*>*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm5ValueESt4pairIKS2_jESt10_Select1stIS5_ESt4lessIS2_ESaIS5_EE8_M_eraseEPSt13_Rb_tree_nodeIS5_E", "std::_Rb_tree<llvm::Value*, std::pair<llvm::Value* const, unsigned int>, std::_Select1st<std::pair<llvm::Value* const, unsigned int> >, std::less<llvm::Value*>, std::allocator<std::pair<llvm::Value* const, unsigned int> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::Value* const, unsigned int> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm5ValueESt4pairIKS2_jESt10_Select1stIS5_ESt4lessIS2_ESaIS5_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS5_ERKS5_", "std::_Rb_tree<llvm::Value*, std::pair<llvm::Value* const, unsigned int>, std::_Select1st<std::pair<llvm::Value* const, unsigned int> >, std::less<llvm::Value*>, std::allocator<std::pair<llvm::Value* const, unsigned int> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::Value* const, unsigned int> >, std::pair<llvm::Value* const, unsigned int> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm5ValueESt4pairIKS2_jESt10_Select1stIS5_ESt4lessIS2_ESaIS5_EE16_M_insert_uniqueERKS5_", "std::_Rb_tree<llvm::Value*, std::pair<llvm::Value* const, unsigned int>, std::_Select1st<std::pair<llvm::Value* const, unsigned int> >, std::less<llvm::Value*>, std::allocator<std::pair<llvm::Value* const, unsigned int> > >::_M_insert_unique(std::pair<llvm::Value* const, unsigned int> const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm11GlobalAliasESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::GlobalAlias*, std::allocator<llvm::GlobalAlias*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::GlobalAlias**, std::vector<llvm::GlobalAlias*, std::allocator<llvm::GlobalAlias*> > >, llvm::GlobalAlias* const&)"),
	mu_demangle_test("_Z16GetHeapSROAValuePN4llvm5ValueEjRNS_8DenseMapIS1_St6vectorIS1_SaIS1_EENS_12DenseMapInfoIS1_EENS6_IS5_EEEERS3_ISt4pairIPNS_7PHINodeEjESaISE_EE", "GetHeapSROAValue(llvm::Value*, unsigned int, llvm::DenseMap<llvm::Value*, std::vector<llvm::Value*, std::allocator<llvm::Value*> >, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<std::vector<llvm::Value*, std::allocator<llvm::Value*> > > >&, std::vector<std::pair<llvm::PHINode*, unsigned int>, std::allocator<std::pair<llvm::PHINode*, unsigned int> > >&)"),
	mu_demangle_test("_Z23RewriteHeapSROALoadUserPN4llvm11InstructionERNS_8DenseMapIPNS_5ValueESt6vectorIS4_SaIS4_EENS_12DenseMapInfoIS4_EENS8_IS7_EEEERS5_ISt4pairIPNS_7PHINodeEjESaISG_EE", "RewriteHeapSROALoadUser(llvm::Instruction*, llvm::DenseMap<llvm::Value*, std::vector<llvm::Value*, std::allocator<llvm::Value*> >, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<std::vector<llvm::Value*, std::allocator<llvm::Value*> > > >&, std::vector<std::pair<llvm::PHINode*, unsigned int>, std::allocator<std::pair<llvm::PHINode*, unsigned int> > >&)"),
	mu_demangle_test("_Z16EvaluateFunctionPN4llvm8FunctionERPNS_8ConstantERKNS_15SmallVectorImplIS3_EERSt6vectorIS1_SaIS1_EERNS_8DenseMapIS3_S3_NS_12DenseMapInfoIS3_EESF_EERS9_IPNS_14GlobalVariableESaISJ_EERNS_11SmallPtrSetIS3_Lj8EEEPKNS_10DataLayoutE", "EvaluateFunction(llvm::Function*, llvm::Constant*&, llvm::SmallVectorImpl<llvm::Constant*> const&, std::vector<llvm::Function*, std::allocator<llvm::Function*> >&, llvm::DenseMap<llvm::Constant*, llvm::Constant*, llvm::DenseMapInfo<llvm::Constant*>, llvm::DenseMapInfo<llvm::Constant*> >&, std::vector<llvm::GlobalVariable*, std::allocator<llvm::GlobalVariable*> >&, llvm::SmallPtrSet<llvm::Constant*, 8u>&, llvm::DataLayout const*)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm5ValueESaIS2_EEaSERKS4_", "std::vector<llvm::Value*, std::allocator<llvm::Value*> >::operator=(std::vector<llvm::Value*, std::allocator<llvm::Value*> > const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPN4llvm7PHINodeEjESaIS4_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS4_S6_EERKS4_", "std::vector<std::pair<llvm::PHINode*, unsigned int>, std::allocator<std::pair<llvm::PHINode*, unsigned int> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::PHINode*, unsigned int>*, std::vector<std::pair<llvm::PHINode*, unsigned int>, std::allocator<std::pair<llvm::PHINode*, unsigned int> > > >, std::pair<llvm::PHINode*, unsigned int> const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm5ValueESaIS2_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS2_S4_EEmRKS2_", "std::vector<llvm::Value*, std::allocator<llvm::Value*> >::_M_fill_insert(__gnu_cxx::__normal_iterator<llvm::Value**, std::vector<llvm::Value*, std::allocator<llvm::Value*> > >, unsigned long, llvm::Value* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5ValueESt6vectorIS2_SaIS2_EENS_12DenseMapInfoIS2_EENS6_IS5_EEE6insertERKSt4pairIS2_S5_E", "llvm::DenseMap<llvm::Value*, std::vector<llvm::Value*, std::allocator<llvm::Value*> >, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<std::vector<llvm::Value*, std::allocator<llvm::Value*> > > >::insert(std::pair<llvm::Value*, std::vector<llvm::Value*, std::allocator<llvm::Value*> > > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5ValueESt6vectorIS2_SaIS2_EENS_12DenseMapInfoIS2_EENS6_IS5_EEE16InsertIntoBucketERKS2_RKS5_PSt4pairIS2_S5_E", "llvm::DenseMap<llvm::Value*, std::vector<llvm::Value*, std::allocator<llvm::Value*> >, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<std::vector<llvm::Value*, std::allocator<llvm::Value*> > > >::InsertIntoBucket(llvm::Value* const&, std::vector<llvm::Value*, std::allocator<llvm::Value*> > const&, std::pair<llvm::Value*, std::vector<llvm::Value*, std::allocator<llvm::Value*> > >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5ValueESt6vectorIS2_SaIS2_EENS_12DenseMapInfoIS2_EENS6_IS5_EEE4growEj", "llvm::DenseMap<llvm::Value*, std::vector<llvm::Value*, std::allocator<llvm::Value*> >, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<std::vector<llvm::Value*, std::allocator<llvm::Value*> > > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5ValueESt6vectorIS2_SaIS2_EENS_12DenseMapInfoIS2_EENS6_IS5_EEE16FindAndConstructERKS2_", "llvm::DenseMap<llvm::Value*, std::vector<llvm::Value*, std::allocator<llvm::Value*> >, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<std::vector<llvm::Value*, std::allocator<llvm::Value*> > > >::FindAndConstruct(llvm::Value* const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm5ValueESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::Value*, std::allocator<llvm::Value*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::Value**, std::vector<llvm::Value*, std::allocator<llvm::Value*> > >, llvm::Value* const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm14GlobalVariableESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::GlobalVariable*, std::allocator<llvm::GlobalVariable*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::GlobalVariable**, std::vector<llvm::GlobalVariable*, std::allocator<llvm::GlobalVariable*> > >, llvm::GlobalVariable* const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm8ConstantESaIS2_EE14_M_fill_assignEmRKS2_", "std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >::_M_fill_assign(unsigned long, llvm::Constant* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_8ConstantES2_NS_12DenseMapInfoIS2_EES4_E16InsertIntoBucketERKS2_S7_PSt4pairIS2_S2_E", "llvm::DenseMap<llvm::Constant*, llvm::Constant*, llvm::DenseMapInfo<llvm::Constant*>, llvm::DenseMapInfo<llvm::Constant*> >::InsertIntoBucket(llvm::Constant* const&, llvm::Constant* const&, std::pair<llvm::Constant*, llvm::Constant*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_8ConstantES2_NS_12DenseMapInfoIS2_EES4_E4growEj", "llvm::DenseMap<llvm::Constant*, llvm::Constant*, llvm::DenseMapInfo<llvm::Constant*>, llvm::DenseMapInfo<llvm::Constant*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5ValueEPNS_8ConstantENS_12DenseMapInfoIS2_EENS5_IS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<llvm::Value*, llvm::Constant*, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<llvm::Constant*> >::InsertIntoBucket(llvm::Value* const&, llvm::Constant* const&, std::pair<llvm::Value*, llvm::Constant*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5ValueEPNS_8ConstantENS_12DenseMapInfoIS2_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::Value*, llvm::Constant*, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<llvm::Constant*> >::grow(unsigned int)"),
	mu_demangle_test("_ZSt6__findIN9__gnu_cxx17__normal_iteratorIPPN4llvm8FunctionESt6vectorIS4_SaIS4_EEEES4_ET_SA_SA_RKT0_St26random_access_iterator_tag", "__gnu_cxx::__normal_iterator<llvm::Function**, std::vector<llvm::Function*, std::allocator<llvm::Function*> > > std::__find<__gnu_cxx::__normal_iterator<llvm::Function**, std::vector<llvm::Function*, std::allocator<llvm::Function*> > >, llvm::Function*>(__gnu_cxx::__normal_iterator<llvm::Function**, std::vector<llvm::Function*, std::allocator<llvm::Function*> > >, __gnu_cxx::__normal_iterator<llvm::Function**, std::vector<llvm::Function*, std::allocator<llvm::Function*> > >, llvm::Function* const&, std::random_access_iterator_tag)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm8FunctionESaIS2_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS2_S4_EEmRKS2_", "std::vector<llvm::Function*, std::allocator<llvm::Function*> >::_M_fill_insert(__gnu_cxx::__normal_iterator<llvm::Function**, std::vector<llvm::Function*, std::allocator<llvm::Function*> > >, unsigned long, llvm::Function* const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm18InlineCostAnalyzer7ArgInfoESaIS2_EEaSERKS4_", "std::vector<llvm::InlineCostAnalyzer::ArgInfo, std::allocator<llvm::InlineCostAnalyzer::ArgInfo> >::operator=(std::vector<llvm::InlineCostAnalyzer::ArgInfo, std::allocator<llvm::InlineCostAnalyzer::ArgInfo> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_10BasicBlockEjNS_12DenseMapInfoIS3_EENS4_IjEEE8CopyFromERKS7_", "llvm::DenseMap<llvm::BasicBlock const*, unsigned int, llvm::DenseMapInfo<llvm::BasicBlock const*>, llvm::DenseMapInfo<unsigned int> >::CopyFrom(llvm::DenseMap<llvm::BasicBlock const*, unsigned int, llvm::DenseMapInfo<llvm::BasicBlock const*>, llvm::DenseMapInfo<unsigned int> > const&)"),
	mu_demangle_test("_ZN4llvm18ValueMapCallbackVHIPKNS_8FunctionENS_18InlineCostAnalyzer12FunctionInfoENS_14ValueMapConfigIS3_EENS_12DenseMapInfoIS5_EEED1Ev", "llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >::~ValueMapCallbackVH()"),
	mu_demangle_test("_ZN4llvm18ValueMapCallbackVHIPKNS_8FunctionENS_18InlineCostAnalyzer12FunctionInfoENS_14ValueMapConfigIS3_EENS_12DenseMapInfoIS5_EEED0Ev", "llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >::~ValueMapCallbackVH()"),
	mu_demangle_test("_ZN4llvm18ValueMapCallbackVHIPKNS_8FunctionENS_18InlineCostAnalyzer12FunctionInfoENS_14ValueMapConfigIS3_EENS_12DenseMapInfoIS5_EEE7deletedEv", "llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >::deleted()"),
	mu_demangle_test("_ZN4llvm18ValueMapCallbackVHIPKNS_8FunctionENS_18InlineCostAnalyzer12FunctionInfoENS_14ValueMapConfigIS3_EENS_12DenseMapInfoIS5_EEE19allUsesReplacedWithEPNS_5ValueE", "llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >::allUsesReplacedWith(llvm::Value*)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_18ValueMapCallbackVHIPKNS_8FunctionENS_18InlineCostAnalyzer12FunctionInfoENS_14ValueMapConfigIS4_EENS_12DenseMapInfoIS6_EEEES6_NS9_ISB_EESA_E4findERKSB_", "llvm::DenseMap<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >, llvm::InlineCostAnalyzer::FunctionInfo, llvm::DenseMapInfo<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> > >, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >::find(llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_18ValueMapCallbackVHIPKNS_8FunctionENS_18InlineCostAnalyzer12FunctionInfoENS_14ValueMapConfigIS4_EENS_12DenseMapInfoIS6_EEEES6_NS9_ISB_EESA_E5eraseENS_16DenseMapIteratorISB_S6_SC_SA_Lb0EEE", "llvm::DenseMap<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >, llvm::InlineCostAnalyzer::FunctionInfo, llvm::DenseMapInfo<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> > >, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >::erase(llvm::DenseMapIterator<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >, llvm::InlineCostAnalyzer::FunctionInfo, llvm::DenseMapInfo<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> > >, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo>, false>)"),
	mu_demangle_test("_ZN4llvm8ValueMapIPKNS_8FunctionENS_18InlineCostAnalyzer12FunctionInfoENS_14ValueMapConfigIS3_EENS_12DenseMapInfoIS5_EEE6insertERKSt4pairIS3_S5_E", "llvm::ValueMap<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >::insert(std::pair<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_18ValueMapCallbackVHIPKNS_8FunctionENS_18InlineCostAnalyzer12FunctionInfoENS_14ValueMapConfigIS4_EENS_12DenseMapInfoIS6_EEEES6_NS9_ISB_EESA_E6insertERKSt4pairISB_S6_E", "llvm::DenseMap<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >, llvm::InlineCostAnalyzer::FunctionInfo, llvm::DenseMapInfo<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> > >, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >::insert(std::pair<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >, llvm::InlineCostAnalyzer::FunctionInfo> const&)"),
	mu_demangle_test("_ZNSt4pairIN4llvm18ValueMapCallbackVHIPKNS0_8FunctionENS0_18InlineCostAnalyzer12FunctionInfoENS0_14ValueMapConfigIS4_EENS0_12DenseMapInfoIS6_EEEES6_EC2ERKSB_RKS6_", "std::pair<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >, llvm::InlineCostAnalyzer::FunctionInfo>::pair(llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> > const&, llvm::InlineCostAnalyzer::FunctionInfo const&)"),
	mu_demangle_test("_ZNK4llvm8DenseMapINS_18ValueMapCallbackVHIPKNS_8FunctionENS_18InlineCostAnalyzer12FunctionInfoENS_14ValueMapConfigIS4_EENS_12DenseMapInfoIS6_EEEES6_NS9_ISB_EESA_E15LookupBucketForERKSB_RPSt4pairISB_S6_E", "llvm::DenseMap<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >, llvm::InlineCostAnalyzer::FunctionInfo, llvm::DenseMapInfo<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> > >, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >::LookupBucketFor(llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> > const&, std::pair<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >, llvm::InlineCostAnalyzer::FunctionInfo>*&) const"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_18ValueMapCallbackVHIPKNS_8FunctionENS_18InlineCostAnalyzer12FunctionInfoENS_14ValueMapConfigIS4_EENS_12DenseMapInfoIS6_EEEES6_NS9_ISB_EESA_E16InsertIntoBucketERKSB_RKS6_PSt4pairISB_S6_E", "llvm::DenseMap<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >, llvm::InlineCostAnalyzer::FunctionInfo, llvm::DenseMapInfo<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> > >, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >::InsertIntoBucket(llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> > const&, llvm::InlineCostAnalyzer::FunctionInfo const&, std::pair<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >, llvm::InlineCostAnalyzer::FunctionInfo>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_18ValueMapCallbackVHIPKNS_8FunctionENS_18InlineCostAnalyzer12FunctionInfoENS_14ValueMapConfigIS4_EENS_12DenseMapInfoIS6_EEEES6_NS9_ISB_EESA_E4growEj", "llvm::DenseMap<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >, llvm::InlineCostAnalyzer::FunctionInfo, llvm::DenseMapInfo<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> > >, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm18InlineCostAnalyzer7ArgInfoESaIS2_EEC2ERKS4_", "std::vector<llvm::InlineCostAnalyzer::ArgInfo, std::allocator<llvm::InlineCostAnalyzer::ArgInfo> >::vector(std::vector<llvm::InlineCostAnalyzer::ArgInfo, std::allocator<llvm::InlineCostAnalyzer::ArgInfo> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_18ValueMapCallbackVHIPKNS_8FunctionENS_18InlineCostAnalyzer12FunctionInfoENS_14ValueMapConfigIS4_EENS_12DenseMapInfoIS6_EEEES6_NS9_ISB_EESA_E5eraseERKSB_", "llvm::DenseMap<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >, llvm::InlineCostAnalyzer::FunctionInfo, llvm::DenseMapInfo<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> > >, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >::erase(llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_18ValueMapCallbackVHIPKNS_8FunctionENS_18InlineCostAnalyzer12FunctionInfoENS_14ValueMapConfigIS4_EENS_12DenseMapInfoIS6_EEEES6_NS9_ISB_EESA_E16FindAndConstructERKSB_", "llvm::DenseMap<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >, llvm::InlineCostAnalyzer::FunctionInfo, llvm::DenseMapInfo<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> > >, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >::FindAndConstruct(llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_18ValueMapCallbackVHIPKNS_8FunctionENS_18InlineCostAnalyzer12FunctionInfoENS_14ValueMapConfigIS4_EENS_12DenseMapInfoIS6_EEEES6_NS9_ISB_EESA_ED2Ev", "llvm::DenseMap<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >, llvm::InlineCostAnalyzer::FunctionInfo, llvm::DenseMapInfo<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> > >, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >::~DenseMap()"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_18ValueMapCallbackVHIPKNS_8FunctionENS_18InlineCostAnalyzer12FunctionInfoENS_14ValueMapConfigIS4_EENS_12DenseMapInfoIS6_EEEES6_NS9_ISB_EESA_E4initEj", "llvm::DenseMap<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >, llvm::InlineCostAnalyzer::FunctionInfo, llvm::DenseMapInfo<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> > >, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >::init(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_9ArrayTypeESt6vectorIPNS_10AllocaInstESaIS6_EENS_12DenseMapInfoIS3_EENS9_IS8_EEE16FindAndConstructERKS3_", "llvm::DenseMap<llvm::ArrayType const*, std::vector<llvm::AllocaInst*, std::allocator<llvm::AllocaInst*> >, llvm::DenseMapInfo<llvm::ArrayType const*>, llvm::DenseMapInfo<std::vector<llvm::AllocaInst*, std::allocator<llvm::AllocaInst*> > > >::FindAndConstruct(llvm::ArrayType const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_9ArrayTypeESt6vectorIPNS_10AllocaInstESaIS6_EENS_12DenseMapInfoIS3_EENS9_IS8_EEE16InsertIntoBucketERKS3_RKS8_PSt4pairIS3_S8_E", "llvm::DenseMap<llvm::ArrayType const*, std::vector<llvm::AllocaInst*, std::allocator<llvm::AllocaInst*> >, llvm::DenseMapInfo<llvm::ArrayType const*>, llvm::DenseMapInfo<std::vector<llvm::AllocaInst*, std::allocator<llvm::AllocaInst*> > > >::InsertIntoBucket(llvm::ArrayType const* const&, std::vector<llvm::AllocaInst*, std::allocator<llvm::AllocaInst*> > const&, std::pair<llvm::ArrayType const*, std::vector<llvm::AllocaInst*, std::allocator<llvm::AllocaInst*> > >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_9ArrayTypeESt6vectorIPNS_10AllocaInstESaIS6_EENS_12DenseMapInfoIS3_EENS9_IS8_EEE4growEj", "llvm::DenseMap<llvm::ArrayType const*, std::vector<llvm::AllocaInst*, std::allocator<llvm::AllocaInst*> >, llvm::DenseMapInfo<llvm::ArrayType const*>, llvm::DenseMapInfo<std::vector<llvm::AllocaInst*, std::allocator<llvm::AllocaInst*> > > >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm10BasicBlockESaIS2_EE22_M_initialize_dispatchINS0_12SuccIteratorIPNS0_14TerminatorInstES1_EEEEvT_SA_St12__false_type", "void std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> >::_M_initialize_dispatch<llvm::SuccIterator<llvm::TerminatorInst*, llvm::BasicBlock> >(llvm::SuccIterator<llvm::TerminatorInst*, llvm::BasicBlock>, llvm::SuccIterator<llvm::TerminatorInst*, llvm::BasicBlock>, std::__false_type)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm15BitstreamWriter9BlockInfoESaIS2_EE9push_backERKS2_", "std::vector<llvm::BitstreamWriter::BlockInfo, std::allocator<llvm::BitstreamWriter::BlockInfo> >::push_back(llvm::BitstreamWriter::BlockInfo const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm15BitstreamWriter9BlockInfoESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::BitstreamWriter::BlockInfo, std::allocator<llvm::BitstreamWriter::BlockInfo> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::BitstreamWriter::BlockInfo*, std::vector<llvm::BitstreamWriter::BlockInfo, std::allocator<llvm::BitstreamWriter::BlockInfo> > >, llvm::BitstreamWriter::BlockInfo const&)"),
	mu_demangle_test("_ZSt21__inplace_stable_sortIN9__gnu_cxx17__normal_iteratorIPSt4pairIPKN4llvm5ValueEjESt6vectorIS7_SaIS7_EEEEN12_GLOBAL__N_116CstSortPredicateEEvT_SF_T0_", "void std::__inplace_stable_sort<__gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, (anonymous namespace)::CstSortPredicate>(__gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, (anonymous namespace)::CstSortPredicate)"),
	mu_demangle_test("_ZSt22__stable_sort_adaptiveIN9__gnu_cxx17__normal_iteratorIPSt4pairIPKN4llvm5ValueEjESt6vectorIS7_SaIS7_EEEES8_lN12_GLOBAL__N_116CstSortPredicateEEvT_SF_T0_T1_T2_", "void std::__stable_sort_adaptive<__gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, std::pair<llvm::Value const*, unsigned int>*, long, (anonymous namespace)::CstSortPredicate>(__gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, std::pair<llvm::Value const*, unsigned int>*, long, (anonymous namespace)::CstSortPredicate)"),
	mu_demangle_test("_ZSt24__merge_sort_with_bufferIN9__gnu_cxx17__normal_iteratorIPSt4pairIPKN4llvm5ValueEjESt6vectorIS7_SaIS7_EEEES8_N12_GLOBAL__N_116CstSortPredicateEEvT_SF_T0_T1_", "void std::__merge_sort_with_buffer<__gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, std::pair<llvm::Value const*, unsigned int>*, (anonymous namespace)::CstSortPredicate>(__gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, std::pair<llvm::Value const*, unsigned int>*, (anonymous namespace)::CstSortPredicate)"),
	mu_demangle_test("_ZSt16__merge_adaptiveIN9__gnu_cxx17__normal_iteratorIPSt4pairIPKN4llvm5ValueEjESt6vectorIS7_SaIS7_EEEElS8_N12_GLOBAL__N_116CstSortPredicateEEvT_SF_SF_T0_SG_T1_SG_T2_", "void std::__merge_adaptive<__gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, long, std::pair<llvm::Value const*, unsigned int>*, (anonymous namespace)::CstSortPredicate>(__gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, long, long, std::pair<llvm::Value const*, unsigned int>*, long, (anonymous namespace)::CstSortPredicate)"),
	mu_demangle_test("_ZSt5mergeIN9__gnu_cxx17__normal_iteratorIPSt4pairIPKN4llvm5ValueEjESt6vectorIS7_SaIS7_EEEESC_S8_N12_GLOBAL__N_116CstSortPredicateEET1_T_SG_T0_SH_SF_T2_", "std::pair<llvm::Value const*, unsigned int>* std::merge<__gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, std::pair<llvm::Value const*, unsigned int>*, (anonymous namespace)::CstSortPredicate>(__gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, std::pair<llvm::Value const*, unsigned int>*, (anonymous namespace)::CstSortPredicate)"),
	mu_demangle_test("_ZSt16__insertion_sortIN9__gnu_cxx17__normal_iteratorIPSt4pairIPKN4llvm5ValueEjESt6vectorIS7_SaIS7_EEEEN12_GLOBAL__N_116CstSortPredicateEEvT_SF_T0_", "void std::__insertion_sort<__gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, (anonymous namespace)::CstSortPredicate>(__gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, (anonymous namespace)::CstSortPredicate)"),
	mu_demangle_test("_ZSt22__merge_without_bufferIN9__gnu_cxx17__normal_iteratorIPSt4pairIPKN4llvm5ValueEjESt6vectorIS7_SaIS7_EEEElN12_GLOBAL__N_116CstSortPredicateEEvT_SF_SF_T0_SG_T1_", "void std::__merge_without_buffer<__gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, long, (anonymous namespace)::CstSortPredicate>(__gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, long, long, (anonymous namespace)::CstSortPredicate)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPKN4llvm5ValueEjESaIS5_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS5_S7_EEmRKS5_", "std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > >::_M_fill_insert(__gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, unsigned long, std::pair<llvm::Value const*, unsigned int> const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPKN4llvm4TypeEjESaIS5_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS5_S7_EERKS5_", "std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, std::pair<llvm::Type const*, unsigned int> const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPKN4llvm5ValueEjESaIS5_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS5_S7_EERKS5_", "std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, std::pair<llvm::Value const*, unsigned int> const&)"),
	mu_demangle_test("_ZSt17__rotate_adaptiveIN9__gnu_cxx17__normal_iteratorIPSt4pairIPKN4llvm5ValueEjESt6vectorIS7_SaIS7_EEEES8_lET_SD_SD_SD_T1_SE_T0_SE_", "__gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > > std::__rotate_adaptive<__gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, std::pair<llvm::Value const*, unsigned int>*, long>(__gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, long, long, std::pair<llvm::Value const*, unsigned int>*, long)"),
	mu_demangle_test("_ZSt8__rotateIN9__gnu_cxx17__normal_iteratorIPSt4pairIPKN4llvm5ValueEjESt6vectorIS7_SaIS7_EEEEEvT_SD_SD_St26random_access_iterator_tag", "void std::__rotate<__gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > > >(__gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Value const*, unsigned int>*, std::vector<std::pair<llvm::Value const*, unsigned int>, std::allocator<std::pair<llvm::Value const*, unsigned int> > > >, std::random_access_iterator_tag)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4TypeEjNS_12DenseMapInfoIS3_EENS4_IjEEE16InsertIntoBucketERKS3_RKjPSt4pairIS3_jE", "llvm::DenseMap<llvm::Type const*, unsigned int, llvm::DenseMapInfo<llvm::Type const*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(llvm::Type const* const&, unsigned int const&, std::pair<llvm::Type const*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4TypeEjNS_12DenseMapInfoIS3_EENS4_IjEEE4growEj", "llvm::DenseMap<llvm::Type const*, unsigned int, llvm::DenseMapInfo<llvm::Type const*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZSt21__inplace_stable_sortIN9__gnu_cxx17__normal_iteratorIPSt4pairIPKN4llvm4TypeEjESt6vectorIS7_SaIS7_EEEEPFbRKS7_SE_EEvT_SH_T0_", "void std::__inplace_stable_sort<__gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, bool (*)(std::pair<llvm::Type const*, unsigned int> const&, std::pair<llvm::Type const*, unsigned int> const&)>(__gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, bool (*)(std::pair<llvm::Type const*, unsigned int> const&, std::pair<llvm::Type const*, unsigned int> const&))"),
	mu_demangle_test("_ZSt22__stable_sort_adaptiveIN9__gnu_cxx17__normal_iteratorIPSt4pairIPKN4llvm4TypeEjESt6vectorIS7_SaIS7_EEEES8_lPFbRKS7_SE_EEvT_SH_T0_T1_T2_", "void std::__stable_sort_adaptive<__gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, std::pair<llvm::Type const*, unsigned int>*, long, bool (*)(std::pair<llvm::Type const*, unsigned int> const&, std::pair<llvm::Type const*, unsigned int> const&)>(__gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, std::pair<llvm::Type const*, unsigned int>*, long, bool (*)(std::pair<llvm::Type const*, unsigned int> const&, std::pair<llvm::Type const*, unsigned int> const&))"),
	mu_demangle_test("_ZSt24__merge_sort_with_bufferIN9__gnu_cxx17__normal_iteratorIPSt4pairIPKN4llvm4TypeEjESt6vectorIS7_SaIS7_EEEES8_PFbRKS7_SE_EEvT_SH_T0_T1_", "void std::__merge_sort_with_buffer<__gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, std::pair<llvm::Type const*, unsigned int>*, bool (*)(std::pair<llvm::Type const*, unsigned int> const&, std::pair<llvm::Type const*, unsigned int> const&)>(__gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, std::pair<llvm::Type const*, unsigned int>*, bool (*)(std::pair<llvm::Type const*, unsigned int> const&, std::pair<llvm::Type const*, unsigned int> const&))"),
	mu_demangle_test("_ZSt16__merge_adaptiveIN9__gnu_cxx17__normal_iteratorIPSt4pairIPKN4llvm4TypeEjESt6vectorIS7_SaIS7_EEEElS8_PFbRKS7_SE_EEvT_SH_SH_T0_SI_T1_SI_T2_", "void std::__merge_adaptive<__gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, long, std::pair<llvm::Type const*, unsigned int>*, bool (*)(std::pair<llvm::Type const*, unsigned int> const&, std::pair<llvm::Type const*, unsigned int> const&)>(__gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, long, long, std::pair<llvm::Type const*, unsigned int>*, long, bool (*)(std::pair<llvm::Type const*, unsigned int> const&, std::pair<llvm::Type const*, unsigned int> const&))"),
	mu_demangle_test("_ZSt16__merge_backwardIN9__gnu_cxx17__normal_iteratorIPSt4pairIPKN4llvm4TypeEjESt6vectorIS7_SaIS7_EEEES8_SC_PFbRKS7_SE_EET1_T_SI_T0_SJ_SH_T2_", "__gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > > std::__merge_backward<__gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, std::pair<llvm::Type const*, unsigned int>*, __gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, bool (*)(std::pair<llvm::Type const*, unsigned int> const&, std::pair<llvm::Type const*, unsigned int> const&)>(__gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, std::pair<llvm::Type const*, unsigned int>*, std::pair<llvm::Type const*, unsigned int>*, __gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, bool (*)(std::pair<llvm::Type const*, unsigned int> const&, std::pair<llvm::Type const*, unsigned int> const&))"),
	mu_demangle_test("_ZSt17__rotate_adaptiveIN9__gnu_cxx17__normal_iteratorIPSt4pairIPKN4llvm4TypeEjESt6vectorIS7_SaIS7_EEEES8_lET_SD_SD_SD_T1_SE_T0_SE_", "__gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > > std::__rotate_adaptive<__gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, std::pair<llvm::Type const*, unsigned int>*, long>(__gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, long, long, std::pair<llvm::Type const*, unsigned int>*, long)"),
	mu_demangle_test("_ZSt8__rotateIN9__gnu_cxx17__normal_iteratorIPSt4pairIPKN4llvm4TypeEjESt6vectorIS7_SaIS7_EEEEEvT_SD_SD_St26random_access_iterator_tag", "void std::__rotate<__gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > > >(__gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, std::random_access_iterator_tag)"),
	mu_demangle_test("_ZSt17__merge_sort_loopIN9__gnu_cxx17__normal_iteratorIPSt4pairIPKN4llvm4TypeEjESt6vectorIS7_SaIS7_EEEES8_lPFbRKS7_SE_EEvT_SH_T0_T1_T2_", "void std::__merge_sort_loop<__gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, std::pair<llvm::Type const*, unsigned int>*, long, bool (*)(std::pair<llvm::Type const*, unsigned int> const&, std::pair<llvm::Type const*, unsigned int> const&)>(__gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, std::pair<llvm::Type const*, unsigned int>*, long, bool (*)(std::pair<llvm::Type const*, unsigned int> const&, std::pair<llvm::Type const*, unsigned int> const&))"),
	mu_demangle_test("_ZSt17__merge_sort_loopIPSt4pairIPKN4llvm4TypeEjEN9__gnu_cxx17__normal_iteratorIS6_St6vectorIS5_SaIS5_EEEElPFbRKS5_SE_EEvT_SH_T0_T1_T2_", "void std::__merge_sort_loop<std::pair<llvm::Type const*, unsigned int>*, __gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, long, bool (*)(std::pair<llvm::Type const*, unsigned int> const&, std::pair<llvm::Type const*, unsigned int> const&)>(std::pair<llvm::Type const*, unsigned int>*, std::pair<llvm::Type const*, unsigned int>*, __gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, long, bool (*)(std::pair<llvm::Type const*, unsigned int> const&, std::pair<llvm::Type const*, unsigned int> const&))"),
	mu_demangle_test("_ZSt16__insertion_sortIN9__gnu_cxx17__normal_iteratorIPSt4pairIPKN4llvm4TypeEjESt6vectorIS7_SaIS7_EEEEPFbRKS7_SE_EEvT_SH_T0_", "void std::__insertion_sort<__gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, bool (*)(std::pair<llvm::Type const*, unsigned int> const&, std::pair<llvm::Type const*, unsigned int> const&)>(__gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, bool (*)(std::pair<llvm::Type const*, unsigned int> const&, std::pair<llvm::Type const*, unsigned int> const&))"),
	mu_demangle_test("_ZSt22__merge_without_bufferIN9__gnu_cxx17__normal_iteratorIPSt4pairIPKN4llvm4TypeEjESt6vectorIS7_SaIS7_EEEElPFbRKS7_SE_EEvT_SH_SH_T0_SI_T1_", "void std::__merge_without_buffer<__gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, long, bool (*)(std::pair<llvm::Type const*, unsigned int> const&, std::pair<llvm::Type const*, unsigned int> const&)>(__gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, unsigned int>*, std::vector<std::pair<llvm::Type const*, unsigned int>, std::allocator<std::pair<llvm::Type const*, unsigned int> > > >, long, long, bool (*)(std::pair<llvm::Type const*, unsigned int> const&, std::pair<llvm::Type const*, unsigned int> const&))"),
	mu_demangle_test("_ZNSt6vectorIN4llvm12PATypeHolderESaIS1_EE7reserveEm", "std::vector<llvm::PATypeHolder, std::allocator<llvm::PATypeHolder> >::reserve(unsigned long)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm10BasicBlockESaIS2_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS2_S4_EEmRKS2_", "std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> >::_M_fill_insert(__gnu_cxx::__normal_iterator<llvm::BasicBlock**, std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> > >, unsigned long, llvm::BasicBlock* const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm8FunctionESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::Function*, std::allocator<llvm::Function*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::Function**, std::vector<llvm::Function*, std::allocator<llvm::Function*> > >, llvm::Function* const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPN4llvm8FunctionES3_ESaIS4_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS4_S6_EERKS4_", "std::vector<std::pair<llvm::Function*, llvm::Function*>, std::allocator<std::pair<llvm::Function*, llvm::Function*> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::Function*, llvm::Function*>*, std::vector<std::pair<llvm::Function*, llvm::Function*>, std::allocator<std::pair<llvm::Function*, llvm::Function*> > > >, std::pair<llvm::Function*, llvm::Function*> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_8FunctionEyNS_12DenseMapInfoIS2_EENS3_IyEEE16InsertIntoBucketERKS2_RKyPSt4pairIS2_yE", "llvm::DenseMap<llvm::Function*, uint64_t, llvm::DenseMapInfo<llvm::Function*>, llvm::DenseMapInfo<uint64_t> >::InsertIntoBucket(llvm::Function* const&, uint64_t const&, std::pair<llvm::Function*, uint64_t>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_8FunctionEyNS_12DenseMapInfoIS2_EENS3_IyEEE4growEj", "llvm::DenseMap<llvm::Function*, uint64_t, llvm::DenseMapInfo<llvm::Function*>, llvm::DenseMapInfo<uint64_t> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIjPN4llvm14GlobalVariableEESaIS4_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS4_S6_EERKS4_", "std::vector<std::pair<unsigned int, llvm::GlobalVariable*>, std::allocator<std::pair<unsigned int, llvm::GlobalVariable*> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<unsigned int, llvm::GlobalVariable*>*, std::vector<std::pair<unsigned int, llvm::GlobalVariable*>, std::allocator<std::pair<unsigned int, llvm::GlobalVariable*> > > >, std::pair<unsigned int, llvm::GlobalVariable*> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_8FunctionESt6vectorISt4pairIjPNS_14GlobalVariableEESaIS7_EENS_12DenseMapInfoIS2_EENSA_IS9_EEE16FindAndConstructERKS2_", "llvm::DenseMap<llvm::Function*, std::vector<std::pair<unsigned int, llvm::GlobalVariable*>, std::allocator<std::pair<unsigned int, llvm::GlobalVariable*> > >, llvm::DenseMapInfo<llvm::Function*>, llvm::DenseMapInfo<std::vector<std::pair<unsigned int, llvm::GlobalVariable*>, std::allocator<std::pair<unsigned int, llvm::GlobalVariable*> > > > >::FindAndConstruct(llvm::Function* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_8FunctionESt6vectorISt4pairIjPNS_14GlobalVariableEESaIS7_EENS_12DenseMapInfoIS2_EENSA_IS9_EEE16InsertIntoBucketERKS2_RKS9_PS4_IS2_S9_E", "llvm::DenseMap<llvm::Function*, std::vector<std::pair<unsigned int, llvm::GlobalVariable*>, std::allocator<std::pair<unsigned int, llvm::GlobalVariable*> > >, llvm::DenseMapInfo<llvm::Function*>, llvm::DenseMapInfo<std::vector<std::pair<unsigned int, llvm::GlobalVariable*>, std::allocator<std::pair<unsigned int, llvm::GlobalVariable*> > > > >::InsertIntoBucket(llvm::Function* const&, std::vector<std::pair<unsigned int, llvm::GlobalVariable*>, std::allocator<std::pair<unsigned int, llvm::GlobalVariable*> > > const&, std::pair<llvm::Function*, std::vector<std::pair<unsigned int, llvm::GlobalVariable*>, std::allocator<std::pair<unsigned int, llvm::GlobalVariable*> > > >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_8FunctionESt6vectorISt4pairIjPNS_14GlobalVariableEESaIS7_EENS_12DenseMapInfoIS2_EENSA_IS9_EEE4growEj", "llvm::DenseMap<llvm::Function*, std::vector<std::pair<unsigned int, llvm::GlobalVariable*>, std::allocator<std::pair<unsigned int, llvm::GlobalVariable*> > >, llvm::DenseMapInfo<llvm::Function*>, llvm::DenseMapInfo<std::vector<std::pair<unsigned int, llvm::GlobalVariable*>, std::allocator<std::pair<unsigned int, llvm::GlobalVariable*> > > > >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIjPN4llvm14GlobalVariableEESaIS4_EEC2ERKS6_", "std::vector<std::pair<unsigned int, llvm::GlobalVariable*>, std::allocator<std::pair<unsigned int, llvm::GlobalVariable*> > >::vector(std::vector<std::pair<unsigned int, llvm::GlobalVariable*>, std::allocator<std::pair<unsigned int, llvm::GlobalVariable*> > > const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPN4llvm11GlobalAliasEjESaIS4_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS4_S6_EERKS4_", "std::vector<std::pair<llvm::GlobalAlias*, unsigned int>, std::allocator<std::pair<llvm::GlobalAlias*, unsigned int> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::GlobalAlias*, unsigned int>*, std::vector<std::pair<llvm::GlobalAlias*, unsigned int>, std::allocator<std::pair<llvm::GlobalAlias*, unsigned int> > > >, std::pair<llvm::GlobalAlias*, unsigned int> const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPN4llvm14GlobalVariableEjESaIS4_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS4_S6_EERKS4_", "std::vector<std::pair<llvm::GlobalVariable*, unsigned int>, std::allocator<std::pair<llvm::GlobalVariable*, unsigned int> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::GlobalVariable*, unsigned int>*, std::vector<std::pair<llvm::GlobalVariable*, unsigned int>, std::allocator<std::pair<llvm::GlobalVariable*, unsigned int> > > >, std::pair<llvm::GlobalVariable*, unsigned int> const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm11AttrListPtrESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<llvm::AttrListPtr, std::allocator<llvm::AttrListPtr> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::AttrListPtr*, std::vector<llvm::AttrListPtr, std::allocator<llvm::AttrListPtr> > >, llvm::AttrListPtr const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm12PATypeHolderESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<llvm::PATypeHolder, std::allocator<llvm::PATypeHolder> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::PATypeHolder*, std::vector<llvm::PATypeHolder, std::allocator<llvm::PATypeHolder> > >, llvm::PATypeHolder const&)"),
	mu_demangle_test("_ZSt16__introsort_loopIN9__gnu_cxx17__normal_iteratorIPSt4pairIPN4llvm8ConstantEjESt6vectorIS6_SaIS6_EEEElEvT_SC_T0_", "void std::__introsort_loop<__gnu_cxx::__normal_iterator<std::pair<llvm::Constant*, unsigned int>*, std::vector<std::pair<llvm::Constant*, unsigned int>, std::allocator<std::pair<llvm::Constant*, unsigned int> > > >, long>(__gnu_cxx::__normal_iterator<std::pair<llvm::Constant*, unsigned int>*, std::vector<std::pair<llvm::Constant*, unsigned int>, std::allocator<std::pair<llvm::Constant*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Constant*, unsigned int>*, std::vector<std::pair<llvm::Constant*, unsigned int>, std::allocator<std::pair<llvm::Constant*, unsigned int> > > >, long)"),
	mu_demangle_test("_ZSt22__final_insertion_sortIN9__gnu_cxx17__normal_iteratorIPSt4pairIPN4llvm8ConstantEjESt6vectorIS6_SaIS6_EEEEEvT_SC_", "void std::__final_insertion_sort<__gnu_cxx::__normal_iterator<std::pair<llvm::Constant*, unsigned int>*, std::vector<std::pair<llvm::Constant*, unsigned int>, std::allocator<std::pair<llvm::Constant*, unsigned int> > > > >(__gnu_cxx::__normal_iterator<std::pair<llvm::Constant*, unsigned int>*, std::vector<std::pair<llvm::Constant*, unsigned int>, std::allocator<std::pair<llvm::Constant*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Constant*, unsigned int>*, std::vector<std::pair<llvm::Constant*, unsigned int>, std::allocator<std::pair<llvm::Constant*, unsigned int> > > >)"),
	mu_demangle_test("_ZSt16__insertion_sortIN9__gnu_cxx17__normal_iteratorIPSt4pairIPN4llvm8ConstantEjESt6vectorIS6_SaIS6_EEEEEvT_SC_", "void std::__insertion_sort<__gnu_cxx::__normal_iterator<std::pair<llvm::Constant*, unsigned int>*, std::vector<std::pair<llvm::Constant*, unsigned int>, std::allocator<std::pair<llvm::Constant*, unsigned int> > > > >(__gnu_cxx::__normal_iterator<std::pair<llvm::Constant*, unsigned int>*, std::vector<std::pair<llvm::Constant*, unsigned int>, std::allocator<std::pair<llvm::Constant*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Constant*, unsigned int>*, std::vector<std::pair<llvm::Constant*, unsigned int>, std::allocator<std::pair<llvm::Constant*, unsigned int> > > >)"),
	mu_demangle_test("_ZSt13__heap_selectIN9__gnu_cxx17__normal_iteratorIPSt4pairIPN4llvm8ConstantEjESt6vectorIS6_SaIS6_EEEEEvT_SC_SC_", "void std::__heap_select<__gnu_cxx::__normal_iterator<std::pair<llvm::Constant*, unsigned int>*, std::vector<std::pair<llvm::Constant*, unsigned int>, std::allocator<std::pair<llvm::Constant*, unsigned int> > > > >(__gnu_cxx::__normal_iterator<std::pair<llvm::Constant*, unsigned int>*, std::vector<std::pair<llvm::Constant*, unsigned int>, std::allocator<std::pair<llvm::Constant*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Constant*, unsigned int>*, std::vector<std::pair<llvm::Constant*, unsigned int>, std::allocator<std::pair<llvm::Constant*, unsigned int> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::Constant*, unsigned int>*, std::vector<std::pair<llvm::Constant*, unsigned int>, std::allocator<std::pair<llvm::Constant*, unsigned int> > > >)"),
	mu_demangle_test("_ZSt13__adjust_heapIN9__gnu_cxx17__normal_iteratorIPSt4pairIPN4llvm8ConstantEjESt6vectorIS6_SaIS6_EEEElS6_EvT_T0_SD_T1_", "void std::__adjust_heap<__gnu_cxx::__normal_iterator<std::pair<llvm::Constant*, unsigned int>*, std::vector<std::pair<llvm::Constant*, unsigned int>, std::allocator<std::pair<llvm::Constant*, unsigned int> > > >, long, std::pair<llvm::Constant*, unsigned int> >(__gnu_cxx::__normal_iterator<std::pair<llvm::Constant*, unsigned int>*, std::vector<std::pair<llvm::Constant*, unsigned int>, std::allocator<std::pair<llvm::Constant*, unsigned int> > > >, long, long, std::pair<llvm::Constant*, unsigned int>)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPN4llvm8ConstantEjESaIS4_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS4_S6_EERKS4_", "std::vector<std::pair<llvm::Constant*, unsigned int>, std::allocator<std::pair<llvm::Constant*, unsigned int> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::Constant*, unsigned int>*, std::vector<std::pair<llvm::Constant*, unsigned int>, std::allocator<std::pair<llvm::Constant*, unsigned int> > > >, std::pair<llvm::Constant*, unsigned int> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjjNS_12DenseMapInfoIjEES2_E16shrink_and_clearEv", "llvm::DenseMap<unsigned int, unsigned int, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<unsigned int> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_8FunctionEyNS_12DenseMapInfoIS2_EENS3_IyEEE16shrink_and_clearEv", "llvm::DenseMap<llvm::Function*, uint64_t, llvm::DenseMapInfo<llvm::Function*>, llvm::DenseMapInfo<uint64_t> >::shrink_and_clear()"),
	mu_demangle_test("_ZNSt6vectorIN4llvm6WeakVHESaIS1_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS1_S3_EEmRKS1_", "std::vector<llvm::WeakVH, std::allocator<llvm::WeakVH> >::_M_fill_insert(__gnu_cxx::__normal_iterator<llvm::WeakVH*, std::vector<llvm::WeakVH, std::allocator<llvm::WeakVH> > >, unsigned long, llvm::WeakVH const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm6WeakVHESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<llvm::WeakVH, std::allocator<llvm::WeakVH> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::WeakVH*, std::vector<llvm::WeakVH, std::allocator<llvm::WeakVH> > >, llvm::WeakVH const&)"),
	mu_demangle_test("_ZN4llvm8LLParser31ResolveForwardRefBlockAddressesEPNS_8FunctionERSt6vectorISt4pairINS_5ValIDEPNS_11GlobalValueEESaIS8_EEPNS0_16PerFunctionStateE", "llvm::LLParser::ResolveForwardRefBlockAddresses(llvm::Function*, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > >&, llvm::LLParser::PerFunctionState*)"),
	mu_demangle_test("_ZN4llvm8LLParser17ParseArgumentListERSt6vectorINS0_7ArgInfoESaIS2_EERbb", "llvm::LLParser::ParseArgumentList(std::vector<llvm::LLParser::ArgInfo, std::allocator<llvm::LLParser::ArgInfo> >&, bool&, bool)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_11InstructionESt6vectorINS_8LLParser5MDRefESaIS5_EENS_12DenseMapInfoIS2_EENS8_IS7_EEE5clearEv", "llvm::DenseMap<llvm::Instruction*, std::vector<llvm::LLParser::MDRef, std::allocator<llvm::LLParser::MDRef> >, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<std::vector<llvm::LLParser::MDRef, std::allocator<llvm::LLParser::MDRef> > > >::clear()"),
	mu_demangle_test("_ZNSt3mapIjSt4pairIN4llvm10TrackingVHINS1_6MDNodeEEENS1_5SMLocEESt4lessIjESaIS0_IKjS6_EEEixERS9_", "std::map<unsigned int, std::pair<llvm::TrackingVH<llvm::MDNode>, llvm::SMLoc>, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, std::pair<llvm::TrackingVH<llvm::MDNode>, llvm::SMLoc> > > >::operator[](unsigned int const&)"),
	mu_demangle_test("_ZNSt3mapISsSt4pairIPN4llvm11GlobalValueENS1_5SMLocEESt4lessISsESaIS0_IKSsS5_EEEixERS8_", "std::map<std::string, std::pair<llvm::GlobalValue*, llvm::SMLoc>, std::less<std::string>, std::allocator<std::pair<std::string const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > > >::operator[](std::string const&)"),
	mu_demangle_test("_ZNSt3mapISsSt4pairIPN4llvm5ValueENS1_5SMLocEESt4lessISsESaIS0_IKSsS5_EEEixERS8_", "std::map<std::string, std::pair<llvm::Value*, llvm::SMLoc>, std::less<std::string>, std::allocator<std::pair<std::string const, std::pair<llvm::Value*, llvm::SMLoc> > > >::operator[](std::string const&)"),
	mu_demangle_test("_ZNSt3mapIN4llvm5ValIDESt6vectorISt4pairIS1_PNS0_11GlobalValueEESaIS6_EESt4lessIS1_ESaIS3_IKS1_S8_EEEixERSB_", "std::map<llvm::ValID, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > >, std::less<llvm::ValID>, std::allocator<std::pair<llvm::ValID const, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > > > >::operator[](llvm::ValID const&)"),
	mu_demangle_test("_ZN9__gnu_cxx13new_allocatorISt4pairIN4llvm5ValIDEPNS2_11GlobalValueEEE9constructEPS6_RKS6_", "__gnu_cxx::new_allocator<std::pair<llvm::ValID, llvm::GlobalValue*> >::construct(std::pair<llvm::ValID, llvm::GlobalValue*>*, std::pair<llvm::ValID, llvm::GlobalValue*> const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN4llvm5ValIDEPNS1_11GlobalValueEESaIS5_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS5_S7_EERKS5_", "std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::ValID, llvm::GlobalValue*>*, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > >, std::pair<llvm::ValID, llvm::GlobalValue*> const&)"),
	mu_demangle_test("_ZNSt4pairIKN4llvm5ValIDESt6vectorIS_IS1_PNS0_11GlobalValueEESaIS6_EEEC2ERS2_RKS8_", "std::pair<llvm::ValID const, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > >::pair(llvm::ValID const&, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > const&)"),
	mu_demangle_test("_ZSt24__uninitialized_copy_auxIN9__gnu_cxx17__normal_iteratorIPKSt4pairIN4llvm5ValIDEPNS3_11GlobalValueEESt6vectorIS7_SaIS7_EEEEPS7_ET0_T_SG_SF_St12__false_type", "std::pair<llvm::ValID, llvm::GlobalValue*>* std::__uninitialized_copy_aux<__gnu_cxx::__normal_iterator<std::pair<llvm::ValID, llvm::GlobalValue*> const*, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > >, std::pair<llvm::ValID, llvm::GlobalValue*>*>(__gnu_cxx::__normal_iterator<std::pair<llvm::ValID, llvm::GlobalValue*> const*, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::ValID, llvm::GlobalValue*> const*, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > >, std::pair<llvm::ValID, llvm::GlobalValue*>*, std::__false_type)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm5ValIDESt4pairIKS1_St6vectorIS2_IS1_PNS0_11GlobalValueEESaIS7_EEESt10_Select1stISA_ESt4lessIS1_ESaISA_EE16_M_insert_uniqueESt17_Rb_tree_iteratorISA_ERKSA_", "std::_Rb_tree<llvm::ValID, std::pair<llvm::ValID const, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > >, std::_Select1st<std::pair<llvm::ValID const, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > > >, std::less<llvm::ValID>, std::allocator<std::pair<llvm::ValID const, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::ValID const, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > > >, std::pair<llvm::ValID const, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm5ValIDESt4pairIKS1_St6vectorIS2_IS1_PNS0_11GlobalValueEESaIS7_EEESt10_Select1stISA_ESt4lessIS1_ESaISA_EE9_M_insertEPSt18_Rb_tree_node_baseSI_RKSA_", "std::_Rb_tree<llvm::ValID, std::pair<llvm::ValID const, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > >, std::_Select1st<std::pair<llvm::ValID const, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > > >, std::less<llvm::ValID>, std::allocator<std::pair<llvm::ValID const, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > > > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<llvm::ValID const, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm5ValIDESt4pairIKS1_St6vectorIS2_IS1_PNS0_11GlobalValueEESaIS7_EEESt10_Select1stISA_ESt4lessIS1_ESaISA_EE16_M_insert_uniqueERKSA_", "std::_Rb_tree<llvm::ValID, std::pair<llvm::ValID const, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > >, std::_Select1st<std::pair<llvm::ValID const, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > > >, std::less<llvm::ValID>, std::allocator<std::pair<llvm::ValID const, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > > > >::_M_insert_unique(std::pair<llvm::ValID const, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > > const&)"),
	mu_demangle_test("_ZNSt4pairIKN4llvm5ValIDESt6vectorIS_IS1_PNS0_11GlobalValueEESaIS6_EEEC2ERKS9_", "std::pair<llvm::ValID const, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > >::pair(std::pair<llvm::ValID const, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsS0_IPN4llvm5ValueENS2_5SMLocEEESt10_Select1stIS7_ESt4lessISsESaIS7_EE11equal_rangeERS1_", "std::_Rb_tree<std::string, std::pair<std::string const, std::pair<llvm::Value*, llvm::SMLoc> >, std::_Select1st<std::pair<std::string const, std::pair<llvm::Value*, llvm::SMLoc> > >, std::less<std::string>, std::allocator<std::pair<std::string const, std::pair<llvm::Value*, llvm::SMLoc> > > >::equal_range(std::string const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsS0_IPN4llvm5ValueENS2_5SMLocEEESt10_Select1stIS7_ESt4lessISsESaIS7_EE5eraseESt17_Rb_tree_iteratorIS7_ESF_", "std::_Rb_tree<std::string, std::pair<std::string const, std::pair<llvm::Value*, llvm::SMLoc> >, std::_Select1st<std::pair<std::string const, std::pair<llvm::Value*, llvm::SMLoc> > >, std::less<std::string>, std::allocator<std::pair<std::string const, std::pair<llvm::Value*, llvm::SMLoc> > > >::erase(std::_Rb_tree_iterator<std::pair<std::string const, std::pair<llvm::Value*, llvm::SMLoc> > >, std::_Rb_tree_iterator<std::pair<std::string const, std::pair<llvm::Value*, llvm::SMLoc> > >)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsS0_IPN4llvm5ValueENS2_5SMLocEEESt10_Select1stIS7_ESt4lessISsESaIS7_EE8_M_eraseEPSt13_Rb_tree_nodeIS7_E", "std::_Rb_tree<std::string, std::pair<std::string const, std::pair<llvm::Value*, llvm::SMLoc> >, std::_Select1st<std::pair<std::string const, std::pair<llvm::Value*, llvm::SMLoc> > >, std::less<std::string>, std::allocator<std::pair<std::string const, std::pair<llvm::Value*, llvm::SMLoc> > > >::_M_erase(std::_Rb_tree_node<std::pair<std::string const, std::pair<llvm::Value*, llvm::SMLoc> > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjS0_IPN4llvm5ValueENS2_5SMLocEEESt10_Select1stIS7_ESt4lessIjESaIS7_EE5eraseESt17_Rb_tree_iteratorIS7_ESF_", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, std::pair<llvm::Value*, llvm::SMLoc> >, std::_Select1st<std::pair<unsigned int const, std::pair<llvm::Value*, llvm::SMLoc> > >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, std::pair<llvm::Value*, llvm::SMLoc> > > >::erase(std::_Rb_tree_iterator<std::pair<unsigned int const, std::pair<llvm::Value*, llvm::SMLoc> > >, std::_Rb_tree_iterator<std::pair<unsigned int const, std::pair<llvm::Value*, llvm::SMLoc> > >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjS0_IPN4llvm5ValueENS2_5SMLocEEESt10_Select1stIS7_ESt4lessIjESaIS7_EE8_M_eraseEPSt13_Rb_tree_nodeIS7_E", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, std::pair<llvm::Value*, llvm::SMLoc> >, std::_Select1st<std::pair<unsigned int const, std::pair<llvm::Value*, llvm::SMLoc> > >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, std::pair<llvm::Value*, llvm::SMLoc> > > >::_M_erase(std::_Rb_tree_node<std::pair<unsigned int const, std::pair<llvm::Value*, llvm::SMLoc> > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjS0_IPN4llvm5ValueENS2_5SMLocEEESt10_Select1stIS7_ESt4lessIjESaIS7_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS7_ERKS7_", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, std::pair<llvm::Value*, llvm::SMLoc> >, std::_Select1st<std::pair<unsigned int const, std::pair<llvm::Value*, llvm::SMLoc> > >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, std::pair<llvm::Value*, llvm::SMLoc> > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<unsigned int const, std::pair<llvm::Value*, llvm::SMLoc> > >, std::pair<unsigned int const, std::pair<llvm::Value*, llvm::SMLoc> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjS0_IPN4llvm5ValueENS2_5SMLocEEESt10_Select1stIS7_ESt4lessIjESaIS7_EE16_M_insert_uniqueERKS7_", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, std::pair<llvm::Value*, llvm::SMLoc> >, std::_Select1st<std::pair<unsigned int const, std::pair<llvm::Value*, llvm::SMLoc> > >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, std::pair<llvm::Value*, llvm::SMLoc> > > >::_M_insert_unique(std::pair<unsigned int const, std::pair<llvm::Value*, llvm::SMLoc> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsS0_IPN4llvm5ValueENS2_5SMLocEEESt10_Select1stIS7_ESt4lessISsESaIS7_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS7_ERKS7_", "std::_Rb_tree<std::string, std::pair<std::string const, std::pair<llvm::Value*, llvm::SMLoc> >, std::_Select1st<std::pair<std::string const, std::pair<llvm::Value*, llvm::SMLoc> > >, std::less<std::string>, std::allocator<std::pair<std::string const, std::pair<llvm::Value*, llvm::SMLoc> > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<std::string const, std::pair<llvm::Value*, llvm::SMLoc> > >, std::pair<std::string const, std::pair<llvm::Value*, llvm::SMLoc> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsS0_IPN4llvm5ValueENS2_5SMLocEEESt10_Select1stIS7_ESt4lessISsESaIS7_EE9_M_insertEPSt18_Rb_tree_node_baseSF_RKS7_", "std::_Rb_tree<std::string, std::pair<std::string const, std::pair<llvm::Value*, llvm::SMLoc> >, std::_Select1st<std::pair<std::string const, std::pair<llvm::Value*, llvm::SMLoc> > >, std::less<std::string>, std::allocator<std::pair<std::string const, std::pair<llvm::Value*, llvm::SMLoc> > > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<std::string const, std::pair<llvm::Value*, llvm::SMLoc> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsS0_IPN4llvm5ValueENS2_5SMLocEEESt10_Select1stIS7_ESt4lessISsESaIS7_EE16_M_insert_uniqueERKS7_", "std::_Rb_tree<std::string, std::pair<std::string const, std::pair<llvm::Value*, llvm::SMLoc> >, std::_Select1st<std::pair<std::string const, std::pair<llvm::Value*, llvm::SMLoc> > >, std::less<std::string>, std::allocator<std::pair<std::string const, std::pair<llvm::Value*, llvm::SMLoc> > > >::_M_insert_unique(std::pair<std::string const, std::pair<llvm::Value*, llvm::SMLoc> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsS0_IPN4llvm5ValueENS2_5SMLocEEESt10_Select1stIS7_ESt4lessISsESaIS7_EE4findERS1_", "std::_Rb_tree<std::string, std::pair<std::string const, std::pair<llvm::Value*, llvm::SMLoc> >, std::_Select1st<std::pair<std::string const, std::pair<llvm::Value*, llvm::SMLoc> > >, std::less<std::string>, std::allocator<std::pair<std::string const, std::pair<llvm::Value*, llvm::SMLoc> > > >::find(std::string const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm5ValIDESt4pairIKS1_St6vectorIS2_IS1_PNS0_11GlobalValueEESaIS7_EEESt10_Select1stISA_ESt4lessIS1_ESaISA_EE4findERS3_", "std::_Rb_tree<llvm::ValID, std::pair<llvm::ValID const, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > >, std::_Select1st<std::pair<llvm::ValID const, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > > >, std::less<llvm::ValID>, std::allocator<std::pair<llvm::ValID const, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > > > >::find(llvm::ValID const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm8LLParser7ArgInfoESaIS2_EED2Ev", "std::vector<llvm::LLParser::ArgInfo, std::allocator<llvm::LLParser::ArgInfo> >::~vector()"),
	mu_demangle_test("_ZNSt6vectorIN4llvm8LLParser7ArgInfoESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::LLParser::ArgInfo, std::allocator<llvm::LLParser::ArgInfo> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::LLParser::ArgInfo*, std::vector<llvm::LLParser::ArgInfo, std::allocator<llvm::LLParser::ArgInfo> > >, llvm::LLParser::ArgInfo const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm8LLParser11UpRefRecordESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::LLParser::UpRefRecord, std::allocator<llvm::LLParser::UpRefRecord> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::LLParser::UpRefRecord*, std::vector<llvm::LLParser::UpRefRecord, std::allocator<llvm::LLParser::UpRefRecord> > >, llvm::LLParser::UpRefRecord const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjS0_IN4llvm12PATypeHolderENS2_5SMLocEEESt10_Select1stIS6_ESt4lessIjESaIS6_EE16_M_insert_uniqueERKS6_", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, std::pair<llvm::PATypeHolder, llvm::SMLoc> >, std::_Select1st<std::pair<unsigned int const, std::pair<llvm::PATypeHolder, llvm::SMLoc> > >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, std::pair<llvm::PATypeHolder, llvm::SMLoc> > > >::_M_insert_unique(std::pair<unsigned int const, std::pair<llvm::PATypeHolder, llvm::SMLoc> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsS0_IN4llvm12PATypeHolderENS2_5SMLocEEESt10_Select1stIS6_ESt4lessISsESaIS6_EE16_M_insert_uniqueERKS6_", "std::_Rb_tree<std::string, std::pair<std::string const, std::pair<llvm::PATypeHolder, llvm::SMLoc> >, std::_Select1st<std::pair<std::string const, std::pair<llvm::PATypeHolder, llvm::SMLoc> > >, std::less<std::string>, std::allocator<std::pair<std::string const, std::pair<llvm::PATypeHolder, llvm::SMLoc> > > >::_M_insert_unique(std::pair<std::string const, std::pair<llvm::PATypeHolder, llvm::SMLoc> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsS0_IN4llvm12PATypeHolderENS2_5SMLocEEESt10_Select1stIS6_ESt4lessISsESaIS6_EE9_M_insertEPSt18_Rb_tree_node_baseSE_RKS6_", "std::_Rb_tree<std::string, std::pair<std::string const, std::pair<llvm::PATypeHolder, llvm::SMLoc> >, std::_Select1st<std::pair<std::string const, std::pair<llvm::PATypeHolder, llvm::SMLoc> > >, std::less<std::string>, std::allocator<std::pair<std::string const, std::pair<llvm::PATypeHolder, llvm::SMLoc> > > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<std::string const, std::pair<llvm::PATypeHolder, llvm::SMLoc> > const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm8LLParser5MDRefESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::LLParser::MDRef, std::allocator<llvm::LLParser::MDRef> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::LLParser::MDRef*, std::vector<llvm::LLParser::MDRef, std::allocator<llvm::LLParser::MDRef> > >, llvm::LLParser::MDRef const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_11InstructionESt6vectorINS_8LLParser5MDRefESaIS5_EENS_12DenseMapInfoIS2_EENS8_IS7_EEE16FindAndConstructERKS2_", "llvm::DenseMap<llvm::Instruction*, std::vector<llvm::LLParser::MDRef, std::allocator<llvm::LLParser::MDRef> >, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<std::vector<llvm::LLParser::MDRef, std::allocator<llvm::LLParser::MDRef> > > >::FindAndConstruct(llvm::Instruction* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_11InstructionESt6vectorINS_8LLParser5MDRefESaIS5_EENS_12DenseMapInfoIS2_EENS8_IS7_EEE16InsertIntoBucketERKS2_RKS7_PSt4pairIS2_S7_E", "llvm::DenseMap<llvm::Instruction*, std::vector<llvm::LLParser::MDRef, std::allocator<llvm::LLParser::MDRef> >, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<std::vector<llvm::LLParser::MDRef, std::allocator<llvm::LLParser::MDRef> > > >::InsertIntoBucket(llvm::Instruction* const&, std::vector<llvm::LLParser::MDRef, std::allocator<llvm::LLParser::MDRef> > const&, std::pair<llvm::Instruction*, std::vector<llvm::LLParser::MDRef, std::allocator<llvm::LLParser::MDRef> > >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_11InstructionESt6vectorINS_8LLParser5MDRefESaIS5_EENS_12DenseMapInfoIS2_EENS8_IS7_EEE4growEj", "llvm::DenseMap<llvm::Instruction*, std::vector<llvm::LLParser::MDRef, std::allocator<llvm::LLParser::MDRef> >, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<std::vector<llvm::LLParser::MDRef, std::allocator<llvm::LLParser::MDRef> > > >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm8LLParser5MDRefESaIS2_EEC2ERKS4_", "std::vector<llvm::LLParser::MDRef, std::allocator<llvm::LLParser::MDRef> >::vector(std::vector<llvm::LLParser::MDRef, std::allocator<llvm::LLParser::MDRef> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjS0_IPN4llvm11GlobalValueENS2_5SMLocEEESt10_Select1stIS7_ESt4lessIjESaIS7_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS7_ERKS7_", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, std::pair<llvm::GlobalValue*, llvm::SMLoc> >, std::_Select1st<std::pair<unsigned int const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<unsigned int const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > >, std::pair<unsigned int const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjS0_IPN4llvm11GlobalValueENS2_5SMLocEEESt10_Select1stIS7_ESt4lessIjESaIS7_EE16_M_insert_uniqueERKS7_", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, std::pair<llvm::GlobalValue*, llvm::SMLoc> >, std::_Select1st<std::pair<unsigned int const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > > >::_M_insert_unique(std::pair<unsigned int const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsS0_IPN4llvm11GlobalValueENS2_5SMLocEEESt10_Select1stIS7_ESt4lessISsESaIS7_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS7_ERKS7_", "std::_Rb_tree<std::string, std::pair<std::string const, std::pair<llvm::GlobalValue*, llvm::SMLoc> >, std::_Select1st<std::pair<std::string const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > >, std::less<std::string>, std::allocator<std::pair<std::string const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<std::string const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > >, std::pair<std::string const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsS0_IPN4llvm11GlobalValueENS2_5SMLocEEESt10_Select1stIS7_ESt4lessISsESaIS7_EE9_M_insertEPSt18_Rb_tree_node_baseSF_RKS7_", "std::_Rb_tree<std::string, std::pair<std::string const, std::pair<llvm::GlobalValue*, llvm::SMLoc> >, std::_Select1st<std::pair<std::string const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > >, std::less<std::string>, std::allocator<std::pair<std::string const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<std::string const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsS0_IPN4llvm11GlobalValueENS2_5SMLocEEESt10_Select1stIS7_ESt4lessISsESaIS7_EE16_M_insert_uniqueERKS7_", "std::_Rb_tree<std::string, std::pair<std::string const, std::pair<llvm::GlobalValue*, llvm::SMLoc> >, std::_Select1st<std::pair<std::string const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > >, std::less<std::string>, std::allocator<std::pair<std::string const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > > >::_M_insert_unique(std::pair<std::string const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm11GlobalValueESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::GlobalValue*, std::allocator<llvm::GlobalValue*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::GlobalValue**, std::vector<llvm::GlobalValue*, std::allocator<llvm::GlobalValue*> > >, llvm::GlobalValue* const&)"),
	mu_demangle_test("_ZN4llvm6iplistINS_14GlobalVariableENS_12ilist_traitsIS1_EEE8transferENS_14ilist_iteratorIS1_EERS4_S6_S6_", "llvm::iplist<llvm::GlobalVariable, llvm::ilist_traits<llvm::GlobalVariable> >::transfer(llvm::ilist_iterator<llvm::GlobalVariable>, llvm::iplist<llvm::GlobalVariable, llvm::ilist_traits<llvm::GlobalVariable> >&, llvm::ilist_iterator<llvm::GlobalVariable>, llvm::ilist_iterator<llvm::GlobalVariable>)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsS0_IPN4llvm11GlobalValueENS2_5SMLocEEESt10_Select1stIS7_ESt4lessISsESaIS7_EE11equal_rangeERS1_", "std::_Rb_tree<std::string, std::pair<std::string const, std::pair<llvm::GlobalValue*, llvm::SMLoc> >, std::_Select1st<std::pair<std::string const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > >, std::less<std::string>, std::allocator<std::pair<std::string const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > > >::equal_range(std::string const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsS0_IPN4llvm11GlobalValueENS2_5SMLocEEESt10_Select1stIS7_ESt4lessISsESaIS7_EE5eraseESt17_Rb_tree_iteratorIS7_ESF_", "std::_Rb_tree<std::string, std::pair<std::string const, std::pair<llvm::GlobalValue*, llvm::SMLoc> >, std::_Select1st<std::pair<std::string const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > >, std::less<std::string>, std::allocator<std::pair<std::string const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > > >::erase(std::_Rb_tree_iterator<std::pair<std::string const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > >, std::_Rb_tree_iterator<std::pair<std::string const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > >)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsS0_IPN4llvm11GlobalValueENS2_5SMLocEEESt10_Select1stIS7_ESt4lessISsESaIS7_EE4findERS1_", "std::_Rb_tree<std::string, std::pair<std::string const, std::pair<llvm::GlobalValue*, llvm::SMLoc> >, std::_Select1st<std::pair<std::string const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > >, std::less<std::string>, std::allocator<std::pair<std::string const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > > >::find(std::string const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm10TrackingVHINS0_6MDNodeEEESaIS3_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS3_S5_EEmRKS3_", "std::vector<llvm::TrackingVH<llvm::MDNode>, std::allocator<llvm::TrackingVH<llvm::MDNode> > >::_M_fill_insert(__gnu_cxx::__normal_iterator<llvm::TrackingVH<llvm::MDNode>*, std::vector<llvm::TrackingVH<llvm::MDNode>, std::allocator<llvm::TrackingVH<llvm::MDNode> > > >, unsigned long, llvm::TrackingVH<llvm::MDNode> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjS0_IN4llvm10TrackingVHINS2_6MDNodeEEENS2_5SMLocEEESt10_Select1stIS8_ESt4lessIjESaIS8_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS8_ERKS8_", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, std::pair<llvm::TrackingVH<llvm::MDNode>, llvm::SMLoc> >, std::_Select1st<std::pair<unsigned int const, std::pair<llvm::TrackingVH<llvm::MDNode>, llvm::SMLoc> > >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, std::pair<llvm::TrackingVH<llvm::MDNode>, llvm::SMLoc> > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<unsigned int const, std::pair<llvm::TrackingVH<llvm::MDNode>, llvm::SMLoc> > >, std::pair<unsigned int const, std::pair<llvm::TrackingVH<llvm::MDNode>, llvm::SMLoc> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjS0_IN4llvm10TrackingVHINS2_6MDNodeEEENS2_5SMLocEEESt10_Select1stIS8_ESt4lessIjESaIS8_EE9_M_insertEPSt18_Rb_tree_node_baseSG_RKS8_", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, std::pair<llvm::TrackingVH<llvm::MDNode>, llvm::SMLoc> >, std::_Select1st<std::pair<unsigned int const, std::pair<llvm::TrackingVH<llvm::MDNode>, llvm::SMLoc> > >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, std::pair<llvm::TrackingVH<llvm::MDNode>, llvm::SMLoc> > > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<unsigned int const, std::pair<llvm::TrackingVH<llvm::MDNode>, llvm::SMLoc> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjS0_IN4llvm10TrackingVHINS2_6MDNodeEEENS2_5SMLocEEESt10_Select1stIS8_ESt4lessIjESaIS8_EE16_M_insert_uniqueERKS8_", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, std::pair<llvm::TrackingVH<llvm::MDNode>, llvm::SMLoc> >, std::_Select1st<std::pair<unsigned int const, std::pair<llvm::TrackingVH<llvm::MDNode>, llvm::SMLoc> > >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, std::pair<llvm::TrackingVH<llvm::MDNode>, llvm::SMLoc> > > >::_M_insert_unique(std::pair<unsigned int const, std::pair<llvm::TrackingVH<llvm::MDNode>, llvm::SMLoc> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsS0_IN4llvm12PATypeHolderENS2_5SMLocEEESt10_Select1stIS6_ESt4lessISsESaIS6_EE4findERS1_", "std::_Rb_tree<std::string, std::pair<std::string const, std::pair<llvm::PATypeHolder, llvm::SMLoc> >, std::_Select1st<std::pair<std::string const, std::pair<llvm::PATypeHolder, llvm::SMLoc> > >, std::less<std::string>, std::allocator<std::pair<std::string const, std::pair<llvm::PATypeHolder, llvm::SMLoc> > > >::find(std::string const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_11InstructionESt6vectorINS_8LLParser5MDRefESaIS5_EENS_12DenseMapInfoIS2_EENS8_IS7_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::Instruction*, std::vector<llvm::LLParser::MDRef, std::allocator<llvm::LLParser::MDRef> >, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<std::vector<llvm::LLParser::MDRef, std::allocator<llvm::LLParser::MDRef> > > >::shrink_and_clear()"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsS0_IN4llvm12PATypeHolderENS2_5SMLocEEESt10_Select1stIS6_ESt4lessISsESaIS6_EE8_M_eraseEPSt13_Rb_tree_nodeIS6_E", "std::_Rb_tree<std::string, std::pair<std::string const, std::pair<llvm::PATypeHolder, llvm::SMLoc> >, std::_Select1st<std::pair<std::string const, std::pair<llvm::PATypeHolder, llvm::SMLoc> > >, std::less<std::string>, std::allocator<std::pair<std::string const, std::pair<llvm::PATypeHolder, llvm::SMLoc> > > >::_M_erase(std::_Rb_tree_node<std::pair<std::string const, std::pair<llvm::PATypeHolder, llvm::SMLoc> > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsS0_IN4llvm12PATypeHolderENS2_5SMLocEEESt10_Select1stIS6_ESt4lessISsESaIS6_EE15_M_destroy_nodeEPSt13_Rb_tree_nodeIS6_E", "std::_Rb_tree<std::string, std::pair<std::string const, std::pair<llvm::PATypeHolder, llvm::SMLoc> >, std::_Select1st<std::pair<std::string const, std::pair<llvm::PATypeHolder, llvm::SMLoc> > >, std::less<std::string>, std::allocator<std::pair<std::string const, std::pair<llvm::PATypeHolder, llvm::SMLoc> > > >::_M_destroy_node(std::_Rb_tree_node<std::pair<std::string const, std::pair<llvm::PATypeHolder, llvm::SMLoc> > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjS0_IN4llvm12PATypeHolderENS2_5SMLocEEESt10_Select1stIS6_ESt4lessIjESaIS6_EE8_M_eraseEPSt13_Rb_tree_nodeIS6_E", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, std::pair<llvm::PATypeHolder, llvm::SMLoc> >, std::_Select1st<std::pair<unsigned int const, std::pair<llvm::PATypeHolder, llvm::SMLoc> > >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, std::pair<llvm::PATypeHolder, llvm::SMLoc> > > >::_M_erase(std::_Rb_tree_node<std::pair<unsigned int const, std::pair<llvm::PATypeHolder, llvm::SMLoc> > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjS0_IN4llvm10TrackingVHINS2_6MDNodeEEENS2_5SMLocEEESt10_Select1stIS8_ESt4lessIjESaIS8_EE8_M_eraseEPSt13_Rb_tree_nodeIS8_E", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, std::pair<llvm::TrackingVH<llvm::MDNode>, llvm::SMLoc> >, std::_Select1st<std::pair<unsigned int const, std::pair<llvm::TrackingVH<llvm::MDNode>, llvm::SMLoc> > >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, std::pair<llvm::TrackingVH<llvm::MDNode>, llvm::SMLoc> > > >::_M_erase(std::_Rb_tree_node<std::pair<unsigned int const, std::pair<llvm::TrackingVH<llvm::MDNode>, llvm::SMLoc> > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsS0_IPN4llvm11GlobalValueENS2_5SMLocEEESt10_Select1stIS7_ESt4lessISsESaIS7_EE8_M_eraseEPSt13_Rb_tree_nodeIS7_E", "std::_Rb_tree<std::string, std::pair<std::string const, std::pair<llvm::GlobalValue*, llvm::SMLoc> >, std::_Select1st<std::pair<std::string const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > >, std::less<std::string>, std::allocator<std::pair<std::string const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > > >::_M_erase(std::_Rb_tree_node<std::pair<std::string const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjS0_IPN4llvm11GlobalValueENS2_5SMLocEEESt10_Select1stIS7_ESt4lessIjESaIS7_EE8_M_eraseEPSt13_Rb_tree_nodeIS7_E", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, std::pair<llvm::GlobalValue*, llvm::SMLoc> >, std::_Select1st<std::pair<unsigned int const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > > >::_M_erase(std::_Rb_tree_node<std::pair<unsigned int const, std::pair<llvm::GlobalValue*, llvm::SMLoc> > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm5ValIDESt4pairIKS1_St6vectorIS2_IS1_PNS0_11GlobalValueEESaIS7_EEESt10_Select1stISA_ESt4lessIS1_ESaISA_EE8_M_eraseEPSt13_Rb_tree_nodeISA_E", "std::_Rb_tree<llvm::ValID, std::pair<llvm::ValID const, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > >, std::_Select1st<std::pair<llvm::ValID const, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > > >, std::less<llvm::ValID>, std::allocator<std::pair<llvm::ValID const, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::ValID const, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > > >*)"),
	mu_demangle_test("_ZNSt4pairIKN4llvm5ValIDESt6vectorIS_IS1_PNS0_11GlobalValueEESaIS6_EEED2Ev", "std::pair<llvm::ValID const, std::vector<std::pair<llvm::ValID, llvm::GlobalValue*>, std::allocator<std::pair<llvm::ValID, llvm::GlobalValue*> > > >::~pair()"),
	mu_demangle_test("_ZN4llvm12df_ext_beginIPNS_17MachineBasicBlockENS_11SmallPtrSetIS2_Lj16EEEEENS_15df_ext_iteratorIT_T0_EERKS6_RS7_", "llvm::df_ext_iterator<llvm::MachineBasicBlock*, llvm::SmallPtrSet<llvm::MachineBasicBlock*, 16u> > llvm::df_ext_begin<llvm::MachineBasicBlock*, llvm::SmallPtrSet<llvm::MachineBasicBlock*, 16u> >(llvm::MachineBasicBlock* const&, llvm::SmallPtrSet<llvm::MachineBasicBlock*, 16u>&)"),
	mu_demangle_test("_ZN4llvm11df_iteratorIPNS_17MachineBasicBlockENS_11SmallPtrSetIS2_Lj16EEELb1ENS_11GraphTraitsIS2_EEE6toNextEv", "llvm::df_iterator<llvm::MachineBasicBlock*, llvm::SmallPtrSet<llvm::MachineBasicBlock*, 16u>, true, llvm::GraphTraits<llvm::MachineBasicBlock*> >::toNext()"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN4llvm14PointerIntPairIPNS1_17MachineBasicBlockELj1EjNS1_21PointerLikeTypeTraitsIS4_EEEEN9__gnu_cxx17__normal_iteratorIPS4_S_IS4_SaIS4_EEEEESaISE_EE13_M_insert_auxENS9_IPSE_SG_EERKSE_", "std::vector<std::pair<llvm::PointerIntPair<llvm::MachineBasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::MachineBasicBlock*> >, __gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > > >, std::allocator<std::pair<llvm::PointerIntPair<llvm::MachineBasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::MachineBasicBlock*> >, __gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > > > > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::PointerIntPair<llvm::MachineBasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::MachineBasicBlock*> >, __gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > > >*, std::vector<std::pair<llvm::PointerIntPair<llvm::MachineBasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::MachineBasicBlock*> >, __gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > > >, std::allocator<std::pair<llvm::PointerIntPair<llvm::MachineBasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::MachineBasicBlock*> >, __gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > > > > > >, std::pair<llvm::PointerIntPair<llvm::MachineBasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::MachineBasicBlock*> >, __gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > > > const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN4llvm14PointerIntPairIPNS1_17MachineBasicBlockELj1EjNS1_21PointerLikeTypeTraitsIS4_EEEEN9__gnu_cxx17__normal_iteratorIPS4_S_IS4_SaIS4_EEEEESaISE_EEC2ERKSG_", "std::vector<std::pair<llvm::PointerIntPair<llvm::MachineBasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::MachineBasicBlock*> >, __gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > > >, std::allocator<std::pair<llvm::PointerIntPair<llvm::MachineBasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::MachineBasicBlock*> >, __gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > > > > >::vector(std::vector<std::pair<llvm::PointerIntPair<llvm::MachineBasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::MachineBasicBlock*> >, __gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > > >, std::allocator<std::pair<llvm::PointerIntPair<llvm::MachineBasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::MachineBasicBlock*> >, __gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > > > > > const&)"),
	mu_demangle_test("_ZN4llvm11df_iteratorIPNS_17MachineBasicBlockENS_11SmallPtrSetIS2_Lj16EEELb1ENS_11GraphTraitsIS2_EEEC2ES2_RS4_", "llvm::df_iterator<llvm::MachineBasicBlock*, llvm::SmallPtrSet<llvm::MachineBasicBlock*, 16u>, true, llvm::GraphTraits<llvm::MachineBasicBlock*> >::df_iterator(llvm::MachineBasicBlock*, llvm::SmallPtrSet<llvm::MachineBasicBlock*, 16u>&)"),
	mu_demangle_test("_ZNSt6vectorIPKN4llvm8MCSymbolESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<llvm::MCSymbol const*, std::allocator<llvm::MCSymbol const*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::MCSymbol const**, std::vector<llvm::MCSymbol const*, std::allocator<llvm::MCSymbol const*> > >, llvm::MCSymbol const* const&)"),
	mu_demangle_test("_ZN4llvm12df_ext_beginIPNS_17MachineBasicBlockENS_11SmallPtrSetIS2_Lj8EEEEENS_15df_ext_iteratorIT_T0_EERKS6_RS7_", "llvm::df_ext_iterator<llvm::MachineBasicBlock*, llvm::SmallPtrSet<llvm::MachineBasicBlock*, 8u> > llvm::df_ext_begin<llvm::MachineBasicBlock*, llvm::SmallPtrSet<llvm::MachineBasicBlock*, 8u> >(llvm::MachineBasicBlock* const&, llvm::SmallPtrSet<llvm::MachineBasicBlock*, 8u>&)"),
	mu_demangle_test("_ZN4llvm11df_iteratorIPNS_17MachineBasicBlockENS_11SmallPtrSetIS2_Lj8EEELb1ENS_11GraphTraitsIS2_EEE6toNextEv", "llvm::df_iterator<llvm::MachineBasicBlock*, llvm::SmallPtrSet<llvm::MachineBasicBlock*, 8u>, true, llvm::GraphTraits<llvm::MachineBasicBlock*> >::toNext()"),
	mu_demangle_test("_ZN4llvm11df_iteratorIPNS_17MachineBasicBlockENS_11SmallPtrSetIS2_Lj8EEELb1ENS_11GraphTraitsIS2_EEEC2ES2_RS4_", "llvm::df_iterator<llvm::MachineBasicBlock*, llvm::SmallPtrSet<llvm::MachineBasicBlock*, 8u>, true, llvm::GraphTraits<llvm::MachineBasicBlock*> >::df_iterator(llvm::MachineBasicBlock*, llvm::SmallPtrSet<llvm::MachineBasicBlock*, 8u>&)"),
	mu_demangle_test("_ZNK4llvm16X86FrameLowering20getInitialFrameStateERSt6vectorINS_11MachineMoveESaIS2_EE", "llvm::X86FrameLowering::getInitialFrameState(std::vector<llvm::MachineMove, std::allocator<llvm::MachineMove> >&) const"),
	mu_demangle_test("_ZNK4llvm16X86FrameLowering25spillCalleeSavedRegistersERNS_17MachineBasicBlockENS_14ilist_iteratorINS_12MachineInstrEEERKSt6vectorINS_15CalleeSavedInfoESaIS7_EEPKNS_18TargetRegisterInfoE", "llvm::X86FrameLowering::spillCalleeSavedRegisters(llvm::MachineBasicBlock&, llvm::ilist_iterator<llvm::MachineInstr>, std::vector<llvm::CalleeSavedInfo, std::allocator<llvm::CalleeSavedInfo> > const&, llvm::TargetRegisterInfo const*) const"),
	mu_demangle_test("_ZNK4llvm16X86FrameLowering27restoreCalleeSavedRegistersERNS_17MachineBasicBlockENS_14ilist_iteratorINS_12MachineInstrEEERKSt6vectorINS_15CalleeSavedInfoESaIS7_EEPKNS_18TargetRegisterInfoE", "llvm::X86FrameLowering::restoreCalleeSavedRegisters(llvm::MachineBasicBlock&, llvm::ilist_iterator<llvm::MachineInstr>, std::vector<llvm::CalleeSavedInfo, std::allocator<llvm::CalleeSavedInfo> > const&, llvm::TargetRegisterInfo const*) const"),
	mu_demangle_test("_ZNSt6vectorIN4llvm11MachineMoveESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<llvm::MachineMove, std::allocator<llvm::MachineMove> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::MachineMove*, std::vector<llvm::MachineMove, std::allocator<llvm::MachineMove> > >, llvm::MachineMove const&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_115X86DAGToDAGISel28SelectInlineAsmMemoryOperandERKN4llvm7SDValueEcRSt6vectorIS2_SaIS2_EE", "(anonymous namespace)::X86DAGToDAGISel::SelectInlineAsmMemoryOperand(llvm::SDValue const&, char, std::vector<llvm::SDValue, std::allocator<llvm::SDValue> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_115X86DAGToDAGISel19CheckComplexPatternEPN4llvm6SDNodeES3_NS1_7SDValueEjRNS1_15SmallVectorImplISt4pairIS4_S3_EEE", "(anonymous namespace)::X86DAGToDAGISel::CheckComplexPattern(llvm::SDNode*, llvm::SDNode*, llvm::SDValue, unsigned int, llvm::SmallVectorImpl<std::pair<llvm::SDValue, llvm::SDNode*> >&)"),
	mu_demangle_test("_ZNK4llvm17X86TargetLowering28LowerAsmOperandForConstraintENS_7SDValueEcRSt6vectorIS1_SaIS1_EERNS_12SelectionDAGE", "llvm::X86TargetLowering::LowerAsmOperandForConstraint(llvm::SDValue, char, std::vector<llvm::SDValue, std::allocator<llvm::SDValue> >&, llvm::SelectionDAG&) const"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm7SDValueES1_St9_IdentityIS1_ESt4lessIS1_ESaIS1_EE16_M_insert_uniqueERKS1_", "std::_Rb_tree<llvm::SDValue, llvm::SDValue, std::_Identity<llvm::SDValue>, std::less<llvm::SDValue>, std::allocator<llvm::SDValue> >::_M_insert_unique(llvm::SDValue const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm9InlineAsm14ConstraintInfoESaIS2_EED2Ev", "std::vector<llvm::InlineAsm::ConstraintInfo, std::allocator<llvm::InlineAsm::ConstraintInfo> >::~vector()"),
	mu_demangle_test("_ZNSt6vectorIN4llvm9InlineAsm17SubConstraintInfoESaIS2_EED2Ev", "std::vector<llvm::InlineAsm::SubConstraintInfo, std::allocator<llvm::InlineAsm::SubConstraintInfo> >::~vector()"),
	mu_demangle_test("_ZN4llvm15SmallVectorImplISt4pairIiiEE6resizeEj", "llvm::SmallVectorImpl<std::pair<int, int> >::resize(unsigned int)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm7SDValueES1_St9_IdentityIS1_ESt4lessIS1_ESaIS1_EE8_M_eraseEPSt13_Rb_tree_nodeIS1_E", "std::_Rb_tree<llvm::SDValue, llvm::SDValue, std::_Identity<llvm::SDValue>, std::less<llvm::SDValue>, std::allocator<llvm::SDValue> >::_M_erase(std::_Rb_tree_node<llvm::SDValue>*)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm7APFloatESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<llvm::APFloat, std::allocator<llvm::APFloat> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::APFloat*, std::vector<llvm::APFloat, std::allocator<llvm::APFloat> > >, llvm::APFloat const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm3EVTESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<llvm::EVT, std::allocator<llvm::EVT> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::EVT*, std::vector<llvm::EVT, std::allocator<llvm::EVT> > >, llvm::EVT const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm7SDValueESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<llvm::SDValue, std::allocator<llvm::SDValue> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::SDValue*, std::vector<llvm::SDValue, std::allocator<llvm::SDValue> > >, llvm::SDValue const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjSt4pairIjjENS_12DenseMapInfoIjEENS3_IS2_EEE16InsertIntoBucketERKjRKS2_PS1_IjS2_E", "llvm::DenseMap<unsigned int, std::pair<unsigned int, unsigned int>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<std::pair<unsigned int, unsigned int> > >::InsertIntoBucket(unsigned int const&, std::pair<unsigned int, unsigned int> const&, std::pair<unsigned int, std::pair<unsigned int, unsigned int> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjSt4pairIjjENS_12DenseMapInfoIjEENS3_IS2_EEE4growEj", "llvm::DenseMap<unsigned int, std::pair<unsigned int, unsigned int>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<std::pair<unsigned int, unsigned int> > >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm12MachineInstrESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::MachineInstr**, std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> > >, llvm::MachineInstr* const&)"),
	mu_demangle_test("_ZN4llvm2cl3optI17AsmWriterFlavorTyLb0ENS0_6parserIS2_EEED1Ev", "llvm::cl::opt<AsmWriterFlavorTy, false, llvm::cl::parser<AsmWriterFlavorTy> >::~opt()"),
	mu_demangle_test("_ZN4llvm2cl3optI17AsmWriterFlavorTyLb0ENS0_6parserIS2_EEE16handleOccurrenceEjNS_9StringRefES6_", "llvm::cl::opt<AsmWriterFlavorTy, false, llvm::cl::parser<AsmWriterFlavorTy> >::handleOccurrence(unsigned int, llvm::StringRef, llvm::StringRef)"),
	mu_demangle_test("_ZNK4llvm2cl3optI17AsmWriterFlavorTyLb0ENS0_6parserIS2_EEE27getValueExpectedFlagDefaultEv", "llvm::cl::opt<AsmWriterFlavorTy, false, llvm::cl::parser<AsmWriterFlavorTy> >::getValueExpectedFlagDefault() const"),
	mu_demangle_test("_ZNK4llvm2cl3optI17AsmWriterFlavorTyLb0ENS0_6parserIS2_EEE14getOptionWidthEv", "llvm::cl::opt<AsmWriterFlavorTy, false, llvm::cl::parser<AsmWriterFlavorTy> >::getOptionWidth() const"),
	mu_demangle_test("_ZNK4llvm2cl3optI17AsmWriterFlavorTyLb0ENS0_6parserIS2_EEE15printOptionInfoEm", "llvm::cl::opt<AsmWriterFlavorTy, false, llvm::cl::parser<AsmWriterFlavorTy> >::printOptionInfo(unsigned long) const"),
	mu_demangle_test("_ZN4llvm2cl3optI17AsmWriterFlavorTyLb0ENS0_6parserIS2_EEE19getExtraOptionNamesERNS_15SmallVectorImplIPKcEE", "llvm::cl::opt<AsmWriterFlavorTy, false, llvm::cl::parser<AsmWriterFlavorTy> >::getExtraOptionNames(llvm::SmallVectorImpl<char const*>&)"),
	mu_demangle_test("_ZN4llvm2cl3optI17AsmWriterFlavorTyLb0ENS0_6parserIS2_EEED0Ev", "llvm::cl::opt<AsmWriterFlavorTy, false, llvm::cl::parser<AsmWriterFlavorTy> >::~opt()"),
	mu_demangle_test("_ZNK4llvm2cl11ValuesClassIiE5applyINS0_3optI17AsmWriterFlavorTyLb0ENS0_6parserIS5_EEEEEEvRT_", "void llvm::cl::ValuesClass<int>::apply<llvm::cl::opt<AsmWriterFlavorTy, false, llvm::cl::parser<AsmWriterFlavorTy> > >(llvm::cl::opt<AsmWriterFlavorTy, false, llvm::cl::parser<AsmWriterFlavorTy> >&) const"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsjESt10_Select1stIS2_ESt4lessISsESaIS2_EE8_M_eraseEPSt13_Rb_tree_nodeIS2_E", "std::_Rb_tree<std::string, std::pair<std::string const, unsigned int>, std::_Select1st<std::pair<std::string const, unsigned int> >, std::less<std::string>, std::allocator<std::pair<std::string const, unsigned int> > >::_M_erase(std::_Rb_tree_node<std::pair<std::string const, unsigned int> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsjESt10_Select1stIS2_ESt4lessISsESaIS2_EE4findERS1_", "std::_Rb_tree<std::string, std::pair<std::string const, unsigned int>, std::_Select1st<std::pair<std::string const, unsigned int> >, std::less<std::string>, std::allocator<std::pair<std::string const, unsigned int> > >::find(std::string const&)"),
	mu_demangle_test("_ZNSt3mapISsjSt4lessISsESaISt4pairIKSsjEEEixERS3_", "std::map<std::string, unsigned int, std::less<std::string>, std::allocator<std::pair<std::string const, unsigned int> > >::operator[](std::string const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsjESt10_Select1stIS2_ESt4lessISsESaIS2_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS2_ERKS2_", "std::_Rb_tree<std::string, std::pair<std::string const, unsigned int>, std::_Select1st<std::pair<std::string const, unsigned int> >, std::less<std::string>, std::allocator<std::pair<std::string const, unsigned int> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<std::string const, unsigned int> >, std::pair<std::string const, unsigned int> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsjESt10_Select1stIS2_ESt4lessISsESaIS2_EE9_M_insertEPSt18_Rb_tree_node_baseSA_RKS2_", "std::_Rb_tree<std::string, std::pair<std::string const, unsigned int>, std::_Select1st<std::pair<std::string const, unsigned int> >, std::less<std::string>, std::allocator<std::pair<std::string const, unsigned int> > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<std::string const, unsigned int> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsjESt10_Select1stIS2_ESt4lessISsESaIS2_EE16_M_insert_uniqueERKS2_", "std::_Rb_tree<std::string, std::pair<std::string const, unsigned int>, std::_Select1st<std::pair<std::string const, unsigned int> >, std::less<std::string>, std::allocator<std::pair<std::string const, unsigned int> > >::_M_insert_unique(std::pair<std::string const, unsigned int> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjbNS_12DenseMapInfoIjEENS1_IbEEE16InsertIntoBucketERKjRKbPSt4pairIjbE", "llvm::DenseMap<unsigned int, bool, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<bool> >::InsertIntoBucket(unsigned int const&, bool const&, std::pair<unsigned int, bool>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjbNS_12DenseMapInfoIjEENS1_IbEEE4growEj", "llvm::DenseMap<unsigned int, bool, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<bool> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPN4llvm8MCSymbolENS1_14PointerIntPairIS3_Lj1EbNS1_21PointerLikeTypeTraitsIS3_EEEEESaIS8_EEaSERKSA_", "std::vector<std::pair<llvm::MCSymbol*, llvm::PointerIntPair<llvm::MCSymbol*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::MCSymbol*> > >, std::allocator<std::pair<llvm::MCSymbol*, llvm::PointerIntPair<llvm::MCSymbol*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::MCSymbol*> > > > >::operator=(std::vector<std::pair<llvm::MCSymbol*, llvm::PointerIntPair<llvm::MCSymbol*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::MCSymbol*> > >, std::allocator<std::pair<llvm::MCSymbol*, llvm::PointerIntPair<llvm::MCSymbol*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::MCSymbol*> > > > > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_8MCSymbolENS_14PointerIntPairIS2_Lj1EbNS_21PointerLikeTypeTraitsIS2_EEEENS_12DenseMapInfoIS2_EENS7_IS6_EEE16InsertIntoBucketERKS2_RKS6_PSt4pairIS2_S6_E", "llvm::DenseMap<llvm::MCSymbol*, llvm::PointerIntPair<llvm::MCSymbol*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::MCSymbol*> >, llvm::DenseMapInfo<llvm::MCSymbol*>, llvm::DenseMapInfo<llvm::PointerIntPair<llvm::MCSymbol*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::MCSymbol*> > > >::InsertIntoBucket(llvm::MCSymbol* const&, llvm::PointerIntPair<llvm::MCSymbol*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::MCSymbol*> > const&, std::pair<llvm::MCSymbol*, llvm::PointerIntPair<llvm::MCSymbol*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::MCSymbol*> > >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_8MCSymbolENS_14PointerIntPairIS2_Lj1EbNS_21PointerLikeTypeTraitsIS2_EEEENS_12DenseMapInfoIS2_EENS7_IS6_EEE4growEj", "llvm::DenseMap<llvm::MCSymbol*, llvm::PointerIntPair<llvm::MCSymbol*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::MCSymbol*> >, llvm::DenseMapInfo<llvm::MCSymbol*>, llvm::DenseMapInfo<llvm::PointerIntPair<llvm::MCSymbol*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::MCSymbol*> > > >::grow(unsigned int)"),
	mu_demangle_test("_ZNK4llvm16ARMBaseInstrInfo16DefinesPredicateEPNS_12MachineInstrERSt6vectorINS_14MachineOperandESaIS4_EE", "llvm::ARMBaseInstrInfo::DefinesPredicate(llvm::MachineInstr*, std::vector<llvm::MachineOperand, std::allocator<llvm::MachineOperand> >&) const"),
	mu_demangle_test("_Z15getNumJTEntriesRKSt6vectorIN4llvm21MachineJumpTableEntryESaIS1_EEj", "getNumJTEntries(std::vector<llvm::MachineJumpTableEntry, std::allocator<llvm::MachineJumpTableEntry> > const&, unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjjNS_12DenseMapInfoIjEES2_E6insertERKSt4pairIjjE", "llvm::DenseMap<unsigned int, unsigned int, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<unsigned int> >::insert(std::pair<unsigned int, unsigned int> const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm14MachineOperandESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<llvm::MachineOperand, std::allocator<llvm::MachineOperand> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::MachineOperand*, std::vector<llvm::MachineOperand, std::allocator<llvm::MachineOperand> > >, llvm::MachineOperand const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjjSt9_IdentityIjESt4lessIjESaIjEE16_M_insert_uniqueERKj", "std::_Rb_tree<unsigned int, unsigned int, std::_Identity<unsigned int>, std::less<unsigned int>, std::allocator<unsigned int> >::_M_insert_unique(unsigned int const&)"),
	mu_demangle_test("_ZSt6__findIN9__gnu_cxx17__normal_iteratorIPPN4llvm12MachineInstrESt6vectorIS4_SaIS4_EEEES4_ET_SA_SA_RKT0_St26random_access_iterator_tag", "__gnu_cxx::__normal_iterator<llvm::MachineInstr**, std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> > > std::__find<__gnu_cxx::__normal_iterator<llvm::MachineInstr**, std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> > >, llvm::MachineInstr*>(__gnu_cxx::__normal_iterator<llvm::MachineInstr**, std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> > >, __gnu_cxx::__normal_iterator<llvm::MachineInstr**, std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> > >, llvm::MachineInstr* const&, std::random_access_iterator_tag)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjlNS_12DenseMapInfoIjEENS1_IlEEE6insertERKSt4pairIjlE", "llvm::DenseMap<unsigned int, long, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<long> >::insert(std::pair<unsigned int, long> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjlNS_12DenseMapInfoIjEENS1_IlEEE16InsertIntoBucketERKjRKlPSt4pairIjlE", "llvm::DenseMap<unsigned int, long, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<long> >::InsertIntoBucket(unsigned int const&, long const&, std::pair<unsigned int, long>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjlNS_12DenseMapInfoIjEENS1_IlEEE4growEj", "llvm::DenseMap<unsigned int, long, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<long> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIN12_GLOBAL__N_118ARMConstantIslands9ImmBranchESaIS2_EE9push_backERKS2_", "std::vector<(anonymous namespace)::ARMConstantIslands::ImmBranch, std::allocator<(anonymous namespace)::ARMConstantIslands::ImmBranch> >::push_back((anonymous namespace)::ARMConstantIslands::ImmBranch const&)"),
	mu_demangle_test("_ZNSt6vectorIN12_GLOBAL__N_118ARMConstantIslands7CPEntryESaIS2_EE9push_backERKS2_", "std::vector<(anonymous namespace)::ARMConstantIslands::CPEntry, std::allocator<(anonymous namespace)::ARMConstantIslands::CPEntry> >::push_back((anonymous namespace)::ARMConstantIslands::CPEntry const&)"),
	mu_demangle_test("_ZNSt6vectorIN12_GLOBAL__N_118ARMConstantIslands7CPEntryESaIS2_EEC1ERKS4_", "std::vector<(anonymous namespace)::ARMConstantIslands::CPEntry, std::allocator<(anonymous namespace)::ARMConstantIslands::CPEntry> >::vector(std::vector<(anonymous namespace)::ARMConstantIslands::CPEntry, std::allocator<(anonymous namespace)::ARMConstantIslands::CPEntry> > const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm17MachineBasicBlockESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > >, llvm::MachineBasicBlock* const&)"),
	mu_demangle_test("_ZSt6__findIN9__gnu_cxx17__normal_iteratorIPPN4llvm17MachineBasicBlockESt6vectorIS4_SaIS4_EEEES4_ET_SA_SA_RKT0_St26random_access_iterator_tag", "__gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > > std::__find<__gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > >, llvm::MachineBasicBlock*>(__gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > >, __gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > >, llvm::MachineBasicBlock* const&, std::random_access_iterator_tag)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm24MachineConstantPoolEntryESaIS1_EEC2ERKS3_", "std::vector<llvm::MachineConstantPoolEntry, std::allocator<llvm::MachineConstantPoolEntry> >::vector(std::vector<llvm::MachineConstantPoolEntry, std::allocator<llvm::MachineConstantPoolEntry> > const&)"),
	mu_demangle_test("_ZNK4llvm16ARMFrameLowering12emitPushInstERNS_17MachineBasicBlockENS_14ilist_iteratorINS_12MachineInstrEEERKSt6vectorINS_15CalleeSavedInfoESaIS7_EEjjbPFbjbE", "llvm::ARMFrameLowering::emitPushInst(llvm::MachineBasicBlock&, llvm::ilist_iterator<llvm::MachineInstr>, std::vector<llvm::CalleeSavedInfo, std::allocator<llvm::CalleeSavedInfo> > const&, unsigned int, unsigned int, bool, bool (*)(unsigned int, bool)) const"),
	mu_demangle_test("_ZNK4llvm16ARMFrameLowering11emitPopInstERNS_17MachineBasicBlockENS_14ilist_iteratorINS_12MachineInstrEEERKSt6vectorINS_15CalleeSavedInfoESaIS7_EEjjbbPFbjbE", "llvm::ARMFrameLowering::emitPopInst(llvm::MachineBasicBlock&, llvm::ilist_iterator<llvm::MachineInstr>, std::vector<llvm::CalleeSavedInfo, std::allocator<llvm::CalleeSavedInfo> > const&, unsigned int, unsigned int, bool, bool, bool (*)(unsigned int, bool)) const"),
	mu_demangle_test("_ZNK4llvm16ARMFrameLowering25spillCalleeSavedRegistersERNS_17MachineBasicBlockENS_14ilist_iteratorINS_12MachineInstrEEERKSt6vectorINS_15CalleeSavedInfoESaIS7_EEPKNS_18TargetRegisterInfoE", "llvm::ARMFrameLowering::spillCalleeSavedRegisters(llvm::MachineBasicBlock&, llvm::ilist_iterator<llvm::MachineInstr>, std::vector<llvm::CalleeSavedInfo, std::allocator<llvm::CalleeSavedInfo> > const&, llvm::TargetRegisterInfo const*) const"),
	mu_demangle_test("_ZNK4llvm16ARMFrameLowering27restoreCalleeSavedRegistersERNS_17MachineBasicBlockENS_14ilist_iteratorINS_12MachineInstrEEERKSt6vectorINS_15CalleeSavedInfoESaIS7_EEPKNS_18TargetRegisterInfoE", "llvm::ARMFrameLowering::restoreCalleeSavedRegisters(llvm::MachineBasicBlock&, llvm::ilist_iterator<llvm::MachineInstr>, std::vector<llvm::CalleeSavedInfo, std::allocator<llvm::CalleeSavedInfo> > const&, llvm::TargetRegisterInfo const*) const"),
	mu_demangle_test("_ZNSt6vectorIN4llvm16MachineFrameInfo11StackObjectESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::MachineFrameInfo::StackObject, std::allocator<llvm::MachineFrameInfo::StackObject> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::MachineFrameInfo::StackObject*, std::vector<llvm::MachineFrameInfo::StackObject, std::allocator<llvm::MachineFrameInfo::StackObject> > >, llvm::MachineFrameInfo::StackObject const&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_115ARMDAGToDAGISel28SelectInlineAsmMemoryOperandERKN4llvm7SDValueEcRSt6vectorIS2_SaIS2_EE", "(anonymous namespace)::ARMDAGToDAGISel::SelectInlineAsmMemoryOperand(llvm::SDValue const&, char, std::vector<llvm::SDValue, std::allocator<llvm::SDValue> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_115ARMDAGToDAGISel19CheckComplexPatternEPN4llvm6SDNodeES3_NS1_7SDValueEjRNS1_15SmallVectorImplISt4pairIS4_S3_EEE", "(anonymous namespace)::ARMDAGToDAGISel::CheckComplexPattern(llvm::SDNode*, llvm::SDNode*, llvm::SDValue, unsigned int, llvm::SmallVectorImpl<std::pair<llvm::SDValue, llvm::SDNode*> >&)"),
	mu_demangle_test("_ZN4llvm15SmallVectorImplISt4pairINS_7SDValueEPNS_6SDNodeEEE6resizeEj", "llvm::SmallVectorImpl<std::pair<llvm::SDValue, llvm::SDNode*> >::resize(unsigned int)"),
	mu_demangle_test("_ZNK4llvm17ARMTargetLowering28LowerAsmOperandForConstraintENS_7SDValueEcRSt6vectorIS1_SaIS1_EERNS_12SelectionDAGE", "llvm::ARMTargetLowering::LowerAsmOperandForConstraint(llvm::SDValue, char, std::vector<llvm::SDValue, std::allocator<llvm::SDValue> >&, llvm::SelectionDAG&) const"),
	mu_demangle_test("_ZN4llvm11make_vectorIjEESt6vectorIT_SaIS2_EES2_z", "std::vector<unsigned int, std::allocator<unsigned int> > llvm::make_vector<unsigned int>(unsigned int, ...)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm14TargetLowering12ArgListEntryESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::TargetLowering::ArgListEntry, std::allocator<llvm::TargetLowering::ArgListEntry> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::TargetLowering::ArgListEntry*, std::vector<llvm::TargetLowering::ArgListEntry, std::allocator<llvm::TargetLowering::ArgListEntry> > >, llvm::TargetLowering::ArgListEntry const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN4llvm3EVTEPNS1_19TargetRegisterClassEESaIS5_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS5_S7_EERKS5_", "std::vector<std::pair<llvm::EVT, llvm::TargetRegisterClass*>, std::allocator<std::pair<llvm::EVT, llvm::TargetRegisterClass*> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::EVT, llvm::TargetRegisterClass*>*, std::vector<std::pair<llvm::EVT, llvm::TargetRegisterClass*>, std::allocator<std::pair<llvm::EVT, llvm::TargetRegisterClass*> > > >, std::pair<llvm::EVT, llvm::TargetRegisterClass*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIjN4llvm3MVT15SimpleValueTypeEES0_IKS4_S3_ESt10_Select1stIS6_ESt4lessIS4_ESaIS6_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS6_ERKS6_", "std::_Rb_tree<std::pair<unsigned int, llvm::MVT::SimpleValueType>, std::pair<std::pair<unsigned int, llvm::MVT::SimpleValueType> const, llvm::MVT::SimpleValueType>, std::_Select1st<std::pair<std::pair<unsigned int, llvm::MVT::SimpleValueType> const, llvm::MVT::SimpleValueType> >, std::less<std::pair<unsigned int, llvm::MVT::SimpleValueType> >, std::allocator<std::pair<std::pair<unsigned int, llvm::MVT::SimpleValueType> const, llvm::MVT::SimpleValueType> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<std::pair<unsigned int, llvm::MVT::SimpleValueType> const, llvm::MVT::SimpleValueType> >, std::pair<std::pair<unsigned int, llvm::MVT::SimpleValueType> const, llvm::MVT::SimpleValueType> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIjN4llvm3MVT15SimpleValueTypeEES0_IKS4_S3_ESt10_Select1stIS6_ESt4lessIS4_ESaIS6_EE16_M_insert_uniqueERKS6_", "std::_Rb_tree<std::pair<unsigned int, llvm::MVT::SimpleValueType>, std::pair<std::pair<unsigned int, llvm::MVT::SimpleValueType> const, llvm::MVT::SimpleValueType>, std::_Select1st<std::pair<std::pair<unsigned int, llvm::MVT::SimpleValueType> const, llvm::MVT::SimpleValueType> >, std::less<std::pair<unsigned int, llvm::MVT::SimpleValueType> >, std::allocator<std::pair<std::pair<unsigned int, llvm::MVT::SimpleValueType> const, llvm::MVT::SimpleValueType> > >::_M_insert_unique(std::pair<std::pair<unsigned int, llvm::MVT::SimpleValueType> const, llvm::MVT::SimpleValueType> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPvlNS_12DenseMapInfoIS1_EENS2_IlEEE6insertERKSt4pairIS1_lE", "llvm::DenseMap<void*, long, llvm::DenseMapInfo<void*>, llvm::DenseMapInfo<long> >::insert(std::pair<void*, long> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPvlNS_12DenseMapInfoIS1_EENS2_IlEEE16InsertIntoBucketERKS1_RKlPSt4pairIS1_lE", "llvm::DenseMap<void*, long, llvm::DenseMapInfo<void*>, llvm::DenseMapInfo<long> >::InsertIntoBucket(void* const&, long const&, std::pair<void*, long>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPvlNS_12DenseMapInfoIS1_EENS2_IlEEE4growEj", "llvm::DenseMap<void*, long, llvm::DenseMapInfo<void*>, llvm::DenseMapInfo<long> >::grow(unsigned int)"),
	mu_demangle_test("_ZN12_GLOBAL__N_123ARMPreAllocLoadStoreOpt13RescheduleOpsEPN4llvm17MachineBasicBlockERNS1_11SmallVectorIPNS1_12MachineInstrELj4EEEjbRNS1_8DenseMapIS6_jNS1_12DenseMapInfoIS6_EENSA_IjEEEE", "(anonymous namespace)::ARMPreAllocLoadStoreOpt::RescheduleOps(llvm::MachineBasicBlock*, llvm::SmallVector<llvm::MachineInstr*, 4u>&, unsigned int, bool, llvm::DenseMap<llvm::MachineInstr*, unsigned int, llvm::DenseMapInfo<llvm::MachineInstr*>, llvm::DenseMapInfo<unsigned int> >&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjNS_11SmallVectorIPNS_12MachineInstrELj4EEENS_12DenseMapInfoIjEENS5_IS4_EEE5clearEv", "llvm::DenseMap<unsigned int, llvm::SmallVector<llvm::MachineInstr*, 4u>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::SmallVector<llvm::MachineInstr*, 4u> > >::clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIjNS_11SmallVectorIPNS_12MachineInstrELj4EEENS_12DenseMapInfoIjEENS5_IS4_EEE16shrink_and_clearEv", "llvm::DenseMap<unsigned int, llvm::SmallVector<llvm::MachineInstr*, 4u>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::SmallVector<llvm::MachineInstr*, 4u> > >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIjNS_11SmallVectorIPNS_12MachineInstrELj4EEENS_12DenseMapInfoIjEENS5_IS4_EEE16FindAndConstructERKj", "llvm::DenseMap<unsigned int, llvm::SmallVector<llvm::MachineInstr*, 4u>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::SmallVector<llvm::MachineInstr*, 4u> > >::FindAndConstruct(unsigned int const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjNS_11SmallVectorIPNS_12MachineInstrELj4EEENS_12DenseMapInfoIjEENS5_IS4_EEE16InsertIntoBucketERKjRKS4_PSt4pairIjS4_E", "llvm::DenseMap<unsigned int, llvm::SmallVector<llvm::MachineInstr*, 4u>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::SmallVector<llvm::MachineInstr*, 4u> > >::InsertIntoBucket(unsigned int const&, llvm::SmallVector<llvm::MachineInstr*, 4u> const&, std::pair<unsigned int, llvm::SmallVector<llvm::MachineInstr*, 4u> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjNS_11SmallVectorIPNS_12MachineInstrELj4EEENS_12DenseMapInfoIjEENS5_IS4_EEE4growEj", "llvm::DenseMap<unsigned int, llvm::SmallVector<llvm::MachineInstr*, 4u>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::SmallVector<llvm::MachineInstr*, 4u> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_12MachineInstrEjNS_12DenseMapInfoIS2_EENS3_IjEEE16InsertIntoBucketERKS2_RKjPSt4pairIS2_jE", "llvm::DenseMap<llvm::MachineInstr*, unsigned int, llvm::DenseMapInfo<llvm::MachineInstr*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(llvm::MachineInstr* const&, unsigned int const&, std::pair<llvm::MachineInstr*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_12MachineInstrEjNS_12DenseMapInfoIS2_EENS3_IjEEE4growEj", "llvm::DenseMap<llvm::MachineInstr*, unsigned int, llvm::DenseMapInfo<llvm::MachineInstr*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZNK4llvm15TargetInstrInfo16DefinesPredicateEPNS_12MachineInstrERSt6vectorINS_14MachineOperandESaIS4_EE", "llvm::TargetInstrInfo::DefinesPredicate(llvm::MachineInstr*, std::vector<llvm::MachineOperand, std::allocator<llvm::MachineOperand> >&) const"),
	mu_demangle_test("_ZNSt8_Rb_treeIjjSt9_IdentityIjESt4lessIjESaIjEE8_M_eraseEPSt13_Rb_tree_nodeIjE", "std::_Rb_tree<unsigned int, unsigned int, std::_Identity<unsigned int>, std::less<unsigned int>, std::allocator<unsigned int> >::_M_erase(std::_Rb_tree_node<unsigned int>*)"),
	mu_demangle_test("_ZNK4llvm19TargetFrameLowering25spillCalleeSavedRegistersERNS_17MachineBasicBlockENS_14ilist_iteratorINS_12MachineInstrEEERKSt6vectorINS_15CalleeSavedInfoESaIS7_EEPKNS_18TargetRegisterInfoE", "llvm::TargetFrameLowering::spillCalleeSavedRegisters(llvm::MachineBasicBlock&, llvm::ilist_iterator<llvm::MachineInstr>, std::vector<llvm::CalleeSavedInfo, std::allocator<llvm::CalleeSavedInfo> > const&, llvm::TargetRegisterInfo const*) const"),
	mu_demangle_test("_ZNK4llvm19TargetFrameLowering27restoreCalleeSavedRegistersERNS_17MachineBasicBlockENS_14ilist_iteratorINS_12MachineInstrEEERKSt6vectorINS_15CalleeSavedInfoESaIS7_EEPKNS_18TargetRegisterInfoE", "llvm::TargetFrameLowering::restoreCalleeSavedRegisters(llvm::MachineBasicBlock&, llvm::ilist_iterator<llvm::MachineInstr>, std::vector<llvm::CalleeSavedInfo, std::allocator<llvm::CalleeSavedInfo> > const&, llvm::TargetRegisterInfo const*) const"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPKNS_12MachineInstrENS_12DenseMapInfoIjEENS4_IS3_EEE16InsertIntoBucketERKjRKS3_PSt4pairIjS3_E", "llvm::DenseMap<unsigned int, llvm::MachineInstr const*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::MachineInstr const*> >::InsertIntoBucket(unsigned int const&, llvm::MachineInstr const* const&, std::pair<unsigned int, llvm::MachineInstr const*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPKNS_12MachineInstrENS_12DenseMapInfoIjEENS4_IS3_EEE4growEj", "llvm::DenseMap<unsigned int, llvm::MachineInstr const*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::MachineInstr const*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNK4llvm19Thumb1FrameLowering25spillCalleeSavedRegistersERNS_17MachineBasicBlockENS_14ilist_iteratorINS_12MachineInstrEEERKSt6vectorINS_15CalleeSavedInfoESaIS7_EEPKNS_18TargetRegisterInfoE", "llvm::Thumb1FrameLowering::spillCalleeSavedRegisters(llvm::MachineBasicBlock&, llvm::ilist_iterator<llvm::MachineInstr>, std::vector<llvm::CalleeSavedInfo, std::allocator<llvm::CalleeSavedInfo> > const&, llvm::TargetRegisterInfo const*) const"),
	mu_demangle_test("_ZNK4llvm19Thumb1FrameLowering27restoreCalleeSavedRegistersERNS_17MachineBasicBlockENS_14ilist_iteratorINS_12MachineInstrEEERKSt6vectorINS_15CalleeSavedInfoESaIS7_EEPKNS_18TargetRegisterInfoE", "llvm::Thumb1FrameLowering::restoreCalleeSavedRegisters(llvm::MachineBasicBlock&, llvm::ilist_iterator<llvm::MachineInstr>, std::vector<llvm::CalleeSavedInfo, std::allocator<llvm::CalleeSavedInfo> > const&, llvm::TargetRegisterInfo const*) const"),
	mu_demangle_test("_ZNSt6vectorIjSaIjEE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPjS1_EERKj", "std::vector<unsigned int, std::allocator<unsigned int> >::_M_insert_aux(__gnu_cxx::__normal_iterator<unsigned int*, std::vector<unsigned int, std::allocator<unsigned int> > >, unsigned int const&)"),
	mu_demangle_test("_ZN4llvm14TargetLowering15DAGCombinerInfo9CombineToEPNS_6SDNodeERKSt6vectorINS_7SDValueESaIS5_EEb", "llvm::TargetLowering::DAGCombinerInfo::CombineTo(llvm::SDNode*, std::vector<llvm::SDValue, std::allocator<llvm::SDValue> > const&, bool)"),
	mu_demangle_test("_ZSt6__findIN9__gnu_cxx17__normal_iteratorIPPN4llvm6SDNodeESt6vectorIS4_SaIS4_EEEES4_ET_SA_SA_RKT0_St26random_access_iterator_tag", "__gnu_cxx::__normal_iterator<llvm::SDNode**, std::vector<llvm::SDNode*, std::allocator<llvm::SDNode*> > > std::__find<__gnu_cxx::__normal_iterator<llvm::SDNode**, std::vector<llvm::SDNode*, std::allocator<llvm::SDNode*> > >, llvm::SDNode*>(__gnu_cxx::__normal_iterator<llvm::SDNode**, std::vector<llvm::SDNode*, std::allocator<llvm::SDNode*> > >, __gnu_cxx::__normal_iterator<llvm::SDNode**, std::vector<llvm::SDNode*, std::allocator<llvm::SDNode*> > >, llvm::SDNode* const&, std::random_access_iterator_tag)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPN4llvm12MachineInstrEjESaIS4_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS4_S6_EEmRKS4_", "std::vector<std::pair<llvm::MachineInstr*, unsigned int>, std::allocator<std::pair<llvm::MachineInstr*, unsigned int> > >::_M_fill_insert(__gnu_cxx::__normal_iterator<std::pair<llvm::MachineInstr*, unsigned int>*, std::vector<std::pair<llvm::MachineInstr*, unsigned int>, std::allocator<std::pair<llvm::MachineInstr*, unsigned int> > > >, unsigned long, std::pair<llvm::MachineInstr*, unsigned int> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_8ArgumentEiNS_12DenseMapInfoIS3_EENS4_IiEEE16InsertIntoBucketERKS3_RKiPSt4pairIS3_iE", "llvm::DenseMap<llvm::Argument const*, int, llvm::DenseMapInfo<llvm::Argument const*>, llvm::DenseMapInfo<int> >::InsertIntoBucket(llvm::Argument const* const&, int const&, std::pair<llvm::Argument const*, int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_8ArgumentEiNS_12DenseMapInfoIS3_EENS4_IiEEE4growEj", "llvm::DenseMap<llvm::Argument const*, int, llvm::DenseMapInfo<llvm::Argument const*>, llvm::DenseMapInfo<int> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_8ArgumentEiNS_12DenseMapInfoIS3_EENS4_IiEEE16shrink_and_clearEv", "llvm::DenseMap<llvm::Argument const*, int, llvm::DenseMapInfo<llvm::Argument const*>, llvm::DenseMapInfo<int> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_10AllocaInstEiNS_12DenseMapInfoIS3_EENS4_IiEEE16shrink_and_clearEv", "llvm::DenseMap<llvm::AllocaInst const*, int, llvm::DenseMapInfo<llvm::AllocaInst const*>, llvm::DenseMapInfo<int> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_10BasicBlockEPNS_17MachineBasicBlockENS_12DenseMapInfoIS3_EENS6_IS5_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::BasicBlock const*, llvm::MachineBasicBlock*, llvm::DenseMapInfo<llvm::BasicBlock const*>, llvm::DenseMapInfo<llvm::MachineBasicBlock*> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm12InstrEmitter15EmitCopyFromRegEPNS_6SDNodeEjbbjRNS_8DenseMapINS_7SDValueEjNS_12DenseMapInfoIS4_EENS5_IjEEEE", "llvm::InstrEmitter::EmitCopyFromReg(llvm::SDNode*, unsigned int, bool, bool, unsigned int, llvm::DenseMap<llvm::SDValue, unsigned int, llvm::DenseMapInfo<llvm::SDValue>, llvm::DenseMapInfo<unsigned int> >&)"),
	mu_demangle_test("_ZN4llvm12InstrEmitter22CreateVirtualRegistersEPNS_6SDNodeEPNS_12MachineInstrERKNS_15TargetInstrDescEbbRNS_8DenseMapINS_7SDValueEjNS_12DenseMapInfoIS9_EENSA_IjEEEE", "llvm::InstrEmitter::CreateVirtualRegisters(llvm::SDNode*, llvm::MachineInstr*, llvm::TargetInstrDesc const&, bool, bool, llvm::DenseMap<llvm::SDValue, unsigned int, llvm::DenseMapInfo<llvm::SDValue>, llvm::DenseMapInfo<unsigned int> >&)"),
	mu_demangle_test("_ZN4llvm12InstrEmitter5getVRENS_7SDValueERNS_8DenseMapIS1_jNS_12DenseMapInfoIS1_EENS3_IjEEEE", "llvm::InstrEmitter::getVR(llvm::SDValue, llvm::DenseMap<llvm::SDValue, unsigned int, llvm::DenseMapInfo<llvm::SDValue>, llvm::DenseMapInfo<unsigned int> >&)"),
	mu_demangle_test("_ZN4llvm12InstrEmitter18AddRegisterOperandEPNS_12MachineInstrENS_7SDValueEjPKNS_15TargetInstrDescERNS_8DenseMapIS3_jNS_12DenseMapInfoIS3_EENS8_IjEEEEbbb", "llvm::InstrEmitter::AddRegisterOperand(llvm::MachineInstr*, llvm::SDValue, unsigned int, llvm::TargetInstrDesc const*, llvm::DenseMap<llvm::SDValue, unsigned int, llvm::DenseMapInfo<llvm::SDValue>, llvm::DenseMapInfo<unsigned int> >&, bool, bool, bool)"),
	mu_demangle_test("_ZN4llvm12InstrEmitter10AddOperandEPNS_12MachineInstrENS_7SDValueEjPKNS_15TargetInstrDescERNS_8DenseMapIS3_jNS_12DenseMapInfoIS3_EENS8_IjEEEEbbb", "llvm::InstrEmitter::AddOperand(llvm::MachineInstr*, llvm::SDValue, unsigned int, llvm::TargetInstrDesc const*, llvm::DenseMap<llvm::SDValue, unsigned int, llvm::DenseMapInfo<llvm::SDValue>, llvm::DenseMapInfo<unsigned int> >&, bool, bool, bool)"),
	mu_demangle_test("_ZN4llvm12InstrEmitter14EmitSubregNodeEPNS_6SDNodeERNS_8DenseMapINS_7SDValueEjNS_12DenseMapInfoIS4_EENS5_IjEEEEbb", "llvm::InstrEmitter::EmitSubregNode(llvm::SDNode*, llvm::DenseMap<llvm::SDValue, unsigned int, llvm::DenseMapInfo<llvm::SDValue>, llvm::DenseMapInfo<unsigned int> >&, bool, bool)"),
	mu_demangle_test("_ZN4llvm12InstrEmitter22EmitCopyToRegClassNodeEPNS_6SDNodeERNS_8DenseMapINS_7SDValueEjNS_12DenseMapInfoIS4_EENS5_IjEEEE", "llvm::InstrEmitter::EmitCopyToRegClassNode(llvm::SDNode*, llvm::DenseMap<llvm::SDValue, unsigned int, llvm::DenseMapInfo<llvm::SDValue>, llvm::DenseMapInfo<unsigned int> >&)"),
	mu_demangle_test("_ZN4llvm12InstrEmitter15EmitRegSequenceEPNS_6SDNodeERNS_8DenseMapINS_7SDValueEjNS_12DenseMapInfoIS4_EENS5_IjEEEEbb", "llvm::InstrEmitter::EmitRegSequence(llvm::SDNode*, llvm::DenseMap<llvm::SDValue, unsigned int, llvm::DenseMapInfo<llvm::SDValue>, llvm::DenseMapInfo<unsigned int> >&, bool, bool)"),
	mu_demangle_test("_ZN4llvm12InstrEmitter12EmitDbgValueEPNS_10SDDbgValueERNS_8DenseMapINS_7SDValueEjNS_12DenseMapInfoIS4_EENS5_IjEEEE", "llvm::InstrEmitter::EmitDbgValue(llvm::SDDbgValue*, llvm::DenseMap<llvm::SDValue, unsigned int, llvm::DenseMapInfo<llvm::SDValue>, llvm::DenseMapInfo<unsigned int> >&)"),
	mu_demangle_test("_ZN4llvm12InstrEmitter15EmitMachineNodeEPNS_6SDNodeEbbRNS_8DenseMapINS_7SDValueEjNS_12DenseMapInfoIS4_EENS5_IjEEEE", "llvm::InstrEmitter::EmitMachineNode(llvm::SDNode*, bool, bool, llvm::DenseMap<llvm::SDValue, unsigned int, llvm::DenseMapInfo<llvm::SDValue>, llvm::DenseMapInfo<unsigned int> >&)"),
	mu_demangle_test("_ZN4llvm12InstrEmitter15EmitSpecialNodeEPNS_6SDNodeEbbRNS_8DenseMapINS_7SDValueEjNS_12DenseMapInfoIS4_EENS5_IjEEEE", "llvm::InstrEmitter::EmitSpecialNode(llvm::SDNode*, bool, bool, llvm::DenseMap<llvm::SDValue, unsigned int, llvm::DenseMapInfo<llvm::SDValue>, llvm::DenseMapInfo<unsigned int> >&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_7SDValueEjNS_12DenseMapInfoIS1_EENS2_IjEEE6insertERKSt4pairIS1_jE", "llvm::DenseMap<llvm::SDValue, unsigned int, llvm::DenseMapInfo<llvm::SDValue>, llvm::DenseMapInfo<unsigned int> >::insert(std::pair<llvm::SDValue, unsigned int> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_7SDValueEjNS_12DenseMapInfoIS1_EENS2_IjEEE4findERKS1_", "llvm::DenseMap<llvm::SDValue, unsigned int, llvm::DenseMapInfo<llvm::SDValue>, llvm::DenseMapInfo<unsigned int> >::find(llvm::SDValue const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_7SDValueEjNS_12DenseMapInfoIS1_EENS2_IjEEE16InsertIntoBucketERKS1_RKjPSt4pairIS1_jE", "llvm::DenseMap<llvm::SDValue, unsigned int, llvm::DenseMapInfo<llvm::SDValue>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(llvm::SDValue const&, unsigned int const&, std::pair<llvm::SDValue, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_7SDValueEjNS_12DenseMapInfoIS1_EENS2_IjEEE4growEj", "llvm::DenseMap<llvm::SDValue, unsigned int, llvm::DenseMapInfo<llvm::SDValue>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_7SDValueES1_NS_12DenseMapInfoIS1_EES3_E16shrink_and_clearEv", "llvm::DenseMap<llvm::SDValue, llvm::SDValue, llvm::DenseMapInfo<llvm::SDValue>, llvm::DenseMapInfo<llvm::SDValue> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_7SDValueES1_NS_12DenseMapInfoIS1_EES3_E6insertERKSt4pairIS1_S1_E", "llvm::DenseMap<llvm::SDValue, llvm::SDValue, llvm::DenseMapInfo<llvm::SDValue>, llvm::DenseMapInfo<llvm::SDValue> >::insert(std::pair<llvm::SDValue, llvm::SDValue> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_7SDValueES1_NS_12DenseMapInfoIS1_EES3_E4findERKS1_", "llvm::DenseMap<llvm::SDValue, llvm::SDValue, llvm::DenseMapInfo<llvm::SDValue>, llvm::DenseMapInfo<llvm::SDValue> >::find(llvm::SDValue const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_7SDValueESt4pairIS1_S1_ENS_12DenseMapInfoIS1_EENS4_IS3_EEE4findERKS1_", "llvm::DenseMap<llvm::SDValue, std::pair<llvm::SDValue, llvm::SDValue>, llvm::DenseMapInfo<llvm::SDValue>, llvm::DenseMapInfo<std::pair<llvm::SDValue, llvm::SDValue> > >::find(llvm::SDValue const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_7SDValueESt4pairIS1_S1_ENS_12DenseMapInfoIS1_EENS4_IS3_EEE16FindAndConstructERKS1_", "llvm::DenseMap<llvm::SDValue, std::pair<llvm::SDValue, llvm::SDValue>, llvm::DenseMapInfo<llvm::SDValue>, llvm::DenseMapInfo<std::pair<llvm::SDValue, llvm::SDValue> > >::FindAndConstruct(llvm::SDValue const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_7SDValueESt4pairIS1_S1_ENS_12DenseMapInfoIS1_EENS4_IS3_EEE16InsertIntoBucketERKS1_RKS3_PS2_IS1_S3_E", "llvm::DenseMap<llvm::SDValue, std::pair<llvm::SDValue, llvm::SDValue>, llvm::DenseMapInfo<llvm::SDValue>, llvm::DenseMapInfo<std::pair<llvm::SDValue, llvm::SDValue> > >::InsertIntoBucket(llvm::SDValue const&, std::pair<llvm::SDValue, llvm::SDValue> const&, std::pair<llvm::SDValue, std::pair<llvm::SDValue, llvm::SDValue> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_7SDValueESt4pairIS1_S1_ENS_12DenseMapInfoIS1_EENS4_IS3_EEE4growEj", "llvm::DenseMap<llvm::SDValue, std::pair<llvm::SDValue, llvm::SDValue>, llvm::DenseMapInfo<llvm::SDValue>, llvm::DenseMapInfo<std::pair<llvm::SDValue, llvm::SDValue> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_7SDValueES1_NS_12DenseMapInfoIS1_EES3_E16FindAndConstructERKS1_", "llvm::DenseMap<llvm::SDValue, llvm::SDValue, llvm::DenseMapInfo<llvm::SDValue>, llvm::DenseMapInfo<llvm::SDValue> >::FindAndConstruct(llvm::SDValue const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_7SDValueES1_NS_12DenseMapInfoIS1_EES3_E16InsertIntoBucketERKS1_S6_PSt4pairIS1_S1_E", "llvm::DenseMap<llvm::SDValue, llvm::SDValue, llvm::DenseMapInfo<llvm::SDValue>, llvm::DenseMapInfo<llvm::SDValue> >::InsertIntoBucket(llvm::SDValue const&, llvm::SDValue const&, std::pair<llvm::SDValue, llvm::SDValue>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_7SDValueES1_NS_12DenseMapInfoIS1_EES3_E4growEj", "llvm::DenseMap<llvm::SDValue, llvm::SDValue, llvm::DenseMapInfo<llvm::SDValue>, llvm::DenseMapInfo<llvm::SDValue> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm7SDValueESaIS1_EE7reserveEm", "std::vector<llvm::SDValue, std::allocator<llvm::SDValue> >::reserve(unsigned long)"),
	mu_demangle_test("_ZN12_GLOBAL__N_118RegReductionPQBase9initNodesERSt6vectorIN4llvm5SUnitESaIS3_EE", "(anonymous namespace)::RegReductionPQBase::initNodes(std::vector<llvm::SUnit, std::allocator<llvm::SUnit> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_125RegReductionPriorityQueueINS_14ilp_ls_rr_sortEE12popFromQueueERSt6vectorIPN4llvm5SUnitESaIS6_EERS1_", "(anonymous namespace)::RegReductionPriorityQueue<(anonymous namespace)::ilp_ls_rr_sort>::popFromQueue(std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> >&, (anonymous namespace)::ilp_ls_rr_sort&)"),
	mu_demangle_test("_Z25CalcNodeSethiUllmanNumberPKN4llvm5SUnitERSt6vectorIjSaIjEE", "CalcNodeSethiUllmanNumber(llvm::SUnit const*, std::vector<unsigned int, std::allocator<unsigned int> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_125RegReductionPriorityQueueINS_17hybrid_ls_rr_sortEE12popFromQueueERSt6vectorIPN4llvm5SUnitESaIS6_EERS1_", "(anonymous namespace)::RegReductionPriorityQueue<(anonymous namespace)::hybrid_ls_rr_sort>::popFromQueue(std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> >&, (anonymous namespace)::hybrid_ls_rr_sort&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_125RegReductionPriorityQueueINS_14src_ls_rr_sortEE12popFromQueueERSt6vectorIPN4llvm5SUnitESaIS6_EERS1_", "(anonymous namespace)::RegReductionPriorityQueue<(anonymous namespace)::src_ls_rr_sort>::popFromQueue(std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> >&, (anonymous namespace)::src_ls_rr_sort&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_125RegReductionPriorityQueueINS_13td_ls_rr_sortEE12popFromQueueERSt6vectorIPN4llvm5SUnitESaIS6_EERS1_", "(anonymous namespace)::RegReductionPriorityQueue<(anonymous namespace)::td_ls_rr_sort>::popFromQueue(std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> >&, (anonymous namespace)::td_ls_rr_sort&)"),
	mu_demangle_test("_Z18CheckForLiveRegDefPN4llvm5SUnitEjRSt6vectorIS1_SaIS1_EERNS_8SmallSetIjLj4EEERNS_11SmallVectorIjLj4EEEPKNS_18TargetRegisterInfoE", "CheckForLiveRegDef(llvm::SUnit*, unsigned int, std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> >&, llvm::SmallSet<unsigned int, 4u>&, llvm::SmallVector<unsigned int, 4u>&, llvm::TargetRegisterInfo const*)"),
	mu_demangle_test("_ZSt6__findIN9__gnu_cxx17__normal_iteratorIPPN4llvm5SUnitESt6vectorIS4_SaIS4_EEEES4_ET_SA_SA_RKT0_St26random_access_iterator_tag", "__gnu_cxx::__normal_iterator<llvm::SUnit**, std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> > > std::__find<__gnu_cxx::__normal_iterator<llvm::SUnit**, std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> > >, llvm::SUnit*>(__gnu_cxx::__normal_iterator<llvm::SUnit**, std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> > >, __gnu_cxx::__normal_iterator<llvm::SUnit**, std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> > >, llvm::SUnit* const&, std::random_access_iterator_tag)"),
	mu_demangle_test("_ZNSt6vectorIjSaIjEE14_M_fill_assignEmRKj", "std::vector<unsigned int, std::allocator<unsigned int> >::_M_fill_assign(unsigned long, unsigned int const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5SUnitENS_11SmallVectorIjLj4EEENS_12DenseMapInfoIS2_EENS5_IS4_EEE6insertERKSt4pairIS2_S4_E", "llvm::DenseMap<llvm::SUnit*, llvm::SmallVector<unsigned int, 4u>, llvm::DenseMapInfo<llvm::SUnit*>, llvm::DenseMapInfo<llvm::SmallVector<unsigned int, 4u> > >::insert(std::pair<llvm::SUnit*, llvm::SmallVector<unsigned int, 4u> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5SUnitENS_11SmallVectorIjLj4EEENS_12DenseMapInfoIS2_EENS5_IS4_EEE16FindAndConstructERKS2_", "llvm::DenseMap<llvm::SUnit*, llvm::SmallVector<unsigned int, 4u>, llvm::DenseMapInfo<llvm::SUnit*>, llvm::DenseMapInfo<llvm::SmallVector<unsigned int, 4u> > >::FindAndConstruct(llvm::SUnit* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5SUnitENS_11SmallVectorIjLj4EEENS_12DenseMapInfoIS2_EENS5_IS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<llvm::SUnit*, llvm::SmallVector<unsigned int, 4u>, llvm::DenseMapInfo<llvm::SUnit*>, llvm::DenseMapInfo<llvm::SmallVector<unsigned int, 4u> > >::InsertIntoBucket(llvm::SUnit* const&, llvm::SmallVector<unsigned int, 4u> const&, std::pair<llvm::SUnit*, llvm::SmallVector<unsigned int, 4u> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5SUnitENS_11SmallVectorIjLj4EEENS_12DenseMapInfoIS2_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::SUnit*, llvm::SmallVector<unsigned int, 4u>, llvm::DenseMapInfo<llvm::SUnit*>, llvm::DenseMapInfo<llvm::SmallVector<unsigned int, 4u> > >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm5SUnitESaIS2_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS2_S4_EEmRKS2_", "std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> >::_M_fill_insert(__gnu_cxx::__normal_iterator<llvm::SUnit**, std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> > >, unsigned long, llvm::SUnit* const&)"),
	mu_demangle_test("_Z17ProcessSourceNodePN4llvm6SDNodeEPNS_12SelectionDAGERNS_12InstrEmitterERNS_8DenseMapINS_7SDValueEjNS_12DenseMapInfoIS7_EENS8_IjEEEERNS_11SmallVectorISt4pairIjPNS_12MachineInstrEELj32EEERNS_8SmallSetIjLj8EEE", "ProcessSourceNode(llvm::SDNode*, llvm::SelectionDAG*, llvm::InstrEmitter&, llvm::DenseMap<llvm::SDValue, unsigned int, llvm::DenseMapInfo<llvm::SDValue>, llvm::DenseMapInfo<unsigned int> >&, llvm::SmallVector<std::pair<unsigned int, llvm::MachineInstr*>, 32u>&, llvm::SmallSet<unsigned int, 8u>&)"),
	mu_demangle_test("_Z18ProcessSDDbgValuesPN4llvm6SDNodeEPNS_12SelectionDAGERNS_12InstrEmitterERNS_11SmallVectorISt4pairIjPNS_12MachineInstrEELj32EEERNS_8DenseMapINS_7SDValueEjNS_12DenseMapInfoISE_EENSF_IjEEEEj", "ProcessSDDbgValues(llvm::SDNode*, llvm::SelectionDAG*, llvm::InstrEmitter&, llvm::SmallVector<std::pair<unsigned int, llvm::MachineInstr*>, 32u>&, llvm::DenseMap<llvm::SDValue, unsigned int, llvm::DenseMapInfo<llvm::SDValue>, llvm::DenseMapInfo<unsigned int> >&, unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIxPNS_6SDNodeENS_12DenseMapInfoIxEENS3_IS2_EEE6insertERKSt4pairIxS2_E", "llvm::DenseMap<int64_t, llvm::SDNode*, llvm::DenseMapInfo<int64_t>, llvm::DenseMapInfo<llvm::SDNode*> >::insert(std::pair<int64_t, llvm::SDNode*> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIxPNS_6SDNodeENS_12DenseMapInfoIxEENS3_IS2_EEE16InsertIntoBucketERKxRKS2_PSt4pairIxS2_E", "llvm::DenseMap<int64_t, llvm::SDNode*, llvm::DenseMapInfo<int64_t>, llvm::DenseMapInfo<llvm::SDNode*> >::InsertIntoBucket(int64_t const&, llvm::SDNode* const&, std::pair<int64_t, llvm::SDNode*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIxPNS_6SDNodeENS_12DenseMapInfoIxEENS3_IS2_EEE4growEj", "llvm::DenseMap<int64_t, llvm::SDNode*, llvm::DenseMapInfo<int64_t>, llvm::DenseMapInfo<llvm::SDNode*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm12SelectionDAG7getNodeEjNS_8DebugLocERKSt6vectorINS_3EVTESaIS3_EEPKNS_7SDValueEj", "llvm::SelectionDAG::getNode(unsigned int, llvm::DebugLoc, std::vector<llvm::EVT, std::allocator<llvm::EVT> > const&, llvm::SDValue const*, unsigned int)"),
	mu_demangle_test("_ZN4llvm12SelectionDAG14getMachineNodeEjNS_8DebugLocERKSt6vectorINS_3EVTESaIS3_EEPKNS_7SDValueEj", "llvm::SelectionDAG::getMachineNode(unsigned int, llvm::DebugLoc, std::vector<llvm::EVT, std::allocator<llvm::EVT> > const&, llvm::SDValue const*, unsigned int)"),
	mu_demangle_test("_Z24FindOptimalMemOpLoweringRSt6vectorIN4llvm3EVTESaIS1_EEjyjjbbRNS0_12SelectionDAGERKNS0_14TargetLoweringE", "FindOptimalMemOpLowering(std::vector<llvm::EVT, std::allocator<llvm::EVT> >&, unsigned int, uint64_t, unsigned int, unsigned int, bool, bool, llvm::SelectionDAG&, llvm::TargetLowering const&)"),
	mu_demangle_test("_ZNSt3mapISt4pairISshEPN4llvm6SDNodeESt4lessIS1_ESaIS0_IKS1_S4_EEEixERS7_", "std::map<std::pair<std::string, unsigned char>, llvm::SDNode*, std::less<std::pair<std::string, unsigned char> >, std::allocator<std::pair<std::pair<std::string, unsigned char> const, llvm::SDNode*> > >::operator[](std::pair<std::string, unsigned char> const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm3EVTESaIS1_EE7reserveEm", "std::vector<llvm::EVT, std::allocator<llvm::EVT> >::reserve(unsigned long)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm3EVTES1_St9_IdentityIS1_ENS1_14compareRawBitsESaIS1_EE16_M_insert_uniqueERKS1_", "std::_Rb_tree<llvm::EVT, llvm::EVT, std::_Identity<llvm::EVT>, llvm::EVT::compareRawBits, std::allocator<llvm::EVT> >::_M_insert_unique(llvm::EVT const&)"),
	mu_demangle_test("_ZN4llvm14object_creatorISt3setINS_3EVTENS2_14compareRawBitsESaIS2_EEEEPvv", "void* llvm::object_creator<std::set<llvm::EVT, llvm::EVT::compareRawBits, std::allocator<llvm::EVT> > >()"),
	mu_demangle_test("_ZN4llvm14object_deleterISt3setINS_3EVTENS2_14compareRawBitsESaIS2_EEE4callEPv", "llvm::object_deleter<std::set<llvm::EVT, llvm::EVT::compareRawBits, std::allocator<llvm::EVT> > >::call(void*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm3EVTES1_St9_IdentityIS1_ENS1_14compareRawBitsESaIS1_EE8_M_eraseEPSt13_Rb_tree_nodeIS1_E", "std::_Rb_tree<llvm::EVT, llvm::EVT, std::_Identity<llvm::EVT>, llvm::EVT::compareRawBits, std::allocator<llvm::EVT> >::_M_erase(std::_Rb_tree_node<llvm::EVT>*)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm8SDVTListESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<llvm::SDVTList, std::allocator<llvm::SDVTList> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::SDVTList*, std::vector<llvm::SDVTList, std::allocator<llvm::SDVTList> > >, llvm::SDVTList const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm14CondCodeSDNodeESaIS2_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS2_S4_EEmRKS2_", "std::vector<llvm::CondCodeSDNode*, std::allocator<llvm::CondCodeSDNode*> >::_M_fill_insert(__gnu_cxx::__normal_iterator<llvm::CondCodeSDNode**, std::vector<llvm::CondCodeSDNode*, std::allocator<llvm::CondCodeSDNode*> > >, unsigned long, llvm::CondCodeSDNode* const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairISshES0_IKS1_PN4llvm6SDNodeEESt10_Select1stIS6_ESt4lessIS1_ESaIS6_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS6_ERKS6_", "std::_Rb_tree<std::pair<std::string, unsigned char>, std::pair<std::pair<std::string, unsigned char> const, llvm::SDNode*>, std::_Select1st<std::pair<std::pair<std::string, unsigned char> const, llvm::SDNode*> >, std::less<std::pair<std::string, unsigned char> >, std::allocator<std::pair<std::pair<std::string, unsigned char> const, llvm::SDNode*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<std::pair<std::string, unsigned char> const, llvm::SDNode*> >, std::pair<std::pair<std::string, unsigned char> const, llvm::SDNode*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairISshES0_IKS1_PN4llvm6SDNodeEESt10_Select1stIS6_ESt4lessIS1_ESaIS6_EE9_M_insertEPSt18_Rb_tree_node_baseSE_RKS6_", "std::_Rb_tree<std::pair<std::string, unsigned char>, std::pair<std::pair<std::string, unsigned char> const, llvm::SDNode*>, std::_Select1st<std::pair<std::pair<std::string, unsigned char> const, llvm::SDNode*> >, std::less<std::pair<std::string, unsigned char> >, std::allocator<std::pair<std::pair<std::string, unsigned char> const, llvm::SDNode*> > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<std::pair<std::string, unsigned char> const, llvm::SDNode*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairISshES0_IKS1_PN4llvm6SDNodeEESt10_Select1stIS6_ESt4lessIS1_ESaIS6_EE16_M_insert_uniqueERKS6_", "std::_Rb_tree<std::pair<std::string, unsigned char>, std::pair<std::pair<std::string, unsigned char> const, llvm::SDNode*>, std::_Select1st<std::pair<std::pair<std::string, unsigned char> const, llvm::SDNode*> >, std::less<std::pair<std::string, unsigned char> >, std::allocator<std::pair<std::pair<std::string, unsigned char> const, llvm::SDNode*> > >::_M_insert_unique(std::pair<std::pair<std::string, unsigned char> const, llvm::SDNode*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairISshES0_IKS1_PN4llvm6SDNodeEESt10_Select1stIS6_ESt4lessIS1_ESaIS6_EE11lower_boundERS2_", "std::_Rb_tree<std::pair<std::string, unsigned char>, std::pair<std::pair<std::string, unsigned char> const, llvm::SDNode*>, std::_Select1st<std::pair<std::pair<std::string, unsigned char> const, llvm::SDNode*> >, std::less<std::pair<std::string, unsigned char> >, std::allocator<std::pair<std::pair<std::string, unsigned char> const, llvm::SDNode*> > >::lower_bound(std::pair<std::string, unsigned char> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm3EVTESt4pairIKS1_PNS0_6SDNodeEESt10_Select1stIS6_ENS1_14compareRawBitsESaIS6_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS6_ERKS6_", "std::_Rb_tree<llvm::EVT, std::pair<llvm::EVT const, llvm::SDNode*>, std::_Select1st<std::pair<llvm::EVT const, llvm::SDNode*> >, llvm::EVT::compareRawBits, std::allocator<std::pair<llvm::EVT const, llvm::SDNode*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::EVT const, llvm::SDNode*> >, std::pair<llvm::EVT const, llvm::SDNode*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm3EVTESt4pairIKS1_PNS0_6SDNodeEESt10_Select1stIS6_ENS1_14compareRawBitsESaIS6_EE16_M_insert_uniqueERKS6_", "std::_Rb_tree<llvm::EVT, std::pair<llvm::EVT const, llvm::SDNode*>, std::_Select1st<std::pair<llvm::EVT const, llvm::SDNode*> >, llvm::EVT::compareRawBits, std::allocator<std::pair<llvm::EVT const, llvm::SDNode*> > >::_M_insert_unique(std::pair<llvm::EVT const, llvm::SDNode*> const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm6SDNodeESaIS2_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS2_S4_EEmRKS2_", "std::vector<llvm::SDNode*, std::allocator<llvm::SDNode*> >::_M_fill_insert(__gnu_cxx::__normal_iterator<llvm::SDNode**, std::vector<llvm::SDNode*, std::allocator<llvm::SDNode*> > >, unsigned long, llvm::SDNode* const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairISshES0_IKS1_PN4llvm6SDNodeEESt10_Select1stIS6_ESt4lessIS1_ESaIS6_EE8_M_eraseEPSt13_Rb_tree_nodeIS6_E", "std::_Rb_tree<std::pair<std::string, unsigned char>, std::pair<std::pair<std::string, unsigned char> const, llvm::SDNode*>, std::_Select1st<std::pair<std::pair<std::string, unsigned char> const, llvm::SDNode*> >, std::less<std::pair<std::string, unsigned char> >, std::allocator<std::pair<std::pair<std::string, unsigned char> const, llvm::SDNode*> > >::_M_erase(std::_Rb_tree_node<std::pair<std::pair<std::string, unsigned char> const, llvm::SDNode*> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm3EVTESt4pairIKS1_PNS0_6SDNodeEESt10_Select1stIS6_ENS1_14compareRawBitsESaIS6_EE8_M_eraseEPSt13_Rb_tree_nodeIS6_E", "std::_Rb_tree<llvm::EVT, std::pair<llvm::EVT const, llvm::SDNode*>, std::_Select1st<std::pair<llvm::EVT const, llvm::SDNode*> >, llvm::EVT::compareRawBits, std::allocator<std::pair<llvm::EVT const, llvm::SDNode*> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::EVT const, llvm::SDNode*> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm3EVTESt4pairIKS1_PNS0_6SDNodeEESt10_Select1stIS6_ENS1_14compareRawBitsESaIS6_EE5eraseESt17_Rb_tree_iteratorIS6_ESD_", "std::_Rb_tree<llvm::EVT, std::pair<llvm::EVT const, llvm::SDNode*>, std::_Select1st<std::pair<llvm::EVT const, llvm::SDNode*> >, llvm::EVT::compareRawBits, std::allocator<std::pair<llvm::EVT const, llvm::SDNode*> > >::erase(std::_Rb_tree_iterator<std::pair<llvm::EVT const, llvm::SDNode*> >, std::_Rb_tree_iterator<std::pair<llvm::EVT const, llvm::SDNode*> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairISshES0_IKS1_PN4llvm6SDNodeEESt10_Select1stIS6_ESt4lessIS1_ESaIS6_EE5eraseESt17_Rb_tree_iteratorIS6_ESE_", "std::_Rb_tree<std::pair<std::string, unsigned char>, std::pair<std::pair<std::string, unsigned char> const, llvm::SDNode*>, std::_Select1st<std::pair<std::pair<std::string, unsigned char> const, llvm::SDNode*> >, std::less<std::pair<std::string, unsigned char> >, std::allocator<std::pair<std::pair<std::string, unsigned char> const, llvm::SDNode*> > >::erase(std::_Rb_tree_iterator<std::pair<std::pair<std::string, unsigned char> const, llvm::SDNode*> >, std::_Rb_tree_iterator<std::pair<std::pair<std::string, unsigned char> const, llvm::SDNode*> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairISshES0_IKS1_PN4llvm6SDNodeEESt10_Select1stIS6_ESt4lessIS1_ESaIS6_EE11upper_boundERS2_", "std::_Rb_tree<std::pair<std::string, unsigned char>, std::pair<std::pair<std::string, unsigned char> const, llvm::SDNode*>, std::_Select1st<std::pair<std::pair<std::string, unsigned char> const, llvm::SDNode*> >, std::less<std::pair<std::string, unsigned char> >, std::allocator<std::pair<std::pair<std::string, unsigned char> const, llvm::SDNode*> > >::upper_bound(std::pair<std::string, unsigned char> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_6SDNodeENS_11SmallVectorIPNS_10SDDbgValueELj2EEENS_12DenseMapInfoIS3_EENS8_IS7_EEE16FindAndConstructERKS3_", "llvm::DenseMap<llvm::SDNode const*, llvm::SmallVector<llvm::SDDbgValue*, 2u>, llvm::DenseMapInfo<llvm::SDNode const*>, llvm::DenseMapInfo<llvm::SmallVector<llvm::SDDbgValue*, 2u> > >::FindAndConstruct(llvm::SDNode const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_6SDNodeENS_11SmallVectorIPNS_10SDDbgValueELj2EEENS_12DenseMapInfoIS3_EENS8_IS7_EEE16InsertIntoBucketERKS3_RKS7_PSt4pairIS3_S7_E", "llvm::DenseMap<llvm::SDNode const*, llvm::SmallVector<llvm::SDDbgValue*, 2u>, llvm::DenseMapInfo<llvm::SDNode const*>, llvm::DenseMapInfo<llvm::SmallVector<llvm::SDDbgValue*, 2u> > >::InsertIntoBucket(llvm::SDNode const* const&, llvm::SmallVector<llvm::SDDbgValue*, 2u> const&, std::pair<llvm::SDNode const*, llvm::SmallVector<llvm::SDDbgValue*, 2u> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_6SDNodeENS_11SmallVectorIPNS_10SDDbgValueELj2EEENS_12DenseMapInfoIS3_EENS8_IS7_EEE4growEj", "llvm::DenseMap<llvm::SDNode const*, llvm::SmallVector<llvm::SDDbgValue*, 2u>, llvm::DenseMapInfo<llvm::SDNode const*>, llvm::DenseMapInfo<llvm::SmallVector<llvm::SDDbgValue*, 2u> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_6SDNodeEjNS_12DenseMapInfoIS3_EENS4_IjEEE16InsertIntoBucketERKS3_RKjPSt4pairIS3_jE", "llvm::DenseMap<llvm::SDNode const*, unsigned int, llvm::DenseMapInfo<llvm::SDNode const*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(llvm::SDNode const* const&, unsigned int const&, std::pair<llvm::SDNode const*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_6SDNodeEjNS_12DenseMapInfoIS3_EENS4_IjEEE4growEj", "llvm::DenseMap<llvm::SDNode const*, unsigned int, llvm::DenseMapInfo<llvm::SDNode const*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_6SDNodeENS_11SmallVectorIPNS_10SDDbgValueELj2EEENS_12DenseMapInfoIS3_EENS8_IS7_EEE5clearEv", "llvm::DenseMap<llvm::SDNode const*, llvm::SmallVector<llvm::SDDbgValue*, 2u>, llvm::DenseMapInfo<llvm::SDNode const*>, llvm::DenseMapInfo<llvm::SmallVector<llvm::SDDbgValue*, 2u> > >::clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_6SDNodeENS_11SmallVectorIPNS_10SDDbgValueELj2EEENS_12DenseMapInfoIS3_EENS8_IS7_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::SDNode const*, llvm::SmallVector<llvm::SDDbgValue*, 2u>, llvm::DenseMapInfo<llvm::SDNode const*>, llvm::DenseMapInfo<llvm::SmallVector<llvm::SDDbgValue*, 2u> > >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_6SDNodeEjNS_12DenseMapInfoIS3_EENS4_IjEEE16shrink_and_clearEv", "llvm::DenseMap<llvm::SDNode const*, unsigned int, llvm::DenseMapInfo<llvm::SDNode const*>, llvm::DenseMapInfo<unsigned int> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm19SelectionDAGBuilder20ShouldEmitAsBranchesERKSt6vectorINS0_9CaseBlockESaIS2_EE", "llvm::SelectionDAGBuilder::ShouldEmitAsBranches(std::vector<llvm::SelectionDAGBuilder::CaseBlock, std::allocator<llvm::SelectionDAGBuilder::CaseBlock> > const&)"),
	mu_demangle_test("_ZN4llvm19SelectionDAGBuilder22handleSmallSwitchRangeERNS0_7CaseRecERSt6vectorIS1_SaIS1_EEPKNS_5ValueEPNS_17MachineBasicBlockESB_", "llvm::SelectionDAGBuilder::handleSmallSwitchRange(llvm::SelectionDAGBuilder::CaseRec&, std::vector<llvm::SelectionDAGBuilder::CaseRec, std::allocator<llvm::SelectionDAGBuilder::CaseRec> >&, llvm::Value const*, llvm::MachineBasicBlock*, llvm::MachineBasicBlock*)"),
	mu_demangle_test("_ZN4llvm19SelectionDAGBuilder18handleJTSwitchCaseERNS0_7CaseRecERSt6vectorIS1_SaIS1_EEPKNS_5ValueEPNS_17MachineBasicBlockESB_", "llvm::SelectionDAGBuilder::handleJTSwitchCase(llvm::SelectionDAGBuilder::CaseRec&, std::vector<llvm::SelectionDAGBuilder::CaseRec, std::allocator<llvm::SelectionDAGBuilder::CaseRec> >&, llvm::Value const*, llvm::MachineBasicBlock*, llvm::MachineBasicBlock*)"),
	mu_demangle_test("_ZN4llvm19SelectionDAGBuilder23handleBTSplitSwitchCaseERNS0_7CaseRecERSt6vectorIS1_SaIS1_EEPKNS_5ValueEPNS_17MachineBasicBlockESB_", "llvm::SelectionDAGBuilder::handleBTSplitSwitchCase(llvm::SelectionDAGBuilder::CaseRec&, std::vector<llvm::SelectionDAGBuilder::CaseRec, std::allocator<llvm::SelectionDAGBuilder::CaseRec> >&, llvm::Value const*, llvm::MachineBasicBlock*, llvm::MachineBasicBlock*)"),
	mu_demangle_test("_ZN4llvm19SelectionDAGBuilder24handleBitTestsSwitchCaseERNS0_7CaseRecERSt6vectorIS1_SaIS1_EEPKNS_5ValueEPNS_17MachineBasicBlockESB_", "llvm::SelectionDAGBuilder::handleBitTestsSwitchCase(llvm::SelectionDAGBuilder::CaseRec&, std::vector<llvm::SelectionDAGBuilder::CaseRec, std::allocator<llvm::SelectionDAGBuilder::CaseRec> >&, llvm::Value const*, llvm::MachineBasicBlock*, llvm::MachineBasicBlock*)"),
	mu_demangle_test("_ZN4llvm19SelectionDAGBuilder10ClusterifyERSt6vectorINS0_4CaseESaIS2_EERKNS_10SwitchInstE", "llvm::SelectionDAGBuilder::Clusterify(std::vector<llvm::SelectionDAGBuilder::Case, std::allocator<llvm::SelectionDAGBuilder::Case> >&, llvm::SwitchInst const&)"),
	mu_demangle_test("_ZNK4llvm14TargetLowering11LowerCallToENS_7SDValueEPKNS_4TypeEbbbbjNS_11CallingConv2IDEbbS1_RSt6vectorINS0_12ArgListEntryESaIS8_EERNS_12SelectionDAGENS_8DebugLocE", "llvm::TargetLowering::LowerCallTo(llvm::SDValue, llvm::Type const*, bool, bool, bool, bool, unsigned int, llvm::CallingConv::ID, bool, bool, llvm::SDValue, std::vector<llvm::TargetLowering::ArgListEntry, std::allocator<llvm::TargetLowering::ArgListEntry> >&, llvm::SelectionDAG&, llvm::DebugLoc) const"),
	mu_demangle_test("_ZN4llvm19SelectionDAGBuilder20GetRegistersForValueERNS_20SDISelAsmOperandInfoERSt3setIjSt4lessIjESaIjEES8_", "llvm::SelectionDAGBuilder::GetRegistersForValue(llvm::SDISelAsmOperandInfo&, std::set<unsigned int, std::less<unsigned int>, std::allocator<unsigned int> >&, std::set<unsigned int, std::less<unsigned int>, std::allocator<unsigned int> >&)"),
	mu_demangle_test("_ZNK12_GLOBAL__N_112RegsForValue20AddInlineAsmOperandsEjbjRN4llvm12SelectionDAGERSt6vectorINS1_7SDValueESaIS5_EE", "(anonymous namespace)::RegsForValue::AddInlineAsmOperands(unsigned int, bool, unsigned int, llvm::SelectionDAG&, std::vector<llvm::SDValue, std::allocator<llvm::SDValue> >&) const"),
	mu_demangle_test("_ZSt22__uninitialized_copy_aIPSt4pairIN12_GLOBAL__N_112RegsForValueEPN4llvm5ValueEES7_S6_ET0_T_S9_S8_SaIT1_E", "std::pair<(anonymous namespace)::RegsForValue, llvm::Value*>* std::__uninitialized_copy_a<std::pair<(anonymous namespace)::RegsForValue, llvm::Value*>*, std::pair<(anonymous namespace)::RegsForValue, llvm::Value*>*, std::pair<(anonymous namespace)::RegsForValue, llvm::Value*> >(std::pair<(anonymous namespace)::RegsForValue, llvm::Value*>*, std::pair<(anonymous namespace)::RegsForValue, llvm::Value*>*, std::pair<(anonymous namespace)::RegsForValue, llvm::Value*>*, std::allocator<std::pair<(anonymous namespace)::RegsForValue, llvm::Value*> >)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN4llvm19SelectionDAGBuilder15JumpTableHeaderENS2_9JumpTableEESaIS5_EE9push_backERKS5_", "std::vector<std::pair<llvm::SelectionDAGBuilder::JumpTableHeader, llvm::SelectionDAGBuilder::JumpTable>, std::allocator<std::pair<llvm::SelectionDAGBuilder::JumpTableHeader, llvm::SelectionDAGBuilder::JumpTable> > >::push_back(std::pair<llvm::SelectionDAGBuilder::JumpTableHeader, llvm::SelectionDAGBuilder::JumpTable> const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm14TargetLowering12ArgListEntryESaIS2_EE7reserveEm", "std::vector<llvm::TargetLowering::ArgListEntry, std::allocator<llvm::TargetLowering::ArgListEntry> >::reserve(unsigned long)"),
	mu_demangle_test("_ZN4llvm8po_beginIPKNS_4TypeEEENS_11po_iteratorIT_NS_11SmallPtrSetIPNS_11GraphTraitsIS5_E8NodeTypeELj8EEELb0ES8_EES5_", "llvm::po_iterator<llvm::Type const*, llvm::SmallPtrSet<llvm::GraphTraits<llvm::Type const*>::NodeType*, 8u>, false, llvm::GraphTraits<llvm::Type const*> > llvm::po_begin<llvm::Type const*>(llvm::Type const*)"),
	mu_demangle_test("_ZNK4llvm20SDISelAsmOperandInfo17MarkAllocatedRegsEbbRSt3setIjSt4lessIjESaIjEES6_RKNS_18TargetRegisterInfoE", "llvm::SDISelAsmOperandInfo::MarkAllocatedRegs(bool, bool, std::set<unsigned int, std::less<unsigned int>, std::allocator<unsigned int> >&, std::set<unsigned int, std::less<unsigned int>, std::allocator<unsigned int> >&, llvm::TargetRegisterInfo const&) const"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_8ConstantEjNS_12DenseMapInfoIS3_EENS4_IjEEE16shrink_and_clearEv", "llvm::DenseMap<llvm::Constant const*, unsigned int, llvm::DenseMapInfo<llvm::Constant const*>, llvm::DenseMapInfo<unsigned int> >::shrink_and_clear()"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPN4llvm12MachineInstrEjESaIS4_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS4_S6_EERKS4_", "std::vector<std::pair<llvm::MachineInstr*, unsigned int>, std::allocator<std::pair<llvm::MachineInstr*, unsigned int> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::MachineInstr*, unsigned int>*, std::vector<std::pair<llvm::MachineInstr*, unsigned int>, std::allocator<std::pair<llvm::MachineInstr*, unsigned int> > > >, std::pair<llvm::MachineInstr*, unsigned int> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_8ConstantEjNS_12DenseMapInfoIS3_EENS4_IjEEE16InsertIntoBucketERKS3_RKjPSt4pairIS3_jE", "llvm::DenseMap<llvm::Constant const*, unsigned int, llvm::DenseMapInfo<llvm::Constant const*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(llvm::Constant const* const&, unsigned int const&, std::pair<llvm::Constant const*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_8ConstantEjNS_12DenseMapInfoIS3_EENS4_IjEEE4growEj", "llvm::DenseMap<llvm::Constant const*, unsigned int, llvm::DenseMapInfo<llvm::Constant const*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN4llvm7SDValueEPKNS1_5ValueEESaIS6_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS6_S8_EERKS6_", "std::vector<std::pair<llvm::SDValue, llvm::Value const*>, std::allocator<std::pair<llvm::SDValue, llvm::Value const*> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::SDValue, llvm::Value const*>*, std::vector<std::pair<llvm::SDValue, llvm::Value const*>, std::allocator<std::pair<llvm::SDValue, llvm::Value const*> > > >, std::pair<llvm::SDValue, llvm::Value const*> const&)"),
	mu_demangle_test("_ZN4llvm11po_iteratorIPKNS_4TypeENS_11SmallPtrSetIS3_Lj8EEELb0ENS_11GraphTraitsIS3_EEE13traverseChildEv", "llvm::po_iterator<llvm::Type const*, llvm::SmallPtrSet<llvm::Type const*, 8u>, false, llvm::GraphTraits<llvm::Type const*> >::traverseChild()"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPKN4llvm4TypeEPNS1_12PATypeHandleEESaIS7_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS7_S9_EERKS7_", "std::vector<std::pair<llvm::Type const*, llvm::PATypeHandle*>, std::allocator<std::pair<llvm::Type const*, llvm::PATypeHandle*> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::Type const*, llvm::PATypeHandle*>*, std::vector<std::pair<llvm::Type const*, llvm::PATypeHandle*>, std::allocator<std::pair<llvm::Type const*, llvm::PATypeHandle*> > > >, std::pair<llvm::Type const*, llvm::PATypeHandle*> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_10AllocaInstEiNS_12DenseMapInfoIS3_EENS4_IiEEE16InsertIntoBucketERKS3_RKiPSt4pairIS3_iE", "llvm::DenseMap<llvm::AllocaInst const*, int, llvm::DenseMapInfo<llvm::AllocaInst const*>, llvm::DenseMapInfo<int> >::InsertIntoBucket(llvm::AllocaInst const* const&, int const&, std::pair<llvm::AllocaInst const*, int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_10AllocaInstEiNS_12DenseMapInfoIS3_EENS4_IiEEE4growEj", "llvm::DenseMap<llvm::AllocaInst const*, int, llvm::DenseMapInfo<llvm::AllocaInst const*>, llvm::DenseMapInfo<int> >::grow(unsigned int)"),
	mu_demangle_test("_ZSt16__introsort_loopIN9__gnu_cxx17__normal_iteratorIPN4llvm19SelectionDAGBuilder4CaseESt6vectorIS4_SaIS4_EEEElNS3_7CaseCmpEEvT_SB_T0_T1_", "void std::__introsort_loop<__gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::Case*, std::vector<llvm::SelectionDAGBuilder::Case, std::allocator<llvm::SelectionDAGBuilder::Case> > >, long, llvm::SelectionDAGBuilder::CaseCmp>(__gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::Case*, std::vector<llvm::SelectionDAGBuilder::Case, std::allocator<llvm::SelectionDAGBuilder::Case> > >, __gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::Case*, std::vector<llvm::SelectionDAGBuilder::Case, std::allocator<llvm::SelectionDAGBuilder::Case> > >, long, llvm::SelectionDAGBuilder::CaseCmp)"),
	mu_demangle_test("_ZSt22__final_insertion_sortIN9__gnu_cxx17__normal_iteratorIPN4llvm19SelectionDAGBuilder4CaseESt6vectorIS4_SaIS4_EEEENS3_7CaseCmpEEvT_SB_T0_", "void std::__final_insertion_sort<__gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::Case*, std::vector<llvm::SelectionDAGBuilder::Case, std::allocator<llvm::SelectionDAGBuilder::Case> > >, llvm::SelectionDAGBuilder::CaseCmp>(__gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::Case*, std::vector<llvm::SelectionDAGBuilder::Case, std::allocator<llvm::SelectionDAGBuilder::Case> > >, __gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::Case*, std::vector<llvm::SelectionDAGBuilder::Case, std::allocator<llvm::SelectionDAGBuilder::Case> > >, llvm::SelectionDAGBuilder::CaseCmp)"),
	mu_demangle_test("_ZSt16__insertion_sortIN9__gnu_cxx17__normal_iteratorIPN4llvm19SelectionDAGBuilder4CaseESt6vectorIS4_SaIS4_EEEENS3_7CaseCmpEEvT_SB_T0_", "void std::__insertion_sort<__gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::Case*, std::vector<llvm::SelectionDAGBuilder::Case, std::allocator<llvm::SelectionDAGBuilder::Case> > >, llvm::SelectionDAGBuilder::CaseCmp>(__gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::Case*, std::vector<llvm::SelectionDAGBuilder::Case, std::allocator<llvm::SelectionDAGBuilder::Case> > >, __gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::Case*, std::vector<llvm::SelectionDAGBuilder::Case, std::allocator<llvm::SelectionDAGBuilder::Case> > >, llvm::SelectionDAGBuilder::CaseCmp)"),
	mu_demangle_test("_ZSt21__unguarded_partitionIN9__gnu_cxx17__normal_iteratorIPN4llvm19SelectionDAGBuilder4CaseESt6vectorIS4_SaIS4_EEEES4_NS3_7CaseCmpEET_SB_SB_T0_T1_", "__gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::Case*, std::vector<llvm::SelectionDAGBuilder::Case, std::allocator<llvm::SelectionDAGBuilder::Case> > > std::__unguarded_partition<__gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::Case*, std::vector<llvm::SelectionDAGBuilder::Case, std::allocator<llvm::SelectionDAGBuilder::Case> > >, llvm::SelectionDAGBuilder::Case, llvm::SelectionDAGBuilder::CaseCmp>(__gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::Case*, std::vector<llvm::SelectionDAGBuilder::Case, std::allocator<llvm::SelectionDAGBuilder::Case> > >, __gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::Case*, std::vector<llvm::SelectionDAGBuilder::Case, std::allocator<llvm::SelectionDAGBuilder::Case> > >, llvm::SelectionDAGBuilder::Case, llvm::SelectionDAGBuilder::CaseCmp)"),
	mu_demangle_test("_ZSt13__heap_selectIN9__gnu_cxx17__normal_iteratorIPN4llvm19SelectionDAGBuilder4CaseESt6vectorIS4_SaIS4_EEEENS3_7CaseCmpEEvT_SB_SB_T0_", "void std::__heap_select<__gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::Case*, std::vector<llvm::SelectionDAGBuilder::Case, std::allocator<llvm::SelectionDAGBuilder::Case> > >, llvm::SelectionDAGBuilder::CaseCmp>(__gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::Case*, std::vector<llvm::SelectionDAGBuilder::Case, std::allocator<llvm::SelectionDAGBuilder::Case> > >, __gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::Case*, std::vector<llvm::SelectionDAGBuilder::Case, std::allocator<llvm::SelectionDAGBuilder::Case> > >, __gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::Case*, std::vector<llvm::SelectionDAGBuilder::Case, std::allocator<llvm::SelectionDAGBuilder::Case> > >, llvm::SelectionDAGBuilder::CaseCmp)"),
	mu_demangle_test("_ZSt13__adjust_heapIN9__gnu_cxx17__normal_iteratorIPN4llvm19SelectionDAGBuilder4CaseESt6vectorIS4_SaIS4_EEEElS4_NS3_7CaseCmpEEvT_T0_SC_T1_T2_", "void std::__adjust_heap<__gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::Case*, std::vector<llvm::SelectionDAGBuilder::Case, std::allocator<llvm::SelectionDAGBuilder::Case> > >, long, llvm::SelectionDAGBuilder::Case, llvm::SelectionDAGBuilder::CaseCmp>(__gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::Case*, std::vector<llvm::SelectionDAGBuilder::Case, std::allocator<llvm::SelectionDAGBuilder::Case> > >, long, long, llvm::SelectionDAGBuilder::Case, llvm::SelectionDAGBuilder::CaseCmp)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm19SelectionDAGBuilder4CaseESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::SelectionDAGBuilder::Case, std::allocator<llvm::SelectionDAGBuilder::Case> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::Case*, std::vector<llvm::SelectionDAGBuilder::Case, std::allocator<llvm::SelectionDAGBuilder::Case> > >, llvm::SelectionDAGBuilder::Case const&)"),
	mu_demangle_test("_ZN9__gnu_cxx13new_allocatorIN4llvm19SelectionDAGBuilder12BitTestBlockEE9constructEPS3_RKS3_", "__gnu_cxx::new_allocator<llvm::SelectionDAGBuilder::BitTestBlock>::construct(llvm::SelectionDAGBuilder::BitTestBlock*, llvm::SelectionDAGBuilder::BitTestBlock const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm19SelectionDAGBuilder12BitTestBlockESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::SelectionDAGBuilder::BitTestBlock, std::allocator<llvm::SelectionDAGBuilder::BitTestBlock> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::BitTestBlock*, std::vector<llvm::SelectionDAGBuilder::BitTestBlock, std::allocator<llvm::SelectionDAGBuilder::BitTestBlock> > >, llvm::SelectionDAGBuilder::BitTestBlock const&)"),
	mu_demangle_test("_ZSt16__introsort_loopIN9__gnu_cxx17__normal_iteratorIPN4llvm19SelectionDAGBuilder8CaseBitsESt6vectorIS4_SaIS4_EEEElNS3_11CaseBitsCmpEEvT_SB_T0_T1_", "void std::__introsort_loop<__gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::CaseBits*, std::vector<llvm::SelectionDAGBuilder::CaseBits, std::allocator<llvm::SelectionDAGBuilder::CaseBits> > >, long, llvm::SelectionDAGBuilder::CaseBitsCmp>(__gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::CaseBits*, std::vector<llvm::SelectionDAGBuilder::CaseBits, std::allocator<llvm::SelectionDAGBuilder::CaseBits> > >, __gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::CaseBits*, std::vector<llvm::SelectionDAGBuilder::CaseBits, std::allocator<llvm::SelectionDAGBuilder::CaseBits> > >, long, llvm::SelectionDAGBuilder::CaseBitsCmp)"),
	mu_demangle_test("_ZSt22__final_insertion_sortIN9__gnu_cxx17__normal_iteratorIPN4llvm19SelectionDAGBuilder8CaseBitsESt6vectorIS4_SaIS4_EEEENS3_11CaseBitsCmpEEvT_SB_T0_", "void std::__final_insertion_sort<__gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::CaseBits*, std::vector<llvm::SelectionDAGBuilder::CaseBits, std::allocator<llvm::SelectionDAGBuilder::CaseBits> > >, llvm::SelectionDAGBuilder::CaseBitsCmp>(__gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::CaseBits*, std::vector<llvm::SelectionDAGBuilder::CaseBits, std::allocator<llvm::SelectionDAGBuilder::CaseBits> > >, __gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::CaseBits*, std::vector<llvm::SelectionDAGBuilder::CaseBits, std::allocator<llvm::SelectionDAGBuilder::CaseBits> > >, llvm::SelectionDAGBuilder::CaseBitsCmp)"),
	mu_demangle_test("_ZSt16__insertion_sortIN9__gnu_cxx17__normal_iteratorIPN4llvm19SelectionDAGBuilder8CaseBitsESt6vectorIS4_SaIS4_EEEENS3_11CaseBitsCmpEEvT_SB_T0_", "void std::__insertion_sort<__gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::CaseBits*, std::vector<llvm::SelectionDAGBuilder::CaseBits, std::allocator<llvm::SelectionDAGBuilder::CaseBits> > >, llvm::SelectionDAGBuilder::CaseBitsCmp>(__gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::CaseBits*, std::vector<llvm::SelectionDAGBuilder::CaseBits, std::allocator<llvm::SelectionDAGBuilder::CaseBits> > >, __gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::CaseBits*, std::vector<llvm::SelectionDAGBuilder::CaseBits, std::allocator<llvm::SelectionDAGBuilder::CaseBits> > >, llvm::SelectionDAGBuilder::CaseBitsCmp)"),
	mu_demangle_test("_ZSt13__heap_selectIN9__gnu_cxx17__normal_iteratorIPN4llvm19SelectionDAGBuilder8CaseBitsESt6vectorIS4_SaIS4_EEEENS3_11CaseBitsCmpEEvT_SB_SB_T0_", "void std::__heap_select<__gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::CaseBits*, std::vector<llvm::SelectionDAGBuilder::CaseBits, std::allocator<llvm::SelectionDAGBuilder::CaseBits> > >, llvm::SelectionDAGBuilder::CaseBitsCmp>(__gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::CaseBits*, std::vector<llvm::SelectionDAGBuilder::CaseBits, std::allocator<llvm::SelectionDAGBuilder::CaseBits> > >, __gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::CaseBits*, std::vector<llvm::SelectionDAGBuilder::CaseBits, std::allocator<llvm::SelectionDAGBuilder::CaseBits> > >, __gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::CaseBits*, std::vector<llvm::SelectionDAGBuilder::CaseBits, std::allocator<llvm::SelectionDAGBuilder::CaseBits> > >, llvm::SelectionDAGBuilder::CaseBitsCmp)"),
	mu_demangle_test("_ZSt9sort_heapIN9__gnu_cxx17__normal_iteratorIPN4llvm19SelectionDAGBuilder8CaseBitsESt6vectorIS4_SaIS4_EEEENS3_11CaseBitsCmpEEvT_SB_T0_", "void std::sort_heap<__gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::CaseBits*, std::vector<llvm::SelectionDAGBuilder::CaseBits, std::allocator<llvm::SelectionDAGBuilder::CaseBits> > >, llvm::SelectionDAGBuilder::CaseBitsCmp>(__gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::CaseBits*, std::vector<llvm::SelectionDAGBuilder::CaseBits, std::allocator<llvm::SelectionDAGBuilder::CaseBits> > >, __gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::CaseBits*, std::vector<llvm::SelectionDAGBuilder::CaseBits, std::allocator<llvm::SelectionDAGBuilder::CaseBits> > >, llvm::SelectionDAGBuilder::CaseBitsCmp)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm19SelectionDAGBuilder8CaseBitsESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::SelectionDAGBuilder::CaseBits, std::allocator<llvm::SelectionDAGBuilder::CaseBits> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::CaseBits*, std::vector<llvm::SelectionDAGBuilder::CaseBits, std::allocator<llvm::SelectionDAGBuilder::CaseBits> > >, llvm::SelectionDAGBuilder::CaseBits const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm19SelectionDAGBuilder7CaseRecESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::SelectionDAGBuilder::CaseRec, std::allocator<llvm::SelectionDAGBuilder::CaseRec> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::CaseRec*, std::vector<llvm::SelectionDAGBuilder::CaseRec, std::allocator<llvm::SelectionDAGBuilder::CaseRec> > >, llvm::SelectionDAGBuilder::CaseRec const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN4llvm19SelectionDAGBuilder15JumpTableHeaderENS2_9JumpTableEESaIS5_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS5_S7_EERKS5_", "std::vector<std::pair<llvm::SelectionDAGBuilder::JumpTableHeader, llvm::SelectionDAGBuilder::JumpTable>, std::allocator<std::pair<llvm::SelectionDAGBuilder::JumpTableHeader, llvm::SelectionDAGBuilder::JumpTable> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::SelectionDAGBuilder::JumpTableHeader, llvm::SelectionDAGBuilder::JumpTable>*, std::vector<std::pair<llvm::SelectionDAGBuilder::JumpTableHeader, llvm::SelectionDAGBuilder::JumpTable>, std::allocator<std::pair<llvm::SelectionDAGBuilder::JumpTableHeader, llvm::SelectionDAGBuilder::JumpTable> > > >, std::pair<llvm::SelectionDAGBuilder::JumpTableHeader, llvm::SelectionDAGBuilder::JumpTable> const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm19SelectionDAGBuilder9CaseBlockESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::SelectionDAGBuilder::CaseBlock, std::allocator<llvm::SelectionDAGBuilder::CaseBlock> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::SelectionDAGBuilder::CaseBlock*, std::vector<llvm::SelectionDAGBuilder::CaseBlock, std::allocator<llvm::SelectionDAGBuilder::CaseBlock> > >, llvm::SelectionDAGBuilder::CaseBlock const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_5ValueENS_19SelectionDAGBuilder17DanglingDebugInfoENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PSt4pairIS3_S5_E", "llvm::DenseMap<llvm::Value const*, llvm::SelectionDAGBuilder::DanglingDebugInfo, llvm::DenseMapInfo<llvm::Value const*>, llvm::DenseMapInfo<llvm::SelectionDAGBuilder::DanglingDebugInfo> >::InsertIntoBucket(llvm::Value const* const&, llvm::SelectionDAGBuilder::DanglingDebugInfo const&, std::pair<llvm::Value const*, llvm::SelectionDAGBuilder::DanglingDebugInfo>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_5ValueENS_19SelectionDAGBuilder17DanglingDebugInfoENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<llvm::Value const*, llvm::SelectionDAGBuilder::DanglingDebugInfo, llvm::DenseMapInfo<llvm::Value const*>, llvm::DenseMapInfo<llvm::SelectionDAGBuilder::DanglingDebugInfo> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_5ValueENS_19SelectionDAGBuilder17DanglingDebugInfoENS_12DenseMapInfoIS3_EENS6_IS5_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::Value const*, llvm::SelectionDAGBuilder::DanglingDebugInfo, llvm::DenseMapInfo<llvm::Value const*>, llvm::DenseMapInfo<llvm::SelectionDAGBuilder::DanglingDebugInfo> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_5ValueENS_7SDValueENS_12DenseMapInfoIS3_EENS5_IS4_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::Value const*, llvm::SDValue, llvm::DenseMapInfo<llvm::Value const*>, llvm::DenseMapInfo<llvm::SDValue> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_5ValueENS_7SDValueENS_12DenseMapInfoIS3_EENS5_IS4_EEE16InsertIntoBucketERKS3_RKS4_PSt4pairIS3_S4_E", "llvm::DenseMap<llvm::Value const*, llvm::SDValue, llvm::DenseMapInfo<llvm::Value const*>, llvm::DenseMapInfo<llvm::SDValue> >::InsertIntoBucket(llvm::Value const* const&, llvm::SDValue const&, std::pair<llvm::Value const*, llvm::SDValue>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_5ValueENS_7SDValueENS_12DenseMapInfoIS3_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::Value const*, llvm::SDValue, llvm::DenseMapInfo<llvm::Value const*>, llvm::DenseMapInfo<llvm::SDValue> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_8MCSymbolEjNS_12DenseMapInfoIS2_EENS3_IjEEE16InsertIntoBucketERKS2_RKjPSt4pairIS2_jE", "llvm::DenseMap<llvm::MCSymbol*, unsigned int, llvm::DenseMapInfo<llvm::MCSymbol*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(llvm::MCSymbol* const&, unsigned int const&, std::pair<llvm::MCSymbol*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_8MCSymbolEjNS_12DenseMapInfoIS2_EENS3_IjEEE4growEj", "llvm::DenseMap<llvm::MCSymbol*, unsigned int, llvm::DenseMapInfo<llvm::MCSymbol*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm6GCRootESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<llvm::GCRoot, std::allocator<llvm::GCRoot> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::GCRoot*, std::vector<llvm::GCRoot, std::allocator<llvm::GCRoot> > >, llvm::GCRoot const&)"),
	mu_demangle_test("_ZN4llvm23SmallVectorTemplateBaseISt4pairINS_10TrackingVHINS_6MDNodeEEES1_IjNS_8DebugLocEEELb0EE4growEm", "llvm::SmallVectorTemplateBase<std::pair<llvm::TrackingVH<llvm::MDNode>, std::pair<unsigned int, llvm::DebugLoc> >, false>::grow(unsigned long)"),
	mu_demangle_test("_ZN4llvm16SelectionDAGISel29SelectInlineAsmMemoryOperandsERSt6vectorINS_7SDValueESaIS2_EE", "llvm::SelectionDAGISel::SelectInlineAsmMemoryOperands(std::vector<llvm::SDValue, std::allocator<llvm::SDValue> >&)"),
	mu_demangle_test("_ZN4llvm2cl3optIPFPNS_18ScheduleDAGSDNodesEPNS_16SelectionDAGISelENS_10CodeGenOpt5LevelEELb0ENS_18RegisterPassParserINS_17RegisterSchedulerEEEED1Ev", "llvm::cl::opt<llvm::ScheduleDAGSDNodes* (*)(llvm::SelectionDAGISel*, llvm::CodeGenOpt::Level), false, llvm::RegisterPassParser<llvm::RegisterScheduler> >::~opt()"),
	mu_demangle_test("_ZN4llvm16SelectionDAGISel28SelectInlineAsmMemoryOperandERKNS_7SDValueEcRSt6vectorIS1_SaIS1_EE", "llvm::SelectionDAGISel::SelectInlineAsmMemoryOperand(llvm::SDValue const&, char, std::vector<llvm::SDValue, std::allocator<llvm::SDValue> >&)"),
	mu_demangle_test("_ZN4llvm16SelectionDAGISel19CheckComplexPatternEPNS_6SDNodeES2_NS_7SDValueEjRNS_15SmallVectorImplISt4pairIS3_S2_EEE", "llvm::SelectionDAGISel::CheckComplexPattern(llvm::SDNode*, llvm::SDNode*, llvm::SDValue, unsigned int, llvm::SmallVectorImpl<std::pair<llvm::SDValue, llvm::SDNode*> >&)"),
	mu_demangle_test("_ZNSt6vectorIjSaIjEE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPjS1_EEmRKj", "std::vector<unsigned int, std::allocator<unsigned int> >::_M_fill_insert(__gnu_cxx::__normal_iterator<unsigned int*, std::vector<unsigned int, std::allocator<unsigned int> > >, unsigned long, unsigned int const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm7SDValueESaIS1_EE15_M_range_insertIN9__gnu_cxx17__normal_iteratorIPS1_S3_EEEEvS8_T_S9_St20forward_iterator_tag", "void std::vector<llvm::SDValue, std::allocator<llvm::SDValue> >::_M_range_insert<__gnu_cxx::__normal_iterator<llvm::SDValue*, std::vector<llvm::SDValue, std::allocator<llvm::SDValue> > > >(__gnu_cxx::__normal_iterator<llvm::SDValue*, std::vector<llvm::SDValue, std::allocator<llvm::SDValue> > >, __gnu_cxx::__normal_iterator<llvm::SDValue*, std::vector<llvm::SDValue, std::allocator<llvm::SDValue> > >, __gnu_cxx::__normal_iterator<llvm::SDValue*, std::vector<llvm::SDValue, std::allocator<llvm::SDValue> > >, std::forward_iterator_tag)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm19SelectionDAGBuilder12BitTestBlockESaIS2_EE15_M_erase_at_endEPS2_", "std::vector<llvm::SelectionDAGBuilder::BitTestBlock, std::allocator<llvm::SelectionDAGBuilder::BitTestBlock> >::_M_erase_at_end(llvm::SelectionDAGBuilder::BitTestBlock*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_10BasicBlockEPNS_17MachineBasicBlockENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PSt4pairIS3_S5_E", "llvm::DenseMap<llvm::BasicBlock const*, llvm::MachineBasicBlock*, llvm::DenseMapInfo<llvm::BasicBlock const*>, llvm::DenseMapInfo<llvm::MachineBasicBlock*> >::InsertIntoBucket(llvm::BasicBlock const* const&, llvm::MachineBasicBlock* const&, std::pair<llvm::BasicBlock const*, llvm::MachineBasicBlock*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_10BasicBlockEPNS_17MachineBasicBlockENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<llvm::BasicBlock const*, llvm::MachineBasicBlock*, llvm::DenseMapInfo<llvm::BasicBlock const*>, llvm::DenseMapInfo<llvm::MachineBasicBlock*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm20FunctionLoweringInfo11LiveOutInfoESaIS2_EE6resizeEmS2_", "std::vector<llvm::FunctionLoweringInfo::LiveOutInfo, std::allocator<llvm::FunctionLoweringInfo::LiveOutInfo> >::resize(unsigned long, llvm::FunctionLoweringInfo::LiveOutInfo)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm20FunctionLoweringInfo11LiveOutInfoESaIS2_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS2_S4_EEmRKS2_", "std::vector<llvm::FunctionLoweringInfo::LiveOutInfo, std::allocator<llvm::FunctionLoweringInfo::LiveOutInfo> >::_M_fill_insert(__gnu_cxx::__normal_iterator<llvm::FunctionLoweringInfo::LiveOutInfo*, std::vector<llvm::FunctionLoweringInfo::LiveOutInfo, std::allocator<llvm::FunctionLoweringInfo::LiveOutInfo> > >, unsigned long, llvm::FunctionLoweringInfo::LiveOutInfo const&)"),
	mu_demangle_test("_ZN4llvm2cl3optIPFPNS_18ScheduleDAGSDNodesEPNS_16SelectionDAGISelENS_10CodeGenOpt5LevelEELb0ENS_18RegisterPassParserINS_17RegisterSchedulerEEEE4doneEv", "llvm::cl::opt<llvm::ScheduleDAGSDNodes* (*)(llvm::SelectionDAGISel*, llvm::CodeGenOpt::Level), false, llvm::RegisterPassParser<llvm::RegisterScheduler> >::done()"),
	mu_demangle_test("_ZN4llvm2cl3optIPFPNS_18ScheduleDAGSDNodesEPNS_16SelectionDAGISelENS_10CodeGenOpt5LevelEELb0ENS_18RegisterPassParserINS_17RegisterSchedulerEEEE16handleOccurrenceEjNS_9StringRefESE_", "llvm::cl::opt<llvm::ScheduleDAGSDNodes* (*)(llvm::SelectionDAGISel*, llvm::CodeGenOpt::Level), false, llvm::RegisterPassParser<llvm::RegisterScheduler> >::handleOccurrence(unsigned int, llvm::StringRef, llvm::StringRef)"),
	mu_demangle_test("_ZNK4llvm2cl3optIPFPNS_18ScheduleDAGSDNodesEPNS_16SelectionDAGISelENS_10CodeGenOpt5LevelEELb0ENS_18RegisterPassParserINS_17RegisterSchedulerEEEE27getValueExpectedFlagDefaultEv", "llvm::cl::opt<llvm::ScheduleDAGSDNodes* (*)(llvm::SelectionDAGISel*, llvm::CodeGenOpt::Level), false, llvm::RegisterPassParser<llvm::RegisterScheduler> >::getValueExpectedFlagDefault() const"),
	mu_demangle_test("_ZNK4llvm2cl3optIPFPNS_18ScheduleDAGSDNodesEPNS_16SelectionDAGISelENS_10CodeGenOpt5LevelEELb0ENS_18RegisterPassParserINS_17RegisterSchedulerEEEE14getOptionWidthEv", "llvm::cl::opt<llvm::ScheduleDAGSDNodes* (*)(llvm::SelectionDAGISel*, llvm::CodeGenOpt::Level), false, llvm::RegisterPassParser<llvm::RegisterScheduler> >::getOptionWidth() const"),
	mu_demangle_test("_ZNK4llvm2cl3optIPFPNS_18ScheduleDAGSDNodesEPNS_16SelectionDAGISelENS_10CodeGenOpt5LevelEELb0ENS_18RegisterPassParserINS_17RegisterSchedulerEEEE15printOptionInfoEm", "llvm::cl::opt<llvm::ScheduleDAGSDNodes* (*)(llvm::SelectionDAGISel*, llvm::CodeGenOpt::Level), false, llvm::RegisterPassParser<llvm::RegisterScheduler> >::printOptionInfo(unsigned long) const"),
	mu_demangle_test("_ZN4llvm2cl3optIPFPNS_18ScheduleDAGSDNodesEPNS_16SelectionDAGISelENS_10CodeGenOpt5LevelEELb0ENS_18RegisterPassParserINS_17RegisterSchedulerEEEE19getExtraOptionNamesERNS_15SmallVectorImplIPKcEE", "llvm::cl::opt<llvm::ScheduleDAGSDNodes* (*)(llvm::SelectionDAGISel*, llvm::CodeGenOpt::Level), false, llvm::RegisterPassParser<llvm::RegisterScheduler> >::getExtraOptionNames(llvm::SmallVectorImpl<char const*>&)"),
	mu_demangle_test("_ZN4llvm2cl3optIPFPNS_18ScheduleDAGSDNodesEPNS_16SelectionDAGISelENS_10CodeGenOpt5LevelEELb0ENS_18RegisterPassParserINS_17RegisterSchedulerEEEED0Ev", "llvm::cl::opt<llvm::ScheduleDAGSDNodes* (*)(llvm::SelectionDAGISel*, llvm::CodeGenOpt::Level), false, llvm::RegisterPassParser<llvm::RegisterScheduler> >::~opt()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_5ValueEjNS_12DenseMapInfoIS3_EENS4_IjEEE16InsertIntoBucketERKS3_RKjPSt4pairIS3_jE", "llvm::DenseMap<llvm::Value const*, unsigned int, llvm::DenseMapInfo<llvm::Value const*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(llvm::Value const* const&, unsigned int const&, std::pair<llvm::Value const*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_5ValueEjNS_12DenseMapInfoIS3_EENS4_IjEEE4growEj", "llvm::DenseMap<llvm::Value const*, unsigned int, llvm::DenseMapInfo<llvm::Value const*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm20FunctionLoweringInfo11LiveOutInfoESaIS2_EED2Ev", "std::vector<llvm::FunctionLoweringInfo::LiveOutInfo, std::allocator<llvm::FunctionLoweringInfo::LiveOutInfo> >::~vector()"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN4llvm19SelectionDAGBuilder15JumpTableHeaderENS2_9JumpTableEESaIS5_EED2Ev", "std::vector<std::pair<llvm::SelectionDAGBuilder::JumpTableHeader, llvm::SelectionDAGBuilder::JumpTable>, std::allocator<std::pair<llvm::SelectionDAGBuilder::JumpTableHeader, llvm::SelectionDAGBuilder::JumpTable> > >::~vector()"),
	mu_demangle_test("_ZNSt6vectorIN4llvm19SelectionDAGBuilder12BitTestBlockESaIS2_EED2Ev", "std::vector<llvm::SelectionDAGBuilder::BitTestBlock, std::allocator<llvm::SelectionDAGBuilder::BitTestBlock> >::~vector()"),
	mu_demangle_test("_ZN4llvm12SelectionDAG22setSubgraphColorHelperEPNS_6SDNodeEPKcRNS_8DenseSetIS2_NS_12DenseMapInfoIS2_EEEEiRb", "llvm::SelectionDAG::setSubgraphColorHelper(llvm::SDNode*, char const*, llvm::DenseSet<llvm::SDNode*, llvm::DenseMapInfo<llvm::SDNode*> >&, int, bool&)"),
	mu_demangle_test("_ZN4llvm11GraphWriterIPNS_11ScheduleDAGEE14emitSimpleNodeEPKvRKSsS7_jPKSt6vectorISsSaISsEE", "llvm::GraphWriter<llvm::ScheduleDAG*>::emitSimpleNode(void const*, std::string const&, std::string const&, unsigned int, std::vector<std::string, std::allocator<std::string> > const*)"),
	mu_demangle_test("_ZNK4llvm14TargetLowering28LowerAsmOperandForConstraintENS_7SDValueEcRSt6vectorIS1_SaIS1_EERNS_12SelectionDAGE", "llvm::TargetLowering::LowerAsmOperandForConstraint(llvm::SDValue, char, std::vector<llvm::SDValue, std::allocator<llvm::SDValue> >&, llvm::SelectionDAG&) const"),
	mu_demangle_test("_ZNK4llvm14TargetLowering9BuildSDIVEPNS_6SDNodeERNS_12SelectionDAGEPSt6vectorIS2_SaIS2_EE", "llvm::TargetLowering::BuildSDIV(llvm::SDNode*, llvm::SelectionDAG&, std::vector<llvm::SDNode*, std::allocator<llvm::SDNode*> >*) const"),
	mu_demangle_test("_ZNK4llvm14TargetLowering9BuildUDIVEPNS_6SDNodeERNS_12SelectionDAGEPSt6vectorIS2_SaIS2_EE", "llvm::TargetLowering::BuildUDIV(llvm::SDNode*, llvm::SelectionDAG&, std::vector<llvm::SDNode*, std::allocator<llvm::SDNode*> >*) const"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm6SDNodeESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::SDNode*, std::allocator<llvm::SDNode*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::SDNode**, std::vector<llvm::SDNode*, std::allocator<llvm::SDNode*> > >, llvm::SDNode* const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm14TargetLowering14AsmOperandInfoESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::TargetLowering::AsmOperandInfo, std::allocator<llvm::TargetLowering::AsmOperandInfo> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::TargetLowering::AsmOperandInfo*, std::vector<llvm::TargetLowering::AsmOperandInfo, std::allocator<llvm::TargetLowering::AsmOperandInfo> > >, llvm::TargetLowering::AsmOperandInfo const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm9InlineAsm17SubConstraintInfoESaIS2_EEaSERKS4_", "std::vector<llvm::InlineAsm::SubConstraintInfo, std::allocator<llvm::InlineAsm::SubConstraintInfo> >::operator=(std::vector<llvm::InlineAsm::SubConstraintInfo, std::allocator<llvm::InlineAsm::SubConstraintInfo> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIjN4llvm3MVT15SimpleValueTypeEES0_IKS4_S3_ESt10_Select1stIS6_ESt4lessIS4_ESaIS6_EE8_M_eraseEPSt13_Rb_tree_nodeIS6_E", "std::_Rb_tree<std::pair<unsigned int, llvm::MVT::SimpleValueType>, std::pair<std::pair<unsigned int, llvm::MVT::SimpleValueType> const, llvm::MVT::SimpleValueType>, std::_Select1st<std::pair<std::pair<unsigned int, llvm::MVT::SimpleValueType> const, llvm::MVT::SimpleValueType> >, std::less<std::pair<unsigned int, llvm::MVT::SimpleValueType> >, std::allocator<std::pair<std::pair<unsigned int, llvm::MVT::SimpleValueType> const, llvm::MVT::SimpleValueType> > >::_M_erase(std::_Rb_tree_node<std::pair<std::pair<unsigned int, llvm::MVT::SimpleValueType> const, llvm::MVT::SimpleValueType> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10GCStrategyEPNS_17GCMetadataPrinterENS_12DenseMapInfoIS2_EENS5_IS4_EEE6insertERKSt4pairIS2_S4_E", "llvm::DenseMap<llvm::GCStrategy*, llvm::GCMetadataPrinter*, llvm::DenseMapInfo<llvm::GCStrategy*>, llvm::DenseMapInfo<llvm::GCMetadataPrinter*> >::insert(std::pair<llvm::GCStrategy*, llvm::GCMetadataPrinter*> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10GCStrategyEPNS_17GCMetadataPrinterENS_12DenseMapInfoIS2_EENS5_IS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<llvm::GCStrategy*, llvm::GCMetadataPrinter*, llvm::DenseMapInfo<llvm::GCStrategy*>, llvm::DenseMapInfo<llvm::GCMetadataPrinter*> >::InsertIntoBucket(llvm::GCStrategy* const&, llvm::GCMetadataPrinter* const&, std::pair<llvm::GCStrategy*, llvm::GCMetadataPrinter*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10GCStrategyEPNS_17GCMetadataPrinterENS_12DenseMapInfoIS2_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::GCStrategy*, llvm::GCMetadataPrinter*, llvm::DenseMapInfo<llvm::GCStrategy*>, llvm::DenseMapInfo<llvm::GCMetadataPrinter*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNK4llvm10AsmPrinter14EmitFrameMovesERKSt6vectorINS_11MachineMoveESaIS2_EEPNS_8MCSymbolEb", "llvm::AsmPrinter::EmitFrameMoves(std::vector<llvm::MachineMove, std::allocator<llvm::MachineMove> > const&, llvm::MCSymbol*, bool) const"),
	mu_demangle_test("_ZNK4llvm10AsmPrinter17EmitCFIFrameMovesERKSt6vectorINS_11MachineMoveESaIS2_EE", "llvm::AsmPrinter::EmitCFIFrameMoves(std::vector<llvm::MachineMove, std::allocator<llvm::MachineMove> > const&) const"),
	mu_demangle_test("_ZN4llvm25array_pod_sort_comparatorISt4pairIjPNS_14StringMapEntryIS1_IPNS_8MCSymbolEjEEEEEEiPKvSA_", "int llvm::array_pod_sort_comparator<std::pair<unsigned int, llvm::StringMapEntry<std::pair<llvm::MCSymbol*, unsigned int> >*> >(void const*, void const*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_3DIEEPKNS_6MDNodeENS_12DenseMapInfoIS2_EENS6_IS5_EEE6insertERKSt4pairIS2_S5_E", "llvm::DenseMap<llvm::DIE*, llvm::MDNode const*, llvm::DenseMapInfo<llvm::DIE*>, llvm::DenseMapInfo<llvm::MDNode const*> >::insert(std::pair<llvm::DIE*, llvm::MDNode const*> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_6MDNodeEPNS_3DIEENS_12DenseMapInfoIS3_EENS6_IS5_EEE6insertERKSt4pairIS3_S5_E", "llvm::DenseMap<llvm::MDNode const*, llvm::DIE*, llvm::DenseMapInfo<llvm::MDNode const*>, llvm::DenseMapInfo<llvm::DIE*> >::insert(std::pair<llvm::MDNode const*, llvm::DIE*> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_6MDNodeEPNS_11CompileUnitENS_12DenseMapInfoIS3_EENS6_IS5_EEE6insertERKSt4pairIS3_S5_E", "llvm::DenseMap<llvm::MDNode const*, llvm::CompileUnit*, llvm::DenseMapInfo<llvm::MDNode const*>, llvm::DenseMapInfo<llvm::CompileUnit*> >::insert(std::pair<llvm::MDNode const*, llvm::CompileUnit*> const&)"),
	mu_demangle_test("_ZN4llvm22DeleteContainerSecondsINS_8DenseMapIPKNS_6MDNodeEPNS_8DbgScopeENS_12DenseMapInfoIS4_EENS7_IS6_EEEEEEvRT_", "void llvm::DeleteContainerSeconds<llvm::DenseMap<llvm::MDNode const*, llvm::DbgScope*, llvm::DenseMapInfo<llvm::MDNode const*>, llvm::DenseMapInfo<llvm::DbgScope*> > >(llvm::DenseMap<llvm::MDNode const*, llvm::DbgScope*, llvm::DenseMapInfo<llvm::MDNode const*>, llvm::DenseMapInfo<llvm::DbgScope*> >&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_6MDNodeEPNS_8DbgScopeENS_12DenseMapInfoIS3_EENS6_IS5_EEE6insertERKSt4pairIS3_S5_E", "llvm::DenseMap<llvm::MDNode const*, llvm::DbgScope*, llvm::DenseMapInfo<llvm::MDNode const*>, llvm::DenseMapInfo<llvm::DbgScope*> >::insert(std::pair<llvm::MDNode const*, llvm::DbgScope*> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_11DbgVariableEiNS_12DenseMapInfoIS3_EENS4_IiEEE16InsertIntoBucketERKS3_RKiPSt4pairIS3_iE", "llvm::DenseMap<llvm::DbgVariable const*, int, llvm::DenseMapInfo<llvm::DbgVariable const*>, llvm::DenseMapInfo<int> >::InsertIntoBucket(llvm::DbgVariable const* const&, int const&, std::pair<llvm::DbgVariable const*, int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_11DbgVariableEiNS_12DenseMapInfoIS3_EENS4_IiEEE4growEj", "llvm::DenseMap<llvm::DbgVariable const*, int, llvm::DenseMapInfo<llvm::DbgVariable const*>, llvm::DenseMapInfo<int> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_12MachineInstrEPNS_8MCSymbolENS_12DenseMapInfoIS3_EENS6_IS5_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::MachineInstr const*, llvm::MCSymbol*, llvm::DenseMapInfo<llvm::MachineInstr const*>, llvm::DenseMapInfo<llvm::MCSymbol*> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_6MDNodeEPNS_11DbgVariableENS_12DenseMapInfoIS3_EENS6_IS5_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::MDNode const*, llvm::DbgVariable*, llvm::DenseMapInfo<llvm::MDNode const*>, llvm::DenseMapInfo<llvm::DbgVariable*> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_6MDNodeEPNS_8DbgScopeENS_12DenseMapInfoIS3_EENS6_IS5_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::MDNode const*, llvm::DbgScope*, llvm::DenseMapInfo<llvm::MDNode const*>, llvm::DenseMapInfo<llvm::DbgScope*> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_11DbgVariableEPKNS_12MachineInstrENS_12DenseMapInfoIS3_EENS7_IS6_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::DbgVariable const*, llvm::MachineInstr const*, llvm::DenseMapInfo<llvm::DbgVariable const*>, llvm::DenseMapInfo<llvm::MachineInstr const*> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_11DbgVariableES3_NS_12DenseMapInfoIS3_EES5_E16shrink_and_clearEv", "llvm::DenseMap<llvm::DbgVariable const*, llvm::DbgVariable const*, llvm::DenseMapInfo<llvm::DbgVariable const*>, llvm::DenseMapInfo<llvm::DbgVariable const*> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_11DbgVariableEiNS_12DenseMapInfoIS3_EENS4_IiEEE16shrink_and_clearEv", "llvm::DenseMap<llvm::DbgVariable const*, int, llvm::DenseMapInfo<llvm::DbgVariable const*>, llvm::DenseMapInfo<int> >::shrink_and_clear()"),
	mu_demangle_test("_ZNSt6vectorIN4llvm10DwarfDebug22FunctionDebugFrameInfoESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::DwarfDebug::FunctionDebugFrameInfo, std::allocator<llvm::DwarfDebug::FunctionDebugFrameInfo> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::DwarfDebug::FunctionDebugFrameInfo*, std::vector<llvm::DwarfDebug::FunctionDebugFrameInfo, std::allocator<llvm::DwarfDebug::FunctionDebugFrameInfo> > >, llvm::DwarfDebug::FunctionDebugFrameInfo const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm11MachineMoveESaIS1_EEaSERKS3_", "std::vector<llvm::MachineMove, std::allocator<llvm::MachineMove> >::operator=(std::vector<llvm::MachineMove, std::allocator<llvm::MachineMove> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_12MachineInstrEPNS_8DbgScopeENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PSt4pairIS3_S5_E", "llvm::DenseMap<llvm::MachineInstr const*, llvm::DbgScope*, llvm::DenseMapInfo<llvm::MachineInstr const*>, llvm::DenseMapInfo<llvm::DbgScope*> >::InsertIntoBucket(llvm::MachineInstr const* const&, llvm::DbgScope* const&, std::pair<llvm::MachineInstr const*, llvm::DbgScope*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_12MachineInstrEPNS_8DbgScopeENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<llvm::MachineInstr const*, llvm::DbgScope*, llvm::DenseMapInfo<llvm::MachineInstr const*>, llvm::DenseMapInfo<llvm::DbgScope*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_6MDNodeEPNS_8DbgScopeENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PSt4pairIS3_S5_E", "llvm::DenseMap<llvm::MDNode const*, llvm::DbgScope*, llvm::DenseMapInfo<llvm::MDNode const*>, llvm::DenseMapInfo<llvm::DbgScope*> >::InsertIntoBucket(llvm::MDNode const* const&, llvm::DbgScope* const&, std::pair<llvm::MDNode const*, llvm::DbgScope*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_6MDNodeEPNS_8DbgScopeENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<llvm::MDNode const*, llvm::DbgScope*, llvm::DenseMapInfo<llvm::MDNode const*>, llvm::DenseMapInfo<llvm::DbgScope*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_12MachineInstrEPNS_8MCSymbolENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PSt4pairIS3_S5_E", "llvm::DenseMap<llvm::MachineInstr const*, llvm::MCSymbol*, llvm::DenseMapInfo<llvm::MachineInstr const*>, llvm::DenseMapInfo<llvm::MCSymbol*> >::InsertIntoBucket(llvm::MachineInstr const* const&, llvm::MCSymbol* const&, std::pair<llvm::MachineInstr const*, llvm::MCSymbol*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_12MachineInstrEPNS_8MCSymbolENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<llvm::MachineInstr const*, llvm::MCSymbol*, llvm::DenseMapInfo<llvm::MachineInstr const*>, llvm::DenseMapInfo<llvm::MCSymbol*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_11DbgVariableEPKNS_12MachineInstrENS_12DenseMapInfoIS3_EENS7_IS6_EEE16InsertIntoBucketERKS3_RKS6_PSt4pairIS3_S6_E", "llvm::DenseMap<llvm::DbgVariable const*, llvm::MachineInstr const*, llvm::DenseMapInfo<llvm::DbgVariable const*>, llvm::DenseMapInfo<llvm::MachineInstr const*> >::InsertIntoBucket(llvm::DbgVariable const* const&, llvm::MachineInstr const* const&, std::pair<llvm::DbgVariable const*, llvm::MachineInstr const*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_11DbgVariableEPKNS_12MachineInstrENS_12DenseMapInfoIS3_EENS7_IS6_EEE4growEj", "llvm::DenseMap<llvm::DbgVariable const*, llvm::MachineInstr const*, llvm::DenseMapInfo<llvm::DbgVariable const*>, llvm::DenseMapInfo<llvm::MachineInstr const*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_11DbgVariableES3_NS_12DenseMapInfoIS3_EES5_E16InsertIntoBucketERKS3_S8_PSt4pairIS3_S3_E", "llvm::DenseMap<llvm::DbgVariable const*, llvm::DbgVariable const*, llvm::DenseMapInfo<llvm::DbgVariable const*>, llvm::DenseMapInfo<llvm::DbgVariable const*> >::InsertIntoBucket(llvm::DbgVariable const* const&, llvm::DbgVariable const* const&, std::pair<llvm::DbgVariable const*, llvm::DbgVariable const*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_11DbgVariableES3_NS_12DenseMapInfoIS3_EES5_E4growEj", "llvm::DenseMap<llvm::DbgVariable const*, llvm::DbgVariable const*, llvm::DenseMapInfo<llvm::DbgVariable const*>, llvm::DenseMapInfo<llvm::DbgVariable const*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_6MDNodeEPNS_11DbgVariableENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PSt4pairIS3_S5_E", "llvm::DenseMap<llvm::MDNode const*, llvm::DbgVariable*, llvm::DenseMapInfo<llvm::MDNode const*>, llvm::DenseMapInfo<llvm::DbgVariable*> >::InsertIntoBucket(llvm::MDNode const* const&, llvm::DbgVariable* const&, std::pair<llvm::MDNode const*, llvm::DbgVariable*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_6MDNodeEPNS_11DbgVariableENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<llvm::MDNode const*, llvm::DbgVariable*, llvm::DenseMapInfo<llvm::MDNode const*>, llvm::DenseMapInfo<llvm::DbgVariable*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm9MCSectionESt4pairIKS3_jESt10_Select1stIS6_ESt4lessIS3_ESaIS6_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS6_ERKS6_", "std::_Rb_tree<llvm::MCSection const*, std::pair<llvm::MCSection const* const, unsigned int>, std::_Select1st<std::pair<llvm::MCSection const* const, unsigned int> >, std::less<llvm::MCSection const*>, std::allocator<std::pair<llvm::MCSection const* const, unsigned int> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::MCSection const* const, unsigned int> >, std::pair<llvm::MCSection const* const, unsigned int> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm9MCSectionESt4pairIKS3_jESt10_Select1stIS6_ESt4lessIS3_ESaIS6_EE16_M_insert_uniqueERKS6_", "std::_Rb_tree<llvm::MCSection const*, std::pair<llvm::MCSection const* const, unsigned int>, std::_Select1st<std::pair<llvm::MCSection const* const, unsigned int> >, std::less<llvm::MCSection const*>, std::allocator<std::pair<llvm::MCSection const* const, unsigned int> > >::_M_insert_unique(std::pair<llvm::MCSection const* const, unsigned int> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_6MDNodeEPNS_11CompileUnitENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PSt4pairIS3_S5_E", "llvm::DenseMap<llvm::MDNode const*, llvm::CompileUnit*, llvm::DenseMapInfo<llvm::MDNode const*>, llvm::DenseMapInfo<llvm::CompileUnit*> >::InsertIntoBucket(llvm::MDNode const* const&, llvm::CompileUnit* const&, std::pair<llvm::MDNode const*, llvm::CompileUnit*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_6MDNodeEPNS_11CompileUnitENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<llvm::MDNode const*, llvm::CompileUnit*, llvm::DenseMapInfo<llvm::MDNode const*>, llvm::DenseMapInfo<llvm::CompileUnit*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_6MDNodeENS_11SmallVectorISt4pairIPKNS_8MCSymbolEPNS_3DIEEELj4EEENS_12DenseMapInfoIS3_EENSD_ISC_EEE16FindAndConstructERKS3_", "llvm::DenseMap<llvm::MDNode const*, llvm::SmallVector<std::pair<llvm::MCSymbol const*, llvm::DIE*>, 4u>, llvm::DenseMapInfo<llvm::MDNode const*>, llvm::DenseMapInfo<llvm::SmallVector<std::pair<llvm::MCSymbol const*, llvm::DIE*>, 4u> > >::FindAndConstruct(llvm::MDNode const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_6MDNodeENS_11SmallVectorISt4pairIPKNS_8MCSymbolEPNS_3DIEEELj4EEENS_12DenseMapInfoIS3_EENSD_ISC_EEE16InsertIntoBucketERKS3_RKSC_PS5_IS3_SC_E", "llvm::DenseMap<llvm::MDNode const*, llvm::SmallVector<std::pair<llvm::MCSymbol const*, llvm::DIE*>, 4u>, llvm::DenseMapInfo<llvm::MDNode const*>, llvm::DenseMapInfo<llvm::SmallVector<std::pair<llvm::MCSymbol const*, llvm::DIE*>, 4u> > >::InsertIntoBucket(llvm::MDNode const* const&, llvm::SmallVector<std::pair<llvm::MCSymbol const*, llvm::DIE*>, 4u> const&, std::pair<llvm::MDNode const*, llvm::SmallVector<std::pair<llvm::MCSymbol const*, llvm::DIE*>, 4u> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_6MDNodeENS_11SmallVectorISt4pairIPKNS_8MCSymbolEPNS_3DIEEELj4EEENS_12DenseMapInfoIS3_EENSD_ISC_EEE4growEj", "llvm::DenseMap<llvm::MDNode const*, llvm::SmallVector<std::pair<llvm::MCSymbol const*, llvm::DIE*>, 4u>, llvm::DenseMapInfo<llvm::MDNode const*>, llvm::DenseMapInfo<llvm::SmallVector<std::pair<llvm::MCSymbol const*, llvm::DIE*>, 4u> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm15SmallVectorImplISt4pairIPKNS_8MCSymbolEPNS_3DIEEEEaSERKS8_", "llvm::SmallVectorImpl<std::pair<llvm::MCSymbol const*, llvm::DIE*> >::operator=(llvm::SmallVectorImpl<std::pair<llvm::MCSymbol const*, llvm::DIE*> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_3DIEEPKNS_6MDNodeENS_12DenseMapInfoIS2_EENS6_IS5_EEE16InsertIntoBucketERKS2_RKS5_PSt4pairIS2_S5_E", "llvm::DenseMap<llvm::DIE*, llvm::MDNode const*, llvm::DenseMapInfo<llvm::DIE*>, llvm::DenseMapInfo<llvm::MDNode const*> >::InsertIntoBucket(llvm::DIE* const&, llvm::MDNode const* const&, std::pair<llvm::DIE*, llvm::MDNode const*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_3DIEEPKNS_6MDNodeENS_12DenseMapInfoIS2_EENS6_IS5_EEE4growEj", "llvm::DenseMap<llvm::DIE*, llvm::MDNode const*, llvm::DenseMapInfo<llvm::DIE*>, llvm::DenseMapInfo<llvm::MDNode const*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm8DIEBlockESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::DIEBlock*, std::allocator<llvm::DIEBlock*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::DIEBlock**, std::vector<llvm::DIEBlock*, std::allocator<llvm::DIEBlock*> > >, llvm::DIEBlock* const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm9DIEAbbrevESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::DIEAbbrev*, std::allocator<llvm::DIEAbbrev*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::DIEAbbrev**, std::vector<llvm::DIEAbbrev*, std::allocator<llvm::DIEAbbrev*> > >, llvm::DIEAbbrev* const&)"),
	mu_demangle_test("_ZN4llvm9StringMapISt4pairIPNS_8MCSymbolEjENS_15MallocAllocatorEE16GetOrCreateValueIS4_EERNS_14StringMapEntryIS4_EENS_9StringRefET_", "llvm::StringMapEntry<std::pair<llvm::MCSymbol*, unsigned int> >& llvm::StringMap<std::pair<llvm::MCSymbol*, unsigned int>, llvm::MallocAllocator>::GetOrCreateValue<std::pair<llvm::MCSymbol*, unsigned int> >(llvm::StringRef, std::pair<llvm::MCSymbol*, unsigned int>)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_6MDNodeEPNS_3DIEENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PSt4pairIS3_S5_E", "llvm::DenseMap<llvm::MDNode const*, llvm::DIE*, llvm::DenseMapInfo<llvm::MDNode const*>, llvm::DenseMapInfo<llvm::DIE*> >::InsertIntoBucket(llvm::MDNode const* const&, llvm::DIE* const&, std::pair<llvm::MDNode const*, llvm::DIE*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_6MDNodeEPNS_3DIEENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<llvm::MDNode const*, llvm::DIE*, llvm::DenseMapInfo<llvm::MDNode const*>, llvm::DenseMapInfo<llvm::DIE*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_6MDNodeEPNS_8DIEEntryENS_12DenseMapInfoIS3_EENS6_IS5_EEE6insertERKSt4pairIS3_S5_E", "llvm::DenseMap<llvm::MDNode const*, llvm::DIEEntry*, llvm::DenseMapInfo<llvm::MDNode const*>, llvm::DenseMapInfo<llvm::DIEEntry*> >::insert(std::pair<llvm::MDNode const*, llvm::DIEEntry*> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_6MDNodeEPNS_8DIEEntryENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PSt4pairIS3_S5_E", "llvm::DenseMap<llvm::MDNode const*, llvm::DIEEntry*, llvm::DenseMapInfo<llvm::MDNode const*>, llvm::DenseMapInfo<llvm::DIEEntry*> >::InsertIntoBucket(llvm::MDNode const* const&, llvm::DIEEntry* const&, std::pair<llvm::MDNode const*, llvm::DIEEntry*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_6MDNodeEPNS_8DIEEntryENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<llvm::MDNode const*, llvm::DIEEntry*, llvm::DenseMapInfo<llvm::MDNode const*>, llvm::DenseMapInfo<llvm::DIEEntry*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm3DIEESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::DIE*, std::allocator<llvm::DIE*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::DIE**, std::vector<llvm::DIE*, std::allocator<llvm::DIE*> > >, llvm::DIE* const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm9MCSectionESt4pairIKS3_jESt10_Select1stIS6_ESt4lessIS3_ESaIS6_EE8_M_eraseEPSt13_Rb_tree_nodeIS6_E", "std::_Rb_tree<llvm::MCSection const*, std::pair<llvm::MCSection const* const, unsigned int>, std::_Select1st<std::pair<llvm::MCSection const* const, unsigned int> >, std::less<llvm::MCSection const*>, std::allocator<std::pair<llvm::MCSection const* const, unsigned int> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::MCSection const* const, unsigned int> >*)"),
	mu_demangle_test("_ZN4llvm14DwarfException20ComputeCallSiteTableERNS_15SmallVectorImplINS0_13CallSiteEntryEEERKNS_8DenseMapIPNS_8MCSymbolENS0_8PadRangeENS_12DenseMapInfoIS7_EENS9_IS8_EEEERKNS1_IPKNS_14LandingPadInfoEEERKNS1_IjEE", "llvm::DwarfException::ComputeCallSiteTable(llvm::SmallVectorImpl<llvm::DwarfException::CallSiteEntry>&, llvm::DenseMap<llvm::MCSymbol*, llvm::DwarfException::PadRange, llvm::DenseMapInfo<llvm::MCSymbol*>, llvm::DenseMapInfo<llvm::DwarfException::PadRange> > const&, llvm::SmallVectorImpl<llvm::LandingPadInfo const*> const&, llvm::SmallVectorImpl<unsigned int> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_8MCSymbolENS_14DwarfException8PadRangeENS_12DenseMapInfoIS2_EENS5_IS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<llvm::MCSymbol*, llvm::DwarfException::PadRange, llvm::DenseMapInfo<llvm::MCSymbol*>, llvm::DenseMapInfo<llvm::DwarfException::PadRange> >::InsertIntoBucket(llvm::MCSymbol* const&, llvm::DwarfException::PadRange const&, std::pair<llvm::MCSymbol*, llvm::DwarfException::PadRange>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_8MCSymbolENS_14DwarfException8PadRangeENS_12DenseMapInfoIS2_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::MCSymbol*, llvm::DwarfException::PadRange, llvm::DenseMapInfo<llvm::MCSymbol*>, llvm::DenseMapInfo<llvm::DwarfException::PadRange> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm19DwarfTableException19FunctionEHFrameInfoESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::DwarfTableException::FunctionEHFrameInfo, std::allocator<llvm::DwarfTableException::FunctionEHFrameInfo> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::DwarfTableException::FunctionEHFrameInfo*, std::vector<llvm::DwarfTableException::FunctionEHFrameInfo, std::allocator<llvm::DwarfTableException::FunctionEHFrameInfo> > >, llvm::DwarfTableException::FunctionEHFrameInfo const&)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_116GenericAsmParserEXadL_ZNS3_20ParseDirectiveLEB128ENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::GenericAsmParser, &(anonymous namespace)::GenericAsmParser::ParseDirectiveLEB128(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_116GenericAsmParserEXadL_ZNS3_22ParseDirectiveEndMacroENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::GenericAsmParser, &(anonymous namespace)::GenericAsmParser::ParseDirectiveEndMacro(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_116GenericAsmParserEXadL_ZNS3_19ParseDirectiveMacroENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::GenericAsmParser, &(anonymous namespace)::GenericAsmParser::ParseDirectiveMacro(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_116GenericAsmParserEXadL_ZNS3_25ParseDirectiveMacrosOnOffENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::GenericAsmParser, &(anonymous namespace)::GenericAsmParser::ParseDirectiveMacrosOnOff(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_116GenericAsmParserEXadL_ZNS3_29ParseDirectiveCFIRestoreStateENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::GenericAsmParser, &(anonymous namespace)::GenericAsmParser::ParseDirectiveCFIRestoreState(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_116GenericAsmParserEXadL_ZNS3_30ParseDirectiveCFIRememberStateENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::GenericAsmParser, &(anonymous namespace)::GenericAsmParser::ParseDirectiveCFIRememberState(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_116GenericAsmParserEXadL_ZNS3_34ParseDirectiveCFIPersonalityOrLsdaENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::GenericAsmParser, &(anonymous namespace)::GenericAsmParser::ParseDirectiveCFIPersonalityOrLsda(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_116GenericAsmParserEXadL_ZNS3_23ParseDirectiveCFIOffsetENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::GenericAsmParser, &(anonymous namespace)::GenericAsmParser::ParseDirectiveCFIOffset(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_116GenericAsmParserEXadL_ZNS3_31ParseDirectiveCFIDefCfaRegisterENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::GenericAsmParser, &(anonymous namespace)::GenericAsmParser::ParseDirectiveCFIDefCfaRegister(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_116GenericAsmParserEXadL_ZNS3_29ParseDirectiveCFIDefCfaOffsetENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::GenericAsmParser, &(anonymous namespace)::GenericAsmParser::ParseDirectiveCFIDefCfaOffset(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_116GenericAsmParserEXadL_ZNS3_23ParseDirectiveCFIDefCfaENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::GenericAsmParser, &(anonymous namespace)::GenericAsmParser::ParseDirectiveCFIDefCfa(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_116GenericAsmParserEXadL_ZNS3_24ParseDirectiveCFIEndProcENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::GenericAsmParser, &(anonymous namespace)::GenericAsmParser::ParseDirectiveCFIEndProc(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_116GenericAsmParserEXadL_ZNS3_26ParseDirectiveCFIStartProcENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::GenericAsmParser, &(anonymous namespace)::GenericAsmParser::ParseDirectiveCFIStartProc(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_116GenericAsmParserEXadL_ZNS3_19ParseDirectiveStabsENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::GenericAsmParser, &(anonymous namespace)::GenericAsmParser::ParseDirectiveStabs(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_116GenericAsmParserEXadL_ZNS3_17ParseDirectiveLocENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::GenericAsmParser, &(anonymous namespace)::GenericAsmParser::ParseDirectiveLoc(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_116GenericAsmParserEXadL_ZNS3_18ParseDirectiveLineENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::GenericAsmParser, &(anonymous namespace)::GenericAsmParser::ParseDirectiveLine(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_116GenericAsmParserEXadL_ZNS3_18ParseDirectiveFileENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::GenericAsmParser, &(anonymous namespace)::GenericAsmParser::ParseDirectiveFile(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm8AsmTokenESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<llvm::AsmToken, std::allocator<llvm::AsmToken> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::AsmToken*, std::vector<llvm::AsmToken, std::allocator<llvm::AsmToken> > >, llvm::AsmToken const&)"),
	mu_demangle_test("_ZNSt6vectorIS_IN4llvm8AsmTokenESaIS1_EESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<std::vector<llvm::AsmToken, std::allocator<llvm::AsmToken> >, std::allocator<std::vector<llvm::AsmToken, std::allocator<llvm::AsmToken> > > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::vector<llvm::AsmToken, std::allocator<llvm::AsmToken> >*, std::vector<std::vector<llvm::AsmToken, std::allocator<llvm::AsmToken> >, std::allocator<std::vector<llvm::AsmToken, std::allocator<llvm::AsmToken> > > > >, std::vector<llvm::AsmToken, std::allocator<llvm::AsmToken> > const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm8AsmTokenESaIS1_EEaSERKS3_", "std::vector<llvm::AsmToken, std::allocator<llvm::AsmToken> >::operator=(std::vector<llvm::AsmToken, std::allocator<llvm::AsmToken> > const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm8AsmTokenESaIS1_EEC2ERKS3_", "std::vector<llvm::AsmToken, std::allocator<llvm::AsmToken> >::vector(std::vector<llvm::AsmToken, std::allocator<llvm::AsmToken> > const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm7AsmCondESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<llvm::AsmCond, std::allocator<llvm::AsmCond> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::AsmCond*, std::vector<llvm::AsmCond, std::allocator<llvm::AsmCond> > >, llvm::AsmCond const&)"),
	mu_demangle_test("_ZN4llvm9StringMapISt4pairIPNS_20MCAsmParserExtensionEPFbS3_NS_9StringRefENS_5SMLocEEENS_15MallocAllocatorEE16GetOrCreateValueIS8_EERNS_14StringMapEntryIS8_EES4_T_", "llvm::StringMapEntry<std::pair<llvm::MCAsmParserExtension*, bool (*)(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)> >& llvm::StringMap<std::pair<llvm::MCAsmParserExtension*, bool (*)(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)>, llvm::MallocAllocator>::GetOrCreateValue<std::pair<llvm::MCAsmParserExtension*, bool (*)(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)> >(llvm::StringRef, std::pair<llvm::MCAsmParserExtension*, bool (*)(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)>)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_113COFFAsmParserEXadL_ZNS3_19ParseDirectiveEndefENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::COFFAsmParser, &(anonymous namespace)::COFFAsmParser::ParseDirectiveEndef(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_113COFFAsmParserEXadL_ZNS3_18ParseDirectiveTypeENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::COFFAsmParser, &(anonymous namespace)::COFFAsmParser::ParseDirectiveType(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_113COFFAsmParserEXadL_ZNS3_17ParseDirectiveSclENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::COFFAsmParser, &(anonymous namespace)::COFFAsmParser::ParseDirectiveScl(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_113COFFAsmParserEXadL_ZNS3_17ParseDirectiveDefENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::COFFAsmParser, &(anonymous namespace)::COFFAsmParser::ParseDirectiveDef(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_113COFFAsmParserEXadL_ZNS3_24ParseSectionDirectiveBSSENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::COFFAsmParser, &(anonymous namespace)::COFFAsmParser::ParseSectionDirectiveBSS(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_113COFFAsmParserEXadL_ZNS3_25ParseSectionDirectiveDataENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::COFFAsmParser, &(anonymous namespace)::COFFAsmParser::ParseSectionDirectiveData(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_113COFFAsmParserEXadL_ZNS3_25ParseSectionDirectiveTextENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::COFFAsmParser, &(anonymous namespace)::COFFAsmParser::ParseSectionDirectiveText(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_24ParseSectionDirectiveTLVENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveTLV(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_35ParseSectionDirectiveThreadInitFuncENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveThreadInitFunc(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_25ParseSectionDirectiveTextENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveText(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_26ParseSectionDirectiveTDataENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveTData(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_31ParseSectionDirectiveSymbolStubENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveSymbolStub(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_31ParseSectionDirectiveStaticDataENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveStaticData(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_32ParseSectionDirectiveStaticConstENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveStaticConst(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_34ParseSectionDirectivePICSymbolStubENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectivePICSymbolStub(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_32ParseSectionDirectiveObjCSymbolsENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveObjCSymbols(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_37ParseSectionDirectiveObjCStringObjectENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveObjCStringObject(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_37ParseSectionDirectiveObjCSelectorStrsENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveObjCSelectorStrs(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_33ParseSectionDirectiveObjCProtocolENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveObjCProtocol(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_35ParseSectionDirectiveObjCModuleInfoENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveObjCModuleInfo(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_37ParseSectionDirectiveObjCMethVarTypesENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveObjCMethVarTypes(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_37ParseSectionDirectiveObjCMethVarNamesENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveObjCMethVarNames(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_34ParseSectionDirectiveObjCMetaClassENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveObjCMetaClass(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_36ParseSectionDirectiveObjCMessageRefsENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveObjCMessageRefs(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_37ParseSectionDirectiveObjCInstanceVarsENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveObjCInstanceVars(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_33ParseSectionDirectiveObjCInstMethENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveObjCInstMeth(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_32ParseSectionDirectiveObjCClsRefsENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveObjCClsRefs(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_32ParseSectionDirectiveObjCClsMethENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveObjCClsMeth(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_34ParseSectionDirectiveObjCClassVarsENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveObjCClassVars(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_35ParseSectionDirectiveObjCClassNamesENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveObjCClassNames(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_30ParseSectionDirectiveObjCClassENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveObjCClass(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_33ParseSectionDirectiveObjCCategoryENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveObjCCategory(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_36ParseSectionDirectiveObjCCatInstMethENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveObjCCatInstMeth(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_35ParseSectionDirectiveObjCCatClsMethENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveObjCCatClsMeth(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_42ParseSectionDirectiveNonLazySymbolPointersENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveNonLazySymbolPointers(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_32ParseSectionDirectiveModTermFuncENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveModTermFunc(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_32ParseSectionDirectiveModInitFuncENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveModInitFunc(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_29ParseSectionDirectiveLiteral8ENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveLiteral8(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_29ParseSectionDirectiveLiteral4ENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveLiteral4(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_30ParseSectionDirectiveLiteral16ENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveLiteral16(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_39ParseSectionDirectiveLazySymbolPointersENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveLazySymbolPointers(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_32ParseSectionDirectiveFVMLibInit1ENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveFVMLibInit1(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_32ParseSectionDirectiveFVMLibInit0ENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveFVMLibInit0(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_25ParseSectionDirectiveDyldENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveDyld(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_31ParseSectionDirectiveDestructorENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveDestructor(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_25ParseSectionDirectiveDataENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveData(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_28ParseSectionDirectiveCStringENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveCString(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_32ParseSectionDirectiveConstructorENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveConstructor(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_30ParseSectionDirectiveConstDataENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveConstData(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_26ParseSectionDirectiveConstENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseSectionDirectiveConst(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_22ParseDirectiveZerofillENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseDirectiveZerofill(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_18ParseDirectiveTBSSENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseDirectiveTBSS(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_28ParseDirectiveSecureLogResetENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseDirectiveSecureLogReset(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_29ParseDirectiveSecureLogUniqueENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseDirectiveSecureLogUnique(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_21ParseDirectiveSectionENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseDirectiveSection(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_24ParseDirectiveDumpOrLoadENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseDirectiveDumpOrLoad(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_35ParseDirectiveSubsectionsViaSymbolsENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseDirectiveSubsectionsViaSymbols(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_18ParseDirectiveLsymENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseDirectiveLsym(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_115DarwinAsmParserEXadL_ZNS3_18ParseDirectiveDescENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::DarwinAsmParser, &(anonymous namespace)::DarwinAsmParser::ParseDirectiveDesc(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_112ELFAsmParserEXadL_ZNS3_21ParseDirectiveWeakrefENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::ELFAsmParser, &(anonymous namespace)::ELFAsmParser::ParseDirectiveWeakref(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_112ELFAsmParserEXadL_ZNS3_20ParseDirectiveSymverENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::ELFAsmParser, &(anonymous namespace)::ELFAsmParser::ParseDirectiveSymver(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_112ELFAsmParserEXadL_ZNS3_19ParseDirectiveIdentENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::ELFAsmParser, &(anonymous namespace)::ELFAsmParser::ParseDirectiveIdent(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_112ELFAsmParserEXadL_ZNS3_18ParseDirectiveTypeENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::ELFAsmParser, &(anonymous namespace)::ELFAsmParser::ParseDirectiveType(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_112ELFAsmParserEXadL_ZNS3_22ParseDirectivePreviousENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::ELFAsmParser, &(anonymous namespace)::ELFAsmParser::ParseDirectivePrevious(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_112ELFAsmParserEXadL_ZNS3_18ParseDirectiveSizeENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::ELFAsmParser, &(anonymous namespace)::ELFAsmParser::ParseDirectiveSize(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_112ELFAsmParserEXadL_ZNS3_21ParseDirectiveSectionENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::ELFAsmParser, &(anonymous namespace)::ELFAsmParser::ParseDirectiveSection(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_112ELFAsmParserEXadL_ZNS3_28ParseSectionDirectiveEhFrameENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::ELFAsmParser, &(anonymous namespace)::ELFAsmParser::ParseSectionDirectiveEhFrame(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_112ELFAsmParserEXadL_ZNS3_35ParseSectionDirectiveDataRelRoLocalENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::ELFAsmParser, &(anonymous namespace)::ELFAsmParser::ParseSectionDirectiveDataRelRoLocal(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_112ELFAsmParserEXadL_ZNS3_30ParseSectionDirectiveDataRelRoENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::ELFAsmParser, &(anonymous namespace)::ELFAsmParser::ParseSectionDirectiveDataRelRo(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_112ELFAsmParserEXadL_ZNS3_28ParseSectionDirectiveDataRelENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::ELFAsmParser, &(anonymous namespace)::ELFAsmParser::ParseSectionDirectiveDataRel(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_112ELFAsmParserEXadL_ZNS3_25ParseSectionDirectiveTBSSENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::ELFAsmParser, &(anonymous namespace)::ELFAsmParser::ParseSectionDirectiveTBSS(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_112ELFAsmParserEXadL_ZNS3_26ParseSectionDirectiveTDataENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::ELFAsmParser, &(anonymous namespace)::ELFAsmParser::ParseSectionDirectiveTData(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_112ELFAsmParserEXadL_ZNS3_27ParseSectionDirectiveRoDataENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::ELFAsmParser, &(anonymous namespace)::ELFAsmParser::ParseSectionDirectiveRoData(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_112ELFAsmParserEXadL_ZNS3_24ParseSectionDirectiveBSSENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::ELFAsmParser, &(anonymous namespace)::ELFAsmParser::ParseSectionDirectiveBSS(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_112ELFAsmParserEXadL_ZNS3_25ParseSectionDirectiveTextENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::ELFAsmParser, &(anonymous namespace)::ELFAsmParser::ParseSectionDirectiveText(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	// mu_demangle_test("_ZN4llvm20MCAsmParserExtension15HandleDirectiveIN12_GLOBAL__N_112ELFAsmParserEXadL_ZNS3_25ParseSectionDirectiveDataENS_9StringRefENS_5SMLocEEEEEbPS0_S4_S5_", "bool llvm::MCAsmParserExtension::HandleDirective<(anonymous namespace)::ELFAsmParser, &(anonymous namespace)::ELFAsmParser::ParseSectionDirectiveData(llvm::StringRef, llvm::SMLoc)>(llvm::MCAsmParserExtension*, llvm::StringRef, llvm::SMLoc)"),
	mu_demangle_test("_ZN4llvm22AggressiveAntiDepState12GetGroupRegsEjRSt6vectorIjSaIjEEPSt8multimapIjNS0_17RegisterReferenceESt4lessIjESaISt4pairIKjS6_EEE", "llvm::AggressiveAntiDepState::GetGroupRegs(unsigned int, std::vector<unsigned int, std::allocator<unsigned int> >&, std::multimap<unsigned int, llvm::AggressiveAntiDepState::RegisterReference, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, llvm::AggressiveAntiDepState::RegisterReference> > >*)"),
	mu_demangle_test("_ZN4llvm24AggressiveAntiDepBreaker15GetPassthruRegsEPNS_12MachineInstrERSt3setIjSt4lessIjESaIjEE", "llvm::AggressiveAntiDepBreaker::GetPassthruRegs(llvm::MachineInstr*, std::set<unsigned int, std::less<unsigned int>, std::allocator<unsigned int> >&)"),
	mu_demangle_test("_ZN4llvm24AggressiveAntiDepBreaker18PrescanInstructionEPNS_12MachineInstrEjRSt3setIjSt4lessIjESaIjEE", "llvm::AggressiveAntiDepBreaker::PrescanInstruction(llvm::MachineInstr*, unsigned int, std::set<unsigned int, std::less<unsigned int>, std::allocator<unsigned int> >&)"),
	mu_demangle_test("_ZN4llvm24AggressiveAntiDepBreaker25FindSuitableFreeRegistersEjRSt3mapIPKNS_19TargetRegisterClassEPKjSt4lessIS4_ESaISt4pairIKS4_S6_EEERS1_IjjS7_IjESaIS9_IS5_jEEE", "llvm::AggressiveAntiDepBreaker::FindSuitableFreeRegisters(unsigned int, std::map<llvm::TargetRegisterClass const*, unsigned int const*, std::less<llvm::TargetRegisterClass const*>, std::allocator<std::pair<llvm::TargetRegisterClass const* const, unsigned int const*> > >&, std::map<unsigned int, unsigned int, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, unsigned int> > >&)"),
	mu_demangle_test("_ZN4llvm24AggressiveAntiDepBreaker21BreakAntiDependenciesERKSt6vectorINS_5SUnitESaIS2_EENS_14ilist_iteratorINS_12MachineInstrEEES9_j", "llvm::AggressiveAntiDepBreaker::BreakAntiDependencies(std::vector<llvm::SUnit, std::allocator<llvm::SUnit> > const&, llvm::ilist_iterator<llvm::MachineInstr>, llvm::ilist_iterator<llvm::MachineInstr>, unsigned int)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm12MachineInstrESt4pairIKS2_PKNS0_5SUnitEESt10_Select1stIS8_ESt4lessIS2_ESaIS8_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS8_ERKS8_", "std::_Rb_tree<llvm::MachineInstr*, std::pair<llvm::MachineInstr* const, llvm::SUnit const*>, std::_Select1st<std::pair<llvm::MachineInstr* const, llvm::SUnit const*> >, std::less<llvm::MachineInstr*>, std::allocator<std::pair<llvm::MachineInstr* const, llvm::SUnit const*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::MachineInstr* const, llvm::SUnit const*> >, std::pair<llvm::MachineInstr* const, llvm::SUnit const*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm12MachineInstrESt4pairIKS2_PKNS0_5SUnitEESt10_Select1stIS8_ESt4lessIS2_ESaIS8_EE16_M_insert_uniqueERKS8_", "std::_Rb_tree<llvm::MachineInstr*, std::pair<llvm::MachineInstr* const, llvm::SUnit const*>, std::_Select1st<std::pair<llvm::MachineInstr* const, llvm::SUnit const*> >, std::less<llvm::MachineInstr*>, std::allocator<std::pair<llvm::MachineInstr* const, llvm::SUnit const*> > >::_M_insert_unique(std::pair<llvm::MachineInstr* const, llvm::SUnit const*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm19TargetRegisterClassESt4pairIKS3_PKjESt10_Select1stIS8_ESt4lessIS3_ESaIS8_EE5eraseESt17_Rb_tree_iteratorIS8_ESG_", "std::_Rb_tree<llvm::TargetRegisterClass const*, std::pair<llvm::TargetRegisterClass const* const, unsigned int const*>, std::_Select1st<std::pair<llvm::TargetRegisterClass const* const, unsigned int const*> >, std::less<llvm::TargetRegisterClass const*>, std::allocator<std::pair<llvm::TargetRegisterClass const* const, unsigned int const*> > >::erase(std::_Rb_tree_iterator<std::pair<llvm::TargetRegisterClass const* const, unsigned int const*> >, std::_Rb_tree_iterator<std::pair<llvm::TargetRegisterClass const* const, unsigned int const*> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm19TargetRegisterClassESt4pairIKS3_PKjESt10_Select1stIS8_ESt4lessIS3_ESaIS8_EE8_M_eraseEPSt13_Rb_tree_nodeIS8_E", "std::_Rb_tree<llvm::TargetRegisterClass const*, std::pair<llvm::TargetRegisterClass const* const, unsigned int const*>, std::_Select1st<std::pair<llvm::TargetRegisterClass const* const, unsigned int const*> >, std::less<llvm::TargetRegisterClass const*>, std::allocator<std::pair<llvm::TargetRegisterClass const* const, unsigned int const*> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::TargetRegisterClass const* const, unsigned int const*> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjjESt10_Select1stIS2_ESt4lessIjESaIS2_EE16_M_insert_uniqueERKS2_", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, unsigned int>, std::_Select1st<std::pair<unsigned int const, unsigned int> >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, unsigned int> > >::_M_insert_unique(std::pair<unsigned int const, unsigned int> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjN4llvm9BitVectorEESt10_Select1stIS4_ESt4lessIjESaIS4_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS4_ERKS4_", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, llvm::BitVector>, std::_Select1st<std::pair<unsigned int const, llvm::BitVector> >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, llvm::BitVector> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<unsigned int const, llvm::BitVector> >, std::pair<unsigned int const, llvm::BitVector> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjN4llvm9BitVectorEESt10_Select1stIS4_ESt4lessIjESaIS4_EE9_M_insertEPSt18_Rb_tree_node_baseSC_RKS4_", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, llvm::BitVector>, std::_Select1st<std::pair<unsigned int const, llvm::BitVector> >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, llvm::BitVector> > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<unsigned int const, llvm::BitVector> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjN4llvm9BitVectorEESt10_Select1stIS4_ESt4lessIjESaIS4_EE16_M_insert_uniqueERKS4_", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, llvm::BitVector>, std::_Select1st<std::pair<unsigned int const, llvm::BitVector> >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, llvm::BitVector> > >::_M_insert_unique(std::pair<unsigned int const, llvm::BitVector> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjjESt10_Select1stIS2_ESt4lessIjESaIS2_EE8_M_eraseEPSt13_Rb_tree_nodeIS2_E", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, unsigned int>, std::_Select1st<std::pair<unsigned int const, unsigned int> >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, unsigned int> > >::_M_erase(std::_Rb_tree_node<std::pair<unsigned int const, unsigned int> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm19TargetRegisterClassESt4pairIKS3_PKjESt10_Select1stIS8_ESt4lessIS3_ESaIS8_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS8_ERKS8_", "std::_Rb_tree<llvm::TargetRegisterClass const*, std::pair<llvm::TargetRegisterClass const* const, unsigned int const*>, std::_Select1st<std::pair<llvm::TargetRegisterClass const* const, unsigned int const*> >, std::less<llvm::TargetRegisterClass const*>, std::allocator<std::pair<llvm::TargetRegisterClass const* const, unsigned int const*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::TargetRegisterClass const* const, unsigned int const*> >, std::pair<llvm::TargetRegisterClass const* const, unsigned int const*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm19TargetRegisterClassESt4pairIKS3_PKjESt10_Select1stIS8_ESt4lessIS3_ESaIS8_EE16_M_insert_uniqueERKS8_", "std::_Rb_tree<llvm::TargetRegisterClass const*, std::pair<llvm::TargetRegisterClass const* const, unsigned int const*>, std::_Select1st<std::pair<llvm::TargetRegisterClass const* const, unsigned int const*> >, std::less<llvm::TargetRegisterClass const*>, std::allocator<std::pair<llvm::TargetRegisterClass const* const, unsigned int const*> > >::_M_insert_unique(std::pair<llvm::TargetRegisterClass const* const, unsigned int const*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjN4llvm22AggressiveAntiDepState17RegisterReferenceEESt10_Select1stIS5_ESt4lessIjESaIS5_EE5eraseESt17_Rb_tree_iteratorIS5_ESD_", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, llvm::AggressiveAntiDepState::RegisterReference>, std::_Select1st<std::pair<unsigned int const, llvm::AggressiveAntiDepState::RegisterReference> >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, llvm::AggressiveAntiDepState::RegisterReference> > >::erase(std::_Rb_tree_iterator<std::pair<unsigned int const, llvm::AggressiveAntiDepState::RegisterReference> >, std::_Rb_tree_iterator<std::pair<unsigned int const, llvm::AggressiveAntiDepState::RegisterReference> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjN4llvm22AggressiveAntiDepState17RegisterReferenceEESt10_Select1stIS5_ESt4lessIjESaIS5_EE8_M_eraseEPSt13_Rb_tree_nodeIS5_E", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, llvm::AggressiveAntiDepState::RegisterReference>, std::_Select1st<std::pair<unsigned int const, llvm::AggressiveAntiDepState::RegisterReference> >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, llvm::AggressiveAntiDepState::RegisterReference> > >::_M_erase(std::_Rb_tree_node<std::pair<unsigned int const, llvm::AggressiveAntiDepState::RegisterReference> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm12MachineInstrESt4pairIKS2_PKNS0_5SUnitEESt10_Select1stIS8_ESt4lessIS2_ESaIS8_EE8_M_eraseEPSt13_Rb_tree_nodeIS8_E", "std::_Rb_tree<llvm::MachineInstr*, std::pair<llvm::MachineInstr* const, llvm::SUnit const*>, std::_Select1st<std::pair<llvm::MachineInstr* const, llvm::SUnit const*> >, std::less<llvm::MachineInstr*>, std::allocator<std::pair<llvm::MachineInstr* const, llvm::SUnit const*> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::MachineInstr* const, llvm::SUnit const*> >*)"),
	mu_demangle_test("_ZNSt6vectorIPKN4llvm4SDepESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<llvm::SDep const*, std::allocator<llvm::SDep const*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::SDep const**, std::vector<llvm::SDep const*, std::allocator<llvm::SDep const*> > >, llvm::SDep const* const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjN4llvm9BitVectorEESt10_Select1stIS4_ESt4lessIjESaIS4_EE8_M_eraseEPSt13_Rb_tree_nodeIS4_E", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, llvm::BitVector>, std::_Select1st<std::pair<unsigned int const, llvm::BitVector> >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, llvm::BitVector> > >::_M_erase(std::_Rb_tree_node<std::pair<unsigned int const, llvm::BitVector> >*)"),
	mu_demangle_test("_ZN4llvm25hasInlineAsmMemConstraintERSt6vectorINS_9InlineAsm14ConstraintInfoESaIS2_EERKNS_14TargetLoweringE", "llvm::hasInlineAsmMemConstraint(std::vector<llvm::InlineAsm::ConstraintInfo, std::allocator<llvm::InlineAsm::ConstraintInfo> >&, llvm::TargetLowering const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm12BranchFolder18MergePotentialsEltESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, llvm::BranchFolder::MergePotentialsElt const&)"),
	mu_demangle_test("_ZSt21__inplace_stable_sortIN9__gnu_cxx17__normal_iteratorIPN4llvm12BranchFolder18MergePotentialsEltESt6vectorIS4_SaIS4_EEEEEvT_SA_", "void std::__inplace_stable_sort<__gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > > >(__gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, __gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >)"),
	mu_demangle_test("_ZSt22__stable_sort_adaptiveIN9__gnu_cxx17__normal_iteratorIPN4llvm12BranchFolder18MergePotentialsEltESt6vectorIS4_SaIS4_EEEES5_lEvT_SA_T0_T1_", "void std::__stable_sort_adaptive<__gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, llvm::BranchFolder::MergePotentialsElt*, long>(__gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, __gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, llvm::BranchFolder::MergePotentialsElt*, long)"),
	mu_demangle_test("_ZSt24__merge_sort_with_bufferIN9__gnu_cxx17__normal_iteratorIPN4llvm12BranchFolder18MergePotentialsEltESt6vectorIS4_SaIS4_EEEES5_EvT_SA_T0_", "void std::__merge_sort_with_buffer<__gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, llvm::BranchFolder::MergePotentialsElt*>(__gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, __gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, llvm::BranchFolder::MergePotentialsElt*)"),
	mu_demangle_test("_ZSt16__merge_adaptiveIN9__gnu_cxx17__normal_iteratorIPN4llvm12BranchFolder18MergePotentialsEltESt6vectorIS4_SaIS4_EEEElS5_EvT_SA_SA_T0_SB_T1_SB_", "void std::__merge_adaptive<__gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, long, llvm::BranchFolder::MergePotentialsElt*>(__gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, __gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, __gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, long, long, llvm::BranchFolder::MergePotentialsElt*, long)"),
	mu_demangle_test("_ZSt5mergeIPN4llvm12BranchFolder18MergePotentialsEltEN9__gnu_cxx17__normal_iteratorIS3_St6vectorIS2_SaIS2_EEEES9_ET1_T_SB_T0_SC_SA_", "__gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > > std::merge<llvm::BranchFolder::MergePotentialsElt*, __gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, __gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > > >(llvm::BranchFolder::MergePotentialsElt*, llvm::BranchFolder::MergePotentialsElt*, __gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, __gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, __gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >)"),
	mu_demangle_test("_ZSt16__merge_backwardIN9__gnu_cxx17__normal_iteratorIPN4llvm12BranchFolder18MergePotentialsEltESt6vectorIS4_SaIS4_EEEES5_S9_ET1_T_SB_T0_SC_SA_", "__gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > > std::__merge_backward<__gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, llvm::BranchFolder::MergePotentialsElt*, __gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > > >(__gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, __gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, llvm::BranchFolder::MergePotentialsElt*, llvm::BranchFolder::MergePotentialsElt*, __gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >)"),
	mu_demangle_test("_ZSt17__rotate_adaptiveIN9__gnu_cxx17__normal_iteratorIPN4llvm12BranchFolder18MergePotentialsEltESt6vectorIS4_SaIS4_EEEES5_lET_SA_SA_SA_T1_SB_T0_SB_", "__gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > > std::__rotate_adaptive<__gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, llvm::BranchFolder::MergePotentialsElt*, long>(__gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, __gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, __gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, long, long, llvm::BranchFolder::MergePotentialsElt*, long)"),
	mu_demangle_test("_ZSt8__rotateIN9__gnu_cxx17__normal_iteratorIPN4llvm12BranchFolder18MergePotentialsEltESt6vectorIS4_SaIS4_EEEEEvT_SA_SA_St26random_access_iterator_tag", "void std::__rotate<__gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > > >(__gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, __gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, __gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, std::random_access_iterator_tag)"),
	mu_demangle_test("_ZSt5mergeIPN4llvm12BranchFolder18MergePotentialsEltES3_N9__gnu_cxx17__normal_iteratorIS3_St6vectorIS2_SaIS2_EEEEET1_T_SB_T0_SC_SA_", "__gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > > std::merge<llvm::BranchFolder::MergePotentialsElt*, llvm::BranchFolder::MergePotentialsElt*, __gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > > >(llvm::BranchFolder::MergePotentialsElt*, llvm::BranchFolder::MergePotentialsElt*, llvm::BranchFolder::MergePotentialsElt*, llvm::BranchFolder::MergePotentialsElt*, __gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >)"),
	mu_demangle_test("_ZSt5mergeIN9__gnu_cxx17__normal_iteratorIPN4llvm12BranchFolder18MergePotentialsEltESt6vectorIS4_SaIS4_EEEES9_S5_ET1_T_SB_T0_SC_SA_", "llvm::BranchFolder::MergePotentialsElt* std::merge<__gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, __gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, llvm::BranchFolder::MergePotentialsElt*>(__gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, __gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, __gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, __gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, llvm::BranchFolder::MergePotentialsElt*)"),
	mu_demangle_test("_ZSt16__insertion_sortIN9__gnu_cxx17__normal_iteratorIPN4llvm12BranchFolder18MergePotentialsEltESt6vectorIS4_SaIS4_EEEEEvT_SA_", "void std::__insertion_sort<__gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > > >(__gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, __gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >)"),
	mu_demangle_test("_ZSt22__merge_without_bufferIN9__gnu_cxx17__normal_iteratorIPN4llvm12BranchFolder18MergePotentialsEltESt6vectorIS4_SaIS4_EEEElEvT_SA_SA_T0_SB_", "void std::__merge_without_buffer<__gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, long>(__gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, __gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, __gnu_cxx::__normal_iterator<llvm::BranchFolder::MergePotentialsElt*, std::vector<llvm::BranchFolder::MergePotentialsElt, std::allocator<llvm::BranchFolder::MergePotentialsElt> > >, long, long)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm12BranchFolder11SameTailEltESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::BranchFolder::SameTailElt, std::allocator<llvm::BranchFolder::SameTailElt> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::BranchFolder::SameTailElt*, std::vector<llvm::BranchFolder::SameTailElt, std::allocator<llvm::BranchFolder::SameTailElt> > >, llvm::BranchFolder::SameTailElt const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjfNS_12DenseMapInfoIjEENS1_IfEEE16shrink_and_clearEv", "llvm::DenseMap<unsigned int, float, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<float> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIjfNS_12DenseMapInfoIjEENS1_IfEEE16InsertIntoBucketERKjRKfPSt4pairIjfE", "llvm::DenseMap<unsigned int, float, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<float> >::InsertIntoBucket(unsigned int const&, float const&, std::pair<unsigned int, float>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjfNS_12DenseMapInfoIjEENS1_IfEEE4growEj", "llvm::DenseMap<unsigned int, float, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<float> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm22CriticalAntiDepBreaker23isNewRegClobberedByRefsESt23_Rb_tree_const_iteratorISt4pairIKjPNS_14MachineOperandEEES7_j", "llvm::CriticalAntiDepBreaker::isNewRegClobberedByRefs(std::_Rb_tree_const_iterator<std::pair<unsigned int const, llvm::MachineOperand*> >, std::_Rb_tree_const_iterator<std::pair<unsigned int const, llvm::MachineOperand*> >, unsigned int)"),
	mu_demangle_test("_ZN4llvm22CriticalAntiDepBreaker24findSuitableFreeRegisterESt23_Rb_tree_const_iteratorISt4pairIKjPNS_14MachineOperandEEES7_jjPKNS_19TargetRegisterClassE", "llvm::CriticalAntiDepBreaker::findSuitableFreeRegister(std::_Rb_tree_const_iterator<std::pair<unsigned int const, llvm::MachineOperand*> >, std::_Rb_tree_const_iterator<std::pair<unsigned int const, llvm::MachineOperand*> >, unsigned int, unsigned int, llvm::TargetRegisterClass const*)"),
	mu_demangle_test("_ZN4llvm22CriticalAntiDepBreaker21BreakAntiDependenciesERKSt6vectorINS_5SUnitESaIS2_EENS_14ilist_iteratorINS_12MachineInstrEEES9_j", "llvm::CriticalAntiDepBreaker::BreakAntiDependencies(std::vector<llvm::SUnit, std::allocator<llvm::SUnit> > const&, llvm::ilist_iterator<llvm::MachineInstr>, llvm::ilist_iterator<llvm::MachineInstr>, unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_12MachineInstrEPKNS_5SUnitENS_12DenseMapInfoIS2_EENS6_IS5_EEE16InsertIntoBucketERKS2_RKS5_PSt4pairIS2_S5_E", "llvm::DenseMap<llvm::MachineInstr*, llvm::SUnit const*, llvm::DenseMapInfo<llvm::MachineInstr*>, llvm::DenseMapInfo<llvm::SUnit const*> >::InsertIntoBucket(llvm::MachineInstr* const&, llvm::SUnit const* const&, std::pair<llvm::MachineInstr*, llvm::SUnit const*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_12MachineInstrEPKNS_5SUnitENS_12DenseMapInfoIS2_EENS6_IS5_EEE4growEj", "llvm::DenseMap<llvm::MachineInstr*, llvm::SUnit const*, llvm::DenseMapInfo<llvm::MachineInstr*>, llvm::DenseMapInfo<llvm::SUnit const*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjPN4llvm14MachineOperandEESt10_Select1stIS5_ESt4lessIjESaIS5_EE5eraseESt17_Rb_tree_iteratorIS5_ESD_", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, llvm::MachineOperand*>, std::_Select1st<std::pair<unsigned int const, llvm::MachineOperand*> >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, llvm::MachineOperand*> > >::erase(std::_Rb_tree_iterator<std::pair<unsigned int const, llvm::MachineOperand*> >, std::_Rb_tree_iterator<std::pair<unsigned int const, llvm::MachineOperand*> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjPN4llvm14MachineOperandEESt10_Select1stIS5_ESt4lessIjESaIS5_EE8_M_eraseEPSt13_Rb_tree_nodeIS5_E", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, llvm::MachineOperand*>, std::_Select1st<std::pair<unsigned int const, llvm::MachineOperand*> >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, llvm::MachineOperand*> > >::_M_erase(std::_Rb_tree_node<std::pair<unsigned int const, llvm::MachineOperand*> >*)"),
	mu_demangle_test("_ZN4llvm17DominatorTreeBaseINS_10BasicBlockEE5SplitINS_7InverseIPS1_EENS_11GraphTraitsIS6_EEEEvRNS0_INT0_8NodeTypeEEEPSA_", "void llvm::DominatorTreeBase<llvm::BasicBlock>::Split<llvm::Inverse<llvm::BasicBlock*>, llvm::GraphTraits<llvm::Inverse<llvm::BasicBlock*> > >(llvm::DominatorTreeBase<llvm::GraphTraits<llvm::Inverse<llvm::BasicBlock*> >::NodeType>&, llvm::GraphTraits<llvm::Inverse<llvm::BasicBlock*> >::NodeType*)"),
	mu_demangle_test("_ZN4llvm17DominatorTreeBaseINS_10BasicBlockEE5SplitIPS1_NS_11GraphTraitsIS4_EEEEvRNS0_INT0_8NodeTypeEEEPS8_", "void llvm::DominatorTreeBase<llvm::BasicBlock>::Split<llvm::BasicBlock*, llvm::GraphTraits<llvm::BasicBlock*> >(llvm::DominatorTreeBase<llvm::GraphTraits<llvm::BasicBlock*>::NodeType>&, llvm::GraphTraits<llvm::BasicBlock*>::NodeType*)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm15DomTreeNodeBaseINS0_10BasicBlockEEESaIS4_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS4_S6_EERKS4_", "std::vector<llvm::DomTreeNodeBase<llvm::BasicBlock>*, std::allocator<llvm::DomTreeNodeBase<llvm::BasicBlock>*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::DomTreeNodeBase<llvm::BasicBlock>**, std::vector<llvm::DomTreeNodeBase<llvm::BasicBlock>*, std::allocator<llvm::DomTreeNodeBase<llvm::BasicBlock>*> > >, llvm::DomTreeNodeBase<llvm::BasicBlock>* const&)"),
	mu_demangle_test("_ZSt6__findIN9__gnu_cxx17__normal_iteratorIPPN4llvm15DomTreeNodeBaseINS2_10BasicBlockEEESt6vectorIS6_SaIS6_EEEES6_ET_SC_SC_RKT0_St26random_access_iterator_tag", "__gnu_cxx::__normal_iterator<llvm::DomTreeNodeBase<llvm::BasicBlock>**, std::vector<llvm::DomTreeNodeBase<llvm::BasicBlock>*, std::allocator<llvm::DomTreeNodeBase<llvm::BasicBlock>*> > > std::__find<__gnu_cxx::__normal_iterator<llvm::DomTreeNodeBase<llvm::BasicBlock>**, std::vector<llvm::DomTreeNodeBase<llvm::BasicBlock>*, std::allocator<llvm::DomTreeNodeBase<llvm::BasicBlock>*> > >, llvm::DomTreeNodeBase<llvm::BasicBlock>*>(__gnu_cxx::__normal_iterator<llvm::DomTreeNodeBase<llvm::BasicBlock>**, std::vector<llvm::DomTreeNodeBase<llvm::BasicBlock>*, std::allocator<llvm::DomTreeNodeBase<llvm::BasicBlock>*> > >, __gnu_cxx::__normal_iterator<llvm::DomTreeNodeBase<llvm::BasicBlock>**, std::vector<llvm::DomTreeNodeBase<llvm::BasicBlock>*, std::allocator<llvm::DomTreeNodeBase<llvm::BasicBlock>*> > >, llvm::DomTreeNodeBase<llvm::BasicBlock>* const&, std::random_access_iterator_tag)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEPNS_15DomTreeNodeBaseIS1_EENS_12DenseMapInfoIS2_EENS6_IS5_EEE16InsertIntoBucketERKS2_RKS5_PSt4pairIS2_S5_E", "llvm::DenseMap<llvm::BasicBlock*, llvm::DomTreeNodeBase<llvm::BasicBlock>*, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::DomTreeNodeBase<llvm::BasicBlock>*> >::InsertIntoBucket(llvm::BasicBlock* const&, llvm::DomTreeNodeBase<llvm::BasicBlock>* const&, std::pair<llvm::BasicBlock*, llvm::DomTreeNodeBase<llvm::BasicBlock>*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEPNS_15DomTreeNodeBaseIS1_EENS_12DenseMapInfoIS2_EENS6_IS5_EEE4growEj", "llvm::DenseMap<llvm::BasicBlock*, llvm::DomTreeNodeBase<llvm::BasicBlock>*, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::DomTreeNodeBase<llvm::BasicBlock>*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm10BasicBlockESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::BasicBlock**, std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> > >, llvm::BasicBlock* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_8FunctionEPNS_14GCFunctionInfoENS_12DenseMapInfoIS3_EENS6_IS5_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::Function const*, llvm::GCFunctionInfo*, llvm::DenseMapInfo<llvm::Function const*>, llvm::DenseMapInfo<llvm::GCFunctionInfo*> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_8FunctionEPNS_14GCFunctionInfoENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PSt4pairIS3_S5_E", "llvm::DenseMap<llvm::Function const*, llvm::GCFunctionInfo*, llvm::DenseMapInfo<llvm::Function const*>, llvm::DenseMapInfo<llvm::GCFunctionInfo*> >::InsertIntoBucket(llvm::Function const* const&, llvm::GCFunctionInfo* const&, std::pair<llvm::Function const*, llvm::GCFunctionInfo*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_8FunctionEPNS_14GCFunctionInfoENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<llvm::Function const*, llvm::GCFunctionInfo*, llvm::DenseMapInfo<llvm::Function const*>, llvm::DenseMapInfo<llvm::GCFunctionInfo*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm10GCStrategyESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::GCStrategy*, std::allocator<llvm::GCStrategy*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::GCStrategy**, std::vector<llvm::GCStrategy*, std::allocator<llvm::GCStrategy*> > >, llvm::GCStrategy* const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm14GCFunctionInfoESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::GCFunctionInfo*, std::allocator<llvm::GCFunctionInfo*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::GCFunctionInfo**, std::vector<llvm::GCFunctionInfo*, std::allocator<llvm::GCFunctionInfo*> > >, llvm::GCFunctionInfo* const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm7GCPointESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<llvm::GCPoint, std::allocator<llvm::GCPoint> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::GCPoint*, std::vector<llvm::GCPoint, std::allocator<llvm::GCPoint> > >, llvm::GCPoint const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockES2_NS_12DenseMapInfoIS2_EES4_E16InsertIntoBucketERKS2_S7_PSt4pairIS2_S2_E", "llvm::DenseMap<llvm::BasicBlock*, llvm::BasicBlock*, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::BasicBlock*> >::InsertIntoBucket(llvm::BasicBlock* const&, llvm::BasicBlock* const&, std::pair<llvm::BasicBlock*, llvm::BasicBlock*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockES2_NS_12DenseMapInfoIS2_EES4_E4growEj", "llvm::DenseMap<llvm::BasicBlock*, llvm::BasicBlock*, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::BasicBlock*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockES2_NS_12DenseMapInfoIS2_EES4_E16shrink_and_clearEv", "llvm::DenseMap<llvm::BasicBlock*, llvm::BasicBlock*, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::BasicBlock*> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEPNS_15DomTreeNodeBaseIS1_EENS_12DenseMapInfoIS2_EENS6_IS5_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::BasicBlock*, llvm::DomTreeNodeBase<llvm::BasicBlock>*, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::DomTreeNodeBase<llvm::BasicBlock>*> >::shrink_and_clear()"),
	mu_demangle_test("_ZN12_GLOBAL__N_111IfConverter12AnalyzeBlockEPN4llvm17MachineBasicBlockERSt6vectorIPNS0_10IfcvtTokenESaIS6_EE", "(anonymous namespace)::IfConverter::AnalyzeBlock(llvm::MachineBasicBlock*, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> >&)"),
	mu_demangle_test("_ZSt21__inplace_stable_sortIN9__gnu_cxx17__normal_iteratorIPPN12_GLOBAL__N_111IfConverter10IfcvtTokenESt6vectorIS5_SaIS5_EEEEPFbS5_S5_EEvT_SD_T0_", "void std::__inplace_stable_sort<__gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, bool (*)((anonymous namespace)::IfConverter::IfcvtToken*, (anonymous namespace)::IfConverter::IfcvtToken*)>(__gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, __gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, bool (*)((anonymous namespace)::IfConverter::IfcvtToken*, (anonymous namespace)::IfConverter::IfcvtToken*))"),
	mu_demangle_test("_ZSt22__stable_sort_adaptiveIN9__gnu_cxx17__normal_iteratorIPPN12_GLOBAL__N_111IfConverter10IfcvtTokenESt6vectorIS5_SaIS5_EEEES6_lPFbS5_S5_EEvT_SD_T0_T1_T2_", "void std::__stable_sort_adaptive<__gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, (anonymous namespace)::IfConverter::IfcvtToken**, long, bool (*)((anonymous namespace)::IfConverter::IfcvtToken*, (anonymous namespace)::IfConverter::IfcvtToken*)>(__gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, __gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, (anonymous namespace)::IfConverter::IfcvtToken**, long, bool (*)((anonymous namespace)::IfConverter::IfcvtToken*, (anonymous namespace)::IfConverter::IfcvtToken*))"),
	mu_demangle_test("_ZSt24__merge_sort_with_bufferIN9__gnu_cxx17__normal_iteratorIPPN12_GLOBAL__N_111IfConverter10IfcvtTokenESt6vectorIS5_SaIS5_EEEES6_PFbS5_S5_EEvT_SD_T0_T1_", "void std::__merge_sort_with_buffer<__gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, (anonymous namespace)::IfConverter::IfcvtToken**, bool (*)((anonymous namespace)::IfConverter::IfcvtToken*, (anonymous namespace)::IfConverter::IfcvtToken*)>(__gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, __gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, (anonymous namespace)::IfConverter::IfcvtToken**, bool (*)((anonymous namespace)::IfConverter::IfcvtToken*, (anonymous namespace)::IfConverter::IfcvtToken*))"),
	mu_demangle_test("_ZSt16__merge_adaptiveIN9__gnu_cxx17__normal_iteratorIPPN12_GLOBAL__N_111IfConverter10IfcvtTokenESt6vectorIS5_SaIS5_EEEElS6_PFbS5_S5_EEvT_SD_SD_T0_SE_T1_SE_T2_", "void std::__merge_adaptive<__gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, long, (anonymous namespace)::IfConverter::IfcvtToken**, bool (*)((anonymous namespace)::IfConverter::IfcvtToken*, (anonymous namespace)::IfConverter::IfcvtToken*)>(__gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, __gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, __gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, long, long, (anonymous namespace)::IfConverter::IfcvtToken**, long, bool (*)((anonymous namespace)::IfConverter::IfcvtToken*, (anonymous namespace)::IfConverter::IfcvtToken*))"),
	mu_demangle_test("_ZSt11lower_boundIN9__gnu_cxx17__normal_iteratorIPPN12_GLOBAL__N_111IfConverter10IfcvtTokenESt6vectorIS5_SaIS5_EEEES5_PFbS5_S5_EET_SD_SD_RKT0_T1_", "__gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > > std::lower_bound<__gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, (anonymous namespace)::IfConverter::IfcvtToken*, bool (*)((anonymous namespace)::IfConverter::IfcvtToken*, (anonymous namespace)::IfConverter::IfcvtToken*)>(__gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, __gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, (anonymous namespace)::IfConverter::IfcvtToken* const&, bool (*)((anonymous namespace)::IfConverter::IfcvtToken*, (anonymous namespace)::IfConverter::IfcvtToken*))"),
	mu_demangle_test("_ZSt11upper_boundIN9__gnu_cxx17__normal_iteratorIPPN12_GLOBAL__N_111IfConverter10IfcvtTokenESt6vectorIS5_SaIS5_EEEES5_PFbS5_S5_EET_SD_SD_RKT0_T1_", "__gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > > std::upper_bound<__gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, (anonymous namespace)::IfConverter::IfcvtToken*, bool (*)((anonymous namespace)::IfConverter::IfcvtToken*, (anonymous namespace)::IfConverter::IfcvtToken*)>(__gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, __gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, (anonymous namespace)::IfConverter::IfcvtToken* const&, bool (*)((anonymous namespace)::IfConverter::IfcvtToken*, (anonymous namespace)::IfConverter::IfcvtToken*))"),
	mu_demangle_test("_ZSt6rotateIN9__gnu_cxx17__normal_iteratorIPPN12_GLOBAL__N_111IfConverter10IfcvtTokenESt6vectorIS5_SaIS5_EEEEEvT_SB_SB_", "void std::rotate<__gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > > >(__gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, __gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, __gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >)"),
	mu_demangle_test("_ZSt5mergeIPPN12_GLOBAL__N_111IfConverter10IfcvtTokenES4_N9__gnu_cxx17__normal_iteratorIS4_St6vectorIS3_SaIS3_EEEEPFbS3_S3_EET1_T_SE_T0_SF_SD_T2_", "__gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > > std::merge<(anonymous namespace)::IfConverter::IfcvtToken**, (anonymous namespace)::IfConverter::IfcvtToken**, __gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, bool (*)((anonymous namespace)::IfConverter::IfcvtToken*, (anonymous namespace)::IfConverter::IfcvtToken*)>((anonymous namespace)::IfConverter::IfcvtToken**, (anonymous namespace)::IfConverter::IfcvtToken**, (anonymous namespace)::IfConverter::IfcvtToken**, (anonymous namespace)::IfConverter::IfcvtToken**, __gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, bool (*)((anonymous namespace)::IfConverter::IfcvtToken*, (anonymous namespace)::IfConverter::IfcvtToken*))"),
	mu_demangle_test("_ZSt5mergeIN9__gnu_cxx17__normal_iteratorIPPN12_GLOBAL__N_111IfConverter10IfcvtTokenESt6vectorIS5_SaIS5_EEEESA_S6_PFbS5_S5_EET1_T_SE_T0_SF_SD_T2_", "(anonymous namespace)::IfConverter::IfcvtToken** std::merge<__gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, __gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, (anonymous namespace)::IfConverter::IfcvtToken**, bool (*)((anonymous namespace)::IfConverter::IfcvtToken*, (anonymous namespace)::IfConverter::IfcvtToken*)>(__gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, __gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, __gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, __gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, (anonymous namespace)::IfConverter::IfcvtToken**, bool (*)((anonymous namespace)::IfConverter::IfcvtToken*, (anonymous namespace)::IfConverter::IfcvtToken*))"),
	mu_demangle_test("_ZSt16__insertion_sortIN9__gnu_cxx17__normal_iteratorIPPN12_GLOBAL__N_111IfConverter10IfcvtTokenESt6vectorIS5_SaIS5_EEEEPFbS5_S5_EEvT_SD_T0_", "void std::__insertion_sort<__gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, bool (*)((anonymous namespace)::IfConverter::IfcvtToken*, (anonymous namespace)::IfConverter::IfcvtToken*)>(__gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, __gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, bool (*)((anonymous namespace)::IfConverter::IfcvtToken*, (anonymous namespace)::IfConverter::IfcvtToken*))"),
	mu_demangle_test("_ZSt22__merge_without_bufferIN9__gnu_cxx17__normal_iteratorIPPN12_GLOBAL__N_111IfConverter10IfcvtTokenESt6vectorIS5_SaIS5_EEEElPFbS5_S5_EEvT_SD_SD_T0_SE_T1_", "void std::__merge_without_buffer<__gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, long, bool (*)((anonymous namespace)::IfConverter::IfcvtToken*, (anonymous namespace)::IfConverter::IfcvtToken*)>(__gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, __gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, __gnu_cxx::__normal_iterator<(anonymous namespace)::IfConverter::IfcvtToken**, std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> > >, long, long, bool (*)((anonymous namespace)::IfConverter::IfcvtToken*, (anonymous namespace)::IfConverter::IfcvtToken*))"),
	mu_demangle_test("_ZNSt6vectorIPN12_GLOBAL__N_111IfConverter10IfcvtTokenESaIS3_EE9push_backERKS3_", "std::vector<(anonymous namespace)::IfConverter::IfcvtToken*, std::allocator<(anonymous namespace)::IfConverter::IfcvtToken*> >::push_back((anonymous namespace)::IfConverter::IfcvtToken* const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjjSt9_IdentityIjESt4lessIjESaIjEE5eraseESt17_Rb_tree_iteratorIjES7_", "std::_Rb_tree<unsigned int, unsigned int, std::_Identity<unsigned int>, std::less<unsigned int>, std::allocator<unsigned int> >::erase(std::_Rb_tree_iterator<unsigned int>, std::_Rb_tree_iterator<unsigned int>)"),
	mu_demangle_test("_ZN4llvm13idf_ext_beginIPNS_17MachineBasicBlockESt3setIS2_St4lessIS2_ESaIS2_EEEENS_16idf_ext_iteratorIT_T0_EERKS9_RSA_", "llvm::idf_ext_iterator<llvm::MachineBasicBlock*, std::set<llvm::MachineBasicBlock*, std::less<llvm::MachineBasicBlock*>, std::allocator<llvm::MachineBasicBlock*> > > llvm::idf_ext_begin<llvm::MachineBasicBlock*, std::set<llvm::MachineBasicBlock*, std::less<llvm::MachineBasicBlock*>, std::allocator<llvm::MachineBasicBlock*> > >(llvm::MachineBasicBlock* const&, std::set<llvm::MachineBasicBlock*, std::less<llvm::MachineBasicBlock*>, std::allocator<llvm::MachineBasicBlock*> >&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm17MachineBasicBlockES2_St9_IdentityIS2_ESt4lessIS2_ESaIS2_EE8_M_eraseEPSt13_Rb_tree_nodeIS2_E", "std::_Rb_tree<llvm::MachineBasicBlock*, llvm::MachineBasicBlock*, std::_Identity<llvm::MachineBasicBlock*>, std::less<llvm::MachineBasicBlock*>, std::allocator<llvm::MachineBasicBlock*> >::_M_erase(std::_Rb_tree_node<llvm::MachineBasicBlock*>*)"),
	mu_demangle_test("_ZN4llvm11df_iteratorINS_7InverseIPNS_17MachineBasicBlockEEESt3setIS3_St4lessIS3_ESaIS3_EELb1ENS_11GraphTraitsIS4_EEE6toNextEv", "llvm::df_iterator<llvm::Inverse<llvm::MachineBasicBlock*>, std::set<llvm::MachineBasicBlock*, std::less<llvm::MachineBasicBlock*>, std::allocator<llvm::MachineBasicBlock*> >, true, llvm::GraphTraits<llvm::Inverse<llvm::MachineBasicBlock*> > >::toNext()"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm17MachineBasicBlockES2_St9_IdentityIS2_ESt4lessIS2_ESaIS2_EE16_M_insert_uniqueERKS2_", "std::_Rb_tree<llvm::MachineBasicBlock*, llvm::MachineBasicBlock*, std::_Identity<llvm::MachineBasicBlock*>, std::less<llvm::MachineBasicBlock*>, std::allocator<llvm::MachineBasicBlock*> >::_M_insert_unique(llvm::MachineBasicBlock* const&)"),
	mu_demangle_test("_Z20EnsureFunctionExistsIN4llvm14ilist_iteratorINS0_8ArgumentEEEEvRNS0_6ModuleEPKcT_S8_PKNS0_4TypeE", "void EnsureFunctionExists<llvm::ilist_iterator<llvm::Argument> >(llvm::Module&, char const*, llvm::ilist_iterator<llvm::Argument>, llvm::ilist_iterator<llvm::Argument>, llvm::Type const*)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE9CreateNotEPNS_5ValueERKNS_5TwineE", "llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateNot(llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE9CreateSubEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateSub(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE9CreateAndEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateAnd(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE13CreateIntCastEPNS_5ValueEPKNS_4TypeEbRKNS_5TwineE", "llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateIntCast(llvm::Value*, llvm::Type const*, bool, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE10CreateCallIPPNS_5ValueEEEPNS_8CallInstES7_T_SB_RKNS_5TwineE", "llvm::CallInst* llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateCall<llvm::Value**>(llvm::Value*, llvm::Value**, llvm::Value**, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE9CreateAddEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateAdd(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm2cl3optINS0_13boolOrDefaultELb0ENS0_6parserIS2_EEED1Ev", "llvm::cl::opt<llvm::cl::boolOrDefault, false, llvm::cl::parser<llvm::cl::boolOrDefault> >::~opt()"),
	mu_demangle_test("_ZN4llvm2cl3optINS0_13boolOrDefaultELb0ENS0_6parserIS2_EEE16handleOccurrenceEjNS_9StringRefES6_", "llvm::cl::opt<llvm::cl::boolOrDefault, false, llvm::cl::parser<llvm::cl::boolOrDefault> >::handleOccurrence(unsigned int, llvm::StringRef, llvm::StringRef)"),
	mu_demangle_test("_ZNK4llvm2cl3optINS0_13boolOrDefaultELb0ENS0_6parserIS2_EEE27getValueExpectedFlagDefaultEv", "llvm::cl::opt<llvm::cl::boolOrDefault, false, llvm::cl::parser<llvm::cl::boolOrDefault> >::getValueExpectedFlagDefault() const"),
	mu_demangle_test("_ZNK4llvm2cl3optINS0_13boolOrDefaultELb0ENS0_6parserIS2_EEE14getOptionWidthEv", "llvm::cl::opt<llvm::cl::boolOrDefault, false, llvm::cl::parser<llvm::cl::boolOrDefault> >::getOptionWidth() const"),
	mu_demangle_test("_ZNK4llvm2cl3optINS0_13boolOrDefaultELb0ENS0_6parserIS2_EEE15printOptionInfoEm", "llvm::cl::opt<llvm::cl::boolOrDefault, false, llvm::cl::parser<llvm::cl::boolOrDefault> >::printOptionInfo(unsigned long) const"),
	mu_demangle_test("_ZN4llvm2cl3optINS0_13boolOrDefaultELb0ENS0_6parserIS2_EEE19getExtraOptionNamesERNS_15SmallVectorImplIPKcEE", "llvm::cl::opt<llvm::cl::boolOrDefault, false, llvm::cl::parser<llvm::cl::boolOrDefault> >::getExtraOptionNames(llvm::SmallVectorImpl<char const*>&)"),
	mu_demangle_test("_ZN4llvm2cl3optINS0_13boolOrDefaultELb0ENS0_6parserIS2_EEED0Ev", "llvm::cl::opt<llvm::cl::boolOrDefault, false, llvm::cl::parser<llvm::cl::boolOrDefault> >::~opt()"),
	mu_demangle_test("_ZN4llvm11IntervalMapINS_9SlotIndexEjLj4ENS_15IntervalMapInfoIS1_EEE14const_iterator7setRootEj", "llvm::IntervalMap<llvm::SlotIndex, unsigned int, 4u, llvm::IntervalMapInfo<llvm::SlotIndex> >::const_iterator::setRoot(unsigned int)"),
	mu_demangle_test("_ZN4llvm11IntervalMapINS_9SlotIndexEjLj4ENS_15IntervalMapInfoIS1_EEE8iterator8setValueEj", "llvm::IntervalMap<llvm::SlotIndex, unsigned int, 4u, llvm::IntervalMapInfo<llvm::SlotIndex> >::iterator::setValue(unsigned int)"),
	mu_demangle_test("_ZN4llvm11IntervalMapINS_9SlotIndexEjLj4ENS_15IntervalMapInfoIS1_EEE8iterator16canCoalesceRightES1_j", "llvm::IntervalMap<llvm::SlotIndex, unsigned int, 4u, llvm::IntervalMapInfo<llvm::SlotIndex> >::iterator::canCoalesceRight(llvm::SlotIndex, unsigned int)"),
	mu_demangle_test("_ZN4llvm11IntervalMapINS_9SlotIndexEjLj4ENS_15IntervalMapInfoIS1_EEE8iterator15canCoalesceLeftES1_j", "llvm::IntervalMap<llvm::SlotIndex, unsigned int, 4u, llvm::IntervalMapInfo<llvm::SlotIndex> >::iterator::canCoalesceLeft(llvm::SlotIndex, unsigned int)"),
	mu_demangle_test("_ZN4llvm11IntervalMapINS_9SlotIndexEjLj4ENS_15IntervalMapInfoIS1_EEE8iterator9treeEraseEb", "llvm::IntervalMap<llvm::SlotIndex, unsigned int, 4u, llvm::IntervalMapInfo<llvm::SlotIndex> >::iterator::treeErase(bool)"),
	mu_demangle_test("_ZN4llvm11IntervalMapINS_9SlotIndexEjLj4ENS_15IntervalMapInfoIS1_EEE8iterator9eraseNodeEj", "llvm::IntervalMap<llvm::SlotIndex, unsigned int, 4u, llvm::IntervalMapInfo<llvm::SlotIndex> >::iterator::eraseNode(unsigned int)"),
	mu_demangle_test("_ZN4llvm11IntervalMapINS_9SlotIndexEjLj4ENS_15IntervalMapInfoIS1_EEE16switchRootToLeafEv", "llvm::IntervalMap<llvm::SlotIndex, unsigned int, 4u, llvm::IntervalMapInfo<llvm::SlotIndex> >::switchRootToLeaf()"),
	mu_demangle_test("_ZN4llvm11IntervalMapINS_9SlotIndexEjLj4ENS_15IntervalMapInfoIS1_EEE10visitNodesEMS4_FvNS_15IntervalMapImpl7NodeRefEjE", "llvm::IntervalMap<llvm::SlotIndex, unsigned int, 4u, llvm::IntervalMapInfo<llvm::SlotIndex> >::visitNodes(void (llvm::IntervalMap<llvm::SlotIndex, unsigned int, 4u, llvm::IntervalMapInfo<llvm::SlotIndex> >::*)(llvm::IntervalMapImpl::NodeRef, unsigned int))"),
	mu_demangle_test("_ZN4llvm11IntervalMapINS_9SlotIndexEjLj4ENS_15IntervalMapInfoIS1_EEE10deleteNodeENS_15IntervalMapImpl7NodeRefEj", "llvm::IntervalMap<llvm::SlotIndex, unsigned int, 4u, llvm::IntervalMapInfo<llvm::SlotIndex> >::deleteNode(llvm::IntervalMapImpl::NodeRef, unsigned int)"),
	mu_demangle_test("_ZN4llvm11IntervalMapINS_9SlotIndexEjLj4ENS_15IntervalMapInfoIS1_EEE8iterator6insertES1_S1_j", "llvm::IntervalMap<llvm::SlotIndex, unsigned int, 4u, llvm::IntervalMapInfo<llvm::SlotIndex> >::iterator::insert(llvm::SlotIndex, llvm::SlotIndex, unsigned int)"),
	mu_demangle_test("_ZN4llvm11IntervalMapINS_9SlotIndexEjLj4ENS_15IntervalMapInfoIS1_EEE8iterator10treeInsertES1_S1_j", "llvm::IntervalMap<llvm::SlotIndex, unsigned int, 4u, llvm::IntervalMapInfo<llvm::SlotIndex> >::iterator::treeInsert(llvm::SlotIndex, llvm::SlotIndex, unsigned int)"),
	mu_demangle_test("_ZN4llvm15IntervalMapImpl8LeafNodeINS_9SlotIndexEjLj4ENS_15IntervalMapInfoIS2_EEE10insertFromERjjS2_S2_j", "llvm::IntervalMapImpl::LeafNode<llvm::SlotIndex, unsigned int, 4u, llvm::IntervalMapInfo<llvm::SlotIndex> >::insertFrom(unsigned int&, unsigned int, llvm::SlotIndex, llvm::SlotIndex, unsigned int)"),
	mu_demangle_test("_ZN4llvm11IntervalMapINS_9SlotIndexEjLj4ENS_15IntervalMapInfoIS1_EEE10branchRootEj", "llvm::IntervalMap<llvm::SlotIndex, unsigned int, 4u, llvm::IntervalMapInfo<llvm::SlotIndex> >::branchRoot(unsigned int)"),
	mu_demangle_test("_ZN4llvm11IntervalMapINS_9SlotIndexEjLj4ENS_15IntervalMapInfoIS1_EEE18switchRootToBranchEv", "llvm::IntervalMap<llvm::SlotIndex, unsigned int, 4u, llvm::IntervalMapInfo<llvm::SlotIndex> >::switchRootToBranch()"),
	mu_demangle_test("_ZN4llvm15IntervalMapImpl8LeafNodeINS_9SlotIndexEjLj9ENS_15IntervalMapInfoIS2_EEE10insertFromERjjS2_S2_j", "llvm::IntervalMapImpl::LeafNode<llvm::SlotIndex, unsigned int, 9u, llvm::IntervalMapInfo<llvm::SlotIndex> >::insertFrom(unsigned int&, unsigned int, llvm::SlotIndex, llvm::SlotIndex, unsigned int)"),
	mu_demangle_test("_ZN4llvm11IntervalMapINS_9SlotIndexEjLj4ENS_15IntervalMapInfoIS1_EEE8iterator8overflowINS_15IntervalMapImpl8LeafNodeIS1_jLj9ES3_EEEEbj", "bool llvm::IntervalMap<llvm::SlotIndex, unsigned int, 4u, llvm::IntervalMapInfo<llvm::SlotIndex> >::iterator::overflow<llvm::IntervalMapImpl::LeafNode<llvm::SlotIndex, unsigned int, 9u, llvm::IntervalMapInfo<llvm::SlotIndex> > >(unsigned int)"),
	mu_demangle_test("_ZN4llvm15IntervalMapImpl18adjustSiblingSizesINS0_8LeafNodeINS_9SlotIndexEjLj9ENS_15IntervalMapInfoIS3_EEEEEEvPPT_jPjPKj", "void llvm::IntervalMapImpl::adjustSiblingSizes<llvm::IntervalMapImpl::LeafNode<llvm::SlotIndex, unsigned int, 9u, llvm::IntervalMapInfo<llvm::SlotIndex> > >(llvm::IntervalMapImpl::LeafNode<llvm::SlotIndex, unsigned int, 9u, llvm::IntervalMapInfo<llvm::SlotIndex> >**, unsigned int, unsigned int*, unsigned int const*)"),
	mu_demangle_test("_ZN4llvm11IntervalMapINS_9SlotIndexEjLj4ENS_15IntervalMapInfoIS1_EEE8iterator10insertNodeEjNS_15IntervalMapImpl7NodeRefES1_", "llvm::IntervalMap<llvm::SlotIndex, unsigned int, 4u, llvm::IntervalMapInfo<llvm::SlotIndex> >::iterator::insertNode(unsigned int, llvm::IntervalMapImpl::NodeRef, llvm::SlotIndex)"),
	mu_demangle_test("_ZN4llvm11IntervalMapINS_9SlotIndexEjLj4ENS_15IntervalMapInfoIS1_EEE9splitRootEj", "llvm::IntervalMap<llvm::SlotIndex, unsigned int, 4u, llvm::IntervalMapInfo<llvm::SlotIndex> >::splitRoot(unsigned int)"),
	mu_demangle_test("_ZN4llvm11IntervalMapINS_9SlotIndexEjLj4ENS_15IntervalMapInfoIS1_EEE8iterator8overflowINS_15IntervalMapImpl10BranchNodeIS1_jLj12ES3_EEEEbj", "bool llvm::IntervalMap<llvm::SlotIndex, unsigned int, 4u, llvm::IntervalMapInfo<llvm::SlotIndex> >::iterator::overflow<llvm::IntervalMapImpl::BranchNode<llvm::SlotIndex, unsigned int, 12u, llvm::IntervalMapInfo<llvm::SlotIndex> > >(unsigned int)"),
	mu_demangle_test("_ZN4llvm11IntervalMapINS_9SlotIndexEjLj4ENS_15IntervalMapInfoIS1_EEE7newNodeINS_15IntervalMapImpl10BranchNodeIS1_jLj12ES3_EEEEPT_v", "llvm::IntervalMapImpl::BranchNode<llvm::SlotIndex, unsigned int, 12u, llvm::IntervalMapInfo<llvm::SlotIndex> >* llvm::IntervalMap<llvm::SlotIndex, unsigned int, 4u, llvm::IntervalMapInfo<llvm::SlotIndex> >::newNode<llvm::IntervalMapImpl::BranchNode<llvm::SlotIndex, unsigned int, 12u, llvm::IntervalMapInfo<llvm::SlotIndex> > >()"),
	mu_demangle_test("_ZN4llvm15IntervalMapImpl18adjustSiblingSizesINS0_10BranchNodeINS_9SlotIndexEjLj12ENS_15IntervalMapInfoIS3_EEEEEEvPPT_jPjPKj", "void llvm::IntervalMapImpl::adjustSiblingSizes<llvm::IntervalMapImpl::BranchNode<llvm::SlotIndex, unsigned int, 12u, llvm::IntervalMapInfo<llvm::SlotIndex> > >(llvm::IntervalMapImpl::BranchNode<llvm::SlotIndex, unsigned int, 12u, llvm::IntervalMapInfo<llvm::SlotIndex> >**, unsigned int, unsigned int*, unsigned int const*)"),
	mu_demangle_test("_ZN4llvm11IntervalMapINS_9SlotIndexEjLj4ENS_15IntervalMapInfoIS1_EEE14const_iterator4findES1_", "llvm::IntervalMap<llvm::SlotIndex, unsigned int, 4u, llvm::IntervalMapInfo<llvm::SlotIndex> >::const_iterator::find(llvm::SlotIndex)"),
	mu_demangle_test("_ZN4llvm11IntervalMapINS_9SlotIndexEjLj4ENS_15IntervalMapInfoIS1_EEE14const_iterator8treeFindES1_", "llvm::IntervalMap<llvm::SlotIndex, unsigned int, 4u, llvm::IntervalMapInfo<llvm::SlotIndex> >::const_iterator::treeFind(llvm::SlotIndex)"),
	mu_demangle_test("_ZN4llvm11IntervalMapINS_9SlotIndexEjLj4ENS_15IntervalMapInfoIS1_EEE14const_iterator12pathFillFindES1_", "llvm::IntervalMap<llvm::SlotIndex, unsigned int, 4u, llvm::IntervalMapInfo<llvm::SlotIndex> >::const_iterator::pathFillFind(llvm::SlotIndex)"),
	mu_demangle_test("_ZN4llvm11IntervalMapINS_9SlotIndexEjLj4ENS_15IntervalMapInfoIS1_EEEC2ERNS_18RecyclingAllocatorINS_16BumpPtrAllocatorEcLm192ELm64EEE", "llvm::IntervalMap<llvm::SlotIndex, unsigned int, 4u, llvm::IntervalMapInfo<llvm::SlotIndex> >::IntervalMap(llvm::RecyclingAllocator<llvm::BumpPtrAllocator, char, 192ul, 64ul>&)"),
	mu_demangle_test("_ZN4llvm13LiveIntervals27rewriteInstructionForSpillsERKNS_12LiveIntervalEPKNS_6VNInfoEbNS_9SlotIndexES7_PNS_12MachineInstrES9_S9_jibbbbRNS_10VirtRegMapEPKNS_19TargetRegisterClassERNS_11SmallVectorIiLj4EEEPKNS_15MachineLoopInfoERjjRbSM_RNS_8DenseMapIjjNS_12DenseMapInfoIjEESP_EERSt6vectorIPS1_SaIST_EE", "llvm::LiveIntervals::rewriteInstructionForSpills(llvm::LiveInterval const&, llvm::VNInfo const*, bool, llvm::SlotIndex, llvm::SlotIndex, llvm::MachineInstr*, llvm::MachineInstr*, llvm::MachineInstr*, unsigned int, int, bool, bool, bool, bool, llvm::VirtRegMap&, llvm::TargetRegisterClass const*, llvm::SmallVector<int, 4u>&, llvm::MachineLoopInfo const*, unsigned int&, unsigned int, bool&, bool&, llvm::DenseMap<unsigned int, unsigned int, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<unsigned int> >&, std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> >&)"),
	mu_demangle_test("_ZN4llvm13LiveIntervals28rewriteInstructionsForSpillsERKNS_12LiveIntervalEbRPKNS_9LiveRangeEPNS_12MachineInstrES9_jibbbbRNS_10VirtRegMapEPKNS_19TargetRegisterClassERNS_11SmallVectorIiLj4EEEPKNS_15MachineLoopInfoERNS_9BitVectorERNS_8DenseMapIjSt6vectorINS0_6SRInfoESaISP_EENS_12DenseMapInfoIjEENSS_ISR_EEEESM_SW_RNSN_IjjST_ST_EERSO_IPS1_SaISZ_EE", "llvm::LiveIntervals::rewriteInstructionsForSpills(llvm::LiveInterval const&, bool, llvm::LiveRange const*&, llvm::MachineInstr*, llvm::MachineInstr*, unsigned int, int, bool, bool, bool, bool, llvm::VirtRegMap&, llvm::TargetRegisterClass const*, llvm::SmallVector<int, 4u>&, llvm::MachineLoopInfo const*, llvm::BitVector&, llvm::DenseMap<unsigned int, std::vector<llvm::LiveIntervals::SRInfo, std::allocator<llvm::LiveIntervals::SRInfo> >, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<std::vector<llvm::LiveIntervals::SRInfo, std::allocator<llvm::LiveIntervals::SRInfo> > > >&, llvm::BitVector&, llvm::DenseMap<unsigned int, std::vector<llvm::LiveIntervals::SRInfo, std::allocator<llvm::LiveIntervals::SRInfo> >, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<std::vector<llvm::LiveIntervals::SRInfo, std::allocator<llvm::LiveIntervals::SRInfo> > > >&, llvm::DenseMap<unsigned int, unsigned int, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<unsigned int> >&, std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> >&)"),
	mu_demangle_test("_ZN4llvm13LiveIntervals16alsoFoldARestoreEiNS_9SlotIndexEjRNS_9BitVectorERNS_8DenseMapIjSt6vectorINS0_6SRInfoESaIS6_EENS_12DenseMapInfoIjEENS9_IS8_EEEE", "llvm::LiveIntervals::alsoFoldARestore(int, llvm::SlotIndex, unsigned int, llvm::BitVector&, llvm::DenseMap<unsigned int, std::vector<llvm::LiveIntervals::SRInfo, std::allocator<llvm::LiveIntervals::SRInfo> >, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<std::vector<llvm::LiveIntervals::SRInfo, std::allocator<llvm::LiveIntervals::SRInfo> > > >&)"),
	mu_demangle_test("_ZN4llvm13LiveIntervals16eraseRestoreInfoEiNS_9SlotIndexEjRNS_9BitVectorERNS_8DenseMapIjSt6vectorINS0_6SRInfoESaIS6_EENS_12DenseMapInfoIjEENS9_IS8_EEEE", "llvm::LiveIntervals::eraseRestoreInfo(int, llvm::SlotIndex, unsigned int, llvm::BitVector&, llvm::DenseMap<unsigned int, std::vector<llvm::LiveIntervals::SRInfo, std::allocator<llvm::LiveIntervals::SRInfo> >, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<std::vector<llvm::LiveIntervals::SRInfo, std::allocator<llvm::LiveIntervals::SRInfo> > > >&)"),
	mu_demangle_test("_ZN4llvm13LiveIntervals20handleSpilledImpDefsERKNS_12LiveIntervalERNS_10VirtRegMapEPKNS_19TargetRegisterClassERSt6vectorIPS1_SaISA_EE", "llvm::LiveIntervals::handleSpilledImpDefs(llvm::LiveInterval const&, llvm::VirtRegMap&, llvm::TargetRegisterClass const*, std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> >&)"),
	mu_demangle_test("_ZN4llvm13LiveIntervals21normalizeSpillWeightsERSt6vectorIPNS_12LiveIntervalESaIS3_EE", "llvm::LiveIntervals::normalizeSpillWeights(std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> >&)"),
	mu_demangle_test("_ZSt16__introsort_loopIN9__gnu_cxx17__normal_iteratorIPN12_GLOBAL__N_111RewriteInfoESt6vectorIS3_SaIS3_EEEElNS2_18RewriteInfoCompareEEvT_SA_T0_T1_", "void std::__introsort_loop<__gnu_cxx::__normal_iterator<(anonymous namespace)::RewriteInfo*, std::vector<(anonymous namespace)::RewriteInfo, std::allocator<(anonymous namespace)::RewriteInfo> > >, long, (anonymous namespace)::RewriteInfoCompare>(__gnu_cxx::__normal_iterator<(anonymous namespace)::RewriteInfo*, std::vector<(anonymous namespace)::RewriteInfo, std::allocator<(anonymous namespace)::RewriteInfo> > >, __gnu_cxx::__normal_iterator<(anonymous namespace)::RewriteInfo*, std::vector<(anonymous namespace)::RewriteInfo, std::allocator<(anonymous namespace)::RewriteInfo> > >, long, (anonymous namespace)::RewriteInfoCompare)"),
	mu_demangle_test("_ZSt16__insertion_sortIN9__gnu_cxx17__normal_iteratorIPN12_GLOBAL__N_111RewriteInfoESt6vectorIS3_SaIS3_EEEENS2_18RewriteInfoCompareEEvT_SA_T0_", "void std::__insertion_sort<__gnu_cxx::__normal_iterator<(anonymous namespace)::RewriteInfo*, std::vector<(anonymous namespace)::RewriteInfo, std::allocator<(anonymous namespace)::RewriteInfo> > >, (anonymous namespace)::RewriteInfoCompare>(__gnu_cxx::__normal_iterator<(anonymous namespace)::RewriteInfo*, std::vector<(anonymous namespace)::RewriteInfo, std::allocator<(anonymous namespace)::RewriteInfo> > >, __gnu_cxx::__normal_iterator<(anonymous namespace)::RewriteInfo*, std::vector<(anonymous namespace)::RewriteInfo, std::allocator<(anonymous namespace)::RewriteInfo> > >, (anonymous namespace)::RewriteInfoCompare)"),
	mu_demangle_test("_ZSt13__adjust_heapIN9__gnu_cxx17__normal_iteratorIPN12_GLOBAL__N_111RewriteInfoESt6vectorIS3_SaIS3_EEEElS3_NS2_18RewriteInfoCompareEEvT_T0_SB_T1_T2_", "void std::__adjust_heap<__gnu_cxx::__normal_iterator<(anonymous namespace)::RewriteInfo*, std::vector<(anonymous namespace)::RewriteInfo, std::allocator<(anonymous namespace)::RewriteInfo> > >, long, (anonymous namespace)::RewriteInfo, (anonymous namespace)::RewriteInfoCompare>(__gnu_cxx::__normal_iterator<(anonymous namespace)::RewriteInfo*, std::vector<(anonymous namespace)::RewriteInfo, std::allocator<(anonymous namespace)::RewriteInfo> > >, long, long, (anonymous namespace)::RewriteInfo, (anonymous namespace)::RewriteInfoCompare)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjSt6vectorINS_13LiveIntervals6SRInfoESaIS3_EENS_12DenseMapInfoIjEENS6_IS5_EEE6insertERKSt4pairIjS5_E", "llvm::DenseMap<unsigned int, std::vector<llvm::LiveIntervals::SRInfo, std::allocator<llvm::LiveIntervals::SRInfo> >, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<std::vector<llvm::LiveIntervals::SRInfo, std::allocator<llvm::LiveIntervals::SRInfo> > > >::insert(std::pair<unsigned int, std::vector<llvm::LiveIntervals::SRInfo, std::allocator<llvm::LiveIntervals::SRInfo> > > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjSt6vectorINS_13LiveIntervals6SRInfoESaIS3_EENS_12DenseMapInfoIjEENS6_IS5_EEE16FindAndConstructERKj", "llvm::DenseMap<unsigned int, std::vector<llvm::LiveIntervals::SRInfo, std::allocator<llvm::LiveIntervals::SRInfo> >, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<std::vector<llvm::LiveIntervals::SRInfo, std::allocator<llvm::LiveIntervals::SRInfo> > > >::FindAndConstruct(unsigned int const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjSt6vectorINS_13LiveIntervals6SRInfoESaIS3_EENS_12DenseMapInfoIjEENS6_IS5_EEE16InsertIntoBucketERKjRKS5_PSt4pairIjS5_E", "llvm::DenseMap<unsigned int, std::vector<llvm::LiveIntervals::SRInfo, std::allocator<llvm::LiveIntervals::SRInfo> >, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<std::vector<llvm::LiveIntervals::SRInfo, std::allocator<llvm::LiveIntervals::SRInfo> > > >::InsertIntoBucket(unsigned int const&, std::vector<llvm::LiveIntervals::SRInfo, std::allocator<llvm::LiveIntervals::SRInfo> > const&, std::pair<unsigned int, std::vector<llvm::LiveIntervals::SRInfo, std::allocator<llvm::LiveIntervals::SRInfo> > >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjSt6vectorINS_13LiveIntervals6SRInfoESaIS3_EENS_12DenseMapInfoIjEENS6_IS5_EEE4growEj", "llvm::DenseMap<unsigned int, std::vector<llvm::LiveIntervals::SRInfo, std::allocator<llvm::LiveIntervals::SRInfo> >, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<std::vector<llvm::LiveIntervals::SRInfo, std::allocator<llvm::LiveIntervals::SRInfo> > > >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm13LiveIntervals6SRInfoESaIS2_EEC2ERKS4_", "std::vector<llvm::LiveIntervals::SRInfo, std::allocator<llvm::LiveIntervals::SRInfo> >::vector(std::vector<llvm::LiveIntervals::SRInfo, std::allocator<llvm::LiveIntervals::SRInfo> > const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm13LiveIntervals6SRInfoESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::LiveIntervals::SRInfo, std::allocator<llvm::LiveIntervals::SRInfo> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::LiveIntervals::SRInfo*, std::vector<llvm::LiveIntervals::SRInfo, std::allocator<llvm::LiveIntervals::SRInfo> > >, llvm::LiveIntervals::SRInfo const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_12LiveIntervalENS_12DenseMapInfoIjEENS3_IS2_EEE16shrink_and_clearEv", "llvm::DenseMap<unsigned int, llvm::LiveInterval*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::LiveInterval*> >::shrink_and_clear()"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm12MachineInstrESt4pairIKS2_St6vectorIjSaIjEEESt10_Select1stIS8_ESt4lessIS2_ESaIS8_EE16_M_insert_uniqueERKS8_", "std::_Rb_tree<llvm::MachineInstr*, std::pair<llvm::MachineInstr* const, std::vector<unsigned int, std::allocator<unsigned int> > >, std::_Select1st<std::pair<llvm::MachineInstr* const, std::vector<unsigned int, std::allocator<unsigned int> > > >, std::less<llvm::MachineInstr*>, std::allocator<std::pair<llvm::MachineInstr* const, std::vector<unsigned int, std::allocator<unsigned int> > > > >::_M_insert_unique(std::pair<llvm::MachineInstr* const, std::vector<unsigned int, std::allocator<unsigned int> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm12MachineInstrESt4pairIKS2_St6vectorIjSaIjEEESt10_Select1stIS8_ESt4lessIS2_ESaIS8_EE14_M_create_nodeERKS8_", "std::_Rb_tree<llvm::MachineInstr*, std::pair<llvm::MachineInstr* const, std::vector<unsigned int, std::allocator<unsigned int> > >, std::_Select1st<std::pair<llvm::MachineInstr* const, std::vector<unsigned int, std::allocator<unsigned int> > > >, std::less<llvm::MachineInstr*>, std::allocator<std::pair<llvm::MachineInstr* const, std::vector<unsigned int, std::allocator<unsigned int> > > > >::_M_create_node(std::pair<llvm::MachineInstr* const, std::vector<unsigned int, std::allocator<unsigned int> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm12MachineInstrESt4pairIKS2_St6vectorIjSaIjEEESt10_Select1stIS8_ESt4lessIS2_ESaIS8_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS8_ERKS8_", "std::_Rb_tree<llvm::MachineInstr*, std::pair<llvm::MachineInstr* const, std::vector<unsigned int, std::allocator<unsigned int> > >, std::_Select1st<std::pair<llvm::MachineInstr* const, std::vector<unsigned int, std::allocator<unsigned int> > > >, std::less<llvm::MachineInstr*>, std::allocator<std::pair<llvm::MachineInstr* const, std::vector<unsigned int, std::allocator<unsigned int> > > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::MachineInstr* const, std::vector<unsigned int, std::allocator<unsigned int> > > >, std::pair<llvm::MachineInstr* const, std::vector<unsigned int, std::allocator<unsigned int> > > const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIjbESaIS1_EEC2ERKS3_", "std::vector<std::pair<unsigned int, bool>, std::allocator<std::pair<unsigned int, bool> > >::vector(std::vector<std::pair<unsigned int, bool>, std::allocator<std::pair<unsigned int, bool> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm12MachineInstrESt4pairIKS2_St6vectorIS3_IjbESaIS6_EEESt10_Select1stIS9_ESt4lessIS2_ESaIS9_EE16_M_insert_uniqueERKS9_", "std::_Rb_tree<llvm::MachineInstr*, std::pair<llvm::MachineInstr* const, std::vector<std::pair<unsigned int, bool>, std::allocator<std::pair<unsigned int, bool> > > >, std::_Select1st<std::pair<llvm::MachineInstr* const, std::vector<std::pair<unsigned int, bool>, std::allocator<std::pair<unsigned int, bool> > > > >, std::less<llvm::MachineInstr*>, std::allocator<std::pair<llvm::MachineInstr* const, std::vector<std::pair<unsigned int, bool>, std::allocator<std::pair<unsigned int, bool> > > > > >::_M_insert_unique(std::pair<llvm::MachineInstr* const, std::vector<std::pair<unsigned int, bool>, std::allocator<std::pair<unsigned int, bool> > > > const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIjbESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<std::pair<unsigned int, bool>, std::allocator<std::pair<unsigned int, bool> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<unsigned int, bool>*, std::vector<std::pair<unsigned int, bool>, std::allocator<std::pair<unsigned int, bool> > > >, std::pair<unsigned int, bool> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_12LiveIntervalENS_12DenseMapInfoIjEENS3_IS2_EEE6insertERKSt4pairIjS2_E", "llvm::DenseMap<unsigned int, llvm::LiveInterval*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::LiveInterval*> >::insert(std::pair<unsigned int, llvm::LiveInterval*> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_12LiveIntervalENS_12DenseMapInfoIjEENS3_IS2_EEE16InsertIntoBucketERKjRKS2_PSt4pairIjS2_E", "llvm::DenseMap<unsigned int, llvm::LiveInterval*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::LiveInterval*> >::InsertIntoBucket(unsigned int const&, llvm::LiveInterval* const&, std::pair<unsigned int, llvm::LiveInterval*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_12LiveIntervalENS_12DenseMapInfoIjEENS3_IS2_EEE4growEj", "llvm::DenseMap<unsigned int, llvm::LiveInterval*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::LiveInterval*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt8_Rb_treeIiSt4pairIKiPKN4llvm19TargetRegisterClassEESt10_Select1stIS6_ESt4lessIiESaIS6_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS6_ERKS6_", "std::_Rb_tree<int, std::pair<int const, llvm::TargetRegisterClass const*>, std::_Select1st<std::pair<int const, llvm::TargetRegisterClass const*> >, std::less<int>, std::allocator<std::pair<int const, llvm::TargetRegisterClass const*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<int const, llvm::TargetRegisterClass const*> >, std::pair<int const, llvm::TargetRegisterClass const*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIiSt4pairIKiPKN4llvm19TargetRegisterClassEESt10_Select1stIS6_ESt4lessIiESaIS6_EE16_M_insert_uniqueERKS6_", "std::_Rb_tree<int, std::pair<int const, llvm::TargetRegisterClass const*>, std::_Select1st<std::pair<int const, llvm::TargetRegisterClass const*> >, std::less<int>, std::allocator<std::pair<int const, llvm::TargetRegisterClass const*> > >::_M_insert_unique(std::pair<int const, llvm::TargetRegisterClass const*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIiSt4pairIKiN4llvm12LiveIntervalEESt10_Select1stIS4_ESt4lessIiESaIS4_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS4_ERKS4_", "std::_Rb_tree<int, std::pair<int const, llvm::LiveInterval>, std::_Select1st<std::pair<int const, llvm::LiveInterval> >, std::less<int>, std::allocator<std::pair<int const, llvm::LiveInterval> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<int const, llvm::LiveInterval> >, std::pair<int const, llvm::LiveInterval> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIiSt4pairIKiN4llvm12LiveIntervalEESt10_Select1stIS4_ESt4lessIiESaIS4_EE16_M_insert_uniqueERKS4_", "std::_Rb_tree<int, std::pair<int const, llvm::LiveInterval>, std::_Select1st<std::pair<int const, llvm::LiveInterval> >, std::less<int>, std::allocator<std::pair<int const, llvm::LiveInterval> > >::_M_insert_unique(std::pair<int const, llvm::LiveInterval> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIiSt4pairIKiN4llvm12LiveIntervalEESt10_Select1stIS4_ESt4lessIiESaIS4_EE14_M_create_nodeERKS4_", "std::_Rb_tree<int, std::pair<int const, llvm::LiveInterval>, std::_Select1st<std::pair<int const, llvm::LiveInterval> >, std::less<int>, std::allocator<std::pair<int const, llvm::LiveInterval> > >::_M_create_node(std::pair<int const, llvm::LiveInterval> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIiSt4pairIKiPKN4llvm19TargetRegisterClassEESt10_Select1stIS6_ESt4lessIiESaIS6_EE8_M_eraseEPSt13_Rb_tree_nodeIS6_E", "std::_Rb_tree<int, std::pair<int const, llvm::TargetRegisterClass const*>, std::_Select1st<std::pair<int const, llvm::TargetRegisterClass const*> >, std::less<int>, std::allocator<std::pair<int const, llvm::TargetRegisterClass const*> > >::_M_erase(std::_Rb_tree_node<std::pair<int const, llvm::TargetRegisterClass const*> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIiSt4pairIKiN4llvm12LiveIntervalEESt10_Select1stIS4_ESt4lessIiESaIS4_EE8_M_eraseEPSt13_Rb_tree_nodeIS4_E", "std::_Rb_tree<int, std::pair<int const, llvm::LiveInterval>, std::_Select1st<std::pair<int const, llvm::LiveInterval> >, std::less<int>, std::allocator<std::pair<int const, llvm::LiveInterval> > >::_M_erase(std::_Rb_tree_node<std::pair<int const, llvm::LiveInterval> >*)"),
	mu_demangle_test("_ZN4llvm13LiveVariables23MarkVirtRegAliveInBlockERNS0_7VarInfoEPNS_17MachineBasicBlockES4_RSt6vectorIS4_SaIS4_EE", "llvm::LiveVariables::MarkVirtRegAliveInBlock(llvm::LiveVariables::VarInfo&, llvm::MachineBasicBlock*, llvm::MachineBasicBlock*, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> >&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_12MachineInstrEjNS_12DenseMapInfoIS2_EENS3_IjEEE6insertERKSt4pairIS2_jE", "llvm::DenseMap<llvm::MachineInstr*, unsigned int, llvm::DenseMapInfo<llvm::MachineInstr*>, llvm::DenseMapInfo<unsigned int> >::insert(std::pair<llvm::MachineInstr*, unsigned int> const&)"),
	mu_demangle_test("_ZSt16__introsort_loopIN9__gnu_cxx17__normal_iteratorIPPN4llvm17MachineBasicBlockESt6vectorIS4_SaIS4_EEEElEvT_SA_T0_", "void std::__introsort_loop<__gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > >, long>(__gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > >, __gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > >, long)"),
	mu_demangle_test("_ZSt22__final_insertion_sortIN9__gnu_cxx17__normal_iteratorIPPN4llvm17MachineBasicBlockESt6vectorIS4_SaIS4_EEEEEvT_SA_", "void std::__final_insertion_sort<__gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > > >(__gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > >, __gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > >)"),
	mu_demangle_test("_ZSt13__heap_selectIN9__gnu_cxx17__normal_iteratorIPPN4llvm17MachineBasicBlockESt6vectorIS4_SaIS4_EEEEEvT_SA_SA_", "void std::__heap_select<__gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > > >(__gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > >, __gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > >, __gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > >)"),
	mu_demangle_test("_ZSt9sort_heapIN9__gnu_cxx17__normal_iteratorIPPN4llvm17MachineBasicBlockESt6vectorIS4_SaIS4_EEEEEvT_SA_", "void std::sort_heap<__gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > > >(__gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > >, __gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > >)"),
	mu_demangle_test("_ZSt9make_heapIN9__gnu_cxx17__normal_iteratorIPPN4llvm17MachineBasicBlockESt6vectorIS4_SaIS4_EEEEEvT_SA_", "void std::make_heap<__gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > > >(__gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > >, __gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > >)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_12MachineInstrEjNS_12DenseMapInfoIS2_EENS3_IjEEE16shrink_and_clearEv", "llvm::DenseMap<llvm::MachineInstr*, unsigned int, llvm::DenseMapInfo<llvm::MachineInstr*>, llvm::DenseMapInfo<unsigned int> >::shrink_and_clear()"),
	mu_demangle_test("_ZNSt6vectorIN4llvm13LiveVariables7VarInfoESaIS2_EE6resizeEmS2_", "std::vector<llvm::LiveVariables::VarInfo, std::allocator<llvm::LiveVariables::VarInfo> >::resize(unsigned long, llvm::LiveVariables::VarInfo)"),
	mu_demangle_test("_ZN4llvm6iplistINS_22SparseBitVectorElementILj128EEENS_12ilist_traitsIS2_EEED2Ev", "llvm::iplist<llvm::SparseBitVectorElement<128u>, llvm::ilist_traits<llvm::SparseBitVectorElement<128u> > >::~iplist()"),
	mu_demangle_test("_ZN4llvm5ilistINS_22SparseBitVectorElementILj128EEEE9push_backERKS2_", "llvm::ilist<llvm::SparseBitVectorElement<128u> >::push_back(llvm::SparseBitVectorElement<128u> const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm13LiveVariables7VarInfoESaIS2_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS2_S4_EEmRKS2_", "std::vector<llvm::LiveVariables::VarInfo, std::allocator<llvm::LiveVariables::VarInfo> >::_M_fill_insert(__gnu_cxx::__normal_iterator<llvm::LiveVariables::VarInfo*, std::vector<llvm::LiveVariables::VarInfo, std::allocator<llvm::LiveVariables::VarInfo> > >, unsigned long, llvm::LiveVariables::VarInfo const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm12MachineInstrESaIS2_EEaSERKS4_", "std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> >::operator=(std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> > const&)"),
	mu_demangle_test("_ZN4llvm17MachineBasicBlock15removeSuccessorEN9__gnu_cxx17__normal_iteratorIPPS0_St6vectorIS3_SaIS3_EEEE", "llvm::MachineBasicBlock::removeSuccessor(__gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > >)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockEPNS_11MachineLoopENS_12DenseMapInfoIS2_EENS5_IS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<llvm::MachineBasicBlock*, llvm::MachineLoop*, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::MachineLoop*> >::InsertIntoBucket(llvm::MachineBasicBlock* const&, llvm::MachineLoop* const&, std::pair<llvm::MachineBasicBlock*, llvm::MachineLoop*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockEPNS_11MachineLoopENS_12DenseMapInfoIS2_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::MachineBasicBlock*, llvm::MachineLoop*, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::MachineLoop*> >::grow(unsigned int)"),
	mu_demangle_test("_ZSt6__findIN9__gnu_cxx17__normal_iteratorIPKPN4llvm17MachineBasicBlockESt6vectorIS4_SaIS4_EEEEPKS3_ET_SD_SD_RKT0_St26random_access_iterator_tag", "__gnu_cxx::__normal_iterator<llvm::MachineBasicBlock* const*, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > > std::__find<__gnu_cxx::__normal_iterator<llvm::MachineBasicBlock* const*, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > >, llvm::MachineBasicBlock const*>(__gnu_cxx::__normal_iterator<llvm::MachineBasicBlock* const*, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > >, __gnu_cxx::__normal_iterator<llvm::MachineBasicBlock* const*, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > >, llvm::MachineBasicBlock const* const&, std::random_access_iterator_tag)"),
	mu_demangle_test("_ZSt6__findIN9__gnu_cxx17__normal_iteratorIPKjSt6vectorIjSaIjEEEEjET_S8_S8_RKT0_St26random_access_iterator_tag", "__gnu_cxx::__normal_iterator<unsigned int const*, std::vector<unsigned int, std::allocator<unsigned int> > > std::__find<__gnu_cxx::__normal_iterator<unsigned int const*, std::vector<unsigned int, std::allocator<unsigned int> > >, unsigned int>(__gnu_cxx::__normal_iterator<unsigned int const*, std::vector<unsigned int, std::allocator<unsigned int> > >, __gnu_cxx::__normal_iterator<unsigned int const*, std::vector<unsigned int, std::allocator<unsigned int> > >, unsigned int const&, std::random_access_iterator_tag)"),
	mu_demangle_test("_ZSt6__findIN9__gnu_cxx17__normal_iteratorIPjSt6vectorIjSaIjEEEEjET_S7_S7_RKT0_St26random_access_iterator_tag", "__gnu_cxx::__normal_iterator<unsigned int*, std::vector<unsigned int, std::allocator<unsigned int> > > std::__find<__gnu_cxx::__normal_iterator<unsigned int*, std::vector<unsigned int, std::allocator<unsigned int> > >, unsigned int>(__gnu_cxx::__normal_iterator<unsigned int*, std::vector<unsigned int, std::allocator<unsigned int> > >, __gnu_cxx::__normal_iterator<unsigned int*, std::vector<unsigned int, std::allocator<unsigned int> > >, unsigned int const&, std::random_access_iterator_tag)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm15DomTreeNodeBaseINS0_17MachineBasicBlockEEESaIS4_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS4_S6_EERKS4_", "std::vector<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, std::allocator<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>**, std::vector<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, std::allocator<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*> > >, llvm::DomTreeNodeBase<llvm::MachineBasicBlock>* const&)"),
	mu_demangle_test("_ZSt6__findIN9__gnu_cxx17__normal_iteratorIPPN4llvm15DomTreeNodeBaseINS2_17MachineBasicBlockEEESt6vectorIS6_SaIS6_EEEES6_ET_SC_SC_RKT0_St26random_access_iterator_tag", "__gnu_cxx::__normal_iterator<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>**, std::vector<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, std::allocator<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*> > > std::__find<__gnu_cxx::__normal_iterator<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>**, std::vector<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, std::allocator<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*> > >, llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*>(__gnu_cxx::__normal_iterator<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>**, std::vector<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, std::allocator<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*> > >, __gnu_cxx::__normal_iterator<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>**, std::vector<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, std::allocator<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*> > >, llvm::DomTreeNodeBase<llvm::MachineBasicBlock>* const&, std::random_access_iterator_tag)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockEPNS_15DomTreeNodeBaseIS1_EENS_12DenseMapInfoIS2_EENS6_IS5_EEE16InsertIntoBucketERKS2_RKS5_PSt4pairIS2_S5_E", "llvm::DenseMap<llvm::MachineBasicBlock*, llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*> >::InsertIntoBucket(llvm::MachineBasicBlock* const&, llvm::DomTreeNodeBase<llvm::MachineBasicBlock>* const&, std::pair<llvm::MachineBasicBlock*, llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockEPNS_15DomTreeNodeBaseIS1_EENS_12DenseMapInfoIS2_EENS6_IS5_EEE4growEj", "llvm::DenseMap<llvm::MachineBasicBlock*, llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm23SmallVectorTemplateBaseISt4pairIPNS_15DomTreeNodeBaseINS_17MachineBasicBlockEEEN9__gnu_cxx17__normal_iteratorIPS5_St6vectorIS5_SaIS5_EEEEELb0EE4growEm", "llvm::SmallVectorTemplateBase<std::pair<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, __gnu_cxx::__normal_iterator<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>**, std::vector<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, std::allocator<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*> > > >, false>::grow(unsigned long)"),
	mu_demangle_test("_ZN4llvm6iplistINS_17MachineBasicBlockENS_12ilist_traitsIS1_EEE6insertENS_14ilist_iteratorIS1_EEPS1_", "llvm::iplist<llvm::MachineBasicBlock, llvm::ilist_traits<llvm::MachineBasicBlock> >::insert(llvm::ilist_iterator<llvm::MachineBasicBlock>, llvm::MachineBasicBlock*)"),
	mu_demangle_test("_ZN4llvm20ScopedHashTableScopeIPNS_12MachineInstrEjNS_27MachineInstrExpressionTraitENS_18RecyclingAllocatorINS_16BumpPtrAllocatorENS_18ScopedHashTableValIS2_jEELm32ELm8EEEED2Ev", "llvm::ScopedHashTableScope<llvm::MachineInstr*, unsigned int, llvm::MachineInstrExpressionTrait, llvm::RecyclingAllocator<llvm::BumpPtrAllocator, llvm::ScopedHashTableVal<llvm::MachineInstr*, unsigned int>, 32ul, 8ul> >::~ScopedHashTableScope()"),
	mu_demangle_test("_ZNK4llvm8DenseMapIPNS_12MachineInstrEPNS_18ScopedHashTableValIS2_jEENS_27MachineInstrExpressionTraitENS_12DenseMapInfoIS5_EEE15LookupBucketForERKS2_RPSt4pairIS2_S5_E", "llvm::DenseMap<llvm::MachineInstr*, llvm::ScopedHashTableVal<llvm::MachineInstr*, unsigned int>*, llvm::MachineInstrExpressionTrait, llvm::DenseMapInfo<llvm::ScopedHashTableVal<llvm::MachineInstr*, unsigned int>*> >::LookupBucketFor(llvm::MachineInstr* const&, std::pair<llvm::MachineInstr*, llvm::ScopedHashTableVal<llvm::MachineInstr*, unsigned int>*>*&) const"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_12MachineInstrEPNS_18ScopedHashTableValIS2_jEENS_27MachineInstrExpressionTraitENS_12DenseMapInfoIS5_EEE16InsertIntoBucketERKS2_RKS5_PSt4pairIS2_S5_E", "llvm::DenseMap<llvm::MachineInstr*, llvm::ScopedHashTableVal<llvm::MachineInstr*, unsigned int>*, llvm::MachineInstrExpressionTrait, llvm::DenseMapInfo<llvm::ScopedHashTableVal<llvm::MachineInstr*, unsigned int>*> >::InsertIntoBucket(llvm::MachineInstr* const&, llvm::ScopedHashTableVal<llvm::MachineInstr*, unsigned int>* const&, std::pair<llvm::MachineInstr*, llvm::ScopedHashTableVal<llvm::MachineInstr*, unsigned int>*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_12MachineInstrEPNS_18ScopedHashTableValIS2_jEENS_27MachineInstrExpressionTraitENS_12DenseMapInfoIS5_EEE4growEj", "llvm::DenseMap<llvm::MachineInstr*, llvm::ScopedHashTableVal<llvm::MachineInstr*, unsigned int>*, llvm::MachineInstrExpressionTrait, llvm::DenseMapInfo<llvm::ScopedHashTableVal<llvm::MachineInstr*, unsigned int>*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm15ScopedHashTableIPNS_12MachineInstrEjNS_27MachineInstrExpressionTraitENS_18RecyclingAllocatorINS_16BumpPtrAllocatorENS_18ScopedHashTableValIS2_jEELm32ELm8EEEE6insertERKS2_RKj", "llvm::ScopedHashTable<llvm::MachineInstr*, unsigned int, llvm::MachineInstrExpressionTrait, llvm::RecyclingAllocator<llvm::BumpPtrAllocator, llvm::ScopedHashTableVal<llvm::MachineInstr*, unsigned int>, 32ul, 8ul> >::insert(llvm::MachineInstr* const&, unsigned int const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockEPNS_20ScopedHashTableScopeIPNS_12MachineInstrEjNS_27MachineInstrExpressionTraitENS_18RecyclingAllocatorINS_16BumpPtrAllocatorENS_18ScopedHashTableValIS5_jEELm32ELm8EEEEENS_12DenseMapInfoIS2_EENSE_ISD_EEE16InsertIntoBucketERKS2_RKSD_PSt4pairIS2_SD_E", "llvm::DenseMap<llvm::MachineBasicBlock*, llvm::ScopedHashTableScope<llvm::MachineInstr*, unsigned int, llvm::MachineInstrExpressionTrait, llvm::RecyclingAllocator<llvm::BumpPtrAllocator, llvm::ScopedHashTableVal<llvm::MachineInstr*, unsigned int>, 32ul, 8ul> >*, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::ScopedHashTableScope<llvm::MachineInstr*, unsigned int, llvm::MachineInstrExpressionTrait, llvm::RecyclingAllocator<llvm::BumpPtrAllocator, llvm::ScopedHashTableVal<llvm::MachineInstr*, unsigned int>, 32ul, 8ul> >*> >::InsertIntoBucket(llvm::MachineBasicBlock* const&, llvm::ScopedHashTableScope<llvm::MachineInstr*, unsigned int, llvm::MachineInstrExpressionTrait, llvm::RecyclingAllocator<llvm::BumpPtrAllocator, llvm::ScopedHashTableVal<llvm::MachineInstr*, unsigned int>, 32ul, 8ul> >* const&, std::pair<llvm::MachineBasicBlock*, llvm::ScopedHashTableScope<llvm::MachineInstr*, unsigned int, llvm::MachineInstrExpressionTrait, llvm::RecyclingAllocator<llvm::BumpPtrAllocator, llvm::ScopedHashTableVal<llvm::MachineInstr*, unsigned int>, 32ul, 8ul> >*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockEPNS_20ScopedHashTableScopeIPNS_12MachineInstrEjNS_27MachineInstrExpressionTraitENS_18RecyclingAllocatorINS_16BumpPtrAllocatorENS_18ScopedHashTableValIS5_jEELm32ELm8EEEEENS_12DenseMapInfoIS2_EENSE_ISD_EEE4growEj", "llvm::DenseMap<llvm::MachineBasicBlock*, llvm::ScopedHashTableScope<llvm::MachineInstr*, unsigned int, llvm::MachineInstrExpressionTrait, llvm::RecyclingAllocator<llvm::BumpPtrAllocator, llvm::ScopedHashTableVal<llvm::MachineInstr*, unsigned int>, 32ul, 8ul> >*, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::ScopedHashTableScope<llvm::MachineInstr*, unsigned int, llvm::MachineInstrExpressionTrait, llvm::RecyclingAllocator<llvm::BumpPtrAllocator, llvm::ScopedHashTableVal<llvm::MachineInstr*, unsigned int>, 32ul, 8ul> >*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_15DomTreeNodeBaseINS_17MachineBasicBlockEEES4_NS_12DenseMapInfoIS4_EES6_E16InsertIntoBucketERKS4_S9_PSt4pairIS4_S4_E", "llvm::DenseMap<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, llvm::DenseMapInfo<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*>, llvm::DenseMapInfo<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*> >::InsertIntoBucket(llvm::DomTreeNodeBase<llvm::MachineBasicBlock>* const&, llvm::DomTreeNodeBase<llvm::MachineBasicBlock>* const&, std::pair<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_15DomTreeNodeBaseINS_17MachineBasicBlockEEES4_NS_12DenseMapInfoIS4_EES6_E4growEj", "llvm::DenseMap<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, llvm::DenseMapInfo<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*>, llvm::DenseMapInfo<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_15DomTreeNodeBaseINS_17MachineBasicBlockEEEjNS_12DenseMapInfoIS4_EENS5_IjEEE16InsertIntoBucketERKS4_RKjPSt4pairIS4_jE", "llvm::DenseMap<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, unsigned int, llvm::DenseMapInfo<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(llvm::DomTreeNodeBase<llvm::MachineBasicBlock>* const&, unsigned int const&, std::pair<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_15DomTreeNodeBaseINS_17MachineBasicBlockEEEjNS_12DenseMapInfoIS4_EENS5_IjEEE4growEj", "llvm::DenseMap<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, unsigned int, llvm::DenseMapInfo<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockEPNS_20ScopedHashTableScopeIPNS_12MachineInstrEjNS_27MachineInstrExpressionTraitENS_18RecyclingAllocatorINS_16BumpPtrAllocatorENS_18ScopedHashTableValIS5_jEELm32ELm8EEEEENS_12DenseMapInfoIS2_EENSE_ISD_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::MachineBasicBlock*, llvm::ScopedHashTableScope<llvm::MachineInstr*, unsigned int, llvm::MachineInstrExpressionTrait, llvm::RecyclingAllocator<llvm::BumpPtrAllocator, llvm::ScopedHashTableVal<llvm::MachineInstr*, unsigned int>, 32ul, 8ul> >*, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::ScopedHashTableScope<llvm::MachineInstr*, unsigned int, llvm::MachineInstrExpressionTrait, llvm::RecyclingAllocator<llvm::BumpPtrAllocator, llvm::ScopedHashTableVal<llvm::MachineInstr*, unsigned int>, 32ul, 8ul> >*> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm15ScopedHashTableIPNS_12MachineInstrEjNS_27MachineInstrExpressionTraitENS_18RecyclingAllocatorINS_16BumpPtrAllocatorENS_18ScopedHashTableValIS2_jEELm32ELm8EEEED2Ev", "llvm::ScopedHashTable<llvm::MachineInstr*, unsigned int, llvm::MachineInstrExpressionTrait, llvm::RecyclingAllocator<llvm::BumpPtrAllocator, llvm::ScopedHashTableVal<llvm::MachineInstr*, unsigned int>, 32ul, 8ul> >::~ScopedHashTable()"),
	mu_demangle_test("_ZN4llvm17DominatorTreeBaseINS_17MachineBasicBlockEE5SplitINS_7InverseIPS1_EENS_11GraphTraitsIS6_EEEEvRNS0_INT0_8NodeTypeEEEPSA_", "void llvm::DominatorTreeBase<llvm::MachineBasicBlock>::Split<llvm::Inverse<llvm::MachineBasicBlock*>, llvm::GraphTraits<llvm::Inverse<llvm::MachineBasicBlock*> > >(llvm::DominatorTreeBase<llvm::GraphTraits<llvm::Inverse<llvm::MachineBasicBlock*> >::NodeType>&, llvm::GraphTraits<llvm::Inverse<llvm::MachineBasicBlock*> >::NodeType*)"),
	mu_demangle_test("_ZN4llvm17DominatorTreeBaseINS_17MachineBasicBlockEE5SplitIPS1_NS_11GraphTraitsIS4_EEEEvRNS0_INT0_8NodeTypeEEEPS8_", "void llvm::DominatorTreeBase<llvm::MachineBasicBlock>::Split<llvm::MachineBasicBlock*, llvm::GraphTraits<llvm::MachineBasicBlock*> >(llvm::DominatorTreeBase<llvm::GraphTraits<llvm::MachineBasicBlock*>::NodeType>&, llvm::GraphTraits<llvm::MachineBasicBlock*>::NodeType*)"),
	mu_demangle_test("_ZN4llvm9CalculateINS_15MachineFunctionENS_7InverseIPNS_17MachineBasicBlockEEEEEvRNS_17DominatorTreeBaseINS_11GraphTraitsIT0_E8NodeTypeEEERT_", "void llvm::Calculate<llvm::MachineFunction, llvm::Inverse<llvm::MachineBasicBlock*> >(llvm::DominatorTreeBase<llvm::GraphTraits<llvm::Inverse<llvm::MachineBasicBlock*> >::NodeType>&, llvm::MachineFunction&)"),
	mu_demangle_test("_ZN4llvm7DFSPassINS_11GraphTraitsINS_7InverseIPNS_17MachineBasicBlockEEEEEEEjRNS_17DominatorTreeBaseINT_8NodeTypeEEEPS9_j", "unsigned int llvm::DFSPass<llvm::GraphTraits<llvm::Inverse<llvm::MachineBasicBlock*> > >(llvm::DominatorTreeBase<llvm::GraphTraits<llvm::Inverse<llvm::MachineBasicBlock*> >::NodeType>&, llvm::GraphTraits<llvm::Inverse<llvm::MachineBasicBlock*> >::NodeType*, unsigned int)"),
	mu_demangle_test("_ZN4llvm4EvalINS_11GraphTraitsINS_7InverseIPNS_17MachineBasicBlockEEEEEEEPNT_8NodeTypeERNS_17DominatorTreeBaseIS8_EES9_j", "llvm::GraphTraits<llvm::Inverse<llvm::MachineBasicBlock*> >::NodeType* llvm::Eval<llvm::GraphTraits<llvm::Inverse<llvm::MachineBasicBlock*> > >(llvm::DominatorTreeBase<llvm::GraphTraits<llvm::Inverse<llvm::MachineBasicBlock*> >::NodeType>&, llvm::GraphTraits<llvm::Inverse<llvm::MachineBasicBlock*> >::NodeType*, unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockENS_17DominatorTreeBaseIS1_E7InfoRecENS_12DenseMapInfoIS2_EENS6_IS5_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::MachineBasicBlock*, llvm::DominatorTreeBase<llvm::MachineBasicBlock>::InfoRec, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::DominatorTreeBase<llvm::MachineBasicBlock>::InfoRec> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm23SmallVectorTemplateBaseISt4pairIPNS_17MachineBasicBlockEN9__gnu_cxx17__normal_iteratorIPS3_St6vectorIS3_SaIS3_EEEEELb0EE4growEm", "llvm::SmallVectorTemplateBase<std::pair<llvm::MachineBasicBlock*, __gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > > >, false>::grow(unsigned long)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockENS_17DominatorTreeBaseIS1_E7InfoRecENS_12DenseMapInfoIS2_EENS6_IS5_EEE16InsertIntoBucketERKS2_RKS5_PSt4pairIS2_S5_E", "llvm::DenseMap<llvm::MachineBasicBlock*, llvm::DominatorTreeBase<llvm::MachineBasicBlock>::InfoRec, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::DominatorTreeBase<llvm::MachineBasicBlock>::InfoRec> >::InsertIntoBucket(llvm::MachineBasicBlock* const&, llvm::DominatorTreeBase<llvm::MachineBasicBlock>::InfoRec const&, std::pair<llvm::MachineBasicBlock*, llvm::DominatorTreeBase<llvm::MachineBasicBlock>::InfoRec>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockENS_17DominatorTreeBaseIS1_E7InfoRecENS_12DenseMapInfoIS2_EENS6_IS5_EEE4growEj", "llvm::DenseMap<llvm::MachineBasicBlock*, llvm::DominatorTreeBase<llvm::MachineBasicBlock>::InfoRec, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::DominatorTreeBase<llvm::MachineBasicBlock>::InfoRec> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm7DFSPassINS_11GraphTraitsIPNS_17MachineBasicBlockEEEEEjRNS_17DominatorTreeBaseINT_8NodeTypeEEEPS7_j", "unsigned int llvm::DFSPass<llvm::GraphTraits<llvm::MachineBasicBlock*> >(llvm::DominatorTreeBase<llvm::GraphTraits<llvm::MachineBasicBlock*>::NodeType>&, llvm::GraphTraits<llvm::MachineBasicBlock*>::NodeType*, unsigned int)"),
	mu_demangle_test("_ZN4llvm4EvalINS_11GraphTraitsIPNS_17MachineBasicBlockEEEEEPNT_8NodeTypeERNS_17DominatorTreeBaseIS6_EES7_j", "llvm::GraphTraits<llvm::MachineBasicBlock*>::NodeType* llvm::Eval<llvm::GraphTraits<llvm::MachineBasicBlock*> >(llvm::DominatorTreeBase<llvm::GraphTraits<llvm::MachineBasicBlock*>::NodeType>&, llvm::GraphTraits<llvm::MachineBasicBlock*>::NodeType*, unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockES2_NS_12DenseMapInfoIS2_EES4_E16InsertIntoBucketERKS2_S7_PSt4pairIS2_S2_E", "llvm::DenseMap<llvm::MachineBasicBlock*, llvm::MachineBasicBlock*, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::MachineBasicBlock*> >::InsertIntoBucket(llvm::MachineBasicBlock* const&, llvm::MachineBasicBlock* const&, std::pair<llvm::MachineBasicBlock*, llvm::MachineBasicBlock*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockES2_NS_12DenseMapInfoIS2_EES4_E4growEj", "llvm::DenseMap<llvm::MachineBasicBlock*, llvm::MachineBasicBlock*, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::MachineBasicBlock*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockES2_NS_12DenseMapInfoIS2_EES4_E16shrink_and_clearEv", "llvm::DenseMap<llvm::MachineBasicBlock*, llvm::MachineBasicBlock*, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::MachineBasicBlock*> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockEPNS_15DomTreeNodeBaseIS1_EENS_12DenseMapInfoIS2_EENS6_IS5_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::MachineBasicBlock*, llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm20MachineJumpTableInfo20createJumpTableIndexERKSt6vectorIPNS_17MachineBasicBlockESaIS3_EE", "llvm::MachineJumpTableInfo::createJumpTableIndex(std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > const&)"),
	mu_demangle_test("_ZN4llvm6iplistINS_17MachineBasicBlockENS_12ilist_traitsIS1_EEE5clearEv", "llvm::iplist<llvm::MachineBasicBlock, llvm::ilist_traits<llvm::MachineBasicBlock> >::clear()"),
	mu_demangle_test("_ZNSt6vectorIN4llvm21MachineJumpTableEntryESaIS1_EE9push_backERKS1_", "std::vector<llvm::MachineJumpTableEntry, std::allocator<llvm::MachineJumpTableEntry> >::push_back(llvm::MachineJumpTableEntry const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm24MachineConstantPoolEntryESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<llvm::MachineConstantPoolEntry, std::allocator<llvm::MachineConstantPoolEntry> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::MachineConstantPoolEntry*, std::vector<llvm::MachineConstantPoolEntry, std::allocator<llvm::MachineConstantPoolEntry> > >, llvm::MachineConstantPoolEntry const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm21MachineJumpTableEntryESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<llvm::MachineJumpTableEntry, std::allocator<llvm::MachineJumpTableEntry> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::MachineJumpTableEntry*, std::vector<llvm::MachineJumpTableEntry, std::allocator<llvm::MachineJumpTableEntry> > >, llvm::MachineJumpTableEntry const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm17MachineBasicBlockESaIS2_EEaSERKS4_", "std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> >::operator=(std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm17MachineBasicBlockESaIS2_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS2_S4_EEmRKS2_", "std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> >::_M_fill_insert(__gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > >, unsigned long, llvm::MachineBasicBlock* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjNS_8DebugLocENS_12DenseMapInfoIjEENS2_IS1_EEE16InsertIntoBucketERKjRKS1_PSt4pairIjS1_E", "llvm::DenseMap<unsigned int, llvm::DebugLoc, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::DebugLoc> >::InsertIntoBucket(unsigned int const&, llvm::DebugLoc const&, std::pair<unsigned int, llvm::DebugLoc>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjNS_8DebugLocENS_12DenseMapInfoIjEENS2_IS1_EEE4growEj", "llvm::DenseMap<unsigned int, llvm::DebugLoc, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::DebugLoc> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIjjESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<std::pair<unsigned int, unsigned int>, std::allocator<std::pair<unsigned int, unsigned int> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<unsigned int, unsigned int>*, std::vector<std::pair<unsigned int, unsigned int>, std::allocator<std::pair<unsigned int, unsigned int> > > >, std::pair<unsigned int, unsigned int> const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm14MachineOperandESaIS1_EE7reserveEm", "std::vector<llvm::MachineOperand, std::allocator<llvm::MachineOperand> >::reserve(unsigned long)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjSt6vectorIPKNS_12MachineInstrESaIS4_EENS_12DenseMapInfoIjEENS7_IS6_EEE5clearEv", "llvm::DenseMap<unsigned int, std::vector<llvm::MachineInstr const*, std::allocator<llvm::MachineInstr const*> >, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<std::vector<llvm::MachineInstr const*, std::allocator<llvm::MachineInstr const*> > > >::clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIjSt6vectorIPKNS_12MachineInstrESaIS4_EENS_12DenseMapInfoIjEENS7_IS6_EEE16shrink_and_clearEv", "llvm::DenseMap<unsigned int, std::vector<llvm::MachineInstr const*, std::allocator<llvm::MachineInstr const*> >, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<std::vector<llvm::MachineInstr const*, std::allocator<llvm::MachineInstr const*> > > >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIjSt6vectorIPKNS_12MachineInstrESaIS4_EENS_12DenseMapInfoIjEENS7_IS6_EEE6insertERKSt4pairIjS6_E", "llvm::DenseMap<unsigned int, std::vector<llvm::MachineInstr const*, std::allocator<llvm::MachineInstr const*> >, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<std::vector<llvm::MachineInstr const*, std::allocator<llvm::MachineInstr const*> > > >::insert(std::pair<unsigned int, std::vector<llvm::MachineInstr const*, std::allocator<llvm::MachineInstr const*> > > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjSt6vectorIPKNS_12MachineInstrESaIS4_EENS_12DenseMapInfoIjEENS7_IS6_EEE16InsertIntoBucketERKjRKS6_PSt4pairIjS6_E", "llvm::DenseMap<unsigned int, std::vector<llvm::MachineInstr const*, std::allocator<llvm::MachineInstr const*> >, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<std::vector<llvm::MachineInstr const*, std::allocator<llvm::MachineInstr const*> > > >::InsertIntoBucket(unsigned int const&, std::vector<llvm::MachineInstr const*, std::allocator<llvm::MachineInstr const*> > const&, std::pair<unsigned int, std::vector<llvm::MachineInstr const*, std::allocator<llvm::MachineInstr const*> > >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjSt6vectorIPKNS_12MachineInstrESaIS4_EENS_12DenseMapInfoIjEENS7_IS6_EEE4growEj", "llvm::DenseMap<unsigned int, std::vector<llvm::MachineInstr const*, std::allocator<llvm::MachineInstr const*> >, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<std::vector<llvm::MachineInstr const*, std::allocator<llvm::MachineInstr const*> > > >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIPKN4llvm12MachineInstrESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<llvm::MachineInstr const*, std::allocator<llvm::MachineInstr const*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::MachineInstr const**, std::vector<llvm::MachineInstr const*, std::allocator<llvm::MachineInstr const*> > >, llvm::MachineInstr const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjiNS_12DenseMapInfoIjEENS1_IiEEE6insertERKSt4pairIjiE", "llvm::DenseMap<unsigned int, int, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<int> >::insert(std::pair<unsigned int, int> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjiNS_12DenseMapInfoIjEENS1_IiEEE16InsertIntoBucketERKjRKiPSt4pairIjiE", "llvm::DenseMap<unsigned int, int, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<int> >::InsertIntoBucket(unsigned int const&, int const&, std::pair<unsigned int, int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjiNS_12DenseMapInfoIjEENS1_IiEEE4growEj", "llvm::DenseMap<unsigned int, int, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<int> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt8_Rb_treeIiiSt9_IdentityIiESt4lessIiESaIiEE8_M_eraseEPSt13_Rb_tree_nodeIiE", "std::_Rb_tree<int, int, std::_Identity<int>, std::less<int>, std::allocator<int> >::_M_erase(std::_Rb_tree_node<int>*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIiiSt9_IdentityIiESt4lessIiESaIiEE16_M_insert_uniqueERKi", "std::_Rb_tree<int, int, std::_Identity<int>, std::less<int>, std::allocator<int> >::_M_insert_unique(int const&)"),
	mu_demangle_test("_ZN4llvm8LoopBaseINS_17MachineBasicBlockENS_11MachineLoopEE15removeChildLoopEN9__gnu_cxx17__normal_iteratorIPKPS2_St6vectorIS6_SaIS6_EEEE", "llvm::LoopBase<llvm::MachineBasicBlock, llvm::MachineLoop>::removeChildLoop(__gnu_cxx::__normal_iterator<llvm::MachineLoop* const*, std::vector<llvm::MachineLoop*, std::allocator<llvm::MachineLoop*> > >)"),
	mu_demangle_test("_ZN4llvm12LoopInfoBaseINS_17MachineBasicBlockENS_11MachineLoopEE10removeLoopEN9__gnu_cxx17__normal_iteratorIPKPS2_St6vectorIS6_SaIS6_EEEE", "llvm::LoopInfoBase<llvm::MachineBasicBlock, llvm::MachineLoop>::removeLoop(__gnu_cxx::__normal_iterator<llvm::MachineLoop* const*, std::vector<llvm::MachineLoop*, std::allocator<llvm::MachineLoop*> > >)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockEPNS_11MachineLoopENS_12DenseMapInfoIS2_EENS5_IS4_EEE6insertERKSt4pairIS2_S4_E", "llvm::DenseMap<llvm::MachineBasicBlock*, llvm::MachineLoop*, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::MachineLoop*> >::insert(std::pair<llvm::MachineBasicBlock*, llvm::MachineLoop*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm17MachineBasicBlockESt4pairIKS2_PNS0_11MachineLoopEESt10_Select1stIS7_ESt4lessIS2_ESaIS7_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS7_ERKS7_", "std::_Rb_tree<llvm::MachineBasicBlock*, std::pair<llvm::MachineBasicBlock* const, llvm::MachineLoop*>, std::_Select1st<std::pair<llvm::MachineBasicBlock* const, llvm::MachineLoop*> >, std::less<llvm::MachineBasicBlock*>, std::allocator<std::pair<llvm::MachineBasicBlock* const, llvm::MachineLoop*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::MachineBasicBlock* const, llvm::MachineLoop*> >, std::pair<llvm::MachineBasicBlock* const, llvm::MachineLoop*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm17MachineBasicBlockESt4pairIKS2_PNS0_11MachineLoopEESt10_Select1stIS7_ESt4lessIS2_ESaIS7_EE16_M_insert_uniqueERKS7_", "std::_Rb_tree<llvm::MachineBasicBlock*, std::pair<llvm::MachineBasicBlock* const, llvm::MachineLoop*>, std::_Select1st<std::pair<llvm::MachineBasicBlock* const, llvm::MachineLoop*> >, std::less<llvm::MachineBasicBlock*>, std::allocator<std::pair<llvm::MachineBasicBlock* const, llvm::MachineLoop*> > >::_M_insert_unique(std::pair<llvm::MachineBasicBlock* const, llvm::MachineLoop*> const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm17MachineBasicBlockESaIS2_EE15_M_range_insertIN9__gnu_cxx17__normal_iteratorIPS2_S4_EEEEvS9_T_SA_St20forward_iterator_tag", "void std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> >::_M_range_insert<__gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > > >(__gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > >, __gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > >, __gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > >, std::forward_iterator_tag)"),
	mu_demangle_test("_ZN4llvm11df_iteratorIPNS_17MachineBasicBlockENS_11SmallPtrSetIS2_Lj8EEELb0ENS_11GraphTraitsIS2_EEE6toNextEv", "llvm::df_iterator<llvm::MachineBasicBlock*, llvm::SmallPtrSet<llvm::MachineBasicBlock*, 8u>, false, llvm::GraphTraits<llvm::MachineBasicBlock*> >::toNext()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockEPNS_11MachineLoopENS_12DenseMapInfoIS2_EENS5_IS4_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::MachineBasicBlock*, llvm::MachineLoop*, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::MachineLoop*> >::shrink_and_clear()"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm11MachineLoopESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::MachineLoop*, std::allocator<llvm::MachineLoop*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::MachineLoop**, std::vector<llvm::MachineLoop*, std::allocator<llvm::MachineLoop*> > >, llvm::MachineLoop* const&)"),
	mu_demangle_test("_ZSt6__findIN9__gnu_cxx17__normal_iteratorIPPN4llvm11MachineLoopESt6vectorIS4_SaIS4_EEEES4_ET_SA_SA_RKT0_St26random_access_iterator_tag", "__gnu_cxx::__normal_iterator<llvm::MachineLoop**, std::vector<llvm::MachineLoop*, std::allocator<llvm::MachineLoop*> > > std::__find<__gnu_cxx::__normal_iterator<llvm::MachineLoop**, std::vector<llvm::MachineLoop*, std::allocator<llvm::MachineLoop*> > >, llvm::MachineLoop*>(__gnu_cxx::__normal_iterator<llvm::MachineLoop**, std::vector<llvm::MachineLoop*, std::allocator<llvm::MachineLoop*> > >, __gnu_cxx::__normal_iterator<llvm::MachineLoop**, std::vector<llvm::MachineLoop*, std::allocator<llvm::MachineLoop*> > >, llvm::MachineLoop* const&, std::random_access_iterator_tag)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm17MachineBasicBlockESt4pairIKS2_PNS0_11MachineLoopEESt10_Select1stIS7_ESt4lessIS2_ESaIS7_EE8_M_eraseEPSt13_Rb_tree_nodeIS7_E", "std::_Rb_tree<llvm::MachineBasicBlock*, std::pair<llvm::MachineBasicBlock* const, llvm::MachineLoop*>, std::_Select1st<std::pair<llvm::MachineBasicBlock* const, llvm::MachineLoop*> >, std::less<llvm::MachineBasicBlock*>, std::allocator<std::pair<llvm::MachineBasicBlock* const, llvm::MachineLoop*> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::MachineBasicBlock* const, llvm::MachineLoop*> >*)"),
	mu_demangle_test("_ZN4llvm15MMIAddrLabelMap29takeDeletedSymbolsForFunctionEPNS_8FunctionERSt6vectorIPNS_8MCSymbolESaIS5_EE", "llvm::MMIAddrLabelMap::takeDeletedSymbolsForFunction(llvm::Function*, std::vector<llvm::MCSymbol*, std::allocator<llvm::MCSymbol*> >&)"),
	mu_demangle_test("_ZN4llvm17MachineModuleInfo29takeDeletedSymbolsForFunctionEPKNS_8FunctionERSt6vectorIPNS_8MCSymbolESaIS6_EE", "llvm::MachineModuleInfo::takeDeletedSymbolsForFunction(llvm::Function const*, std::vector<llvm::MCSymbol*, std::allocator<llvm::MCSymbol*> >&)"),
	mu_demangle_test("_ZN4llvm17MachineModuleInfo16addCatchTypeInfoEPNS_17MachineBasicBlockERSt6vectorIPKNS_14GlobalVariableESaIS6_EE", "llvm::MachineModuleInfo::addCatchTypeInfo(llvm::MachineBasicBlock*, std::vector<llvm::GlobalVariable const*, std::allocator<llvm::GlobalVariable const*> >&)"),
	mu_demangle_test("_ZN4llvm17MachineModuleInfo17addFilterTypeInfoEPNS_17MachineBasicBlockERSt6vectorIPKNS_14GlobalVariableESaIS6_EE", "llvm::MachineModuleInfo::addFilterTypeInfo(llvm::MachineBasicBlock*, std::vector<llvm::GlobalVariable const*, std::allocator<llvm::GlobalVariable const*> >&)"),
	mu_demangle_test("_ZN4llvm17MachineModuleInfo14getFilterIDForERSt6vectorIjSaIjEE", "llvm::MachineModuleInfo::getFilterIDFor(std::vector<unsigned int, std::allocator<unsigned int> >&)"),
	mu_demangle_test("_ZN4llvm17MachineModuleInfo15TidyLandingPadsEPNS_8DenseMapIPNS_8MCSymbolEmNS_12DenseMapInfoIS3_EENS4_ImEEEE", "llvm::MachineModuleInfo::TidyLandingPads(llvm::DenseMap<llvm::MCSymbol*, unsigned long, llvm::DenseMapInfo<llvm::MCSymbol*>, llvm::DenseMapInfo<unsigned long> >*)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm8MCSymbolESaIS2_EEaSERKS4_", "std::vector<llvm::MCSymbol*, std::allocator<llvm::MCSymbol*> >::operator=(std::vector<llvm::MCSymbol*, std::allocator<llvm::MCSymbol*> > const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm14LandingPadInfoESaIS1_EE5clearEv", "std::vector<llvm::LandingPadInfo, std::allocator<llvm::LandingPadInfo> >::clear()"),
	mu_demangle_test("_ZNSt6vectorIN4llvm14LandingPadInfoESaIS1_EE5eraseEN9__gnu_cxx17__normal_iteratorIPS1_S3_EE", "std::vector<llvm::LandingPadInfo, std::allocator<llvm::LandingPadInfo> >::erase(__gnu_cxx::__normal_iterator<llvm::LandingPadInfo*, std::vector<llvm::LandingPadInfo, std::allocator<llvm::LandingPadInfo> > >)"),
	mu_demangle_test("_ZNSt6vectorIPKN4llvm14GlobalVariableESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<llvm::GlobalVariable const*, std::allocator<llvm::GlobalVariable const*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::GlobalVariable const**, std::vector<llvm::GlobalVariable const*, std::allocator<llvm::GlobalVariable const*> > >, llvm::GlobalVariable const* const&)"),
	mu_demangle_test("_ZNSt6vectorIiSaIiEEaSERKS1_", "std::vector<int, std::allocator<int> >::operator=(std::vector<int, std::allocator<int> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_8MCSymbolEmNS_12DenseMapInfoIS2_EENS3_ImEEE16InsertIntoBucketERKS2_RKmPSt4pairIS2_mE", "llvm::DenseMap<llvm::MCSymbol*, unsigned long, llvm::DenseMapInfo<llvm::MCSymbol*>, llvm::DenseMapInfo<unsigned long> >::InsertIntoBucket(llvm::MCSymbol* const&, unsigned long const&, std::pair<llvm::MCSymbol*, unsigned long>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_8MCSymbolEmNS_12DenseMapInfoIS2_EENS3_ImEEE4growEj", "llvm::DenseMap<llvm::MCSymbol*, unsigned long, llvm::DenseMapInfo<llvm::MCSymbol*>, llvm::DenseMapInfo<unsigned long> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIiSaIiEE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPiS1_EERKi", "std::vector<int, std::allocator<int> >::_M_insert_aux(__gnu_cxx::__normal_iterator<int*, std::vector<int, std::allocator<int> > >, int const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm14LandingPadInfoESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<llvm::LandingPadInfo, std::allocator<llvm::LandingPadInfo> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::LandingPadInfo*, std::vector<llvm::LandingPadInfo, std::allocator<llvm::LandingPadInfo> > >, llvm::LandingPadInfo const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_8MCSymbolEjNS_12DenseMapInfoIS2_EENS3_IjEEE16shrink_and_clearEv", "llvm::DenseMap<llvm::MCSymbol*, unsigned int, llvm::DenseMapInfo<llvm::MCSymbol*>, llvm::DenseMapInfo<unsigned int> >::shrink_and_clear()"),
	mu_demangle_test("_ZNSt6vectorIPKN4llvm8FunctionESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<llvm::Function const*, std::allocator<llvm::Function const*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::Function const**, std::vector<llvm::Function const*, std::allocator<llvm::Function const*> > >, llvm::Function const* const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm14LandingPadInfoESaIS1_EED2Ev", "std::vector<llvm::LandingPadInfo, std::allocator<llvm::LandingPadInfo> >::~vector()"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm8MCSymbolESaIS2_EE15_M_range_insertIN9__gnu_cxx17__normal_iteratorIPS2_S4_EEEEvS9_T_SA_St20forward_iterator_tag", "void std::vector<llvm::MCSymbol*, std::allocator<llvm::MCSymbol*> >::_M_range_insert<__gnu_cxx::__normal_iterator<llvm::MCSymbol**, std::vector<llvm::MCSymbol*, std::allocator<llvm::MCSymbol*> > > >(__gnu_cxx::__normal_iterator<llvm::MCSymbol**, std::vector<llvm::MCSymbol*, std::allocator<llvm::MCSymbol*> > >, __gnu_cxx::__normal_iterator<llvm::MCSymbol**, std::vector<llvm::MCSymbol*, std::allocator<llvm::MCSymbol*> > >, __gnu_cxx::__normal_iterator<llvm::MCSymbol**, std::vector<llvm::MCSymbol*, std::allocator<llvm::MCSymbol*> > >, std::forward_iterator_tag)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_11AssertingVHINS_8FunctionEEESt6vectorIPNS_8MCSymbolESaIS6_EENS_12DenseMapInfoIS3_EENS9_IS8_EEE16FindAndConstructERKS3_", "llvm::DenseMap<llvm::AssertingVH<llvm::Function>, std::vector<llvm::MCSymbol*, std::allocator<llvm::MCSymbol*> >, llvm::DenseMapInfo<llvm::AssertingVH<llvm::Function> >, llvm::DenseMapInfo<std::vector<llvm::MCSymbol*, std::allocator<llvm::MCSymbol*> > > >::FindAndConstruct(llvm::AssertingVH<llvm::Function> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_11AssertingVHINS_8FunctionEEESt6vectorIPNS_8MCSymbolESaIS6_EENS_12DenseMapInfoIS3_EENS9_IS8_EEE16InsertIntoBucketERKS3_RKS8_PSt4pairIS3_S8_E", "llvm::DenseMap<llvm::AssertingVH<llvm::Function>, std::vector<llvm::MCSymbol*, std::allocator<llvm::MCSymbol*> >, llvm::DenseMapInfo<llvm::AssertingVH<llvm::Function> >, llvm::DenseMapInfo<std::vector<llvm::MCSymbol*, std::allocator<llvm::MCSymbol*> > > >::InsertIntoBucket(llvm::AssertingVH<llvm::Function> const&, std::vector<llvm::MCSymbol*, std::allocator<llvm::MCSymbol*> > const&, std::pair<llvm::AssertingVH<llvm::Function>, std::vector<llvm::MCSymbol*, std::allocator<llvm::MCSymbol*> > >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_11AssertingVHINS_8FunctionEEESt6vectorIPNS_8MCSymbolESaIS6_EENS_12DenseMapInfoIS3_EENS9_IS8_EEE4growEj", "llvm::DenseMap<llvm::AssertingVH<llvm::Function>, std::vector<llvm::MCSymbol*, std::allocator<llvm::MCSymbol*> >, llvm::DenseMapInfo<llvm::AssertingVH<llvm::Function> >, llvm::DenseMapInfo<std::vector<llvm::MCSymbol*, std::allocator<llvm::MCSymbol*> > > >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm8MCSymbolESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::MCSymbol*, std::allocator<llvm::MCSymbol*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::MCSymbol**, std::vector<llvm::MCSymbol*, std::allocator<llvm::MCSymbol*> > >, llvm::MCSymbol* const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm26MMIAddrLabelMapCallbackPtrESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<llvm::MMIAddrLabelMapCallbackPtr, std::allocator<llvm::MMIAddrLabelMapCallbackPtr> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::MMIAddrLabelMapCallbackPtr*, std::vector<llvm::MMIAddrLabelMapCallbackPtr, std::allocator<llvm::MMIAddrLabelMapCallbackPtr> > >, llvm::MMIAddrLabelMapCallbackPtr const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_11AssertingVHINS_10BasicBlockEEENS_15MMIAddrLabelMap17AddrLabelSymEntryENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PSt4pairIS3_S5_E", "llvm::DenseMap<llvm::AssertingVH<llvm::BasicBlock>, llvm::MMIAddrLabelMap::AddrLabelSymEntry, llvm::DenseMapInfo<llvm::AssertingVH<llvm::BasicBlock> >, llvm::DenseMapInfo<llvm::MMIAddrLabelMap::AddrLabelSymEntry> >::InsertIntoBucket(llvm::AssertingVH<llvm::BasicBlock> const&, llvm::MMIAddrLabelMap::AddrLabelSymEntry const&, std::pair<llvm::AssertingVH<llvm::BasicBlock>, llvm::MMIAddrLabelMap::AddrLabelSymEntry>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_11AssertingVHINS_10BasicBlockEEENS_15MMIAddrLabelMap17AddrLabelSymEntryENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<llvm::AssertingVH<llvm::BasicBlock>, llvm::MMIAddrLabelMap::AddrLabelSymEntry, llvm::DenseMapInfo<llvm::AssertingVH<llvm::BasicBlock> >, llvm::DenseMapInfo<llvm::MMIAddrLabelMap::AddrLabelSymEntry> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm21MachineModuleInfoImpl14GetSortedStubsERKNS_8DenseMapIPNS_8MCSymbolENS_14PointerIntPairIS3_Lj1EbNS_21PointerLikeTypeTraitsIS3_EEEENS_12DenseMapInfoIS3_EENS8_IS7_EEEE", "llvm::MachineModuleInfoImpl::GetSortedStubs(llvm::DenseMap<llvm::MCSymbol*, llvm::PointerIntPair<llvm::MCSymbol*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::MCSymbol*> >, llvm::DenseMapInfo<llvm::MCSymbol*>, llvm::DenseMapInfo<llvm::PointerIntPair<llvm::MCSymbol*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::MCSymbol*> > > > const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPN4llvm8MCSymbolENS1_14PointerIntPairIS3_Lj1EbNS1_21PointerLikeTypeTraitsIS3_EEEEESaIS8_EE19_M_range_initializeINS1_16DenseMapIteratorIS3_S7_NS1_12DenseMapInfoIS3_EENSD_IS7_EELb1EEEEEvT_SH_St20forward_iterator_tag", "void std::vector<std::pair<llvm::MCSymbol*, llvm::PointerIntPair<llvm::MCSymbol*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::MCSymbol*> > >, std::allocator<std::pair<llvm::MCSymbol*, llvm::PointerIntPair<llvm::MCSymbol*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::MCSymbol*> > > > >::_M_range_initialize<llvm::DenseMapIterator<llvm::MCSymbol*, llvm::PointerIntPair<llvm::MCSymbol*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::MCSymbol*> >, llvm::DenseMapInfo<llvm::MCSymbol*>, llvm::DenseMapInfo<llvm::PointerIntPair<llvm::MCSymbol*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::MCSymbol*> > >, true> >(llvm::DenseMapIterator<llvm::MCSymbol*, llvm::PointerIntPair<llvm::MCSymbol*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::MCSymbol*> >, llvm::DenseMapInfo<llvm::MCSymbol*>, llvm::DenseMapInfo<llvm::PointerIntPair<llvm::MCSymbol*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::MCSymbol*> > >, true>, llvm::DenseMapIterator<llvm::MCSymbol*, llvm::PointerIntPair<llvm::MCSymbol*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::MCSymbol*> >, llvm::DenseMapInfo<llvm::MCSymbol*>, llvm::DenseMapInfo<llvm::PointerIntPair<llvm::MCSymbol*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::MCSymbol*> > >, true>, std::forward_iterator_tag)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIjjESaIS1_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS1_S3_EEmRKS1_", "std::vector<std::pair<unsigned int, unsigned int>, std::allocator<std::pair<unsigned int, unsigned int> > >::_M_fill_insert(__gnu_cxx::__normal_iterator<std::pair<unsigned int, unsigned int>*, std::vector<std::pair<unsigned int, unsigned int>, std::allocator<std::pair<unsigned int, unsigned int> > > >, unsigned long, std::pair<unsigned int, unsigned int> const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPKN4llvm19TargetRegisterClassEPNS1_14MachineOperandEESaIS7_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS7_S9_EEmRKS7_", "std::vector<std::pair<llvm::TargetRegisterClass const*, llvm::MachineOperand*>, std::allocator<std::pair<llvm::TargetRegisterClass const*, llvm::MachineOperand*> > >::_M_fill_insert(__gnu_cxx::__normal_iterator<std::pair<llvm::TargetRegisterClass const*, llvm::MachineOperand*>*, std::vector<std::pair<llvm::TargetRegisterClass const*, llvm::MachineOperand*>, std::allocator<std::pair<llvm::TargetRegisterClass const*, llvm::MachineOperand*> > > >, unsigned long, std::pair<llvm::TargetRegisterClass const*, llvm::MachineOperand*> const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIjjESaIS1_EE7reserveEm", "std::vector<std::pair<unsigned int, unsigned int>, std::allocator<std::pair<unsigned int, unsigned int> > >::reserve(unsigned long)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPKN4llvm19TargetRegisterClassEPNS1_14MachineOperandEESaIS7_EE7reserveEm", "std::vector<std::pair<llvm::TargetRegisterClass const*, llvm::MachineOperand*>, std::allocator<std::pair<llvm::TargetRegisterClass const*, llvm::MachineOperand*> > >::reserve(unsigned long)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockEPNS_14SSAUpdaterImplINS_17MachineSSAUpdaterEE6BBInfoENS_12DenseMapInfoIS2_EENS8_IS7_EEE16InsertIntoBucketERKS2_RKS7_PSt4pairIS2_S7_E", "llvm::DenseMap<llvm::MachineBasicBlock*, llvm::SSAUpdaterImpl<llvm::MachineSSAUpdater>::BBInfo*, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::SSAUpdaterImpl<llvm::MachineSSAUpdater>::BBInfo*> >::InsertIntoBucket(llvm::MachineBasicBlock* const&, llvm::SSAUpdaterImpl<llvm::MachineSSAUpdater>::BBInfo* const&, std::pair<llvm::MachineBasicBlock*, llvm::SSAUpdaterImpl<llvm::MachineSSAUpdater>::BBInfo*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockEPNS_14SSAUpdaterImplINS_17MachineSSAUpdaterEE6BBInfoENS_12DenseMapInfoIS2_EENS8_IS7_EEE4growEj", "llvm::DenseMap<llvm::MachineBasicBlock*, llvm::SSAUpdaterImpl<llvm::MachineSSAUpdater>::BBInfo*, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::SSAUpdaterImpl<llvm::MachineSSAUpdater>::BBInfo*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockEjNS_12DenseMapInfoIS2_EENS3_IjEEE16InsertIntoBucketERKS2_RKjPSt4pairIS2_jE", "llvm::DenseMap<llvm::MachineBasicBlock*, unsigned int, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(llvm::MachineBasicBlock* const&, unsigned int const&, std::pair<llvm::MachineBasicBlock*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockEjNS_12DenseMapInfoIS2_EENS3_IjEEE4growEj", "llvm::DenseMap<llvm::MachineBasicBlock*, unsigned int, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockEjNS_12DenseMapInfoIS2_EENS3_IjEEE16shrink_and_clearEv", "llvm::DenseMap<llvm::MachineBasicBlock*, unsigned int, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<unsigned int> >::shrink_and_clear()"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPN4llvm17MachineBasicBlockES3_ES4_St9_IdentityIS4_ESt4lessIS4_ESaIS4_EE16_M_insert_uniqueERKS4_", "std::_Rb_tree<std::pair<llvm::MachineBasicBlock*, llvm::MachineBasicBlock*>, std::pair<llvm::MachineBasicBlock*, llvm::MachineBasicBlock*>, std::_Identity<std::pair<llvm::MachineBasicBlock*, llvm::MachineBasicBlock*> >, std::less<std::pair<llvm::MachineBasicBlock*, llvm::MachineBasicBlock*> >, std::allocator<std::pair<llvm::MachineBasicBlock*, llvm::MachineBasicBlock*> > >::_M_insert_unique(std::pair<llvm::MachineBasicBlock*, llvm::MachineBasicBlock*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPN4llvm17MachineBasicBlockES3_ES4_St9_IdentityIS4_ESt4lessIS4_ESaIS4_EE8_M_eraseEPSt13_Rb_tree_nodeIS4_E", "std::_Rb_tree<std::pair<llvm::MachineBasicBlock*, llvm::MachineBasicBlock*>, std::pair<llvm::MachineBasicBlock*, llvm::MachineBasicBlock*>, std::_Identity<std::pair<llvm::MachineBasicBlock*, llvm::MachineBasicBlock*> >, std::less<std::pair<llvm::MachineBasicBlock*, llvm::MachineBasicBlock*> >, std::allocator<std::pair<llvm::MachineBasicBlock*, llvm::MachineBasicBlock*> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::MachineBasicBlock*, llvm::MachineBasicBlock*> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_17MachineBasicBlockEN12_GLOBAL__N_115MachineVerifier6BBInfoENS_12DenseMapInfoIS3_EENS7_IS6_EEEixERKS3_", "llvm::DenseMap<llvm::MachineBasicBlock const*, (anonymous namespace)::MachineVerifier::BBInfo, llvm::DenseMapInfo<llvm::MachineBasicBlock const*>, llvm::DenseMapInfo<(anonymous namespace)::MachineVerifier::BBInfo> >::operator[](llvm::MachineBasicBlock const* const&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_115MachineVerifier6BBInfo9addPassedERKN4llvm8DenseSetIjNS2_12DenseMapInfoIjEEEE", "(anonymous namespace)::MachineVerifier::BBInfo::addPassed(llvm::DenseSet<unsigned int, llvm::DenseMapInfo<unsigned int> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjcNS_12DenseMapInfoIjEENS1_IcEEE16shrink_and_clearEv", "llvm::DenseMap<unsigned int, char, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<char> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_17MachineBasicBlockEcNS_12DenseMapInfoIS3_EENS4_IcEEE6insertERKSt4pairIS3_cE", "llvm::DenseMap<llvm::MachineBasicBlock const*, char, llvm::DenseMapInfo<llvm::MachineBasicBlock const*>, llvm::DenseMapInfo<char> >::insert(std::pair<llvm::MachineBasicBlock const*, char> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_17MachineBasicBlockEcNS_12DenseMapInfoIS3_EENS4_IcEEE16InsertIntoBucketERKS3_RKcPSt4pairIS3_cE", "llvm::DenseMap<llvm::MachineBasicBlock const*, char, llvm::DenseMapInfo<llvm::MachineBasicBlock const*>, llvm::DenseMapInfo<char> >::InsertIntoBucket(llvm::MachineBasicBlock const* const&, char const&, std::pair<llvm::MachineBasicBlock const*, char>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_17MachineBasicBlockEcNS_12DenseMapInfoIS3_EENS4_IcEEE4growEj", "llvm::DenseMap<llvm::MachineBasicBlock const*, char, llvm::DenseMapInfo<llvm::MachineBasicBlock const*>, llvm::DenseMapInfo<char> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjcNS_12DenseMapInfoIjEENS1_IcEEE8CopyFromERKS4_", "llvm::DenseMap<unsigned int, char, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<char> >::CopyFrom(llvm::DenseMap<unsigned int, char, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<char> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPKNS_12MachineInstrENS_12DenseMapInfoIjEENS4_IS3_EEE8CopyFromERKS7_", "llvm::DenseMap<unsigned int, llvm::MachineInstr const*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::MachineInstr const*> >::CopyFrom(llvm::DenseMap<unsigned int, llvm::MachineInstr const*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::MachineInstr const*> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPKNS_12MachineInstrENS_12DenseMapInfoIjEENS4_IS3_EEE6insertERKSt4pairIjS3_E", "llvm::DenseMap<unsigned int, llvm::MachineInstr const*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::MachineInstr const*> >::insert(std::pair<unsigned int, llvm::MachineInstr const*> const&)"),
	mu_demangle_test("_ZSt6__findIN9__gnu_cxx17__normal_iteratorIPPN4llvm12MachineInstrESt6vectorIS4_SaIS4_EEEEPKS3_ET_SC_SC_RKT0_St26random_access_iterator_tag", "__gnu_cxx::__normal_iterator<llvm::MachineInstr**, std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> > > std::__find<__gnu_cxx::__normal_iterator<llvm::MachineInstr**, std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> > >, llvm::MachineInstr const*>(__gnu_cxx::__normal_iterator<llvm::MachineInstr**, std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> > >, __gnu_cxx::__normal_iterator<llvm::MachineInstr**, std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> > >, llvm::MachineInstr const* const&, std::random_access_iterator_tag)"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIjjEjNS_12DenseMapInfoIS2_EENS3_IjEEE5clearEv", "llvm::DenseMap<std::pair<unsigned int, unsigned int>, unsigned int, llvm::DenseMapInfo<std::pair<unsigned int, unsigned int> >, llvm::DenseMapInfo<unsigned int> >::clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIjjEjNS_12DenseMapInfoIS2_EENS3_IjEEE16shrink_and_clearEv", "llvm::DenseMap<std::pair<unsigned int, unsigned int>, unsigned int, llvm::DenseMapInfo<std::pair<unsigned int, unsigned int> >, llvm::DenseMapInfo<unsigned int> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_12MachineInstrEjNS_27MachineInstrExpressionTraitENS_12DenseMapInfoIjEEE16shrink_and_clearEv", "llvm::DenseMap<llvm::MachineInstr*, unsigned int, llvm::MachineInstrExpressionTrait, llvm::DenseMapInfo<unsigned int> >::shrink_and_clear()"),
	mu_demangle_test("_ZNK4llvm8DenseMapISt4pairIjjEjNS_12DenseMapInfoIS2_EENS3_IjEEE15LookupBucketForERKS2_RPS1_IS2_jE", "llvm::DenseMap<std::pair<unsigned int, unsigned int>, unsigned int, llvm::DenseMapInfo<std::pair<unsigned int, unsigned int> >, llvm::DenseMapInfo<unsigned int> >::LookupBucketFor(std::pair<unsigned int, unsigned int> const&, std::pair<std::pair<unsigned int, unsigned int>, unsigned int>*&) const"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIjjEjNS_12DenseMapInfoIS2_EENS3_IjEEE16InsertIntoBucketERKS2_RKjPS1_IS2_jE", "llvm::DenseMap<std::pair<unsigned int, unsigned int>, unsigned int, llvm::DenseMapInfo<std::pair<unsigned int, unsigned int> >, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(std::pair<unsigned int, unsigned int> const&, unsigned int const&, std::pair<std::pair<unsigned int, unsigned int>, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIjjEjNS_12DenseMapInfoIS2_EENS3_IjEEE4growEj", "llvm::DenseMap<std::pair<unsigned int, unsigned int>, unsigned int, llvm::DenseMapInfo<std::pair<unsigned int, unsigned int> >, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZNK4llvm8DenseMapIPNS_12MachineInstrEjNS_27MachineInstrExpressionTraitENS_12DenseMapInfoIjEEE15LookupBucketForERKS2_RPSt4pairIS2_jE", "llvm::DenseMap<llvm::MachineInstr*, unsigned int, llvm::MachineInstrExpressionTrait, llvm::DenseMapInfo<unsigned int> >::LookupBucketFor(llvm::MachineInstr* const&, std::pair<llvm::MachineInstr*, unsigned int>*&) const"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_12MachineInstrEjNS_27MachineInstrExpressionTraitENS_12DenseMapInfoIjEEE16InsertIntoBucketERKS2_RKjPSt4pairIS2_jE", "llvm::DenseMap<llvm::MachineInstr*, unsigned int, llvm::MachineInstrExpressionTrait, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(llvm::MachineInstr* const&, unsigned int const&, std::pair<llvm::MachineInstr*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_12MachineInstrEjNS_27MachineInstrExpressionTraitENS_12DenseMapInfoIjEEE4growEj", "llvm::DenseMap<llvm::MachineInstr*, unsigned int, llvm::MachineInstrExpressionTrait, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm2cl3optIPFPNS_12FunctionPassEvELb0ENS_18RegisterPassParserINS_16RegisterRegAllocEEEED1Ev", "llvm::cl::opt<llvm::FunctionPass* (*)(), false, llvm::RegisterPassParser<llvm::RegisterRegAlloc> >::~opt()"),
	mu_demangle_test("_ZN4llvm2cl3optIPFPNS_12FunctionPassEvELb0ENS_18RegisterPassParserINS_16RegisterRegAllocEEEE4doneEv", "llvm::cl::opt<llvm::FunctionPass* (*)(), false, llvm::RegisterPassParser<llvm::RegisterRegAlloc> >::done()"),
	mu_demangle_test("_ZN4llvm2cl3optIPFPNS_12FunctionPassEvELb0ENS_18RegisterPassParserINS_16RegisterRegAllocEEEE16handleOccurrenceEjNS_9StringRefESA_", "llvm::cl::opt<llvm::FunctionPass* (*)(), false, llvm::RegisterPassParser<llvm::RegisterRegAlloc> >::handleOccurrence(unsigned int, llvm::StringRef, llvm::StringRef)"),
	mu_demangle_test("_ZNK4llvm2cl3optIPFPNS_12FunctionPassEvELb0ENS_18RegisterPassParserINS_16RegisterRegAllocEEEE27getValueExpectedFlagDefaultEv", "llvm::cl::opt<llvm::FunctionPass* (*)(), false, llvm::RegisterPassParser<llvm::RegisterRegAlloc> >::getValueExpectedFlagDefault() const"),
	mu_demangle_test("_ZNK4llvm2cl3optIPFPNS_12FunctionPassEvELb0ENS_18RegisterPassParserINS_16RegisterRegAllocEEEE14getOptionWidthEv", "llvm::cl::opt<llvm::FunctionPass* (*)(), false, llvm::RegisterPassParser<llvm::RegisterRegAlloc> >::getOptionWidth() const"),
	mu_demangle_test("_ZNK4llvm2cl3optIPFPNS_12FunctionPassEvELb0ENS_18RegisterPassParserINS_16RegisterRegAllocEEEE15printOptionInfoEm", "llvm::cl::opt<llvm::FunctionPass* (*)(), false, llvm::RegisterPassParser<llvm::RegisterRegAlloc> >::printOptionInfo(unsigned long) const"),
	mu_demangle_test("_ZN4llvm2cl3optIPFPNS_12FunctionPassEvELb0ENS_18RegisterPassParserINS_16RegisterRegAllocEEEE19getExtraOptionNamesERNS_15SmallVectorImplIPKcEE", "llvm::cl::opt<llvm::FunctionPass* (*)(), false, llvm::RegisterPassParser<llvm::RegisterRegAlloc> >::getExtraOptionNames(llvm::SmallVectorImpl<char const*>&)"),
	mu_demangle_test("_ZN4llvm2cl3optIPFPNS_12FunctionPassEvELb0ENS_18RegisterPassParserINS_16RegisterRegAllocEEEED0Ev", "llvm::cl::opt<llvm::FunctionPass* (*)(), false, llvm::RegisterPassParser<llvm::RegisterRegAlloc> >::~opt()"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_12MachineInstrENS_12DenseMapInfoIjEENS3_IS2_EEE6insertERKSt4pairIjS2_E", "llvm::DenseMap<unsigned int, llvm::MachineInstr*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::MachineInstr*> >::insert(std::pair<unsigned int, llvm::MachineInstr*> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_12MachineInstrENS_12DenseMapInfoIjEENS3_IS2_EEE16InsertIntoBucketERKjRKS2_PSt4pairIjS2_E", "llvm::DenseMap<unsigned int, llvm::MachineInstr*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::MachineInstr*> >::InsertIntoBucket(unsigned int const&, llvm::MachineInstr* const&, std::pair<unsigned int, llvm::MachineInstr*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_12MachineInstrENS_12DenseMapInfoIjEENS3_IS2_EEE4growEj", "llvm::DenseMap<unsigned int, llvm::MachineInstr*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::MachineInstr*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_12MachineInstrENS_12DenseMapInfoIjEENS3_IS2_EEE16shrink_and_clearEv", "llvm::DenseMap<unsigned int, llvm::MachineInstr*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::MachineInstr*> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm2cl3optISsLb0ENS0_6parserISsEEEC2IA24_cNS0_4descENS0_11initializerIA5_cEENS0_12OptionHiddenEEERKT_RKT0_RKT1_RKT2_", "llvm::cl::opt<std::string, false, llvm::cl::parser<std::string> >::opt<char [24], llvm::cl::desc, llvm::cl::initializer<char [5]>, llvm::cl::OptionHidden>(char const (&) [24], llvm::cl::desc const&, llvm::cl::initializer<char [5]> const&, llvm::cl::OptionHidden const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm5SUnitESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::SUnit**, std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> > >, llvm::SUnit* const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm5SUnitESaIS1_EE15_M_erase_at_endEPS1_", "std::vector<llvm::SUnit, std::allocator<llvm::SUnit> >::_M_erase_at_end(llvm::SUnit*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjS0_IPKN4llvm14MachineOperandEjEESt10_Select1stIS7_ESt4lessIjESaIS7_EE8_M_eraseEPSt13_Rb_tree_nodeIS7_E", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, std::pair<llvm::MachineOperand const*, unsigned int> >, std::_Select1st<std::pair<unsigned int const, std::pair<llvm::MachineOperand const*, unsigned int> > >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, std::pair<llvm::MachineOperand const*, unsigned int> > > >::_M_erase(std::_Rb_tree_node<std::pair<unsigned int const, std::pair<llvm::MachineOperand const*, unsigned int> > >*)"),
	mu_demangle_test("_ZN4llvm20LatencyPriorityQueue9initNodesERSt6vectorINS_5SUnitESaIS2_EE", "llvm::LatencyPriorityQueue::initNodes(std::vector<llvm::SUnit, std::allocator<llvm::SUnit> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_117PreAllocSplitting22PerformPHIConstructionEN4llvm14ilist_iteratorINS1_12MachineInstrEEEPNS1_17MachineBasicBlockEPNS1_12LiveIntervalERNS1_11SmallPtrSetIPS3_Lj4EEERNS1_8DenseMapIS6_NS9_ISA_Lj2EEENS1_12DenseMapInfoIS6_EENSF_ISE_EEEESJ_RNSD_ISA_PNS1_6VNInfoENSF_ISA_EENSF_ISL_EEEERNSD_IS6_SL_SG_SN_EESR_bb", "(anonymous namespace)::PreAllocSplitting::PerformPHIConstruction(llvm::ilist_iterator<llvm::MachineInstr>, llvm::MachineBasicBlock*, llvm::LiveInterval*, llvm::SmallPtrSet<llvm::MachineInstr*, 4u>&, llvm::DenseMap<llvm::MachineBasicBlock*, llvm::SmallPtrSet<llvm::MachineInstr*, 2u>, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::SmallPtrSet<llvm::MachineInstr*, 2u> > >&, llvm::DenseMap<llvm::MachineBasicBlock*, llvm::SmallPtrSet<llvm::MachineInstr*, 2u>, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::SmallPtrSet<llvm::MachineInstr*, 2u> > >&, llvm::DenseMap<llvm::MachineInstr*, llvm::VNInfo*, llvm::DenseMapInfo<llvm::MachineInstr*>, llvm::DenseMapInfo<llvm::VNInfo*> >&, llvm::DenseMap<llvm::MachineBasicBlock*, llvm::VNInfo*, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::VNInfo*> >&, llvm::DenseMap<llvm::MachineBasicBlock*, llvm::VNInfo*, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::VNInfo*> >&, bool, bool)"),
	mu_demangle_test("_ZN12_GLOBAL__N_117PreAllocSplitting30PerformPHIConstructionFallBackEN4llvm14ilist_iteratorINS1_12MachineInstrEEEPNS1_17MachineBasicBlockEPNS1_12LiveIntervalERNS1_11SmallPtrSetIPS3_Lj4EEERNS1_8DenseMapIS6_NS9_ISA_Lj2EEENS1_12DenseMapInfoIS6_EENSF_ISE_EEEESJ_RNSD_ISA_PNS1_6VNInfoENSF_ISA_EENSF_ISL_EEEERNSD_IS6_SL_SG_SN_EESR_bb", "(anonymous namespace)::PreAllocSplitting::PerformPHIConstructionFallBack(llvm::ilist_iterator<llvm::MachineInstr>, llvm::MachineBasicBlock*, llvm::LiveInterval*, llvm::SmallPtrSet<llvm::MachineInstr*, 4u>&, llvm::DenseMap<llvm::MachineBasicBlock*, llvm::SmallPtrSet<llvm::MachineInstr*, 2u>, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::SmallPtrSet<llvm::MachineInstr*, 2u> > >&, llvm::DenseMap<llvm::MachineBasicBlock*, llvm::SmallPtrSet<llvm::MachineInstr*, 2u>, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::SmallPtrSet<llvm::MachineInstr*, 2u> > >&, llvm::DenseMap<llvm::MachineInstr*, llvm::VNInfo*, llvm::DenseMapInfo<llvm::MachineInstr*>, llvm::DenseMapInfo<llvm::VNInfo*> >&, llvm::DenseMap<llvm::MachineBasicBlock*, llvm::VNInfo*, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::VNInfo*> >&, llvm::DenseMap<llvm::MachineBasicBlock*, llvm::VNInfo*, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::VNInfo*> >&, bool, bool)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_6VNInfoENS_11SmallPtrSetIPNS_12MachineInstrELj4EEENS_12DenseMapInfoIS2_EENS7_IS6_EEE16FindAndConstructERKS2_", "llvm::DenseMap<llvm::VNInfo*, llvm::SmallPtrSet<llvm::MachineInstr*, 4u>, llvm::DenseMapInfo<llvm::VNInfo*>, llvm::DenseMapInfo<llvm::SmallPtrSet<llvm::MachineInstr*, 4u> > >::FindAndConstruct(llvm::VNInfo* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_6VNInfoENS_11SmallPtrSetIPNS_12MachineInstrELj4EEENS_12DenseMapInfoIS2_EENS7_IS6_EEE16InsertIntoBucketERKS2_RKS6_PSt4pairIS2_S6_E", "llvm::DenseMap<llvm::VNInfo*, llvm::SmallPtrSet<llvm::MachineInstr*, 4u>, llvm::DenseMapInfo<llvm::VNInfo*>, llvm::DenseMapInfo<llvm::SmallPtrSet<llvm::MachineInstr*, 4u> > >::InsertIntoBucket(llvm::VNInfo* const&, llvm::SmallPtrSet<llvm::MachineInstr*, 4u> const&, std::pair<llvm::VNInfo*, llvm::SmallPtrSet<llvm::MachineInstr*, 4u> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_6VNInfoENS_11SmallPtrSetIPNS_12MachineInstrELj4EEENS_12DenseMapInfoIS2_EENS7_IS6_EEE4growEj", "llvm::DenseMap<llvm::VNInfo*, llvm::SmallPtrSet<llvm::MachineInstr*, 4u>, llvm::DenseMapInfo<llvm::VNInfo*>, llvm::DenseMapInfo<llvm::SmallPtrSet<llvm::MachineInstr*, 4u> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockEPNS_6VNInfoENS_12DenseMapInfoIS2_EENS5_IS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<llvm::MachineBasicBlock*, llvm::VNInfo*, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::VNInfo*> >::InsertIntoBucket(llvm::MachineBasicBlock* const&, llvm::VNInfo* const&, std::pair<llvm::MachineBasicBlock*, llvm::VNInfo*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockEPNS_6VNInfoENS_12DenseMapInfoIS2_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::MachineBasicBlock*, llvm::VNInfo*, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::VNInfo*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_12MachineInstrEPNS_6VNInfoENS_12DenseMapInfoIS2_EENS5_IS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<llvm::MachineInstr*, llvm::VNInfo*, llvm::DenseMapInfo<llvm::MachineInstr*>, llvm::DenseMapInfo<llvm::VNInfo*> >::InsertIntoBucket(llvm::MachineInstr* const&, llvm::VNInfo* const&, std::pair<llvm::MachineInstr*, llvm::VNInfo*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_12MachineInstrEPNS_6VNInfoENS_12DenseMapInfoIS2_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::MachineInstr*, llvm::VNInfo*, llvm::DenseMapInfo<llvm::MachineInstr*>, llvm::DenseMapInfo<llvm::VNInfo*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockENS_11SmallPtrSetIPNS_12MachineInstrELj2EEENS_12DenseMapInfoIS2_EENS7_IS6_EEE16FindAndConstructERKS2_", "llvm::DenseMap<llvm::MachineBasicBlock*, llvm::SmallPtrSet<llvm::MachineInstr*, 2u>, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::SmallPtrSet<llvm::MachineInstr*, 2u> > >::FindAndConstruct(llvm::MachineBasicBlock* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockENS_11SmallPtrSetIPNS_12MachineInstrELj2EEENS_12DenseMapInfoIS2_EENS7_IS6_EEE16InsertIntoBucketERKS2_RKS6_PSt4pairIS2_S6_E", "llvm::DenseMap<llvm::MachineBasicBlock*, llvm::SmallPtrSet<llvm::MachineInstr*, 2u>, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::SmallPtrSet<llvm::MachineInstr*, 2u> > >::InsertIntoBucket(llvm::MachineBasicBlock* const&, llvm::SmallPtrSet<llvm::MachineInstr*, 2u> const&, std::pair<llvm::MachineBasicBlock*, llvm::SmallPtrSet<llvm::MachineInstr*, 2u> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockENS_11SmallPtrSetIPNS_12MachineInstrELj2EEENS_12DenseMapInfoIS2_EENS7_IS6_EEE4growEj", "llvm::DenseMap<llvm::MachineBasicBlock*, llvm::SmallPtrSet<llvm::MachineInstr*, 2u>, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::SmallPtrSet<llvm::MachineInstr*, 2u> > >::grow(unsigned int)"),
	mu_demangle_test("_ZNK4llvm8DenseMapINS_9SlotIndexES1_NS_12DenseMapInfoIS1_EES3_E15LookupBucketForERKS1_RPSt4pairIS1_S1_E", "llvm::DenseMap<llvm::SlotIndex, llvm::SlotIndex, llvm::DenseMapInfo<llvm::SlotIndex>, llvm::DenseMapInfo<llvm::SlotIndex> >::LookupBucketFor(llvm::SlotIndex const&, std::pair<llvm::SlotIndex, llvm::SlotIndex>*&) const"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_9SlotIndexES1_NS_12DenseMapInfoIS1_EES3_E16InsertIntoBucketERKS1_S6_PSt4pairIS1_S1_E", "llvm::DenseMap<llvm::SlotIndex, llvm::SlotIndex, llvm::DenseMapInfo<llvm::SlotIndex>, llvm::DenseMapInfo<llvm::SlotIndex> >::InsertIntoBucket(llvm::SlotIndex const&, llvm::SlotIndex const&, std::pair<llvm::SlotIndex, llvm::SlotIndex>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_9SlotIndexES1_NS_12DenseMapInfoIS1_EES3_E4growEj", "llvm::DenseMap<llvm::SlotIndex, llvm::SlotIndex, llvm::DenseMapInfo<llvm::SlotIndex>, llvm::DenseMapInfo<llvm::SlotIndex> >::grow(unsigned int)"),
	mu_demangle_test("_ZNK4llvm8DenseMapINS_9SlotIndexES1_NS_12DenseMapInfoIS1_EES3_E4findERKS1_", "llvm::DenseMap<llvm::SlotIndex, llvm::SlotIndex, llvm::DenseMapInfo<llvm::SlotIndex>, llvm::DenseMapInfo<llvm::SlotIndex> >::find(llvm::SlotIndex const&) const"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_9SlotIndexES1_NS_12DenseMapInfoIS1_EES3_E5clearEv", "llvm::DenseMap<llvm::SlotIndex, llvm::SlotIndex, llvm::DenseMapInfo<llvm::SlotIndex>, llvm::DenseMapInfo<llvm::SlotIndex> >::clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_9SlotIndexES1_NS_12DenseMapInfoIS1_EES3_E16shrink_and_clearEv", "llvm::DenseMap<llvm::SlotIndex, llvm::SlotIndex, llvm::DenseMapInfo<llvm::SlotIndex>, llvm::DenseMapInfo<llvm::SlotIndex> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIjiNS_12DenseMapInfoIjEENS1_IiEEE16shrink_and_clearEv", "llvm::DenseMap<unsigned int, int, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<int> >::shrink_and_clear()"),
	mu_demangle_test("_ZNSt6vectorIN4llvm15CalleeSavedInfoESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<llvm::CalleeSavedInfo, std::allocator<llvm::CalleeSavedInfo> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::CalleeSavedInfo*, std::vector<llvm::CalleeSavedInfo, std::allocator<llvm::CalleeSavedInfo> > >, llvm::CalleeSavedInfo const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm14ilist_iteratorINS0_12MachineInstrEEESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<llvm::ilist_iterator<llvm::MachineInstr>, std::allocator<llvm::ilist_iterator<llvm::MachineInstr> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::ilist_iterator<llvm::MachineInstr>*, std::vector<llvm::ilist_iterator<llvm::MachineInstr>, std::allocator<llvm::ilist_iterator<llvm::MachineInstr> > > >, llvm::ilist_iterator<llvm::MachineInstr> const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm15CalleeSavedInfoESaIS1_EEaSERKS3_", "std::vector<llvm::CalleeSavedInfo, std::allocator<llvm::CalleeSavedInfo> >::operator=(std::vector<llvm::CalleeSavedInfo, std::allocator<llvm::CalleeSavedInfo> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIiSt4pairIKiPKN4llvm17PseudoSourceValueEESt10_Select1stIS6_ESt4lessIiESaIS6_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS6_ERKS6_", "std::_Rb_tree<int, std::pair<int const, llvm::PseudoSourceValue const*>, std::_Select1st<std::pair<int const, llvm::PseudoSourceValue const*> >, std::less<int>, std::allocator<std::pair<int const, llvm::PseudoSourceValue const*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<int const, llvm::PseudoSourceValue const*> >, std::pair<int const, llvm::PseudoSourceValue const*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIiSt4pairIKiPKN4llvm17PseudoSourceValueEESt10_Select1stIS6_ESt4lessIiESaIS6_EE16_M_insert_uniqueERKS6_", "std::_Rb_tree<int, std::pair<int const, llvm::PseudoSourceValue const*>, std::_Select1st<std::pair<int const, llvm::PseudoSourceValue const*> >, std::less<int>, std::allocator<std::pair<int const, llvm::PseudoSourceValue const*> > >::_M_insert_unique(std::pair<int const, llvm::PseudoSourceValue const*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIiSt4pairIKiPKN4llvm17PseudoSourceValueEESt10_Select1stIS6_ESt4lessIiESaIS6_EE8_M_eraseEPSt13_Rb_tree_nodeIS6_E", "std::_Rb_tree<int, std::pair<int const, llvm::PseudoSourceValue const*>, std::_Select1st<std::pair<int const, llvm::PseudoSourceValue const*> >, std::less<int>, std::allocator<std::pair<int const, llvm::PseudoSourceValue const*> > >::_M_erase(std::_Rb_tree_node<std::pair<int const, llvm::PseudoSourceValue const*> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjN12_GLOBAL__N_16RAFast7LiveRegENS_12DenseMapInfoIjEENS4_IS3_EEE6insertERKSt4pairIjS3_E", "llvm::DenseMap<unsigned int, (anonymous namespace)::RAFast::LiveReg, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<(anonymous namespace)::RAFast::LiveReg> >::insert(std::pair<unsigned int, (anonymous namespace)::RAFast::LiveReg> const&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_19RALinScan18updateSpillWeightsERSt6vectorIfSaIfEEjfPKN4llvm19TargetRegisterClassE", "(anonymous namespace)::RALinScan::updateSpillWeights(std::vector<float, std::allocator<float> >&, unsigned int, float, llvm::TargetRegisterClass const*)"),
	mu_demangle_test("_ZSt16__introsort_loopIN9__gnu_cxx17__normal_iteratorIPSt4pairIjfESt6vectorIS3_SaIS3_EEEElN12_GLOBAL__N_113WeightCompareEEvT_SB_T0_T1_", "void std::__introsort_loop<__gnu_cxx::__normal_iterator<std::pair<unsigned int, float>*, std::vector<std::pair<unsigned int, float>, std::allocator<std::pair<unsigned int, float> > > >, long, (anonymous namespace)::WeightCompare>(__gnu_cxx::__normal_iterator<std::pair<unsigned int, float>*, std::vector<std::pair<unsigned int, float>, std::allocator<std::pair<unsigned int, float> > > >, __gnu_cxx::__normal_iterator<std::pair<unsigned int, float>*, std::vector<std::pair<unsigned int, float>, std::allocator<std::pair<unsigned int, float> > > >, long, (anonymous namespace)::WeightCompare)"),
	mu_demangle_test("_ZSt16__insertion_sortIN9__gnu_cxx17__normal_iteratorIPSt4pairIjfESt6vectorIS3_SaIS3_EEEEN12_GLOBAL__N_113WeightCompareEEvT_SB_T0_", "void std::__insertion_sort<__gnu_cxx::__normal_iterator<std::pair<unsigned int, float>*, std::vector<std::pair<unsigned int, float>, std::allocator<std::pair<unsigned int, float> > > >, (anonymous namespace)::WeightCompare>(__gnu_cxx::__normal_iterator<std::pair<unsigned int, float>*, std::vector<std::pair<unsigned int, float>, std::allocator<std::pair<unsigned int, float> > > >, __gnu_cxx::__normal_iterator<std::pair<unsigned int, float>*, std::vector<std::pair<unsigned int, float>, std::allocator<std::pair<unsigned int, float> > > >, (anonymous namespace)::WeightCompare)"),
	mu_demangle_test("_ZSt13__adjust_heapIN9__gnu_cxx17__normal_iteratorIPSt4pairIjfESt6vectorIS3_SaIS3_EEEElS3_N12_GLOBAL__N_113WeightCompareEEvT_T0_SC_T1_T2_", "void std::__adjust_heap<__gnu_cxx::__normal_iterator<std::pair<unsigned int, float>*, std::vector<std::pair<unsigned int, float>, std::allocator<std::pair<unsigned int, float> > > >, long, std::pair<unsigned int, float>, (anonymous namespace)::WeightCompare>(__gnu_cxx::__normal_iterator<std::pair<unsigned int, float>*, std::vector<std::pair<unsigned int, float>, std::allocator<std::pair<unsigned int, float> > > >, long, long, std::pair<unsigned int, float>, (anonymous namespace)::WeightCompare)"),
	mu_demangle_test("_ZNSt14priority_queueIPN4llvm12LiveIntervalENS0_11SmallVectorIS2_Lj64EEENS0_11greater_ptrIS1_EEE4pushERKS2_", "std::priority_queue<llvm::LiveInterval*, llvm::SmallVector<llvm::LiveInterval*, 64u>, llvm::greater_ptr<llvm::LiveInterval> >::push(llvm::LiveInterval* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPKNS_19TargetRegisterClassENS_12DenseMapInfoIjEENS4_IS3_EEE16InsertIntoBucketERKjRKS3_PSt4pairIjS3_E", "llvm::DenseMap<unsigned int, llvm::TargetRegisterClass const*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::TargetRegisterClass const*> >::InsertIntoBucket(unsigned int const&, llvm::TargetRegisterClass const* const&, std::pair<unsigned int, llvm::TargetRegisterClass const*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPKNS_19TargetRegisterClassENS_12DenseMapInfoIjEENS4_IS3_EEE4growEj", "llvm::DenseMap<unsigned int, llvm::TargetRegisterClass const*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::TargetRegisterClass const*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIjfESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<std::pair<unsigned int, float>, std::allocator<std::pair<unsigned int, float> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<unsigned int, float>*, std::vector<std::pair<unsigned int, float>, std::allocator<std::pair<unsigned int, float> > > >, std::pair<unsigned int, float> const&)"),
	mu_demangle_test("_ZSt13__adjust_heapIPPN4llvm12LiveIntervalElS2_NS0_11greater_ptrIS1_EEEvT_T0_S7_T1_T2_", "void std::__adjust_heap<llvm::LiveInterval**, long, llvm::LiveInterval*, llvm::greater_ptr<llvm::LiveInterval> >(llvm::LiveInterval**, long, long, llvm::LiveInterval*, llvm::greater_ptr<llvm::LiveInterval>)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm18EquivalenceClassesIPKNS0_19TargetRegisterClassEE7ECValueES6_St9_IdentityIS6_ESt4lessIS6_ESaIS6_EE16_M_insert_uniqueERKS6_", "std::_Rb_tree<llvm::EquivalenceClasses<llvm::TargetRegisterClass const*>::ECValue, llvm::EquivalenceClasses<llvm::TargetRegisterClass const*>::ECValue, std::_Identity<llvm::EquivalenceClasses<llvm::TargetRegisterClass const*>::ECValue>, std::less<llvm::EquivalenceClasses<llvm::TargetRegisterClass const*>::ECValue>, std::allocator<llvm::EquivalenceClasses<llvm::TargetRegisterClass const*>::ECValue> >::_M_insert_unique(llvm::EquivalenceClasses<llvm::TargetRegisterClass const*>::ECValue const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm18EquivalenceClassesIPKNS0_19TargetRegisterClassEE7ECValueES6_St9_IdentityIS6_ESt4lessIS6_ESaIS6_EE8_M_eraseEPSt13_Rb_tree_nodeIS6_E", "std::_Rb_tree<llvm::EquivalenceClasses<llvm::TargetRegisterClass const*>::ECValue, llvm::EquivalenceClasses<llvm::TargetRegisterClass const*>::ECValue, std::_Identity<llvm::EquivalenceClasses<llvm::TargetRegisterClass const*>::ECValue>, std::less<llvm::EquivalenceClasses<llvm::TargetRegisterClass const*>::ECValue>, std::allocator<llvm::EquivalenceClasses<llvm::TargetRegisterClass const*>::ECValue> >::_M_erase(std::_Rb_tree_node<llvm::EquivalenceClasses<llvm::TargetRegisterClass const*>::ECValue>*)"),
	mu_demangle_test("_ZNSt14priority_queueIPN4llvm12LiveIntervalENS0_11SmallVectorIS2_Lj64EEENS0_11greater_ptrIS1_EEEC2ERKS6_RKS4_", "std::priority_queue<llvm::LiveInterval*, llvm::SmallVector<llvm::LiveInterval*, 64u>, llvm::greater_ptr<llvm::LiveInterval> >::priority_queue(llvm::greater_ptr<llvm::LiveInterval> const&, llvm::SmallVector<llvm::LiveInterval*, 64u> const&)"),
	mu_demangle_test("_ZN4llvm26ScheduleDAGTopologicalSortC1ERSt6vectorINS_5SUnitESaIS2_EE", "llvm::ScheduleDAGTopologicalSort::ScheduleDAGTopologicalSort(std::vector<llvm::SUnit, std::allocator<llvm::SUnit> >&)"),
	mu_demangle_test("_ZN4llvm26ScheduleDAGTopologicalSortC2ERSt6vectorINS_5SUnitESaIS2_EE", "llvm::ScheduleDAGTopologicalSort::ScheduleDAGTopologicalSort(std::vector<llvm::SUnit, std::allocator<llvm::SUnit> >&)"),
	mu_demangle_test("_ZNSt6vectorIPKN4llvm5SUnitESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<llvm::SUnit const*, std::allocator<llvm::SUnit const*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::SUnit const**, std::vector<llvm::SUnit const*, std::allocator<llvm::SUnit const*> > >, llvm::SUnit const* const&)"),
	mu_demangle_test("_ZNSt6vectorIiSaIiEE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPiS1_EEmRKi", "std::vector<int, std::allocator<int> >::_M_fill_insert(__gnu_cxx::__normal_iterator<int*, std::vector<int, std::allocator<int> > >, unsigned long, int const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm5SUnitESaIS1_EED2Ev", "std::vector<llvm::SUnit, std::allocator<llvm::SUnit> >::~vector()"),
	mu_demangle_test("_ZN4llvm11ScheduleDAG15EmitPhysRegCopyEPNS_5SUnitERNS_8DenseMapIS2_jNS_12DenseMapInfoIS2_EENS4_IjEEEE", "llvm::ScheduleDAG::EmitPhysRegCopy(llvm::SUnit*, llvm::DenseMap<llvm::SUnit*, unsigned int, llvm::DenseMapInfo<llvm::SUnit*>, llvm::DenseMapInfo<unsigned int> >&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5SUnitEjNS_12DenseMapInfoIS2_EENS3_IjEEE6insertERKSt4pairIS2_jE", "llvm::DenseMap<llvm::SUnit*, unsigned int, llvm::DenseMapInfo<llvm::SUnit*>, llvm::DenseMapInfo<unsigned int> >::insert(std::pair<llvm::SUnit*, unsigned int> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5SUnitEjNS_12DenseMapInfoIS2_EENS3_IjEEE16InsertIntoBucketERKS2_RKjPSt4pairIS2_jE", "llvm::DenseMap<llvm::SUnit*, unsigned int, llvm::DenseMapInfo<llvm::SUnit*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(llvm::SUnit* const&, unsigned int const&, std::pair<llvm::SUnit*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5SUnitEjNS_12DenseMapInfoIS2_EENS3_IjEEE4growEj", "llvm::DenseMap<llvm::SUnit*, unsigned int, llvm::DenseMapInfo<llvm::SUnit*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm5SUnitESaIS1_EE7reserveEm", "std::vector<llvm::SUnit, std::allocator<llvm::SUnit> >::reserve(unsigned long)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm5ValueESt4pairIKS3_St6vectorIPNS0_5SUnitESaIS8_EEESt10_Select1stISB_ESt4lessIS3_ESaISB_EE16_M_insert_uniqueESt17_Rb_tree_iteratorISB_ERKSB_", "std::_Rb_tree<llvm::Value const*, std::pair<llvm::Value const* const, std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> > >, std::_Select1st<std::pair<llvm::Value const* const, std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> > > >, std::less<llvm::Value const*>, std::allocator<std::pair<llvm::Value const* const, std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> > > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::Value const* const, std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> > > >, std::pair<llvm::Value const* const, std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm5ValueESt4pairIKS3_St6vectorIPNS0_5SUnitESaIS8_EEESt10_Select1stISB_ESt4lessIS3_ESaISB_EE16_M_insert_uniqueERKSB_", "std::_Rb_tree<llvm::Value const*, std::pair<llvm::Value const* const, std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> > >, std::_Select1st<std::pair<llvm::Value const* const, std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> > > >, std::less<llvm::Value const*>, std::allocator<std::pair<llvm::Value const* const, std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> > > > >::_M_insert_unique(std::pair<llvm::Value const* const, std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm5ValueESt4pairIKS3_St6vectorIPNS0_5SUnitESaIS8_EEESt10_Select1stISB_ESt4lessIS3_ESaISB_EE14_M_create_nodeERKSB_", "std::_Rb_tree<llvm::Value const*, std::pair<llvm::Value const* const, std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> > >, std::_Select1st<std::pair<llvm::Value const* const, std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> > > >, std::less<llvm::Value const*>, std::allocator<std::pair<llvm::Value const* const, std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> > > > >::_M_create_node(std::pair<llvm::Value const* const, std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm5ValueESt4pairIKS3_PNS0_5SUnitEESt10_Select1stIS8_ESt4lessIS3_ESaIS8_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS8_ERKS8_", "std::_Rb_tree<llvm::Value const*, std::pair<llvm::Value const* const, llvm::SUnit*>, std::_Select1st<std::pair<llvm::Value const* const, llvm::SUnit*> >, std::less<llvm::Value const*>, std::allocator<std::pair<llvm::Value const* const, llvm::SUnit*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::Value const* const, llvm::SUnit*> >, std::pair<llvm::Value const* const, llvm::SUnit*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm5ValueESt4pairIKS3_PNS0_5SUnitEESt10_Select1stIS8_ESt4lessIS3_ESaIS8_EE16_M_insert_uniqueERKS8_", "std::_Rb_tree<llvm::Value const*, std::pair<llvm::Value const* const, llvm::SUnit*>, std::_Select1st<std::pair<llvm::Value const* const, llvm::SUnit*> >, std::less<llvm::Value const*>, std::allocator<std::pair<llvm::Value const* const, llvm::SUnit*> > >::_M_insert_unique(std::pair<llvm::Value const* const, llvm::SUnit*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm5ValueESt4pairIKS3_St6vectorIPNS0_5SUnitESaIS8_EEESt10_Select1stISB_ESt4lessIS3_ESaISB_EE8_M_eraseEPSt13_Rb_tree_nodeISB_E", "std::_Rb_tree<llvm::Value const*, std::pair<llvm::Value const* const, std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> > >, std::_Select1st<std::pair<llvm::Value const* const, std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> > > >, std::less<llvm::Value const*>, std::allocator<std::pair<llvm::Value const* const, std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> > > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::Value const* const, std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> > > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm5ValueESt4pairIKS3_PNS0_5SUnitEESt10_Select1stIS8_ESt4lessIS3_ESaIS8_EE8_M_eraseEPSt13_Rb_tree_nodeIS8_E", "std::_Rb_tree<llvm::Value const*, std::pair<llvm::Value const* const, llvm::SUnit*>, std::_Select1st<std::pair<llvm::Value const* const, llvm::SUnit*> >, std::less<llvm::Value const*>, std::allocator<std::pair<llvm::Value const* const, llvm::SUnit*> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::Value const* const, llvm::SUnit*> >*)"),
	mu_demangle_test("_ZSt26__uninitialized_fill_n_auxIPSt6vectorIPN4llvm5SUnitESaIS3_EEmS5_EvT_T0_RKT1_St12__false_type", "void std::__uninitialized_fill_n_aux<std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> >*, unsigned long, std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> > >(std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> >*, unsigned long, std::vector<llvm::SUnit*, std::allocator<llvm::SUnit*> > const&, std::__false_type)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm5SUnitESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<llvm::SUnit, std::allocator<llvm::SUnit> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::SUnit*, std::vector<llvm::SUnit, std::allocator<llvm::SUnit> > >, llvm::SUnit const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjS0_IPKN4llvm14MachineOperandEjEESt10_Select1stIS7_ESt4lessIjESaIS7_EE16_M_insert_uniqueERKS7_", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, std::pair<llvm::MachineOperand const*, unsigned int> >, std::_Select1st<std::pair<unsigned int const, std::pair<llvm::MachineOperand const*, unsigned int> > >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, std::pair<llvm::MachineOperand const*, unsigned int> > > >::_M_insert_unique(std::pair<unsigned int const, std::pair<llvm::MachineOperand const*, unsigned int> > const&)"),
	mu_demangle_test("_ZN4llvm3PEI19calcSpillPlacementsEPNS_17MachineBasicBlockERNS_11SmallVectorIS2_Lj4EEERNS_8DenseMapIS2_NS_15SparseBitVectorILj128EEENS_12DenseMapInfoIS2_EENS9_IS8_EEEE", "llvm::PEI::calcSpillPlacements(llvm::MachineBasicBlock*, llvm::SmallVector<llvm::MachineBasicBlock*, 4u>&, llvm::DenseMap<llvm::MachineBasicBlock*, llvm::SparseBitVector<128u>, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::SparseBitVector<128u> > >&)"),
	mu_demangle_test("_ZN4llvm3PEI21calcRestorePlacementsEPNS_17MachineBasicBlockERNS_11SmallVectorIS2_Lj4EEERNS_8DenseMapIS2_NS_15SparseBitVectorILj128EEENS_12DenseMapInfoIS2_EENS9_IS8_EEEE", "llvm::PEI::calcRestorePlacements(llvm::MachineBasicBlock*, llvm::SmallVector<llvm::MachineBasicBlock*, 4u>&, llvm::DenseMap<llvm::MachineBasicBlock*, llvm::SparseBitVector<128u>, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::SparseBitVector<128u> > >&)"),
	mu_demangle_test("_ZN4llvm2cl3optI20ShrinkWrapDebugLevelLb0ENS0_6parserIS2_EEED1Ev", "llvm::cl::opt<ShrinkWrapDebugLevel, false, llvm::cl::parser<ShrinkWrapDebugLevel> >::~opt()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockENS_15SparseBitVectorILj128EEENS_12DenseMapInfoIS2_EENS5_IS4_EEE5clearEv", "llvm::DenseMap<llvm::MachineBasicBlock*, llvm::SparseBitVector<128u>, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::SparseBitVector<128u> > >::clear()"),
	mu_demangle_test("_ZNSt6vectorIN4llvm15CalleeSavedInfoESaIS1_EEC2ERKS3_", "std::vector<llvm::CalleeSavedInfo, std::allocator<llvm::CalleeSavedInfo> >::vector(std::vector<llvm::CalleeSavedInfo, std::allocator<llvm::CalleeSavedInfo> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockENS_15SparseBitVectorILj128EEENS_12DenseMapInfoIS2_EENS5_IS4_EEE16FindAndConstructERKS2_", "llvm::DenseMap<llvm::MachineBasicBlock*, llvm::SparseBitVector<128u>, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::SparseBitVector<128u> > >::FindAndConstruct(llvm::MachineBasicBlock* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockENS_15SparseBitVectorILj128EEENS_12DenseMapInfoIS2_EENS5_IS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<llvm::MachineBasicBlock*, llvm::SparseBitVector<128u>, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::SparseBitVector<128u> > >::InsertIntoBucket(llvm::MachineBasicBlock* const&, llvm::SparseBitVector<128u> const&, std::pair<llvm::MachineBasicBlock*, llvm::SparseBitVector<128u> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockENS_15SparseBitVectorILj128EEENS_12DenseMapInfoIS2_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::MachineBasicBlock*, llvm::SparseBitVector<128u>, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::SparseBitVector<128u> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockENS_15SparseBitVectorILj128EEENS_12DenseMapInfoIS2_EENS5_IS4_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::MachineBasicBlock*, llvm::SparseBitVector<128u>, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<llvm::SparseBitVector<128u> > >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm2cl3optI20ShrinkWrapDebugLevelLb0ENS0_6parserIS2_EEE16handleOccurrenceEjNS_9StringRefES6_", "llvm::cl::opt<ShrinkWrapDebugLevel, false, llvm::cl::parser<ShrinkWrapDebugLevel> >::handleOccurrence(unsigned int, llvm::StringRef, llvm::StringRef)"),
	mu_demangle_test("_ZNK4llvm2cl3optI20ShrinkWrapDebugLevelLb0ENS0_6parserIS2_EEE27getValueExpectedFlagDefaultEv", "llvm::cl::opt<ShrinkWrapDebugLevel, false, llvm::cl::parser<ShrinkWrapDebugLevel> >::getValueExpectedFlagDefault() const"),
	mu_demangle_test("_ZNK4llvm2cl3optI20ShrinkWrapDebugLevelLb0ENS0_6parserIS2_EEE14getOptionWidthEv", "llvm::cl::opt<ShrinkWrapDebugLevel, false, llvm::cl::parser<ShrinkWrapDebugLevel> >::getOptionWidth() const"),
	mu_demangle_test("_ZNK4llvm2cl3optI20ShrinkWrapDebugLevelLb0ENS0_6parserIS2_EEE15printOptionInfoEm", "llvm::cl::opt<ShrinkWrapDebugLevel, false, llvm::cl::parser<ShrinkWrapDebugLevel> >::printOptionInfo(unsigned long) const"),
	mu_demangle_test("_ZN4llvm2cl3optI20ShrinkWrapDebugLevelLb0ENS0_6parserIS2_EEE19getExtraOptionNamesERNS_15SmallVectorImplIPKcEE", "llvm::cl::opt<ShrinkWrapDebugLevel, false, llvm::cl::parser<ShrinkWrapDebugLevel> >::getExtraOptionNames(llvm::SmallVectorImpl<char const*>&)"),
	mu_demangle_test("_ZN4llvm2cl3optI20ShrinkWrapDebugLevelLb0ENS0_6parserIS2_EEED0Ev", "llvm::cl::opt<ShrinkWrapDebugLevel, false, llvm::cl::parser<ShrinkWrapDebugLevel> >::~opt()"),
	mu_demangle_test("_ZNK4llvm2cl11ValuesClassIiE5applyINS0_3optI20ShrinkWrapDebugLevelLb0ENS0_6parserIS5_EEEEEEvRT_", "void llvm::cl::ValuesClass<int>::apply<llvm::cl::opt<ShrinkWrapDebugLevel, false, llvm::cl::parser<ShrinkWrapDebugLevel> > >(llvm::cl::opt<ShrinkWrapDebugLevel, false, llvm::cl::parser<ShrinkWrapDebugLevel> >&) const"),
	mu_demangle_test("_ZN4llvm2cl3optISsLb0ENS0_6parserISsEEEC2IA17_cNS0_12OptionHiddenENS0_4descENS0_10value_descENS0_11initializerIA1_cEEEERKT_RKT0_RKT1_RKT2_RKT3_", "llvm::cl::opt<std::string, false, llvm::cl::parser<std::string> >::opt<char [17], llvm::cl::OptionHidden, llvm::cl::desc, llvm::cl::value_desc, llvm::cl::initializer<char [1]> >(char const (&) [17], llvm::cl::OptionHidden const&, llvm::cl::desc const&, llvm::cl::value_desc const&, llvm::cl::initializer<char [1]> const&)"),
	mu_demangle_test("_Z17ComputeUltimateVNPN4llvm6VNInfoERNS_11SmallVectorIS1_Lj16EEERNS_8DenseMapIS1_S1_NS_12DenseMapInfoIS1_EES7_EES9_RNS2_IiLj16EEESB_", "ComputeUltimateVN(llvm::VNInfo*, llvm::SmallVector<llvm::VNInfo*, 16u>&, llvm::DenseMap<llvm::VNInfo*, llvm::VNInfo*, llvm::DenseMapInfo<llvm::VNInfo*>, llvm::DenseMapInfo<llvm::VNInfo*> >&, llvm::DenseMap<llvm::VNInfo*, llvm::VNInfo*, llvm::DenseMapInfo<llvm::VNInfo*>, llvm::DenseMapInfo<llvm::VNInfo*> >&, llvm::SmallVector<int, 16u>&, llvm::SmallVector<int, 16u>&)"),
	mu_demangle_test("_ZN4llvm24SimpleRegisterCoalescing17CopyCoalesceInMBBEPNS_17MachineBasicBlockERSt6vectorINS_7CopyRecESaIS4_EE", "llvm::SimpleRegisterCoalescing::CopyCoalesceInMBB(llvm::MachineBasicBlock*, std::vector<llvm::CopyRec, std::allocator<llvm::CopyRec> >&)"),
	mu_demangle_test("_ZSt16__introsort_loopIN9__gnu_cxx17__normal_iteratorIPSt4pairIjPN4llvm17MachineBasicBlockEESt6vectorIS6_SaIS6_EEEElN12_GLOBAL__N_115DepthMBBCompareEEvT_SE_T0_T1_", "void std::__introsort_loop<__gnu_cxx::__normal_iterator<std::pair<unsigned int, llvm::MachineBasicBlock*>*, std::vector<std::pair<unsigned int, llvm::MachineBasicBlock*>, std::allocator<std::pair<unsigned int, llvm::MachineBasicBlock*> > > >, long, (anonymous namespace)::DepthMBBCompare>(__gnu_cxx::__normal_iterator<std::pair<unsigned int, llvm::MachineBasicBlock*>*, std::vector<std::pair<unsigned int, llvm::MachineBasicBlock*>, std::allocator<std::pair<unsigned int, llvm::MachineBasicBlock*> > > >, __gnu_cxx::__normal_iterator<std::pair<unsigned int, llvm::MachineBasicBlock*>*, std::vector<std::pair<unsigned int, llvm::MachineBasicBlock*>, std::allocator<std::pair<unsigned int, llvm::MachineBasicBlock*> > > >, long, (anonymous namespace)::DepthMBBCompare)"),
	mu_demangle_test("_ZSt16__insertion_sortIN9__gnu_cxx17__normal_iteratorIPSt4pairIjPN4llvm17MachineBasicBlockEESt6vectorIS6_SaIS6_EEEEN12_GLOBAL__N_115DepthMBBCompareEEvT_SE_T0_", "void std::__insertion_sort<__gnu_cxx::__normal_iterator<std::pair<unsigned int, llvm::MachineBasicBlock*>*, std::vector<std::pair<unsigned int, llvm::MachineBasicBlock*>, std::allocator<std::pair<unsigned int, llvm::MachineBasicBlock*> > > >, (anonymous namespace)::DepthMBBCompare>(__gnu_cxx::__normal_iterator<std::pair<unsigned int, llvm::MachineBasicBlock*>*, std::vector<std::pair<unsigned int, llvm::MachineBasicBlock*>, std::allocator<std::pair<unsigned int, llvm::MachineBasicBlock*> > > >, __gnu_cxx::__normal_iterator<std::pair<unsigned int, llvm::MachineBasicBlock*>*, std::vector<std::pair<unsigned int, llvm::MachineBasicBlock*>, std::allocator<std::pair<unsigned int, llvm::MachineBasicBlock*> > > >, (anonymous namespace)::DepthMBBCompare)"),
	mu_demangle_test("_ZSt13__adjust_heapIN9__gnu_cxx17__normal_iteratorIPSt4pairIjPN4llvm17MachineBasicBlockEESt6vectorIS6_SaIS6_EEEElS6_N12_GLOBAL__N_115DepthMBBCompareEEvT_T0_SF_T1_T2_", "void std::__adjust_heap<__gnu_cxx::__normal_iterator<std::pair<unsigned int, llvm::MachineBasicBlock*>*, std::vector<std::pair<unsigned int, llvm::MachineBasicBlock*>, std::allocator<std::pair<unsigned int, llvm::MachineBasicBlock*> > > >, long, std::pair<unsigned int, llvm::MachineBasicBlock*>, (anonymous namespace)::DepthMBBCompare>(__gnu_cxx::__normal_iterator<std::pair<unsigned int, llvm::MachineBasicBlock*>*, std::vector<std::pair<unsigned int, llvm::MachineBasicBlock*>, std::allocator<std::pair<unsigned int, llvm::MachineBasicBlock*> > > >, long, long, std::pair<unsigned int, llvm::MachineBasicBlock*>, (anonymous namespace)::DepthMBBCompare)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIjPN4llvm17MachineBasicBlockEESaIS4_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS4_S6_EERKS4_", "std::vector<std::pair<unsigned int, llvm::MachineBasicBlock*>, std::allocator<std::pair<unsigned int, llvm::MachineBasicBlock*> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<unsigned int, llvm::MachineBasicBlock*>*, std::vector<std::pair<unsigned int, llvm::MachineBasicBlock*>, std::allocator<std::pair<unsigned int, llvm::MachineBasicBlock*> > > >, std::pair<unsigned int, llvm::MachineBasicBlock*> const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm7CopyRecESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<llvm::CopyRec, std::allocator<llvm::CopyRec> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::CopyRec*, std::vector<llvm::CopyRec, std::allocator<llvm::CopyRec> > >, llvm::CopyRec const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_6VNInfoES2_NS_12DenseMapInfoIS2_EES4_E16InsertIntoBucketERKS2_S7_PSt4pairIS2_S2_E", "llvm::DenseMap<llvm::VNInfo*, llvm::VNInfo*, llvm::DenseMapInfo<llvm::VNInfo*>, llvm::DenseMapInfo<llvm::VNInfo*> >::InsertIntoBucket(llvm::VNInfo* const&, llvm::VNInfo* const&, std::pair<llvm::VNInfo*, llvm::VNInfo*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_6VNInfoES2_NS_12DenseMapInfoIS2_EES4_E4growEj", "llvm::DenseMap<llvm::VNInfo*, llvm::VNInfo*, llvm::DenseMapInfo<llvm::VNInfo*>, llvm::DenseMapInfo<llvm::VNInfo*> >::grow(unsigned int)"),
	mu_demangle_test("_Z16MarkBlocksLiveInPN4llvm10BasicBlockERSt3setIS1_St4lessIS1_ESaIS1_EE", "MarkBlocksLiveIn(llvm::BasicBlock*, std::set<llvm::BasicBlock*, std::less<llvm::BasicBlock*>, std::allocator<llvm::BasicBlock*> >&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm10BasicBlockES2_St9_IdentityIS2_ESt4lessIS2_ESaIS2_EE8_M_eraseEPSt13_Rb_tree_nodeIS2_E", "std::_Rb_tree<llvm::BasicBlock*, llvm::BasicBlock*, std::_Identity<llvm::BasicBlock*>, std::less<llvm::BasicBlock*>, std::allocator<llvm::BasicBlock*> >::_M_erase(std::_Rb_tree_node<llvm::BasicBlock*>*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm10BasicBlockES2_St9_IdentityIS2_ESt4lessIS2_ESaIS2_EE16_M_insert_uniqueERKS2_", "std::_Rb_tree<llvm::BasicBlock*, llvm::BasicBlock*, std::_Identity<llvm::BasicBlock*>, std::less<llvm::BasicBlock*>, std::allocator<llvm::BasicBlock*> >::_M_insert_unique(llvm::BasicBlock* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_12MachineInstrENS_9SlotIndexENS_12DenseMapInfoIS3_EENS5_IS4_EEE6insertERKSt4pairIS3_S4_E", "llvm::DenseMap<llvm::MachineInstr const*, llvm::SlotIndex, llvm::DenseMapInfo<llvm::MachineInstr const*>, llvm::DenseMapInfo<llvm::SlotIndex> >::insert(std::pair<llvm::MachineInstr const*, llvm::SlotIndex> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_17MachineBasicBlockESt4pairINS_9SlotIndexES5_ENS_12DenseMapInfoIS3_EENS7_IS6_EEE6insertERKS4_IS3_S6_E", "llvm::DenseMap<llvm::MachineBasicBlock const*, std::pair<llvm::SlotIndex, llvm::SlotIndex>, llvm::DenseMapInfo<llvm::MachineBasicBlock const*>, llvm::DenseMapInfo<std::pair<llvm::SlotIndex, llvm::SlotIndex> > >::insert(std::pair<llvm::MachineBasicBlock const*, std::pair<llvm::SlotIndex, llvm::SlotIndex> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_17MachineBasicBlockESt4pairINS_9SlotIndexES5_ENS_12DenseMapInfoIS3_EENS7_IS6_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::MachineBasicBlock const*, std::pair<llvm::SlotIndex, llvm::SlotIndex>, llvm::DenseMapInfo<llvm::MachineBasicBlock const*>, llvm::DenseMapInfo<std::pair<llvm::SlotIndex, llvm::SlotIndex> > >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_12MachineInstrENS_9SlotIndexENS_12DenseMapInfoIS3_EENS5_IS4_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::MachineInstr const*, llvm::SlotIndex, llvm::DenseMapInfo<llvm::MachineInstr const*>, llvm::DenseMapInfo<llvm::SlotIndex> >::shrink_and_clear()"),
	mu_demangle_test("_ZSt16__introsort_loopIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm9SlotIndexEPNS3_17MachineBasicBlockEESt6vectorIS7_SaIS7_EEEElNS3_14Idx2MBBCompareEEvT_SE_T0_T1_", "void std::__introsort_loop<__gnu_cxx::__normal_iterator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>*, std::vector<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>, std::allocator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*> > > >, long, llvm::Idx2MBBCompare>(__gnu_cxx::__normal_iterator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>*, std::vector<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>, std::allocator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>*, std::vector<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>, std::allocator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*> > > >, long, llvm::Idx2MBBCompare)"),
	mu_demangle_test("_ZSt22__final_insertion_sortIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm9SlotIndexEPNS3_17MachineBasicBlockEESt6vectorIS7_SaIS7_EEEENS3_14Idx2MBBCompareEEvT_SE_T0_", "void std::__final_insertion_sort<__gnu_cxx::__normal_iterator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>*, std::vector<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>, std::allocator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*> > > >, llvm::Idx2MBBCompare>(__gnu_cxx::__normal_iterator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>*, std::vector<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>, std::allocator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>*, std::vector<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>, std::allocator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*> > > >, llvm::Idx2MBBCompare)"),
	mu_demangle_test("_ZSt16__insertion_sortIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm9SlotIndexEPNS3_17MachineBasicBlockEESt6vectorIS7_SaIS7_EEEENS3_14Idx2MBBCompareEEvT_SE_T0_", "void std::__insertion_sort<__gnu_cxx::__normal_iterator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>*, std::vector<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>, std::allocator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*> > > >, llvm::Idx2MBBCompare>(__gnu_cxx::__normal_iterator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>*, std::vector<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>, std::allocator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>*, std::vector<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>, std::allocator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*> > > >, llvm::Idx2MBBCompare)"),
	mu_demangle_test("_ZSt21__unguarded_partitionIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm9SlotIndexEPNS3_17MachineBasicBlockEESt6vectorIS7_SaIS7_EEEES7_NS3_14Idx2MBBCompareEET_SE_SE_T0_T1_", "__gnu_cxx::__normal_iterator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>*, std::vector<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>, std::allocator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*> > > > std::__unguarded_partition<__gnu_cxx::__normal_iterator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>*, std::vector<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>, std::allocator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*> > > >, std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>, llvm::Idx2MBBCompare>(__gnu_cxx::__normal_iterator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>*, std::vector<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>, std::allocator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>*, std::vector<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>, std::allocator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*> > > >, std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>, llvm::Idx2MBBCompare)"),
	mu_demangle_test("_ZSt13__heap_selectIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm9SlotIndexEPNS3_17MachineBasicBlockEESt6vectorIS7_SaIS7_EEEENS3_14Idx2MBBCompareEEvT_SE_SE_T0_", "void std::__heap_select<__gnu_cxx::__normal_iterator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>*, std::vector<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>, std::allocator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*> > > >, llvm::Idx2MBBCompare>(__gnu_cxx::__normal_iterator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>*, std::vector<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>, std::allocator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>*, std::vector<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>, std::allocator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>*, std::vector<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>, std::allocator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*> > > >, llvm::Idx2MBBCompare)"),
	mu_demangle_test("_ZSt13__adjust_heapIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm9SlotIndexEPNS3_17MachineBasicBlockEESt6vectorIS7_SaIS7_EEEElS7_NS3_14Idx2MBBCompareEEvT_T0_SF_T1_T2_", "void std::__adjust_heap<__gnu_cxx::__normal_iterator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>*, std::vector<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>, std::allocator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*> > > >, long, std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>, llvm::Idx2MBBCompare>(__gnu_cxx::__normal_iterator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>*, std::vector<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>, std::allocator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*> > > >, long, long, std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>, llvm::Idx2MBBCompare)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN4llvm9SlotIndexEPNS1_17MachineBasicBlockEESaIS5_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS5_S7_EERKS5_", "std::vector<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>, std::allocator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>*, std::vector<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*>, std::allocator<std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*> > > >, std::pair<llvm::SlotIndex, llvm::MachineBasicBlock*> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_17MachineBasicBlockESt4pairINS_9SlotIndexES5_ENS_12DenseMapInfoIS3_EENS7_IS6_EEE16InsertIntoBucketERKS3_RKS6_PS4_IS3_S6_E", "llvm::DenseMap<llvm::MachineBasicBlock const*, std::pair<llvm::SlotIndex, llvm::SlotIndex>, llvm::DenseMapInfo<llvm::MachineBasicBlock const*>, llvm::DenseMapInfo<std::pair<llvm::SlotIndex, llvm::SlotIndex> > >::InsertIntoBucket(llvm::MachineBasicBlock const* const&, std::pair<llvm::SlotIndex, llvm::SlotIndex> const&, std::pair<llvm::MachineBasicBlock const*, std::pair<llvm::SlotIndex, llvm::SlotIndex> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_17MachineBasicBlockESt4pairINS_9SlotIndexES5_ENS_12DenseMapInfoIS3_EENS7_IS6_EEE4growEj", "llvm::DenseMap<llvm::MachineBasicBlock const*, std::pair<llvm::SlotIndex, llvm::SlotIndex>, llvm::DenseMapInfo<llvm::MachineBasicBlock const*>, llvm::DenseMapInfo<std::pair<llvm::SlotIndex, llvm::SlotIndex> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_12MachineInstrENS_9SlotIndexENS_12DenseMapInfoIS3_EENS5_IS4_EEE16InsertIntoBucketERKS3_RKS4_PSt4pairIS3_S4_E", "llvm::DenseMap<llvm::MachineInstr const*, llvm::SlotIndex, llvm::DenseMapInfo<llvm::MachineInstr const*>, llvm::DenseMapInfo<llvm::SlotIndex> >::InsertIntoBucket(llvm::MachineInstr const* const&, llvm::SlotIndex const&, std::pair<llvm::MachineInstr const*, llvm::SlotIndex>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_12MachineInstrENS_9SlotIndexENS_12DenseMapInfoIS3_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::MachineInstr const*, llvm::SlotIndex, llvm::DenseMapInfo<llvm::MachineInstr const*>, llvm::DenseMapInfo<llvm::SlotIndex> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm2cl3optIN12_GLOBAL__N_111SpillerNameELb0ENS0_6parserIS3_EEED1Ev", "llvm::cl::opt<(anonymous namespace)::SpillerName, false, llvm::cl::parser<(anonymous namespace)::SpillerName> >::~opt()"),
	mu_demangle_test("_ZN4llvm2cl3optIN12_GLOBAL__N_111SpillerNameELb0ENS0_6parserIS3_EEE16handleOccurrenceEjNS_9StringRefES7_", "llvm::cl::opt<(anonymous namespace)::SpillerName, false, llvm::cl::parser<(anonymous namespace)::SpillerName> >::handleOccurrence(unsigned int, llvm::StringRef, llvm::StringRef)"),
	mu_demangle_test("_ZNK4llvm2cl3optIN12_GLOBAL__N_111SpillerNameELb0ENS0_6parserIS3_EEE27getValueExpectedFlagDefaultEv", "llvm::cl::opt<(anonymous namespace)::SpillerName, false, llvm::cl::parser<(anonymous namespace)::SpillerName> >::getValueExpectedFlagDefault() const"),
	mu_demangle_test("_ZNK4llvm2cl3optIN12_GLOBAL__N_111SpillerNameELb0ENS0_6parserIS3_EEE14getOptionWidthEv", "llvm::cl::opt<(anonymous namespace)::SpillerName, false, llvm::cl::parser<(anonymous namespace)::SpillerName> >::getOptionWidth() const"),
	mu_demangle_test("_ZNK4llvm2cl3optIN12_GLOBAL__N_111SpillerNameELb0ENS0_6parserIS3_EEE15printOptionInfoEm", "llvm::cl::opt<(anonymous namespace)::SpillerName, false, llvm::cl::parser<(anonymous namespace)::SpillerName> >::printOptionInfo(unsigned long) const"),
	mu_demangle_test("_ZN4llvm2cl3optIN12_GLOBAL__N_111SpillerNameELb0ENS0_6parserIS3_EEE19getExtraOptionNamesERNS_15SmallVectorImplIPKcEE", "llvm::cl::opt<(anonymous namespace)::SpillerName, false, llvm::cl::parser<(anonymous namespace)::SpillerName> >::getExtraOptionNames(llvm::SmallVectorImpl<char const*>&)"),
	mu_demangle_test("_ZN4llvm2cl3optIN12_GLOBAL__N_111SpillerNameELb0ENS0_6parserIS3_EEED0Ev", "llvm::cl::opt<(anonymous namespace)::SpillerName, false, llvm::cl::parser<(anonymous namespace)::SpillerName> >::~opt()"),
	mu_demangle_test("_ZN4llvm15SmallVectorImplIPNS_12LiveIntervalEE6insertIN9__gnu_cxx17__normal_iteratorIPS2_St6vectorIS2_SaIS2_EEEEEES7_S7_T_SC_", "llvm::LiveInterval** llvm::SmallVectorImpl<llvm::LiveInterval*>::insert<__gnu_cxx::__normal_iterator<llvm::LiveInterval**, std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> > > >(llvm::LiveInterval**, __gnu_cxx::__normal_iterator<llvm::LiveInterval**, std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> > >, __gnu_cxx::__normal_iterator<llvm::LiveInterval**, std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> > >)"),
	mu_demangle_test("_ZSt21__inplace_stable_sortIN9__gnu_cxx17__normal_iteratorIPPN4llvm12LiveIntervalESt6vectorIS4_SaIS4_EEEEN12_GLOBAL__N_114IntervalSorterEEvT_SC_T0_", "void std::__inplace_stable_sort<__gnu_cxx::__normal_iterator<llvm::LiveInterval**, std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> > >, (anonymous namespace)::IntervalSorter>(__gnu_cxx::__normal_iterator<llvm::LiveInterval**, std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> > >, __gnu_cxx::__normal_iterator<llvm::LiveInterval**, std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> > >, (anonymous namespace)::IntervalSorter)"),
	mu_demangle_test("_ZSt22__stable_sort_adaptiveIN9__gnu_cxx17__normal_iteratorIPPN4llvm12LiveIntervalESt6vectorIS4_SaIS4_EEEES5_lN12_GLOBAL__N_114IntervalSorterEEvT_SC_T0_T1_T2_", "void std::__stable_sort_adaptive<__gnu_cxx::__normal_iterator<llvm::LiveInterval**, std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> > >, llvm::LiveInterval**, long, (anonymous namespace)::IntervalSorter>(__gnu_cxx::__normal_iterator<llvm::LiveInterval**, std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> > >, __gnu_cxx::__normal_iterator<llvm::LiveInterval**, std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> > >, llvm::LiveInterval**, long, (anonymous namespace)::IntervalSorter)"),
	mu_demangle_test("_ZSt24__merge_sort_with_bufferIN9__gnu_cxx17__normal_iteratorIPPN4llvm12LiveIntervalESt6vectorIS4_SaIS4_EEEES5_N12_GLOBAL__N_114IntervalSorterEEvT_SC_T0_T1_", "void std::__merge_sort_with_buffer<__gnu_cxx::__normal_iterator<llvm::LiveInterval**, std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> > >, llvm::LiveInterval**, (anonymous namespace)::IntervalSorter>(__gnu_cxx::__normal_iterator<llvm::LiveInterval**, std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> > >, __gnu_cxx::__normal_iterator<llvm::LiveInterval**, std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> > >, llvm::LiveInterval**, (anonymous namespace)::IntervalSorter)"),
	mu_demangle_test("_ZSt16__merge_adaptiveIN9__gnu_cxx17__normal_iteratorIPPN4llvm12LiveIntervalESt6vectorIS4_SaIS4_EEEElS5_N12_GLOBAL__N_114IntervalSorterEEvT_SC_SC_T0_SD_T1_SD_T2_", "void std::__merge_adaptive<__gnu_cxx::__normal_iterator<llvm::LiveInterval**, std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> > >, long, llvm::LiveInterval**, (anonymous namespace)::IntervalSorter>(__gnu_cxx::__normal_iterator<llvm::LiveInterval**, std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> > >, __gnu_cxx::__normal_iterator<llvm::LiveInterval**, std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> > >, __gnu_cxx::__normal_iterator<llvm::LiveInterval**, std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> > >, long, long, llvm::LiveInterval**, long, (anonymous namespace)::IntervalSorter)"),
	mu_demangle_test("_ZSt22__merge_without_bufferIN9__gnu_cxx17__normal_iteratorIPPN4llvm12LiveIntervalESt6vectorIS4_SaIS4_EEEElN12_GLOBAL__N_114IntervalSorterEEvT_SC_SC_T0_SD_T1_", "void std::__merge_without_buffer<__gnu_cxx::__normal_iterator<llvm::LiveInterval**, std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> > >, long, (anonymous namespace)::IntervalSorter>(__gnu_cxx::__normal_iterator<llvm::LiveInterval**, std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> > >, __gnu_cxx::__normal_iterator<llvm::LiveInterval**, std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> > >, __gnu_cxx::__normal_iterator<llvm::LiveInterval**, std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> > >, long, long, (anonymous namespace)::IntervalSorter)"),
	mu_demangle_test("_ZN4llvm15SmallVectorImplINS_8SmallSetIjLj4EEEED2Ev", "llvm::SmallVectorImpl<llvm::SmallSet<unsigned int, 4u> >::~SmallVectorImpl()"),
	mu_demangle_test("_ZN4llvm15SmallVectorImplINS_8SmallSetIjLj4EEEE9push_backERKS2_", "llvm::SmallVectorImpl<llvm::SmallSet<unsigned int, 4u> >::push_back(llvm::SmallSet<unsigned int, 4u> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjjSt9_IdentityIjESt4lessIjESaIjEE7_M_copyEPKSt13_Rb_tree_nodeIjEPS7_", "std::_Rb_tree<unsigned int, unsigned int, std::_Identity<unsigned int>, std::less<unsigned int>, std::allocator<unsigned int> >::_M_copy(std::_Rb_tree_node<unsigned int> const*, std::_Rb_tree_node<unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_19TargetRegisterClassENS_9BitVectorENS_12DenseMapInfoIS3_EENS5_IS4_EEE16FindAndConstructERKS3_", "llvm::DenseMap<llvm::TargetRegisterClass const*, llvm::BitVector, llvm::DenseMapInfo<llvm::TargetRegisterClass const*>, llvm::DenseMapInfo<llvm::BitVector> >::FindAndConstruct(llvm::TargetRegisterClass const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_19TargetRegisterClassENS_9BitVectorENS_12DenseMapInfoIS3_EENS5_IS4_EEE16InsertIntoBucketERKS3_RKS4_PSt4pairIS3_S4_E", "llvm::DenseMap<llvm::TargetRegisterClass const*, llvm::BitVector, llvm::DenseMapInfo<llvm::TargetRegisterClass const*>, llvm::DenseMapInfo<llvm::BitVector> >::InsertIntoBucket(llvm::TargetRegisterClass const* const&, llvm::BitVector const&, std::pair<llvm::TargetRegisterClass const*, llvm::BitVector>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_19TargetRegisterClassENS_9BitVectorENS_12DenseMapInfoIS3_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::TargetRegisterClass const*, llvm::BitVector, llvm::DenseMapInfo<llvm::TargetRegisterClass const*>, llvm::DenseMapInfo<llvm::BitVector> >::grow(unsigned int)"),
	mu_demangle_test("_ZSt8__rotateIN9__gnu_cxx17__normal_iteratorIPPN4llvm12LiveIntervalESt6vectorIS4_SaIS4_EEEEEvT_SA_SA_St26random_access_iterator_tag", "void std::__rotate<__gnu_cxx::__normal_iterator<llvm::LiveInterval**, std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> > > >(__gnu_cxx::__normal_iterator<llvm::LiveInterval**, std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> > >, __gnu_cxx::__normal_iterator<llvm::LiveInterval**, std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> > >, __gnu_cxx::__normal_iterator<llvm::LiveInterval**, std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> > >, std::random_access_iterator_tag)"),
	mu_demangle_test("_ZN4llvm15SmallVectorImplINS_11SmallVectorIPNS_12LiveIntervalELj4EEEE6resizeEj", "llvm::SmallVectorImpl<llvm::SmallVector<llvm::LiveInterval*, 4u> >::resize(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm12LiveIntervalESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::LiveInterval**, std::vector<llvm::LiveInterval*, std::allocator<llvm::LiveInterval*> > >, llvm::LiveInterval* const&)"),
	mu_demangle_test("_ZN4llvm15SmallVectorImplINS_11SmallVectorIPNS_12MachineInstrELj8EEEE6resizeEj", "llvm::SmallVectorImpl<llvm::SmallVector<llvm::MachineInstr*, 8u> >::resize(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPN12_GLOBAL__N_120StrongPHIElimination4NodeENS_12DenseMapInfoIjEENS5_IS4_EEE5clearEv", "llvm::DenseMap<unsigned int, (anonymous namespace)::StrongPHIElimination::Node*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<(anonymous namespace)::StrongPHIElimination::Node*> >::clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPN12_GLOBAL__N_120StrongPHIElimination4NodeENS_12DenseMapInfoIjEENS5_IS4_EEEixERKj", "llvm::DenseMap<unsigned int, (anonymous namespace)::StrongPHIElimination::Node*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<(anonymous namespace)::StrongPHIElimination::Node*> >::operator[](unsigned int const&)"),
	mu_demangle_test("_ZSt16__introsort_loopIN9__gnu_cxx17__normal_iteratorIPPN4llvm12MachineInstrESt6vectorIS4_SaIS4_EEEElN12_GLOBAL__N_114MIIndexCompareEEvT_SC_T0_T1_", "void std::__introsort_loop<__gnu_cxx::__normal_iterator<llvm::MachineInstr**, std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> > >, long, (anonymous namespace)::MIIndexCompare>(__gnu_cxx::__normal_iterator<llvm::MachineInstr**, std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> > >, __gnu_cxx::__normal_iterator<llvm::MachineInstr**, std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> > >, long, (anonymous namespace)::MIIndexCompare)"),
	mu_demangle_test("_ZSt16__insertion_sortIN9__gnu_cxx17__normal_iteratorIPPN4llvm12MachineInstrESt6vectorIS4_SaIS4_EEEEN12_GLOBAL__N_114MIIndexCompareEEvT_SC_T0_", "void std::__insertion_sort<__gnu_cxx::__normal_iterator<llvm::MachineInstr**, std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> > >, (anonymous namespace)::MIIndexCompare>(__gnu_cxx::__normal_iterator<llvm::MachineInstr**, std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> > >, __gnu_cxx::__normal_iterator<llvm::MachineInstr**, std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> > >, (anonymous namespace)::MIIndexCompare)"),
	mu_demangle_test("_ZSt13__adjust_heapIN9__gnu_cxx17__normal_iteratorIPPN4llvm12MachineInstrESt6vectorIS4_SaIS4_EEEElS4_N12_GLOBAL__N_114MIIndexCompareEEvT_T0_SD_T1_T2_", "void std::__adjust_heap<__gnu_cxx::__normal_iterator<llvm::MachineInstr**, std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> > >, long, llvm::MachineInstr*, (anonymous namespace)::MIIndexCompare>(__gnu_cxx::__normal_iterator<llvm::MachineInstr**, std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> > >, long, long, llvm::MachineInstr*, (anonymous namespace)::MIIndexCompare)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockESt6vectorIPNS_12MachineInstrESaIS5_EENS_12DenseMapInfoIS2_EENS8_IS7_EEE5clearEv", "llvm::DenseMap<llvm::MachineBasicBlock*, std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> >, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> > > >::clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPNS_17MachineBasicBlockEjEPNS_12MachineInstrENS_12DenseMapInfoIS4_EENS7_IS6_EEE5clearEv", "llvm::DenseMap<std::pair<llvm::MachineBasicBlock*, unsigned int>, llvm::MachineInstr*, llvm::DenseMapInfo<std::pair<llvm::MachineBasicBlock*, unsigned int> >, llvm::DenseMapInfo<llvm::MachineInstr*> >::clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPNS_17MachineBasicBlockEjEPNS_12MachineInstrENS_12DenseMapInfoIS4_EENS7_IS6_EEE16shrink_and_clearEv", "llvm::DenseMap<std::pair<llvm::MachineBasicBlock*, unsigned int>, llvm::MachineInstr*, llvm::DenseMapInfo<std::pair<llvm::MachineBasicBlock*, unsigned int> >, llvm::DenseMapInfo<llvm::MachineInstr*> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPNS_17MachineBasicBlockEjEcNS_12DenseMapInfoIS4_EENS5_IcEEE5clearEv", "llvm::DenseMap<std::pair<llvm::MachineBasicBlock*, unsigned int>, char, llvm::DenseMapInfo<std::pair<llvm::MachineBasicBlock*, unsigned int> >, llvm::DenseMapInfo<char> >::clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPNS_17MachineBasicBlockEjEcNS_12DenseMapInfoIS4_EENS5_IcEEE16shrink_and_clearEv", "llvm::DenseMap<std::pair<llvm::MachineBasicBlock*, unsigned int>, char, llvm::DenseMapInfo<std::pair<llvm::MachineBasicBlock*, unsigned int> >, llvm::DenseMapInfo<char> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockESt6vectorIPNS_12MachineInstrESaIS5_EENS_12DenseMapInfoIS2_EENS8_IS7_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::MachineBasicBlock*, std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> >, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> > > >::shrink_and_clear()"),
	mu_demangle_test("_ZNK4llvm8DenseMapISt4pairIPNS_17MachineBasicBlockEjEPNS_12MachineInstrENS_12DenseMapInfoIS4_EENS7_IS6_EEE15LookupBucketForERKS4_RPS1_IS4_S6_E", "llvm::DenseMap<std::pair<llvm::MachineBasicBlock*, unsigned int>, llvm::MachineInstr*, llvm::DenseMapInfo<std::pair<llvm::MachineBasicBlock*, unsigned int> >, llvm::DenseMapInfo<llvm::MachineInstr*> >::LookupBucketFor(std::pair<llvm::MachineBasicBlock*, unsigned int> const&, std::pair<std::pair<llvm::MachineBasicBlock*, unsigned int>, llvm::MachineInstr*>*&) const"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPNS_17MachineBasicBlockEjEPNS_12MachineInstrENS_12DenseMapInfoIS4_EENS7_IS6_EEE16InsertIntoBucketERKS4_RKS6_PS1_IS4_S6_E", "llvm::DenseMap<std::pair<llvm::MachineBasicBlock*, unsigned int>, llvm::MachineInstr*, llvm::DenseMapInfo<std::pair<llvm::MachineBasicBlock*, unsigned int> >, llvm::DenseMapInfo<llvm::MachineInstr*> >::InsertIntoBucket(std::pair<llvm::MachineBasicBlock*, unsigned int> const&, llvm::MachineInstr* const&, std::pair<std::pair<llvm::MachineBasicBlock*, unsigned int>, llvm::MachineInstr*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPNS_17MachineBasicBlockEjEPNS_12MachineInstrENS_12DenseMapInfoIS4_EENS7_IS6_EEE4growEj", "llvm::DenseMap<std::pair<llvm::MachineBasicBlock*, unsigned int>, llvm::MachineInstr*, llvm::DenseMapInfo<std::pair<llvm::MachineBasicBlock*, unsigned int> >, llvm::DenseMapInfo<llvm::MachineInstr*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPNS_17MachineBasicBlockEjEcNS_12DenseMapInfoIS4_EENS5_IcEEE6insertERKS1_IS4_cE", "llvm::DenseMap<std::pair<llvm::MachineBasicBlock*, unsigned int>, char, llvm::DenseMapInfo<std::pair<llvm::MachineBasicBlock*, unsigned int> >, llvm::DenseMapInfo<char> >::insert(std::pair<std::pair<llvm::MachineBasicBlock*, unsigned int>, char> const&)"),
	mu_demangle_test("_ZNK4llvm8DenseMapISt4pairIPNS_17MachineBasicBlockEjEcNS_12DenseMapInfoIS4_EENS5_IcEEE15LookupBucketForERKS4_RPS1_IS4_cE", "llvm::DenseMap<std::pair<llvm::MachineBasicBlock*, unsigned int>, char, llvm::DenseMapInfo<std::pair<llvm::MachineBasicBlock*, unsigned int> >, llvm::DenseMapInfo<char> >::LookupBucketFor(std::pair<llvm::MachineBasicBlock*, unsigned int> const&, std::pair<std::pair<llvm::MachineBasicBlock*, unsigned int>, char>*&) const"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPNS_17MachineBasicBlockEjEcNS_12DenseMapInfoIS4_EENS5_IcEEE16InsertIntoBucketERKS4_RKcPS1_IS4_cE", "llvm::DenseMap<std::pair<llvm::MachineBasicBlock*, unsigned int>, char, llvm::DenseMapInfo<std::pair<llvm::MachineBasicBlock*, unsigned int> >, llvm::DenseMapInfo<char> >::InsertIntoBucket(std::pair<llvm::MachineBasicBlock*, unsigned int> const&, char const&, std::pair<std::pair<llvm::MachineBasicBlock*, unsigned int>, char>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPNS_17MachineBasicBlockEjEcNS_12DenseMapInfoIS4_EENS5_IcEEE4growEj", "llvm::DenseMap<std::pair<llvm::MachineBasicBlock*, unsigned int>, char, llvm::DenseMapInfo<std::pair<llvm::MachineBasicBlock*, unsigned int> >, llvm::DenseMapInfo<char> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm11df_iteratorIPNS_15DomTreeNodeBaseINS_17MachineBasicBlockEEENS_11SmallPtrSetIS4_Lj8EEELb0ENS_11GraphTraitsIS4_EEE6toNextEv", "llvm::df_iterator<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, llvm::SmallPtrSet<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, 8u>, false, llvm::GraphTraits<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*> >::toNext()"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN4llvm14PointerIntPairIPNS1_15DomTreeNodeBaseINS1_17MachineBasicBlockEEELj1EjNS1_21PointerLikeTypeTraitsIS6_EEEEN9__gnu_cxx17__normal_iteratorIPS6_S_IS6_SaIS6_EEEEESaISG_EE13_M_insert_auxENSB_IPSG_SI_EERKSG_", "std::vector<std::pair<llvm::PointerIntPair<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*> >, __gnu_cxx::__normal_iterator<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>**, std::vector<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, std::allocator<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*> > > >, std::allocator<std::pair<llvm::PointerIntPair<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*> >, __gnu_cxx::__normal_iterator<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>**, std::vector<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, std::allocator<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*> > > > > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::PointerIntPair<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*> >, __gnu_cxx::__normal_iterator<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>**, std::vector<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, std::allocator<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*> > > >*, std::vector<std::pair<llvm::PointerIntPair<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*> >, __gnu_cxx::__normal_iterator<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>**, std::vector<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, std::allocator<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*> > > >, std::allocator<std::pair<llvm::PointerIntPair<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*> >, __gnu_cxx::__normal_iterator<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>**, std::vector<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, std::allocator<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*> > > > > > >, std::pair<llvm::PointerIntPair<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*> >, __gnu_cxx::__normal_iterator<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>**, std::vector<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*, std::allocator<llvm::DomTreeNodeBase<llvm::MachineBasicBlock>*> > > > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjSt4pairIPNS_12MachineInstrEjENS_12DenseMapInfoIjEENS5_IS4_EEE16InsertIntoBucketERKjRKS4_PS1_IjS4_E", "llvm::DenseMap<unsigned int, std::pair<llvm::MachineInstr*, unsigned int>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<std::pair<llvm::MachineInstr*, unsigned int> > >::InsertIntoBucket(unsigned int const&, std::pair<llvm::MachineInstr*, unsigned int> const&, std::pair<unsigned int, std::pair<llvm::MachineInstr*, unsigned int> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjSt4pairIPNS_12MachineInstrEjENS_12DenseMapInfoIjEENS5_IS4_EEE4growEj", "llvm::DenseMap<unsigned int, std::pair<llvm::MachineInstr*, unsigned int>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<std::pair<llvm::MachineInstr*, unsigned int> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjSt4pairIPNS_12MachineInstrEjENS_12DenseMapInfoIjEENS5_IS4_EEE16shrink_and_clearEv", "llvm::DenseMap<unsigned int, std::pair<llvm::MachineInstr*, unsigned int>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<std::pair<llvm::MachineInstr*, unsigned int> > >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockESt6vectorIPNS_12MachineInstrESaIS5_EENS_12DenseMapInfoIS2_EENS8_IS7_EEE16FindAndConstructERKS2_", "llvm::DenseMap<llvm::MachineBasicBlock*, std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> >, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> > > >::FindAndConstruct(llvm::MachineBasicBlock* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockESt6vectorIPNS_12MachineInstrESaIS5_EENS_12DenseMapInfoIS2_EENS8_IS7_EEE16InsertIntoBucketERKS2_RKS7_PSt4pairIS2_S7_E", "llvm::DenseMap<llvm::MachineBasicBlock*, std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> >, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> > > >::InsertIntoBucket(llvm::MachineBasicBlock* const&, std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> > const&, std::pair<llvm::MachineBasicBlock*, std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> > >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_17MachineBasicBlockESt6vectorIPNS_12MachineInstrESaIS5_EENS_12DenseMapInfoIS2_EENS8_IS7_EEE4growEj", "llvm::DenseMap<llvm::MachineBasicBlock*, std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> >, llvm::DenseMapInfo<llvm::MachineBasicBlock*>, llvm::DenseMapInfo<std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> > > >::grow(unsigned int)"),
	mu_demangle_test("_ZN12_GLOBAL__N_117TailDuplicatePass10ProcessPHIEPN4llvm12MachineInstrEPNS1_17MachineBasicBlockES5_RNS1_8DenseMapIjjNS1_12DenseMapInfoIjEES8_EERNS1_11SmallVectorISt4pairIjjELj4EEE", "(anonymous namespace)::TailDuplicatePass::ProcessPHI(llvm::MachineInstr*, llvm::MachineBasicBlock*, llvm::MachineBasicBlock*, llvm::DenseMap<unsigned int, unsigned int, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<unsigned int> >&, llvm::SmallVector<std::pair<unsigned int, unsigned int>, 4u>&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_117TailDuplicatePass20DuplicateInstructionEPN4llvm12MachineInstrEPNS1_17MachineBasicBlockES5_RNS1_15MachineFunctionERNS1_8DenseMapIjjNS1_12DenseMapInfoIjEESA_EE", "(anonymous namespace)::TailDuplicatePass::DuplicateInstruction(llvm::MachineInstr*, llvm::MachineBasicBlock*, llvm::MachineBasicBlock*, llvm::MachineFunction&, llvm::DenseMap<unsigned int, unsigned int, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<unsigned int> >&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjSt6vectorISt4pairIPNS_17MachineBasicBlockEjESaIS5_EENS_12DenseMapInfoIjEENS8_IS7_EEE5clearEv", "llvm::DenseMap<unsigned int, std::vector<std::pair<llvm::MachineBasicBlock*, unsigned int>, std::allocator<std::pair<llvm::MachineBasicBlock*, unsigned int> > >, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<std::vector<std::pair<llvm::MachineBasicBlock*, unsigned int>, std::allocator<std::pair<llvm::MachineBasicBlock*, unsigned int> > > > >::clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIjSt6vectorISt4pairIPNS_17MachineBasicBlockEjESaIS5_EENS_12DenseMapInfoIjEENS8_IS7_EEE16shrink_and_clearEv", "llvm::DenseMap<unsigned int, std::vector<std::pair<llvm::MachineBasicBlock*, unsigned int>, std::allocator<std::pair<llvm::MachineBasicBlock*, unsigned int> > >, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<std::vector<std::pair<llvm::MachineBasicBlock*, unsigned int>, std::allocator<std::pair<llvm::MachineBasicBlock*, unsigned int> > > > >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIjSt6vectorISt4pairIPNS_17MachineBasicBlockEjESaIS5_EENS_12DenseMapInfoIjEENS8_IS7_EEE6insertERKS2_IjS7_E", "llvm::DenseMap<unsigned int, std::vector<std::pair<llvm::MachineBasicBlock*, unsigned int>, std::allocator<std::pair<llvm::MachineBasicBlock*, unsigned int> > >, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<std::vector<std::pair<llvm::MachineBasicBlock*, unsigned int>, std::allocator<std::pair<llvm::MachineBasicBlock*, unsigned int> > > > >::insert(std::pair<unsigned int, std::vector<std::pair<llvm::MachineBasicBlock*, unsigned int>, std::allocator<std::pair<llvm::MachineBasicBlock*, unsigned int> > > > const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPN4llvm17MachineBasicBlockEjESaIS4_EEC2ERKS6_", "std::vector<std::pair<llvm::MachineBasicBlock*, unsigned int>, std::allocator<std::pair<llvm::MachineBasicBlock*, unsigned int> > >::vector(std::vector<std::pair<llvm::MachineBasicBlock*, unsigned int>, std::allocator<std::pair<llvm::MachineBasicBlock*, unsigned int> > > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjSt6vectorISt4pairIPNS_17MachineBasicBlockEjESaIS5_EENS_12DenseMapInfoIjEENS8_IS7_EEE16InsertIntoBucketERKjRKS7_PS2_IjS7_E", "llvm::DenseMap<unsigned int, std::vector<std::pair<llvm::MachineBasicBlock*, unsigned int>, std::allocator<std::pair<llvm::MachineBasicBlock*, unsigned int> > >, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<std::vector<std::pair<llvm::MachineBasicBlock*, unsigned int>, std::allocator<std::pair<llvm::MachineBasicBlock*, unsigned int> > > > >::InsertIntoBucket(unsigned int const&, std::vector<std::pair<llvm::MachineBasicBlock*, unsigned int>, std::allocator<std::pair<llvm::MachineBasicBlock*, unsigned int> > > const&, std::pair<unsigned int, std::vector<std::pair<llvm::MachineBasicBlock*, unsigned int>, std::allocator<std::pair<llvm::MachineBasicBlock*, unsigned int> > > >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjSt6vectorISt4pairIPNS_17MachineBasicBlockEjESaIS5_EENS_12DenseMapInfoIjEENS8_IS7_EEE4growEj", "llvm::DenseMap<unsigned int, std::vector<std::pair<llvm::MachineBasicBlock*, unsigned int>, std::allocator<std::pair<llvm::MachineBasicBlock*, unsigned int> > >, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<std::vector<std::pair<llvm::MachineBasicBlock*, unsigned int>, std::allocator<std::pair<llvm::MachineBasicBlock*, unsigned int> > > > >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPN4llvm17MachineBasicBlockEjESaIS4_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS4_S6_EERKS4_", "std::vector<std::pair<llvm::MachineBasicBlock*, unsigned int>, std::allocator<std::pair<llvm::MachineBasicBlock*, unsigned int> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::MachineBasicBlock*, unsigned int>*, std::vector<std::pair<llvm::MachineBasicBlock*, unsigned int>, std::allocator<std::pair<llvm::MachineBasicBlock*, unsigned int> > > >, std::pair<llvm::MachineBasicBlock*, unsigned int> const&)"),
	mu_demangle_test("_ZN4llvm14SmallSetVectorIPNS_17MachineBasicBlockELj8EEC2IN9__gnu_cxx17__normal_iteratorIPS2_St6vectorIS2_SaIS2_EEEEEET_SC_", "llvm::SmallSetVector<llvm::MachineBasicBlock*, 8u>::SmallSetVector<__gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > > >(__gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > >, __gnu_cxx::__normal_iterator<llvm::MachineBasicBlock**, std::vector<llvm::MachineBasicBlock*, std::allocator<llvm::MachineBasicBlock*> > >)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjNS_11SmallVectorISt4pairIjjELj4EEENS_12DenseMapInfoIjEENS5_IS4_EEE6insertERKS2_IjS4_E", "llvm::DenseMap<unsigned int, llvm::SmallVector<std::pair<unsigned int, unsigned int>, 4u>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::SmallVector<std::pair<unsigned int, unsigned int>, 4u> > >::insert(std::pair<unsigned int, llvm::SmallVector<std::pair<unsigned int, unsigned int>, 4u> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjNS_11SmallVectorISt4pairIjjELj4EEENS_12DenseMapInfoIjEENS5_IS4_EEE5clearEv", "llvm::DenseMap<unsigned int, llvm::SmallVector<std::pair<unsigned int, unsigned int>, 4u>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::SmallVector<std::pair<unsigned int, unsigned int>, 4u> > >::clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIjNS_11SmallVectorISt4pairIjjELj4EEENS_12DenseMapInfoIjEENS5_IS4_EEE16shrink_and_clearEv", "llvm::DenseMap<unsigned int, llvm::SmallVector<std::pair<unsigned int, unsigned int>, 4u>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::SmallVector<std::pair<unsigned int, unsigned int>, 4u> > >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm15SmallVectorImplISt4pairIjjEEaSERKS3_", "llvm::SmallVectorImpl<std::pair<unsigned int, unsigned int> >::operator=(llvm::SmallVectorImpl<std::pair<unsigned int, unsigned int> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjNS_11SmallVectorISt4pairIjjELj4EEENS_12DenseMapInfoIjEENS5_IS4_EEE16InsertIntoBucketERKjRKS4_PS2_IjS4_E", "llvm::DenseMap<unsigned int, llvm::SmallVector<std::pair<unsigned int, unsigned int>, 4u>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::SmallVector<std::pair<unsigned int, unsigned int>, 4u> > >::InsertIntoBucket(unsigned int const&, llvm::SmallVector<std::pair<unsigned int, unsigned int>, 4u> const&, std::pair<unsigned int, llvm::SmallVector<std::pair<unsigned int, unsigned int>, 4u> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjNS_11SmallVectorISt4pairIjjELj4EEENS_12DenseMapInfoIjEENS5_IS4_EEE4growEj", "llvm::DenseMap<unsigned int, llvm::SmallVector<std::pair<unsigned int, unsigned int>, 4u>, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::SmallVector<std::pair<unsigned int, unsigned int>, 4u> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm12df_ext_beginIPNS_15MachineFunctionENS_11SmallPtrSetIPNS_17MachineBasicBlockELj8EEEEENS_15df_ext_iteratorIT_T0_EERKS8_RS9_", "llvm::df_ext_iterator<llvm::MachineFunction*, llvm::SmallPtrSet<llvm::MachineBasicBlock*, 8u> > llvm::df_ext_begin<llvm::MachineFunction*, llvm::SmallPtrSet<llvm::MachineBasicBlock*, 8u> >(llvm::MachineFunction* const&, llvm::SmallPtrSet<llvm::MachineBasicBlock*, 8u>&)"),
	mu_demangle_test("_ZN4llvm11df_iteratorIPNS_15MachineFunctionENS_11SmallPtrSetIPNS_17MachineBasicBlockELj8EEELb1ENS_11GraphTraitsIS2_EEE6toNextEv", "llvm::df_iterator<llvm::MachineFunction*, llvm::SmallPtrSet<llvm::MachineBasicBlock*, 8u>, true, llvm::GraphTraits<llvm::MachineFunction*> >::toNext()"),
	mu_demangle_test("_ZN4llvm11df_iteratorIPNS_15MachineFunctionENS_11SmallPtrSetIPNS_17MachineBasicBlockELj8EEELb1ENS_11GraphTraitsIS2_EEEC2ES5_RS6_", "llvm::df_iterator<llvm::MachineFunction*, llvm::SmallPtrSet<llvm::MachineBasicBlock*, 8u>, true, llvm::GraphTraits<llvm::MachineFunction*> >::df_iterator(llvm::MachineBasicBlock*, llvm::SmallPtrSet<llvm::MachineBasicBlock*, 8u>&)"),
	mu_demangle_test("_ZN4llvm12df_ext_beginIPNS_8FunctionENS_11SmallPtrSetIPNS_10BasicBlockELj8EEEEENS_15df_ext_iteratorIT_T0_EERKS8_RS9_", "llvm::df_ext_iterator<llvm::Function*, llvm::SmallPtrSet<llvm::BasicBlock*, 8u> > llvm::df_ext_begin<llvm::Function*, llvm::SmallPtrSet<llvm::BasicBlock*, 8u> >(llvm::Function* const&, llvm::SmallPtrSet<llvm::BasicBlock*, 8u>&)"),
	mu_demangle_test("_ZN4llvm11df_iteratorIPNS_8FunctionENS_11SmallPtrSetIPNS_10BasicBlockELj8EEELb1ENS_11GraphTraitsIS2_EEE6toNextEv", "llvm::df_iterator<llvm::Function*, llvm::SmallPtrSet<llvm::BasicBlock*, 8u>, true, llvm::GraphTraits<llvm::Function*> >::toNext()"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN4llvm14PointerIntPairIPNS1_10BasicBlockELj1EjNS1_21PointerLikeTypeTraitsIS4_EEEENS1_12SuccIteratorIPNS1_14TerminatorInstES3_EEESaISC_EEC2ERKSE_", "std::vector<std::pair<llvm::PointerIntPair<llvm::BasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::BasicBlock*> >, llvm::SuccIterator<llvm::TerminatorInst*, llvm::BasicBlock> >, std::allocator<std::pair<llvm::PointerIntPair<llvm::BasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::BasicBlock*> >, llvm::SuccIterator<llvm::TerminatorInst*, llvm::BasicBlock> > > >::vector(std::vector<std::pair<llvm::PointerIntPair<llvm::BasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::BasicBlock*> >, llvm::SuccIterator<llvm::TerminatorInst*, llvm::BasicBlock> >, std::allocator<std::pair<llvm::PointerIntPair<llvm::BasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::BasicBlock*> >, llvm::SuccIterator<llvm::TerminatorInst*, llvm::BasicBlock> > > > const&)"),
	mu_demangle_test("_ZN4llvm11df_iteratorIPNS_8FunctionENS_11SmallPtrSetIPNS_10BasicBlockELj8EEELb1ENS_11GraphTraitsIS2_EEEC2ES5_RS6_", "llvm::df_iterator<llvm::Function*, llvm::SmallPtrSet<llvm::BasicBlock*, 8u>, true, llvm::GraphTraits<llvm::Function*> >::df_iterator(llvm::BasicBlock*, llvm::SmallPtrSet<llvm::BasicBlock*, 8u>&)"),
	mu_demangle_test("_ZN4llvm15SmallVectorImplINS_11SmallPtrSetIPNS_12MachineInstrELj4EEEE6resizeEj", "llvm::SmallVectorImpl<llvm::SmallPtrSet<llvm::MachineInstr*, 4u> >::resize(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_19TargetRegisterClassENS_9BitVectorENS_12DenseMapInfoIS3_EENS5_IS4_EEE5clearEv", "llvm::DenseMap<llvm::TargetRegisterClass const*, llvm::BitVector, llvm::DenseMapInfo<llvm::TargetRegisterClass const*>, llvm::DenseMapInfo<llvm::BitVector> >::clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_19TargetRegisterClassENS_9BitVectorENS_12DenseMapInfoIS3_EENS5_IS4_EEE6insertERKSt4pairIS3_S4_E", "llvm::DenseMap<llvm::TargetRegisterClass const*, llvm::BitVector, llvm::DenseMapInfo<llvm::TargetRegisterClass const*>, llvm::DenseMapInfo<llvm::BitVector> >::insert(std::pair<llvm::TargetRegisterClass const*, llvm::BitVector> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm12MachineInstrESt4pairIKS2_St6vectorIjSaIjEEESt10_Select1stIS8_ESt4lessIS2_ESaIS8_EE5eraseESt17_Rb_tree_iteratorIS8_ESG_", "std::_Rb_tree<llvm::MachineInstr*, std::pair<llvm::MachineInstr* const, std::vector<unsigned int, std::allocator<unsigned int> > >, std::_Select1st<std::pair<llvm::MachineInstr* const, std::vector<unsigned int, std::allocator<unsigned int> > > >, std::less<llvm::MachineInstr*>, std::allocator<std::pair<llvm::MachineInstr* const, std::vector<unsigned int, std::allocator<unsigned int> > > > >::erase(std::_Rb_tree_iterator<std::pair<llvm::MachineInstr* const, std::vector<unsigned int, std::allocator<unsigned int> > > >, std::_Rb_tree_iterator<std::pair<llvm::MachineInstr* const, std::vector<unsigned int, std::allocator<unsigned int> > > >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm12MachineInstrESt4pairIKS2_St6vectorIjSaIjEEESt10_Select1stIS8_ESt4lessIS2_ESaIS8_EE8_M_eraseEPSt13_Rb_tree_nodeIS8_E", "std::_Rb_tree<llvm::MachineInstr*, std::pair<llvm::MachineInstr* const, std::vector<unsigned int, std::allocator<unsigned int> > >, std::_Select1st<std::pair<llvm::MachineInstr* const, std::vector<unsigned int, std::allocator<unsigned int> > > >, std::less<llvm::MachineInstr*>, std::allocator<std::pair<llvm::MachineInstr* const, std::vector<unsigned int, std::allocator<unsigned int> > > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::MachineInstr* const, std::vector<unsigned int, std::allocator<unsigned int> > > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm12MachineInstrESt4pairIKS2_St6vectorIS3_IjbESaIS6_EEESt10_Select1stIS9_ESt4lessIS2_ESaIS9_EE5eraseESt17_Rb_tree_iteratorIS9_ESH_", "std::_Rb_tree<llvm::MachineInstr*, std::pair<llvm::MachineInstr* const, std::vector<std::pair<unsigned int, bool>, std::allocator<std::pair<unsigned int, bool> > > >, std::_Select1st<std::pair<llvm::MachineInstr* const, std::vector<std::pair<unsigned int, bool>, std::allocator<std::pair<unsigned int, bool> > > > >, std::less<llvm::MachineInstr*>, std::allocator<std::pair<llvm::MachineInstr* const, std::vector<std::pair<unsigned int, bool>, std::allocator<std::pair<unsigned int, bool> > > > > >::erase(std::_Rb_tree_iterator<std::pair<llvm::MachineInstr* const, std::vector<std::pair<unsigned int, bool>, std::allocator<std::pair<unsigned int, bool> > > > >, std::_Rb_tree_iterator<std::pair<llvm::MachineInstr* const, std::vector<std::pair<unsigned int, bool>, std::allocator<std::pair<unsigned int, bool> > > > >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm12MachineInstrESt4pairIKS2_St6vectorIS3_IjbESaIS6_EEESt10_Select1stIS9_ESt4lessIS2_ESaIS9_EE8_M_eraseEPSt13_Rb_tree_nodeIS9_E", "std::_Rb_tree<llvm::MachineInstr*, std::pair<llvm::MachineInstr* const, std::vector<std::pair<unsigned int, bool>, std::allocator<std::pair<unsigned int, bool> > > >, std::_Select1st<std::pair<llvm::MachineInstr* const, std::vector<std::pair<unsigned int, bool>, std::allocator<std::pair<unsigned int, bool> > > > >, std::less<llvm::MachineInstr*>, std::allocator<std::pair<llvm::MachineInstr* const, std::vector<std::pair<unsigned int, bool>, std::allocator<std::pair<unsigned int, bool> > > > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::MachineInstr* const, std::vector<std::pair<unsigned int, bool>, std::allocator<std::pair<unsigned int, bool> > > > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm12MachineInstrESt4pairIKS2_S3_IjNS0_10VirtRegMap6ModRefEEESt10_Select1stIS8_ESt4lessIS2_ESaIS8_EE5eraseESt17_Rb_tree_iteratorIS8_ESG_", "std::_Rb_tree<llvm::MachineInstr*, std::pair<llvm::MachineInstr* const, std::pair<unsigned int, llvm::VirtRegMap::ModRef> >, std::_Select1st<std::pair<llvm::MachineInstr* const, std::pair<unsigned int, llvm::VirtRegMap::ModRef> > >, std::less<llvm::MachineInstr*>, std::allocator<std::pair<llvm::MachineInstr* const, std::pair<unsigned int, llvm::VirtRegMap::ModRef> > > >::erase(std::_Rb_tree_iterator<std::pair<llvm::MachineInstr* const, std::pair<unsigned int, llvm::VirtRegMap::ModRef> > >, std::_Rb_tree_iterator<std::pair<llvm::MachineInstr* const, std::pair<unsigned int, llvm::VirtRegMap::ModRef> > >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm12MachineInstrESt4pairIKS2_S3_IjNS0_10VirtRegMap6ModRefEEESt10_Select1stIS8_ESt4lessIS2_ESaIS8_EE8_M_eraseEPSt13_Rb_tree_nodeIS8_E", "std::_Rb_tree<llvm::MachineInstr*, std::pair<llvm::MachineInstr* const, std::pair<unsigned int, llvm::VirtRegMap::ModRef> >, std::_Select1st<std::pair<llvm::MachineInstr* const, std::pair<unsigned int, llvm::VirtRegMap::ModRef> > >, std::less<llvm::MachineInstr*>, std::allocator<std::pair<llvm::MachineInstr* const, std::pair<unsigned int, llvm::VirtRegMap::ModRef> > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::MachineInstr* const, std::pair<unsigned int, llvm::VirtRegMap::ModRef> > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm12MachineInstrESt4pairIKS2_S3_IjNS0_10VirtRegMap6ModRefEEESt10_Select1stIS8_ESt4lessIS2_ESaIS8_EE15_M_insert_equalESt17_Rb_tree_iteratorIS8_ERKS8_", "std::_Rb_tree<llvm::MachineInstr*, std::pair<llvm::MachineInstr* const, std::pair<unsigned int, llvm::VirtRegMap::ModRef> >, std::_Select1st<std::pair<llvm::MachineInstr* const, std::pair<unsigned int, llvm::VirtRegMap::ModRef> > >, std::less<llvm::MachineInstr*>, std::allocator<std::pair<llvm::MachineInstr* const, std::pair<unsigned int, llvm::VirtRegMap::ModRef> > > >::_M_insert_equal(std::_Rb_tree_iterator<std::pair<llvm::MachineInstr* const, std::pair<unsigned int, llvm::VirtRegMap::ModRef> > >, std::pair<llvm::MachineInstr* const, std::pair<unsigned int, llvm::VirtRegMap::ModRef> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm19TargetRegisterClassESt4pairIKS3_iESt10_Select1stIS6_ESt4lessIS3_ESaIS6_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS6_ERKS6_", "std::_Rb_tree<llvm::TargetRegisterClass const*, std::pair<llvm::TargetRegisterClass const* const, int>, std::_Select1st<std::pair<llvm::TargetRegisterClass const* const, int> >, std::less<llvm::TargetRegisterClass const*>, std::allocator<std::pair<llvm::TargetRegisterClass const* const, int> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::TargetRegisterClass const* const, int> >, std::pair<llvm::TargetRegisterClass const* const, int> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm19TargetRegisterClassESt4pairIKS3_iESt10_Select1stIS6_ESt4lessIS3_ESaIS6_EE16_M_insert_uniqueERKS6_", "std::_Rb_tree<llvm::TargetRegisterClass const*, std::pair<llvm::TargetRegisterClass const* const, int>, std::_Select1st<std::pair<llvm::TargetRegisterClass const* const, int> >, std::less<llvm::TargetRegisterClass const*>, std::allocator<std::pair<llvm::TargetRegisterClass const* const, int> > >::_M_insert_unique(std::pair<llvm::TargetRegisterClass const* const, int> const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm12MachineInstrESaIS2_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS2_S4_EEmRKS2_", "std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> >::_M_fill_insert(__gnu_cxx::__normal_iterator<llvm::MachineInstr**, std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> > >, unsigned long, llvm::MachineInstr* const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm9SlotIndexESaIS1_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS1_S3_EEmRKS1_", "std::vector<llvm::SlotIndex, std::allocator<llvm::SlotIndex> >::_M_fill_insert(__gnu_cxx::__normal_iterator<llvm::SlotIndex*, std::vector<llvm::SlotIndex, std::allocator<llvm::SlotIndex> > >, unsigned long, llvm::SlotIndex const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_19TargetRegisterClassENS_9BitVectorENS_12DenseMapInfoIS3_EENS5_IS4_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::TargetRegisterClass const*, llvm::BitVector, llvm::DenseMapInfo<llvm::TargetRegisterClass const*>, llvm::DenseMapInfo<llvm::BitVector> >::shrink_and_clear()"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm19TargetRegisterClassESt4pairIKS3_iESt10_Select1stIS6_ESt4lessIS3_ESaIS6_EE8_M_eraseEPSt13_Rb_tree_nodeIS6_E", "std::_Rb_tree<llvm::TargetRegisterClass const*, std::pair<llvm::TargetRegisterClass const* const, int>, std::_Select1st<std::pair<llvm::TargetRegisterClass const* const, int> >, std::less<llvm::TargetRegisterClass const*>, std::allocator<std::pair<llvm::TargetRegisterClass const* const, int> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::TargetRegisterClass const* const, int> >*)"),
	mu_demangle_test("_ZN4llvm2cl3optIN12_GLOBAL__N_112RewriterNameELb0ENS0_6parserIS3_EEED1Ev", "llvm::cl::opt<(anonymous namespace)::RewriterName, false, llvm::cl::parser<(anonymous namespace)::RewriterName> >::~opt()"),
	mu_demangle_test("_ZN4llvm2cl3optIN12_GLOBAL__N_112RewriterNameELb0ENS0_6parserIS3_EEE16handleOccurrenceEjNS_9StringRefES7_", "llvm::cl::opt<(anonymous namespace)::RewriterName, false, llvm::cl::parser<(anonymous namespace)::RewriterName> >::handleOccurrence(unsigned int, llvm::StringRef, llvm::StringRef)"),
	mu_demangle_test("_ZNK4llvm2cl3optIN12_GLOBAL__N_112RewriterNameELb0ENS0_6parserIS3_EEE27getValueExpectedFlagDefaultEv", "llvm::cl::opt<(anonymous namespace)::RewriterName, false, llvm::cl::parser<(anonymous namespace)::RewriterName> >::getValueExpectedFlagDefault() const"),
	mu_demangle_test("_ZNK4llvm2cl3optIN12_GLOBAL__N_112RewriterNameELb0ENS0_6parserIS3_EEE14getOptionWidthEv", "llvm::cl::opt<(anonymous namespace)::RewriterName, false, llvm::cl::parser<(anonymous namespace)::RewriterName> >::getOptionWidth() const"),
	mu_demangle_test("_ZNK4llvm2cl3optIN12_GLOBAL__N_112RewriterNameELb0ENS0_6parserIS3_EEE15printOptionInfoEm", "llvm::cl::opt<(anonymous namespace)::RewriterName, false, llvm::cl::parser<(anonymous namespace)::RewriterName> >::printOptionInfo(unsigned long) const"),
	mu_demangle_test("_ZN4llvm2cl3optIN12_GLOBAL__N_112RewriterNameELb0ENS0_6parserIS3_EEE19getExtraOptionNamesERNS_15SmallVectorImplIPKcEE", "llvm::cl::opt<(anonymous namespace)::RewriterName, false, llvm::cl::parser<(anonymous namespace)::RewriterName> >::getExtraOptionNames(llvm::SmallVectorImpl<char const*>&)"),
	mu_demangle_test("_ZN4llvm2cl3optIN12_GLOBAL__N_112RewriterNameELb0ENS0_6parserIS3_EEED0Ev", "llvm::cl::opt<(anonymous namespace)::RewriterName, false, llvm::cl::parser<(anonymous namespace)::RewriterName> >::~opt()"),
	mu_demangle_test("_ZN12_GLOBAL__N_113LocalRewriter10RewriteMBBEPN4llvm13LiveIntervalsERNS_15AvailableSpillsERNS1_9BitVectorERSt6vectorIPNS1_14MachineOperandESaISA_EE", "(anonymous namespace)::LocalRewriter::RewriteMBB(llvm::LiveIntervals*, (anonymous namespace)::AvailableSpills&, llvm::BitVector&, std::vector<llvm::MachineOperand*, std::allocator<llvm::MachineOperand*> >&)"),
	mu_demangle_test("_Z22ResurrectConfirmedKilljPKN4llvm18TargetRegisterInfoERNS_9BitVectorERSt6vectorIPNS_14MachineOperandESaIS7_EE", "ResurrectConfirmedKill(unsigned int, llvm::TargetRegisterInfo const*, llvm::BitVector&, std::vector<llvm::MachineOperand*, std::allocator<llvm::MachineOperand*> >&)"),
	mu_demangle_test("_Z15InvalidateKillsRN4llvm12MachineInstrEPKNS_18TargetRegisterInfoERNS_9BitVectorERSt6vectorIPNS_14MachineOperandESaIS9_EEPNS_11SmallVectorIjLj2EEE", "InvalidateKills(llvm::MachineInstr&, llvm::TargetRegisterInfo const*, llvm::BitVector&, std::vector<llvm::MachineOperand*, std::allocator<llvm::MachineOperand*> >&, llvm::SmallVector<unsigned int, 2u>*)"),
	mu_demangle_test("_Z11UpdateKillsRN4llvm12MachineInstrEPKNS_18TargetRegisterInfoERNS_9BitVectorERSt6vectorIPNS_14MachineOperandESaIS9_EE", "UpdateKills(llvm::MachineInstr&, llvm::TargetRegisterInfo const*, llvm::BitVector&, std::vector<llvm::MachineOperand*, std::allocator<llvm::MachineOperand*> >&)"),
	mu_demangle_test("_Z13ResurrectKillRN4llvm12MachineInstrEjPKNS_18TargetRegisterInfoERNS_9BitVectorERSt6vectorIPNS_14MachineOperandESaIS9_EE", "ResurrectKill(llvm::MachineInstr&, unsigned int, llvm::TargetRegisterInfo const*, llvm::BitVector&, std::vector<llvm::MachineOperand*, std::allocator<llvm::MachineOperand*> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_19ReuseInfo15GetRegForReloadEPKN4llvm19TargetRegisterClassEjRNS1_15MachineFunctionEPNS1_12MachineInstrERNS_15AvailableSpillsERSt6vectorIS8_SaIS8_EERNS1_8SmallSetIjLj8EEERNS1_9BitVectorERSB_IPNS1_14MachineOperandESaISL_EERNS1_10VirtRegMapE", "(anonymous namespace)::ReuseInfo::GetRegForReload(llvm::TargetRegisterClass const*, unsigned int, llvm::MachineFunction&, llvm::MachineInstr*, (anonymous namespace)::AvailableSpills&, std::vector<llvm::MachineInstr*, std::allocator<llvm::MachineInstr*> >&, llvm::SmallSet<unsigned int, 8u>&, llvm::BitVector&, std::vector<llvm::MachineOperand*, std::allocator<llvm::MachineOperand*> >&, llvm::VirtRegMap&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIiNS_11SmallVectorIPNS_12MachineInstrELj4EEENS_12DenseMapInfoIiEENS5_IS4_EEE5clearEv", "llvm::DenseMap<int, llvm::SmallVector<llvm::MachineInstr*, 4u>, llvm::DenseMapInfo<int>, llvm::DenseMapInfo<llvm::SmallVector<llvm::MachineInstr*, 4u> > >::clear()"),
	mu_demangle_test("_ZNSt8_Rb_treeIiSt4pairIKijESt10_Select1stIS2_ESt4lessIiESaIS2_EE8_M_eraseEPSt13_Rb_tree_nodeIS2_E", "std::_Rb_tree<int, std::pair<int const, unsigned int>, std::_Select1st<std::pair<int const, unsigned int> >, std::less<int>, std::allocator<std::pair<int const, unsigned int> > >::_M_erase(std::_Rb_tree_node<std::pair<int const, unsigned int> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjiESt10_Select1stIS2_ESt4lessIjESaIS2_EE8_M_eraseEPSt13_Rb_tree_nodeIS2_E", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, int>, std::_Select1st<std::pair<unsigned int const, int> >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, int> > >::_M_erase(std::_Rb_tree_node<std::pair<unsigned int const, int> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIiNS_11SmallVectorIPNS_12MachineInstrELj4EEENS_12DenseMapInfoIiEENS5_IS4_EEE16shrink_and_clearEv", "llvm::DenseMap<int, llvm::SmallVector<llvm::MachineInstr*, 4u>, llvm::DenseMapInfo<int>, llvm::DenseMapInfo<llvm::SmallVector<llvm::MachineInstr*, 4u> > >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIiNS_11SmallVectorIPNS_12MachineInstrELj4EEENS_12DenseMapInfoIiEENS5_IS4_EEE16FindAndConstructERKi", "llvm::DenseMap<int, llvm::SmallVector<llvm::MachineInstr*, 4u>, llvm::DenseMapInfo<int>, llvm::DenseMapInfo<llvm::SmallVector<llvm::MachineInstr*, 4u> > >::FindAndConstruct(int const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIiNS_11SmallVectorIPNS_12MachineInstrELj4EEENS_12DenseMapInfoIiEENS5_IS4_EEE16InsertIntoBucketERKiRKS4_PSt4pairIiS4_E", "llvm::DenseMap<int, llvm::SmallVector<llvm::MachineInstr*, 4u>, llvm::DenseMapInfo<int>, llvm::DenseMapInfo<llvm::SmallVector<llvm::MachineInstr*, 4u> > >::InsertIntoBucket(int const&, llvm::SmallVector<llvm::MachineInstr*, 4u> const&, std::pair<int, llvm::SmallVector<llvm::MachineInstr*, 4u> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIiNS_11SmallVectorIPNS_12MachineInstrELj4EEENS_12DenseMapInfoIiEENS5_IS4_EEE4growEj", "llvm::DenseMap<int, llvm::SmallVector<llvm::MachineInstr*, 4u>, llvm::DenseMapInfo<int>, llvm::DenseMapInfo<llvm::SmallVector<llvm::MachineInstr*, 4u> > >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt8_Rb_treeIiSt4pairIKijESt10_Select1stIS2_ESt4lessIiESaIS2_EE5eraseESt17_Rb_tree_iteratorIS2_ESA_", "std::_Rb_tree<int, std::pair<int const, unsigned int>, std::_Select1st<std::pair<int const, unsigned int> >, std::less<int>, std::allocator<std::pair<int const, unsigned int> > >::erase(std::_Rb_tree_iterator<std::pair<int const, unsigned int> >, std::_Rb_tree_iterator<std::pair<int const, unsigned int> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIiSt4pairIKijESt10_Select1stIS2_ESt4lessIiESaIS2_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS2_ERKS2_", "std::_Rb_tree<int, std::pair<int const, unsigned int>, std::_Select1st<std::pair<int const, unsigned int> >, std::less<int>, std::allocator<std::pair<int const, unsigned int> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<int const, unsigned int> >, std::pair<int const, unsigned int> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIiSt4pairIKijESt10_Select1stIS2_ESt4lessIiESaIS2_EE16_M_insert_uniqueERKS2_", "std::_Rb_tree<int, std::pair<int const, unsigned int>, std::_Select1st<std::pair<int const, unsigned int> >, std::less<int>, std::allocator<std::pair<int const, unsigned int> > >::_M_insert_unique(std::pair<int const, unsigned int> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm12MachineInstrESt4pairIKS2_St6vectorIS3_IjbESaIS6_EEESt10_Select1stIS9_ESt4lessIS2_ESaIS9_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS9_ERKS9_", "std::_Rb_tree<llvm::MachineInstr*, std::pair<llvm::MachineInstr* const, std::vector<std::pair<unsigned int, bool>, std::allocator<std::pair<unsigned int, bool> > > >, std::_Select1st<std::pair<llvm::MachineInstr* const, std::vector<std::pair<unsigned int, bool>, std::allocator<std::pair<unsigned int, bool> > > > >, std::less<llvm::MachineInstr*>, std::allocator<std::pair<llvm::MachineInstr* const, std::vector<std::pair<unsigned int, bool>, std::allocator<std::pair<unsigned int, bool> > > > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::MachineInstr* const, std::vector<std::pair<unsigned int, bool>, std::allocator<std::pair<unsigned int, bool> > > > >, std::pair<llvm::MachineInstr* const, std::vector<std::pair<unsigned int, bool>, std::allocator<std::pair<unsigned int, bool> > > > const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm14MachineOperandESaIS2_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS2_S4_EEmRKS2_", "std::vector<llvm::MachineOperand*, std::allocator<llvm::MachineOperand*> >::_M_fill_insert(__gnu_cxx::__normal_iterator<llvm::MachineOperand**, std::vector<llvm::MachineOperand*, std::allocator<llvm::MachineOperand*> > >, unsigned long, llvm::MachineOperand* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5ValueES2_NS_12DenseMapInfoIS2_EES4_E16shrink_and_clearEv", "llvm::DenseMap<llvm::Value*, llvm::Value*, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<llvm::Value*> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5ValueES2_NS_12DenseMapInfoIS2_EES4_E16InsertIntoBucketERKS2_S7_PSt4pairIS2_S2_E", "llvm::DenseMap<llvm::Value*, llvm::Value*, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<llvm::Value*> >::InsertIntoBucket(llvm::Value* const&, llvm::Value* const&, std::pair<llvm::Value*, llvm::Value*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5ValueES2_NS_12DenseMapInfoIS2_EES4_E4growEj", "llvm::DenseMap<llvm::Value*, llvm::Value*, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<llvm::Value*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEPNS_7CmpInstENS_12DenseMapInfoIS2_EENS5_IS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<llvm::BasicBlock*, llvm::CmpInst*, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::CmpInst*> >::InsertIntoBucket(llvm::BasicBlock* const&, llvm::CmpInst* const&, std::pair<llvm::BasicBlock*, llvm::CmpInst*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEPNS_7CmpInstENS_12DenseMapInfoIS2_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::BasicBlock*, llvm::CmpInst*, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::CmpInst*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEPNS_11InstructionENS_12DenseMapInfoIS2_EENS5_IS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<llvm::BasicBlock*, llvm::Instruction*, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::Instruction*> >::InsertIntoBucket(llvm::BasicBlock* const&, llvm::Instruction* const&, std::pair<llvm::BasicBlock*, llvm::Instruction*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEPNS_11InstructionENS_12DenseMapInfoIS2_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::BasicBlock*, llvm::Instruction*, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::Instruction*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEPNS_8CastInstENS_12DenseMapInfoIS2_EENS5_IS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<llvm::BasicBlock*, llvm::CastInst*, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::CastInst*> >::InsertIntoBucket(llvm::BasicBlock* const&, llvm::CastInst* const&, std::pair<llvm::BasicBlock*, llvm::CastInst*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEPNS_8CastInstENS_12DenseMapInfoIS2_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::BasicBlock*, llvm::CastInst*, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::CastInst*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm10BasicBlockES4_ES5_St9_IdentityIS5_ESt4lessIS5_ESaIS5_EE16_M_insert_uniqueERKS5_", "std::_Rb_tree<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, std::_Identity<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> > >::_M_insert_unique(std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm10BasicBlockES4_ES5_St9_IdentityIS5_ESt4lessIS5_ESaIS5_EE8_M_eraseEPSt13_Rb_tree_nodeIS5_E", "std::_Rb_tree<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, std::_Identity<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN12_GLOBAL__N_111SimpleValueEPNS_18ScopedHashTableValIS2_PNS_5ValueEEENS_12DenseMapInfoIS2_EENS8_IS7_EEEixERKS2_", "llvm::DenseMap<(anonymous namespace)::SimpleValue, llvm::ScopedHashTableVal<(anonymous namespace)::SimpleValue, llvm::Value*>*, llvm::DenseMapInfo<(anonymous namespace)::SimpleValue>, llvm::DenseMapInfo<llvm::ScopedHashTableVal<(anonymous namespace)::SimpleValue, llvm::Value*>*> >::operator[]((anonymous namespace)::SimpleValue const&)"),
	mu_demangle_test("_ZNK4llvm8DenseMapIN12_GLOBAL__N_111SimpleValueEPNS_18ScopedHashTableValIS2_PNS_5ValueEEENS_12DenseMapInfoIS2_EENS8_IS7_EEE15LookupBucketForERKS2_RPSt4pairIS2_S7_E", "llvm::DenseMap<(anonymous namespace)::SimpleValue, llvm::ScopedHashTableVal<(anonymous namespace)::SimpleValue, llvm::Value*>*, llvm::DenseMapInfo<(anonymous namespace)::SimpleValue>, llvm::DenseMapInfo<llvm::ScopedHashTableVal<(anonymous namespace)::SimpleValue, llvm::Value*>*> >::LookupBucketFor((anonymous namespace)::SimpleValue const&, std::pair<(anonymous namespace)::SimpleValue, llvm::ScopedHashTableVal<(anonymous namespace)::SimpleValue, llvm::Value*>*>*&) const"),
	mu_demangle_test("_ZN4llvm8DenseMapIN12_GLOBAL__N_19CallValueEPNS_18ScopedHashTableValIS2_St4pairIPNS_5ValueEjEEENS_12DenseMapInfoIS2_EENSA_IS9_EEEixERKS2_", "llvm::DenseMap<(anonymous namespace)::CallValue, llvm::ScopedHashTableVal<(anonymous namespace)::CallValue, std::pair<llvm::Value*, unsigned int> >*, llvm::DenseMapInfo<(anonymous namespace)::CallValue>, llvm::DenseMapInfo<llvm::ScopedHashTableVal<(anonymous namespace)::CallValue, std::pair<llvm::Value*, unsigned int> >*> >::operator[]((anonymous namespace)::CallValue const&)"),
	mu_demangle_test("_ZNK4llvm8DenseMapIN12_GLOBAL__N_19CallValueEPNS_18ScopedHashTableValIS2_St4pairIPNS_5ValueEjEEENS_12DenseMapInfoIS2_EENSA_IS9_EEE15LookupBucketForERKS2_RPS4_IS2_S9_E", "llvm::DenseMap<(anonymous namespace)::CallValue, llvm::ScopedHashTableVal<(anonymous namespace)::CallValue, std::pair<llvm::Value*, unsigned int> >*, llvm::DenseMapInfo<(anonymous namespace)::CallValue>, llvm::DenseMapInfo<llvm::ScopedHashTableVal<(anonymous namespace)::CallValue, std::pair<llvm::Value*, unsigned int> >*> >::LookupBucketFor((anonymous namespace)::CallValue const&, std::pair<(anonymous namespace)::CallValue, llvm::ScopedHashTableVal<(anonymous namespace)::CallValue, std::pair<llvm::Value*, unsigned int> >*>*&) const"),
	mu_demangle_test("_ZN4llvm15ScopedHashTableIPNS_5ValueESt4pairIS2_jENS_12DenseMapInfoIS2_EENS_18RecyclingAllocatorINS_16BumpPtrAllocatorENS_18ScopedHashTableValIS2_S4_EELm40ELm8EEEED2Ev", "llvm::ScopedHashTable<llvm::Value*, std::pair<llvm::Value*, unsigned int>, llvm::DenseMapInfo<llvm::Value*>, llvm::RecyclingAllocator<llvm::BumpPtrAllocator, llvm::ScopedHashTableVal<llvm::Value*, std::pair<llvm::Value*, unsigned int> >, 40ul, 8ul> >::~ScopedHashTable()"),
	mu_demangle_test("_ZN4llvm15ScopedHashTableIPNS_5ValueESt4pairIS2_jENS_12DenseMapInfoIS2_EENS_18RecyclingAllocatorINS_16BumpPtrAllocatorENS_18ScopedHashTableValIS2_S4_EELm40ELm8EEEE6insertERKS2_RKS4_", "llvm::ScopedHashTable<llvm::Value*, std::pair<llvm::Value*, unsigned int>, llvm::DenseMapInfo<llvm::Value*>, llvm::RecyclingAllocator<llvm::BumpPtrAllocator, llvm::ScopedHashTableVal<llvm::Value*, std::pair<llvm::Value*, unsigned int> >, 40ul, 8ul> >::insert(llvm::Value* const&, std::pair<llvm::Value*, unsigned int> const&)"),
	mu_demangle_test("_ZN4llvm20ScopedHashTableScopeIPNS_5ValueESt4pairIS2_jENS_12DenseMapInfoIS2_EENS_18RecyclingAllocatorINS_16BumpPtrAllocatorENS_18ScopedHashTableValIS2_S4_EELm40ELm8EEEED2Ev", "llvm::ScopedHashTableScope<llvm::Value*, std::pair<llvm::Value*, unsigned int>, llvm::DenseMapInfo<llvm::Value*>, llvm::RecyclingAllocator<llvm::BumpPtrAllocator, llvm::ScopedHashTableVal<llvm::Value*, std::pair<llvm::Value*, unsigned int> >, 40ul, 8ul> >::~ScopedHashTableScope()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5ValueEPNS_18ScopedHashTableValIS2_St4pairIS2_jEEENS_12DenseMapInfoIS2_EENS8_IS7_EEE16InsertIntoBucketERKS2_RKS7_PS4_IS2_S7_E", "llvm::DenseMap<llvm::Value*, llvm::ScopedHashTableVal<llvm::Value*, std::pair<llvm::Value*, unsigned int> >*, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<llvm::ScopedHashTableVal<llvm::Value*, std::pair<llvm::Value*, unsigned int> >*> >::InsertIntoBucket(llvm::Value* const&, llvm::ScopedHashTableVal<llvm::Value*, std::pair<llvm::Value*, unsigned int> >* const&, std::pair<llvm::Value*, llvm::ScopedHashTableVal<llvm::Value*, std::pair<llvm::Value*, unsigned int> >*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5ValueEPNS_18ScopedHashTableValIS2_St4pairIS2_jEEENS_12DenseMapInfoIS2_EENS8_IS7_EEE4growEj", "llvm::DenseMap<llvm::Value*, llvm::ScopedHashTableVal<llvm::Value*, std::pair<llvm::Value*, unsigned int> >*, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<llvm::ScopedHashTableVal<llvm::Value*, std::pair<llvm::Value*, unsigned int> >*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjN12_GLOBAL__N_13GVN16LeaderTableEntryENS_12DenseMapInfoIjEENS4_IS3_EEEixERKj", "llvm::DenseMap<unsigned int, (anonymous namespace)::GVN::LeaderTableEntry, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<(anonymous namespace)::GVN::LeaderTableEntry> >::operator[](unsigned int const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN12_GLOBAL__N_110ExpressionEjNS_12DenseMapInfoIS2_EENS3_IjEEEixERKS2_", "llvm::DenseMap<(anonymous namespace)::Expression, unsigned int, llvm::DenseMapInfo<(anonymous namespace)::Expression>, llvm::DenseMapInfo<unsigned int> >::operator[]((anonymous namespace)::Expression const&)"),
	mu_demangle_test("_ZNK4llvm8DenseMapIN12_GLOBAL__N_110ExpressionEjNS_12DenseMapInfoIS2_EENS3_IjEEE15LookupBucketForERKS2_RPSt4pairIS2_jE", "llvm::DenseMap<(anonymous namespace)::Expression, unsigned int, llvm::DenseMapInfo<(anonymous namespace)::Expression>, llvm::DenseMapInfo<unsigned int> >::LookupBucketFor((anonymous namespace)::Expression const&, std::pair<(anonymous namespace)::Expression, unsigned int>*&) const"),
	mu_demangle_test("_Z28IsValueFullyAvailableInBlockPN4llvm10BasicBlockERNS_8DenseMapIS1_cNS_12DenseMapInfoIS1_EENS3_IcEEEE", "IsValueFullyAvailableInBlock(llvm::BasicBlock*, llvm::DenseMap<llvm::BasicBlock*, char, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<char> >&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5ValueEjNS_12DenseMapInfoIS2_EENS3_IjEEE16shrink_and_clearEv", "llvm::DenseMap<llvm::Value*, unsigned int, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<unsigned int> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm11df_iteratorIPNS_10BasicBlockENS_11SmallPtrSetIS2_Lj8EEELb0ENS_11GraphTraitsIS2_EEE6toNextEv", "llvm::df_iterator<llvm::BasicBlock*, llvm::SmallPtrSet<llvm::BasicBlock*, 8u>, false, llvm::GraphTraits<llvm::BasicBlock*> >::toNext()"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN4llvm14PointerIntPairIPNS1_10BasicBlockELj1EjNS1_21PointerLikeTypeTraitsIS4_EEEENS1_12SuccIteratorIPNS1_14TerminatorInstES3_EEESaISC_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPSC_SE_EERKSC_", "std::vector<std::pair<llvm::PointerIntPair<llvm::BasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::BasicBlock*> >, llvm::SuccIterator<llvm::TerminatorInst*, llvm::BasicBlock> >, std::allocator<std::pair<llvm::PointerIntPair<llvm::BasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::BasicBlock*> >, llvm::SuccIterator<llvm::TerminatorInst*, llvm::BasicBlock> > > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::PointerIntPair<llvm::BasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::BasicBlock*> >, llvm::SuccIterator<llvm::TerminatorInst*, llvm::BasicBlock> >*, std::vector<std::pair<llvm::PointerIntPair<llvm::BasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::BasicBlock*> >, llvm::SuccIterator<llvm::TerminatorInst*, llvm::BasicBlock> >, std::allocator<std::pair<llvm::PointerIntPair<llvm::BasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::BasicBlock*> >, llvm::SuccIterator<llvm::TerminatorInst*, llvm::BasicBlock> > > > >, std::pair<llvm::PointerIntPair<llvm::BasicBlock*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::BasicBlock*> >, llvm::SuccIterator<llvm::TerminatorInst*, llvm::BasicBlock> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5ValueEjNS_12DenseMapInfoIS2_EENS3_IjEEE6insertERKSt4pairIS2_jE", "llvm::DenseMap<llvm::Value*, unsigned int, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<unsigned int> >::insert(std::pair<llvm::Value*, unsigned int> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5ValueEjNS_12DenseMapInfoIS2_EENS3_IjEEE16InsertIntoBucketERKS2_RKjPSt4pairIS2_jE", "llvm::DenseMap<llvm::Value*, unsigned int, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(llvm::Value* const&, unsigned int const&, std::pair<llvm::Value*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5ValueEjNS_12DenseMapInfoIS2_EENS3_IjEEE4growEj", "llvm::DenseMap<llvm::Value*, unsigned int, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEPNS_5ValueENS_12DenseMapInfoIS2_EENS5_IS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<llvm::BasicBlock*, llvm::Value*, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::Value*> >::InsertIntoBucket(llvm::BasicBlock* const&, llvm::Value* const&, std::pair<llvm::BasicBlock*, llvm::Value*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEPNS_5ValueENS_12DenseMapInfoIS2_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::BasicBlock*, llvm::Value*, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::Value*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm23SmallVectorTemplateBaseISt4pairIPNS_15DomTreeNodeBaseINS_10BasicBlockEEEN9__gnu_cxx17__normal_iteratorIPS5_St6vectorIS5_SaIS5_EEEEELb0EE4growEm", "llvm::SmallVectorTemplateBase<std::pair<llvm::DomTreeNodeBase<llvm::BasicBlock>*, __gnu_cxx::__normal_iterator<llvm::DomTreeNodeBase<llvm::BasicBlock>**, std::vector<llvm::DomTreeNodeBase<llvm::BasicBlock>*, std::allocator<llvm::DomTreeNodeBase<llvm::BasicBlock>*> > > >, false>::grow(unsigned long)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEPNS_5ValueENS_12DenseMapInfoIS2_EENS5_IS4_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::BasicBlock*, llvm::Value*, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::Value*> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm11df_iteratorIPNS_15DomTreeNodeBaseINS_10BasicBlockEEENS_11SmallPtrSetIS4_Lj8EEELb0ENS_11GraphTraitsIS4_EEE6toNextEv", "llvm::df_iterator<llvm::DomTreeNodeBase<llvm::BasicBlock>*, llvm::SmallPtrSet<llvm::DomTreeNodeBase<llvm::BasicBlock>*, 8u>, false, llvm::GraphTraits<llvm::DomTreeNodeBase<llvm::BasicBlock>*> >::toNext()"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN4llvm14PointerIntPairIPNS1_15DomTreeNodeBaseINS1_10BasicBlockEEELj1EjNS1_21PointerLikeTypeTraitsIS6_EEEEN9__gnu_cxx17__normal_iteratorIPS6_S_IS6_SaIS6_EEEEESaISG_EE13_M_insert_auxENSB_IPSG_SI_EERKSG_", "std::vector<std::pair<llvm::PointerIntPair<llvm::DomTreeNodeBase<llvm::BasicBlock>*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::DomTreeNodeBase<llvm::BasicBlock>*> >, __gnu_cxx::__normal_iterator<llvm::DomTreeNodeBase<llvm::BasicBlock>**, std::vector<llvm::DomTreeNodeBase<llvm::BasicBlock>*, std::allocator<llvm::DomTreeNodeBase<llvm::BasicBlock>*> > > >, std::allocator<std::pair<llvm::PointerIntPair<llvm::DomTreeNodeBase<llvm::BasicBlock>*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::DomTreeNodeBase<llvm::BasicBlock>*> >, __gnu_cxx::__normal_iterator<llvm::DomTreeNodeBase<llvm::BasicBlock>**, std::vector<llvm::DomTreeNodeBase<llvm::BasicBlock>*, std::allocator<llvm::DomTreeNodeBase<llvm::BasicBlock>*> > > > > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::PointerIntPair<llvm::DomTreeNodeBase<llvm::BasicBlock>*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::DomTreeNodeBase<llvm::BasicBlock>*> >, __gnu_cxx::__normal_iterator<llvm::DomTreeNodeBase<llvm::BasicBlock>**, std::vector<llvm::DomTreeNodeBase<llvm::BasicBlock>*, std::allocator<llvm::DomTreeNodeBase<llvm::BasicBlock>*> > > >*, std::vector<std::pair<llvm::PointerIntPair<llvm::DomTreeNodeBase<llvm::BasicBlock>*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::DomTreeNodeBase<llvm::BasicBlock>*> >, __gnu_cxx::__normal_iterator<llvm::DomTreeNodeBase<llvm::BasicBlock>**, std::vector<llvm::DomTreeNodeBase<llvm::BasicBlock>*, std::allocator<llvm::DomTreeNodeBase<llvm::BasicBlock>*> > > >, std::allocator<std::pair<llvm::PointerIntPair<llvm::DomTreeNodeBase<llvm::BasicBlock>*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::DomTreeNodeBase<llvm::BasicBlock>*> >, __gnu_cxx::__normal_iterator<llvm::DomTreeNodeBase<llvm::BasicBlock>**, std::vector<llvm::DomTreeNodeBase<llvm::BasicBlock>*, std::allocator<llvm::DomTreeNodeBase<llvm::BasicBlock>*> > > > > > >, std::pair<llvm::PointerIntPair<llvm::DomTreeNodeBase<llvm::BasicBlock>*, 1u, unsigned int, llvm::PointerLikeTypeTraits<llvm::DomTreeNodeBase<llvm::BasicBlock>*> >, __gnu_cxx::__normal_iterator<llvm::DomTreeNodeBase<llvm::BasicBlock>**, std::vector<llvm::DomTreeNodeBase<llvm::BasicBlock>*, std::allocator<llvm::DomTreeNodeBase<llvm::BasicBlock>*> > > > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEcNS_12DenseMapInfoIS2_EENS3_IcEEE6insertERKSt4pairIS2_cE", "llvm::DenseMap<llvm::BasicBlock*, char, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<char> >::insert(std::pair<llvm::BasicBlock*, char> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEcNS_12DenseMapInfoIS2_EENS3_IcEEE16InsertIntoBucketERKS2_RKcPSt4pairIS2_cE", "llvm::DenseMap<llvm::BasicBlock*, char, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<char> >::InsertIntoBucket(llvm::BasicBlock* const&, char const&, std::pair<llvm::BasicBlock*, char>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEcNS_12DenseMapInfoIS2_EENS3_IcEEE4growEj", "llvm::DenseMap<llvm::BasicBlock*, char, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<char> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE8CreateOrEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateOr(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE9CreateShlEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateShl(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE10CreateCastENS_11Instruction7CastOpsEPNS_5ValueEPKNS_4TypeERKNS_5TwineE", "llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateCast(llvm::Instruction::CastOps, llvm::Value*, llvm::Type const*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE10CreateLShrEPNS_5ValueES6_RKNS_5TwineEb", "llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateLShr(llvm::Value*, llvm::Value*, llvm::Twine const&, bool)"),
	mu_demangle_test("_ZN12_GLOBAL__N_113JumpThreading31ComputeValueKnownInPredecessorsEPN4llvm5ValueEPNS1_10BasicBlockERNS1_15SmallVectorImplISt4pairIPNS1_8ConstantES5_EEENS_18ConstantPreferenceE", "(anonymous namespace)::JumpThreading::ComputeValueKnownInPredecessors(llvm::Value*, llvm::BasicBlock*, llvm::SmallVectorImpl<std::pair<llvm::Constant*, llvm::BasicBlock*> >&, (anonymous namespace)::ConstantPreference)"),
	mu_demangle_test("_Z31AddPHINodeEntriesForMappedBlockPN4llvm10BasicBlockES1_S1_RNS_8DenseMapIPNS_11InstructionEPNS_5ValueENS_12DenseMapInfoIS4_EENS7_IS6_EEEE", "AddPHINodeEntriesForMappedBlock(llvm::BasicBlock*, llvm::BasicBlock*, llvm::BasicBlock*, llvm::DenseMap<llvm::Instruction*, llvm::Value*, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<llvm::Value*> >&)"),
	mu_demangle_test("_ZN4llvm25array_pod_sort_comparatorISt4pairIPNS_10BasicBlockEPNS_5ValueEEEEiPKvS8_", "int llvm::array_pod_sort_comparator<std::pair<llvm::BasicBlock*, llvm::Value*> >(void const*, void const*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_11InstructionEPNS_5ValueENS_12DenseMapInfoIS2_EENS5_IS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<llvm::Instruction*, llvm::Value*, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<llvm::Value*> >::InsertIntoBucket(llvm::Instruction* const&, llvm::Value* const&, std::pair<llvm::Instruction*, llvm::Value*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_11InstructionEPNS_5ValueENS_12DenseMapInfoIS2_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::Instruction*, llvm::Value*, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<llvm::Value*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNK4llvm8DenseMapISt4pairIPNS_5ValueEPNS_10BasicBlockEEcNS_12DenseMapInfoIS6_EENS7_IcEEE15LookupBucketForERKS6_RPS1_IS6_cE", "llvm::DenseMap<std::pair<llvm::Value*, llvm::BasicBlock*>, char, llvm::DenseMapInfo<std::pair<llvm::Value*, llvm::BasicBlock*> >, llvm::DenseMapInfo<char> >::LookupBucketFor(std::pair<llvm::Value*, llvm::BasicBlock*> const&, std::pair<std::pair<llvm::Value*, llvm::BasicBlock*>, char>*&) const"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPNS_5ValueEPNS_10BasicBlockEEcNS_12DenseMapInfoIS6_EENS7_IcEEE6insertERKS1_IS6_cE", "llvm::DenseMap<std::pair<llvm::Value*, llvm::BasicBlock*>, char, llvm::DenseMapInfo<std::pair<llvm::Value*, llvm::BasicBlock*> >, llvm::DenseMapInfo<char> >::insert(std::pair<std::pair<llvm::Value*, llvm::BasicBlock*>, char> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPNS_5ValueEPNS_10BasicBlockEEcNS_12DenseMapInfoIS6_EENS7_IcEEE16InsertIntoBucketERKS6_RKcPS1_IS6_cE", "llvm::DenseMap<std::pair<llvm::Value*, llvm::BasicBlock*>, char, llvm::DenseMapInfo<std::pair<llvm::Value*, llvm::BasicBlock*> >, llvm::DenseMapInfo<char> >::InsertIntoBucket(std::pair<llvm::Value*, llvm::BasicBlock*> const&, char const&, std::pair<std::pair<llvm::Value*, llvm::BasicBlock*>, char>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPNS_5ValueEPNS_10BasicBlockEEcNS_12DenseMapInfoIS6_EENS7_IcEEE4growEj", "llvm::DenseMap<std::pair<llvm::Value*, llvm::BasicBlock*>, char, llvm::DenseMapInfo<std::pair<llvm::Value*, llvm::BasicBlock*> >, llvm::DenseMapInfo<char> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm6iplistINS_8AliasSetENS_12ilist_traitsIS1_EEE3endEv", "llvm::iplist<llvm::AliasSet, llvm::ilist_traits<llvm::AliasSet> >::end()"),
	mu_demangle_test("_ZN4llvm6iplistINS_8AliasSetENS_12ilist_traitsIS1_EEED2Ev", "llvm::iplist<llvm::AliasSet, llvm::ilist_traits<llvm::AliasSet> >::~iplist()"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_15AliasSetTracker13ASTCallbackVHEPNS_8AliasSet10PointerRecENS1_25ASTCallbackVHDenseMapInfoENS_12DenseMapInfoIS5_EEED2Ev", "llvm::DenseMap<llvm::AliasSetTracker::ASTCallbackVH, llvm::AliasSet::PointerRec*, llvm::AliasSetTracker::ASTCallbackVHDenseMapInfo, llvm::DenseMapInfo<llvm::AliasSet::PointerRec*> >::~DenseMap()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_4LoopEPNS_15AliasSetTrackerENS_12DenseMapInfoIS2_EENS5_IS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<llvm::Loop*, llvm::AliasSetTracker*, llvm::DenseMapInfo<llvm::Loop*>, llvm::DenseMapInfo<llvm::AliasSetTracker*> >::InsertIntoBucket(llvm::Loop* const&, llvm::AliasSetTracker* const&, std::pair<llvm::Loop*, llvm::AliasSetTracker*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_4LoopEPNS_15AliasSetTrackerENS_12DenseMapInfoIS2_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::Loop*, llvm::AliasSetTracker*, llvm::DenseMapInfo<llvm::Loop*>, llvm::DenseMapInfo<llvm::AliasSetTracker*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_15AliasSetTracker13ASTCallbackVHEPNS_8AliasSet10PointerRecENS1_25ASTCallbackVHDenseMapInfoENS_12DenseMapInfoIS5_EEE4initEj", "llvm::DenseMap<llvm::AliasSetTracker::ASTCallbackVH, llvm::AliasSet::PointerRec*, llvm::AliasSetTracker::ASTCallbackVHDenseMapInfo, llvm::DenseMapInfo<llvm::AliasSet::PointerRec*> >::init(unsigned int)"),
	mu_demangle_test("_ZN4llvm15SmallVectorImplIPNS_15DomTreeNodeBaseINS_10BasicBlockEEEE6insertIN9__gnu_cxx17__normal_iteratorIPS4_St6vectorIS4_SaIS4_EEEEEES9_S9_T_SE_", "llvm::DomTreeNodeBase<llvm::BasicBlock>** llvm::SmallVectorImpl<llvm::DomTreeNodeBase<llvm::BasicBlock>*>::insert<__gnu_cxx::__normal_iterator<llvm::DomTreeNodeBase<llvm::BasicBlock>**, std::vector<llvm::DomTreeNodeBase<llvm::BasicBlock>*, std::allocator<llvm::DomTreeNodeBase<llvm::BasicBlock>*> > > >(llvm::DomTreeNodeBase<llvm::BasicBlock>**, __gnu_cxx::__normal_iterator<llvm::DomTreeNodeBase<llvm::BasicBlock>**, std::vector<llvm::DomTreeNodeBase<llvm::BasicBlock>*, std::allocator<llvm::DomTreeNodeBase<llvm::BasicBlock>*> > >, __gnu_cxx::__normal_iterator<llvm::DomTreeNodeBase<llvm::BasicBlock>**, std::vector<llvm::DomTreeNodeBase<llvm::BasicBlock>*, std::allocator<llvm::DomTreeNodeBase<llvm::BasicBlock>*> > >)"),
	mu_demangle_test("_ZN4llvm8ValueMapIPKNS_5ValueENS_10TrackingVHIS1_EENS_14ValueMapConfigIS3_EENS_12DenseMapInfoIS5_EEEixERKS3_", "llvm::ValueMap<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >::operator[](llvm::Value const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_18ValueMapCallbackVHIPKNS_5ValueENS_10TrackingVHIS2_EENS_14ValueMapConfigIS4_EENS_12DenseMapInfoIS6_EEEES6_NS9_ISB_EESA_ED2Ev", "llvm::DenseMap<llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >, llvm::TrackingVH<llvm::Value>, llvm::DenseMapInfo<llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > > >, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >::~DenseMap()"),
	mu_demangle_test("_ZN4llvm18ValueMapCallbackVHIPKNS_5ValueENS_10TrackingVHIS1_EENS_14ValueMapConfigIS3_EENS_12DenseMapInfoIS5_EEED1Ev", "llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >::~ValueMapCallbackVH()"),
	mu_demangle_test("_ZN4llvm18ValueMapCallbackVHIPKNS_5ValueENS_10TrackingVHIS1_EENS_14ValueMapConfigIS3_EENS_12DenseMapInfoIS5_EEED0Ev", "llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >::~ValueMapCallbackVH()"),
	mu_demangle_test("_ZN4llvm18ValueMapCallbackVHIPKNS_5ValueENS_10TrackingVHIS1_EENS_14ValueMapConfigIS3_EENS_12DenseMapInfoIS5_EEE7deletedEv", "llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >::deleted()"),
	mu_demangle_test("_ZN4llvm18ValueMapCallbackVHIPKNS_5ValueENS_10TrackingVHIS1_EENS_14ValueMapConfigIS3_EENS_12DenseMapInfoIS5_EEE19allUsesReplacedWithEPS1_", "llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >::allUsesReplacedWith(llvm::Value*)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_18ValueMapCallbackVHIPKNS_5ValueENS_10TrackingVHIS2_EENS_14ValueMapConfigIS4_EENS_12DenseMapInfoIS6_EEEES6_NS9_ISB_EESA_E4findERKSB_", "llvm::DenseMap<llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >, llvm::TrackingVH<llvm::Value>, llvm::DenseMapInfo<llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > > >, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >::find(llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_18ValueMapCallbackVHIPKNS_5ValueENS_10TrackingVHIS2_EENS_14ValueMapConfigIS4_EENS_12DenseMapInfoIS6_EEEES6_NS9_ISB_EESA_E5eraseENS_16DenseMapIteratorISB_S6_SC_SA_Lb0EEE", "llvm::DenseMap<llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >, llvm::TrackingVH<llvm::Value>, llvm::DenseMapInfo<llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > > >, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >::erase(llvm::DenseMapIterator<llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >, llvm::TrackingVH<llvm::Value>, llvm::DenseMapInfo<llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > > >, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> >, false>)"),
	mu_demangle_test("_ZN4llvm8ValueMapIPKNS_5ValueENS_10TrackingVHIS1_EENS_14ValueMapConfigIS3_EENS_12DenseMapInfoIS5_EEE6insertERKSt4pairIS3_S5_E", "llvm::ValueMap<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >::insert(std::pair<llvm::Value const*, llvm::TrackingVH<llvm::Value> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_18ValueMapCallbackVHIPKNS_5ValueENS_10TrackingVHIS2_EENS_14ValueMapConfigIS4_EENS_12DenseMapInfoIS6_EEEES6_NS9_ISB_EESA_E6insertERKSt4pairISB_S6_E", "llvm::DenseMap<llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >, llvm::TrackingVH<llvm::Value>, llvm::DenseMapInfo<llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > > >, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >::insert(std::pair<llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >, llvm::TrackingVH<llvm::Value> > const&)"),
	mu_demangle_test("_ZNK4llvm8DenseMapINS_18ValueMapCallbackVHIPKNS_5ValueENS_10TrackingVHIS2_EENS_14ValueMapConfigIS4_EENS_12DenseMapInfoIS6_EEEES6_NS9_ISB_EESA_E15LookupBucketForERKSB_RPSt4pairISB_S6_E", "llvm::DenseMap<llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >, llvm::TrackingVH<llvm::Value>, llvm::DenseMapInfo<llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > > >, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >::LookupBucketFor(llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > > const&, std::pair<llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >, llvm::TrackingVH<llvm::Value> >*&) const"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_18ValueMapCallbackVHIPKNS_5ValueENS_10TrackingVHIS2_EENS_14ValueMapConfigIS4_EENS_12DenseMapInfoIS6_EEEES6_NS9_ISB_EESA_E16InsertIntoBucketERKSB_RKS6_PSt4pairISB_S6_E", "llvm::DenseMap<llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >, llvm::TrackingVH<llvm::Value>, llvm::DenseMapInfo<llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > > >, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >::InsertIntoBucket(llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > > const&, llvm::TrackingVH<llvm::Value> const&, std::pair<llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >, llvm::TrackingVH<llvm::Value> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_18ValueMapCallbackVHIPKNS_5ValueENS_10TrackingVHIS2_EENS_14ValueMapConfigIS4_EENS_12DenseMapInfoIS6_EEEES6_NS9_ISB_EESA_E4growEj", "llvm::DenseMap<llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >, llvm::TrackingVH<llvm::Value>, llvm::DenseMapInfo<llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > > >, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_18ValueMapCallbackVHIPKNS_5ValueENS_10TrackingVHIS2_EENS_14ValueMapConfigIS4_EENS_12DenseMapInfoIS6_EEEES6_NS9_ISB_EESA_E5eraseERKSB_", "llvm::DenseMap<llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >, llvm::TrackingVH<llvm::Value>, llvm::DenseMapInfo<llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > > >, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >::erase(llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_18ValueMapCallbackVHIPKNS_5ValueENS_10TrackingVHIS2_EENS_14ValueMapConfigIS4_EENS_12DenseMapInfoIS6_EEEES6_NS9_ISB_EESA_E4initEj", "llvm::DenseMap<llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >, llvm::TrackingVH<llvm::Value>, llvm::DenseMapInfo<llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > > >, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >::init(unsigned int)"),
	mu_demangle_test("_ZNK12_GLOBAL__N_111LSRInstance12SolveRecurseERN4llvm15SmallVectorImplIPKNS_7FormulaEEERNS_4CostES7_RKS8_RKNS1_11SmallPtrSetIPKNS1_4SCEVELj16EEERNS1_8DenseSetISF_NS1_12DenseMapInfoISF_EEEE", "(anonymous namespace)::LSRInstance::SolveRecurse(llvm::SmallVectorImpl<(anonymous namespace)::Formula const*>&, (anonymous namespace)::Cost&, llvm::SmallVectorImpl<(anonymous namespace)::Formula const*>&, (anonymous namespace)::Cost const&, llvm::SmallPtrSet<llvm::SCEV const*, 16u> const&, llvm::DenseSet<llvm::SCEV const*, llvm::DenseMapInfo<llvm::SCEV const*> >&) const"),
	mu_demangle_test("_ZN12_GLOBAL__N_14Cost11RateFormulaERKNS_7FormulaERN4llvm11SmallPtrSetIPKNS4_4SCEVELj16EEERKNS4_8DenseSetIS8_NS4_12DenseMapInfoIS8_EEEEPKNS4_4LoopERKNS4_15SmallVectorImplIxEERNS4_15ScalarEvolutionERNS4_13DominatorTreeE", "(anonymous namespace)::Cost::RateFormula((anonymous namespace)::Formula const&, llvm::SmallPtrSet<llvm::SCEV const*, 16u>&, llvm::DenseSet<llvm::SCEV const*, llvm::DenseMapInfo<llvm::SCEV const*> > const&, llvm::Loop const*, llvm::SmallVectorImpl<int64_t> const&, llvm::ScalarEvolution&, llvm::DominatorTree&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_11SmallVectorIPKNS_4SCEVELj2EEEcN12_GLOBAL__N_122UniquifierDenseMapInfoENS_12DenseMapInfoIcEEE8CopyFromERKSA_", "llvm::DenseMap<llvm::SmallVector<llvm::SCEV const*, 2u>, char, (anonymous namespace)::UniquifierDenseMapInfo, llvm::DenseMapInfo<char> >::CopyFrom(llvm::DenseMap<llvm::SmallVector<llvm::SCEV const*, 2u>, char, (anonymous namespace)::UniquifierDenseMapInfo, llvm::DenseMapInfo<char> > const&)"),
	mu_demangle_test("_ZNK4llvm8DenseMapINS_11SmallVectorIPKNS_4SCEVELj2EEEcN12_GLOBAL__N_122UniquifierDenseMapInfoENS_12DenseMapInfoIcEEE15LookupBucketForERKS5_RPSt4pairIS5_cE", "llvm::DenseMap<llvm::SmallVector<llvm::SCEV const*, 2u>, char, (anonymous namespace)::UniquifierDenseMapInfo, llvm::DenseMapInfo<char> >::LookupBucketFor(llvm::SmallVector<llvm::SCEV const*, 2u> const&, std::pair<llvm::SmallVector<llvm::SCEV const*, 2u>, char>*&) const"),
	mu_demangle_test("_ZNK4llvm8DenseMapINS_11SmallVectorIPKNS_4SCEVELj2EEEmN12_GLOBAL__N_122UniquifierDenseMapInfoENS_12DenseMapInfoImEEE15LookupBucketForERKS5_RPSt4pairIS5_mE", "llvm::DenseMap<llvm::SmallVector<llvm::SCEV const*, 2u>, unsigned long, (anonymous namespace)::UniquifierDenseMapInfo, llvm::DenseMapInfo<unsigned long> >::LookupBucketFor(llvm::SmallVector<llvm::SCEV const*, 2u> const&, std::pair<llvm::SmallVector<llvm::SCEV const*, 2u>, unsigned long>*&) const"),
	mu_demangle_test("_ZNSt8_Rb_treeIxxSt9_IdentityIxESt4lessIxESaIxEE8_M_eraseEPSt13_Rb_tree_nodeIxE", "std::_Rb_tree<int64_t, int64_t, std::_Identity<int64_t>, std::less<int64_t>, std::allocator<int64_t> >::_M_erase(std::_Rb_tree_node<int64_t>*)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm4SCEVEPNS1_11InstructionEES0_IKS7_NS1_11AssertingVHINS1_5ValueEEEESt10_Select1stISC_ESt4lessIS7_ESaISC_EE8_M_eraseEPSt13_Rb_tree_nodeISC_E", "std::_Rb_tree<std::pair<llvm::SCEV const*, llvm::Instruction*>, std::pair<std::pair<llvm::SCEV const*, llvm::Instruction*> const, llvm::AssertingVH<llvm::Value> >, std::_Select1st<std::pair<std::pair<llvm::SCEV const*, llvm::Instruction*> const, llvm::AssertingVH<llvm::Value> > >, std::less<std::pair<llvm::SCEV const*, llvm::Instruction*> >, std::allocator<std::pair<std::pair<llvm::SCEV const*, llvm::Instruction*> const, llvm::AssertingVH<llvm::Value> > > >::_M_erase(std::_Rb_tree_node<std::pair<std::pair<llvm::SCEV const*, llvm::Instruction*> const, llvm::AssertingVH<llvm::Value> > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm11AssertingVHINS0_5ValueEEES3_St9_IdentityIS3_ESt4lessIS3_ESaIS3_EE8_M_eraseEPSt13_Rb_tree_nodeIS3_E", "std::_Rb_tree<llvm::AssertingVH<llvm::Value>, llvm::AssertingVH<llvm::Value>, std::_Identity<llvm::AssertingVH<llvm::Value> >, std::less<llvm::AssertingVH<llvm::Value> >, std::allocator<llvm::AssertingVH<llvm::Value> > >::_M_erase(std::_Rb_tree_node<llvm::AssertingVH<llvm::Value> >*)"),
	mu_demangle_test("_ZSt6__findIN9__gnu_cxx17__normal_iteratorIPKPN4llvm10BasicBlockESt6vectorIS4_SaIS4_EEEEPKS3_ET_SD_SD_RKT0_St26random_access_iterator_tag", "__gnu_cxx::__normal_iterator<llvm::BasicBlock* const*, std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> > > std::__find<__gnu_cxx::__normal_iterator<llvm::BasicBlock* const*, std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> > >, llvm::BasicBlock const*>(__gnu_cxx::__normal_iterator<llvm::BasicBlock* const*, std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> > >, __gnu_cxx::__normal_iterator<llvm::BasicBlock* const*, std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> > >, llvm::BasicBlock const* const&, std::random_access_iterator_tag)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEPNS_5ValueENS_12DenseMapInfoIS2_EENS5_IS4_EEE6insertERKSt4pairIS2_S4_E", "llvm::DenseMap<llvm::BasicBlock*, llvm::Value*, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::Value*> >::insert(std::pair<llvm::BasicBlock*, llvm::Value*> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4SCEVEcNS_12DenseMapInfoIS3_EENS4_IcEEE6insertERKSt4pairIS3_cE", "llvm::DenseMap<llvm::SCEV const*, char, llvm::DenseMapInfo<llvm::SCEV const*>, llvm::DenseMapInfo<char> >::insert(std::pair<llvm::SCEV const*, char> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4SCEVEcNS_12DenseMapInfoIS3_EENS4_IcEEE16InsertIntoBucketERKS3_RKcPSt4pairIS3_cE", "llvm::DenseMap<llvm::SCEV const*, char, llvm::DenseMapInfo<llvm::SCEV const*>, llvm::DenseMapInfo<char> >::InsertIntoBucket(llvm::SCEV const* const&, char const&, std::pair<llvm::SCEV const*, char>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4SCEVEcNS_12DenseMapInfoIS3_EENS4_IcEEE4growEj", "llvm::DenseMap<llvm::SCEV const*, char, llvm::DenseMapInfo<llvm::SCEV const*>, llvm::DenseMapInfo<char> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4SCEVESt3mapIxS3_St4lessIxESaISt4pairIKxS3_EEENS_12DenseMapInfoIS3_EENSC_ISB_EEE6insertERKS7_IS3_SB_E", "llvm::DenseMap<llvm::SCEV const*, std::map<int64_t, llvm::SCEV const*, std::less<int64_t>, std::allocator<std::pair<int64_t const, llvm::SCEV const*> > >, llvm::DenseMapInfo<llvm::SCEV const*>, llvm::DenseMapInfo<std::map<int64_t, llvm::SCEV const*, std::less<int64_t>, std::allocator<std::pair<int64_t const, llvm::SCEV const*> > > > >::insert(std::pair<llvm::SCEV const*, std::map<int64_t, llvm::SCEV const*, std::less<int64_t>, std::allocator<std::pair<int64_t const, llvm::SCEV const*> > > > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4SCEVESt3mapIxS3_St4lessIxESaISt4pairIKxS3_EEENS_12DenseMapInfoIS3_EENSC_ISB_EEE5clearEv", "llvm::DenseMap<llvm::SCEV const*, std::map<int64_t, llvm::SCEV const*, std::less<int64_t>, std::allocator<std::pair<int64_t const, llvm::SCEV const*> > >, llvm::DenseMapInfo<llvm::SCEV const*>, llvm::DenseMapInfo<std::map<int64_t, llvm::SCEV const*, std::less<int64_t>, std::allocator<std::pair<int64_t const, llvm::SCEV const*> > > > >::clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4SCEVENS_14SmallBitVectorENS_12DenseMapInfoIS3_EENS5_IS4_EEE5clearEv", "llvm::DenseMap<llvm::SCEV const*, llvm::SmallBitVector, llvm::DenseMapInfo<llvm::SCEV const*>, llvm::DenseMapInfo<llvm::SmallBitVector> >::clear()"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairImxES1_St9_IdentityIS1_ESt4lessIS1_ESaIS1_EE8_M_eraseEPSt13_Rb_tree_nodeIS1_E", "std::_Rb_tree<std::pair<unsigned long, int64_t>, std::pair<unsigned long, int64_t>, std::_Identity<std::pair<unsigned long, int64_t> >, std::less<std::pair<unsigned long, int64_t> >, std::allocator<std::pair<unsigned long, int64_t> > >::_M_erase(std::_Rb_tree_node<std::pair<unsigned long, int64_t> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4SCEVENS_14SmallBitVectorENS_12DenseMapInfoIS3_EENS5_IS4_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::SCEV const*, llvm::SmallBitVector, llvm::DenseMapInfo<llvm::SCEV const*>, llvm::DenseMapInfo<llvm::SmallBitVector> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4SCEVESt3mapIxS3_St4lessIxESaISt4pairIKxS3_EEENS_12DenseMapInfoIS3_EENSC_ISB_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::SCEV const*, std::map<int64_t, llvm::SCEV const*, std::less<int64_t>, std::allocator<std::pair<int64_t const, llvm::SCEV const*> > >, llvm::DenseMapInfo<llvm::SCEV const*>, llvm::DenseMapInfo<std::map<int64_t, llvm::SCEV const*, std::less<int64_t>, std::allocator<std::pair<int64_t const, llvm::SCEV const*> > > > >::shrink_and_clear()"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairImxES1_St9_IdentityIS1_ESt4lessIS1_ESaIS1_EE16_M_insert_uniqueERKS1_", "std::_Rb_tree<std::pair<unsigned long, int64_t>, std::pair<unsigned long, int64_t>, std::_Identity<std::pair<unsigned long, int64_t> >, std::less<std::pair<unsigned long, int64_t> >, std::allocator<std::pair<unsigned long, int64_t> > >::_M_insert_unique(std::pair<unsigned long, int64_t> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4SCEVENS_14SmallBitVectorENS_12DenseMapInfoIS3_EENS5_IS4_EEE16FindAndConstructERKS3_", "llvm::DenseMap<llvm::SCEV const*, llvm::SmallBitVector, llvm::DenseMapInfo<llvm::SCEV const*>, llvm::DenseMapInfo<llvm::SmallBitVector> >::FindAndConstruct(llvm::SCEV const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4SCEVENS_14SmallBitVectorENS_12DenseMapInfoIS3_EENS5_IS4_EEE16InsertIntoBucketERKS3_RKS4_PSt4pairIS3_S4_E", "llvm::DenseMap<llvm::SCEV const*, llvm::SmallBitVector, llvm::DenseMapInfo<llvm::SCEV const*>, llvm::DenseMapInfo<llvm::SmallBitVector> >::InsertIntoBucket(llvm::SCEV const* const&, llvm::SmallBitVector const&, std::pair<llvm::SCEV const*, llvm::SmallBitVector>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4SCEVENS_14SmallBitVectorENS_12DenseMapInfoIS3_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::SCEV const*, llvm::SmallBitVector, llvm::DenseMapInfo<llvm::SCEV const*>, llvm::DenseMapInfo<llvm::SmallBitVector> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt8_Rb_treeIxSt4pairIKxPKN4llvm4SCEVEESt10_Select1stIS6_ESt4lessIxESaIS6_EE16_M_insert_uniqueERKS6_", "std::_Rb_tree<int64_t, std::pair<int64_t const, llvm::SCEV const*>, std::_Select1st<std::pair<int64_t const, llvm::SCEV const*> >, std::less<int64_t>, std::allocator<std::pair<int64_t const, llvm::SCEV const*> > >::_M_insert_unique(std::pair<int64_t const, llvm::SCEV const*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIxSt4pairIKxPKN4llvm4SCEVEESt10_Select1stIS6_ESt4lessIxESaIS6_EE8_M_eraseEPSt13_Rb_tree_nodeIS6_E", "std::_Rb_tree<int64_t, std::pair<int64_t const, llvm::SCEV const*>, std::_Select1st<std::pair<int64_t const, llvm::SCEV const*> >, std::less<int64_t>, std::allocator<std::pair<int64_t const, llvm::SCEV const*> > >::_M_erase(std::_Rb_tree_node<std::pair<int64_t const, llvm::SCEV const*> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIxSt4pairIKxPKN4llvm4SCEVEESt10_Select1stIS6_ESt4lessIxESaIS6_EE7_M_copyEPKSt13_Rb_tree_nodeIS6_EPSE_", "std::_Rb_tree<int64_t, std::pair<int64_t const, llvm::SCEV const*>, std::_Select1st<std::pair<int64_t const, llvm::SCEV const*> >, std::less<int64_t>, std::allocator<std::pair<int64_t const, llvm::SCEV const*> > >::_M_copy(std::_Rb_tree_node<std::pair<int64_t const, llvm::SCEV const*> > const*, std::_Rb_tree_node<std::pair<int64_t const, llvm::SCEV const*> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4SCEVESt3mapIxS3_St4lessIxESaISt4pairIKxS3_EEENS_12DenseMapInfoIS3_EENSC_ISB_EEE16InsertIntoBucketERKS3_RKSB_PS7_IS3_SB_E", "llvm::DenseMap<llvm::SCEV const*, std::map<int64_t, llvm::SCEV const*, std::less<int64_t>, std::allocator<std::pair<int64_t const, llvm::SCEV const*> > >, llvm::DenseMapInfo<llvm::SCEV const*>, llvm::DenseMapInfo<std::map<int64_t, llvm::SCEV const*, std::less<int64_t>, std::allocator<std::pair<int64_t const, llvm::SCEV const*> > > > >::InsertIntoBucket(llvm::SCEV const* const&, std::map<int64_t, llvm::SCEV const*, std::less<int64_t>, std::allocator<std::pair<int64_t const, llvm::SCEV const*> > > const&, std::pair<llvm::SCEV const*, std::map<int64_t, llvm::SCEV const*, std::less<int64_t>, std::allocator<std::pair<int64_t const, llvm::SCEV const*> > > >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4SCEVESt3mapIxS3_St4lessIxESaISt4pairIKxS3_EEENS_12DenseMapInfoIS3_EENSC_ISB_EEE4growEj", "llvm::DenseMap<llvm::SCEV const*, std::map<int64_t, llvm::SCEV const*, std::less<int64_t>, std::allocator<std::pair<int64_t const, llvm::SCEV const*> > >, llvm::DenseMapInfo<llvm::SCEV const*>, llvm::DenseMapInfo<std::map<int64_t, llvm::SCEV const*, std::less<int64_t>, std::allocator<std::pair<int64_t const, llvm::SCEV const*> > > > >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt8_Rb_treeIxxSt9_IdentityIxESt4lessIxESaIxEE16_M_insert_uniqueERKx", "std::_Rb_tree<int64_t, int64_t, std::_Identity<int64_t>, std::less<int64_t>, std::allocator<int64_t> >::_M_insert_unique(int64_t const&)"),
	mu_demangle_test("_Z9CloneLoopPN4llvm4LoopES1_RNS_8ValueMapIPKNS_5ValueENS_10TrackingVHIS3_EENS_14ValueMapConfigIS5_EENS_12DenseMapInfoIS7_EEEEPNS_8LoopInfoEPNS_13LPPassManagerE", "CloneLoop(llvm::Loop*, llvm::Loop*, llvm::ValueMap<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >&, llvm::LoopInfo*, llvm::LPPassManager*)"),
	mu_demangle_test("_ZN12_GLOBAL__N_112LoopUnswitch12SimplifyCodeERSt6vectorIPN4llvm11InstructionESaIS4_EEPNS2_4LoopE", "(anonymous namespace)::LoopUnswitch::SimplifyCode(std::vector<llvm::Instruction*, std::allocator<llvm::Instruction*> >&, llvm::Loop*)"),
	mu_demangle_test("_Z18RemoveFromWorklistPN4llvm11InstructionERSt6vectorIS1_SaIS1_EE", "RemoveFromWorklist(llvm::Instruction*, std::vector<llvm::Instruction*, std::allocator<llvm::Instruction*> >&)"),
	mu_demangle_test("_Z17ReplaceUsesOfWithPN4llvm11InstructionEPNS_5ValueERSt6vectorIS1_SaIS1_EEPNS_4LoopEPNS_13LPPassManagerE", "ReplaceUsesOfWith(llvm::Instruction*, llvm::Value*, std::vector<llvm::Instruction*, std::allocator<llvm::Instruction*> >&, llvm::Loop*, llvm::LPPassManager*)"),
	mu_demangle_test("_Z28isTrivialLoopExitBlockHelperPN4llvm4LoopEPNS_10BasicBlockERS3_RSt3setIS3_St4lessIS3_ESaIS3_EE", "isTrivialLoopExitBlockHelper(llvm::Loop*, llvm::BasicBlock*, llvm::BasicBlock*&, std::set<llvm::BasicBlock*, std::less<llvm::BasicBlock*>, std::allocator<llvm::BasicBlock*> >&)"),
	mu_demangle_test("_ZSt6__findIN9__gnu_cxx17__normal_iteratorIPPN4llvm11InstructionESt6vectorIS4_SaIS4_EEEES4_ET_SA_SA_RKT0_St26random_access_iterator_tag", "__gnu_cxx::__normal_iterator<llvm::Instruction**, std::vector<llvm::Instruction*, std::allocator<llvm::Instruction*> > > std::__find<__gnu_cxx::__normal_iterator<llvm::Instruction**, std::vector<llvm::Instruction*, std::allocator<llvm::Instruction*> > >, llvm::Instruction*>(__gnu_cxx::__normal_iterator<llvm::Instruction**, std::vector<llvm::Instruction*, std::allocator<llvm::Instruction*> > >, __gnu_cxx::__normal_iterator<llvm::Instruction**, std::vector<llvm::Instruction*, std::allocator<llvm::Instruction*> > >, llvm::Instruction* const&, std::random_access_iterator_tag)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm4UserESaIS2_EEC2INS0_18value_use_iteratorIS1_EEEET_S8_RKS3_", "std::vector<llvm::User*, std::allocator<llvm::User*> >::vector<llvm::value_use_iterator<llvm::User> >(llvm::value_use_iterator<llvm::User>, llvm::value_use_iterator<llvm::User>, std::allocator<llvm::User*> const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm10BasicBlockESaIS2_EE15_M_range_insertIPS2_EEvN9__gnu_cxx17__normal_iteratorIS6_S4_EET_SA_St20forward_iterator_tag", "void std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> >::_M_range_insert<llvm::BasicBlock**>(__gnu_cxx::__normal_iterator<llvm::BasicBlock**, std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> > >, llvm::BasicBlock**, llvm::BasicBlock**, std::forward_iterator_tag)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm10BasicBlockESaIS2_EE15_M_range_insertIN9__gnu_cxx17__normal_iteratorIPKS2_S4_EEEEvNS7_IPS2_S4_EET_SD_St20forward_iterator_tag", "void std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> >::_M_range_insert<__gnu_cxx::__normal_iterator<llvm::BasicBlock* const*, std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> > > >(__gnu_cxx::__normal_iterator<llvm::BasicBlock**, std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> > >, __gnu_cxx::__normal_iterator<llvm::BasicBlock* const*, std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> > >, __gnu_cxx::__normal_iterator<llvm::BasicBlock* const*, std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> > >, std::forward_iterator_tag)"),
	mu_demangle_test("_ZN4llvm15SmallVectorImplIPNS_4UserEE6appendINS_18value_use_iteratorIS1_EEEEvT_S7_", "void llvm::SmallVectorImpl<llvm::User*>::append<llvm::value_use_iterator<llvm::User> >(llvm::value_use_iterator<llvm::User>, llvm::value_use_iterator<llvm::User>)"),
	mu_demangle_test("_Z21LowerNegateToMultiplyPN4llvm11InstructionERNS_8DenseMapINS_11AssertingVHINS_5ValueEEEjNS_12DenseMapInfoIS5_EENS6_IjEEEE", "LowerNegateToMultiply(llvm::Instruction*, llvm::DenseMap<llvm::AssertingVH<llvm::Value>, unsigned int, llvm::DenseMapInfo<llvm::AssertingVH<llvm::Value> >, llvm::DenseMapInfo<unsigned int> >&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_11AssertingVHINS_5ValueEEEjNS_12DenseMapInfoIS3_EENS4_IjEEE16shrink_and_clearEv", "llvm::DenseMap<llvm::AssertingVH<llvm::Value>, unsigned int, llvm::DenseMapInfo<llvm::AssertingVH<llvm::Value> >, llvm::DenseMapInfo<unsigned int> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_11AssertingVHINS_5ValueEEEjNS_12DenseMapInfoIS3_EENS4_IjEEE16InsertIntoBucketERKS3_RKjPSt4pairIS3_jE", "llvm::DenseMap<llvm::AssertingVH<llvm::Value>, unsigned int, llvm::DenseMapInfo<llvm::AssertingVH<llvm::Value> >, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(llvm::AssertingVH<llvm::Value> const&, unsigned int const&, std::pair<llvm::AssertingVH<llvm::Value>, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_11AssertingVHINS_5ValueEEEjNS_12DenseMapInfoIS3_EENS4_IjEEE4growEj", "llvm::DenseMap<llvm::AssertingVH<llvm::Value>, unsigned int, llvm::DenseMapInfo<llvm::AssertingVH<llvm::Value> >, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm25ReversePostOrderTraversalIPNS_8FunctionENS_11GraphTraitsIS2_EEEC2ES2_", "llvm::ReversePostOrderTraversal<llvm::Function*, llvm::GraphTraits<llvm::Function*> >::ReversePostOrderTraversal(llvm::Function*)"),
	mu_demangle_test("_ZSt4copyIN4llvm11po_iteratorIPNS0_10BasicBlockENS0_11SmallPtrSetIS3_Lj8EEELb0ENS0_11GraphTraitsIS3_EEEESt20back_insert_iteratorISt6vectorIS3_SaIS3_EEEET0_T_SF_SE_", "std::back_insert_iterator<std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> > > std::copy<llvm::po_iterator<llvm::BasicBlock*, llvm::SmallPtrSet<llvm::BasicBlock*, 8u>, false, llvm::GraphTraits<llvm::BasicBlock*> >, std::back_insert_iterator<std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> > > >(llvm::po_iterator<llvm::BasicBlock*, llvm::SmallPtrSet<llvm::BasicBlock*, 8u>, false, llvm::GraphTraits<llvm::BasicBlock*> >, llvm::po_iterator<llvm::BasicBlock*, llvm::SmallPtrSet<llvm::BasicBlock*, 8u>, false, llvm::GraphTraits<llvm::BasicBlock*> >, std::back_insert_iterator<std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> > >)"),
	mu_demangle_test("_ZN4llvm8po_beginIPNS_10BasicBlockEEENS_11po_iteratorIT_NS_11SmallPtrSetIPNS_11GraphTraitsIS4_E8NodeTypeELj8EEELb0ES7_EES4_", "llvm::po_iterator<llvm::BasicBlock*, llvm::SmallPtrSet<llvm::GraphTraits<llvm::BasicBlock*>::NodeType*, 8u>, false, llvm::GraphTraits<llvm::BasicBlock*> > llvm::po_begin<llvm::BasicBlock*>(llvm::BasicBlock*)"),
	mu_demangle_test("_ZN4llvm11po_iteratorIPNS_10BasicBlockENS_11SmallPtrSetIS2_Lj8EEELb0ENS_11GraphTraitsIS2_EEE13traverseChildEv", "llvm::po_iterator<llvm::BasicBlock*, llvm::SmallPtrSet<llvm::BasicBlock*, 8u>, false, llvm::GraphTraits<llvm::BasicBlock*> >::traverseChild()"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPN4llvm10BasicBlockENS1_12SuccIteratorIPNS1_14TerminatorInstES2_EEESaIS8_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS8_SA_EERKS8_", "std::vector<std::pair<llvm::BasicBlock*, llvm::SuccIterator<llvm::TerminatorInst*, llvm::BasicBlock> >, std::allocator<std::pair<llvm::BasicBlock*, llvm::SuccIterator<llvm::TerminatorInst*, llvm::BasicBlock> > > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::BasicBlock*, llvm::SuccIterator<llvm::TerminatorInst*, llvm::BasicBlock> >*, std::vector<std::pair<llvm::BasicBlock*, llvm::SuccIterator<llvm::TerminatorInst*, llvm::BasicBlock> >, std::allocator<std::pair<llvm::BasicBlock*, llvm::SuccIterator<llvm::TerminatorInst*, llvm::BasicBlock> > > > >, std::pair<llvm::BasicBlock*, llvm::SuccIterator<llvm::TerminatorInst*, llvm::BasicBlock> > const&)"),
	mu_demangle_test("_ZNSt13__copy_normalILb0ELb0EE8__copy_nIN4llvm11po_iteratorIPNS2_10BasicBlockENS2_11SmallPtrSetIS5_Lj8EEELb0ENS2_11GraphTraitsIS5_EEEESt20back_insert_iteratorISt6vectorIS5_SaIS5_EEEEET0_T_SH_SG_", "std::back_insert_iterator<std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> > > std::__copy_normal<false, false>::__copy_n<llvm::po_iterator<llvm::BasicBlock*, llvm::SmallPtrSet<llvm::BasicBlock*, 8u>, false, llvm::GraphTraits<llvm::BasicBlock*> >, std::back_insert_iterator<std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> > > >(llvm::po_iterator<llvm::BasicBlock*, llvm::SmallPtrSet<llvm::BasicBlock*, 8u>, false, llvm::GraphTraits<llvm::BasicBlock*> >, llvm::po_iterator<llvm::BasicBlock*, llvm::SmallPtrSet<llvm::BasicBlock*, 8u>, false, llvm::GraphTraits<llvm::BasicBlock*> >, std::back_insert_iterator<std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> > >)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPN4llvm10BasicBlockENS1_12SuccIteratorIPNS1_14TerminatorInstES2_EEESaIS8_EEC2ERKSA_", "std::vector<std::pair<llvm::BasicBlock*, llvm::SuccIterator<llvm::TerminatorInst*, llvm::BasicBlock> >, std::allocator<std::pair<llvm::BasicBlock*, llvm::SuccIterator<llvm::TerminatorInst*, llvm::BasicBlock> > > >::vector(std::vector<std::pair<llvm::BasicBlock*, llvm::SuccIterator<llvm::TerminatorInst*, llvm::BasicBlock> >, std::allocator<std::pair<llvm::BasicBlock*, llvm::SuccIterator<llvm::TerminatorInst*, llvm::BasicBlock> > > > const&)"),
	mu_demangle_test("_ZSt10__copy_auxIN4llvm11po_iteratorIPNS0_10BasicBlockENS0_11SmallPtrSetIS3_Lj8EEELb0ENS0_11GraphTraitsIS3_EEEESt20back_insert_iteratorISt6vectorIS3_SaIS3_EEEET0_T_SF_SE_", "std::back_insert_iterator<std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> > > std::__copy_aux<llvm::po_iterator<llvm::BasicBlock*, llvm::SmallPtrSet<llvm::BasicBlock*, 8u>, false, llvm::GraphTraits<llvm::BasicBlock*> >, std::back_insert_iterator<std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> > > >(llvm::po_iterator<llvm::BasicBlock*, llvm::SmallPtrSet<llvm::BasicBlock*, 8u>, false, llvm::GraphTraits<llvm::BasicBlock*> >, llvm::po_iterator<llvm::BasicBlock*, llvm::SmallPtrSet<llvm::BasicBlock*, 8u>, false, llvm::GraphTraits<llvm::BasicBlock*> >, std::back_insert_iterator<std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> > >)"),
	mu_demangle_test("_ZNSt6__copyILb0ESt20forward_iterator_tagE4copyIN4llvm11po_iteratorIPNS3_10BasicBlockENS3_11SmallPtrSetIS6_Lj8EEELb0ENS3_11GraphTraitsIS6_EEEESt20back_insert_iteratorISt6vectorIS6_SaIS6_EEEEET0_T_SI_SH_", "std::back_insert_iterator<std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> > > std::__copy<false, std::forward_iterator_tag>::copy<llvm::po_iterator<llvm::BasicBlock*, llvm::SmallPtrSet<llvm::BasicBlock*, 8u>, false, llvm::GraphTraits<llvm::BasicBlock*> >, std::back_insert_iterator<std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> > > >(llvm::po_iterator<llvm::BasicBlock*, llvm::SmallPtrSet<llvm::BasicBlock*, 8u>, false, llvm::GraphTraits<llvm::BasicBlock*> >, llvm::po_iterator<llvm::BasicBlock*, llvm::SmallPtrSet<llvm::BasicBlock*, 8u>, false, llvm::GraphTraits<llvm::BasicBlock*> >, std::back_insert_iterator<std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> > >)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5ValueEN12_GLOBAL__N_110LatticeValENS_12DenseMapInfoIS2_EENS5_IS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<llvm::Value*, (anonymous namespace)::LatticeVal, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<(anonymous namespace)::LatticeVal> >::InsertIntoBucket(llvm::Value* const&, (anonymous namespace)::LatticeVal const&, std::pair<llvm::Value*, (anonymous namespace)::LatticeVal>*)"),
	mu_demangle_test("_ZNK4llvm8DenseMapISt4pairIPNS_8FunctionEjEN12_GLOBAL__N_110LatticeValENS_12DenseMapInfoIS4_EENS7_IS6_EEE15LookupBucketForERKS4_RPS1_IS4_S6_E", "llvm::DenseMap<std::pair<llvm::Function*, unsigned int>, (anonymous namespace)::LatticeVal, llvm::DenseMapInfo<std::pair<llvm::Function*, unsigned int> >, llvm::DenseMapInfo<(anonymous namespace)::LatticeVal> >::LookupBucketFor(std::pair<llvm::Function*, unsigned int> const&, std::pair<std::pair<llvm::Function*, unsigned int>, (anonymous namespace)::LatticeVal>*&) const"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPNS_8FunctionEjEN12_GLOBAL__N_110LatticeValENS_12DenseMapInfoIS4_EENS7_IS6_EEE16InsertIntoBucketERKS4_RKS6_PS1_IS4_S6_E", "llvm::DenseMap<std::pair<llvm::Function*, unsigned int>, (anonymous namespace)::LatticeVal, llvm::DenseMapInfo<std::pair<llvm::Function*, unsigned int> >, llvm::DenseMapInfo<(anonymous namespace)::LatticeVal> >::InsertIntoBucket(std::pair<llvm::Function*, unsigned int> const&, (anonymous namespace)::LatticeVal const&, std::pair<std::pair<llvm::Function*, unsigned int>, (anonymous namespace)::LatticeVal>*)"),
	mu_demangle_test("_ZNK4llvm8DenseMapISt4pairIPNS_5ValueEjEN12_GLOBAL__N_110LatticeValENS_12DenseMapInfoIS4_EENS7_IS6_EEE15LookupBucketForERKS4_RPS1_IS4_S6_E", "llvm::DenseMap<std::pair<llvm::Value*, unsigned int>, (anonymous namespace)::LatticeVal, llvm::DenseMapInfo<std::pair<llvm::Value*, unsigned int> >, llvm::DenseMapInfo<(anonymous namespace)::LatticeVal> >::LookupBucketFor(std::pair<llvm::Value*, unsigned int> const&, std::pair<std::pair<llvm::Value*, unsigned int>, (anonymous namespace)::LatticeVal>*&) const"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm7PHINodeESt4pairIKS2_PNS0_11InstructionEESt10_Select1stIS7_ESt4lessIS2_ESaIS7_EE8_M_eraseEPSt13_Rb_tree_nodeIS7_E", "std::_Rb_tree<llvm::PHINode*, std::pair<llvm::PHINode* const, llvm::Instruction*>, std::_Select1st<std::pair<llvm::PHINode* const, llvm::Instruction*> >, std::less<llvm::PHINode*>, std::allocator<std::pair<llvm::PHINode* const, llvm::Instruction*> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::PHINode* const, llvm::Instruction*> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPNS_10BasicBlockES3_EcNS_12DenseMapInfoIS4_EENS5_IcEEE6insertERKS1_IS4_cE", "llvm::DenseMap<std::pair<llvm::BasicBlock*, llvm::BasicBlock*>, char, llvm::DenseMapInfo<std::pair<llvm::BasicBlock*, llvm::BasicBlock*> >, llvm::DenseMapInfo<char> >::insert(std::pair<std::pair<llvm::BasicBlock*, llvm::BasicBlock*>, char> const&)"),
	mu_demangle_test("_ZNK4llvm8DenseMapISt4pairIPNS_10BasicBlockES3_EcNS_12DenseMapInfoIS4_EENS5_IcEEE15LookupBucketForERKS4_RPS1_IS4_cE", "llvm::DenseMap<std::pair<llvm::BasicBlock*, llvm::BasicBlock*>, char, llvm::DenseMapInfo<std::pair<llvm::BasicBlock*, llvm::BasicBlock*> >, llvm::DenseMapInfo<char> >::LookupBucketFor(std::pair<llvm::BasicBlock*, llvm::BasicBlock*> const&, std::pair<std::pair<llvm::BasicBlock*, llvm::BasicBlock*>, char>*&) const"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPNS_10BasicBlockES3_EcNS_12DenseMapInfoIS4_EENS5_IcEEE16InsertIntoBucketERKS4_RKcPS1_IS4_cE", "llvm::DenseMap<std::pair<llvm::BasicBlock*, llvm::BasicBlock*>, char, llvm::DenseMapInfo<std::pair<llvm::BasicBlock*, llvm::BasicBlock*> >, llvm::DenseMapInfo<char> >::InsertIntoBucket(std::pair<llvm::BasicBlock*, llvm::BasicBlock*> const&, char const&, std::pair<std::pair<llvm::BasicBlock*, llvm::BasicBlock*>, char>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPNS_10BasicBlockES3_EcNS_12DenseMapInfoIS4_EENS5_IcEEE4growEj", "llvm::DenseMap<std::pair<llvm::BasicBlock*, llvm::BasicBlock*>, char, llvm::DenseMapInfo<std::pair<llvm::BasicBlock*, llvm::BasicBlock*> >, llvm::DenseMapInfo<char> >::grow(unsigned int)"),
	mu_demangle_test("_ZN12_GLOBAL__N_119ConvertToScalarInfo26ConvertScalar_ExtractValueEPN4llvm5ValueEPKNS1_4TypeEyRNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::ConvertToScalarInfo::ConvertScalar_ExtractValue(llvm::Value*, llvm::Type const*, uint64_t, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_119ConvertToScalarInfo25ConvertScalar_InsertValueEPN4llvm5ValueES3_yRNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::ConvertToScalarInfo::ConvertScalar_InsertValue(llvm::Value*, llvm::Value*, uint64_t, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE10CreateLoadEPNS_5ValueERKNS_5TwineE", "llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateLoad(llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE19CreateInsertElementEPNS_5ValueES6_S6_RKNS_5TwineE", "llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateInsertElement(llvm::Value*, llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE18CreateExtractValueEPNS_5ValueEjRKNS_5TwineE", "llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateExtractValue(llvm::Value*, unsigned int, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE20CreateExtractElementEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateExtractElement(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE17CreateInsertValueEPNS_5ValueES6_jRKNS_5TwineE", "llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateInsertValue(llvm::Value*, llvm::Value*, unsigned int, llvm::Twine const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm10AllocaInstESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::AllocaInst*, std::allocator<llvm::AllocaInst*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::AllocaInst**, std::vector<llvm::AllocaInst*, std::allocator<llvm::AllocaInst*> > >, llvm::AllocaInst* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEPNS_8LoadInstENS_12DenseMapInfoIS2_EENS5_IS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<llvm::BasicBlock*, llvm::LoadInst*, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::LoadInst*> >::InsertIntoBucket(llvm::BasicBlock* const&, llvm::LoadInst* const&, std::pair<llvm::BasicBlock*, llvm::LoadInst*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEPNS_8LoadInstENS_12DenseMapInfoIS2_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::BasicBlock*, llvm::LoadInst*, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::LoadInst*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN12_GLOBAL__N_19StrCatOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::StrCatOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_110StrNCatOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::StrNCatOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_19StrChrOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::StrChrOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_110StrRChrOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::StrRChrOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_19StrCmpOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::StrCmpOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_110StrNCmpOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::StrNCmpOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_19StrCpyOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::StrCpyOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_110StrNCpyOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::StrNCpyOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_19StrLenOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::StrLenOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_110StrPBrkOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::StrPBrkOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_18StrToOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::StrToOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_19StrSpnOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::StrSpnOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_110StrCSpnOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::StrCSpnOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_19StrStrOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::StrStrOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_19MemCmpOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::MemCmpOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_19MemCpyOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::MemCpyOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_110MemMoveOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::MemMoveOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_19MemSetOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::MemSetOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_16PowOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::PowOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_17Exp2Opt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::Exp2Opt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_116UnaryDoubleFPOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::UnaryDoubleFPOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_16FFSOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::FFSOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_16AbsOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::AbsOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_110IsDigitOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::IsDigitOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_110IsAsciiOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::IsAsciiOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_110ToAsciiOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::ToAsciiOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_110SPrintFOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::SPrintFOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_19PrintFOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::PrintFOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_19FWriteOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::FWriteOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_18FPutsOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::FPutsOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_110FPrintFOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::FPrintFOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_17PutsOpt13CallOptimizerEPN4llvm8FunctionEPNS1_8CallInstERNS1_9IRBuilderILb1ENS1_14ConstantFolderENS1_24IRBuilderDefaultInserterILb1EEEEE", "(anonymous namespace)::PutsOpt::CallOptimizer(llvm::Function*, llvm::CallInst*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE9CreateGEPEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateGEP(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE10CreateLoadEPNS_5ValueEPKc", "llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateLoad(llvm::Value*, char const*)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE10CreateICmpENS_7CmpInst9PredicateEPNS_5ValueES8_RKNS_5TwineE", "llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateICmp(llvm::CmpInst::Predicate, llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE26CreateConstInBoundsGEP1_64EPNS_5ValueEyRKNS_5TwineE", "llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateConstInBoundsGEP1_64(llvm::Value*, uint64_t, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE12CreateSelectEPNS_5ValueES6_S6_RKNS_5TwineE", "llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateSelect(llvm::Value*, llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE10CreateFMulEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateFMul(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE10CreateFDivEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateFDiv(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE10CreateFCmpENS_7CmpInst9PredicateEPNS_5ValueES8_RKNS_5TwineE", "llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateFCmp(llvm::CmpInst::Predicate, llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE11CreateCall2EPNS_5ValueES6_S6_RKNS_5TwineE", "llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateCall2(llvm::Value*, llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE10CreateCallEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateCall(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE9CreateNegEPNS_5ValueERKNS_5TwineE", "llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateNeg(llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE11CreateStoreEPNS_5ValueES6_b", "llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateStore(llvm::Value*, llvm::Value*, bool)"),
	mu_demangle_test("_ZN4llvm12PatternMatch14BinaryOp_matchINS0_9neg_matchINS0_7bind_tyINS_5ValueEEEEES5_Lj12EE5matchINS_14BinaryOperatorEEEbPT_", "bool llvm::PatternMatch::BinaryOp_match<llvm::PatternMatch::neg_match<llvm::PatternMatch::bind_ty<llvm::Value> >, llvm::PatternMatch::bind_ty<llvm::Value>, 12u>::match<llvm::BinaryOperator>(llvm::BinaryOperator*)"),
	mu_demangle_test("_ZN4llvm12PatternMatch9neg_matchINS0_7bind_tyINS_5ValueEEEE5matchIS3_EEbPT_", "bool llvm::PatternMatch::neg_match<llvm::PatternMatch::bind_ty<llvm::Value> >::match<llvm::Value>(llvm::Value*)"),
	mu_demangle_test("_ZN4llvm12PatternMatch9neg_matchINS0_7bind_tyINS_5ValueEEEE5matchINS_8ConstantEEEbPT_", "bool llvm::PatternMatch::neg_match<llvm::PatternMatch::bind_ty<llvm::Value> >::match<llvm::Constant>(llvm::Constant*)"),
	mu_demangle_test("_ZN4llvm12PatternMatch14BinaryOp_matchINS0_7bind_tyINS_5ValueEEENS0_9neg_matchIS4_EELj12EE5matchINS_14BinaryOperatorEEEbPT_", "bool llvm::PatternMatch::BinaryOp_match<llvm::PatternMatch::bind_ty<llvm::Value>, llvm::PatternMatch::neg_match<llvm::PatternMatch::bind_ty<llvm::Value> >, 12u>::match<llvm::BinaryOperator>(llvm::BinaryOperator*)"),
	mu_demangle_test("_ZN4llvm12PatternMatch9not_matchINS0_14BinaryOp_matchINS0_7bind_tyINS_5ValueEEES5_Lj23EEEE10matchIfNotEPS4_S8_", "llvm::PatternMatch::not_match<llvm::PatternMatch::BinaryOp_match<llvm::PatternMatch::bind_ty<llvm::Value>, llvm::PatternMatch::bind_ty<llvm::Value>, 23u> >::matchIfNot(llvm::Value*, llvm::Value*)"),
	mu_demangle_test("_ZN4llvm12PatternMatch9not_matchINS0_15CastClass_matchINS0_14specificval_tyELj32EEEE10matchIfNotEPNS_5ValueES7_", "llvm::PatternMatch::not_match<llvm::PatternMatch::CastClass_match<llvm::PatternMatch::specificval_ty, 32u> >::matchIfNot(llvm::Value*, llvm::Value*)"),
	mu_demangle_test("_ZN4llvm12PatternMatch9not_matchINS0_7bind_tyINS_5ValueEEEE5matchINS_14BinaryOperatorEEEbPT_", "bool llvm::PatternMatch::not_match<llvm::PatternMatch::bind_ty<llvm::Value> >::match<llvm::BinaryOperator>(llvm::BinaryOperator*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN12_GLOBAL__N_116LoweredPHIRecordEPNS_7PHINodeENS_12DenseMapInfoIS2_EENS5_IS4_EEEixERKS2_", "llvm::DenseMap<(anonymous namespace)::LoweredPHIRecord, llvm::PHINode*, llvm::DenseMapInfo<(anonymous namespace)::LoweredPHIRecord>, llvm::DenseMapInfo<llvm::PHINode*> >::operator[]((anonymous namespace)::LoweredPHIRecord const&)"),
	mu_demangle_test("_ZNK4llvm8DenseMapIN12_GLOBAL__N_116LoweredPHIRecordEPNS_7PHINodeENS_12DenseMapInfoIS2_EENS5_IS4_EEE15LookupBucketForERKS2_RPSt4pairIS2_S4_E", "llvm::DenseMap<(anonymous namespace)::LoweredPHIRecord, llvm::PHINode*, llvm::DenseMapInfo<(anonymous namespace)::LoweredPHIRecord>, llvm::DenseMapInfo<llvm::PHINode*> >::LookupBucketFor((anonymous namespace)::LoweredPHIRecord const&, std::pair<(anonymous namespace)::LoweredPHIRecord, llvm::PHINode*>*&) const"),
	mu_demangle_test("_Z22CollectShuffleElementsPN4llvm5ValueERSt6vectorIPNS_8ConstantESaIS4_EERS1_", "CollectShuffleElements(llvm::Value*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >&, llvm::Value*&)"),
	mu_demangle_test("_Z28CollectSingleShuffleElementsPN4llvm5ValueES1_S1_RSt6vectorIPNS_8ConstantESaIS4_EE", "CollectSingleShuffleElements(llvm::Value*, llvm::Value*, llvm::Value*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >&)"),
	mu_demangle_test("_ZN4llvm12PatternMatch9not_matchINS0_7bind_tyINS_5ValueEEEE5matchIS3_EEbPT_", "bool llvm::PatternMatch::not_match<llvm::PatternMatch::bind_ty<llvm::Value> >::match<llvm::Value>(llvm::Value*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_11InstructionEjNS_12DenseMapInfoIS2_EENS3_IjEEE16shrink_and_clearEv", "llvm::DenseMap<llvm::Instruction*, unsigned int, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<unsigned int> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_11InstructionEjNS_12DenseMapInfoIS2_EENS3_IjEEE6insertERKSt4pairIS2_jE", "llvm::DenseMap<llvm::Instruction*, unsigned int, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<unsigned int> >::insert(std::pair<llvm::Instruction*, unsigned int> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_11InstructionEjNS_12DenseMapInfoIS2_EENS3_IjEEE16InsertIntoBucketERKS2_RKjPSt4pairIS2_jE", "llvm::DenseMap<llvm::Instruction*, unsigned int, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(llvm::Instruction* const&, unsigned int const&, std::pair<llvm::Instruction*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_11InstructionEjNS_12DenseMapInfoIS2_EENS3_IjEEE4growEj", "llvm::DenseMap<llvm::Instruction*, unsigned int, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_Z17FindAllMemoryUsesPN4llvm11InstructionERNS_15SmallVectorImplISt4pairIS1_jEEERNS_11SmallPtrSetIS1_Lj16EEERKNS_14TargetLoweringE", "FindAllMemoryUses(llvm::Instruction*, llvm::SmallVectorImpl<std::pair<llvm::Instruction*, unsigned int> >&, llvm::SmallPtrSet<llvm::Instruction*, 16u>&, llvm::TargetLowering const&)"),
	mu_demangle_test("_ZN4llvm20ReplaceInstWithValueERNS_6iplistINS_11InstructionENS_12ilist_traitsIS1_EEEERNS_14ilist_iteratorIS1_EEPNS_5ValueE", "llvm::ReplaceInstWithValue(llvm::iplist<llvm::Instruction, llvm::ilist_traits<llvm::Instruction> >&, llvm::ilist_iterator<llvm::Instruction>&, llvm::Value*)"),
	mu_demangle_test("_ZN4llvm19ReplaceInstWithInstERNS_6iplistINS_11InstructionENS_12ilist_traitsIS1_EEEERNS_14ilist_iteratorIS1_EEPS1_", "llvm::ReplaceInstWithInst(llvm::iplist<llvm::Instruction, llvm::ilist_traits<llvm::Instruction> >&, llvm::ilist_iterator<llvm::Instruction>&, llvm::Instruction*)"),
	mu_demangle_test("_ZN4llvm21FindFunctionBackedgesERKNS_8FunctionERNS_15SmallVectorImplISt4pairIPKNS_10BasicBlockES7_EEE", "llvm::FindFunctionBackedges(llvm::Function const&, llvm::SmallVectorImpl<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >&)"),
	mu_demangle_test("_ZN4llvm23SmallVectorTemplateBaseISt4pairIPKNS_10BasicBlockENS_12SuccIteratorIPKNS_14TerminatorInstES3_EEELb0EE4growEm", "llvm::SmallVectorTemplateBase<std::pair<llvm::BasicBlock const*, llvm::SuccIterator<llvm::TerminatorInst const*, llvm::BasicBlock const> >, false>::grow(unsigned long)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEPNS_4LoopENS_12DenseMapInfoIS2_EENS5_IS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<llvm::BasicBlock*, llvm::Loop*, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::Loop*> >::InsertIntoBucket(llvm::BasicBlock* const&, llvm::Loop* const&, std::pair<llvm::BasicBlock*, llvm::Loop*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEPNS_4LoopENS_12DenseMapInfoIS2_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::BasicBlock*, llvm::Loop*, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::Loop*> >::grow(unsigned int)"),
	mu_demangle_test("_ZSt6__findIN9__gnu_cxx17__normal_iteratorIPPN4llvm10BasicBlockESt6vectorIS4_SaIS4_EEEES4_ET_SA_SA_RKT0_St26random_access_iterator_tag", "__gnu_cxx::__normal_iterator<llvm::BasicBlock**, std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> > > std::__find<__gnu_cxx::__normal_iterator<llvm::BasicBlock**, std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> > >, llvm::BasicBlock*>(__gnu_cxx::__normal_iterator<llvm::BasicBlock**, std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> > >, __gnu_cxx::__normal_iterator<llvm::BasicBlock**, std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> > >, llvm::BasicBlock* const&, std::random_access_iterator_tag)"),
	mu_demangle_test("_ZN4llvm10CastToCStrEPNS_5ValueERNS_9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEEE", "llvm::CastToCStr(llvm::Value*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&)"),
	mu_demangle_test("_ZN4llvm10EmitStrLenEPNS_5ValueERNS_9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEEEPKNS_10DataLayoutE", "llvm::EmitStrLen(llvm::Value*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&, llvm::DataLayout const*)"),
	mu_demangle_test("_ZN4llvm10EmitStrChrEPNS_5ValueEcRNS_9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEEEPKNS_10DataLayoutE", "llvm::EmitStrChr(llvm::Value*, char, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&, llvm::DataLayout const*)"),
	mu_demangle_test("_ZN4llvm11EmitStrNCmpEPNS_5ValueES1_S1_RNS_9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEEEPKNS_10DataLayoutE", "llvm::EmitStrNCmp(llvm::Value*, llvm::Value*, llvm::Value*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&, llvm::DataLayout const*)"),
	mu_demangle_test("_ZN4llvm10EmitStrCpyEPNS_5ValueES1_RNS_9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEEEPKNS_10DataLayoutENS_9StringRefE", "llvm::EmitStrCpy(llvm::Value*, llvm::Value*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&, llvm::DataLayout const*, llvm::StringRef)"),
	mu_demangle_test("_ZN4llvm11EmitStrNCpyEPNS_5ValueES1_S1_RNS_9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEEEPKNS_10DataLayoutENS_9StringRefE", "llvm::EmitStrNCpy(llvm::Value*, llvm::Value*, llvm::Value*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&, llvm::DataLayout const*, llvm::StringRef)"),
	mu_demangle_test("_ZN4llvm13EmitMemCpyChkEPNS_5ValueES1_S1_S1_RNS_9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEEEPKNS_10DataLayoutE", "llvm::EmitMemCpyChk(llvm::Value*, llvm::Value*, llvm::Value*, llvm::Value*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&, llvm::DataLayout const*)"),
	mu_demangle_test("_ZN4llvm10EmitMemChrEPNS_5ValueES1_S1_RNS_9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEEEPKNS_10DataLayoutE", "llvm::EmitMemChr(llvm::Value*, llvm::Value*, llvm::Value*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&, llvm::DataLayout const*)"),
	mu_demangle_test("_ZN4llvm10EmitMemCmpEPNS_5ValueES1_S1_RNS_9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEEEPKNS_10DataLayoutE", "llvm::EmitMemCmp(llvm::Value*, llvm::Value*, llvm::Value*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&, llvm::DataLayout const*)"),
	mu_demangle_test("_ZN4llvm20EmitUnaryFloatFnCallEPNS_5ValueEPKcRNS_9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEEERKNS_11AttrListPtrE", "llvm::EmitUnaryFloatFnCall(llvm::Value*, char const*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&, llvm::AttrListPtr const&)"),
	mu_demangle_test("_ZN4llvm11EmitPutCharEPNS_5ValueERNS_9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEEEPKNS_10DataLayoutE", "llvm::EmitPutChar(llvm::Value*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&, llvm::DataLayout const*)"),
	mu_demangle_test("_ZN4llvm8EmitPutSEPNS_5ValueERNS_9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEEEPKNS_10DataLayoutE", "llvm::EmitPutS(llvm::Value*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&, llvm::DataLayout const*)"),
	mu_demangle_test("_ZN4llvm9EmitFPutCEPNS_5ValueES1_RNS_9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEEEPKNS_10DataLayoutE", "llvm::EmitFPutC(llvm::Value*, llvm::Value*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&, llvm::DataLayout const*)"),
	mu_demangle_test("_ZN4llvm9EmitFPutSEPNS_5ValueES1_RNS_9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEEEPKNS_10DataLayoutE", "llvm::EmitFPutS(llvm::Value*, llvm::Value*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&, llvm::DataLayout const*)"),
	mu_demangle_test("_ZN4llvm10EmitFWriteEPNS_5ValueES1_S1_RNS_9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEEEPKNS_10DataLayoutE", "llvm::EmitFWrite(llvm::Value*, llvm::Value*, llvm::Value*, llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >&, llvm::DataLayout const*)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE11CreateCall3EPNS_5ValueES6_S6_S6_RKNS_5TwineE", "llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateCall3(llvm::Value*, llvm::Value*, llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE11CreateCall4EPNS_5ValueES6_S6_S6_S6_RKNS_5TwineE", "llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateCall4(llvm::Value*, llvm::Value*, llvm::Value*, llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm15CloneBasicBlockEPKNS_10BasicBlockERNS_8ValueMapIPKNS_5ValueENS_10TrackingVHIS4_EENS_14ValueMapConfigIS6_EENS_12DenseMapInfoIS8_EEEERKNS_5TwineEPNS_8FunctionEPNS_14ClonedCodeInfoE", "llvm::CloneBasicBlock(llvm::BasicBlock const*, llvm::ValueMap<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >&, llvm::Twine const&, llvm::Function*, llvm::ClonedCodeInfo*)"),
	mu_demangle_test("_ZN4llvm17CloneFunctionIntoEPNS_8FunctionEPKS0_RNS_8ValueMapIPKNS_5ValueENS_10TrackingVHIS5_EENS_14ValueMapConfigIS7_EENS_12DenseMapInfoIS9_EEEEbRNS_15SmallVectorImplIPNS_10ReturnInstEEEPKcPNS_14ClonedCodeInfoE", "llvm::CloneFunctionInto(llvm::Function*, llvm::Function const*, llvm::ValueMap<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >&, bool, llvm::SmallVectorImpl<llvm::ReturnInst*>&, char const*, llvm::ClonedCodeInfo*)"),
	mu_demangle_test("_ZN4llvm13CloneFunctionEPKNS_8FunctionERNS_8ValueMapIPKNS_5ValueENS_10TrackingVHIS4_EENS_14ValueMapConfigIS6_EENS_12DenseMapInfoIS8_EEEEbPNS_14ClonedCodeInfoE", "llvm::CloneFunction(llvm::Function const*, llvm::ValueMap<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >&, bool, llvm::ClonedCodeInfo*)"),
	mu_demangle_test("_ZN4llvm25CloneAndPruneFunctionIntoEPNS_8FunctionEPKS0_RNS_8ValueMapIPKNS_5ValueENS_10TrackingVHIS5_EENS_14ValueMapConfigIS7_EENS_12DenseMapInfoIS9_EEEEbRNS_15SmallVectorImplIPNS_10ReturnInstEEEPKcPNS_14ClonedCodeInfoEPKNS_10DataLayoutEPNS_11InstructionE", "llvm::CloneAndPruneFunctionInto(llvm::Function*, llvm::Function const*, llvm::ValueMap<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >&, bool, llvm::SmallVectorImpl<llvm::ReturnInst*>&, char const*, llvm::ClonedCodeInfo*, llvm::DataLayout const*, llvm::Instruction*)"),
	mu_demangle_test("_ZNSt6vectorIPKN4llvm10BasicBlockESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<llvm::BasicBlock const*, std::allocator<llvm::BasicBlock const*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::BasicBlock const**, std::vector<llvm::BasicBlock const*, std::allocator<llvm::BasicBlock const*> > >, llvm::BasicBlock const* const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm10BasicBlockESt4pairIKS2_PNS0_5ValueEESt10_Select1stIS7_ESt4lessIS2_ESaIS7_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS7_ERKS7_", "std::_Rb_tree<llvm::BasicBlock*, std::pair<llvm::BasicBlock* const, llvm::Value*>, std::_Select1st<std::pair<llvm::BasicBlock* const, llvm::Value*> >, std::less<llvm::BasicBlock*>, std::allocator<std::pair<llvm::BasicBlock* const, llvm::Value*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::BasicBlock* const, llvm::Value*> >, std::pair<llvm::BasicBlock* const, llvm::Value*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm10BasicBlockESt4pairIKS2_PNS0_5ValueEESt10_Select1stIS7_ESt4lessIS2_ESaIS7_EE16_M_insert_uniqueERKS7_", "std::_Rb_tree<llvm::BasicBlock*, std::pair<llvm::BasicBlock* const, llvm::Value*>, std::_Select1st<std::pair<llvm::BasicBlock* const, llvm::Value*> >, std::less<llvm::BasicBlock*>, std::allocator<std::pair<llvm::BasicBlock* const, llvm::Value*> > >::_M_insert_unique(std::pair<llvm::BasicBlock* const, llvm::Value*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm10BasicBlockESt4pairIKS2_PNS0_5ValueEESt10_Select1stIS7_ESt4lessIS2_ESaIS7_EE8_M_eraseEPSt13_Rb_tree_nodeIS7_E", "std::_Rb_tree<llvm::BasicBlock*, std::pair<llvm::BasicBlock* const, llvm::Value*>, std::_Select1st<std::pair<llvm::BasicBlock* const, llvm::Value*> >, std::less<llvm::BasicBlock*>, std::allocator<std::pair<llvm::BasicBlock* const, llvm::Value*> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::BasicBlock* const, llvm::Value*> >*)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN4llvm6WeakVHEPNS1_13CallGraphNodeEESaIS5_EE13_M_assign_auxIN9__gnu_cxx17__normal_iteratorIPS5_S7_EEEEvT_SD_St20forward_iterator_tag", "void std::vector<std::pair<llvm::WeakVH, llvm::CallGraphNode*>, std::allocator<std::pair<llvm::WeakVH, llvm::CallGraphNode*> > >::_M_assign_aux<__gnu_cxx::__normal_iterator<std::pair<llvm::WeakVH, llvm::CallGraphNode*>*, std::vector<std::pair<llvm::WeakVH, llvm::CallGraphNode*>, std::allocator<std::pair<llvm::WeakVH, llvm::CallGraphNode*> > > > >(__gnu_cxx::__normal_iterator<std::pair<llvm::WeakVH, llvm::CallGraphNode*>*, std::vector<std::pair<llvm::WeakVH, llvm::CallGraphNode*>, std::allocator<std::pair<llvm::WeakVH, llvm::CallGraphNode*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::WeakVH, llvm::CallGraphNode*>*, std::vector<std::pair<llvm::WeakVH, llvm::CallGraphNode*>, std::allocator<std::pair<llvm::WeakVH, llvm::CallGraphNode*> > > >, std::forward_iterator_tag)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN4llvm6WeakVHEPNS1_13CallGraphNodeEESaIS5_EE20_M_allocate_and_copyIN9__gnu_cxx17__normal_iteratorIPS5_S7_EEEESB_mT_SD_", "std::pair<llvm::WeakVH, llvm::CallGraphNode*>* std::vector<std::pair<llvm::WeakVH, llvm::CallGraphNode*>, std::allocator<std::pair<llvm::WeakVH, llvm::CallGraphNode*> > >::_M_allocate_and_copy<__gnu_cxx::__normal_iterator<std::pair<llvm::WeakVH, llvm::CallGraphNode*>*, std::vector<std::pair<llvm::WeakVH, llvm::CallGraphNode*>, std::allocator<std::pair<llvm::WeakVH, llvm::CallGraphNode*> > > > >(unsigned long, __gnu_cxx::__normal_iterator<std::pair<llvm::WeakVH, llvm::CallGraphNode*>*, std::vector<std::pair<llvm::WeakVH, llvm::CallGraphNode*>, std::allocator<std::pair<llvm::WeakVH, llvm::CallGraphNode*> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::WeakVH, llvm::CallGraphNode*>*, std::vector<std::pair<llvm::WeakVH, llvm::CallGraphNode*>, std::allocator<std::pair<llvm::WeakVH, llvm::CallGraphNode*> > > >)"),
	mu_demangle_test("_ZN4llvm8DenseMapImPNS_7PHINodeENS_12DenseMapInfoImEENS3_IS2_EEE6insertERKSt4pairImS2_E", "llvm::DenseMap<unsigned long, llvm::PHINode*, llvm::DenseMapInfo<unsigned long>, llvm::DenseMapInfo<llvm::PHINode*> >::insert(std::pair<unsigned long, llvm::PHINode*> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_7PHINodeES2_NS_12DenseMapInfoIS2_EES4_E16InsertIntoBucketERKS2_S7_PSt4pairIS2_S2_E", "llvm::DenseMap<llvm::PHINode*, llvm::PHINode*, llvm::DenseMapInfo<llvm::PHINode*>, llvm::DenseMapInfo<llvm::PHINode*> >::InsertIntoBucket(llvm::PHINode* const&, llvm::PHINode* const&, std::pair<llvm::PHINode*, llvm::PHINode*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_7PHINodeES2_NS_12DenseMapInfoIS2_EES4_E4growEj", "llvm::DenseMap<llvm::PHINode*, llvm::PHINode*, llvm::DenseMapInfo<llvm::PHINode*>, llvm::DenseMapInfo<llvm::PHINode*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapImPNS_7PHINodeENS_12DenseMapInfoImEENS3_IS2_EEE16InsertIntoBucketERKmRKS2_PSt4pairImS2_E", "llvm::DenseMap<unsigned long, llvm::PHINode*, llvm::DenseMapInfo<unsigned long>, llvm::DenseMapInfo<llvm::PHINode*> >::InsertIntoBucket(unsigned long const&, llvm::PHINode* const&, std::pair<unsigned long, llvm::PHINode*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapImPNS_7PHINodeENS_12DenseMapInfoImEENS3_IS2_EEE4growEj", "llvm::DenseMap<unsigned long, llvm::PHINode*, llvm::DenseMapInfo<unsigned long>, llvm::DenseMapInfo<llvm::PHINode*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm11SmallPtrSetIPNS_10BasicBlockELj16EEC2INS_12PredIteratorIS1_NS_18value_use_iteratorINS_4UserEEEEEEET_SA_", "llvm::SmallPtrSet<llvm::BasicBlock*, 16u>::SmallPtrSet<llvm::PredIterator<llvm::BasicBlock, llvm::value_use_iterator<llvm::User> > >(llvm::PredIterator<llvm::BasicBlock, llvm::value_use_iterator<llvm::User> >, llvm::PredIterator<llvm::BasicBlock, llvm::value_use_iterator<llvm::User> >)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_18ValueMapCallbackVHIPKNS_5ValueENS_10TrackingVHIS2_EENS_14ValueMapConfigIS4_EENS_12DenseMapInfoIS6_EEEES6_NS9_ISB_EESA_E5beginEv", "llvm::DenseMap<llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >, llvm::TrackingVH<llvm::Value>, llvm::DenseMapInfo<llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > > >, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >::begin()"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm7PHINodeESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::PHINode*, std::allocator<llvm::PHINode*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::PHINode**, std::vector<llvm::PHINode*, std::allocator<llvm::PHINode*> > >, llvm::PHINode* const&)"),
	mu_demangle_test("_Z16MarkBlocksLiveInPN4llvm10BasicBlockERSt3setIS1_St4lessIS1_ESaIS1_EE", "MarkBlocksLiveIn(llvm::BasicBlock*, std::set<llvm::BasicBlock*, std::less<llvm::BasicBlock*>, std::allocator<llvm::BasicBlock*> >&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm10InvokeInstES2_St9_IdentityIS2_ESt4lessIS2_ESaIS2_EE8_M_eraseEPSt13_Rb_tree_nodeIS2_E", "std::_Rb_tree<llvm::InvokeInst*, llvm::InvokeInst*, std::_Identity<llvm::InvokeInst*>, std::less<llvm::InvokeInst*>, std::allocator<llvm::InvokeInst*> >::_M_erase(std::_Rb_tree_node<llvm::InvokeInst*>*)"),
	mu_demangle_test("_ZlsRN4llvm11raw_ostreamERKSt6vectorIN12_GLOBAL__N_111LowerSwitch9CaseRangeESaIS5_EE", "operator<<(llvm::raw_ostream&, std::vector<(anonymous namespace)::LowerSwitch::CaseRange, std::allocator<(anonymous namespace)::LowerSwitch::CaseRange> > const&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_111LowerSwitch13switchConvertEN9__gnu_cxx17__normal_iteratorIPNS0_9CaseRangeESt6vectorIS3_SaIS3_EEEES8_PN4llvm5ValueEPNS9_10BasicBlockESD_", "(anonymous namespace)::LowerSwitch::switchConvert(__gnu_cxx::__normal_iterator<(anonymous namespace)::LowerSwitch::CaseRange*, std::vector<(anonymous namespace)::LowerSwitch::CaseRange, std::allocator<(anonymous namespace)::LowerSwitch::CaseRange> > >, __gnu_cxx::__normal_iterator<(anonymous namespace)::LowerSwitch::CaseRange*, std::vector<(anonymous namespace)::LowerSwitch::CaseRange, std::allocator<(anonymous namespace)::LowerSwitch::CaseRange> > >, llvm::Value*, llvm::BasicBlock*, llvm::BasicBlock*)"),
	mu_demangle_test("_ZSt16__introsort_loopIN9__gnu_cxx17__normal_iteratorIPN12_GLOBAL__N_111LowerSwitch9CaseRangeESt6vectorIS4_SaIS4_EEEElNS2_7CaseCmpEEvT_SB_T0_T1_", "void std::__introsort_loop<__gnu_cxx::__normal_iterator<(anonymous namespace)::LowerSwitch::CaseRange*, std::vector<(anonymous namespace)::LowerSwitch::CaseRange, std::allocator<(anonymous namespace)::LowerSwitch::CaseRange> > >, long, (anonymous namespace)::CaseCmp>(__gnu_cxx::__normal_iterator<(anonymous namespace)::LowerSwitch::CaseRange*, std::vector<(anonymous namespace)::LowerSwitch::CaseRange, std::allocator<(anonymous namespace)::LowerSwitch::CaseRange> > >, __gnu_cxx::__normal_iterator<(anonymous namespace)::LowerSwitch::CaseRange*, std::vector<(anonymous namespace)::LowerSwitch::CaseRange, std::allocator<(anonymous namespace)::LowerSwitch::CaseRange> > >, long, (anonymous namespace)::CaseCmp)"),
	mu_demangle_test("_ZSt16__insertion_sortIN9__gnu_cxx17__normal_iteratorIPN12_GLOBAL__N_111LowerSwitch9CaseRangeESt6vectorIS4_SaIS4_EEEENS2_7CaseCmpEEvT_SB_T0_", "void std::__insertion_sort<__gnu_cxx::__normal_iterator<(anonymous namespace)::LowerSwitch::CaseRange*, std::vector<(anonymous namespace)::LowerSwitch::CaseRange, std::allocator<(anonymous namespace)::LowerSwitch::CaseRange> > >, (anonymous namespace)::CaseCmp>(__gnu_cxx::__normal_iterator<(anonymous namespace)::LowerSwitch::CaseRange*, std::vector<(anonymous namespace)::LowerSwitch::CaseRange, std::allocator<(anonymous namespace)::LowerSwitch::CaseRange> > >, __gnu_cxx::__normal_iterator<(anonymous namespace)::LowerSwitch::CaseRange*, std::vector<(anonymous namespace)::LowerSwitch::CaseRange, std::allocator<(anonymous namespace)::LowerSwitch::CaseRange> > >, (anonymous namespace)::CaseCmp)"),
	mu_demangle_test("_ZSt13__adjust_heapIN9__gnu_cxx17__normal_iteratorIPN12_GLOBAL__N_111LowerSwitch9CaseRangeESt6vectorIS4_SaIS4_EEEElS4_NS2_7CaseCmpEEvT_T0_SC_T1_T2_", "void std::__adjust_heap<__gnu_cxx::__normal_iterator<(anonymous namespace)::LowerSwitch::CaseRange*, std::vector<(anonymous namespace)::LowerSwitch::CaseRange, std::allocator<(anonymous namespace)::LowerSwitch::CaseRange> > >, long, (anonymous namespace)::LowerSwitch::CaseRange, (anonymous namespace)::CaseCmp>(__gnu_cxx::__normal_iterator<(anonymous namespace)::LowerSwitch::CaseRange*, std::vector<(anonymous namespace)::LowerSwitch::CaseRange, std::allocator<(anonymous namespace)::LowerSwitch::CaseRange> > >, long, long, (anonymous namespace)::LowerSwitch::CaseRange, (anonymous namespace)::CaseCmp)"),
	mu_demangle_test("_ZN4llvm15PromoteMemToRegERKSt6vectorIPNS_10AllocaInstESaIS2_EERNS_13DominatorTreeEPNS_15AliasSetTrackerE", "llvm::PromoteMemToReg(std::vector<llvm::AllocaInst*, std::allocator<llvm::AllocaInst*> > const&, llvm::DominatorTree&, llvm::AliasSetTracker*)"),
	mu_demangle_test("_ZNSt6vectorIN12_GLOBAL__N_114RenamePassDataESaIS1_EE9push_backERKS1_", "std::vector<(anonymous namespace)::RenamePassData, std::allocator<(anonymous namespace)::RenamePassData> >::push_back((anonymous namespace)::RenamePassData const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPNS_10BasicBlockEjEPNS_7PHINodeENS_12DenseMapInfoIS4_EENS7_IS6_EEE5clearEv", "llvm::DenseMap<std::pair<llvm::BasicBlock*, unsigned int>, llvm::PHINode*, llvm::DenseMapInfo<std::pair<llvm::BasicBlock*, unsigned int> >, llvm::DenseMapInfo<llvm::PHINode*> >::clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPNS_10BasicBlockEjEPNS_7PHINodeENS_12DenseMapInfoIS4_EENS7_IS6_EEE16shrink_and_clearEv", "llvm::DenseMap<std::pair<llvm::BasicBlock*, unsigned int>, llvm::PHINode*, llvm::DenseMapInfo<std::pair<llvm::BasicBlock*, unsigned int> >, llvm::DenseMapInfo<llvm::PHINode*> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_7PHINodeEjNS_12DenseMapInfoIS2_EENS3_IjEEE16InsertIntoBucketERKS2_RKjPSt4pairIS2_jE", "llvm::DenseMap<llvm::PHINode*, unsigned int, llvm::DenseMapInfo<llvm::PHINode*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(llvm::PHINode* const&, unsigned int const&, std::pair<llvm::PHINode*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_7PHINodeEjNS_12DenseMapInfoIS2_EENS3_IjEEE4growEj", "llvm::DenseMap<llvm::PHINode*, unsigned int, llvm::DenseMapInfo<llvm::PHINode*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_11InstructionEjNS_12DenseMapInfoIS3_EENS4_IjEEE16shrink_and_clearEv", "llvm::DenseMap<llvm::Instruction const*, unsigned int, llvm::DenseMapInfo<llvm::Instruction const*>, llvm::DenseMapInfo<unsigned int> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPNS_10BasicBlockEjEPNS_7PHINodeENS_12DenseMapInfoIS4_EENS7_IS6_EEE16FindAndConstructERKS4_", "llvm::DenseMap<std::pair<llvm::BasicBlock*, unsigned int>, llvm::PHINode*, llvm::DenseMapInfo<std::pair<llvm::BasicBlock*, unsigned int> >, llvm::DenseMapInfo<llvm::PHINode*> >::FindAndConstruct(std::pair<llvm::BasicBlock*, unsigned int> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPNS_10BasicBlockEjEPNS_7PHINodeENS_12DenseMapInfoIS4_EENS7_IS6_EEE16InsertIntoBucketERKS4_RKS6_PS1_IS4_S6_E", "llvm::DenseMap<std::pair<llvm::BasicBlock*, unsigned int>, llvm::PHINode*, llvm::DenseMapInfo<std::pair<llvm::BasicBlock*, unsigned int> >, llvm::DenseMapInfo<llvm::PHINode*> >::InsertIntoBucket(std::pair<llvm::BasicBlock*, unsigned int> const&, llvm::PHINode* const&, std::pair<std::pair<llvm::BasicBlock*, unsigned int>, llvm::PHINode*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPNS_10BasicBlockEjEPNS_7PHINodeENS_12DenseMapInfoIS4_EENS7_IS6_EEE4growEj", "llvm::DenseMap<std::pair<llvm::BasicBlock*, unsigned int>, llvm::PHINode*, llvm::DenseMapInfo<std::pair<llvm::BasicBlock*, unsigned int> >, llvm::DenseMapInfo<llvm::PHINode*> >::grow(unsigned int)"),
	mu_demangle_test("_ZSt13__adjust_heapIPSt4pairIjPN4llvm10BasicBlockEElS4_EvT_T0_S7_T1_", "void std::__adjust_heap<std::pair<unsigned int, llvm::BasicBlock*>*, long, std::pair<unsigned int, llvm::BasicBlock*> >(std::pair<unsigned int, llvm::BasicBlock*>*, long, long, std::pair<unsigned int, llvm::BasicBlock*>)"),
	mu_demangle_test("_ZN4llvm15SmallVectorImplISt4pairIPNS_15DomTreeNodeBaseINS_10BasicBlockEEEjEEaSERKS7_", "llvm::SmallVectorImpl<std::pair<llvm::DomTreeNodeBase<llvm::BasicBlock>*, unsigned int> >::operator=(llvm::SmallVectorImpl<std::pair<llvm::DomTreeNodeBase<llvm::BasicBlock>*, unsigned int> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10AllocaInstEjNS_12DenseMapInfoIS2_EENS3_IjEEE16InsertIntoBucketERKS2_RKjPSt4pairIS2_jE", "llvm::DenseMap<llvm::AllocaInst*, unsigned int, llvm::DenseMapInfo<llvm::AllocaInst*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(llvm::AllocaInst* const&, unsigned int const&, std::pair<llvm::AllocaInst*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10AllocaInstEjNS_12DenseMapInfoIS2_EENS3_IjEEE4growEj", "llvm::DenseMap<llvm::AllocaInst*, unsigned int, llvm::DenseMapInfo<llvm::AllocaInst*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_15DomTreeNodeBaseINS_10BasicBlockEEEjNS_12DenseMapInfoIS4_EENS5_IjEEE16InsertIntoBucketERKS4_RKjPSt4pairIS4_jE", "llvm::DenseMap<llvm::DomTreeNodeBase<llvm::BasicBlock>*, unsigned int, llvm::DenseMapInfo<llvm::DomTreeNodeBase<llvm::BasicBlock>*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(llvm::DomTreeNodeBase<llvm::BasicBlock>* const&, unsigned int const&, std::pair<llvm::DomTreeNodeBase<llvm::BasicBlock>*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_15DomTreeNodeBaseINS_10BasicBlockEEEjNS_12DenseMapInfoIS4_EENS5_IjEEE4growEj", "llvm::DenseMap<llvm::DomTreeNodeBase<llvm::BasicBlock>*, unsigned int, llvm::DenseMapInfo<llvm::DomTreeNodeBase<llvm::BasicBlock>*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZSt13__adjust_heapIPSt4pairIjPN4llvm9StoreInstEElS4_EvT_T0_S7_T1_", "void std::__adjust_heap<std::pair<unsigned int, llvm::StoreInst*>*, long, std::pair<unsigned int, llvm::StoreInst*> >(std::pair<unsigned int, llvm::StoreInst*>*, long, long, std::pair<unsigned int, llvm::StoreInst*>)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_11InstructionEjNS_12DenseMapInfoIS3_EENS4_IjEEE16InsertIntoBucketERKS3_RKjPSt4pairIS3_jE", "llvm::DenseMap<llvm::Instruction const*, unsigned int, llvm::DenseMapInfo<llvm::Instruction const*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(llvm::Instruction const* const&, unsigned int const&, std::pair<llvm::Instruction const*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_11InstructionEjNS_12DenseMapInfoIS3_EENS4_IjEEE4growEj", "llvm::DenseMap<llvm::Instruction const*, unsigned int, llvm::DenseMapInfo<llvm::Instruction const*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm11InstructionESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::Instruction*, std::allocator<llvm::Instruction*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::Instruction**, std::vector<llvm::Instruction*, std::allocator<llvm::Instruction*> > >, llvm::Instruction* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockESt6vectorIPNS_11InstructionESaIS5_EENS_12DenseMapInfoIS2_EENS8_IS7_EEE16FindAndConstructERKS2_", "llvm::DenseMap<llvm::BasicBlock*, std::vector<llvm::Instruction*, std::allocator<llvm::Instruction*> >, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<std::vector<llvm::Instruction*, std::allocator<llvm::Instruction*> > > >::FindAndConstruct(llvm::BasicBlock* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockESt6vectorIPNS_11InstructionESaIS5_EENS_12DenseMapInfoIS2_EENS8_IS7_EEE16InsertIntoBucketERKS2_RKS7_PSt4pairIS2_S7_E", "llvm::DenseMap<llvm::BasicBlock*, std::vector<llvm::Instruction*, std::allocator<llvm::Instruction*> >, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<std::vector<llvm::Instruction*, std::allocator<llvm::Instruction*> > > >::InsertIntoBucket(llvm::BasicBlock* const&, std::vector<llvm::Instruction*, std::allocator<llvm::Instruction*> > const&, std::pair<llvm::BasicBlock*, std::vector<llvm::Instruction*, std::allocator<llvm::Instruction*> > >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockESt6vectorIPNS_11InstructionESaIS5_EENS_12DenseMapInfoIS2_EENS8_IS7_EEE4growEj", "llvm::DenseMap<llvm::BasicBlock*, std::vector<llvm::Instruction*, std::allocator<llvm::Instruction*> >, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<std::vector<llvm::Instruction*, std::allocator<llvm::Instruction*> > > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEPNS_14SSAUpdaterImplINS_10SSAUpdaterEE6BBInfoENS_12DenseMapInfoIS2_EENS8_IS7_EEE16InsertIntoBucketERKS2_RKS7_PSt4pairIS2_S7_E", "llvm::DenseMap<llvm::BasicBlock*, llvm::SSAUpdaterImpl<llvm::SSAUpdater>::BBInfo*, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::SSAUpdaterImpl<llvm::SSAUpdater>::BBInfo*> >::InsertIntoBucket(llvm::BasicBlock* const&, llvm::SSAUpdaterImpl<llvm::SSAUpdater>::BBInfo* const&, std::pair<llvm::BasicBlock*, llvm::SSAUpdaterImpl<llvm::SSAUpdater>::BBInfo*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEPNS_14SSAUpdaterImplINS_10SSAUpdaterEE6BBInfoENS_12DenseMapInfoIS2_EENS8_IS7_EEE4growEj", "llvm::DenseMap<llvm::BasicBlock*, llvm::SSAUpdaterImpl<llvm::SSAUpdater>::BBInfo*, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::SSAUpdaterImpl<llvm::SSAUpdater>::BBInfo*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN12_GLOBAL__N_114SimplifyCFGOpt31GetValueEqualityComparisonCasesEPN4llvm14TerminatorInstERSt6vectorISt4pairIPNS1_11ConstantIntEPNS1_10BasicBlockEESaISA_EE", "(anonymous namespace)::SimplifyCFGOpt::GetValueEqualityComparisonCases(llvm::TerminatorInst*, std::vector<std::pair<llvm::ConstantInt*, llvm::BasicBlock*>, std::allocator<std::pair<llvm::ConstantInt*, llvm::BasicBlock*> > >&)"),
	mu_demangle_test("_ZNSt3setIPN4llvm11ConstantIntEN12_GLOBAL__N_119ConstantIntOrderingESaIS2_EE6insertERKS2_", "std::set<llvm::ConstantInt*, (anonymous namespace)::ConstantIntOrdering, std::allocator<llvm::ConstantInt*> >::insert(llvm::ConstantInt* const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm11ConstantIntES2_St9_IdentityIS2_EN12_GLOBAL__N_119ConstantIntOrderingESaIS2_EE8_M_eraseEPSt13_Rb_tree_nodeIS2_E", "std::_Rb_tree<llvm::ConstantInt*, llvm::ConstantInt*, std::_Identity<llvm::ConstantInt*>, (anonymous namespace)::ConstantIntOrdering, std::allocator<llvm::ConstantInt*> >::_M_erase(std::_Rb_tree_node<llvm::ConstantInt*>*)"),
	mu_demangle_test("_ZN4llvm25array_pod_sort_comparatorISt4pairIPNS_11ConstantIntEPNS_10BasicBlockEEEEiPKvS8_", "int llvm::array_pod_sort_comparator<std::pair<llvm::ConstantInt*, llvm::BasicBlock*> >(void const*, void const*)"),
	mu_demangle_test("_Z22GatherConstantComparesPN4llvm5ValueERSt6vectorIPNS_11ConstantIntESaIS4_EERS1_PKNS_10DataLayoutEbRj", "GatherConstantCompares(llvm::Value*, std::vector<llvm::ConstantInt*, std::allocator<llvm::ConstantInt*> >&, llvm::Value*&, llvm::DataLayout const*, bool, unsigned int&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm10BasicBlockESt4pairIKS2_jESt10_Select1stIS5_ESt4lessIS2_ESaIS5_EE8_M_eraseEPSt13_Rb_tree_nodeIS5_E", "std::_Rb_tree<llvm::BasicBlock*, std::pair<llvm::BasicBlock* const, unsigned int>, std::_Select1st<std::pair<llvm::BasicBlock* const, unsigned int> >, std::less<llvm::BasicBlock*>, std::allocator<std::pair<llvm::BasicBlock* const, unsigned int> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::BasicBlock* const, unsigned int> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm10BasicBlockESt4pairIKS2_jESt10_Select1stIS5_ESt4lessIS2_ESaIS5_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS5_ERKS5_", "std::_Rb_tree<llvm::BasicBlock*, std::pair<llvm::BasicBlock* const, unsigned int>, std::_Select1st<std::pair<llvm::BasicBlock* const, unsigned int> >, std::less<llvm::BasicBlock*>, std::allocator<std::pair<llvm::BasicBlock* const, unsigned int> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::BasicBlock* const, unsigned int> >, std::pair<llvm::BasicBlock* const, unsigned int> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm10BasicBlockESt4pairIKS2_jESt10_Select1stIS5_ESt4lessIS2_ESaIS5_EE16_M_insert_uniqueERKS5_", "std::_Rb_tree<llvm::BasicBlock*, std::pair<llvm::BasicBlock* const, unsigned int>, std::_Select1st<std::pair<llvm::BasicBlock* const, unsigned int> >, std::less<llvm::BasicBlock*>, std::allocator<std::pair<llvm::BasicBlock* const, unsigned int> > >::_M_insert_unique(std::pair<llvm::BasicBlock* const, unsigned int> const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPN4llvm11ConstantIntEPNS1_10BasicBlockEESaIS6_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS6_S8_EERKS6_", "std::vector<std::pair<llvm::ConstantInt*, llvm::BasicBlock*>, std::allocator<std::pair<llvm::ConstantInt*, llvm::BasicBlock*> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::ConstantInt*, llvm::BasicBlock*>*, std::vector<std::pair<llvm::ConstantInt*, llvm::BasicBlock*>, std::allocator<std::pair<llvm::ConstantInt*, llvm::BasicBlock*> > > >, std::pair<llvm::ConstantInt*, llvm::BasicBlock*> const&)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPN4llvm11ConstantIntEPNS1_10BasicBlockEESaIS6_EE7reserveEm", "std::vector<std::pair<llvm::ConstantInt*, llvm::BasicBlock*>, std::allocator<std::pair<llvm::ConstantInt*, llvm::BasicBlock*> > >::reserve(unsigned long)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPN4llvm5ValueES3_ES0_IKS4_PNS1_10SelectInstEESt10_Select1stIS8_ESt4lessIS4_ESaIS8_EE8_M_eraseEPSt13_Rb_tree_nodeIS8_E", "std::_Rb_tree<std::pair<llvm::Value*, llvm::Value*>, std::pair<std::pair<llvm::Value*, llvm::Value*> const, llvm::SelectInst*>, std::_Select1st<std::pair<std::pair<llvm::Value*, llvm::Value*> const, llvm::SelectInst*> >, std::less<std::pair<llvm::Value*, llvm::Value*> >, std::allocator<std::pair<std::pair<llvm::Value*, llvm::Value*> const, llvm::SelectInst*> > >::_M_erase(std::_Rb_tree_node<std::pair<std::pair<llvm::Value*, llvm::Value*> const, llvm::SelectInst*> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPN4llvm5ValueES3_ES0_IKS4_PNS1_10SelectInstEESt10_Select1stIS8_ESt4lessIS4_ESaIS8_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS8_ERKS8_", "std::_Rb_tree<std::pair<llvm::Value*, llvm::Value*>, std::pair<std::pair<llvm::Value*, llvm::Value*> const, llvm::SelectInst*>, std::_Select1st<std::pair<std::pair<llvm::Value*, llvm::Value*> const, llvm::SelectInst*> >, std::less<std::pair<llvm::Value*, llvm::Value*> >, std::allocator<std::pair<std::pair<llvm::Value*, llvm::Value*> const, llvm::SelectInst*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<std::pair<llvm::Value*, llvm::Value*> const, llvm::SelectInst*> >, std::pair<std::pair<llvm::Value*, llvm::Value*> const, llvm::SelectInst*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPN4llvm5ValueES3_ES0_IKS4_PNS1_10SelectInstEESt10_Select1stIS8_ESt4lessIS4_ESaIS8_EE16_M_insert_uniqueERKS8_", "std::_Rb_tree<std::pair<llvm::Value*, llvm::Value*>, std::pair<std::pair<llvm::Value*, llvm::Value*> const, llvm::SelectInst*>, std::_Select1st<std::pair<std::pair<llvm::Value*, llvm::Value*> const, llvm::SelectInst*> >, std::less<std::pair<llvm::Value*, llvm::Value*> >, std::allocator<std::pair<std::pair<llvm::Value*, llvm::Value*> const, llvm::SelectInst*> > >::_M_insert_unique(std::pair<std::pair<llvm::Value*, llvm::Value*> const, llvm::SelectInst*> const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm11ConstantIntESaIS2_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS2_S4_EEmRKS2_", "std::vector<llvm::ConstantInt*, std::allocator<llvm::ConstantInt*> >::_M_fill_insert(__gnu_cxx::__normal_iterator<llvm::ConstantInt**, std::vector<llvm::ConstantInt*, std::allocator<llvm::ConstantInt*> > >, unsigned long, llvm::ConstantInt* const&)"),
	mu_demangle_test("_ZN4llvm8MapValueEPKNS_5ValueERNS_8ValueMapIS2_NS_10TrackingVHIS0_EENS_14ValueMapConfigIS2_EENS_12DenseMapInfoIS5_EEEENS_10RemapFlagsE", "llvm::MapValue(llvm::Value const*, llvm::ValueMap<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >&, llvm::RemapFlags)"),
	mu_demangle_test("_ZN4llvm16RemapInstructionEPNS_11InstructionERNS_8ValueMapIPKNS_5ValueENS_10TrackingVHIS3_EENS_14ValueMapConfigIS5_EENS_12DenseMapInfoIS7_EEEENS_10RemapFlagsE", "llvm::RemapInstruction(llvm::Instruction*, llvm::ValueMap<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >&, llvm::RemapFlags)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm8FunctionESt4pairIKS3_PNS0_13CallGraphNodeEESt10_Select1stIS8_ESt4lessIS3_ESaIS8_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS8_ERKS8_", "std::_Rb_tree<llvm::Function const*, std::pair<llvm::Function const* const, llvm::CallGraphNode*>, std::_Select1st<std::pair<llvm::Function const* const, llvm::CallGraphNode*> >, std::less<llvm::Function const*>, std::allocator<std::pair<llvm::Function const* const, llvm::CallGraphNode*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::Function const* const, llvm::CallGraphNode*> >, std::pair<llvm::Function const* const, llvm::CallGraphNode*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm8FunctionESt4pairIKS3_PNS0_13CallGraphNodeEESt10_Select1stIS8_ESt4lessIS3_ESaIS8_EE16_M_insert_uniqueERKS8_", "std::_Rb_tree<llvm::Function const*, std::pair<llvm::Function const* const, llvm::CallGraphNode*>, std::_Select1st<std::pair<llvm::Function const* const, llvm::CallGraphNode*> >, std::less<llvm::Function const*>, std::allocator<std::pair<llvm::Function const* const, llvm::CallGraphNode*> > >::_M_insert_unique(std::pair<llvm::Function const* const, llvm::CallGraphNode*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm8FunctionESt4pairIKS3_PNS0_13CallGraphNodeEESt10_Select1stIS8_ESt4lessIS3_ESaIS8_EE5eraseESt17_Rb_tree_iteratorIS8_ESG_", "std::_Rb_tree<llvm::Function const*, std::pair<llvm::Function const* const, llvm::CallGraphNode*>, std::_Select1st<std::pair<llvm::Function const* const, llvm::CallGraphNode*> >, std::less<llvm::Function const*>, std::allocator<std::pair<llvm::Function const* const, llvm::CallGraphNode*> > >::erase(std::_Rb_tree_iterator<std::pair<llvm::Function const* const, llvm::CallGraphNode*> >, std::_Rb_tree_iterator<std::pair<llvm::Function const* const, llvm::CallGraphNode*> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm8FunctionESt4pairIKS3_PNS0_13CallGraphNodeEESt10_Select1stIS8_ESt4lessIS3_ESaIS8_EE8_M_eraseEPSt13_Rb_tree_nodeIS8_E", "std::_Rb_tree<llvm::Function const*, std::pair<llvm::Function const* const, llvm::CallGraphNode*>, std::_Select1st<std::pair<llvm::Function const* const, llvm::CallGraphNode*> >, std::less<llvm::Function const*>, std::allocator<std::pair<llvm::Function const* const, llvm::CallGraphNode*> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::Function const* const, llvm::CallGraphNode*> >*)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN4llvm6WeakVHEPNS1_13CallGraphNodeEESaIS5_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS5_S7_EERKS5_", "std::vector<std::pair<llvm::WeakVH, llvm::CallGraphNode*>, std::allocator<std::pair<llvm::WeakVH, llvm::CallGraphNode*> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::WeakVH, llvm::CallGraphNode*>*, std::vector<std::pair<llvm::WeakVH, llvm::CallGraphNode*>, std::allocator<std::pair<llvm::WeakVH, llvm::CallGraphNode*> > > >, std::pair<llvm::WeakVH, llvm::CallGraphNode*> const&)"),
	mu_demangle_test("_ZN4llvm12scc_iteratorIPNS_9CallGraphENS_11GraphTraitsIS2_EEE11ReplaceNodeEPNS_13CallGraphNodeES7_", "llvm::scc_iterator<llvm::CallGraph*, llvm::GraphTraits<llvm::CallGraph*> >::ReplaceNode(llvm::CallGraphNode*, llvm::CallGraphNode*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_13CallGraphNodeEjNS_12DenseMapInfoIS2_EENS3_IjEEE16InsertIntoBucketERKS2_RKjPSt4pairIS2_jE", "llvm::DenseMap<llvm::CallGraphNode*, unsigned int, llvm::DenseMapInfo<llvm::CallGraphNode*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(llvm::CallGraphNode* const&, unsigned int const&, std::pair<llvm::CallGraphNode*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_13CallGraphNodeEjNS_12DenseMapInfoIS2_EENS3_IjEEE4growEj", "llvm::DenseMap<llvm::CallGraphNode*, unsigned int, llvm::DenseMapInfo<llvm::CallGraphNode*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm9scc_beginIPNS_9CallGraphEEENS_12scc_iteratorIT_NS_11GraphTraitsIS4_EEEERKS4_", "llvm::scc_iterator<llvm::CallGraph*, llvm::GraphTraits<llvm::CallGraph*> > llvm::scc_begin<llvm::CallGraph*>(llvm::CallGraph* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5ValueEPNS_13CallGraphNodeENS_12DenseMapInfoIS2_EENS5_IS4_EEE6insertERKSt4pairIS2_S4_E", "llvm::DenseMap<llvm::Value*, llvm::CallGraphNode*, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<llvm::CallGraphNode*> >::insert(std::pair<llvm::Value*, llvm::CallGraphNode*> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5ValueEPNS_13CallGraphNodeENS_12DenseMapInfoIS2_EENS5_IS4_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::Value*, llvm::CallGraphNode*, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<llvm::CallGraphNode*> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5ValueEPNS_13CallGraphNodeENS_12DenseMapInfoIS2_EENS5_IS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<llvm::Value*, llvm::CallGraphNode*, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<llvm::CallGraphNode*> >::InsertIntoBucket(llvm::Value* const&, llvm::CallGraphNode* const&, std::pair<llvm::Value*, llvm::CallGraphNode*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5ValueEPNS_13CallGraphNodeENS_12DenseMapInfoIS2_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::Value*, llvm::CallGraphNode*, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<llvm::CallGraphNode*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm12scc_iteratorIPNS_9CallGraphENS_11GraphTraitsIS2_EEE10GetNextSCCEv", "llvm::scc_iterator<llvm::CallGraph*, llvm::GraphTraits<llvm::CallGraph*> >::GetNextSCC()"),
	mu_demangle_test("_ZN4llvm12scc_iteratorIPNS_9CallGraphENS_11GraphTraitsIS2_EEE16DFSVisitChildrenEv", "llvm::scc_iterator<llvm::CallGraph*, llvm::GraphTraits<llvm::CallGraph*> >::DFSVisitChildren()"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm13CallGraphNodeESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::CallGraphNode*, std::allocator<llvm::CallGraphNode*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::CallGraphNode**, std::vector<llvm::CallGraphNode*, std::allocator<llvm::CallGraphNode*> > >, llvm::CallGraphNode* const&)"),
	mu_demangle_test("_ZN4llvm12scc_iteratorIPNS_9CallGraphENS_11GraphTraitsIS2_EEE11DFSVisitOneEPNS_13CallGraphNodeE", "llvm::scc_iterator<llvm::CallGraph*, llvm::GraphTraits<llvm::CallGraph*> >::DFSVisitOne(llvm::CallGraphNode*)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPN4llvm13CallGraphNodeENS1_15mapped_iteratorIN9__gnu_cxx17__normal_iteratorIPS0_INS1_6WeakVHES3_ES_IS8_SaIS8_EEEESt25pointer_to_unary_functionIS8_S3_EEEESaISG_EE13_M_insert_auxENS6_IPSG_SI_EERKSG_", "std::vector<std::pair<llvm::CallGraphNode*, llvm::mapped_iterator<__gnu_cxx::__normal_iterator<std::pair<llvm::WeakVH, llvm::CallGraphNode*>*, std::vector<std::pair<llvm::WeakVH, llvm::CallGraphNode*>, std::allocator<std::pair<llvm::WeakVH, llvm::CallGraphNode*> > > >, std::pointer_to_unary_function<std::pair<llvm::WeakVH, llvm::CallGraphNode*>, llvm::CallGraphNode*> > >, std::allocator<std::pair<llvm::CallGraphNode*, llvm::mapped_iterator<__gnu_cxx::__normal_iterator<std::pair<llvm::WeakVH, llvm::CallGraphNode*>*, std::vector<std::pair<llvm::WeakVH, llvm::CallGraphNode*>, std::allocator<std::pair<llvm::WeakVH, llvm::CallGraphNode*> > > >, std::pointer_to_unary_function<std::pair<llvm::WeakVH, llvm::CallGraphNode*>, llvm::CallGraphNode*> > > > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::CallGraphNode*, llvm::mapped_iterator<__gnu_cxx::__normal_iterator<std::pair<llvm::WeakVH, llvm::CallGraphNode*>*, std::vector<std::pair<llvm::WeakVH, llvm::CallGraphNode*>, std::allocator<std::pair<llvm::WeakVH, llvm::CallGraphNode*> > > >, std::pointer_to_unary_function<std::pair<llvm::WeakVH, llvm::CallGraphNode*>, llvm::CallGraphNode*> > >*, std::vector<std::pair<llvm::CallGraphNode*, llvm::mapped_iterator<__gnu_cxx::__normal_iterator<std::pair<llvm::WeakVH, llvm::CallGraphNode*>*, std::vector<std::pair<llvm::WeakVH, llvm::CallGraphNode*>, std::allocator<std::pair<llvm::WeakVH, llvm::CallGraphNode*> > > >, std::pointer_to_unary_function<std::pair<llvm::WeakVH, llvm::CallGraphNode*>, llvm::CallGraphNode*> > >, std::allocator<std::pair<llvm::CallGraphNode*, llvm::mapped_iterator<__gnu_cxx::__normal_iterator<std::pair<llvm::WeakVH, llvm::CallGraphNode*>*, std::vector<std::pair<llvm::WeakVH, llvm::CallGraphNode*>, std::allocator<std::pair<llvm::WeakVH, llvm::CallGraphNode*> > > >, std::pointer_to_unary_function<std::pair<llvm::WeakVH, llvm::CallGraphNode*>, llvm::CallGraphNode*> > > > > >, std::pair<llvm::CallGraphNode*, llvm::mapped_iterator<__gnu_cxx::__normal_iterator<std::pair<llvm::WeakVH, llvm::CallGraphNode*>*, std::vector<std::pair<llvm::WeakVH, llvm::CallGraphNode*>, std::allocator<std::pair<llvm::WeakVH, llvm::CallGraphNode*> > > >, std::pointer_to_unary_function<std::pair<llvm::WeakVH, llvm::CallGraphNode*>, llvm::CallGraphNode*> > > const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm13CallGraphNodeESaIS2_EE13_M_assign_auxIPKS2_EEvT_S8_St20forward_iterator_tag", "void std::vector<llvm::CallGraphNode*, std::allocator<llvm::CallGraphNode*> >::_M_assign_aux<llvm::CallGraphNode* const*>(llvm::CallGraphNode* const*, llvm::CallGraphNode* const*, std::forward_iterator_tag)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4TypeES3_St9_IdentityIS3_ESt4lessIS3_ESaIS3_EE16_M_insert_uniqueERKS3_", "std::_Rb_tree<llvm::Type const*, llvm::Type const*, std::_Identity<llvm::Type const*>, std::less<llvm::Type const*>, std::allocator<llvm::Type const*> >::_M_insert_unique(llvm::Type const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_15AliasSetTracker13ASTCallbackVHEPNS_8AliasSet10PointerRecENS1_25ASTCallbackVHDenseMapInfoENS_12DenseMapInfoIS5_EEE5beginEv", "llvm::DenseMap<llvm::AliasSetTracker::ASTCallbackVH, llvm::AliasSet::PointerRec*, llvm::AliasSetTracker::ASTCallbackVHDenseMapInfo, llvm::DenseMapInfo<llvm::AliasSet::PointerRec*> >::begin()"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_15AliasSetTracker13ASTCallbackVHEPNS_8AliasSet10PointerRecENS1_25ASTCallbackVHDenseMapInfoENS_12DenseMapInfoIS5_EEE5clearEv", "llvm::DenseMap<llvm::AliasSetTracker::ASTCallbackVH, llvm::AliasSet::PointerRec*, llvm::AliasSetTracker::ASTCallbackVHDenseMapInfo, llvm::DenseMapInfo<llvm::AliasSet::PointerRec*> >::clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_15AliasSetTracker13ASTCallbackVHEPNS_8AliasSet10PointerRecENS1_25ASTCallbackVHDenseMapInfoENS_12DenseMapInfoIS5_EEE5eraseERKS2_", "llvm::DenseMap<llvm::AliasSetTracker::ASTCallbackVH, llvm::AliasSet::PointerRec*, llvm::AliasSetTracker::ASTCallbackVHDenseMapInfo, llvm::DenseMapInfo<llvm::AliasSet::PointerRec*> >::erase(llvm::AliasSetTracker::ASTCallbackVH const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_15AliasSetTracker13ASTCallbackVHEPNS_8AliasSet10PointerRecENS1_25ASTCallbackVHDenseMapInfoENS_12DenseMapInfoIS5_EEE4findERKS2_", "llvm::DenseMap<llvm::AliasSetTracker::ASTCallbackVH, llvm::AliasSet::PointerRec*, llvm::AliasSetTracker::ASTCallbackVHDenseMapInfo, llvm::DenseMapInfo<llvm::AliasSet::PointerRec*> >::find(llvm::AliasSetTracker::ASTCallbackVH const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_15AliasSetTracker13ASTCallbackVHEPNS_8AliasSet10PointerRecENS1_25ASTCallbackVHDenseMapInfoENS_12DenseMapInfoIS5_EEE5eraseENS_16DenseMapIteratorIS2_S5_S6_S8_Lb0EEE", "llvm::DenseMap<llvm::AliasSetTracker::ASTCallbackVH, llvm::AliasSet::PointerRec*, llvm::AliasSetTracker::ASTCallbackVHDenseMapInfo, llvm::DenseMapInfo<llvm::AliasSet::PointerRec*> >::erase(llvm::DenseMapIterator<llvm::AliasSetTracker::ASTCallbackVH, llvm::AliasSet::PointerRec*, llvm::AliasSetTracker::ASTCallbackVHDenseMapInfo, llvm::DenseMapInfo<llvm::AliasSet::PointerRec*>, false>)"),
	mu_demangle_test("_ZNK4llvm6iplistINS_8AliasSetENS_12ilist_traitsIS1_EEE3endEv", "llvm::iplist<llvm::AliasSet, llvm::ilist_traits<llvm::AliasSet> >::end() const"),
	mu_demangle_test("_ZNK4llvm8DenseMapINS_15AliasSetTracker13ASTCallbackVHEPNS_8AliasSet10PointerRecENS1_25ASTCallbackVHDenseMapInfoENS_12DenseMapInfoIS5_EEE15LookupBucketForERKS2_RPSt4pairIS2_S5_E", "llvm::DenseMap<llvm::AliasSetTracker::ASTCallbackVH, llvm::AliasSet::PointerRec*, llvm::AliasSetTracker::ASTCallbackVHDenseMapInfo, llvm::DenseMapInfo<llvm::AliasSet::PointerRec*> >::LookupBucketFor(llvm::AliasSetTracker::ASTCallbackVH const&, std::pair<llvm::AliasSetTracker::ASTCallbackVH, llvm::AliasSet::PointerRec*>*&) const"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_15AliasSetTracker13ASTCallbackVHEPNS_8AliasSet10PointerRecENS1_25ASTCallbackVHDenseMapInfoENS_12DenseMapInfoIS5_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::AliasSetTracker::ASTCallbackVH, llvm::AliasSet::PointerRec*, llvm::AliasSetTracker::ASTCallbackVHDenseMapInfo, llvm::DenseMapInfo<llvm::AliasSet::PointerRec*> >::shrink_and_clear()"),
	mu_demangle_test("_ZNSt6vectorIN4llvm11AssertingVHINS0_11InstructionEEESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<llvm::AssertingVH<llvm::Instruction>, std::allocator<llvm::AssertingVH<llvm::Instruction> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::AssertingVH<llvm::Instruction>*, std::vector<llvm::AssertingVH<llvm::Instruction>, std::allocator<llvm::AssertingVH<llvm::Instruction> > > >, llvm::AssertingVH<llvm::Instruction> const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm11AssertingVHINS0_11InstructionEEESaIS3_EE15_M_range_insertIN9__gnu_cxx17__normal_iteratorIPS3_S5_EEEEvSA_T_SB_St20forward_iterator_tag", "void std::vector<llvm::AssertingVH<llvm::Instruction>, std::allocator<llvm::AssertingVH<llvm::Instruction> > >::_M_range_insert<__gnu_cxx::__normal_iterator<llvm::AssertingVH<llvm::Instruction>*, std::vector<llvm::AssertingVH<llvm::Instruction>, std::allocator<llvm::AssertingVH<llvm::Instruction> > > > >(__gnu_cxx::__normal_iterator<llvm::AssertingVH<llvm::Instruction>*, std::vector<llvm::AssertingVH<llvm::Instruction>, std::allocator<llvm::AssertingVH<llvm::Instruction> > > >, __gnu_cxx::__normal_iterator<llvm::AssertingVH<llvm::Instruction>*, std::vector<llvm::AssertingVH<llvm::Instruction>, std::allocator<llvm::AssertingVH<llvm::Instruction> > > >, __gnu_cxx::__normal_iterator<llvm::AssertingVH<llvm::Instruction>*, std::vector<llvm::AssertingVH<llvm::Instruction>, std::allocator<llvm::AssertingVH<llvm::Instruction> > > >, std::forward_iterator_tag)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_15AliasSetTracker13ASTCallbackVHEPNS_8AliasSet10PointerRecENS1_25ASTCallbackVHDenseMapInfoENS_12DenseMapInfoIS5_EEE16InsertIntoBucketERKS2_RKS5_PSt4pairIS2_S5_E", "llvm::DenseMap<llvm::AliasSetTracker::ASTCallbackVH, llvm::AliasSet::PointerRec*, llvm::AliasSetTracker::ASTCallbackVHDenseMapInfo, llvm::DenseMapInfo<llvm::AliasSet::PointerRec*> >::InsertIntoBucket(llvm::AliasSetTracker::ASTCallbackVH const&, llvm::AliasSet::PointerRec* const&, std::pair<llvm::AliasSetTracker::ASTCallbackVH, llvm::AliasSet::PointerRec*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_15AliasSetTracker13ASTCallbackVHEPNS_8AliasSet10PointerRecENS1_25ASTCallbackVHDenseMapInfoENS_12DenseMapInfoIS5_EEE4growEj", "llvm::DenseMap<llvm::AliasSetTracker::ASTCallbackVH, llvm::AliasSet::PointerRec*, llvm::AliasSetTracker::ASTCallbackVHDenseMapInfo, llvm::DenseMapInfo<llvm::AliasSet::PointerRec*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm18InlineCostAnalyzer7ArgInfoESaIS2_EE7reserveEm", "std::vector<llvm::InlineCostAnalyzer::ArgInfo, std::allocator<llvm::InlineCostAnalyzer::ArgInfo> >::reserve(unsigned long)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_18ValueMapCallbackVHIPKNS_8FunctionENS_18InlineCostAnalyzer12FunctionInfoENS_14ValueMapConfigIS4_EENS_12DenseMapInfoIS6_EEEES6_NS9_ISB_EESA_E5clearEv", "llvm::DenseMap<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >, llvm::InlineCostAnalyzer::FunctionInfo, llvm::DenseMapInfo<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> > >, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >::clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_18ValueMapCallbackVHIPKNS_8FunctionENS_18InlineCostAnalyzer12FunctionInfoENS_14ValueMapConfigIS4_EENS_12DenseMapInfoIS6_EEEES6_NS9_ISB_EESA_E16shrink_and_clearEv", "llvm::DenseMap<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >, llvm::InlineCostAnalyzer::FunctionInfo, llvm::DenseMapInfo<llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> > >, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >::shrink_and_clear()"),
	mu_demangle_test("_ZNSt6vectorIN4llvm18InlineCostAnalyzer7ArgInfoESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::InlineCostAnalyzer::ArgInfo, std::allocator<llvm::InlineCostAnalyzer::ArgInfo> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::InlineCostAnalyzer::ArgInfo*, std::vector<llvm::InlineCostAnalyzer::ArgInfo, std::allocator<llvm::InlineCostAnalyzer::ArgInfo> > >, llvm::InlineCostAnalyzer::ArgInfo const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_10BasicBlockEjNS_12DenseMapInfoIS3_EENS4_IjEEE16InsertIntoBucketERKS3_RKjPSt4pairIS3_jE", "llvm::DenseMap<llvm::BasicBlock const*, unsigned int, llvm::DenseMapInfo<llvm::BasicBlock const*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(llvm::BasicBlock const* const&, unsigned int const&, std::pair<llvm::BasicBlock const*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_10BasicBlockEjNS_12DenseMapInfoIS3_EENS4_IjEEE4growEj", "llvm::DenseMap<llvm::BasicBlock const*, unsigned int, llvm::DenseMapInfo<llvm::BasicBlock const*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZNK4llvm8DenseMapIN12_GLOBAL__N_114LVIValueHandleESt3mapINS_11AssertingVHINS_10BasicBlockEEENS1_13LVILatticeValESt4lessIS6_ESaISt4pairIKS6_S7_EEENS_12DenseMapInfoIS2_EENSF_ISE_EEE15LookupBucketForERKS2_RPSA_IS2_SE_E", "llvm::DenseMap<(anonymous namespace)::LVIValueHandle, std::map<llvm::AssertingVH<llvm::BasicBlock>, (anonymous namespace)::LVILatticeVal, std::less<llvm::AssertingVH<llvm::BasicBlock> >, std::allocator<std::pair<llvm::AssertingVH<llvm::BasicBlock> const, (anonymous namespace)::LVILatticeVal> > >, llvm::DenseMapInfo<(anonymous namespace)::LVIValueHandle>, llvm::DenseMapInfo<std::map<llvm::AssertingVH<llvm::BasicBlock>, (anonymous namespace)::LVILatticeVal, std::less<llvm::AssertingVH<llvm::BasicBlock> >, std::allocator<std::pair<llvm::AssertingVH<llvm::BasicBlock> const, (anonymous namespace)::LVILatticeVal> > > > >::LookupBucketFor((anonymous namespace)::LVIValueHandle const&, std::pair<(anonymous namespace)::LVIValueHandle, std::map<llvm::AssertingVH<llvm::BasicBlock>, (anonymous namespace)::LVILatticeVal, std::less<llvm::AssertingVH<llvm::BasicBlock> >, std::allocator<std::pair<llvm::AssertingVH<llvm::BasicBlock> const, (anonymous namespace)::LVILatticeVal> > > >*&) const"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm11AssertingVHINS0_10BasicBlockEEESt4pairIKS3_N12_GLOBAL__N_113LVILatticeValEESt10_Select1stIS8_ESt4lessIS3_ESaIS8_EE8_M_eraseEPSt13_Rb_tree_nodeIS8_E", "std::_Rb_tree<llvm::AssertingVH<llvm::BasicBlock>, std::pair<llvm::AssertingVH<llvm::BasicBlock> const, (anonymous namespace)::LVILatticeVal>, std::_Select1st<std::pair<llvm::AssertingVH<llvm::BasicBlock> const, (anonymous namespace)::LVILatticeVal> >, std::less<llvm::AssertingVH<llvm::BasicBlock> >, std::allocator<std::pair<llvm::AssertingVH<llvm::BasicBlock> const, (anonymous namespace)::LVILatticeVal> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::AssertingVH<llvm::BasicBlock> const, (anonymous namespace)::LVILatticeVal> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIN12_GLOBAL__N_114LVIValueHandleESt3mapINS_11AssertingVHINS_10BasicBlockEEENS1_13LVILatticeValESt4lessIS6_ESaISt4pairIKS6_S7_EEENS_12DenseMapInfoIS2_EENSF_ISE_EEEixERKS2_", "llvm::DenseMap<(anonymous namespace)::LVIValueHandle, std::map<llvm::AssertingVH<llvm::BasicBlock>, (anonymous namespace)::LVILatticeVal, std::less<llvm::AssertingVH<llvm::BasicBlock> >, std::allocator<std::pair<llvm::AssertingVH<llvm::BasicBlock> const, (anonymous namespace)::LVILatticeVal> > >, llvm::DenseMapInfo<(anonymous namespace)::LVIValueHandle>, llvm::DenseMapInfo<std::map<llvm::AssertingVH<llvm::BasicBlock>, (anonymous namespace)::LVILatticeVal, std::less<llvm::AssertingVH<llvm::BasicBlock> >, std::allocator<std::pair<llvm::AssertingVH<llvm::BasicBlock> const, (anonymous namespace)::LVILatticeVal> > > > >::operator[]((anonymous namespace)::LVIValueHandle const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm11AssertingVHINS0_10BasicBlockEEESt4pairIKS3_N12_GLOBAL__N_113LVILatticeValEESt10_Select1stIS8_ESt4lessIS3_ESaIS8_EE7_M_copyEPKSt13_Rb_tree_nodeIS8_EPSG_", "std::_Rb_tree<llvm::AssertingVH<llvm::BasicBlock>, std::pair<llvm::AssertingVH<llvm::BasicBlock> const, (anonymous namespace)::LVILatticeVal>, std::_Select1st<std::pair<llvm::AssertingVH<llvm::BasicBlock> const, (anonymous namespace)::LVILatticeVal> >, std::less<llvm::AssertingVH<llvm::BasicBlock> >, std::allocator<std::pair<llvm::AssertingVH<llvm::BasicBlock> const, (anonymous namespace)::LVILatticeVal> > >::_M_copy(std::_Rb_tree_node<std::pair<llvm::AssertingVH<llvm::BasicBlock> const, (anonymous namespace)::LVILatticeVal> > const*, std::_Rb_tree_node<std::pair<llvm::AssertingVH<llvm::BasicBlock> const, (anonymous namespace)::LVILatticeVal> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm11AssertingVHINS0_10BasicBlockEEESt4pairIKS3_N12_GLOBAL__N_113LVILatticeValEESt10_Select1stIS8_ESt4lessIS3_ESaIS8_EE14_M_create_nodeERKS8_", "std::_Rb_tree<llvm::AssertingVH<llvm::BasicBlock>, std::pair<llvm::AssertingVH<llvm::BasicBlock> const, (anonymous namespace)::LVILatticeVal>, std::_Select1st<std::pair<llvm::AssertingVH<llvm::BasicBlock> const, (anonymous namespace)::LVILatticeVal> >, std::less<llvm::AssertingVH<llvm::BasicBlock> >, std::allocator<std::pair<llvm::AssertingVH<llvm::BasicBlock> const, (anonymous namespace)::LVILatticeVal> > >::_M_create_node(std::pair<llvm::AssertingVH<llvm::BasicBlock> const, (anonymous namespace)::LVILatticeVal> const&)"),
	mu_demangle_test("_ZNSt3mapIN4llvm11AssertingVHINS0_10BasicBlockEEEN12_GLOBAL__N_113LVILatticeValESt4lessIS3_ESaISt4pairIKS3_S5_EEEixERS9_", "std::map<llvm::AssertingVH<llvm::BasicBlock>, (anonymous namespace)::LVILatticeVal, std::less<llvm::AssertingVH<llvm::BasicBlock> >, std::allocator<std::pair<llvm::AssertingVH<llvm::BasicBlock> const, (anonymous namespace)::LVILatticeVal> > >::operator[](llvm::AssertingVH<llvm::BasicBlock> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm11AssertingVHINS0_10BasicBlockEEESt4pairIKS3_N12_GLOBAL__N_113LVILatticeValEESt10_Select1stIS8_ESt4lessIS3_ESaIS8_EE16_M_insert_uniqueERKS8_", "std::_Rb_tree<llvm::AssertingVH<llvm::BasicBlock>, std::pair<llvm::AssertingVH<llvm::BasicBlock> const, (anonymous namespace)::LVILatticeVal>, std::_Select1st<std::pair<llvm::AssertingVH<llvm::BasicBlock> const, (anonymous namespace)::LVILatticeVal> >, std::less<llvm::AssertingVH<llvm::BasicBlock> >, std::allocator<std::pair<llvm::AssertingVH<llvm::BasicBlock> const, (anonymous namespace)::LVILatticeVal> > >::_M_insert_unique(std::pair<llvm::AssertingVH<llvm::BasicBlock> const, (anonymous namespace)::LVILatticeVal> const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm10BasicBlockESaIS2_EE15_M_range_insertINS0_12SuccIteratorIPNS0_14TerminatorInstES1_EEEEvN9__gnu_cxx17__normal_iteratorIPS2_S4_EET_SE_St20forward_iterator_tag", "void std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> >::_M_range_insert<llvm::SuccIterator<llvm::TerminatorInst*, llvm::BasicBlock> >(__gnu_cxx::__normal_iterator<llvm::BasicBlock**, std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> > >, llvm::SuccIterator<llvm::TerminatorInst*, llvm::BasicBlock>, llvm::SuccIterator<llvm::TerminatorInst*, llvm::BasicBlock>, std::forward_iterator_tag)"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairINS_11AssertingVHINS_10BasicBlockEEEPNS_5ValueEEcNS_12DenseMapInfoIS7_EENS8_IcEEE4findERKS7_", "llvm::DenseMap<std::pair<llvm::AssertingVH<llvm::BasicBlock>, llvm::Value*>, char, llvm::DenseMapInfo<std::pair<llvm::AssertingVH<llvm::BasicBlock>, llvm::Value*> >, llvm::DenseMapInfo<char> >::find(std::pair<llvm::AssertingVH<llvm::BasicBlock>, llvm::Value*> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5ValueEcNS_12DenseMapInfoIS2_EENS3_IcEEE6insertERKSt4pairIS2_cE", "llvm::DenseMap<llvm::Value*, char, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<char> >::insert(std::pair<llvm::Value*, char> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5ValueEcNS_12DenseMapInfoIS2_EENS3_IcEEE16InsertIntoBucketERKS2_RKcPSt4pairIS2_cE", "llvm::DenseMap<llvm::Value*, char, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<char> >::InsertIntoBucket(llvm::Value* const&, char const&, std::pair<llvm::Value*, char>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5ValueEcNS_12DenseMapInfoIS2_EENS3_IcEEE4growEj", "llvm::DenseMap<llvm::Value*, char, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<char> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt5dequeISt4pairIPN4llvm10BasicBlockEPNS1_5ValueEESaIS6_EE9push_backERKS6_", "std::deque<std::pair<llvm::BasicBlock*, llvm::Value*>, std::allocator<std::pair<llvm::BasicBlock*, llvm::Value*> > >::push_back(std::pair<llvm::BasicBlock*, llvm::Value*> const&)"),
	mu_demangle_test("_ZNSt5dequeISt4pairIPN4llvm10BasicBlockEPNS1_5ValueEESaIS6_EE17_M_reallocate_mapEmb", "std::deque<std::pair<llvm::BasicBlock*, llvm::Value*>, std::allocator<std::pair<llvm::BasicBlock*, llvm::Value*> > >::_M_reallocate_map(unsigned long, bool)"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairINS_11AssertingVHINS_10BasicBlockEEEPNS_5ValueEEcNS_12DenseMapInfoIS7_EENS8_IcEEE6insertERKS1_IS7_cE", "llvm::DenseMap<std::pair<llvm::AssertingVH<llvm::BasicBlock>, llvm::Value*>, char, llvm::DenseMapInfo<std::pair<llvm::AssertingVH<llvm::BasicBlock>, llvm::Value*> >, llvm::DenseMapInfo<char> >::insert(std::pair<std::pair<llvm::AssertingVH<llvm::BasicBlock>, llvm::Value*>, char> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairINS_11AssertingVHINS_10BasicBlockEEEPNS_5ValueEEcNS_12DenseMapInfoIS7_EENS8_IcEEE16InsertIntoBucketERKS7_RKcPS1_IS7_cE", "llvm::DenseMap<std::pair<llvm::AssertingVH<llvm::BasicBlock>, llvm::Value*>, char, llvm::DenseMapInfo<std::pair<llvm::AssertingVH<llvm::BasicBlock>, llvm::Value*> >, llvm::DenseMapInfo<char> >::InsertIntoBucket(std::pair<llvm::AssertingVH<llvm::BasicBlock>, llvm::Value*> const&, char const&, std::pair<std::pair<llvm::AssertingVH<llvm::BasicBlock>, llvm::Value*>, char>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairINS_11AssertingVHINS_10BasicBlockEEEPNS_5ValueEEcNS_12DenseMapInfoIS7_EENS8_IcEEE4growEj", "llvm::DenseMap<std::pair<llvm::AssertingVH<llvm::BasicBlock>, llvm::Value*>, char, llvm::DenseMapInfo<std::pair<llvm::AssertingVH<llvm::BasicBlock>, llvm::Value*> >, llvm::DenseMapInfo<char> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseSetISt4pairINS_11AssertingVHINS_10BasicBlockEEEPNS_5ValueEENS_12DenseMapInfoIS7_EEE5clearEv", "llvm::DenseSet<std::pair<llvm::AssertingVH<llvm::BasicBlock>, llvm::Value*>, llvm::DenseMapInfo<std::pair<llvm::AssertingVH<llvm::BasicBlock>, llvm::Value*> > >::clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairINS_11AssertingVHINS_10BasicBlockEEEPNS_5ValueEEcNS_12DenseMapInfoIS7_EENS8_IcEEE16shrink_and_clearEv", "llvm::DenseMap<std::pair<llvm::AssertingVH<llvm::BasicBlock>, llvm::Value*>, char, llvm::DenseMapInfo<std::pair<llvm::AssertingVH<llvm::BasicBlock>, llvm::Value*> >, llvm::DenseMapInfo<char> >::shrink_and_clear()"),
	mu_demangle_test("_ZNSt11_Deque_baseISt4pairIPN4llvm10BasicBlockEPNS1_5ValueEESaIS6_EE17_M_initialize_mapEm", "std::_Deque_base<std::pair<llvm::BasicBlock*, llvm::Value*>, std::allocator<std::pair<llvm::BasicBlock*, llvm::Value*> > >::_M_initialize_map(unsigned long)"),
	mu_demangle_test("_ZNSt5dequeISt4pairIPN4llvm10BasicBlockEPNS1_5ValueEESaIS6_EEC2ERKS8_", "std::deque<std::pair<llvm::BasicBlock*, llvm::Value*>, std::allocator<std::pair<llvm::BasicBlock*, llvm::Value*> > >::deque(std::deque<std::pair<llvm::BasicBlock*, llvm::Value*>, std::allocator<std::pair<llvm::BasicBlock*, llvm::Value*> > > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEPNS_4LoopENS_12DenseMapInfoIS2_EENS5_IS4_EEE6insertERKSt4pairIS2_S4_E", "llvm::DenseMap<llvm::BasicBlock*, llvm::Loop*, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::Loop*> >::insert(std::pair<llvm::BasicBlock*, llvm::Loop*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm10BasicBlockESt4pairIKS2_PNS0_4LoopEESt10_Select1stIS7_ESt4lessIS2_ESaIS7_EE8_M_eraseEPSt13_Rb_tree_nodeIS7_E", "std::_Rb_tree<llvm::BasicBlock*, std::pair<llvm::BasicBlock* const, llvm::Loop*>, std::_Select1st<std::pair<llvm::BasicBlock* const, llvm::Loop*> >, std::less<llvm::BasicBlock*>, std::allocator<std::pair<llvm::BasicBlock* const, llvm::Loop*> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::BasicBlock* const, llvm::Loop*> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm10BasicBlockESt4pairIKS2_PNS0_4LoopEESt10_Select1stIS7_ESt4lessIS2_ESaIS7_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS7_ERKS7_", "std::_Rb_tree<llvm::BasicBlock*, std::pair<llvm::BasicBlock* const, llvm::Loop*>, std::_Select1st<std::pair<llvm::BasicBlock* const, llvm::Loop*> >, std::less<llvm::BasicBlock*>, std::allocator<std::pair<llvm::BasicBlock* const, llvm::Loop*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::BasicBlock* const, llvm::Loop*> >, std::pair<llvm::BasicBlock* const, llvm::Loop*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm10BasicBlockESt4pairIKS2_PNS0_4LoopEESt10_Select1stIS7_ESt4lessIS2_ESaIS7_EE16_M_insert_uniqueERKS7_", "std::_Rb_tree<llvm::BasicBlock*, std::pair<llvm::BasicBlock* const, llvm::Loop*>, std::_Select1st<std::pair<llvm::BasicBlock* const, llvm::Loop*> >, std::less<llvm::BasicBlock*>, std::allocator<std::pair<llvm::BasicBlock* const, llvm::Loop*> > >::_M_insert_unique(std::pair<llvm::BasicBlock* const, llvm::Loop*> const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm10BasicBlockESaIS2_EE15_M_range_insertINS0_12PredIteratorIS1_NS0_18value_use_iteratorINS0_4UserEEEEEEEvN9__gnu_cxx17__normal_iteratorIPS2_S4_EET_SF_St20forward_iterator_tag", "void std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> >::_M_range_insert<llvm::PredIterator<llvm::BasicBlock, llvm::value_use_iterator<llvm::User> > >(__gnu_cxx::__normal_iterator<llvm::BasicBlock**, std::vector<llvm::BasicBlock*, std::allocator<llvm::BasicBlock*> > >, llvm::PredIterator<llvm::BasicBlock, llvm::value_use_iterator<llvm::User> >, llvm::PredIterator<llvm::BasicBlock, llvm::value_use_iterator<llvm::User> >, std::forward_iterator_tag)"),
	mu_demangle_test("_ZSt6__findIN9__gnu_cxx17__normal_iteratorIPPN4llvm4LoopESt6vectorIS4_SaIS4_EEEES4_ET_SA_SA_RKT0_St26random_access_iterator_tag", "__gnu_cxx::__normal_iterator<llvm::Loop**, std::vector<llvm::Loop*, std::allocator<llvm::Loop*> > > std::__find<__gnu_cxx::__normal_iterator<llvm::Loop**, std::vector<llvm::Loop*, std::allocator<llvm::Loop*> > >, llvm::Loop*>(__gnu_cxx::__normal_iterator<llvm::Loop**, std::vector<llvm::Loop*, std::allocator<llvm::Loop*> > >, __gnu_cxx::__normal_iterator<llvm::Loop**, std::vector<llvm::Loop*, std::allocator<llvm::Loop*> > >, llvm::Loop* const&, std::random_access_iterator_tag)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEPNS_4LoopENS_12DenseMapInfoIS2_EENS5_IS4_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::BasicBlock*, llvm::Loop*, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::Loop*> >::shrink_and_clear()"),
	mu_demangle_test("_Z16addLoopIntoQueuePN4llvm4LoopERSt5dequeIS1_SaIS1_EE", "addLoopIntoQueue(llvm::Loop*, std::deque<llvm::Loop*, std::allocator<llvm::Loop*> >&)"),
	mu_demangle_test("_ZNSt5dequeIPN4llvm4LoopESaIS2_EE5eraseESt15_Deque_iteratorIS2_RS2_PS2_E", "std::deque<llvm::Loop*, std::allocator<llvm::Loop*> >::erase(std::_Deque_iterator<llvm::Loop*, llvm::Loop*&, llvm::Loop**>)"),
	mu_demangle_test("_ZNSt5dequeIPN4llvm4LoopESaIS2_EE9push_backERKS2_", "std::deque<llvm::Loop*, std::allocator<llvm::Loop*> >::push_back(llvm::Loop* const&)"),
	mu_demangle_test("_ZNSt5dequeIPN4llvm4LoopESaIS2_EE17_M_reallocate_mapEmb", "std::deque<llvm::Loop*, std::allocator<llvm::Loop*> >::_M_reallocate_map(unsigned long, bool)"),
	mu_demangle_test("_ZNSt5dequeIPN4llvm4LoopESaIS2_EE14_M_fill_insertESt15_Deque_iteratorIS2_RS2_PS2_EmRKS2_", "std::deque<llvm::Loop*, std::allocator<llvm::Loop*> >::_M_fill_insert(std::_Deque_iterator<llvm::Loop*, llvm::Loop*&, llvm::Loop**>, unsigned long, llvm::Loop* const&)"),
	mu_demangle_test("_ZNSt5dequeIPN4llvm4LoopESaIS2_EE13_M_insert_auxESt15_Deque_iteratorIS2_RS2_PS2_EmRKS2_", "std::deque<llvm::Loop*, std::allocator<llvm::Loop*> >::_M_insert_aux(std::_Deque_iterator<llvm::Loop*, llvm::Loop*&, llvm::Loop**>, unsigned long, llvm::Loop* const&)"),
	mu_demangle_test("_ZSt4fillIPN4llvm4LoopEEvRKSt15_Deque_iteratorIT_RS4_PS4_ES9_RKS4_", "void std::fill<llvm::Loop*>(std::_Deque_iterator<llvm::Loop*, llvm::Loop*&, llvm::Loop**> const&, std::_Deque_iterator<llvm::Loop*, llvm::Loop*&, llvm::Loop**> const&, llvm::Loop* const&)"),
	mu_demangle_test("_ZNSt15__copy_backwardILb0ESt26random_access_iterator_tagE8__copy_bISt15_Deque_iteratorIPN4llvm4LoopERS6_PS6_ES9_EET0_T_SB_SA_", "std::_Deque_iterator<llvm::Loop*, llvm::Loop*&, llvm::Loop**> std::__copy_backward<false, std::random_access_iterator_tag>::__copy_b<std::_Deque_iterator<llvm::Loop*, llvm::Loop*&, llvm::Loop**>, std::_Deque_iterator<llvm::Loop*, llvm::Loop*&, llvm::Loop**> >(std::_Deque_iterator<llvm::Loop*, llvm::Loop*&, llvm::Loop**>, std::_Deque_iterator<llvm::Loop*, llvm::Loop*&, llvm::Loop**>, std::_Deque_iterator<llvm::Loop*, llvm::Loop*&, llvm::Loop**>)"),
	mu_demangle_test("_ZNSt5dequeIPN4llvm4LoopESaIS2_EE23_M_new_elements_at_backEm", "std::deque<llvm::Loop*, std::allocator<llvm::Loop*> >::_M_new_elements_at_back(unsigned long)"),
	mu_demangle_test("_ZNSt5dequeIPN4llvm4LoopESaIS2_EE24_M_new_elements_at_frontEm", "std::deque<llvm::Loop*, std::allocator<llvm::Loop*> >::_M_new_elements_at_front(unsigned long)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm4LoopESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::Loop*, std::allocator<llvm::Loop*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::Loop**, std::vector<llvm::Loop*, std::allocator<llvm::Loop*> > >, llvm::Loop* const&)"),
	mu_demangle_test("_ZNSt11_Deque_baseIPN4llvm4LoopESaIS2_EE17_M_initialize_mapEm", "std::_Deque_base<llvm::Loop*, std::allocator<llvm::Loop*> >::_M_initialize_map(unsigned long)"),
	mu_demangle_test("_Z20RemoveFromReverseMapIPN4llvm11InstructionEEvRNS0_8DenseMapIS2_NS0_11SmallPtrSetIT_Lj4EEENS0_12DenseMapInfoIS2_EENS7_IS6_EEEES2_S5_", "void RemoveFromReverseMap<llvm::Instruction*>(llvm::DenseMap<llvm::Instruction*, llvm::SmallPtrSet<llvm::Instruction*, 4u>, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<llvm::SmallPtrSet<llvm::Instruction*, 4u> > >&, llvm::Instruction*, llvm::Instruction*)"),
	mu_demangle_test("_ZN4llvm24MemoryDependenceAnalysis27getNonLocalPointerDepFromBBERKNS_12PHITransAddrERKNS_13AliasAnalysis8LocationEbPNS_10BasicBlockERNS_15SmallVectorImplINS_17NonLocalDepResultEEERNS_8DenseMapIS9_PNS_5ValueENS_12DenseMapInfoIS9_EENSH_ISG_EEEEb", "llvm::MemoryDependenceAnalysis::getNonLocalPointerDepFromBB(llvm::PHITransAddr const&, llvm::AliasAnalysis::Location const&, bool, llvm::BasicBlock*, llvm::SmallVectorImpl<llvm::NonLocalDepResult>&, llvm::DenseMap<llvm::BasicBlock*, llvm::Value*, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::Value*> >&, bool)"),
	mu_demangle_test("_ZN4llvm24MemoryDependenceAnalysis23GetNonLocalInfoForBlockERKNS_13AliasAnalysis8LocationEbPNS_10BasicBlockEPSt6vectorINS_16NonLocalDepEntryESaIS8_EEj", "llvm::MemoryDependenceAnalysis::GetNonLocalInfoForBlock(llvm::AliasAnalysis::Location const&, bool, llvm::BasicBlock*, std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> >*, unsigned int)"),
	mu_demangle_test("_Z20RemoveFromReverseMapIN4llvm14PointerIntPairIPKNS0_5ValueELj1EbNS0_21PointerLikeTypeTraitsIS4_EEEEEvRNS0_8DenseMapIPNS0_11InstructionENS0_11SmallPtrSetIT_Lj4EEENS0_12DenseMapInfoISA_EENSE_ISD_EEEESA_SC_", "void RemoveFromReverseMap<llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> > >(llvm::DenseMap<llvm::Instruction*, llvm::SmallPtrSet<llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> >, 4u>, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<llvm::SmallPtrSet<llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> >, 4u> > >&, llvm::Instruction*, llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> >)"),
	mu_demangle_test("_Z24SortNonLocalDepInfoCacheRSt6vectorIN4llvm16NonLocalDepEntryESaIS1_EEj", "SortNonLocalDepInfoCache(std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> >&, unsigned int)"),
	mu_demangle_test("_ZN4llvm24MemoryDependenceAnalysis39RemoveCachedNonLocalPointerDependenciesENS_14PointerIntPairIPKNS_5ValueELj1EbNS_21PointerLikeTypeTraitsIS4_EEEE", "llvm::MemoryDependenceAnalysis::RemoveCachedNonLocalPointerDependencies(llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> >)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_11InstructionESt4pairISt6vectorINS_16NonLocalDepEntryESaIS5_EEbENS_12DenseMapInfoIS2_EENS9_IS8_EEE5clearEv", "llvm::DenseMap<llvm::Instruction*, std::pair<std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> >, bool>, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<std::pair<std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> >, bool> > >::clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_14PointerIntPairIPKNS_5ValueELj1EbNS_21PointerLikeTypeTraitsIS4_EEEENS_24MemoryDependenceAnalysis19NonLocalPointerInfoENS_12DenseMapInfoIS7_EENSA_IS9_EEE5clearEv", "llvm::DenseMap<llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> >, llvm::MemoryDependenceAnalysis::NonLocalPointerInfo, llvm::DenseMapInfo<llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> > >, llvm::DenseMapInfo<llvm::MemoryDependenceAnalysis::NonLocalPointerInfo> >::clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_11InstructionENS_11SmallPtrSetIS2_Lj4EEENS_12DenseMapInfoIS2_EENS5_IS4_EEE5clearEv", "llvm::DenseMap<llvm::Instruction*, llvm::SmallPtrSet<llvm::Instruction*, 4u>, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<llvm::SmallPtrSet<llvm::Instruction*, 4u> > >::clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_11InstructionENS_11SmallPtrSetINS_14PointerIntPairIPKNS_5ValueELj1EbNS_21PointerLikeTypeTraitsIS7_EEEELj4EEENS_12DenseMapInfoIS2_EENSC_ISB_EEE5clearEv", "llvm::DenseMap<llvm::Instruction*, llvm::SmallPtrSet<llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> >, 4u>, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<llvm::SmallPtrSet<llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> >, 4u> > >::clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_14PointerIntPairIPKNS_5ValueELj1EbNS_21PointerLikeTypeTraitsIS4_EEEENS_24MemoryDependenceAnalysis19NonLocalPointerInfoENS_12DenseMapInfoIS7_EENSA_IS9_EEE6insertERKSt4pairIS7_S9_E", "llvm::DenseMap<llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> >, llvm::MemoryDependenceAnalysis::NonLocalPointerInfo, llvm::DenseMapInfo<llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> > >, llvm::DenseMapInfo<llvm::MemoryDependenceAnalysis::NonLocalPointerInfo> >::insert(std::pair<llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> >, llvm::MemoryDependenceAnalysis::NonLocalPointerInfo> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_14PointerIntPairIPKNS_5ValueELj1EbNS_21PointerLikeTypeTraitsIS4_EEEENS_24MemoryDependenceAnalysis19NonLocalPointerInfoENS_12DenseMapInfoIS7_EENSA_IS9_EEE16FindAndConstructERKS7_", "llvm::DenseMap<llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> >, llvm::MemoryDependenceAnalysis::NonLocalPointerInfo, llvm::DenseMapInfo<llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> > >, llvm::DenseMapInfo<llvm::MemoryDependenceAnalysis::NonLocalPointerInfo> >::FindAndConstruct(llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_14PointerIntPairIPKNS_5ValueELj1EbNS_21PointerLikeTypeTraitsIS4_EEEENS_24MemoryDependenceAnalysis19NonLocalPointerInfoENS_12DenseMapInfoIS7_EENSA_IS9_EEE16InsertIntoBucketERKS7_RKS9_PSt4pairIS7_S9_E", "llvm::DenseMap<llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> >, llvm::MemoryDependenceAnalysis::NonLocalPointerInfo, llvm::DenseMapInfo<llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> > >, llvm::DenseMapInfo<llvm::MemoryDependenceAnalysis::NonLocalPointerInfo> >::InsertIntoBucket(llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> > const&, llvm::MemoryDependenceAnalysis::NonLocalPointerInfo const&, std::pair<llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> >, llvm::MemoryDependenceAnalysis::NonLocalPointerInfo>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_14PointerIntPairIPKNS_5ValueELj1EbNS_21PointerLikeTypeTraitsIS4_EEEENS_24MemoryDependenceAnalysis19NonLocalPointerInfoENS_12DenseMapInfoIS7_EENSA_IS9_EEE4growEj", "llvm::DenseMap<llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> >, llvm::MemoryDependenceAnalysis::NonLocalPointerInfo, llvm::DenseMapInfo<llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> > >, llvm::DenseMapInfo<llvm::MemoryDependenceAnalysis::NonLocalPointerInfo> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_11InstructionENS_11SmallPtrSetINS_14PointerIntPairIPKNS_5ValueELj1EbNS_21PointerLikeTypeTraitsIS7_EEEELj4EEENS_12DenseMapInfoIS2_EENSC_ISB_EEE16FindAndConstructERKS2_", "llvm::DenseMap<llvm::Instruction*, llvm::SmallPtrSet<llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> >, 4u>, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<llvm::SmallPtrSet<llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> >, 4u> > >::FindAndConstruct(llvm::Instruction* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_11InstructionENS_11SmallPtrSetINS_14PointerIntPairIPKNS_5ValueELj1EbNS_21PointerLikeTypeTraitsIS7_EEEELj4EEENS_12DenseMapInfoIS2_EENSC_ISB_EEE16InsertIntoBucketERKS2_RKSB_PSt4pairIS2_SB_E", "llvm::DenseMap<llvm::Instruction*, llvm::SmallPtrSet<llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> >, 4u>, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<llvm::SmallPtrSet<llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> >, 4u> > >::InsertIntoBucket(llvm::Instruction* const&, llvm::SmallPtrSet<llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> >, 4u> const&, std::pair<llvm::Instruction*, llvm::SmallPtrSet<llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> >, 4u> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_11InstructionENS_11SmallPtrSetINS_14PointerIntPairIPKNS_5ValueELj1EbNS_21PointerLikeTypeTraitsIS7_EEEELj4EEENS_12DenseMapInfoIS2_EENSC_ISB_EEE4growEj", "llvm::DenseMap<llvm::Instruction*, llvm::SmallPtrSet<llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> >, 4u>, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<llvm::SmallPtrSet<llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> >, 4u> > >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm16NonLocalDepEntryESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::NonLocalDepEntry*, std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> > >, llvm::NonLocalDepEntry const&)"),
	mu_demangle_test("_ZSt16__introsort_loopIN9__gnu_cxx17__normal_iteratorIPN4llvm16NonLocalDepEntryESt6vectorIS3_SaIS3_EEEElEvT_S9_T0_", "void std::__introsort_loop<__gnu_cxx::__normal_iterator<llvm::NonLocalDepEntry*, std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> > >, long>(__gnu_cxx::__normal_iterator<llvm::NonLocalDepEntry*, std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> > >, __gnu_cxx::__normal_iterator<llvm::NonLocalDepEntry*, std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> > >, long)"),
	mu_demangle_test("_ZSt22__final_insertion_sortIN9__gnu_cxx17__normal_iteratorIPN4llvm16NonLocalDepEntryESt6vectorIS3_SaIS3_EEEEEvT_S9_", "void std::__final_insertion_sort<__gnu_cxx::__normal_iterator<llvm::NonLocalDepEntry*, std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> > > >(__gnu_cxx::__normal_iterator<llvm::NonLocalDepEntry*, std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> > >, __gnu_cxx::__normal_iterator<llvm::NonLocalDepEntry*, std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> > >)"),
	mu_demangle_test("_ZSt16__insertion_sortIN9__gnu_cxx17__normal_iteratorIPN4llvm16NonLocalDepEntryESt6vectorIS3_SaIS3_EEEEEvT_S9_", "void std::__insertion_sort<__gnu_cxx::__normal_iterator<llvm::NonLocalDepEntry*, std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> > > >(__gnu_cxx::__normal_iterator<llvm::NonLocalDepEntry*, std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> > >, __gnu_cxx::__normal_iterator<llvm::NonLocalDepEntry*, std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> > >)"),
	mu_demangle_test("_ZSt13__heap_selectIN9__gnu_cxx17__normal_iteratorIPN4llvm16NonLocalDepEntryESt6vectorIS3_SaIS3_EEEEEvT_S9_S9_", "void std::__heap_select<__gnu_cxx::__normal_iterator<llvm::NonLocalDepEntry*, std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> > > >(__gnu_cxx::__normal_iterator<llvm::NonLocalDepEntry*, std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> > >, __gnu_cxx::__normal_iterator<llvm::NonLocalDepEntry*, std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> > >, __gnu_cxx::__normal_iterator<llvm::NonLocalDepEntry*, std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> > >)"),
	mu_demangle_test("_ZSt9sort_heapIN9__gnu_cxx17__normal_iteratorIPN4llvm16NonLocalDepEntryESt6vectorIS3_SaIS3_EEEEEvT_S9_", "void std::sort_heap<__gnu_cxx::__normal_iterator<llvm::NonLocalDepEntry*, std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> > > >(__gnu_cxx::__normal_iterator<llvm::NonLocalDepEntry*, std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> > >, __gnu_cxx::__normal_iterator<llvm::NonLocalDepEntry*, std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> > >)"),
	mu_demangle_test("_ZSt9make_heapIN9__gnu_cxx17__normal_iteratorIPN4llvm16NonLocalDepEntryESt6vectorIS3_SaIS3_EEEEEvT_S9_", "void std::make_heap<__gnu_cxx::__normal_iterator<llvm::NonLocalDepEntry*, std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> > > >(__gnu_cxx::__normal_iterator<llvm::NonLocalDepEntry*, std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> > >, __gnu_cxx::__normal_iterator<llvm::NonLocalDepEntry*, std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> > >)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_11InstructionESt4pairISt6vectorINS_16NonLocalDepEntryESaIS5_EEbENS_12DenseMapInfoIS2_EENS9_IS8_EEE16FindAndConstructERKS2_", "llvm::DenseMap<llvm::Instruction*, std::pair<std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> >, bool>, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<std::pair<std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> >, bool> > >::FindAndConstruct(llvm::Instruction* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_11InstructionESt4pairISt6vectorINS_16NonLocalDepEntryESaIS5_EEbENS_12DenseMapInfoIS2_EENS9_IS8_EEE16InsertIntoBucketERKS2_RKS8_PS3_IS2_S8_E", "llvm::DenseMap<llvm::Instruction*, std::pair<std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> >, bool>, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<std::pair<std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> >, bool> > >::InsertIntoBucket(llvm::Instruction* const&, std::pair<std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> >, bool> const&, std::pair<llvm::Instruction*, std::pair<std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> >, bool> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_11InstructionESt4pairISt6vectorINS_16NonLocalDepEntryESaIS5_EEbENS_12DenseMapInfoIS2_EENS9_IS8_EEE4growEj", "llvm::DenseMap<llvm::Instruction*, std::pair<std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> >, bool>, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<std::pair<std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> >, bool> > >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm16NonLocalDepEntryESaIS1_EEC2ERKS3_", "std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> >::vector(std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_11InstructionENS_11SmallPtrSetIS2_Lj4EEENS_12DenseMapInfoIS2_EENS5_IS4_EEE16FindAndConstructERKS2_", "llvm::DenseMap<llvm::Instruction*, llvm::SmallPtrSet<llvm::Instruction*, 4u>, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<llvm::SmallPtrSet<llvm::Instruction*, 4u> > >::FindAndConstruct(llvm::Instruction* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_11InstructionENS_11SmallPtrSetIS2_Lj4EEENS_12DenseMapInfoIS2_EENS5_IS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<llvm::Instruction*, llvm::SmallPtrSet<llvm::Instruction*, 4u>, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<llvm::SmallPtrSet<llvm::Instruction*, 4u> > >::InsertIntoBucket(llvm::Instruction* const&, llvm::SmallPtrSet<llvm::Instruction*, 4u> const&, std::pair<llvm::Instruction*, llvm::SmallPtrSet<llvm::Instruction*, 4u> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_11InstructionENS_11SmallPtrSetIS2_Lj4EEENS_12DenseMapInfoIS2_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::Instruction*, llvm::SmallPtrSet<llvm::Instruction*, 4u>, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<llvm::SmallPtrSet<llvm::Instruction*, 4u> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_11InstructionENS_12MemDepResultENS_12DenseMapInfoIS2_EENS4_IS3_EEE16InsertIntoBucketERKS2_RKS3_PSt4pairIS2_S3_E", "llvm::DenseMap<llvm::Instruction*, llvm::MemDepResult, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<llvm::MemDepResult> >::InsertIntoBucket(llvm::Instruction* const&, llvm::MemDepResult const&, std::pair<llvm::Instruction*, llvm::MemDepResult>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_11InstructionENS_12MemDepResultENS_12DenseMapInfoIS2_EENS4_IS3_EEE4growEj", "llvm::DenseMap<llvm::Instruction*, llvm::MemDepResult, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<llvm::MemDepResult> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_11InstructionENS_11SmallPtrSetINS_14PointerIntPairIPKNS_5ValueELj1EbNS_21PointerLikeTypeTraitsIS7_EEEELj4EEENS_12DenseMapInfoIS2_EENSC_ISB_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::Instruction*, llvm::SmallPtrSet<llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> >, 4u>, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<llvm::SmallPtrSet<llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> >, 4u> > >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_11InstructionENS_11SmallPtrSetIS2_Lj4EEENS_12DenseMapInfoIS2_EENS5_IS4_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::Instruction*, llvm::SmallPtrSet<llvm::Instruction*, 4u>, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<llvm::SmallPtrSet<llvm::Instruction*, 4u> > >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_14PointerIntPairIPKNS_5ValueELj1EbNS_21PointerLikeTypeTraitsIS4_EEEENS_24MemoryDependenceAnalysis19NonLocalPointerInfoENS_12DenseMapInfoIS7_EENSA_IS9_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> >, llvm::MemoryDependenceAnalysis::NonLocalPointerInfo, llvm::DenseMapInfo<llvm::PointerIntPair<llvm::Value const*, 1u, bool, llvm::PointerLikeTypeTraits<llvm::Value const*> > >, llvm::DenseMapInfo<llvm::MemoryDependenceAnalysis::NonLocalPointerInfo> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_11InstructionESt4pairISt6vectorINS_16NonLocalDepEntryESaIS5_EEbENS_12DenseMapInfoIS2_EENS9_IS8_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::Instruction*, std::pair<std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> >, bool>, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<std::pair<std::vector<llvm::NonLocalDepEntry, std::allocator<llvm::NonLocalDepEntry> >, bool> > >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_11InstructionENS_12MemDepResultENS_12DenseMapInfoIS2_EENS4_IS3_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::Instruction*, llvm::MemDepResult, llvm::DenseMapInfo<llvm::Instruction*>, llvm::DenseMapInfo<llvm::MemDepResult> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEjNS_12DenseMapInfoIS2_EENS3_IjEEE16InsertIntoBucketERKS2_RKjPSt4pairIS2_jE", "llvm::DenseMap<llvm::BasicBlock*, unsigned int, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(llvm::BasicBlock* const&, unsigned int const&, std::pair<llvm::BasicBlock*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEjNS_12DenseMapInfoIS2_EENS3_IjEEE4growEj", "llvm::DenseMap<llvm::BasicBlock*, unsigned int, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEPS2_NS_12DenseMapInfoIS2_EENS4_IS3_EEE16InsertIntoBucketERKS2_RKS3_PSt4pairIS2_S3_E", "llvm::DenseMap<llvm::BasicBlock*, llvm::BasicBlock**, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::BasicBlock**> >::InsertIntoBucket(llvm::BasicBlock* const&, llvm::BasicBlock** const&, std::pair<llvm::BasicBlock*, llvm::BasicBlock**>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEPS2_NS_12DenseMapInfoIS2_EENS4_IS3_EEE4growEj", "llvm::DenseMap<llvm::BasicBlock*, llvm::BasicBlock**, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::BasicBlock**> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEjNS_12DenseMapInfoIS2_EENS3_IjEEE16shrink_and_clearEv", "llvm::DenseMap<llvm::BasicBlock*, unsigned int, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<unsigned int> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockEPS2_NS_12DenseMapInfoIS2_EENS4_IS3_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::BasicBlock*, llvm::BasicBlock**, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::BasicBlock**> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm12ProfileInfoTINS_8FunctionENS_10BasicBlockEE7GetPathEPKS2_S5_RSt3mapIS5_S5_St4lessIS5_ESaISt4pairIKS5_S5_EEEj", "llvm::ProfileInfoT<llvm::Function, llvm::BasicBlock>::GetPath(llvm::BasicBlock const*, llvm::BasicBlock const*, std::map<llvm::BasicBlock const*, llvm::BasicBlock const*, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::BasicBlock const*> > >&, unsigned int)"),
	mu_demangle_test("_ZNSt3mapIPKN4llvm8FunctionES_IPKNS0_10BasicBlockEdSt4lessIS6_ESaISt4pairIKS6_dEEES7_IS3_ESaIS9_IKS3_SD_EEEixERSF_", "std::map<llvm::Function const*, std::map<llvm::BasicBlock const*, double, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, double> > >, std::less<llvm::Function const*>, std::allocator<std::pair<llvm::Function const* const, std::map<llvm::BasicBlock const*, double, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, double> > > > > >::operator[](llvm::Function const* const&)"),
	mu_demangle_test("_ZNSt3mapIPKN4llvm15MachineFunctionES_IPKNS0_17MachineBasicBlockEdSt4lessIS6_ESaISt4pairIKS6_dEEES7_IS3_ESaIS9_IKS3_SD_EEEixERSF_", "std::map<llvm::MachineFunction const*, std::map<llvm::MachineBasicBlock const*, double, std::less<llvm::MachineBasicBlock const*>, std::allocator<std::pair<llvm::MachineBasicBlock const* const, double> > >, std::less<llvm::MachineFunction const*>, std::allocator<std::pair<llvm::MachineFunction const* const, std::map<llvm::MachineBasicBlock const*, double, std::less<llvm::MachineBasicBlock const*>, std::allocator<std::pair<llvm::MachineBasicBlock const* const, double> > > > > >::operator[](llvm::MachineFunction const* const&)"),
	mu_demangle_test("_ZNSt3mapIPKN4llvm8FunctionES_ISt4pairIPKNS0_10BasicBlockES7_EdSt4lessIS8_ESaIS4_IKS8_dEEES9_IS3_ESaIS4_IKS3_SE_EEEixERSG_", "std::map<llvm::Function const*, std::map<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, double, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > >, std::less<llvm::Function const*>, std::allocator<std::pair<llvm::Function const* const, std::map<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, double, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > > > > >::operator[](llvm::Function const* const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm10BasicBlockES4_ES0_IKS5_dESt10_Select1stIS7_ESt4lessIS5_ESaIS7_EE7_M_copyEPKSt13_Rb_tree_nodeIS7_EPSF_", "std::_Rb_tree<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double>, std::_Select1st<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> >, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > >::_M_copy(std::_Rb_tree_node<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > const*, std::_Rb_tree_node<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm10BasicBlockES3_St9_IdentityIS3_ESt4lessIS3_ESaIS3_EE8_M_eraseEPSt13_Rb_tree_nodeIS3_E", "std::_Rb_tree<llvm::BasicBlock const*, llvm::BasicBlock const*, std::_Identity<llvm::BasicBlock const*>, std::less<llvm::BasicBlock const*>, std::allocator<llvm::BasicBlock const*> >::_M_erase(std::_Rb_tree_node<llvm::BasicBlock const*>*)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm10BasicBlockES4_ES5_St9_IdentityIS5_ESt4lessIS5_ESaIS5_EE5eraseESt17_Rb_tree_iteratorIS5_ESD_", "std::_Rb_tree<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, std::_Identity<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> > >::erase(std::_Rb_tree_iterator<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::_Rb_tree_iterator<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm10BasicBlockES3_St9_IdentityIS3_ESt4lessIS3_ESaIS3_EE5eraseESt17_Rb_tree_iteratorIS3_ESB_", "std::_Rb_tree<llvm::BasicBlock const*, llvm::BasicBlock const*, std::_Identity<llvm::BasicBlock const*>, std::less<llvm::BasicBlock const*>, std::allocator<llvm::BasicBlock const*> >::erase(std::_Rb_tree_iterator<llvm::BasicBlock const*>, std::_Rb_tree_iterator<llvm::BasicBlock const*>)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm8FunctionESt4pairIKS3_dESt10_Select1stIS6_ESt4lessIS3_ESaIS6_EE5eraseESt17_Rb_tree_iteratorIS6_ESE_", "std::_Rb_tree<llvm::Function const*, std::pair<llvm::Function const* const, double>, std::_Select1st<std::pair<llvm::Function const* const, double> >, std::less<llvm::Function const*>, std::allocator<std::pair<llvm::Function const* const, double> > >::erase(std::_Rb_tree_iterator<std::pair<llvm::Function const* const, double> >, std::_Rb_tree_iterator<std::pair<llvm::Function const* const, double> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm8FunctionESt4pairIKS3_dESt10_Select1stIS6_ESt4lessIS3_ESaIS6_EE8_M_eraseEPSt13_Rb_tree_nodeIS6_E", "std::_Rb_tree<llvm::Function const*, std::pair<llvm::Function const* const, double>, std::_Select1st<std::pair<llvm::Function const* const, double> >, std::less<llvm::Function const*>, std::allocator<std::pair<llvm::Function const* const, double> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::Function const* const, double> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm8FunctionESt4pairIKS3_St3mapIPKNS0_10BasicBlockEdSt4lessIS9_ESaIS4_IKS9_dEEEESt10_Select1stISG_ESA_IS3_ESaISG_EE5eraseESt17_Rb_tree_iteratorISG_ESN_", "std::_Rb_tree<llvm::Function const*, std::pair<llvm::Function const* const, std::map<llvm::BasicBlock const*, double, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, double> > > >, std::_Select1st<std::pair<llvm::Function const* const, std::map<llvm::BasicBlock const*, double, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, double> > > > >, std::less<llvm::Function const*>, std::allocator<std::pair<llvm::Function const* const, std::map<llvm::BasicBlock const*, double, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, double> > > > > >::erase(std::_Rb_tree_iterator<std::pair<llvm::Function const* const, std::map<llvm::BasicBlock const*, double, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, double> > > > >, std::_Rb_tree_iterator<std::pair<llvm::Function const* const, std::map<llvm::BasicBlock const*, double, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, double> > > > >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm10BasicBlockESt4pairIKS3_dESt10_Select1stIS6_ESt4lessIS3_ESaIS6_EE8_M_eraseEPSt13_Rb_tree_nodeIS6_E", "std::_Rb_tree<llvm::BasicBlock const*, std::pair<llvm::BasicBlock const* const, double>, std::_Select1st<std::pair<llvm::BasicBlock const* const, double> >, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, double> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::BasicBlock const* const, double> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm8FunctionESt4pairIKS3_St3mapIPKNS0_10BasicBlockEdSt4lessIS9_ESaIS4_IKS9_dEEEESt10_Select1stISG_ESA_IS3_ESaISG_EE8_M_eraseEPSt13_Rb_tree_nodeISG_E", "std::_Rb_tree<llvm::Function const*, std::pair<llvm::Function const* const, std::map<llvm::BasicBlock const*, double, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, double> > > >, std::_Select1st<std::pair<llvm::Function const* const, std::map<llvm::BasicBlock const*, double, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, double> > > > >, std::less<llvm::Function const*>, std::allocator<std::pair<llvm::Function const* const, std::map<llvm::BasicBlock const*, double, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, double> > > > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::Function const* const, std::map<llvm::BasicBlock const*, double, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, double> > > > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm8FunctionESt4pairIKS3_St3mapIS4_IPKNS0_10BasicBlockES9_EdSt4lessISA_ESaIS4_IKSA_dEEEESt10_Select1stISH_ESB_IS3_ESaISH_EE5eraseESt17_Rb_tree_iteratorISH_ESO_", "std::_Rb_tree<llvm::Function const*, std::pair<llvm::Function const* const, std::map<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, double, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > > >, std::_Select1st<std::pair<llvm::Function const* const, std::map<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, double, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > > > >, std::less<llvm::Function const*>, std::allocator<std::pair<llvm::Function const* const, std::map<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, double, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > > > > >::erase(std::_Rb_tree_iterator<std::pair<llvm::Function const* const, std::map<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, double, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > > > >, std::_Rb_tree_iterator<std::pair<llvm::Function const* const, std::map<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, double, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > > > >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm8FunctionESt4pairIKS3_St3mapIS4_IPKNS0_10BasicBlockES9_EdSt4lessISA_ESaIS4_IKSA_dEEEESt10_Select1stISH_ESB_IS3_ESaISH_EE8_M_eraseEPSt13_Rb_tree_nodeISH_E", "std::_Rb_tree<llvm::Function const*, std::pair<llvm::Function const* const, std::map<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, double, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > > >, std::_Select1st<std::pair<llvm::Function const* const, std::map<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, double, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > > > >, std::less<llvm::Function const*>, std::allocator<std::pair<llvm::Function const* const, std::map<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, double, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > > > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::Function const* const, std::map<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, double, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > > > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm10BasicBlockES4_ES0_IKS5_dESt10_Select1stIS7_ESt4lessIS5_ESaIS7_EE8_M_eraseEPSt13_Rb_tree_nodeIS7_E", "std::_Rb_tree<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double>, std::_Select1st<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> >, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > >::_M_erase(std::_Rb_tree_node<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm10BasicBlockESt4pairIKS3_S3_ESt10_Select1stIS6_ESt4lessIS3_ESaIS6_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS6_ERKS6_", "std::_Rb_tree<llvm::BasicBlock const*, std::pair<llvm::BasicBlock const* const, llvm::BasicBlock const*>, std::_Select1st<std::pair<llvm::BasicBlock const* const, llvm::BasicBlock const*> >, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::BasicBlock const*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::BasicBlock const* const, llvm::BasicBlock const*> >, std::pair<llvm::BasicBlock const* const, llvm::BasicBlock const*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm10BasicBlockESt4pairIKS3_S3_ESt10_Select1stIS6_ESt4lessIS3_ESaIS6_EE16_M_insert_uniqueERKS6_", "std::_Rb_tree<llvm::BasicBlock const*, std::pair<llvm::BasicBlock const* const, llvm::BasicBlock const*>, std::_Select1st<std::pair<llvm::BasicBlock const* const, llvm::BasicBlock const*> >, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::BasicBlock const*> > >::_M_insert_unique(std::pair<llvm::BasicBlock const* const, llvm::BasicBlock const*> const&)"),
	mu_demangle_test("_ZNSt5dequeIPKN4llvm10BasicBlockESaIS3_EE9push_backERKS3_", "std::deque<llvm::BasicBlock const*, std::allocator<llvm::BasicBlock const*> >::push_back(llvm::BasicBlock const* const&)"),
	mu_demangle_test("_ZNSt5dequeIPKN4llvm10BasicBlockESaIS3_EE17_M_reallocate_mapEmb", "std::deque<llvm::BasicBlock const*, std::allocator<llvm::BasicBlock const*> >::_M_reallocate_map(unsigned long, bool)"),
	mu_demangle_test("_ZNSt11_Deque_baseIPKN4llvm10BasicBlockESaIS3_EE17_M_initialize_mapEm", "std::_Deque_base<llvm::BasicBlock const*, std::allocator<llvm::BasicBlock const*> >::_M_initialize_map(unsigned long)"),
	mu_demangle_test("_ZNSt5dequeIPKN4llvm10BasicBlockESaIS3_EEC2ERKS5_", "std::deque<llvm::BasicBlock const*, std::allocator<llvm::BasicBlock const*> >::deque(std::deque<llvm::BasicBlock const*, std::allocator<llvm::BasicBlock const*> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm10BasicBlockES4_ES0_IKS5_dESt10_Select1stIS7_ESt4lessIS5_ESaIS7_EE5eraseESt17_Rb_tree_iteratorIS7_ESF_", "std::_Rb_tree<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double>, std::_Select1st<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> >, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > >::erase(std::_Rb_tree_iterator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> >, std::_Rb_tree_iterator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm10BasicBlockESt4pairIKS3_dESt10_Select1stIS6_ESt4lessIS3_ESaIS6_EE5eraseESt17_Rb_tree_iteratorIS6_ESE_", "std::_Rb_tree<llvm::BasicBlock const*, std::pair<llvm::BasicBlock const* const, double>, std::_Select1st<std::pair<llvm::BasicBlock const* const, double> >, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, double> > >::erase(std::_Rb_tree_iterator<std::pair<llvm::BasicBlock const* const, double> >, std::_Rb_tree_iterator<std::pair<llvm::BasicBlock const* const, double> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm10BasicBlockES4_ES0_IKS5_dESt10_Select1stIS7_ESt4lessIS5_ESaIS7_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS7_ERKS7_", "std::_Rb_tree<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double>, std::_Select1st<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> >, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> >, std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm10BasicBlockES4_ES0_IKS5_dESt10_Select1stIS7_ESt4lessIS5_ESaIS7_EE16_M_insert_uniqueERKS7_", "std::_Rb_tree<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double>, std::_Select1st<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> >, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > >::_M_insert_unique(std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm8FunctionESt4pairIKS3_St3mapIS4_IPKNS0_10BasicBlockES9_EdSt4lessISA_ESaIS4_IKSA_dEEEESt10_Select1stISH_ESB_IS3_ESaISH_EE16_M_insert_uniqueESt17_Rb_tree_iteratorISH_ERKSH_", "std::_Rb_tree<llvm::Function const*, std::pair<llvm::Function const* const, std::map<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, double, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > > >, std::_Select1st<std::pair<llvm::Function const* const, std::map<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, double, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > > > >, std::less<llvm::Function const*>, std::allocator<std::pair<llvm::Function const* const, std::map<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, double, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > > > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::Function const* const, std::map<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, double, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > > > >, std::pair<llvm::Function const* const, std::map<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, double, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm8FunctionESt4pairIKS3_St3mapIS4_IPKNS0_10BasicBlockES9_EdSt4lessISA_ESaIS4_IKSA_dEEEESt10_Select1stISH_ESB_IS3_ESaISH_EE9_M_insertEPSt18_Rb_tree_node_baseSO_RKSH_", "std::_Rb_tree<llvm::Function const*, std::pair<llvm::Function const* const, std::map<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, double, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > > >, std::_Select1st<std::pair<llvm::Function const* const, std::map<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, double, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > > > >, std::less<llvm::Function const*>, std::allocator<std::pair<llvm::Function const* const, std::map<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, double, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > > > > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<llvm::Function const* const, std::map<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, double, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm8FunctionESt4pairIKS3_St3mapIS4_IPKNS0_10BasicBlockES9_EdSt4lessISA_ESaIS4_IKSA_dEEEESt10_Select1stISH_ESB_IS3_ESaISH_EE16_M_insert_uniqueERKSH_", "std::_Rb_tree<llvm::Function const*, std::pair<llvm::Function const* const, std::map<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, double, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > > >, std::_Select1st<std::pair<llvm::Function const* const, std::map<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, double, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > > > >, std::less<llvm::Function const*>, std::allocator<std::pair<llvm::Function const* const, std::map<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, double, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > > > > >::_M_insert_unique(std::pair<llvm::Function const* const, std::map<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*>, double, std::less<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::BasicBlock const*, llvm::BasicBlock const*> const, double> > > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm17MachineBasicBlockESt4pairIKS3_dESt10_Select1stIS6_ESt4lessIS3_ESaIS6_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS6_ERKS6_", "std::_Rb_tree<llvm::MachineBasicBlock const*, std::pair<llvm::MachineBasicBlock const* const, double>, std::_Select1st<std::pair<llvm::MachineBasicBlock const* const, double> >, std::less<llvm::MachineBasicBlock const*>, std::allocator<std::pair<llvm::MachineBasicBlock const* const, double> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::MachineBasicBlock const* const, double> >, std::pair<llvm::MachineBasicBlock const* const, double> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm17MachineBasicBlockESt4pairIKS3_dESt10_Select1stIS6_ESt4lessIS3_ESaIS6_EE16_M_insert_uniqueERKS6_", "std::_Rb_tree<llvm::MachineBasicBlock const*, std::pair<llvm::MachineBasicBlock const* const, double>, std::_Select1st<std::pair<llvm::MachineBasicBlock const* const, double> >, std::less<llvm::MachineBasicBlock const*>, std::allocator<std::pair<llvm::MachineBasicBlock const* const, double> > >::_M_insert_unique(std::pair<llvm::MachineBasicBlock const* const, double> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm17MachineBasicBlockESt4pairIKS3_dESt10_Select1stIS6_ESt4lessIS3_ESaIS6_EE8_M_eraseEPSt13_Rb_tree_nodeIS6_E", "std::_Rb_tree<llvm::MachineBasicBlock const*, std::pair<llvm::MachineBasicBlock const* const, double>, std::_Select1st<std::pair<llvm::MachineBasicBlock const* const, double> >, std::less<llvm::MachineBasicBlock const*>, std::allocator<std::pair<llvm::MachineBasicBlock const* const, double> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::MachineBasicBlock const* const, double> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm17MachineBasicBlockESt4pairIKS3_dESt10_Select1stIS6_ESt4lessIS3_ESaIS6_EE7_M_copyEPKSt13_Rb_tree_nodeIS6_EPSE_", "std::_Rb_tree<llvm::MachineBasicBlock const*, std::pair<llvm::MachineBasicBlock const* const, double>, std::_Select1st<std::pair<llvm::MachineBasicBlock const* const, double> >, std::less<llvm::MachineBasicBlock const*>, std::allocator<std::pair<llvm::MachineBasicBlock const* const, double> > >::_M_copy(std::_Rb_tree_node<std::pair<llvm::MachineBasicBlock const* const, double> > const*, std::_Rb_tree_node<std::pair<llvm::MachineBasicBlock const* const, double> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm15MachineFunctionESt4pairIKS3_St3mapIPKNS0_17MachineBasicBlockEdSt4lessIS9_ESaIS4_IKS9_dEEEESt10_Select1stISG_ESA_IS3_ESaISG_EE16_M_insert_uniqueESt17_Rb_tree_iteratorISG_ERKSG_", "std::_Rb_tree<llvm::MachineFunction const*, std::pair<llvm::MachineFunction const* const, std::map<llvm::MachineBasicBlock const*, double, std::less<llvm::MachineBasicBlock const*>, std::allocator<std::pair<llvm::MachineBasicBlock const* const, double> > > >, std::_Select1st<std::pair<llvm::MachineFunction const* const, std::map<llvm::MachineBasicBlock const*, double, std::less<llvm::MachineBasicBlock const*>, std::allocator<std::pair<llvm::MachineBasicBlock const* const, double> > > > >, std::less<llvm::MachineFunction const*>, std::allocator<std::pair<llvm::MachineFunction const* const, std::map<llvm::MachineBasicBlock const*, double, std::less<llvm::MachineBasicBlock const*>, std::allocator<std::pair<llvm::MachineBasicBlock const* const, double> > > > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::MachineFunction const* const, std::map<llvm::MachineBasicBlock const*, double, std::less<llvm::MachineBasicBlock const*>, std::allocator<std::pair<llvm::MachineBasicBlock const* const, double> > > > >, std::pair<llvm::MachineFunction const* const, std::map<llvm::MachineBasicBlock const*, double, std::less<llvm::MachineBasicBlock const*>, std::allocator<std::pair<llvm::MachineBasicBlock const* const, double> > > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm15MachineFunctionESt4pairIKS3_St3mapIPKNS0_17MachineBasicBlockEdSt4lessIS9_ESaIS4_IKS9_dEEEESt10_Select1stISG_ESA_IS3_ESaISG_EE9_M_insertEPSt18_Rb_tree_node_baseSN_RKSG_", "std::_Rb_tree<llvm::MachineFunction const*, std::pair<llvm::MachineFunction const* const, std::map<llvm::MachineBasicBlock const*, double, std::less<llvm::MachineBasicBlock const*>, std::allocator<std::pair<llvm::MachineBasicBlock const* const, double> > > >, std::_Select1st<std::pair<llvm::MachineFunction const* const, std::map<llvm::MachineBasicBlock const*, double, std::less<llvm::MachineBasicBlock const*>, std::allocator<std::pair<llvm::MachineBasicBlock const* const, double> > > > >, std::less<llvm::MachineFunction const*>, std::allocator<std::pair<llvm::MachineFunction const* const, std::map<llvm::MachineBasicBlock const*, double, std::less<llvm::MachineBasicBlock const*>, std::allocator<std::pair<llvm::MachineBasicBlock const* const, double> > > > > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<llvm::MachineFunction const* const, std::map<llvm::MachineBasicBlock const*, double, std::less<llvm::MachineBasicBlock const*>, std::allocator<std::pair<llvm::MachineBasicBlock const* const, double> > > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm15MachineFunctionESt4pairIKS3_St3mapIPKNS0_17MachineBasicBlockEdSt4lessIS9_ESaIS4_IKS9_dEEEESt10_Select1stISG_ESA_IS3_ESaISG_EE16_M_insert_uniqueERKSG_", "std::_Rb_tree<llvm::MachineFunction const*, std::pair<llvm::MachineFunction const* const, std::map<llvm::MachineBasicBlock const*, double, std::less<llvm::MachineBasicBlock const*>, std::allocator<std::pair<llvm::MachineBasicBlock const* const, double> > > >, std::_Select1st<std::pair<llvm::MachineFunction const* const, std::map<llvm::MachineBasicBlock const*, double, std::less<llvm::MachineBasicBlock const*>, std::allocator<std::pair<llvm::MachineBasicBlock const* const, double> > > > >, std::less<llvm::MachineFunction const*>, std::allocator<std::pair<llvm::MachineFunction const* const, std::map<llvm::MachineBasicBlock const*, double, std::less<llvm::MachineBasicBlock const*>, std::allocator<std::pair<llvm::MachineBasicBlock const* const, double> > > > > >::_M_insert_unique(std::pair<llvm::MachineFunction const* const, std::map<llvm::MachineBasicBlock const*, double, std::less<llvm::MachineBasicBlock const*>, std::allocator<std::pair<llvm::MachineBasicBlock const* const, double> > > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm15MachineFunctionESt4pairIKS3_dESt10_Select1stIS6_ESt4lessIS3_ESaIS6_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS6_ERKS6_", "std::_Rb_tree<llvm::MachineFunction const*, std::pair<llvm::MachineFunction const* const, double>, std::_Select1st<std::pair<llvm::MachineFunction const* const, double> >, std::less<llvm::MachineFunction const*>, std::allocator<std::pair<llvm::MachineFunction const* const, double> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::MachineFunction const* const, double> >, std::pair<llvm::MachineFunction const* const, double> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm15MachineFunctionESt4pairIKS3_dESt10_Select1stIS6_ESt4lessIS3_ESaIS6_EE16_M_insert_uniqueERKS6_", "std::_Rb_tree<llvm::MachineFunction const*, std::pair<llvm::MachineFunction const* const, double>, std::_Select1st<std::pair<llvm::MachineFunction const* const, double> >, std::less<llvm::MachineFunction const*>, std::allocator<std::pair<llvm::MachineFunction const* const, double> > >::_M_insert_unique(std::pair<llvm::MachineFunction const* const, double> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm8FunctionESt4pairIKS3_dESt10_Select1stIS6_ESt4lessIS3_ESaIS6_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS6_ERKS6_", "std::_Rb_tree<llvm::Function const*, std::pair<llvm::Function const* const, double>, std::_Select1st<std::pair<llvm::Function const* const, double> >, std::less<llvm::Function const*>, std::allocator<std::pair<llvm::Function const* const, double> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::Function const* const, double> >, std::pair<llvm::Function const* const, double> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm8FunctionESt4pairIKS3_dESt10_Select1stIS6_ESt4lessIS3_ESaIS6_EE16_M_insert_uniqueERKS6_", "std::_Rb_tree<llvm::Function const*, std::pair<llvm::Function const* const, double>, std::_Select1st<std::pair<llvm::Function const* const, double> >, std::less<llvm::Function const*>, std::allocator<std::pair<llvm::Function const* const, double> > >::_M_insert_unique(std::pair<llvm::Function const* const, double> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm10BasicBlockESt4pairIKS3_dESt10_Select1stIS6_ESt4lessIS3_ESaIS6_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS6_ERKS6_", "std::_Rb_tree<llvm::BasicBlock const*, std::pair<llvm::BasicBlock const* const, double>, std::_Select1st<std::pair<llvm::BasicBlock const* const, double> >, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, double> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::BasicBlock const* const, double> >, std::pair<llvm::BasicBlock const* const, double> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm10BasicBlockESt4pairIKS3_dESt10_Select1stIS6_ESt4lessIS3_ESaIS6_EE16_M_insert_uniqueERKS6_", "std::_Rb_tree<llvm::BasicBlock const*, std::pair<llvm::BasicBlock const* const, double>, std::_Select1st<std::pair<llvm::BasicBlock const* const, double> >, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, double> > >::_M_insert_unique(std::pair<llvm::BasicBlock const* const, double> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm10BasicBlockESt4pairIKS3_dESt10_Select1stIS6_ESt4lessIS3_ESaIS6_EE7_M_copyEPKSt13_Rb_tree_nodeIS6_EPSE_", "std::_Rb_tree<llvm::BasicBlock const*, std::pair<llvm::BasicBlock const* const, double>, std::_Select1st<std::pair<llvm::BasicBlock const* const, double> >, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, double> > >::_M_copy(std::_Rb_tree_node<std::pair<llvm::BasicBlock const* const, double> > const*, std::_Rb_tree_node<std::pair<llvm::BasicBlock const* const, double> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm8FunctionESt4pairIKS3_St3mapIPKNS0_10BasicBlockEdSt4lessIS9_ESaIS4_IKS9_dEEEESt10_Select1stISG_ESA_IS3_ESaISG_EE16_M_insert_uniqueESt17_Rb_tree_iteratorISG_ERKSG_", "std::_Rb_tree<llvm::Function const*, std::pair<llvm::Function const* const, std::map<llvm::BasicBlock const*, double, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, double> > > >, std::_Select1st<std::pair<llvm::Function const* const, std::map<llvm::BasicBlock const*, double, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, double> > > > >, std::less<llvm::Function const*>, std::allocator<std::pair<llvm::Function const* const, std::map<llvm::BasicBlock const*, double, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, double> > > > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::Function const* const, std::map<llvm::BasicBlock const*, double, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, double> > > > >, std::pair<llvm::Function const* const, std::map<llvm::BasicBlock const*, double, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, double> > > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm8FunctionESt4pairIKS3_St3mapIPKNS0_10BasicBlockEdSt4lessIS9_ESaIS4_IKS9_dEEEESt10_Select1stISG_ESA_IS3_ESaISG_EE9_M_insertEPSt18_Rb_tree_node_baseSN_RKSG_", "std::_Rb_tree<llvm::Function const*, std::pair<llvm::Function const* const, std::map<llvm::BasicBlock const*, double, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, double> > > >, std::_Select1st<std::pair<llvm::Function const* const, std::map<llvm::BasicBlock const*, double, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, double> > > > >, std::less<llvm::Function const*>, std::allocator<std::pair<llvm::Function const* const, std::map<llvm::BasicBlock const*, double, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, double> > > > > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<llvm::Function const* const, std::map<llvm::BasicBlock const*, double, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, double> > > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm8FunctionESt4pairIKS3_St3mapIPKNS0_10BasicBlockEdSt4lessIS9_ESaIS4_IKS9_dEEEESt10_Select1stISG_ESA_IS3_ESaISG_EE16_M_insert_uniqueERKSG_", "std::_Rb_tree<llvm::Function const*, std::pair<llvm::Function const* const, std::map<llvm::BasicBlock const*, double, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, double> > > >, std::_Select1st<std::pair<llvm::Function const* const, std::map<llvm::BasicBlock const*, double, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, double> > > > >, std::less<llvm::Function const*>, std::allocator<std::pair<llvm::Function const* const, std::map<llvm::BasicBlock const*, double, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, double> > > > > >::_M_insert_unique(std::pair<llvm::Function const* const, std::map<llvm::BasicBlock const*, double, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, double> > > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm10BasicBlockES3_St9_IdentityIS3_ESt4lessIS3_ESaIS3_EE16_M_insert_uniqueERKS3_", "std::_Rb_tree<llvm::BasicBlock const*, llvm::BasicBlock const*, std::_Identity<llvm::BasicBlock const*>, std::less<llvm::BasicBlock const*>, std::allocator<llvm::BasicBlock const*> >::_M_insert_unique(llvm::BasicBlock const* const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm10BasicBlockESt4pairIKS3_S3_ESt10_Select1stIS6_ESt4lessIS3_ESaIS6_EE8_M_eraseEPSt13_Rb_tree_nodeIS6_E", "std::_Rb_tree<llvm::BasicBlock const*, std::pair<llvm::BasicBlock const* const, llvm::BasicBlock const*>, std::_Select1st<std::pair<llvm::BasicBlock const* const, llvm::BasicBlock const*> >, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::BasicBlock const*> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::BasicBlock const* const, llvm::BasicBlock const*> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm15MachineFunctionESt4pairIKS3_St3mapIS4_IPKNS0_17MachineBasicBlockES9_EdSt4lessISA_ESaIS4_IKSA_dEEEESt10_Select1stISH_ESB_IS3_ESaISH_EE8_M_eraseEPSt13_Rb_tree_nodeISH_E", "std::_Rb_tree<llvm::MachineFunction const*, std::pair<llvm::MachineFunction const* const, std::map<std::pair<llvm::MachineBasicBlock const*, llvm::MachineBasicBlock const*>, double, std::less<std::pair<llvm::MachineBasicBlock const*, llvm::MachineBasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::MachineBasicBlock const*, llvm::MachineBasicBlock const*> const, double> > > >, std::_Select1st<std::pair<llvm::MachineFunction const* const, std::map<std::pair<llvm::MachineBasicBlock const*, llvm::MachineBasicBlock const*>, double, std::less<std::pair<llvm::MachineBasicBlock const*, llvm::MachineBasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::MachineBasicBlock const*, llvm::MachineBasicBlock const*> const, double> > > > >, std::less<llvm::MachineFunction const*>, std::allocator<std::pair<llvm::MachineFunction const* const, std::map<std::pair<llvm::MachineBasicBlock const*, llvm::MachineBasicBlock const*>, double, std::less<std::pair<llvm::MachineBasicBlock const*, llvm::MachineBasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::MachineBasicBlock const*, llvm::MachineBasicBlock const*> const, double> > > > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::MachineFunction const* const, std::map<std::pair<llvm::MachineBasicBlock const*, llvm::MachineBasicBlock const*>, double, std::less<std::pair<llvm::MachineBasicBlock const*, llvm::MachineBasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::MachineBasicBlock const*, llvm::MachineBasicBlock const*> const, double> > > > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm17MachineBasicBlockES4_ES0_IKS5_dESt10_Select1stIS7_ESt4lessIS5_ESaIS7_EE8_M_eraseEPSt13_Rb_tree_nodeIS7_E", "std::_Rb_tree<std::pair<llvm::MachineBasicBlock const*, llvm::MachineBasicBlock const*>, std::pair<std::pair<llvm::MachineBasicBlock const*, llvm::MachineBasicBlock const*> const, double>, std::_Select1st<std::pair<std::pair<llvm::MachineBasicBlock const*, llvm::MachineBasicBlock const*> const, double> >, std::less<std::pair<llvm::MachineBasicBlock const*, llvm::MachineBasicBlock const*> >, std::allocator<std::pair<std::pair<llvm::MachineBasicBlock const*, llvm::MachineBasicBlock const*> const, double> > >::_M_erase(std::_Rb_tree_node<std::pair<std::pair<llvm::MachineBasicBlock const*, llvm::MachineBasicBlock const*> const, double> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm15MachineFunctionESt4pairIKS3_St3mapIPKNS0_17MachineBasicBlockEdSt4lessIS9_ESaIS4_IKS9_dEEEESt10_Select1stISG_ESA_IS3_ESaISG_EE8_M_eraseEPSt13_Rb_tree_nodeISG_E", "std::_Rb_tree<llvm::MachineFunction const*, std::pair<llvm::MachineFunction const* const, std::map<llvm::MachineBasicBlock const*, double, std::less<llvm::MachineBasicBlock const*>, std::allocator<std::pair<llvm::MachineBasicBlock const* const, double> > > >, std::_Select1st<std::pair<llvm::MachineFunction const* const, std::map<llvm::MachineBasicBlock const*, double, std::less<llvm::MachineBasicBlock const*>, std::allocator<std::pair<llvm::MachineBasicBlock const* const, double> > > > >, std::less<llvm::MachineFunction const*>, std::allocator<std::pair<llvm::MachineFunction const* const, std::map<llvm::MachineBasicBlock const*, double, std::less<llvm::MachineBasicBlock const*>, std::allocator<std::pair<llvm::MachineBasicBlock const* const, double> > > > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::MachineFunction const* const, std::map<llvm::MachineBasicBlock const*, double, std::less<llvm::MachineBasicBlock const*>, std::allocator<std::pair<llvm::MachineBasicBlock const* const, double> > > > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm15MachineFunctionESt4pairIKS3_dESt10_Select1stIS6_ESt4lessIS3_ESaIS6_EE8_M_eraseEPSt13_Rb_tree_nodeIS6_E", "std::_Rb_tree<llvm::MachineFunction const*, std::pair<llvm::MachineFunction const* const, double>, std::_Select1st<std::pair<llvm::MachineFunction const* const, double> >, std::less<llvm::MachineFunction const*>, std::allocator<std::pair<llvm::MachineFunction const* const, double> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::MachineFunction const* const, double> >*)"),
	mu_demangle_test("_Z28CollectAddOperandsWithScalesRN4llvm8DenseMapIPKNS_4SCEVENS_5APIntENS_12DenseMapInfoIS3_EENS5_IS4_EEEERNS_11SmallVectorIS3_Lj8EEERS4_PKS3_mRKS4_RNS_15ScalarEvolutionE", "CollectAddOperandsWithScales(llvm::DenseMap<llvm::SCEV const*, llvm::APInt, llvm::DenseMapInfo<llvm::SCEV const*>, llvm::DenseMapInfo<llvm::APInt> >&, llvm::SmallVector<llvm::SCEV const*, 8u>&, llvm::APInt&, llvm::SCEV const* const*, unsigned long, llvm::APInt const&, llvm::ScalarEvolution&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm5APIntESt4pairIKS1_NS0_11SmallVectorIPKNS0_4SCEVELj4EEEESt10_Select1stIS9_EN12_GLOBAL__N_112APIntCompareESaIS9_EE9_M_insertEPSt18_Rb_tree_node_baseSH_RKS9_", "std::_Rb_tree<llvm::APInt, std::pair<llvm::APInt const, llvm::SmallVector<llvm::SCEV const*, 4u> >, std::_Select1st<std::pair<llvm::APInt const, llvm::SmallVector<llvm::SCEV const*, 4u> > >, (anonymous namespace)::APIntCompare, std::allocator<std::pair<llvm::APInt const, llvm::SmallVector<llvm::SCEV const*, 4u> > > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<llvm::APInt const, llvm::SmallVector<llvm::SCEV const*, 4u> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm5APIntESt4pairIKS1_NS0_11SmallVectorIPKNS0_4SCEVELj4EEEESt10_Select1stIS9_EN12_GLOBAL__N_112APIntCompareESaIS9_EE16_M_insert_uniqueERKS9_", "std::_Rb_tree<llvm::APInt, std::pair<llvm::APInt const, llvm::SmallVector<llvm::SCEV const*, 4u> >, std::_Select1st<std::pair<llvm::APInt const, llvm::SmallVector<llvm::SCEV const*, 4u> > >, (anonymous namespace)::APIntCompare, std::allocator<std::pair<llvm::APInt const, llvm::SmallVector<llvm::SCEV const*, 4u> > > >::_M_insert_unique(std::pair<llvm::APInt const, llvm::SmallVector<llvm::SCEV const*, 4u> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm5APIntESt4pairIKS1_NS0_11SmallVectorIPKNS0_4SCEVELj4EEEESt10_Select1stIS9_EN12_GLOBAL__N_112APIntCompareESaIS9_EE8_M_eraseEPSt13_Rb_tree_nodeIS9_E", "std::_Rb_tree<llvm::APInt, std::pair<llvm::APInt const, llvm::SmallVector<llvm::SCEV const*, 4u> >, std::_Select1st<std::pair<llvm::APInt const, llvm::SmallVector<llvm::SCEV const*, 4u> > >, (anonymous namespace)::APIntCompare, std::allocator<std::pair<llvm::APInt const, llvm::SmallVector<llvm::SCEV const*, 4u> > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::APInt const, llvm::SmallVector<llvm::SCEV const*, 4u> > >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_15ScalarEvolution14SCEVCallbackVHEPKNS_4SCEVENS_12DenseMapInfoIPNS_5ValueEEENS6_IS5_EEE4findERKS2_", "llvm::DenseMap<llvm::ScalarEvolution::SCEVCallbackVH, llvm::SCEV const*, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<llvm::SCEV const*> >::find(llvm::ScalarEvolution::SCEVCallbackVH const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_15ScalarEvolution14SCEVCallbackVHEPKNS_4SCEVENS_12DenseMapInfoIPNS_5ValueEEENS6_IS5_EEE6insertERKSt4pairIS2_S5_E", "llvm::DenseMap<llvm::ScalarEvolution::SCEVCallbackVH, llvm::SCEV const*, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<llvm::SCEV const*> >::insert(std::pair<llvm::ScalarEvolution::SCEVCallbackVH, llvm::SCEV const*> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_15ScalarEvolution14SCEVCallbackVHEPKNS_4SCEVENS_12DenseMapInfoIPNS_5ValueEEENS6_IS5_EEE5eraseENS_16DenseMapIteratorIS2_S5_S9_SA_Lb0EEE", "llvm::DenseMap<llvm::ScalarEvolution::SCEVCallbackVH, llvm::SCEV const*, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<llvm::SCEV const*> >::erase(llvm::DenseMapIterator<llvm::ScalarEvolution::SCEVCallbackVH, llvm::SCEV const*, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<llvm::SCEV const*>, false>)"),
	mu_demangle_test("_ZNSt3mapIPKN4llvm4SCEVES_IPKNS0_4LoopES3_St4lessIS6_ESaISt4pairIKS6_S3_EEES7_IS3_ESaIS9_IKS3_SD_EEEixERSF_", "std::map<llvm::SCEV const*, std::map<llvm::Loop const*, llvm::SCEV const*, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::SCEV const*> > >, std::less<llvm::SCEV const*>, std::allocator<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::SCEV const*, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::SCEV const*> > > > > >::operator[](llvm::SCEV const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_15ScalarEvolution14SCEVCallbackVHEPKNS_4SCEVENS_12DenseMapInfoIPNS_5ValueEEENS6_IS5_EEE5eraseERKS2_", "llvm::DenseMap<llvm::ScalarEvolution::SCEVCallbackVH, llvm::SCEV const*, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<llvm::SCEV const*> >::erase(llvm::ScalarEvolution::SCEVCallbackVH const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_15ScalarEvolution14SCEVCallbackVHEPKNS_4SCEVENS_12DenseMapInfoIPNS_5ValueEEENS6_IS5_EEE5clearEv", "llvm::DenseMap<llvm::ScalarEvolution::SCEVCallbackVH, llvm::SCEV const*, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<llvm::SCEV const*> >::clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4SCEVENS_13ConstantRangeENS_12DenseMapInfoIS3_EENS5_IS4_EEE5clearEv", "llvm::DenseMap<llvm::SCEV const*, llvm::ConstantRange, llvm::DenseMapInfo<llvm::SCEV const*>, llvm::DenseMapInfo<llvm::ConstantRange> >::clear()"),
	mu_demangle_test("_ZNSt3mapIPKN4llvm4SCEVES_IPKNS0_4LoopENS0_15ScalarEvolution15LoopDispositionESt4lessIS6_ESaISt4pairIKS6_S8_EEES9_IS3_ESaISB_IKS3_SF_EEEixERSH_", "std::map<llvm::SCEV const*, std::map<llvm::Loop const*, llvm::ScalarEvolution::LoopDisposition, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> > >, std::less<llvm::SCEV const*>, std::allocator<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::ScalarEvolution::LoopDisposition, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> > > > > >::operator[](llvm::SCEV const* const&)"),
	mu_demangle_test("_ZNSt3mapIPKN4llvm4SCEVES_IPKNS0_10BasicBlockENS0_15ScalarEvolution16BlockDispositionESt4lessIS6_ESaISt4pairIKS6_S8_EEES9_IS3_ESaISB_IKS3_SF_EEEixERSH_", "std::map<llvm::SCEV const*, std::map<llvm::BasicBlock const*, llvm::ScalarEvolution::BlockDisposition, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> > >, std::less<llvm::SCEV const*>, std::allocator<std::pair<llvm::SCEV const* const, std::map<llvm::BasicBlock const*, llvm::ScalarEvolution::BlockDisposition, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> > > > > >::operator[](llvm::SCEV const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4SCEVENS_13ConstantRangeENS_12DenseMapInfoIS3_EENS5_IS4_EEE5eraseERKS3_", "llvm::DenseMap<llvm::SCEV const*, llvm::ConstantRange, llvm::DenseMapInfo<llvm::SCEV const*>, llvm::DenseMapInfo<llvm::ConstantRange> >::erase(llvm::SCEV const* const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4SCEVESt4pairIKS3_St3mapIPKNS0_10BasicBlockENS0_15ScalarEvolution16BlockDispositionESt4lessIS9_ESaIS4_IKS9_SB_EEEESt10_Select1stISI_ESC_IS3_ESaISI_EE5eraseESt17_Rb_tree_iteratorISI_ESP_", "std::_Rb_tree<llvm::SCEV const*, std::pair<llvm::SCEV const* const, std::map<llvm::BasicBlock const*, llvm::ScalarEvolution::BlockDisposition, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> > > >, std::_Select1st<std::pair<llvm::SCEV const* const, std::map<llvm::BasicBlock const*, llvm::ScalarEvolution::BlockDisposition, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> > > > >, std::less<llvm::SCEV const*>, std::allocator<std::pair<llvm::SCEV const* const, std::map<llvm::BasicBlock const*, llvm::ScalarEvolution::BlockDisposition, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> > > > > >::erase(std::_Rb_tree_iterator<std::pair<llvm::SCEV const* const, std::map<llvm::BasicBlock const*, llvm::ScalarEvolution::BlockDisposition, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> > > > >, std::_Rb_tree_iterator<std::pair<llvm::SCEV const* const, std::map<llvm::BasicBlock const*, llvm::ScalarEvolution::BlockDisposition, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> > > > >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm10BasicBlockESt4pairIKS3_NS0_15ScalarEvolution16BlockDispositionEESt10_Select1stIS8_ESt4lessIS3_ESaIS8_EE8_M_eraseEPSt13_Rb_tree_nodeIS8_E", "std::_Rb_tree<llvm::BasicBlock const*, std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition>, std::_Select1st<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> >, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4SCEVESt4pairIKS3_St3mapIPKNS0_10BasicBlockENS0_15ScalarEvolution16BlockDispositionESt4lessIS9_ESaIS4_IKS9_SB_EEEESt10_Select1stISI_ESC_IS3_ESaISI_EE8_M_eraseEPSt13_Rb_tree_nodeISI_E", "std::_Rb_tree<llvm::SCEV const*, std::pair<llvm::SCEV const* const, std::map<llvm::BasicBlock const*, llvm::ScalarEvolution::BlockDisposition, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> > > >, std::_Select1st<std::pair<llvm::SCEV const* const, std::map<llvm::BasicBlock const*, llvm::ScalarEvolution::BlockDisposition, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> > > > >, std::less<llvm::SCEV const*>, std::allocator<std::pair<llvm::SCEV const* const, std::map<llvm::BasicBlock const*, llvm::ScalarEvolution::BlockDisposition, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> > > > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::SCEV const* const, std::map<llvm::BasicBlock const*, llvm::ScalarEvolution::BlockDisposition, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> > > > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4SCEVESt4pairIKS3_St3mapIPKNS0_4LoopENS0_15ScalarEvolution15LoopDispositionESt4lessIS9_ESaIS4_IKS9_SB_EEEESt10_Select1stISI_ESC_IS3_ESaISI_EE5eraseESt17_Rb_tree_iteratorISI_ESP_", "std::_Rb_tree<llvm::SCEV const*, std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::ScalarEvolution::LoopDisposition, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> > > >, std::_Select1st<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::ScalarEvolution::LoopDisposition, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> > > > >, std::less<llvm::SCEV const*>, std::allocator<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::ScalarEvolution::LoopDisposition, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> > > > > >::erase(std::_Rb_tree_iterator<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::ScalarEvolution::LoopDisposition, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> > > > >, std::_Rb_tree_iterator<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::ScalarEvolution::LoopDisposition, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> > > > >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4LoopESt4pairIKS3_NS0_15ScalarEvolution15LoopDispositionEESt10_Select1stIS8_ESt4lessIS3_ESaIS8_EE8_M_eraseEPSt13_Rb_tree_nodeIS8_E", "std::_Rb_tree<llvm::Loop const*, std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition>, std::_Select1st<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> >, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4SCEVESt4pairIKS3_St3mapIPKNS0_4LoopENS0_15ScalarEvolution15LoopDispositionESt4lessIS9_ESaIS4_IKS9_SB_EEEESt10_Select1stISI_ESC_IS3_ESaISI_EE8_M_eraseEPSt13_Rb_tree_nodeISI_E", "std::_Rb_tree<llvm::SCEV const*, std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::ScalarEvolution::LoopDisposition, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> > > >, std::_Select1st<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::ScalarEvolution::LoopDisposition, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> > > > >, std::less<llvm::SCEV const*>, std::allocator<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::ScalarEvolution::LoopDisposition, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> > > > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::ScalarEvolution::LoopDisposition, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> > > > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4SCEVESt4pairIKS3_St3mapIPKNS0_4LoopES3_St4lessIS9_ESaIS4_IKS9_S3_EEEESt10_Select1stISG_ESA_IS3_ESaISG_EE5eraseESt17_Rb_tree_iteratorISG_ESN_", "std::_Rb_tree<llvm::SCEV const*, std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::SCEV const*, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::SCEV const*> > > >, std::_Select1st<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::SCEV const*, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::SCEV const*> > > > >, std::less<llvm::SCEV const*>, std::allocator<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::SCEV const*, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::SCEV const*> > > > > >::erase(std::_Rb_tree_iterator<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::SCEV const*, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::SCEV const*> > > > >, std::_Rb_tree_iterator<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::SCEV const*, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::SCEV const*> > > > >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4LoopESt4pairIKS3_PKNS0_4SCEVEESt10_Select1stIS9_ESt4lessIS3_ESaIS9_EE8_M_eraseEPSt13_Rb_tree_nodeIS9_E", "std::_Rb_tree<llvm::Loop const*, std::pair<llvm::Loop const* const, llvm::SCEV const*>, std::_Select1st<std::pair<llvm::Loop const* const, llvm::SCEV const*> >, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::SCEV const*> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::Loop const* const, llvm::SCEV const*> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4SCEVESt4pairIKS3_St3mapIPKNS0_4LoopES3_St4lessIS9_ESaIS4_IKS9_S3_EEEESt10_Select1stISG_ESA_IS3_ESaISG_EE8_M_eraseEPSt13_Rb_tree_nodeISG_E", "std::_Rb_tree<llvm::SCEV const*, std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::SCEV const*, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::SCEV const*> > > >, std::_Select1st<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::SCEV const*, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::SCEV const*> > > > >, std::less<llvm::SCEV const*>, std::allocator<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::SCEV const*, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::SCEV const*> > > > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::SCEV const*, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::SCEV const*> > > > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm10BasicBlockESt4pairIKS3_NS0_15ScalarEvolution16BlockDispositionEESt10_Select1stIS8_ESt4lessIS3_ESaIS8_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS8_ERKS8_", "std::_Rb_tree<llvm::BasicBlock const*, std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition>, std::_Select1st<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> >, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> >, std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm10BasicBlockESt4pairIKS3_NS0_15ScalarEvolution16BlockDispositionEESt10_Select1stIS8_ESt4lessIS3_ESaIS8_EE16_M_insert_uniqueERKS8_", "std::_Rb_tree<llvm::BasicBlock const*, std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition>, std::_Select1st<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> >, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> > >::_M_insert_unique(std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm10BasicBlockESt4pairIKS3_NS0_15ScalarEvolution16BlockDispositionEESt10_Select1stIS8_ESt4lessIS3_ESaIS8_EE7_M_copyEPKSt13_Rb_tree_nodeIS8_EPSG_", "std::_Rb_tree<llvm::BasicBlock const*, std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition>, std::_Select1st<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> >, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> > >::_M_copy(std::_Rb_tree_node<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> > const*, std::_Rb_tree_node<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4SCEVESt4pairIKS3_St3mapIPKNS0_10BasicBlockENS0_15ScalarEvolution16BlockDispositionESt4lessIS9_ESaIS4_IKS9_SB_EEEESt10_Select1stISI_ESC_IS3_ESaISI_EE16_M_insert_uniqueESt17_Rb_tree_iteratorISI_ERKSI_", "std::_Rb_tree<llvm::SCEV const*, std::pair<llvm::SCEV const* const, std::map<llvm::BasicBlock const*, llvm::ScalarEvolution::BlockDisposition, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> > > >, std::_Select1st<std::pair<llvm::SCEV const* const, std::map<llvm::BasicBlock const*, llvm::ScalarEvolution::BlockDisposition, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> > > > >, std::less<llvm::SCEV const*>, std::allocator<std::pair<llvm::SCEV const* const, std::map<llvm::BasicBlock const*, llvm::ScalarEvolution::BlockDisposition, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> > > > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::SCEV const* const, std::map<llvm::BasicBlock const*, llvm::ScalarEvolution::BlockDisposition, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> > > > >, std::pair<llvm::SCEV const* const, std::map<llvm::BasicBlock const*, llvm::ScalarEvolution::BlockDisposition, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> > > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4SCEVESt4pairIKS3_St3mapIPKNS0_10BasicBlockENS0_15ScalarEvolution16BlockDispositionESt4lessIS9_ESaIS4_IKS9_SB_EEEESt10_Select1stISI_ESC_IS3_ESaISI_EE9_M_insertEPSt18_Rb_tree_node_baseSP_RKSI_", "std::_Rb_tree<llvm::SCEV const*, std::pair<llvm::SCEV const* const, std::map<llvm::BasicBlock const*, llvm::ScalarEvolution::BlockDisposition, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> > > >, std::_Select1st<std::pair<llvm::SCEV const* const, std::map<llvm::BasicBlock const*, llvm::ScalarEvolution::BlockDisposition, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> > > > >, std::less<llvm::SCEV const*>, std::allocator<std::pair<llvm::SCEV const* const, std::map<llvm::BasicBlock const*, llvm::ScalarEvolution::BlockDisposition, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> > > > > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<llvm::SCEV const* const, std::map<llvm::BasicBlock const*, llvm::ScalarEvolution::BlockDisposition, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> > > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4SCEVESt4pairIKS3_St3mapIPKNS0_10BasicBlockENS0_15ScalarEvolution16BlockDispositionESt4lessIS9_ESaIS4_IKS9_SB_EEEESt10_Select1stISI_ESC_IS3_ESaISI_EE16_M_insert_uniqueERKSI_", "std::_Rb_tree<llvm::SCEV const*, std::pair<llvm::SCEV const* const, std::map<llvm::BasicBlock const*, llvm::ScalarEvolution::BlockDisposition, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> > > >, std::_Select1st<std::pair<llvm::SCEV const* const, std::map<llvm::BasicBlock const*, llvm::ScalarEvolution::BlockDisposition, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> > > > >, std::less<llvm::SCEV const*>, std::allocator<std::pair<llvm::SCEV const* const, std::map<llvm::BasicBlock const*, llvm::ScalarEvolution::BlockDisposition, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> > > > > >::_M_insert_unique(std::pair<llvm::SCEV const* const, std::map<llvm::BasicBlock const*, llvm::ScalarEvolution::BlockDisposition, std::less<llvm::BasicBlock const*>, std::allocator<std::pair<llvm::BasicBlock const* const, llvm::ScalarEvolution::BlockDisposition> > > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4LoopESt4pairIKS3_NS0_15ScalarEvolution15LoopDispositionEESt10_Select1stIS8_ESt4lessIS3_ESaIS8_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS8_ERKS8_", "std::_Rb_tree<llvm::Loop const*, std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition>, std::_Select1st<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> >, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> >, std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4LoopESt4pairIKS3_NS0_15ScalarEvolution15LoopDispositionEESt10_Select1stIS8_ESt4lessIS3_ESaIS8_EE16_M_insert_uniqueERKS8_", "std::_Rb_tree<llvm::Loop const*, std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition>, std::_Select1st<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> >, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> > >::_M_insert_unique(std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4LoopESt4pairIKS3_NS0_15ScalarEvolution15LoopDispositionEESt10_Select1stIS8_ESt4lessIS3_ESaIS8_EE7_M_copyEPKSt13_Rb_tree_nodeIS8_EPSG_", "std::_Rb_tree<llvm::Loop const*, std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition>, std::_Select1st<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> >, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> > >::_M_copy(std::_Rb_tree_node<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> > const*, std::_Rb_tree_node<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4SCEVESt4pairIKS3_St3mapIPKNS0_4LoopENS0_15ScalarEvolution15LoopDispositionESt4lessIS9_ESaIS4_IKS9_SB_EEEESt10_Select1stISI_ESC_IS3_ESaISI_EE16_M_insert_uniqueESt17_Rb_tree_iteratorISI_ERKSI_", "std::_Rb_tree<llvm::SCEV const*, std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::ScalarEvolution::LoopDisposition, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> > > >, std::_Select1st<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::ScalarEvolution::LoopDisposition, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> > > > >, std::less<llvm::SCEV const*>, std::allocator<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::ScalarEvolution::LoopDisposition, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> > > > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::ScalarEvolution::LoopDisposition, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> > > > >, std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::ScalarEvolution::LoopDisposition, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> > > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4SCEVESt4pairIKS3_St3mapIPKNS0_4LoopENS0_15ScalarEvolution15LoopDispositionESt4lessIS9_ESaIS4_IKS9_SB_EEEESt10_Select1stISI_ESC_IS3_ESaISI_EE9_M_insertEPSt18_Rb_tree_node_baseSP_RKSI_", "std::_Rb_tree<llvm::SCEV const*, std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::ScalarEvolution::LoopDisposition, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> > > >, std::_Select1st<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::ScalarEvolution::LoopDisposition, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> > > > >, std::less<llvm::SCEV const*>, std::allocator<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::ScalarEvolution::LoopDisposition, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> > > > > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::ScalarEvolution::LoopDisposition, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> > > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4SCEVESt4pairIKS3_St3mapIPKNS0_4LoopENS0_15ScalarEvolution15LoopDispositionESt4lessIS9_ESaIS4_IKS9_SB_EEEESt10_Select1stISI_ESC_IS3_ESaISI_EE16_M_insert_uniqueERKSI_", "std::_Rb_tree<llvm::SCEV const*, std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::ScalarEvolution::LoopDisposition, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> > > >, std::_Select1st<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::ScalarEvolution::LoopDisposition, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> > > > >, std::less<llvm::SCEV const*>, std::allocator<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::ScalarEvolution::LoopDisposition, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> > > > > >::_M_insert_unique(std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::ScalarEvolution::LoopDisposition, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::LoopDisposition> > > > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4SCEVENS_13ConstantRangeENS_12DenseMapInfoIS3_EENS5_IS4_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::SCEV const*, llvm::ConstantRange, llvm::DenseMapInfo<llvm::SCEV const*>, llvm::DenseMapInfo<llvm::ConstantRange> >::shrink_and_clear()"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm7PHINodeESt4pairIKS2_PNS0_8ConstantEESt10_Select1stIS7_ESt4lessIS2_ESaIS7_EE8_M_eraseEPSt13_Rb_tree_nodeIS7_E", "std::_Rb_tree<llvm::PHINode*, std::pair<llvm::PHINode* const, llvm::Constant*>, std::_Select1st<std::pair<llvm::PHINode* const, llvm::Constant*> >, std::less<llvm::PHINode*>, std::allocator<std::pair<llvm::PHINode* const, llvm::Constant*> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::PHINode* const, llvm::Constant*> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4LoopESt4pairIKS3_NS0_15ScalarEvolution17BackedgeTakenInfoEESt10_Select1stIS8_ESt4lessIS3_ESaIS8_EE8_M_eraseEPSt13_Rb_tree_nodeIS8_E", "std::_Rb_tree<llvm::Loop const*, std::pair<llvm::Loop const* const, llvm::ScalarEvolution::BackedgeTakenInfo>, std::_Select1st<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::BackedgeTakenInfo> >, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::BackedgeTakenInfo> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::BackedgeTakenInfo> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_15ScalarEvolution14SCEVCallbackVHEPKNS_4SCEVENS_12DenseMapInfoIPNS_5ValueEEENS6_IS5_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::ScalarEvolution::SCEVCallbackVH, llvm::SCEV const*, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<llvm::SCEV const*> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_15ScalarEvolution14SCEVCallbackVHEPKNS_4SCEVENS_12DenseMapInfoIPNS_5ValueEEENS6_IS5_EEE4initEj", "llvm::DenseMap<llvm::ScalarEvolution::SCEVCallbackVH, llvm::SCEV const*, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<llvm::SCEV const*> >::init(unsigned int)"),
	mu_demangle_test("_ZNK4llvm8DenseMapINS_15ScalarEvolution14SCEVCallbackVHEPKNS_4SCEVENS_12DenseMapInfoIPNS_5ValueEEENS6_IS5_EEE15LookupBucketForERKS2_RPSt4pairIS2_S5_E", "llvm::DenseMap<llvm::ScalarEvolution::SCEVCallbackVH, llvm::SCEV const*, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<llvm::SCEV const*> >::LookupBucketFor(llvm::ScalarEvolution::SCEVCallbackVH const&, std::pair<llvm::ScalarEvolution::SCEVCallbackVH, llvm::SCEV const*>*&) const"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4LoopESt4pairIKS3_PKNS0_4SCEVEESt10_Select1stIS9_ESt4lessIS3_ESaIS9_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS9_ERKS9_", "std::_Rb_tree<llvm::Loop const*, std::pair<llvm::Loop const* const, llvm::SCEV const*>, std::_Select1st<std::pair<llvm::Loop const* const, llvm::SCEV const*> >, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::SCEV const*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::Loop const* const, llvm::SCEV const*> >, std::pair<llvm::Loop const* const, llvm::SCEV const*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4LoopESt4pairIKS3_PKNS0_4SCEVEESt10_Select1stIS9_ESt4lessIS3_ESaIS9_EE16_M_insert_uniqueERKS9_", "std::_Rb_tree<llvm::Loop const*, std::pair<llvm::Loop const* const, llvm::SCEV const*>, std::_Select1st<std::pair<llvm::Loop const* const, llvm::SCEV const*> >, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::SCEV const*> > >::_M_insert_unique(std::pair<llvm::Loop const* const, llvm::SCEV const*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4LoopESt4pairIKS3_PKNS0_4SCEVEESt10_Select1stIS9_ESt4lessIS3_ESaIS9_EE7_M_copyEPKSt13_Rb_tree_nodeIS9_EPSH_", "std::_Rb_tree<llvm::Loop const*, std::pair<llvm::Loop const* const, llvm::SCEV const*>, std::_Select1st<std::pair<llvm::Loop const* const, llvm::SCEV const*> >, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::SCEV const*> > >::_M_copy(std::_Rb_tree_node<std::pair<llvm::Loop const* const, llvm::SCEV const*> > const*, std::_Rb_tree_node<std::pair<llvm::Loop const* const, llvm::SCEV const*> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4SCEVESt4pairIKS3_St3mapIPKNS0_4LoopES3_St4lessIS9_ESaIS4_IKS9_S3_EEEESt10_Select1stISG_ESA_IS3_ESaISG_EE16_M_insert_uniqueESt17_Rb_tree_iteratorISG_ERKSG_", "std::_Rb_tree<llvm::SCEV const*, std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::SCEV const*, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::SCEV const*> > > >, std::_Select1st<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::SCEV const*, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::SCEV const*> > > > >, std::less<llvm::SCEV const*>, std::allocator<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::SCEV const*, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::SCEV const*> > > > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::SCEV const*, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::SCEV const*> > > > >, std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::SCEV const*, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::SCEV const*> > > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4SCEVESt4pairIKS3_St3mapIPKNS0_4LoopES3_St4lessIS9_ESaIS4_IKS9_S3_EEEESt10_Select1stISG_ESA_IS3_ESaISG_EE9_M_insertEPSt18_Rb_tree_node_baseSN_RKSG_", "std::_Rb_tree<llvm::SCEV const*, std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::SCEV const*, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::SCEV const*> > > >, std::_Select1st<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::SCEV const*, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::SCEV const*> > > > >, std::less<llvm::SCEV const*>, std::allocator<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::SCEV const*, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::SCEV const*> > > > > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::SCEV const*, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::SCEV const*> > > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4SCEVESt4pairIKS3_St3mapIPKNS0_4LoopES3_St4lessIS9_ESaIS4_IKS9_S3_EEEESt10_Select1stISG_ESA_IS3_ESaISG_EE16_M_insert_uniqueERKSG_", "std::_Rb_tree<llvm::SCEV const*, std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::SCEV const*, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::SCEV const*> > > >, std::_Select1st<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::SCEV const*, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::SCEV const*> > > > >, std::less<llvm::SCEV const*>, std::allocator<std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::SCEV const*, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::SCEV const*> > > > > >::_M_insert_unique(std::pair<llvm::SCEV const* const, std::map<llvm::Loop const*, llvm::SCEV const*, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::SCEV const*> > > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm7PHINodeESt4pairIKS2_PNS0_8ConstantEESt10_Select1stIS7_ESt4lessIS2_ESaIS7_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS7_ERKS7_", "std::_Rb_tree<llvm::PHINode*, std::pair<llvm::PHINode* const, llvm::Constant*>, std::_Select1st<std::pair<llvm::PHINode* const, llvm::Constant*> >, std::less<llvm::PHINode*>, std::allocator<std::pair<llvm::PHINode* const, llvm::Constant*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::PHINode* const, llvm::Constant*> >, std::pair<llvm::PHINode* const, llvm::Constant*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm7PHINodeESt4pairIKS2_PNS0_8ConstantEESt10_Select1stIS7_ESt4lessIS2_ESaIS7_EE16_M_insert_uniqueERKS7_", "std::_Rb_tree<llvm::PHINode*, std::pair<llvm::PHINode* const, llvm::Constant*>, std::_Select1st<std::pair<llvm::PHINode* const, llvm::Constant*> >, std::less<llvm::PHINode*>, std::allocator<std::pair<llvm::PHINode* const, llvm::Constant*> > >::_M_insert_unique(std::pair<llvm::PHINode* const, llvm::Constant*> const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm11ConstantIntESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::ConstantInt*, std::allocator<llvm::ConstantInt*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::ConstantInt**, std::vector<llvm::ConstantInt*, std::allocator<llvm::ConstantInt*> > >, llvm::ConstantInt* const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4LoopESt4pairIKS3_NS0_15ScalarEvolution17BackedgeTakenInfoEESt10_Select1stIS8_ESt4lessIS3_ESaIS8_EE5eraseESt17_Rb_tree_iteratorIS8_ESG_", "std::_Rb_tree<llvm::Loop const*, std::pair<llvm::Loop const* const, llvm::ScalarEvolution::BackedgeTakenInfo>, std::_Select1st<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::BackedgeTakenInfo> >, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::BackedgeTakenInfo> > >::erase(std::_Rb_tree_iterator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::BackedgeTakenInfo> >, std::_Rb_tree_iterator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::BackedgeTakenInfo> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm7PHINodeESt4pairIKS2_PNS0_8ConstantEESt10_Select1stIS7_ESt4lessIS2_ESaIS7_EE5eraseESt17_Rb_tree_iteratorIS7_ESF_", "std::_Rb_tree<llvm::PHINode*, std::pair<llvm::PHINode* const, llvm::Constant*>, std::_Select1st<std::pair<llvm::PHINode* const, llvm::Constant*> >, std::less<llvm::PHINode*>, std::allocator<std::pair<llvm::PHINode* const, llvm::Constant*> > >::erase(std::_Rb_tree_iterator<std::pair<llvm::PHINode* const, llvm::Constant*> >, std::_Rb_tree_iterator<std::pair<llvm::PHINode* const, llvm::Constant*> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4LoopESt4pairIKS3_NS0_15ScalarEvolution17BackedgeTakenInfoEESt10_Select1stIS8_ESt4lessIS3_ESaIS8_EE16_M_insert_uniqueERKS8_", "std::_Rb_tree<llvm::Loop const*, std::pair<llvm::Loop const* const, llvm::ScalarEvolution::BackedgeTakenInfo>, std::_Select1st<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::BackedgeTakenInfo> >, std::less<llvm::Loop const*>, std::allocator<std::pair<llvm::Loop const* const, llvm::ScalarEvolution::BackedgeTakenInfo> > >::_M_insert_unique(std::pair<llvm::Loop const* const, llvm::ScalarEvolution::BackedgeTakenInfo> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_15ScalarEvolution14SCEVCallbackVHEPKNS_4SCEVENS_12DenseMapInfoIPNS_5ValueEEENS6_IS5_EEE16InsertIntoBucketERKS2_RKS5_PSt4pairIS2_S5_E", "llvm::DenseMap<llvm::ScalarEvolution::SCEVCallbackVH, llvm::SCEV const*, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<llvm::SCEV const*> >::InsertIntoBucket(llvm::ScalarEvolution::SCEVCallbackVH const&, llvm::SCEV const* const&, std::pair<llvm::ScalarEvolution::SCEVCallbackVH, llvm::SCEV const*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_15ScalarEvolution14SCEVCallbackVHEPKNS_4SCEVENS_12DenseMapInfoIPNS_5ValueEEENS6_IS5_EEE4growEj", "llvm::DenseMap<llvm::ScalarEvolution::SCEVCallbackVH, llvm::SCEV const*, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<llvm::SCEV const*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_15ScalarEvolution14SCEVCallbackVHEPKNS_4SCEVENS_12DenseMapInfoIPNS_5ValueEEENS6_IS5_EEED2Ev", "llvm::DenseMap<llvm::ScalarEvolution::SCEVCallbackVH, llvm::SCEV const*, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<llvm::SCEV const*> >::~DenseMap()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4SCEVENS_13ConstantRangeENS_12DenseMapInfoIS3_EENS5_IS4_EEED2Ev", "llvm::DenseMap<llvm::SCEV const*, llvm::ConstantRange, llvm::DenseMapInfo<llvm::SCEV const*>, llvm::DenseMapInfo<llvm::ConstantRange> >::~DenseMap()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4SCEVENS_13ConstantRangeENS_12DenseMapInfoIS3_EENS5_IS4_EEE6insertERKSt4pairIS3_S4_E", "llvm::DenseMap<llvm::SCEV const*, llvm::ConstantRange, llvm::DenseMapInfo<llvm::SCEV const*>, llvm::DenseMapInfo<llvm::ConstantRange> >::insert(std::pair<llvm::SCEV const*, llvm::ConstantRange> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4SCEVENS_13ConstantRangeENS_12DenseMapInfoIS3_EENS5_IS4_EEE16InsertIntoBucketERKS3_RKS4_PSt4pairIS3_S4_E", "llvm::DenseMap<llvm::SCEV const*, llvm::ConstantRange, llvm::DenseMapInfo<llvm::SCEV const*>, llvm::DenseMapInfo<llvm::ConstantRange> >::InsertIntoBucket(llvm::SCEV const* const&, llvm::ConstantRange const&, std::pair<llvm::SCEV const*, llvm::ConstantRange>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4SCEVENS_13ConstantRangeENS_12DenseMapInfoIS3_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::SCEV const*, llvm::ConstantRange, llvm::DenseMapInfo<llvm::SCEV const*>, llvm::DenseMapInfo<llvm::ConstantRange> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4SCEVENS_5APIntENS_12DenseMapInfoIS3_EENS5_IS4_EEE6insertERKSt4pairIS3_S4_E", "llvm::DenseMap<llvm::SCEV const*, llvm::APInt, llvm::DenseMapInfo<llvm::SCEV const*>, llvm::DenseMapInfo<llvm::APInt> >::insert(std::pair<llvm::SCEV const*, llvm::APInt> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4SCEVENS_5APIntENS_12DenseMapInfoIS3_EENS5_IS4_EEE16InsertIntoBucketERKS3_RKS4_PSt4pairIS3_S4_E", "llvm::DenseMap<llvm::SCEV const*, llvm::APInt, llvm::DenseMapInfo<llvm::SCEV const*>, llvm::DenseMapInfo<llvm::APInt> >::InsertIntoBucket(llvm::SCEV const* const&, llvm::APInt const&, std::pair<llvm::SCEV const*, llvm::APInt>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4SCEVENS_5APIntENS_12DenseMapInfoIS3_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::SCEV const*, llvm::APInt, llvm::DenseMapInfo<llvm::SCEV const*>, llvm::DenseMapInfo<llvm::APInt> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_12TargetFolderENS_24IRBuilderDefaultInserterILb1EEEE11CreateBinOpENS_11Instruction9BinaryOpsEPNS_5ValueES8_RKNS_5TwineE", "llvm::IRBuilder<true, llvm::TargetFolder, llvm::IRBuilderDefaultInserter<true> >::CreateBinOp(llvm::Instruction::BinaryOps, llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_12TargetFolderENS_24IRBuilderDefaultInserterILb1EEEE9CreateGEPEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<true, llvm::TargetFolder, llvm::IRBuilderDefaultInserter<true> >::CreateGEP(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_12TargetFolderENS_24IRBuilderDefaultInserterILb1EEEE9CreateGEPIPPNS_5ValueEEES7_S7_T_S9_RKNS_5TwineE", "llvm::Value* llvm::IRBuilder<true, llvm::TargetFolder, llvm::IRBuilderDefaultInserter<true> >::CreateGEP<llvm::Value**>(llvm::Value*, llvm::Value**, llvm::Value**, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4SCEVEPKNS_4LoopENS_12DenseMapInfoIS3_EENS7_IS6_EEE6insertERKSt4pairIS3_S6_E", "llvm::DenseMap<llvm::SCEV const*, llvm::Loop const*, llvm::DenseMapInfo<llvm::SCEV const*>, llvm::DenseMapInfo<llvm::Loop const*> >::insert(std::pair<llvm::SCEV const*, llvm::Loop const*> const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_12TargetFolderENS_24IRBuilderDefaultInserterILb1EEEE9CreatePHIEPKNS_4TypeERKNS_5TwineE", "llvm::IRBuilder<true, llvm::TargetFolder, llvm::IRBuilderDefaultInserter<true> >::CreatePHI(llvm::Type const*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_12TargetFolderENS_24IRBuilderDefaultInserterILb1EEEE9CreateSubEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<true, llvm::TargetFolder, llvm::IRBuilderDefaultInserter<true> >::CreateSub(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_12TargetFolderENS_24IRBuilderDefaultInserterILb1EEEE9CreateAddEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<true, llvm::TargetFolder, llvm::IRBuilderDefaultInserter<true> >::CreateAdd(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_12TargetFolderENS_24IRBuilderDefaultInserterILb1EEEE9CreateMulEPNS_5ValueES6_RKNS_5TwineE", "llvm::IRBuilder<true, llvm::TargetFolder, llvm::IRBuilderDefaultInserter<true> >::CreateMul(llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_12TargetFolderENS_24IRBuilderDefaultInserterILb1EEEE12CreateSelectEPNS_5ValueES6_S6_RKNS_5TwineE", "llvm::IRBuilder<true, llvm::TargetFolder, llvm::IRBuilderDefaultInserter<true> >::CreateSelect(llvm::Value*, llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm4SCEVEPNS1_11InstructionEES0_IKS7_NS1_11AssertingVHINS1_5ValueEEEESt10_Select1stISC_ESt4lessIS7_ESaISC_EE16_M_insert_uniqueESt17_Rb_tree_iteratorISC_ERKSC_", "std::_Rb_tree<std::pair<llvm::SCEV const*, llvm::Instruction*>, std::pair<std::pair<llvm::SCEV const*, llvm::Instruction*> const, llvm::AssertingVH<llvm::Value> >, std::_Select1st<std::pair<std::pair<llvm::SCEV const*, llvm::Instruction*> const, llvm::AssertingVH<llvm::Value> > >, std::less<std::pair<llvm::SCEV const*, llvm::Instruction*> >, std::allocator<std::pair<std::pair<llvm::SCEV const*, llvm::Instruction*> const, llvm::AssertingVH<llvm::Value> > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<std::pair<llvm::SCEV const*, llvm::Instruction*> const, llvm::AssertingVH<llvm::Value> > >, std::pair<std::pair<llvm::SCEV const*, llvm::Instruction*> const, llvm::AssertingVH<llvm::Value> > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm4SCEVEPNS1_11InstructionEES0_IKS7_NS1_11AssertingVHINS1_5ValueEEEESt10_Select1stISC_ESt4lessIS7_ESaISC_EE16_M_insert_uniqueERKSC_", "std::_Rb_tree<std::pair<llvm::SCEV const*, llvm::Instruction*>, std::pair<std::pair<llvm::SCEV const*, llvm::Instruction*> const, llvm::AssertingVH<llvm::Value> >, std::_Select1st<std::pair<std::pair<llvm::SCEV const*, llvm::Instruction*> const, llvm::AssertingVH<llvm::Value> > >, std::less<std::pair<llvm::SCEV const*, llvm::Instruction*> >, std::allocator<std::pair<std::pair<llvm::SCEV const*, llvm::Instruction*> const, llvm::AssertingVH<llvm::Value> > > >::_M_insert_unique(std::pair<std::pair<llvm::SCEV const*, llvm::Instruction*> const, llvm::AssertingVH<llvm::Value> > const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_12TargetFolderENS_24IRBuilderDefaultInserterILb1EEEE10CreateICmpENS_7CmpInst9PredicateEPNS_5ValueES8_RKNS_5TwineE", "llvm::IRBuilder<true, llvm::TargetFolder, llvm::IRBuilderDefaultInserter<true> >::CreateICmp(llvm::CmpInst::Predicate, llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_12TargetFolderENS_24IRBuilderDefaultInserterILb1EEEE10CreateCastENS_11Instruction7CastOpsEPNS_5ValueEPKNS_4TypeERKNS_5TwineE", "llvm::IRBuilder<true, llvm::TargetFolder, llvm::IRBuilderDefaultInserter<true> >::CreateCast(llvm::Instruction::CastOps, llvm::Value*, llvm::Type const*, llvm::Twine const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm11AssertingVHINS0_5ValueEEES3_St9_IdentityIS3_ESt4lessIS3_ESaIS3_EE16_M_insert_uniqueERKS3_", "std::_Rb_tree<llvm::AssertingVH<llvm::Value>, llvm::AssertingVH<llvm::Value>, std::_Identity<llvm::AssertingVH<llvm::Value> >, std::less<llvm::AssertingVH<llvm::Value> >, std::allocator<llvm::AssertingVH<llvm::Value> > >::_M_insert_unique(llvm::AssertingVH<llvm::Value> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4SCEVEPKNS_4LoopENS_12DenseMapInfoIS3_EENS7_IS6_EEE16InsertIntoBucketERKS3_RKS6_PSt4pairIS3_S6_E", "llvm::DenseMap<llvm::SCEV const*, llvm::Loop const*, llvm::DenseMapInfo<llvm::SCEV const*>, llvm::DenseMapInfo<llvm::Loop const*> >::InsertIntoBucket(llvm::SCEV const* const&, llvm::Loop const* const&, std::pair<llvm::SCEV const*, llvm::Loop const*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4SCEVEPKNS_4LoopENS_12DenseMapInfoIS3_EENS7_IS6_EEE4growEj", "llvm::DenseMap<llvm::SCEV const*, llvm::Loop const*, llvm::DenseMapInfo<llvm::SCEV const*>, llvm::DenseMapInfo<llvm::Loop const*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_11GlobalValueEjNS_12DenseMapInfoIS3_EENS4_IjEEE16InsertIntoBucketERKS3_RKjPSt4pairIS3_jE", "llvm::DenseMap<llvm::GlobalValue const*, unsigned int, llvm::DenseMapInfo<llvm::GlobalValue const*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(llvm::GlobalValue const* const&, unsigned int const&, std::pair<llvm::GlobalValue const*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_11GlobalValueEjNS_12DenseMapInfoIS3_EENS4_IjEEE4growEj", "llvm::DenseMap<llvm::GlobalValue const*, unsigned int, llvm::DenseMapInfo<llvm::GlobalValue const*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_Z5SplitRSt6vectorISsSaISsEERKSs", "Split(std::vector<std::string, std::allocator<std::string> >&, std::string const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_10StructTypeEPNS_12StructLayoutENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PSt4pairIS3_S5_E", "llvm::DenseMap<llvm::StructType const*, llvm::StructLayout*, llvm::DenseMapInfo<llvm::StructType const*>, llvm::DenseMapInfo<llvm::StructLayout*> >::InsertIntoBucket(llvm::StructType const* const&, llvm::StructLayout* const&, std::pair<llvm::StructType const*, llvm::StructLayout*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_10StructTypeEPNS_12StructLayoutENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<llvm::StructType const*, llvm::StructLayout*, llvm::DenseMapInfo<llvm::StructType const*>, llvm::DenseMapInfo<llvm::StructLayout*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNK4llvm19TargetFrameLowering20getInitialFrameStateERSt6vectorINS_11MachineMoveESaIS2_EE", "llvm::TargetFrameLowering::getInitialFrameState(std::vector<llvm::MachineMove, std::allocator<llvm::MachineMove> >&) const"),
	mu_demangle_test("_ZN4llvm2cl3optIbLb1ENS0_6parserIbEEED1Ev", "llvm::cl::opt<bool, true, llvm::cl::parser<bool> >::~opt()"),
	mu_demangle_test("_ZN4llvm2cl3optINS_8FloatABI7ABITypeELb1ENS0_6parserIS3_EEED1Ev", "llvm::cl::opt<llvm::FloatABI::ABIType, true, llvm::cl::parser<llvm::FloatABI::ABIType> >::~opt()"),
	mu_demangle_test("_ZN4llvm2cl3optINS_5Reloc5ModelELb1ENS0_6parserIS3_EEED1Ev", "llvm::cl::opt<llvm::Reloc::Model, true, llvm::cl::parser<llvm::Reloc::Model> >::~opt()"),
	mu_demangle_test("_ZN4llvm2cl3optINS_9CodeModel5ModelELb1ENS0_6parserIS3_EEED1Ev", "llvm::cl::opt<llvm::CodeModel::Model, true, llvm::cl::parser<llvm::CodeModel::Model> >::~opt()"),
	mu_demangle_test("_ZN4llvm2cl3optIjLb1ENS0_6parserIjEEED1Ev", "llvm::cl::opt<unsigned int, true, llvm::cl::parser<unsigned int> >::~opt()"),
	mu_demangle_test("_ZN4llvm2cl3optIbLb1ENS0_6parserIbEEE16handleOccurrenceEjNS_9StringRefES5_", "llvm::cl::opt<bool, true, llvm::cl::parser<bool> >::handleOccurrence(unsigned int, llvm::StringRef, llvm::StringRef)"),
	mu_demangle_test("_ZNK4llvm2cl3optIbLb1ENS0_6parserIbEEE27getValueExpectedFlagDefaultEv", "llvm::cl::opt<bool, true, llvm::cl::parser<bool> >::getValueExpectedFlagDefault() const"),
	mu_demangle_test("_ZNK4llvm2cl3optIbLb1ENS0_6parserIbEEE14getOptionWidthEv", "llvm::cl::opt<bool, true, llvm::cl::parser<bool> >::getOptionWidth() const"),
	mu_demangle_test("_ZNK4llvm2cl3optIbLb1ENS0_6parserIbEEE15printOptionInfoEm", "llvm::cl::opt<bool, true, llvm::cl::parser<bool> >::printOptionInfo(unsigned long) const"),
	mu_demangle_test("_ZN4llvm2cl3optIbLb1ENS0_6parserIbEEE19getExtraOptionNamesERNS_15SmallVectorImplIPKcEE", "llvm::cl::opt<bool, true, llvm::cl::parser<bool> >::getExtraOptionNames(llvm::SmallVectorImpl<char const*>&)"),
	mu_demangle_test("_ZN4llvm2cl3optIbLb1ENS0_6parserIbEEED0Ev", "llvm::cl::opt<bool, true, llvm::cl::parser<bool> >::~opt()"),
	mu_demangle_test("_ZN4llvm2cl3optIjLb1ENS0_6parserIjEEE16handleOccurrenceEjNS_9StringRefES5_", "llvm::cl::opt<unsigned int, true, llvm::cl::parser<unsigned int> >::handleOccurrence(unsigned int, llvm::StringRef, llvm::StringRef)"),
	mu_demangle_test("_ZNK4llvm2cl3optIjLb1ENS0_6parserIjEEE27getValueExpectedFlagDefaultEv", "llvm::cl::opt<unsigned int, true, llvm::cl::parser<unsigned int> >::getValueExpectedFlagDefault() const"),
	mu_demangle_test("_ZNK4llvm2cl3optIjLb1ENS0_6parserIjEEE14getOptionWidthEv", "llvm::cl::opt<unsigned int, true, llvm::cl::parser<unsigned int> >::getOptionWidth() const"),
	mu_demangle_test("_ZNK4llvm2cl3optIjLb1ENS0_6parserIjEEE15printOptionInfoEm", "llvm::cl::opt<unsigned int, true, llvm::cl::parser<unsigned int> >::printOptionInfo(unsigned long) const"),
	mu_demangle_test("_ZN4llvm2cl3optIjLb1ENS0_6parserIjEEE19getExtraOptionNamesERNS_15SmallVectorImplIPKcEE", "llvm::cl::opt<unsigned int, true, llvm::cl::parser<unsigned int> >::getExtraOptionNames(llvm::SmallVectorImpl<char const*>&)"),
	mu_demangle_test("_ZN4llvm2cl3optIjLb1ENS0_6parserIjEEED0Ev", "llvm::cl::opt<unsigned int, true, llvm::cl::parser<unsigned int> >::~opt()"),
	mu_demangle_test("_ZN4llvm2cl3optINS_9CodeModel5ModelELb1ENS0_6parserIS3_EEE16handleOccurrenceEjNS_9StringRefES7_", "llvm::cl::opt<llvm::CodeModel::Model, true, llvm::cl::parser<llvm::CodeModel::Model> >::handleOccurrence(unsigned int, llvm::StringRef, llvm::StringRef)"),
	mu_demangle_test("_ZNK4llvm2cl3optINS_9CodeModel5ModelELb1ENS0_6parserIS3_EEE27getValueExpectedFlagDefaultEv", "llvm::cl::opt<llvm::CodeModel::Model, true, llvm::cl::parser<llvm::CodeModel::Model> >::getValueExpectedFlagDefault() const"),
	mu_demangle_test("_ZNK4llvm2cl3optINS_9CodeModel5ModelELb1ENS0_6parserIS3_EEE14getOptionWidthEv", "llvm::cl::opt<llvm::CodeModel::Model, true, llvm::cl::parser<llvm::CodeModel::Model> >::getOptionWidth() const"),
	mu_demangle_test("_ZNK4llvm2cl3optINS_9CodeModel5ModelELb1ENS0_6parserIS3_EEE15printOptionInfoEm", "llvm::cl::opt<llvm::CodeModel::Model, true, llvm::cl::parser<llvm::CodeModel::Model> >::printOptionInfo(unsigned long) const"),
	mu_demangle_test("_ZN4llvm2cl3optINS_9CodeModel5ModelELb1ENS0_6parserIS3_EEE19getExtraOptionNamesERNS_15SmallVectorImplIPKcEE", "llvm::cl::opt<llvm::CodeModel::Model, true, llvm::cl::parser<llvm::CodeModel::Model> >::getExtraOptionNames(llvm::SmallVectorImpl<char const*>&)"),
	mu_demangle_test("_ZN4llvm2cl3optINS_9CodeModel5ModelELb1ENS0_6parserIS3_EEED0Ev", "llvm::cl::opt<llvm::CodeModel::Model, true, llvm::cl::parser<llvm::CodeModel::Model> >::~opt()"),
	mu_demangle_test("_ZNK4llvm2cl11ValuesClassIiE5applyINS0_3optINS_9CodeModel5ModelELb1ENS0_6parserIS6_EEEEEEvRT_", "void llvm::cl::ValuesClass<int>::apply<llvm::cl::opt<llvm::CodeModel::Model, true, llvm::cl::parser<llvm::CodeModel::Model> > >(llvm::cl::opt<llvm::CodeModel::Model, true, llvm::cl::parser<llvm::CodeModel::Model> >&) const"),
	mu_demangle_test("_ZN4llvm2cl3optINS_5Reloc5ModelELb1ENS0_6parserIS3_EEE16handleOccurrenceEjNS_9StringRefES7_", "llvm::cl::opt<llvm::Reloc::Model, true, llvm::cl::parser<llvm::Reloc::Model> >::handleOccurrence(unsigned int, llvm::StringRef, llvm::StringRef)"),
	mu_demangle_test("_ZNK4llvm2cl3optINS_5Reloc5ModelELb1ENS0_6parserIS3_EEE27getValueExpectedFlagDefaultEv", "llvm::cl::opt<llvm::Reloc::Model, true, llvm::cl::parser<llvm::Reloc::Model> >::getValueExpectedFlagDefault() const"),
	mu_demangle_test("_ZNK4llvm2cl3optINS_5Reloc5ModelELb1ENS0_6parserIS3_EEE14getOptionWidthEv", "llvm::cl::opt<llvm::Reloc::Model, true, llvm::cl::parser<llvm::Reloc::Model> >::getOptionWidth() const"),
	mu_demangle_test("_ZNK4llvm2cl3optINS_5Reloc5ModelELb1ENS0_6parserIS3_EEE15printOptionInfoEm", "llvm::cl::opt<llvm::Reloc::Model, true, llvm::cl::parser<llvm::Reloc::Model> >::printOptionInfo(unsigned long) const"),
	mu_demangle_test("_ZN4llvm2cl3optINS_5Reloc5ModelELb1ENS0_6parserIS3_EEE19getExtraOptionNamesERNS_15SmallVectorImplIPKcEE", "llvm::cl::opt<llvm::Reloc::Model, true, llvm::cl::parser<llvm::Reloc::Model> >::getExtraOptionNames(llvm::SmallVectorImpl<char const*>&)"),
	mu_demangle_test("_ZN4llvm2cl3optINS_5Reloc5ModelELb1ENS0_6parserIS3_EEED0Ev", "llvm::cl::opt<llvm::Reloc::Model, true, llvm::cl::parser<llvm::Reloc::Model> >::~opt()"),
	mu_demangle_test("_ZNK4llvm2cl11ValuesClassIiE5applyINS0_3optINS_5Reloc5ModelELb1ENS0_6parserIS6_EEEEEEvRT_", "void llvm::cl::ValuesClass<int>::apply<llvm::cl::opt<llvm::Reloc::Model, true, llvm::cl::parser<llvm::Reloc::Model> > >(llvm::cl::opt<llvm::Reloc::Model, true, llvm::cl::parser<llvm::Reloc::Model> >&) const"),
	mu_demangle_test("_ZN4llvm2cl3optINS_8FloatABI7ABITypeELb1ENS0_6parserIS3_EEE16handleOccurrenceEjNS_9StringRefES7_", "llvm::cl::opt<llvm::FloatABI::ABIType, true, llvm::cl::parser<llvm::FloatABI::ABIType> >::handleOccurrence(unsigned int, llvm::StringRef, llvm::StringRef)"),
	mu_demangle_test("_ZNK4llvm2cl3optINS_8FloatABI7ABITypeELb1ENS0_6parserIS3_EEE27getValueExpectedFlagDefaultEv", "llvm::cl::opt<llvm::FloatABI::ABIType, true, llvm::cl::parser<llvm::FloatABI::ABIType> >::getValueExpectedFlagDefault() const"),
	mu_demangle_test("_ZNK4llvm2cl3optINS_8FloatABI7ABITypeELb1ENS0_6parserIS3_EEE14getOptionWidthEv", "llvm::cl::opt<llvm::FloatABI::ABIType, true, llvm::cl::parser<llvm::FloatABI::ABIType> >::getOptionWidth() const"),
	mu_demangle_test("_ZNK4llvm2cl3optINS_8FloatABI7ABITypeELb1ENS0_6parserIS3_EEE15printOptionInfoEm", "llvm::cl::opt<llvm::FloatABI::ABIType, true, llvm::cl::parser<llvm::FloatABI::ABIType> >::printOptionInfo(unsigned long) const"),
	mu_demangle_test("_ZN4llvm2cl3optINS_8FloatABI7ABITypeELb1ENS0_6parserIS3_EEE19getExtraOptionNamesERNS_15SmallVectorImplIPKcEE", "llvm::cl::opt<llvm::FloatABI::ABIType, true, llvm::cl::parser<llvm::FloatABI::ABIType> >::getExtraOptionNames(llvm::SmallVectorImpl<char const*>&)"),
	mu_demangle_test("_ZN4llvm2cl3optINS_8FloatABI7ABITypeELb1ENS0_6parserIS3_EEED0Ev", "llvm::cl::opt<llvm::FloatABI::ABIType, true, llvm::cl::parser<llvm::FloatABI::ABIType> >::~opt()"),
	mu_demangle_test("_ZNK4llvm2cl11ValuesClassIiE5applyINS0_3optINS_8FloatABI7ABITypeELb1ENS0_6parserIS6_EEEEEEvRT_", "void llvm::cl::ValuesClass<int>::apply<llvm::cl::opt<llvm::FloatABI::ABIType, true, llvm::cl::parser<llvm::FloatABI::ABIType> > >(llvm::cl::opt<llvm::FloatABI::ABIType, true, llvm::cl::parser<llvm::FloatABI::ABIType> >&) const"),
	mu_demangle_test("_Z23AddModuleTypesToPrinterRN4llvm12TypePrintingERSt6vectorIPKNS_4TypeESaIS5_EEPKNS_6ModuleE", "AddModuleTypesToPrinter(llvm::TypePrinting&, std::vector<llvm::Type const*, std::allocator<llvm::Type const*> >&, llvm::Module const*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4TypeESsNS_12DenseMapInfoIS3_EENS4_ISsEEE5clearEv", "llvm::DenseMap<llvm::Type const*, std::string, llvm::DenseMapInfo<llvm::Type const*>, llvm::DenseMapInfo<std::string> >::clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4TypeESsNS_12DenseMapInfoIS3_EENS4_ISsEEE6insertERKSt4pairIS3_SsE", "llvm::DenseMap<llvm::Type const*, std::string, llvm::DenseMapInfo<llvm::Type const*>, llvm::DenseMapInfo<std::string> >::insert(std::pair<llvm::Type const*, std::string> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4TypeESsNS_12DenseMapInfoIS3_EENS4_ISsEEE16InsertIntoBucketERKS3_RKSsPSt4pairIS3_SsE", "llvm::DenseMap<llvm::Type const*, std::string, llvm::DenseMapInfo<llvm::Type const*>, llvm::DenseMapInfo<std::string> >::InsertIntoBucket(llvm::Type const* const&, std::string const&, std::pair<llvm::Type const*, std::string>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4TypeESsNS_12DenseMapInfoIS3_EENS4_ISsEEE4growEj", "llvm::DenseMap<llvm::Type const*, std::string, llvm::DenseMapInfo<llvm::Type const*>, llvm::DenseMapInfo<std::string> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4TypeESsNS_12DenseMapInfoIS3_EENS4_ISsEEE16shrink_and_clearEv", "llvm::DenseMap<llvm::Type const*, std::string, llvm::DenseMapInfo<llvm::Type const*>, llvm::DenseMapInfo<std::string> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_5ValueEjNS_12DenseMapInfoIS3_EENS4_IjEEE16shrink_and_clearEv", "llvm::DenseMap<llvm::Value const*, unsigned int, llvm::DenseMapInfo<llvm::Value const*>, llvm::DenseMapInfo<unsigned int> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_6MDNodeEjNS_12DenseMapInfoIS3_EENS4_IjEEE16InsertIntoBucketERKS3_RKjPSt4pairIS3_jE", "llvm::DenseMap<llvm::MDNode const*, unsigned int, llvm::DenseMapInfo<llvm::MDNode const*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(llvm::MDNode const* const&, unsigned int const&, std::pair<llvm::MDNode const*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_6MDNodeEjNS_12DenseMapInfoIS3_EENS4_IjEEE4growEj", "llvm::DenseMap<llvm::MDNode const*, unsigned int, llvm::DenseMapInfo<llvm::MDNode const*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_5ValueEcNS_12DenseMapInfoIS3_EENS4_IcEEE6insertERKSt4pairIS3_cE", "llvm::DenseMap<llvm::Value const*, char, llvm::DenseMapInfo<llvm::Value const*>, llvm::DenseMapInfo<char> >::insert(std::pair<llvm::Value const*, char> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_5ValueEcNS_12DenseMapInfoIS3_EENS4_IcEEE16InsertIntoBucketERKS3_RKcPSt4pairIS3_cE", "llvm::DenseMap<llvm::Value const*, char, llvm::DenseMapInfo<llvm::Value const*>, llvm::DenseMapInfo<char> >::InsertIntoBucket(llvm::Value const* const&, char const&, std::pair<llvm::Value const*, char>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_5ValueEcNS_12DenseMapInfoIS3_EENS4_IcEEE4growEj", "llvm::DenseMap<llvm::Value const*, char, llvm::DenseMapInfo<llvm::Value const*>, llvm::DenseMapInfo<char> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4TypeEcNS_12DenseMapInfoIS3_EENS4_IcEEE6insertERKSt4pairIS3_cE", "llvm::DenseMap<llvm::Type const*, char, llvm::DenseMapInfo<llvm::Type const*>, llvm::DenseMapInfo<char> >::insert(std::pair<llvm::Type const*, char> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4TypeEcNS_12DenseMapInfoIS3_EENS4_IcEEE16InsertIntoBucketERKS3_RKcPSt4pairIS3_cE", "llvm::DenseMap<llvm::Type const*, char, llvm::DenseMapInfo<llvm::Type const*>, llvm::DenseMapInfo<char> >::InsertIntoBucket(llvm::Type const* const&, char const&, std::pair<llvm::Type const*, char>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_4TypeEcNS_12DenseMapInfoIS3_EENS4_IcEEE4growEj", "llvm::DenseMap<llvm::Type const*, char, llvm::DenseMapInfo<llvm::Type const*>, llvm::DenseMapInfo<char> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm14object_creatorINS_10FoldingSetINS_17AttributeListImplEEEEEPvv", "void* llvm::object_creator<llvm::FoldingSet<llvm::AttributeListImpl> >()"),
	mu_demangle_test("_ZN4llvm14object_deleterINS_10FoldingSetINS_17AttributeListImplEEEE4callEPv", "llvm::object_deleter<llvm::FoldingSet<llvm::AttributeListImpl> >::call(void*)"),
	mu_demangle_test("_ZN4llvm9IRBuilderILb1ENS_14ConstantFolderENS_24IRBuilderDefaultInserterILb1EEEE19CreateShuffleVectorEPNS_5ValueES6_S6_RKNS_5TwineE", "llvm::IRBuilder<true, llvm::ConstantFolder, llvm::IRBuilderDefaultInserter<true> >::CreateShuffleVector(llvm::Value*, llvm::Value*, llvm::Value*, llvm::Twine const&)"),
	mu_demangle_test("_ZN4llvm6iplistINS_11InstructionENS_12ilist_traitsIS1_EEE5eraseENS_14ilist_iteratorIS1_EE", "llvm::iplist<llvm::Instruction, llvm::ilist_traits<llvm::Instruction> >::erase(llvm::ilist_iterator<llvm::Instruction>)"),
	mu_demangle_test("_ZN4llvm14ConstantVector3getERKSt6vectorIPNS_8ConstantESaIS3_EE", "llvm::ConstantVector::get(std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > const&)"),
	mu_demangle_test("_ZN4llvm14ConstantVector3getEPKNS_10VectorTypeERKSt6vectorIPNS_8ConstantESaIS6_EE", "llvm::ConstantVector::get(llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > const&)"),
	mu_demangle_test("_ZN4llvm13ConstantArrayC1EPKNS_9ArrayTypeERKSt6vectorIPNS_8ConstantESaIS6_EE", "llvm::ConstantArray::ConstantArray(llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > const&)"),
	mu_demangle_test("_ZN4llvm13ConstantArrayC2EPKNS_9ArrayTypeERKSt6vectorIPNS_8ConstantESaIS6_EE", "llvm::ConstantArray::ConstantArray(llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > const&)"),
	mu_demangle_test("_ZN4llvm13ConstantArray3getEPKNS_9ArrayTypeERKSt6vectorIPNS_8ConstantESaIS6_EE", "llvm::ConstantArray::get(llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > const&)"),
	mu_demangle_test("_ZN4llvm14ConstantStructC1EPKNS_10StructTypeERKSt6vectorIPNS_8ConstantESaIS6_EE", "llvm::ConstantStruct::ConstantStruct(llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > const&)"),
	mu_demangle_test("_ZN4llvm14ConstantStructC2EPKNS_10StructTypeERKSt6vectorIPNS_8ConstantESaIS6_EE", "llvm::ConstantStruct::ConstantStruct(llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > const&)"),
	mu_demangle_test("_ZN4llvm14ConstantStruct3getEPKNS_10StructTypeERKSt6vectorIPNS_8ConstantESaIS6_EE", "llvm::ConstantStruct::get(llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > const&)"),
	mu_demangle_test("_ZN4llvm14ConstantStruct3getERNS_11LLVMContextERKSt6vectorIPNS_8ConstantESaIS5_EEb", "llvm::ConstantStruct::get(llvm::LLVMContext&, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > const&, bool)"),
	mu_demangle_test("_ZN4llvm14ConstantVectorC1EPKNS_10VectorTypeERKSt6vectorIPNS_8ConstantESaIS6_EE", "llvm::ConstantVector::ConstantVector(llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > const&)"),
	mu_demangle_test("_ZN4llvm14ConstantVectorC2EPKNS_10VectorTypeERKSt6vectorIPNS_8ConstantESaIS6_EE", "llvm::ConstantVector::ConstantVector(llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > const&)"),
	mu_demangle_test("_ZN4llvm25GetElementPtrConstantExprC1EPNS_8ConstantERKSt6vectorIS2_SaIS2_EEPKNS_4TypeE", "llvm::GetElementPtrConstantExpr::GetElementPtrConstantExpr(llvm::Constant*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > const&, llvm::Type const*)"),
	mu_demangle_test("_ZN4llvm25GetElementPtrConstantExprC2EPNS_8ConstantERKSt6vectorIS2_SaIS2_EEPKNS_4TypeE", "llvm::GetElementPtrConstantExpr::GetElementPtrConstantExpr(llvm::Constant*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > const&, llvm::Type const*)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_9ArrayTypeENS_13ConstantArrayELb1EE11getOrCreateEPKS6_RKS5_", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::ArrayType, llvm::ConstantArray, true>::getOrCreate(llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > const&)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_10StructTypeENS_14ConstantStructELb1EE11getOrCreateEPKS6_RKS5_", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::StructType, llvm::ConstantStruct, true>::getOrCreate(llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > const&)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_10VectorTypeENS_14ConstantVectorELb0EE11getOrCreateEPKS6_RKS5_", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::VectorType, llvm::ConstantVector, false>::getOrCreate(llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > const&)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_9ArrayTypeENS_13ConstantArrayELb1EE6removeEPS7_", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::ArrayType, llvm::ConstantArray, true>::remove(llvm::ConstantArray*)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_10StructTypeENS_14ConstantStructELb1EE6removeEPS7_", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::StructType, llvm::ConstantStruct, true>::remove(llvm::ConstantStruct*)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_10VectorTypeENS_14ConstantVectorELb0EE6removeEPS7_", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::VectorType, llvm::ConstantVector, false>::remove(llvm::ConstantVector*)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_9ArrayTypeENS_13ConstantArrayELb1EE15InsertOrGetItemERSt4pairIS9_IPKS6_S5_EPS7_ERb", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::ArrayType, llvm::ConstantArray, true>::InsertOrGetItem(std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > >, llvm::ConstantArray*>&, bool&)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_9ArrayTypeENS_13ConstantArrayELb1EE21MoveConstantToNewSlotEPS7_St17_Rb_tree_iteratorISt4pairIKSB_IPKS6_S5_ES9_EE", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::ArrayType, llvm::ConstantArray, true>::MoveConstantToNewSlot(llvm::ConstantArray*, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> >)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_10StructTypeENS_14ConstantStructELb1EE15InsertOrGetItemERSt4pairIS9_IPKS6_S5_EPS7_ERb", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::StructType, llvm::ConstantStruct, true>::InsertOrGetItem(std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > >, llvm::ConstantStruct*>&, bool&)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_10StructTypeENS_14ConstantStructELb1EE21MoveConstantToNewSlotEPS7_St17_Rb_tree_iteratorISt4pairIKSB_IPKS6_S5_ES9_EE", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::StructType, llvm::ConstantStruct, true>::MoveConstantToNewSlot(llvm::ConstantStruct*, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> >)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapINS_14ExprMapKeyTypeENS_4TypeENS_12ConstantExprELb0EE6CreateEPKS2_RKS1_St17_Rb_tree_iteratorISt4pairIKSA_IS6_S1_EPS3_EE", "llvm::ConstantUniqueMap<llvm::ExprMapKeyType, llvm::Type, llvm::ConstantExpr, false>::Create(llvm::Type const*, llvm::ExprMapKeyType const&, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm4TypeENS1_14ExprMapKeyTypeEES0_IKS6_PNS1_12ConstantExprEESt10_Select1stISA_ESt4lessIS6_ESaISA_EE16_M_insert_uniqueESt17_Rb_tree_iteratorISA_ERKSA_", "std::_Rb_tree<std::pair<llvm::Type const*, llvm::ExprMapKeyType>, std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*>, std::_Select1st<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> >, std::less<std::pair<llvm::Type const*, llvm::ExprMapKeyType> >, std::allocator<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> >, std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> const&)"),
	mu_demangle_test("_ZNK4llvm8DenseMapISt4pairIPNS_8FunctionEPNS_10BasicBlockEEPNS_12BlockAddressENS_12DenseMapInfoIS6_EENS9_IS8_EEE15LookupBucketForERKS6_RPS1_IS6_S8_E", "llvm::DenseMap<std::pair<llvm::Function*, llvm::BasicBlock*>, llvm::BlockAddress*, llvm::DenseMapInfo<std::pair<llvm::Function*, llvm::BasicBlock*> >, llvm::DenseMapInfo<llvm::BlockAddress*> >::LookupBucketFor(std::pair<llvm::Function*, llvm::BasicBlock*> const&, std::pair<std::pair<llvm::Function*, llvm::BasicBlock*>, llvm::BlockAddress*>*&) const"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPNS_8FunctionEPNS_10BasicBlockEEPNS_12BlockAddressENS_12DenseMapInfoIS6_EENS9_IS8_EEE16InsertIntoBucketERKS6_RKS8_PS1_IS6_S8_E", "llvm::DenseMap<std::pair<llvm::Function*, llvm::BasicBlock*>, llvm::BlockAddress*, llvm::DenseMapInfo<std::pair<llvm::Function*, llvm::BasicBlock*> >, llvm::DenseMapInfo<llvm::BlockAddress*> >::InsertIntoBucket(std::pair<llvm::Function*, llvm::BasicBlock*> const&, llvm::BlockAddress* const&, std::pair<std::pair<llvm::Function*, llvm::BasicBlock*>, llvm::BlockAddress*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPNS_8FunctionEPNS_10BasicBlockEEPNS_12BlockAddressENS_12DenseMapInfoIS6_EENS9_IS8_EEE4growEj", "llvm::DenseMap<std::pair<llvm::Function*, llvm::BasicBlock*>, llvm::BlockAddress*, llvm::DenseMapInfo<std::pair<llvm::Function*, llvm::BasicBlock*> >, llvm::DenseMapInfo<llvm::BlockAddress*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapIcNS_4TypeENS_10UndefValueELb0EE6CreateEPKS1_RKcSt17_Rb_tree_iteratorISt4pairIKS9_IS5_cEPS2_EE", "llvm::ConstantUniqueMap<char, llvm::Type, llvm::UndefValue, false>::Create(llvm::Type const*, char const&, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm4TypeEcES0_IKS5_PNS1_10UndefValueEESt10_Select1stIS9_ESt4lessIS5_ESaIS9_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS9_ERKS9_", "std::_Rb_tree<std::pair<llvm::Type const*, char>, std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*>, std::_Select1st<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> >, std::less<std::pair<llvm::Type const*, char> >, std::allocator<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> >, std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> const&)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapIcNS_11PointerTypeENS_19ConstantPointerNullELb0EE6CreateEPKS1_RKcSt17_Rb_tree_iteratorISt4pairIKS9_IS5_cEPS2_EE", "llvm::ConstantUniqueMap<char, llvm::PointerType, llvm::ConstantPointerNull, false>::Create(llvm::PointerType const*, char const&, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm11PointerTypeEcES0_IKS5_PNS1_19ConstantPointerNullEESt10_Select1stIS9_ESt4lessIS5_ESaIS9_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS9_ERKS9_", "std::_Rb_tree<std::pair<llvm::PointerType const*, char>, std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*>, std::_Select1st<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> >, std::less<std::pair<llvm::PointerType const*, char> >, std::allocator<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> >, std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> const&)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_10VectorTypeENS_14ConstantVectorELb0EE19FindExistingElementEPS7_", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::VectorType, llvm::ConstantVector, false>::FindExistingElement(llvm::ConstantVector*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm14ConstantStructESt4pairIKS2_St17_Rb_tree_iteratorIS3_IKS3_IPKNS0_10StructTypeESt6vectorIPNS0_8ConstantESaISB_EEES2_EEESt10_Select1stISI_ESt4lessIS2_ESaISI_EE5eraseES5_ISI_ESP_", "std::_Rb_tree<llvm::ConstantStruct*, std::pair<llvm::ConstantStruct* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > >, std::_Select1st<std::pair<llvm::ConstantStruct* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > > >, std::less<llvm::ConstantStruct*>, std::allocator<std::pair<llvm::ConstantStruct* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > > > >::erase(std::_Rb_tree_iterator<std::pair<llvm::ConstantStruct* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > > >, std::_Rb_tree_iterator<std::pair<llvm::ConstantStruct* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > > >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm13ConstantArrayESt4pairIKS2_St17_Rb_tree_iteratorIS3_IKS3_IPKNS0_9ArrayTypeESt6vectorIPNS0_8ConstantESaISB_EEES2_EEESt10_Select1stISI_ESt4lessIS2_ESaISI_EE5eraseES5_ISI_ESP_", "std::_Rb_tree<llvm::ConstantArray*, std::pair<llvm::ConstantArray* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > >, std::_Select1st<std::pair<llvm::ConstantArray* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > > >, std::less<llvm::ConstantArray*>, std::allocator<std::pair<llvm::ConstantArray* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > > > >::erase(std::_Rb_tree_iterator<std::pair<llvm::ConstantArray* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > > >, std::_Rb_tree_iterator<std::pair<llvm::ConstantArray* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > > >)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapIcNS_4TypeENS_21ConstantAggregateZeroELb0EE6CreateEPKS1_RKcSt17_Rb_tree_iteratorISt4pairIKS9_IS5_cEPS2_EE", "llvm::ConstantUniqueMap<char, llvm::Type, llvm::ConstantAggregateZero, false>::Create(llvm::Type const*, char const&, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm4TypeEcES0_IKS5_PNS1_21ConstantAggregateZeroEESt10_Select1stIS9_ESt4lessIS5_ESaIS9_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS9_ERKS9_", "std::_Rb_tree<std::pair<llvm::Type const*, char>, std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*>, std::_Select1st<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> >, std::less<std::pair<llvm::Type const*, char> >, std::allocator<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> >, std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> const&)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_10VectorTypeENS_14ConstantVectorELb0EE6CreateEPKS6_RKS5_St17_Rb_tree_iteratorISt4pairIKSE_ISA_S5_EPS7_EE", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::VectorType, llvm::ConstantVector, false>::Create(llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > const&, std::_Rb_tree_iterator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm10VectorTypeESt6vectorIPNS1_8ConstantESaIS7_EEES0_IKSA_PNS1_14ConstantVectorEESt10_Select1stISE_ESt4lessISA_ESaISE_EE16_M_insert_uniqueESt17_Rb_tree_iteratorISE_ERKSE_", "std::_Rb_tree<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > >, std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*>, std::_Select1st<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> >, std::less<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > >, std::allocator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> >, std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> const&)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_10StructTypeENS_14ConstantStructELb1EE6CreateEPKS6_RKS5_St17_Rb_tree_iteratorISt4pairIKSE_ISA_S5_EPS7_EE", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::StructType, llvm::ConstantStruct, true>::Create(llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > const&, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm10StructTypeESt6vectorIPNS1_8ConstantESaIS7_EEES0_IKSA_PNS1_14ConstantStructEESt10_Select1stISE_ESt4lessISA_ESaISE_EE16_M_insert_uniqueESt17_Rb_tree_iteratorISE_ERKSE_", "std::_Rb_tree<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > >, std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*>, std::_Select1st<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> >, std::less<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > >, std::allocator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> >, std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> const&)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_9ArrayTypeENS_13ConstantArrayELb1EE6CreateEPKS6_RKS5_St17_Rb_tree_iteratorISt4pairIKSE_ISA_S5_EPS7_EE", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::ArrayType, llvm::ConstantArray, true>::Create(llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > const&, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm9ArrayTypeESt6vectorIPNS1_8ConstantESaIS7_EEES0_IKSA_PNS1_13ConstantArrayEESt10_Select1stISE_ESt4lessISA_ESaISE_EE16_M_insert_uniqueESt17_Rb_tree_iteratorISE_ERKSE_", "std::_Rb_tree<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > >, std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*>, std::_Select1st<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> >, std::less<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > >, std::allocator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> >, std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> const&)"),
	mu_demangle_test("_ZNK4llvm8DenseMapINS_22DenseMapAPFloatKeyInfo5KeyTyEPNS_10ConstantFPES1_NS_12DenseMapInfoIS4_EEE15LookupBucketForERKS2_RPSt4pairIS2_S4_E", "llvm::DenseMap<llvm::DenseMapAPFloatKeyInfo::KeyTy, llvm::ConstantFP*, llvm::DenseMapAPFloatKeyInfo, llvm::DenseMapInfo<llvm::ConstantFP*> >::LookupBucketFor(llvm::DenseMapAPFloatKeyInfo::KeyTy const&, std::pair<llvm::DenseMapAPFloatKeyInfo::KeyTy, llvm::ConstantFP*>*&) const"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_22DenseMapAPFloatKeyInfo5KeyTyEPNS_10ConstantFPES1_NS_12DenseMapInfoIS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<llvm::DenseMapAPFloatKeyInfo::KeyTy, llvm::ConstantFP*, llvm::DenseMapAPFloatKeyInfo, llvm::DenseMapInfo<llvm::ConstantFP*> >::InsertIntoBucket(llvm::DenseMapAPFloatKeyInfo::KeyTy const&, llvm::ConstantFP* const&, std::pair<llvm::DenseMapAPFloatKeyInfo::KeyTy, llvm::ConstantFP*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_22DenseMapAPFloatKeyInfo5KeyTyEPNS_10ConstantFPES1_NS_12DenseMapInfoIS4_EEE4growEj", "llvm::DenseMap<llvm::DenseMapAPFloatKeyInfo::KeyTy, llvm::ConstantFP*, llvm::DenseMapAPFloatKeyInfo, llvm::DenseMapInfo<llvm::ConstantFP*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNK4llvm8DenseMapINS_20DenseMapAPIntKeyInfo5KeyTyEPNS_11ConstantIntES1_NS_12DenseMapInfoIS4_EEE15LookupBucketForERKS2_RPSt4pairIS2_S4_E", "llvm::DenseMap<llvm::DenseMapAPIntKeyInfo::KeyTy, llvm::ConstantInt*, llvm::DenseMapAPIntKeyInfo, llvm::DenseMapInfo<llvm::ConstantInt*> >::LookupBucketFor(llvm::DenseMapAPIntKeyInfo::KeyTy const&, std::pair<llvm::DenseMapAPIntKeyInfo::KeyTy, llvm::ConstantInt*>*&) const"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_20DenseMapAPIntKeyInfo5KeyTyEPNS_11ConstantIntES1_NS_12DenseMapInfoIS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<llvm::DenseMapAPIntKeyInfo::KeyTy, llvm::ConstantInt*, llvm::DenseMapAPIntKeyInfo, llvm::DenseMapInfo<llvm::ConstantInt*> >::InsertIntoBucket(llvm::DenseMapAPIntKeyInfo::KeyTy const&, llvm::ConstantInt* const&, std::pair<llvm::DenseMapAPIntKeyInfo::KeyTy, llvm::ConstantInt*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_20DenseMapAPIntKeyInfo5KeyTyEPNS_11ConstantIntES1_NS_12DenseMapInfoIS4_EEE4growEj", "llvm::DenseMap<llvm::DenseMapAPIntKeyInfo::KeyTy, llvm::ConstantInt*, llvm::DenseMapAPIntKeyInfo, llvm::DenseMapInfo<llvm::ConstantInt*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm8ConstantESaIS2_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS2_S4_EEmRKS2_", "std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >::_M_fill_insert(__gnu_cxx::__normal_iterator<llvm::Constant**, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > >, unsigned long, llvm::Constant* const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm10DebugRecVHESaIS1_EE7reserveEm", "std::vector<llvm::DebugRecVH, std::allocator<llvm::DebugRecVH> >::reserve(unsigned long)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN4llvm10DebugRecVHES2_ESaIS3_EE7reserveEm", "std::vector<std::pair<llvm::DebugRecVH, llvm::DebugRecVH>, std::allocator<std::pair<llvm::DebugRecVH, llvm::DebugRecVH> > >::reserve(unsigned long)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN4llvm10DebugRecVHES2_ESaIS3_EE9push_backERKS3_", "std::vector<std::pair<llvm::DebugRecVH, llvm::DebugRecVH>, std::allocator<std::pair<llvm::DebugRecVH, llvm::DebugRecVH> > >::push_back(std::pair<llvm::DebugRecVH, llvm::DebugRecVH> const&)"),
	mu_demangle_test("_ZNK4llvm8DenseMapISt4pairIPNS_6MDNodeES3_EiNS_12DenseMapInfoIS4_EENS5_IiEEE15LookupBucketForERKS4_RPS1_IS4_iE", "llvm::DenseMap<std::pair<llvm::MDNode*, llvm::MDNode*>, int, llvm::DenseMapInfo<std::pair<llvm::MDNode*, llvm::MDNode*> >, llvm::DenseMapInfo<int> >::LookupBucketFor(std::pair<llvm::MDNode*, llvm::MDNode*> const&, std::pair<std::pair<llvm::MDNode*, llvm::MDNode*>, int>*&) const"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN4llvm10DebugRecVHES2_ESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<std::pair<llvm::DebugRecVH, llvm::DebugRecVH>, std::allocator<std::pair<llvm::DebugRecVH, llvm::DebugRecVH> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::DebugRecVH, llvm::DebugRecVH>*, std::vector<std::pair<llvm::DebugRecVH, llvm::DebugRecVH>, std::allocator<std::pair<llvm::DebugRecVH, llvm::DebugRecVH> > > >, std::pair<llvm::DebugRecVH, llvm::DebugRecVH> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPNS_6MDNodeES3_EiNS_12DenseMapInfoIS4_EENS5_IiEEE16InsertIntoBucketERKS4_RKiPS1_IS4_iE", "llvm::DenseMap<std::pair<llvm::MDNode*, llvm::MDNode*>, int, llvm::DenseMapInfo<std::pair<llvm::MDNode*, llvm::MDNode*> >, llvm::DenseMapInfo<int> >::InsertIntoBucket(std::pair<llvm::MDNode*, llvm::MDNode*> const&, int const&, std::pair<std::pair<llvm::MDNode*, llvm::MDNode*>, int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapISt4pairIPNS_6MDNodeES3_EiNS_12DenseMapInfoIS4_EENS5_IiEEE4growEj", "llvm::DenseMap<std::pair<llvm::MDNode*, llvm::MDNode*>, int, llvm::DenseMapInfo<std::pair<llvm::MDNode*, llvm::MDNode*> >, llvm::DenseMapInfo<int> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm10DebugRecVHESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<llvm::DebugRecVH, std::allocator<llvm::DebugRecVH> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::DebugRecVH*, std::vector<llvm::DebugRecVH, std::allocator<llvm::DebugRecVH> > >, llvm::DebugRecVH const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm10DebugRecVHESaIS1_EE20_M_allocate_and_copyIPS1_EES5_mT_S6_", "llvm::DebugRecVH* std::vector<llvm::DebugRecVH, std::allocator<llvm::DebugRecVH> >::_M_allocate_and_copy<llvm::DebugRecVH*>(unsigned long, llvm::DebugRecVH*, llvm::DebugRecVH*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_6MDNodeEiNS_12DenseMapInfoIS2_EENS3_IiEEE16InsertIntoBucketERKS2_RKiPSt4pairIS2_iE", "llvm::DenseMap<llvm::MDNode*, int, llvm::DenseMapInfo<llvm::MDNode*>, llvm::DenseMapInfo<int> >::InsertIntoBucket(llvm::MDNode* const&, int const&, std::pair<llvm::MDNode*, int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_6MDNodeEiNS_12DenseMapInfoIS2_EENS3_IiEEE4growEj", "llvm::DenseMap<llvm::MDNode*, int, llvm::DenseMapInfo<llvm::MDNode*>, llvm::DenseMapInfo<int> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm9CalculateINS_8FunctionENS_7InverseIPNS_10BasicBlockEEEEEvRNS_17DominatorTreeBaseINS_11GraphTraitsIT0_E8NodeTypeEEERT_", "void llvm::Calculate<llvm::Function, llvm::Inverse<llvm::BasicBlock*> >(llvm::DominatorTreeBase<llvm::GraphTraits<llvm::Inverse<llvm::BasicBlock*> >::NodeType>&, llvm::Function&)"),
	mu_demangle_test("_ZN4llvm7DFSPassINS_11GraphTraitsINS_7InverseIPNS_10BasicBlockEEEEEEEjRNS_17DominatorTreeBaseINT_8NodeTypeEEEPS9_j", "unsigned int llvm::DFSPass<llvm::GraphTraits<llvm::Inverse<llvm::BasicBlock*> > >(llvm::DominatorTreeBase<llvm::GraphTraits<llvm::Inverse<llvm::BasicBlock*> >::NodeType>&, llvm::GraphTraits<llvm::Inverse<llvm::BasicBlock*> >::NodeType*, unsigned int)"),
	mu_demangle_test("_ZN4llvm4EvalINS_11GraphTraitsINS_7InverseIPNS_10BasicBlockEEEEEEEPNT_8NodeTypeERNS_17DominatorTreeBaseIS8_EES9_j", "llvm::GraphTraits<llvm::Inverse<llvm::BasicBlock*> >::NodeType* llvm::Eval<llvm::GraphTraits<llvm::Inverse<llvm::BasicBlock*> > >(llvm::DominatorTreeBase<llvm::GraphTraits<llvm::Inverse<llvm::BasicBlock*> >::NodeType>&, llvm::GraphTraits<llvm::Inverse<llvm::BasicBlock*> >::NodeType*, unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockENS_17DominatorTreeBaseIS1_E7InfoRecENS_12DenseMapInfoIS2_EENS6_IS5_EEE16shrink_and_clearEv", "llvm::DenseMap<llvm::BasicBlock*, llvm::DominatorTreeBase<llvm::BasicBlock>::InfoRec, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::DominatorTreeBase<llvm::BasicBlock>::InfoRec> >::shrink_and_clear()"),
	mu_demangle_test("_ZN4llvm23SmallVectorTemplateBaseISt4pairIPNS_10BasicBlockENS_12PredIteratorIS2_NS_18value_use_iteratorINS_4UserEEEEEELb0EE4growEm", "llvm::SmallVectorTemplateBase<std::pair<llvm::BasicBlock*, llvm::PredIterator<llvm::BasicBlock, llvm::value_use_iterator<llvm::User> > >, false>::grow(unsigned long)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockENS_17DominatorTreeBaseIS1_E7InfoRecENS_12DenseMapInfoIS2_EENS6_IS5_EEE16InsertIntoBucketERKS2_RKS5_PSt4pairIS2_S5_E", "llvm::DenseMap<llvm::BasicBlock*, llvm::DominatorTreeBase<llvm::BasicBlock>::InfoRec, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::DominatorTreeBase<llvm::BasicBlock>::InfoRec> >::InsertIntoBucket(llvm::BasicBlock* const&, llvm::DominatorTreeBase<llvm::BasicBlock>::InfoRec const&, std::pair<llvm::BasicBlock*, llvm::DominatorTreeBase<llvm::BasicBlock>::InfoRec>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_10BasicBlockENS_17DominatorTreeBaseIS1_E7InfoRecENS_12DenseMapInfoIS2_EENS6_IS5_EEE4growEj", "llvm::DenseMap<llvm::BasicBlock*, llvm::DominatorTreeBase<llvm::BasicBlock>::InfoRec, llvm::DenseMapInfo<llvm::BasicBlock*>, llvm::DenseMapInfo<llvm::DominatorTreeBase<llvm::BasicBlock>::InfoRec> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm7DFSPassINS_11GraphTraitsIPNS_10BasicBlockEEEEEjRNS_17DominatorTreeBaseINT_8NodeTypeEEEPS7_j", "unsigned int llvm::DFSPass<llvm::GraphTraits<llvm::BasicBlock*> >(llvm::DominatorTreeBase<llvm::GraphTraits<llvm::BasicBlock*>::NodeType>&, llvm::GraphTraits<llvm::BasicBlock*>::NodeType*, unsigned int)"),
	mu_demangle_test("_ZN4llvm4EvalINS_11GraphTraitsIPNS_10BasicBlockEEEEEPNT_8NodeTypeERNS_17DominatorTreeBaseIS6_EES7_j", "llvm::GraphTraits<llvm::BasicBlock*>::NodeType* llvm::Eval<llvm::GraphTraits<llvm::BasicBlock*> >(llvm::DominatorTreeBase<llvm::GraphTraits<llvm::BasicBlock*>::NodeType>&, llvm::GraphTraits<llvm::BasicBlock*>::NodeType*, unsigned int)"),
	mu_demangle_test("_ZN4llvm23SmallVectorTemplateBaseISt4pairIPNS_10BasicBlockENS_12SuccIteratorIPNS_14TerminatorInstES2_EEELb0EE4growEm", "llvm::SmallVectorTemplateBase<std::pair<llvm::BasicBlock*, llvm::SuccIterator<llvm::TerminatorInst*, llvm::BasicBlock> >, false>::grow(unsigned long)"),
	mu_demangle_test("_ZN4llvm6iplistINS_8ArgumentENS_12ilist_traitsIS1_EEE5clearEv", "llvm::iplist<llvm::Argument, llvm::ilist_traits<llvm::Argument> >::clear()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_8FunctionENS_15PooledStringPtrENS_12DenseMapInfoIS3_EENS5_IS4_EEE5eraseERKS3_", "llvm::DenseMap<llvm::Function const*, llvm::PooledStringPtr, llvm::DenseMapInfo<llvm::Function const*>, llvm::DenseMapInfo<llvm::PooledStringPtr> >::erase(llvm::Function const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_8FunctionENS_15PooledStringPtrENS_12DenseMapInfoIS3_EENS5_IS4_EEED2Ev", "llvm::DenseMap<llvm::Function const*, llvm::PooledStringPtr, llvm::DenseMapInfo<llvm::Function const*>, llvm::DenseMapInfo<llvm::PooledStringPtr> >::~DenseMap()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_8FunctionENS_15PooledStringPtrENS_12DenseMapInfoIS3_EENS5_IS4_EEE16FindAndConstructERKS3_", "llvm::DenseMap<llvm::Function const*, llvm::PooledStringPtr, llvm::DenseMapInfo<llvm::Function const*>, llvm::DenseMapInfo<llvm::PooledStringPtr> >::FindAndConstruct(llvm::Function const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_8FunctionENS_15PooledStringPtrENS_12DenseMapInfoIS3_EENS5_IS4_EEE16InsertIntoBucketERKS3_RKS4_PSt4pairIS3_S4_E", "llvm::DenseMap<llvm::Function const*, llvm::PooledStringPtr, llvm::DenseMapInfo<llvm::Function const*>, llvm::DenseMapInfo<llvm::PooledStringPtr> >::InsertIntoBucket(llvm::Function const* const&, llvm::PooledStringPtr const&, std::pair<llvm::Function const*, llvm::PooledStringPtr>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_8FunctionENS_15PooledStringPtrENS_12DenseMapInfoIS3_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::Function const*, llvm::PooledStringPtr, llvm::DenseMapInfo<llvm::Function const*>, llvm::DenseMapInfo<llvm::PooledStringPtr> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm14object_creatorINS_3sys12SmartRWMutexILb1EEEEEPvv", "void* llvm::object_creator<llvm::sys::SmartRWMutex<true> >()"),
	mu_demangle_test("_ZN4llvm14object_deleterINS_3sys12SmartRWMutexILb1EEEE4callEPv", "llvm::object_deleter<llvm::sys::SmartRWMutex<true> >::call(void*)"),
	mu_demangle_test("_ZN4llvm6iplistINS_10BasicBlockENS_12ilist_traitsIS1_EEE5eraseENS_14ilist_iteratorIS1_EE", "llvm::iplist<llvm::BasicBlock, llvm::ilist_traits<llvm::BasicBlock> >::erase(llvm::ilist_iterator<llvm::BasicBlock>)"),
	mu_demangle_test("_ZN4llvm6iplistINS_14GlobalVariableENS_12ilist_traitsIS1_EEE9push_backEPS1_", "llvm::iplist<llvm::GlobalVariable, llvm::ilist_traits<llvm::GlobalVariable> >::push_back(llvm::GlobalVariable*)"),
	mu_demangle_test("_ZN4llvm6iplistINS_11GlobalAliasENS_12ilist_traitsIS1_EEE9push_backEPS1_", "llvm::iplist<llvm::GlobalAlias, llvm::ilist_traits<llvm::GlobalAlias> >::push_back(llvm::GlobalAlias*)"),
	mu_demangle_test("_ZN4llvm9InlineAsm14ConstraintInfo5ParseENS_9StringRefERSt6vectorIS1_SaIS1_EE", "llvm::InlineAsm::ConstraintInfo::Parse(llvm::StringRef, std::vector<llvm::InlineAsm::ConstraintInfo, std::allocator<llvm::InlineAsm::ConstraintInfo> >&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm9InlineAsm14ConstraintInfoESaIS2_EE9push_backERKS2_", "std::vector<llvm::InlineAsm::ConstraintInfo, std::allocator<llvm::InlineAsm::ConstraintInfo> >::push_back(llvm::InlineAsm::ConstraintInfo const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm9InlineAsm14ConstraintInfoESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::InlineAsm::ConstraintInfo, std::allocator<llvm::InlineAsm::ConstraintInfo> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::InlineAsm::ConstraintInfo*, std::vector<llvm::InlineAsm::ConstraintInfo, std::allocator<llvm::InlineAsm::ConstraintInfo> > >, llvm::InlineAsm::ConstraintInfo const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm9InlineAsm14ConstraintInfoESaIS2_EE15_M_erase_at_endEPS2_", "std::vector<llvm::InlineAsm::ConstraintInfo, std::allocator<llvm::InlineAsm::ConstraintInfo> >::_M_erase_at_end(llvm::InlineAsm::ConstraintInfo*)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm9InlineAsm17SubConstraintInfoESaIS2_EE15_M_erase_at_endEPS2_", "std::vector<llvm::InlineAsm::SubConstraintInfo, std::allocator<llvm::InlineAsm::SubConstraintInfo> >::_M_erase_at_end(llvm::InlineAsm::SubConstraintInfo*)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm9InlineAsm17SubConstraintInfoESaIS2_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS2_S4_EEmRKS2_", "std::vector<llvm::InlineAsm::SubConstraintInfo, std::allocator<llvm::InlineAsm::SubConstraintInfo> >::_M_fill_insert(__gnu_cxx::__normal_iterator<llvm::InlineAsm::SubConstraintInfo*, std::vector<llvm::InlineAsm::SubConstraintInfo, std::allocator<llvm::InlineAsm::SubConstraintInfo> > >, unsigned long, llvm::InlineAsm::SubConstraintInfo const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm9InlineAsm17SubConstraintInfoESaIS2_EEC2ERKS4_", "std::vector<llvm::InlineAsm::SubConstraintInfo, std::allocator<llvm::InlineAsm::SubConstraintInfo> >::vector(std::vector<llvm::InlineAsm::SubConstraintInfo, std::allocator<llvm::InlineAsm::SubConstraintInfo> > const&)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapINS_16InlineAsmKeyTypeENS_11PointerTypeENS_9InlineAsmELb0EE6CreateEPKS2_RKS1_St17_Rb_tree_iteratorISt4pairIKSA_IS6_S1_EPS3_EE", "llvm::ConstantUniqueMap<llvm::InlineAsmKeyType, llvm::PointerType, llvm::InlineAsm, false>::Create(llvm::PointerType const*, llvm::InlineAsmKeyType const&, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm11PointerTypeENS1_16InlineAsmKeyTypeEES0_IKS6_PNS1_9InlineAsmEESt10_Select1stISA_ESt4lessIS6_ESaISA_EE16_M_insert_uniqueESt17_Rb_tree_iteratorISA_ERKSA_", "std::_Rb_tree<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType>, std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*>, std::_Select1st<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> >, std::less<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> >, std::allocator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> >, std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> const&)"),
	mu_demangle_test("_ZN4llvm15SmallVectorImplIPNS_6MDNodeEE6appendINS_19SmallPtrSetIteratorIS2_EEEEvT_S7_", "void llvm::SmallVectorImpl<llvm::MDNode*>::append<llvm::SmallPtrSetIterator<llvm::MDNode*> >(llvm::SmallPtrSetIterator<llvm::MDNode*>, llvm::SmallPtrSetIterator<llvm::MDNode*>)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_10VectorTypeENS_14ConstantVectorELb0EED1Ev", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::VectorType, llvm::ConstantVector, false>::~ConstantUniqueMap()"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_10StructTypeENS_14ConstantStructELb1EED1Ev", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::StructType, llvm::ConstantStruct, true>::~ConstantUniqueMap()"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_9ArrayTypeENS_13ConstantArrayELb1EED1Ev", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::ArrayType, llvm::ConstantArray, true>::~ConstantUniqueMap()"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm6ModuleESaIS2_EE19_M_range_initializeINS0_19SmallPtrSetIteratorIS2_EEEEvT_S8_St20forward_iterator_tag", "void std::vector<llvm::Module*, std::allocator<llvm::Module*> >::_M_range_initialize<llvm::SmallPtrSetIterator<llvm::Module*> >(llvm::SmallPtrSetIterator<llvm::Module*>, llvm::SmallPtrSetIterator<llvm::Module*>, std::forward_iterator_tag)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_11InstructionENS_11SmallVectorISt4pairIjNS_10TrackingVHINS_6MDNodeEEEELj2EEENS_12DenseMapInfoIS3_EENSB_ISA_EEED2Ev", "llvm::DenseMap<llvm::Instruction const*, llvm::SmallVector<std::pair<unsigned int, llvm::TrackingVH<llvm::MDNode> >, 2u>, llvm::DenseMapInfo<llvm::Instruction const*>, llvm::DenseMapInfo<llvm::SmallVector<std::pair<unsigned int, llvm::TrackingVH<llvm::MDNode> >, 2u> > >::~DenseMap()"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_22DenseMapAPFloatKeyInfo5KeyTyEPNS_10ConstantFPES1_NS_12DenseMapInfoIS4_EEED2Ev", "llvm::DenseMap<llvm::DenseMapAPFloatKeyInfo::KeyTy, llvm::ConstantFP*, llvm::DenseMapAPFloatKeyInfo, llvm::DenseMapInfo<llvm::ConstantFP*> >::~DenseMap()"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_20DenseMapAPIntKeyInfo5KeyTyEPNS_11ConstantIntES1_NS_12DenseMapInfoIS4_EEED2Ev", "llvm::DenseMap<llvm::DenseMapAPIntKeyInfo::KeyTy, llvm::ConstantInt*, llvm::DenseMapAPIntKeyInfo, llvm::DenseMapInfo<llvm::ConstantInt*> >::~DenseMap()"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_22DenseMapAPFloatKeyInfo5KeyTyEPNS_10ConstantFPES1_NS_12DenseMapInfoIS4_EEE4initEj", "llvm::DenseMap<llvm::DenseMapAPFloatKeyInfo::KeyTy, llvm::ConstantFP*, llvm::DenseMapAPFloatKeyInfo, llvm::DenseMapInfo<llvm::ConstantFP*> >::init(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapINS_20DenseMapAPIntKeyInfo5KeyTyEPNS_11ConstantIntES1_NS_12DenseMapInfoIS4_EEE4initEj", "llvm::DenseMap<llvm::DenseMapAPIntKeyInfo::KeyTy, llvm::ConstantInt*, llvm::DenseMapAPIntKeyInfo, llvm::DenseMapInfo<llvm::ConstantInt*> >::init(unsigned int)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapIcNS_4TypeENS_21ConstantAggregateZeroELb0EE21UpdateAbstractTypeMapEPKNS_11DerivedTypeESt17_Rb_tree_iteratorISt4pairIKS8_IPKS1_cEPS2_EE", "llvm::ConstantUniqueMap<char, llvm::Type, llvm::ConstantAggregateZero, false>::UpdateAbstractTypeMap(llvm::DerivedType const*, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_4TypeEcEPNS0_21ConstantAggregateZeroEEEESt10_Select1stISG_ESt4lessIS3_ESaISG_EE16_M_insert_uniqueES6_ISG_ERKSG_", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> > > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> > > >, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_4TypeEcEPNS0_21ConstantAggregateZeroEEEESt10_Select1stISG_ESt4lessIS3_ESaISG_EE16_M_insert_uniqueERKSG_", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> > > > >::_M_insert_unique(std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_4TypeEcEPNS0_21ConstantAggregateZeroEEEESt10_Select1stISG_ESt4lessIS3_ESaISG_EE5eraseES6_ISG_ESN_", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> > > > >::erase(std::_Rb_tree_iterator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> > > >, std::_Rb_tree_iterator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> > > >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_4TypeEcEPNS0_21ConstantAggregateZeroEEEESt10_Select1stISG_ESt4lessIS3_ESaISG_EE8_M_eraseEPSt13_Rb_tree_nodeISG_E", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> > > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> > > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm4TypeEcES0_IKS5_PNS1_21ConstantAggregateZeroEESt10_Select1stIS9_ESt4lessIS5_ESaIS9_EE16_M_insert_uniqueERKS9_", "std::_Rb_tree<std::pair<llvm::Type const*, char>, std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*>, std::_Select1st<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> >, std::less<std::pair<llvm::Type const*, char> >, std::allocator<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> > >::_M_insert_unique(std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm4TypeEcES0_IKS5_PNS1_21ConstantAggregateZeroEESt10_Select1stIS9_ESt4lessIS5_ESaIS9_EE8_M_eraseEPSt13_Rb_tree_nodeIS9_E", "std::_Rb_tree<std::pair<llvm::Type const*, char>, std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*>, std::_Select1st<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> >, std::less<std::pair<llvm::Type const*, char> >, std::allocator<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> > >::_M_erase(std::_Rb_tree_node<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm21ConstantAggregateZeroESt4pairIKS2_St17_Rb_tree_iteratorIS3_IKS3_IPKNS0_4TypeEcES2_EEESt10_Select1stISD_ESt4lessIS2_ESaISD_EE8_M_eraseEPSt13_Rb_tree_nodeISD_E", "std::_Rb_tree<llvm::ConstantAggregateZero*, std::pair<llvm::ConstantAggregateZero* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> > >, std::_Select1st<std::pair<llvm::ConstantAggregateZero* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> > > >, std::less<llvm::ConstantAggregateZero*>, std::allocator<std::pair<llvm::ConstantAggregateZero* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> > > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::ConstantAggregateZero* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::ConstantAggregateZero*> > > >*)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_9ArrayTypeENS_13ConstantArrayELb1EED0Ev", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::ArrayType, llvm::ConstantArray, true>::~ConstantUniqueMap()"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_9ArrayTypeENS_13ConstantArrayELb1EE18refineAbstractTypeEPKNS_11DerivedTypeEPKNS_4TypeE", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::ArrayType, llvm::ConstantArray, true>::refineAbstractType(llvm::DerivedType const*, llvm::Type const*)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_9ArrayTypeENS_13ConstantArrayELb1EE18typeBecameConcreteEPKNS_11DerivedTypeE", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::ArrayType, llvm::ConstantArray, true>::typeBecameConcrete(llvm::DerivedType const*)"),
	mu_demangle_test("_ZNK4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_9ArrayTypeENS_13ConstantArrayELb1EE4dumpEv", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::ArrayType, llvm::ConstantArray, true>::dump() const"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_9ArrayTypeENS_13ConstantArrayELb1EE21UpdateAbstractTypeMapEPKNS_11DerivedTypeESt17_Rb_tree_iteratorISt4pairIKSD_IPKS6_S5_EPS7_EE", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::ArrayType, llvm::ConstantArray, true>::UpdateAbstractTypeMap(llvm::DerivedType const*, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_9ArrayTypeESt6vectorIPNS0_8ConstantESaISC_EEEPNS0_13ConstantArrayEEEESt10_Select1stISL_ESt4lessIS3_ESaISL_EE16_M_insert_uniqueES6_ISL_ERKSL_", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > > >, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_9ArrayTypeESt6vectorIPNS0_8ConstantESaISC_EEEPNS0_13ConstantArrayEEEESt10_Select1stISL_ESt4lessIS3_ESaISL_EE16_M_insert_uniqueERKSL_", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > > > >::_M_insert_unique(std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm13ConstantArrayESt4pairIKS2_St17_Rb_tree_iteratorIS3_IKS3_IPKNS0_9ArrayTypeESt6vectorIPNS0_8ConstantESaISB_EEES2_EEESt10_Select1stISI_ESt4lessIS2_ESaISI_EE16_M_insert_uniqueES5_ISI_ERKSI_", "std::_Rb_tree<llvm::ConstantArray*, std::pair<llvm::ConstantArray* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > >, std::_Select1st<std::pair<llvm::ConstantArray* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > > >, std::less<llvm::ConstantArray*>, std::allocator<std::pair<llvm::ConstantArray* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::ConstantArray* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > > >, std::pair<llvm::ConstantArray* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm13ConstantArrayESt4pairIKS2_St17_Rb_tree_iteratorIS3_IKS3_IPKNS0_9ArrayTypeESt6vectorIPNS0_8ConstantESaISB_EEES2_EEESt10_Select1stISI_ESt4lessIS2_ESaISI_EE16_M_insert_uniqueERKSI_", "std::_Rb_tree<llvm::ConstantArray*, std::pair<llvm::ConstantArray* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > >, std::_Select1st<std::pair<llvm::ConstantArray* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > > >, std::less<llvm::ConstantArray*>, std::allocator<std::pair<llvm::ConstantArray* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > > > >::_M_insert_unique(std::pair<llvm::ConstantArray* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_9ArrayTypeESt6vectorIPNS0_8ConstantESaISC_EEEPNS0_13ConstantArrayEEEESt10_Select1stISL_ESt4lessIS3_ESaISL_EE5eraseES6_ISL_ESS_", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > > > >::erase(std::_Rb_tree_iterator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > > >, std::_Rb_tree_iterator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > > >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_9ArrayTypeESt6vectorIPNS0_8ConstantESaISC_EEEPNS0_13ConstantArrayEEEESt10_Select1stISL_ESt4lessIS3_ESaISL_EE8_M_eraseEPSt13_Rb_tree_nodeISL_E", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm9ArrayTypeESt6vectorIPNS1_8ConstantESaIS7_EEES0_IKSA_PNS1_13ConstantArrayEESt10_Select1stISE_ESt4lessISA_ESaISE_EE4findERSB_", "std::_Rb_tree<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > >, std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*>, std::_Select1st<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> >, std::less<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > >, std::allocator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > >::find(std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm9ArrayTypeESt6vectorIPNS1_8ConstantESaIS7_EEES0_IKSA_PNS1_13ConstantArrayEESt10_Select1stISE_ESt4lessISA_ESaISE_EE16_M_insert_uniqueERKSE_", "std::_Rb_tree<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > >, std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*>, std::_Select1st<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> >, std::less<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > >, std::allocator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > >::_M_insert_unique(std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm9ArrayTypeESt6vectorIPNS1_8ConstantESaIS7_EEES0_IKSA_PNS1_13ConstantArrayEESt10_Select1stISE_ESt4lessISA_ESaISE_EE9_M_insertEPSt18_Rb_tree_node_baseSM_RKSE_", "std::_Rb_tree<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > >, std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*>, std::_Select1st<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> >, std::less<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > >, std::allocator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm9ArrayTypeESt6vectorIPNS1_8ConstantESaIS7_EEES0_IKSA_PNS1_13ConstantArrayEESt10_Select1stISE_ESt4lessISA_ESaISE_EE14_M_create_nodeERKSE_", "std::_Rb_tree<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > >, std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*>, std::_Select1st<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> >, std::less<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > >, std::allocator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > >::_M_create_node(std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm8ConstantESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::Constant**, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > >, llvm::Constant* const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm9ArrayTypeESt6vectorIPNS1_8ConstantESaIS7_EEES0_IKSA_PNS1_13ConstantArrayEESt10_Select1stISE_ESt4lessISA_ESaISE_EE8_M_eraseEPSt13_Rb_tree_nodeISE_E", "std::_Rb_tree<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > >, std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*>, std::_Select1st<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> >, std::less<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > >, std::allocator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > >::_M_erase(std::_Rb_tree_node<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm13ConstantArrayESt4pairIKS2_St17_Rb_tree_iteratorIS3_IKS3_IPKNS0_9ArrayTypeESt6vectorIPNS0_8ConstantESaISB_EEES2_EEESt10_Select1stISI_ESt4lessIS2_ESaISI_EE8_M_eraseEPSt13_Rb_tree_nodeISI_E", "std::_Rb_tree<llvm::ConstantArray*, std::pair<llvm::ConstantArray* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > >, std::_Select1st<std::pair<llvm::ConstantArray* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > > >, std::less<llvm::ConstantArray*>, std::allocator<std::pair<llvm::ConstantArray* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::ConstantArray* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::ArrayType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantArray*> > > >*)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_10StructTypeENS_14ConstantStructELb1EED0Ev", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::StructType, llvm::ConstantStruct, true>::~ConstantUniqueMap()"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_10StructTypeENS_14ConstantStructELb1EE18refineAbstractTypeEPKNS_11DerivedTypeEPKNS_4TypeE", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::StructType, llvm::ConstantStruct, true>::refineAbstractType(llvm::DerivedType const*, llvm::Type const*)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_10StructTypeENS_14ConstantStructELb1EE18typeBecameConcreteEPKNS_11DerivedTypeE", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::StructType, llvm::ConstantStruct, true>::typeBecameConcrete(llvm::DerivedType const*)"),
	mu_demangle_test("_ZNK4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_10StructTypeENS_14ConstantStructELb1EE4dumpEv", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::StructType, llvm::ConstantStruct, true>::dump() const"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_10StructTypeENS_14ConstantStructELb1EE21UpdateAbstractTypeMapEPKNS_11DerivedTypeESt17_Rb_tree_iteratorISt4pairIKSD_IPKS6_S5_EPS7_EE", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::StructType, llvm::ConstantStruct, true>::UpdateAbstractTypeMap(llvm::DerivedType const*, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_10StructTypeESt6vectorIPNS0_8ConstantESaISC_EEEPNS0_14ConstantStructEEEESt10_Select1stISL_ESt4lessIS3_ESaISL_EE16_M_insert_uniqueES6_ISL_ERKSL_", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > > >, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_10StructTypeESt6vectorIPNS0_8ConstantESaISC_EEEPNS0_14ConstantStructEEEESt10_Select1stISL_ESt4lessIS3_ESaISL_EE16_M_insert_uniqueERKSL_", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > > > >::_M_insert_unique(std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm14ConstantStructESt4pairIKS2_St17_Rb_tree_iteratorIS3_IKS3_IPKNS0_10StructTypeESt6vectorIPNS0_8ConstantESaISB_EEES2_EEESt10_Select1stISI_ESt4lessIS2_ESaISI_EE16_M_insert_uniqueES5_ISI_ERKSI_", "std::_Rb_tree<llvm::ConstantStruct*, std::pair<llvm::ConstantStruct* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > >, std::_Select1st<std::pair<llvm::ConstantStruct* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > > >, std::less<llvm::ConstantStruct*>, std::allocator<std::pair<llvm::ConstantStruct* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::ConstantStruct* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > > >, std::pair<llvm::ConstantStruct* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm14ConstantStructESt4pairIKS2_St17_Rb_tree_iteratorIS3_IKS3_IPKNS0_10StructTypeESt6vectorIPNS0_8ConstantESaISB_EEES2_EEESt10_Select1stISI_ESt4lessIS2_ESaISI_EE16_M_insert_uniqueERKSI_", "std::_Rb_tree<llvm::ConstantStruct*, std::pair<llvm::ConstantStruct* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > >, std::_Select1st<std::pair<llvm::ConstantStruct* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > > >, std::less<llvm::ConstantStruct*>, std::allocator<std::pair<llvm::ConstantStruct* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > > > >::_M_insert_unique(std::pair<llvm::ConstantStruct* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_10StructTypeESt6vectorIPNS0_8ConstantESaISC_EEEPNS0_14ConstantStructEEEESt10_Select1stISL_ESt4lessIS3_ESaISL_EE5eraseES6_ISL_ESS_", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > > > >::erase(std::_Rb_tree_iterator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > > >, std::_Rb_tree_iterator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > > >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_10StructTypeESt6vectorIPNS0_8ConstantESaISC_EEEPNS0_14ConstantStructEEEESt10_Select1stISL_ESt4lessIS3_ESaISL_EE8_M_eraseEPSt13_Rb_tree_nodeISL_E", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm10StructTypeESt6vectorIPNS1_8ConstantESaIS7_EEES0_IKSA_PNS1_14ConstantStructEESt10_Select1stISE_ESt4lessISA_ESaISE_EE4findERSB_", "std::_Rb_tree<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > >, std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*>, std::_Select1st<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> >, std::less<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > >, std::allocator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > >::find(std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm10StructTypeESt6vectorIPNS1_8ConstantESaIS7_EEES0_IKSA_PNS1_14ConstantStructEESt10_Select1stISE_ESt4lessISA_ESaISE_EE16_M_insert_uniqueERKSE_", "std::_Rb_tree<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > >, std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*>, std::_Select1st<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> >, std::less<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > >, std::allocator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > >::_M_insert_unique(std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm10StructTypeESt6vectorIPNS1_8ConstantESaIS7_EEES0_IKSA_PNS1_14ConstantStructEESt10_Select1stISE_ESt4lessISA_ESaISE_EE9_M_insertEPSt18_Rb_tree_node_baseSM_RKSE_", "std::_Rb_tree<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > >, std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*>, std::_Select1st<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> >, std::less<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > >, std::allocator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm10StructTypeESt6vectorIPNS1_8ConstantESaIS7_EEES0_IKSA_PNS1_14ConstantStructEESt10_Select1stISE_ESt4lessISA_ESaISE_EE14_M_create_nodeERKSE_", "std::_Rb_tree<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > >, std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*>, std::_Select1st<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> >, std::less<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > >, std::allocator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > >::_M_create_node(std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm10StructTypeESt6vectorIPNS1_8ConstantESaIS7_EEES0_IKSA_PNS1_14ConstantStructEESt10_Select1stISE_ESt4lessISA_ESaISE_EE8_M_eraseEPSt13_Rb_tree_nodeISE_E", "std::_Rb_tree<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > >, std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*>, std::_Select1st<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> >, std::less<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > >, std::allocator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > >::_M_erase(std::_Rb_tree_node<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm14ConstantStructESt4pairIKS2_St17_Rb_tree_iteratorIS3_IKS3_IPKNS0_10StructTypeESt6vectorIPNS0_8ConstantESaISB_EEES2_EEESt10_Select1stISI_ESt4lessIS2_ESaISI_EE8_M_eraseEPSt13_Rb_tree_nodeISI_E", "std::_Rb_tree<llvm::ConstantStruct*, std::pair<llvm::ConstantStruct* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > >, std::_Select1st<std::pair<llvm::ConstantStruct* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > > >, std::less<llvm::ConstantStruct*>, std::allocator<std::pair<llvm::ConstantStruct* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::ConstantStruct* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::StructType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantStruct*> > > >*)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_10VectorTypeENS_14ConstantVectorELb0EED0Ev", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::VectorType, llvm::ConstantVector, false>::~ConstantUniqueMap()"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_10VectorTypeENS_14ConstantVectorELb0EE18refineAbstractTypeEPKNS_11DerivedTypeEPKNS_4TypeE", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::VectorType, llvm::ConstantVector, false>::refineAbstractType(llvm::DerivedType const*, llvm::Type const*)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_10VectorTypeENS_14ConstantVectorELb0EE18typeBecameConcreteEPKNS_11DerivedTypeE", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::VectorType, llvm::ConstantVector, false>::typeBecameConcrete(llvm::DerivedType const*)"),
	mu_demangle_test("_ZNK4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_10VectorTypeENS_14ConstantVectorELb0EE4dumpEv", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::VectorType, llvm::ConstantVector, false>::dump() const"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_10VectorTypeENS_14ConstantVectorELb0EE21UpdateAbstractTypeMapEPKNS_11DerivedTypeESt17_Rb_tree_iteratorISt4pairIKSD_IPKS6_S5_EPS7_EE", "llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::VectorType, llvm::ConstantVector, false>::UpdateAbstractTypeMap(llvm::DerivedType const*, std::_Rb_tree_iterator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_10VectorTypeESt6vectorIPNS0_8ConstantESaISC_EEEPNS0_14ConstantVectorEEEESt10_Select1stISL_ESt4lessIS3_ESaISL_EE16_M_insert_uniqueES6_ISL_ERKSL_", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> > > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> > > >, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_10VectorTypeESt6vectorIPNS0_8ConstantESaISC_EEEPNS0_14ConstantVectorEEEESt10_Select1stISL_ESt4lessIS3_ESaISL_EE16_M_insert_uniqueERKSL_", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> > > > >::_M_insert_unique(std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_10VectorTypeESt6vectorIPNS0_8ConstantESaISC_EEEPNS0_14ConstantVectorEEEESt10_Select1stISL_ESt4lessIS3_ESaISL_EE5eraseES6_ISL_ESS_", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> > > > >::erase(std::_Rb_tree_iterator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> > > >, std::_Rb_tree_iterator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> > > >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_10VectorTypeESt6vectorIPNS0_8ConstantESaISC_EEEPNS0_14ConstantVectorEEEESt10_Select1stISL_ESt4lessIS3_ESaISL_EE8_M_eraseEPSt13_Rb_tree_nodeISL_E", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> > > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> > > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm10VectorTypeESt6vectorIPNS1_8ConstantESaIS7_EEES0_IKSA_PNS1_14ConstantVectorEESt10_Select1stISE_ESt4lessISA_ESaISE_EE4findERSB_", "std::_Rb_tree<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > >, std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*>, std::_Select1st<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> >, std::less<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > >, std::allocator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> > >::find(std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm10VectorTypeESt6vectorIPNS1_8ConstantESaIS7_EEES0_IKSA_PNS1_14ConstantVectorEESt10_Select1stISE_ESt4lessISA_ESaISE_EE16_M_insert_uniqueERKSE_", "std::_Rb_tree<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > >, std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*>, std::_Select1st<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> >, std::less<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > >, std::allocator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> > >::_M_insert_unique(std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm10VectorTypeESt6vectorIPNS1_8ConstantESaIS7_EEES0_IKSA_PNS1_14ConstantVectorEESt10_Select1stISE_ESt4lessISA_ESaISE_EE9_M_insertEPSt18_Rb_tree_node_baseSM_RKSE_", "std::_Rb_tree<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > >, std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*>, std::_Select1st<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> >, std::less<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > >, std::allocator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm10VectorTypeESt6vectorIPNS1_8ConstantESaIS7_EEES0_IKSA_PNS1_14ConstantVectorEESt10_Select1stISE_ESt4lessISA_ESaISE_EE14_M_create_nodeERKSE_", "std::_Rb_tree<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > >, std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*>, std::_Select1st<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> >, std::less<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > >, std::allocator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> > >::_M_create_node(std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm10VectorTypeESt6vectorIPNS1_8ConstantESaIS7_EEES0_IKSA_PNS1_14ConstantVectorEESt10_Select1stISE_ESt4lessISA_ESaISE_EE8_M_eraseEPSt13_Rb_tree_nodeISE_E", "std::_Rb_tree<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > >, std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*>, std::_Select1st<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> >, std::less<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > >, std::allocator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> > >::_M_erase(std::_Rb_tree_node<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm14ConstantVectorESt4pairIKS2_St17_Rb_tree_iteratorIS3_IKS3_IPKNS0_10VectorTypeESt6vectorIPNS0_8ConstantESaISB_EEES2_EEESt10_Select1stISI_ESt4lessIS2_ESaISI_EE8_M_eraseEPSt13_Rb_tree_nodeISI_E", "std::_Rb_tree<llvm::ConstantVector*, std::pair<llvm::ConstantVector* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> > >, std::_Select1st<std::pair<llvm::ConstantVector* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> > > >, std::less<llvm::ConstantVector*>, std::allocator<std::pair<llvm::ConstantVector* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> > > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::ConstantVector* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::VectorType const*, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > > const, llvm::ConstantVector*> > > >*)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapIcNS_11PointerTypeENS_19ConstantPointerNullELb0EE21UpdateAbstractTypeMapEPKNS_11DerivedTypeESt17_Rb_tree_iteratorISt4pairIKS8_IPKS1_cEPS2_EE", "llvm::ConstantUniqueMap<char, llvm::PointerType, llvm::ConstantPointerNull, false>::UpdateAbstractTypeMap(llvm::DerivedType const*, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_11PointerTypeEcEPNS0_19ConstantPointerNullEEEESt10_Select1stISG_ESt4lessIS3_ESaISG_EE16_M_insert_uniqueES6_ISG_ERKSG_", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> > > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> > > >, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_11PointerTypeEcEPNS0_19ConstantPointerNullEEEESt10_Select1stISG_ESt4lessIS3_ESaISG_EE16_M_insert_uniqueERKSG_", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> > > > >::_M_insert_unique(std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_11PointerTypeEcEPNS0_19ConstantPointerNullEEEESt10_Select1stISG_ESt4lessIS3_ESaISG_EE5eraseES6_ISG_ESN_", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> > > > >::erase(std::_Rb_tree_iterator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> > > >, std::_Rb_tree_iterator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> > > >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_11PointerTypeEcEPNS0_19ConstantPointerNullEEEESt10_Select1stISG_ESt4lessIS3_ESaISG_EE8_M_eraseEPSt13_Rb_tree_nodeISG_E", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> > > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> > > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm11PointerTypeEcES0_IKS5_PNS1_19ConstantPointerNullEESt10_Select1stIS9_ESt4lessIS5_ESaIS9_EE16_M_insert_uniqueERKS9_", "std::_Rb_tree<std::pair<llvm::PointerType const*, char>, std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*>, std::_Select1st<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> >, std::less<std::pair<llvm::PointerType const*, char> >, std::allocator<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> > >::_M_insert_unique(std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm11PointerTypeEcES0_IKS5_PNS1_19ConstantPointerNullEESt10_Select1stIS9_ESt4lessIS5_ESaIS9_EE8_M_eraseEPSt13_Rb_tree_nodeIS9_E", "std::_Rb_tree<std::pair<llvm::PointerType const*, char>, std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*>, std::_Select1st<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> >, std::less<std::pair<llvm::PointerType const*, char> >, std::allocator<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> > >::_M_erase(std::_Rb_tree_node<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm19ConstantPointerNullESt4pairIKS2_St17_Rb_tree_iteratorIS3_IKS3_IPKNS0_11PointerTypeEcES2_EEESt10_Select1stISD_ESt4lessIS2_ESaISD_EE8_M_eraseEPSt13_Rb_tree_nodeISD_E", "std::_Rb_tree<llvm::ConstantPointerNull*, std::pair<llvm::ConstantPointerNull* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> > >, std::_Select1st<std::pair<llvm::ConstantPointerNull* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> > > >, std::less<llvm::ConstantPointerNull*>, std::allocator<std::pair<llvm::ConstantPointerNull* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> > > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::ConstantPointerNull* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, char> const, llvm::ConstantPointerNull*> > > >*)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapIcNS_4TypeENS_10UndefValueELb0EE21UpdateAbstractTypeMapEPKNS_11DerivedTypeESt17_Rb_tree_iteratorISt4pairIKS8_IPKS1_cEPS2_EE", "llvm::ConstantUniqueMap<char, llvm::Type, llvm::UndefValue, false>::UpdateAbstractTypeMap(llvm::DerivedType const*, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_4TypeEcEPNS0_10UndefValueEEEESt10_Select1stISG_ESt4lessIS3_ESaISG_EE16_M_insert_uniqueES6_ISG_ERKSG_", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> > > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> > > >, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_4TypeEcEPNS0_10UndefValueEEEESt10_Select1stISG_ESt4lessIS3_ESaISG_EE16_M_insert_uniqueERKSG_", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> > > > >::_M_insert_unique(std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_4TypeEcEPNS0_10UndefValueEEEESt10_Select1stISG_ESt4lessIS3_ESaISG_EE5eraseES6_ISG_ESN_", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> > > > >::erase(std::_Rb_tree_iterator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> > > >, std::_Rb_tree_iterator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> > > >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_4TypeEcEPNS0_10UndefValueEEEESt10_Select1stISG_ESt4lessIS3_ESaISG_EE8_M_eraseEPSt13_Rb_tree_nodeISG_E", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> > > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> > > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm4TypeEcES0_IKS5_PNS1_10UndefValueEESt10_Select1stIS9_ESt4lessIS5_ESaIS9_EE16_M_insert_uniqueERKS9_", "std::_Rb_tree<std::pair<llvm::Type const*, char>, std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*>, std::_Select1st<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> >, std::less<std::pair<llvm::Type const*, char> >, std::allocator<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> > >::_M_insert_unique(std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm4TypeEcES0_IKS5_PNS1_10UndefValueEESt10_Select1stIS9_ESt4lessIS5_ESaIS9_EE8_M_eraseEPSt13_Rb_tree_nodeIS9_E", "std::_Rb_tree<std::pair<llvm::Type const*, char>, std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*>, std::_Select1st<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> >, std::less<std::pair<llvm::Type const*, char> >, std::allocator<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> > >::_M_erase(std::_Rb_tree_node<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm10UndefValueESt4pairIKS2_St17_Rb_tree_iteratorIS3_IKS3_IPKNS0_4TypeEcES2_EEESt10_Select1stISD_ESt4lessIS2_ESaISD_EE8_M_eraseEPSt13_Rb_tree_nodeISD_E", "std::_Rb_tree<llvm::UndefValue*, std::pair<llvm::UndefValue* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> > >, std::_Select1st<std::pair<llvm::UndefValue* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> > > >, std::less<llvm::UndefValue*>, std::allocator<std::pair<llvm::UndefValue* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> > > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::UndefValue* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, char> const, llvm::UndefValue*> > > >*)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapINS_14ExprMapKeyTypeENS_4TypeENS_12ConstantExprELb0EE21UpdateAbstractTypeMapEPKNS_11DerivedTypeESt17_Rb_tree_iteratorISt4pairIKS9_IPKS2_S1_EPS3_EE", "llvm::ConstantUniqueMap<llvm::ExprMapKeyType, llvm::Type, llvm::ConstantExpr, false>::UpdateAbstractTypeMap(llvm::DerivedType const*, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_4TypeENS0_14ExprMapKeyTypeEEPNS0_12ConstantExprEEEESt10_Select1stISH_ESt4lessIS3_ESaISH_EE16_M_insert_uniqueES6_ISH_ERKSH_", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> > > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> > > >, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_4TypeENS0_14ExprMapKeyTypeEEPNS0_12ConstantExprEEEESt10_Select1stISH_ESt4lessIS3_ESaISH_EE16_M_insert_uniqueERKSH_", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> > > > >::_M_insert_unique(std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_4TypeENS0_14ExprMapKeyTypeEEPNS0_12ConstantExprEEEESt10_Select1stISH_ESt4lessIS3_ESaISH_EE5eraseES6_ISH_ESO_", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> > > > >::erase(std::_Rb_tree_iterator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> > > >, std::_Rb_tree_iterator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> > > >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_4TypeENS0_14ExprMapKeyTypeEEPNS0_12ConstantExprEEEESt10_Select1stISH_ESt4lessIS3_ESaISH_EE8_M_eraseEPSt13_Rb_tree_nodeISH_E", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> > > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> > > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm4TypeENS1_14ExprMapKeyTypeEES0_IKS6_PNS1_12ConstantExprEESt10_Select1stISA_ESt4lessIS6_ESaISA_EE16_M_insert_uniqueERKSA_", "std::_Rb_tree<std::pair<llvm::Type const*, llvm::ExprMapKeyType>, std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*>, std::_Select1st<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> >, std::less<std::pair<llvm::Type const*, llvm::ExprMapKeyType> >, std::allocator<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> > >::_M_insert_unique(std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> const&)"),
	mu_demangle_test("_ZN9__gnu_cxx13new_allocatorISt4pairIKS1_IPKN4llvm4TypeENS2_14ExprMapKeyTypeEEPNS2_12ConstantExprEEE9constructEPSB_RKSB_", "__gnu_cxx::new_allocator<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> >::construct(std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*>*, std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> const&)"),
	mu_demangle_test("_ZN4llvm14ExprMapKeyTypeC2EjRKSt6vectorIPNS_8ConstantESaIS3_EEttRKNS_11SmallVectorIjLj4EEE", "llvm::ExprMapKeyType::ExprMapKeyType(unsigned int, std::vector<llvm::Constant*, std::allocator<llvm::Constant*> > const&, unsigned short, unsigned short, llvm::SmallVector<unsigned int, 4u> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm4TypeENS1_14ExprMapKeyTypeEES0_IKS6_PNS1_12ConstantExprEESt10_Select1stISA_ESt4lessIS6_ESaISA_EE8_M_eraseEPSt13_Rb_tree_nodeISA_E", "std::_Rb_tree<std::pair<llvm::Type const*, llvm::ExprMapKeyType>, std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*>, std::_Select1st<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> >, std::less<std::pair<llvm::Type const*, llvm::ExprMapKeyType> >, std::allocator<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> > >::_M_erase(std::_Rb_tree_node<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm12ConstantExprESt4pairIKS2_St17_Rb_tree_iteratorIS3_IKS3_IPKNS0_4TypeENS0_14ExprMapKeyTypeEES2_EEESt10_Select1stISE_ESt4lessIS2_ESaISE_EE8_M_eraseEPSt13_Rb_tree_nodeISE_E", "std::_Rb_tree<llvm::ConstantExpr*, std::pair<llvm::ConstantExpr* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> > >, std::_Select1st<std::pair<llvm::ConstantExpr* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> > > >, std::less<llvm::ConstantExpr*>, std::allocator<std::pair<llvm::ConstantExpr* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> > > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::ConstantExpr* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::Type const*, llvm::ExprMapKeyType> const, llvm::ConstantExpr*> > > >*)"),
	mu_demangle_test("_ZN4llvm17ConstantUniqueMapINS_16InlineAsmKeyTypeENS_11PointerTypeENS_9InlineAsmELb0EE21UpdateAbstractTypeMapEPKNS_11DerivedTypeESt17_Rb_tree_iteratorISt4pairIKS9_IPKS2_S1_EPS3_EE", "llvm::ConstantUniqueMap<llvm::InlineAsmKeyType, llvm::PointerType, llvm::InlineAsm, false>::UpdateAbstractTypeMap(llvm::DerivedType const*, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_11PointerTypeENS0_16InlineAsmKeyTypeEEPNS0_9InlineAsmEEEESt10_Select1stISH_ESt4lessIS3_ESaISH_EE16_M_insert_uniqueES6_ISH_ERKSH_", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> > > > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> > > >, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_11PointerTypeENS0_16InlineAsmKeyTypeEEPNS0_9InlineAsmEEEESt10_Select1stISH_ESt4lessIS3_ESaISH_EE16_M_insert_uniqueERKSH_", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> > > > >::_M_insert_unique(std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> > > const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm11PointerTypeENS1_16InlineAsmKeyTypeEES0_IKS6_PNS1_9InlineAsmEESt10_Select1stISA_ESt4lessIS6_ESaISA_EE5eraseESt17_Rb_tree_iteratorISA_E", "std::_Rb_tree<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType>, std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*>, std::_Select1st<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> >, std::less<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> >, std::allocator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> > >::erase(std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_11PointerTypeENS0_16InlineAsmKeyTypeEEPNS0_9InlineAsmEEEESt10_Select1stISH_ESt4lessIS3_ESaISH_EE5eraseES6_ISH_ESO_", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> > > > >::erase(std::_Rb_tree_iterator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> > > >, std::_Rb_tree_iterator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> > > >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm11DerivedTypeESt4pairIKS3_St17_Rb_tree_iteratorIS4_IKS4_IPKNS0_11PointerTypeENS0_16InlineAsmKeyTypeEEPNS0_9InlineAsmEEEESt10_Select1stISH_ESt4lessIS3_ESaISH_EE8_M_eraseEPSt13_Rb_tree_nodeISH_E", "std::_Rb_tree<llvm::DerivedType const*, std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> > >, std::_Select1st<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> > > >, std::less<llvm::DerivedType const*>, std::allocator<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> > > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::DerivedType const* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> > > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm11PointerTypeENS1_16InlineAsmKeyTypeEES0_IKS6_PNS1_9InlineAsmEESt10_Select1stISA_ESt4lessIS6_ESaISA_EE16_M_insert_uniqueERKSA_", "std::_Rb_tree<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType>, std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*>, std::_Select1st<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> >, std::less<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> >, std::allocator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> > >::_M_insert_unique(std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm11PointerTypeENS1_16InlineAsmKeyTypeEES0_IKS6_PNS1_9InlineAsmEESt10_Select1stISA_ESt4lessIS6_ESaISA_EE9_M_insertEPSt18_Rb_tree_node_baseSI_RKSA_", "std::_Rb_tree<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType>, std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*>, std::_Select1st<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> >, std::less<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> >, std::allocator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISt4pairIPKN4llvm11PointerTypeENS1_16InlineAsmKeyTypeEES0_IKS6_PNS1_9InlineAsmEESt10_Select1stISA_ESt4lessIS6_ESaISA_EE8_M_eraseEPSt13_Rb_tree_nodeISA_E", "std::_Rb_tree<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType>, std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*>, std::_Select1st<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> >, std::less<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> >, std::allocator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> > >::_M_erase(std::_Rb_tree_node<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm9InlineAsmESt4pairIKS2_St17_Rb_tree_iteratorIS3_IKS3_IPKNS0_11PointerTypeENS0_16InlineAsmKeyTypeEES2_EEESt10_Select1stISE_ESt4lessIS2_ESaISE_EE8_M_eraseEPSt13_Rb_tree_nodeISE_E", "std::_Rb_tree<llvm::InlineAsm*, std::pair<llvm::InlineAsm* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> > >, std::_Select1st<std::pair<llvm::InlineAsm* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> > > >, std::less<llvm::InlineAsm*>, std::allocator<std::pair<llvm::InlineAsm* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> > > > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::InlineAsm* const, std::_Rb_tree_iterator<std::pair<std::pair<llvm::PointerType const*, llvm::InlineAsmKeyType> const, llvm::InlineAsm*> > > >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjN4llvm12PATypeHolderEESt10_Select1stIS4_ESt4lessIjESaIS4_EE8_M_eraseEPSt13_Rb_tree_nodeIS4_E", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, llvm::PATypeHolder>, std::_Select1st<std::pair<unsigned int const, llvm::PATypeHolder> >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, llvm::PATypeHolder> > >::_M_erase(std::_Rb_tree_node<std::pair<unsigned int const, llvm::PATypeHolder> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm12ArrayValTypeESt4pairIKS1_NS0_12PATypeHolderEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE8_M_eraseEPSt13_Rb_tree_nodeIS5_E", "std::_Rb_tree<llvm::ArrayValType, std::pair<llvm::ArrayValType const, llvm::PATypeHolder>, std::_Select1st<std::pair<llvm::ArrayValType const, llvm::PATypeHolder> >, std::less<llvm::ArrayValType>, std::allocator<std::pair<llvm::ArrayValType const, llvm::PATypeHolder> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::ArrayValType const, llvm::PATypeHolder> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm13VectorValTypeESt4pairIKS1_NS0_12PATypeHolderEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE8_M_eraseEPSt13_Rb_tree_nodeIS5_E", "std::_Rb_tree<llvm::VectorValType, std::pair<llvm::VectorValType const, llvm::PATypeHolder>, std::_Select1st<std::pair<llvm::VectorValType const, llvm::PATypeHolder> >, std::less<llvm::VectorValType>, std::allocator<std::pair<llvm::VectorValType const, llvm::PATypeHolder> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::VectorValType const, llvm::PATypeHolder> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm14PointerValTypeESt4pairIKS1_NS0_12PATypeHolderEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE8_M_eraseEPSt13_Rb_tree_nodeIS5_E", "std::_Rb_tree<llvm::PointerValType, std::pair<llvm::PointerValType const, llvm::PATypeHolder>, std::_Select1st<std::pair<llvm::PointerValType const, llvm::PATypeHolder> >, std::less<llvm::PointerValType>, std::allocator<std::pair<llvm::PointerValType const, llvm::PATypeHolder> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::PointerValType const, llvm::PATypeHolder> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm15FunctionValTypeESt4pairIKS1_NS0_12PATypeHolderEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE8_M_eraseEPSt13_Rb_tree_nodeIS5_E", "std::_Rb_tree<llvm::FunctionValType, std::pair<llvm::FunctionValType const, llvm::PATypeHolder>, std::_Select1st<std::pair<llvm::FunctionValType const, llvm::PATypeHolder> >, std::less<llvm::FunctionValType>, std::allocator<std::pair<llvm::FunctionValType const, llvm::PATypeHolder> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::FunctionValType const, llvm::PATypeHolder> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm13StructValTypeESt4pairIKS1_NS0_12PATypeHolderEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE8_M_eraseEPSt13_Rb_tree_nodeIS5_E", "std::_Rb_tree<llvm::StructValType, std::pair<llvm::StructValType const, llvm::PATypeHolder>, std::_Select1st<std::pair<llvm::StructValType const, llvm::PATypeHolder> >, std::less<llvm::StructValType>, std::allocator<std::pair<llvm::StructValType const, llvm::PATypeHolder> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::StructValType const, llvm::PATypeHolder> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm14IntegerValTypeESt4pairIKS1_NS0_12PATypeHolderEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE8_M_eraseEPSt13_Rb_tree_nodeIS5_E", "std::_Rb_tree<llvm::IntegerValType, std::pair<llvm::IntegerValType const, llvm::PATypeHolder>, std::_Select1st<std::pair<llvm::IntegerValType const, llvm::PATypeHolder> >, std::less<llvm::IntegerValType>, std::allocator<std::pair<llvm::IntegerValType const, llvm::PATypeHolder> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::IntegerValType const, llvm::PATypeHolder> >*)"),
	mu_demangle_test("_ZNK4llvm11Instruction18getAllMetadataImplERNS_15SmallVectorImplISt4pairIjPNS_6MDNodeEEEE", "llvm::Instruction::getAllMetadataImpl(llvm::SmallVectorImpl<std::pair<unsigned int, llvm::MDNode*> >&) const"),
	mu_demangle_test("_ZNK4llvm11Instruction35getAllMetadataOtherThanDebugLocImplERNS_15SmallVectorImplISt4pairIjPNS_6MDNodeEEEE", "llvm::Instruction::getAllMetadataOtherThanDebugLocImpl(llvm::SmallVectorImpl<std::pair<unsigned int, llvm::MDNode*> >&) const"),
	mu_demangle_test("_ZN4llvm25array_pod_sort_comparatorISt4pairIjPNS_6MDNodeEEEEiPKvS6_", "int llvm::array_pod_sort_comparator<std::pair<unsigned int, llvm::MDNode*> >(void const*, void const*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_11InstructionENS_11SmallVectorISt4pairIjNS_10TrackingVHINS_6MDNodeEEEELj2EEENS_12DenseMapInfoIS3_EENSB_ISA_EEE5eraseERKS3_", "llvm::DenseMap<llvm::Instruction const*, llvm::SmallVector<std::pair<unsigned int, llvm::TrackingVH<llvm::MDNode> >, 2u>, llvm::DenseMapInfo<llvm::Instruction const*>, llvm::DenseMapInfo<llvm::SmallVector<std::pair<unsigned int, llvm::TrackingVH<llvm::MDNode> >, 2u> > >::erase(llvm::Instruction const* const&)"),
	mu_demangle_test("_ZN4llvm15SmallVectorImplISt4pairIjPNS_6MDNodeEEE6appendIPKS1_IjNS_10TrackingVHIS2_EEEEEvT_SC_", "void llvm::SmallVectorImpl<std::pair<unsigned int, llvm::MDNode*> >::append<std::pair<unsigned int, llvm::TrackingVH<llvm::MDNode> > const*>(std::pair<unsigned int, llvm::TrackingVH<llvm::MDNode> > const*, std::pair<unsigned int, llvm::TrackingVH<llvm::MDNode> > const*)"),
	mu_demangle_test("_ZN4llvm23SmallVectorTemplateBaseISt4pairIjNS_10TrackingVHINS_6MDNodeEEEELb0EE4growEm", "llvm::SmallVectorTemplateBase<std::pair<unsigned int, llvm::TrackingVH<llvm::MDNode> >, false>::grow(unsigned long)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_11InstructionENS_11SmallVectorISt4pairIjNS_10TrackingVHINS_6MDNodeEEEELj2EEENS_12DenseMapInfoIS3_EENSB_ISA_EEE16FindAndConstructERKS3_", "llvm::DenseMap<llvm::Instruction const*, llvm::SmallVector<std::pair<unsigned int, llvm::TrackingVH<llvm::MDNode> >, 2u>, llvm::DenseMapInfo<llvm::Instruction const*>, llvm::DenseMapInfo<llvm::SmallVector<std::pair<unsigned int, llvm::TrackingVH<llvm::MDNode> >, 2u> > >::FindAndConstruct(llvm::Instruction const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_11InstructionENS_11SmallVectorISt4pairIjNS_10TrackingVHINS_6MDNodeEEEELj2EEENS_12DenseMapInfoIS3_EENSB_ISA_EEE16InsertIntoBucketERKS3_RKSA_PS5_IS3_SA_E", "llvm::DenseMap<llvm::Instruction const*, llvm::SmallVector<std::pair<unsigned int, llvm::TrackingVH<llvm::MDNode> >, 2u>, llvm::DenseMapInfo<llvm::Instruction const*>, llvm::DenseMapInfo<llvm::SmallVector<std::pair<unsigned int, llvm::TrackingVH<llvm::MDNode> >, 2u> > >::InsertIntoBucket(llvm::Instruction const* const&, llvm::SmallVector<std::pair<unsigned int, llvm::TrackingVH<llvm::MDNode> >, 2u> const&, std::pair<llvm::Instruction const*, llvm::SmallVector<std::pair<unsigned int, llvm::TrackingVH<llvm::MDNode> >, 2u> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_11InstructionENS_11SmallVectorISt4pairIjNS_10TrackingVHINS_6MDNodeEEEELj2EEENS_12DenseMapInfoIS3_EENSB_ISA_EEE4growEj", "llvm::DenseMap<llvm::Instruction const*, llvm::SmallVector<std::pair<unsigned int, llvm::TrackingVH<llvm::MDNode> >, 2u>, llvm::DenseMapInfo<llvm::Instruction const*>, llvm::DenseMapInfo<llvm::SmallVector<std::pair<unsigned int, llvm::TrackingVH<llvm::MDNode> >, 2u> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm15SmallVectorImplISt4pairIjNS_10TrackingVHINS_6MDNodeEEEEEaSERKS6_", "llvm::SmallVectorImpl<std::pair<unsigned int, llvm::TrackingVH<llvm::MDNode> > >::operator=(llvm::SmallVectorImpl<std::pair<unsigned int, llvm::TrackingVH<llvm::MDNode> > > const&)"),
	mu_demangle_test("_ZNSt6vectorIPKN4llvm4TypeESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<llvm::Type const*, std::allocator<llvm::Type const*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::Type const**, std::vector<llvm::Type const*, std::allocator<llvm::Type const*> > >, llvm::Type const* const&)"),
	mu_demangle_test("_ZN4llvm6iplistINS_11GlobalAliasENS_12ilist_traitsIS1_EEE5eraseENS_14ilist_iteratorIS1_EE", "llvm::iplist<llvm::GlobalAlias, llvm::ilist_traits<llvm::GlobalAlias> >::erase(llvm::ilist_iterator<llvm::GlobalAlias>)"),
	mu_demangle_test("_ZN4llvm6iplistINS_8FunctionENS_12ilist_traitsIS1_EEE5eraseENS_14ilist_iteratorIS1_EE", "llvm::iplist<llvm::Function, llvm::ilist_traits<llvm::Function> >::erase(llvm::ilist_iterator<llvm::Function>)"),
	mu_demangle_test("_ZN4llvm6iplistINS_14GlobalVariableENS_12ilist_traitsIS1_EEE5eraseENS_14ilist_iteratorIS1_EE", "llvm::iplist<llvm::GlobalVariable, llvm::ilist_traits<llvm::GlobalVariable> >::erase(llvm::ilist_iterator<llvm::GlobalVariable>)"),
	mu_demangle_test("_ZN4llvm6iplistINS_11GlobalAliasENS_12ilist_traitsIS1_EEED2Ev", "llvm::iplist<llvm::GlobalAlias, llvm::ilist_traits<llvm::GlobalAlias> >::~iplist()"),
	mu_demangle_test("_ZN4llvm6iplistINS_14GlobalVariableENS_12ilist_traitsIS1_EEED2Ev", "llvm::iplist<llvm::GlobalVariable, llvm::ilist_traits<llvm::GlobalVariable> >::~iplist()"),
	mu_demangle_test("_ZN4llvm2cl3optINS_14PassDebugLevelELb0ENS0_6parserIS2_EEED1Ev", "llvm::cl::opt<llvm::PassDebugLevel, false, llvm::cl::parser<llvm::PassDebugLevel> >::~opt()"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm13PMDataManagerESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::PMDataManager*, std::allocator<llvm::PMDataManager*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::PMDataManager**, std::vector<llvm::PMDataManager*, std::allocator<llvm::PMDataManager*> > >, llvm::PMDataManager* const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm4PassESt4pairIKS2_PNS0_23FunctionPassManagerImplEESt10_Select1stIS7_ESt4lessIS2_ESaIS7_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS7_ERKS7_", "std::_Rb_tree<llvm::Pass*, std::pair<llvm::Pass* const, llvm::FunctionPassManagerImpl*>, std::_Select1st<std::pair<llvm::Pass* const, llvm::FunctionPassManagerImpl*> >, std::less<llvm::Pass*>, std::allocator<std::pair<llvm::Pass* const, llvm::FunctionPassManagerImpl*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::Pass* const, llvm::FunctionPassManagerImpl*> >, std::pair<llvm::Pass* const, llvm::FunctionPassManagerImpl*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm4PassESt4pairIKS2_PNS0_23FunctionPassManagerImplEESt10_Select1stIS7_ESt4lessIS2_ESaIS7_EE16_M_insert_uniqueERKS7_", "std::_Rb_tree<llvm::Pass*, std::pair<llvm::Pass* const, llvm::FunctionPassManagerImpl*>, std::_Select1st<std::pair<llvm::Pass* const, llvm::FunctionPassManagerImpl*> >, std::less<llvm::Pass*>, std::allocator<std::pair<llvm::Pass* const, llvm::FunctionPassManagerImpl*> > >::_M_insert_unique(std::pair<llvm::Pass* const, llvm::FunctionPassManagerImpl*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKvSt4pairIKS1_PN4llvm4PassEESt10_Select1stIS7_ESt4lessIS1_ESaIS7_EE5eraseESt17_Rb_tree_iteratorIS7_ESF_", "std::_Rb_tree<void const*, std::pair<void const* const, llvm::Pass*>, std::_Select1st<std::pair<void const* const, llvm::Pass*> >, std::less<void const*>, std::allocator<std::pair<void const* const, llvm::Pass*> > >::erase(std::_Rb_tree_iterator<std::pair<void const* const, llvm::Pass*> >, std::_Rb_tree_iterator<std::pair<void const* const, llvm::Pass*> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKvSt4pairIKS1_PN4llvm4PassEESt10_Select1stIS7_ESt4lessIS1_ESaIS7_EE8_M_eraseEPSt13_Rb_tree_nodeIS7_E", "std::_Rb_tree<void const*, std::pair<void const* const, llvm::Pass*>, std::_Select1st<std::pair<void const* const, llvm::Pass*> >, std::less<void const*>, std::allocator<std::pair<void const* const, llvm::Pass*> > >::_M_erase(std::_Rb_tree_node<std::pair<void const* const, llvm::Pass*> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKvSt4pairIKS1_PN4llvm4PassEESt10_Select1stIS7_ESt4lessIS1_ESaIS7_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS7_ERKS7_", "std::_Rb_tree<void const*, std::pair<void const* const, llvm::Pass*>, std::_Select1st<std::pair<void const* const, llvm::Pass*> >, std::less<void const*>, std::allocator<std::pair<void const* const, llvm::Pass*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<void const* const, llvm::Pass*> >, std::pair<void const* const, llvm::Pass*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKvSt4pairIKS1_PN4llvm4PassEESt10_Select1stIS7_ESt4lessIS1_ESaIS7_EE16_M_insert_uniqueERKS7_", "std::_Rb_tree<void const*, std::pair<void const* const, llvm::Pass*>, std::_Select1st<std::pair<void const* const, llvm::Pass*> >, std::less<void const*>, std::allocator<std::pair<void const* const, llvm::Pass*> > >::_M_insert_unique(std::pair<void const* const, llvm::Pass*> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_4PassENS_11SmallPtrSetIS2_Lj8EEENS_12DenseMapInfoIS2_EENS5_IS4_EEE16FindAndConstructERKS2_", "llvm::DenseMap<llvm::Pass*, llvm::SmallPtrSet<llvm::Pass*, 8u>, llvm::DenseMapInfo<llvm::Pass*>, llvm::DenseMapInfo<llvm::SmallPtrSet<llvm::Pass*, 8u> > >::FindAndConstruct(llvm::Pass* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_4PassENS_11SmallPtrSetIS2_Lj8EEENS_12DenseMapInfoIS2_EENS5_IS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<llvm::Pass*, llvm::SmallPtrSet<llvm::Pass*, 8u>, llvm::DenseMapInfo<llvm::Pass*>, llvm::DenseMapInfo<llvm::SmallPtrSet<llvm::Pass*, 8u> > >::InsertIntoBucket(llvm::Pass* const&, llvm::SmallPtrSet<llvm::Pass*, 8u> const&, std::pair<llvm::Pass*, llvm::SmallPtrSet<llvm::Pass*, 8u> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_4PassENS_11SmallPtrSetIS2_Lj8EEENS_12DenseMapInfoIS2_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::Pass*, llvm::SmallPtrSet<llvm::Pass*, 8u>, llvm::DenseMapInfo<llvm::Pass*>, llvm::DenseMapInfo<llvm::SmallPtrSet<llvm::Pass*, 8u> > >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_4PassEPNS_13AnalysisUsageENS_12DenseMapInfoIS2_EENS5_IS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<llvm::Pass*, llvm::AnalysisUsage*, llvm::DenseMapInfo<llvm::Pass*>, llvm::DenseMapInfo<llvm::AnalysisUsage*> >::InsertIntoBucket(llvm::Pass* const&, llvm::AnalysisUsage* const&, std::pair<llvm::Pass*, llvm::AnalysisUsage*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_4PassEPNS_13AnalysisUsageENS_12DenseMapInfoIS2_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::Pass*, llvm::AnalysisUsage*, llvm::DenseMapInfo<llvm::Pass*>, llvm::DenseMapInfo<llvm::AnalysisUsage*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_4PassES2_NS_12DenseMapInfoIS2_EES4_E16InsertIntoBucketERKS2_S7_PSt4pairIS2_S2_E", "llvm::DenseMap<llvm::Pass*, llvm::Pass*, llvm::DenseMapInfo<llvm::Pass*>, llvm::DenseMapInfo<llvm::Pass*> >::InsertIntoBucket(llvm::Pass* const&, llvm::Pass* const&, std::pair<llvm::Pass*, llvm::Pass*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_4PassES2_NS_12DenseMapInfoIS2_EES4_E4growEj", "llvm::DenseMap<llvm::Pass*, llvm::Pass*, llvm::DenseMapInfo<llvm::Pass*>, llvm::DenseMapInfo<llvm::Pass*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIPKN4llvm8PassInfoESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<llvm::PassInfo const*, std::allocator<llvm::PassInfo const*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::PassInfo const**, std::vector<llvm::PassInfo const*, std::allocator<llvm::PassInfo const*> > >, llvm::PassInfo const* const&)"),
	mu_demangle_test("_ZN4llvm2cl3optINS_14PassDebugLevelELb0ENS0_6parserIS2_EEE16handleOccurrenceEjNS_9StringRefES6_", "llvm::cl::opt<llvm::PassDebugLevel, false, llvm::cl::parser<llvm::PassDebugLevel> >::handleOccurrence(unsigned int, llvm::StringRef, llvm::StringRef)"),
	mu_demangle_test("_ZNK4llvm2cl3optINS_14PassDebugLevelELb0ENS0_6parserIS2_EEE27getValueExpectedFlagDefaultEv", "llvm::cl::opt<llvm::PassDebugLevel, false, llvm::cl::parser<llvm::PassDebugLevel> >::getValueExpectedFlagDefault() const"),
	mu_demangle_test("_ZNK4llvm2cl3optINS_14PassDebugLevelELb0ENS0_6parserIS2_EEE14getOptionWidthEv", "llvm::cl::opt<llvm::PassDebugLevel, false, llvm::cl::parser<llvm::PassDebugLevel> >::getOptionWidth() const"),
	mu_demangle_test("_ZNK4llvm2cl3optINS_14PassDebugLevelELb0ENS0_6parserIS2_EEE15printOptionInfoEm", "llvm::cl::opt<llvm::PassDebugLevel, false, llvm::cl::parser<llvm::PassDebugLevel> >::printOptionInfo(unsigned long) const"),
	mu_demangle_test("_ZN4llvm2cl3optINS_14PassDebugLevelELb0ENS0_6parserIS2_EEE19getExtraOptionNamesERNS_15SmallVectorImplIPKcEE", "llvm::cl::opt<llvm::PassDebugLevel, false, llvm::cl::parser<llvm::PassDebugLevel> >::getExtraOptionNames(llvm::SmallVectorImpl<char const*>&)"),
	mu_demangle_test("_ZN4llvm2cl3optINS_14PassDebugLevelELb0ENS0_6parserIS2_EEED0Ev", "llvm::cl::opt<llvm::PassDebugLevel, false, llvm::cl::parser<llvm::PassDebugLevel> >::~opt()"),
	mu_demangle_test("_ZNK4llvm2cl11ValuesClassIiE5applyINS0_3optINS_14PassDebugLevelELb0ENS0_6parserIS5_EEEEEEvRT_", "void llvm::cl::ValuesClass<int>::apply<llvm::cl::opt<llvm::PassDebugLevel, false, llvm::cl::parser<llvm::PassDebugLevel> > >(llvm::cl::opt<llvm::PassDebugLevel, false, llvm::cl::parser<llvm::PassDebugLevel> >&) const"),
	mu_demangle_test("_ZNSt8_Rb_treeIPN4llvm4PassESt4pairIKS2_PNS0_23FunctionPassManagerImplEESt10_Select1stIS7_ESt4lessIS2_ESaIS7_EE8_M_eraseEPSt13_Rb_tree_nodeIS7_E", "std::_Rb_tree<llvm::Pass*, std::pair<llvm::Pass* const, llvm::FunctionPassManagerImpl*>, std::_Select1st<std::pair<llvm::Pass* const, llvm::FunctionPassManagerImpl*> >, std::less<llvm::Pass*>, std::allocator<std::pair<llvm::Pass* const, llvm::FunctionPassManagerImpl*> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::Pass* const, llvm::FunctionPassManagerImpl*> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_4PassEPNS_5TimerENS_12DenseMapInfoIS2_EENS5_IS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<llvm::Pass*, llvm::Timer*, llvm::DenseMapInfo<llvm::Pass*>, llvm::DenseMapInfo<llvm::Timer*> >::InsertIntoBucket(llvm::Pass* const&, llvm::Timer* const&, std::pair<llvm::Pass*, llvm::Timer*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_4PassEPNS_5TimerENS_12DenseMapInfoIS2_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::Pass*, llvm::Timer*, llvm::DenseMapInfo<llvm::Pass*>, llvm::DenseMapInfo<llvm::Timer*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPKvPN4llvm4PassEESaIS6_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS6_S8_EERKS6_", "std::vector<std::pair<void const*, llvm::Pass*>, std::allocator<std::pair<void const*, llvm::Pass*> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<void const*, llvm::Pass*>*, std::vector<std::pair<void const*, llvm::Pass*>, std::allocator<std::pair<void const*, llvm::Pass*> > > >, std::pair<void const*, llvm::Pass*> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKvPKNS_8PassInfoENS_12DenseMapInfoIS2_EENS6_IS5_EEE6insertERKSt4pairIS2_S5_E", "llvm::DenseMap<void const*, llvm::PassInfo const*, llvm::DenseMapInfo<void const*>, llvm::DenseMapInfo<llvm::PassInfo const*> >::insert(std::pair<void const*, llvm::PassInfo const*> const&)"),
	mu_demangle_test("_ZSt6__findIN9__gnu_cxx17__normal_iteratorIPPN4llvm24PassRegistrationListenerESt6vectorIS4_SaIS4_EEEES4_ET_SA_SA_RKT0_St26random_access_iterator_tag", "__gnu_cxx::__normal_iterator<llvm::PassRegistrationListener**, std::vector<llvm::PassRegistrationListener*, std::allocator<llvm::PassRegistrationListener*> > > std::__find<__gnu_cxx::__normal_iterator<llvm::PassRegistrationListener**, std::vector<llvm::PassRegistrationListener*, std::allocator<llvm::PassRegistrationListener*> > >, llvm::PassRegistrationListener*>(__gnu_cxx::__normal_iterator<llvm::PassRegistrationListener**, std::vector<llvm::PassRegistrationListener*, std::allocator<llvm::PassRegistrationListener*> > >, __gnu_cxx::__normal_iterator<llvm::PassRegistrationListener**, std::vector<llvm::PassRegistrationListener*, std::allocator<llvm::PassRegistrationListener*> > >, llvm::PassRegistrationListener* const&, std::random_access_iterator_tag)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKvPKNS_8PassInfoENS_12DenseMapInfoIS2_EENS6_IS5_EEE16InsertIntoBucketERKS2_RKS5_PSt4pairIS2_S5_E", "llvm::DenseMap<void const*, llvm::PassInfo const*, llvm::DenseMapInfo<void const*>, llvm::DenseMapInfo<llvm::PassInfo const*> >::InsertIntoBucket(void const* const&, llvm::PassInfo const* const&, std::pair<void const*, llvm::PassInfo const*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKvPKNS_8PassInfoENS_12DenseMapInfoIS2_EENS6_IS5_EEE4growEj", "llvm::DenseMap<void const*, llvm::PassInfo const*, llvm::DenseMapInfo<void const*>, llvm::DenseMapInfo<llvm::PassInfo const*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm12FunctionTypeC1EPKNS_4TypeERKSt6vectorIS3_SaIS3_EEb", "llvm::FunctionType::FunctionType(llvm::Type const*, std::vector<llvm::Type const*, std::allocator<llvm::Type const*> > const&, bool)"),
	mu_demangle_test("_ZN4llvm12FunctionTypeC2EPKNS_4TypeERKSt6vectorIS3_SaIS3_EEb", "llvm::FunctionType::FunctionType(llvm::Type const*, std::vector<llvm::Type const*, std::allocator<llvm::Type const*> > const&, bool)"),
	mu_demangle_test("_ZN4llvm10StructTypeC1ERNS_11LLVMContextERKSt6vectorIPKNS_4TypeESaIS6_EEb", "llvm::StructType::StructType(llvm::LLVMContext&, std::vector<llvm::Type const*, std::allocator<llvm::Type const*> > const&, bool)"),
	mu_demangle_test("_ZN4llvm10StructTypeC2ERNS_11LLVMContextERKSt6vectorIPKNS_4TypeESaIS6_EEb", "llvm::StructType::StructType(llvm::LLVMContext&, std::vector<llvm::Type const*, std::allocator<llvm::Type const*> > const&, bool)"),
	mu_demangle_test("_ZN4llvm12FunctionType3getEPKNS_4TypeERKSt6vectorIS3_SaIS3_EEb", "llvm::FunctionType::get(llvm::Type const*, std::vector<llvm::Type const*, std::allocator<llvm::Type const*> > const&, bool)"),
	mu_demangle_test("_ZN4llvm10StructType3getERNS_11LLVMContextERKSt6vectorIPKNS_4TypeESaIS6_EEb", "llvm::StructType::get(llvm::LLVMContext&, std::vector<llvm::Type const*, std::allocator<llvm::Type const*> > const&, bool)"),
	mu_demangle_test("_Z10TypesEqualPKN4llvm4TypeES2_RSt3mapIS2_S2_St4lessIS2_ESaISt4pairIKS2_S2_EEE", "TypesEqual(llvm::Type const*, llvm::Type const*, std::map<llvm::Type const*, llvm::Type const*, std::less<llvm::Type const*>, std::allocator<std::pair<llvm::Type const* const, llvm::Type const*> > >&)"),
	mu_demangle_test("_ZN4llvm12scc_iteratorIN12_GLOBAL__N_118TypePromotionGraphENS_11GraphTraitsIS2_EEE10GetNextSCCEv", "llvm::scc_iterator<(anonymous namespace)::TypePromotionGraph, llvm::GraphTraits<(anonymous namespace)::TypePromotionGraph> >::GetNextSCC()"),
	mu_demangle_test("_ZN4llvm12scc_iteratorIN12_GLOBAL__N_118TypePromotionGraphENS_11GraphTraitsIS2_EEE11DFSVisitOneEPNS_4TypeE", "llvm::scc_iterator<(anonymous namespace)::TypePromotionGraph, llvm::GraphTraits<(anonymous namespace)::TypePromotionGraph> >::DFSVisitOne(llvm::Type*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIjSt4pairIKjN4llvm12PATypeHolderEESt10_Select1stIS4_ESt4lessIjESaIS4_EE15_M_insert_equalERKS4_", "std::_Rb_tree<unsigned int, std::pair<unsigned int const, llvm::PATypeHolder>, std::_Select1st<std::pair<unsigned int const, llvm::PATypeHolder> >, std::less<unsigned int>, std::allocator<std::pair<unsigned int const, llvm::PATypeHolder> > >::_M_insert_equal(std::pair<unsigned int const, llvm::PATypeHolder> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4TypeESt4pairIKS3_S3_ESt10_Select1stIS6_ESt4lessIS3_ESaIS6_EE8_M_eraseEPSt13_Rb_tree_nodeIS6_E", "std::_Rb_tree<llvm::Type const*, std::pair<llvm::Type const* const, llvm::Type const*>, std::_Select1st<std::pair<llvm::Type const* const, llvm::Type const*> >, std::less<llvm::Type const*>, std::allocator<std::pair<llvm::Type const* const, llvm::Type const*> > >::_M_erase(std::_Rb_tree_node<std::pair<llvm::Type const* const, llvm::Type const*> >*)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4TypeESt4pairIKS3_S3_ESt10_Select1stIS6_ESt4lessIS3_ESaIS6_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS6_ERKS6_", "std::_Rb_tree<llvm::Type const*, std::pair<llvm::Type const* const, llvm::Type const*>, std::_Select1st<std::pair<llvm::Type const* const, llvm::Type const*> >, std::less<llvm::Type const*>, std::allocator<std::pair<llvm::Type const* const, llvm::Type const*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<llvm::Type const* const, llvm::Type const*> >, std::pair<llvm::Type const* const, llvm::Type const*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIPKN4llvm4TypeESt4pairIKS3_S3_ESt10_Select1stIS6_ESt4lessIS3_ESaIS6_EE16_M_insert_uniqueERKS6_", "std::_Rb_tree<llvm::Type const*, std::pair<llvm::Type const* const, llvm::Type const*>, std::_Select1st<std::pair<llvm::Type const* const, llvm::Type const*> >, std::less<llvm::Type const*>, std::allocator<std::pair<llvm::Type const* const, llvm::Type const*> > >::_M_insert_unique(std::pair<llvm::Type const* const, llvm::Type const*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm14PointerValTypeESt4pairIKS1_NS0_12PATypeHolderEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE16_M_insert_uniqueERKS5_", "std::_Rb_tree<llvm::PointerValType, std::pair<llvm::PointerValType const, llvm::PATypeHolder>, std::_Select1st<std::pair<llvm::PointerValType const, llvm::PATypeHolder> >, std::less<llvm::PointerValType>, std::allocator<std::pair<llvm::PointerValType const, llvm::PATypeHolder> > >::_M_insert_unique(std::pair<llvm::PointerValType const, llvm::PATypeHolder> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm14PointerValTypeESt4pairIKS1_NS0_12PATypeHolderEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE9_M_insertEPSt18_Rb_tree_node_baseSD_RKS5_", "std::_Rb_tree<llvm::PointerValType, std::pair<llvm::PointerValType const, llvm::PATypeHolder>, std::_Select1st<std::pair<llvm::PointerValType const, llvm::PATypeHolder> >, std::less<llvm::PointerValType>, std::allocator<std::pair<llvm::PointerValType const, llvm::PATypeHolder> > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<llvm::PointerValType const, llvm::PATypeHolder> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm14PointerValTypeESt4pairIKS1_NS0_12PATypeHolderEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE5eraseESt17_Rb_tree_iteratorIS5_ESD_", "std::_Rb_tree<llvm::PointerValType, std::pair<llvm::PointerValType const, llvm::PATypeHolder>, std::_Select1st<std::pair<llvm::PointerValType const, llvm::PATypeHolder> >, std::less<llvm::PointerValType>, std::allocator<std::pair<llvm::PointerValType const, llvm::PATypeHolder> > >::erase(std::_Rb_tree_iterator<std::pair<llvm::PointerValType const, llvm::PATypeHolder> >, std::_Rb_tree_iterator<std::pair<llvm::PointerValType const, llvm::PATypeHolder> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm13StructValTypeESt4pairIKS1_NS0_12PATypeHolderEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE16_M_insert_uniqueERKS5_", "std::_Rb_tree<llvm::StructValType, std::pair<llvm::StructValType const, llvm::PATypeHolder>, std::_Select1st<std::pair<llvm::StructValType const, llvm::PATypeHolder> >, std::less<llvm::StructValType>, std::allocator<std::pair<llvm::StructValType const, llvm::PATypeHolder> > >::_M_insert_unique(std::pair<llvm::StructValType const, llvm::PATypeHolder> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm13StructValTypeESt4pairIKS1_NS0_12PATypeHolderEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE9_M_insertEPSt18_Rb_tree_node_baseSD_RKS5_", "std::_Rb_tree<llvm::StructValType, std::pair<llvm::StructValType const, llvm::PATypeHolder>, std::_Select1st<std::pair<llvm::StructValType const, llvm::PATypeHolder> >, std::less<llvm::StructValType>, std::allocator<std::pair<llvm::StructValType const, llvm::PATypeHolder> > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<llvm::StructValType const, llvm::PATypeHolder> const&)"),
	mu_demangle_test("_ZN9__gnu_cxx13new_allocatorISt4pairIKN4llvm13StructValTypeENS2_12PATypeHolderEEE9constructEPS6_RKS6_", "__gnu_cxx::new_allocator<std::pair<llvm::StructValType const, llvm::PATypeHolder> >::construct(std::pair<llvm::StructValType const, llvm::PATypeHolder>*, std::pair<llvm::StructValType const, llvm::PATypeHolder> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm13StructValTypeESt4pairIKS1_NS0_12PATypeHolderEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE5eraseERS3_", "std::_Rb_tree<llvm::StructValType, std::pair<llvm::StructValType const, llvm::PATypeHolder>, std::_Select1st<std::pair<llvm::StructValType const, llvm::PATypeHolder> >, std::less<llvm::StructValType>, std::allocator<std::pair<llvm::StructValType const, llvm::PATypeHolder> > >::erase(llvm::StructValType const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm13StructValTypeESt4pairIKS1_NS0_12PATypeHolderEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE5eraseESt17_Rb_tree_iteratorIS5_E", "std::_Rb_tree<llvm::StructValType, std::pair<llvm::StructValType const, llvm::PATypeHolder>, std::_Select1st<std::pair<llvm::StructValType const, llvm::PATypeHolder> >, std::less<llvm::StructValType>, std::allocator<std::pair<llvm::StructValType const, llvm::PATypeHolder> > >::erase(std::_Rb_tree_iterator<std::pair<llvm::StructValType const, llvm::PATypeHolder> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm13StructValTypeESt4pairIKS1_NS0_12PATypeHolderEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE11lower_boundERS3_", "std::_Rb_tree<llvm::StructValType, std::pair<llvm::StructValType const, llvm::PATypeHolder>, std::_Select1st<std::pair<llvm::StructValType const, llvm::PATypeHolder> >, std::less<llvm::StructValType>, std::allocator<std::pair<llvm::StructValType const, llvm::PATypeHolder> > >::lower_bound(llvm::StructValType const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm13StructValTypeESt4pairIKS1_NS0_12PATypeHolderEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE11upper_boundERS3_", "std::_Rb_tree<llvm::StructValType, std::pair<llvm::StructValType const, llvm::PATypeHolder>, std::_Select1st<std::pair<llvm::StructValType const, llvm::PATypeHolder> >, std::less<llvm::StructValType>, std::allocator<std::pair<llvm::StructValType const, llvm::PATypeHolder> > >::upper_bound(llvm::StructValType const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm13VectorValTypeESt4pairIKS1_NS0_12PATypeHolderEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE16_M_insert_uniqueERKS5_", "std::_Rb_tree<llvm::VectorValType, std::pair<llvm::VectorValType const, llvm::PATypeHolder>, std::_Select1st<std::pair<llvm::VectorValType const, llvm::PATypeHolder> >, std::less<llvm::VectorValType>, std::allocator<std::pair<llvm::VectorValType const, llvm::PATypeHolder> > >::_M_insert_unique(std::pair<llvm::VectorValType const, llvm::PATypeHolder> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm13VectorValTypeESt4pairIKS1_NS0_12PATypeHolderEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE9_M_insertEPSt18_Rb_tree_node_baseSD_RKS5_", "std::_Rb_tree<llvm::VectorValType, std::pair<llvm::VectorValType const, llvm::PATypeHolder>, std::_Select1st<std::pair<llvm::VectorValType const, llvm::PATypeHolder> >, std::less<llvm::VectorValType>, std::allocator<std::pair<llvm::VectorValType const, llvm::PATypeHolder> > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<llvm::VectorValType const, llvm::PATypeHolder> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm13VectorValTypeESt4pairIKS1_NS0_12PATypeHolderEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE5eraseESt17_Rb_tree_iteratorIS5_ESD_", "std::_Rb_tree<llvm::VectorValType, std::pair<llvm::VectorValType const, llvm::PATypeHolder>, std::_Select1st<std::pair<llvm::VectorValType const, llvm::PATypeHolder> >, std::less<llvm::VectorValType>, std::allocator<std::pair<llvm::VectorValType const, llvm::PATypeHolder> > >::erase(std::_Rb_tree_iterator<std::pair<llvm::VectorValType const, llvm::PATypeHolder> >, std::_Rb_tree_iterator<std::pair<llvm::VectorValType const, llvm::PATypeHolder> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm12ArrayValTypeESt4pairIKS1_NS0_12PATypeHolderEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE16_M_insert_uniqueERKS5_", "std::_Rb_tree<llvm::ArrayValType, std::pair<llvm::ArrayValType const, llvm::PATypeHolder>, std::_Select1st<std::pair<llvm::ArrayValType const, llvm::PATypeHolder> >, std::less<llvm::ArrayValType>, std::allocator<std::pair<llvm::ArrayValType const, llvm::PATypeHolder> > >::_M_insert_unique(std::pair<llvm::ArrayValType const, llvm::PATypeHolder> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm12ArrayValTypeESt4pairIKS1_NS0_12PATypeHolderEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE9_M_insertEPSt18_Rb_tree_node_baseSD_RKS5_", "std::_Rb_tree<llvm::ArrayValType, std::pair<llvm::ArrayValType const, llvm::PATypeHolder>, std::_Select1st<std::pair<llvm::ArrayValType const, llvm::PATypeHolder> >, std::less<llvm::ArrayValType>, std::allocator<std::pair<llvm::ArrayValType const, llvm::PATypeHolder> > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<llvm::ArrayValType const, llvm::PATypeHolder> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm12ArrayValTypeESt4pairIKS1_NS0_12PATypeHolderEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE5eraseESt17_Rb_tree_iteratorIS5_ESD_", "std::_Rb_tree<llvm::ArrayValType, std::pair<llvm::ArrayValType const, llvm::PATypeHolder>, std::_Select1st<std::pair<llvm::ArrayValType const, llvm::PATypeHolder> >, std::less<llvm::ArrayValType>, std::allocator<std::pair<llvm::ArrayValType const, llvm::PATypeHolder> > >::erase(std::_Rb_tree_iterator<std::pair<llvm::ArrayValType const, llvm::PATypeHolder> >, std::_Rb_tree_iterator<std::pair<llvm::ArrayValType const, llvm::PATypeHolder> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm15FunctionValTypeESt4pairIKS1_NS0_12PATypeHolderEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE16_M_insert_uniqueERKS5_", "std::_Rb_tree<llvm::FunctionValType, std::pair<llvm::FunctionValType const, llvm::PATypeHolder>, std::_Select1st<std::pair<llvm::FunctionValType const, llvm::PATypeHolder> >, std::less<llvm::FunctionValType>, std::allocator<std::pair<llvm::FunctionValType const, llvm::PATypeHolder> > >::_M_insert_unique(std::pair<llvm::FunctionValType const, llvm::PATypeHolder> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm15FunctionValTypeESt4pairIKS1_NS0_12PATypeHolderEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE9_M_insertEPSt18_Rb_tree_node_baseSD_RKS5_", "std::_Rb_tree<llvm::FunctionValType, std::pair<llvm::FunctionValType const, llvm::PATypeHolder>, std::_Select1st<std::pair<llvm::FunctionValType const, llvm::PATypeHolder> >, std::less<llvm::FunctionValType>, std::allocator<std::pair<llvm::FunctionValType const, llvm::PATypeHolder> > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<llvm::FunctionValType const, llvm::PATypeHolder> const&)"),
	mu_demangle_test("_ZN9__gnu_cxx13new_allocatorISt4pairIKN4llvm15FunctionValTypeENS2_12PATypeHolderEEE9constructEPS6_RKS6_", "__gnu_cxx::new_allocator<std::pair<llvm::FunctionValType const, llvm::PATypeHolder> >::construct(std::pair<llvm::FunctionValType const, llvm::PATypeHolder>*, std::pair<llvm::FunctionValType const, llvm::PATypeHolder> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm15FunctionValTypeESt4pairIKS1_NS0_12PATypeHolderEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE5eraseERS3_", "std::_Rb_tree<llvm::FunctionValType, std::pair<llvm::FunctionValType const, llvm::PATypeHolder>, std::_Select1st<std::pair<llvm::FunctionValType const, llvm::PATypeHolder> >, std::less<llvm::FunctionValType>, std::allocator<std::pair<llvm::FunctionValType const, llvm::PATypeHolder> > >::erase(llvm::FunctionValType const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm15FunctionValTypeESt4pairIKS1_NS0_12PATypeHolderEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE11equal_rangeERS3_", "std::_Rb_tree<llvm::FunctionValType, std::pair<llvm::FunctionValType const, llvm::PATypeHolder>, std::_Select1st<std::pair<llvm::FunctionValType const, llvm::PATypeHolder> >, std::less<llvm::FunctionValType>, std::allocator<std::pair<llvm::FunctionValType const, llvm::PATypeHolder> > >::equal_range(llvm::FunctionValType const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm15FunctionValTypeESt4pairIKS1_NS0_12PATypeHolderEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE5eraseESt17_Rb_tree_iteratorIS5_E", "std::_Rb_tree<llvm::FunctionValType, std::pair<llvm::FunctionValType const, llvm::PATypeHolder>, std::_Select1st<std::pair<llvm::FunctionValType const, llvm::PATypeHolder> >, std::less<llvm::FunctionValType>, std::allocator<std::pair<llvm::FunctionValType const, llvm::PATypeHolder> > >::erase(std::_Rb_tree_iterator<std::pair<llvm::FunctionValType const, llvm::PATypeHolder> >)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm16AbstractTypeUserESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::AbstractTypeUser*, std::allocator<llvm::AbstractTypeUser*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::AbstractTypeUser**, std::vector<llvm::AbstractTypeUser*, std::allocator<llvm::AbstractTypeUser*> > >, llvm::AbstractTypeUser* const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm13StructValTypeESt4pairIKS1_NS0_12PATypeHolderEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE4findERS3_", "std::_Rb_tree<llvm::StructValType, std::pair<llvm::StructValType const, llvm::PATypeHolder>, std::_Select1st<std::pair<llvm::StructValType const, llvm::PATypeHolder> >, std::less<llvm::StructValType>, std::allocator<std::pair<llvm::StructValType const, llvm::PATypeHolder> > >::find(llvm::StructValType const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm15FunctionValTypeESt4pairIKS1_NS0_12PATypeHolderEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE4findERS3_", "std::_Rb_tree<llvm::FunctionValType, std::pair<llvm::FunctionValType const, llvm::PATypeHolder>, std::_Select1st<std::pair<llvm::FunctionValType const, llvm::PATypeHolder> >, std::less<llvm::FunctionValType>, std::allocator<std::pair<llvm::FunctionValType const, llvm::PATypeHolder> > >::find(llvm::FunctionValType const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm14IntegerValTypeESt4pairIKS1_NS0_12PATypeHolderEESt10_Select1stIS5_ESt4lessIS1_ESaIS5_EE16_M_insert_uniqueERKS5_", "std::_Rb_tree<llvm::IntegerValType, std::pair<llvm::IntegerValType const, llvm::PATypeHolder>, std::_Select1st<std::pair<llvm::IntegerValType const, llvm::PATypeHolder> >, std::less<llvm::IntegerValType>, std::allocator<std::pair<llvm::IntegerValType const, llvm::PATypeHolder> > >::_M_insert_unique(std::pair<llvm::IntegerValType const, llvm::PATypeHolder> const&)"),
	mu_demangle_test("_ZSt6__findIN9__gnu_cxx17__normal_iteratorIPPN4llvm4TypeESt6vectorIS4_SaIS4_EEEENS2_12PATypeHandleEET_SB_SB_RKT0_St26random_access_iterator_tag", "__gnu_cxx::__normal_iterator<llvm::Type**, std::vector<llvm::Type*, std::allocator<llvm::Type*> > > std::__find<__gnu_cxx::__normal_iterator<llvm::Type**, std::vector<llvm::Type*, std::allocator<llvm::Type*> > >, llvm::PATypeHandle>(__gnu_cxx::__normal_iterator<llvm::Type**, std::vector<llvm::Type*, std::allocator<llvm::Type*> > >, __gnu_cxx::__normal_iterator<llvm::Type**, std::vector<llvm::Type*, std::allocator<llvm::Type*> > >, llvm::PATypeHandle const&, std::random_access_iterator_tag)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm4TypeESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::Type*, std::allocator<llvm::Type*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::Type**, std::vector<llvm::Type*, std::allocator<llvm::Type*> > >, llvm::Type* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_4TypeEjNS_12DenseMapInfoIS2_EENS3_IjEEE16InsertIntoBucketERKS2_RKjPSt4pairIS2_jE", "llvm::DenseMap<llvm::Type*, unsigned int, llvm::DenseMapInfo<llvm::Type*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(llvm::Type* const&, unsigned int const&, std::pair<llvm::Type*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_4TypeEjNS_12DenseMapInfoIS2_EENS3_IjEEE4growEj", "llvm::DenseMap<llvm::Type*, unsigned int, llvm::DenseMapInfo<llvm::Type*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPN4llvm4TypeEPNS1_12PATypeHandleEESaIS6_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS6_S8_EERKS6_", "std::vector<std::pair<llvm::Type*, llvm::PATypeHandle*>, std::allocator<std::pair<llvm::Type*, llvm::PATypeHandle*> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::Type*, llvm::PATypeHandle*>*, std::vector<std::pair<llvm::Type*, llvm::PATypeHandle*>, std::allocator<std::pair<llvm::Type*, llvm::PATypeHandle*> > > >, std::pair<llvm::Type*, llvm::PATypeHandle*> const&)"),
	mu_demangle_test("_ZN4llvm15TypeSymbolTable6removeESt17_Rb_tree_iteratorISt4pairIKSsPKNS_4TypeEEE", "llvm::TypeSymbolTable::remove(std::_Rb_tree_iterator<std::pair<std::string const, llvm::Type const*> >)"),
	mu_demangle_test("_ZNSt8_Rb_treeIKSsSt4pairIS0_PKN4llvm4TypeEESt10_Select1stIS6_ESt4lessIS0_ESaIS6_EE16_M_insert_uniqueERKS6_", "std::_Rb_tree<std::string const, std::pair<std::string const, llvm::Type const*>, std::_Select1st<std::pair<std::string const, llvm::Type const*> >, std::less<std::string const>, std::allocator<std::pair<std::string const, llvm::Type const*> > >::_M_insert_unique(std::pair<std::string const, llvm::Type const*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIKSsSt4pairIS0_PKN4llvm4TypeEESt10_Select1stIS6_ESt4lessIS0_ESaIS6_EE9_M_insertEPSt18_Rb_tree_node_baseSE_RKS6_", "std::_Rb_tree<std::string const, std::pair<std::string const, llvm::Type const*>, std::_Select1st<std::pair<std::string const, llvm::Type const*> >, std::less<std::string const>, std::allocator<std::pair<std::string const, llvm::Type const*> > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<std::string const, llvm::Type const*> const&)"),
	mu_demangle_test("_ZNKSt8_Rb_treeIKSsSt4pairIS0_PKN4llvm4TypeEESt10_Select1stIS6_ESt4lessIS0_ESaIS6_EE4findERS0_", "std::_Rb_tree<std::string const, std::pair<std::string const, llvm::Type const*>, std::_Select1st<std::pair<std::string const, llvm::Type const*> >, std::less<std::string const>, std::allocator<std::pair<std::string const, llvm::Type const*> > >::find(std::string const&) const"),
	mu_demangle_test("_ZNSt8_Rb_treeIKSsSt4pairIS0_PKN4llvm4TypeEESt10_Select1stIS6_ESt4lessIS0_ESaIS6_EE8_M_eraseEPSt13_Rb_tree_nodeIS6_E", "std::_Rb_tree<std::string const, std::pair<std::string const, llvm::Type const*>, std::_Select1st<std::pair<std::string const, llvm::Type const*> >, std::less<std::string const>, std::allocator<std::pair<std::string const, llvm::Type const*> > >::_M_erase(std::_Rb_tree_node<std::pair<std::string const, llvm::Type const*> >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5ValueEPNS_15ValueHandleBaseENS_12DenseMapInfoIS2_EENS5_IS4_EEE16InsertIntoBucketERKS2_RKS4_PSt4pairIS2_S4_E", "llvm::DenseMap<llvm::Value*, llvm::ValueHandleBase*, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<llvm::ValueHandleBase*> >::InsertIntoBucket(llvm::Value* const&, llvm::ValueHandleBase* const&, std::pair<llvm::Value*, llvm::ValueHandleBase*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPNS_5ValueEPNS_15ValueHandleBaseENS_12DenseMapInfoIS2_EENS5_IS4_EEE4growEj", "llvm::DenseMap<llvm::Value*, llvm::ValueHandleBase*, llvm::DenseMapInfo<llvm::Value*>, llvm::DenseMapInfo<llvm::ValueHandleBase*> >::grow(unsigned int)"),
	mu_demangle_test("_ZSt13__adjust_heapIPSt4pairIPN4llvm10BasicBlockEPNS1_5ValueEElS6_EvT_T0_S9_T1_", "void std::__adjust_heap<std::pair<llvm::BasicBlock*, llvm::Value*>*, long, std::pair<llvm::BasicBlock*, llvm::Value*> >(std::pair<llvm::BasicBlock*, llvm::Value*>*, long, long, std::pair<llvm::BasicBlock*, llvm::Value*>)"),
	mu_demangle_test("_ZN4llvm15SmallVectorImplIPNS_10BasicBlockEE6appendINS_12PredIteratorIS1_NS_18value_use_iteratorINS_4UserEEEEEEEvT_SA_", "void llvm::SmallVectorImpl<llvm::BasicBlock*>::append<llvm::PredIterator<llvm::BasicBlock, llvm::value_use_iterator<llvm::User> > >(llvm::PredIterator<llvm::BasicBlock, llvm::value_use_iterator<llvm::User> >, llvm::PredIterator<llvm::BasicBlock, llvm::value_use_iterator<llvm::User> >)"),
	mu_demangle_test("_ZN12_GLOBAL__N_115ELFObjectWriter16WriteSymbolTableEPN4llvm14MCDataFragmentES3_RKNS1_11MCAssemblerERKNS1_11MCAsmLayoutERKNS1_8DenseMapIPKNS1_12MCSectionELFEjNS1_12DenseMapInfoISD_EENSE_IjEEEE", "(anonymous namespace)::ELFObjectWriter::WriteSymbolTable(llvm::MCDataFragment*, llvm::MCDataFragment*, llvm::MCAssembler const&, llvm::MCAsmLayout const&, llvm::DenseMap<llvm::MCSectionELF const*, unsigned int, llvm::DenseMapInfo<llvm::MCSectionELF const*>, llvm::DenseMapInfo<unsigned int> > const&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_115ELFObjectWriter18ComputeSymbolTableERN4llvm11MCAssemblerERKNS1_8DenseMapIPKNS1_12MCSectionELFEjNS1_12DenseMapInfoIS7_EENS8_IjEEEENS4_IPKNS1_8MCSymbolES7_NS8_ISG_EES9_EE", "(anonymous namespace)::ELFObjectWriter::ComputeSymbolTable(llvm::MCAssembler&, llvm::DenseMap<llvm::MCSectionELF const*, unsigned int, llvm::DenseMapInfo<llvm::MCSectionELF const*>, llvm::DenseMapInfo<unsigned int> > const&, llvm::DenseMap<llvm::MCSymbol const*, llvm::MCSectionELF const*, llvm::DenseMapInfo<llvm::MCSymbol const*>, llvm::DenseMapInfo<llvm::MCSectionELF const*> >)"),
	mu_demangle_test("_ZN12_GLOBAL__N_115ELFObjectWriter15ComputeIndexMapERN4llvm11MCAssemblerERNS1_8DenseMapIPKNS1_12MCSectionELFEjNS1_12DenseMapInfoIS7_EENS8_IjEEEE", "(anonymous namespace)::ELFObjectWriter::ComputeIndexMap(llvm::MCAssembler&, llvm::DenseMap<llvm::MCSectionELF const*, unsigned int, llvm::DenseMapInfo<llvm::MCSectionELF const*>, llvm::DenseMapInfo<unsigned int> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_115ELFObjectWriter22CreateMetadataSectionsERN4llvm11MCAssemblerERNS1_11MCAsmLayoutERKNS1_8DenseMapIPKNS1_12MCSectionELFEjNS1_12DenseMapInfoIS9_EENSA_IjEEEE", "(anonymous namespace)::ELFObjectWriter::CreateMetadataSections(llvm::MCAssembler&, llvm::MCAsmLayout&, llvm::DenseMap<llvm::MCSectionELF const*, unsigned int, llvm::DenseMapInfo<llvm::MCSectionELF const*>, llvm::DenseMapInfo<unsigned int> > const&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_115ELFObjectWriter21CreateIndexedSectionsERN4llvm11MCAssemblerERNS1_11MCAsmLayoutERNS1_8DenseMapIPKNS1_12MCSectionELFEPKNS1_8MCSymbolENS1_12DenseMapInfoIS9_EENSD_ISC_EEEERNS6_ISC_S9_SF_SE_EE", "(anonymous namespace)::ELFObjectWriter::CreateIndexedSections(llvm::MCAssembler&, llvm::MCAsmLayout&, llvm::DenseMap<llvm::MCSectionELF const*, llvm::MCSymbol const*, llvm::DenseMapInfo<llvm::MCSectionELF const*>, llvm::DenseMapInfo<llvm::MCSymbol const*> >&, llvm::DenseMap<llvm::MCSymbol const*, llvm::MCSectionELF const*, llvm::DenseMapInfo<llvm::MCSymbol const*>, llvm::DenseMapInfo<llvm::MCSectionELF const*> >&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_115ELFObjectWriter12WriteSectionERN4llvm11MCAssemblerERKNS1_8DenseMapIPKNS1_12MCSectionELFEjNS1_12DenseMapInfoIS7_EENS8_IjEEEEjyyyRS6_", "(anonymous namespace)::ELFObjectWriter::WriteSection(llvm::MCAssembler&, llvm::DenseMap<llvm::MCSectionELF const*, unsigned int, llvm::DenseMapInfo<llvm::MCSectionELF const*>, llvm::DenseMapInfo<unsigned int> > const&, unsigned int, uint64_t, uint64_t, uint64_t, llvm::MCSectionELF const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_13MCSectionDataESt6vectorIN12_GLOBAL__N_115ELFObjectWriter18ELFRelocationEntryESaIS7_EENS_12DenseMapInfoIS3_EENSA_IS9_EEEixERKS3_", "llvm::DenseMap<llvm::MCSectionData const*, std::vector<(anonymous namespace)::ELFObjectWriter::ELFRelocationEntry, std::allocator<(anonymous namespace)::ELFObjectWriter::ELFRelocationEntry> >, llvm::DenseMapInfo<llvm::MCSectionData const*>, llvm::DenseMapInfo<std::vector<(anonymous namespace)::ELFObjectWriter::ELFRelocationEntry, std::allocator<(anonymous namespace)::ELFObjectWriter::ELFRelocationEntry> > > >::operator[](llvm::MCSectionData const* const&)"),
	mu_demangle_test("_ZNSt6vectorIN12_GLOBAL__N_115ELFObjectWriter13ELFSymbolDataESaIS2_EE9push_backERKS2_", "std::vector<(anonymous namespace)::ELFObjectWriter::ELFSymbolData, std::allocator<(anonymous namespace)::ELFObjectWriter::ELFSymbolData> >::push_back((anonymous namespace)::ELFObjectWriter::ELFSymbolData const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_9MCSectionEyNS_12DenseMapInfoIS3_EENS4_IyEEE16InsertIntoBucketERKS3_RKyPSt4pairIS3_yE", "llvm::DenseMap<llvm::MCSection const*, uint64_t, llvm::DenseMapInfo<llvm::MCSection const*>, llvm::DenseMapInfo<uint64_t> >::InsertIntoBucket(llvm::MCSection const* const&, uint64_t const&, std::pair<llvm::MCSection const*, uint64_t>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_9MCSectionEyNS_12DenseMapInfoIS3_EENS4_IyEEE4growEj", "llvm::DenseMap<llvm::MCSection const*, uint64_t, llvm::DenseMapInfo<llvm::MCSection const*>, llvm::DenseMapInfo<uint64_t> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_12MCSectionELFEPKNS_8MCSymbolENS_12DenseMapInfoIS3_EENS7_IS6_EEE16InsertIntoBucketERKS3_RKS6_PSt4pairIS3_S6_E", "llvm::DenseMap<llvm::MCSectionELF const*, llvm::MCSymbol const*, llvm::DenseMapInfo<llvm::MCSectionELF const*>, llvm::DenseMapInfo<llvm::MCSymbol const*> >::InsertIntoBucket(llvm::MCSectionELF const* const&, llvm::MCSymbol const* const&, std::pair<llvm::MCSectionELF const*, llvm::MCSymbol const*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_12MCSectionELFEPKNS_8MCSymbolENS_12DenseMapInfoIS3_EENS7_IS6_EEE4growEj", "llvm::DenseMap<llvm::MCSectionELF const*, llvm::MCSymbol const*, llvm::DenseMapInfo<llvm::MCSectionELF const*>, llvm::DenseMapInfo<llvm::MCSymbol const*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_8MCSymbolEPKNS_12MCSectionELFENS_12DenseMapInfoIS3_EENS7_IS6_EEE16InsertIntoBucketERKS3_RKS6_PSt4pairIS3_S6_E", "llvm::DenseMap<llvm::MCSymbol const*, llvm::MCSectionELF const*, llvm::DenseMapInfo<llvm::MCSymbol const*>, llvm::DenseMapInfo<llvm::MCSectionELF const*> >::InsertIntoBucket(llvm::MCSymbol const* const&, llvm::MCSectionELF const* const&, std::pair<llvm::MCSymbol const*, llvm::MCSectionELF const*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_8MCSymbolEPKNS_12MCSectionELFENS_12DenseMapInfoIS3_EENS7_IS6_EEE4growEj", "llvm::DenseMap<llvm::MCSymbol const*, llvm::MCSectionELF const*, llvm::DenseMapInfo<llvm::MCSymbol const*>, llvm::DenseMapInfo<llvm::MCSectionELF const*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_12MCSectionELFEjNS_12DenseMapInfoIS3_EENS4_IjEEE16InsertIntoBucketERKS3_RKjPSt4pairIS3_jE", "llvm::DenseMap<llvm::MCSectionELF const*, unsigned int, llvm::DenseMapInfo<llvm::MCSectionELF const*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(llvm::MCSectionELF const* const&, unsigned int const&, std::pair<llvm::MCSectionELF const*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_12MCSectionELFEjNS_12DenseMapInfoIS3_EENS4_IjEEE4growEj", "llvm::DenseMap<llvm::MCSectionELF const*, unsigned int, llvm::DenseMapInfo<llvm::MCSectionELF const*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIPKN4llvm12MCSectionELFESaIS3_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS3_S5_EEmRKS3_", "std::vector<llvm::MCSectionELF const*, std::allocator<llvm::MCSectionELF const*> >::_M_fill_insert(__gnu_cxx::__normal_iterator<llvm::MCSectionELF const**, std::vector<llvm::MCSectionELF const*, std::allocator<llvm::MCSectionELF const*> > >, unsigned long, llvm::MCSectionELF const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_8MCSymbolEPKNS_12MCSectionELFENS_12DenseMapInfoIS3_EENS7_IS6_EEE8CopyFromERKSA_", "llvm::DenseMap<llvm::MCSymbol const*, llvm::MCSectionELF const*, llvm::DenseMapInfo<llvm::MCSymbol const*>, llvm::DenseMapInfo<llvm::MCSectionELF const*> >::CopyFrom(llvm::DenseMap<llvm::MCSymbol const*, llvm::MCSectionELF const*, llvm::DenseMapInfo<llvm::MCSymbol const*>, llvm::DenseMapInfo<llvm::MCSectionELF const*> > const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_8MCSymbolES3_NS_12DenseMapInfoIS3_EES5_E6insertERKSt4pairIS3_S3_E", "llvm::DenseMap<llvm::MCSymbol const*, llvm::MCSymbol const*, llvm::DenseMapInfo<llvm::MCSymbol const*>, llvm::DenseMapInfo<llvm::MCSymbol const*> >::insert(std::pair<llvm::MCSymbol const*, llvm::MCSymbol const*> const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_8MCSymbolES3_NS_12DenseMapInfoIS3_EES5_E16InsertIntoBucketERKS3_S8_PSt4pairIS3_S3_E", "llvm::DenseMap<llvm::MCSymbol const*, llvm::MCSymbol const*, llvm::DenseMapInfo<llvm::MCSymbol const*>, llvm::DenseMapInfo<llvm::MCSymbol const*> >::InsertIntoBucket(llvm::MCSymbol const* const&, llvm::MCSymbol const* const&, std::pair<llvm::MCSymbol const*, llvm::MCSymbol const*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_8MCSymbolES3_NS_12DenseMapInfoIS3_EES5_E4growEj", "llvm::DenseMap<llvm::MCSymbol const*, llvm::MCSymbol const*, llvm::DenseMapInfo<llvm::MCSymbol const*>, llvm::DenseMapInfo<llvm::MCSymbol const*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm6iplistINS_12MCSymbolDataENS_12ilist_traitsIS1_EEED2Ev", "llvm::iplist<llvm::MCSymbolData, llvm::ilist_traits<llvm::MCSymbolData> >::~iplist()"),
	mu_demangle_test("_ZN4llvm6iplistINS_13MCSectionDataENS_12ilist_traitsIS1_EEED2Ev", "llvm::iplist<llvm::MCSectionData, llvm::ilist_traits<llvm::MCSectionData> >::~iplist()"),
	mu_demangle_test("_ZN4llvm6iplistINS_10MCFragmentENS_12ilist_traitsIS1_EEED2Ev", "llvm::iplist<llvm::MCFragment, llvm::ilist_traits<llvm::MCFragment> >::~iplist()"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_13MCSectionDataEPNS_10MCFragmentENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PSt4pairIS3_S5_E", "llvm::DenseMap<llvm::MCSectionData const*, llvm::MCFragment*, llvm::DenseMapInfo<llvm::MCSectionData const*>, llvm::DenseMapInfo<llvm::MCFragment*> >::InsertIntoBucket(llvm::MCSectionData const* const&, llvm::MCFragment* const&, std::pair<llvm::MCSectionData const*, llvm::MCFragment*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_13MCSectionDataEPNS_10MCFragmentENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<llvm::MCSectionData const*, llvm::MCFragment*, llvm::DenseMapInfo<llvm::MCSectionData const*>, llvm::DenseMapInfo<llvm::MCFragment*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm9StringRefESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<llvm::StringRef, std::allocator<llvm::StringRef> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::StringRef*, std::vector<llvm::StringRef, std::allocator<llvm::StringRef> > >, llvm::StringRef const&)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm11MCDwarfFileESaIS2_EE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPS2_S4_EEmRKS2_", "std::vector<llvm::MCDwarfFile*, std::allocator<llvm::MCDwarfFile*> >::_M_fill_insert(__gnu_cxx::__normal_iterator<llvm::MCDwarfFile**, std::vector<llvm::MCDwarfFile*, std::allocator<llvm::MCDwarfFile*> > >, unsigned long, llvm::MCDwarfFile* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_7MCLabelENS_12DenseMapInfoIjEENS3_IS2_EEE16InsertIntoBucketERKjRKS2_PSt4pairIjS2_E", "llvm::DenseMap<unsigned int, llvm::MCLabel*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::MCLabel*> >::InsertIntoBucket(unsigned int const&, llvm::MCLabel* const&, std::pair<unsigned int, llvm::MCLabel*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIjPNS_7MCLabelENS_12DenseMapInfoIjEENS3_IS2_EEE4growEj", "llvm::DenseMap<unsigned int, llvm::MCLabel*, llvm::DenseMapInfo<unsigned int>, llvm::DenseMapInfo<llvm::MCLabel*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNK4llvm8DenseMapIN12_GLOBAL__N_16CIEKeyEPKNS_8MCSymbolENS_12DenseMapInfoIS2_EENS6_IS5_EEE15LookupBucketForERKS2_RPSt4pairIS2_S5_E", "llvm::DenseMap<(anonymous namespace)::CIEKey, llvm::MCSymbol const*, llvm::DenseMapInfo<(anonymous namespace)::CIEKey>, llvm::DenseMapInfo<llvm::MCSymbol const*> >::LookupBucketFor((anonymous namespace)::CIEKey const&, std::pair<(anonymous namespace)::CIEKey, llvm::MCSymbol const*>*&) const"),
	mu_demangle_test("_Z19EmitCFIInstructionsRN4llvm10MCStreamerERKSt6vectorINS_16MCCFIInstructionESaIS3_EEPNS_8MCSymbolE", "EmitCFIInstructions(llvm::MCStreamer&, std::vector<llvm::MCCFIInstruction, std::allocator<llvm::MCCFIInstruction> > const&, llvm::MCSymbol*)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm11MachineMoveESaIS1_EEC2ERKS3_", "std::vector<llvm::MachineMove, std::allocator<llvm::MachineMove> >::vector(std::vector<llvm::MachineMove, std::allocator<llvm::MachineMove> > const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm11MCLineEntryESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<llvm::MCLineEntry, std::allocator<llvm::MCLineEntry> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::MCLineEntry*, std::vector<llvm::MCLineEntry, std::allocator<llvm::MCLineEntry> > >, llvm::MCLineEntry const&)"),
	mu_demangle_test("_ZNSt6vectorIPKN4llvm9MCSectionESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<llvm::MCSection const*, std::allocator<llvm::MCSection const*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::MCSection const**, std::vector<llvm::MCSection const*, std::allocator<llvm::MCSection const*> > >, llvm::MCSection const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_9MCSectionEPNS_13MCLineSectionENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PSt4pairIS3_S5_E", "llvm::DenseMap<llvm::MCSection const*, llvm::MCLineSection*, llvm::DenseMapInfo<llvm::MCSection const*>, llvm::DenseMapInfo<llvm::MCLineSection*> >::InsertIntoBucket(llvm::MCSection const* const&, llvm::MCLineSection* const&, std::pair<llvm::MCSection const*, llvm::MCLineSection*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_9MCSectionEPNS_13MCLineSectionENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<llvm::MCSection const*, llvm::MCLineSection*, llvm::DenseMapInfo<llvm::MCSection const*>, llvm::DenseMapInfo<llvm::MCLineSection*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNK4llvm6MCExpr18EvaluateAsAbsoluteERxPKNS_11MCAssemblerEPKNS_11MCAsmLayoutEPKNS_8DenseMapIPKNS_13MCSectionDataEyNS_12DenseMapInfoISB_EENSC_IyEEEE", "llvm::MCExpr::EvaluateAsAbsolute(int64_t&, llvm::MCAssembler const*, llvm::MCAsmLayout const*, llvm::DenseMap<llvm::MCSectionData const*, uint64_t, llvm::DenseMapInfo<llvm::MCSectionData const*>, llvm::DenseMapInfo<uint64_t> > const*) const"),
	mu_demangle_test("_ZNK4llvm6MCExpr18EvaluateAsAbsoluteERxRKNS_11MCAsmLayoutERKNS_8DenseMapIPKNS_13MCSectionDataEyNS_12DenseMapInfoIS8_EENS9_IyEEEE", "llvm::MCExpr::EvaluateAsAbsolute(int64_t&, llvm::MCAsmLayout const&, llvm::DenseMap<llvm::MCSectionData const*, uint64_t, llvm::DenseMapInfo<llvm::MCSectionData const*>, llvm::DenseMapInfo<uint64_t> > const&) const"),
	mu_demangle_test("_ZNK4llvm6MCExpr25EvaluateAsRelocatableImplERNS_7MCValueEPKNS_11MCAssemblerEPKNS_11MCAsmLayoutEPKNS_8DenseMapIPKNS_13MCSectionDataEyNS_12DenseMapInfoISC_EENSD_IyEEEEb", "llvm::MCExpr::EvaluateAsRelocatableImpl(llvm::MCValue&, llvm::MCAssembler const*, llvm::MCAsmLayout const*, llvm::DenseMap<llvm::MCSectionData const*, uint64_t, llvm::DenseMapInfo<llvm::MCSectionData const*>, llvm::DenseMapInfo<uint64_t> > const*, bool) const"),
	mu_demangle_test("_Z19EvaluateSymbolicAddPKN4llvm11MCAssemblerEPKNS_11MCAsmLayoutEPKNS_8DenseMapIPKNS_13MCSectionDataEyNS_12DenseMapInfoIS9_EENSA_IyEEEEbRKNS_7MCValueEPKNS_15MCSymbolRefExprESL_xRSG_", "EvaluateSymbolicAdd(llvm::MCAssembler const*, llvm::MCAsmLayout const*, llvm::DenseMap<llvm::MCSectionData const*, uint64_t, llvm::DenseMapInfo<llvm::MCSectionData const*>, llvm::DenseMapInfo<uint64_t> > const*, bool, llvm::MCValue const&, llvm::MCSymbolRefExpr const*, llvm::MCSymbolRefExpr const*, int64_t, llvm::MCValue&)"),
	mu_demangle_test("_Z35AttemptToFoldSymbolOffsetDifferencePKN4llvm11MCAssemblerEPKNS_11MCAsmLayoutEPKNS_8DenseMapIPKNS_13MCSectionDataEyNS_12DenseMapInfoIS9_EENSA_IyEEEEbRPKNS_15MCSymbolRefExprESJ_Rx", "AttemptToFoldSymbolOffsetDifference(llvm::MCAssembler const*, llvm::MCAsmLayout const*, llvm::DenseMap<llvm::MCSectionData const*, uint64_t, llvm::DenseMapInfo<llvm::MCSectionData const*>, llvm::DenseMapInfo<uint64_t> > const*, bool, llvm::MCSymbolRefExpr const*&, llvm::MCSymbolRefExpr const*&, int64_t&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm7MCFixupESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<llvm::MCFixup, std::allocator<llvm::MCFixup> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::MCFixup*, std::vector<llvm::MCFixup, std::allocator<llvm::MCFixup> > >, llvm::MCFixup const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_10MCFragmentEPNS_12MCSymbolDataENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PSt4pairIS3_S5_E", "llvm::DenseMap<llvm::MCFragment const*, llvm::MCSymbolData*, llvm::DenseMapInfo<llvm::MCFragment const*>, llvm::DenseMapInfo<llvm::MCSymbolData*> >::InsertIntoBucket(llvm::MCFragment const* const&, llvm::MCSymbolData* const&, std::pair<llvm::MCFragment const*, llvm::MCSymbolData*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_10MCFragmentEPNS_12MCSymbolDataENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<llvm::MCFragment const*, llvm::MCSymbolData*, llvm::DenseMapInfo<llvm::MCFragment const*>, llvm::DenseMapInfo<llvm::MCSymbolData*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_8MCSymbolEPNS_12MCSymbolDataENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PSt4pairIS3_S5_E", "llvm::DenseMap<llvm::MCSymbol const*, llvm::MCSymbolData*, llvm::DenseMapInfo<llvm::MCSymbol const*>, llvm::DenseMapInfo<llvm::MCSymbolData*> >::InsertIntoBucket(llvm::MCSymbol const* const&, llvm::MCSymbolData* const&, std::pair<llvm::MCSymbol const*, llvm::MCSymbolData*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_8MCSymbolEPNS_12MCSymbolDataENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<llvm::MCSymbol const*, llvm::MCSymbolData*, llvm::DenseMapInfo<llvm::MCSymbol const*>, llvm::DenseMapInfo<llvm::MCSymbolData*> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_9MCSectionEPNS_13MCSectionDataENS_12DenseMapInfoIS3_EENS6_IS5_EEE16InsertIntoBucketERKS3_RKS5_PSt4pairIS3_S5_E", "llvm::DenseMap<llvm::MCSection const*, llvm::MCSectionData*, llvm::DenseMapInfo<llvm::MCSection const*>, llvm::DenseMapInfo<llvm::MCSectionData*> >::InsertIntoBucket(llvm::MCSection const* const&, llvm::MCSectionData* const&, std::pair<llvm::MCSection const*, llvm::MCSectionData*>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_9MCSectionEPNS_13MCSectionDataENS_12DenseMapInfoIS3_EENS6_IS5_EEE4growEj", "llvm::DenseMap<llvm::MCSection const*, llvm::MCSectionData*, llvm::DenseMapInfo<llvm::MCSection const*>, llvm::DenseMapInfo<llvm::MCSectionData*> >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm18IndirectSymbolDataESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<llvm::IndirectSymbolData, std::allocator<llvm::IndirectSymbolData> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::IndirectSymbolData*, std::vector<llvm::IndirectSymbolData, std::allocator<llvm::IndirectSymbolData> > >, llvm::IndirectSymbolData const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm16MCCFIInstructionESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<llvm::MCCFIInstruction, std::allocator<llvm::MCCFIInstruction> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::MCCFIInstruction*, std::vector<llvm::MCCFIInstruction, std::allocator<llvm::MCCFIInstruction> > >, llvm::MCCFIInstruction const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm16MCDwarfFrameInfoESaIS1_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS1_S3_EERKS1_", "std::vector<llvm::MCDwarfFrameInfo, std::allocator<llvm::MCDwarfFrameInfo> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::MCDwarfFrameInfo*, std::vector<llvm::MCDwarfFrameInfo, std::allocator<llvm::MCDwarfFrameInfo> > >, llvm::MCDwarfFrameInfo const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm16MCCFIInstructionESaIS1_EEaSERKS3_", "std::vector<llvm::MCCFIInstruction, std::allocator<llvm::MCCFIInstruction> >::operator=(std::vector<llvm::MCCFIInstruction, std::allocator<llvm::MCCFIInstruction> > const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm16MCCFIInstructionESaIS1_EEC2ERKS3_", "std::vector<llvm::MCCFIInstruction, std::allocator<llvm::MCCFIInstruction> >::vector(std::vector<llvm::MCCFIInstruction, std::allocator<llvm::MCCFIInstruction> > const&)"),
	mu_demangle_test("_ZNSt6vectorIN12_GLOBAL__N_116MachObjectWriter14MachSymbolDataESaIS2_EE9push_backERKS2_", "std::vector<(anonymous namespace)::MachObjectWriter::MachSymbolData, std::allocator<(anonymous namespace)::MachObjectWriter::MachSymbolData> >::push_back((anonymous namespace)::MachObjectWriter::MachSymbolData const&)"),
	mu_demangle_test("_ZSt4sortIN9__gnu_cxx17__normal_iteratorIPN12_GLOBAL__N_116MachObjectWriter14MachSymbolDataESt6vectorIS4_SaIS4_EEEEEvT_SA_", "void std::sort<__gnu_cxx::__normal_iterator<(anonymous namespace)::MachObjectWriter::MachSymbolData*, std::vector<(anonymous namespace)::MachObjectWriter::MachSymbolData, std::allocator<(anonymous namespace)::MachObjectWriter::MachSymbolData> > > >(__gnu_cxx::__normal_iterator<(anonymous namespace)::MachObjectWriter::MachSymbolData*, std::vector<(anonymous namespace)::MachObjectWriter::MachSymbolData, std::allocator<(anonymous namespace)::MachObjectWriter::MachSymbolData> > >, __gnu_cxx::__normal_iterator<(anonymous namespace)::MachObjectWriter::MachSymbolData*, std::vector<(anonymous namespace)::MachObjectWriter::MachSymbolData, std::allocator<(anonymous namespace)::MachObjectWriter::MachSymbolData> > >)"),
	mu_demangle_test("_ZSt16__introsort_loopIN9__gnu_cxx17__normal_iteratorIPN12_GLOBAL__N_116MachObjectWriter14MachSymbolDataESt6vectorIS4_SaIS4_EEEElEvT_SA_T0_", "void std::__introsort_loop<__gnu_cxx::__normal_iterator<(anonymous namespace)::MachObjectWriter::MachSymbolData*, std::vector<(anonymous namespace)::MachObjectWriter::MachSymbolData, std::allocator<(anonymous namespace)::MachObjectWriter::MachSymbolData> > >, long>(__gnu_cxx::__normal_iterator<(anonymous namespace)::MachObjectWriter::MachSymbolData*, std::vector<(anonymous namespace)::MachObjectWriter::MachSymbolData, std::allocator<(anonymous namespace)::MachObjectWriter::MachSymbolData> > >, __gnu_cxx::__normal_iterator<(anonymous namespace)::MachObjectWriter::MachSymbolData*, std::vector<(anonymous namespace)::MachObjectWriter::MachSymbolData, std::allocator<(anonymous namespace)::MachObjectWriter::MachSymbolData> > >, long)"),
	mu_demangle_test("_ZSt16__insertion_sortIN9__gnu_cxx17__normal_iteratorIPN12_GLOBAL__N_116MachObjectWriter14MachSymbolDataESt6vectorIS4_SaIS4_EEEEEvT_SA_", "void std::__insertion_sort<__gnu_cxx::__normal_iterator<(anonymous namespace)::MachObjectWriter::MachSymbolData*, std::vector<(anonymous namespace)::MachObjectWriter::MachSymbolData, std::allocator<(anonymous namespace)::MachObjectWriter::MachSymbolData> > > >(__gnu_cxx::__normal_iterator<(anonymous namespace)::MachObjectWriter::MachSymbolData*, std::vector<(anonymous namespace)::MachObjectWriter::MachSymbolData, std::allocator<(anonymous namespace)::MachObjectWriter::MachSymbolData> > >, __gnu_cxx::__normal_iterator<(anonymous namespace)::MachObjectWriter::MachSymbolData*, std::vector<(anonymous namespace)::MachObjectWriter::MachSymbolData, std::allocator<(anonymous namespace)::MachObjectWriter::MachSymbolData> > >)"),
	mu_demangle_test("_ZSt13__adjust_heapIN9__gnu_cxx17__normal_iteratorIPN12_GLOBAL__N_116MachObjectWriter14MachSymbolDataESt6vectorIS4_SaIS4_EEEElS4_EvT_T0_SB_T1_", "void std::__adjust_heap<__gnu_cxx::__normal_iterator<(anonymous namespace)::MachObjectWriter::MachSymbolData*, std::vector<(anonymous namespace)::MachObjectWriter::MachSymbolData, std::allocator<(anonymous namespace)::MachObjectWriter::MachSymbolData> > >, long, (anonymous namespace)::MachObjectWriter::MachSymbolData>(__gnu_cxx::__normal_iterator<(anonymous namespace)::MachObjectWriter::MachSymbolData*, std::vector<(anonymous namespace)::MachObjectWriter::MachSymbolData, std::allocator<(anonymous namespace)::MachObjectWriter::MachSymbolData> > >, long, long, (anonymous namespace)::MachObjectWriter::MachSymbolData)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_13MCSectionDataESt6vectorINS_6object5macho15RelocationEntryESaIS7_EENS_12DenseMapInfoIS3_EENSA_IS9_EEE16FindAndConstructERKS3_", "llvm::DenseMap<llvm::MCSectionData const*, std::vector<llvm::object::macho::RelocationEntry, std::allocator<llvm::object::macho::RelocationEntry> >, llvm::DenseMapInfo<llvm::MCSectionData const*>, llvm::DenseMapInfo<std::vector<llvm::object::macho::RelocationEntry, std::allocator<llvm::object::macho::RelocationEntry> > > >::FindAndConstruct(llvm::MCSectionData const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_13MCSectionDataESt6vectorINS_6object5macho15RelocationEntryESaIS7_EENS_12DenseMapInfoIS3_EENSA_IS9_EEE16InsertIntoBucketERKS3_RKS9_PSt4pairIS3_S9_E", "llvm::DenseMap<llvm::MCSectionData const*, std::vector<llvm::object::macho::RelocationEntry, std::allocator<llvm::object::macho::RelocationEntry> >, llvm::DenseMapInfo<llvm::MCSectionData const*>, llvm::DenseMapInfo<std::vector<llvm::object::macho::RelocationEntry, std::allocator<llvm::object::macho::RelocationEntry> > > >::InsertIntoBucket(llvm::MCSectionData const* const&, std::vector<llvm::object::macho::RelocationEntry, std::allocator<llvm::object::macho::RelocationEntry> > const&, std::pair<llvm::MCSectionData const*, std::vector<llvm::object::macho::RelocationEntry, std::allocator<llvm::object::macho::RelocationEntry> > >*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_13MCSectionDataESt6vectorINS_6object5macho15RelocationEntryESaIS7_EENS_12DenseMapInfoIS3_EENSA_IS9_EEE4growEj", "llvm::DenseMap<llvm::MCSectionData const*, std::vector<llvm::object::macho::RelocationEntry, std::allocator<llvm::object::macho::RelocationEntry> >, llvm::DenseMapInfo<llvm::MCSectionData const*>, llvm::DenseMapInfo<std::vector<llvm::object::macho::RelocationEntry, std::allocator<llvm::object::macho::RelocationEntry> > > >::grow(unsigned int)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm6object5macho15RelocationEntryESaIS3_EEC2ERKS5_", "std::vector<llvm::object::macho::RelocationEntry, std::allocator<llvm::object::macho::RelocationEntry> >::vector(std::vector<llvm::object::macho::RelocationEntry, std::allocator<llvm::object::macho::RelocationEntry> > const&)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm6object5macho15RelocationEntryESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<llvm::object::macho::RelocationEntry, std::allocator<llvm::object::macho::RelocationEntry> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::object::macho::RelocationEntry*, std::vector<llvm::object::macho::RelocationEntry, std::allocator<llvm::object::macho::RelocationEntry> > >, llvm::object::macho::RelocationEntry const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_9MCSectionEhNS_12DenseMapInfoIS3_EENS4_IhEEE16InsertIntoBucketERKS3_RKhPSt4pairIS3_hE", "llvm::DenseMap<llvm::MCSection const*, unsigned char, llvm::DenseMapInfo<llvm::MCSection const*>, llvm::DenseMapInfo<unsigned char> >::InsertIntoBucket(llvm::MCSection const* const&, unsigned char const&, std::pair<llvm::MCSection const*, unsigned char>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_9MCSectionEhNS_12DenseMapInfoIS3_EENS4_IhEEE4growEj", "llvm::DenseMap<llvm::MCSection const*, unsigned char, llvm::DenseMapInfo<llvm::MCSection const*>, llvm::DenseMapInfo<unsigned char> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_13MCSectionDataEjNS_12DenseMapInfoIS3_EENS4_IjEEE16InsertIntoBucketERKS3_RKjPSt4pairIS3_jE", "llvm::DenseMap<llvm::MCSectionData const*, unsigned int, llvm::DenseMapInfo<llvm::MCSectionData const*>, llvm::DenseMapInfo<unsigned int> >::InsertIntoBucket(llvm::MCSectionData const* const&, unsigned int const&, std::pair<llvm::MCSectionData const*, unsigned int>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_13MCSectionDataEjNS_12DenseMapInfoIS3_EENS4_IjEEE4growEj", "llvm::DenseMap<llvm::MCSectionData const*, unsigned int, llvm::DenseMapInfo<llvm::MCSectionData const*>, llvm::DenseMapInfo<unsigned int> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_13MCSectionDataEyNS_12DenseMapInfoIS3_EENS4_IyEEE16InsertIntoBucketERKS3_RKyPSt4pairIS3_yE", "llvm::DenseMap<llvm::MCSectionData const*, uint64_t, llvm::DenseMapInfo<llvm::MCSectionData const*>, llvm::DenseMapInfo<uint64_t> >::InsertIntoBucket(llvm::MCSectionData const* const&, uint64_t const&, std::pair<llvm::MCSectionData const*, uint64_t>*)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_13MCSectionDataEyNS_12DenseMapInfoIS3_EENS4_IyEEE4growEj", "llvm::DenseMap<llvm::MCSectionData const*, uint64_t, llvm::DenseMapInfo<llvm::MCSectionData const*>, llvm::DenseMapInfo<uint64_t> >::grow(unsigned int)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_9MCSectionEPN12_GLOBAL__N_111COFFSectionENS_12DenseMapInfoIS3_EENS7_IS6_EEEixERKS3_", "llvm::DenseMap<llvm::MCSection const*, (anonymous namespace)::COFFSection*, llvm::DenseMapInfo<llvm::MCSection const*>, llvm::DenseMapInfo<(anonymous namespace)::COFFSection*> >::operator[](llvm::MCSection const* const&)"),
	mu_demangle_test("_ZN4llvm8DenseMapIPKNS_8MCSymbolEPN12_GLOBAL__N_110COFFSymbolENS_12DenseMapInfoIS3_EENS7_IS6_EEEixERKS3_", "llvm::DenseMap<llvm::MCSymbol const*, (anonymous namespace)::COFFSymbol*, llvm::DenseMapInfo<llvm::MCSymbol const*>, llvm::DenseMapInfo<(anonymous namespace)::COFFSymbol*> >::operator[](llvm::MCSymbol const* const&)"),
	mu_demangle_test("_ZN12_GLOBAL__N_119WinCOFFObjectWriter16createCOFFEntityINS_10COFFSymbolESt6vectorIPS2_SaIS4_EEEEPT_N4llvm9StringRefERT0_", "(anonymous namespace)::COFFSymbol* (anonymous namespace)::WinCOFFObjectWriter::createCOFFEntity<(anonymous namespace)::COFFSymbol, std::vector<(anonymous namespace)::COFFSymbol*, std::allocator<(anonymous namespace)::COFFSymbol*> > >(llvm::StringRef, std::vector<(anonymous namespace)::COFFSymbol*, std::allocator<(anonymous namespace)::COFFSymbol*> >&)"),
	mu_demangle_test("_ZNSt6vectorIcSaIcEE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPcS1_EERKc", "std::vector<char, std::allocator<char> >::_M_insert_aux(__gnu_cxx::__normal_iterator<char*, std::vector<char, std::allocator<char> > >, char const&)"),
	mu_demangle_test("_ZNSt6vectorIcSaIcEE15_M_range_insertIPKcEEvN9__gnu_cxx17__normal_iteratorIPcS1_EET_S9_St20forward_iterator_tag", "void std::vector<char, std::allocator<char> >::_M_range_insert<char const*>(__gnu_cxx::__normal_iterator<char*, std::vector<char, std::allocator<char> > >, char const*, char const*, std::forward_iterator_tag)"),
	// mu_demangle_test("_ZN4llvm7APFloatC1EDF16_", "llvm::APFloat::APFloat(_Float16)"),
	// mu_demangle_test("_ZN4llvm7APFloatC2EDF16_", "llvm::APFloat::APFloat(_Float16)"),
	mu_demangle_test("_Z18ParseCStringVectorRSt6vectorIPcSaIS0_EEPKc", "ParseCStringVector(std::vector<char*, std::allocator<char*> >&, char const*)"),
	mu_demangle_test("_ZN4llvm2cl3optIN12_GLOBAL__N_111HelpPrinterELb1ENS0_6parserIbEEED1Ev", "llvm::cl::opt<(anonymous namespace)::HelpPrinter, true, llvm::cl::parser<bool> >::~opt()"),
	mu_demangle_test("_ZN4llvm2cl3optIN12_GLOBAL__N_114VersionPrinterELb1ENS0_6parserIbEEED1Ev", "llvm::cl::opt<(anonymous namespace)::VersionPrinter, true, llvm::cl::parser<bool> >::~opt()"),
	mu_demangle_test("_ZN4llvm2cl3optIN12_GLOBAL__N_114VersionPrinterELb1ENS0_6parserIbEEE16handleOccurrenceEjNS_9StringRefES7_", "llvm::cl::opt<(anonymous namespace)::VersionPrinter, true, llvm::cl::parser<bool> >::handleOccurrence(unsigned int, llvm::StringRef, llvm::StringRef)"),
	mu_demangle_test("_ZNK4llvm2cl3optIN12_GLOBAL__N_114VersionPrinterELb1ENS0_6parserIbEEE27getValueExpectedFlagDefaultEv", "llvm::cl::opt<(anonymous namespace)::VersionPrinter, true, llvm::cl::parser<bool> >::getValueExpectedFlagDefault() const"),
	mu_demangle_test("_ZNK4llvm2cl3optIN12_GLOBAL__N_114VersionPrinterELb1ENS0_6parserIbEEE14getOptionWidthEv", "llvm::cl::opt<(anonymous namespace)::VersionPrinter, true, llvm::cl::parser<bool> >::getOptionWidth() const"),
	mu_demangle_test("_ZNK4llvm2cl3optIN12_GLOBAL__N_114VersionPrinterELb1ENS0_6parserIbEEE15printOptionInfoEm", "llvm::cl::opt<(anonymous namespace)::VersionPrinter, true, llvm::cl::parser<bool> >::printOptionInfo(unsigned long) const"),
	mu_demangle_test("_ZN4llvm2cl3optIN12_GLOBAL__N_114VersionPrinterELb1ENS0_6parserIbEEE19getExtraOptionNamesERNS_15SmallVectorImplIPKcEE", "llvm::cl::opt<(anonymous namespace)::VersionPrinter, true, llvm::cl::parser<bool> >::getExtraOptionNames(llvm::SmallVectorImpl<char const*>&)"),
	mu_demangle_test("_ZN4llvm2cl3optIN12_GLOBAL__N_114VersionPrinterELb1ENS0_6parserIbEEED0Ev", "llvm::cl::opt<(anonymous namespace)::VersionPrinter, true, llvm::cl::parser<bool> >::~opt()"),
	mu_demangle_test("_ZN4llvm2cl3optIN12_GLOBAL__N_111HelpPrinterELb1ENS0_6parserIbEEE16handleOccurrenceEjNS_9StringRefES7_", "llvm::cl::opt<(anonymous namespace)::HelpPrinter, true, llvm::cl::parser<bool> >::handleOccurrence(unsigned int, llvm::StringRef, llvm::StringRef)"),
	mu_demangle_test("_ZNK4llvm2cl3optIN12_GLOBAL__N_111HelpPrinterELb1ENS0_6parserIbEEE27getValueExpectedFlagDefaultEv", "llvm::cl::opt<(anonymous namespace)::HelpPrinter, true, llvm::cl::parser<bool> >::getValueExpectedFlagDefault() const"),
	mu_demangle_test("_ZNK4llvm2cl3optIN12_GLOBAL__N_111HelpPrinterELb1ENS0_6parserIbEEE14getOptionWidthEv", "llvm::cl::opt<(anonymous namespace)::HelpPrinter, true, llvm::cl::parser<bool> >::getOptionWidth() const"),
	mu_demangle_test("_ZNK4llvm2cl3optIN12_GLOBAL__N_111HelpPrinterELb1ENS0_6parserIbEEE15printOptionInfoEm", "llvm::cl::opt<(anonymous namespace)::HelpPrinter, true, llvm::cl::parser<bool> >::printOptionInfo(unsigned long) const"),
	mu_demangle_test("_ZN4llvm2cl3optIN12_GLOBAL__N_111HelpPrinterELb1ENS0_6parserIbEEE19getExtraOptionNamesERNS_15SmallVectorImplIPKcEE", "llvm::cl::opt<(anonymous namespace)::HelpPrinter, true, llvm::cl::parser<bool> >::getExtraOptionNames(llvm::SmallVectorImpl<char const*>&)"),
	mu_demangle_test("_ZN4llvm2cl3optIN12_GLOBAL__N_111HelpPrinterELb1ENS0_6parserIbEEED0Ev", "llvm::cl::opt<(anonymous namespace)::HelpPrinter, true, llvm::cl::parser<bool> >::~opt()"),
	mu_demangle_test("_ZN4llvm2cl3optIjLb0ENS0_6parserIjEEE16handleOccurrenceEjNS_9StringRefES5_", "llvm::cl::opt<unsigned int, false, llvm::cl::parser<unsigned int> >::handleOccurrence(unsigned int, llvm::StringRef, llvm::StringRef)"),
	mu_demangle_test("_ZNK4llvm2cl3optIjLb0ENS0_6parserIjEEE27getValueExpectedFlagDefaultEv", "llvm::cl::opt<unsigned int, false, llvm::cl::parser<unsigned int> >::getValueExpectedFlagDefault() const"),
	mu_demangle_test("_ZN4llvm2cl3optIjLb0ENS0_6parserIjEEE19getExtraOptionNamesERNS_15SmallVectorImplIPKcEE", "llvm::cl::opt<unsigned int, false, llvm::cl::parser<unsigned int> >::getExtraOptionNames(llvm::SmallVectorImpl<char const*>&)"),
	mu_demangle_test("_ZNK4llvm2cl3optIjLb0ENS0_6parserIjEEE14getOptionWidthEv", "llvm::cl::opt<unsigned int, false, llvm::cl::parser<unsigned int> >::getOptionWidth() const"),
	mu_demangle_test("_ZNK4llvm2cl3optIjLb0ENS0_6parserIjEEE15printOptionInfoEm", "llvm::cl::opt<unsigned int, false, llvm::cl::parser<unsigned int> >::printOptionInfo(unsigned long) const"),
	mu_demangle_test("_ZN4llvm2cl3optIjLb0ENS0_6parserIjEEE4doneEv", "llvm::cl::opt<unsigned int, false, llvm::cl::parser<unsigned int> >::done()"),
	mu_demangle_test("_ZN4llvm2cl3optIjLb0ENS0_6parserIjEEE15setInitialValueERKj", "llvm::cl::opt<unsigned int, false, llvm::cl::parser<unsigned int> >::setInitialValue(unsigned int const&)"),
	mu_demangle_test("_ZN4llvm2cl3optIjLb0ENS0_6parserIjEEE9getParserEv", "llvm::cl::opt<unsigned int, false, llvm::cl::parser<unsigned int> >::getParser()"),
	mu_demangle_test("_ZN4llvm2cl3optIiLb0ENS0_6parserIiEEE16handleOccurrenceEjNS_9StringRefES5_", "llvm::cl::opt<int, false, llvm::cl::parser<int> >::handleOccurrence(unsigned int, llvm::StringRef, llvm::StringRef)"),
	mu_demangle_test("_ZNK4llvm2cl3optIiLb0ENS0_6parserIiEEE27getValueExpectedFlagDefaultEv", "llvm::cl::opt<int, false, llvm::cl::parser<int> >::getValueExpectedFlagDefault() const"),
	mu_demangle_test("_ZN4llvm2cl3optIiLb0ENS0_6parserIiEEE19getExtraOptionNamesERNS_15SmallVectorImplIPKcEE", "llvm::cl::opt<int, false, llvm::cl::parser<int> >::getExtraOptionNames(llvm::SmallVectorImpl<char const*>&)"),
	mu_demangle_test("_ZNK4llvm2cl3optIiLb0ENS0_6parserIiEEE14getOptionWidthEv", "llvm::cl::opt<int, false, llvm::cl::parser<int> >::getOptionWidth() const"),
	mu_demangle_test("_ZNK4llvm2cl3optIiLb0ENS0_6parserIiEEE15printOptionInfoEm", "llvm::cl::opt<int, false, llvm::cl::parser<int> >::printOptionInfo(unsigned long) const"),
	mu_demangle_test("_ZN4llvm2cl3optIiLb0ENS0_6parserIiEEE4doneEv", "llvm::cl::opt<int, false, llvm::cl::parser<int> >::done()"),
	mu_demangle_test("_ZN4llvm2cl3optIiLb0ENS0_6parserIiEEE15setInitialValueERKi", "llvm::cl::opt<int, false, llvm::cl::parser<int> >::setInitialValue(int const&)"),
	mu_demangle_test("_ZN4llvm2cl3optIiLb0ENS0_6parserIiEEE9getParserEv", "llvm::cl::opt<int, false, llvm::cl::parser<int> >::getParser()"),
	mu_demangle_test("_ZN4llvm2cl3optISsLb0ENS0_6parserISsEEE16handleOccurrenceEjNS_9StringRefES5_", "llvm::cl::opt<std::string, false, llvm::cl::parser<std::string> >::handleOccurrence(unsigned int, llvm::StringRef, llvm::StringRef)"),
	mu_demangle_test("_ZNK4llvm2cl3optISsLb0ENS0_6parserISsEEE27getValueExpectedFlagDefaultEv", "llvm::cl::opt<std::string, false, llvm::cl::parser<std::string> >::getValueExpectedFlagDefault() const"),
	mu_demangle_test("_ZN4llvm2cl3optISsLb0ENS0_6parserISsEEE19getExtraOptionNamesERNS_15SmallVectorImplIPKcEE", "llvm::cl::opt<std::string, false, llvm::cl::parser<std::string> >::getExtraOptionNames(llvm::SmallVectorImpl<char const*>&)"),
	mu_demangle_test("_ZNK4llvm2cl3optISsLb0ENS0_6parserISsEEE14getOptionWidthEv", "llvm::cl::opt<std::string, false, llvm::cl::parser<std::string> >::getOptionWidth() const"),
	mu_demangle_test("_ZNK4llvm2cl3optISsLb0ENS0_6parserISsEEE15printOptionInfoEm", "llvm::cl::opt<std::string, false, llvm::cl::parser<std::string> >::printOptionInfo(unsigned long) const"),
	mu_demangle_test("_ZN4llvm2cl3optISsLb0ENS0_6parserISsEEE4doneEv", "llvm::cl::opt<std::string, false, llvm::cl::parser<std::string> >::done()"),
	mu_demangle_test("_ZN4llvm2cl3optISsLb0ENS0_6parserISsEEE15setInitialValueERKSs", "llvm::cl::opt<std::string, false, llvm::cl::parser<std::string> >::setInitialValue(std::string const&)"),
	mu_demangle_test("_ZN4llvm2cl3optISsLb0ENS0_6parserISsEEE9getParserEv", "llvm::cl::opt<std::string, false, llvm::cl::parser<std::string> >::getParser()"),
	mu_demangle_test("_ZN4llvm2cl3optIcLb0ENS0_6parserIcEEE16handleOccurrenceEjNS_9StringRefES5_", "llvm::cl::opt<char, false, llvm::cl::parser<char> >::handleOccurrence(unsigned int, llvm::StringRef, llvm::StringRef)"),
	mu_demangle_test("_ZNK4llvm2cl3optIcLb0ENS0_6parserIcEEE27getValueExpectedFlagDefaultEv", "llvm::cl::opt<char, false, llvm::cl::parser<char> >::getValueExpectedFlagDefault() const"),
	mu_demangle_test("_ZN4llvm2cl3optIcLb0ENS0_6parserIcEEE19getExtraOptionNamesERNS_15SmallVectorImplIPKcEE", "llvm::cl::opt<char, false, llvm::cl::parser<char> >::getExtraOptionNames(llvm::SmallVectorImpl<char const*>&)"),
	mu_demangle_test("_ZNK4llvm2cl3optIcLb0ENS0_6parserIcEEE14getOptionWidthEv", "llvm::cl::opt<char, false, llvm::cl::parser<char> >::getOptionWidth() const"),
	mu_demangle_test("_ZNK4llvm2cl3optIcLb0ENS0_6parserIcEEE15printOptionInfoEm", "llvm::cl::opt<char, false, llvm::cl::parser<char> >::printOptionInfo(unsigned long) const"),
	mu_demangle_test("_ZN4llvm2cl3optIcLb0ENS0_6parserIcEEE4doneEv", "llvm::cl::opt<char, false, llvm::cl::parser<char> >::done()"),
	mu_demangle_test("_ZN4llvm2cl3optIcLb0ENS0_6parserIcEEE15setInitialValueERKc", "llvm::cl::opt<char, false, llvm::cl::parser<char> >::setInitialValue(char const&)"),
	mu_demangle_test("_ZN4llvm2cl3optIcLb0ENS0_6parserIcEEE9getParserEv", "llvm::cl::opt<char, false, llvm::cl::parser<char> >::getParser()"),
	mu_demangle_test("_ZN4llvm2cl3optIbLb0ENS0_6parserIbEEE16handleOccurrenceEjNS_9StringRefES5_", "llvm::cl::opt<bool, false, llvm::cl::parser<bool> >::handleOccurrence(unsigned int, llvm::StringRef, llvm::StringRef)"),
	mu_demangle_test("_ZNK4llvm2cl3optIbLb0ENS0_6parserIbEEE27getValueExpectedFlagDefaultEv", "llvm::cl::opt<bool, false, llvm::cl::parser<bool> >::getValueExpectedFlagDefault() const"),
	mu_demangle_test("_ZN4llvm2cl3optIbLb0ENS0_6parserIbEEE19getExtraOptionNamesERNS_15SmallVectorImplIPKcEE", "llvm::cl::opt<bool, false, llvm::cl::parser<bool> >::getExtraOptionNames(llvm::SmallVectorImpl<char const*>&)"),
	mu_demangle_test("_ZNK4llvm2cl3optIbLb0ENS0_6parserIbEEE14getOptionWidthEv", "llvm::cl::opt<bool, false, llvm::cl::parser<bool> >::getOptionWidth() const"),
	mu_demangle_test("_ZNK4llvm2cl3optIbLb0ENS0_6parserIbEEE15printOptionInfoEm", "llvm::cl::opt<bool, false, llvm::cl::parser<bool> >::printOptionInfo(unsigned long) const"),
	mu_demangle_test("_ZN4llvm2cl3optIbLb0ENS0_6parserIbEEE4doneEv", "llvm::cl::opt<bool, false, llvm::cl::parser<bool> >::done()"),
	mu_demangle_test("_ZN4llvm2cl3optIbLb0ENS0_6parserIbEEE15setInitialValueERKb", "llvm::cl::opt<bool, false, llvm::cl::parser<bool> >::setInitialValue(bool const&)"),
	mu_demangle_test("_ZN4llvm2cl3optIbLb0ENS0_6parserIbEEE9getParserEv", "llvm::cl::opt<bool, false, llvm::cl::parser<bool> >::getParser()"),
	mu_demangle_test("_ZN4llvm2cl3optIjLb0ENS0_6parserIjEEED1Ev", "llvm::cl::opt<unsigned int, false, llvm::cl::parser<unsigned int> >::~opt()"),
	mu_demangle_test("_ZN4llvm2cl3optIjLb0ENS0_6parserIjEEED0Ev", "llvm::cl::opt<unsigned int, false, llvm::cl::parser<unsigned int> >::~opt()"),
	mu_demangle_test("_ZN4llvm2cl3optIiLb0ENS0_6parserIiEEED1Ev", "llvm::cl::opt<int, false, llvm::cl::parser<int> >::~opt()"),
	mu_demangle_test("_ZN4llvm2cl3optIiLb0ENS0_6parserIiEEED0Ev", "llvm::cl::opt<int, false, llvm::cl::parser<int> >::~opt()"),
	mu_demangle_test("_ZN4llvm2cl3optISsLb0ENS0_6parserISsEEED1Ev", "llvm::cl::opt<std::string, false, llvm::cl::parser<std::string> >::~opt()"),
	mu_demangle_test("_ZN4llvm2cl3optISsLb0ENS0_6parserISsEEED0Ev", "llvm::cl::opt<std::string, false, llvm::cl::parser<std::string> >::~opt()"),
	mu_demangle_test("_ZN4llvm2cl3optIcLb0ENS0_6parserIcEEED1Ev", "llvm::cl::opt<char, false, llvm::cl::parser<char> >::~opt()"),
	mu_demangle_test("_ZN4llvm2cl3optIcLb0ENS0_6parserIcEEED0Ev", "llvm::cl::opt<char, false, llvm::cl::parser<char> >::~opt()"),
	mu_demangle_test("_ZN4llvm2cl3optIbLb0ENS0_6parserIbEEED0Ev", "llvm::cl::opt<bool, false, llvm::cl::parser<bool> >::~opt()"),
	mu_demangle_test("_ZNSt6vectorIPcSaIS0_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS0_S2_EERKS0_", "std::vector<char*, std::allocator<char*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<char**, std::vector<char*, std::allocator<char*> > >, char* const&)"),
	mu_demangle_test("_ZN4llvm14object_creatorISt6vectorIPKcSaIS3_EEEEPvv", "void* llvm::object_creator<std::vector<char const*, std::allocator<char const*> > >()"),
	mu_demangle_test("_ZN4llvm14object_deleterISt6vectorIPKcSaIS3_EEE4callEPv", "llvm::object_deleter<std::vector<char const*, std::allocator<char const*> > >::call(void*)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPKcPKN4llvm6TargetEESaIS7_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS7_S9_EERKS7_", "std::vector<std::pair<char const*, llvm::Target const*>, std::allocator<std::pair<char const*, llvm::Target const*> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<char const*, llvm::Target const*>*, std::vector<std::pair<char const*, llvm::Target const*>, std::allocator<std::pair<char const*, llvm::Target const*> > > >, std::pair<char const*, llvm::Target const*> const&)"),
	mu_demangle_test("_ZNSt3mapISsPvSt4lessISsESaISt4pairIKSsS0_EEEixERS4_", "std::map<std::string, void*, std::less<std::string>, std::allocator<std::pair<std::string const, void*> > >::operator[](std::string const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsPvESt10_Select1stIS3_ESt4lessISsESaIS3_EE4findERS1_", "std::_Rb_tree<std::string, std::pair<std::string const, void*>, std::_Select1st<std::pair<std::string const, void*> >, std::less<std::string>, std::allocator<std::pair<std::string const, void*> > >::find(std::string const&)"),
	mu_demangle_test("_ZNSt6vectorIPvSaIS0_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS0_S2_EERKS0_", "std::vector<void*, std::allocator<void*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<void**, std::vector<void*, std::allocator<void*> > >, void* const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsPvESt10_Select1stIS3_ESt4lessISsESaIS3_EE16_M_insert_uniqueESt17_Rb_tree_iteratorIS3_ERKS3_", "std::_Rb_tree<std::string, std::pair<std::string const, void*>, std::_Select1st<std::pair<std::string const, void*> >, std::less<std::string>, std::allocator<std::pair<std::string const, void*> > >::_M_insert_unique(std::_Rb_tree_iterator<std::pair<std::string const, void*> >, std::pair<std::string const, void*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsPvESt10_Select1stIS3_ESt4lessISsESaIS3_EE9_M_insertEPSt18_Rb_tree_node_baseSB_RKS3_", "std::_Rb_tree<std::string, std::pair<std::string const, void*>, std::_Select1st<std::pair<std::string const, void*> >, std::less<std::string>, std::allocator<std::pair<std::string const, void*> > >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, std::pair<std::string const, void*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsPvESt10_Select1stIS3_ESt4lessISsESaIS3_EE16_M_insert_uniqueERKS3_", "std::_Rb_tree<std::string, std::pair<std::string const, void*>, std::_Select1st<std::pair<std::string const, void*> >, std::less<std::string>, std::allocator<std::pair<std::string const, void*> > >::_M_insert_unique(std::pair<std::string const, void*> const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeISsSt4pairIKSsPvESt10_Select1stIS3_ESt4lessISsESaIS3_EE8_M_eraseEPSt13_Rb_tree_nodeIS3_E", "std::_Rb_tree<std::string, std::pair<std::string const, void*>, std::_Select1st<std::pair<std::string const, void*> >, std::less<std::string>, std::allocator<std::pair<std::string const, void*> > >::_M_erase(std::_Rb_tree_node<std::pair<std::string const, void*> >*)"),
	mu_demangle_test("_ZN4llvm3sys4Path21GetSystemLibraryPathsERSt6vectorIS1_SaIS1_EE", "llvm::sys::Path::GetSystemLibraryPaths(std::vector<llvm::sys::Path, std::allocator<llvm::sys::Path> >&)"),
	mu_demangle_test("_Z11getPathListPKcRSt6vectorIN4llvm3sys4PathESaIS4_EE", "getPathList(char const*, std::vector<llvm::sys::Path, std::allocator<llvm::sys::Path> >&)"),
	mu_demangle_test("_ZN4llvm3sys4Path22GetBitcodeLibraryPathsERSt6vectorIS1_SaIS1_EE", "llvm::sys::Path::GetBitcodeLibraryPaths(std::vector<llvm::sys::Path, std::allocator<llvm::sys::Path> >&)"),
	mu_demangle_test("_ZNK4llvm3sys4Path20getDirectoryContentsERSt3setIS1_St4lessIS1_ESaIS1_EEPSs", "llvm::sys::Path::getDirectoryContents(std::set<llvm::sys::Path, std::less<llvm::sys::Path>, std::allocator<llvm::sys::Path> >&, std::string*) const"),
	mu_demangle_test("_ZNSt6vectorIcSaIcEE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPcS1_EEmRKc", "std::vector<char, std::allocator<char> >::_M_fill_insert(__gnu_cxx::__normal_iterator<char*, std::vector<char, std::allocator<char> > >, unsigned long, char const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm3sys4PathES2_St9_IdentityIS2_ESt4lessIS2_ESaIS2_EE16_M_insert_uniqueERKS2_", "std::_Rb_tree<llvm::sys::Path, llvm::sys::Path, std::_Identity<llvm::sys::Path>, std::less<llvm::sys::Path>, std::allocator<llvm::sys::Path> >::_M_insert_unique(llvm::sys::Path const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm3sys4PathES2_St9_IdentityIS2_ESt4lessIS2_ESaIS2_EE9_M_insertEPSt18_Rb_tree_node_baseSA_RKS2_", "std::_Rb_tree<llvm::sys::Path, llvm::sys::Path, std::_Identity<llvm::sys::Path>, std::less<llvm::sys::Path>, std::allocator<llvm::sys::Path> >::_M_insert(std::_Rb_tree_node_base*, std::_Rb_tree_node_base*, llvm::sys::Path const&)"),
	mu_demangle_test("_ZNSt8_Rb_treeIN4llvm3sys4PathES2_St9_IdentityIS2_ESt4lessIS2_ESaIS2_EE8_M_eraseEPSt13_Rb_tree_nodeIS2_E", "std::_Rb_tree<llvm::sys::Path, llvm::sys::Path, std::_Identity<llvm::sys::Path>, std::less<llvm::sys::Path>, std::allocator<llvm::sys::Path> >::_M_erase(std::_Rb_tree_node<llvm::sys::Path>*)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm3sys4PathESaIS2_EED1Ev", "std::vector<llvm::sys::Path, std::allocator<llvm::sys::Path> >::~vector()"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPFvPvES1_ESaIS4_EED1Ev", "std::vector<std::pair<void (*)(void*), void*>, std::allocator<std::pair<void (*)(void*), void*> > >::~vector()"),
	mu_demangle_test("_ZNSt6vectorISt4pairIPFvPvES1_ESaIS4_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS4_S6_EERKS4_", "std::vector<std::pair<void (*)(void*), void*>, std::allocator<std::pair<void (*)(void*), void*> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<void (*)(void*), void*>*, std::vector<std::pair<void (*)(void*), void*>, std::allocator<std::pair<void (*)(void*), void*> > > >, std::pair<void (*)(void*), void*> const&)"),
	mu_demangle_test("_ZSt6__findISt16reverse_iteratorIN9__gnu_cxx17__normal_iteratorIPN4llvm3sys4PathESt6vectorIS5_SaIS5_EEEEES5_ET_SC_SC_RKT0_St26random_access_iterator_tag", "std::reverse_iterator<__gnu_cxx::__normal_iterator<llvm::sys::Path*, std::vector<llvm::sys::Path, std::allocator<llvm::sys::Path> > > > std::__find<std::reverse_iterator<__gnu_cxx::__normal_iterator<llvm::sys::Path*, std::vector<llvm::sys::Path, std::allocator<llvm::sys::Path> > > >, llvm::sys::Path>(std::reverse_iterator<__gnu_cxx::__normal_iterator<llvm::sys::Path*, std::vector<llvm::sys::Path, std::allocator<llvm::sys::Path> > > >, std::reverse_iterator<__gnu_cxx::__normal_iterator<llvm::sys::Path*, std::vector<llvm::sys::Path, std::allocator<llvm::sys::Path> > > >, llvm::sys::Path const&, std::random_access_iterator_tag)"),
	mu_demangle_test("_ZNSt6vectorIN4llvm3sys4PathESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::sys::Path, std::allocator<llvm::sys::Path> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::sys::Path*, std::vector<llvm::sys::Path, std::allocator<llvm::sys::Path> > >, llvm::sys::Path const&)"),
	mu_demangle_test("_ZSt21__inplace_stable_sortIN9__gnu_cxx17__normal_iteratorIPPKN4llvm9StatisticESt6vectorIS5_SaIS5_EEEEN12_GLOBAL__N_111NameCompareEEvT_SD_T0_", "void std::__inplace_stable_sort<__gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, (anonymous namespace)::NameCompare>(__gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, __gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, (anonymous namespace)::NameCompare)"),
	mu_demangle_test("_ZSt22__stable_sort_adaptiveIN9__gnu_cxx17__normal_iteratorIPPKN4llvm9StatisticESt6vectorIS5_SaIS5_EEEES6_lN12_GLOBAL__N_111NameCompareEEvT_SD_T0_T1_T2_", "void std::__stable_sort_adaptive<__gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, llvm::Statistic const**, long, (anonymous namespace)::NameCompare>(__gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, __gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, llvm::Statistic const**, long, (anonymous namespace)::NameCompare)"),
	mu_demangle_test("_ZSt24__merge_sort_with_bufferIN9__gnu_cxx17__normal_iteratorIPPKN4llvm9StatisticESt6vectorIS5_SaIS5_EEEES6_N12_GLOBAL__N_111NameCompareEEvT_SD_T0_T1_", "void std::__merge_sort_with_buffer<__gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, llvm::Statistic const**, (anonymous namespace)::NameCompare>(__gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, __gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, llvm::Statistic const**, (anonymous namespace)::NameCompare)"),
	mu_demangle_test("_ZSt16__merge_adaptiveIN9__gnu_cxx17__normal_iteratorIPPKN4llvm9StatisticESt6vectorIS5_SaIS5_EEEElS6_N12_GLOBAL__N_111NameCompareEEvT_SD_SD_T0_SE_T1_SE_T2_", "void std::__merge_adaptive<__gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, long, llvm::Statistic const**, (anonymous namespace)::NameCompare>(__gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, __gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, __gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, long, long, llvm::Statistic const**, long, (anonymous namespace)::NameCompare)"),
	mu_demangle_test("_ZSt5mergeIPPKN4llvm9StatisticES4_N9__gnu_cxx17__normal_iteratorIS4_St6vectorIS3_SaIS3_EEEEN12_GLOBAL__N_111NameCompareEET1_T_SE_T0_SF_SD_T2_", "__gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > > std::merge<llvm::Statistic const**, llvm::Statistic const**, __gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, (anonymous namespace)::NameCompare>(llvm::Statistic const**, llvm::Statistic const**, llvm::Statistic const**, llvm::Statistic const**, __gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, (anonymous namespace)::NameCompare)"),
	mu_demangle_test("_ZSt5mergeIN9__gnu_cxx17__normal_iteratorIPPKN4llvm9StatisticESt6vectorIS5_SaIS5_EEEESA_S6_N12_GLOBAL__N_111NameCompareEET1_T_SE_T0_SF_SD_T2_", "llvm::Statistic const** std::merge<__gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, __gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, llvm::Statistic const**, (anonymous namespace)::NameCompare>(__gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, __gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, __gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, __gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, llvm::Statistic const**, (anonymous namespace)::NameCompare)"),
	mu_demangle_test("_ZSt16__insertion_sortIN9__gnu_cxx17__normal_iteratorIPPKN4llvm9StatisticESt6vectorIS5_SaIS5_EEEEN12_GLOBAL__N_111NameCompareEEvT_SD_T0_", "void std::__insertion_sort<__gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, (anonymous namespace)::NameCompare>(__gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, __gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, (anonymous namespace)::NameCompare)"),
	mu_demangle_test("_ZSt22__merge_without_bufferIN9__gnu_cxx17__normal_iteratorIPPKN4llvm9StatisticESt6vectorIS5_SaIS5_EEEElN12_GLOBAL__N_111NameCompareEEvT_SD_SD_T0_SE_T1_", "void std::__merge_without_buffer<__gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, long, (anonymous namespace)::NameCompare>(__gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, __gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, __gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, long, long, (anonymous namespace)::NameCompare)"),
	mu_demangle_test("_ZSt8__rotateIN9__gnu_cxx17__normal_iteratorIPPKN4llvm9StatisticESt6vectorIS5_SaIS5_EEEEEvT_SB_SB_St26random_access_iterator_tag", "void std::__rotate<__gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > > >(__gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, __gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, __gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, std::random_access_iterator_tag)"),
	mu_demangle_test("_ZNSt6vectorIPKN4llvm9StatisticESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::Statistic const**, std::vector<llvm::Statistic const*, std::allocator<llvm::Statistic const*> > >, llvm::Statistic const* const&)"),
	mu_demangle_test("_ZN4llvm2cl3optIbLb0ENS0_6parserIbEEED1Ev", "llvm::cl::opt<bool, false, llvm::cl::parser<bool> >::~opt()"),
	mu_demangle_test("_ZN4llvm2cl3optISsLb1ENS0_6parserISsEEED1Ev", "llvm::cl::opt<std::string, true, llvm::cl::parser<std::string> >::~opt()"),
	mu_demangle_test("_ZSt16__introsort_loopIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm10TimeRecordESsESt6vectorIS5_SaIS5_EEEElEvT_SB_T0_", "void std::__introsort_loop<__gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > >, long>(__gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > >, long)"),
	mu_demangle_test("_ZSt22__final_insertion_sortIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm10TimeRecordESsESt6vectorIS5_SaIS5_EEEEEvT_SB_", "void std::__final_insertion_sort<__gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > > >(__gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > >)"),
	mu_demangle_test("_ZSt16__insertion_sortIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm10TimeRecordESsESt6vectorIS5_SaIS5_EEEEEvT_SB_", "void std::__insertion_sort<__gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > > >(__gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > >)"),
	mu_demangle_test("_ZSt25__unguarded_linear_insertIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm10TimeRecordESsESt6vectorIS5_SaIS5_EEEES5_EvT_T0_", "void std::__unguarded_linear_insert<__gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > >, std::pair<llvm::TimeRecord, std::string> >(__gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > >, std::pair<llvm::TimeRecord, std::string>)"),
	mu_demangle_test("_ZSt21__unguarded_partitionIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm10TimeRecordESsESt6vectorIS5_SaIS5_EEEES5_ET_SB_SB_T0_", "__gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > > std::__unguarded_partition<__gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > >, std::pair<llvm::TimeRecord, std::string> >(__gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > >, std::pair<llvm::TimeRecord, std::string>)"),
	mu_demangle_test("_ZSt8__medianISt4pairIN4llvm10TimeRecordESsEERKT_S6_S6_S6_", "std::pair<llvm::TimeRecord, std::string> const& std::__median<std::pair<llvm::TimeRecord, std::string> >(std::pair<llvm::TimeRecord, std::string> const&, std::pair<llvm::TimeRecord, std::string> const&, std::pair<llvm::TimeRecord, std::string> const&)"),
	mu_demangle_test("_ZSt13__heap_selectIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm10TimeRecordESsESt6vectorIS5_SaIS5_EEEEEvT_SB_SB_", "void std::__heap_select<__gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > > >(__gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > >)"),
	mu_demangle_test("_ZSt8pop_heapIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm10TimeRecordESsESt6vectorIS5_SaIS5_EEEEEvT_SB_", "void std::pop_heap<__gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > > >(__gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > >)"),
	mu_demangle_test("_ZSt13__adjust_heapIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm10TimeRecordESsESt6vectorIS5_SaIS5_EEEElS5_EvT_T0_SC_T1_", "void std::__adjust_heap<__gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > >, long, std::pair<llvm::TimeRecord, std::string> >(__gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > >, long, long, std::pair<llvm::TimeRecord, std::string>)"),
	mu_demangle_test("_ZSt11__push_heapIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm10TimeRecordESsESt6vectorIS5_SaIS5_EEEElS5_EvT_T0_SC_T1_", "void std::__push_heap<__gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > >, long, std::pair<llvm::TimeRecord, std::string> >(__gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > >, long, long, std::pair<llvm::TimeRecord, std::string>)"),
	mu_demangle_test("_ZSt9make_heapIN9__gnu_cxx17__normal_iteratorIPSt4pairIN4llvm10TimeRecordESsESt6vectorIS5_SaIS5_EEEEEvT_SB_", "void std::make_heap<__gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > > >(__gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > >, __gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > >)"),
	mu_demangle_test("_ZNSt6vectorISt4pairIN4llvm10TimeRecordESsESaIS3_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS3_S5_EERKS3_", "std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > >::_M_insert_aux(__gnu_cxx::__normal_iterator<std::pair<llvm::TimeRecord, std::string>*, std::vector<std::pair<llvm::TimeRecord, std::string>, std::allocator<std::pair<llvm::TimeRecord, std::string> > > >, std::pair<llvm::TimeRecord, std::string> const&)"),
	mu_demangle_test("_ZN4llvm9StringMapISt4pairIPNS_10TimerGroupENS0_INS_5TimerENS_15MallocAllocatorEEEES5_ED2Ev", "llvm::StringMap<std::pair<llvm::TimerGroup*, llvm::StringMap<llvm::Timer, llvm::MallocAllocator> >, llvm::MallocAllocator>::~StringMap()"),
	mu_demangle_test("_ZN4llvm14object_creatorINS_3sys10SmartMutexILb1EEEEEPvv", "void* llvm::object_creator<llvm::sys::SmartMutex<true> >()"),
	mu_demangle_test("_ZN4llvm14object_deleterINS_3sys10SmartMutexILb1EEEE4callEPv", "llvm::object_deleter<llvm::sys::SmartMutex<true> >::call(void*)"),
	mu_demangle_test("_ZSt6__findIN9__gnu_cxx17__normal_iteratorIPPN4llvm5TimerESt6vectorIS4_SaIS4_EEEES4_ET_SA_SA_RKT0_St26random_access_iterator_tag", "__gnu_cxx::__normal_iterator<llvm::Timer**, std::vector<llvm::Timer*, std::allocator<llvm::Timer*> > > std::__find<__gnu_cxx::__normal_iterator<llvm::Timer**, std::vector<llvm::Timer*, std::allocator<llvm::Timer*> > >, llvm::Timer*>(__gnu_cxx::__normal_iterator<llvm::Timer**, std::vector<llvm::Timer*, std::allocator<llvm::Timer*> > >, __gnu_cxx::__normal_iterator<llvm::Timer**, std::vector<llvm::Timer*, std::allocator<llvm::Timer*> > >, llvm::Timer* const&, std::random_access_iterator_tag)"),
	mu_demangle_test("_ZNSt6vectorIPN4llvm5TimerESaIS2_EE13_M_insert_auxEN9__gnu_cxx17__normal_iteratorIPS2_S4_EERKS2_", "std::vector<llvm::Timer*, std::allocator<llvm::Timer*> >::_M_insert_aux(__gnu_cxx::__normal_iterator<llvm::Timer**, std::vector<llvm::Timer*, std::allocator<llvm::Timer*> > >, llvm::Timer* const&)"),
	mu_demangle_test("_ZN4llvm14object_creatorISt6vectorIPNS_5TimerESaIS3_EEEEPvv", "void* llvm::object_creator<std::vector<llvm::Timer*, std::allocator<llvm::Timer*> > >()"),
	mu_demangle_test("_ZN4llvm14object_deleterISt6vectorIPNS_5TimerESaIS3_EEE4callEPv", "llvm::object_deleter<std::vector<llvm::Timer*, std::allocator<llvm::Timer*> > >::call(void*)"),
	mu_demangle_test("_ZN4llvm2cl3optISsLb1ENS0_6parserISsEEE16handleOccurrenceEjNS_9StringRefES5_", "llvm::cl::opt<std::string, true, llvm::cl::parser<std::string> >::handleOccurrence(unsigned int, llvm::StringRef, llvm::StringRef)"),
	mu_demangle_test("_ZNK4llvm2cl3optISsLb1ENS0_6parserISsEEE27getValueExpectedFlagDefaultEv", "llvm::cl::opt<std::string, true, llvm::cl::parser<std::string> >::getValueExpectedFlagDefault() const"),
	mu_demangle_test("_ZNK4llvm2cl3optISsLb1ENS0_6parserISsEEE14getOptionWidthEv", "llvm::cl::opt<std::string, true, llvm::cl::parser<std::string> >::getOptionWidth() const"),
	mu_demangle_test("_ZNK4llvm2cl3optISsLb1ENS0_6parserISsEEE15printOptionInfoEm", "llvm::cl::opt<std::string, true, llvm::cl::parser<std::string> >::printOptionInfo(unsigned long) const"),
	mu_demangle_test("_ZN4llvm2cl3optISsLb1ENS0_6parserISsEEE19getExtraOptionNamesERNS_15SmallVectorImplIPKcEE", "llvm::cl::opt<std::string, true, llvm::cl::parser<std::string> >::getExtraOptionNames(llvm::SmallVectorImpl<char const*>&)"),
	mu_demangle_test("_ZN4llvm2cl3optISsLb1ENS0_6parserISsEEED0Ev", "llvm::cl::opt<std::string, true, llvm::cl::parser<std::string> >::~opt()"),
	mu_demangle_test("_ZN4llvm9StringMapISt4pairIPNS_10TimerGroupENS0_INS_5TimerENS_15MallocAllocatorEEEES5_E16GetOrCreateValueIS7_EERNS_14StringMapEntryIS7_EENS_9StringRefET_", "llvm::StringMapEntry<std::pair<llvm::TimerGroup*, llvm::StringMap<llvm::Timer, llvm::MallocAllocator> > >& llvm::StringMap<std::pair<llvm::TimerGroup*, llvm::StringMap<llvm::Timer, llvm::MallocAllocator> >, llvm::MallocAllocator>::GetOrCreateValue<std::pair<llvm::TimerGroup*, llvm::StringMap<llvm::Timer, llvm::MallocAllocator> > >(llvm::StringRef, std::pair<llvm::TimerGroup*, llvm::StringMap<llvm::Timer, llvm::MallocAllocator> >)"),
	mu_demangle_test("_ZN4llvm14StringMapEntryISt4pairIPNS_10TimerGroupENS_9StringMapINS_5TimerENS_15MallocAllocatorEEEEE6CreateIS6_S8_EEPS9_PKcSD_RT_T0_", "llvm::StringMapEntry<std::pair<llvm::TimerGroup*, llvm::StringMap<llvm::Timer, llvm::MallocAllocator> > >* llvm::StringMapEntry<std::pair<llvm::TimerGroup*, llvm::StringMap<llvm::Timer, llvm::MallocAllocator> > >::Create<llvm::MallocAllocator, std::pair<llvm::TimerGroup*, llvm::StringMap<llvm::Timer, llvm::MallocAllocator> > >(char const*, char const*, llvm::MallocAllocator&, std::pair<llvm::TimerGroup*, llvm::StringMap<llvm::Timer, llvm::MallocAllocator> >)"),
	mu_demangle_test("_ZN4llvm14object_creatorINS_9StringMapINS_5TimerENS_15MallocAllocatorEEEEEPvv", "void* llvm::object_creator<llvm::StringMap<llvm::Timer, llvm::MallocAllocator> >()"),
	mu_demangle_test("_ZN4llvm14object_deleterINS_9StringMapINS_5TimerENS_15MallocAllocatorEEEE4callEPv", "llvm::object_deleter<llvm::StringMap<llvm::Timer, llvm::MallocAllocator> >::call(void*)"),
	mu_demangle_test("_ZTSN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_9ArrayTypeENS_13ConstantArrayELb1EEE", "typeinfo name for llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::ArrayType, llvm::ConstantArray, true>"),
	mu_demangle_test("_ZTSN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_10StructTypeENS_14ConstantStructELb1EEE", "typeinfo name for llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::StructType, llvm::ConstantStruct, true>"),
	mu_demangle_test("_ZTSN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_10VectorTypeENS_14ConstantVectorELb0EEE", "typeinfo name for llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::VectorType, llvm::ConstantVector, false>"),
	mu_demangle_test("_ZTSN4llvm2cl3optIbLb1ENS0_6parserIbEEEE", "typeinfo name for llvm::cl::opt<bool, true, llvm::cl::parser<bool> >"),
	mu_demangle_test("_ZTSSt6vectorIPKN4llvm8PassInfoESaIS3_EE", "typeinfo name for std::vector<llvm::PassInfo const*, std::allocator<llvm::PassInfo const*> >"),
	mu_demangle_test("_ZTSSt12_Vector_baseIPKN4llvm8PassInfoESaIS3_EE", "typeinfo name for std::_Vector_base<llvm::PassInfo const*, std::allocator<llvm::PassInfo const*> >"),
	mu_demangle_test("_ZTSN4llvm2cl3optINS_14PassDebugLevelELb0ENS0_6parserIS2_EEEE", "typeinfo name for llvm::cl::opt<llvm::PassDebugLevel, false, llvm::cl::parser<llvm::PassDebugLevel> >"),
	mu_demangle_test("_ZTSN4llvm2cl3optIN12_GLOBAL__N_114VersionPrinterELb1ENS0_6parserIbEEEE", "typeinfo name for llvm::cl::opt<(anonymous namespace)::VersionPrinter, true, llvm::cl::parser<bool> >"),
	mu_demangle_test("_ZTSN4llvm2cl3optIN12_GLOBAL__N_111HelpPrinterELb1ENS0_6parserIbEEEE", "typeinfo name for llvm::cl::opt<(anonymous namespace)::HelpPrinter, true, llvm::cl::parser<bool> >"),
	mu_demangle_test("_ZTSN4llvm2cl3optIjLb0ENS0_6parserIjEEEE", "typeinfo name for llvm::cl::opt<unsigned int, false, llvm::cl::parser<unsigned int> >"),
	mu_demangle_test("_ZTSN4llvm2cl3optIiLb0ENS0_6parserIiEEEE", "typeinfo name for llvm::cl::opt<int, false, llvm::cl::parser<int> >"),
	mu_demangle_test("_ZTSN4llvm2cl3optISsLb0ENS0_6parserISsEEEE", "typeinfo name for llvm::cl::opt<std::string, false, llvm::cl::parser<std::string> >"),
	mu_demangle_test("_ZTSN4llvm2cl3optIcLb0ENS0_6parserIcEEEE", "typeinfo name for llvm::cl::opt<char, false, llvm::cl::parser<char> >"),
	mu_demangle_test("_ZTSN4llvm2cl3optIbLb0ENS0_6parserIbEEEE", "typeinfo name for llvm::cl::opt<bool, false, llvm::cl::parser<bool> >"),
	mu_demangle_test("_ZTSN4llvm2cl3optISsLb1ENS0_6parserISsEEEE", "typeinfo name for llvm::cl::opt<std::string, true, llvm::cl::parser<std::string> >"),
	mu_demangle_test("_ZTIN4llvm2cl3optIN12_GLOBAL__N_114VersionPrinterELb1ENS0_6parserIbEEEE", "typeinfo for llvm::cl::opt<(anonymous namespace)::VersionPrinter, true, llvm::cl::parser<bool> >"),
	mu_demangle_test("_ZTIN4llvm2cl3optIN12_GLOBAL__N_111HelpPrinterELb1ENS0_6parserIbEEEE", "typeinfo for llvm::cl::opt<(anonymous namespace)::HelpPrinter, true, llvm::cl::parser<bool> >"),
	mu_demangle_test("_ZTIN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_9ArrayTypeENS_13ConstantArrayELb1EEE", "typeinfo for llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::ArrayType, llvm::ConstantArray, true>"),
	mu_demangle_test("_ZTIN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_10StructTypeENS_14ConstantStructELb1EEE", "typeinfo for llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::StructType, llvm::ConstantStruct, true>"),
	mu_demangle_test("_ZTIN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_10VectorTypeENS_14ConstantVectorELb0EEE", "typeinfo for llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::VectorType, llvm::ConstantVector, false>"),
	mu_demangle_test("_ZTIN4llvm2cl3optIbLb1ENS0_6parserIbEEEE", "typeinfo for llvm::cl::opt<bool, true, llvm::cl::parser<bool> >"),
	mu_demangle_test("_ZTISt12_Vector_baseIPKN4llvm8PassInfoESaIS3_EE", "typeinfo for std::_Vector_base<llvm::PassInfo const*, std::allocator<llvm::PassInfo const*> >"),
	mu_demangle_test("_ZTISt6vectorIPKN4llvm8PassInfoESaIS3_EE", "typeinfo for std::vector<llvm::PassInfo const*, std::allocator<llvm::PassInfo const*> >"),
	mu_demangle_test("_ZTIN4llvm2cl3optINS_14PassDebugLevelELb0ENS0_6parserIS2_EEEE", "typeinfo for llvm::cl::opt<llvm::PassDebugLevel, false, llvm::cl::parser<llvm::PassDebugLevel> >"),
	mu_demangle_test("_ZTIN4llvm2cl3optIjLb0ENS0_6parserIjEEEE", "typeinfo for llvm::cl::opt<unsigned int, false, llvm::cl::parser<unsigned int> >"),
	mu_demangle_test("_ZTIN4llvm2cl3optIiLb0ENS0_6parserIiEEEE", "typeinfo for llvm::cl::opt<int, false, llvm::cl::parser<int> >"),
	mu_demangle_test("_ZTIN4llvm2cl3optISsLb0ENS0_6parserISsEEEE", "typeinfo for llvm::cl::opt<std::string, false, llvm::cl::parser<std::string> >"),
	mu_demangle_test("_ZTIN4llvm2cl3optIcLb0ENS0_6parserIcEEEE", "typeinfo for llvm::cl::opt<char, false, llvm::cl::parser<char> >"),
	mu_demangle_test("_ZTIN4llvm2cl3optIbLb0ENS0_6parserIbEEEE", "typeinfo for llvm::cl::opt<bool, false, llvm::cl::parser<bool> >"),
	mu_demangle_test("_ZTIN4llvm2cl3optISsLb1ENS0_6parserISsEEEE", "typeinfo for llvm::cl::opt<std::string, true, llvm::cl::parser<std::string> >"),
	mu_demangle_test("_ZN4llvm8RegistryIN5clang15PluginASTActionENS_14RegistryTraitsIS2_EEE4HeadE", "llvm::Registry<clang::PluginASTAction, llvm::RegistryTraits<clang::PluginASTAction> >::Head"),
	mu_demangle_test("_ZZN5clang4ento12GRStateTraitIN4llvm12ImmutableMapIPKNS0_10SymbolDataEjNS2_16ImutKeyValueInfoIS6_jEEEEE8GDMIndexEvE5index", "clang::ento::GRStateTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, unsigned int, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, unsigned int> > >::GDMIndex()::index"),
	mu_demangle_test("_ZTVN4llvm21FoldingSetNodeWrapperISt4pairIN5clang4ento4SValES4_EEE", "vtable for llvm::FoldingSetNodeWrapper<std::pair<clang::ento::SVal, clang::ento::SVal> >"),
	mu_demangle_test("_ZTVN4llvm10FoldingSetINS_21FoldingSetNodeWrapperISt4pairIN5clang4ento4SValES5_EEEEE", "vtable for llvm::FoldingSet<llvm::FoldingSetNodeWrapper<std::pair<clang::ento::SVal, clang::ento::SVal> > >"),
	mu_demangle_test("_ZTVN4llvm21FoldingSetNodeWrapperISt4pairIN5clang4ento4SValEmEEE", "vtable for llvm::FoldingSetNodeWrapper<std::pair<clang::ento::SVal, unsigned long> >"),
	mu_demangle_test("_ZTVN4llvm10FoldingSetINS_21FoldingSetNodeWrapperISt4pairIN5clang4ento4SValEmEEEEE", "vtable for llvm::FoldingSet<llvm::FoldingSetNodeWrapper<std::pair<clang::ento::SVal, unsigned long> > >"),
	mu_demangle_test("_ZTVN4llvm10FoldingSetINS_17ImmutableListImplIN5clang4ento4SValEEEEE", "vtable for llvm::FoldingSet<llvm::ImmutableListImpl<clang::ento::SVal> >"),
	mu_demangle_test("_ZTVN4llvm10FoldingSetINS_21FoldingSetNodeWrapperINS_6APSIntEEEEE", "vtable for llvm::FoldingSet<llvm::FoldingSetNodeWrapper<llvm::APSInt> >"),
	mu_demangle_test("_ZTVN4llvm10FoldingSetINS_17ImmutableListImplIPN5clang4ento18BugReporterVisitorEEEEE", "vtable for llvm::FoldingSet<llvm::ImmutableListImpl<clang::ento::BugReporterVisitor*> >"),
	mu_demangle_test("_ZTVN4llvm10FoldingSetINS_17ImmutableListImplIPKN5clang4ento10SymbolDataEEEEE", "vtable for llvm::FoldingSet<llvm::ImmutableListImpl<clang::ento::SymbolData const*> >"),
	mu_demangle_test("_ZTVN4llvm18ValueMapCallbackVHIPKNS_8FunctionENS_18InlineCostAnalyzer12FunctionInfoENS_14ValueMapConfigIS3_EENS_12DenseMapInfoIS5_EEEE", "vtable for llvm::ValueMapCallbackVH<llvm::Function const*, llvm::InlineCostAnalyzer::FunctionInfo, llvm::ValueMapConfig<llvm::Function const*>, llvm::DenseMapInfo<llvm::InlineCostAnalyzer::FunctionInfo> >"),
	mu_demangle_test("_ZTVN4llvm2cl3optI17AsmWriterFlavorTyLb0ENS0_6parserIS2_EEEE", "vtable for llvm::cl::opt<AsmWriterFlavorTy, false, llvm::cl::parser<AsmWriterFlavorTy> >"),
	mu_demangle_test("_ZTVN4llvm2cl3optIPFPNS_18ScheduleDAGSDNodesEPNS_16SelectionDAGISelENS_10CodeGenOpt5LevelEELb0ENS_18RegisterPassParserINS_17RegisterSchedulerEEEEE", "vtable for llvm::cl::opt<llvm::ScheduleDAGSDNodes* (*)(llvm::SelectionDAGISel*, llvm::CodeGenOpt::Level), false, llvm::RegisterPassParser<llvm::RegisterScheduler> >"),
	mu_demangle_test("_ZN4llvm8RegistryINS_17GCMetadataPrinterENS_14RegistryTraitsIS1_EEE4HeadE", "llvm::Registry<llvm::GCMetadataPrinter, llvm::RegistryTraits<llvm::GCMetadataPrinter> >::Head"),
	mu_demangle_test("_ZN4llvm8RegistryINS_10GCStrategyENS_14RegistryTraitsIS1_EEE4HeadE", "llvm::Registry<llvm::GCStrategy, llvm::RegistryTraits<llvm::GCStrategy> >::Head"),
	mu_demangle_test("_ZTVN4llvm2cl3optINS0_13boolOrDefaultELb0ENS0_6parserIS2_EEEE", "vtable for llvm::cl::opt<llvm::cl::boolOrDefault, false, llvm::cl::parser<llvm::cl::boolOrDefault> >"),
	mu_demangle_test("_ZTVN4llvm2cl3optIPFPNS_12FunctionPassEvELb0ENS_18RegisterPassParserINS_16RegisterRegAllocEEEEE", "vtable for llvm::cl::opt<llvm::FunctionPass* (*)(), false, llvm::RegisterPassParser<llvm::RegisterRegAlloc> >"),
	mu_demangle_test("_ZTVN4llvm2cl3optI20ShrinkWrapDebugLevelLb0ENS0_6parserIS2_EEEE", "vtable for llvm::cl::opt<ShrinkWrapDebugLevel, false, llvm::cl::parser<ShrinkWrapDebugLevel> >"),
	mu_demangle_test("_ZTVN4llvm2cl3optIN12_GLOBAL__N_111SpillerNameELb0ENS0_6parserIS3_EEEE", "vtable for llvm::cl::opt<(anonymous namespace)::SpillerName, false, llvm::cl::parser<(anonymous namespace)::SpillerName> >"),
	mu_demangle_test("_ZTVN4llvm2cl3optIN12_GLOBAL__N_112RewriterNameELb0ENS0_6parserIS3_EEEE", "vtable for llvm::cl::opt<(anonymous namespace)::RewriterName, false, llvm::cl::parser<(anonymous namespace)::RewriterName> >"),
	mu_demangle_test("_ZTVN4llvm18ValueMapCallbackVHIPKNS_5ValueENS_10TrackingVHIS1_EENS_14ValueMapConfigIS3_EENS_12DenseMapInfoIS5_EEEE", "vtable for llvm::ValueMapCallbackVH<llvm::Value const*, llvm::TrackingVH<llvm::Value>, llvm::ValueMapConfig<llvm::Value const*>, llvm::DenseMapInfo<llvm::TrackingVH<llvm::Value> > >"),
	mu_demangle_test("_ZTVN4llvm2cl3optIbLb1ENS0_6parserIbEEEE", "vtable for llvm::cl::opt<bool, true, llvm::cl::parser<bool> >"),
	mu_demangle_test("_ZTVN4llvm2cl3optIjLb1ENS0_6parserIjEEEE", "vtable for llvm::cl::opt<unsigned int, true, llvm::cl::parser<unsigned int> >"),
	mu_demangle_test("_ZTVN4llvm2cl3optINS_9CodeModel5ModelELb1ENS0_6parserIS3_EEEE", "vtable for llvm::cl::opt<llvm::CodeModel::Model, true, llvm::cl::parser<llvm::CodeModel::Model> >"),
	mu_demangle_test("_ZTVN4llvm2cl3optINS_5Reloc5ModelELb1ENS0_6parserIS3_EEEE", "vtable for llvm::cl::opt<llvm::Reloc::Model, true, llvm::cl::parser<llvm::Reloc::Model> >"),
	mu_demangle_test("_ZTVN4llvm2cl3optINS_8FloatABI7ABITypeELb1ENS0_6parserIS3_EEEE", "vtable for llvm::cl::opt<llvm::FloatABI::ABIType, true, llvm::cl::parser<llvm::FloatABI::ABIType> >"),
	mu_demangle_test("_ZTVN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_9ArrayTypeENS_13ConstantArrayELb1EEE", "vtable for llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::ArrayType, llvm::ConstantArray, true>"),
	mu_demangle_test("_ZTVN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_10StructTypeENS_14ConstantStructELb1EEE", "vtable for llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::StructType, llvm::ConstantStruct, true>"),
	mu_demangle_test("_ZTVN4llvm17ConstantUniqueMapISt6vectorIPNS_8ConstantESaIS3_EENS_10VectorTypeENS_14ConstantVectorELb0EEE", "vtable for llvm::ConstantUniqueMap<std::vector<llvm::Constant*, std::allocator<llvm::Constant*> >, llvm::VectorType, llvm::ConstantVector, false>"),
	mu_demangle_test("_ZTVN4llvm2cl3optINS_14PassDebugLevelELb0ENS0_6parserIS2_EEEE", "vtable for llvm::cl::opt<llvm::PassDebugLevel, false, llvm::cl::parser<llvm::PassDebugLevel> >"),
	mu_demangle_test("_ZTVN4llvm2cl3optIjLb0ENS0_6parserIjEEEE", "vtable for llvm::cl::opt<unsigned int, false, llvm::cl::parser<unsigned int> >"),
	mu_demangle_test("_ZTVN4llvm2cl3optIiLb0ENS0_6parserIiEEEE", "vtable for llvm::cl::opt<int, false, llvm::cl::parser<int> >"),
	mu_demangle_test("_ZTVN4llvm2cl3optISsLb0ENS0_6parserISsEEEE", "vtable for llvm::cl::opt<std::string, false, llvm::cl::parser<std::string> >"),
	mu_demangle_test("_ZTVN4llvm2cl3optIcLb0ENS0_6parserIcEEEE", "vtable for llvm::cl::opt<char, false, llvm::cl::parser<char> >"),
	mu_demangle_test("_ZTVN4llvm2cl3optIbLb0ENS0_6parserIbEEEE", "vtable for llvm::cl::opt<bool, false, llvm::cl::parser<bool> >"),
	mu_demangle_test("_ZTVN4llvm2cl3optIN12_GLOBAL__N_114VersionPrinterELb1ENS0_6parserIbEEEE", "vtable for llvm::cl::opt<(anonymous namespace)::VersionPrinter, true, llvm::cl::parser<bool> >"),
	mu_demangle_test("_ZTVN4llvm2cl3optIN12_GLOBAL__N_111HelpPrinterELb1ENS0_6parserIbEEEE", "vtable for llvm::cl::opt<(anonymous namespace)::HelpPrinter, true, llvm::cl::parser<bool> >"),
	mu_demangle_test("_ZTVN4llvm2cl3optISsLb1ENS0_6parserISsEEEE", "vtable for llvm::cl::opt<std::string, true, llvm::cl::parser<std::string> >"),
	mu_demangle_test("_ZZN5clang4ento12GRStateTraitIN4llvm12ImmutableMapIPKNS0_10SymbolDataEN12_GLOBAL__N_16RefValENS2_16ImutKeyValueInfoIS6_S8_EEEEE8GDMIndexEvE9RefBIndex", "clang::ento::GRStateTrait<llvm::ImmutableMap<clang::ento::SymbolData const*, (anonymous namespace)::RefVal, llvm::ImutKeyValueInfo<clang::ento::SymbolData const*, (anonymous namespace)::RefVal> > >::GDMIndex()::RefBIndex"),
	mu_demangle_test("_ZNKSt9basic_iosIcSt11char_traitsIcEE5widenEc", "std::basic_ios<char, std::char_traits<char> >::widen(char) const"),
	mu_demangle_test("_ZNSsC1EPKcRKSaIcE", "std::basic_string<char, std::char_traits<char>, std::allocator<char> >::basic_string(char const*, std::allocator<char> const&)"),
	mu_demangle_test("_ZNSsC1EPKcmRKSaIcE", "std::basic_string<char, std::char_traits<char>, std::allocator<char> >::basic_string(char const*, unsigned long, std::allocator<char> const&)"),
	mu_demangle_test("_ZNSsC1ERKSs", "std::basic_string<char, std::char_traits<char>, std::allocator<char> >::basic_string(std::string const&)"),
	mu_demangle_test("_ZNSsC1ERKSsmm", "std::basic_string<char, std::char_traits<char>, std::allocator<char> >::basic_string(std::string const&, unsigned long, unsigned long)"),
	mu_demangle_test("_ZNSsC1EmcRKSaIcE", "std::basic_string<char, std::char_traits<char>, std::allocator<char> >::basic_string(unsigned long, char, std::allocator<char> const&)"),
	mu_demangle_test("_ZSt16__ostream_insertIcSt11char_traitsIcEERSt13basic_ostreamIT_T0_ES6_PKS3_l", "std::basic_ostream<char, std::char_traits<char> >& std::__ostream_insert<char, std::char_traits<char> >(std::basic_ostream<char, std::char_traits<char> >&, char const*, long)"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE7Opcodes8", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::Opcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE7Opcodes9", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::Opcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE7Opcodes10", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::Opcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE7Opcodes11", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::Opcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE7Opcodes12", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::Opcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8DOpcodes13", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::DOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8QOpcodes14", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::QOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8DOpcodes15", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::DOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8DOpcodes16", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::DOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE9QOpcodes118", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::QOpcodes1"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8DOpcodes19", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::DOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8DOpcodes21", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::DOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8DOpcodes23", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::DOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8DOpcodes25", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::DOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8QOpcodes26", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::QOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8DOpcodes27", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::DOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8QOpcodes28", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::QOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8DOpcodes29", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::DOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE9QOpcodes131", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::QOpcodes1"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8DOpcodes32", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::DOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE9QOpcodes134", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::QOpcodes1"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8DOpcodes35", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::DOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8DOpcodes37", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::DOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8DOpcodes39", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::DOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8DOpcodes41", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::DOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8QOpcodes42", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::QOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8DOpcodes43", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::DOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8QOpcodes44", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::QOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8DOpcodes45", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::DOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE9QOpcodes046", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::QOpcodes0"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE9QOpcodes147", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::QOpcodes1"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8DOpcodes48", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::DOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE9QOpcodes049", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::QOpcodes0"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE9QOpcodes150", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::QOpcodes1"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8DOpcodes51", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::DOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8DOpcodes53", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::DOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8DOpcodes55", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::DOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8DOpcodes57", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::DOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8QOpcodes58", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::QOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8DOpcodes59", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::DOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8QOpcodes60", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::QOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8DOpcodes61", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::DOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE9QOpcodes062", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::QOpcodes0"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE9QOpcodes163", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::QOpcodes1"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8DOpcodes64", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::DOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE9QOpcodes065", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::QOpcodes0"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE9QOpcodes166", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::QOpcodes1"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8DOpcodes67", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::DOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8DOpcodes69", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::DOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_115ARMDAGToDAGISel6SelectEPN4llvm6SDNodeEE8DOpcodes71", "(anonymous namespace)::ARMDAGToDAGISel::Select(llvm::SDNode*)::DOpcodes"),
	// mu_demangle_test("_ZZN12_GLOBAL__N_116Thumb2SizeReduce13ReduceSpecialERN4llvm17MachineBasicBlockEPNS1_12MachineInstrERKNS_11ReduceEntryEbE11NarrowEntry11", "(anonymous namespace)::Thumb2SizeReduce::ReduceSpecial(llvm::MachineBasicBlock&, llvm::MachineInstr*, (anonymous namespace)::ReduceEntry const&, bool)::NarrowEntry"),
	// mu_demangle_test("_ZL17Lang_iso9899_1999", "Lang_iso9899_1999"),
	// mu_demangle_test("_ZL17Lang_iso9899_1990", "Lang_iso9899_1990"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXleT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)<=(4), void>::type*)"),
	mu_demangle_test("_ZN5Casts6cstyleILj4EEEvPN9enable_ifIXleT_cvjLi4EEvE4typeE", "void Casts::cstyle<4u>(enable_if<(4u)<=((unsigned int)(4)), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXaaT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)&&(4), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXaNT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)&=(4), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXaST_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)=(4), void>::type*)"),
	// mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXcmT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<((4u),(4)), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXplLi1EcmT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(1)+((4u),(4)), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXcoT_EvE4typeE", "void Casts::implicit<4u>(enable_if<~(4u), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXdeT_EvE4typeE", "void Casts::implicit<4u>(enable_if<*(4u), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXdvT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)/(4), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXdVT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)/=(4), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXeoT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)^(4), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXeOT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)^=(4), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXeqT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)==(4), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXgeT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)>=(4), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXgtT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<((4u)>(4)), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXngorLi0EgtT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<-((0)|(((4u)>(4)))), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXlsT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)<<(4), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXlST_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)<<=(4), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXltT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)<(4), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXmiT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)-(4), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXmIT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)-=(4), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXmlT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)*(4), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXmLT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)*=(4), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXmmT_EvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)--, void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXneT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)!=(4), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXngT_EvE4typeE", "void Casts::implicit<4u>(enable_if<-(4u), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXntT_EvE4typeE", "void Casts::implicit<4u>(enable_if<!(4u), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXooT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)||(4), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXorT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)|(4), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXoRT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)|=(4), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXpmT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)->*(4), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXplT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)+(4), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXpLT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)+=(4), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXppT_EvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)++, void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXpsT_EvE4typeE", "void Casts::implicit<4u>(enable_if<+(4u), void>::type*)"),
	// mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXptT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)->(4), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXquT_Li4ELi5EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)?(4) : (5), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXrmT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)%(4), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXrMT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)%=(4), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXrsT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)>>(4), void>::type*)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXrST_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)>>=(4), void>::type*)"),
	// mu_demangle_test("_ZN5test22f1ENS_2t1IXadL_ZNS_2f0EfEEEE", "test2::f1(test2::t1<&test2::f0(float)>)"),
	// mu_demangle_test("_ZN5test62f0ENS_1TIXadL_ZNS_1A3im0EfEEEE", "test6::f0(test6::T<&test6::A::im0(float)>)"),
	mu_demangle_test("_ZN5test71XIiEC1IdEEPT_PNS_5int_cIXplL_ZNS_4metaIiE5valueEEsrNS6_IS3_EE5valueEE4typeE", "test7::X<int>::X<double>(double*, test7::int_c<test7::meta<int>::value+test7::meta<double>::value>::type*)"),
	mu_demangle_test("_Z1fno", "f(int128_t, uint128_t)"),
	mu_demangle_test("_ZN11Expressions2f1ILi1EEEvPAplngT_Li2E_i", "void Expressions::f1<1>(int (*) [(-(1))+(2)])"),
	// mu_demangle_test("_ZN11Expressions2f2ILi1EEEvPApsT__i", "void Expressions::f2<1>(int (*) [+1])"),
	// mu_demangle_test("_ZN11Expressions2f3ILi1EEEvPAplT_T__i", "void Expressions::f3<1>(int (*) [1 + 1])"),
	// mu_demangle_test("_ZN11Expressions2f4ILi1EEEvPAplplLi2ET_T__i", "void Expressions::f4<1>(int (*) [2 + 1 + 1])"),
	// mu_demangle_test("_ZN11Expressions2f4ILi1EEEvPAplLi2EplT_T__i", "void Expressions::f4<1>(int (*) [2 + (1 + 1)])"),
	mu_demangle_test("_ZN6PR58615AllocIcNS_6PolicyINS_1PELb1EEEE8allocateEiPKv", "PR5861::Alloc<char, PR5861::Policy<PR5861::P, true> >::allocate(int, void const*)"),
	mu_demangle_test("_ZN5test211read_memberINS_1AEEEDtptcvPT_Li0E6memberERS2_", "decltype (((test2::A*)(0))->member) test2::read_member<test2::A>(test2::A&)"),
	mu_demangle_test("_ZN5test37get_p_1INS_7DerivedEEEDtptcvPT_Li0EsrNS_5Path1E1pERS2_", "decltype (((test3::Derived*)(0))->test3::Path1::p) test3::get_p_1<test3::Derived>(test3::Derived&)"),
	mu_demangle_test("_ZN5test37get_p_1INS_7DerivedEEEDtptcvPT_Li0EsrNS_5Path2E1pERS2_", "decltype (((test3::Derived*)(0))->test3::Path2::p) test3::get_p_1<test3::Derived>(test3::Derived&)"),
	// mu_demangle_test("_ZN5test71gEPNS_3zedIXadL_ZNS_3foo3barEvEEEE", "test7::g(test7::zed<&test7::foo::bar()>*)"),
	mu_demangle_test("_ZN6test101fILc3EEEvNS_1SIXquLb0ELc97ET_EEE", "void test10::f<(char)3>(test10::S<(false)?((char)97) : ((char)3)>)"),
	mu_demangle_test("_ZN6test151fILi7EEEvNS_1SIXplT_LNS_1EE3EEEE", "void test15::f<7>(test15::S<(7)+((test15::E)3)>)"),
	mu_demangle_test("_ZN6test191gINS_1AEEEvNS_1SIXadsrT_1fIiEEEE", "void test19::g<test19::A>(test19::S<&(test19::A::f<int>)>)"),
	// mu_demangle_test("_ZN6test191gINS_1AEEEvNS_1SIXadsrT_cviEEE", "void test19::g<test19::A>(test19::S<&test19::A::operator int>)"),
	mu_demangle_test("_ZN6test191gINS_1AEEEvNS_1SIXadsrT_miIdEEEE", "void test19::g<test19::A>(test19::S<&(test19::A::operator-<double>)>)"),
	mu_demangle_test("_ZN6test205test0IiEEvDTcl1fIPT_ELi0EEE", "void test20::test0<int>(decltype ((f<int*>)(0)))"),
	mu_demangle_test("_ZN6test221fEDn", "test22::f(decltype(nullptr))"),
	mu_demangle_test("_ZN6test205test1IiEEvDTcl1fIEcvT__EEE", "void test20::test1<int>(decltype ((f<>)((int)())))"),
	// mu_demangle_test("_Z2f0IJEEv1XIXsZT_EJDpRT_EE", "void f0<>(X<sizeof...()>)"),
	// mu_demangle_test("_Z2f0IJifdEEv1XIXsZT_EJDpRT_EE", "void f0<int, float, double>(X<sizeof...(int, float, double), int&, float&, double&>)"),
	// mu_demangle_test("_Z10float16addDF16_DF16_", "float16add(_Float16, _Float16)"),
	// mu_demangle_test("_ZNK10__cxxabiv111__libcxxabi5__sub20first_demangled_nameEPc.eh", "__cxxabiv1::__libcxxabi::__sub::first_demangled_name(char*) const (.eh)"),
	mu_demangle_test("_ZSt13copy_backwardIN9__gnu_cxx17__normal_iteratorIPNS0_19_Hashtable_iteratorISt4pairIK16CSCppSymbolOwnerP20CSCppSymbolOwnerDataES4_27CSCppSymbolOwnerHashFunctorSt10_Select1stIS8_E29CSCppSymbolOwnerEqualsFunctorSaIS7_EEESt6vectorISE_SaISE_EEEESJ_ET0_T_SL_SK_", "__gnu_cxx::__normal_iterator<__gnu_cxx::_Hashtable_iterator<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*>, CSCppSymbolOwner, CSCppSymbolOwnerHashFunctor, std::_Select1st<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*> >, CSCppSymbolOwnerEqualsFunctor, std::allocator<CSCppSymbolOwnerData*> >*, std::vector<__gnu_cxx::_Hashtable_iterator<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*>, CSCppSymbolOwner, CSCppSymbolOwnerHashFunctor, std::_Select1st<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*> >, CSCppSymbolOwnerEqualsFunctor, std::allocator<CSCppSymbolOwnerData*> >, std::allocator<__gnu_cxx::_Hashtable_iterator<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*>, CSCppSymbolOwner, CSCppSymbolOwnerHashFunctor, std::_Select1st<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*> >, CSCppSymbolOwnerEqualsFunctor, std::allocator<CSCppSymbolOwnerData*> > > > > std::copy_backward<__gnu_cxx::__normal_iterator<__gnu_cxx::_Hashtable_iterator<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*>, CSCppSymbolOwner, CSCppSymbolOwnerHashFunctor, std::_Select1st<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*> >, CSCppSymbolOwnerEqualsFunctor, std::allocator<CSCppSymbolOwnerData*> >*, std::vector<__gnu_cxx::_Hashtable_iterator<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*>, CSCppSymbolOwner, CSCppSymbolOwnerHashFunctor, std::_Select1st<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*> >, CSCppSymbolOwnerEqualsFunctor, std::allocator<CSCppSymbolOwnerData*> >, std::allocator<__gnu_cxx::_Hashtable_iterator<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*>, CSCppSymbolOwner, CSCppSymbolOwnerHashFunctor, std::_Select1st<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*> >, CSCppSymbolOwnerEqualsFunctor, std::allocator<CSCppSymbolOwnerData*> > > > >, __gnu_cxx::__normal_iterator<__gnu_cxx::_Hashtable_iterator<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*>, CSCppSymbolOwner, CSCppSymbolOwnerHashFunctor, std::_Select1st<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*> >, CSCppSymbolOwnerEqualsFunctor, std::allocator<CSCppSymbolOwnerData*> >*, std::vector<__gnu_cxx::_Hashtable_iterator<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*>, CSCppSymbolOwner, CSCppSymbolOwnerHashFunctor, std::_Select1st<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*> >, CSCppSymbolOwnerEqualsFunctor, std::allocator<CSCppSymbolOwnerData*> >, std::allocator<__gnu_cxx::_Hashtable_iterator<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*>, CSCppSymbolOwner, CSCppSymbolOwnerHashFunctor, std::_Select1st<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*> >, CSCppSymbolOwnerEqualsFunctor, std::allocator<CSCppSymbolOwnerData*> > > > > >(__gnu_cxx::__normal_iterator<__gnu_cxx::_Hashtable_iterator<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*>, CSCppSymbolOwner, CSCppSymbolOwnerHashFunctor, std::_Select1st<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*> >, CSCppSymbolOwnerEqualsFunctor, std::allocator<CSCppSymbolOwnerData*> >*, std::vector<__gnu_cxx::_Hashtable_iterator<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*>, CSCppSymbolOwner, CSCppSymbolOwnerHashFunctor, std::_Select1st<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*> >, CSCppSymbolOwnerEqualsFunctor, std::allocator<CSCppSymbolOwnerData*> >, std::allocator<__gnu_cxx::_Hashtable_iterator<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*>, CSCppSymbolOwner, CSCppSymbolOwnerHashFunctor, std::_Select1st<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*> >, CSCppSymbolOwnerEqualsFunctor, std::allocator<CSCppSymbolOwnerData*> > > > >, __gnu_cxx::__normal_iterator<__gnu_cxx::_Hashtable_iterator<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*>, CSCppSymbolOwner, CSCppSymbolOwnerHashFunctor, std::_Select1st<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*> >, CSCppSymbolOwnerEqualsFunctor, std::allocator<CSCppSymbolOwnerData*> >*, std::vector<__gnu_cxx::_Hashtable_iterator<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*>, CSCppSymbolOwner, CSCppSymbolOwnerHashFunctor, std::_Select1st<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*> >, CSCppSymbolOwnerEqualsFunctor, std::allocator<CSCppSymbolOwnerData*> >, std::allocator<__gnu_cxx::_Hashtable_iterator<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*>, CSCppSymbolOwner, CSCppSymbolOwnerHashFunctor, std::_Select1st<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*> >, CSCppSymbolOwnerEqualsFunctor, std::allocator<CSCppSymbolOwnerData*> > > > >, __gnu_cxx::__normal_iterator<__gnu_cxx::_Hashtable_iterator<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*>, CSCppSymbolOwner, CSCppSymbolOwnerHashFunctor, std::_Select1st<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*> >, CSCppSymbolOwnerEqualsFunctor, std::allocator<CSCppSymbolOwnerData*> >*, std::vector<__gnu_cxx::_Hashtable_iterator<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*>, CSCppSymbolOwner, CSCppSymbolOwnerHashFunctor, std::_Select1st<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*> >, CSCppSymbolOwnerEqualsFunctor, std::allocator<CSCppSymbolOwnerData*> >, std::allocator<__gnu_cxx::_Hashtable_iterator<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*>, CSCppSymbolOwner, CSCppSymbolOwnerHashFunctor, std::_Select1st<std::pair<CSCppSymbolOwner const, CSCppSymbolOwnerData*> >, CSCppSymbolOwnerEqualsFunctor, std::allocator<CSCppSymbolOwnerData*> > > > >)"),
	// mu_demangle_test("_ZGRZN1N1gEvE1a", "reference temporary for N::g()::a"),
	mu_demangle_test("_ZN5boost4bindIvN10libtorrent15peer_connectionEiRKNS1_11disk_io_jobENS1_12peer_requestENS_10shared_ptrINS1_7torrentEEENS_13intrusive_ptrIS2_EENS_3argILi1EEENSC_ILi2EEES6_S9_EENS_3_bi6bind_tIT_NS_4_mfi3mf4ISH_T0_T1_T2_T3_T4_EENSF_9list_av_5IT5_T6_T7_T8_T9_E4typeEEEMSK_FSH_SL_SM_SN_SO_ESR_SS_ST_SU_SV_", "boost::_bi::bind_t<void, boost::_mfi::mf4<void, libtorrent::peer_connection, int, libtorrent::disk_io_job const&, libtorrent::peer_request, boost::shared_ptr<libtorrent::torrent> >, boost::_bi::list_av_5<boost::intrusive_ptr<libtorrent::peer_connection>, boost::arg<1>, boost::arg<2>, libtorrent::peer_request, boost::shared_ptr<libtorrent::torrent> >::type> boost::bind<void, libtorrent::peer_connection, int, libtorrent::disk_io_job const&, libtorrent::peer_request, boost::shared_ptr<libtorrent::torrent>, boost::intrusive_ptr<libtorrent::peer_connection>, boost::arg<1>, boost::arg<2>, libtorrent::peer_request, boost::shared_ptr<libtorrent::torrent> >(void (libtorrent::peer_connection::*)(int, libtorrent::disk_io_job const&, libtorrent::peer_request, boost::shared_ptr<libtorrent::torrent>), boost::intrusive_ptr<libtorrent::peer_connection>, boost::arg<1>, boost::arg<2>, libtorrent::peer_request, boost::shared_ptr<libtorrent::torrent>)"),
	mu_demangle_test("_ZN3WTF15deleteAllValuesIPN7WebCore5XPath4Step8NodeTestEKNS_9HashTableIS5_S5_NS_17IdentityExtractorENS_7PtrHashIS5_EENS_10HashTraitsIS5_EESB_EEEEvRT0_", "void WTF::deleteAllValues<WebCore::XPath::Step::NodeTest*, WTF::HashTable<WebCore::XPath::Step::NodeTest*, WebCore::XPath::Step::NodeTest*, WTF::IdentityExtractor, WTF::PtrHash<WebCore::XPath::Step::NodeTest*>, WTF::HashTraits<WebCore::XPath::Step::NodeTest*>, WTF::HashTraits<WebCore::XPath::Step::NodeTest*> > const>(WTF::HashTable<WebCore::XPath::Step::NodeTest*, WebCore::XPath::Step::NodeTest*, WTF::IdentityExtractor, WTF::PtrHash<WebCore::XPath::Step::NodeTest*>, WTF::HashTraits<WebCore::XPath::Step::NodeTest*>, WTF::HashTraits<WebCore::XPath::Step::NodeTest*> > const&)"),
	mu_demangle_test("_Z13JVTLib_103270ILi1EEvPsDv2_xS1_", "void JVTLib_103270<1>(short*, int64_t __vector(2), int64_t __vector(2))"),
	mu_demangle_test("_ZN8platform20split_string_convertIcPFiRKSsEiSaIiESt6vectorEEjPKT_S9_S7_T0_RT3_IT1_T2_E", "unsigned int platform::split_string_convert<char, int (*)(std::string const&), int, std::allocator<int>, std::vector>(char const*, char const*, char, int (*)(std::string const&), std::vector<int, std::allocator<int> >&)"),
	// mu_demangle_test("_ZZN4NIds4NStr14TCStrAggregateINS0_13TCTCStrTraitsINS0_11TCStrTraitsIcNS0_17CDefaultStrParamsEEENS0_14TCStrImp_FixedIS5_Lx256EEEEEE21f_AddFromIteratorUTF8INS0_16CStrIteratorUTF8EEEvRxRKT_ENKSA_ISB_EUlmE0_clEm", "void NIds::NStr::TCStrAggregate<NIds::NStr::TCTCStrTraits<NIds::NStr::TCStrTraits<char, NIds::NStr::CDefaultStrParams>, NIds::NStr::TCStrImp_Fixed<NIds::NStr::TCStrTraits<char, NIds::NStr::CDefaultStrParams>, 256ll> > >::f_AddFromIteratorUTF8<NIds::NStr::CStrIteratorUTF8>(int64_t&, NIds::NStr::CStrIteratorUTF8 const&)::NIds::NStr::TCStrAggregate<NIds::NStr::TCTCStrTraits<NIds::NStr::TCStrTraits<char, NIds::NStr::CDefaultStrParams>, NIds::NStr::TCStrImp_Fixed<NIds::NStr::TCStrTraits<char, NIds::NStr::CDefaultStrParams>, 256ll> > >::f_AddFromIteratorUTF8<NIds::NStr::CStrIteratorUTF8>::'lambda0'(unsigned long)::operator()(unsigned long) const"),
	// mu_demangle_test("_ZZN4NIds4NStr14TCStrAggregateINS0_13TCTCStrTraitsINS0_11TCStrTraitsIcNS0_17CDefaultStrParamsEEENS0_14TCStrImp_FixedIS5_Lx256EEEEEE21f_AddFromIteratorUTF8INS0_16CStrIteratorUTF8EEEvRxRKT_ENKSA_ISB_EUt0_clEm", "void NIds::NStr::TCStrAggregate<NIds::NStr::TCTCStrTraits<NIds::NStr::TCStrTraits<char, NIds::NStr::CDefaultStrParams>, NIds::NStr::TCStrImp_Fixed<NIds::NStr::TCStrTraits<char, NIds::NStr::CDefaultStrParams>, 256ll> > >::f_AddFromIteratorUTF8<NIds::NStr::CStrIteratorUTF8>(int64_t&, NIds::NStr::CStrIteratorUTF8 const&)::NIds::NStr::TCStrAggregate<NIds::NStr::TCTCStrTraits<NIds::NStr::TCStrTraits<char, NIds::NStr::CDefaultStrParams>, NIds::NStr::TCStrImp_Fixed<NIds::NStr::TCStrTraits<char, NIds::NStr::CDefaultStrParams>, 256ll> > >::f_AddFromIteratorUTF8<NIds::NStr::CStrIteratorUTF8>::'unnamed0'::operator()(unsigned long) const"),
	// mu_demangle_test("_ZNKSt3__110__function6__funcIZN4DLCL8DLFutureIP15AnalysenManagerE3setINS_8functionIFS5_vEEEJEEEvT_DpOT0_EUlvE_NS_9allocatorISF_EEFvvEE7__cloneEv", "std::__1::__function::__func<void DLCL::DLFuture<AnalysenManager*>::set<std::__1::function<AnalysenManager* ()> >(std::__1::function<AnalysenManager* ()>)::'lambda'(), std::__1::allocator<void DLCL::DLFuture<AnalysenManager*>::set<std::__1::function<AnalysenManager* ()> >(std::__1::function<AnalysenManager* ()>)::'lambda'()>, void ()>::__clone() const"),
	// mu_demangle_test("___ZN19URLConnectionClient33_clientInterface_cancelConnectionEP16dispatch_queue_sU13block_pointerFvvE_block_invoke14", "invocation function for block in URLConnectionClient::_clientInterface_cancelConnection(dispatch_queue_s*, void () block_pointer)"),
	mu_demangle_test("_ZSteqIcEN9__gnu_cxx11__enable_ifIXsr9__is_charIT_EE7__valueEbE6__typeERKSbIS2_St11char_traitsIS2_ESaIS2_EESA_", "__gnu_cxx::__enable_if<__is_char<char>::__value, bool>::__type std::operator==<char>(std::basic_string<char, std::char_traits<char>, std::allocator<char> > const&, std::basic_string<char, std::char_traits<char>, std::allocator<char> > const&)"),
	mu_demangle_test("_ZN9__gnu_cxx17__normal_iteratorIPKSt4pairISsbESt6vectorIS2_SaIS2_EEEC5ERKS4_", "__gnu_cxx::__normal_iterator<std::pair<std::string, bool> const*, std::vector<std::pair<std::string, bool>, std::allocator<std::pair<std::string, bool> > > >::__normal_iterator(std::pair<std::string, bool> const* const&)"),
	// mu_demangle_test("_Z1fIiEDTeqfp_LDnEEPT_", "decltype (fp == nullptr) f<int>(int*)"),
	// mu_demangle_test("_Z1fIiEDTeqfp1_LDnEEicPT_", "decltype (fp1 == nullptr) f<int>(int, char, int*)"),
	// mu_demangle_test("_ZZN1S1fEiiEd0_NKUlvE_clEv", "S::f(int, int)::'lambda'()::operator()() const"),
	// mu_demangle_test("_Z1fPU11objcproto1A11objc_object", "f(id<A>)"),
	// mu_demangle_test("_Z1fPKU11objcproto1A7NSArray", "f(NSArray<A> const*)"),
	// mu_demangle_test("_ZNK1AIJ1Z1Y1XEEcv1BIJDpPT_EEIJS2_S1_S0_EEEv", "A<Z, Y, X>::operator B<X*, Y*, Z*><X, Y, Z>() const"),
	// mu_demangle_test("i", "int"),
	// mu_demangle_test("PKFvRiE", "void (*)(int&) const"),
	// mu_demangle_test("PVFvRmOE", "void (*)(unsigned long&) volatile &&"),
	// mu_demangle_test("PFvRmOE", "void (*)(unsigned long&) &&"),
	mu_demangle_test("_ZTW1x", "TLS wrapper function for x"),
	mu_demangle_test("_ZTHN3fooE", "TLS init function for foo"),
	// mu_demangle_test("_Z1fIJEJiEEvDpT_DpT0_", "void f<int>(int)"),
	// mu_demangle_test("_Z1pIJicEEiDp4MerpIXsZT_EJT_EE", "int p<int, char>(Merp<sizeof...(int, char), int>, Merp<sizeof...(int, char), char>)"),
	mu_demangle_test("_ZN5Casts8implicitILj4EEEvPN9enable_ifIXleT_Li4EEvE4typeE", "void Casts::implicit<4u>(enable_if<(4u)<=(4), void>::type*)"),
	mu_demangle_test("_ZN5Casts6cstyleILj4EEEvPN9enable_ifIXleT_cvjLi4EEvE4typeE", "void Casts::cstyle<4u>(enable_if<(4u)<=((unsigned int)(4)), void>::type*)"),
	mu_demangle_test("_ZN5Casts10functionalILj4EEEvPN9enable_ifIXleT_cvjLi4EEvE4typeE", "void Casts::functional<4u>(enable_if<(4u)<=((unsigned int)(4)), void>::type*)"),
	mu_demangle_test("_ZN5Casts7static_ILj4EEEvPN9enable_ifIXleT_scjLi4EEvE4typeE", "void Casts::static_<4u>(enable_if<(4u)<=(static_cast<unsigned int>(4)), void>::type*)"),
	mu_demangle_test("_ZN5Casts12reinterpret_ILj4EiEEvPN9enable_ifIXleT_szrcPT0_Li0EEvE4typeE", "void Casts::reinterpret_<4u, int>(enable_if<(4u)<=(sizeof (reinterpret_cast<int*>(0))), void>::type*)"),
	mu_demangle_test("_ZN5Casts6const_IiXadL_ZNS_1iEEEEEvPN9enable_ifIXleLi0EszccPT_T0_EvE4typeE", "void Casts::const_<int, &Casts::i>(enable_if<(0)<=(sizeof (const_cast<int*>(&Casts::i))), void>::type*)"),
	mu_demangle_test("_ZN5Casts8dynamic_INS_1SEXadL_ZNS_1sEEEEEvPN9enable_ifIXleLi0EszdcPT_T0_EvE4typeE", "void Casts::dynamic_<Casts::S, &Casts::s>(enable_if<(0)<=(sizeof (dynamic_cast<Casts::S*>(&Casts::s))), void>::type*)"),
	// mu_demangle_test("_ZN5Casts7scalar_IiEEvDTcmcvT__Ecvi_EE", "void Casts::scalar_<int>(decltype ((int)(), (int)()))"),
	mu_demangle_test("_ZN5test11aIsEEDTcl3foocvT__EEES1_", "decltype (foo((short)())) test1::a<short>(short)"),
	// mu_demangle_test("_ZN5test21aIPFfvEEEvT_DTclfL0p_EE", "void test2::a<float (*)()>(float (*)(), decltype (fp()))"),
	// mu_demangle_test("_ZN5test21bIPFfvEEEDTclfp_EET_", "decltype (fp()) test2::b<float (*)()>(float (*)())"),
	// mu_demangle_test("_ZN5test21cIPFfvEEEvT_PFvDTclfL1p_EEE", "void test2::c<float (*)()>(float (*)(), void (*)(decltype (fp())))"),
	// mu_demangle_test("_ZN5test21dIPFfvEEEvT_PFDTclfL0p_EEvE", "void test2::d<float (*)()>(float (*)(), decltype (fp()) (*)())"),
	// mu_demangle_test("_ZN5test21eIPFfvEEEvPFDTclfp_EET_E", "void test2::e<float (*)()>(decltype (fp()) (*)(float (*)()))"),
	// mu_demangle_test("_ZN5test21fIPFfvEEEvPFvT_DTclfL0p_EEE", "void test2::f<float (*)()>(void (*)(float (*)(), decltype (fp())))"),
	// mu_demangle_test("_ZN5test21gIPFfvEEEvT_DTclfL0p_EE", "void test2::g<float (*)()>(float (*)(), decltype (fp()))"),
	// mu_demangle_test("_ZN5test21hIPFfvEEEvT_DTcvPFDTclfL0p_EEvELi0EE", "void test2::h<float (*)()>(float (*)(), decltype ((decltype(fp()) (*)())(0)))"),
	// mu_demangle_test("_ZN5test21iIPFfvEEEvDTcvPFDTclfp_EET_ELi0EE", "void test2::i<float (*)()>(decltype ((decltype(fp()) (*)(float (*)()))(0)))"),
	// mu_demangle_test("_ZZN5test21gIPFfvEEEvT_DTclfL0p_EEE8variable", "void test2::g<float (*)()>(float (*)(), decltype (fp()))::variable"),
	// mu_demangle_test("_ZN5test31aINS_1XEMS1_PiEEvT_T0_DTdsfL0p_fL0p0_E", "void test3::a<test3::X, int* test3::X::*>(test3::X, int* test3::X::*, decltype (fp.*fp0))"),
	mu_demangle_test("_ZN5test43tf1INS_1XEEEvDTnw_T_piLi1EEE", "void test4::tf1<test4::X>(decltype (new test4::X(1)))"),
	// mu_demangle_test("_ZN5test51aIiEEvDTnxcvT__EE", "void test5::a<int>(decltype (noexcept ((int)())))"),
	mu_demangle_test("_ZN5test62f1IiEEvDTcvT_dtdtL_ZNS_1zEE2ua1iE", "void test6::f1<int>(decltype ((int)((test6::z.ua).i)))"),
	mu_demangle_test("_ZN5test62f2IiEEvDTcvT_dtdtL_ZNS_1zEE2ub1iE", "void test6::f2<int>(decltype ((int)((test6::z.ub).i)))"),
	mu_demangle_test("_ZN5test62f3IiEEvDTcvT_dtdtL_ZNS_1zEE1s1iE", "void test6::f3<int>(decltype ((int)((test6::z.s).i)))"),
	mu_demangle_test("_ZN5test62f4IiEEvDTcvT_dtdtL_ZNS_1zEE4uuss1iE", "void test6::f4<int>(decltype ((int)((test6::z.uuss).i)))"),
	mu_demangle_test("_ZN5test62f5IiEEvDTcvT_dtptL_ZNS_2zpEE2ua1iE", "void test6::f5<int>(decltype ((int)((test6::zp->ua).i)))"),
	mu_demangle_test("_ZN5test62f6IiEEvDTcvT_dtptL_ZNS_2zpEE2ub1iE", "void test6::f6<int>(decltype ((int)((test6::zp->ub).i)))"),
	mu_demangle_test("_ZN5test62f7IiEEvDTcvT_dtptL_ZNS_2zpEE1s1iE", "void test6::f7<int>(decltype ((int)((test6::zp->s).i)))"),
	mu_demangle_test("_ZN5test62f8IiEEvDTcvT_dtptL_ZNS_2zpEE4uuss1iE", "void test6::f8<int>(decltype ((int)((test6::zp->uuss).i)))"),
	mu_demangle_test("_ZN5test73fD2IiEEDTcmcvNS_1DEL_ZNS_1bEEcvT__EES2_", "decltype (((test7::D)test7::b),((int)())) test7::fD2<int>(int)"),
	mu_demangle_test("_ZN5test73fT2IiEEDTcvT__EES1_", "decltype ((int)()) test7::fT2<int>(int)"),
	mu_demangle_test("_ZN5test73fT4IiEEDTcvT_Li1EES1_", "decltype ((int)(1)) test7::fT4<int>(int)"),
	mu_demangle_test("_ZN5test73fT6INS_1BEEEDTcvT__Li1ELi2EEES2_", "decltype ((test7::B)(1, 2)) test7::fT6<test7::B>(test7::B)"),
	mu_demangle_test("_ZNK5test81XIiE3barIiEEDTcl3fooIT_EEEv", "decltype ((foo<int>)()) test8::X<int>::bar<int>() const"),
	// mu_demangle_test("_Z1fPU3AS1KiS0_", "f(int const AS1*, int const AS1*)"),
	// mu_demangle_test("_ZN6test471fINS_1SEEEvPTsNT_1cE", "void test47::f<test47::S>(struct test47::S::c*)"),
	// mu_demangle_test("_ZN6test481fINS_1SEEEvPTuNT_1uE", "void test48::f<test48::S>(union test48::S::u*)"),
	// mu_demangle_test("_ZN6test451fINS_1SEEEvPTeNT_1eE", "void test45::f<test45::S>(enum test45::S::e*)"),
	// mu_demangle_test("_Z1fIcEvDTcv3StrIT_ELA6_KcEE", "void f<char>(decltype ((Str<char>)(\"<char const [6]>\")))"),
	mu_demangle_test("_ZN5test43tf2INS_1XEEEvDTnw_T_piilLi1EEEE", "void test4::tf2<test4::X>(decltype (new test4::X({1})))"),
	mu_demangle_test("_ZN5test73fA1IiEEDTcmtlNS_1AELi1ELi2EEcvT__EES2_", "decltype (test7::A{1, 2},((int)())) test7::fA1<int>(int)"),
	mu_demangle_test("_ZN5test73fA2IiEEDTcmcvNS_1AEilLi1ELi2EEcvT__EES2_", "decltype (((test7::A){1, 2}),((int)())) test7::fA2<int>(int)"),
	mu_demangle_test("_ZN5test73fB1IiEEDTcmtlNS_1BELi1ELi2EEcvT__EES2_", "decltype (test7::B{1, 2},((int)())) test7::fB1<int>(int)"),
	mu_demangle_test("_ZN5test73fB2IiEEDTcmcvNS_1BEilLi1ELi2EEcvT__EES2_", "decltype (((test7::B){1, 2}),((int)())) test7::fB2<int>(int)"),
	mu_demangle_test("_ZN5test73fC1IiEEDTcmtlNS_1CEilLi1ELi2EEEcvT__EES2_", "decltype (test7::C{{1, 2}},((int)())) test7::fC1<int>(int)"),
	mu_demangle_test("_ZN5test73fC2IiEEDTcmcvNS_1CEilLi1ELi2EEcvT__EES2_", "decltype (((test7::C){1, 2}),((int)())) test7::fC2<int>(int)"),
	mu_demangle_test("_ZN5test73fD1IiEEDTcmtlNS_1DEL_ZNS_1bEEEcvT__EES2_", "decltype (test7::D{test7::b},((int)())) test7::fD1<int>(int)"),
	mu_demangle_test("_ZN5test73fE1IiEEDTcmtlNS_1EELi1ELi2EEcvT__EES2_", "decltype (test7::E{1, 2},((int)())) test7::fE1<int>(int)"),
	mu_demangle_test("_ZN5test73fE2IiEEDTcmcvNS_1EEilLi1ELi2EEcvT__EES2_", "decltype (((test7::E){1, 2}),((int)())) test7::fE2<int>(int)"),
	mu_demangle_test("_ZN5test73fF1IiEEDTcmtlNS_1FEilLi1ELi2EEEcvT__EES2_", "decltype (test7::F{{1, 2}},((int)())) test7::fF1<int>(int)"),
	mu_demangle_test("_ZN5test73fF2IiEEDTcmcvNS_1FEilLi1ELi2EEcvT__EES2_", "decltype (((test7::F){1, 2}),((int)())) test7::fF2<int>(int)"),
	mu_demangle_test("_ZN5test73fT1IiEEDTtlT_EES1_", "decltype (int{}) test7::fT1<int>(int)"),
	mu_demangle_test("_ZN5test73fT3IiEEDTtlT_Li1EEES1_", "decltype (int{1}) test7::fT3<int>(int)"),
	mu_demangle_test("_ZN5test73fT5INS_1BEEEDTtlT_Li1ELi2EEES2_", "decltype (test7::B{1, 2}) test7::fT5<test7::B>(test7::B)"),
	mu_demangle_test("_ZN5test73fT7INS_1AEEEDTtlT_ilEEES2_", "decltype (test7::A{{}}) test7::fT7<test7::A>(test7::A)"),
	mu_demangle_test("_ZN5test73fT8INS_1AEEEDTcvT_ilEES2_", "decltype ((test7::A){}) test7::fT8<test7::A>(test7::A)"),
	mu_demangle_test("_ZN5test73fT9INS_1AEEEDTtlT_ilLi1EEEES2_", "decltype (test7::A{{1}}) test7::fT9<test7::A>(test7::A)"),
	mu_demangle_test("_ZN5test73fTAINS_1AEEEDTcvT_ilLi1EEES2_", "decltype ((test7::A){1}) test7::fTA<test7::A>(test7::A)"),
	mu_demangle_test("_ZN5test73fTBINS_1CEEEDTtlT_ilLi1ELi2EEEES2_", "decltype (test7::C{{1, 2}}) test7::fTB<test7::C>(test7::C)"),
	// mu_demangle_test("_ZN5test73fTCINS_1CEEEDTcvT_ilLi1ELi2EEES2_", "decltype *((test7::C)({1, 2}) test7::fTC<test7::C>(test7::C)"),
	// mu_demangle_test("_ZN15designated_init1fINS_1AEEEvDTtlT_di1adi1bdxLi3EdXLi1ELi4ELi9EEE", "void designated_init::f<designated_init::A>(decltype (designated_init::A{.a.b[3][1 ... 4] = 9}))"),
	// mu_demangle_test("_Z1fIXtl1Xdi1adi1bdxLi3ELi1EEEE", "f<X{.a.b[3] = 1}>"),
	// mu_demangle_test("_ZN1BCI21AEi", "B::B(int)"),
	// mu_demangle_test("_ZN1DCI21CIiEET_", "D::D(int)"),
	// mu_demangle_test("_Z1hIJEEPDwDpT_iEFivEPDwiS1_EFivE", "int (*h<>(int (*)() throw(int)))() throw(int)"),
	// mu_demangle_test("_Z1pILb1EEiM1SKDOT_EFivRE", "int p<true>(int (S::*)() const & noexcept(true))"),
	// mu_demangle_test("_Z1pIJicfEEiM1SVKDwDpT_EFivOE", "int p<int, char, float>(int (S::*)() const volatile && throw(int, char, float))"),
	// mu_demangle_test("___Z10blocksNRVOv_block_invoke", "invocation function for block in blocksNRVO()"),
	// mu_demangle_test("_ZGRDC1x1yE_", "reference temporary for [x, y]"),
	// mu_demangle_test("_ZGR1bIvE2_", "reference temporary for b<void>"),
	// mu_demangle_test("_ZZ18test_assign_throwsI20small_throws_on_copyLb0EEvvENKUlRNSt3__13anyEOT_E_clIRS0_EEDaS3_S5_", "auto void test_assign_throws<small_throws_on_copy, false>()::'lambda'(std::__1::any&, auto&&)::operator()<small_throws_on_copy&>(std::__1::any&, auto&&) const"),
	// mu_demangle_test("_Z1fUa9enable_ifIXLi1EEEv", "f() [enable_if:1]"),
	// mu_demangle_test("_ZN5test4IdE1fEUa9enable_ifIXeqfL0p_Li1EEXeqfL0p0_Li2EEEi", "test4<double>::f(int) [enable_if:fp == 1, fp0 == 2]"),
	// mu_demangle_test("_Z3quxUa9enable_ifIXLi1EEXL_Z9TRUEFACTSEEEi", "qux(int) [enable_if:1, TRUEFACTS]"),
	// mu_demangle_test("_ZN5OuterI4MarpEcv7MuncherIJT_T0_DpT1_EEI4MerpS0_JicfEEEv", "Outer<Marp>::operator Muncher<Merp, Marp, int, char, float><Merp, Marp, int, char, float>()"),
	// mu_demangle_test("_ZZN5OuterI4MarpEcv7MuncherIJT_T0_DpT1_EEI4MerpS0_JicfEEEvEN1ScvS9_Ev", "Outer<Marp>::operator Muncher<Merp, Marp, int, char, float><Merp, Marp, int, char, float>()::S::operator Merp()"),
	// mu_demangle_test("_ZN1Scv7MuncherIJDpPT_EEIJFivEA_iEEEv", "S::operator Muncher<int (*)(), int (*) []><int (), int []>()"),
	// mu_demangle_test("_Z2f8IiJ8identityIiES0_IfEEEvRAsPiDpT0_T_DpNS3_4typeEE_i", "void f8<int, identity<int>, identity<float> >(int (&) [sizeof... (int, identity<int>, identity<float>, int, identity<int>::type, identity<float>::type)])"),
	// mu_demangle_test("_ZNK13StaticMembersIfE1xMUlvE_clEv", "StaticMembers<float>::x::'lambda'()::operator()() const"),
	// mu_demangle_test("_ZNK10inline_varMUlvE_clEv", "inline_var::'lambda'()::operator()() const"),
	mu_demangle_test("_Z6foldl1IJLi1ELi2ELi3EEEv1AIXfLplLi1ET_EE", "void foldl1<1, 2, 3>(A<((1)+...+(1, 2, 3))>)"),
	mu_demangle_test("_Z6foldr1IJLi1ELi2ELi3EEEv1AIXfRplT_Li1EEE", "void foldr1<1, 2, 3>(A<((1, 2, 3)+...+(1))>)"),
	mu_demangle_test("_Z5foldlIJLi1ELi2ELi3EEEv1AIXflplT_EE", "void foldl<1, 2, 3>(A<(...+(1, 2, 3))>)"),
	mu_demangle_test("_Z5foldrIJLi1ELi2ELi3EEEv1AIXfrplT_EE", "void foldr<1, 2, 3>(A<((1, 2, 3)+...)>)"),
	mu_demangle_test("_ZN7PartialIJLi1ELi2EEE5foldrIJLi3ELi4EEEEv1AIXplLi1EplLi2EfRplT_plLi1EplLi2EfrplT_EE", "void Partial<1, 2>::foldr<3, 4>(A<(1)+((2)+(((3, 4)+...+((1)+((2)+(((3, 4)+...)))))))>)"),
	mu_demangle_test("_ZN7PartialIJLi1ELi2EEE5foldrIJLi3ELi4EEEEv1AIXplplLi1ELi2EfRplT_plplLi1ELi2EflplT_EE", "void Partial<1, 2>::foldr<3, 4>(A<((1)+(2))+(((3, 4)+...+(((1)+(2))+((...+(3, 4))))))>)"),
	// mu_demangle_test("_Z1fIXfLpm1x1yEEvv", "void f<(x ->* ... ->* (y...))>()"),
	// mu_demangle_test("_Z1fIXfLds1x1yEEvv", "void f<(x .* ... .* (y...))>()"),
	// mu_demangle_test("___Z3foo_block_invoke.25", "invocation function for block in foo"),
	// mu_demangle_test("____Z3foo_block_invoke.25", "invocation function for block in foo"),
	// mu_demangle_test("_Z2tfIZUb_E1SEiv", "int tf<'block-literal'::S>()"),
	mu_demangle_test("_Z2f1IiEvDTatT_E", "void f1<int>(decltype (alignof (int)))"),
	mu_demangle_test("_Z2f3IiEvDTazcvT_Li0EE", "void f3<int>(decltype (alignof ((int)(0))))"),
	mu_demangle_test("_Z2f2IiEvDTu11__alignof__T_EE", "void f2<int>(decltype (__alignof__(int)))"),
	mu_demangle_test("_Z2f4IiEvDTu11__alignof__XcvT_Li0EEEE", "void f4<int>(decltype (__alignof__((int)(0))))"),
	// mu_demangle_test("_Z15test_uuidofTypeI10TestStructEvDTu8__uuidoftT_E", "void test_uuidofType<TestStruct>(decltype (__uuidof(TestStruct)))"),
	mu_demangle_test("_Z15test_uuidofExprI9HasMemberEvDTu8__uuidofXsrT_6memberEEE", "void test_uuidofExpr<HasMember>(decltype (__uuidof(HasMember::member)))"),
	mu_demangle_test("_Z15test_uuidofTypeI10TestStructEvDTu8__uuidofT_EE", "void test_uuidofType<TestStruct>(decltype (__uuidof(TestStruct)))"),
	mu_demangle_test("_Z15test_uuidofExprI9HasMemberEvDTu8__uuidofXsrT_6memberEEE", "void test_uuidofExpr<HasMember>(decltype (__uuidof(HasMember::member)))"),
	// mu_demangle_test("_ZNK1xMUlTyT_E_clIiEEDaS_", "auto x::'lambda'<typename $T>($T)::operator()<int>(x) const"),
	// mu_demangle_test("_ZNK1xMUlTnPA3_ivE_clILS0_0EEEDav", "auto x::'lambda'<int (*$N) [3]>()::operator()<(int [3])0>() const"),
	// mu_demangle_test("_ZNK1xMUlTyTtTyTnT_TpTnPA3_TL0__ETpTyvE_clIi1XJfEEEDav", "auto x::'lambda'<typename $T, template<typename $T0, $T $N, $T0 (*...$N0) [3]> typename $TT, typename ...$T1>()::operator()<int, X, float>() const"),
	// mu_demangle_test("_ZN1AIiE1fIfEEvDTLUlTyTtTyTnTL1__ETL0_1_T_TL0__E_EE", "void A<int>::f<float>(decltype ([]<typename $T, template<typename $T0, $T0 $N> typename $TT>(auto, float, $T){...}))"),
	// mu_demangle_test("_ZN1S1fILb1EEEv1XILUlvE0_EE", "void S::f<true>(X<[](){...}>)"),
	// mu_demangle_test("_ZZ11inline_funcvENKUlTyTyT_T0_E_clIiiEEDaS_S0_", "auto inline_func()::'lambda'<typename $T, typename $T0>($T, $T0)::operator()<int, int>($T, $T0) const"),
	// mu_demangle_test("_ZZ11inline_funcvENKUlTyTyT_T1_T0_E_clIiiiEEDaS_S0_S1_", "auto inline_func()::'lambda'<typename $T, typename $T0>($T, auto, $T0)::operator()<int, int, int>($T, auto, $T0) const"),
	// mu_demangle_test("_ZN1XIZ1fIiEvOT_EUlOT_DpT0_E_EclIJEEEvDpT_", "void X<void f<int>(int&&)::'lambda'(auto&&, auto...)>::operator()<>()"),
	// mu_demangle_test("_ZN1XIZ1fIiEvOT_EUlS2_DpT0_E_EclIJEEEvDpT_", "void X<void f<int>(int&&)::'lambda'(int&&, auto...)>::operator()<>()"),
	// mu_demangle_test("_ZZZZN6abcdef9abcdefghi29abcdefabcdefabcdefabcefabcdef27xxxxxxxxxxxxxxxxxxxxxxxxxxxEN4absl8DurationERKNSt3__u12basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEEPNS1_19yyyyyyyyyyyyyyyyyyyEENK3$_5clEvENKUlvE_clEvE6zzzzzz", "abcdef::abcdefghi::abcdefabcdefabcdefabcefabcdef::xxxxxxxxxxxxxxxxxxxxxxxxxxx(absl::Duration, std::__u::basic_string<char, std::__u::char_traits<char>, std::__u::allocator<char> > const&, abcdef::abcdefghi::abcdefabcdefabcdefabcefabcdef::yyyyyyyyyyyyyyyyyyy*)::$_5::operator()() const::'lambda'()::operator()() const::zzzzzz"),
	// mu_demangle_test("_ZN1C1fIiEEvDTtlNS_UlT_TL0__E_EEE", "void C::f<int>(decltype (C::'lambda'(int, auto){}))"),
	// mu_demangle_test("_Z1fIXtl1BadsoiL_Z6nestedE_EEEEvv", "void f<B{&nested.<int at offset 0>}>()"),
	// mu_demangle_test("_Z1fIXtl1BadsoiL_Z6nestedE16_0pEEEEvv", "void f<B{&nested.<int at offset 16>}>()"),
	// mu_demangle_test("_Z1fIXtl2BRsoiL_Z7derivedE4EEEEvv", "void f<BR{derived.<int at offset 4>}>()"),
	mu_demangle_test("_Z1fIXtl1BcvPiplcvPcadL_Z7derivedELl16EEEEvv", "void f<B{(int*)(((char*)(&derived))+(16l))}>()"),
	// mu_demangle_test("_Z1fIXtl1CadsoKiL_Z7derivedE4EEEEvv", "void f<C{&derived.<int const at offset 4>}>()"),
	// mu_demangle_test("_Z1fIXtl1DmcM7DerivedKiadL_ZN11MoreDerived1zEEn8EEEEvv", "void f<D{(int const Derived::*)(&MoreDerived::z)}>()"),
	mu_demangle_test("_Z1fIXtl1Edi1nLi42EEEEvv", "void f<E{.n=(42)}>()"),
	// mu_demangle_test("_Z1h1XIJZ1fIiEDaOT_E1AZ1gIdEDaS2_E1BEE", "h(X<auto f<int>(int&&)::A, auto g<double>(int&&)::B>)"),
	mu_demangle_test("_ZN1A1gIiEEDTcldtptfpT1b1fIT_EEEv", "decltype (((this->b).(f<int>))()) A::g<int>()"),
	// mu_demangle_test("_ZN3xxx3yyyIvNS_1AILm0EEEZNS_2bb2cc2ddILNS_1eE1EEEvRKNS_1fERKNS_1g1hINS_1iEEERKNS_1jEfRKNS_1kEiPhEUlvE_JEEEvT1_DpT2_", "void xxx::yyy<void, xxx::A<0ul>, void xxx::bb::cc::dd<(xxx::e)1>(xxx::f const&, xxx::g::h<xxx::i> const&, xxx::j const&, float, xxx::k const&, int, unsigned char*)::'lambda'()>(void xxx::bb::cc::dd<(xxx::e)1>(xxx::f const&, xxx::g::h<xxx::i> const&, xxx::j const&, float, xxx::k const&, int, unsigned char*)::'lambda'())"),
	// mu_demangle_test("_Zcv1BIRT_EIS1_E", "operator B<><>"),
	// mu_demangle_test("_ZN2FnIXgsnw_iEEXna_ipiLi4EEEEEvv", "void Fn<::new int, new[] int(4)>()"),
	// mu_demangle_test("_ZN2FnIXnwLj4E_iEEXgsnaLj4E_ipiLi4EEEEEvv", "void Fn<new(4u) int, ::new[](4u) int(4)>()"),
	mu_demangle_test("_ZN2FnIXgsdlLi4EEXdaLi4EEEEvv", "void Fn<::delete (4), delete[] (4)>()"),
	mu_demangle_test("_ZN2FnIXdlLj4EEXgsdaLj4EEEEvv", "void Fn<delete (4u), ::delete[] (4u)>()"),
	mu_demangle_test("_Z2f0IiE1SIX1CIT_EEEv", "S<C<int> > f0<int>()"),
	// mu_demangle_test("_ZN5test21AIiEF1fEzQ4TrueIT_E", "test2::A<int>::friend f(...) requires True<T>"),
	// mu_demangle_test("_ZN5test2F1gIvEEvzQaa4TrueIT_E4TrueITL0__E", "void test2::friend g<void>(...) requires True<T> && True<TL0_>"),
	// mu_demangle_test("_ZN5test21hIvEEvzQ4TrueITL0__E", "void test2::h<void>(...) requires True<TL0_>"),
	// mu_demangle_test("_ZN5test2F1iIvQaa4TrueIT_E4TrueITL0__EEEvz", "void test2::friend i<void>(...)"),
	// mu_demangle_test("_ZN5test21jIvQ4TrueITL0__EEEvz", "void test2::j<void>(...)"),
	// mu_demangle_test("_ZN5test2F1kITk4TruevQ4TrueIT_EEEvz", "void test2::friend k<void>(...)"),
	// mu_demangle_test("_ZN5test21lITk4TruevEEvz", "void test2::l<void>(...)"),
	// mu_demangle_test("_ZN5test31dITnDaLi0EEEvv", "void test3::d<0>()"),
	// mu_demangle_test("_ZN5test31eITnDcLi0EEEvv", "void test3::e<0>()"),
	// mu_demangle_test("_ZN5test31fITnDk1CLi0EEEvv", "void test3::f<0>()"),
	// mu_demangle_test("_ZN5test31gITnDk1DIiELi0EEEvv", "void test3::g<0>()"),
	// mu_demangle_test("_ZN5test31hIiTnDk1DIT_ELi0EEEvv", "void test3::h<int, 0>()"),
	// mu_demangle_test("_ZN5test31iIiEEvDTnw_Dk1CpicvT__EEE", "void test3::i<int>(decltype (new C auto((int)())))"),
	// mu_demangle_test("_ZN5test31jIiEEvDTnw_DK1CpicvT__EEE", "void test3::j<int>(decltype (new C decltype(auto)((int)())))"),
	// mu_demangle_test("_ZN5test41fITk1CiEEvv", "void test4::f<int>()"),
	// mu_demangle_test("_ZN5test41gITk1DIiEiEEvv", "void test4::g<int>()"),
	// mu_demangle_test("_ZN5test51fITtTyTnTL0__ENS_1YEEEvv", "void test5::f<test5::Y>()"),
	// mu_demangle_test("_ZN5test51fITtTyTnTL0__ENS_1ZEEEvv", "void test5::f<test5::Z>()"),
	// mu_demangle_test("_ZN5test51gITtTyTnTL0__Q1CIS1_EENS_1XEEEvv", "void test5::g<test5::X>()"),
	// mu_demangle_test("_ZN5test51gITtTyTnTL0__Q1CIS1_EENS_1ZEEEvv", "void test5::g<test5::Z>()"),
	// mu_demangle_test("_ZN5test51hITtTk1CTnTL0__ENS_1XEEEvv", "void test5::h<test5::X>()"),
	// mu_demangle_test("_ZN5test51hITtTk1CTnTL0__ENS_1YEEEvv", "void test5::h<test5::Y>()"),
	// mu_demangle_test("_ZN5test51iITpTtTk1CTnTL0__EJNS_1XENS_1YENS_1ZEEEEvv", "void test5::i<test5::X, test5::Y, test5::Z>()"),
	// mu_demangle_test("_ZN5test51iITpTtTk1CTnTL0__EJNS_1YENS_1ZENS_1XEEEEvv", "void test5::i<test5::Y, test5::Z, test5::X>()"),
	// mu_demangle_test("_ZN5test51pITtTpTyENS_1BEEEvv", "void test5::p<test5::B>()"),
	// mu_demangle_test("_ZN5test51qITtTyTyENS_1AEEEvv", "void test5::q<test5::A>()"),
	// mu_demangle_test("_ZN5test61fITk1CiEEvT_", "void test6::f<int>(int)"),
	// mu_demangle_test("_ZN5test61gIiTk1DIT_EiEEvT0_", "void test6::g<int, int>(int)"),
	// mu_demangle_test("_ZZN5test71fIiEEvvENKUlTyQaa1CIT_E1CITL0__ET0_E_clIiiEEDaS3_Q1CIDtfp_EE", "auto void test7::f<int>()::'lambda'<typename $T> requires C<T> && C<TL0_> (auto)::operator()<int, int>(auto) const requires C<decltype (fp)>"),
	// mu_demangle_test("_ZZN5test71fIiEEvvENKUlTyQaa1CIT_E1CITL0__ET0_E0_clIiiEEDaS3_Qaa1CIDtfp_EELb1E", "auto void test7::f<int>()::'lambda0'<typename $T> requires C<T> && C<TL0_> (auto)::operator()<int, int>(auto) const requires C<decltype (fp)> && true"),
	// mu_demangle_test("_ZZN5test71fIiEEvvENKUlTyQaa1CIT_E1CITL0__ET0_E1_clIiiEEDaS3_Q1CIDtfp_EE", "auto void test7::f<int>()::'lambda1'<typename $T> requires C<T> && C<TL0_> (auto)::operator()<int, int>(auto) const requires C<decltype (fp)>"),
	// mu_demangle_test("_ZZN5test71fIiEEvvENKUlTyT0_E_clIiiEEDaS1_", "auto void test7::f<int>()::'lambda'<typename $T>(auto)::operator()<int, int>(auto) const"),
	// mu_demangle_test("_Z1fIiEviQrqXcvT__EXfp_Xeqfp_cvS0__EXplcvS0__ELi1ER5SmallXmicvS0__ELi1ENXmlcvS0__ELi2ENR11SmallerThanILi1234EETS0_T1XIS0_ETNS3_4typeETS2_IiEQ11SmallerThanIS0_Li256EEE", "void f<int>(int) requires requires { (T)(); fp; fp == (T)(); {(T)() + 1} -> Small; {(T)() - 1} noexcept; {(T)() * 2} noexcept -> SmallerThan<1234>; typename T; typename X<T>; typename X<T>::type; typename X<int>; requires SmallerThan<T, 256>; }"),
	// mu_demangle_test("_Z1gIiEviQrQT__XplfL0p_fp_E", "void g<int>(int) requires requires (T) { fp + fp; )"),
	mu_demangle_test("_ZNSdC1Ev", "std::basic_iostream<char, std::char_traits<char> >::basic_iostream()"),
	mu_demangle_test("_ZNSiC1Ev", "std::basic_istream<char, std::char_traits<char> >::basic_istream()"),
	mu_demangle_test("_ZNSoC1Ev", "std::basic_ostream<char, std::char_traits<char> >::basic_ostream()"),
	mu_demangle_test("_ZNSsC1Ev", "std::basic_string<char, std::char_traits<char>, std::allocator<char> >::basic_string()"),
	// mu_demangle_test("_Z2f5IiEvu22__add_lvalue_referenceIT_E", "void f5<int>(__add_lvalue_reference(int))"),
	// mu_demangle_test("_Z2f5IiEvu13__add_pointerIT_E", "void f5<int>(__add_pointer(int))"),
	// mu_demangle_test("_Z2f5IiEvu7__decayIT_E", "void f5<int>(__decay(int))"),
	// mu_demangle_test("_Z2f5IjEvu13__make_signedIT_E", "void f5<unsigned int>(__make_signed(unsigned int))"),
	// mu_demangle_test("_Z2f5IKiEvu14__remove_constIT_E", "void f5<int const>(__remove_const(int const))"),
	// mu_demangle_test("_Z2f5IPiEvu16__remove_pointerIT_E", "void f5<int*>(__remove_pointer(int*))"),
	// mu_demangle_test("_Z2f5IiEvu14__remove_cvrefIT_E", "void f5<int>(__remove_cvref(int))"),
	// mu_demangle_test("_ZNH3Foo3fooES_i", "Foo::foo(this Foo, int)"),
	// mu_demangle_test("_ZNH3Foo3fooERKS_i", "Foo::foo(this Foo const&, int)"),
	// mu_demangle_test("_ZNH1X3fooIRS_EEvOT_i", "void X::foo<X&>(this X&, int)"),
	// mu_demangle_test("_ZZNH2ns3Foo3fooES0_iENH4Foo24foo2EOKS1_", "ns::Foo::foo(this ns::Foo, int)::Foo2::foo2(this Foo2 const&&)"),
	// mu_demangle_test("_ZNH2ns3FooB7Foo_tag3fooB7foo_tagERKS0_i", "ns::Foo[abi:Foo_tag]::foo[abi:foo_tag](this ns::Foo[abi:Foo_tag] const&, int)"),
	// mu_demangle_test("_ZZN3Foo3fooEiENH4Foo24foo2EOKS0_", "Foo::foo(int)::Foo2::foo2(this Foo2 const&&)"),
	// mu_demangle_test("_ZZNH3Foo3fooES_iENK4Foo24foo2Ev", "Foo::foo(this Foo, int)::Foo2::foo2() const"),
	// mu_demangle_test("_ZNH3FooclERKS_", "Foo::operator()(this Foo const&)"),
	// mu_demangle_test("__ZTSZ13xml_ParseFileE3$_0", "typeinfo name for xml_ParseFile::$_0"),
	// mu_demangle_test("__ZTSZ14xml_ModifyFileE3$_1", "typeinfo name for xml_ModifyFile::$_1"),
	// mu_demangle_test("__ZTSZN8csconfig12LoadFromFileERNS_6csconfEE3$_0", "typeinfo name for csconfig::LoadFromFile(csconfig::csconf&)::$_0"),
	// mu_demangle_test("__ZTSZN8csconfig12ModifyConfigERKNS_6csconfEE3$_1", "typeinfo name for csconfig::ModifyConfig(csconfig::csconf const&)::$_1"),
	// mu_demangle_test("__ZTSZN6common7strutil14TokenizeAccessERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEEcE3$_0", "typeinfo name for common::strutil::TokenizeAccess(std::__1::basic_string<char, std::__1::char_traits<char>, std::__1::allocator<char> > const&, char)::$_0"),
	// mu_demangle_test("__ZTSZL10vpn_statusvE3$_0", "typeinfo name for vpn_status()::$_0"),
	// mu_demangle_test("__ZTSZL11ztna_statusiE3$_1", "typeinfo name for ztna_status(int)::$_1"),
	// mu_demangle_test("__ZTSZN8sbconfig12LoadFromFileERNS_6sbconfEE3$_0", "typeinfo name for sbconfig::LoadFromFile(sbconfig::sbconf&)::$_0"),
	// mu_demangle_test("__ZTSZN8sbconfig12ModifyConfigERKNS_6sbconfEE3$_1", "typeinfo name for sbconfig::ModifyConfig(sbconfig::sbconf const&)::$_1"),
	// mu_demangle_test("__ZTIZ13xml_ParseFileE3$_0", "typeinfo for xml_ParseFile::$_0"),
	// mu_demangle_test("__ZTIZ14xml_ModifyFileE3$_1", "typeinfo for xml_ModifyFile::$_1"),
	// mu_demangle_test("__ZTIZN8csconfig12LoadFromFileERNS_6csconfEE3$_0", "typeinfo for csconfig::LoadFromFile(csconfig::csconf&)::$_0"),
	// mu_demangle_test("__ZTIZN8csconfig12ModifyConfigERKNS_6csconfEE3$_1", "typeinfo for csconfig::ModifyConfig(csconfig::csconf const&)::$_1"),
	// mu_demangle_test("__ZTIZN6common7strutil14TokenizeAccessERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEEcE3$_0", "typeinfo for common::strutil::TokenizeAccess(std::__1::basic_string<char, std::__1::char_traits<char>, std::__1::allocator<char> > const&, char)::$_0"),
	// mu_demangle_test("__ZTIZL10vpn_statusvE3$_0", "typeinfo for vpn_status()::$_0"),
	// mu_demangle_test("__ZTIZL11ztna_statusiE3$_1", "typeinfo for ztna_status(int)::$_1"),
	// mu_demangle_test("__ZTIZN8sbconfig12LoadFromFileERNS_6sbconfEE3$_0", "typeinfo for sbconfig::LoadFromFile(sbconfig::sbconf&)::$_0"),
	// mu_demangle_test("__ZTIZN8sbconfig12ModifyConfigERKNS_6sbconfEE3$_1", "typeinfo for sbconfig::ModifyConfig(sbconfig::sbconf const&)::$_1"),
	// mu_demangle_test("__ZNSt3__1L15__get_nullptr_tEv", "std::__1::__get_nullptr_t()"),
	// mu_demangle_test("__ZNKSt3__19nullptr_tcvPT_IcEEv", "std::__1::nullptr_t::operator char*<char>() const"),
	mu_demangle_test("__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1INS_9nullptr_tEEEPKc", "std::__1::basic_string<char, std::__1::char_traits<char>, std::__1::allocator<char> >::basic_string<std::__1::nullptr_t>(char const*)"),
	// mu_demangle_test("__ZNKSt3__19nullptr_tcvPT_IKcEEv", "std::__1::nullptr_t::operator char const*<char const>() const"),
	mu_demangle_test("__ZNSt3__19nullptr_tC1EMNS0_5__natEi", "std::__1::nullptr_t::nullptr_t(int std::__1::nullptr_t::__nat::*)"),
	mu_demangle_test("__ZNSt3__19nullptr_tC2EMNS0_5__natEi", "std::__1::nullptr_t::nullptr_t(int std::__1::nullptr_t::__nat::*)"),
	mu_demangle_test("__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2INS_9nullptr_tEEEPKc", "std::__1::basic_string<char, std::__1::char_traits<char>, std::__1::allocator<char> >::basic_string<std::__1::nullptr_t>(char const*)"),
);

mu_main(gpl, cxx, RZ_DEMANGLE_OPT_BASE);
